"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],le=function(W){for(var t=[],_=0,F=W.length;_<F;_++)t[_]=se[W[_]];return t};const We=this,je=typeof global=="object"?global:{};var de;(function(W){W.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(de||(de={}));var de;(function(W){class t{constructor(o,w,f){this.type=o,this.detail=w,this.timestamp=f}}W.LoaderEvent=t;class _{constructor(o){this._events=[new t(1,"",o)]}record(o,w){this._events.push(new t(o,w,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=_;class F{record(o,w){}getEvents(){return[]}}F.INSTANCE=new F,W.NullLoaderEventRecorder=F})(de||(de={}));var de;(function(W){class t{static fileUriToFilePath(F,r){if(r=decodeURI(r).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(F,r){return F.length>=r.length&&F.substr(0,r.length)===r}static endsWith(F,r){return F.length>=r.length&&F.substr(F.length-r.length)===r}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,r){if(F){let o;for(o in F)F.hasOwnProperty(o)&&r(o,F[o])}}static isEmpty(F){let r=!0;return t.forEachProperty(F,()=>{r=!1}),r}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let r=Array.isArray(F)?[]:{};return t.forEachProperty(F,(o,w)=>{w&&typeof w=="object"?r[o]=t.recursiveClone(w):r[o]=w}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(de||(de={}));var de;(function(W){function t(r){if(r instanceof Error)return r;const o=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(o.stack=r.stack),o}W.ensureError=t;class _{static validateConfigurationOptions(o){function w(f){if(f.phase==="loading"){console.error('Loading "'+f.moduleId+'" failed'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}if(f.phase==="factory"){console.error('The factory function of "'+f.moduleId+'" has thrown an exception'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=w),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(W.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const f=t(new Error("INVALID cached data configuration, 'path' MUST be set"));f.phase="configuration",o.onError(f),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,w=null){let f=W.Utilities.recursiveClone(w||{});return W.Utilities.forEachProperty(o,(a,s)=>{a==="ignoreDuplicateModules"&&typeof f.ignoreDuplicateModules<"u"?f.ignoreDuplicateModules=f.ignoreDuplicateModules.concat(s):a==="paths"&&typeof f.paths<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.paths[h]=A):a==="config"&&typeof f.config<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.config[h]=A):f[a]=W.Utilities.recursiveClone(s)}),_.validateConfigurationOptions(f)}}W.ConfigurationOptionsUtil=_;class F{constructor(o,w){if(this._env=o,this.options=_.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let f=this.options.nodeRequire.main.filename,a=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(o,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:o,to:w}):this.sortedPathsRules.push({from:o,to:[w]})}),this.sortedPathsRules.sort((o,w)=>w.from.length-o.from.length)}cloneAndMerge(o){return new F(this._env,_.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let w;for(let f=0,a=this.sortedPathsRules.length;f<a;f++)if(w=this.sortedPathsRules[f],W.Utilities.startsWith(o,w.from)){let s=[];for(let h=0,A=w.to.length;h<A;h++)s.push(w.to[h]+o.substr(w.from.length));return s}return[o]}_addUrlArgsToUrl(o){return W.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let w=0,f=o.length;w<f;w++)o[w]=this._addUrlArgsToUrl(o[w]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let w=o,f;if(!W.Utilities.endsWith(w,".js")&&!W.Utilities.isAbsolutePath(w)){f=this._applyPaths(w);for(let a=0,s=f.length;a<s;a++)this.isBuild()&&f[a]==="empty:"||(W.Utilities.isAbsolutePath(f[a])||(f[a]=this.options.baseUrl+f[a]),!W.Utilities.endsWith(f[a],".js")&&!W.Utilities.containsQueryString(f[a])&&(f[a]=f[a]+".js"))}else!W.Utilities.endsWith(w,".js")&&!W.Utilities.containsQueryString(w)&&(w=w+".js"),f=[w];return this._addUrlArgsIfNecessaryToUrls(f)}requireToUrl(o){let w=o;return W.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],W.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}W.Configuration=F})(de||(de={}));var de;(function(W){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,h,A,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new _:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new _;let m={callback:A,errorback:g};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(m);return}this._callbackMap[h]=[m],this._scriptLoader.load(s,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(s){let h=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<h.length;A++)h[A].callback()}triggerErrorback(s,h){let A=this._callbackMap[s];delete this._callbackMap[s];for(let g=0;g<A.length;g++)A[g].errorback(h)}}class _{attachListeners(s,h,A){let g=()=>{s.removeEventListener("load",m),s.removeEventListener("error",e)},m=E=>{g(),h()},e=E=>{g(),A(E)};s.addEventListener("load",m),s.addEventListener("error",e)}load(s,h,A,g){if(/^node\|/.test(h)){let m=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),E=h.split("|"),R=null;try{R=e(E[1])}catch(N){g(N);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,A,g);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),m.setAttribute("src",h);const{cspNonce:E}=s.getConfig().getOptionsLiteral();E&&m.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(m)}}}function F(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(s)),this._cachedCanUseEval}load(s,h,A,g){if(/^node\|/.test(h)){const m=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),E=h.split("|");let R=null;try{R=e(E[1])}catch(N){g(N);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:m}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(h).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${h}`,(m?self.eval(m.createScript("",E)):new Function(E)).call(self),A()}).then(void 0,g);return}try{m&&(h=m.createScriptURL(h)),importScripts(h),A()}catch(E){g(E)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,h){const{nodeCachedData:A}=h.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,m=s("module");function e(E){const R=E.constructor;let N=function(b){try{return E.require(b)}finally{}};return N.resolve=function(b,u){return R._resolveFilename(b,E,!1,u)},N.resolve.paths=function(b){return R._resolveLookupPaths(b,E)},N.main=process.mainModule,N.extensions=R._extensions,N.cache=R._cache,N}m.prototype._compile=function(E,R){const N=m.wrap(E.replace(/^#!.*/,"")),$=h.getRecorder(),b=g._getCachedDataPath(A,R),u={filename:R};let c;try{const p=g._fs.readFileSync(b);c=p.slice(0,16),u.cachedData=p.slice(16),$.record(60,b)}catch{$.record(61,b)}const n=new g._vm.Script(N,u),l=n.runInThisContext(u),L=g._path.dirname(R),d=e(this),v=[this.exports,d,this,R,L,process,je,Buffer],k=l.apply(this.exports,v);return g._handleCachedData(n,N,b,!u.cachedData,h),g._verifyCachedData(n,N,b,c,h),k}}load(s,h,A,g){const m=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),E=m.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(h)){let N=h.split("|"),$=null;try{$=e(N[1])}catch(b){g(b);return}s.enqueueDefineAnonymousModule([],()=>$),A()}else{h=W.Utilities.fileUriToFilePath(this._env.isWindows,h);const N=this._path.normalize(h),$=this._getElectronRendererScriptPathOrUri(N),b=!!m.nodeCachedData,u=b?this._getCachedDataPath(m.nodeCachedData,h):void 0;this._readSourceAndCachedData(N,u,R,(c,n,l,L)=>{if(c){g(c);return}let d;n.charCodeAt(0)===o._BOM?d=o._PREFIX+n.substring(1)+o._SUFFIX:d=o._PREFIX+n+o._SUFFIX,d=E(d,N);const v={filename:$,cachedData:l},k=this._createAndEvalScript(s,d,v,A,g);this._handleCachedData(k,d,u,b&&!l,s),this._verifyCachedData(k,d,u,L,s)})}}_createAndEvalScript(s,h,A,g,m){const e=s.getRecorder();e.record(31,A.filename);const E=new this._vm.Script(h,A),R=E.runInThisContext(A),N=s.getGlobalAMDDefineFunc();let $=!1;const b=function(){return $=!0,N.apply(null,arguments)};return b.amd=N.amd,R.call(W.global,s.getGlobalAMDRequireFunc(),b,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),$?g():m(new Error(`Didn't receive define call in ${A.filename}!`)),E}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let h=s.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,h){const A=this._crypto.createHash("md5").update(h,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(h).replace(/\.js$/,"");return this._path.join(s.path,`${g}-${A}.code`)}_handleCachedData(s,h,A,g,m){s.cachedDataRejected?this._fs.unlink(A,e=>{m.getRecorder().record(62,A),this._createAndWriteCachedData(s,h,A,m),e&&m.getConfig().onError(e)}):g&&this._createAndWriteCachedData(s,h,A,m)}_createAndWriteCachedData(s,h,A,g){let m=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,R;const N=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(h,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||E>=5)){if($.length<e){N();return}e=$.length,this._fs.writeFile(A,Buffer.concat([R,$]),b=>{b&&g.getConfig().onError(b),g.getRecorder().record(63,A),N()})}},m*Math.pow(4,E++))};N()}_readSourceAndCachedData(s,h,A,g){if(!h)this._fs.readFile(s,{encoding:"utf8"},g);else{let m,e,E,R=2;const N=$=>{$?g($):--R===0&&g(void 0,m,e,E)};this._fs.readFile(s,{encoding:"utf8"},($,b)=>{m=b,N($)}),this._fs.readFile(h,($,b)=>{!$&&b&&b.length>0?(E=b.slice(0,16),e=b.slice(16),A.record(60,h)):A.record(61,h),N()})}}_verifyCachedData(s,h,A,g,m){g&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();g.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,E=>{E&&m.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function w(a,s){if(s.__$__isRecorded)return s;const h=function(g){a.record(33,g);try{return s(g)}finally{a.record(34,g)}};return h.__$__isRecorded=!0,h}W.ensureRecordedNodeRequire=w;function f(a){return new t(a)}W.createScriptLoader=f})(de||(de={}));var de;(function(W){class t{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,h;for(h=/\/\.\//;h.test(s);)s=s.replace(h,"/");for(s=s.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(s);)s=s.replace(h,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return W.Utilities.isAbsolutePath(s)||(W.Utilities.startsWith(s,"./")||W.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),W.ModuleIdResolver=t;class _{constructor(a,s,h,A,g,m){this.id=a,this.strId=s,this.dependencies=h,this._callback=A,this._errorback=g,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(W.global,s),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(a,s,h,A){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(h,A):{returnedValue:h.apply(W.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,h,A){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let m=_._invokeFactory(s,this.strId,this._callback,h);g=m.producedError,a.record(22,this.strId),!g&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(g){let m=W.ensureError(g);m.phase="factory",m.moduleId=this.strId,m.neededBy=A(this.id),this.error=m,s.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}W.Module=_;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class r{constructor(a){this.id=a}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),W.RegularDependency=r;class o{constructor(a,s,h){this.id=a,this.pluginId=s,this.pluginParam=h}}W.PluginDependency=o;class w{constructor(a,s,h,A,g=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=g,this._defineFunc=h,this._requireFunc=A,this._moduleIdProvider=new F,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let h=m=>m.replace(/\\/g,"/"),A=h(a),g=s.split(/\n/);for(let m=0;m<g.length;m++){let e=g[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],R=e[2],N=e[3],$=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr($),E=h(E),E===A){let b={line:parseInt(R,10),col:parseInt(N,10)};return b.line===1&&(b.col-=53),b}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let h=0,A=this._modules2.length;h<A;h++){let g=this._modules2[h];if(!g)continue;let m=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,E=this._buildInfoDependencies[g.id];a[s++]={id:g.strId,path:m,defineLocation:m&&e?w._findRelevantLocationInStack(m,e):null,dependencies:E,shim:null,exports:g.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:a,callback:s}}defineModule(a,s,h,A,g,m=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let E=new _(e,a,this._normalizeDependencies(s,m),h,A,m);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(E.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(E)}_normalizeDependency(a,s){if(a==="exports")return r.EXPORTS;if(a==="module")return r.MODULE;if(a==="require")return r.REQUIRE;let h=a.indexOf("!");if(h>=0){let A=s.resolveModule(a.substr(0,h)),g=s.resolveModule(a.substr(h+1)),m=this._moduleIdProvider.getModuleId(A+"!"+g),e=this._moduleIdProvider.getModuleId(A);return new o(m,e,g)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let h=[],A=0;for(let g=0,m=a.length;g<m;g++)h[A++]=this._normalizeDependency(a[g],s);return h}_relativeRequire(a,s,h,A){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(W.Utilities.generateAnonymousModule(),s,h,A,null,a)}synchronousRequire(a,s=new t(a)){let h=this._normalizeDependency(a,s),A=this._modules2[h.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(a,s){let h=this._config.shouldRecordStats();s?this._config=new W.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let h=this._moduleIdProvider.getStrModuleId(a),A=(this._inverseDependencies2[a]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const g=W.ensureError(s);return g.phase="loading",g.moduleId=h,g.neededBy=A,g}_onLoadError(a,s){const h=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new _(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let A=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)A[e]=!1;let g=!1,m=[];for(m.push(a),A[a]=!0;m.length>0;){let e=m.shift(),E=this._modules2[e];E&&(g=E.onDependencyError(h)||g);let R=this._inverseDependencies2[e];if(R)for(let N=0,$=R.length;N<$;N++){let b=R[N];A[b]||(m.push(b),A[b]=!0)}}g||this._config.onError(h)}_hasDependencyPath(a,s){let h=this._modules2[a];if(!h)return!1;let A=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)A[m]=!1;let g=[];for(g.push(h),A[a]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let E=0,R=e.length;E<R;E++){let N=e[E];if(N.id===s)return!0;let $=this._modules2[N.id];$&&!A[N.id]&&(A[N.id]=!0,g.push($))}}return!1}_findCyclePath(a,s,h){if(a===s||h===50)return[a];let A=this._modules2[a];if(!A)return null;let g=A.dependencies;if(g)for(let m=0,e=g.length;m<e;m++){let E=this._findCyclePath(g[m].id,s,h+1);if(E!==null)return E.push(a),E}return null}_createRequire(a){let s=(h,A,g)=>this._relativeRequire(a,h,A,g);return s.toUrl=h=>this._config.requireToUrl(a.resolveModule(h)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(h,A=!1)=>{this.configure(h,A)},s.__$__nodeRequire=W.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),h=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&h.push("node|"+s);let g=-1,m=e=>{if(g++,g>=h.length)this._onLoadError(a,e);else{let E=h[g],R=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[a]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}R.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=E),R.record(11,E),this._onLoad(a)},N=>{R.record(12,E),m(N)})}};m(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let h=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};h.error=A=>{this._config.onError(this._createLoadError(s.id,A))},a.load(s.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let h=0,A=s.length;h<A;h++){let g=s[h];if(g===r.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(g===r.MODULE){a.unresolvedDependenciesCount--;continue}if(g===r.REQUIRE){a.unresolvedDependenciesCount--;continue}let m=this._modules2[g.id];if(m&&m.isComplete()){if(m.error){a.onDependencyError(m.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,a.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(a.id),g instanceof o){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let E=this._inversePluginDependencies2.get(g.pluginId);E||(E=[],this._inversePluginDependencies2.set(g.pluginId,E)),E.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let h=a.dependencies,A=[];if(h)for(let E=0,R=h.length;E<R;E++){let N=h[E];if(N===r.EXPORTS){A[E]=a.exports;continue}if(N===r.MODULE){A[E]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(N===r.REQUIRE){A[E]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[N.id];if($){A[E]=$.exports;continue}A[E]=null}const g=E=>(this._inverseDependencies2[E]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));a.complete(s,this._config,A,g);let m=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,m)for(let E=0,R=m.length;E<R;E++){let N=m[E],$=this._modules2[N];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let E=0,R=e.length;E<R;E++)this._loadPluginDependency(a.exports,e[E])}}}W.ModuleManager=w})(de||(de={}));var te,de;(function(W){const t=new W.Environment;let _=null;const F=function(f,a,s){typeof f!="string"&&(s=a,a=f,f=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),f?_.defineModule(f,a,s,null,null):_.enqueueDefineAnonymousModule(a,s)};F.amd={jQuery:!0};const r=function(f,a=!1){_.configure(f,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return _.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){_.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=r,o.getConfig=function(){return _.getConfig().getOptionsLiteral()},o.reset=function(){_=_.reset()},o.getBuildInfo=function(){return _.getBuildInfo()},o.getStats=function(){return _.getLoaderEvents()},o.define=F;function w(){if(typeof W.global.require<"u"||typeof require<"u"){const f=W.global.require||require;if(typeof f=="function"&&typeof f.resolve=="function"){const a=W.ensureRecordedNodeRequire(_.getRecorder(),f);W.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(W.global.define=F),W.global.require=o)}W.init=w,(typeof W.global.define!="function"||!W.global.define.amd)&&(_=new W.ModuleManager(t,W.createScriptLoader(t),F,o,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&o.config(W.global.require),te=function(){return F.apply(null,arguments)},te.amd=F.amd,typeof doNotInitLoader>"u"&&w())})(de||(de={})),te(se[66],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function _(f,a,s,h){if(h=h||{},(h["vs/css"]||{}).disabled){s({});return}const g=a.toUrl(f+".css");F(f,g,()=>{s({})},m=>{typeof s.error=="function"&&s.error("Could not find "+g+".")})}t.load=_;function F(f,a,s,h){if(r(f,a)){s();return}o(f,a,s,h)}function r(f,a){const s=window.document.getElementsByTagName("link");for(let h=0,A=s.length;h<A;h++){const g=s[h].getAttribute("data-name"),m=s[h].getAttribute("href");if(g===f||m===a)return!0}return!1}function o(f,a,s,h){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",f),w(f,A,s,h),A.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(A)}function w(f,a,s,h){const A=()=>{a.removeEventListener("load",g),a.removeEventListener("error",m)},g=e=>{A(),s()},m=e=>{A(),h(e)};a.addEventListener("load",g),a.addEventListener("error",m)}}),te("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let _=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function r(R,N){let $;return N.length===0?$=R:$=R.replace(/\{(\d+)\}/g,(b,u)=>{const c=u[0],n=N[c];let l=b;return typeof n=="string"?l=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(l=String(n)),l}),_&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function o(R,N){let $=R[N];return $||($=R["*"],$)?$:null}function w(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function f(R,N,$){const b=w(R)+w(N)+"vscode/"+w($),u=await fetch(b);if(u.ok)return await u.json();throw new Error(`${u.status} - ${u.statusText}`)}function a(R){return function(N,$){const b=Array.prototype.slice.call(arguments,2);return r(R[N],b)}}function s(R){return(N,$,...b)=>({value:r(R[N],b),original:r($,b)})}function h(R,N,...$){return r(N,$)}t.localize=h;function A(R,N,...$){const b=r(N,$);return{value:b,original:b}}t.localize2=A;function g(R){}t.getConfiguredDefaultLocale=g;function m(R){_=R}t.setPseudoTranslation=m;function e(R,N){return{localize:a(N[R]),localize2:s(N[R]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??($=>{})}}t.create=e;function E(R,N,$,b){const u=b["vs/nls"]??{};if(!R||R.length===0)return $({localize:h,localize2:A,getConfiguredDefaultLocale:()=>u.availableLanguages?.["*"]});const c=u.availableLanguages?o(u.availableLanguages,R):null,n=c===null||c===F;let l=".nls";n||(l=l+"."+c);const L=d=>{Array.isArray(d)?(d.localize=a(d),d.localize2=s(d)):(d.localize=a(d[R]),d.localize2=s(d[R])),d.getConfiguredDefaultLocale=()=>u.availableLanguages?.["*"],$(d)};typeof u.loadBundle=="function"?u.loadBundle(R,c,(d,v)=>{d?N([R+".nls"],L):L(v)}):u.translationServiceUrl&&!n?(async()=>{try{const d=await f(u.translationServiceUrl,c,R);return L(d)}catch(d){if(!c.includes("-"))return console.error(d),N([R+".nls"],L);try{const v=c.split("-")[0],k=await f(u.translationServiceUrl,v,R);return u.availableLanguages??(u.availableLanguages={}),u.availableLanguages["*"]=v,L(k)}catch(v){return console.error(v),N([R+".nls"],L)}}})():N([R+l],L,d=>{if(l===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,d),N([R+".nls"],L)})}t.load=E}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function _(h,A){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(h,A)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(h,A)}catch(g){console.warn(g);return}}const F=_("amdLoader",{createScriptURL:h=>h,createScript:(h,...A)=>{const g=A.slice(0,-1).join(","),m=A.pop().toString();return`(function anonymous(${g}) { ${m}
})`}});function r(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((h,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const g=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,A);return}F?importScripts(F.createScriptURL(g)):importScripts(g),h()})}function w(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function f(h){o().then(()=>{w(),require([h],function(A){setTimeout(function(){const g=A.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>g.onmessage(m.data,m.ports);s.length>0;){const m=s.shift();g.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let a=!0;const s=[];globalThis.onmessage=h=>{if(!a){s.push(h);return}a=!1,f(h.data)}}(),te(se[9],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function _(E,R,N){const $=F(E,R);if($!==-1)return E[$]}t.$fb=_;function F(E,R,N=E.length-1){for(let $=N;$>=0;$--){const b=E[$];if(R(b))return $}return-1}t.$gb=F;function r(E,R){const N=o(E,R);return N===-1?void 0:E[N]}t.$hb=r;function o(E,R,N=0,$=E.length){let b=N,u=$;for(;b<u;){const c=Math.floor((b+u)/2);R(E[c])?b=c+1:u=c}return b-1}t.$ib=o;function w(E,R){const N=f(E,R);return N===E.length?void 0:E[N]}t.$jb=w;function f(E,R,N=0,$=E.length){let b=N,u=$;for(;b<u;){const c=Math.floor((b+u)/2);R(E[c])?u=c:b=c+1}return b}t.$kb=f;function a(E,R,N=0,$=E.length){const b=f(E,R,N,$);return b===E.length?-1:b}t.$lb=a;class s{constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!R($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const N=o(this.e,R,this.c);return this.c=N+1,N===-1?void 0:this.e[N]}}t.$mb=s,s.assertInvariants=!1;function h(E,R){if(E.length===0)return;let N=E[0];for(let $=1;$<E.length;$++){const b=E[$];R(b,N)>0&&(N=b)}return N}t.$nb=h;function A(E,R){if(E.length===0)return;let N=E[0];for(let $=1;$<E.length;$++){const b=E[$];R(b,N)>=0&&(N=b)}return N}t.$ob=A;function g(E,R){return h(E,(N,$)=>-R(N,$))}t.$pb=g;function m(E,R){if(E.length===0)return-1;let N=0;for(let $=1;$<E.length;$++){const b=E[$];R(b,E[N])>0&&(N=$)}return N}t.$qb=m;function e(E,R){for(const N of E){const $=R(N);if($!==void 0)return $}}t.$rb=e}),te(se[34],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=void 0;function _(w,f){const a=Object.create(null);for(const s of w){const h=f(s);let A=a[h];A||(A=a[h]=[]),A.push(s)}return a}t.$E=_;function F(w,f){const a=[],s=[];for(const h of w)f.has(h)||a.push(h);for(const h of f)w.has(h)||s.push(h);return{removed:a,added:s}}t.$F=F;function r(w,f){const a=[],s=[];for(const[h,A]of w)f.has(h)||a.push(A);for(const[h,A]of f)w.has(h)||s.push(A);return{removed:a,added:s}}t.$G=r;function o(w,f){const a=new Set;for(const s of f)w.has(s)&&a.add(s);return a}t.$H=o}),te(se[35],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yt=t.$xt=t.$wt=t.$vt=void 0;function _(f,a){const s=Math.pow(10,a);return Math.round(f*s)/s}class F{constructor(a,s,h,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=_(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}t.$vt=F;class r{constructor(a,s,h,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.l=_(Math.max(Math.min(1,h),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,g=a.a,m=Math.max(s,h,A),e=Math.min(s,h,A);let E=0,R=0;const N=(e+m)/2,$=m-e;if($>0){switch(R=Math.min(N<=.5?$/(2*N):$/(2-2*N),1),m){case s:E=(h-A)/$+(h<A?6:0);break;case h:E=(A-s)/$+2;break;case A:E=(s-h)/$+4;break}E*=60,E=Math.round(E)}return new r(E,R,N,g)}static i(a,s,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?a+(s-a)*6*h:h<1/2?s:h<2/3?a+(s-a)*(2/3-h)*6:a}static toRGBA(a){const s=a.h/360,{s:h,l:A,a:g}=a;let m,e,E;if(h===0)m=e=E=A;else{const R=A<.5?A*(1+h):A+h-A*h,N=2*A-R;m=r.i(N,R,s+1/3),e=r.i(N,R,s),E=r.i(N,R,s-1/3)}return new F(Math.round(m*255),Math.round(e*255),Math.round(E*255),g)}}t.$wt=r;class o{constructor(a,s,h,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.v=_(Math.max(Math.min(1,h),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,g=Math.max(s,h,A),m=Math.min(s,h,A),e=g-m,E=g===0?0:e/g;let R;return e===0?R=0:g===s?R=((h-A)/e%6+6)%6:g===h?R=(A-s)/e+2:R=(s-h)/e+4,new o(Math.round(R*60),E,g,a.a)}static toRGBA(a){const{h:s,s:h,v:A,a:g}=a,m=A*h,e=m*(1-Math.abs(s/60%2-1)),E=A-m;let[R,N,$]=[0,0,0];return s<60?(R=m,N=e):s<120?(R=e,N=m):s<180?(N=m,$=e):s<240?(N=e,$=m):s<300?(R=e,$=m):s<=360&&(R=m,$=e),R=Math.round((R+E)*255),N=Math.round((N+E)*255),$=Math.round(($+E)*255),new F(R,N,$,g)}}t.$xt=o;class w{static fromHex(a){return w.Format.CSS.parseHex(a)||w.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof F)this.rgba=a;else if(a instanceof r)this.i=a,this.rgba=r.toRGBA(a);else if(a instanceof o)this.j=a,this.rgba=o.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&F.equals(this.rgba,a.rgba)&&r.equals(this.hsla,a.hsla)&&o.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=w.k(this.rgba.r),s=w.k(this.rgba.g),h=w.k(this.rgba.b),A=.2126*a+.7152*s+.0722*h;return _(A,4)}static k(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h?(s+.05)/(h+.05):(h+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h}isDarkerThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s<h}lighten(a){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:h,b:A,a:g}=this.rgba;return new w(new F(s,h,A,g*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const s=a.rgba,h=this.rgba.a,A=s.a,g=h+A*(1-h);if(g<1e-6)return w.transparent;const m=this.rgba.r*h/g+s.r*A*(1-h)/g,e=this.rgba.g*h/g+s.g*A*(1-h)/g,E=this.rgba.b*h/g+s.b*A*(1-h)/g;return new w(new F(m,e,E,g))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:h,b:A,a:g}=this.rgba;return new w(new F(a.rgba.r-g*(a.rgba.r-s),a.rgba.g-g*(a.rgba.g-h),a.rgba.b-g*(a.rgba.b-A),1))}flatten(...a){const s=a.reduceRight((h,A)=>w.o(A,h));return w.o(this,s)}static o(a,s){const h=1-a.rgba.a;return new w(new F(h*s.rgba.r+a.rgba.a*a.rgba.r,h*s.rgba.g+a.rgba.a*a.rgba.g,h*s.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(a,s,h){if(a.isLighterThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),g=s.getRelativeLuminance();return h=h*(g-A)/g,a.lighten(h)}static getDarkerColor(a,s,h){if(a.isDarkerThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),g=s.getRelativeLuminance();return h=h*(A-g)/A,a.darken(h)}}t.$yt=w,w.white=new w(new F(255,255,255,1)),w.black=new w(new F(0,0,0,1)),w.red=new w(new F(255,0,0,1)),w.blue=new w(new F(0,0,255,1)),w.green=new w(new F(0,255,0,1)),w.cyan=new w(new F(0,255,255,1)),w.lightgrey=new w(new F(211,211,211,1)),w.transparent=new w(new F(0,0,0,0)),function(f){let a;(function(s){let h;(function(A){function g(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:f.Format.CSS.formatRGBA(n)}A.formatRGB=g;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}A.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:f.Format.CSS.formatHSLA(n)}A.formatHSL=e;function E(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}A.formatHSLA=E;function R(n){const l=n.toString(16);return l.length!==2?"0"+l:l}function N(n){return`#${R(n.rgba.r)}${R(n.rgba.g)}${R(n.rgba.b)}`}A.formatHex=N;function $(n,l=!1){return l&&n.rgba.a===1?f.Format.CSS.formatHex(n):`#${R(n.rgba.r)}${R(n.rgba.g)}${R(n.rgba.b)}${R(Math.round(n.rgba.a*255))}`}A.formatHexA=$;function b(n){return n.isOpaque()?f.Format.CSS.formatHex(n):f.Format.CSS.formatRGBA(n)}A.format=b;function u(n){const l=n.length;if(l===0||n.charCodeAt(0)!==35)return null;if(l===7){const L=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),d=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),v=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new f(new F(L,d,v,1))}if(l===9){const L=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),d=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),v=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),k=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new f(new F(L,d,v,k/255))}if(l===4){const L=c(n.charCodeAt(1)),d=c(n.charCodeAt(2)),v=c(n.charCodeAt(3));return new f(new F(16*L+L,16*d+d,16*v+v))}if(l===5){const L=c(n.charCodeAt(1)),d=c(n.charCodeAt(2)),v=c(n.charCodeAt(3)),k=c(n.charCodeAt(4));return new f(new F(16*L+L,16*d+d,16*v+v,(16*k+k)/255))}return null}A.parseHex=u;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=s.CSS||(s.CSS={}))})(a=f.Format||(f.Format={}))}(w||(t.$yt=w={}))}),te(se[36],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=void 0;class _{constructor(r,o,w,f){this.originalStart=r,this.originalLength=o,this.modifiedStart=w,this.modifiedLength=f}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$0s=_}),te(se[3],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class _{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?b.isErrorNoTelemetry(n)?new b(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(l=>{l(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=_,t.$X=new _;function F(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=F;function r(c){if(!c||typeof c!="object")return!1;const n=c;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function o(c){s(c)||t.$X.onUnexpectedError(c)}t.$1=o;function w(c){s(c)||t.$X.onUnexpectedExternalError(c)}t.$2=w;function f(c){if(c instanceof Error){const{name:n,message:l}=c,L=c.stacktrace||c.stack;return{$isError:!0,name:n,message:l,stack:L,noTelemetry:b.isErrorNoTelemetry(c)}}return c}t.$3=f;const a="Canceled";function s(c){return c instanceof h?!0:c instanceof Error&&c.name===a&&c.message===a}t.$4=s;class h extends Error{constructor(){super(a),this.name=this.message}}t.$5=h;function A(){const c=new Error(a);return c.name=c.message,c}t.$6=A;function g(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=g;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=m;class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=E;class R extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=R;class N extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=N;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class b extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof b)return n;const l=new b;return l.message=n.message,l.stack=n.stack,l}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=b;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}t.$cb=u}),te(se[6],le([0,1,3,9]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(B,C=0){return B[B.length-(1+C)]}t.$sb=r;function o(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}t.$tb=o;function w(B,C,j=(J,x)=>J===x){if(B===C)return!0;if(!B||!C||B.length!==C.length)return!1;for(let J=0,x=B.length;J<x;J++)if(!j(B[J],C[J]))return!1;return!0}t.$ub=w;function f(B,C){const j=B.length-1;C<j&&(B[C]=B[j]),B.pop()}t.$vb=f;function a(B,C,j){return s(B.length,J=>j(B[J],C))}t.$wb=a;function s(B,C){let j=0,J=B-1;for(;j<=J;){const x=(j+J)/2|0,G=C(x);if(G<0)j=x+1;else if(G>0)J=x-1;else return x}return-(j+1)}t.$xb=s;function h(B,C,j){if(B=B|0,B>=C.length)throw new TypeError("invalid index");const J=C[Math.floor(C.length*Math.random())],x=[],G=[],Z=[];for(const K of C){const re=j(K,J);re<0?x.push(K):re>0?G.push(K):Z.push(K)}return B<x.length?h(B,x,j):B<x.length+Z.length?Z[0]:h(B-(x.length+Z.length),G,j)}t.$yb=h;function A(B,C){const j=[];let J;for(const x of B.slice(0).sort(C))!J||C(J[0],x)!==0?(J=[x],j.push(J)):J.push(x);return j}t.$zb=A;function*g(B,C){let j,J;for(const x of B)J!==void 0&&C(J,x)?j.push(x):(j&&(yield j),j=[x]),J=x;j&&(yield j)}t.$Ab=g;function m(B,C){for(let j=0;j<=B.length;j++)C(j===0?void 0:B[j-1],j===B.length?void 0:B[j])}t.$Bb=m;function e(B,C){for(let j=0;j<B.length;j++)C(j===0?void 0:B[j-1],B[j],j+1===B.length?void 0:B[j+1])}t.$Cb=e;function E(B,C,j){const J=[];function x(K,re,ae){if(re===0&&ae.length===0)return;const ce=J[J.length-1];ce&&ce.start+ce.deleteCount===K?(ce.deleteCount+=re,ce.toInsert.push(...ae)):J.push({start:K,deleteCount:re,toInsert:ae})}let G=0,Z=0;for(;;){if(G===B.length){x(G,0,C.slice(Z));break}if(Z===C.length){x(G,B.length-G,[]);break}const K=B[G],re=C[Z],ae=j(K,re);ae===0?(G+=1,Z+=1):ae<0?(x(G,1,[]),G+=1):ae>0&&(x(G,0,[re]),Z+=1)}return J}t.$Db=E;function R(B,C,j){const J=E(B,C,j),x=[],G=[];for(const Z of J)x.push(...B.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:x,added:G}}t.$Eb=R;function N(B,C,j){if(j===0)return[];const J=B.slice(0,j).sort(C);return b(B,C,J,j,B.length),J}t.top=N;function $(B,C,j,J,x){return j===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const K=B.length,re=B.slice(0,j).sort(C);for(let ae=j,ce=Math.min(j+J,K);ae<K;ae=ce,ce=Math.min(ce+J,K)){if(ae>j&&await new Promise(fe=>setTimeout(fe)),x&&x.isCancellationRequested)throw new _.$5;b(B,C,re,ae,ce)}return re})().then(G,Z)})}t.$Gb=$;function b(B,C,j,J,x){for(const G=j.length;J<x;J++){const Z=B[J];if(C(Z,j[G-1])<0){j.pop();const K=(0,F.$kb)(j,re=>C(Z,re)<0);j.splice(K,0,Z)}}}function u(B){return B.filter(C=>!!C)}t.$Hb=u;function c(B){let C=0;for(let j=0;j<B.length;j++)B[j]&&(B[C]=B[j],C+=1);B.length=C}t.$Ib=c;function n(B,C,j){B.splice(j,0,B.splice(C,1)[0])}t.$Jb=n;function l(B){return!Array.isArray(B)||B.length===0}t.$Kb=l;function L(B){return Array.isArray(B)&&B.length>0}t.$Lb=L;function d(B,C=j=>j){const j=new Set;return B.filter(J=>{const x=C(J);return j.has(x)?!1:(j.add(x),!0)})}t.$Mb=d;function v(B){const C=new Set;return j=>{const J=B(j);return C.has(J)?!1:(C.add(J),!0)}}t.$Nb=v;function k(B,C){return B.length>0?B[0]:C}t.$Ob=k;function p(B,C){return B.length>0?B[B.length-1]:C}t.$Pb=p;function y(B,C,j=(J,x)=>J===x){let J=0;for(let x=0,G=Math.min(B.length,C.length);x<G&&j(B[x],C[x]);x++)J++;return J}t.$Qb=y;function M(B){return[].concat(...B)}t.$Rb=M;function P(B,C){let j=typeof C=="number"?B:0;typeof C=="number"?j=B:(j=0,C=B);const J=[];if(j<=C)for(let x=j;x<C;x++)J.push(x);else for(let x=j;x>C;x--)J.push(x);return J}t.$Sb=P;function T(B,C,j){return B.reduce((J,x)=>(J[C(x)]=j?j(x):x,J),Object.create(null))}t.$Tb=T;function D(B,C){return B.push(C),()=>q(B,C)}t.$Ub=D;function q(B,C){const j=B.indexOf(C);if(j>-1)return B.splice(j,1),C}t.$Vb=q;function V(B,C,j){const J=B.slice(0,C),x=B.slice(C);return J.concat(j,x)}t.$Wb=V;function H(B,C){let j;if(typeof C=="number"){let J=C;j=()=>{const x=Math.sin(J++)*179426549;return x-Math.floor(x)}}else j=Math.random;for(let J=B.length-1;J>0;J-=1){const x=Math.floor(j()*(J+1)),G=B[J];B[J]=B[x],B[x]=G}}t.$Xb=H;function ee(B,C){const j=B.indexOf(C);j>-1&&(B.splice(j,1),B.unshift(C))}t.$Yb=ee;function S(B,C){const j=B.indexOf(C);j>-1&&(B.splice(j,1),B.push(C))}t.$Zb=S;function U(B,C){for(const j of C)B.push(j)}t.$1b=U;function Y(B,C){return Array.isArray(B)?B.map(C):C(B)}t.$2b=Y;function X(B){return Array.isArray(B)?B:[B]}t.$3b=X;function ne(B){return B[Math.floor(Math.random()*B.length)]}t.$4b=ne;function ue(B,C,j){const J=ge(B,C),x=B.length,G=j.length;B.length=x+G;for(let Z=x-1;Z>=J;Z--)B[Z+G]=B[Z];for(let Z=0;Z<G;Z++)B[Z+J]=j[Z]}t.$5b=ue;function i(B,C,j,J){const x=ge(B,C);let G=B.splice(x,j);return G===void 0&&(G=[]),ue(B,x,J),G}t.$6b=i;function ge(B,C){return C<0?Math.max(C+B.length,0):Math.min(C,B.length)}var ve;(function(B){function C(G){return G<0}B.isLessThan=C;function j(G){return G<=0}B.isLessThanOrEqual=j;function J(G){return G>0}B.isGreaterThan=J;function x(G){return G===0}B.isNeitherLessOrGreaterThan=x,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function Re(B,C){return(j,J)=>C(B(j),B(J))}t.$7b=Re;function $e(...B){return(C,j)=>{for(const J of B){const x=J(C,j);if(!ve.isNeitherLessOrGreaterThan(x))return x}return ve.neitherLessOrGreaterThan}}t.$8b=$e;const pe=(B,C)=>B-C;t.$9b=pe;const Te=(B,C)=>(0,t.$9b)(B?1:0,C?1:0);t.$0b=Te;function Me(B){return(C,j)=>-B(C,j)}t.$$b=Me;class Se{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let j=this.c;for(;j<this.g.length&&C(this.g[j]);)j++;const J=j===this.c?null:this.g.slice(this.c,j);return this.c=j,J}takeFromEndWhile(C){let j=this.d;for(;j>=0&&C(this.g[j]);)j--;const J=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const j=this.g.slice(this.c,this.c+C);return this.c+=C,j}}t.$_b=Se;class Ne{constructor(C){this.iterate=C}forEach(C){this.iterate(j=>(C(j),!0))}toArray(){const C=[];return this.iterate(j=>(C.push(j),!0)),C}filter(C){return new Ne(j=>this.iterate(J=>C(J)?j(J):!0))}map(C){return new Ne(j=>this.iterate(J=>j(C(J))))}some(C){let j=!1;return this.iterate(J=>(j=C(J),!j)),j}findFirst(C){let j;return this.iterate(J=>C(J)?(j=J,!1):!0),j}findLast(C){let j;return this.iterate(J=>(C(J)&&(j=J),!0)),j}findLastMaxBy(C){let j,J=!0;return this.iterate(x=>((J||ve.isGreaterThan(C(x,j)))&&(J=!1,j=x),!0)),j}}t.$ac=Ne,Ne.empty=new Ne(B=>{})}),te(se[13],le([0,1,3]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.ok=void 0;function F(s,h){if(!s)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=F;function r(s,h="Unreachable"){throw new Error(h)}t.$9c=r;function o(s){if(!s)throw new _.$cb("Assertion Failed")}t.$0c=o;function w(s){s||(0,_.$1)(new _.$cb("Soft Assertion Failed"))}t.$$c=w;function f(s){if(!s()){debugger;s(),(0,_.$1)(new _.$cb("Assertion Failed"))}}t.$_c=f;function a(s,h){let A=0;for(;A<s.length-1;){const g=s[A],m=s[A+1];if(!h(g,m))return!1;A++}return!0}t.$ad=a}),te(se[19],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function _(F,r){const o=this;let w=!1,f;return function(){if(w)return f;if(w=!0,r)try{f=F.apply(o,arguments)}finally{r()}else f=F.apply(o,arguments);return f}}t.$db=_}),te(se[20],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var _;(function(F){function r(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}F.is=r;const o=Object.freeze([]);function w(){return o}F.empty=w;function*f(n){yield n}F.single=f;function a(n){return r(n)?n:f(n)}F.wrap=a;function s(n){return n||o}F.from=s;function*h(n){for(let l=n.length-1;l>=0;l--)yield n[l]}F.reverse=h;function A(n){return!n||n[Symbol.iterator]().next().done===!0}F.isEmpty=A;function g(n){return n[Symbol.iterator]().next().value}F.first=g;function m(n,l){for(const L of n)if(l(L))return!0;return!1}F.some=m;function e(n,l){for(const L of n)if(l(L))return L}F.find=e;function*E(n,l){for(const L of n)l(L)&&(yield L)}F.filter=E;function*R(n,l){let L=0;for(const d of n)yield l(d,L++)}F.map=R;function*N(...n){for(const l of n)yield*l}F.concat=N;function $(n,l,L){let d=L;for(const v of n)d=l(d,v);return d}F.reduce=$;function*b(n,l,L=n.length){for(l<0&&(l+=n.length),L<0?L+=n.length:L>n.length&&(L=n.length);l<L;l++)yield n[l]}F.slice=b;function u(n,l=Number.POSITIVE_INFINITY){const L=[];if(l===0)return[L,n];const d=n[Symbol.iterator]();for(let v=0;v<l;v++){const k=d.next();if(k.done)return[L,F.empty()];L.push(k.value)}return[L,{[Symbol.iterator](){return d}}]}F.consume=u;async function c(n){const l=[];for await(const L of n)l.push(L);return Promise.resolve(l)}F.asyncToArray=c})(_||(t.Iterable=_={}))}),te(se[37],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gr=t.KeyMod=t.KeyCodeUtils=t.$fr=t.$er=t.$dr=t.$cr=t.$br=t.ScanCode=t.KeyCode=void 0;var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(_||(t.KeyCode=_={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,R){this._keyCodeToStr[E]=R,this._strToKeyCode[R.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const o=new r,w=new r,f=new r;t.$br=new Array(230),t.$cr={};const a=[],s=Object.create(null),h=Object.create(null);t.$dr={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>s[e]||0,toString:e=>a[e]||"None"},t.$er=[],t.$fr=[];for(let e=0;e<=193;e++)t.$er[e]=-1;for(let e=0;e<=132;e++)t.$fr[e]=-1;(function(){const e="",E=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],N=[];for(const $ of E){const[b,u,c,n,l,L,d,v,k]=$;if(N[u]||(N[u]=!0,a[u]=c,s[c]=u,h[c.toLowerCase()]=u,b&&(t.$er[u]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$fr[n]=u))),!R[n]){if(R[n]=!0,!l)throw new Error(`String representation missing for key code ${n} around scan code ${c}`);o.define(n,l),w.define(n,v||l),f.define(n,k||v||l)}L&&(t.$br[L]=n),d&&(t.$cr[d]=n)}t.$fr[3]=46})();var A;(function(e){function E(c){return o.keyCodeToStr(c)}e.toString=E;function R(c){return o.strToKeyCode(c)}e.fromString=R;function N(c){return w.keyCodeToStr(c)}e.toUserSettingsUS=N;function $(c){return f.keyCodeToStr(c)}e.toUserSettingsGeneral=$;function b(c){return w.strToKeyCode(c)||f.strToKeyCode(c)}e.fromUserSettings=b;function u(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=u})(A||(t.KeyCodeUtils=A={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(t.KeyMod=g={}));function m(e,E){const R=(E&65535)<<16>>>0;return(e|R)>>>0}t.$gr=m}),te(se[38],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class _{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=_}),te(se[21],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class _{constructor(o){this.element=o,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class F{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let o=this.a;for(;o!==_.Undefined;){const w=o.next;o.prev=_.Undefined,o.next=_.Undefined,o=w}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,w){const f=new _(o);if(this.a===_.Undefined)this.a=f,this.b=f;else if(w){const s=this.b;this.b=f,f.prev=s,s.next=f}else{const s=this.a;this.a=f,f.next=s,s.prev=f}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(f))}}shift(){if(this.a!==_.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==_.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==_.Undefined&&o.next!==_.Undefined){const w=o.prev;w.next=o.next,o.next.prev=w}else o.prev===_.Undefined&&o.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):o.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):o.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==_.Undefined;)yield o.element,o=o.next}}t.$4c=F}),te(se[22],le([0,1]),function(W,t){"use strict";var _,F,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function o(b,u,c){let n=b.get(u);return n===void 0&&(n=c,b.set(u,n)),n}t.$xc=o;function w(b){const u=[];return b.forEach((c,n)=>{u.push(`${n} => ${c}`)}),`Map(${b.size}) {${u.join(", ")}}`}t.$yc=w;function f(b){const u=[];return b.forEach(c=>{u.push(c)}),`Set(${b.size}) {${u.join(", ")}}`}t.$zc=f;class a{constructor(u,c){this.uri=u,this.value=c}}function s(b){return Array.isArray(b)}class h{constructor(u,c){if(this[_]="ResourceMap",u instanceof h)this.d=new Map(u.d),this.e=c??h.c;else if(s(u)){this.d=new Map,this.e=c??h.c;for(const[n,l]of u)this.set(n,l)}else this.d=new Map,this.e=u??h.c}set(u,c){return this.d.set(this.e(u),new a(u,c)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,c){typeof c<"u"&&(u=u.bind(c));for(const[n,l]of this.d)u(l.value,l.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}t.$Ac=h,h.c=b=>b.toString();class A{constructor(u,c){this[F]="ResourceSet",!u||typeof u=="function"?this.c=new h(u):(this.c=new h(c),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,c){this.c.forEach((n,l)=>u.call(c,l,l,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var g;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(g||(t.Touch=g={}));class m{constructor(){this[r]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,c=0){const n=this.c.get(u);if(n)return c!==0&&this.l(n,c),n.value}set(u,c,n=0){let l=this.c.get(u);if(l)l.value=c,n!==0&&this.l(l,n);else{switch(l={key:u,value:c,next:void 0,previous:void 0},n){case 0:this.j(l);break;case 1:this.i(l);break;case 2:this.j(l);break;default:this.j(l);break}this.c.set(u,l),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const c=this.c.get(u);if(c)return this.c.delete(u),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,c){const n=this.g;let l=this.d;for(;l;){if(c?u.bind(c)(l.value,l.key,this):u(l.value,l.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const u=this,c=this.g;let n=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(n){const L={value:n.key,done:!1};return n=n.next,L}else return{value:void 0,done:!0}}};return l}values(){const u=this,c=this.g;let n=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(n){const L={value:n.value,done:!1};return n=n.next,L}else return{value:void 0,done:!0}}};return l}entries(){const u=this,c=this.g;let n=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(n){const L={value:[n.key,n.value],done:!1};return n=n.next,L}else return{value:void 0,done:!0}}};return l}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let c=this.d,n=this.size;for(;c&&n>u;)this.c.delete(c.key),c=c.next,n--;this.d=c,this.f=n,c&&(c.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const c=u.next,n=u.previous;if(!c||!n)throw new Error("Invalid list");c.previous=n,n.next=c}u.next=void 0,u.previous=void 0,this.g++}l(u,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(u===this.d)return;const n=u.next,l=u.previous;u===this.e?(l.next=void 0,this.e=l):(n.previous=l,l.next=n),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(c===2){if(u===this.e)return;const n=u.next,l=u.previous;u===this.d?(n.previous=void 0,this.d=n):(n.previous=l,l.next=n),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((c,n)=>{u.push([n,c])}),u}fromJSON(u){this.clear();for(const[c,n]of u)this.set(c,n)}}t.$Cc=m;class e extends m{constructor(u,c=1){super(),this.m=u,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,c=2){return super.get(u,c)}peek(u){return super.get(u,0)}set(u,c){return super.set(u,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class E{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let c=this.c.get(u)||0;return c===0?!1:(c--,c===0?this.c.delete(u):this.c.set(u,c),!0)}has(u){return this.c.has(u)}}t.$Ec=E;class R{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[c,n]of u)this.set(c,n)}clear(){this.c.clear(),this.d.clear()}set(u,c){this.c.set(u,c),this.d.set(c,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const c=this.c.get(u);return c===void 0?!1:(this.c.delete(u),this.d.delete(c),!0)}forEach(u,c){this.c.forEach((n,l)=>{u.call(c,n,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=R;class N{constructor(){this.c=new Map}add(u,c){let n=this.c.get(u);n||(n=new Set,this.c.set(u,n)),n.add(c)}delete(u,c){const n=this.c.get(u);n&&(n.delete(c),n.size===0&&this.c.delete(u))}forEach(u,c){const n=this.c.get(u);n&&n.forEach(c)}get(u){const c=this.c.get(u);return c||new Set}}t.$Gc=N;function $(b,u){if(b===u)return!0;if(b.size!==u.size)return!1;for(const[c,n]of b)if(!u.has(c)||u.get(c)!==n)return!1;for(const[c]of u)if(!b.has(c))return!1;return!0}t.$Hc=$}),te(se[10],le([0,1,6,34,22,19,20]),function(W,t,_,F,r,o,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const f=!1;let a=null;class s{constructor(){this.b=new Map}c(D){let q=this.b.get(D);return q||(q={parent:null,source:null,isSingleton:!1,value:D,idx:s.a++},this.b.set(D,q)),q}trackDisposable(D){const q=this.c(D);q.source||(q.source=new Error().stack)}setParent(D,q){const V=this.c(D);V.parent=q}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,q){const V=q.get(D);if(V)return V;const H=D.parent?this.f(this.c(D.parent),q):D;return q.set(D,H),H}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,V])=>V.source!==null&&!this.f(V,D).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(D=10,q){let V;if(q)V=q;else{const Y=new Map,X=[...this.b.values()].filter(ue=>ue.source!==null&&!this.f(ue,Y).isSingleton);if(X.length===0)return;const ne=new Set(X.map(ue=>ue.value));if(V=X.filter(ue=>!(ue.parent&&ne.has(ue.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function H(Y){function X(ue,i){for(;ue.length>0&&i.some(ge=>typeof ge=="string"?ge===ue[0]:ue[0].match(ge));)ue.shift()}const ne=Y.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return X(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const ee=new r.$Gc;for(const Y of V){const X=H(Y);for(let ne=0;ne<=X.length;ne++)ee.add(X.slice(0,ne).join(`
`),Y)}V.sort((0,_.$7b)(Y=>Y.idx,_.$9b));let S="",U=0;for(const Y of V.slice(0,D)){U++;const X=H(Y),ne=[];for(let ue=0;ue<X.length;ue++){let i=X[ue];i=`(shared with ${ee.get(X.slice(0,ue+1).join(`
`)).size}/${V.length} leaks) at ${i}`;const ve=ee.get(X.slice(0,ue).join(`
`)),Re=(0,F.$E)([...ve].map($e=>H($e)[ue]),$e=>$e);delete Re[X[ue]];for(const[$e,pe]of Object.entries(Re))ne.unshift(`    - stacktraces of ${pe.length} other leaks continue with ${$e}`);ne.unshift(i)}S+=`


==================== Leaking disposable ${U}/${V.length}: ${Y.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return V.length>D&&(S+=`


... and ${V.length-D} more leaking disposables

`),{leaks:V,details:S}}}t.$Ic=s,s.a=0;function h(T){a=T}if(t.$Jc=h,f){const T="__is_disposable_tracked__";h(new class{trackDisposable(D){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[T]||console.log(q)},3e3)}setParent(D,q){if(D&&D!==n.None)try{D[T]=!0}catch{}}markAsDisposed(D){if(D&&D!==n.None)try{D[T]=!0}catch{}}markAsSingleton(D){}})}function A(T){return a?.trackDisposable(T),T}t.$Kc=A;function g(T){a?.markAsDisposed(T)}t.$Lc=g;function m(T,D){a?.setParent(T,D)}function e(T,D){if(a)for(const q of T)a.setParent(q,D)}function E(T){return a?.markAsSingleton(T),T}t.$Mc=E;function R(T){return typeof T.dispose=="function"&&T.dispose.length===0}t.$Nc=R;function N(T){if(w.Iterable.is(T)){const D=[];for(const q of T)if(q)try{q.dispose()}catch(V){D.push(V)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}t.$Oc=N;function $(T){for(const D of T)R(D)&&D.dispose();return[]}t.$Pc=$;function b(...T){const D=u(()=>N(T));return e(T,D),D}t.$Qc=b;function u(T){const D=A({dispose:(0,o.$db)(()=>{g(D),T()})});return D}t.$Rc=u;class c{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{N(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return m(D,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),m(D,null))}}t.$Sc=c,c.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new c,A(this),m(this.q,this)}dispose(){g(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}t.$Tc=n,n.None=Object.freeze({dispose(){}});class l{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&m(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&m(D,null),D}}t.$Uc=l;class L{constructor(D){this.a=new l,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=L;class d{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=d;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(D){let q=D;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,g(this))},this}}t.$Xc=v;class k{constructor(){this.a=new Map}acquire(D,...q){let V=this.a.get(D);V||(V={counter:0,object:this.b(D,...q)},this.a.set(D,V));const{object:H}=V,ee=(0,o.$db)(()=>{--V.counter===0&&(this.c(D,V.object),this.a.delete(D))});return V.counter++,{object:H,dispose:ee}}}t.$Yc=k;class p{constructor(D){this.a=D}async acquire(D,...q){const V=this.a.acquire(D,...q);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(H){throw V.dispose(),H}}}t.$Zc=p;class y{constructor(D){this.object=D}dispose(){}}t.$1c=y;function M(T){const D=new c;try{T(D)}finally{D.dispose()}}t.$2c=M;class P{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{N(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,q,V=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this.a.get(D)?.dispose(),this.a.set(D,q)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=P}),te(se[14],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$D=t.$C=t.$B=t.$A=t.$z=t.$y=t.$x=t.OS=t.OperatingSystem=t.$v=t.$u=t.$t=t.$s=t.$r=t.Language=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.$g=t.$f=t.$e=t.$d=t.$c=t.$b=t.Platform=t.$a=void 0,t.$a="en";let _=!1,F=!1,r=!1,o=!1,w=!1,f=!1,a=!1,s=!1,h=!1,A=!1,g,m=t.$a,e=t.$a,E,R;const N=globalThis;let $;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?$=N.vscode.process:typeof process<"u"&&($=process);const b=typeof $?.versions?.electron=="string",u=b&&$?.type==="renderer";if(typeof $=="object"){_=$.platform==="win32",F=$.platform==="darwin",r=$.platform==="linux",o=r&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,a=b,h=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t.$a,m=t.$a;const M=$.env.VSCODE_NLS_CONFIG;if(M)try{const P=JSON.parse(M),T=P.availableLanguages["*"];g=P.locale,e=P.osLocale,m=T||t.$a,E=P._translationsConfigFile}catch{}w=!0}else if(typeof navigator=="object"&&!u){R=navigator.userAgent,_=R.indexOf("Windows")>=0,F=R.indexOf("Macintosh")>=0,s=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=R.indexOf("Linux")>=0,A=R?.indexOf("Mobi")>=0,f=!0,g=t.$a,m=g,e=navigator.language;const M=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),P=M&&M.getAttribute("data-settings");if(P)try{const T=JSON.parse(P),D=T.availableLanguages["*"];g=T.locale,e=T.osLocale,m=D||t.$a,E=T._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var c;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(c||(t.Platform=c={}));function n(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$b=n;let l=0;F?l=1:_?l=3:r&&(l=2),t.$c=_,t.$d=F,t.$e=r,t.$f=o,t.$g=w,t.$h=a,t.$i=f,t.$j=f&&typeof N.importScripts=="function",t.$k=t.$j?N.origin:void 0,t.$l=s,t.$m=A,t.$n=h,t.$o=l,t.$p=R,t.$q=m;var L;(function(M){function P(){return t.$q}M.value=P;function T(){return t.$q.length===2?t.$q==="en":t.$q.length>=3?t.$q[0]==="e"&&t.$q[1]==="n"&&t.$q[2]==="-":!1}M.isDefaultVariant=T;function D(){return t.$q==="en"}M.isDefault=D})(L||(t.Language=L={})),t.$r=g,t.$s=e,t.$t=E,t.$u=typeof N.postMessage=="function"&&!N.importScripts,t.$v=(()=>{if(t.$u){const M=[];N.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let D=0,q=M.length;D<q;D++){const V=M[D];if(V.id===T.data.vscodeScheduleAsyncWork){M.splice(D,1),V.callback();return}}});let P=0;return T=>{const D=++P;M.push({id:D,callback:T}),N.postMessage({vscodeScheduleAsyncWork:D},"*")}}return M=>setTimeout(M)})();var d;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(d||(t.OperatingSystem=d={})),t.OS=F||s?2:_?1:3;let v=!0,k=!1;function p(){if(!k){k=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,v=new Uint16Array(M.buffer)[0]===513}return v}t.$x=p,t.$y=!!(t.$p&&t.$p.indexOf("Chrome")>=0),t.$z=!!(t.$p&&t.$p.indexOf("Firefox")>=0),t.$A=!!(!t.$y&&t.$p&&t.$p.indexOf("Safari")>=0),t.$B=!!(t.$p&&t.$p.indexOf("Edg/")>=0),t.$C=!!(t.$p&&t.$p.indexOf("Android")>=0);function y(M){return parseFloat(M)>=20}t.$D=y}),te(se[39],le([0,1,14]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let F;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const o=r.process;F={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return _.$c?"win32":_.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$dc=F.platform,t.$ec=F.arch}),te(se[40],le([0,1,39]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const F=65,r=97,o=90,w=122,f=46,a=47,s=92,h=58,A=63;class g extends Error{constructor(l,L,d){let v;typeof L=="string"&&L.indexOf("not ")===0?(v="must not be",L=L.replace(/^not /,"")):v="must be";const k=l.indexOf(".")!==-1?"property":"argument";let p=`The "${l}" ${k} ${v} of type ${L}`;p+=`. Received type ${typeof d}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,l){if(n===null||typeof n!="object")throw new g(l,"Object",n)}function e(n,l){if(typeof n!="string")throw new g(l,"string",n)}const E=_.$dc==="win32";function R(n){return n===a||n===s}function N(n){return n===a}function $(n){return n>=F&&n<=o||n>=r&&n<=w}function b(n,l,L,d){let v="",k=0,p=-1,y=0,M=0;for(let P=0;P<=n.length;++P){if(P<n.length)M=n.charCodeAt(P);else{if(d(M))break;M=a}if(d(M)){if(!(p===P-1||y===1))if(y===2){if(v.length<2||k!==2||v.charCodeAt(v.length-1)!==f||v.charCodeAt(v.length-2)!==f){if(v.length>2){const T=v.lastIndexOf(L);T===-1?(v="",k=0):(v=v.slice(0,T),k=v.length-1-v.lastIndexOf(L)),p=P,y=0;continue}else if(v.length!==0){v="",k=0,p=P,y=0;continue}}l&&(v+=v.length>0?`${L}..`:"..",k=2)}else v.length>0?v+=`${L}${n.slice(p+1,P)}`:v=n.slice(p+1,P),k=P-p-1;p=P,y=0}else M===f&&y!==-1?++y:y=-1}return v}function u(n,l){m(l,"pathObject");const L=l.dir||l.root,d=l.base||`${l.name||""}${l.ext||""}`;return L?L===l.root?`${L}${d}`:`${L}${n}${d}`:d}t.$fc={resolve(...n){let l="",L="",d=!1;for(let v=n.length-1;v>=-1;v--){let k;if(v>=0){if(k=n[v],e(k,"path"),k.length===0)continue}else l.length===0?k=_.cwd():(k=_.env[`=${l}`]||_.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==l.toLowerCase()&&k.charCodeAt(2)===s)&&(k=`${l}\\`));const p=k.length;let y=0,M="",P=!1;const T=k.charCodeAt(0);if(p===1)R(T)&&(y=1,P=!0);else if(R(T))if(P=!0,R(k.charCodeAt(1))){let D=2,q=D;for(;D<p&&!R(k.charCodeAt(D));)D++;if(D<p&&D!==q){const V=k.slice(q,D);for(q=D;D<p&&R(k.charCodeAt(D));)D++;if(D<p&&D!==q){for(q=D;D<p&&!R(k.charCodeAt(D));)D++;(D===p||D!==q)&&(M=`\\\\${V}\\${k.slice(q,D)}`,y=D)}}}else y=1;else $(T)&&k.charCodeAt(1)===h&&(M=k.slice(0,2),y=2,p>2&&R(k.charCodeAt(2))&&(P=!0,y=3));if(M.length>0)if(l.length>0){if(M.toLowerCase()!==l.toLowerCase())continue}else l=M;if(d){if(l.length>0)break}else if(L=`${k.slice(y)}\\${L}`,d=P,P&&l.length>0)break}return L=b(L,!d,"\\",R),d?`${l}\\${L}`:`${l}${L}`||"."},normalize(n){e(n,"path");const l=n.length;if(l===0)return".";let L=0,d,v=!1;const k=n.charCodeAt(0);if(l===1)return N(k)?"\\":n;if(R(k))if(v=!0,R(n.charCodeAt(1))){let y=2,M=y;for(;y<l&&!R(n.charCodeAt(y));)y++;if(y<l&&y!==M){const P=n.slice(M,y);for(M=y;y<l&&R(n.charCodeAt(y));)y++;if(y<l&&y!==M){for(M=y;y<l&&!R(n.charCodeAt(y));)y++;if(y===l)return`\\\\${P}\\${n.slice(M)}\\`;y!==M&&(d=`\\\\${P}\\${n.slice(M,y)}`,L=y)}}}else L=1;else $(k)&&n.charCodeAt(1)===h&&(d=n.slice(0,2),L=2,l>2&&R(n.charCodeAt(2))&&(v=!0,L=3));let p=L<l?b(n.slice(L),!v,"\\",R):"";return p.length===0&&!v&&(p="."),p.length>0&&R(n.charCodeAt(l-1))&&(p+="\\"),d===void 0?v?`\\${p}`:p:v?`${d}\\${p}`:`${d}${p}`},isAbsolute(n){e(n,"path");const l=n.length;if(l===0)return!1;const L=n.charCodeAt(0);return R(L)||l>2&&$(L)&&n.charCodeAt(1)===h&&R(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let l,L;for(let k=0;k<n.length;++k){const p=n[k];e(p,"path"),p.length>0&&(l===void 0?l=L=p:l+=`\\${p}`)}if(l===void 0)return".";let d=!0,v=0;if(typeof L=="string"&&R(L.charCodeAt(0))){++v;const k=L.length;k>1&&R(L.charCodeAt(1))&&(++v,k>2&&(R(L.charCodeAt(2))?++v:d=!1))}if(d){for(;v<l.length&&R(l.charCodeAt(v));)v++;v>=2&&(l=`\\${l.slice(v)}`)}return t.$fc.normalize(l)},relative(n,l){if(e(n,"from"),e(l,"to"),n===l)return"";const L=t.$fc.resolve(n),d=t.$fc.resolve(l);if(L===d||(n=L.toLowerCase(),l=d.toLowerCase(),n===l))return"";let v=0;for(;v<n.length&&n.charCodeAt(v)===s;)v++;let k=n.length;for(;k-1>v&&n.charCodeAt(k-1)===s;)k--;const p=k-v;let y=0;for(;y<l.length&&l.charCodeAt(y)===s;)y++;let M=l.length;for(;M-1>y&&l.charCodeAt(M-1)===s;)M--;const P=M-y,T=p<P?p:P;let D=-1,q=0;for(;q<T;q++){const H=n.charCodeAt(v+q);if(H!==l.charCodeAt(y+q))break;H===s&&(D=q)}if(q!==T){if(D===-1)return d}else{if(P>T){if(l.charCodeAt(y+q)===s)return d.slice(y+q+1);if(q===2)return d.slice(y+q)}p>T&&(n.charCodeAt(v+q)===s?D=q:q===2&&(D=3)),D===-1&&(D=0)}let V="";for(q=v+D+1;q<=k;++q)(q===k||n.charCodeAt(q)===s)&&(V+=V.length===0?"..":"\\..");return y+=D,V.length>0?`${V}${d.slice(y,M)}`:(d.charCodeAt(y)===s&&++y,d.slice(y,M))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const l=t.$fc.resolve(n);if(l.length<=2)return n;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const L=l.charCodeAt(2);if(L!==A&&L!==f)return`\\\\?\\UNC\\${l.slice(2)}`}}else if($(l.charCodeAt(0))&&l.charCodeAt(1)===h&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return n},dirname(n){e(n,"path");const l=n.length;if(l===0)return".";let L=-1,d=0;const v=n.charCodeAt(0);if(l===1)return R(v)?n:".";if(R(v)){if(L=d=1,R(n.charCodeAt(1))){let y=2,M=y;for(;y<l&&!R(n.charCodeAt(y));)y++;if(y<l&&y!==M){for(M=y;y<l&&R(n.charCodeAt(y));)y++;if(y<l&&y!==M){for(M=y;y<l&&!R(n.charCodeAt(y));)y++;if(y===l)return n;y!==M&&(L=d=y+1)}}}}else $(v)&&n.charCodeAt(1)===h&&(L=l>2&&R(n.charCodeAt(2))?3:2,d=L);let k=-1,p=!0;for(let y=l-1;y>=d;--y)if(R(n.charCodeAt(y))){if(!p){k=y;break}}else p=!1;if(k===-1){if(L===-1)return".";k=L}return n.slice(0,k)},basename(n,l){l!==void 0&&e(l,"ext"),e(n,"path");let L=0,d=-1,v=!0,k;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===h&&(L=2),l!==void 0&&l.length>0&&l.length<=n.length){if(l===n)return"";let p=l.length-1,y=-1;for(k=n.length-1;k>=L;--k){const M=n.charCodeAt(k);if(R(M)){if(!v){L=k+1;break}}else y===-1&&(v=!1,y=k+1),p>=0&&(M===l.charCodeAt(p)?--p===-1&&(d=k):(p=-1,d=y))}return L===d?d=y:d===-1&&(d=n.length),n.slice(L,d)}for(k=n.length-1;k>=L;--k)if(R(n.charCodeAt(k))){if(!v){L=k+1;break}}else d===-1&&(v=!1,d=k+1);return d===-1?"":n.slice(L,d)},extname(n){e(n,"path");let l=0,L=-1,d=0,v=-1,k=!0,p=0;n.length>=2&&n.charCodeAt(1)===h&&$(n.charCodeAt(0))&&(l=d=2);for(let y=n.length-1;y>=l;--y){const M=n.charCodeAt(y);if(R(M)){if(!k){d=y+1;break}continue}v===-1&&(k=!1,v=y+1),M===f?L===-1?L=y:p!==1&&(p=1):L!==-1&&(p=-1)}return L===-1||v===-1||p===0||p===1&&L===v-1&&L===d+1?"":n.slice(L,v)},format:u.bind(null,"\\"),parse(n){e(n,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return l;const L=n.length;let d=0,v=n.charCodeAt(0);if(L===1)return R(v)?(l.root=l.dir=n,l):(l.base=l.name=n,l);if(R(v)){if(d=1,R(n.charCodeAt(1))){let D=2,q=D;for(;D<L&&!R(n.charCodeAt(D));)D++;if(D<L&&D!==q){for(q=D;D<L&&R(n.charCodeAt(D));)D++;if(D<L&&D!==q){for(q=D;D<L&&!R(n.charCodeAt(D));)D++;D===L?d=D:D!==q&&(d=D+1)}}}}else if($(v)&&n.charCodeAt(1)===h){if(L<=2)return l.root=l.dir=n,l;if(d=2,R(n.charCodeAt(2))){if(L===3)return l.root=l.dir=n,l;d=3}}d>0&&(l.root=n.slice(0,d));let k=-1,p=d,y=-1,M=!0,P=n.length-1,T=0;for(;P>=d;--P){if(v=n.charCodeAt(P),R(v)){if(!M){p=P+1;break}continue}y===-1&&(M=!1,y=P+1),v===f?k===-1?k=P:T!==1&&(T=1):k!==-1&&(T=-1)}return y!==-1&&(k===-1||T===0||T===1&&k===y-1&&k===p+1?l.base=l.name=n.slice(p,y):(l.name=n.slice(p,k),l.base=n.slice(p,y),l.ext=n.slice(k,y))),p>0&&p!==d?l.dir=n.slice(0,p-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(E){const n=/\\/g;return()=>{const l=_.cwd().replace(n,"/");return l.slice(l.indexOf("/"))}}return()=>_.cwd()})();t.$gc={resolve(...n){let l="",L=!1;for(let d=n.length-1;d>=-1&&!L;d--){const v=d>=0?n[d]:c();e(v,"path"),v.length!==0&&(l=`${v}/${l}`,L=v.charCodeAt(0)===a)}return l=b(l,!L,"/",N),L?`/${l}`:l.length>0?l:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const l=n.charCodeAt(0)===a,L=n.charCodeAt(n.length-1)===a;return n=b(n,!l,"/",N),n.length===0?l?"/":L?"./":".":(L&&(n+="/"),l?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===a},join(...n){if(n.length===0)return".";let l;for(let L=0;L<n.length;++L){const d=n[L];e(d,"path"),d.length>0&&(l===void 0?l=d:l+=`/${d}`)}return l===void 0?".":t.$gc.normalize(l)},relative(n,l){if(e(n,"from"),e(l,"to"),n===l||(n=t.$gc.resolve(n),l=t.$gc.resolve(l),n===l))return"";const L=1,d=n.length,v=d-L,k=1,p=l.length-k,y=v<p?v:p;let M=-1,P=0;for(;P<y;P++){const D=n.charCodeAt(L+P);if(D!==l.charCodeAt(k+P))break;D===a&&(M=P)}if(P===y)if(p>y){if(l.charCodeAt(k+P)===a)return l.slice(k+P+1);if(P===0)return l.slice(k+P)}else v>y&&(n.charCodeAt(L+P)===a?M=P:P===0&&(M=0));let T="";for(P=L+M+1;P<=d;++P)(P===d||n.charCodeAt(P)===a)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(k+M)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const l=n.charCodeAt(0)===a;let L=-1,d=!0;for(let v=n.length-1;v>=1;--v)if(n.charCodeAt(v)===a){if(!d){L=v;break}}else d=!1;return L===-1?l?"/":".":l&&L===1?"//":n.slice(0,L)},basename(n,l){l!==void 0&&e(l,"ext"),e(n,"path");let L=0,d=-1,v=!0,k;if(l!==void 0&&l.length>0&&l.length<=n.length){if(l===n)return"";let p=l.length-1,y=-1;for(k=n.length-1;k>=0;--k){const M=n.charCodeAt(k);if(M===a){if(!v){L=k+1;break}}else y===-1&&(v=!1,y=k+1),p>=0&&(M===l.charCodeAt(p)?--p===-1&&(d=k):(p=-1,d=y))}return L===d?d=y:d===-1&&(d=n.length),n.slice(L,d)}for(k=n.length-1;k>=0;--k)if(n.charCodeAt(k)===a){if(!v){L=k+1;break}}else d===-1&&(v=!1,d=k+1);return d===-1?"":n.slice(L,d)},extname(n){e(n,"path");let l=-1,L=0,d=-1,v=!0,k=0;for(let p=n.length-1;p>=0;--p){const y=n.charCodeAt(p);if(y===a){if(!v){L=p+1;break}continue}d===-1&&(v=!1,d=p+1),y===f?l===-1?l=p:k!==1&&(k=1):l!==-1&&(k=-1)}return l===-1||d===-1||k===0||k===1&&l===d-1&&l===L+1?"":n.slice(l,d)},format:u.bind(null,"/"),parse(n){e(n,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return l;const L=n.charCodeAt(0)===a;let d;L?(l.root="/",d=1):d=0;let v=-1,k=0,p=-1,y=!0,M=n.length-1,P=0;for(;M>=d;--M){const T=n.charCodeAt(M);if(T===a){if(!y){k=M+1;break}continue}p===-1&&(y=!1,p=M+1),T===f?v===-1?v=M:P!==1&&(P=1):v!==-1&&(P=-1)}if(p!==-1){const T=k===0&&L?1:k;v===-1||P===0||P===1&&v===p-1&&v===k+1?l.base=l.name=n.slice(T,p):(l.name=n.slice(T,v),l.base=n.slice(T,p),l.ext=n.slice(v,p))}return k>0?l.dir=n.slice(0,k-1):L&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=E?t.$fc.normalize:t.$gc.normalize,t.$ic=E?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=E?t.$fc.join:t.$gc.join,t.$kc=E?t.$fc.resolve:t.$gc.resolve,t.$lc=E?t.$fc.relative:t.$gc.relative,t.$mc=E?t.$fc.dirname:t.$gc.dirname,t.$nc=E?t.$fc.basename:t.$gc.basename,t.$oc=E?t.$fc.extname:t.$gc.extname,t.$pc=E?t.$fc.format:t.$gc.format,t.$qc=E?t.$fc.parse:t.$gc.parse,t.$rc=E?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=E?t.$fc.sep:t.$gc.sep,t.$tc=E?t.$fc.delimiter:t.$gc.delimiter}),te(se[23],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1d=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(o){return new F(o)}constructor(o){this.c=_&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$1d=F}),te(se[11],le([0,1,3,19,10,21,23]),function(W,t,_,F,r,o,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.Event=void 0;const f=!1,a=!1;var s;(function(M){M.None=()=>r.$Tc.None;function P(x){if(a){const{onDidAddListener:G}=x,Z=e.create();let K=0;x.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),G?.()}}}function T(x,G){return ne(x,()=>{},0,void 0,!0,void 0,G)}M.defer=T;function D(x){return(G,Z=null,K)=>{let re=!1,ae;return ae=x(ce=>{if(!re)return ae?ae.dispose():re=!0,G.call(Z,ce)},null,K),re&&ae.dispose(),ae}}M.once=D;function q(x,G,Z){return Y((K,re=null,ae)=>x(ce=>K.call(re,G(ce)),null,ae),Z)}M.map=q;function V(x,G,Z){return Y((K,re=null,ae)=>x(ce=>{G(ce),K.call(re,ce)},null,ae),Z)}M.forEach=V;function H(x,G,Z){return Y((K,re=null,ae)=>x(ce=>G(ce)&&K.call(re,ce),null,ae),Z)}M.filter=H;function ee(x){return x}M.signal=ee;function S(...x){return(G,Z=null,K)=>{const re=(0,r.$Qc)(...x.map(ae=>ae(ce=>G.call(Z,ce))));return X(re,K)}}M.any=S;function U(x,G,Z,K){let re=Z;return q(x,ae=>(re=G(re,ae),re),K)}M.reduce=U;function Y(x,G){let Z;const K={onWillAddFirstListener(){Z=x(re.fire,re)},onDidRemoveLastListener(){Z?.dispose()}};G||P(K);const re=new b(K);return G?.add(re),re.event}function X(x,G){return G instanceof Array?G.push(x):G&&G.add(x),x}function ne(x,G,Z=100,K=!1,re=!1,ae,ce){let fe,me,ke,_e=0,ye;const qe={leakWarningThreshold:ae,onWillAddFirstListener(){fe=x(Ue=>{_e++,me=G(me,Ue),K&&!ke&&(Pe.fire(me),me=void 0),ye=()=>{const Le=me;me=void 0,ke=void 0,(!K||_e>1)&&Pe.fire(Le),_e=0},typeof Z=="number"?(clearTimeout(ke),ke=setTimeout(ye,Z)):ke===void 0&&(ke=0,queueMicrotask(ye))})},onWillRemoveListener(){re&&_e>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,fe.dispose()}};ce||P(qe);const Pe=new b(qe);return ce?.add(Pe),Pe.event}M.debounce=ne;function ue(x,G=0,Z){return M.debounce(x,(K,re)=>K?(K.push(re),K):[re],G,void 0,!0,void 0,Z)}M.accumulate=ue;function i(x,G=(K,re)=>K===re,Z){let K=!0,re;return H(x,ae=>{const ce=K||!G(ae,re);return K=!1,re=ae,ce},Z)}M.latch=i;function ge(x,G,Z){return[M.filter(x,G,Z),M.filter(x,K=>!G(K),Z)]}M.split=ge;function ve(x,G=!1,Z=[],K){let re=Z.slice(),ae=x(me=>{re?re.push(me):fe.fire(me)});K&&K.add(ae);const ce=()=>{re?.forEach(me=>fe.fire(me)),re=null},fe=new b({onWillAddFirstListener(){ae||(ae=x(me=>fe.fire(me)),K&&K.add(ae))},onDidAddFirstListener(){re&&(G?setTimeout(ce):ce())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return K&&K.add(fe),fe.event}M.buffer=ve;function Re(x,G){return(K,re,ae)=>{const ce=G(new pe);return x(function(fe){const me=ce.evaluate(fe);me!==$e&&K.call(re,me)},void 0,ae)}}M.chain=Re;const $e=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(Z=>(G(Z),Z)),this}filter(G){return this.f.push(Z=>G(Z)?Z:$e),this}reduce(G,Z){let K=Z;return this.f.push(re=>(K=G(K,re),K)),this}latch(G=(Z,K)=>Z===K){let Z=!0,K;return this.f.push(re=>{const ae=Z||!G(re,K);return Z=!1,K=re,ae?re:$e}),this}evaluate(G){for(const Z of this.f)if(G=Z(G),G===$e)break;return G}}function Te(x,G,Z=K=>K){const K=(...fe)=>ce.fire(Z(...fe)),re=()=>x.on(G,K),ae=()=>x.removeListener(G,K),ce=new b({onWillAddFirstListener:re,onDidRemoveLastListener:ae});return ce.event}M.fromNodeEventEmitter=Te;function Me(x,G,Z=K=>K){const K=(...fe)=>ce.fire(Z(...fe)),re=()=>x.addEventListener(G,K),ae=()=>x.removeEventListener(G,K),ce=new b({onWillAddFirstListener:re,onDidRemoveLastListener:ae});return ce.event}M.fromDOMEventEmitter=Me;function Se(x){return new Promise(G=>D(x)(G))}M.toPromise=Se;function Ne(x){const G=new b;return x.then(Z=>{G.fire(Z)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}M.fromPromise=Ne;function B(x,G,Z){return G(Z),x(K=>G(K))}M.runAndSubscribe=B;class C{constructor(G,Z){this._observable=G,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Z||P(K),this.emitter=new b(K),Z&&Z.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,Z){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function j(x,G){return new C(x,G).emitter.event}M.fromObservable=j;function J(x){return(G,Z,K)=>{let re=0,ae=!1;const ce={beginUpdate(){re++},endUpdate(){re--,re===0&&(x.reportChanges(),ae&&(ae=!1,G.call(Z)))},handlePossibleChange(){},handleChange(){ae=!0}};x.addObserver(ce),x.reportChanges();const fe={dispose(){x.removeObserver(ce)}};return K instanceof r.$Sc?K.add(fe):Array.isArray(K)&&K.push(fe),fe}}M.fromObservableLight=J})(s||(t.Event=s={}));class h{constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${h.f++}`,h.all.add(this)}start(P){this.g=new w.$1d,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$3d=h,h.all=new Set,h.f=0;let A=-1;function g(M){const P=A;return A=M,{dispose(){A=P}}}t.$4d=g;class m{constructor(P,T=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=T,this.g=0}dispose(){this.f?.clear()}check(P,T){const D=this.threshold;if(D<=0||T<D)return;this.f||(this.f=new Map);const q=this.f.get(P.value)||0;if(this.f.set(P.value,q+1),this.g-=1,this.g<=0){this.g=D*.5;let V,H=0;for(const[ee,S]of this.f)(!V||H<S)&&(V=ee,H=S);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${H}):`),console.warn(V)}return()=>{const V=this.f.get(P.value)||0;this.f.set(P.value,V-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class R{constructor(P){this.value=P,this.id=E++}}const N=2,$=(M,P)=>{if(M instanceof R)P(M);else for(let T=0;T<M.length;T++){const D=M[T];D&&P(D)}};class b{constructor(P){this.w=0,this.f=P,this.g=A>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(f){const P=this.t;queueMicrotask(()=>{$(P,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(P,T,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Tc.None;if(this.m)return r.$Tc.None;T&&(P=P.bind(T));const q=new R(P);let V,H;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),V=this.g.check(q.stack,this.w+1)),f&&(q.stack=H??e.create()),this.t?this.t instanceof R?(this.u??(this.u=new c),this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,r.$Rc)(()=>{V?.(),this.x(q)});return D instanceof r.$Sc?D.add(ee):Array.isArray(D)&&D.push(ee),ee}),this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,D=T.indexOf(P);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[D]=void 0;const q=this.u.current===this;if(this.w*N<=T.length){let V=0;for(let H=0;H<T.length;H++)T[H]?T[V++]=T[H]:q&&(this.u.end--,V<this.u.i&&this.u.i--);T.length=V}}y(P,T){if(!P)return;const D=this.f?.onListenerError||_.$1;if(!D){P.value(T);return}try{P.value(T)}catch(q){D(q)}}z(P){const T=P.current.t;for(;P.i<P.end;)this.y(T[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,P);else{const T=this.u;T.enqueue(this,P,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}t.$5d=b;const u=()=>new c;t.$6d=u;class c{constructor(){this.i=-1,this.end=0}enqueue(P,T,D){this.i=0,this.end=D,this.current=P,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends b{async fireAsync(P,T,D){if(this.t)for(this.h||(this.h=new o.$4c),$(this.t,q=>this.h.push([q.value,P]));this.h.size>0&&!T.isCancellationRequested;){const[q,V]=this.h.shift(),H=[],ee={...V,token:T,waitUntil:S=>{if(Object.isFrozen(H))throw new Error("waitUntil can NOT be called asynchronous");D&&(S=D(S,q)),H.push(S)}};try{q(ee)}catch(S){(0,_.$1)(S);continue}Object.freeze(H),await Promise.allSettled(H).then(S=>{for(const U of S)U.status==="rejected"&&(0,_.$1)(U.reason)})}}}t.$7d=n;class l extends b{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new o.$4c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$8d=l;class L extends l{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$9d=L;class d extends b{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}t.$0d=d;class v{constructor(){this.g=!1,this.h=[],this.f=new b({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const T={event:P,listener:null};this.h.push(T),this.g&&this.m(T);const D=()=>{this.g&&this.o(T);const q=this.h.indexOf(T);this.h.splice(q,1)};return(0,r.$Rc)((0,F.$db)(D))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(T=>this.f.fire(T))}o(P){P.listener?.dispose(),P.listener=null}dispose(){this.f.dispose();for(const P of this.h)P.listener?.dispose();this.h=[]}}t.$$d=v;class k{constructor(P,T,D,q){this.f=new r.$Sc;const V=this.f.add(new v),H=this.f.add(new r.$3c);function ee(S){H.set(S,V.add(q(S)))}for(const S of P)ee(S);this.f.add(T(S=>{ee(S)})),this.f.add(D(S=>{H.deleteAndDispose(S)})),this.event=V.event}dispose(){this.f.dispose()}}t.$_d=k;class p{constructor(){this.f=[]}wrapEvent(P){return(T,D,q)=>P(V=>{const H=this.f[this.f.length-1];H?H.push(()=>T.call(D,V)):T.call(D,V)},void 0,q)}bufferEvents(P){const T=[];this.f.push(T);const D=P();return this.f.pop(),T.forEach(q=>q()),D}}t.$ae=p;class y{constructor(){this.f=!1,this.g=s.None,this.h=r.$Tc.None,this.j=new b({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$be=y}),te(se[24],le([0,1,11]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=t.CancellationToken=void 0;const F=Object.freeze(function(f,a){const s=setTimeout(f.bind(a),0);return{dispose(){clearTimeout(s)}}});var r;(function(f){function a(s){return s===f.None||s===f.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}f.isCancellationToken=a,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(r||(t.CancellationToken=r={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new _.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new o),this.f}cancel(){this.f?this.f instanceof o&&this.f.cancel():this.f=r.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof o&&this.f.dispose():this.f=r.None}}t.$ce=w}),te(se[41],le([0,1,24]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pe=t.$Oe=t.$Ne=void 0;class F{constructor(f){this.b=f,this.a=null}get(){if(this.a)return this.a;const f=new _.$ce,a=this.b(f.token);return this.a={promise:a,dispose:()=>{this.a=null,f.cancel(),f.dispose()}},this.a}}t.$Ne=F;class r{constructor(f){this.c=f,this.a=void 0,this.b=void 0}get(f){const a=JSON.stringify(f);return this.b!==a&&(this.b=a,this.a=this.c(f)),this.a}}t.$Oe=r;class o{get cachedValues(){return this.a}constructor(f){this.b=f,this.a=new Map}get(f){if(this.a.has(f))return this.a.get(f);const a=this.b(f);return this.a.set(f,a),a}}t.$Pe=o}),te(se[7],le([0,1,41,38]),function(W,t,_,F){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Rf=t.$Qf=t.$Pf=t.$Of=t.GraphemeBreakType=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=void 0;function o(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.$Se=o;const w=/{(\d+)}/g;function f(I,...O){return O.length===0?I:I.replace(w,function(z,Q){const ie=parseInt(Q,10);return isNaN(ie)||ie<0||ie>=O.length?z:O[ie]})}t.$Te=f;const a=/{([^}]+)}/g;function s(I,O){return Object.keys(O).length===0?I:I.replace(a,(z,Q)=>O[Q]??z)}t.$Ue=s;function h(I){return I.replace(/[<>"'&]/g,O=>{switch(O){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return O})}t.$Ve=h;function A(I){return I.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}t.$We=A;function g(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Xe=g;function m(I,O){let z=0;const Q=O.charCodeAt(0);for(let ie=I.length-1;ie>=0;ie--)I.charCodeAt(ie)===Q&&z++;return z}t.$Ye=m;function e(I,O,z="\u2026"){return I.length<=O?I:`${I.substr(0,O)}${z}`}t.$Ze=e;function E(I,O,z="\u2026"){if(I.length<=O)return I;const Q=Math.ceil(O/2)-z.length/2,ie=Math.floor(O/2)-z.length/2;return`${I.substr(0,Q)}${z}${I.substr(I.length-ie)}`}t.$1e=E;function R(I,O=" "){const z=N(I,O);return $(z,O)}t.$2e=R;function N(I,O){if(!I||!O)return I;const z=O.length;if(z===0||I.length===0)return I;let Q=0;for(;I.indexOf(O,Q)===Q;)Q=Q+z;return I.substring(Q)}t.$3e=N;function $(I,O){if(!I||!O)return I;const z=O.length,Q=I.length;if(z===0||Q===0)return I;let ie=Q,oe=-1;for(;oe=I.lastIndexOf(O,ie-1),!(oe===-1||oe+z!==ie);){if(oe===0)return"";ie=oe}return I.substring(0,ie)}t.$4e=$;function b(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$5e=b;function u(I){return I.replace(/\*/g,"")}t.$6e=u;function c(I,O,z={}){if(!I)throw new Error("Cannot create regex from empty string");O||(I=g(I)),z.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Q="";return z.global&&(Q+="g"),z.matchCase||(Q+="i"),z.multiline&&(Q+="m"),z.unicode&&(Q+="u"),new RegExp(I,Q)}t.$7e=c;function n(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.$8e=n;function l(I){return I.split(/\r\n|\r|\n/)}t.$9e=l;function L(I){const O=[],z=I.split(/(\r\n|\r|\n)/);for(let Q=0;Q<Math.ceil(z.length/2);Q++)O.push(z[2*Q]+(z[2*Q+1]??""));return O}t.$0e=L;function d(I){for(let O=0,z=I.length;O<z;O++){const Q=I.charCodeAt(O);if(Q!==32&&Q!==9)return O}return-1}t.$$e=d;function v(I,O=0,z=I.length){for(let Q=O;Q<z;Q++){const ie=I.charCodeAt(Q);if(ie!==32&&ie!==9)return I.substring(O,Q)}return I.substring(O,z)}t.$_e=v;function k(I,O=I.length-1){for(let z=O;z>=0;z--){const Q=I.charCodeAt(z);if(Q!==32&&Q!==9)return z}return-1}t.$af=k;function p(I,O,z){const Q=[];let ie=0;for(const oe of I.matchAll(O)){if(Q.push(I.slice(ie,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ie=oe.index+oe[0].length,Q.push(z(oe[0],...oe.slice(1),oe.index,I,oe.groups))}return Q.push(I.slice(ie)),Promise.all(Q).then(oe=>oe.join(""))}t.$bf=p;function y(I,O){return I<O?-1:I>O?1:0}t.$cf=y;function M(I,O,z=0,Q=I.length,ie=0,oe=O.length){for(;z<Q&&ie<oe;z++,ie++){const Ee=I.charCodeAt(z),he=O.charCodeAt(ie);if(Ee<he)return-1;if(Ee>he)return 1}const be=Q-z,Fe=oe-ie;return be<Fe?-1:be>Fe?1:0}t.$df=M;function P(I,O){return T(I,O,0,I.length,0,O.length)}t.$ef=P;function T(I,O,z=0,Q=I.length,ie=0,oe=O.length){for(;z<Q&&ie<oe;z++,ie++){let Ee=I.charCodeAt(z),he=O.charCodeAt(ie);if(Ee===he)continue;if(Ee>=128||he>=128)return M(I.toLowerCase(),O.toLowerCase(),z,Q,ie,oe);q(Ee)&&(Ee-=32),q(he)&&(he-=32);const we=Ee-he;if(we!==0)return we}const be=Q-z,Fe=oe-ie;return be<Fe?-1:be>Fe?1:0}t.$ff=T;function D(I){return I>=48&&I<=57}t.$gf=D;function q(I){return I>=97&&I<=122}t.$hf=q;function V(I){return I>=65&&I<=90}t.$if=V;function H(I,O){return I.length===O.length&&T(I,O)===0}t.$jf=H;function ee(I,O){const z=O.length;return O.length>I.length?!1:T(I,O,0,z)===0}t.$kf=ee;function S(I,O){const z=Math.min(I.length,O.length);let Q;for(Q=0;Q<z;Q++)if(I.charCodeAt(Q)!==O.charCodeAt(Q))return Q;return z}t.$lf=S;function U(I,O){const z=Math.min(I.length,O.length);let Q;const ie=I.length-1,oe=O.length-1;for(Q=0;Q<z;Q++)if(I.charCodeAt(ie-Q)!==O.charCodeAt(oe-Q))return Q;return z}t.$mf=U;function Y(I){return 55296<=I&&I<=56319}t.$nf=Y;function X(I){return 56320<=I&&I<=57343}t.$of=X;function ne(I,O){return(I-55296<<10)+(O-56320)+65536}t.$pf=ne;function ue(I,O,z){const Q=I.charCodeAt(z);if(Y(Q)&&z+1<O){const ie=I.charCodeAt(z+1);if(X(ie))return ne(Q,ie)}return Q}t.$qf=ue;function i(I,O){const z=I.charCodeAt(O-1);if(X(z)&&O>1){const Q=I.charCodeAt(O-2);if(Y(Q))return ne(Q,z)}return z}class ge{get offset(){return this.e}constructor(O,z=0){this.c=O,this.d=O.length,this.e=z}setOffset(O){this.e=O}prevCodePoint(){const O=i(this.c,this.e);return this.e-=O>=65536?2:1,O}nextCodePoint(){const O=ue(this.c,this.d,this.e);return this.e+=O>=65536?2:1,O}eol(){return this.e>=this.d}}t.$rf=ge;class ve{get offset(){return this.c.offset}constructor(O,z=0){this.c=new ge(O,z)}nextGraphemeLength(){const O=Le.getInstance(),z=this.c,Q=z.offset;let ie=O.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const oe=z.offset,be=O.getGraphemeBreakType(z.nextCodePoint());if(Pe(ie,be)){z.setOffset(oe);break}ie=be}return z.offset-Q}prevGraphemeLength(){const O=Le.getInstance(),z=this.c,Q=z.offset;let ie=O.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const oe=z.offset,be=O.getGraphemeBreakType(z.prevCodePoint());if(Pe(be,ie)){z.setOffset(oe);break}ie=be}return Q-z.offset}eol(){return this.c.eol()}}t.$sf=ve;function Re(I,O){return new ve(I,O).nextGraphemeLength()}t.$tf=Re;function $e(I,O){return new ve(I,O).prevGraphemeLength()}t.$uf=$e;function pe(I,O){O>0&&X(I.charCodeAt(O))&&O--;const z=O+Re(I,O);return[z-$e(I,z),z]}t.$vf=pe;function Te(I){const O=new ve(I);let z=0;for(;!O.eol();)z++,O.nextGraphemeLength();return z}t.$wf=Te;let Me;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ne(I){return Me||(Me=Se()),Me.test(I)}t.$xf=Ne;const B=/^[\t\n\r\x20-\x7E]*$/;function C(I){return B.test(I)}t.$yf=C,t.$zf=/[\u2028\u2029]/;function j(I){return t.$zf.test(I)}t.$Af=j;function J(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.$Bf=J;function x(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.$Cf=x;function G(I,O,z=""){const Q=I.trimStart();if(Q.length<O)return Q;const ie=/\b/g;let oe=0;for(;ie.test(Q)&&!(Q.length-ie.lastIndex<O);)oe=ie.lastIndex,ie.lastIndex+=1;return oe===0?Q:z+Q.substring(oe).trimStart()}t.$Df=G;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,K=/\x1b\].*?\x07/g;function re(I){return I&&(I=I.replace(Z,"").replace(K,"")),I}t.$Ef=re,t.$Ff="\uFEFF";function ae(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.$Gf=ae;function ce(I){return ae(I)?I.substr(1):I}t.$Hf=ce;function fe(I,O){if(!I||!O||I.length<O.length)return!1;const z=O.length,Q=I.toLowerCase();let ie=0,oe=-1;for(;ie<z;){const be=Q.indexOf(O[ie],oe+1);if(be<0)return!1;oe=be,ie++}return!0}t.$If=fe;function me(I,O=!1){return I?(O&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.$Jf=me;function ke(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.$Kf=ke;function _e(I,O=1){if(O===0)return"";let z=-1;do z=I.indexOf(`
`,z+1),O--;while(O>0&&z>=0);return z===-1?I:(I[z-1]==="\r"&&z--,I.substr(0,z))}t.$Lf=_e;function ye(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.$Mf=ye;function qe(I){return Le.getInstance().getGraphemeBreakType(I)}t.$Nf=qe;function Pe(I,O){return I===0?O!==5&&O!==7:I===2&&O===3?!1:I===4||I===2||I===3||O===4||O===2||O===3?!0:!(I===8&&(O===8||O===9||O===11||O===12)||(I===11||I===9)&&(O===9||O===10)||(I===12||I===10)&&O===10||O===5||O===13||O===7||I===1||I===13&&O===14||I===6&&O===6)}var Ue;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(Ue||(t.GraphemeBreakType=Ue={}));class Le{static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=Ce()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const z=this.d,Q=z.length/3;let ie=1;for(;ie<=Q;)if(O<z[3*ie])ie=2*ie;else if(O>z[3*ie+1])ie=2*ie+1;else return z[3*ie+2];return 0}}Le.c=null;function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(I,O){if(I===0)return 0;const z=ze(I,O);if(z!==void 0)return z;const Q=new ge(O,I);return Q.prevCodePoint(),Q.offset}t.$Of=xe;function ze(I,O){const z=new ge(O,I);let Q=z.prevCodePoint();for(;He(Q)||Q===65039||Q===8419;){if(z.offset===0)return;Q=z.prevCodePoint()}if(!x(Q))return;let ie=z.offset;return ie>0&&z.prevCodePoint()===8205&&(ie=z.offset),ie}function He(I){return 127995<=I&&I<=127999}var Ve;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.$Pf="\xA0";class Ie{static getInstance(O){return r.d.get(Array.from(O))}static getLocales(){return r.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Qf=Ie,r=Ie,Ie.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ie.d=new _.$Oe(I=>{function O(he){const we=new Map;for(let Ae=0;Ae<he.length;Ae+=2)we.set(he[Ae],he[Ae+1]);return we}function z(he,we){const Ae=new Map(he);for(const[Be,Oe]of we)Ae.set(Be,Oe);return Ae}function Q(he,we){if(!he)return we;const Ae=new Map;for(const[Be,Oe]of he)we.has(Be)&&Ae.set(Be,Oe);return Ae}const ie=r.c.value;let oe=I.filter(he=>!he.startsWith("_")&&he in ie);oe.length===0&&(oe=["_default"]);let be;for(const he of oe){const we=O(ie[he]);be=Q(be,we)}const Fe=O(ie._common),Ee=z(Fe,be);return new r(Ee)}),Ie.e=new F.$V(()=>Object.keys(r.c.value).filter(I=>!I.startsWith("_")));class De{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(De.c())),this.d}static isInvisibleCharacter(O){return De.e().has(O)}static get codePoints(){return De.e()}}t.$Rf=De,De.d=void 0}),te(se[42],le([0,1,7]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$i=t.$0i=t.$9i=t.$8i=t.$7i=t.$6i=t.$5i=void 0;function F(N){return r(N,0)}t.$5i=F;function r(N,$){switch(typeof N){case"object":return N===null?o(349,$):Array.isArray(N)?a(N,$):s(N,$);case"string":return f(N,$);case"boolean":return w(N,$);case"number":return o(N,$);case"undefined":return o(937,$);default:return o(617,$)}}t.$6i=r;function o(N,$){return($<<5)-$+N|0}t.$7i=o;function w(N,$){return o(N?433:863,$)}function f(N,$){$=o(149417,$);for(let b=0,u=N.length;b<u;b++)$=o(N.charCodeAt(b),$);return $}t.$8i=f;function a(N,$){return $=o(104579,$),N.reduce((b,u)=>r(u,b),$)}function s(N,$){return $=o(181387,$),Object.keys(N).sort().reduce((b,u)=>(b=f(u,b),r(N[u],b)),$)}class h{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=r($,this.g),this.g}}t.$9i=h;var A;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function g(N,$,b=32){const u=b-$,c=~((1<<u)-1);return(N<<$|(c&N)>>>u)>>>0}function m(N,$=0,b=N.byteLength,u=0){for(let c=0;c<b;c++)N[$+c]=u}function e(N,$,b="0"){for(;N.length<$;)N=b+N;return N}function E(N,$=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(b=>b.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),$/4)}t.$0i=E;class R{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const b=$.length;if(b===0)return;const u=this.p;let c=this.r,n=this.u,l,L;for(n!==0?(l=n,L=-1,n=0):(l=$.charCodeAt(0),L=0);;){let d=l;if(_.$nf(l))if(L+1<b){const v=$.charCodeAt(L+1);_.$of(v)?(L++,d=_.$pf(l,v)):d=65533}else{n=l;break}else _.$of(l)&&(d=65533);if(c=this.w(u,c,d),L++,L<b)l=$.charCodeAt(L);else break}this.r=c,this.u=n}w($,b,u){return u<128?$[b++]=u:u<2048?($[b++]=192|(u&1984)>>>6,$[b++]=128|(u&63)>>>0):u<65536?($[b++]=224|(u&61440)>>>12,$[b++]=128|(u&4032)>>>6,$[b++]=128|(u&63)>>>0):($[b++]=240|(u&1835008)>>>18,$[b++]=128|(u&258048)>>>12,$[b++]=128|(u&4032)>>>6,$[b++]=128|(u&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=R.g,b=this.q;for(let p=0;p<64;p+=4)$.setUint32(p,b.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)$.setUint32(p,g($.getUint32(p-12,!1)^$.getUint32(p-32,!1)^$.getUint32(p-56,!1)^$.getUint32(p-64,!1),1),!1);let u=this.h,c=this.l,n=this.m,l=this.n,L=this.o,d,v,k;for(let p=0;p<80;p++)p<20?(d=c&n|~c&l,v=1518500249):p<40?(d=c^n^l,v=1859775393):p<60?(d=c&n|c&l|n&l,v=2400959708):(d=c^n^l,v=3395469782),k=g(u,5)+d+L+v+$.getUint32(p*4,!1)&4294967295,L=l,l=n,n=g(c,30),c=u,u=k;this.h=this.h+u&4294967295,this.l=this.l+c&4294967295,this.m=this.m+n&4294967295,this.n=this.n+l&4294967295,this.o=this.o+L&4294967295}}t.$$i=R,R.g=new DataView(new ArrayBuffer(320))}),te(se[25],le([0,1,36,42]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=t.$_s=t.$$s=void 0;class r{constructor(g){this.a=g}getElements(){const g=this.a,m=new Int32Array(g.length);for(let e=0,E=g.length;e<E;e++)m[e]=g.charCodeAt(e);return m}}t.$$s=r;function o(A,g,m){return new h(new r(A),new r(g)).ComputeDiff(m).changes}t.$_s=o;class w{static Assert(g,m){if(!g)throw new Error(m)}}class f{static Copy(g,m,e,E,R){for(let N=0;N<R;N++)e[E+N]=g[m+N]}static Copy2(g,m,e,E,R){for(let N=0;N<R;N++)e[E+N]=g[m+N]}}var a;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new _.$0s(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(g,m,e=null){this.a=e,this.b=g,this.c=m;const[E,R,N]=h.o(g),[$,b,u]=h.o(m);this.d=N&&u,this.e=E,this.f=R,this.g=$,this.h=b,this.k=[],this.m=[]}static n(g){return g.length>0&&typeof g[0]=="string"}static o(g){const m=g.getElements();if(h.n(m)){const e=new Int32Array(m.length);for(let E=0,R=m.length;E<R;E++)e[E]=(0,F.$8i)(m[E],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(g,m){return this.f[g]!==this.h[m]?!1:this.d?this.e[g]===this.g[m]:!0}q(g,m){if(!this.p(g,m))return!1;const e=h.r(this.b,g),E=h.r(this.c,m);return e===E}static r(g,m){return typeof g.getStrictElement=="function"?g.getStrictElement(m):null}s(g,m){return this.f[g]!==this.f[m]?!1:this.d?this.e[g]===this.e[m]:!0}u(g,m){return this.h[g]!==this.h[m]?!1:this.d?this.g[g]===this.g[m]:!0}ComputeDiff(g){return this.v(0,this.f.length-1,0,this.h.length-1,g)}v(g,m,e,E,R){const N=[!1];let $=this.w(g,m,e,E,N);return R&&($=this.z($)),{quitEarly:N[0],changes:$}}w(g,m,e,E,R){for(R[0]=!1;g<=m&&e<=E&&this.p(g,e);)g++,e++;for(;m>=g&&E>=e&&this.p(m,E);)m--,E--;if(g>m||e>E){let n;return e<=E?(w.Assert(g===m+1,"originalStart should only be one more than originalEnd"),n=[new _.$0s(g,0,e,E-e+1)]):g<=m?(w.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),n=[new _.$0s(g,m-g+1,e,0)]):(w.Assert(g===m+1,"originalStart should only be one more than originalEnd"),w.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const N=[0],$=[0],b=this.y(g,m,e,E,N,$,R),u=N[0],c=$[0];if(b!==null)return b;if(!R[0]){const n=this.w(g,u,e,c,R);let l=[];return R[0]?l=[new _.$0s(u+1,m-(u+1)+1,c+1,E-(c+1)+1)]:l=this.w(u+1,m,c+1,E,R),this.H(n,l)}return[new _.$0s(g,m-g+1,e,E-e+1)]}x(g,m,e,E,R,N,$,b,u,c,n,l,L,d,v,k,p,y){let M=null,P=null,T=new s,D=m,q=e,V=L[0]-k[0]-E,H=-1073741824,ee=this.k.length-1;do{const S=V+g;S===D||S<q&&u[S-1]<u[S+1]?(n=u[S+1],d=n-V-E,n<H&&T.MarkNextChange(),H=n,T.AddModifiedElement(n+1,d),V=S+1-g):(n=u[S-1]+1,d=n-V-E,n<H&&T.MarkNextChange(),H=n-1,T.AddOriginalElement(n,d+1),V=S-1-g),ee>=0&&(u=this.k[ee],g=u[0],D=1,q=u.length-1)}while(--ee>=-1);if(M=T.getReverseChanges(),y[0]){let S=L[0]+1,U=k[0]+1;if(M!==null&&M.length>0){const Y=M[M.length-1];S=Math.max(S,Y.getOriginalEnd()),U=Math.max(U,Y.getModifiedEnd())}P=[new _.$0s(S,l-S+1,U,v-U+1)]}else{T=new s,D=N,q=$,V=L[0]-k[0]-b,H=1073741824,ee=p?this.m.length-1:this.m.length-2;do{const S=V+R;S===D||S<q&&c[S-1]>=c[S+1]?(n=c[S+1]-1,d=n-V-b,n>H&&T.MarkNextChange(),H=n+1,T.AddOriginalElement(n+1,d+1),V=S+1-R):(n=c[S-1],d=n-V-b,n>H&&T.MarkNextChange(),H=n,T.AddModifiedElement(n+1,d+1),V=S-1-R),ee>=0&&(c=this.m[ee],R=c[0],D=1,q=c.length-1)}while(--ee>=-1);P=T.getChanges()}return this.H(M,P)}y(g,m,e,E,R,N,$){let b=0,u=0,c=0,n=0,l=0,L=0;g--,e--,R[0]=0,N[0]=0,this.k=[],this.m=[];const d=m-g+(E-e),v=d+1,k=new Int32Array(v),p=new Int32Array(v),y=E-e,M=m-g,P=g-e,T=m-E,q=(M-y)%2===0;k[y]=g,p[M]=m,$[0]=!1;for(let V=1;V<=d/2+1;V++){let H=0,ee=0;c=this.J(y-V,V,y,v),n=this.J(y+V,V,y,v);for(let U=c;U<=n;U+=2){U===c||U<n&&k[U-1]<k[U+1]?b=k[U+1]:b=k[U-1]+1,u=b-(U-y)-P;const Y=b;for(;b<m&&u<E&&this.p(b+1,u+1);)b++,u++;if(k[U]=b,b+u>H+ee&&(H=b,ee=u),!q&&Math.abs(U-M)<=V-1&&b>=p[U])return R[0]=b,N[0]=u,Y<=p[U]&&1447>0&&V<=1448?this.x(y,c,n,P,M,l,L,T,k,p,b,m,R,u,E,N,q,$):null}const S=(H-g+(ee-e)-V)/2;if(this.a!==null&&!this.a(H,S))return $[0]=!0,R[0]=H,N[0]=ee,S>0&&1447>0&&V<=1448?this.x(y,c,n,P,M,l,L,T,k,p,b,m,R,u,E,N,q,$):(g++,e++,[new _.$0s(g,m-g+1,e,E-e+1)]);l=this.J(M-V,V,M,v),L=this.J(M+V,V,M,v);for(let U=l;U<=L;U+=2){U===l||U<L&&p[U-1]>=p[U+1]?b=p[U+1]-1:b=p[U-1],u=b-(U-M)-T;const Y=b;for(;b>g&&u>e&&this.p(b,u);)b--,u--;if(p[U]=b,q&&Math.abs(U-y)<=V&&b<=k[U])return R[0]=b,N[0]=u,Y>=k[U]&&1447>0&&V<=1448?this.x(y,c,n,P,M,l,L,T,k,p,b,m,R,u,E,N,q,$):null}if(V<=1447){let U=new Int32Array(n-c+2);U[0]=y-c+1,f.Copy2(k,c,U,1,n-c+1),this.k.push(U),U=new Int32Array(L-l+2),U[0]=M-l+1,f.Copy2(p,l,U,1,L-l+1),this.m.push(U)}}return this.x(y,c,n,P,M,l,L,T,k,p,b,m,R,u,E,N,q,$)}z(g){for(let m=0;m<g.length;m++){const e=g[m],E=m<g.length-1?g[m+1].originalStart:this.f.length,R=m<g.length-1?g[m+1].modifiedStart:this.h.length,N=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<R&&(!N||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const b=[null];if(m<g.length-1&&this.I(g[m],g[m+1],b)){g[m]=b[0],g.splice(m+1,1),m--;continue}}for(let m=g.length-1;m>=0;m--){const e=g[m];let E=0,R=0;if(m>0){const n=g[m-1];E=n.originalStart+n.originalLength,R=n.modifiedStart+n.modifiedLength}const N=e.originalLength>0,$=e.modifiedLength>0;let b=0,u=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const l=e.originalStart-n,L=e.modifiedStart-n;if(l<E||L<R||N&&!this.s(l,l+e.originalLength)||$&&!this.u(L,L+e.modifiedLength))break;const v=(l===E&&L===R?5:0)+this.G(l,e.originalLength,L,e.modifiedLength);v>u&&(u=v,b=n)}e.originalStart-=b,e.modifiedStart-=b;const c=[null];if(m>0&&this.I(g[m-1],g[m],c)){g[m-1]=c[0],g.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=g.length;m<e;m++){const E=g[m-1],R=g[m],N=R.originalStart-E.originalStart-E.originalLength,$=E.originalStart,b=R.originalStart+R.originalLength,u=b-$,c=E.modifiedStart,n=R.modifiedStart+R.modifiedLength,l=n-c;if(N<5&&u<20&&l<20){const L=this.A($,u,c,l,N);if(L){const[d,v]=L;(d!==E.originalStart+E.originalLength||v!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=d-E.originalStart,E.modifiedLength=v-E.modifiedStart,R.originalStart=d+N,R.modifiedStart=v+N,R.originalLength=b-R.originalStart,R.modifiedLength=n-R.modifiedStart)}}}return g}A(g,m,e,E,R){if(m<R||E<R)return null;const N=g+m-R+1,$=e+E-R+1;let b=0,u=0,c=0;for(let n=g;n<N;n++)for(let l=e;l<$;l++){const L=this.B(n,l,R);L>0&&L>b&&(b=L,u=n,c=l)}return b>0?[u,c]:null}B(g,m,e){let E=0;for(let R=0;R<e;R++){if(!this.p(g+R,m+R))return 0;E+=this.e[g+R].length}return E}C(g){return g<=0||g>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[g])}D(g,m){if(this.C(g)||this.C(g-1))return!0;if(m>0){const e=g+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(g){return g<=0||g>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[g])}F(g,m){if(this.E(g)||this.E(g-1))return!0;if(m>0){const e=g+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(g,m,e,E){const R=this.D(g,m)?1:0,N=this.F(e,E)?1:0;return R+N}H(g,m){const e=[];if(g.length===0||m.length===0)return m.length>0?m:g;if(this.I(g[g.length-1],m[0],e)){const E=new Array(g.length+m.length-1);return f.Copy(g,0,E,0,g.length-1),E[g.length-1]=e[0],f.Copy(m,1,E,g.length,m.length-1),E}else{const E=new Array(g.length+m.length);return f.Copy(g,0,E,0,g.length),f.Copy(m,0,E,g.length,m.length),E}}I(g,m,e){if(w.Assert(g.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),w.Assert(g.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=m.originalStart||g.modifiedStart+g.modifiedLength>=m.modifiedStart){const E=g.originalStart;let R=g.originalLength;const N=g.modifiedStart;let $=g.modifiedLength;return g.originalStart+g.originalLength>=m.originalStart&&(R=m.originalStart+m.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-g.modifiedStart),e[0]=new _.$0s(E,R,N,$),!0}else return e[0]=null,!1}J(g,m,e,E){if(g>=0&&g<E)return g;const R=e,N=E-e-1,$=m%2===0;if(g<0){const b=R%2===0;return $===b?0:1}else{const b=N%2===0;return $===b?E-1:E-2}}}t.$at=h}),te(se[26],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=void 0;function _(c){return typeof c=="string"}t.$Sf=_;function F(c){return Array.isArray(c)&&c.every(n=>_(n))}t.$Tf=F;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Uf=r;function o(c){const n=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof n}t.$Vf=o;function w(c){return typeof c=="number"&&!isNaN(c)}t.$Wf=w;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Xf=f;function a(c){return c===!0||c===!1}t.$Yf=a;function s(c){return typeof c>"u"}t.$Zf=s;function h(c){return!A(c)}t.$1f=h;function A(c){return s(c)||c===null}t.$2f=A;function g(c,n){if(!c)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}t.$3f=g;function m(c){if(A(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$4f=m;function e(...c){const n=[];for(let l=0;l<c.length;l++){const L=c[l];if(A(L))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);n.push(L)}return n}t.$5f=e;const E=Object.prototype.hasOwnProperty;function R(c){if(!r(c))return!1;for(const n in c)if(E.call(c,n))return!1;return!0}t.$6f=R;function N(c){return typeof c=="function"}t.$7f=N;function $(...c){return c.length>0&&c.every(N)}t.$8f=$;function b(c,n){const l=Math.min(c.length,n.length);for(let L=0;L<l;L++)u(c[L],n[L])}t.$9f=b;function u(c,n){if(_(n)){if(typeof c!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(N(n)){try{if(c instanceof n)return}catch{}if(!A(c)&&c.constructor===n||n.length===1&&n.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$0f=u}),te(se[43],le([0,1,26]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kk=t.$jk=t.$ik=void 0;const F=Object.create(null);function r(f,a){if((0,_.$Sf)(a)){const s=F[a];if(s===void 0)throw new Error(`${f} references an unknown codicon: ${a}`);a=s}return F[f]=a,{id:f}}function o(){return F}t.$ik=o;function w(){return Object.values(t.$kk)}t.$jk=w,t.$kk={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),runAllCoverage:r("run-all-coverage",60461),runCoverage:r("run-all-coverage",60460),coverage:r("coverage",60462),githubProject:r("github-project",60463),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(se[15],le([0,1,26]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tn=t.$Sn=t.$Rn=t.$Qn=t.$Pn=t.$On=t.$Nn=t.$Mn=t.$Ln=t.$Kn=t.$Jn=t.$In=void 0;function F(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const $=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([b,u])=>{$[b]=u&&typeof u=="object"?F(u):u}),$}t.$In=F;function r(N){if(!N||typeof N!="object")return N;const $=[N];for(;$.length>0;){const b=$.shift();Object.freeze(b);for(const u in b)if(o.call(b,u)){const c=b[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,_.$Vf)(c)&&$.push(c)}}return N}t.$Jn=r;const o=Object.prototype.hasOwnProperty;function w(N,$){return f(N,$,new Set)}t.$Kn=w;function f(N,$,b){if((0,_.$2f)(N))return N;const u=$(N);if(typeof u<"u")return u;if(Array.isArray(N)){const c=[];for(const n of N)c.push(f(n,$,b));return c}if((0,_.$Uf)(N)){if(b.has(N))throw new Error("Cannot clone recursive data-structure");b.add(N);const c={};for(const n in N)o.call(N,n)&&(c[n]=f(N[n],$,b));return b.delete(N),c}return N}function a(N,$,b=!0){return(0,_.$Uf)(N)?((0,_.$Uf)($)&&Object.keys($).forEach(u=>{u in N?b&&((0,_.$Uf)(N[u])&&(0,_.$Uf)($[u])?a(N[u],$[u],b):N[u]=$[u]):N[u]=$[u]}),N):$}t.$Ln=a;function s(N,$){if(N===$)return!0;if(N==null||$===null||$===void 0||typeof N!=typeof $||typeof N!="object"||Array.isArray(N)!==Array.isArray($))return!1;let b,u;if(Array.isArray(N)){if(N.length!==$.length)return!1;for(b=0;b<N.length;b++)if(!s(N[b],$[b]))return!1}else{const c=[];for(u in N)c.push(u);c.sort();const n=[];for(u in $)n.push(u);if(n.sort(),!s(c,n))return!1;for(b=0;b<c.length;b++)if(!s(N[c[b]],$[c[b]]))return!1}return!0}t.$Mn=s;function h(N){const $=new Set;return JSON.stringify(N,(b,u)=>{if((0,_.$Uf)(u)||Array.isArray(u)){if($.has(u))return"[Circular]";$.add(u)}return u})}t.$Nn=h;function A(N,$){const b=Object.create(null);return!N||!$||Object.keys($).forEach(c=>{const n=N[c],l=$[c];s(n,l)||(b[c]=l)}),b}t.$On=A;function g(N,$){const b=$.toLowerCase(),u=Object.keys(N).find(c=>c.toLowerCase()===b);return u?N[u]:N[$]}t.$Pn=g;function m(N,$){const b=Object.create(null);for(const[u,c]of Object.entries(N))$(u,c)&&(b[u]=c);return b}t.$Qn=m;function e(N){let $=[];for(;Object.prototype!==N;)$=$.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return $}t.$Rn=e;function E(N){const $=[];for(const b of e(N))typeof N[b]=="function"&&$.push(b);return $}t.$Sn=E;function R(N,$){const b=c=>function(){const n=Array.prototype.slice.call(arguments,0);return $(c,n)},u={};for(const c of N)u[c]=b(c);return u}t.$Tn=R}),te(se[27],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.Constants=void 0;var _;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(t.Constants=_={}));function F(o){return o<0?0:o>255?255:o|0}t.$Qe=F;function r(o){return o<0?0:o>4294967295?4294967295:o|0}t.$Re=r}),te(se[16],le([0,1,40,14]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,o=/^\//,w=/^\/\//;function f(d,v){if(!d.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!o.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,v){return!d&&!v?"file":d}function s(d,v){switch(d){case"https":case"http":case"file":v?v[0]!==A&&(v=A+v):v=A;break}return v}const h="",A="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(v){return v instanceof m?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,k,p,y,M,P=!1){typeof v=="object"?(this.scheme=v.scheme||h,this.authority=v.authority||h,this.path=v.path||h,this.query=v.query||h,this.fragment=v.fragment||h):(this.scheme=a(v,P),this.authority=k||h,this.path=s(this.scheme,p||h),this.query=y||h,this.fragment=M||h,f(this,P))}get fsPath(){return u(this,!1)}with(v){if(!v)return this;let{scheme:k,authority:p,path:y,query:M,fragment:P}=v;return k===void 0?k=this.scheme:k===null&&(k=h),p===void 0?p=this.authority:p===null&&(p=h),y===void 0?y=this.path:y===null&&(y=h),M===void 0?M=this.query:M===null&&(M=h),P===void 0?P=this.fragment:P===null&&(P=h),k===this.scheme&&p===this.authority&&y===this.path&&M===this.query&&P===this.fragment?this:new R(k,p,y,M,P)}static parse(v,k=!1){const p=g.exec(v);return p?new R(p[2]||h,L(p[4]||h),L(p[5]||h),L(p[7]||h),L(p[9]||h),k):new R(h,h,h,h,h)}static file(v){let k=h;if(F.$c&&(v=v.replace(/\\/g,A)),v[0]===A&&v[1]===A){const p=v.indexOf(A,2);p===-1?(k=v.substring(2),v=A):(k=v.substring(2,p),v=v.substring(p)||A)}return new R("file",k,v,h,h)}static from(v,k){return new R(v.scheme,v.authority,v.path,v.query,v.fragment,k)}static joinPath(v,...k){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return F.$c&&v.scheme==="file"?p=m.file(_.$fc.join(u(v,!0),...k)).path:p=_.$gc.join(v.path,...k),v.with({path:p})}toString(v=!1){return c(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof m)return v;{const k=new R(v);return k._formatted=v.external??null,k._fsPath=v._sep===E?v.fsPath??null:null,k}}else return v}}t.URI=m;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$vc=e;const E=F.$c?1:void 0;class R extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(v=!1){return v?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=E),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const N={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(d,v,k){let p,y=-1;for(let M=0;M<d.length;M++){const P=d.charCodeAt(M);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||v&&P===47||k&&P===91||k&&P===93||k&&P===58)y!==-1&&(p+=encodeURIComponent(d.substring(y,M)),y=-1),p!==void 0&&(p+=d.charAt(M));else{p===void 0&&(p=d.substr(0,M));const T=N[P];T!==void 0?(y!==-1&&(p+=encodeURIComponent(d.substring(y,M)),y=-1),p+=T):y===-1&&(y=M)}}return y!==-1&&(p+=encodeURIComponent(d.substring(y))),p!==void 0?p:d}function b(d){let v;for(let k=0;k<d.length;k++){const p=d.charCodeAt(k);p===35||p===63?(v===void 0&&(v=d.substr(0,k)),v+=N[p]):v!==void 0&&(v+=d[k])}return v!==void 0?v:d}function u(d,v){let k;return d.authority&&d.path.length>1&&d.scheme==="file"?k=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?v?k=d.path.substr(1):k=d.path[1].toLowerCase()+d.path.substr(2):k=d.path,F.$c&&(k=k.replace(/\//g,"\\")),k}t.$wc=u;function c(d,v){const k=v?b:$;let p="",{scheme:y,authority:M,path:P,query:T,fragment:D}=d;if(y&&(p+=y,p+=":"),(M||y==="file")&&(p+=A,p+=A),M){let q=M.indexOf("@");if(q!==-1){const V=M.substr(0,q);M=M.substr(q+1),q=V.lastIndexOf(":"),q===-1?p+=k(V,!1,!1):(p+=k(V.substr(0,q),!1,!1),p+=":",p+=k(V.substr(q+1),!1,!0)),p+="@"}M=M.toLowerCase(),q=M.lastIndexOf(":"),q===-1?p+=k(M,!1,!0):(p+=k(M.substr(0,q),!1,!0),p+=M.substr(q))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const q=P.charCodeAt(1);q>=65&&q<=90&&(P=`/${String.fromCharCode(q+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const q=P.charCodeAt(0);q>=65&&q<=90&&(P=`${String.fromCharCode(q+32)}:${P.substr(2)}`)}p+=k(P,!0,!1)}return T&&(p+="?",p+=k(T,!1,!1)),D&&(p+="#",p+=v?D:$(D,!1,!1)),p}function n(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+n(d.substr(3)):d}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(d){return d.match(l)?d.replace(l,v=>n(v)):d}}),te(se[67],le([0,1,3,11,10,15,14,7]),function(W,t,_,F,r,o,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function h(L){w.$i&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(L.message))}t.logOnceWebWorkerWarning=h;var A;(function(L){L[L.Request=0]="Request",L[L.Reply=1]="Reply",L[L.SubscribeEvent=2]="SubscribeEvent",L[L.Event=3]="Event",L[L.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class g{constructor(d,v,k,p){this.vsWorker=d,this.req=v,this.method=k,this.args=p,this.type=0}}class m{constructor(d,v,k,p){this.vsWorker=d,this.seq=v,this.res=k,this.err=p,this.type=1}}class e{constructor(d,v,k,p){this.vsWorker=d,this.req=v,this.eventName=k,this.arg=p,this.type=2}}class E{constructor(d,v,k){this.vsWorker=d,this.req=v,this.event=k,this.type=3}}class R{constructor(d,v){this.vsWorker=d,this.req=v,this.type=4}}class N{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,v){const k=String(++this.b);return new Promise((p,y)=>{this.c[k]={resolve:p,reject:y},this.o(new g(this.a,k,d,v))})}listen(d,v){let k=null;const p=new F.$5d({onWillAddFirstListener:()=>{k=String(++this.b),this.d.set(k,p),this.o(new e(this.a,k,d,v))},onDidRemoveLastListener:()=>{this.d.delete(k),this.o(new R(this.a,k)),k=null}});return p.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const v=this.c[d.seq];if(delete this.c[d.seq],d.err){let k=d.err;d.err.$isError&&(k=new Error,k.name=d.err.name,k.message=d.err.message,k.stack=d.err.stack),v.reject(k);return}v.resolve(d.res)}k(d){const v=d.req;this.g.handleMessage(d.method,d.args).then(p=>{this.o(new m(this.a,v,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,_.$3)(p.detail)),this.o(new m(this.a,v,void 0,(0,_.$3)(p)))})}l(d){const v=d.req,k=this.g.handleEvent(d.eventName,d.arg)(p=>{this.o(new E(this.a,v,p))});this.f.set(v,k)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const v=[];if(d.type===0)for(let k=0;k<d.args.length;k++)d.args[k]instanceof ArrayBuffer&&v.push(d.args[k]);else d.type===1&&d.res instanceof ArrayBuffer&&v.push(d.res);this.g.sendMessage(d,v)}}class $ extends r.$Tc{constructor(d,v,k){super();let p=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new N({sendMessage:(q,V)=>{this.a.postMessage(q,V)},handleMessage:(q,V)=>{if(typeof k[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(k[q].apply(k,V))}catch(H){return Promise.reject(H)}},handleEvent:(q,V)=>{if(u(q)){const H=k[q].call(k,V);if(typeof H!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return H}if(b(q)){const H=k[q];if(typeof H!="function")throw new Error(`Missing event ${q} on main thread host.`);return H}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const M=globalThis.require;typeof M<"u"&&typeof M.getConfig=="function"?y=M.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const P=(0,o.$Sn)(k);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(y)),v,P]);const T=(q,V)=>this.g(q,V),D=(q,V)=>this.c.listen(q,V);this.f=new Promise((q,V)=>{p=V,this.b.then(H=>{q(c(H,T,D))},H=>{V(H),this.h("Worker failed to load "+v,H)})})}getProxyObject(){return this.f}g(d,v){return new Promise((k,p)=>{this.b.then(()=>{this.c.sendMessage(d,v).then(k,p)},p)})}h(d,v){console.error(d),console.info(v)}}t.SimpleWorkerClient=$;function b(L){return L[0]==="o"&&L[1]==="n"&&f.$if(L.charCodeAt(2))}function u(L){return/^onDynamic/.test(L)&&f.$if(L.charCodeAt(9))}function c(L,d,v){const k=M=>function(){const P=Array.prototype.slice.call(arguments,0);return d(M,P)},p=M=>function(P){return v(M,P)},y={};for(const M of L){if(u(M)){y[M]=p(M);continue}if(b(M)){y[M]=v(M,void 0);continue}y[M]=k(M)}return y}class n{constructor(d,v){this.a=v,this.b=null,this.c=new N({sendMessage:(k,p)=>{d(k,p)},handleMessage:(k,p)=>this.d(k,p),handleEvent:(k,p)=>this.f(k,p)})}onmessage(d){this.c.handleMessage(d)}d(d,v){if(d===a)return this.g(v[0],v[1],v[2],v[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,v))}catch(k){return Promise.reject(k)}}f(d,v){if(!this.b)throw new Error("Missing requestHandler");if(u(d)){const k=this.b[d].call(this.b,v);if(typeof k!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return k}if(b(d)){const k=this.b[d];if(typeof k!="function")throw new Error(`Missing event ${d} on request handler.`);return k}throw new Error(`Malformed event name ${d}`)}g(d,v,k,p){this.c.setWorkerId(d);const P=c(p,(T,D)=>this.c.sendMessage(T,D),(T,D)=>this.c.listen(T,D));return this.a?(this.b=this.a(P),Promise.resolve((0,o.$Sn)(this.b))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy<"u"&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((T,D)=>{(globalThis.require||W)([k],V=>{if(this.b=V.create(P),!this.b){D(new Error("No RequestHandler!"));return}T((0,o.$Sn)(this.b))},D)}))}}t.SimpleWorkerServer=n;function l(L){return new n(L,null)}t.create=l}),te(se[28],le([0,1,27]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$st=t.$rt=void 0;class F{constructor(f){const a=(0,_.$Qe)(f);this.c=a,this.a=F.d(a),this.b=new Map}static d(f){const a=new Uint8Array(256);return a.fill(f),a}set(f,a){const s=(0,_.$Qe)(a);f>=0&&f<256?this.a[f]=s:this.b.set(f,s)}get(f){return f>=0&&f<256?this.a[f]:this.b.get(f)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$rt=F;var r;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(r||(r={}));class o{constructor(){this.a=new F(0)}add(f){this.a.set(f,1)}has(f){return this.a.get(f)===1}clear(){return this.a.clear()}}t.$st=o}),te(se[4],le([0,1,3]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ct=t.$bt=void 0;class F{static addRange(w,f){let a=0;for(;a<f.length&&f[a].endExclusive<w.start;)a++;let s=a;for(;s<f.length&&f[s].start<=w.endExclusive;)s++;if(a===s)f.splice(a,0,w);else{const h=Math.min(w.start,f[a].start),A=Math.max(w.endExclusive,f[s-1].endExclusive);f.splice(a,s-a,new F(h,A))}}static tryCreate(w,f){if(!(w>f))return new F(w,f)}static ofLength(w){return new F(0,w)}static ofStartAndLength(w,f){return new F(w,w+f)}constructor(w,f){if(this.start=w,this.endExclusive=f,w>f)throw new _.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new F(this.start+w,this.endExclusive+w)}deltaStart(w){return new F(this.start+w,this.endExclusive)}deltaEnd(w){return new F(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new F(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const f=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);if(f<=a)return new F(f,a)}intersects(w){const f=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return f<a}intersectsOrTouches(w){const f=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return f<=a}isBefore(w){return this.endExclusive<=w.start}isAfter(w){return this.start>=w.endExclusive}slice(w){return w.slice(this.start,this.endExclusive)}substring(w){return w.substring(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new _.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new _.$cb(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const f=[];for(let a=this.start;a<this.endExclusive;a++)f.push(w(a));return f}forEach(w){for(let f=this.start;f<this.endExclusive;f++)w(f)}}t.$bt=F;class r{constructor(){this.a=[]}addRange(w){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<w.start;)f++;let a=f;for(;a<this.a.length&&this.a[a].start<=w.endExclusive;)a++;if(f===a)this.a.splice(f,0,w);else{const s=Math.min(w.start,this.a[f].start),h=Math.max(w.endExclusive,this.a[a-1].endExclusive);this.a.splice(f,a-f,new F(s,h))}}toString(){return this.a.map(w=>w.toString()).join(", ")}intersectsStrict(w){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<=w.start;)f++;return f<this.a.length&&this.a[f].start<w.endExclusive}intersectWithRange(w){const f=new r;for(const a of this.a){const s=a.intersect(w);s&&f.addRange(s)}return f}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this.a.reduce((w,f)=>w+f.length,0)}}t.$ct=r}),te(se[5],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6s=void 0;class _{constructor(r,o){this.lineNumber=r,this.column=o}with(r=this.lineNumber,o=this.column){return r===this.lineNumber&&o===this.column?this:new _(r,o)}delta(r=0,o=0){return this.with(this.lineNumber+r,this.column+o)}equals(r){return _.equals(this,r)}static equals(r,o){return!r&&!o?!0:!!r&&!!o&&r.lineNumber===o.lineNumber&&r.column===o.column}isBefore(r){return _.isBefore(this,r)}static isBefore(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<o.column}isBeforeOrEqual(r){return _.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<=o.column}static compare(r,o){const w=r.lineNumber|0,f=o.lineNumber|0;if(w===f){const a=r.column|0,s=o.column|0;return a-s}return w-f}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new _(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$6s=_}),te(se[2],le([0,1,5]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7s=void 0;class F{constructor(o,w,f,a){o>f||o===f&&w>a?(this.startLineNumber=f,this.startColumn=a,this.endLineNumber=o,this.endColumn=w):(this.startLineNumber=o,this.startColumn=w,this.endLineNumber=f,this.endColumn=a)}isEmpty(){return F.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return F.containsPosition(this,o)}static containsPosition(o,w){return!(w.lineNumber<o.startLineNumber||w.lineNumber>o.endLineNumber||w.lineNumber===o.startLineNumber&&w.column<o.startColumn||w.lineNumber===o.endLineNumber&&w.column>o.endColumn)}static strictContainsPosition(o,w){return!(w.lineNumber<o.startLineNumber||w.lineNumber>o.endLineNumber||w.lineNumber===o.startLineNumber&&w.column<=o.startColumn||w.lineNumber===o.endLineNumber&&w.column>=o.endColumn)}containsRange(o){return F.containsRange(this,o)}static containsRange(o,w){return!(w.startLineNumber<o.startLineNumber||w.endLineNumber<o.startLineNumber||w.startLineNumber>o.endLineNumber||w.endLineNumber>o.endLineNumber||w.startLineNumber===o.startLineNumber&&w.startColumn<o.startColumn||w.endLineNumber===o.endLineNumber&&w.endColumn>o.endColumn)}strictContainsRange(o){return F.strictContainsRange(this,o)}static strictContainsRange(o,w){return!(w.startLineNumber<o.startLineNumber||w.endLineNumber<o.startLineNumber||w.startLineNumber>o.endLineNumber||w.endLineNumber>o.endLineNumber||w.startLineNumber===o.startLineNumber&&w.startColumn<=o.startColumn||w.endLineNumber===o.endLineNumber&&w.endColumn>=o.endColumn)}plusRange(o){return F.plusRange(this,o)}static plusRange(o,w){let f,a,s,h;return w.startLineNumber<o.startLineNumber?(f=w.startLineNumber,a=w.startColumn):w.startLineNumber===o.startLineNumber?(f=w.startLineNumber,a=Math.min(w.startColumn,o.startColumn)):(f=o.startLineNumber,a=o.startColumn),w.endLineNumber>o.endLineNumber?(s=w.endLineNumber,h=w.endColumn):w.endLineNumber===o.endLineNumber?(s=w.endLineNumber,h=Math.max(w.endColumn,o.endColumn)):(s=o.endLineNumber,h=o.endColumn),new F(f,a,s,h)}intersectRanges(o){return F.intersectRanges(this,o)}static intersectRanges(o,w){let f=o.startLineNumber,a=o.startColumn,s=o.endLineNumber,h=o.endColumn;const A=w.startLineNumber,g=w.startColumn,m=w.endLineNumber,e=w.endColumn;return f<A?(f=A,a=g):f===A&&(a=Math.max(a,g)),s>m?(s=m,h=e):s===m&&(h=Math.min(h,e)),f>s||f===s&&a>h?null:new F(f,a,s,h)}equalsRange(o){return F.equalsRange(this,o)}static equalsRange(o,w){return!o&&!w?!0:!!o&&!!w&&o.startLineNumber===w.startLineNumber&&o.startColumn===w.startColumn&&o.endLineNumber===w.endLineNumber&&o.endColumn===w.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(o){return new _.$6s(o.endLineNumber,o.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(o){return new _.$6s(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,w){return new F(this.startLineNumber,this.startColumn,o,w)}setStartPosition(o,w){return new F(o,w,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(o){return new F(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(o){return new F(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new F(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,w=o){return new F(o.lineNumber,o.column,w.lineNumber,w.column)}static lift(o){return o?new F(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,w){return!(o.endLineNumber<w.startLineNumber||o.endLineNumber===w.startLineNumber&&o.endColumn<w.startColumn||w.endLineNumber<o.startLineNumber||w.endLineNumber===o.startLineNumber&&w.endColumn<o.startColumn)}static areIntersecting(o,w){return!(o.endLineNumber<w.startLineNumber||o.endLineNumber===w.startLineNumber&&o.endColumn<=w.startColumn||w.endLineNumber<o.startLineNumber||w.endLineNumber===o.startLineNumber&&w.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,w){if(o&&w){const s=o.startLineNumber|0,h=w.startLineNumber|0;if(s===h){const A=o.startColumn|0,g=w.startColumn|0;if(A===g){const m=o.endLineNumber|0,e=w.endLineNumber|0;if(m===e){const E=o.endColumn|0,R=w.endColumn|0;return E-R}return m-e}return A-g}return s-h}return(o?1:0)-(w?1:0)}static compareRangesUsingEnds(o,w){return o.endLineNumber===w.endLineNumber?o.endColumn===w.endColumn?o.startLineNumber===w.startLineNumber?o.startColumn-w.startColumn:o.startLineNumber-w.startLineNumber:o.endColumn-w.endColumn:o.endLineNumber-w.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$7s=F}),te(se[44],le([0,1,2]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8s=void 0;class F{static insert(o,w){return{range:new _.$7s(o.lineNumber,o.column,o.lineNumber,o.column),text:w,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,w){return{range:o,text:w}}static replaceMove(o,w){return{range:o,text:w,forceMoveMarkers:!0}}}t.$8s=F}),te(se[12],le([0,1,3,4,2,9]),function(W,t,_,F,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=t.$dt=void 0;class w{static fromRange(s){return new w(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new w(s.startLineNumber,s.endLineNumber+1)}static subtract(s,h){return h?s.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<s.endLineNumberExclusive?[new w(s.startLineNumber,h.startLineNumber),new w(h.endLineNumberExclusive,s.endLineNumberExclusive)]:h.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<s.endLineNumberExclusive?[new w(Math.max(h.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new w(s.startLineNumber,Math.min(h.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let h=new f(s[0].slice());for(let A=1;A<s.length;A++)h=h.getUnion(new f(s[A].slice()));return h.ranges}static ofLength(s,h){return new w(s,s+h)}static deserialize(s){return new w(s[0],s[1])}constructor(s,h){if(s>h)throw new _.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=s,this.endLineNumberExclusive=h}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new w(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new w(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new w(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const h=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(h<=A)return new w(h,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$7s(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$7s(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const h=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)h.push(s(A));return h}forEach(s){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)s(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new F.$bt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$dt=w;class f{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const h=(0,o.$kb)(this.c,g=>g.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,g=>g.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)this.c.splice(h,0,s);else if(h===A-1){const g=this.c[h];this.c[h]=g.join(s)}else{const g=this.c[h].join(this.c[A-1]).join(s);this.c.splice(h,A-h,g)}}contains(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<=s);return!!h&&h.endLineNumberExclusive>s}intersects(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const h=[];let A=0,g=0,m=null;for(;A<this.c.length||g<s.c.length;){let e=null;if(A<this.c.length&&g<s.c.length){const E=this.c[A],R=s.c[g];E.startLineNumber<R.startLineNumber?(e=E,A++):(e=R,g++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[g],g++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new w(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(m),m=e)}return m!==null&&h.push(m),new f(h)}subtractFrom(s){const h=(0,o.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)return new f([s]);const g=[];let m=s.startLineNumber;for(let e=h;e<A;e++){const E=this.c[e];E.startLineNumber>m&&g.push(new w(m,E.startLineNumber)),m=E.endLineNumberExclusive}return m<s.endLineNumberExclusive&&g.push(new w(m,s.endLineNumberExclusive)),new f(g)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const h=[];let A=0,g=0;for(;A<this.c.length&&g<s.c.length;){const m=this.c[A],e=s.c[g],E=m.intersect(e);E&&!E.isEmpty&&h.push(E),m.endLineNumberExclusive<e.endLineNumberExclusive?A++:g++}return new f(h)}getWithDelta(s){return new f(this.c.map(h=>h.delta(s)))}}t.$et=f}),te(se[45],le([0,1,5,2]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=t.SelectionDirection=void 0;var r;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class o extends F.$7s{constructor(f,a,s,h){super(f,a,s,h),this.selectionStartLineNumber=f,this.selectionStartColumn=a,this.positionLineNumber=s,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return o.selectionsEqual(this,f)}static selectionsEqual(f,a){return f.selectionStartLineNumber===a.selectionStartLineNumber&&f.selectionStartColumn===a.selectionStartColumn&&f.positionLineNumber===a.positionLineNumber&&f.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,a){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,f,a):new o(f,a,this.startLineNumber,this.startColumn)}getPosition(){return new _.$6s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new _.$6s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,a){return this.getDirection()===0?new o(f,a,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,f,a)}static fromPositions(f,a=f){return new o(f.lineNumber,f.column,a.lineNumber,a.column)}static fromRange(f,a){return a===0?new o(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new o(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new o(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,a){if(f&&!a||!f&&a)return!1;if(!f&&!a)return!0;if(f.length!==a.length)return!1;for(let s=0,h=f.length;s<h;s++)if(!this.selectionsEqual(f[s],a[s]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,a,s,h,A){return A===0?new o(f,a,s,h):new o(s,h,f,a)}}t.$9s=o}),te(se[46],le([0,1,28]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ut=t.$tt=t.WordCharacterClass=void 0;var F;(function(w){w[w.Regular=0]="Regular",w[w.Whitespace=1]="Whitespace",w[w.WordSeparator=2]="WordSeparator"})(F||(t.WordCharacterClass=F={}));class r extends _.$rt{constructor(f){super(0);for(let a=0,s=f.length;a<s;a++)this.set(f.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.$tt=r;function o(w){const f={};return a=>(f.hasOwnProperty(a)||(f[a]=w(a)),f[a])}t.$ut=o(w=>new r(w))}),te(se[29],le([0,1,20,10,21]),function(W,t,_,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Js=t.$Is=t.$Hs=t.$Gs=t.$Fs=void 0,t.$Fs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(A=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Fs)A.indexOf(m)>=0||(g+="\\"+m);return g+="\\s]+)",new RegExp(g,"g")}t.$Gs=o();function w(A){let g=t.$Gs;if(A&&A instanceof RegExp)if(A.global)g=A;else{let m="g";A.ignoreCase&&(m+="i"),A.multiline&&(m+="m"),A.unicode&&(m+="u"),g=new RegExp(A.source,m)}return g.lastIndex=0,g}t.$Hs=w;const f=new r.$4c;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(A){const g=f.unshift(A);return(0,F.$Rc)(g)}t.$Is=a;function s(A,g,m,e,E){if(g=w(g),E||(E=_.Iterable.first(f)),m.length>E.maxLen){let u=A-E.maxLen/2;return u<0?u=0:e+=u,m=m.substring(u,A+E.maxLen/2),s(A,g,m,e,E)}const R=Date.now(),N=A-1-e;let $=-1,b=null;for(let u=1;!(Date.now()-R>=E.timeBudget);u++){const c=N-E.windowSize*u;g.lastIndex=Math.max(0,c);const n=h(g,m,N,$);if(!n&&b||(b=n,c<=0))break;$=c}if(b){const u={word:b[0],startColumn:e+1+b.index,endColumn:e+1+b.index+b[0].length};return g.lastIndex=0,u}return null}t.$Js=s;function h(A,g,m,e){let E;for(;E=A.exec(g);){const R=E.index||0;if(R<=m&&A.lastIndex>=m)return E;if(e>0&&R>e)return null}return null}}),te(se[8],le([0,1,6,3,4]),function(W,t,_,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$h2=t.$g2=t.$f2=t.$e2=t.$d2=void 0;class o{static trivial(A,g){return new o([new w(r.$bt.ofLength(A.length),r.$bt.ofLength(g.length))],!1)}static trivialTimedOut(A,g){return new o([new w(r.$bt.ofLength(A.length),r.$bt.ofLength(g.length))],!0)}constructor(A,g){this.diffs=A,this.hitTimeout=g}}t.$d2=o;class w{static invert(A,g){const m=[];return(0,_.$Bb)(A,(e,E)=>{m.push(w.fromOffsetPairs(e?e.getEndExclusives():f.zero,E?E.getStarts():new f(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),m}static fromOffsetPairs(A,g){return new w(new r.$bt(A.offset1,g.offset1),new r.$bt(A.offset2,g.offset2))}constructor(A,g){this.seq1Range=A,this.seq2Range=g}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new w(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new w(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new w(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new w(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const g=this.seq1Range.intersect(A.seq1Range),m=this.seq2Range.intersect(A.seq2Range);if(!(!g||!m))return new w(g,m)}getStarts(){return new f(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new f(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$e2=w;class f{constructor(A,g){this.offset1=A,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(A){return A===0?this:new f(this.offset1+A,this.offset2+A)}equals(A){return this.offset1===A.offset1&&this.offset2===A.offset2}}t.$f2=f,f.zero=new f(0,0),f.max=new f(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class a{isValid(){return!0}}t.$g2=a,a.instance=new a;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new F.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$h2=s}),te(se[30],le([0,1,4,8]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m2=void 0;class r{compute(s,h,A=F.$g2.instance){if(s.length===0||h.length===0)return F.$d2.trivial(s,h);const g=s,m=h;function e(l,L){for(;l<g.length&&L<m.length&&g.getElement(l)===m.getElement(L);)l++,L++;return l}let E=0;const R=new w;R.set(0,e(0,0));const N=new f;N.set(0,R.get(0)===0?null:new o(null,0,0,R.get(0)));let $=0;e:for(;;){if(E++,!A.isValid())return F.$d2.trivialTimedOut(g,m);const l=-Math.min(E,m.length+E%2),L=Math.min(E,g.length+E%2);for($=l;$<=L;$+=2){let d=0;const v=$===L?-1:R.get($+1),k=$===l?-1:R.get($-1)+1;d++;const p=Math.min(Math.max(v,k),g.length),y=p-$;if(d++,p>g.length||y>m.length)continue;const M=e(p,y);R.set($,M);const P=p===v?N.get($+1):N.get($-1);if(N.set($,M!==p?new o(P,p,y,M-p):P),R.get($)===g.length&&R.get($)-$===m.length)break e}}let b=N.get($);const u=[];let c=g.length,n=m.length;for(;;){const l=b?b.x+b.length:0,L=b?b.y+b.length:0;if((l!==c||L!==n)&&u.push(new F.$e2(new _.$bt(l,c),new _.$bt(L,n))),!b)break;c=b.x,n=b.y,b=b.prev}return u.reverse(),new F.$d2(u,!1)}}t.$m2=r;class o{constructor(s,h,A,g){this.prev=s,this.x=h,this.y=A,this.length=g}}class w{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=h}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=h}}}class f{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){s<0?(s=-s-1,this.b[s]=h):this.a[s]=h}}}),te(se[47],le([0,1,6,4,8]),function(W,t,_,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$u2=t.$t2=t.$s2=t.$r2=t.$q2=void 0;function o(e,E,R){let N=R;return N=w(e,E,N),N=w(e,E,N),N=f(e,E,N),N}t.$q2=o;function w(e,E,R){if(R.length===0)return R;const N=[];N.push(R[0]);for(let b=1;b<R.length;b++){const u=N[N.length-1];let c=R[b];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const n=c.seq1Range.start-u.seq1Range.endExclusive;let l;for(l=1;l<=n&&!(e.getElement(c.seq1Range.start-l)!==e.getElement(c.seq1Range.endExclusive-l)||E.getElement(c.seq2Range.start-l)!==E.getElement(c.seq2Range.endExclusive-l));l++);if(l--,l===n){N[N.length-1]=new r.$e2(new F.$bt(u.seq1Range.start,c.seq1Range.endExclusive-n),new F.$bt(u.seq2Range.start,c.seq2Range.endExclusive-n));continue}c=c.delta(-l)}N.push(c)}const $=[];for(let b=0;b<N.length-1;b++){const u=N[b+1];let c=N[b];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const n=u.seq1Range.start-c.seq1Range.endExclusive;let l;for(l=0;l<n&&!(!e.isStronglyEqual(c.seq1Range.start+l,c.seq1Range.endExclusive+l)||!E.isStronglyEqual(c.seq2Range.start+l,c.seq2Range.endExclusive+l));l++);if(l===n){N[b+1]=new r.$e2(new F.$bt(c.seq1Range.start+n,u.seq1Range.endExclusive),new F.$bt(c.seq2Range.start+n,u.seq2Range.endExclusive));continue}l>0&&(c=c.delta(l))}$.push(c)}return N.length>0&&$.push(N[N.length-1]),$}function f(e,E,R){if(!e.getBoundaryScore||!E.getBoundaryScore)return R;for(let N=0;N<R.length;N++){const $=N>0?R[N-1]:void 0,b=R[N],u=N+1<R.length?R[N+1]:void 0,c=new F.$bt($?$.seq1Range.endExclusive+1:0,u?u.seq1Range.start-1:e.length),n=new F.$bt($?$.seq2Range.endExclusive+1:0,u?u.seq2Range.start-1:E.length);b.seq1Range.isEmpty?R[N]=a(b,e,E,c,n):b.seq2Range.isEmpty&&(R[N]=a(b.swap(),E,e,n,c).swap())}return R}function a(e,E,R,N,$){let u=1;for(;e.seq1Range.start-u>=N.start&&e.seq2Range.start-u>=$.start&&R.isStronglyEqual(e.seq2Range.start-u,e.seq2Range.endExclusive-u)&&u<100;)u++;u--;let c=0;for(;e.seq1Range.start+c<N.endExclusive&&e.seq2Range.endExclusive+c<$.endExclusive&&R.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(u===0&&c===0)return e;let n=0,l=-1;for(let L=-u;L<=c;L++){const d=e.seq2Range.start+L,v=e.seq2Range.endExclusive+L,k=e.seq1Range.start+L,p=E.getBoundaryScore(k)+R.getBoundaryScore(d)+R.getBoundaryScore(v);p>l&&(l=p,n=L)}return e.delta(n)}function s(e,E,R){const N=[];for(const $ of R){const b=N[N.length-1];if(!b){N.push($);continue}$.seq1Range.start-b.seq1Range.endExclusive<=2||$.seq2Range.start-b.seq2Range.endExclusive<=2?N[N.length-1]=new r.$e2(b.seq1Range.join($.seq1Range),b.seq2Range.join($.seq2Range)):N.push($)}return N}t.$r2=s;function h(e,E,R){const N=r.$e2.invert(R,e.length),$=[];let b=new r.$f2(0,0);function u(n,l){if(n.offset1<b.offset1||n.offset2<b.offset2)return;const L=e.findWordContaining(n.offset1),d=E.findWordContaining(n.offset2);if(!L||!d)return;let v=new r.$e2(L,d);const k=v.intersect(l);let p=k.seq1Range.length,y=k.seq2Range.length;for(;N.length>0;){const M=N[0];if(!(M.seq1Range.intersects(L)||M.seq2Range.intersects(d)))break;const T=e.findWordContaining(M.seq1Range.start),D=E.findWordContaining(M.seq2Range.start),q=new r.$e2(T,D),V=q.intersect(M);if(p+=V.seq1Range.length,y+=V.seq2Range.length,v=v.join(q),v.seq1Range.endExclusive>=M.seq1Range.endExclusive)N.shift();else break}p+y<(v.seq1Range.length+v.seq2Range.length)*2/3&&$.push(v),b=v.getEndExclusives()}for(;N.length>0;){const n=N.shift();n.seq1Range.isEmpty||(u(n.getStarts(),n),u(n.getEndExclusives().delta(-1),n))}return A(R,$)}t.$s2=h;function A(e,E){const R=[];for(;e.length>0||E.length>0;){const N=e[0],$=E[0];let b;N&&(!$||N.seq1Range.start<$.seq1Range.start)?b=e.shift():b=E.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=b.seq1Range.start?R[R.length-1]=R[R.length-1].join(b):R.push(b)}return R}function g(e,E,R){let N=R;if(N.length===0)return N;let $=0,b;do{b=!1;const u=[N[0]];for(let c=1;c<N.length;c++){let L=function(v,k){const p=new F.$bt(l.seq1Range.endExclusive,n.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||k.seq1Range.length+k.seq2Range.length>5)};const n=N[c],l=u[u.length-1];L(l,n)?(b=!0,u[u.length-1]=u[u.length-1].join(n)):u.push(n)}N=u}while($++<10&&b);return N}t.$t2=g;function m(e,E,R){let N=R;if(N.length===0)return N;let $=0,b;do{b=!1;const c=[N[0]];for(let n=1;n<N.length;n++){let d=function(k,p){const y=new F.$bt(L.seq1Range.endExclusive,l.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const P=e.getText(y).trim();if(P.length>20||P.split(/\r\n|\r|\n/).length>1)return!1;const T=e.countLinesIn(k.seq1Range),D=k.seq1Range.length,q=E.countLinesIn(k.seq2Range),V=k.seq2Range.length,H=e.countLinesIn(p.seq1Range),ee=p.seq1Range.length,S=E.countLinesIn(p.seq2Range),U=p.seq2Range.length,Y=2*40+50;function X(ne){return Math.min(ne,Y)}return Math.pow(Math.pow(X(T*40+D),1.5)+Math.pow(X(q*40+V),1.5),1.5)+Math.pow(Math.pow(X(H*40+ee),1.5)+Math.pow(X(S*40+U),1.5),1.5)>(Y**1.5)**1.5*1.3};const l=N[n],L=c[c.length-1];d(L,l)?(b=!0,c[c.length-1]=c[c.length-1].join(l)):c.push(l)}N=c}while($++<10&&b);const u=[];return(0,_.$Cb)(N,(c,n,l)=>{let L=n;function d(P){return P.length>0&&P.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const v=e.extendToFullLines(n.seq1Range),k=e.getText(new F.$bt(v.start,n.seq1Range.start));d(k)&&(L=L.deltaStart(-k.length));const p=e.getText(new F.$bt(n.seq1Range.endExclusive,v.endExclusive));d(p)&&(L=L.deltaEnd(p.length));const y=r.$e2.fromOffsetPairs(c?c.getEndExclusives():r.$f2.zero,l?l.getStarts():r.$f2.max),M=L.intersect(y);u.length>0&&M.getStarts().equals(u[u.length-1].getEndExclusives())?u[u.length-1]=u[u.length-1].join(M):u.push(M)}),u}t.$u2=m}),te(se[48],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p2=void 0;class _{constructor(o,w){this.a=o,this.b=w}getElement(o){return this.a[o]}get length(){return this.a.length}getBoundaryScore(o){const w=o===0?0:F(this.b[o-1]),f=o===this.b.length?0:F(this.b[o]);return 1e3-(w+f)}getText(o){return this.b.slice(o.start,o.endExclusive).join(`
`)}isStronglyEqual(o,w){return this.b[o]===this.b[w]}}t.$p2=_;function F(r){let o=0;for(;o<r.length&&(r.charCodeAt(o)===32||r.charCodeAt(o)===9);)o++;return o}}),te(se[17],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$k2=t.$j2=t.$i2=void 0;class _{constructor(w,f){this.width=w,this.height=f,this.a=[],this.a=new Array(w*f)}get(w,f){return this.a[w+f*this.width]}set(w,f,a){this.a[w+f*this.width]=a}}t.$i2=_;function F(o){return o===32||o===9}t.$j2=F;class r{static b(w){let f=this.a.get(w);return f===void 0&&(f=this.a.size,this.a.set(w,f)),f}constructor(w,f,a){this.range=w,this.lines=f,this.source=a,this.d=[];let s=0;for(let h=w.startLineNumber-1;h<w.endLineNumberExclusive-1;h++){const A=f[h];for(let m=0;m<A.length;m++){s++;const e=A[m],E=r.b(e);this.d[E]=(this.d[E]||0)+1}s++;const g=r.b(`
`);this.d[g]=(this.d[g]||0)+1}this.c=s}computeSimilarity(w){let f=0;const a=Math.max(this.d.length,w.d.length);for(let s=0;s<a;s++)f+=Math.abs((this.d[s]??0)-(w.d[s]??0));return 1-f/(this.c+w.c)}}t.$k2=r,r.a=new Map}),te(se[49],le([0,1,4,8,17]),function(W,t,_,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$l2=void 0;class o{compute(f,a,s=F.$g2.instance,h){if(f.length===0||a.length===0)return F.$d2.trivial(f,a);const A=new r.$i2(f.length,a.length),g=new r.$i2(f.length,a.length),m=new r.$i2(f.length,a.length);for(let u=0;u<f.length;u++)for(let c=0;c<a.length;c++){if(!s.isValid())return F.$d2.trivialTimedOut(f,a);const n=u===0?0:A.get(u-1,c),l=c===0?0:A.get(u,c-1);let L;f.getElement(u)===a.getElement(c)?(u===0||c===0?L=0:L=A.get(u-1,c-1),u>0&&c>0&&g.get(u-1,c-1)===3&&(L+=m.get(u-1,c-1)),L+=h?h(u,c):1):L=-1;const d=Math.max(n,l,L);if(d===L){const v=u>0&&c>0?m.get(u-1,c-1):0;m.set(u,c,v+1),g.set(u,c,3)}else d===n?(m.set(u,c,0),g.set(u,c,1)):d===l&&(m.set(u,c,0),g.set(u,c,2));A.set(u,c,d)}const e=[];let E=f.length,R=a.length;function N(u,c){(u+1!==E||c+1!==R)&&e.push(new F.$e2(new _.$bt(u+1,E),new _.$bt(c+1,R))),E=u,R=c}let $=f.length-1,b=a.length-1;for(;$>=0&&b>=0;)g.get($,b)===3?(N($,b),$--,b--):g.get($,b)===1?$--:b--;return N(-1,-1),e.reverse(),new F.$d2(e,!1)}}t.$l2=o}),te(se[31],le([0,1,9,4,5,2,17]),function(W,t,_,F,r,o,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n2=void 0;class f{constructor(e,E,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let N=!1;E.start>0&&E.endExclusive>=e.length&&(E=new F.$bt(E.start-1,E.endExclusive),N=!0),this.lineRange=E,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let b=e[$],u=0;if(N)u=b.length,b="",N=!1;else if(!R){const c=b.trimStart();u=b.length-c.length,b=c.trimEnd()}this.d.push(u);for(let c=0;c<b.length;c++)this.b.push(b.charCodeAt(c));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.$bt(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const E=g(e>0?this.b[e-1]:-1),R=g(e<this.b.length?this.b[e]:-1);if(E===7&&R===8)return 0;if(E===8)return 150;let N=0;return E!==R&&(N+=10,E===0&&R===1&&(N+=1)),N+=A(E),N+=A(R),N}translateOffset(e){if(this.lineRange.isEmpty)return new r.$6s(this.lineRange.start+1,1);const E=(0,_.$ib)(this.c,R=>R<=e);return new r.$6s(this.lineRange.start+E+1,e-this.c[E]+this.d[E]+1)}translateRange(e){return o.$7s.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let E=e;for(;E>0&&a(this.b[E-1]);)E--;let R=e;for(;R<this.b.length&&a(this.b[R]);)R++;return new F.$bt(E,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,E){return this.b[e]===this.b[E]}extendToFullLines(e){const E=(0,_.$hb)(this.c,N=>N<=e.start)??0,R=(0,_.$jb)(this.c,N=>e.endExclusive<=N)??this.b.length;return new F.$bt(E,R)}}t.$n2=f;function a(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var s;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const h={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function A(m){return h[m]}function g(m){return m===10?8:m===13?7:(0,w.$j2)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),te(se[32],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jt=t.$it=void 0;class _{constructor(o,w,f){this.changes=o,this.moves=w,this.hitTimeout=f}}t.$it=_;class F{constructor(o,w){this.lineRangeMapping=o,this.changes=w}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(o=>o.flip()))}}t.$jt=F}),te(se[18],le([0,1,12]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ht=t.$gt=t.$ft=void 0;class F{static inverse(f,a,s){const h=[];let A=1,g=1;for(const e of f){const E=new F(new _.$dt(A,e.original.startLineNumber),new _.$dt(g,e.modified.startLineNumber));E.modified.isEmpty||h.push(E),A=e.original.endLineNumberExclusive,g=e.modified.endLineNumberExclusive}const m=new F(new _.$dt(A,a+1),new _.$dt(g,s+1));return m.modified.isEmpty||h.push(m),h}static clip(f,a,s){const h=[];for(const A of f){const g=A.original.intersect(a),m=A.modified.intersect(s);g&&!g.isEmpty&&m&&!m.isEmpty&&h.push(new F(g,m))}return h}constructor(f,a){this.original=f,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(f){return new F(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$ft=F;class r extends F{constructor(f,a,s){super(f,a),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}}t.$gt=r;class o{constructor(f,a){this.originalRange=f,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$ht=o}),te(se[50],le([0,1,8,18,6,9,22,12,4,31,17,30]),function(W,t,_,F,r,o,w,f,a,s,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o2=void 0;function g(b,u,c,n,l,L){let{moves:d,excludedChanges:v}=e(b,u,c,L);if(!L.isValid())return[];const k=b.filter(y=>!v.has(y)),p=E(k,n,l,u,c,L);return(0,r.$1b)(d,p),d=N(d),d=d.filter(y=>{const M=y.original.toOffsetRange().slice(u).map(T=>T.trim());return M.join(`
`).length>=15&&m(M,T=>T.length>=2)>=2}),d=$(b,d),d}t.$o2=g;function m(b,u){let c=0;for(const n of b)u(n)&&c++;return c}function e(b,u,c,n){const l=[],L=b.filter(k=>k.modified.isEmpty&&k.original.length>=3).map(k=>new h.$k2(k.original,u,k)),d=new Set(b.filter(k=>k.original.isEmpty&&k.modified.length>=3).map(k=>new h.$k2(k.modified,c,k))),v=new Set;for(const k of L){let p=-1,y;for(const M of d){const P=k.computeSimilarity(M);P>p&&(p=P,y=M)}if(p>.9&&y&&(d.delete(y),l.push(new F.$ft(k.range,y.range)),v.add(k.source),v.add(y.source)),!n.isValid())return{moves:l,excludedChanges:v}}return{moves:l,excludedChanges:v}}function E(b,u,c,n,l,L){const d=[],v=new w.$Gc;for(const P of b)for(let T=P.original.startLineNumber;T<P.original.endLineNumberExclusive-2;T++){const D=`${u[T-1]}:${u[T+1-1]}:${u[T+2-1]}`;v.add(D,{range:new f.$dt(T,T+3)})}const k=[];b.sort((0,r.$7b)(P=>P.modified.startLineNumber,r.$9b));for(const P of b){let T=[];for(let D=P.modified.startLineNumber;D<P.modified.endLineNumberExclusive-2;D++){const q=`${c[D-1]}:${c[D+1-1]}:${c[D+2-1]}`,V=new f.$dt(D,D+3),H=[];v.forEach(q,({range:ee})=>{for(const U of T)if(U.originalLineRange.endLineNumberExclusive+1===ee.endLineNumberExclusive&&U.modifiedLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive){U.originalLineRange=new f.$dt(U.originalLineRange.startLineNumber,ee.endLineNumberExclusive),U.modifiedLineRange=new f.$dt(U.modifiedLineRange.startLineNumber,V.endLineNumberExclusive),H.push(U);return}const S={modifiedLineRange:V,originalLineRange:ee};k.push(S),H.push(S)}),T=H}if(!L.isValid())return[]}k.sort((0,r.$$b)((0,r.$7b)(P=>P.modifiedLineRange.length,r.$9b)));const p=new f.$et,y=new f.$et;for(const P of k){const T=P.modifiedLineRange.startLineNumber-P.originalLineRange.startLineNumber,D=p.subtractFrom(P.modifiedLineRange),q=y.subtractFrom(P.originalLineRange).getWithDelta(T),V=D.getIntersection(q);for(const H of V.ranges){if(H.length<3)continue;const ee=H,S=H.delta(-T);d.push(new F.$ft(S,ee)),p.addRange(ee),y.addRange(S)}}d.sort((0,r.$7b)(P=>P.original.startLineNumber,r.$9b));const M=new o.$mb(b);for(let P=0;P<d.length;P++){const T=d[P],D=M.findLastMonotonous(X=>X.original.startLineNumber<=T.original.startLineNumber),q=(0,o.$hb)(b,X=>X.modified.startLineNumber<=T.modified.startLineNumber),V=Math.max(T.original.startLineNumber-D.original.startLineNumber,T.modified.startLineNumber-q.modified.startLineNumber),H=M.findLastMonotonous(X=>X.original.startLineNumber<T.original.endLineNumberExclusive),ee=(0,o.$hb)(b,X=>X.modified.startLineNumber<T.modified.endLineNumberExclusive),S=Math.max(H.original.endLineNumberExclusive-T.original.endLineNumberExclusive,ee.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let U;for(U=0;U<V;U++){const X=T.original.startLineNumber-U-1,ne=T.modified.startLineNumber-U-1;if(X>n.length||ne>l.length||p.contains(ne)||y.contains(X)||!R(n[X-1],l[ne-1],L))break}U>0&&(y.addRange(new f.$dt(T.original.startLineNumber-U,T.original.startLineNumber)),p.addRange(new f.$dt(T.modified.startLineNumber-U,T.modified.startLineNumber)));let Y;for(Y=0;Y<S;Y++){const X=T.original.endLineNumberExclusive+Y,ne=T.modified.endLineNumberExclusive+Y;if(X>n.length||ne>l.length||p.contains(ne)||y.contains(X)||!R(n[X-1],l[ne-1],L))break}Y>0&&(y.addRange(new f.$dt(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+Y)),p.addRange(new f.$dt(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+Y))),(U>0||Y>0)&&(d[P]=new F.$ft(new f.$dt(T.original.startLineNumber-U,T.original.endLineNumberExclusive+Y),new f.$dt(T.modified.startLineNumber-U,T.modified.endLineNumberExclusive+Y)))}return d}function R(b,u,c){if(b.trim()===u.trim())return!0;if(b.length>300&&u.length>300)return!1;const l=new A.$m2().compute(new s.$n2([b],new a.$bt(0,1),!1),new s.$n2([u],new a.$bt(0,1),!1),c);let L=0;const d=_.$e2.invert(l.diffs,b.length);for(const y of d)y.seq1Range.forEach(M=>{(0,h.$j2)(b.charCodeAt(M))||L++});function v(y){let M=0;for(let P=0;P<b.length;P++)(0,h.$j2)(y.charCodeAt(P))||M++;return M}const k=v(b.length>u.length?b:u);return L/k>.6&&k>10}function N(b){if(b.length===0)return b;b.sort((0,r.$7b)(c=>c.original.startLineNumber,r.$9b));const u=[b[0]];for(let c=1;c<b.length;c++){const n=u[u.length-1],l=b[c],L=l.original.startLineNumber-n.original.endLineNumberExclusive,d=l.modified.startLineNumber-n.modified.endLineNumberExclusive;if(L>=0&&d>=0&&L+d<=2){u[u.length-1]=n.join(l);continue}u.push(l)}return u}function $(b,u){const c=new o.$mb(b);return u=u.filter(n=>{const l=c.findLastMonotonous(v=>v.original.startLineNumber<n.original.endLineNumberExclusive)||new F.$ft(new f.$dt(1,1),new f.$dt(1,1)),L=(0,o.$hb)(b,v=>v.modified.startLineNumber<n.modified.endLineNumberExclusive);return l!==L}),u}}),te(se[51],le([0,1,6,13,12,4,2,8,49,30,50,47,32,18,31,48]),function(W,t,_,F,r,o,w,f,a,s,h,A,g,m,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x2=t.$w2=t.$v2=void 0;class R{constructor(){this.e=new a.$l2,this.f=new s.$m2}computeDiff(u,c,n){if(u.length<=1&&(0,_.$ub)(u,c,(Y,X)=>Y===X))return new g.$it([],[],!1);if(u.length===1&&u[0].length===0||c.length===1&&c[0].length===0)return new g.$it([new m.$gt(new r.$dt(1,u.length+1),new r.$dt(1,c.length+1),[new m.$ht(new w.$7s(1,1,u.length,u[0].length+1),new w.$7s(1,1,c.length,c[0].length+1))])],[],!1);const l=n.maxComputationTimeMs===0?f.$g2.instance:new f.$h2(n.maxComputationTimeMs),L=!n.ignoreTrimWhitespace,d=new Map;function v(Y){let X=d.get(Y);return X===void 0&&(X=d.size,d.set(Y,X)),X}const k=u.map(Y=>v(Y.trim())),p=c.map(Y=>v(Y.trim())),y=new E.$p2(k,u),M=new E.$p2(p,c),P=y.length+M.length<1700?this.e.compute(y,M,l,(Y,X)=>u[Y]===c[X]?c[X].length===0?.1:1+Math.log(1+c[X].length):.99):this.f.compute(y,M);let T=P.diffs,D=P.hitTimeout;T=(0,A.$q2)(y,M,T),T=(0,A.$t2)(y,M,T);const q=[],V=Y=>{if(L)for(let X=0;X<Y;X++){const ne=H+X,ue=ee+X;if(u[ne]!==c[ue]){const i=this.j(u,c,new f.$e2(new o.$bt(ne,ne+1),new o.$bt(ue,ue+1)),l,L);for(const ge of i.mappings)q.push(ge);i.hitTimeout&&(D=!0)}}};let H=0,ee=0;for(const Y of T){(0,F.$_c)(()=>Y.seq1Range.start-H===Y.seq2Range.start-ee);const X=Y.seq1Range.start-H;V(X),H=Y.seq1Range.endExclusive,ee=Y.seq2Range.endExclusive;const ne=this.j(u,c,Y,l,L);ne.hitTimeout&&(D=!0);for(const ue of ne.mappings)q.push(ue)}V(u.length-H);const S=N(q,u,c);let U=[];return n.computeMoves&&(U=this.h(S,u,c,k,p,l,L)),(0,F.$_c)(()=>{function Y(ne,ue){if(ne.lineNumber<1||ne.lineNumber>ue.length)return!1;const i=ue[ne.lineNumber-1];return!(ne.column<1||ne.column>i.length+1)}function X(ne,ue){return!(ne.startLineNumber<1||ne.startLineNumber>ue.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>ue.length+1)}for(const ne of S){if(!ne.innerChanges)return!1;for(const ue of ne.innerChanges)if(!(Y(ue.modifiedRange.getStartPosition(),c)&&Y(ue.modifiedRange.getEndPosition(),c)&&Y(ue.originalRange.getStartPosition(),u)&&Y(ue.originalRange.getEndPosition(),u)))return!1;if(!X(ne.modified,c)||!X(ne.original,u))return!1}return!0}),new g.$it(S,U,D)}h(u,c,n,l,L,d,v){return(0,h.$o2)(u,c,n,l,L,d).map(y=>{const M=this.j(c,n,new f.$e2(y.original.toOffsetRange(),y.modified.toOffsetRange()),d,v),P=N(M.mappings,c,n,!0);return new g.$jt(y,P)})}j(u,c,n,l,L){const d=new e.$n2(u,n.seq1Range,L),v=new e.$n2(c,n.seq2Range,L),k=d.length+v.length<500?this.e.compute(d,v,l):this.f.compute(d,v,l);let p=k.diffs;return p=(0,A.$q2)(d,v,p),p=(0,A.$s2)(d,v,p),p=(0,A.$r2)(d,v,p),p=(0,A.$u2)(d,v,p),{mappings:p.map(M=>new m.$ht(d.translateRange(M.seq1Range),v.translateRange(M.seq2Range))),hitTimeout:k.hitTimeout}}}t.$v2=R;function N(b,u,c,n=!1){const l=[];for(const L of(0,_.$Ab)(b.map(d=>$(d,u,c)),(d,v)=>d.original.overlapOrTouch(v.original)||d.modified.overlapOrTouch(v.modified))){const d=L[0],v=L[L.length-1];l.push(new m.$gt(d.original.join(v.original),d.modified.join(v.modified),L.map(k=>k.innerChanges[0])))}return(0,F.$_c)(()=>!n&&l.length>0&&l[0].original.startLineNumber!==l[0].modified.startLineNumber?!1:(0,F.$ad)(l,(L,d)=>d.original.startLineNumber-L.original.endLineNumberExclusive===d.modified.startLineNumber-L.modified.endLineNumberExclusive&&L.original.endLineNumberExclusive<d.original.startLineNumber&&L.modified.endLineNumberExclusive<d.modified.startLineNumber)),l}t.$w2=N;function $(b,u,c){let n=0,l=0;b.modifiedRange.endColumn===1&&b.originalRange.endColumn===1&&b.originalRange.startLineNumber+n<=b.originalRange.endLineNumber&&b.modifiedRange.startLineNumber+n<=b.modifiedRange.endLineNumber&&(l=-1),b.modifiedRange.startColumn-1>=c[b.modifiedRange.startLineNumber-1].length&&b.originalRange.startColumn-1>=u[b.originalRange.startLineNumber-1].length&&b.originalRange.startLineNumber<=b.originalRange.endLineNumber+l&&b.modifiedRange.startLineNumber<=b.modifiedRange.endLineNumber+l&&(n=1);const L=new r.$dt(b.originalRange.startLineNumber+n,b.originalRange.endLineNumber+1+l),d=new r.$dt(b.modifiedRange.startLineNumber+n,b.modifiedRange.endLineNumber+1+l);return new m.$gt(L,d,[b])}t.$x2=$}),te(se[33],le([0,1,25,32,18,7,2,13,12]),function(W,t,_,F,r,o,w,f,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lt=t.$kt=void 0;const s=3;class h{computeDiff(n,l,L){const v=new N(n,l,{maxComputationTime:L.maxComputationTimeMs,shouldIgnoreTrimWhitespace:L.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),k=[];let p=null;for(const y of v.changes){let M;y.originalEndLineNumber===0?M=new a.$dt(y.originalStartLineNumber+1,y.originalStartLineNumber+1):M=new a.$dt(y.originalStartLineNumber,y.originalEndLineNumber+1);let P;y.modifiedEndLineNumber===0?P=new a.$dt(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):P=new a.$dt(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let T=new r.$gt(M,P,y.charChanges?.map(D=>new r.$ht(new w.$7s(D.originalStartLineNumber,D.originalStartColumn,D.originalEndLineNumber,D.originalEndColumn),new w.$7s(D.modifiedStartLineNumber,D.modifiedStartColumn,D.modifiedEndLineNumber,D.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===T.modified.startLineNumber||p.original.endLineNumberExclusive===T.original.startLineNumber)&&(T=new r.$gt(p.original.join(T.original),p.modified.join(T.modified),p.innerChanges&&T.innerChanges?p.innerChanges.concat(T.innerChanges):void 0),k.pop()),k.push(T),p=T}return(0,f.$_c)(()=>(0,f.$ad)(k,(y,M)=>M.original.startLineNumber-y.original.endLineNumberExclusive===M.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<M.original.startLineNumber&&y.modified.endLineNumberExclusive<M.modified.startLineNumber)),new F.$it(k,[],v.quitEarly)}}t.$kt=h;function A(c,n,l,L){return new _.$at(c,n,l).ComputeDiff(L)}class g{constructor(n){const l=[],L=[];for(let d=0,v=n.length;d<v;d++)l[d]=$(n[d],1),L[d]=b(n[d],1);this.lines=n,this.a=l,this.b=L}getElements(){const n=[];for(let l=0,L=this.lines.length;l<L;l++)n[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,l,L){const d=[],v=[],k=[];let p=0;for(let y=l;y<=L;y++){const M=this.lines[y],P=n?this.a[y]:1,T=n?this.b[y]:M.length+1;for(let D=P;D<T;D++)d[p]=M.charCodeAt(D-1),v[p]=y+1,k[p]=D,p++;!n&&y<L&&(d[p]=10,v[p]=y+1,k[p]=M.length+1,p++)}return new m(d,v,k)}}class m{constructor(n,l,L){this.a=n,this.b=l,this.d=L}toString(){return"["+this.a.map((n,l)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(n,l){if(n<0||n>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,l,L,d,v,k,p,y){this.originalStartLineNumber=n,this.originalStartColumn=l,this.originalEndLineNumber=L,this.originalEndColumn=d,this.modifiedStartLineNumber=v,this.modifiedStartColumn=k,this.modifiedEndLineNumber=p,this.modifiedEndColumn=y}static createFromDiffChange(n,l,L){const d=l.getStartLineNumber(n.originalStart),v=l.getStartColumn(n.originalStart),k=l.getEndLineNumber(n.originalStart+n.originalLength-1),p=l.getEndColumn(n.originalStart+n.originalLength-1),y=L.getStartLineNumber(n.modifiedStart),M=L.getStartColumn(n.modifiedStart),P=L.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),T=L.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(d,v,k,p,y,M,P,T)}}function E(c){if(c.length<=1)return c;const n=[c[0]];let l=n[0];for(let L=1,d=c.length;L<d;L++){const v=c[L],k=v.originalStart-(l.originalStart+l.originalLength),p=v.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(k,p)<s?(l.originalLength=v.originalStart+v.originalLength-l.originalStart,l.modifiedLength=v.modifiedStart+v.modifiedLength-l.modifiedStart):(n.push(v),l=v)}return n}class R{constructor(n,l,L,d,v){this.originalStartLineNumber=n,this.originalEndLineNumber=l,this.modifiedStartLineNumber=L,this.modifiedEndLineNumber=d,this.charChanges=v}static createFromDiffResult(n,l,L,d,v,k,p){let y,M,P,T,D;if(l.originalLength===0?(y=L.getStartLineNumber(l.originalStart)-1,M=0):(y=L.getStartLineNumber(l.originalStart),M=L.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(P=d.getStartLineNumber(l.modifiedStart)-1,T=0):(P=d.getStartLineNumber(l.modifiedStart),T=d.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),k&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&v()){const q=L.createCharSequence(n,l.originalStart,l.originalStart+l.originalLength-1),V=d.createCharSequence(n,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(q.getElements().length>0&&V.getElements().length>0){let H=A(q,V,v,!0).changes;p&&(H=E(H)),D=[];for(let ee=0,S=H.length;ee<S;ee++)D.push(e.createFromDiffChange(H[ee],q,V))}}return new R(y,M,P,T,D)}}class N{constructor(n,l,L){this.a=L.shouldComputeCharChanges,this.b=L.shouldPostProcessCharChanges,this.d=L.shouldIgnoreTrimWhitespace,this.e=L.shouldMakePrettyDiff,this.f=n,this.g=l,this.h=new g(n),this.j=new g(l),this.k=u(L.maxComputationTime),this.l=u(L.maxComputationTime===0?0:Math.min(L.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=A(this.h,this.j,this.k,this.e),l=n.changes,L=n.quitEarly;if(this.d){const p=[];for(let y=0,M=l.length;y<M;y++)p.push(R.createFromDiffResult(this.d,l[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:L,changes:p}}const d=[];let v=0,k=0;for(let p=-1,y=l.length;p<y;p++){const M=p+1<y?l[p+1]:null,P=M?M.originalStart:this.f.length,T=M?M.modifiedStart:this.g.length;for(;v<P&&k<T;){const D=this.f[v],q=this.g[k];if(D!==q){{let V=$(D,1),H=$(q,1);for(;V>1&&H>1;){const ee=D.charCodeAt(V-2),S=q.charCodeAt(H-2);if(ee!==S)break;V--,H--}(V>1||H>1)&&this.m(d,v+1,1,V,k+1,1,H)}{let V=b(D,1),H=b(q,1);const ee=D.length+1,S=q.length+1;for(;V<ee&&H<S;){const U=D.charCodeAt(V-1),Y=D.charCodeAt(H-1);if(U!==Y)break;V++,H++}(V<ee||H<S)&&this.m(d,v+1,V,ee,k+1,H,S)}}v++,k++}M&&(d.push(R.createFromDiffResult(this.d,M,this.h,this.j,this.l,this.a,this.b)),v+=M.originalLength,k+=M.modifiedLength)}return{quitEarly:L,changes:d}}m(n,l,L,d,v,k,p){if(this.n(n,l,L,d,v,k,p))return;let y;this.a&&(y=[new e(l,L,l,d,v,k,v,p)]),n.push(new R(l,l,v,v,y))}n(n,l,L,d,v,k,p){const y=n.length;if(y===0)return!1;const M=n[y-1];return M.originalEndLineNumber===0||M.modifiedEndLineNumber===0?!1:M.originalEndLineNumber===l&&M.modifiedEndLineNumber===v?(this.a&&M.charChanges&&M.charChanges.push(new e(l,L,l,d,v,k,v,p)),!0):M.originalEndLineNumber+1===l&&M.modifiedEndLineNumber+1===v?(M.originalEndLineNumber=l,M.modifiedEndLineNumber=v,this.a&&M.charChanges&&M.charChanges.push(new e(l,L,l,d,v,k,v,p)),!0):!1}}t.$lt=N;function $(c,n){const l=o.$$e(c);return l===-1?n:l+1}function b(c,n){const l=o.$af(c);return l===-1?n:l+2}function u(c){if(c===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<c}}),te(se[52],le([0,1,33,51]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$y2=void 0,t.$y2={getLegacy:()=>new _.$kt,getDefault:()=>new F.$v2}}),te(se[53],le([0,1,35]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z2=void 0;function F(g){const m=[];for(const e of g){const E=Number(e);(E||E===0&&e.replace(/\s/g,"")!=="")&&m.push(E)}return m}function r(g,m,e,E){return{red:g/255,blue:e/255,green:m/255,alpha:E}}function o(g,m){const e=m.index,E=m[0].length;if(!e)return;const R=g.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+E}}function w(g,m){if(!g)return;const e=_.$yt.Format.CSS.parseHex(m);if(e)return{range:g,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function f(g,m,e){if(!g||m.length!==1)return;const R=m[0].values(),N=F(R);return{range:g,color:r(N[0],N[1],N[2],e?N[3]:1)}}function a(g,m,e){if(!g||m.length!==1)return;const R=m[0].values(),N=F(R),$=new _.$yt(new _.$wt(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:g,color:r($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(g,m){return typeof g=="string"?[...g.matchAll(m)]:g.findMatches(m)}function h(g){const m=[],E=s(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(E.length>0)for(const R of E){const N=R.filter(c=>c!==void 0),$=N[1],b=N[2];if(!b)continue;let u;if($==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;u=f(o(g,R),s(b,c),!1)}else if($==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=f(o(g,R),s(b,c),!0)}else if($==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;u=a(o(g,R),s(b,c),!1)}else if($==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=a(o(g,R),s(b,c),!0)}else $==="#"&&(u=w(o(g,R),$+b));u&&m.push(u)}return m}function A(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:h(g)}t.$z2=A}),te(se[54],le([0,1,28]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_1=t.$$1=t.$01=t.State=void 0;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class r{constructor(e,E,R){const N=new Uint8Array(e*E);for(let $=0,b=e*E;$<b;$++)N[$]=R;this.a=N,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,R){this.a[e*this.cols+E]=R}}class o{constructor(e){let E=0,R=0;for(let $=0,b=e.length;$<b;$++){const[u,c,n]=e[$];c>E&&(E=c),u>R&&(R=u),n>R&&(R=n)}E++,R++;const N=new r(R,E,0);for(let $=0,b=e.length;$<b;$++){const[u,c,n]=e[$];N.set(u,c,n)}this.a=N,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.$01=o;let w=null;function f(){return w===null&&(w=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),w}var a;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let s=null;function h(){if(s===null){s=new _.$rt(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<m.length;E++)s.set(m.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)s.set(e.charCodeAt(E),2)}return s}class A{static a(e,E,R,N,$){let b=$-1;do{const u=E.charCodeAt(b);if(e.get(u)!==2)break;b--}while(b>N);if(N>0){const u=E.charCodeAt(N-1),c=E.charCodeAt(b);(u===40&&c===41||u===91&&c===93||u===123&&c===125)&&b--}return{range:{startLineNumber:R,startColumn:N+1,endLineNumber:R,endColumn:b+2},url:E.substring(N,b+1)}}static computeLinks(e,E=f()){const R=h(),N=[];for(let $=1,b=e.getLineCount();$<=b;$++){const u=e.getLineContent($),c=u.length;let n=0,l=0,L=0,d=1,v=!1,k=!1,p=!1,y=!1;for(;n<c;){let M=!1;const P=u.charCodeAt(n);if(d===13){let T;switch(P){case 40:v=!0,T=0;break;case 41:T=v?0:1;break;case 91:p=!0,k=!0,T=0;break;case 93:p=!1,T=k?0:1;break;case 123:y=!0,T=0;break;case 125:T=y?0:1;break;case 39:case 34:case 96:L===P?T=1:L===39||L===34||L===96?T=0:T=1;break;case 42:T=L===42?1:0;break;case 124:T=L===124?1:0;break;case 32:T=p?0:1;break;default:T=R.get(P)}T===1&&(N.push(A.a(R,u,$,l,n)),M=!0)}else if(d===12){let T;P===91?(k=!0,T=0):T=R.get(P),T===1?M=!0:d=13}else d=E.nextState(d,P),d===0&&(M=!0);M&&(d=1,v=!1,k=!1,y=!1,l=n+1,L=P),n++}d===13&&N.push(A.a(R,u,$,l,c))}return N}}t.$$1=A;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:A.computeLinks(m)}t.$_1=g}),te(se[55],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a2=void 0;class _{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(r,o,w,f,a){if(r&&o){const s=this.a(o,a);if(s)return{range:r,value:s}}if(w&&f){const s=this.a(f,a);if(s)return{range:w,value:s}}return null}a(r,o){const w=this.b(r,o);return w!==null?w:this.d(r,o)}b(r,o){const w=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let f=Number(r);const a=parseFloat(r);return!isNaN(f)&&!isNaN(a)&&f===a?f===0&&!o?null:(f=Math.floor(f*w),f+=o?w:-w,String(f/w)):null}d(r,o){return this.e(this.c,r,o)}e(r,o,w){let f=null;for(let a=0,s=r.length;f===null&&a<s;a++)f=this.f(r[a],o,w);return f}f(r,o,w){let f=r.indexOf(o);return f>=0?(f+=w?1:-1,f<0?f=r.length-1:f%=r.length,r[f]):null}}t.$a2=_,_.INSTANCE=new _}),te(se[56],le([0,1,15]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sv=t.$rv=t.$qv=t.$pv=t.ModelConstants=t.PositionAffinity=t.$ov=t.TrackedRangeStickiness=t.$nv=t.$mv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var F;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var r;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(r||(t.GlyphMarginLane=r={}));var o;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var w;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(w||(t.InjectedTextCursorStops=w={}));var f;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(f||(t.EndOfLinePreference=f={}));var a;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var s;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,_.$Mn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$mv=h;class A{constructor(c,n){this._findMatchBrand=void 0,this.range=c,this.matches=n}}t.$nv=A;var g;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(g||(t.TrackedRangeStickiness=g={}));function m(u){return u&&typeof u.read=="function"}t.$ov=m;var e;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var E;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class R{constructor(c,n,l,L,d,v){this.identifier=c,this.range=n,this.text=l,this.forceMoveMarkers=L,this.isAutoWhitespaceEdit=d,this._isTracked=v}}t.$pv=R;class N{constructor(c,n,l){this.regex=c,this.wordSeparators=n,this.simpleSearch=l}}t.$qv=N;class ${constructor(c,n,l){this.reverseEdits=c,this.changes=n,this.trimAutoWhitespaceLineNumbers=l}}t.$rv=$;function b(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}t.$sv=b}),te(se[57],le([0,1,6,27]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xv=t.$wv=t.$vv=void 0;class r{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,s){a=(0,F.$Re)(a);const h=this.a,A=this.b,g=s.length;return g===0?!1:(this.a=new Uint32Array(h.length+g),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a),a+g),this.a.set(s,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(a,s){return a=(0,F.$Re)(a),s=(0,F.$Re)(s),this.a[a]===s?!1:(this.a[a]=s,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,s){a=(0,F.$Re)(a),s=(0,F.$Re)(s);const h=this.a,A=this.b;if(a>=h.length)return!1;const g=h.length-a;return s>=g&&(s=g),s===0?!1:(this.a=new Uint32Array(h.length-s),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a+s),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,F.$Re)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),a>=this.a.length&&(a=this.a.length-1);for(let h=s;h<=a;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,h=this.a.length-1,A=0,g=0,m=0;for(;s<=h;)if(A=s+(h-s)/2|0,g=this.b[A],m=g-this.a[A],a<m)h=A-1;else if(a>=g)s=A+1;else break;return new w(A,a-m)}}t.$vv=r;class o{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const s=this.e[a],h=s>0?this.d[s-1]:0;return new w(s,a-h)}removeValues(a,s){this.a.splice(a,s),this.f(a)}insertValues(a,s){this.a=(0,_.$Wb)(this.a,a,s),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,s=this.a.length;a<s;a++){const h=this.a[a],A=a>0?this.d[a-1]:0;this.d[a]=A+h;for(let g=0;g<h;g++)this.e[A+g]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,s){this.a[a]!==s&&(this.a[a]=s,this.f(a))}}t.$wv=o;class w{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}t.$xv=w}),te(se[58],le([0,1,7,5,57]),function(W,t,_,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yv=void 0;class o{constructor(f,a,s,h){this.d=f,this.f=a,this.g=s,this.h=h,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(f){f.eol&&f.eol!==this.g&&(this.g=f.eol,this.j=null);const a=f.changes;for(const s of a)this.o(s.range),this.p(new F.$6s(s.range.startLineNumber,s.range.startColumn),s.text);this.h=f.versionId,this.k=null}l(){if(!this.j){const f=this.g.length,a=this.f.length,s=new Uint32Array(a);for(let h=0;h<a;h++)s[h]=this.f[h].length+f;this.j=new r.$vv(s)}}n(f,a){this.f[f]=a,this.j&&this.j.setValue(f,this.f[f].length+this.g.length)}o(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.startLineNumber-1].substring(f.endColumn-1));return}this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.endLineNumber-1].substring(f.endColumn-1)),this.f.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this.j&&this.j.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}p(f,a){if(a.length===0)return;const s=(0,_.$9e)(a);if(s.length===1){this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]+this.f[f.lineNumber-1].substring(f.column-1));return}s[s.length-1]+=this.f[f.lineNumber-1].substring(f.column-1),this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]);const h=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(f.lineNumber+A-1,0,s[A]),h[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(f.lineNumber,h)}}t.$yv=o}),te(se[59],le([0,1,7,46,5,2,56]),function(W,t,_,F,r,o,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iC=t.$hC=t.$gC=t.$fC=t.$eC=t.$dC=void 0;const f=999;class a{constructor($,b,u,c){this.searchString=$,this.isRegex=b,this.matchCase=u,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let b=null;try{b=_.$7e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!b)return null;let u=!this.isRegex&&!$;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new w.$qv(b,this.wordSeparators?(0,F.$ut)(this.wordSeparators):null,u?this.searchString:null)}}t.$dC=a;function s(N){if(!N||N.length===0)return!1;for(let $=0,b=N.length;$<b;$++){const u=N.charCodeAt($);if(u===10)return!0;if(u===92){if($++,$>=b)break;const c=N.charCodeAt($);if(c===110||c===114||c===87)return!0}}return!1}t.$eC=s;function h(N,$,b){if(!b)return new w.$nv(N,null);const u=[];for(let c=0,n=$.length;c<n;c++)u[c]=$[c];return new w.$nv(N,u)}t.$fC=h;class A{constructor($){const b=[];let u=0;for(let c=0,n=$.length;c<n;c++)$.charCodeAt(c)===10&&(b[u++]=c);this.a=b}findLineFeedCountBeforeOffset($){const b=this.a;let u=0,c=b.length-1;if(c===-1||$<=b[0])return 0;for(;u<c;){const n=u+((c-u)/2>>0);b[n]>=$?c=n-1:b[n+1]>=$?(u=n,c=n):u=n+1}return u+1}}class g{static findMatches($,b,u,c,n){const l=b.parseSearchRequest();return l?l.regex.multiline?this.b($,u,new R(l.wordSeparators,l.regex),c,n):this.c($,u,l,c,n):[]}static a($,b,u,c,n,l){let L,d=0;c?(d=c.findLineFeedCountBeforeOffset(n),L=b+n+d):L=b+n;let v;if(c){const M=c.findLineFeedCountBeforeOffset(n+l.length)-d;v=L+l.length+M}else v=L+l.length;const k=$.getPositionAt(L),p=$.getPositionAt(v);return new o.$7s(k.lineNumber,k.column,p.lineNumber,p.column)}static b($,b,u,c,n){const l=$.getOffsetAt(b.getStartPosition()),L=$.getValueInRange(b,1),d=$.getEOL()===`\r
`?new A(L):null,v=[];let k=0,p;for(u.reset(0);p=u.next(L);)if(v[k++]=h(this.a($,l,L,d,p.index,p[0]),p,c),k>=n)return v;return v}static c($,b,u,c,n){const l=[];let L=0;if(b.startLineNumber===b.endLineNumber){const v=$.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return L=this.d(u,v,b.startLineNumber,b.startColumn-1,L,l,c,n),l}const d=$.getLineContent(b.startLineNumber).substring(b.startColumn-1);L=this.d(u,d,b.startLineNumber,b.startColumn-1,L,l,c,n);for(let v=b.startLineNumber+1;v<b.endLineNumber&&L<n;v++)L=this.d(u,$.getLineContent(v),v,0,L,l,c,n);if(L<n){const v=$.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);L=this.d(u,v,b.endLineNumber,0,L,l,c,n)}return l}static d($,b,u,c,n,l,L,d){const v=$.wordSeparators;if(!L&&$.simpleSearch){const y=$.simpleSearch,M=y.length,P=b.length;let T=-M;for(;(T=b.indexOf(y,T+M))!==-1;)if((!v||E(v,b,P,T,M))&&(l[n++]=new w.$nv(new o.$7s(u,T+1+c,u,T+1+M+c),null),n>=d))return n;return n}const k=new R($.wordSeparators,$.regex);let p;k.reset(0);do if(p=k.next(b),p&&(l[n++]=h(new o.$7s(u,p.index+1+c,u,p.index+1+p[0].length+c),p,L),n>=d))return n;while(p);return n}static findNextMatch($,b,u,c){const n=b.parseSearchRequest();if(!n)return null;const l=new R(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,u,l,c):this.f($,u,l,c)}static e($,b,u,c){const n=new r.$6s(b.lineNumber,1),l=$.getOffsetAt(n),L=$.getLineCount(),d=$.getValueInRange(new o.$7s(n.lineNumber,n.column,L,$.getLineMaxColumn(L)),1),v=$.getEOL()===`\r
`?new A(d):null;u.reset(b.column-1);const k=u.next(d);return k?h(this.a($,l,d,v,k.index,k[0]),k,c):b.lineNumber!==1||b.column!==1?this.e($,new r.$6s(1,1),u,c):null}static f($,b,u,c){const n=$.getLineCount(),l=b.lineNumber,L=$.getLineContent(l),d=this.g(u,L,l,b.column,c);if(d)return d;for(let v=1;v<=n;v++){const k=(l+v-1)%n,p=$.getLineContent(k+1),y=this.g(u,p,k+1,1,c);if(y)return y}return null}static g($,b,u,c,n){$.reset(c-1);const l=$.next(b);return l?h(new o.$7s(u,l.index+1,u,l.index+1+l[0].length),l,n):null}static findPreviousMatch($,b,u,c){const n=b.parseSearchRequest();if(!n)return null;const l=new R(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,u,l,c):this.j($,u,l,c)}static h($,b,u,c){const n=this.b($,new o.$7s(1,1,b.lineNumber,b.column),u,c,10*f);if(n.length>0)return n[n.length-1];const l=$.getLineCount();return b.lineNumber!==l||b.column!==$.getLineMaxColumn(l)?this.h($,new r.$6s(l,$.getLineMaxColumn(l)),u,c):null}static j($,b,u,c){const n=$.getLineCount(),l=b.lineNumber,L=$.getLineContent(l).substring(0,b.column-1),d=this.k(u,L,l,c);if(d)return d;for(let v=1;v<=n;v++){const k=(n+l-v-1)%n,p=$.getLineContent(k+1),y=this.k(u,p,k+1,c);if(y)return y}return null}static k($,b,u,c){let n=null,l;for($.reset(0);l=$.next(b);)n=h(new o.$7s(u,l.index+1,u,l.index+1+l[0].length),l,c);return n}}t.$gC=g;function m(N,$,b,u,c){if(u===0)return!0;const n=$.charCodeAt(u-1);if(N.get(n)!==0||n===13||n===10)return!0;if(c>0){const l=$.charCodeAt(u);if(N.get(l)!==0)return!0}return!1}function e(N,$,b,u,c){if(u+c===b)return!0;const n=$.charCodeAt(u+c);if(N.get(n)!==0||n===13||n===10)return!0;if(c>0){const l=$.charCodeAt(u+c-1);if(N.get(l)!==0)return!0}return!1}function E(N,$,b,u,c){return m(N,$,b,u,c)&&e(N,$,b,u,c)}t.$hC=E;class R{constructor($,b){this._wordSeparators=$,this.a=b,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const b=$.length;let u;do{if(this.b+this.c===b||(u=this.a.exec($),!u))return null;const c=u.index,n=u[0].length;if(c===this.b&&n===this.c){if(n===0){_.$qf($,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=n,!this._wordSeparators||E(this._wordSeparators,$,b,c,n))return u}while(u);return null}}t.$iC=R}),te(se[60],le([0,1,2,59,7,13,29]),function(W,t,_,F,r,o,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$91=void 0;class f{static computeUnicodeHighlights(e,E,R){const N=R?R.startLineNumber:1,$=R?R.endLineNumber:e.getLineCount(),b=new h(E),u=b.getCandidateCodePoints();let c;u==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(u))}`,"g");const n=new F.$iC(null,c),l=[];let L=!1,d,v=0,k=0,p=0;e:for(let y=N,M=$;y<=M;y++){const P=e.getLineContent(y),T=P.length;n.reset(0);do if(d=n.next(P),d){let D=d.index,q=d.index+d[0].length;if(D>0){const S=P.charCodeAt(D-1);r.$nf(S)&&D--}if(q+1<T){const S=P.charCodeAt(q-1);r.$nf(S)&&q++}const V=P.substring(D,q);let H=(0,w.$Js)(D+1,w.$Gs,P,0);H&&H.endColumn<=D+1&&(H=null);const ee=b.shouldHighlightNonBasicASCII(V,H?H.word:null);if(ee!==0){if(ee===3?v++:ee===2?k++:ee===1?p++:(0,o.$9c)(ee),l.length>=1e3){L=!0;break e}l.push(new _.$7s(y,D+1,y,q+1))}}while(d)}return{ranges:l,hasMore:L,ambiguousCharacterCount:v,invisibleCharacterCount:k,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,E){const R=new h(E);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),b=R.ambiguousCharacters.getPrimaryConfusable($),u=r.$Qf.getLocales().filter(c=>!r.$Qf.getInstance(new Set([...E.allowedLocales,c])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(b),notAmbiguousInLocales:u}}case 1:return{kind:2}}}}t.$91=f;function a(m,e){return`[${r.$Xe(m.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$Qf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of r.$Rf.codePoints)A(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let N=!1,$=!1;if(E)for(const b of E){const u=b.codePointAt(0),c=r.$yf(b);N=N||c,!c&&!this.ambiguousCharacters.isAmbiguous(u)&&!r.$Rf.isInvisibleCharacter(u)&&($=!0)}return!N&&$?0:this.b.invisibleCharacters&&!A(e)&&r.$Rf.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(m){return m===" "||m===`
`||m==="	"}var g;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(g||(g={}))}),te(se[61],le([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var _;(function(i){i[i.Unknown=0]="Unknown",i[i.Disabled=1]="Disabled",i[i.Enabled=2]="Enabled"})(_||(t.AccessibilitySupport=_={}));var F;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var r;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var o;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var w;(function(i){i[i.Deprecated=1]="Deprecated"})(w||(t.CompletionItemTag=w={}));var f;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(t.CompletionTriggerKind=f={}));var a;(function(i){i[i.EXACT=0]="EXACT",i[i.ABOVE=1]="ABOVE",i[i.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var s;(function(i){i[i.NotSet=0]="NotSet",i[i.ContentFlush=1]="ContentFlush",i[i.RecoverFromMarkers=2]="RecoverFromMarkers",i[i.Explicit=3]="Explicit",i[i.Paste=4]="Paste",i[i.Undo=5]="Undo",i[i.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var h;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var A;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var g;(function(i){i[i.None=0]="None",i[i.Keep=1]="Keep",i[i.Brackets=2]="Brackets",i[i.Advanced=3]="Advanced",i[i.Full=4]="Full"})(g||(t.EditorAutoIndentStrategy=g={}));var m;(function(i){i[i.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",i[i.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",i[i.accessibilitySupport=2]="accessibilitySupport",i[i.accessibilityPageSize=3]="accessibilityPageSize",i[i.ariaLabel=4]="ariaLabel",i[i.ariaRequired=5]="ariaRequired",i[i.autoClosingBrackets=6]="autoClosingBrackets",i[i.autoClosingComments=7]="autoClosingComments",i[i.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",i[i.autoClosingDelete=9]="autoClosingDelete",i[i.autoClosingOvertype=10]="autoClosingOvertype",i[i.autoClosingQuotes=11]="autoClosingQuotes",i[i.autoIndent=12]="autoIndent",i[i.automaticLayout=13]="automaticLayout",i[i.autoSurround=14]="autoSurround",i[i.bracketPairColorization=15]="bracketPairColorization",i[i.guides=16]="guides",i[i.codeLens=17]="codeLens",i[i.codeLensFontFamily=18]="codeLensFontFamily",i[i.codeLensFontSize=19]="codeLensFontSize",i[i.colorDecorators=20]="colorDecorators",i[i.colorDecoratorsLimit=21]="colorDecoratorsLimit",i[i.columnSelection=22]="columnSelection",i[i.comments=23]="comments",i[i.contextmenu=24]="contextmenu",i[i.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",i[i.cursorBlinking=26]="cursorBlinking",i[i.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",i[i.cursorStyle=28]="cursorStyle",i[i.cursorSurroundingLines=29]="cursorSurroundingLines",i[i.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",i[i.cursorWidth=31]="cursorWidth",i[i.disableLayerHinting=32]="disableLayerHinting",i[i.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",i[i.domReadOnly=34]="domReadOnly",i[i.dragAndDrop=35]="dragAndDrop",i[i.dropIntoEditor=36]="dropIntoEditor",i[i.emptySelectionClipboard=37]="emptySelectionClipboard",i[i.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",i[i.extraEditorClassName=39]="extraEditorClassName",i[i.fastScrollSensitivity=40]="fastScrollSensitivity",i[i.find=41]="find",i[i.fixedOverflowWidgets=42]="fixedOverflowWidgets",i[i.folding=43]="folding",i[i.foldingStrategy=44]="foldingStrategy",i[i.foldingHighlight=45]="foldingHighlight",i[i.foldingImportsByDefault=46]="foldingImportsByDefault",i[i.foldingMaximumRegions=47]="foldingMaximumRegions",i[i.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",i[i.fontFamily=49]="fontFamily",i[i.fontInfo=50]="fontInfo",i[i.fontLigatures=51]="fontLigatures",i[i.fontSize=52]="fontSize",i[i.fontWeight=53]="fontWeight",i[i.fontVariations=54]="fontVariations",i[i.formatOnPaste=55]="formatOnPaste",i[i.formatOnType=56]="formatOnType",i[i.glyphMargin=57]="glyphMargin",i[i.gotoLocation=58]="gotoLocation",i[i.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",i[i.hover=60]="hover",i[i.inDiffEditor=61]="inDiffEditor",i[i.inlineSuggest=62]="inlineSuggest",i[i.inlineEdit=63]="inlineEdit",i[i.letterSpacing=64]="letterSpacing",i[i.lightbulb=65]="lightbulb",i[i.lineDecorationsWidth=66]="lineDecorationsWidth",i[i.lineHeight=67]="lineHeight",i[i.lineNumbers=68]="lineNumbers",i[i.lineNumbersMinChars=69]="lineNumbersMinChars",i[i.linkedEditing=70]="linkedEditing",i[i.links=71]="links",i[i.matchBrackets=72]="matchBrackets",i[i.minimap=73]="minimap",i[i.mouseStyle=74]="mouseStyle",i[i.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",i[i.mouseWheelZoom=76]="mouseWheelZoom",i[i.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",i[i.multiCursorModifier=78]="multiCursorModifier",i[i.multiCursorPaste=79]="multiCursorPaste",i[i.multiCursorLimit=80]="multiCursorLimit",i[i.occurrencesHighlight=81]="occurrencesHighlight",i[i.overviewRulerBorder=82]="overviewRulerBorder",i[i.overviewRulerLanes=83]="overviewRulerLanes",i[i.padding=84]="padding",i[i.pasteAs=85]="pasteAs",i[i.parameterHints=86]="parameterHints",i[i.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",i[i.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",i[i.quickSuggestions=89]="quickSuggestions",i[i.quickSuggestionsDelay=90]="quickSuggestionsDelay",i[i.readOnly=91]="readOnly",i[i.readOnlyMessage=92]="readOnlyMessage",i[i.renameOnType=93]="renameOnType",i[i.renderControlCharacters=94]="renderControlCharacters",i[i.renderFinalNewline=95]="renderFinalNewline",i[i.renderLineHighlight=96]="renderLineHighlight",i[i.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",i[i.renderValidationDecorations=98]="renderValidationDecorations",i[i.renderWhitespace=99]="renderWhitespace",i[i.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",i[i.roundedSelection=101]="roundedSelection",i[i.rulers=102]="rulers",i[i.scrollbar=103]="scrollbar",i[i.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",i[i.scrollBeyondLastLine=105]="scrollBeyondLastLine",i[i.scrollPredominantAxis=106]="scrollPredominantAxis",i[i.selectionClipboard=107]="selectionClipboard",i[i.selectionHighlight=108]="selectionHighlight",i[i.selectOnLineNumbers=109]="selectOnLineNumbers",i[i.showFoldingControls=110]="showFoldingControls",i[i.showUnused=111]="showUnused",i[i.snippetSuggestions=112]="snippetSuggestions",i[i.smartSelect=113]="smartSelect",i[i.smoothScrolling=114]="smoothScrolling",i[i.stickyScroll=115]="stickyScroll",i[i.stickyTabStops=116]="stickyTabStops",i[i.stopRenderingLineAfter=117]="stopRenderingLineAfter",i[i.suggest=118]="suggest",i[i.suggestFontSize=119]="suggestFontSize",i[i.suggestLineHeight=120]="suggestLineHeight",i[i.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",i[i.suggestSelection=122]="suggestSelection",i[i.tabCompletion=123]="tabCompletion",i[i.tabIndex=124]="tabIndex",i[i.unicodeHighlighting=125]="unicodeHighlighting",i[i.unusualLineTerminators=126]="unusualLineTerminators",i[i.useShadowDOM=127]="useShadowDOM",i[i.useTabStops=128]="useTabStops",i[i.wordBreak=129]="wordBreak",i[i.wordSeparators=130]="wordSeparators",i[i.wordWrap=131]="wordWrap",i[i.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",i[i.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",i[i.wordWrapColumn=134]="wordWrapColumn",i[i.wordWrapOverride1=135]="wordWrapOverride1",i[i.wordWrapOverride2=136]="wordWrapOverride2",i[i.wrappingIndent=137]="wrappingIndent",i[i.wrappingStrategy=138]="wrappingStrategy",i[i.showDeprecated=139]="showDeprecated",i[i.inlayHints=140]="inlayHints",i[i.editorClassName=141]="editorClassName",i[i.pixelRatio=142]="pixelRatio",i[i.tabFocusMode=143]="tabFocusMode",i[i.layoutInfo=144]="layoutInfo",i[i.wrappingInfo=145]="wrappingInfo",i[i.defaultColorDecorators=146]="defaultColorDecorators",i[i.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",i[i.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var E;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(E||(t.EndOfLineSequence=E={}));var R;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var N;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(N||(t.IndentAction=N={}));var $;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var b;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(b||(t.InlayHintKind=b={}));var u;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(u||(t.InlineCompletionTriggerKind=u={}));var c;(function(i){i[i.Invoke=0]="Invoke",i[i.Automatic=1]="Automatic"})(c||(t.InlineEditTriggerKind=c={}));var n;(function(i){i[i.DependsOnKbLayout=-1]="DependsOnKbLayout",i[i.Unknown=0]="Unknown",i[i.Backspace=1]="Backspace",i[i.Tab=2]="Tab",i[i.Enter=3]="Enter",i[i.Shift=4]="Shift",i[i.Ctrl=5]="Ctrl",i[i.Alt=6]="Alt",i[i.PauseBreak=7]="PauseBreak",i[i.CapsLock=8]="CapsLock",i[i.Escape=9]="Escape",i[i.Space=10]="Space",i[i.PageUp=11]="PageUp",i[i.PageDown=12]="PageDown",i[i.End=13]="End",i[i.Home=14]="Home",i[i.LeftArrow=15]="LeftArrow",i[i.UpArrow=16]="UpArrow",i[i.RightArrow=17]="RightArrow",i[i.DownArrow=18]="DownArrow",i[i.Insert=19]="Insert",i[i.Delete=20]="Delete",i[i.Digit0=21]="Digit0",i[i.Digit1=22]="Digit1",i[i.Digit2=23]="Digit2",i[i.Digit3=24]="Digit3",i[i.Digit4=25]="Digit4",i[i.Digit5=26]="Digit5",i[i.Digit6=27]="Digit6",i[i.Digit7=28]="Digit7",i[i.Digit8=29]="Digit8",i[i.Digit9=30]="Digit9",i[i.KeyA=31]="KeyA",i[i.KeyB=32]="KeyB",i[i.KeyC=33]="KeyC",i[i.KeyD=34]="KeyD",i[i.KeyE=35]="KeyE",i[i.KeyF=36]="KeyF",i[i.KeyG=37]="KeyG",i[i.KeyH=38]="KeyH",i[i.KeyI=39]="KeyI",i[i.KeyJ=40]="KeyJ",i[i.KeyK=41]="KeyK",i[i.KeyL=42]="KeyL",i[i.KeyM=43]="KeyM",i[i.KeyN=44]="KeyN",i[i.KeyO=45]="KeyO",i[i.KeyP=46]="KeyP",i[i.KeyQ=47]="KeyQ",i[i.KeyR=48]="KeyR",i[i.KeyS=49]="KeyS",i[i.KeyT=50]="KeyT",i[i.KeyU=51]="KeyU",i[i.KeyV=52]="KeyV",i[i.KeyW=53]="KeyW",i[i.KeyX=54]="KeyX",i[i.KeyY=55]="KeyY",i[i.KeyZ=56]="KeyZ",i[i.Meta=57]="Meta",i[i.ContextMenu=58]="ContextMenu",i[i.F1=59]="F1",i[i.F2=60]="F2",i[i.F3=61]="F3",i[i.F4=62]="F4",i[i.F5=63]="F5",i[i.F6=64]="F6",i[i.F7=65]="F7",i[i.F8=66]="F8",i[i.F9=67]="F9",i[i.F10=68]="F10",i[i.F11=69]="F11",i[i.F12=70]="F12",i[i.F13=71]="F13",i[i.F14=72]="F14",i[i.F15=73]="F15",i[i.F16=74]="F16",i[i.F17=75]="F17",i[i.F18=76]="F18",i[i.F19=77]="F19",i[i.F20=78]="F20",i[i.F21=79]="F21",i[i.F22=80]="F22",i[i.F23=81]="F23",i[i.F24=82]="F24",i[i.NumLock=83]="NumLock",i[i.ScrollLock=84]="ScrollLock",i[i.Semicolon=85]="Semicolon",i[i.Equal=86]="Equal",i[i.Comma=87]="Comma",i[i.Minus=88]="Minus",i[i.Period=89]="Period",i[i.Slash=90]="Slash",i[i.Backquote=91]="Backquote",i[i.BracketLeft=92]="BracketLeft",i[i.Backslash=93]="Backslash",i[i.BracketRight=94]="BracketRight",i[i.Quote=95]="Quote",i[i.OEM_8=96]="OEM_8",i[i.IntlBackslash=97]="IntlBackslash",i[i.Numpad0=98]="Numpad0",i[i.Numpad1=99]="Numpad1",i[i.Numpad2=100]="Numpad2",i[i.Numpad3=101]="Numpad3",i[i.Numpad4=102]="Numpad4",i[i.Numpad5=103]="Numpad5",i[i.Numpad6=104]="Numpad6",i[i.Numpad7=105]="Numpad7",i[i.Numpad8=106]="Numpad8",i[i.Numpad9=107]="Numpad9",i[i.NumpadMultiply=108]="NumpadMultiply",i[i.NumpadAdd=109]="NumpadAdd",i[i.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",i[i.NumpadSubtract=111]="NumpadSubtract",i[i.NumpadDecimal=112]="NumpadDecimal",i[i.NumpadDivide=113]="NumpadDivide",i[i.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",i[i.ABNT_C1=115]="ABNT_C1",i[i.ABNT_C2=116]="ABNT_C2",i[i.AudioVolumeMute=117]="AudioVolumeMute",i[i.AudioVolumeUp=118]="AudioVolumeUp",i[i.AudioVolumeDown=119]="AudioVolumeDown",i[i.BrowserSearch=120]="BrowserSearch",i[i.BrowserHome=121]="BrowserHome",i[i.BrowserBack=122]="BrowserBack",i[i.BrowserForward=123]="BrowserForward",i[i.MediaTrackNext=124]="MediaTrackNext",i[i.MediaTrackPrevious=125]="MediaTrackPrevious",i[i.MediaStop=126]="MediaStop",i[i.MediaPlayPause=127]="MediaPlayPause",i[i.LaunchMediaPlayer=128]="LaunchMediaPlayer",i[i.LaunchMail=129]="LaunchMail",i[i.LaunchApp2=130]="LaunchApp2",i[i.Clear=131]="Clear",i[i.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var l;(function(i){i[i.Hint=1]="Hint",i[i.Info=2]="Info",i[i.Warning=4]="Warning",i[i.Error=8]="Error"})(l||(t.MarkerSeverity=l={}));var L;(function(i){i[i.Unnecessary=1]="Unnecessary",i[i.Deprecated=2]="Deprecated"})(L||(t.MarkerTag=L={}));var d;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(d||(t.MinimapPosition=d={}));var v;(function(i){i[i.UNKNOWN=0]="UNKNOWN",i[i.TEXTAREA=1]="TEXTAREA",i[i.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",i[i.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",i[i.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",i[i.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",i[i.CONTENT_TEXT=6]="CONTENT_TEXT",i[i.CONTENT_EMPTY=7]="CONTENT_EMPTY",i[i.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",i[i.CONTENT_WIDGET=9]="CONTENT_WIDGET",i[i.OVERVIEW_RULER=10]="OVERVIEW_RULER",i[i.SCROLLBAR=11]="SCROLLBAR",i[i.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",i[i.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(v||(t.MouseTargetType=v={}));var k;(function(i){i[i.AIGenerated=1]="AIGenerated"})(k||(t.NewSymbolNameTag=k={}));var p;(function(i){i[i.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",i[i.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",i[i.TOP_CENTER=2]="TOP_CENTER"})(p||(t.OverlayWidgetPositionPreference=p={}));var y;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(y||(t.OverviewRulerLane=y={}));var M;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(M||(t.PositionAffinity=M={}));var P;(function(i){i[i.Off=0]="Off",i[i.On=1]="On",i[i.Relative=2]="Relative",i[i.Interval=3]="Interval",i[i.Custom=4]="Custom"})(P||(t.RenderLineNumbersType=P={}));var T;(function(i){i[i.None=0]="None",i[i.Text=1]="Text",i[i.Blocks=2]="Blocks"})(T||(t.RenderMinimap=T={}));var D;(function(i){i[i.Smooth=0]="Smooth",i[i.Immediate=1]="Immediate"})(D||(t.ScrollType=D={}));var q;(function(i){i[i.Auto=1]="Auto",i[i.Hidden=2]="Hidden",i[i.Visible=3]="Visible"})(q||(t.ScrollbarVisibility=q={}));var V;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(V||(t.SelectionDirection=V={}));var H;(function(i){i.Off="off",i.OnCode="onCode",i.On="on"})(H||(t.ShowLightbulbIconMode=H={}));var ee;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(ee||(t.SignatureHelpTriggerKind=ee={}));var S;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(S||(t.SymbolKind=S={}));var U;(function(i){i[i.Deprecated=1]="Deprecated"})(U||(t.SymbolTag=U={}));var Y;(function(i){i[i.Hidden=0]="Hidden",i[i.Blink=1]="Blink",i[i.Smooth=2]="Smooth",i[i.Phase=3]="Phase",i[i.Expand=4]="Expand",i[i.Solid=5]="Solid"})(Y||(t.TextEditorCursorBlinkingStyle=Y={}));var X;(function(i){i[i.Line=1]="Line",i[i.Block=2]="Block",i[i.Underline=3]="Underline",i[i.LineThin=4]="LineThin",i[i.BlockOutline=5]="BlockOutline",i[i.UnderlineThin=6]="UnderlineThin"})(X||(t.TextEditorCursorStyle=X={}));var ne;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ne||(t.TrackedRangeStickiness=ne={}));var ue;(function(i){i[i.None=0]="None",i[i.Same=1]="Same",i[i.Indent=2]="Indent",i[i.DeepIndent=3]="DeepIndent"})(ue||(t.WrappingIndent=ue={}))}),te(se[62],le([0,1,11,10]),function(W,t,_,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ft=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new _.$5d,this.onDidChange=this.c.event,this.d=null}handleChange(f){this.c.fire({changedLanguages:f,changedColorMap:!1})}register(f,a){return this.a.set(f,a),this.handleChange([f]),(0,F.$Rc)(()=>{this.a.get(f)===a&&(this.a.delete(f),this.handleChange([f]))})}get(f){return this.a.get(f)||null}registerFactory(f,a){this.b.get(f)?.dispose();const s=new o(this,f,a);return this.b.set(f,s),(0,F.$Rc)(()=>{const h=this.b.get(f);!h||h!==s||(this.b.delete(f),h.dispose())})}async getOrCreate(f){const a=this.get(f);if(a)return a;const s=this.b.get(f);return!s||s.isResolved?null:(await s.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const s=this.b.get(f);return!!(!s||s.isResolved)}setColorMap(f){this.d=f,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Ft=r;class o extends F.$Tc{get isResolved(){return this.c}constructor(f,a,s){super(),this.f=f,this.g=a,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const f=await this.h.tokenizationSupport;this.c=!0,f&&!this.a&&this.B(this.f.register(this.g,f))}}}),te(se[63],le([68,69]),function(W,t){return W.create("vs/editor/common/languages",t)}),te(se[64],le([0,1,43,16,44,2,62,63]),function(W,t,_,F,r,o,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$Zt=t.$Yt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$Xt=t.$Wt=t.SymbolKinds=t.SymbolTag=t.$Vt=t.$Ut=t.SymbolKind=t.$Tt=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$St=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Rt=t.$Qt=t.$Pt=void 0;class a{constructor(U,Y,X){this.offset=U,this.type=Y,this.language=X,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Pt=a;class s{constructor(U,Y){this.tokens=U,this.endState=Y,this._tokenizationResultBrand=void 0}}t.$Qt=s;class h{constructor(U,Y){this.tokens=U,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}t.$Rt=h;var A;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var g;(function(S){const U=new Map;U.set(0,_.$kk.symbolMethod),U.set(1,_.$kk.symbolFunction),U.set(2,_.$kk.symbolConstructor),U.set(3,_.$kk.symbolField),U.set(4,_.$kk.symbolVariable),U.set(5,_.$kk.symbolClass),U.set(6,_.$kk.symbolStruct),U.set(7,_.$kk.symbolInterface),U.set(8,_.$kk.symbolModule),U.set(9,_.$kk.symbolProperty),U.set(10,_.$kk.symbolEvent),U.set(11,_.$kk.symbolOperator),U.set(12,_.$kk.symbolUnit),U.set(13,_.$kk.symbolValue),U.set(15,_.$kk.symbolEnum),U.set(14,_.$kk.symbolConstant),U.set(15,_.$kk.symbolEnum),U.set(16,_.$kk.symbolEnumMember),U.set(17,_.$kk.symbolKeyword),U.set(27,_.$kk.symbolSnippet),U.set(18,_.$kk.symbolText),U.set(19,_.$kk.symbolColor),U.set(20,_.$kk.symbolFile),U.set(21,_.$kk.symbolReference),U.set(22,_.$kk.symbolCustomColor),U.set(23,_.$kk.symbolFolder),U.set(24,_.$kk.symbolTypeParameter),U.set(25,_.$kk.account),U.set(26,_.$kk.issues);function Y(ue){let i=U.get(ue);return i||(console.info("No codicon found for CompletionItemKind "+ue),i=_.$kk.symbolProperty),i}S.toIcon=Y;const X=new Map;X.set("method",0),X.set("function",1),X.set("constructor",2),X.set("field",3),X.set("variable",4),X.set("class",5),X.set("struct",6),X.set("interface",7),X.set("module",8),X.set("property",9),X.set("event",10),X.set("operator",11),X.set("unit",12),X.set("value",13),X.set("constant",14),X.set("enum",15),X.set("enum-member",16),X.set("enumMember",16),X.set("keyword",17),X.set("snippet",27),X.set("text",18),X.set("color",19),X.set("file",20),X.set("reference",21),X.set("customcolor",22),X.set("folder",23),X.set("type-parameter",24),X.set("typeParameter",24),X.set("account",25),X.set("issue",26);function ne(ue,i){let ge=X.get(ue);return typeof ge>"u"&&!i&&(ge=9),ge}S.fromString=ne})(g||(t.CompletionItemKinds=g={}));var m;(function(S){S[S.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var E;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var R;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class N{constructor(U,Y,X,ne){this.range=U,this.text=Y,this.completionKind=X,this.isSnippetText=ne}equals(U){return o.$7s.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}t.$St=N;var $;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var b;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(b||(t.SignatureHelpTriggerKind=b={}));var u;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(u||(t.DocumentHighlightKind=u={}));function c(S){return S&&F.URI.isUri(S.uri)&&o.$7s.isIRange(S.range)&&(o.$7s.isIRange(S.originSelectionRange)||o.$7s.isIRange(S.targetSelectionRange))}t.$Tt=c;var n;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(n||(t.SymbolKind=n={})),t.$Ut={17:(0,f.localize)(0,null),16:(0,f.localize)(1,null),4:(0,f.localize)(2,null),13:(0,f.localize)(3,null),8:(0,f.localize)(4,null),9:(0,f.localize)(5,null),21:(0,f.localize)(6,null),23:(0,f.localize)(7,null),7:(0,f.localize)(8,null),0:(0,f.localize)(9,null),11:(0,f.localize)(10,null),10:(0,f.localize)(11,null),19:(0,f.localize)(12,null),5:(0,f.localize)(13,null),1:(0,f.localize)(14,null),2:(0,f.localize)(15,null),20:(0,f.localize)(16,null),15:(0,f.localize)(17,null),18:(0,f.localize)(18,null),24:(0,f.localize)(19,null),3:(0,f.localize)(20,null),6:(0,f.localize)(21,null),14:(0,f.localize)(22,null),22:(0,f.localize)(23,null),25:(0,f.localize)(24,null),12:(0,f.localize)(25,null)};function l(S,U){return(0,f.localize)(26,null,S,t.$Ut[U])}t.$Vt=l;var L;(function(S){S[S.Deprecated=1]="Deprecated"})(L||(t.SymbolTag=L={}));var d;(function(S){const U=new Map;U.set(0,_.$kk.symbolFile),U.set(1,_.$kk.symbolModule),U.set(2,_.$kk.symbolNamespace),U.set(3,_.$kk.symbolPackage),U.set(4,_.$kk.symbolClass),U.set(5,_.$kk.symbolMethod),U.set(6,_.$kk.symbolProperty),U.set(7,_.$kk.symbolField),U.set(8,_.$kk.symbolConstructor),U.set(9,_.$kk.symbolEnum),U.set(10,_.$kk.symbolInterface),U.set(11,_.$kk.symbolFunction),U.set(12,_.$kk.symbolVariable),U.set(13,_.$kk.symbolConstant),U.set(14,_.$kk.symbolString),U.set(15,_.$kk.symbolNumber),U.set(16,_.$kk.symbolBoolean),U.set(17,_.$kk.symbolArray),U.set(18,_.$kk.symbolObject),U.set(19,_.$kk.symbolKey),U.set(20,_.$kk.symbolNull),U.set(21,_.$kk.symbolEnumMember),U.set(22,_.$kk.symbolStruct),U.set(23,_.$kk.symbolEvent),U.set(24,_.$kk.symbolOperator),U.set(25,_.$kk.symbolTypeParameter);function Y(X){let ne=U.get(X);return ne||(console.info("No codicon found for SymbolKind "+X),ne=_.$kk.symbolProperty),ne}S.toIcon=Y})(d||(t.SymbolKinds=d={}));class v{static asEditOperation(U){return r.$8s.replace(o.$7s.lift(U.range),U.text)}}t.$Wt=v;class k{static fromValue(U){switch(U){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(U)}constructor(U){this.value=U}}t.$Xt=k,k.Comment=new k("comment"),k.Imports=new k("imports"),k.Region=new k("region");var p;(function(S){S[S.AIGenerated=1]="AIGenerated"})(p||(t.NewSymbolNameTag=p={}));var y;(function(S){function U(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}S.is=U})(y||(t.Command=y={}));var M;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(M||(t.CommentThreadCollapsibleState=M={}));var P;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(P||(t.CommentThreadState=P={}));var T;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(T||(t.CommentMode=T={}));var D;(function(S){S[S.Published=0]="Published",S[S.Draft=1]="Draft"})(D||(t.CommentState=D={}));var q;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(q||(t.InlayHintKind=q={}));class V{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Yt=V,t.$Zt=new w.$Ft;var H;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(H||(t.ExternalUriOpenerPriority=H={}));var ee;(function(S){S[S.Invoke=0]="Invoke",S[S.Automatic=1]="Automatic"})(ee||(t.InlineEditTriggerKind=ee={}))}),te(se[65],le([0,1,24,11,37,16,5,2,45,64,61]),function(W,t,_,F,r,o,w,f,a,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c2=t.$b2=void 0;class A{static chord(e,E){return(0,r.$gr)(e,E)}}t.$b2=A,A.CtrlCmd=2048,A.Shift=1024,A.Alt=512,A.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:_.$ce,Emitter:F.$5d,KeyCode:h.KeyCode,KeyMod:A,Position:w.$6s,Range:f.$7s,Selection:a.$9s,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:o.URI,Token:s.$Pt}}t.$c2=g}),te(se[70],le([0,1,25,16,5,2,58,29,54,55,65,23,60,33,52,15,3,53]),function(W,t,_,F,r,o,w,f,a,s,h,A,g,m,e,E,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends w.$yv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(n){const l=[];for(let L=0;L<this.f.length;L++){const d=this.f[L],v=this.offsetAt(new r.$6s(L+1,1)),k=d.matchAll(n);for(const p of k)(p.index||p.index===0)&&(p.index=p.index+v),l.push(p)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(n){return this.f[n-1]}getWordAtPosition(n,l){const L=(0,f.$Js)(n.column,(0,f.$Hs)(l),this.f[n.lineNumber-1],0);return L?new o.$7s(n.lineNumber,L.startColumn,n.lineNumber,L.endColumn):null}getWordUntilPosition(n,l){const L=this.getWordAtPosition(n,l);return L?{word:this.f[n.lineNumber-1].substring(L.startColumn-1,n.column-1),startColumn:L.startColumn,endColumn:n.column}:{word:"",startColumn:n.column,endColumn:n.column}}words(n){const l=this.f,L=this.q.bind(this);let d=0,v="",k=0,p=[];return{*[Symbol.iterator](){for(;;)if(k<p.length){const y=v.substring(p[k].start,p[k].end);k+=1,yield y}else if(d<l.length)v=l[d],p=L(v,n),k=0,d+=1;else break}}}getLineWords(n,l){const L=this.f[n-1],d=this.q(L,l),v=[];for(const k of d)v.push({word:L.substring(k.start,k.end),startColumn:k.start+1,endColumn:k.end+1});return v}q(n,l){const L=[];let d;for(l.lastIndex=0;(d=l.exec(n))&&d[0].length!==0;)L.push({start:d.index,end:d.index+d[0].length});return L}getValueInRange(n){if(n=this.r(n),n.startLineNumber===n.endLineNumber)return this.f[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);const l=this.g,L=n.startLineNumber-1,d=n.endLineNumber-1,v=[];v.push(this.f[L].substring(n.startColumn-1));for(let k=L+1;k<d;k++)v.push(this.f[k]);return v.push(this.f[d].substring(0,n.endColumn-1)),v.join(l)}offsetAt(n){return n=this.s(n),this.l(),this.j.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this.l();const l=this.j.getIndexOf(n),L=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,L)}}r(n){const l=this.s({lineNumber:n.startLineNumber,column:n.startColumn}),L=this.s({lineNumber:n.endLineNumber,column:n.endColumn});return l.lineNumber!==n.startLineNumber||l.column!==n.startColumn||L.lineNumber!==n.endLineNumber||L.column!==n.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:L.lineNumber,endColumn:L.column}:n}s(n){if(!r.$6s.isIPosition(n))throw new Error("bad position");let{lineNumber:l,column:L}=n,d=!1;if(l<1)l=1,L=1,d=!0;else if(l>this.f.length)l=this.f.length,L=this.f[l-1].length+1,d=!0;else{const v=this.f[l-1].length+1;L<1?(L=1,d=!0):L>v&&(L=v,d=!0)}return d?{lineNumber:l,column:L}:n}}class b{constructor(n,l){this.d=n,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(n){return this.f[n]}k(){const n=[];return Object.keys(this.f).forEach(l=>n.push(this.f[l])),n}acceptNewModel(n){this.f[n.url]=new $(F.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,l){if(!this.f[n])return;this.f[n].onEvents(l)}acceptRemovedModel(n){this.f[n]&&delete this.f[n]}async computeUnicodeHighlights(n,l,L){const d=this.j(n);return d?g.$91.computeUnicodeHighlights(d,l,L):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(n,l,L,d){const v=this.j(n),k=this.j(l);return!v||!k?null:b.l(v,k,L,d)}static l(n,l,L,d){const v=d==="advanced"?e.$y2.getDefault():e.$y2.getLegacy(),k=n.getLinesContent(),p=l.getLinesContent(),y=v.computeDiff(k,p,L),M=y.changes.length>0?!1:this.n(n,l);function P(T){return T.map(D=>[D.original.startLineNumber,D.original.endLineNumberExclusive,D.modified.startLineNumber,D.modified.endLineNumberExclusive,D.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:M,quitEarly:y.hitTimeout,changes:P(y.changes),moves:y.moves.map(T=>[T.lineRangeMapping.original.startLineNumber,T.lineRangeMapping.original.endLineNumberExclusive,T.lineRangeMapping.modified.startLineNumber,T.lineRangeMapping.modified.endLineNumberExclusive,P(T.changes)])}}static n(n,l){const L=n.getLineCount(),d=l.getLineCount();if(L!==d)return!1;for(let v=1;v<=L;v++){const k=n.getLineContent(v),p=l.getLineContent(v);if(k!==p)return!1}return!0}async computeDirtyDiff(n,l,L){const d=this.j(n),v=this.j(l);if(!d||!v)return null;const k=d.getLinesContent(),p=v.getLinesContent();return new m.$lt(k,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:L,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(n,l,L){const d=this.j(n);if(!d)return l;const v=[];let k;l=l.slice(0).sort((y,M)=>{if(y.range&&M.range)return o.$7s.compareRangesUsingStarts(y.range,M.range);const P=y.range?0:1,T=M.range?0:1;return P-T});let p=0;for(let y=1;y<l.length;y++)o.$7s.getEndPosition(l[p].range).equals(o.$7s.getStartPosition(l[y].range))?(l[p].range=o.$7s.fromPositions(o.$7s.getStartPosition(l[p].range),o.$7s.getEndPosition(l[y].range)),l[p].text+=l[y].text):(p++,l[p]=l[y]);l.length=p+1;for(let{range:y,text:M,eol:P}of l){if(typeof P=="number"&&(k=P),o.$7s.isEmpty(y)&&!M)continue;const T=d.getValueInRange(y);if(M=M.replace(/\r\n|\n|\r/g,d.eol),T===M)continue;if(Math.max(M.length,T.length)>b.o){v.push({range:y,text:M});continue}const D=(0,_.$_s)(T,M,L),q=d.offsetAt(o.$7s.lift(y).getStartPosition());for(const V of D){const H=d.positionAt(q+V.originalStart),ee=d.positionAt(q+V.originalStart+V.originalLength),S={text:M.substr(V.modifiedStart,V.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:ee.lineNumber,endColumn:ee.column}};d.getValueInRange(S.range)!==S.text&&v.push(S)}}return typeof k=="number"&&v.push({eol:k,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}computeHumanReadableDiff(n,l,L){const d=this.j(n);if(!d)return l;const v=[];let k;l=l.slice(0).sort((p,y)=>{if(p.range&&y.range)return o.$7s.compareRangesUsingStarts(p.range,y.range);const M=p.range?0:1,P=y.range?0:1;return M-P});for(let{range:p,text:y,eol:M}of l){let H=function(S,U){return new r.$6s(S.lineNumber+U.lineNumber-1,U.lineNumber===1?S.column+U.column-1:U.column)},ee=function(S,U){const Y=[];for(let X=U.startLineNumber;X<=U.endLineNumber;X++){const ne=S[X-1];X===U.startLineNumber&&X===U.endLineNumber?Y.push(ne.substring(U.startColumn-1,U.endColumn-1)):X===U.startLineNumber?Y.push(ne.substring(U.startColumn-1)):X===U.endLineNumber?Y.push(ne.substring(0,U.endColumn-1)):Y.push(ne)}return Y};if(typeof M=="number"&&(k=M),o.$7s.isEmpty(p)&&!y)continue;const P=d.getValueInRange(p);if(y=y.replace(/\r\n|\n|\r/g,d.eol),P===y)continue;if(Math.max(y.length,P.length)>b.o){v.push({range:p,text:y});continue}const T=P.split(/\r\n|\n|\r/),D=y.split(/\r\n|\n|\r/),q=e.$y2.getDefault().computeDiff(T,D,L),V=o.$7s.lift(p).getStartPosition();for(const S of q.changes)if(S.innerChanges)for(const U of S.innerChanges)v.push({range:o.$7s.fromPositions(H(V,U.originalRange.getStartPosition()),H(V,U.originalRange.getEndPosition())),text:ee(D,U.modifiedRange).join(d.eol)});else throw new R.$cb("The experimental diff algorithm always produces inner changes")}return typeof k=="number"&&v.push({eol:k,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeLinks(n){const l=this.j(n);return l?(0,a.$_1)(l):null}async computeDefaultDocumentColors(n){const l=this.j(n);return l?(0,N.$z2)(l):null}async textualSuggest(n,l,L,d){const v=new A.$1d,k=new RegExp(L,d),p=new Set;e:for(const y of n){const M=this.j(y);if(M){for(const P of M.words(k))if(!(P===l||!isNaN(Number(P)))&&(p.add(P),p.size>b.p))break e}}return{words:Array.from(p),duration:v.elapsed()}}async computeWordRanges(n,l,L,d){const v=this.j(n);if(!v)return Object.create(null);const k=new RegExp(L,d),p=Object.create(null);for(let y=l.startLineNumber;y<l.endLineNumber;y++){const M=v.getLineWords(y,k);for(const P of M){if(!isNaN(Number(P.word)))continue;let T=p[P.word];T||(T=[],p[P.word]=T),T.push({startLineNumber:y,startColumn:P.startColumn,endLineNumber:y,endColumn:P.endColumn})}}return p}async navigateValueSet(n,l,L,d,v){const k=this.j(n);if(!k)return null;const p=new RegExp(d,v);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const y=k.getValueInRange(l),M=k.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},p);if(!M)return null;const P=k.getValueInRange(M);return s.$a2.INSTANCE.navigateValueSet(l,y,M,P,L)}loadForeignModule(n,l,L){const d=(p,y)=>this.d.fhr(p,y),k={host:(0,E.$Tn)(L,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(k,l),Promise.resolve((0,E.$Sn)(this.h))):new Promise((p,y)=>{W([n],M=>{this.h=M.create(k,l),p((0,E.$Sn)(this.h))},y)})}fmr(n,l){if(!this.h||typeof this.h[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this.h[n].apply(this.h,l))}catch(L){return Promise.reject(L)}}}t.EditorSimpleWorker=b,b.o=1e5,b.p=1e4;function u(c){return new b(c,null)}t.create=u,typeof importScripts=="function"&&(globalThis.monaco=(0,h.$c2)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
