"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/network","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/async","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","os","vs/base/common/process","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/base/common/json","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","vs/server/node/server.main"],ke=function(le){for(var e=[],y=0,C=le.length;y<C;y++)e[y]=Ee[le[y]];return e};define(Ee[96],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class y{static get(){const s=new Map,S=new Map,k=new Map,P=new Map;function v(m,d){m.has(d.detail)||m.set(d.detail,-d.timestamp)}function p(m,d){const c=m.get(d.detail);c&&(c>=0||m.set(d.detail,c+d.timestamp))}let D=[];typeof le=="function"&&typeof le.getStats=="function"&&(D=le.getStats().slice(0).sort((m,d)=>m.timestamp-d.timestamp));for(const m of D)switch(m.type){case 10:v(s,m);break;case 11:case 12:p(s,m);break;case 21:v(S,m);break;case 22:p(S,m);break;case 33:v(k,m);break;case 34:p(k,m);break;case 31:v(P,m);break;case 32:p(P,m);break}let E=0;k.forEach(m=>E+=m);function w(m){const d=[];return m.forEach((c,b)=>d.push([b,c])),d}return{amdLoad:w(s),amdInvoke:w(S),nodeRequire:w(k),nodeEval:w(P),nodeRequireTotal:E}}static toMarkdownTable(s,S){let k="";const P=[];return s.forEach((v,p)=>{P[p]=v.length}),S.forEach(v=>{v.forEach((p,D)=>{typeof p>"u"&&(p=v[D]="-");const E=p.toString().length;P[D]=Math.max(E,P[D])})}),s.forEach((v,p)=>{k+=`| ${v+" ".repeat(P[p]-v.toString().length)} `}),k+=`|
`,s.forEach((v,p)=>{k+=`| ${"-".repeat(P[p])} `}),k+=`|
`,S.forEach(v=>{v.forEach((p,D)=>{typeof p<"u"&&(k+=`| ${p+" ".repeat(P[D]-p.toString().length)} `)}),k+=`|
`}),k}}e.$U=y}),define(Ee[142],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function y(c,b,u){const g=C(c,b);if(g!==-1)return c[g]}e.$fb=y;function C(c,b,u=c.length-1){for(let g=u;g>=0;g--){const h=c[g];if(b(h))return g}return-1}e.$gb=C;function s(c,b){const u=S(c,b);return u===-1?void 0:c[u]}e.$hb=s;function S(c,b,u=0,g=c.length){let h=u,f=g;for(;h<f;){const l=Math.floor((h+f)/2);b(c[l])?h=l+1:f=l}return h-1}e.$ib=S;function k(c,b){const u=P(c,b);return u===c.length?void 0:c[u]}e.$jb=k;function P(c,b,u=0,g=c.length){let h=u,f=g;for(;h<f;){const l=Math.floor((h+f)/2);b(c[l])?f=l:h=l+1}return h}e.$kb=P;function v(c,b,u=0,g=c.length){const h=P(c,b,u,g);return h===c.length?-1:h}e.$lb=v;class p{constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(p.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!b(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const u=S(this.e,b,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=p,p.assertInvariants=!1;function D(c,b){if(c.length===0)return;let u=c[0];for(let g=1;g<c.length;g++){const h=c[g];b(h,u)>0&&(u=h)}return u}e.$nb=D;function E(c,b){if(c.length===0)return;let u=c[0];for(let g=1;g<c.length;g++){const h=c[g];b(h,u)>=0&&(u=h)}return u}e.$ob=E;function w(c,b){return D(c,(u,g)=>-b(u,g))}e.$pb=w;function m(c,b){if(c.length===0)return-1;let u=0;for(let g=1;g<c.length;g++){const h=c[g];b(h,c[u])>0&&(u=g)}return u}e.$qb=m;function d(c,b){for(const u of c){const g=b(u);if(g!==void 0)return g}}e.$rb=d}),define(Ee[143],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=void 0;function y(k,P){const v=Object.create(null);for(const p of k){const D=P(p);let E=v[D];E||(E=v[D]=[]),E.push(p)}return v}e.$E=y;function C(k,P){const v=[],p=[];for(const D of k)P.has(D)||v.push(D);for(const D of P)k.has(D)||p.push(D);return{removed:v,added:p}}e.$F=C;function s(k,P){const v=[],p=[];for(const[D,E]of k)P.has(D)||v.push(E);for(const[D,E]of P)k.has(D)||p.push(E);return{removed:v,added:p}}e.$G=s;function S(k,P){const v=new Set;for(const p of P)k.has(p)&&v.add(p);return v}e.$H=S}),define(Ee[75],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function y(k){return(P,v,p)=>{let D=null,E=null;if(typeof p.value=="function"?(D="value",E=p.value):typeof p.get=="function"&&(D="get",E=p.get),!E)throw new Error("not supported");p[D]=k(E,v)}}function C(k,P,v){let p=null,D=null;if(typeof v.value=="function"?(p="value",D=v.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(p="get",D=v.get),!D)throw new Error("not supported");const E=`$memoize$${P}`;v[p]=function(...w){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,w)}),this[E]}}e.$Ih=C;function s(k,P,v){return y((p,D)=>{const E=`$debounce$${D}`,w=`$debounce$result$${D}`;return function(...m){this[w]||(this[w]=v?v():void 0),clearTimeout(this[E]),P&&(this[w]=P(this[w],...m),m=[this[w]]),this[E]=setTimeout(()=>{p.apply(this,m),this[w]=v?v():void 0},k)}})}e.$Jh=s;function S(k,P,v){return y((p,D)=>{const E=`$throttle$timer$${D}`,w=`$throttle$result$${D}`,m=`$throttle$lastRun$${D}`,d=`$throttle$pending$${D}`;return function(...c){if(this[w]||(this[w]=v?v():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[w]=P(this[w],...c)),this[d])return;const b=this[m]+k;b<=Date.now()?(this[m]=Date.now(),p.apply(this,[this[w]]),this[w]=v?v():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[m]=Date.now(),p.apply(this,[this[w]]),this[w]=v?v():void 0},b-Date.now()))}})}e.$Kh=S}),define(Ee[8],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class y{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=y,e.$X=new y;function C(l){e.$X.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=C;function s(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function S(l){p(l)||e.$X.onUnexpectedError(l)}e.$1=S;function k(l){p(l)||e.$X.onUnexpectedExternalError(l)}e.$2=k;function P(l){if(l instanceof Error){const{name:t,message:r}=l,o=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:o,noTelemetry:h.isErrorNoTelemetry(l)}}return l}e.$3=P;const v="Canceled";function p(l){return l instanceof D?!0:l instanceof Error&&l.name===v&&l.message===v}e.$4=p;class D extends Error{constructor(){super(v),this.name=this.message}}e.$5=D;function E(){const l=new Error(v);return l.name=l.message,l}e.$6=E;function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.$7=w;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.$8=m;class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function c(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.$0=c;class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=b;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const r=new h;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class f extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.$cb=f}),define(Ee[18],ke([1,0,8,142]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(Q,K=0){return Q[Q.length-(1+K)]}e.$sb=s;function S(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}e.$tb=S;function k(Q,K,X=(Y,N)=>Y===N){if(Q===K)return!0;if(!Q||!K||Q.length!==K.length)return!1;for(let Y=0,N=Q.length;Y<N;Y++)if(!X(Q[Y],K[Y]))return!1;return!0}e.$ub=k;function P(Q,K){const X=Q.length-1;K<X&&(Q[K]=Q[X]),Q.pop()}e.$vb=P;function v(Q,K,X){return p(Q.length,Y=>X(Q[Y],K))}e.$wb=v;function p(Q,K){let X=0,Y=Q-1;for(;X<=Y;){const N=(X+Y)/2|0,U=K(N);if(U<0)X=N+1;else if(U>0)Y=N-1;else return N}return-(X+1)}e.$xb=p;function D(Q,K,X){if(Q=Q|0,Q>=K.length)throw new TypeError("invalid index");const Y=K[Math.floor(K.length*Math.random())],N=[],U=[],te=[];for(const ie of K){const de=X(ie,Y);de<0?N.push(ie):de>0?U.push(ie):te.push(ie)}return Q<N.length?D(Q,N,X):Q<N.length+te.length?te[0]:D(Q-(N.length+te.length),U,X)}e.$yb=D;function E(Q,K){const X=[];let Y;for(const N of Q.slice(0).sort(K))!Y||K(Y[0],N)!==0?(Y=[N],X.push(Y)):Y.push(N);return X}e.$zb=E;function*w(Q,K){let X,Y;for(const N of Q)Y!==void 0&&K(Y,N)?X.push(N):(X&&(yield X),X=[N]),Y=N;X&&(yield X)}e.$Ab=w;function m(Q,K){for(let X=0;X<=Q.length;X++)K(X===0?void 0:Q[X-1],X===Q.length?void 0:Q[X])}e.$Bb=m;function d(Q,K){for(let X=0;X<Q.length;X++)K(X===0?void 0:Q[X-1],Q[X],X+1===Q.length?void 0:Q[X+1])}e.$Cb=d;function c(Q,K,X){const Y=[];function N(ie,de,ae){if(de===0&&ae.length===0)return;const be=Y[Y.length-1];be&&be.start+be.deleteCount===ie?(be.deleteCount+=de,be.toInsert.push(...ae)):Y.push({start:ie,deleteCount:de,toInsert:ae})}let U=0,te=0;for(;;){if(U===Q.length){N(U,0,K.slice(te));break}if(te===K.length){N(U,Q.length-U,[]);break}const ie=Q[U],de=K[te],ae=X(ie,de);ae===0?(U+=1,te+=1):ae<0?(N(U,1,[]),U+=1):ae>0&&(N(U,0,[de]),te+=1)}return Y}e.$Db=c;function b(Q,K,X){const Y=c(Q,K,X),N=[],U=[];for(const te of Y)N.push(...Q.slice(te.start,te.start+te.deleteCount)),U.push(...te.toInsert);return{removed:N,added:U}}e.$Eb=b;function u(Q,K,X){if(X===0)return[];const Y=Q.slice(0,X).sort(K);return h(Q,K,Y,X,Q.length),Y}e.top=u;function g(Q,K,X,Y,N){return X===0?Promise.resolve([]):new Promise((U,te)=>{(async()=>{const ie=Q.length,de=Q.slice(0,X).sort(K);for(let ae=X,be=Math.min(X+Y,ie);ae<ie;ae=be,be=Math.min(be+Y,ie)){if(ae>X&&await new Promise(ye=>setTimeout(ye)),N&&N.isCancellationRequested)throw new y.$5;h(Q,K,de,ae,be)}return de})().then(U,te)})}e.$Gb=g;function h(Q,K,X,Y,N){for(const U=X.length;Y<N;Y++){const te=Q[Y];if(K(te,X[U-1])<0){X.pop();const ie=(0,C.$kb)(X,de=>K(te,de)<0);X.splice(ie,0,te)}}}function f(Q){return Q.filter(K=>!!K)}e.$Hb=f;function l(Q){let K=0;for(let X=0;X<Q.length;X++)Q[X]&&(Q[K]=Q[X],K+=1);Q.length=K}e.$Ib=l;function t(Q,K,X){Q.splice(X,0,Q.splice(K,1)[0])}e.$Jb=t;function r(Q){return!Array.isArray(Q)||Q.length===0}e.$Kb=r;function o(Q){return Array.isArray(Q)&&Q.length>0}e.$Lb=o;function n(Q,K=X=>X){const X=new Set;return Q.filter(Y=>{const N=K(Y);return X.has(N)?!1:(X.add(N),!0)})}e.$Mb=n;function i(Q){const K=new Set;return X=>{const Y=Q(X);return K.has(Y)?!1:(K.add(Y),!0)}}e.$Nb=i;function a(Q,K){return Q.length>0?Q[0]:K}e.$Ob=a;function $(Q,K){return Q.length>0?Q[Q.length-1]:K}e.$Pb=$;function A(Q,K,X=(Y,N)=>Y===N){let Y=0;for(let N=0,U=Math.min(Q.length,K.length);N<U&&X(Q[N],K[N]);N++)Y++;return Y}e.$Qb=A;function R(Q){return[].concat(...Q)}e.$Rb=R;function I(Q,K){let X=typeof K=="number"?Q:0;typeof K=="number"?X=Q:(X=0,K=Q);const Y=[];if(X<=K)for(let N=X;N<K;N++)Y.push(N);else for(let N=X;N>K;N--)Y.push(N);return Y}e.$Sb=I;function O(Q,K,X){return Q.reduce((Y,N)=>(Y[K(N)]=X?X(N):N,Y),Object.create(null))}e.$Tb=O;function M(Q,K){return Q.push(K),()=>Z(Q,K)}e.$Ub=M;function Z(Q,K){const X=Q.indexOf(K);if(X>-1)return Q.splice(X,1),K}e.$Vb=Z;function ee(Q,K,X){const Y=Q.slice(0,K),N=Q.slice(K);return Y.concat(X,N)}e.$Wb=ee;function fe(Q,K){let X;if(typeof K=="number"){let Y=K;X=()=>{const N=Math.sin(Y++)*179426549;return N-Math.floor(N)}}else X=Math.random;for(let Y=Q.length-1;Y>0;Y-=1){const N=Math.floor(X()*(Y+1)),U=Q[Y];Q[Y]=Q[N],Q[N]=U}}e.$Xb=fe;function ue(Q,K){const X=Q.indexOf(K);X>-1&&(Q.splice(X,1),Q.unshift(K))}e.$Yb=ue;function j(Q,K){const X=Q.indexOf(K);X>-1&&(Q.splice(X,1),Q.push(K))}e.$Zb=j;function H(Q,K){for(const X of K)Q.push(X)}e.$1b=H;function q(Q,K){return Array.isArray(Q)?Q.map(K):K(Q)}e.$2b=q;function J(Q){return Array.isArray(Q)?Q:[Q]}e.$3b=J;function ne(Q){return Q[Math.floor(Math.random()*Q.length)]}e.$4b=ne;function x(Q,K,X){const Y=se(Q,K),N=Q.length,U=X.length;Q.length=N+U;for(let te=N-1;te>=Y;te--)Q[te+U]=Q[te];for(let te=0;te<U;te++)Q[te+Y]=X[te]}e.$5b=x;function G(Q,K,X,Y){const N=se(Q,K);let U=Q.splice(N,X);return U===void 0&&(U=[]),x(Q,N,Y),U}e.$6b=G;function se(Q,K){return K<0?Math.max(K+Q.length,0):Math.min(K,Q.length)}var ce;(function(Q){function K(U){return U<0}Q.isLessThan=K;function X(U){return U<=0}Q.isLessThanOrEqual=X;function Y(U){return U>0}Q.isGreaterThan=Y;function N(U){return U===0}Q.isNeitherLessOrGreaterThan=N,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function re(Q,K){return(X,Y)=>K(Q(X),Q(Y))}e.$7b=re;function ge(...Q){return(K,X)=>{for(const Y of Q){const N=Y(K,X);if(!ce.isNeitherLessOrGreaterThan(N))return N}return ce.neitherLessOrGreaterThan}}e.$8b=ge;const B=(Q,K)=>Q-K;e.$9b=B;const W=(Q,K)=>(0,e.$9b)(Q?1:0,K?1:0);e.$0b=W;function F(Q){return(K,X)=>-Q(K,X)}e.$$b=F;class z{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let X=this.c;for(;X<this.g.length&&K(this.g[X]);)X++;const Y=X===this.c?null:this.g.slice(this.c,X);return this.c=X,Y}takeFromEndWhile(K){let X=this.d;for(;X>=0&&K(this.g[X]);)X--;const Y=X===this.d?null:this.g.slice(X+1,this.d+1);return this.d=X,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const X=this.g.slice(this.c,this.c+K);return this.c+=K,X}}e.$_b=z;class _{constructor(K){this.iterate=K}forEach(K){this.iterate(X=>(K(X),!0))}toArray(){const K=[];return this.iterate(X=>(K.push(X),!0)),K}filter(K){return new _(X=>this.iterate(Y=>K(Y)?X(Y):!0))}map(K){return new _(X=>this.iterate(Y=>X(K(Y))))}some(K){let X=!1;return this.iterate(Y=>(X=K(Y),!X)),X}findFirst(K){let X;return this.iterate(Y=>K(Y)?(X=Y,!1):!0),X}findLast(K){let X;return this.iterate(Y=>(K(Y)&&(X=Y),!0)),X}findLastMaxBy(K){let X,Y=!0;return this.iterate(N=>((Y||ce.isGreaterThan(K(N,X)))&&(Y=!1,X=N),!0)),X}}e.$ac=_,_.empty=new _(Q=>{})}),define(Ee[97],ke([1,0,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function C(p,D){if(!p)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=C;function s(p,D="Unreachable"){throw new Error(D)}e.$9c=s;function S(p){if(!p)throw new y.$cb("Assertion Failed")}e.$0c=S;function k(p){p||(0,y.$1)(new y.$cb("Soft Assertion Failed"))}e.$$c=k;function P(p){if(!p()){debugger;p(),(0,y.$1)(new y.$cb("Assertion Failed"))}}e.$_c=P;function v(p,D){let E=0;for(;E<p.length-1;){const w=p[E],m=p[E+1];if(!D(w,m))return!1;E++}return!0}e.$ad=v}),define(Ee[76],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function y(C,s){const S=this;let k=!1,P;return function(){if(k)return P;if(k=!0,s)try{P=C.apply(S,arguments)}finally{s()}else P=C.apply(S,arguments);return P}}e.$db=y}),define(Ee[49],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(C){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=s;const S=Object.freeze([]);function k(){return S}C.empty=k;function*P(t){yield t}C.single=P;function v(t){return s(t)?t:P(t)}C.wrap=v;function p(t){return t||S}C.from=p;function*D(t){for(let r=t.length-1;r>=0;r--)yield t[r]}C.reverse=D;function E(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=E;function w(t){return t[Symbol.iterator]().next().value}C.first=w;function m(t,r){for(const o of t)if(r(o))return!0;return!1}C.some=m;function d(t,r){for(const o of t)if(r(o))return o}C.find=d;function*c(t,r){for(const o of t)r(o)&&(yield o)}C.filter=c;function*b(t,r){let o=0;for(const n of t)yield r(n,o++)}C.map=b;function*u(...t){for(const r of t)yield*r}C.concat=u;function g(t,r,o){let n=o;for(const i of t)n=r(n,i);return n}C.reduce=g;function*h(t,r,o=t.length){for(r<0&&(r+=t.length),o<0?o+=t.length:o>t.length&&(o=t.length);r<o;r++)yield t[r]}C.slice=h;function f(t,r=Number.POSITIVE_INFINITY){const o=[];if(r===0)return[o,t];const n=t[Symbol.iterator]();for(let i=0;i<r;i++){const a=n.next();if(a.done)return[o,C.empty()];o.push(a.value)}return[o,{[Symbol.iterator](){return n}}]}C.consume=f;async function l(t){const r=[];for await(const o of t)r.push(o);return Promise.resolve(r)}C.asyncToArray=l})(y||(e.Iterable=y={}))}),define(Ee[41],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S||(e.ParseOptions=S={}));function k(t,r=!1){let o=0;const n=t.length;let i="",a=0,$=16,A=0;function R(ue){let j=0,H=0;for(;j<ue;){const q=t.charCodeAt(o);if(q>=48&&q<=57)H=H*16+q-48;else if(q>=65&&q<=70)H=H*16+q-65+10;else if(q>=97&&q<=102)H=H*16+q-97+10;else break;o++,j++}return j<ue&&(H=-1),H}function I(ue){o=ue,i="",a=0,$=16,A=0}function O(){const ue=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&p(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&p(t.charCodeAt(o)))for(o++;o<t.length&&p(t.charCodeAt(o));)o++;else return A=3,t.substring(ue,o);let j=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&p(t.charCodeAt(o))){for(o++;o<t.length&&p(t.charCodeAt(o));)o++;j=o}else A=3;return t.substring(ue,j)}function M(){let ue="",j=o;for(;;){if(o>=n){ue+=t.substring(j,o),A=2;break}const H=t.charCodeAt(o);if(H===34){ue+=t.substring(j,o),o++;break}if(H===92){if(ue+=t.substring(j,o),o++,o>=n){A=2;break}switch(t.charCodeAt(o++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const J=R(4);J>=0?ue+=String.fromCharCode(J):A=4;break}default:A=5}j=o;continue}if(H>=0&&H<=31)if(v(H)){ue+=t.substring(j,o),A=2;break}else A=6;o++}return ue}function Z(){if(i="",A=0,a=o,o>=n)return a=n,$=17;let ue=t.charCodeAt(o);if(P(ue)){do o++,i+=String.fromCharCode(ue),ue=t.charCodeAt(o);while(P(ue));return $=15}if(v(ue))return o++,i+=String.fromCharCode(ue),ue===13&&t.charCodeAt(o)===10&&(o++,i+=`
`),$=14;switch(ue){case 123:return o++,$=1;case 125:return o++,$=2;case 91:return o++,$=3;case 93:return o++,$=4;case 58:return o++,$=6;case 44:return o++,$=5;case 34:return o++,i=M(),$=10;case 47:{const j=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<n&&!v(t.charCodeAt(o));)o++;return i=t.substring(j,o),$=12}if(t.charCodeAt(o+1)===42){o+=2;const H=n-1;let q=!1;for(;o<H;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,q=!0;break}o++}return q||(o++,A=1),i=t.substring(j,o),$=13}return i+=String.fromCharCode(ue),o++,$=16}case 45:if(i+=String.fromCharCode(ue),o++,o===n||!p(t.charCodeAt(o)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=O(),$=11;default:for(;o<n&&ee(ue);)o++,ue=t.charCodeAt(o);if(a!==o){switch(i=t.substring(a,o),i){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return i+=String.fromCharCode(ue),o++,$=16}}function ee(ue){if(P(ue)||v(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function fe(){let ue;do ue=Z();while(ue>=12&&ue<=15);return ue}return{setPosition:I,getPosition:()=>o,scan:r?fe:Z,getToken:()=>$,getTokenValue:()=>i,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>A}}e.$nn=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function E(t,r){const o=[],n=new Object;let i;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function A(R,I,O,M){a.value=R,a.offset=I,a.length=O,a.type=M,a.colonOffset=void 0,i=a}try{h(t,{onObjectBegin:(R,I)=>{if(r<=R)throw n;i=void 0,$=r>R,o.push("")},onObjectProperty:(R,I,O)=>{if(r<I||(A(R,I,O,"property"),o[o.length-1]=R,r<=I+O))throw n},onObjectEnd:(R,I)=>{if(r<=R)throw n;i=void 0,o.pop()},onArrayBegin:(R,I)=>{if(r<=R)throw n;i=void 0,o.push(0)},onArrayEnd:(R,I)=>{if(r<=R)throw n;i=void 0,o.pop()},onLiteralValue:(R,I,O)=>{if(r<I||(A(R,I,O,l(R)),r<=I+O))throw n},onSeparator:(R,I,O)=>{if(r<=I)throw n;if(R===":"&&i&&i.type==="property")i.colonOffset=I,$=!1,i=void 0;else if(R===","){const M=o[o.length-1];typeof M=="number"?o[o.length-1]=M+1:($=!0,o[o.length-1]=""),i=void 0}}})}catch(R){if(R!==n)throw R}return{path:o,previousNode:i,isAtPropertyKey:$,matches:R=>{let I=0;for(let O=0;I<R.length&&O<o.length;O++)if(R[I]===o[O]||R[I]==="*")I++;else if(R[I]!=="**")return!1;return I===R.length}}}e.$on=E;function w(t,r=[],o=S.DEFAULT){let n=null,i=[];const a=[];function $(R){Array.isArray(i)?i.push(R):n!==null&&(i[n]=R)}return h(t,{onObjectBegin:()=>{const R={};$(R),a.push(i),i=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{const R=[];$(R),a.push(i),i=R,n=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:$,onError:(R,I,O)=>{r.push({error:R,offset:I,length:O})}},o),i[0]}e.$pn=w;function m(t,r=[],o=S.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(R){n.type==="property"&&(n.length=R-n.offset,n=n.parent)}function a(R){return n.children.push(R),R}h(t,{onObjectBegin:R=>{n=a({type:"object",offset:R,length:-1,parent:n,children:[]})},onObjectProperty:(R,I,O)=>{n=a({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:R,offset:I,length:O,parent:n})},onObjectEnd:(R,I)=>{n.length=R+I-n.offset,n=n.parent,i(R+I)},onArrayBegin:(R,I)=>{n=a({type:"array",offset:R,length:-1,parent:n,children:[]})},onArrayEnd:(R,I)=>{n.length=R+I-n.offset,n=n.parent,i(R+I)},onLiteralValue:(R,I,O)=>{a({type:l(R),offset:I,length:O,parent:n,value:R}),i(I+O)},onSeparator:(R,I,O)=>{n.type==="property"&&(R===":"?n.colonOffset=I:R===","&&i(I))},onError:(R,I,O)=>{r.push({error:R,offset:I,length:O})}},o);const A=n.children[0];return A&&delete A.parent,A}e.$qn=m;function d(t,r){if(!t)return;let o=t;for(const n of r)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let i=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===n){o=a.children[1],i=!0;break}if(!i)return}else{const i=n;if(o.type!=="array"||i<0||!Array.isArray(o.children)||i>=o.children.length)return;o=o.children[i]}return o}e.$rn=d;function c(t){if(!t.parent||!t.parent.children)return[];const r=c(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.$sn=c;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":{const r=Object.create(null);for(const o of t.children){const n=o.children[1];n&&(r[o.children[0].value]=b(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$tn=b;function u(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.$un=u;function g(t,r,o=!1){if(u(t,r,o)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=r;i++){const a=g(n[i],r,o);if(a)return a}return t}}e.$vn=g;function h(t,r,o=S.DEFAULT){const n=k(t,!1);function i(re){return re?()=>re(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(re){return re?ge=>re(ge,n.getTokenOffset(),n.getTokenLength()):()=>!0}const $=i(r.onObjectBegin),A=a(r.onObjectProperty),R=i(r.onObjectEnd),I=i(r.onArrayBegin),O=i(r.onArrayEnd),M=a(r.onLiteralValue),Z=a(r.onSeparator),ee=i(r.onComment),fe=a(r.onError),ue=o&&o.disallowComments,j=o&&o.allowTrailingComma;function H(){for(;;){const re=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:ue||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(re){case 12:case 13:ue?q(10):ee();break;case 16:q(1);break;case 15:case 14:break;default:return re}}}function q(re,ge=[],B=[]){if(fe(re),ge.length+B.length>0){let W=n.getToken();for(;W!==17;){if(ge.indexOf(W)!==-1){H();break}else if(B.indexOf(W)!==-1)break;W=H()}}}function J(re){const ge=n.getTokenValue();return re?M(ge):A(ge),H(),!0}function ne(){switch(n.getToken()){case 11:{let re=0;try{re=JSON.parse(n.getTokenValue()),typeof re!="number"&&(q(2),re=0)}catch{q(2)}M(re);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return H(),!0}function x(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(J(!1),n.getToken()===6?(Z(":"),H(),ce()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function G(){$(),H();let re=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(re||q(4,[],[]),Z(","),H(),n.getToken()===2&&j)break}else re&&q(6,[],[]);x()||q(4,[],[2,5]),re=!0}return R(),n.getToken()!==2?q(7,[2],[]):H(),!0}function se(){I(),H();let re=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(re||q(4,[],[]),Z(","),H(),n.getToken()===4&&j)break}else re&&q(6,[],[]);ce()||q(4,[],[4,5]),re=!0}return O(),n.getToken()!==4?q(8,[4],[]):H(),!0}function ce(){switch(n.getToken()){case 3:return se();case 1:return G();case 10:return J(!0);default:return ne()}}return H(),n.getToken()===17?o.allowEmptyContent?!0:(q(4,[],[]),!1):ce()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$wn=h;function f(t,r){const o=k(t),n=[];let i,a=0,$;do switch($=o.getPosition(),i=o.scan(),i){case 12:case 13:case 17:a!==$&&n.push(t.substring(a,$)),r!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,r)),a=o.getPosition();break}while(i!==17);return n.join("")}e.$xn=f;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$yn=l}),define(Ee[144],ke([1,0,41]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=e.$An=e.$zn=void 0;function C(p,D,E){let w,m,d,c,b;if(D){for(c=D.offset,b=c+D.length,d=c;d>0&&!v(p,d-1);)d--;let $=b;for(;$<p.length&&!v(p,$);)$++;m=p.substring(d,$),w=k(m,E)}else m=p,w=0,d=0,c=0,b=p.length;const u=P(E,p);let g=!1,h=0,f;E.insertSpaces?f=S(" ",E.tabSize||4):f="	";const l=(0,y.$nn)(m,!1);let t=!1;function r(){return u+S(f,w+h)}function o(){let $=l.scan();for(g=!1;$===15||$===14;)g=g||$===14,$=l.scan();return t=$===16||l.getTokenError()!==0,$}const n=[];function i($,A,R){!t&&A<b&&R>c&&p.substring(A,R)!==$&&n.push({offset:A,length:R-A,content:$})}let a=o();if(a!==17){const $=l.getTokenOffset()+d,A=S(f,w);i(A,d,$)}for(;a!==17;){let $=l.getTokenOffset()+l.getTokenLength()+d,A=o(),R="";for(;!g&&(A===12||A===13);){const O=l.getTokenOffset()+d;i(" ",$,O),$=l.getTokenOffset()+l.getTokenLength()+d,R=A===12?r():"",A=o()}if(A===2)a!==1&&(h--,R=r());else if(A===4)a!==3&&(h--,R=r());else{switch(a){case 3:case 1:h++,R=r();break;case 5:case 12:R=r();break;case 13:g?R=r():R=" ";break;case 6:R=" ";break;case 10:if(A===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?R=" ":A!==5&&A!==17&&(t=!0);break;case 16:t=!0;break}g&&(A===12||A===13)&&(R=r())}const I=l.getTokenOffset()+d;i(R,$,I),a=A}return n}e.$zn=C;function s(p,D){const E=JSON.stringify(p,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?E.replace(/\r\n|\r|\n/g,D.eol):E}e.$An=s;function S(p,D){let E="";for(let w=0;w<D;w++)E+=p;return E}function k(p,D){let E=0,w=0;const m=D.tabSize||4;for(;E<p.length;){const d=p.charAt(E);if(d===" ")w++;else if(d==="	")w+=m;else break;E++}return Math.floor(w/m)}function P(p,D){for(let E=0;E<D.length;E++){const w=D.charAt(E);if(w==="\r")return E+1<D.length&&D.charAt(E+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return p&&p.eol||`
`}e.$Bn=P;function v(p,D){return`\r
`.indexOf(p.charAt(D))!==-1}e.$Cn=v}),define(Ee[145],ke([1,0,41,144]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=void 0;function s(p,D,E){return S(p,D,void 0,E)}e.$Dn=s;function S(p,D,E,w,m){const d=D.slice(),c=[],b=(0,y.$qn)(p,c);let u,g;for(;d.length>0&&(g=d.pop(),u=(0,y.$rn)(b,d),u===void 0&&E!==void 0);)typeof g=="string"?E={[g]:E}:E=[E];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const h=(0,y.$rn)(u,[g]);if(h!==void 0)if(E===void 0){if(!h.parent)throw new Error("Malformed AST");const f=u.children.indexOf(h.parent);let l,t=h.parent.offset+h.parent.length;if(f>0){const r=u.children[f-1];l=r.offset+r.length}else l=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return k(p,{offset:l,length:t-l,content:""},w)}else return k(p,{offset:h.offset,length:h.length,content:JSON.stringify(E)},w);else{if(E===void 0)return[];const f=`${JSON.stringify(g)}: ${JSON.stringify(E)}`,l=m?m(u.children.map(r=>r.children[0].value)):u.children.length;let t;if(l>0){const r=u.children[l-1];t={offset:r.offset+r.length,length:0,content:","+f}}else u.children.length===0?t={offset:u.offset+1,length:0,content:f}:t={offset:u.offset+1,length:0,content:f+","};return k(p,t,w)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(E!==void 0){const h=`${JSON.stringify(E)}`;let f;if(u.children.length===0||g===0)f={offset:u.offset+1,length:0,content:u.children.length===0?h:h+","};else{const l=g===-1||g>u.children.length?u.children.length:g,t=u.children[l-1];f={offset:t.offset+t.length,length:0,content:","+h}}return k(p,f,w)}else{const h=g,f=u.children[h];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===h){const t=u.children[h-1],r=t.offset+t.length,o=u.offset+u.length;l={offset:r,length:o-2-r,content:""}}else l={offset:f.offset,length:u.children[h+1].offset-f.offset,content:""};return k(p,l,w)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return k(p,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},w)}}e.$En=S;function k(p,D,E){let w=P(p,D),m=D.offset,d=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;m>0&&!(0,C.$Cn)(w,m-1);)m--;for(;d<w.length&&!(0,C.$Cn)(w,d);)d++}const c=(0,C.$zn)(w,{offset:m,length:d-m},E);for(let u=c.length-1;u>=0;u--){const g=c[u];w=P(w,g),m=Math.min(m,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const b=p.length-(w.length-d)-m;return[{offset:m,length:b,content:w.substring(m,d)}]}e.$Fn=k;function P(p,D){return p.substring(0,D.offset)+D.content+p.substring(D.offset+D.length)}e.$Gn=P;function v(p,D){const E=D.slice(0).sort((m,d)=>{const c=m.offset-d.offset;return c===0?m.length-d.length:c});let w=p.length;for(let m=E.length-1;m>=0;m--){const d=E[m];if(d.offset+d.length<=w)p=P(p,d);else throw new Error("Overlapping edit");w=d.offset}return p}e.$Hn=v}),define(Ee[60],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(Ee[98],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class y{constructor(S){this.element=S,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class C{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let S=this.a;for(;S!==y.Undefined;){const k=S.next;S.prev=y.Undefined,S.next=y.Undefined,S=k}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(S){return this.d(S,!1)}push(S){return this.d(S,!0)}d(S,k){const P=new y(S);if(this.a===y.Undefined)this.a=P,this.b=P;else if(k){const p=this.b;this.b=P,P.prev=p,p.next=P}else{const p=this.a;this.a=P,P.next=p,p.prev=P}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(P))}}shift(){if(this.a!==y.Undefined){const S=this.a.element;return this.e(this.a),S}}pop(){if(this.b!==y.Undefined){const S=this.b.element;return this.e(this.b),S}}e(S){if(S.prev!==y.Undefined&&S.next!==y.Undefined){const k=S.prev;k.next=S.next,S.next.prev=k}else S.prev===y.Undefined&&S.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):S.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):S.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let S=this.a;for(;S!==y.Undefined;)yield S.element,S=S.next}}e.$4c=C}),define(Ee[24],ke([1,0]),function(le,e){"use strict";var y,C,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function S(h,f,l){let t=h.get(f);return t===void 0&&(t=l,h.set(f,t)),t}e.$xc=S;function k(h){const f=[];return h.forEach((l,t)=>{f.push(`${t} => ${l}`)}),`Map(${h.size}) {${f.join(", ")}}`}e.$yc=k;function P(h){const f=[];return h.forEach(l=>{f.push(l)}),`Set(${h.size}) {${f.join(", ")}}`}e.$zc=P;class v{constructor(f,l){this.uri=f,this.value=l}}function p(h){return Array.isArray(h)}class D{constructor(f,l){if(this[y]="ResourceMap",f instanceof D)this.d=new Map(f.d),this.e=l??D.c;else if(p(f)){this.d=new Map,this.e=l??D.c;for(const[t,r]of f)this.set(t,r)}else this.d=new Map,this.e=f??D.c}set(f,l){return this.d.set(this.e(f),new v(f,l)),this}get(f){return this.d.get(this.e(f))?.value}has(f){return this.d.has(this.e(f))}get size(){return this.d.size}clear(){this.d.clear()}delete(f){return this.d.delete(this.e(f))}forEach(f,l){typeof l<"u"&&(f=f.bind(l));for(const[t,r]of this.d)f(r.value,r.uri,this)}*values(){for(const f of this.d.values())yield f.value}*keys(){for(const f of this.d.values())yield f.uri}*entries(){for(const f of this.d.values())yield[f.uri,f.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.d)yield[f.uri,f.value]}}e.$Ac=D,D.c=h=>h.toString();class E{constructor(f,l){this[C]="ResourceSet",!f||typeof f=="function"?this.c=new D(f):(this.c=new D(l),f.forEach(this.add,this))}get size(){return this.c.size}add(f){return this.c.set(f,f),this}clear(){this.c.clear()}delete(f){return this.c.delete(f)}forEach(f,l){this.c.forEach((t,r)=>f.call(l,r,r,this))}has(f){return this.c.has(f)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=E;var w;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class m{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(f){return this.c.has(f)}get(f,l=0){const t=this.c.get(f);if(t)return l!==0&&this.l(t,l),t.value}set(f,l,t=0){let r=this.c.get(f);if(r)r.value=l,t!==0&&this.l(r,t);else{switch(r={key:f,value:l,next:void 0,previous:void 0},t){case 0:this.j(r);break;case 1:this.i(r);break;case 2:this.j(r);break;default:this.j(r);break}this.c.set(f,r),this.f++}return this}delete(f){return!!this.remove(f)}remove(f){const l=this.c.get(f);if(l)return this.c.delete(f),this.k(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const f=this.d;return this.c.delete(f.key),this.k(f),this.f--,f.value}forEach(f,l){const t=this.g;let r=this.d;for(;r;){if(l?f.bind(l)(r.value,r.key,this):f(r.value,r.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const f=this,l=this.g;let t=this.d;const r={[Symbol.iterator](){return r},next(){if(f.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.key,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return r}values(){const f=this,l=this.g;let t=this.d;const r={[Symbol.iterator](){return r},next(){if(f.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.value,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return r}entries(){const f=this,l=this.g;let t=this.d;const r={[Symbol.iterator](){return r},next(){if(f.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:[t.key,t.value],done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return r}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(f){if(f>=this.size)return;if(f===0){this.clear();return}let l=this.d,t=this.size;for(;l&&t>f;)this.c.delete(l.key),l=l.next,t--;this.d=l,this.f=t,l&&(l.previous=void 0),this.g++}i(f){if(!this.d&&!this.e)this.e=f;else if(this.d)f.next=this.d,this.d.previous=f;else throw new Error("Invalid list");this.d=f,this.g++}j(f){if(!this.d&&!this.e)this.d=f;else if(this.e)f.previous=this.e,this.e.next=f;else throw new Error("Invalid list");this.e=f,this.g++}k(f){if(f===this.d&&f===this.e)this.d=void 0,this.e=void 0;else if(f===this.d){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.d=f.next}else if(f===this.e){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.e=f.previous}else{const l=f.next,t=f.previous;if(!l||!t)throw new Error("Invalid list");l.previous=t,t.next=l}f.next=void 0,f.previous=void 0,this.g++}l(f,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(f===this.d)return;const t=f.next,r=f.previous;f===this.e?(r.next=void 0,this.e=r):(t.previous=r,r.next=t),f.previous=void 0,f.next=this.d,this.d.previous=f,this.d=f,this.g++}else if(l===2){if(f===this.e)return;const t=f.next,r=f.previous;f===this.d?(t.previous=void 0,this.d=t):(t.previous=r,r.next=t),f.next=void 0,f.previous=this.e,this.e.next=f,this.e=f,this.g++}}}toJSON(){const f=[];return this.forEach((l,t)=>{f.push([t,l])}),f}fromJSON(f){this.clear();for(const[l,t]of f)this.set(l,t)}}e.$Cc=m;class d extends m{constructor(f,l=1){super(),this.m=f,this.n=Math.min(Math.max(0,l),1)}get limit(){return this.m}set limit(f){this.m=f,this.o()}get ratio(){return this.n}set ratio(f){this.n=Math.min(Math.max(0,f),1),this.o()}get(f,l=2){return super.get(f,l)}peek(f){return super.get(f,0)}set(f,l){return super.set(f,l,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=d;class c{constructor(){this.c=new Map}add(f){return this.c.set(f,(this.c.get(f)||0)+1),this}delete(f){let l=this.c.get(f)||0;return l===0?!1:(l--,l===0?this.c.delete(f):this.c.set(f,l),!0)}has(f){return this.c.has(f)}}e.$Ec=c;class b{constructor(f){if(this.c=new Map,this.d=new Map,f)for(const[l,t]of f)this.set(l,t)}clear(){this.c.clear(),this.d.clear()}set(f,l){this.c.set(f,l),this.d.set(l,f)}get(f){return this.c.get(f)}getKey(f){return this.d.get(f)}delete(f){const l=this.c.get(f);return l===void 0?!1:(this.c.delete(f),this.d.delete(l),!0)}forEach(f,l){this.c.forEach((t,r)=>{f.call(l,t,r,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=b;class u{constructor(){this.c=new Map}add(f,l){let t=this.c.get(f);t||(t=new Set,this.c.set(f,t)),t.add(l)}delete(f,l){const t=this.c.get(f);t&&(t.delete(l),t.size===0&&this.c.delete(f))}forEach(f,l){const t=this.c.get(f);t&&t.forEach(l)}get(f){const l=this.c.get(f);return l||new Set}}e.$Gc=u;function g(h,f){if(h===f)return!0;if(h.size!==f.size)return!1;for(const[l,t]of h)if(!f.has(l)||f.get(l)!==t)return!1;for(const[l]of f)if(!h.has(l))return!1;return!0}e.$Hc=g}),define(Ee[2],ke([1,0,18,143,24,76,49]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const P=!1;let v=null;class p{constructor(){this.b=new Map}c(M){let Z=this.b.get(M);return Z||(Z={parent:null,source:null,isSingleton:!1,value:M,idx:p.a++},this.b.set(M,Z)),Z}trackDisposable(M){const Z=this.c(M);Z.source||(Z.source=new Error().stack)}setParent(M,Z){const ee=this.c(M);ee.parent=Z}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,Z){const ee=Z.get(M);if(ee)return ee;const fe=M.parent?this.f(this.c(M.parent),Z):M;return Z.set(M,fe),fe}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,M).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(M=10,Z){let ee;if(Z)ee=Z;else{const q=new Map,J=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,q).isSingleton);if(J.length===0)return;const ne=new Set(J.map(x=>x.value));if(ee=J.filter(x=>!(x.parent&&ne.has(x.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function fe(q){function J(x,G){for(;x.length>0&&G.some(se=>typeof se=="string"?se===x[0]:x[0].match(se));)x.shift()}const ne=q.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return J(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const ue=new s.$Gc;for(const q of ee){const J=fe(q);for(let ne=0;ne<=J.length;ne++)ue.add(J.slice(0,ne).join(`
`),q)}ee.sort((0,y.$7b)(q=>q.idx,y.$9b));let j="",H=0;for(const q of ee.slice(0,M)){H++;const J=fe(q),ne=[];for(let x=0;x<J.length;x++){let G=J[x];G=`(shared with ${ue.get(J.slice(0,x+1).join(`
`)).size}/${ee.length} leaks) at ${G}`;const ce=ue.get(J.slice(0,x).join(`
`)),re=(0,C.$E)([...ce].map(ge=>fe(ge)[x]),ge=>ge);delete re[J[x]];for(const[ge,B]of Object.entries(re))ne.unshift(`    - stacktraces of ${B.length} other leaks continue with ${ge}`);ne.unshift(G)}j+=`


==================== Leaking disposable ${H}/${ee.length}: ${q.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return ee.length>M&&(j+=`


... and ${ee.length-M} more leaking disposables

`),{leaks:ee,details:j}}}e.$Ic=p,p.a=0;function D(O){v=O}if(e.$Jc=D,P){const O="__is_disposable_tracked__";D(new class{trackDisposable(M){const Z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[O]||console.log(Z)},3e3)}setParent(M,Z){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsSingleton(M){}})}function E(O){return v?.trackDisposable(O),O}e.$Kc=E;function w(O){v?.markAsDisposed(O)}e.$Lc=w;function m(O,M){v?.setParent(O,M)}function d(O,M){if(v)for(const Z of O)v.setParent(Z,M)}function c(O){return v?.markAsSingleton(O),O}e.$Mc=c;function b(O){return typeof O.dispose=="function"&&O.dispose.length===0}e.$Nc=b;function u(O){if(k.Iterable.is(O)){const M=[];for(const Z of O)if(Z)try{Z.dispose()}catch(ee){M.push(ee)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}e.$Oc=u;function g(O){for(const M of O)b(M)&&M.dispose();return[]}e.$Pc=g;function h(...O){const M=f(()=>u(O));return d(O,M),M}e.$Qc=h;function f(O){const M=E({dispose:(0,S.$db)(()=>{w(M),O()})});return M}e.$Rc=f;class l{constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return m(M,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),m(M,null))}}e.$Sc=l,l.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new l,E(this),m(this.q,this)}dispose(){w(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Tc=t,t.None=Object.freeze({dispose(){}});class r{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&m(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&m(M,null),M}}e.$Uc=r;class o{constructor(M){this.a=new r,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=o;class n{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(M){let Z=M;return this.unset=()=>Z=void 0,this.isset=()=>Z!==void 0,this.dispose=()=>{Z&&(Z(),Z=void 0,w(this))},this}}e.$Xc=i;class a{constructor(){this.a=new Map}acquire(M,...Z){let ee=this.a.get(M);ee||(ee={counter:0,object:this.b(M,...Z)},this.a.set(M,ee));const{object:fe}=ee,ue=(0,S.$db)(()=>{--ee.counter===0&&(this.c(M,ee.object),this.a.delete(M))});return ee.counter++,{object:fe,dispose:ue}}}e.$Yc=a;class ${constructor(M){this.a=M}async acquire(M,...Z){const ee=this.a.acquire(M,...Z);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(fe){throw ee.dispose(),fe}}}e.$Zc=$;class A{constructor(M){this.object=M}dispose(){}}e.$1c=A;function R(O){const M=new l;try{O(M)}finally{M.dispose()}}e.$2c=R;class I{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,Z,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(M)?.dispose(),this.a.set(M,Z)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=I}),function(le,e){typeof define=="function"&&define.amd?define(Ee[146],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(K,X){for(var Y=0;Y<X.length;Y++){var N=X[Y];N.enumerable=N.enumerable||!1,N.configurable=!0,"value"in N&&(N.writable=!0),Object.defineProperty(K,N.key,N)}}function y(K,X,Y){return X&&e(K.prototype,X),Y&&e(K,Y),Object.defineProperty(K,"prototype",{writable:!1}),K}function C(K,X){if(K){if(typeof K=="string")return s(K,X);var Y=Object.prototype.toString.call(K).slice(8,-1);if(Y==="Object"&&K.constructor&&(Y=K.constructor.name),Y==="Map"||Y==="Set")return Array.from(K);if(Y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Y))return s(K,X)}}function s(K,X){(X==null||X>K.length)&&(X=K.length);for(var Y=0,N=new Array(X);Y<X;Y++)N[Y]=K[Y];return N}function S(K,X){var Y=typeof Symbol<"u"&&K[Symbol.iterator]||K["@@iterator"];if(Y)return(Y=Y.call(K)).next.bind(Y);if(Array.isArray(K)||(Y=C(K))||X&&K&&typeof K.length=="number"){Y&&(K=Y);var N=0;return function(){return N>=K.length?{done:!0}:{done:!1,value:K[N++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=k();function P(K){le.defaults=K}var v=/[&<>"']/,p=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(X){return w[X]};function d(K,X){if(X){if(v.test(K))return K.replace(p,m)}else if(D.test(K))return K.replace(E,m);return K}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(K){return K.replace(c,function(X,Y){return Y=Y.toLowerCase(),Y==="colon"?":":Y.charAt(0)==="#"?Y.charAt(1)==="x"?String.fromCharCode(parseInt(Y.substring(2),16)):String.fromCharCode(+Y.substring(1)):""})}var u=/(^|[^\[])\^/g;function g(K,X){K=typeof K=="string"?K:K.source,X=X||"";var Y={replace:function(U,te){return te=te.source||te,te=te.replace(u,"$1"),K=K.replace(U,te),Y},getRegex:function(){return new RegExp(K,X)}};return Y}var h=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(K,X,Y){if(K){var N;try{N=decodeURIComponent(b(Y)).replace(h,"").toLowerCase()}catch{return null}if(N.indexOf("javascript:")===0||N.indexOf("vbscript:")===0||N.indexOf("data:")===0)return null}X&&!f.test(Y)&&(Y=i(X,Y));try{Y=encodeURI(Y).replace(/%25/g,"%")}catch{return null}return Y}var t={},r=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(K,X){t[" "+K]||(r.test(K)?t[" "+K]=K+"/":t[" "+K]=R(K,"/",!0)),K=t[" "+K];var Y=K.indexOf(":")===-1;return X.substring(0,2)==="//"?Y?X:K.replace(o,"$1")+X:X.charAt(0)==="/"?Y?X:K.replace(n,"$1")+X:K+X}var a={exec:function(){}};function $(K){for(var X=1,Y,N;X<arguments.length;X++){Y=arguments[X];for(N in Y)Object.prototype.hasOwnProperty.call(Y,N)&&(K[N]=Y[N])}return K}function A(K,X){var Y=K.replace(/\|/g,function(te,ie,de){for(var ae=!1,be=ie;--be>=0&&de[be]==="\\";)ae=!ae;return ae?"|":" |"}),N=Y.split(/ \|/),U=0;if(N[0].trim()||N.shift(),N.length>0&&!N[N.length-1].trim()&&N.pop(),N.length>X)N.splice(X);else for(;N.length<X;)N.push("");for(;U<N.length;U++)N[U]=N[U].trim().replace(/\\\|/g,"|");return N}function R(K,X,Y){var N=K.length;if(N===0)return"";for(var U=0;U<N;){var te=K.charAt(N-U-1);if(te===X&&!Y)U++;else if(te!==X&&Y)U++;else break}return K.slice(0,N-U)}function I(K,X){if(K.indexOf(X[1])===-1)return-1;for(var Y=K.length,N=0,U=0;U<Y;U++)if(K[U]==="\\")U++;else if(K[U]===X[0])N++;else if(K[U]===X[1]&&(N--,N<0))return U;return-1}function O(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(K,X){if(X<1)return"";for(var Y="";X>1;)X&1&&(Y+=K),X>>=1,K+=K;return Y+K}function Z(K,X,Y,N){var U=X.href,te=X.title?d(X.title):null,ie=K[1].replace(/\\([\[\]])/g,"$1");if(K[0].charAt(0)!=="!"){N.state.inLink=!0;var de={type:"link",raw:Y,href:U,title:te,text:ie,tokens:N.inlineTokens(ie)};return N.state.inLink=!1,de}return{type:"image",raw:Y,href:U,title:te,text:d(ie)}}function ee(K,X){var Y=K.match(/^(\s+)(?:```)/);if(Y===null)return X;var N=Y[1];return X.split(`
`).map(function(U){var te=U.match(/^\s+/);if(te===null)return U;var ie=te[0];return ie.length>=N.length?U.slice(N.length):U}).join(`
`)}var fe=function(){function K(Y){this.options=Y||le.defaults}var X=K.prototype;return X.space=function(N){var U=this.rules.block.newline.exec(N);if(U&&U[0].length>0)return{type:"space",raw:U[0]}},X.code=function(N){var U=this.rules.block.code.exec(N);if(U){var te=U[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:U[0],codeBlockStyle:"indented",text:this.options.pedantic?te:R(te,`
`)}}},X.fences=function(N){var U=this.rules.block.fences.exec(N);if(U){var te=U[0],ie=ee(te,U[3]||"");return{type:"code",raw:te,lang:U[2]?U[2].trim():U[2],text:ie}}},X.heading=function(N){var U=this.rules.block.heading.exec(N);if(U){var te=U[2].trim();if(/#$/.test(te)){var ie=R(te,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(te=ie.trim())}return{type:"heading",raw:U[0],depth:U[1].length,text:te,tokens:this.lexer.inline(te)}}},X.hr=function(N){var U=this.rules.block.hr.exec(N);if(U)return{type:"hr",raw:U[0]}},X.blockquote=function(N){var U=this.rules.block.blockquote.exec(N);if(U){var te=U[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:U[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},X.list=function(N){var U=this.rules.block.list.exec(N);if(U){var te,ie,de,ae,be,ye,Re,Me,$e,Se,De,je,Te=U[1].trim(),We=Te.length>1,ze={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Je=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");N&&(je=!1,!(!(U=Je.exec(N))||this.rules.block.hr.test(N)));){if(te=U[0],N=N.substring(te.length),Me=U[2].split(`
`,1)[0],$e=N.split(`
`,1)[0],this.options.pedantic?(ae=2,De=Me.trimLeft()):(ae=U[2].search(/[^ ]/),ae=ae>4?1:ae,De=Me.slice(ae),ae+=U[1].length),ye=!1,!Me&&/^ *$/.test($e)&&(te+=$e+`
`,N=N.substring($e.length+1),je=!0),!je)for(var _e=new RegExp("^ {0,"+Math.min(3,ae-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,ae-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ae-1)+"}(?:```|~~~)"),Ke=new RegExp("^ {0,"+Math.min(3,ae-1)+"}#");N&&(Se=N.split(`
`,1)[0],Me=Se,this.options.pedantic&&(Me=Me.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(Me)||Ke.test(Me)||_e.test(Me)||xe.test(N)));){if(Me.search(/[^ ]/)>=ae||!Me.trim())De+=`
`+Me.slice(ae);else if(!ye)De+=`
`+Me;else break;!ye&&!Me.trim()&&(ye=!0),te+=Se+`
`,N=N.substring(Se.length+1)}ze.loose||(Re?ze.loose=!0:/\n *\n *$/.test(te)&&(Re=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(De),ie&&(de=ie[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:te,task:!!ie,checked:de,loose:!1,text:De}),ze.raw+=te}ze.items[ze.items.length-1].raw=te.trimRight(),ze.items[ze.items.length-1].text=De.trimRight(),ze.raw=ze.raw.trimRight();var Ze=ze.items.length;for(be=0;be<Ze;be++){this.lexer.state.top=!1,ze.items[be].tokens=this.lexer.blockTokens(ze.items[be].text,[]);var me=ze.items[be].tokens.filter(function(Ae){return Ae.type==="space"}),Ie=me.every(function(Ae){for(var Oe=Ae.raw.split(""),Fe=0,He=S(Oe),Ve;!(Ve=He()).done;){var st=Ve.value;if(st===`
`&&(Fe+=1),Fe>1)return!0}return!1});!ze.loose&&me.length&&Ie&&(ze.loose=!0,ze.items[be].loose=!0)}return ze}},X.html=function(N){var U=this.rules.block.html.exec(N);if(U){var te={type:"html",raw:U[0],pre:!this.options.sanitizer&&(U[1]==="pre"||U[1]==="script"||U[1]==="style"),text:U[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(U[0]):d(U[0]);te.type="paragraph",te.text=ie,te.tokens=this.lexer.inline(ie)}return te}},X.def=function(N){var U=this.rules.block.def.exec(N);if(U){U[3]&&(U[3]=U[3].substring(1,U[3].length-1));var te=U[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:U[0],href:U[2],title:U[3]}}},X.table=function(N){var U=this.rules.block.table.exec(N);if(U){var te={type:"table",header:A(U[1]).map(function(Re){return{text:Re}}),align:U[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:U[3]&&U[3].trim()?U[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=U[0];var ie=te.align.length,de,ae,be,ye;for(de=0;de<ie;de++)/^ *-+: *$/.test(te.align[de])?te.align[de]="right":/^ *:-+: *$/.test(te.align[de])?te.align[de]="center":/^ *:-+ *$/.test(te.align[de])?te.align[de]="left":te.align[de]=null;for(ie=te.rows.length,de=0;de<ie;de++)te.rows[de]=A(te.rows[de],te.header.length).map(function(Re){return{text:Re}});for(ie=te.header.length,ae=0;ae<ie;ae++)te.header[ae].tokens=this.lexer.inline(te.header[ae].text);for(ie=te.rows.length,ae=0;ae<ie;ae++)for(ye=te.rows[ae],be=0;be<ye.length;be++)ye[be].tokens=this.lexer.inline(ye[be].text);return te}}},X.lheading=function(N){var U=this.rules.block.lheading.exec(N);if(U)return{type:"heading",raw:U[0],depth:U[2].charAt(0)==="="?1:2,text:U[1],tokens:this.lexer.inline(U[1])}},X.paragraph=function(N){var U=this.rules.block.paragraph.exec(N);if(U){var te=U[1].charAt(U[1].length-1)===`
`?U[1].slice(0,-1):U[1];return{type:"paragraph",raw:U[0],text:te,tokens:this.lexer.inline(te)}}},X.text=function(N){var U=this.rules.block.text.exec(N);if(U)return{type:"text",raw:U[0],text:U[0],tokens:this.lexer.inline(U[0])}},X.escape=function(N){var U=this.rules.inline.escape.exec(N);if(U)return{type:"escape",raw:U[0],text:d(U[1])}},X.tag=function(N){var U=this.rules.inline.tag.exec(N);if(U)return!this.lexer.state.inLink&&/^<a /i.test(U[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(U[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(U[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(U[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:U[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(U[0]):d(U[0]):U[0]}},X.link=function(N){var U=this.rules.inline.link.exec(N);if(U){var te=U[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ie=R(te.slice(0,-1),"\\");if((te.length-ie.length)%2===0)return}else{var de=I(U[2],"()");if(de>-1){var ae=U[0].indexOf("!")===0?5:4,be=ae+U[1].length+de;U[2]=U[2].substring(0,de),U[0]=U[0].substring(0,be).trim(),U[3]=""}}var ye=U[2],Re="";if(this.options.pedantic){var Me=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ye);Me&&(ye=Me[1],Re=Me[3])}else Re=U[3]?U[3].slice(1,-1):"";return ye=ye.trim(),/^</.test(ye)&&(this.options.pedantic&&!/>$/.test(te)?ye=ye.slice(1):ye=ye.slice(1,-1)),Z(U,{href:ye&&ye.replace(this.rules.inline._escapes,"$1"),title:Re&&Re.replace(this.rules.inline._escapes,"$1")},U[0],this.lexer)}},X.reflink=function(N,U){var te;if((te=this.rules.inline.reflink.exec(N))||(te=this.rules.inline.nolink.exec(N))){var ie=(te[2]||te[1]).replace(/\s+/g," ");if(ie=U[ie.toLowerCase()],!ie||!ie.href){var de=te[0].charAt(0);return{type:"text",raw:de,text:de}}return Z(te,ie,te[0],this.lexer)}},X.emStrong=function(N,U,te){te===void 0&&(te="");var ie=this.rules.inline.emStrong.lDelim.exec(N);if(ie&&!(ie[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=ie[1]||ie[2]||"";if(!de||de&&(te===""||this.rules.inline.punctuation.exec(te))){var ae=ie[0].length-1,be,ye,Re=ae,Me=0,$e=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,U=U.slice(-1*N.length+ae);(ie=$e.exec(U))!=null;)if(be=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!be){if(ye=be.length,ie[3]||ie[4]){Re+=ye;continue}else if((ie[5]||ie[6])&&ae%3&&!((ae+ye)%3)){Me+=ye;continue}if(Re-=ye,!(Re>0)){if(ye=Math.min(ye,ye+Re+Me),Math.min(ae,ye)%2){var Se=N.slice(1,ae+ie.index+ye);return{type:"em",raw:N.slice(0,ae+ie.index+ye+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var De=N.slice(2,ae+ie.index+ye-1);return{type:"strong",raw:N.slice(0,ae+ie.index+ye+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},X.codespan=function(N){var U=this.rules.inline.code.exec(N);if(U){var te=U[2].replace(/\n/g," "),ie=/[^ ]/.test(te),de=/^ /.test(te)&&/ $/.test(te);return ie&&de&&(te=te.substring(1,te.length-1)),te=d(te,!0),{type:"codespan",raw:U[0],text:te}}},X.br=function(N){var U=this.rules.inline.br.exec(N);if(U)return{type:"br",raw:U[0]}},X.del=function(N){var U=this.rules.inline.del.exec(N);if(U)return{type:"del",raw:U[0],text:U[2],tokens:this.lexer.inlineTokens(U[2])}},X.autolink=function(N,U){var te=this.rules.inline.autolink.exec(N);if(te){var ie,de;return te[2]==="@"?(ie=d(this.options.mangle?U(te[1]):te[1]),de="mailto:"+ie):(ie=d(te[1]),de=ie),{type:"link",raw:te[0],text:ie,href:de,tokens:[{type:"text",raw:ie,text:ie}]}}},X.url=function(N,U){var te;if(te=this.rules.inline.url.exec(N)){var ie,de;if(te[2]==="@")ie=d(this.options.mangle?U(te[0]):te[0]),de="mailto:"+ie;else{var ae;do ae=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(ae!==te[0]);ie=d(te[0]),te[1]==="www."?de="http://"+ie:de=ie}return{type:"link",raw:te[0],text:ie,href:de,tokens:[{type:"text",raw:ie,text:ie}]}}},X.inlineText=function(N,U){var te=this.rules.inline.text.exec(N);if(te){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):d(te[0]):te[0]:ie=d(this.options.smartypants?U(te[0]):te[0]),{type:"text",raw:te[0],text:ie}}},K}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=g(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=g(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=g(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=g(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=g(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=g(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=$({},ue),ue.gfm=$({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=g(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=g(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=$({},ue.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:g(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=g(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=g(ue._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=g(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=g(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=g(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=g(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=g(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=g(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=g(j.reflink).replace("label",j._label).replace("ref",ue._label).getRegex(),j.nolink=g(j.nolink).replace("ref",ue._label).getRegex(),j.reflinkSearch=g(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=$({},j),j.pedantic=$({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=$({},j.normal,{escape:g(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=g(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=$({},j.gfm,{br:g(j.br).replace("{2,}","*").getRegex(),text:g(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function H(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(K){var X="",Y,N,U=K.length;for(Y=0;Y<U;Y++)N=K.charCodeAt(Y),Math.random()>.5&&(N="x"+N.toString(16)),X+="&#"+N+";";return X}var J=function(){function K(Y){this.tokens=[],this.tokens.links=Object.create(null),this.options=Y||le.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var N={block:ue.normal,inline:j.normal};this.options.pedantic?(N.block=ue.pedantic,N.inline=j.pedantic):this.options.gfm&&(N.block=ue.gfm,this.options.breaks?N.inline=j.breaks:N.inline=j.gfm),this.tokenizer.rules=N}K.lex=function(N,U){var te=new K(U);return te.lex(N)},K.lexInline=function(N,U){var te=new K(U);return te.inlineTokens(N)};var X=K.prototype;return X.lex=function(N){N=N.replace(/\r\n|\r/g,`
`),this.blockTokens(N,this.tokens);for(var U;U=this.inlineQueue.shift();)this.inlineTokens(U.src,U.tokens);return this.tokens},X.blockTokens=function(N,U){var te=this;U===void 0&&(U=[]),this.options.pedantic?N=N.replace(/\t/g,"    ").replace(/^ +$/gm,""):N=N.replace(/^( *)(\t+)/gm,function(Re,Me,$e){return Me+"    ".repeat($e.length)});for(var ie,de,ae,be;N;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Re){return(ie=Re.call({lexer:te},N,U))?(N=N.substring(ie.raw.length),U.push(ie),!0):!1}))){if(ie=this.tokenizer.space(N)){N=N.substring(ie.raw.length),ie.raw.length===1&&U.length>0?U[U.length-1].raw+=`
`:U.push(ie);continue}if(ie=this.tokenizer.code(N)){N=N.substring(ie.raw.length),de=U[U.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):U.push(ie);continue}if(ie=this.tokenizer.fences(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.heading(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.hr(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.blockquote(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.list(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.html(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.def(N)){N=N.substring(ie.raw.length),de=U[U.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.lheading(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ae=N,this.options.extensions&&this.options.extensions.startBlock&&function(){var Re=1/0,Me=N.slice(1),$e=void 0;te.options.extensions.startBlock.forEach(function(Se){$e=Se.call({lexer:this},Me),typeof $e=="number"&&$e>=0&&(Re=Math.min(Re,$e))}),Re<1/0&&Re>=0&&(ae=N.substring(0,Re+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(ae))){de=U[U.length-1],be&&de.type==="paragraph"?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):U.push(ie),be=ae.length!==N.length,N=N.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(N)){N=N.substring(ie.raw.length),de=U[U.length-1],de&&de.type==="text"?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):U.push(ie);continue}if(N){var ye="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return this.state.top=!0,U},X.inline=function(N,U){return U===void 0&&(U=[]),this.inlineQueue.push({src:N,tokens:U}),U},X.inlineTokens=function(N,U){var te=this;U===void 0&&(U=[]);var ie,de,ae,be=N,ye,Re,Me;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(ye=this.tokenizer.rules.inline.reflinkSearch.exec(be))!=null;)$e.includes(ye[0].slice(ye[0].lastIndexOf("[")+1,-1))&&(be=be.slice(0,ye.index)+"["+M("a",ye[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ye=this.tokenizer.rules.inline.blockSkip.exec(be))!=null;)be=be.slice(0,ye.index)+"["+M("a",ye[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ye=this.tokenizer.rules.inline.escapedEmSt.exec(be))!=null;)be=be.slice(0,ye.index)+"++"+be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;N;)if(Re||(Me=""),Re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(ie=De.call({lexer:te},N,U))?(N=N.substring(ie.raw.length),U.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.tag(N)){N=N.substring(ie.raw.length),de=U[U.length-1],de&&ie.type==="text"&&de.type==="text"?(de.raw+=ie.raw,de.text+=ie.text):U.push(ie);continue}if(ie=this.tokenizer.link(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.reflink(N,this.tokens.links)){N=N.substring(ie.raw.length),de=U[U.length-1],de&&ie.type==="text"&&de.type==="text"?(de.raw+=ie.raw,de.text+=ie.text):U.push(ie);continue}if(ie=this.tokenizer.emStrong(N,be,Me)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.codespan(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.br(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.del(N)){N=N.substring(ie.raw.length),U.push(ie);continue}if(ie=this.tokenizer.autolink(N,q)){N=N.substring(ie.raw.length),U.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(N,q))){N=N.substring(ie.raw.length),U.push(ie);continue}if(ae=N,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,je=N.slice(1),Te=void 0;te.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},je),typeof Te=="number"&&Te>=0&&(De=Math.min(De,Te))}),De<1/0&&De>=0&&(ae=N.substring(0,De+1))}(),ie=this.tokenizer.inlineText(ae,H)){N=N.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(Me=ie.raw.slice(-1)),Re=!0,de=U[U.length-1],de&&de.type==="text"?(de.raw+=ie.raw,de.text+=ie.text):U.push(ie);continue}if(N){var Se="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return U},y(K,null,[{key:"rules",get:function(){return{block:ue,inline:j}}}]),K}(),ne=function(){function K(Y){this.options=Y||le.defaults}var X=K.prototype;return X.code=function(N,U,te){var ie=(U||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(N,ie);de!=null&&de!==N&&(te=!0,N=de)}return N=N.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+d(ie,!0)+'">'+(te?N:d(N,!0))+`</code></pre>
`:"<pre><code>"+(te?N:d(N,!0))+`</code></pre>
`},X.blockquote=function(N){return`<blockquote>
`+N+`</blockquote>
`},X.html=function(N){return N},X.heading=function(N,U,te,ie){if(this.options.headerIds){var de=this.options.headerPrefix+ie.slug(te);return"<h"+U+' id="'+de+'">'+N+"</h"+U+`>
`}return"<h"+U+">"+N+"</h"+U+`>
`},X.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},X.list=function(N,U,te){var ie=U?"ol":"ul",de=U&&te!==1?' start="'+te+'"':"";return"<"+ie+de+`>
`+N+"</"+ie+`>
`},X.listitem=function(N){return"<li>"+N+`</li>
`},X.checkbox=function(N){return"<input "+(N?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},X.paragraph=function(N){return"<p>"+N+`</p>
`},X.table=function(N,U){return U&&(U="<tbody>"+U+"</tbody>"),`<table>
<thead>
`+N+`</thead>
`+U+`</table>
`},X.tablerow=function(N){return`<tr>
`+N+`</tr>
`},X.tablecell=function(N,U){var te=U.header?"th":"td",ie=U.align?"<"+te+' align="'+U.align+'">':"<"+te+">";return ie+N+("</"+te+`>
`)},X.strong=function(N){return"<strong>"+N+"</strong>"},X.em=function(N){return"<em>"+N+"</em>"},X.codespan=function(N){return"<code>"+N+"</code>"},X.br=function(){return this.options.xhtml?"<br/>":"<br>"},X.del=function(N){return"<del>"+N+"</del>"},X.link=function(N,U,te){if(N=l(this.options.sanitize,this.options.baseUrl,N),N===null)return te;var ie='<a href="'+d(N)+'"';return U&&(ie+=' title="'+U+'"'),ie+=">"+te+"</a>",ie},X.image=function(N,U,te){if(N=l(this.options.sanitize,this.options.baseUrl,N),N===null)return te;var ie='<img src="'+N+'" alt="'+te+'"';return U&&(ie+=' title="'+U+'"'),ie+=this.options.xhtml?"/>":">",ie},X.text=function(N){return N},K}(),x=function(){function K(){}var X=K.prototype;return X.strong=function(N){return N},X.em=function(N){return N},X.codespan=function(N){return N},X.del=function(N){return N},X.html=function(N){return N},X.text=function(N){return N},X.link=function(N,U,te){return""+te},X.image=function(N,U,te){return""+te},X.br=function(){return""},K}(),G=function(){function K(){this.seen={}}var X=K.prototype;return X.serialize=function(N){return N.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},X.getNextSafeSlug=function(N,U){var te=N,ie=0;if(this.seen.hasOwnProperty(te)){ie=this.seen[N];do ie++,te=N+"-"+ie;while(this.seen.hasOwnProperty(te))}return U||(this.seen[N]=ie,this.seen[te]=0),te},X.slug=function(N,U){U===void 0&&(U={});var te=this.serialize(N);return this.getNextSafeSlug(te,U.dryrun)},K}(),se=function(){function K(Y){this.options=Y||le.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new G}K.parse=function(N,U){var te=new K(U);return te.parse(N)},K.parseInline=function(N,U){var te=new K(U);return te.parseInline(N)};var X=K.prototype;return X.parse=function(N,U){U===void 0&&(U=!0);var te="",ie,de,ae,be,ye,Re,Me,$e,Se,De,je,Te,We,ze,Je,_e,xe,nt,Ke,Ze=N.length;for(ie=0;ie<Ze;ie++){if(De=N[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(Ke=this.options.extensions.renderers[De.type].call({parser:this},De),Ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){te+=Ke||"";continue}switch(De.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(De.tokens),De.depth,b(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for($e="",Me="",be=De.header.length,de=0;de<be;de++)Me+=this.renderer.tablecell(this.parseInline(De.header[de].tokens),{header:!0,align:De.align[de]});for($e+=this.renderer.tablerow(Me),Se="",be=De.rows.length,de=0;de<be;de++){for(Re=De.rows[de],Me="",ye=Re.length,ae=0;ae<ye;ae++)Me+=this.renderer.tablecell(this.parseInline(Re[ae].tokens),{header:!1,align:De.align[ae]});Se+=this.renderer.tablerow(Me)}te+=this.renderer.table($e,Se);continue}case"blockquote":{Se=this.parse(De.tokens),te+=this.renderer.blockquote(Se);continue}case"list":{for(je=De.ordered,Te=De.start,We=De.loose,be=De.items.length,Se="",de=0;de<be;de++)Je=De.items[de],_e=Je.checked,xe=Je.task,ze="",Je.task&&(nt=this.renderer.checkbox(_e),We?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=nt+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=nt+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:nt}):ze+=nt),ze+=this.parse(Je.tokens,We),Se+=this.renderer.listitem(ze,xe,_e);te+=this.renderer.list(Se,je,Te);continue}case"html":{te+=this.renderer.html(De.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Se=De.tokens?this.parseInline(De.tokens):De.text;ie+1<Ze&&N[ie+1].type==="text";)De=N[++ie],Se+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);te+=U?this.renderer.paragraph(Se):Se;continue}default:{var me='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(me);return}else throw new Error(me)}}}return te},X.parseInline=function(N,U){U=U||this.renderer;var te="",ie,de,ae,be=N.length;for(ie=0;ie<be;ie++){if(de=N[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(ae=this.options.extensions.renderers[de.type].call({parser:this},de),ae!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){te+=ae||"";continue}switch(de.type){case"escape":{te+=U.text(de.text);break}case"html":{te+=U.html(de.text);break}case"link":{te+=U.link(de.href,de.title,this.parseInline(de.tokens,U));break}case"image":{te+=U.image(de.href,de.title,de.text);break}case"strong":{te+=U.strong(this.parseInline(de.tokens,U));break}case"em":{te+=U.em(this.parseInline(de.tokens,U));break}case"codespan":{te+=U.codespan(de.text);break}case"br":{te+=U.br();break}case"del":{te+=U.del(this.parseInline(de.tokens,U));break}case"text":{te+=U.text(de.text);break}default:{var ye='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(ye);return}else throw new Error(ye)}}}return te},K}();function ce(K,X,Y){if(typeof K>"u"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof X=="function"&&(Y=X,X=null),X=$({},ce.defaults,X||{}),O(X),Y){var N=X.highlight,U;try{U=J.lex(K,X)}catch(be){return Y(be)}var te=function(ye){var Re;if(!ye)try{X.walkTokens&&ce.walkTokens(U,X.walkTokens),Re=se.parse(U,X)}catch(Me){ye=Me}return X.highlight=N,ye?Y(ye):Y(null,Re)};if(!N||N.length<3||(delete X.highlight,!U.length))return te();var ie=0;ce.walkTokens(U,function(be){be.type==="code"&&(ie++,setTimeout(function(){N(be.text,be.lang,function(ye,Re){if(ye)return te(ye);Re!=null&&Re!==be.text&&(be.text=Re,be.escaped=!0),ie--,ie===0&&te()})},0))}),ie===0&&te();return}function de(be){if(be.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+d(be.message+"",!0)+"</pre>";throw be}try{var ae=J.lex(K,X);if(X.walkTokens){if(X.async)return Promise.all(ce.walkTokens(ae,X.walkTokens)).then(function(){return se.parse(ae,X)}).catch(de);ce.walkTokens(ae,X.walkTokens)}return se.parse(ae,X)}catch(be){de(be)}}ce.options=ce.setOptions=function(K){return $(ce.defaults,K),P(ce.defaults),ce},ce.getDefaults=k,ce.defaults=le.defaults,ce.use=function(){for(var K=arguments.length,X=new Array(K),Y=0;Y<K;Y++)X[Y]=arguments[Y];var N=$.apply(void 0,[{}].concat(X)),U=ce.defaults.extensions||{renderers:{},childTokens:{}},te;X.forEach(function(ie){if(ie.extensions&&(te=!0,ie.extensions.forEach(function(ae){if(!ae.name)throw new Error("extension name required");if(ae.renderer){var be=U.renderers?U.renderers[ae.name]:null;be?U.renderers[ae.name]=function(){for(var ye=arguments.length,Re=new Array(ye),Me=0;Me<ye;Me++)Re[Me]=arguments[Me];var $e=ae.renderer.apply(this,Re);return $e===!1&&($e=be.apply(this,Re)),$e}:U.renderers[ae.name]=ae.renderer}if(ae.tokenizer){if(!ae.level||ae.level!=="block"&&ae.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");U[ae.level]?U[ae.level].unshift(ae.tokenizer):U[ae.level]=[ae.tokenizer],ae.start&&(ae.level==="block"?U.startBlock?U.startBlock.push(ae.start):U.startBlock=[ae.start]:ae.level==="inline"&&(U.startInline?U.startInline.push(ae.start):U.startInline=[ae.start]))}ae.childTokens&&(U.childTokens[ae.name]=ae.childTokens)})),ie.renderer&&function(){var ae=ce.defaults.renderer||new ne,be=function(Me){var $e=ae[Me];ae[Me]=function(){for(var Se=arguments.length,De=new Array(Se),je=0;je<Se;je++)De[je]=arguments[je];var Te=ie.renderer[Me].apply(ae,De);return Te===!1&&(Te=$e.apply(ae,De)),Te}};for(var ye in ie.renderer)be(ye);N.renderer=ae}(),ie.tokenizer&&function(){var ae=ce.defaults.tokenizer||new fe,be=function(Me){var $e=ae[Me];ae[Me]=function(){for(var Se=arguments.length,De=new Array(Se),je=0;je<Se;je++)De[je]=arguments[je];var Te=ie.tokenizer[Me].apply(ae,De);return Te===!1&&(Te=$e.apply(ae,De)),Te}};for(var ye in ie.tokenizer)be(ye);N.tokenizer=ae}(),ie.walkTokens){var de=ce.defaults.walkTokens;N.walkTokens=function(ae){var be=[];return be.push(ie.walkTokens.call(this,ae)),de&&(be=be.concat(de.call(this,ae))),be}}te&&(N.extensions=U),ce.setOptions(N)})},ce.walkTokens=function(K,X){for(var Y=[],N=function(){var de=te.value;switch(Y=Y.concat(X.call(ce,de)),de.type){case"table":{for(var ae=S(de.header),be;!(be=ae()).done;){var ye=be.value;Y=Y.concat(ce.walkTokens(ye.tokens,X))}for(var Re=S(de.rows),Me;!(Me=Re()).done;)for(var $e=Me.value,Se=S($e),De;!(De=Se()).done;){var je=De.value;Y=Y.concat(ce.walkTokens(je.tokens,X))}break}case"list":{Y=Y.concat(ce.walkTokens(de.items,X));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[de.type]?ce.defaults.extensions.childTokens[de.type].forEach(function(Te){Y=Y.concat(ce.walkTokens(de[Te],X))}):de.tokens&&(Y=Y.concat(ce.walkTokens(de.tokens,X)))}},U=S(K),te;!(te=U()).done;)N();return Y},ce.parseInline=function(K,X){if(typeof K>"u"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");X=$({},ce.defaults,X||{}),O(X);try{var Y=J.lexInline(K,X);return X.walkTokens&&ce.walkTokens(Y,X.walkTokens),se.parseInline(Y,X)}catch(N){if(N.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+d(N.message+"",!0)+"</pre>";throw N}},ce.Parser=se,ce.parser=se.parse,ce.Renderer=ne,ce.TextRenderer=x,ce.Lexer=J,ce.lexer=J.lex,ce.Tokenizer=fe,ce.Slugger=G,ce.parse=ce;var re=ce.options,ge=ce.setOptions,B=ce.use,W=ce.walkTokens,F=ce.parseInline,z=ce,_=se.parse,Q=J.lex;le.Lexer=J,le.Parser=se,le.Renderer=ne,le.Slugger=G,le.TextRenderer=x,le.Tokenizer=fe,le.getDefaults=k,le.lexer=Q,le.marked=ce,le.options=re,le.parse=z,le.parseInline=F,le.parser=_,le.setOptions=ge,le.use=B,le.walkTokens=W,Object.defineProperty(le,"__esModule",{value:!0})}),define(Ee[147],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0;function y(c){const b=S(c);if(b&&b.length>0)return new Uint32Array(b)}e.$3j=y;let C=0;const s=new Uint32Array(10);function S(c){if(C=0,k(c,E,4352),C>0||(k(c,w,4449),C>0)||(k(c,m,4520),C>0)||(k(c,d,12593),C))return s.subarray(0,C);if(c>=44032&&c<=55203){const b=c-44032,u=b%588,g=Math.floor(b/588),h=Math.floor(u/28),f=u%28-1;if(g<E.length?k(g,E,0):4352+g-12593<d.length&&k(4352+g,d,12593),h<w.length?k(h,w,0):4449+h-12593<d.length&&k(4449+h-12593,d,12593),f>=0&&(f<m.length?k(f,m,0):4520+f-12593<d.length&&k(4520+f-12593,d,12593)),C>0)return s.subarray(0,C)}}function k(c,b,u){c>=u&&c<u+b.length&&P(b[c-u])}function P(c){c!==0&&(s[C++]=c&255,c>>8&&(s[C++]=c>>8&255),c>>16&&(s[C++]=c>>16&255))}var v;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var p;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(p||(p={}));var D;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(D||(D={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),m=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),d=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ee[99],ke([1,0,24]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=void 0;const C=new y.$Dc(1e4);function s(p){return v(p,"NFC",C)}e.$Sl=s;const S=new y.$Dc(1e4);function k(p){return v(p,"NFD",S)}e.$Tl=k;const P=/[^\u0000-\u0080]/;function v(p,D,E){if(!p)return p;const w=E.get(p);if(w)return w;let m;return P.test(p)?m=p.normalize(D):m=p,E.set(p,m),m}e.$Ul=function(){const p=/[\u0300-\u036f]/g;return function(D){return k(D).replace(p,"")}}()}),define(Ee[148],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.rot=e.$gm=void 0;function y(P,v,p){return Math.min(Math.max(P,v),p)}e.$gm=y;function C(P,v){return(v+P%v)%v}e.rot=C;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$im=s;class S{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$jm=S;class k{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const p=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$km=k}),function(){function le(s){const S=[];typeof s=="number"&&S.push("code/timeOrigin",s);function k(v){S.push(v,Date.now())}function P(){const v=[];for(let p=0;p<S.length;p+=2)v.push({name:S[p],startTime:S[p+1]});return v}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const k of performance.getEntriesByType("mark"))S.push({name:k.name,startTime:Math.round(s+k.startTime)});return S}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function y(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=y(C))}(),define(Ee[3],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D=e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.$b=e.Platform=e.$a=void 0,e.$a="en";let y=!1,C=!1,s=!1,S=!1,k=!1,P=!1,v=!1,p=!1,D=!1,E=!1,w,m=e.$a,d=e.$a,c,b;const u=globalThis;let g;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?g=u.vscode.process:typeof process<"u"&&(g=process);const h=typeof g?.versions?.electron=="string",f=h&&g?.type==="renderer";if(typeof g=="object"){y=g.platform==="win32",C=g.platform==="darwin",s=g.platform==="linux",S=s&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,v=h,D=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$a,m=e.$a;const R=g.env.VSCODE_NLS_CONFIG;if(R)try{const I=JSON.parse(R),O=I.availableLanguages["*"];w=I.locale,d=I.osLocale,m=O||e.$a,c=I._translationsConfigFile}catch{}k=!0}else if(typeof navigator=="object"&&!f){b=navigator.userAgent,y=b.indexOf("Windows")>=0,C=b.indexOf("Macintosh")>=0,p=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=b.indexOf("Linux")>=0,E=b?.indexOf("Mobi")>=0,P=!0,w=e.$a,m=w,d=navigator.language;const R=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),I=R&&R.getAttribute("data-settings");if(I)try{const O=JSON.parse(I),M=O.availableLanguages["*"];w=O.locale,d=O.osLocale,m=M||e.$a,c=O._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var l;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(l||(e.Platform=l={}));function t(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$b=t;let r=0;C?r=1:y?r=3:s&&(r=2),e.$c=y,e.$d=C,e.$e=s,e.$f=S,e.$g=k,e.$h=v,e.$i=P,e.$j=P&&typeof u.importScripts=="function",e.$k=e.$j?u.origin:void 0,e.$l=p,e.$m=E,e.$n=D,e.$o=r,e.$p=b,e.$q=m;var o;(function(R){function I(){return e.$q}R.value=I;function O(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}R.isDefaultVariant=O;function M(){return e.$q==="en"}R.isDefault=M})(o||(e.Language=o={})),e.$r=w,e.$s=d,e.$t=c,e.$u=typeof u.postMessage=="function"&&!u.importScripts,e.$v=(()=>{if(e.$u){const R=[];u.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let M=0,Z=R.length;M<Z;M++){const ee=R[M];if(ee.id===O.data.vscodeScheduleAsyncWork){R.splice(M,1),ee.callback();return}}});let I=0;return O=>{const M=++I;R.push({id:M,callback:O}),u.postMessage({vscodeScheduleAsyncWork:M},"*")}}return R=>setTimeout(R)})();var n;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=C||p?2:y?1:3;let i=!0,a=!1;function $(){if(!a){a=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,i=new Uint16Array(R.buffer)[0]===513}return i}e.$x=$,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function A(R){return parseFloat(R)>=20}e.$D=A}),define(Ee[28],ke([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let C;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const S=s.process;C={get platform(){return S.platform},get arch(){return S.arch},get env(){return S.env},cwd(){return S.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return y.$c?"win32":y.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$dc=C.platform,e.$ec=C.arch}),define(Ee[7],ke([1,0,28]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const C=65,s=97,S=90,k=122,P=46,v=47,p=92,D=58,E=63;class w extends Error{constructor(r,o,n){let i;typeof o=="string"&&o.indexOf("not ")===0?(i="must not be",o=o.replace(/^not /,"")):i="must be";const a=r.indexOf(".")!==-1?"property":"argument";let $=`The "${r}" ${a} ${i} of type ${o}`;$+=`. Received type ${typeof n}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,r){if(t===null||typeof t!="object")throw new w(r,"Object",t)}function d(t,r){if(typeof t!="string")throw new w(r,"string",t)}const c=y.$dc==="win32";function b(t){return t===v||t===p}function u(t){return t===v}function g(t){return t>=C&&t<=S||t>=s&&t<=k}function h(t,r,o,n){let i="",a=0,$=-1,A=0,R=0;for(let I=0;I<=t.length;++I){if(I<t.length)R=t.charCodeAt(I);else{if(n(R))break;R=v}if(n(R)){if(!($===I-1||A===1))if(A===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==P||i.charCodeAt(i.length-2)!==P){if(i.length>2){const O=i.lastIndexOf(o);O===-1?(i="",a=0):(i=i.slice(0,O),a=i.length-1-i.lastIndexOf(o)),$=I,A=0;continue}else if(i.length!==0){i="",a=0,$=I,A=0;continue}}r&&(i+=i.length>0?`${o}..`:"..",a=2)}else i.length>0?i+=`${o}${t.slice($+1,I)}`:i=t.slice($+1,I),a=I-$-1;$=I,A=0}else R===P&&A!==-1?++A:A=-1}return i}function f(t,r){m(r,"pathObject");const o=r.dir||r.root,n=r.base||`${r.name||""}${r.ext||""}`;return o?o===r.root?`${o}${n}`:`${o}${t}${n}`:n}e.$fc={resolve(...t){let r="",o="",n=!1;for(let i=t.length-1;i>=-1;i--){let a;if(i>=0){if(a=t[i],d(a,"path"),a.length===0)continue}else r.length===0?a=y.cwd():(a=y.env[`=${r}`]||y.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==r.toLowerCase()&&a.charCodeAt(2)===p)&&(a=`${r}\\`));const $=a.length;let A=0,R="",I=!1;const O=a.charCodeAt(0);if($===1)b(O)&&(A=1,I=!0);else if(b(O))if(I=!0,b(a.charCodeAt(1))){let M=2,Z=M;for(;M<$&&!b(a.charCodeAt(M));)M++;if(M<$&&M!==Z){const ee=a.slice(Z,M);for(Z=M;M<$&&b(a.charCodeAt(M));)M++;if(M<$&&M!==Z){for(Z=M;M<$&&!b(a.charCodeAt(M));)M++;(M===$||M!==Z)&&(R=`\\\\${ee}\\${a.slice(Z,M)}`,A=M)}}}else A=1;else g(O)&&a.charCodeAt(1)===D&&(R=a.slice(0,2),A=2,$>2&&b(a.charCodeAt(2))&&(I=!0,A=3));if(R.length>0)if(r.length>0){if(R.toLowerCase()!==r.toLowerCase())continue}else r=R;if(n){if(r.length>0)break}else if(o=`${a.slice(A)}\\${o}`,n=I,I&&r.length>0)break}return o=h(o,!n,"\\",b),n?`${r}\\${o}`:`${r}${o}`||"."},normalize(t){d(t,"path");const r=t.length;if(r===0)return".";let o=0,n,i=!1;const a=t.charCodeAt(0);if(r===1)return u(a)?"\\":t;if(b(a))if(i=!0,b(t.charCodeAt(1))){let A=2,R=A;for(;A<r&&!b(t.charCodeAt(A));)A++;if(A<r&&A!==R){const I=t.slice(R,A);for(R=A;A<r&&b(t.charCodeAt(A));)A++;if(A<r&&A!==R){for(R=A;A<r&&!b(t.charCodeAt(A));)A++;if(A===r)return`\\\\${I}\\${t.slice(R)}\\`;A!==R&&(n=`\\\\${I}\\${t.slice(R,A)}`,o=A)}}}else o=1;else g(a)&&t.charCodeAt(1)===D&&(n=t.slice(0,2),o=2,r>2&&b(t.charCodeAt(2))&&(i=!0,o=3));let $=o<r?h(t.slice(o),!i,"\\",b):"";return $.length===0&&!i&&($="."),$.length>0&&b(t.charCodeAt(r-1))&&($+="\\"),n===void 0?i?`\\${$}`:$:i?`${n}\\${$}`:`${n}${$}`},isAbsolute(t){d(t,"path");const r=t.length;if(r===0)return!1;const o=t.charCodeAt(0);return b(o)||r>2&&g(o)&&t.charCodeAt(1)===D&&b(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,o;for(let a=0;a<t.length;++a){const $=t[a];d($,"path"),$.length>0&&(r===void 0?r=o=$:r+=`\\${$}`)}if(r===void 0)return".";let n=!0,i=0;if(typeof o=="string"&&b(o.charCodeAt(0))){++i;const a=o.length;a>1&&b(o.charCodeAt(1))&&(++i,a>2&&(b(o.charCodeAt(2))?++i:n=!1))}if(n){for(;i<r.length&&b(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.$fc.normalize(r)},relative(t,r){if(d(t,"from"),d(r,"to"),t===r)return"";const o=e.$fc.resolve(t),n=e.$fc.resolve(r);if(o===n||(t=o.toLowerCase(),r=n.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===p;)i++;let a=t.length;for(;a-1>i&&t.charCodeAt(a-1)===p;)a--;const $=a-i;let A=0;for(;A<r.length&&r.charCodeAt(A)===p;)A++;let R=r.length;for(;R-1>A&&r.charCodeAt(R-1)===p;)R--;const I=R-A,O=$<I?$:I;let M=-1,Z=0;for(;Z<O;Z++){const fe=t.charCodeAt(i+Z);if(fe!==r.charCodeAt(A+Z))break;fe===p&&(M=Z)}if(Z!==O){if(M===-1)return n}else{if(I>O){if(r.charCodeAt(A+Z)===p)return n.slice(A+Z+1);if(Z===2)return n.slice(A+Z)}$>O&&(t.charCodeAt(i+Z)===p?M=Z:Z===2&&(M=3)),M===-1&&(M=0)}let ee="";for(Z=i+M+1;Z<=a;++Z)(Z===a||t.charCodeAt(Z)===p)&&(ee+=ee.length===0?"..":"\\..");return A+=M,ee.length>0?`${ee}${n.slice(A,R)}`:(n.charCodeAt(A)===p&&++A,n.slice(A,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===p){if(r.charCodeAt(1)===p){const o=r.charCodeAt(2);if(o!==E&&o!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===D&&r.charCodeAt(2)===p)return`\\\\?\\${r}`;return t},dirname(t){d(t,"path");const r=t.length;if(r===0)return".";let o=-1,n=0;const i=t.charCodeAt(0);if(r===1)return b(i)?t:".";if(b(i)){if(o=n=1,b(t.charCodeAt(1))){let A=2,R=A;for(;A<r&&!b(t.charCodeAt(A));)A++;if(A<r&&A!==R){for(R=A;A<r&&b(t.charCodeAt(A));)A++;if(A<r&&A!==R){for(R=A;A<r&&!b(t.charCodeAt(A));)A++;if(A===r)return t;A!==R&&(o=n=A+1)}}}}else g(i)&&t.charCodeAt(1)===D&&(o=r>2&&b(t.charCodeAt(2))?3:2,n=o);let a=-1,$=!0;for(let A=r-1;A>=n;--A)if(b(t.charCodeAt(A))){if(!$){a=A;break}}else $=!1;if(a===-1){if(o===-1)return".";a=o}return t.slice(0,a)},basename(t,r){r!==void 0&&d(r,"ext"),d(t,"path");let o=0,n=-1,i=!0,a;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===D&&(o=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let $=r.length-1,A=-1;for(a=t.length-1;a>=o;--a){const R=t.charCodeAt(a);if(b(R)){if(!i){o=a+1;break}}else A===-1&&(i=!1,A=a+1),$>=0&&(R===r.charCodeAt($)?--$===-1&&(n=a):($=-1,n=A))}return o===n?n=A:n===-1&&(n=t.length),t.slice(o,n)}for(a=t.length-1;a>=o;--a)if(b(t.charCodeAt(a))){if(!i){o=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(o,n)},extname(t){d(t,"path");let r=0,o=-1,n=0,i=-1,a=!0,$=0;t.length>=2&&t.charCodeAt(1)===D&&g(t.charCodeAt(0))&&(r=n=2);for(let A=t.length-1;A>=r;--A){const R=t.charCodeAt(A);if(b(R)){if(!a){n=A+1;break}continue}i===-1&&(a=!1,i=A+1),R===P?o===-1?o=A:$!==1&&($=1):o!==-1&&($=-1)}return o===-1||i===-1||$===0||$===1&&o===i-1&&o===n+1?"":t.slice(o,i)},format:f.bind(null,"\\"),parse(t){d(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const o=t.length;let n=0,i=t.charCodeAt(0);if(o===1)return b(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(b(i)){if(n=1,b(t.charCodeAt(1))){let M=2,Z=M;for(;M<o&&!b(t.charCodeAt(M));)M++;if(M<o&&M!==Z){for(Z=M;M<o&&b(t.charCodeAt(M));)M++;if(M<o&&M!==Z){for(Z=M;M<o&&!b(t.charCodeAt(M));)M++;M===o?n=M:M!==Z&&(n=M+1)}}}}else if(g(i)&&t.charCodeAt(1)===D){if(o<=2)return r.root=r.dir=t,r;if(n=2,b(t.charCodeAt(2))){if(o===3)return r.root=r.dir=t,r;n=3}}n>0&&(r.root=t.slice(0,n));let a=-1,$=n,A=-1,R=!0,I=t.length-1,O=0;for(;I>=n;--I){if(i=t.charCodeAt(I),b(i)){if(!R){$=I+1;break}continue}A===-1&&(R=!1,A=I+1),i===P?a===-1?a=I:O!==1&&(O=1):a!==-1&&(O=-1)}return A!==-1&&(a===-1||O===0||O===1&&a===A-1&&a===$+1?r.base=r.name=t.slice($,A):(r.name=t.slice($,a),r.base=t.slice($,A),r.ext=t.slice(a,A))),$>0&&$!==n?r.dir=t.slice(0,$-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(c){const t=/\\/g;return()=>{const r=y.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>y.cwd()})();e.$gc={resolve(...t){let r="",o=!1;for(let n=t.length-1;n>=-1&&!o;n--){const i=n>=0?t[n]:l();d(i,"path"),i.length!==0&&(r=`${i}/${r}`,o=i.charCodeAt(0)===v)}return r=h(r,!o,"/",u),o?`/${r}`:r.length>0?r:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===v,o=t.charCodeAt(t.length-1)===v;return t=h(t,!r,"/",u),t.length===0?r?"/":o?"./":".":(o&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let r;for(let o=0;o<t.length;++o){const n=t[o];d(n,"path"),n.length>0&&(r===void 0?r=n:r+=`/${n}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(d(t,"from"),d(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const o=1,n=t.length,i=n-o,a=1,$=r.length-a,A=i<$?i:$;let R=-1,I=0;for(;I<A;I++){const M=t.charCodeAt(o+I);if(M!==r.charCodeAt(a+I))break;M===v&&(R=I)}if(I===A)if($>A){if(r.charCodeAt(a+I)===v)return r.slice(a+I+1);if(I===0)return r.slice(a+I)}else i>A&&(t.charCodeAt(o+I)===v?R=I:I===0&&(R=0));let O="";for(I=o+R+1;I<=n;++I)(I===n||t.charCodeAt(I)===v)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(a+R)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===v;let o=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===v){if(!n){o=i;break}}else n=!1;return o===-1?r?"/":".":r&&o===1?"//":t.slice(0,o)},basename(t,r){r!==void 0&&d(r,"ext"),d(t,"path");let o=0,n=-1,i=!0,a;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let $=r.length-1,A=-1;for(a=t.length-1;a>=0;--a){const R=t.charCodeAt(a);if(R===v){if(!i){o=a+1;break}}else A===-1&&(i=!1,A=a+1),$>=0&&(R===r.charCodeAt($)?--$===-1&&(n=a):($=-1,n=A))}return o===n?n=A:n===-1&&(n=t.length),t.slice(o,n)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===v){if(!i){o=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(o,n)},extname(t){d(t,"path");let r=-1,o=0,n=-1,i=!0,a=0;for(let $=t.length-1;$>=0;--$){const A=t.charCodeAt($);if(A===v){if(!i){o=$+1;break}continue}n===-1&&(i=!1,n=$+1),A===P?r===-1?r=$:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||n===-1||a===0||a===1&&r===n-1&&r===o+1?"":t.slice(r,n)},format:f.bind(null,"/"),parse(t){d(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const o=t.charCodeAt(0)===v;let n;o?(r.root="/",n=1):n=0;let i=-1,a=0,$=-1,A=!0,R=t.length-1,I=0;for(;R>=n;--R){const O=t.charCodeAt(R);if(O===v){if(!A){a=R+1;break}continue}$===-1&&(A=!1,$=R+1),O===P?i===-1?i=R:I!==1&&(I=1):i!==-1&&(I=-1)}if($!==-1){const O=a===0&&o?1:a;i===-1||I===0||I===1&&i===$-1&&i===a+1?r.base=r.name=t.slice(O,$):(r.name=t.slice(O,i),r.base=t.slice(O,$),r.ext=t.slice(i,$))}return a>0?r.dir=t.slice(0,a-1):o&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(Ee[61],ke([1,0,7]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=e.$ss=e.$rs=void 0,e.$rs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(D){const E=(0,y.$oc)(D),w=C[E.toLowerCase()];return w!==void 0?w:k(D)}e.$ss=S;function k(D){const E=(0,y.$oc)(D);return s[E.toLowerCase()]}e.$ts=k;function P(D){for(const E in s)if(s[E]===D)return E}e.$us=P;const v=/^(.+)\/(.+?)(;.+)?$/;function p(D,E){const w=v.exec(D);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:E?void 0:D}e.$vs=p}),define(Ee[62],ke([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.TerminateResponseCode=e.Source=void 0;var C;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(C||(e.Source=C={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function S(P,...v){const p=v.reduce((w,m)=>(w[m]=!0,w),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(P).filter(w=>!p[w]).forEach(w=>{for(let m=0;m<D.length;m++)if(w.search(D[m])!==-1){delete P[w];break}})}e.$4l=S;function k(P){P&&(delete P.DEBUG,y.$d&&delete P.DYLD_LIBRARY_PATH,y.$e&&delete P.LD_PRELOAD)}e.$5l=k}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var C in y)(typeof exports=="object"?exports:le)[C]=y[C]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function y(C){if(e[C])return e[C].exports;var s=e[C]={i:C,l:!1,exports:{}};return le[C].call(s.exports,s,s.exports,y),s.l=!0,s.exports}return y.m=le,y.c=e,y.d=function(C,s,S){y.o(C,s)||Object.defineProperty(C,s,{enumerable:!0,get:S})},y.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},y.t=function(C,s){if(1&s&&(C=y(C)),8&s||4&s&&typeof C=="object"&&C&&C.__esModule)return C;var S=Object.create(null);if(y.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:C}),2&s&&typeof C!="string")for(var k in C)y.d(S,k,function(P){return C[P]}.bind(null,k));return S},y.n=function(C){var s=C&&C.__esModule?function(){return C.default}:function(){return C};return y.d(s,"a",s),s},y.o=function(C,s){return Object.prototype.hasOwnProperty.call(C,s)},y.p="",y(y.s=0)}([function(le,e,y){(function(C){var s;e=le.exports=B,s=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var $e=Array.prototype.slice.call(arguments,0);$e.unshift("SEMVER"),console.log.apply(console,$e)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var S=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],v=e.src=[],p=0,D=p++;v[D]="0|[1-9]\\d*";var E=p++;v[E]="[0-9]+";var w=p++;v[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=p++;v[m]="("+v[D]+")\\.("+v[D]+")\\.("+v[D]+")";var d=p++;v[d]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var c=p++;v[c]="(?:"+v[D]+"|"+v[w]+")";var b=p++;v[b]="(?:"+v[E]+"|"+v[w]+")";var u=p++;v[u]="(?:-("+v[c]+"(?:\\."+v[c]+")*))";var g=p++;v[g]="(?:-?("+v[b]+"(?:\\."+v[b]+")*))";var h=p++;v[h]="[0-9A-Za-z-]+";var f=p++;v[f]="(?:\\+("+v[h]+"(?:\\."+v[h]+")*))";var l=p++,t="v?"+v[m]+v[u]+"?"+v[f]+"?";v[l]="^"+t+"$";var r="[v=\\s]*"+v[d]+v[g]+"?"+v[f]+"?",o=p++;v[o]="^"+r+"$";var n=p++;v[n]="((?:<|>)?=?)";var i=p++;v[i]=v[E]+"|x|X|\\*";var a=p++;v[a]=v[D]+"|x|X|\\*";var $=p++;v[$]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[u]+")?"+v[f]+"?)?)?";var A=p++;v[A]="[v=\\s]*("+v[i]+")(?:\\.("+v[i]+")(?:\\.("+v[i]+")(?:"+v[g]+")?"+v[f]+"?)?)?";var R=p++;v[R]="^"+v[n]+"\\s*"+v[$]+"$";var I=p++;v[I]="^"+v[n]+"\\s*"+v[A]+"$";var O=p++;v[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=p++;v[M]="(?:~>?)";var Z=p++;v[Z]="(\\s*)"+v[M]+"\\s+",P[Z]=new RegExp(v[Z],"g");var ee=p++;v[ee]="^"+v[M]+v[$]+"$";var fe=p++;v[fe]="^"+v[M]+v[A]+"$";var ue=p++;v[ue]="(?:\\^)";var j=p++;v[j]="(\\s*)"+v[ue]+"\\s+",P[j]=new RegExp(v[j],"g");var H=p++;v[H]="^"+v[ue]+v[$]+"$";var q=p++;v[q]="^"+v[ue]+v[A]+"$";var J=p++;v[J]="^"+v[n]+"\\s*("+r+")$|^$";var ne=p++;v[ne]="^"+v[n]+"\\s*("+t+")$|^$";var x=p++;v[x]="(\\s*)"+v[n]+"\\s*("+r+"|"+v[$]+")",P[x]=new RegExp(v[x],"g");var G=p++;v[G]="^\\s*("+v[$]+")\\s+-\\s+("+v[$]+")\\s*$";var se=p++;v[se]="^\\s*("+v[A]+")\\s+-\\s+("+v[A]+")\\s*$";var ce=p++;v[ce]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)s(re,v[re]),P[re]||(P[re]=new RegExp(v[re]));function ge($e,Se){if($e instanceof B)return $e;if(typeof $e!="string"||$e.length>S||!(Se?P[o]:P[l]).test($e))return null;try{return new B($e,Se)}catch{return null}}function B($e,Se){if($e instanceof B){if($e.loose===Se)return $e;$e=$e.version}else if(typeof $e!="string")throw new TypeError("Invalid Version: "+$e);if($e.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof B))return new B($e,Se);s("SemVer",$e,Se),this.loose=Se;var De=$e.trim().match(Se?P[o]:P[l]);if(!De)throw new TypeError("Invalid Version: "+$e);if(this.raw=$e,this.major=+De[1],this.minor=+De[2],this.patch=+De[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");De[4]?this.prerelease=De[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Te=+je;if(Te>=0&&Te<k)return Te}return je}):this.prerelease=[],this.build=De[5]?De[5].split("."):[],this.format()}e.parse=ge,e.valid=function($e,Se){var De=ge($e,Se);return De?De.version:null},e.clean=function($e,Se){var De=ge($e.trim().replace(/^[=v]+/,""),Se);return De?De.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function($e){return s("SemVer.compare",this.version,this.loose,$e),$e instanceof B||($e=new B($e,this.loose)),this.compareMain($e)||this.comparePre($e)},B.prototype.compareMain=function($e){return $e instanceof B||($e=new B($e,this.loose)),F(this.major,$e.major)||F(this.minor,$e.minor)||F(this.patch,$e.patch)},B.prototype.comparePre=function($e){if($e instanceof B||($e=new B($e,this.loose)),this.prerelease.length&&!$e.prerelease.length)return-1;if(!this.prerelease.length&&$e.prerelease.length)return 1;if(!this.prerelease.length&&!$e.prerelease.length)return 0;var Se=0;do{var De=this.prerelease[Se],je=$e.prerelease[Se];if(s("prerelease compare",Se,De,je),De===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(De===void 0)return-1;if(De!==je)return F(De,je)}while(++Se)},B.prototype.inc=function($e,Se){switch($e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var De=this.prerelease.length;--De>=0;)typeof this.prerelease[De]=="number"&&(this.prerelease[De]++,De=-2);De===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+$e)}return this.format(),this.raw=this.version,this},e.inc=function($e,Se,De,je){typeof De=="string"&&(je=De,De=void 0);try{return new B($e,De).inc(Se,je).version}catch{return null}},e.diff=function($e,Se){if(K($e,Se))return null;var De=ge($e),je=ge(Se);if(De.prerelease.length||je.prerelease.length){for(var Te in De)if((Te==="major"||Te==="minor"||Te==="patch")&&De[Te]!==je[Te])return"pre"+Te;return"prerelease"}for(var Te in De)if((Te==="major"||Te==="minor"||Te==="patch")&&De[Te]!==je[Te])return Te},e.compareIdentifiers=F;var W=/^[0-9]+$/;function F($e,Se){var De=W.test($e),je=W.test(Se);return De&&je&&($e=+$e,Se=+Se),De&&!je?-1:je&&!De?1:$e<Se?-1:$e>Se?1:0}function z($e,Se,De){return new B($e,De).compare(new B(Se,De))}function _($e,Se,De){return z($e,Se,De)>0}function Q($e,Se,De){return z($e,Se,De)<0}function K($e,Se,De){return z($e,Se,De)===0}function X($e,Se,De){return z($e,Se,De)!==0}function Y($e,Se,De){return z($e,Se,De)>=0}function N($e,Se,De){return z($e,Se,De)<=0}function U($e,Se,De,je){var Te;switch(Se){case"===":typeof $e=="object"&&($e=$e.version),typeof De=="object"&&(De=De.version),Te=$e===De;break;case"!==":typeof $e=="object"&&($e=$e.version),typeof De=="object"&&(De=De.version),Te=$e!==De;break;case"":case"=":case"==":Te=K($e,De,je);break;case"!=":Te=X($e,De,je);break;case">":Te=_($e,De,je);break;case">=":Te=Y($e,De,je);break;case"<":Te=Q($e,De,je);break;case"<=":Te=N($e,De,je);break;default:throw new TypeError("Invalid operator: "+Se)}return Te}function te($e,Se){if($e instanceof te){if($e.loose===Se)return $e;$e=$e.value}if(!(this instanceof te))return new te($e,Se);s("comparator",$e,Se),this.loose=Se,this.parse($e),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function($e,Se){return F(Se,$e)},e.major=function($e,Se){return new B($e,Se).major},e.minor=function($e,Se){return new B($e,Se).minor},e.patch=function($e,Se){return new B($e,Se).patch},e.compare=z,e.compareLoose=function($e,Se){return z($e,Se,!0)},e.rcompare=function($e,Se,De){return z(Se,$e,De)},e.sort=function($e,Se){return $e.sort(function(De,je){return e.compare(De,je,Se)})},e.rsort=function($e,Se){return $e.sort(function(De,je){return e.rcompare(De,je,Se)})},e.gt=_,e.lt=Q,e.eq=K,e.neq=X,e.gte=Y,e.lte=N,e.cmp=U,e.Comparator=te;var ie={};function de($e,Se){if($e instanceof de)return $e.loose===Se?$e:new de($e.raw,Se);if($e instanceof te)return new de($e.value,Se);if(!(this instanceof de))return new de($e,Se);if(this.loose=Se,this.raw=$e,this.set=$e.split(/\s*\|\|\s*/).map(function(De){return this.parseRange(De.trim())},this).filter(function(De){return De.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$e);this.format()}function ae($e){return!$e||$e.toLowerCase()==="x"||$e==="*"}function be($e,Se,De,je,Te,We,ze,Je,_e,xe,nt,Ke,Ze){return((Se=ae(De)?"":ae(je)?">="+De+".0.0":ae(Te)?">="+De+"."+je+".0":">="+Se)+" "+(Je=ae(_e)?"":ae(xe)?"<"+(+_e+1)+".0.0":ae(nt)?"<"+_e+"."+(+xe+1)+".0":Ke?"<="+_e+"."+xe+"."+nt+"-"+Ke:"<="+Je)).trim()}function ye($e,Se){for(var De=0;De<$e.length;De++)if(!$e[De].test(Se))return!1;if(Se.prerelease.length){for(De=0;De<$e.length;De++)if(s($e[De].semver),$e[De].semver!==ie&&$e[De].semver.prerelease.length>0){var je=$e[De].semver;if(je.major===Se.major&&je.minor===Se.minor&&je.patch===Se.patch)return!0}return!1}return!0}function Re($e,Se,De){try{Se=new de(Se,De)}catch{return!1}return Se.test($e)}function Me($e,Se,De,je){var Te,We,ze,Je,_e;switch($e=new B($e,je),Se=new de(Se,je),De){case">":Te=_,We=N,ze=Q,Je=">",_e=">=";break;case"<":Te=Q,We=Y,ze=_,Je="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re($e,Se,je))return!1;for(var xe=0;xe<Se.set.length;++xe){var nt=Se.set[xe],Ke=null,Ze=null;if(nt.forEach(function(me){me.semver===ie&&(me=new te(">=0.0.0")),Ke=Ke||me,Ze=Ze||me,Te(me.semver,Ke.semver,je)?Ke=me:ze(me.semver,Ze.semver,je)&&(Ze=me)}),Ke.operator===Je||Ke.operator===_e||(!Ze.operator||Ze.operator===Je)&&We($e,Ze.semver)||Ze.operator===_e&&ze($e,Ze.semver))return!1}return!0}te.prototype.parse=function($e){var Se=this.loose?P[J]:P[ne],De=$e.match(Se);if(!De)throw new TypeError("Invalid comparator: "+$e);this.operator=De[1],this.operator==="="&&(this.operator=""),De[2]?this.semver=new B(De[2],this.loose):this.semver=ie},te.prototype.toString=function(){return this.value},te.prototype.test=function($e){return s("Comparator.test",$e,this.loose),this.semver===ie||(typeof $e=="string"&&($e=new B($e,this.loose)),U($e,this.operator,this.semver,this.loose))},te.prototype.intersects=function($e,Se){if(!($e instanceof te))throw new TypeError("a Comparator is required");var De;if(this.operator==="")return De=new de($e.value,Se),Re(this.value,De,Se);if($e.operator==="")return De=new de(this.value,Se),Re($e.semver,De,Se);var je=!(this.operator!==">="&&this.operator!==">"||$e.operator!==">="&&$e.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||$e.operator!=="<="&&$e.operator!=="<"),We=this.semver.version===$e.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||$e.operator!==">="&&$e.operator!=="<="),Je=U(this.semver,"<",$e.semver,Se)&&(this.operator===">="||this.operator===">")&&($e.operator==="<="||$e.operator==="<"),_e=U(this.semver,">",$e.semver,Se)&&(this.operator==="<="||this.operator==="<")&&($e.operator===">="||$e.operator===">");return je||Te||We&&ze||Je||_e},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function($e){return $e.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function($e){var Se=this.loose;$e=$e.trim(),s("range",$e,Se);var De=Se?P[se]:P[G];$e=$e.replace(De,be),s("hyphen replace",$e),$e=$e.replace(P[x],"$1$2$3"),s("comparator trim",$e,P[x]),$e=($e=($e=$e.replace(P[Z],"$1~")).replace(P[j],"$1^")).split(/\s+/).join(" ");var je=Se?P[J]:P[ne],Te=$e.split(" ").map(function(We){return function(ze,Je){return s("comp",ze),ze=function(_e,xe){return _e.trim().split(/\s+/).map(function(nt){return function(Ke,Ze){s("caret",Ke,Ze);var me=Ze?P[q]:P[H];return Ke.replace(me,function(Ie,Ae,Oe,Fe,He){var Ve;return s("caret",Ke,Ie,Ae,Oe,Fe,He),ae(Ae)?Ve="":ae(Oe)?Ve=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":ae(Fe)?Ve=Ae==="0"?">="+Ae+"."+Oe+".0 <"+Ae+"."+(+Oe+1)+".0":">="+Ae+"."+Oe+".0 <"+(+Ae+1)+".0.0":He?(s("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ve=Ae==="0"?Oe==="0"?">="+Ae+"."+Oe+"."+Fe+He+" <"+Ae+"."+Oe+"."+(+Fe+1):">="+Ae+"."+Oe+"."+Fe+He+" <"+Ae+"."+(+Oe+1)+".0":">="+Ae+"."+Oe+"."+Fe+He+" <"+(+Ae+1)+".0.0"):(s("no pr"),Ve=Ae==="0"?Oe==="0"?">="+Ae+"."+Oe+"."+Fe+" <"+Ae+"."+Oe+"."+(+Fe+1):">="+Ae+"."+Oe+"."+Fe+" <"+Ae+"."+(+Oe+1)+".0":">="+Ae+"."+Oe+"."+Fe+" <"+(+Ae+1)+".0.0"),s("caret return",Ve),Ve})}(nt,xe)}).join(" ")}(ze,Je),s("caret",ze),ze=function(_e,xe){return _e.trim().split(/\s+/).map(function(nt){return function(Ke,Ze){var me=Ze?P[fe]:P[ee];return Ke.replace(me,function(Ie,Ae,Oe,Fe,He){var Ve;return s("tilde",Ke,Ie,Ae,Oe,Fe,He),ae(Ae)?Ve="":ae(Oe)?Ve=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":ae(Fe)?Ve=">="+Ae+"."+Oe+".0 <"+Ae+"."+(+Oe+1)+".0":He?(s("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ve=">="+Ae+"."+Oe+"."+Fe+He+" <"+Ae+"."+(+Oe+1)+".0"):Ve=">="+Ae+"."+Oe+"."+Fe+" <"+Ae+"."+(+Oe+1)+".0",s("tilde return",Ve),Ve})}(nt,xe)}).join(" ")}(ze,Je),s("tildes",ze),ze=function(_e,xe){return s("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(nt){return function(Ke,Ze){Ke=Ke.trim();var me=Ze?P[I]:P[R];return Ke.replace(me,function(Ie,Ae,Oe,Fe,He,Ve){s("xRange",Ke,Ie,Ae,Oe,Fe,He,Ve);var st=ae(Oe),it=st||ae(Fe),Xe=it||ae(He);return Ae==="="&&Xe&&(Ae=""),st?Ie=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&Xe?(it&&(Fe=0),Xe&&(He=0),Ae===">"?(Ae=">=",it?(Oe=+Oe+1,Fe=0,He=0):Xe&&(Fe=+Fe+1,He=0)):Ae==="<="&&(Ae="<",it?Oe=+Oe+1:Fe=+Fe+1),Ie=Ae+Oe+"."+Fe+"."+He):it?Ie=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Xe&&(Ie=">="+Oe+"."+Fe+".0 <"+Oe+"."+(+Fe+1)+".0"),s("xRange return",Ie),Ie})}(nt,xe)}).join(" ")}(ze,Je),s("xrange",ze),ze=function(_e,xe){return s("replaceStars",_e,xe),_e.trim().replace(P[ce],"")}(ze,Je),s("stars",ze),ze}(We,Se)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(je)})),Te=Te.map(function(We){return new te(We,Se)})},de.prototype.intersects=function($e,Se){if(!($e instanceof de))throw new TypeError("a Range is required");return this.set.some(function(De){return De.every(function(je){return $e.set.some(function(Te){return Te.every(function(We){return je.intersects(We,Se)})})})})},e.toComparators=function($e,Se){return new de($e,Se).set.map(function(De){return De.map(function(je){return je.value}).join(" ").trim().split(" ")})},de.prototype.test=function($e){if(!$e)return!1;typeof $e=="string"&&($e=new B($e,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ye(this.set[Se],$e))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function($e,Se,De){var je=null,Te=null;try{var We=new de(Se,De)}catch{return null}return $e.forEach(function(ze){We.test(ze)&&(je&&Te.compare(ze)!==-1||(Te=new B(je=ze,De)))}),je},e.minSatisfying=function($e,Se,De){var je=null,Te=null;try{var We=new de(Se,De)}catch{return null}return $e.forEach(function(ze){We.test(ze)&&(je&&Te.compare(ze)!==1||(Te=new B(je=ze,De)))}),je},e.validRange=function($e,Se){try{return new de($e,Se).range||"*"}catch{return null}},e.ltr=function($e,Se,De){return Me($e,Se,"<",De)},e.gtr=function($e,Se,De){return Me($e,Se,">",De)},e.outside=Me,e.prerelease=function($e,Se){var De=ge($e,Se);return De&&De.prerelease.length?De.prerelease:null},e.intersects=function($e,Se,De){return $e=new de($e,De),Se=new de(Se,De),$e.intersects(Se)},e.coerce=function($e){if($e instanceof B)return $e;if(typeof $e!="string")return null;var Se=$e.match(P[O]);return Se==null?null:ge((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,y(1))},function(le,e){var y,C,s=le.exports={};function S(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(b){if(y===setTimeout)return setTimeout(b,0);if((y===S||!y)&&setTimeout)return y=setTimeout,setTimeout(b,0);try{return y(b,0)}catch{try{return y.call(null,b,0)}catch{return y.call(this,b,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:S}catch{y=S}try{C=typeof clearTimeout=="function"?clearTimeout:k}catch{C=k}})();var v,p=[],D=!1,E=-1;function w(){D&&v&&(D=!1,v.length?p=v.concat(p):E=-1,p.length&&m())}function m(){if(!D){var b=P(w);D=!0;for(var u=p.length;u;){for(v=p,p=[];++E<u;)v&&v[E].run();E=-1,u=p.length}v=null,D=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===k||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(b)}}function d(b,u){this.fun=b,this.array=u}function c(){}s.nextTick=function(b){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];p.push(new d(b,u)),p.length!==1||D||P(m)},d.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=c,s.addListener=c,s.once=c,s.off=c,s.removeListener=c,s.removeAllListeners=c,s.emit=c,s.prependListener=c,s.prependOnceListener=c,s.listeners=function(b){return[]},s.binding=function(b){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(b){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(Ee[149],ke([1,0]),function(le,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;class C{constructor(P,v,p){this.level=P,this.key=v,this.value=p,this.forward=[]}}const s=void 0;class S{constructor(P,v=2**16){this.comparator=P,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new C(this.c,s,s)}get size(){return this.f}clear(){this.e=new C(this.c,s,s),this.f=0}has(P){return!!S.g(this,P,this.comparator)}get(P){return S.g(this,P,this.comparator)?.value}set(P,v){return S.h(this,P,v,this.comparator)&&(this.f+=1),this}delete(P){const v=S.k(this,P,this.comparator);return v&&(this.f-=1),v}forEach(P,v){let p=this.e.forward[0];for(;p;)P.call(v,p.value,p.key,this),p=p.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",v=this.e.forward[0];for(;v;)P+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return P}static g(P,v,p){let D=P.e;for(let E=P.d-1;E>=0;E--)for(;D.forward[E]&&p(D.forward[E].key,v)<0;)D=D.forward[E];if(D=D.forward[0],D&&p(D.key,v)===0)return D}static h(P,v,p,D){const E=[];let w=P.e;for(let m=P.d-1;m>=0;m--){for(;w.forward[m]&&D(w.forward[m].key,v)<0;)w=w.forward[m];E[m]=w}if(w=w.forward[0],w&&D(w.key,v)===0)return w.value=p,!1;{const m=S.j(P);if(m>P.d){for(let d=P.d;d<m;d++)E[d]=P.e;P.d=m}w=new C(m,v,p);for(let d=0;d<m;d++)w.forward[d]=E[d].forward[d],E[d].forward[d]=w;return!0}}static j(P,v=.5){let p=1;for(;Math.random()<v&&p<P.c;)p+=1;return p}static k(P,v,p){const D=[];let E=P.e;for(let w=P.d-1;w>=0;w--){for(;E.forward[w]&&p(E.forward[w].key,v)<0;)E=E.forward[w];D[w]=E}if(E=E.forward[0],!E||p(E.key,v)!==0)return!1;for(let w=0;w<P.d&&D[w].forward[w]===E;w++)D[w].forward[w]=E.forward[w];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$as=S}),define(Ee[63],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(S){return new C(S)}constructor(S){this.c=y&&S===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1d=C}),define(Ee[6],ke([1,0,8,76,2,98,63]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.Event=void 0;const P=!1,v=!1;var p;(function(R){R.None=()=>s.$Tc.None;function I(N){if(v){const{onDidAddListener:U}=N,te=d.create();let ie=0;N.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),te.print()),U?.()}}}function O(N,U){return ne(N,()=>{},0,void 0,!0,void 0,U)}R.defer=O;function M(N){return(U,te=null,ie)=>{let de=!1,ae;return ae=N(be=>{if(!de)return ae?ae.dispose():de=!0,U.call(te,be)},null,ie),de&&ae.dispose(),ae}}R.once=M;function Z(N,U,te){return q((ie,de=null,ae)=>N(be=>ie.call(de,U(be)),null,ae),te)}R.map=Z;function ee(N,U,te){return q((ie,de=null,ae)=>N(be=>{U(be),ie.call(de,be)},null,ae),te)}R.forEach=ee;function fe(N,U,te){return q((ie,de=null,ae)=>N(be=>U(be)&&ie.call(de,be),null,ae),te)}R.filter=fe;function ue(N){return N}R.signal=ue;function j(...N){return(U,te=null,ie)=>{const de=(0,s.$Qc)(...N.map(ae=>ae(be=>U.call(te,be))));return J(de,ie)}}R.any=j;function H(N,U,te,ie){let de=te;return Z(N,ae=>(de=U(de,ae),de),ie)}R.reduce=H;function q(N,U){let te;const ie={onWillAddFirstListener(){te=N(de.fire,de)},onDidRemoveLastListener(){te?.dispose()}};U||I(ie);const de=new h(ie);return U?.add(de),de.event}function J(N,U){return U instanceof Array?U.push(N):U&&U.add(N),N}function ne(N,U,te=100,ie=!1,de=!1,ae,be){let ye,Re,Me,$e=0,Se;const De={leakWarningThreshold:ae,onWillAddFirstListener(){ye=N(Te=>{$e++,Re=U(Re,Te),ie&&!Me&&(je.fire(Re),Re=void 0),Se=()=>{const We=Re;Re=void 0,Me=void 0,(!ie||$e>1)&&je.fire(We),$e=0},typeof te=="number"?(clearTimeout(Me),Me=setTimeout(Se,te)):Me===void 0&&(Me=0,queueMicrotask(Se))})},onWillRemoveListener(){de&&$e>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,ye.dispose()}};be||I(De);const je=new h(De);return be?.add(je),je.event}R.debounce=ne;function x(N,U=0,te){return R.debounce(N,(ie,de)=>ie?(ie.push(de),ie):[de],U,void 0,!0,void 0,te)}R.accumulate=x;function G(N,U=(ie,de)=>ie===de,te){let ie=!0,de;return fe(N,ae=>{const be=ie||!U(ae,de);return ie=!1,de=ae,be},te)}R.latch=G;function se(N,U,te){return[R.filter(N,U,te),R.filter(N,ie=>!U(ie),te)]}R.split=se;function ce(N,U=!1,te=[],ie){let de=te.slice(),ae=N(Re=>{de?de.push(Re):ye.fire(Re)});ie&&ie.add(ae);const be=()=>{de?.forEach(Re=>ye.fire(Re)),de=null},ye=new h({onWillAddFirstListener(){ae||(ae=N(Re=>ye.fire(Re)),ie&&ie.add(ae))},onDidAddFirstListener(){de&&(U?setTimeout(be):be())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return ie&&ie.add(ye),ye.event}R.buffer=ce;function re(N,U){return(ie,de,ae)=>{const be=U(new B);return N(function(ye){const Re=be.evaluate(ye);Re!==ge&&ie.call(de,Re)},void 0,ae)}}R.chain=re;const ge=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(U){return this.f.push(U),this}forEach(U){return this.f.push(te=>(U(te),te)),this}filter(U){return this.f.push(te=>U(te)?te:ge),this}reduce(U,te){let ie=te;return this.f.push(de=>(ie=U(ie,de),ie)),this}latch(U=(te,ie)=>te===ie){let te=!0,ie;return this.f.push(de=>{const ae=te||!U(de,ie);return te=!1,ie=de,ae?de:ge}),this}evaluate(U){for(const te of this.f)if(U=te(U),U===ge)break;return U}}function W(N,U,te=ie=>ie){const ie=(...ye)=>be.fire(te(...ye)),de=()=>N.on(U,ie),ae=()=>N.removeListener(U,ie),be=new h({onWillAddFirstListener:de,onDidRemoveLastListener:ae});return be.event}R.fromNodeEventEmitter=W;function F(N,U,te=ie=>ie){const ie=(...ye)=>be.fire(te(...ye)),de=()=>N.addEventListener(U,ie),ae=()=>N.removeEventListener(U,ie),be=new h({onWillAddFirstListener:de,onDidRemoveLastListener:ae});return be.event}R.fromDOMEventEmitter=F;function z(N){return new Promise(U=>M(N)(U))}R.toPromise=z;function _(N){const U=new h;return N.then(te=>{U.fire(te)},()=>{U.fire(void 0)}).finally(()=>{U.dispose()}),U.event}R.fromPromise=_;function Q(N,U,te){return U(te),N(ie=>U(ie))}R.runAndSubscribe=Q;class K{constructor(U,te){this._observable=U,this.f=0,this.g=!1;const ie={onWillAddFirstListener:()=>{U.addObserver(this)},onDidRemoveLastListener:()=>{U.removeObserver(this)}};te||I(ie),this.emitter=new h(ie),te&&te.add(this.emitter)}beginUpdate(U){this.f++}handlePossibleChange(U){}handleChange(U,te){this.g=!0}endUpdate(U){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(N,U){return new K(N,U).emitter.event}R.fromObservable=X;function Y(N){return(U,te,ie)=>{let de=0,ae=!1;const be={beginUpdate(){de++},endUpdate(){de--,de===0&&(N.reportChanges(),ae&&(ae=!1,U.call(te)))},handlePossibleChange(){},handleChange(){ae=!0}};N.addObserver(be),N.reportChanges();const ye={dispose(){N.removeObserver(be)}};return ie instanceof s.$Sc?ie.add(ye):Array.isArray(ie)&&ie.push(ye),ye}}R.fromObservableLight=Y})(p||(e.Event=p={}));class D{constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${D.f++}`,D.all.add(this)}start(I){this.g=new k.$1d,this.listenerCount=I}stop(){if(this.g){const I=this.g.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.g=void 0}}}e.$3d=D,D.all=new Set,D.f=0;let E=-1;function w(R){const I=E;return E=R,{dispose(){E=I}}}e.$4d=w;class m{constructor(I,O=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=O,this.g=0}dispose(){this.f?.clear()}check(I,O){const M=this.threshold;if(M<=0||O<M)return;this.f||(this.f=new Map);const Z=this.f.get(I.value)||0;if(this.f.set(I.value,Z+1),this.g-=1,this.g<=0){this.g=M*.5;let ee,fe=0;for(const[ue,j]of this.f)(!ee||fe<j)&&(ee=ue,fe=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${fe}):`),console.warn(ee)}return()=>{const ee=this.f.get(I.value)||0;this.f.set(I.value,ee-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class b{constructor(I){this.value=I,this.id=c++}}const u=2,g=(R,I)=>{if(R instanceof b)I(R);else for(let O=0;O<R.length;O++){const M=R[O];M&&I(M)}};class h{constructor(I){this.w=0,this.f=I,this.g=E>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new D(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const I=this.t;queueMicrotask(()=>{g(I,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(I,O,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;O&&(I=I.bind(O));const Z=new b(I);let ee,fe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Z.stack=d.create(),ee=this.g.check(Z.stack,this.w+1)),P&&(Z.stack=fe??d.create()),this.t?this.t instanceof b?(this.u??(this.u=new l),this.t=[this.t,Z]):this.t.push(Z):(this.f?.onWillAddFirstListener?.(this),this.t=Z,this.f?.onDidAddFirstListener?.(this)),this.w++;const ue=(0,s.$Rc)(()=>{ee?.(),this.x(Z)});return M instanceof s.$Sc?M.add(ue):Array.isArray(M)&&M.push(ue),ue}),this.q}x(I){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,M=O.indexOf(I);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[M]=void 0;const Z=this.u.current===this;if(this.w*u<=O.length){let ee=0;for(let fe=0;fe<O.length;fe++)O[fe]?O[ee++]=O[fe]:Z&&(this.u.end--,ee<this.u.i&&this.u.i--);O.length=ee}}y(I,O){if(!I)return;const M=this.f?.onListenerError||y.$1;if(!M){I.value(O);return}try{I.value(O)}catch(Z){M(Z)}}z(I){const O=I.current.t;for(;I.i<I.end;)this.y(O[I.i++],I.value);I.reset()}fire(I){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,I);else{const O=this.u;O.enqueue(this,I,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}e.$5d=h;const f=()=>new l;e.$6d=f;class l{constructor(){this.i=-1,this.end=0}enqueue(I,O,M){this.i=0,this.end=M,this.current=I,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends h{async fireAsync(I,O,M){if(this.t)for(this.h||(this.h=new S.$4c),g(this.t,Z=>this.h.push([Z.value,I]));this.h.size>0&&!O.isCancellationRequested;){const[Z,ee]=this.h.shift(),fe=[],ue={...ee,token:O,waitUntil:j=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");M&&(j=M(j,Z)),fe.push(j)}};try{Z(ue)}catch(j){(0,y.$1)(j);continue}Object.freeze(fe),await Promise.allSettled(fe).then(j=>{for(const H of j)H.status==="rejected"&&(0,y.$1)(H.reason)})}}}e.$7d=t;class r extends h{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new S.$4c,this.A=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.A(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.w&&(this.h!==0?this.s.push(I):super.fire(I))}}e.$8d=r;class o extends r{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}e.$9d=o;class n extends h{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}e.$0d=n;class i{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(I){const O={event:I,listener:null};this.h.push(O),this.g&&this.m(O);const M=()=>{this.g&&this.o(O);const Z=this.h.indexOf(O);this.h.splice(Z,1)};return(0,s.$Rc)((0,C.$db)(M))}j(){this.g=!0,this.h.forEach(I=>this.m(I))}k(){this.g=!1,this.h.forEach(I=>this.o(I))}m(I){I.listener=I.event(O=>this.f.fire(O))}o(I){I.listener?.dispose(),I.listener=null}dispose(){this.f.dispose();for(const I of this.h)I.listener?.dispose();this.h=[]}}e.$$d=i;class a{constructor(I,O,M,Z){this.f=new s.$Sc;const ee=this.f.add(new i),fe=this.f.add(new s.$3c);function ue(j){fe.set(j,ee.add(Z(j)))}for(const j of I)ue(j);this.f.add(O(j=>{ue(j)})),this.f.add(M(j=>{fe.deleteAndDispose(j)})),this.event=ee.event}dispose(){this.f.dispose()}}e.$_d=a;class ${constructor(){this.f=[]}wrapEvent(I){return(O,M,Z)=>I(ee=>{const fe=this.f[this.f.length-1];fe?fe.push(()=>O.call(M,ee)):O.call(M,ee)},void 0,Z)}bufferEvents(I){const O=[];this.f.push(O);const M=I();return this.f.pop(),O.forEach(Z=>Z()),M}}e.$ae=$;class A{constructor(){this.f=!1,this.g=p.None,this.h=s.$Tc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(I){this.g=I,this.f&&(this.h.dispose(),this.h=I(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$be=A}),define(Ee[20],ke([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.CancellationToken=void 0;const C=Object.freeze(function(P,v){const p=setTimeout(P.bind(v),0);return{dispose(){clearTimeout(p)}}});var s;(function(P){function v(p){return p===P.None||p===P.Cancelled||p instanceof S?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}P.isCancellationToken=v,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(s||(e.CancellationToken=s={}));class S{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new y.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(v){this.f=void 0,this.g=void 0,this.g=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new S),this.f}cancel(){this.f?this.f instanceof S&&this.f.cancel():this.f=s.Cancelled}dispose(v=!1){v&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof S&&this.f.dispose():this.f=s.None}}e.$ce=k}),define(Ee[150],ke([1,0,20]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=void 0;class C{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new y.$ce,v=this.b(P.token);return this.a={promise:v,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Ne=C;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const v=JSON.stringify(P);return this.b!==v&&(this.b=v,this.a=this.c(P)),this.a}}e.$Oe=s;class S{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const v=this.b(P);return this.a.set(P,v),v}}e.$Pe=S}),define(Ee[50],ke([1,0,8,2]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function s(f){const l=f;return l?typeof l.read=="function":!1}e.$de=s;function S(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.$ee=S;function k(f){const l=f;return l?S(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$fe=k;function P(f,l){return new v(f,l)}e.$ge=P;class v{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,y.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let r;switch(l){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const o=r.indexOf(t);o>=0&&r.splice(o,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(f,l){const t=[];let r;for(;(r=f.read())!==null;)t.push(r);return l(t)}e.$he=p;function D(f,l,t){const r=[];let o;for(;(o=f.read())!==null&&r.length<t;)r.push(o);return o===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof o<"u"){const n=o;return o=void 0,n}return f.read()}}}e.$ie=D;function E(f,l){return new Promise((t,r)=>{const o=[];w(f,{onData:n=>{l&&o.push(n)},onError:n=>{l?r(n):t(void 0)},onEnd:()=>{t(l?l(o):void 0)}})})}e.$je=E;function w(f,l,t){f.on("error",r=>{t?.isCancellationRequested||l.onError(r)}),f.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),f.on("data",r=>{t?.isCancellationRequested||l.onData(r)})}e.$ke=w;function m(f,l){return new Promise((t,r)=>{const o=new C.$Sc,n=[],i=A=>{if(n.push(A),n.length>l)return o.dispose(),f.pause(),t({stream:f,buffer:n,ended:!1})},a=A=>(o.dispose(),r(A)),$=()=>(o.dispose(),t({stream:f,buffer:n,ended:!0}));o.add((0,C.$Rc)(()=>f.removeListener("error",a))),f.on("error",a),o.add((0,C.$Rc)(()=>f.removeListener("end",$))),f.on("end",$),o.add((0,C.$Rc)(()=>f.removeListener("data",i))),f.on("data",i)})}e.$le=m;function d(f,l){const t=P(l);return t.end(f),t}e.$me=d;function c(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.$ne=c;function b(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.$oe=b;function u(f,l,t){const r=P(t);return w(f,{onData:o=>r.write(l.data(o)),onError:o=>r.error(l.error?l.error(o):o),onEnd:()=>r.end()}),r}e.$pe=u;function g(f,l,t){let r=!1;return{read:()=>{const o=l.read();return r?o:(r=!0,o!==null?t([f,o]):f)}}}e.$qe=g;function h(f,l,t){let r=!1;const o=P(t);return w(l,{onData:n=>r?o.write(n):(r=!0,o.write(t([f,n]))),onError:n=>o.error(n),onEnd:()=>{r||(r=!0,o.write(f)),o.end()}}),o}e.$re=h}),define(Ee[14],ke([1,0,60,50]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const s=typeof Buffer<"u",S=new y.$V(()=>new Uint8Array(256));let k,P;class v{static alloc(O){return s?new v(Buffer.allocUnsafe(O)):new v(new Uint8Array(O))}static wrap(O){return s&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new v(O)}static fromString(O,M){return!(M?.dontUseNodeBuffer||!1)&&s?new v(Buffer.from(O)):(k||(k=new TextEncoder),new v(k.encode(O)))}static fromByteArray(O){const M=v.alloc(O.length);for(let Z=0,ee=O.length;Z<ee;Z++)M.buffer[Z]=O[Z];return M}static concat(O,M){if(typeof M>"u"){M=0;for(let fe=0,ue=O.length;fe<ue;fe++)M+=O[fe].byteLength}const Z=v.alloc(M);let ee=0;for(let fe=0,ue=O.length;fe<ue;fe++){const j=O[fe];Z.set(j,ee),ee+=j.byteLength}return Z}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=v.alloc(this.byteLength);return O.set(this),O}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(O,M){return new v(this.buffer.subarray(O,M))}set(O,M){if(O instanceof v)this.buffer.set(O.buffer,M);else if(O instanceof Uint8Array)this.buffer.set(O,M);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),M);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return w(this.buffer,O)}writeUInt32BE(O,M){m(this.buffer,O,M)}readUInt32LE(O){return d(this.buffer,O)}writeUInt32LE(O,M){c(this.buffer,O,M)}readUInt8(O){return b(this.buffer,O)}writeUInt8(O,M){u(this.buffer,O,M)}indexOf(O,M=0){return p(this.buffer,O instanceof v?O.buffer:O,M)}}e.$se=v;function p(I,O,M=0){const Z=O.byteLength,ee=I.byteLength;if(Z===0)return 0;if(Z===1)return I.indexOf(O[0]);if(Z>ee-M)return-1;const fe=S.value;fe.fill(O.length);for(let q=0;q<O.length;q++)fe[O[q]]=O.length-q-1;let ue=M+O.length-1,j=ue,H=-1;for(;ue<ee;)if(I[ue]===O[j]){if(j===0){H=ue;break}ue--,j--}else ue+=Math.max(O.length-j,fe[I[ue]]),j=O.length-1;return H}e.$te=p;function D(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}e.$ue=D;function E(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255}e.$ve=E;function w(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}e.$we=w;function m(I,O,M){I[M+3]=O,O=O>>>8,I[M+2]=O,O=O>>>8,I[M+1]=O,O=O>>>8,I[M]=O}e.$xe=m;function d(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}e.$ye=d;function c(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255,O=O>>>8,I[M+2]=O&255,O=O>>>8,I[M+3]=O&255}e.$ze=c;function b(I,O){return I[O]}e.$Ae=b;function u(I,O,M){I[M]=O}e.$Be=u;function g(I){return C.$he(I,O=>v.concat(O))}e.$Ce=g;function h(I){return C.$oe(I)}e.$De=h;function f(I){return C.$je(I,O=>v.concat(O))}e.$Ee=f;async function l(I){return I.ended?v.concat(I.buffer):v.concat([...I.buffer,await f(I.stream)])}e.$Fe=l;function t(I){return C.$me(I,O=>v.concat(O))}e.$Ge=t;function r(I){return C.$pe(I,{data:O=>typeof O=="string"?v.fromString(O):v.wrap(O)},O=>v.concat(O))}e.$He=r;function o(I){return C.$ge(O=>v.concat(O),I)}e.$Ie=o;function n(I,O){return C.$qe(I,O,M=>v.concat(M))}e.$Je=n;function i(I,O){return C.$re(I,O,M=>v.concat(M))}e.$Ke=i;function a(I){let O=0,M=0,Z=0;const ee=new Uint8Array(Math.floor(I.length/4*3)),fe=j=>{switch(M){case 3:ee[Z++]=O|j,M=0;break;case 2:ee[Z++]=O|j>>>2,O=j<<6,M=3;break;case 1:ee[Z++]=O|j>>>4,O=j<<4,M=2;break;default:O=j<<2,M=1}};for(let j=0;j<I.length;j++){const H=I.charCodeAt(j);if(H>=65&&H<=90)fe(H-65);else if(H>=97&&H<=122)fe(H-97+26);else if(H>=48&&H<=57)fe(H-48+52);else if(H===43||H===45)fe(62);else if(H===47||H===95)fe(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${I[j]}`)}}const ue=Z;for(;M>0;)fe(0);return v.wrap(ee).slice(0,ue)}e.$Le=a;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:I},O=!0,M=!1){const Z=M?A:$;let ee="";const fe=I.byteLength%3;let ue=0;for(;ue<I.byteLength-fe;ue+=3){const j=I[ue+0],H=I[ue+1],q=I[ue+2];ee+=Z[j>>>2],ee+=Z[(j<<4|H>>>4)&63],ee+=Z[(H<<2|q>>>6)&63],ee+=Z[q&63]}if(fe===1){const j=I[ue+0];ee+=Z[j>>>2],ee+=Z[j<<4&63],O&&(ee+="==")}else if(fe===2){const j=I[ue+0],H=I[ue+1];ee+=Z[j>>>2],ee+=Z[(j<<4|H>>>4)&63],ee+=Z[H<<2&63],O&&(ee+="=")}return ee}e.$Me=R}),define(Ee[17],ke([1,0,150,60]),function(le,e,y,C){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rf=e.$Qf=e.$Pf=e.$Of=e.GraphemeBreakType=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=void 0;function S(me){return!me||typeof me!="string"?!0:me.trim().length===0}e.$Se=S;const k=/{(\d+)}/g;function P(me,...Ie){return Ie.length===0?me:me.replace(k,function(Ae,Oe){const Fe=parseInt(Oe,10);return isNaN(Fe)||Fe<0||Fe>=Ie.length?Ae:Ie[Fe]})}e.$Te=P;const v=/{([^}]+)}/g;function p(me,Ie){return Object.keys(Ie).length===0?me:me.replace(v,(Ae,Oe)=>Ie[Oe]??Ae)}e.$Ue=p;function D(me){return me.replace(/[<>"'&]/g,Ie=>{switch(Ie){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ie})}e.$Ve=D;function E(me){return me.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.$We=E;function w(me){return me.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Xe=w;function m(me,Ie){let Ae=0;const Oe=Ie.charCodeAt(0);for(let Fe=me.length-1;Fe>=0;Fe--)me.charCodeAt(Fe)===Oe&&Ae++;return Ae}e.$Ye=m;function d(me,Ie,Ae="\u2026"){return me.length<=Ie?me:`${me.substr(0,Ie)}${Ae}`}e.$Ze=d;function c(me,Ie,Ae="\u2026"){if(me.length<=Ie)return me;const Oe=Math.ceil(Ie/2)-Ae.length/2,Fe=Math.floor(Ie/2)-Ae.length/2;return`${me.substr(0,Oe)}${Ae}${me.substr(me.length-Fe)}`}e.$1e=c;function b(me,Ie=" "){const Ae=u(me,Ie);return g(Ae,Ie)}e.$2e=b;function u(me,Ie){if(!me||!Ie)return me;const Ae=Ie.length;if(Ae===0||me.length===0)return me;let Oe=0;for(;me.indexOf(Ie,Oe)===Oe;)Oe=Oe+Ae;return me.substring(Oe)}e.$3e=u;function g(me,Ie){if(!me||!Ie)return me;const Ae=Ie.length,Oe=me.length;if(Ae===0||Oe===0)return me;let Fe=Oe,He=-1;for(;He=me.lastIndexOf(Ie,Fe-1),!(He===-1||He+Ae!==Fe);){if(He===0)return"";Fe=He}return me.substring(0,Fe)}e.$4e=g;function h(me){return me.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$5e=h;function f(me){return me.replace(/\*/g,"")}e.$6e=f;function l(me,Ie,Ae={}){if(!me)throw new Error("Cannot create regex from empty string");Ie||(me=w(me)),Ae.wholeWord&&(/\B/.test(me.charAt(0))||(me="\\b"+me),/\B/.test(me.charAt(me.length-1))||(me=me+"\\b"));let Oe="";return Ae.global&&(Oe+="g"),Ae.matchCase||(Oe+="i"),Ae.multiline&&(Oe+="m"),Ae.unicode&&(Oe+="u"),new RegExp(me,Oe)}e.$7e=l;function t(me){return me.source==="^"||me.source==="^$"||me.source==="$"||me.source==="^\\s*$"?!1:!!(me.exec("")&&me.lastIndex===0)}e.$8e=t;function r(me){return me.split(/\r\n|\r|\n/)}e.$9e=r;function o(me){const Ie=[],Ae=me.split(/(\r\n|\r|\n)/);for(let Oe=0;Oe<Math.ceil(Ae.length/2);Oe++)Ie.push(Ae[2*Oe]+(Ae[2*Oe+1]??""));return Ie}e.$0e=o;function n(me){for(let Ie=0,Ae=me.length;Ie<Ae;Ie++){const Oe=me.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return Ie}return-1}e.$$e=n;function i(me,Ie=0,Ae=me.length){for(let Oe=Ie;Oe<Ae;Oe++){const Fe=me.charCodeAt(Oe);if(Fe!==32&&Fe!==9)return me.substring(Ie,Oe)}return me.substring(Ie,Ae)}e.$_e=i;function a(me,Ie=me.length-1){for(let Ae=Ie;Ae>=0;Ae--){const Oe=me.charCodeAt(Ae);if(Oe!==32&&Oe!==9)return Ae}return-1}e.$af=a;function $(me,Ie,Ae){const Oe=[];let Fe=0;for(const He of me.matchAll(Ie)){if(Oe.push(me.slice(Fe,He.index)),He.index===void 0)throw new Error("match.index should be defined");Fe=He.index+He[0].length,Oe.push(Ae(He[0],...He.slice(1),He.index,me,He.groups))}return Oe.push(me.slice(Fe)),Promise.all(Oe).then(He=>He.join(""))}e.$bf=$;function A(me,Ie){return me<Ie?-1:me>Ie?1:0}e.$cf=A;function R(me,Ie,Ae=0,Oe=me.length,Fe=0,He=Ie.length){for(;Ae<Oe&&Fe<He;Ae++,Fe++){const it=me.charCodeAt(Ae),Xe=Ie.charCodeAt(Fe);if(it<Xe)return-1;if(it>Xe)return 1}const Ve=Oe-Ae,st=He-Fe;return Ve<st?-1:Ve>st?1:0}e.$df=R;function I(me,Ie){return O(me,Ie,0,me.length,0,Ie.length)}e.$ef=I;function O(me,Ie,Ae=0,Oe=me.length,Fe=0,He=Ie.length){for(;Ae<Oe&&Fe<He;Ae++,Fe++){let it=me.charCodeAt(Ae),Xe=Ie.charCodeAt(Fe);if(it===Xe)continue;if(it>=128||Xe>=128)return R(me.toLowerCase(),Ie.toLowerCase(),Ae,Oe,Fe,He);Z(it)&&(it-=32),Z(Xe)&&(Xe-=32);const ct=it-Xe;if(ct!==0)return ct}const Ve=Oe-Ae,st=He-Fe;return Ve<st?-1:Ve>st?1:0}e.$ff=O;function M(me){return me>=48&&me<=57}e.$gf=M;function Z(me){return me>=97&&me<=122}e.$hf=Z;function ee(me){return me>=65&&me<=90}e.$if=ee;function fe(me,Ie){return me.length===Ie.length&&O(me,Ie)===0}e.$jf=fe;function ue(me,Ie){const Ae=Ie.length;return Ie.length>me.length?!1:O(me,Ie,0,Ae)===0}e.$kf=ue;function j(me,Ie){const Ae=Math.min(me.length,Ie.length);let Oe;for(Oe=0;Oe<Ae;Oe++)if(me.charCodeAt(Oe)!==Ie.charCodeAt(Oe))return Oe;return Ae}e.$lf=j;function H(me,Ie){const Ae=Math.min(me.length,Ie.length);let Oe;const Fe=me.length-1,He=Ie.length-1;for(Oe=0;Oe<Ae;Oe++)if(me.charCodeAt(Fe-Oe)!==Ie.charCodeAt(He-Oe))return Oe;return Ae}e.$mf=H;function q(me){return 55296<=me&&me<=56319}e.$nf=q;function J(me){return 56320<=me&&me<=57343}e.$of=J;function ne(me,Ie){return(me-55296<<10)+(Ie-56320)+65536}e.$pf=ne;function x(me,Ie,Ae){const Oe=me.charCodeAt(Ae);if(q(Oe)&&Ae+1<Ie){const Fe=me.charCodeAt(Ae+1);if(J(Fe))return ne(Oe,Fe)}return Oe}e.$qf=x;function G(me,Ie){const Ae=me.charCodeAt(Ie-1);if(J(Ae)&&Ie>1){const Oe=me.charCodeAt(Ie-2);if(q(Oe))return ne(Oe,Ae)}return Ae}class se{get offset(){return this.e}constructor(Ie,Ae=0){this.c=Ie,this.d=Ie.length,this.e=Ae}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=G(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=x(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.$rf=se;class ce{get offset(){return this.c.offset}constructor(Ie,Ae=0){this.c=new se(Ie,Ae)}nextGraphemeLength(){const Ie=We.getInstance(),Ae=this.c,Oe=Ae.offset;let Fe=Ie.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const He=Ae.offset,Ve=Ie.getGraphemeBreakType(Ae.nextCodePoint());if(je(Fe,Ve)){Ae.setOffset(He);break}Fe=Ve}return Ae.offset-Oe}prevGraphemeLength(){const Ie=We.getInstance(),Ae=this.c,Oe=Ae.offset;let Fe=Ie.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const He=Ae.offset,Ve=Ie.getGraphemeBreakType(Ae.prevCodePoint());if(je(Ve,Fe)){Ae.setOffset(He);break}Fe=Ve}return Oe-Ae.offset}eol(){return this.c.eol()}}e.$sf=ce;function re(me,Ie){return new ce(me,Ie).nextGraphemeLength()}e.$tf=re;function ge(me,Ie){return new ce(me,Ie).prevGraphemeLength()}e.$uf=ge;function B(me,Ie){Ie>0&&J(me.charCodeAt(Ie))&&Ie--;const Ae=Ie+re(me,Ie);return[Ae-ge(me,Ae),Ae]}e.$vf=B;function W(me){const Ie=new ce(me);let Ae=0;for(;!Ie.eol();)Ae++,Ie.nextGraphemeLength();return Ae}e.$wf=W;let F;function z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(me){return F||(F=z()),F.test(me)}e.$xf=_;const Q=/^[\t\n\r\x20-\x7E]*$/;function K(me){return Q.test(me)}e.$yf=K,e.$zf=/[\u2028\u2029]/;function X(me){return e.$zf.test(me)}e.$Af=X;function Y(me){return me>=11904&&me<=55215||me>=63744&&me<=64255||me>=65281&&me<=65374}e.$Bf=Y;function N(me){return me>=127462&&me<=127487||me===8986||me===8987||me===9200||me===9203||me>=9728&&me<=10175||me===11088||me===11093||me>=127744&&me<=128591||me>=128640&&me<=128764||me>=128992&&me<=129008||me>=129280&&me<=129535||me>=129648&&me<=129782}e.$Cf=N;function U(me,Ie,Ae=""){const Oe=me.trimStart();if(Oe.length<Ie)return Oe;const Fe=/\b/g;let He=0;for(;Fe.test(Oe)&&!(Oe.length-Fe.lastIndex<Ie);)He=Fe.lastIndex,Fe.lastIndex+=1;return He===0?Oe:Ae+Oe.substring(He).trimStart()}e.$Df=U;const te=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function de(me){return me&&(me=me.replace(te,"").replace(ie,"")),me}e.$Ef=de,e.$Ff="\uFEFF";function ae(me){return!!(me&&me.length>0&&me.charCodeAt(0)===65279)}e.$Gf=ae;function be(me){return ae(me)?me.substr(1):me}e.$Hf=be;function ye(me,Ie){if(!me||!Ie||me.length<Ie.length)return!1;const Ae=Ie.length,Oe=me.toLowerCase();let Fe=0,He=-1;for(;Fe<Ae;){const Ve=Oe.indexOf(Ie[Fe],He+1);if(Ve<0)return!1;He=Ve,Fe++}return!0}e.$If=ye;function Re(me,Ie=!1){return me?(Ie&&(me=me.replace(/\\./g,"")),me.toLowerCase()!==me):!1}e.$Jf=Re;function Me(me){return me.charAt(0).toUpperCase()+me.slice(1)}e.$Kf=Me;function $e(me,Ie=1){if(Ie===0)return"";let Ae=-1;do Ae=me.indexOf(`
`,Ae+1),Ie--;while(Ie>0&&Ae>=0);return Ae===-1?me:(me[Ae-1]==="\r"&&Ae--,me.substr(0,Ae))}e.$Lf=$e;function Se(me){return me=me%(2*26),me<26?String.fromCharCode(97+me):String.fromCharCode(65+me-26)}e.$Mf=Se;function De(me){return We.getInstance().getGraphemeBreakType(me)}e.$Nf=De;function je(me,Ie){return me===0?Ie!==5&&Ie!==7:me===2&&Ie===3?!1:me===4||me===2||me===3||Ie===4||Ie===2||Ie===3?!0:!(me===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(me===11||me===9)&&(Ie===9||Ie===10)||(me===12||me===10)&&Ie===10||Ie===5||Ie===13||Ie===7||me===1||me===13&&Ie===14||me===6&&Ie===6)}var Te;(function(me){me[me.Other=0]="Other",me[me.Prepend=1]="Prepend",me[me.CR=2]="CR",me[me.LF=3]="LF",me[me.Control=4]="Control",me[me.Extend=5]="Extend",me[me.Regional_Indicator=6]="Regional_Indicator",me[me.SpacingMark=7]="SpacingMark",me[me.L=8]="L",me[me.V=9]="V",me[me.T=10]="T",me[me.LV=11]="LV",me[me.LVT=12]="LVT",me[me.ZWJ=13]="ZWJ",me[me.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(e.GraphemeBreakType=Te={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=ze()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ae=this.d,Oe=Ae.length/3;let Fe=1;for(;Fe<=Oe;)if(Ie<Ae[3*Fe])Fe=2*Fe;else if(Ie>Ae[3*Fe+1])Fe=2*Fe+1;else return Ae[3*Fe+2];return 0}}We.c=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(me,Ie){if(me===0)return 0;const Ae=_e(me,Ie);if(Ae!==void 0)return Ae;const Oe=new se(Ie,me);return Oe.prevCodePoint(),Oe.offset}e.$Of=Je;function _e(me,Ie){const Ae=new se(Ie,me);let Oe=Ae.prevCodePoint();for(;xe(Oe)||Oe===65039||Oe===8419;){if(Ae.offset===0)return;Oe=Ae.prevCodePoint()}if(!N(Oe))return;let Fe=Ae.offset;return Fe>0&&Ae.prevCodePoint()===8205&&(Fe=Ae.offset),Fe}function xe(me){return 127995<=me&&me<=127999}var nt;(function(me){me[me.zwj=8205]="zwj",me[me.emojiVariantSelector=65039]="emojiVariantSelector",me[me.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Pf="\xA0";class Ke{static getInstance(Ie){return s.d.get(Array.from(Ie))}static getLocales(){return s.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Qf=Ke,s=Ke,Ke.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ke.d=new y.$Oe(me=>{function Ie(Xe){const ct=new Map;for(let at=0;at<Xe.length;at+=2)ct.set(Xe[at],Xe[at+1]);return ct}function Ae(Xe,ct){const at=new Map(Xe);for(const[ft,lt]of ct)at.set(ft,lt);return at}function Oe(Xe,ct){if(!Xe)return ct;const at=new Map;for(const[ft,lt]of Xe)ct.has(ft)&&at.set(ft,lt);return at}const Fe=s.c.value;let He=me.filter(Xe=>!Xe.startsWith("_")&&Xe in Fe);He.length===0&&(He=["_default"]);let Ve;for(const Xe of He){const ct=Ie(Fe[Xe]);Ve=Oe(Ve,ct)}const st=Ie(Fe._common),it=Ae(st,Ve);return new s(it)}),Ke.e=new C.$V(()=>Object.keys(s.c.value).filter(me=>!me.startsWith("_")));class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(Ie){return Ze.e().has(Ie)}static get codePoints(){return Ze.e()}}e.$Rf=Ze,Ze.d=void 0}),define(Ee[151],ke([1,0,24,147,17]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.FuzzyScore=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.or=void 0;function S(...ae){return function(be,ye){for(let Re=0,Me=ae.length;Re<Me;Re++){const $e=ae[Re](be,ye);if($e)return $e}return null}}e.or=S,e.$5j=k.bind(void 0,!1),e.$6j=k.bind(void 0,!0);function k(ae,be,ye){if(!ye||ye.length<be.length)return null;let Re;return ae?Re=s.$kf(ye,be):Re=ye.indexOf(be)===0,Re?be.length>0?[{start:0,end:be.length}]:[]:null}function P(ae,be){const ye=be.toLowerCase().indexOf(ae.toLowerCase());return ye===-1?null:[{start:ye,end:ye+ae.length}]}e.$7j=P;function v(ae,be){return p(ae.toLowerCase(),be.toLowerCase(),0,0)}e.$8j=v;function p(ae,be,ye,Re){if(ye===ae.length)return[];if(Re===be.length)return null;if(ae[ye]===be[Re]){let Me=null;return(Me=p(ae,be,ye+1,Re+1))?f({start:Re,end:Re+1},Me):null}return p(ae,be,ye,Re+1)}function D(ae){return 97<=ae&&ae<=122}function E(ae){return 65<=ae&&ae<=90}e.$9j=E;function w(ae){return 48<=ae&&ae<=57}function m(ae){return ae===32||ae===9||ae===10||ae===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ae=>d.add(ae.charCodeAt(0)));function c(ae){return m(ae)||d.has(ae)}function b(ae,be){return ae===be||c(ae)&&c(be)}const u=new Map;function g(ae){if(u.has(ae))return u.get(ae);let be;const ye=(0,C.$3j)(ae);return ye&&(be=ye),u.set(ae,be),be}function h(ae){return D(ae)||E(ae)||w(ae)}function f(ae,be){return be.length===0?be=[ae]:ae.end===be[0].start?be[0].start=ae.start:be.unshift(ae),be}function l(ae,be){for(let ye=be;ye<ae.length;ye++){const Re=ae.charCodeAt(ye);if(E(Re)||w(Re)||ye>0&&!h(ae.charCodeAt(ye-1)))return ye}return ae.length}function t(ae,be,ye,Re){if(ye===ae.length)return[];if(Re===be.length)return null;if(ae[ye]!==be[Re].toLowerCase())return null;{let Me=null,$e=Re+1;for(Me=t(ae,be,ye+1,Re+1);!Me&&($e=l(be,$e))<be.length;)Me=t(ae,be,ye+1,$e),$e++;return Me===null?null:f({start:Re,end:Re+1},Me)}}function r(ae){let be=0,ye=0,Re=0,Me=0,$e=0;for(let We=0;We<ae.length;We++)$e=ae.charCodeAt(We),E($e)&&be++,D($e)&&ye++,h($e)&&Re++,w($e)&&Me++;const Se=be/ae.length,De=ye/ae.length,je=Re/ae.length,Te=Me/ae.length;return{upperPercent:Se,lowerPercent:De,alphaPercent:je,numericPercent:Te}}function o(ae){const{upperPercent:be,lowerPercent:ye}=ae;return ye===0&&be>.6}function n(ae){const{upperPercent:be,lowerPercent:ye,alphaPercent:Re,numericPercent:Me}=ae;return ye>.2&&be<.8&&Re>.6&&Me<.2}function i(ae){let be=0,ye=0,Re=0,Me=0;for(let $e=0;$e<ae.length;$e++)Re=ae.charCodeAt($e),E(Re)&&be++,D(Re)&&ye++,m(Re)&&Me++;return(be===0||ye===0)&&Me===0?ae.length<=30:be<=5}function a(ae,be){if(!be||(be=be.trim(),be.length===0)||!i(ae))return null;be.length>60&&(be=be.substring(0,60));const ye=r(be);if(!n(ye)){if(!o(ye))return null;be=be.toLowerCase()}let Re=null,Me=0;for(ae=ae.toLowerCase();Me<be.length&&(Re=t(ae,be,0,Me))===null;)Me=l(be,Me+1);return Re}e.$0j=a;function $(ae,be,ye=!1){if(!be||be.length===0)return null;let Re=null,Me=0;for(ae=ae.toLowerCase(),be=be.toLowerCase();Me<be.length&&(Re=A(ae,be,0,Me,ye),Re===null);)Me=R(be,Me+1);return Re}e.$$j=$;function A(ae,be,ye,Re,Me){let $e=0;if(ye===ae.length)return[];if(Re===be.length)return null;if(!b(ae.charCodeAt(ye),be.charCodeAt(Re))){const je=g(ae.charCodeAt(ye));if(!je)return null;for(let Te=0;Te<je.length;Te++)if(!b(je[Te],be.charCodeAt(Re+Te)))return null;$e+=je.length-1}let Se=null,De=Re+$e+1;if(Se=A(ae,be,ye+1,De,Me),!Me)for(;!Se&&(De=R(be,De))<be.length;)Se=A(ae,be,ye+1,De,Me),De++;if(!Se)return null;if(ae.charCodeAt(ye)!==be.charCodeAt(Re)){const je=g(ae.charCodeAt(ye));if(!je)return Se;for(let Te=0;Te<je.length;Te++)if(je[Te]!==be.charCodeAt(Re+Te))return Se}return f({start:Re,end:Re+$e+1},Se)}function R(ae,be){for(let ye=be;ye<ae.length;ye++)if(c(ae.charCodeAt(ye))||ye>0&&c(ae.charCodeAt(ye-1)))return ye;return ae.length}const I=S(e.$6j,a,P),O=S(e.$6j,a,v),M=new y.$Dc(1e4);function Z(ae,be,ye=!1){if(typeof ae!="string"||typeof be!="string")return null;let Re=M.get(ae);Re||(Re=new RegExp(s.$5e(ae),"i"),M.set(ae,Re));const Me=Re.exec(be);return Me?[{start:Me.index,end:Me.index+Me[0].length}]:ye?O(ae,be):I(ae,be)}e.$_j=Z;function ee(ae,be){const ye=X(ae,ae.toLowerCase(),0,be,be.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ye?ue(ye):null}e.$ak=ee;function fe(ae,be,ye,Re,Me,$e){const Se=Math.min(13,ae.length);for(;ye<Se;ye++){const De=X(ae,be,ye,Re,Me,$e,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,$e]}e.$bk=fe;function ue(ae){if(typeof ae>"u")return[];const be=[],ye=ae[1];for(let Re=ae.length-1;Re>1;Re--){const Me=ae[Re]+ye,$e=be[be.length-1];$e&&$e.end===Me?$e.end=Me+1:be.push({start:Me,end:Me+1})}return be}e.$ck=ue;const j=128;function H(){const ae=[],be=[];for(let ye=0;ye<=j;ye++)be[ye]=0;for(let ye=0;ye<=j;ye++)ae.push(be.slice(0));return ae}function q(ae){const be=[];for(let ye=0;ye<=ae;ye++)be[ye]=0;return be}const J=q(2*j),ne=q(2*j),x=H(),G=H(),se=H(),ce=!1;function re(ae,be,ye,Re,Me){function $e(De,je,Te=" "){for(;De.length<je;)De=Te+De;return De}let Se=` |   |${Re.split("").map(De=>$e(De,3)).join("|")}
`;for(let De=0;De<=ye;De++)De===0?Se+=" |":Se+=`${be[De-1]}|`,Se+=ae[De].slice(0,Me+1).map(je=>$e(je.toString(),3)).join("|")+`
`;return Se}function ge(ae,be,ye,Re){ae=ae.substr(be),ye=ye.substr(Re),console.log(re(G,ae,ae.length,ye,ye.length)),console.log(re(se,ae,ae.length,ye,ye.length)),console.log(re(x,ae,ae.length,ye,ye.length))}function B(ae,be){if(be<0||be>=ae.length)return!1;const ye=ae.codePointAt(be);switch(ye){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!s.$Cf(ye)}}function W(ae,be){if(be<0||be>=ae.length)return!1;switch(ae.charCodeAt(be)){case 32:case 9:return!0;default:return!1}}function F(ae,be,ye){return be[ae]!==ye[ae]}function z(ae,be,ye,Re,Me,$e,Se=!1){for(;be<ye&&Me<$e;)ae[be]===Re[Me]&&(Se&&(J[be]=Me),be+=1),Me+=1;return be===ye}e.$dk=z;var _;(function(ae){ae[ae.Diag=1]="Diag",ae[ae.Left=2]="Left",ae[ae.LeftLeft=3]="LeftLeft"})(_||(_={}));var Q;(function(ae){ae.Default=[-100,0];function be(ye){return!ye||ye.length===2&&ye[0]===-100&&ye[1]===0}ae.isDefault=be})(Q||(e.FuzzyScore=Q={}));class K{constructor(be,ye){this.firstMatchCanBeWeak=be,this.boostFullMatch=ye}}e.$ek=K,K.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function X(ae,be,ye,Re,Me,$e,Se=K.default){const De=ae.length>j?j:ae.length,je=Re.length>j?j:Re.length;if(ye>=De||$e>=je||De-ye>je-$e||!z(be,ye,De,Me,$e,je,!0))return;Y(De,je,ye,$e,be,Me);let Te=1,We=1,ze=ye,Je=$e;const _e=[!1];for(Te=1,ze=ye;ze<De;Te++,ze++){const me=J[ze],Ie=ne[ze],Ae=ze+1<De?ne[ze+1]:je;for(We=me-$e+1,Je=me;Je<Ae;We++,Je++){let Oe=Number.MIN_SAFE_INTEGER,Fe=!1;Je<=Ie&&(Oe=N(ae,be,ze,ye,Re,Me,Je,je,$e,x[Te-1][We-1]===0,_e));let He=0;Oe!==Number.MAX_SAFE_INTEGER&&(Fe=!0,He=Oe+G[Te-1][We-1]);const Ve=Je>me,st=Ve?G[Te][We-1]+(x[Te][We-1]>0?-5:0):0,it=Je>me+1&&x[Te][We-1]>0,Xe=it?G[Te][We-2]+(x[Te][We-2]>0?-5:0):0;if(it&&(!Ve||Xe>=st)&&(!Fe||Xe>=He))G[Te][We]=Xe,se[Te][We]=3,x[Te][We]=0;else if(Ve&&(!Fe||st>=He))G[Te][We]=st,se[Te][We]=2,x[Te][We]=0;else if(Fe)G[Te][We]=He,se[Te][We]=1,x[Te][We]=x[Te-1][We-1]+1;else throw new Error("not possible")}}if(ce&&ge(ae,ye,Re,$e),!_e[0]&&!Se.firstMatchCanBeWeak)return;Te--,We--;const xe=[G[Te][We],$e];let nt=0,Ke=0;for(;Te>=1;){let me=We;do{const Ie=se[Te][me];if(Ie===3)me=me-2;else if(Ie===2)me=me-1;else break}while(me>=1);nt>1&&be[ye+Te-1]===Me[$e+We-1]&&!F(me+$e-1,Re,Me)&&nt+1>x[Te][me]&&(me=We),me===We?nt++:nt=1,Ke||(Ke=me),Te--,We=me-1,xe.push(We)}je===De&&Se.boostFullMatch&&(xe[0]+=2);const Ze=Ke-De;return xe[0]-=Ze,xe}e.$fk=X;function Y(ae,be,ye,Re,Me,$e){let Se=ae-1,De=be-1;for(;Se>=ye&&De>=Re;)Me[Se]===$e[De]&&(ne[Se]=De,Se--),De--}function N(ae,be,ye,Re,Me,$e,Se,De,je,Te,We){if(be[ye]!==$e[Se])return Number.MIN_SAFE_INTEGER;let ze=1,Je=!1;return Se===ye-Re?ze=ae[ye]===Me[Se]?7:5:F(Se,Me,$e)&&(Se===0||!F(Se-1,Me,$e))?(ze=ae[ye]===Me[Se]?7:5,Je=!0):B($e,Se)&&(Se===0||!B($e,Se-1))?ze=5:(B($e,Se-1)||W($e,Se-1))&&(ze=5,Je=!0),ze>1&&ye===Re&&(We[0]=!0),Je||(Je=F(Se,Me,$e)||B($e,Se-1)||W($e,Se-1)),ye===Re?Se>je&&(ze-=Je?3:5):Te?ze+=Je?2:0:ze+=Je?0:1,Se+1===De&&(ze-=Je?3:5),ze}function U(ae,be,ye,Re,Me,$e,Se){return ie(ae,be,ye,Re,Me,$e,!0,Se)}e.$gk=U;function te(ae,be,ye,Re,Me,$e,Se){return ie(ae,be,ye,Re,Me,$e,!1,Se)}e.$hk=te;function ie(ae,be,ye,Re,Me,$e,Se,De){let je=X(ae,be,ye,Re,Me,$e,De);if(je&&!Se)return je;if(ae.length>=3){const Te=Math.min(7,ae.length-1);for(let We=ye+1;We<Te;We++){const ze=de(ae,We);if(ze){const Je=X(ze,ze.toLowerCase(),ye,Re,Me,$e,De);Je&&(Je[0]-=3,(!je||Je[0]>je[0])&&(je=Je))}}}return je}function de(ae,be){if(be+1>=ae.length)return;const ye=ae[be],Re=ae[be+1];if(ye!==Re)return ae.slice(0,be)+Re+ye+ae.slice(be+2)}}),define(Ee[64],ke([1,0,17]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0;function C(u){return s(u,0)}e.$5i=C;function s(u,g){switch(typeof u){case"object":return u===null?S(349,g):Array.isArray(u)?v(u,g):p(u,g);case"string":return P(u,g);case"boolean":return k(u,g);case"number":return S(u,g);case"undefined":return S(937,g);default:return S(617,g)}}e.$6i=s;function S(u,g){return(g<<5)-g+u|0}e.$7i=S;function k(u,g){return S(u?433:863,g)}function P(u,g){g=S(149417,g);for(let h=0,f=u.length;h<f;h++)g=S(u.charCodeAt(h),g);return g}e.$8i=P;function v(u,g){return g=S(104579,g),u.reduce((h,f)=>s(f,h),g)}function p(u,g){return g=S(181387,g),Object.keys(u).sort().reduce((h,f)=>(h=P(f,h),s(u[f],h)),g)}class D{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=s(g,this.g),this.g}}e.$9i=D;var E;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function w(u,g,h=32){const f=h-g,l=~((1<<f)-1);return(u<<g|(l&u)>>>f)>>>0}function m(u,g=0,h=u.byteLength,f=0){for(let l=0;l<h;l++)u[g+l]=f}function d(u,g,h="0"){for(;u.length<g;)u=h+u;return u}function c(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),g/4)}e.$0i=c;class b{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const h=g.length;if(h===0)return;const f=this.p;let l=this.r,t=this.u,r,o;for(t!==0?(r=t,o=-1,t=0):(r=g.charCodeAt(0),o=0);;){let n=r;if(y.$nf(r))if(o+1<h){const i=g.charCodeAt(o+1);y.$of(i)?(o++,n=y.$pf(r,i)):n=65533}else{t=r;break}else y.$of(r)&&(n=65533);if(l=this.w(f,l,n),o++,o<h)r=g.charCodeAt(o);else break}this.r=l,this.u=t}w(g,h,f){return f<128?g[h++]=f:f<2048?(g[h++]=192|(f&1984)>>>6,g[h++]=128|(f&63)>>>0):f<65536?(g[h++]=224|(f&61440)>>>12,g[h++]=128|(f&4032)>>>6,g[h++]=128|(f&63)>>>0):(g[h++]=240|(f&1835008)>>>18,g[h++]=128|(f&258048)>>>12,g[h++]=128|(f&4032)>>>6,g[h++]=128|(f&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=b.g,h=this.q;for(let $=0;$<64;$+=4)g.setUint32($,h.getUint32($,!1),!1);for(let $=64;$<320;$+=4)g.setUint32($,w(g.getUint32($-12,!1)^g.getUint32($-32,!1)^g.getUint32($-56,!1)^g.getUint32($-64,!1),1),!1);let f=this.h,l=this.l,t=this.m,r=this.n,o=this.o,n,i,a;for(let $=0;$<80;$++)$<20?(n=l&t|~l&r,i=1518500249):$<40?(n=l^t^r,i=1859775393):$<60?(n=l&t|l&r|t&r,i=2400959708):(n=l^t^r,i=3395469782),a=w(f,5)+n+o+i+g.getUint32($*4,!1)&4294967295,o=r,r=t,t=w(l,30),l=f,f=a;this.h=this.h+f&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+o&4294967295}}e.$$i=b,b.g=new DataView(new ArrayBuffer(320))}),define(Ee[65],ke([1,0,17]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(C||(C={})),function(s){const S="error",k="warning",P="warn",v="info",p="ignore";function D(w){return w?y.$jf(S,w)?s.Error:y.$jf(k,w)||y.$jf(P,w)?s.Warning:y.$jf(v,w)?s.Info:s.Ignore:s.Ignore}s.fromValue=D;function E(w){switch(w){case s.Error:return S;case s.Warning:return k;case s.Info:return v;default:return p}}s.toString=E}(C||(C={})),e.default=C}),define(Ee[152],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(Ee[66],ke([1,0,18,17]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class s{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const d=m.charCodeAt(0),c=this.b.charCodeAt(this.c);return d-c}value(){return this.b[this.c]}}e.$gi=s;class S{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,C.$df)(m,this.b,0,m.length,this.c,this.d):(0,C.$ff)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=S;class k{constructor(m=!0,d=!0){this.f=m,this.g=d}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let d=m.length-1;d>=0;d--,this.c--){const c=this.b.charCodeAt(d);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,C.$df)(m,this.b,0,m.length,this.d,this.e):(0,C.$ff)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=k;var P;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(P||(P={}));class v{constructor(m,d){this.f=m,this.g=d,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,C.$ef)(m,this.c.scheme);if(this.d[this.e]===2)return(0,C.$ef)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,C.$cf)(m,this.c.query);if(this.d[this.e]===5)return(0,C.$cf)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=v;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(D||(D={}));class E{static forUris(m=()=>!1,d=()=>!1){return new E(new v(m,d))}static forPaths(m=!1){return new E(new k(void 0,!m))}static forStrings(){return new E(new s)}static forConfigKeys(){return new E(new S)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,d){if(d){const c=d.slice(0);(0,y.$Xb)(c);for(const b of c)this.set(b,m)}else{const c=m.slice(0);(0,y.$Xb)(c);for(const b of c)this.set(b[0],b[1])}}set(m,d){const c=this.b.reset(m);let b;this.c||(this.c=new p,this.c.segment=c.value());const u=[];for(b=this.c;;){const h=c.cmp(b.segment);if(h>0)b.left||(b.left=new p,b.left.segment=c.value()),u.push([-1,b]),b=b.left;else if(h<0)b.right||(b.right=new p,b.right.segment=c.value()),u.push([1,b]),b=b.right;else if(c.hasNext())c.next(),b.mid||(b.mid=new p,b.mid.segment=c.value()),u.push([0,b]),b=b.mid;else break}const g=b.value;b.value=d,b.key=m;for(let h=u.length-1;h>=0;h--){const f=u[h][1];f.updateHeight();const l=f.balanceFactor();if(l<-1||l>1){const t=u[h][0],r=u[h+1][0];if(t===1&&r===1)u[h][1]=f.rotateLeft();else if(t===-1&&r===-1)u[h][1]=f.rotateRight();else if(t===1&&r===-1)f.right=u[h+1][1]=u[h+1][1].rotateRight(),u[h][1]=f.rotateLeft();else if(t===-1&&r===1)f.left=u[h+1][1]=u[h+1][1].rotateLeft(),u[h][1]=f.rotateRight();else throw new Error;if(h>0)switch(u[h-1][0]){case-1:u[h-1][1].left=u[h][1];break;case 1:u[h-1][1].right=u[h][1];break;case 0:u[h-1][1].mid=u[h][1];break}else this.c=u[0][1]}}return g}get(m){return this.d(m)?.value}d(m){const d=this.b.reset(m);let c=this.c;for(;c;){const b=d.cmp(c.segment);if(b>0)c=c.left;else if(b<0)c=c.right;else if(d.hasNext())d.next(),c=c.mid;else break}return c}has(m){const d=this.d(m);return!(d?.value===void 0&&d?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,d){const c=this.b.reset(m),b=[];let u=this.c;for(;u;){const g=c.cmp(u.segment);if(g>0)b.push([-1,u]),u=u.left;else if(g<0)b.push([1,u]),u=u.right;else if(c.hasNext())c.next(),b.push([0,u]),u=u.mid;else break}if(u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:h,value:f,segment:l}=g;this.e(g.key,!1),u.key=h,u.value=f,u.segment=l}}else{const g=u.left??u.right;if(b.length>0){const[h,f]=b[b.length-1];switch(h){case-1:f.left=g;break;case 0:f.mid=g;break;case 1:f.right=g;break}}else this.c=g}for(let g=b.length-1;g>=0;g--){const h=b[g][1];h.updateHeight();const f=h.balanceFactor();if(f>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),b[g][1]=h.rotateLeft()):f<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),b[g][1]=h.rotateRight()),g>0)switch(b[g-1][0]){case-1:b[g-1][1].left=b[g][1];break;case 1:b[g-1][1].right=b[g][1];break;case 0:b[g-1][1].mid=b[g][1];break}else this.c=b[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const d=this.b.reset(m);let c=this.c,b;for(;c;){const u=d.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(d.hasNext())d.next(),b=c.value||b,c=c.mid;else break}return c&&c.value||b}findSuperstr(m){return this.g(m,!1)}g(m,d){const c=this.b.reset(m);let b=this.c;for(;b;){const u=c.cmp(b.segment);if(u>0)b=b.left;else if(u<0)b=b.right;else if(c.hasNext())c.next(),b=b.mid;else return b.mid?this.h(b.mid):d?b.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[d,c]of this)m(c,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const d=[];return this.j(m,d),d[Symbol.iterator]()}j(m,d){m&&(m.left&&this.j(m.left,d),m.value&&d.push([m.key,m.value]),m.mid&&this.j(m.mid,d),m.right&&this.j(m.right,d))}_isBalanced(){const m=d=>{if(!d)return!0;const c=d.balanceFactor();return c<-1||c>1?!1:m(d.left)&&m(d.right)};return m(this.c)}}e.$ki=E}),define(Ee[9],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=void 0;function y(l){return typeof l=="string"}e.$Sf=y;function C(l){return Array.isArray(l)&&l.every(t=>y(t))}e.$Tf=C;function s(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$Uf=s;function S(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}e.$Vf=S;function k(l){return typeof l=="number"&&!isNaN(l)}e.$Wf=k;function P(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$Xf=P;function v(l){return l===!0||l===!1}e.$Yf=v;function p(l){return typeof l>"u"}e.$Zf=p;function D(l){return!E(l)}e.$1f=D;function E(l){return p(l)||l===null}e.$2f=E;function w(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$3f=w;function m(l){if(E(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$4f=m;function d(...l){const t=[];for(let r=0;r<l.length;r++){const o=l[r];if(E(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(o)}return t}e.$5f=d;const c=Object.prototype.hasOwnProperty;function b(l){if(!s(l))return!1;for(const t in l)if(c.call(l,t))return!1;return!0}e.$6f=b;function u(l){return typeof l=="function"}e.$7f=u;function g(...l){return l.length>0&&l.every(u)}e.$8f=g;function h(l,t){const r=Math.min(l.length,t.length);for(let o=0;o<r;o++)f(l[o],t[o])}e.$9f=h;function f(l,t){if(y(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(l instanceof t)return}catch{}if(!E(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$0f=f}),define(Ee[51],ke([1,0,9]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=void 0;const C=Object.create(null);function s(P,v){if((0,y.$Sf)(v)){const p=C[v];if(p===void 0)throw new Error(`${P} references an unknown codicon: ${v}`);v=p}return C[P]=v,{id:P}}function S(){return C}e.$ik=S;function k(){return Object.values(e.$kk)}e.$jk=k,e.$kk={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),gitStash:s("git-stash",60454),gitStashApply:s("git-stash-apply",60455),gitStashPop:s("git-stash-pop",60456),runAllCoverage:s("run-all-coverage",60461),runCoverage:s("run-all-coverage",60460),coverage:s("coverage",60462),githubProject:s("github-project",60463),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(Ee[39],ke([1,0,7,3,17,9]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function k(a){return a===47||a===92}e.$$f=k;function P(a){return a.replace(/[\\/]/g,y.$gc.sep)}e.$_f=P;function v(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$ag=v;function p(a,$=y.$gc.sep){if(!a)return"";const A=a.length,R=a.charCodeAt(0);if(k(R)){if(k(a.charCodeAt(1))&&!k(a.charCodeAt(2))){let O=3;const M=O;for(;O<A&&!k(a.charCodeAt(O));O++);if(M!==O&&!k(a.charCodeAt(O+1))){for(O+=1;O<A;O++)if(k(a.charCodeAt(O)))return a.slice(0,O+1).replace(/[\\/]/g,$)}}return $}else if(u(R)&&a.charCodeAt(1)===58)return k(a.charCodeAt(2))?a.slice(0,2)+$:a.slice(0,2);let I=a.indexOf("://");if(I!==-1){for(I+=3;I<A;I++)if(k(a.charCodeAt(I)))return a.slice(0,I+1)}return""}e.$bg=p;function D(a){if(!C.$c||!a||a.length<5)return!1;let $=a.charCodeAt(0);if($!==92||($=a.charCodeAt(1),$!==92))return!1;let A=2;const R=A;for(;A<a.length&&($=a.charCodeAt(A),$!==92);A++);return!(R===A||($=a.charCodeAt(A+1),isNaN($)||$===92))}e.$cg=D;const E=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,$=C.$c){const A=$?E:w;return!(!a||a.length===0||/^\s+$/.test(a)||(A.lastIndex=0,A.test(a))||$&&m.test(a)||a==="."||a===".."||$&&a[a.length-1]==="."||$&&a.length!==a.trim().length||a.length>255)}e.$dg=d;function c(a,$,A){const R=a===$;return!A||R?R:!a||!$?!1:(0,s.$jf)(a,$)}e.$eg=c;function b(a,$,A,R=y.sep){if(a===$)return!0;if(!a||!$||$.length>a.length)return!1;if(A){if(!(0,s.$kf)(a,$))return!1;if($.length===a.length)return!0;let O=$.length;return $.charAt($.length-1)===R&&O--,a.charAt(O)===R}return $.charAt($.length-1)!==R&&($+=R),a.indexOf($)===0}e.$fg=b;function u(a){return a>=65&&a<=90||a>=97&&a<=122}e.$gg=u;function g(a,$){return C.$c&&a.endsWith(":")&&(a+=y.sep),(0,y.$ic)(a)||(a=(0,y.$jc)($,a)),a=(0,y.$hc)(a),C.$c?(a=(0,s.$4e)(a,y.sep),a.endsWith(":")&&(a+=y.sep)):(a=(0,s.$4e)(a,y.sep),a||(a=y.sep)),a}e.$hg=g;function h(a){const $=(0,y.$hc)(a);return C.$c?a.length>3?!1:f($)&&(a.length===2||$.charCodeAt(2)===92):$===y.$gc.sep}e.$ig=h;function f(a,$=C.$c){return $?u(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$jg=f;function l(a,$=C.$c){return f(a,$)?a[0]:void 0}e.$kg=l;function t(a,$,A){return $.length>a.length?-1:a===$?0:(A&&(a=a.toLowerCase(),$=$.toLowerCase()),a.indexOf($))}e.$lg=t;function r(a){const $=a.split(":");let A,R,I;for(const O of $){const M=Number(O);(0,S.$Wf)(M)?R===void 0?R=M:I===void 0&&(I=M):A=A?[A,O].join(":"):O}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:R!==void 0?R:void 0,column:I!==void 0?I:R!==void 0?1:void 0}}e.$mg=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(a,$,A=8){let R="";for(let O=0;O<A;O++){let M;O===0&&C.$c&&!$&&(A===3||A===4)?M=n:M=o,R+=M.charAt(Math.floor(Math.random()*M.length))}let I;return $?I=`${$}-${R}`:I=R,a?(0,y.$jc)(a,I):I}e.$ng=i}),define(Ee[21],ke([1,0,9]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=void 0;function C(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([h,f])=>{g[h]=f&&typeof f=="object"?C(f):f}),g}e.$In=C;function s(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const h=g.shift();Object.freeze(h);for(const f in h)if(S.call(h,f)){const l=h[f];typeof l=="object"&&!Object.isFrozen(l)&&!(0,y.$Vf)(l)&&g.push(l)}}return u}e.$Jn=s;const S=Object.prototype.hasOwnProperty;function k(u,g){return P(u,g,new Set)}e.$Kn=k;function P(u,g,h){if((0,y.$2f)(u))return u;const f=g(u);if(typeof f<"u")return f;if(Array.isArray(u)){const l=[];for(const t of u)l.push(P(t,g,h));return l}if((0,y.$Uf)(u)){if(h.has(u))throw new Error("Cannot clone recursive data-structure");h.add(u);const l={};for(const t in u)S.call(u,t)&&(l[t]=P(u[t],g,h));return h.delete(u),l}return u}function v(u,g,h=!0){return(0,y.$Uf)(u)?((0,y.$Uf)(g)&&Object.keys(g).forEach(f=>{f in u?h&&((0,y.$Uf)(u[f])&&(0,y.$Uf)(g[f])?v(u[f],g[f],h):u[f]=g[f]):u[f]=g[f]}),u):g}e.$Ln=v;function p(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let h,f;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(h=0;h<u.length;h++)if(!p(u[h],g[h]))return!1}else{const l=[];for(f in u)l.push(f);l.sort();const t=[];for(f in g)t.push(f);if(t.sort(),!p(l,t))return!1;for(h=0;h<l.length;h++)if(!p(u[l[h]],g[l[h]]))return!1}return!0}e.$Mn=p;function D(u){const g=new Set;return JSON.stringify(u,(h,f)=>{if((0,y.$Uf)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.$Nn=D;function E(u,g){const h=Object.create(null);return!u||!g||Object.keys(g).forEach(l=>{const t=u[l],r=g[l];p(t,r)||(h[l]=r)}),h}e.$On=E;function w(u,g){const h=g.toLowerCase(),f=Object.keys(u).find(l=>l.toLowerCase()===h);return f?u[f]:u[g]}e.$Pn=w;function m(u,g){const h=Object.create(null);for(const[f,l]of Object.entries(u))g(f,l)&&(h[f]=l);return h}e.$Qn=m;function d(u){let g=[];for(;Object.prototype!==u;)g=g.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return g}e.$Rn=d;function c(u){const g=[];for(const h of d(u))typeof u[h]=="function"&&g.push(h);return g}e.$Sn=c;function b(u,g){const h=l=>function(){const t=Array.prototype.slice.call(arguments,0);return g(l,t)},f={};for(const l of u)f[l]=h(l);return f}e.$Tn=b}),define(Ee[100],ke([1,0,51]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$lk=e.ThemeColor=void 0;var C;(function(k){function P(v){return v&&typeof v=="object"&&typeof v.id=="string"}k.isThemeColor=P})(C||(e.ThemeColor=C={}));function s(k){return{id:k}}e.$lk=s;var S;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function v(g){const h=P.exec(g.id);if(!h)return v(y.$kk.error);const[,f,l]=h,t=["codicon","codicon-"+f];return l&&t.push("codicon-modifier-"+l.substring(1)),t}k.asClassNameArray=v;function p(g){return v(g).join(" ")}k.asClassName=p;function D(g){return"."+v(g).join(".")}k.asCSSSelector=D;function E(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||C.isThemeColor(g.color))}k.isThemeIcon=E;const w=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function m(g){const h=w.exec(g);if(!h)return;const[,f]=h;return{id:f}}k.fromString=m;function d(g){return{id:g}}k.fromId=d;function c(g,h){let f=g.id;const l=f.lastIndexOf("~");return l!==-1&&(f=f.substring(0,l)),h&&(f=`${f}~${h}`),{id:f}}k.modify=c;function b(g){const h=g.id.lastIndexOf("~");if(h!==-1)return g.id.substring(h+1)}k.getModifier=b;function u(g,h){return g.id===h.id&&g.color?.id===h.color?.id}k.isEqual=u})(S||(e.ThemeIcon=S={}))}),define(Ee[153],ke([1,0,151,17,100]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;const S="$(",k=new RegExp(`\\$\\(${s.ThemeIcon.iconNameExpression}(?:${s.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${k.source}`,"g");function v(u){return u.replace(P,(g,h)=>h?g:`\\${g}`)}e.$mk=v;const p=new RegExp(`\\\\${k.source}`,"g");function D(u){return u.replace(p,g=>`\\${g}`)}e.$nk=D;const E=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function w(u){return u.indexOf(S)===-1?u:u.replace(E,(g,h,f,l)=>f?g:h||l||"")}e.$ok=w;function m(u){return u?u.replace(/\$\((.*?)\)/g,(g,h)=>` ${h} `).trim():""}e.$pk=m;const d=new RegExp(`\\$\\(${s.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(u){d.lastIndex=0;let g="";const h=[];let f=0;for(;;){const l=d.lastIndex,t=d.exec(u),r=u.substring(l,t?.index);if(r.length>0){g+=r;for(let o=0;o<r.length;o++)h.push(f)}if(!t)break;f+=t[0].length}return{text:g,iconOffsets:h}}e.$qk=c;function b(u,g,h=!1){const{text:f,iconOffsets:l}=g;if(!l||l.length===0)return(0,y.$_j)(u,f,h);const t=(0,C.$3e)(f," "),r=f.length-t.length,o=(0,y.$_j)(u,t,h);if(o)for(const n of o){const i=l[n.start+r]+r;n.start+=i,n.end+=i}return o}e.$rk=b}),define(Ee[4],ke([1,0,7,3]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,S=/^\//,k=/^\/\//;function P(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!s.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!S.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(n,i){return!n&&!i?"file":n}function p(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const D="",E="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,$,A,R,I=!1){typeof i=="object"?(this.scheme=i.scheme||D,this.authority=i.authority||D,this.path=i.path||D,this.query=i.query||D,this.fragment=i.fragment||D):(this.scheme=v(i,I),this.authority=a||D,this.path=p(this.scheme,$||D),this.query=A||D,this.fragment=R||D,P(this,I))}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:$,path:A,query:R,fragment:I}=i;return a===void 0?a=this.scheme:a===null&&(a=D),$===void 0?$=this.authority:$===null&&($=D),A===void 0?A=this.path:A===null&&(A=D),R===void 0?R=this.query:R===null&&(R=D),I===void 0?I=this.fragment:I===null&&(I=D),a===this.scheme&&$===this.authority&&A===this.path&&R===this.query&&I===this.fragment?this:new b(a,$,A,R,I)}static parse(i,a=!1){const $=w.exec(i);return $?new b($[2]||D,o($[4]||D),o($[5]||D),o($[7]||D),o($[9]||D),a):new b(D,D,D,D,D)}static file(i){let a=D;if(C.$c&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const $=i.indexOf(E,2);$===-1?(a=i.substring(2),i=E):(a=i.substring(2,$),i=i.substring($)||E)}return new b("file",a,i,D,D)}static from(i,a){return new b(i.scheme,i.authority,i.path,i.query,i.fragment,a)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return C.$c&&i.scheme==="file"?$=m.file(y.$fc.join(f(i,!0),...a)).path:$=y.$gc.join(i.path,...a),i.with({path:$})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const a=new b(i);return a._formatted=i.external??null,a._fsPath=i._sep===c?i.fsPath??null:null,a}}else return i}}e.URI=m;function d(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$vc=d;const c=C.$c?1:void 0;class b extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(n,i,a){let $,A=-1;for(let R=0;R<n.length;R++){const I=n.charCodeAt(R);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||i&&I===47||a&&I===91||a&&I===93||a&&I===58)A!==-1&&($+=encodeURIComponent(n.substring(A,R)),A=-1),$!==void 0&&($+=n.charAt(R));else{$===void 0&&($=n.substr(0,R));const O=u[I];O!==void 0?(A!==-1&&($+=encodeURIComponent(n.substring(A,R)),A=-1),$+=O):A===-1&&(A=R)}}return A!==-1&&($+=encodeURIComponent(n.substring(A))),$!==void 0?$:n}function h(n){let i;for(let a=0;a<n.length;a++){const $=n.charCodeAt(a);$===35||$===63?(i===void 0&&(i=n.substr(0,a)),i+=u[$]):i!==void 0&&(i+=n[a])}return i!==void 0?i:n}function f(n,i){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,C.$c&&(a=a.replace(/\//g,"\\")),a}e.$wc=f;function l(n,i){const a=i?h:g;let $="",{scheme:A,authority:R,path:I,query:O,fragment:M}=n;if(A&&($+=A,$+=":"),(R||A==="file")&&($+=E,$+=E),R){let Z=R.indexOf("@");if(Z!==-1){const ee=R.substr(0,Z);R=R.substr(Z+1),Z=ee.lastIndexOf(":"),Z===-1?$+=a(ee,!1,!1):($+=a(ee.substr(0,Z),!1,!1),$+=":",$+=a(ee.substr(Z+1),!1,!0)),$+="@"}R=R.toLowerCase(),Z=R.lastIndexOf(":"),Z===-1?$+=a(R,!1,!0):($+=a(R.substr(0,Z),!1,!0),$+=R.substr(Z))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const Z=I.charCodeAt(1);Z>=65&&Z<=90&&(I=`/${String.fromCharCode(Z+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const Z=I.charCodeAt(0);Z>=65&&Z<=90&&(I=`${String.fromCharCode(Z+32)}:${I.substr(2)}`)}$+=a(I,!0,!1)}return O&&($+="?",$+=a(O,!1,!1)),M&&($+="#",$+=i?M:g(M,!1,!1)),$}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,i=>t(i)):n}}),define(Ee[154],ke([1,0,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Aq=e.$zq=e.$yq=void 0;function C(p){const D=p;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.$yq=C;function s(p){const D=[];let E;try{const w=JSON.parse(p.arguments),m=w[w.length-1];m&&m.__$stack&&(w.pop(),E=m.__$stack),D.push(...w)}catch{D.push("Unable to log remote console arguments",p.arguments)}return{args:D,stack:E}}e.$zq=s;function S(p){if(typeof p!="string")return S(s(p).stack);const D=p;if(D){const E=k(D),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(w&&w.length===4)return{uri:y.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Aq=S;function k(p){if(!p)return p;const D=p.indexOf(`
`);return D===-1?p:p.substring(0,D)}function P(p,D){const{args:E,stack:w}=s(p),m=typeof E[0]=="string"&&E.length===1;let d=k(w);d&&(d=`(${d.trim()})`);let c=[];if(typeof E[0]=="string"?d&&m?c=[`%c[${D}] %c${E[0]} %c${d}`,v("blue"),v(""),v("grey")]:c=[`%c[${D}] %c${E[0]}`,v("blue"),v(""),...E.slice(1)]:c=[`%c[${D}]%`,v("blue"),...E],d&&!m&&c.push(d),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,c)}e.log=P;function v(p){return`color: ${p}`}}),define(Ee[52],ke([1,0,14,4]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function s(v){return JSON.stringify(v,k)}e.$Lh=s;function S(v){let p=JSON.parse(v);return p=P(p),p}e.$Mh=S;function k(v,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function P(v,p=0){if(!v||p>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return C.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 17:return new Date(v.source)}if(v instanceof y.$se||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let D=0;D<v.length;++D)v[D]=P(v[D],p+1);else for(const D in v)Object.hasOwnProperty.call(v,D)&&(v[D]=P(v[D],p+1))}return v}e.$Nh=P}),define(Ee[12],ke([1,0,8,3,17,4]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var k;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.codeSetting="code-setting",w.codeFeature="code-feature"})(k||(e.Schemas=k={}));function P(w,m){return S.URI.isUri(w)?(0,s.$jf)(w.scheme,m):(0,s.$kf)(w,m+":")}e.$og=P;function v(w,...m){return m.some(d=>P(w,d))}e.$pg=v,e.$qg="vscode-tkn",e.$rg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${k.vscodeRemoteResource}`}set(m,d,c){this.a[m]=d,this.b[m]=c}setConnectionToken(m,d){this.c[m]=d}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(h){return y.$1(h),m}const d=m.authority;let c=this.a[d];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const b=this.b[d],u=this.c[d];let g=`path=${encodeURIComponent(m.path)}`;return typeof u=="string"&&(g+=`&${e.$rg}=${encodeURIComponent(u)}`),S.URI.from({scheme:C.$i?this.d:k.vscodeRemoteResource,authority:`${c}:${b}`,path:C.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:g})}}e.$sg=new p,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class D{asBrowserUri(m){const d=this.b(m,le);return this.uriToBrowserUri(d)}uriToBrowserUri(m){return m.scheme===k.vscodeRemote?e.$sg.rewrite(m):m.scheme===k.file&&(C.$g||C.$k===`${k.vscodeFileResource}://${D.a}`)?m.with({scheme:k.vscodeFileResource,authority:m.authority||D.a,query:null,fragment:null}):m}asFileUri(m){const d=this.b(m,le);return this.uriToFileUri(d)}uriToFileUri(m){return m.scheme===k.vscodeFileResource?m.with({scheme:k.file,authority:m.authority!==D.a?m.authority:null,query:null,fragment:null}):m}b(m,d){return S.URI.isUri(m)?m:S.URI.parse(d.toUrl(m))}}D.a=e.$xg,e.$yg=new D;var E;(function(w){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(m.get("3"));const d="vscode-coi";function c(u){let g;typeof u=="string"?g=new URL(u).searchParams:u instanceof URL?g=u.searchParams:S.URI.isUri(u)&&(g=new URL(u.toString(!0)).searchParams);const h=g?.get(d);if(h)return m.get(h)}w.getHeadersFromQuery=c;function b(u,g,h){if(!globalThis.crossOriginIsolated)return;const f=g&&h?"3":h?"2":"1";u instanceof URLSearchParams?u.set(d,f):u[d]=f}w.addSearchParam=b})(E||(e.COI=E={}))}),define(Ee[155],ke([1,0,96,12,3,4]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=void 0;class k{constructor(w,m,d){this.id=w,this.dependencies=m,this.callback=d}}class P{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,m,d)=>{typeof w!="string"&&(d=m,m=w,w=null),(typeof m!="object"||!Array.isArray(m))&&(d=m,m=null),this.c.push(new k(w,m,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const m=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!m)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(w){return new Promise((m,d)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const b=()=>{c.removeEventListener("load",u),c.removeEventListener("error",g)},u=h=>{b(),m(this.c.pop())},g=h=>{b(),d(h)};c.addEventListener("load",u),c.addEventListener("error",g),this.f&&(w=this.f.createScriptURL(w)),c.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(w){return new Promise((m,d)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),m(this.c.pop())}catch(c){d(c)}})}async j(w){try{const m=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,b=S.URI.parse(w).fsPath,u=m.readFileSync(b).toString(),g=c.wrap(u.replace(/^#!.*/,""));return new d.Script(g).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}P.INSTANCE=new P;const v=new Map;let p={};typeof globalThis.require=="object"&&(p=globalThis.require.paths??{});async function D(E,w,m){if(y.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),p[E]&&(E=p[E]);const d=`${E}/${w}`;if(v.has(d))return v.get(d);let c;if(/^\w[\w\d+.-]*:\/\//.test(d))c=d;else{const h=`${m&&!s.$i?C.$vg:C.$ug}/${d}`;c=C.$yg.asBrowserUri(h).toString(!0)}const b=P.INSTANCE.load(c);return v.set(d,b),b}else return await new Promise((d,c)=>{le([E],d,c)})}e.$uD=D}),define(Ee[19],ke([1,0,39,12,7,3,17,4]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function v(m){return(0,P.$wc)(m,!0)}e.$Fg=v;class p{constructor(d){this.a=d}compare(d,c,b=!1){return d===c?0:(0,k.$cf)(this.getComparisonKey(d,b),this.getComparisonKey(c,b))}isEqual(d,c,b=!1){return d===c?!0:!d||!c?!1:this.getComparisonKey(d,b)===this.getComparisonKey(c,b)}getComparisonKey(d,c=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,c,b=!1){if(d.scheme===c.scheme){if(d.scheme===C.Schemas.file)return y.$fg(v(d),v(c),this.a(d))&&d.query===c.query&&(b||d.fragment===c.fragment);if((0,e.$Wg)(d.authority,c.authority))return y.$fg(d.path,c.path,this.a(d),"/")&&d.query===c.query&&(b||d.fragment===c.fragment)}return!1}joinPath(d,...c){return P.URI.joinPath(d,...c)}basenameOrAuthority(d){return(0,e.$Og)(d)||d.authority}basename(d){return s.$gc.basename(d.path)}extname(d){return s.$gc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let c;return d.scheme===C.Schemas.file?c=P.URI.file(s.$mc(v(d))).path:(c=s.$gc.dirname(d.path),d.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),c="/")),d.with({path:c})}normalizePath(d){if(!d.path.length)return d;let c;return d.scheme===C.Schemas.file?c=P.URI.file(s.$hc(v(d))).path:c=s.$gc.normalize(d.path),d.with({path:c})}relativePath(d,c){if(d.scheme!==c.scheme||!(0,e.$Wg)(d.authority,c.authority))return;if(d.scheme===C.Schemas.file){const g=s.$lc(v(d),v(c));return S.$c?y.$_f(g):g}let b=d.path||"/";const u=c.path||"/";if(this.a(d)){let g=0;for(const h=Math.min(b.length,u.length);g<h&&!(b.charCodeAt(g)!==u.charCodeAt(g)&&b.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);b=u.substr(0,g)+b.substr(g)}return s.$gc.relative(b,u)}resolvePath(d,c){if(d.scheme===C.Schemas.file){const b=P.URI.file(s.$kc(v(d),c));return d.with({authority:b.authority,path:b.path})}return c=y.$ag(c),d.with({path:s.$gc.resolve(d.path,c)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,c){return d===c||d!==void 0&&c!==void 0&&(0,k.$jf)(d,c)}hasTrailingPathSeparator(d,c=s.sep){if(d.scheme===C.Schemas.file){const b=v(d);return b.length>y.$bg(b).length&&b[b.length-1]===c}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,c=s.sep){return(0,e.$Xg)(d,c)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,c=s.sep){let b=!1;if(d.scheme===C.Schemas.file){const u=v(d);b=u!==void 0&&u.length===y.$bg(u).length&&u[u.length-1]===c}else{c="/";const u=d.path;b=u.length===1&&u.charCodeAt(u.length-1)===47}return!b&&!(0,e.$Xg)(d,c)?d.with({path:d.path+"/"}):d}}e.$Gg=p,e.$Hg=new p(()=>!1),e.$Ig=new p(m=>m.scheme===C.Schemas.file?!S.$e:!0),e.$Jg=new p(m=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function D(m,d){const c=[];for(let b=0;b<m.length;b++){const u=d(m[b]);m.some((g,h)=>h===b?!1:(0,e.$Lg)(u,d(g)))||c.push(m[b])}return c}e.$1g=D;var E;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function d(c){const b=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(h=>{const[f,l]=h.split(":");f&&l&&b.set(f,l)});const g=c.path.substring(0,c.path.indexOf(";"));return g&&b.set(m.META_DATA_MIME,g),b}m.parseMetaData=d})(E||(e.DataUri=E={}));function w(m,d,c){if(d){let b=m.path;return b&&b[0]!==s.$gc.sep&&(b=s.$gc.sep+b),m.with({scheme:c,authority:d,path:b})}return m.with({scheme:c})}e.$2g=w}),define(Ee[15],ke([1,0,20,8,6,2,19,3,152,60]),function(le,e,y,C,s,S,k,P,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function D(Y){return!!Y&&typeof Y.then=="function"}e.$3g=D;function E(Y){const N=new y.$ce,U=Y(N.token),te=new Promise((ie,de)=>{const ae=N.token.onCancellationRequested(()=>{ae.dispose(),de(new C.$5)});Promise.resolve(U).then(be=>{ae.dispose(),N.dispose(),ie(be)},be=>{ae.dispose(),N.dispose(),de(be)})});return new class{cancel(){N.cancel(),N.dispose()}then(ie,de){return te.then(ie,de)}catch(ie){return this.then(void 0,ie)}finally(ie){return te.finally(ie)}}}e.$4g=E;function w(Y,N,U){return new Promise((te,ie)=>{const de=N.onCancellationRequested(()=>{de.dispose(),te(U)});Y.then(te,ie).finally(()=>de.dispose())})}e.$5g=w;function m(Y,N){return new Promise((U,te)=>{const ie=N.onCancellationRequested(()=>{ie.dispose(),te(new C.$5)});Y.then(U,te).finally(()=>ie.dispose())})}e.$6g=m;async function d(Y){let N=-1;const U=Y.map((te,ie)=>te.then(de=>(N=ie,de)));try{return await Promise.race(U)}finally{Y.forEach((te,ie)=>{ie!==N&&te.cancel()})}}e.$7g=d;function c(Y,N,U){let te;const ie=setTimeout(()=>{te?.(void 0),U?.()},N);return Promise.race([Y.finally(()=>clearTimeout(ie)),new Promise(de=>te=de)])}e.$8g=c;function b(Y){return new Promise((N,U)=>{const te=Y();D(te)?te.then(N,U):N(te)})}e.$9g=b;function u(){let Y,N;return{promise:new Promise((te,ie)=>{Y=te,N=ie}),resolve:Y,reject:N}}e.$0g=u;class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=N,!this.b){const U=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(U,U).then(te)})}return new Promise((U,te)=>{this.b.then(U,te)})}return this.a=N(),new Promise((U,te)=>{this.a.then(ie=>{this.a=null,U(ie)},ie=>{this.a=null,te(ie)})})}dispose(){this.f=!0}}e.$$g=g;class h{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$_g=h;class f{constructor(){this.a=new Map}queue(N,U){const ie=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(N)===ie&&this.a.delete(N)});return this.a.set(N,ie),ie}}e.$ah=f;const l=(Y,N)=>{let U=!0;const te=setTimeout(()=>{U=!1,N()},Y);return{isTriggered:()=>U,dispose:()=>{clearTimeout(te),U=!1}}},t=Y=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,Y())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class r{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,U=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((ie,de)=>{this.d=ie,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const ie=this.g;return this.g=null,ie()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=U===v.$2d?t(te):l(U,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=r;class o{constructor(N){this.a=new r(N),this.b=new g}trigger(N,U){return this.a.trigger(()=>this.b.queue(N),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=o;class n{constructor(){this.a=!1,this.b=new Promise((N,U)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=n;class i extends n{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$eh=i;function a(Y,N){return N?new Promise((U,te)=>{const ie=setTimeout(()=>{de.dispose(),U()},Y),de=N.onCancellationRequested(()=>{clearTimeout(ie),de.dispose(),te(new C.$5)})}):E(U=>a(Y,U))}e.$fh=a;function $(Y,N=0,U){const te=setTimeout(()=>{Y(),U&&ie.dispose()},N),ie=(0,S.$Rc)(()=>{clearTimeout(te),U?.deleteAndLeak(ie)});return U?.add(ie),ie}e.$gh=$;function A(Y){const N=[];let U=0;const te=Y.length;function ie(){return U<te?Y[U++]():null}function de(ae){ae!=null&&N.push(ae);const be=ie();return be?be.then(de):Promise.resolve(N)}return Promise.resolve(null).then(de)}e.$hh=A;function R(Y,N=te=>!!te,U=null){let te=0;const ie=Y.length,de=()=>{if(te>=ie)return Promise.resolve(U);const ae=Y[te++];return Promise.resolve(ae()).then(ye=>N(ye)?Promise.resolve(ye):de())};return de()}e.$ih=R;function I(Y,N=te=>!!te,U=null){if(Y.length===0)return Promise.resolve(U);let te=Y.length;const ie=()=>{te=-1;for(const de of Y)de.cancel?.()};return new Promise((de,ae)=>{for(const be of Y)be.then(ye=>{--te>=0&&N(ye)?(ie(),de(ye)):te===0&&de(U)}).catch(ye=>{--te>=0&&(ie(),ae(ye))})})}e.$jh=I;class O{constructor(N){this.a=0,this.b=!1,this.f=N,this.g=[],this.d=0,this.h=new s.$5d}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(N){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((U,te)=>{this.g.push({factory:N,c:U,e:te}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const N=this.g.shift();this.d++;const U=N.factory();U.then(N.c,N.e),U.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=O;class M extends O{constructor(){super(1)}}e.$lh=M;class Z{constructor(){this.a=new se,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$mh=Z;class ee{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const N=new ge;return this.b.add(N),N.p}g(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueSize(N,U=k.$Hg){const te=U.getComparisonKey(N);return this.a.get(te)?.size??0}queueFor(N,U,te=k.$Hg){const ie=te.getComparisonKey(N);let de=this.a.get(ie);if(!de){de=new M;const ae=this.f++,be=s.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ie),this.h(),this.d?.deleteAndDispose(ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new S.$3c),this.d.set(ae,be),this.a.set(ie,de)}return de.queue(U)}h(){this.g()&&this.j()}j(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=ee;class fe{constructor(N,U){this.a=-1,typeof N=="function"&&typeof U=="number"&&this.setIfNotSet(N,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},U)}setIfNotSet(N,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},U))}}e.$oh=fe;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(N,U,te=globalThis){this.cancel();const ie=te.setInterval(()=>{N()},U);this.d=(0,S.$Rc)(()=>{te.clearInterval(ie),this.d=void 0})}dispose(){this.cancel()}}e.$ph=ue;class j{constructor(N,U){this.b=-1,this.a=N,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=j;class H{constructor(N,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=N,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=H;class q extends j{constructor(N,U){super(N,U),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$sh=q;class J extends S.$Tc{constructor(N,U){super(),this.g=N,this.h=U,this.a=[],this.b=this.B(new S.$Uc),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of N)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(Y,N)=>{(0,P.$v)(()=>{if(U)return;const te=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.$vh=(Y,N,U)=>{const te=Y.requestIdleCallback(N,typeof U=="number"?{timeout:U}:void 0);let ie=!1;return{dispose(){ie||(ie=!0,Y.cancelIdleCallback(te))}}},e.$uh=Y=>(0,e.$vh)(globalThis,Y)}();class ne{constructor(N,U){this.g=!1,this.d=()=>{try{this.j=U()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$vh)(N,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=ne;class x extends ne{constructor(N){super(globalThis,N)}}e.$xh=x;async function G(Y,N,U){let te;for(let ie=0;ie<U;ie++)try{return await Y()}catch(de){te=de,await a(N)}throw te}e.$yh=G;class se{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,U,te){return this.a={taskId:N,cancel:()=>te?.(),promise:U},U.then(()=>this.d(N),()=>this.d(N)),U}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{const{promise:U,resolve:te,reject:ie}=u();this.b={run:N,promise:U,promiseResolve:te,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=se;class ce{constructor(N,U=()=>Date.now()){this.d=N,this.f=U,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$Ah=ce;var re;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(re||(re={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((N,U)=>{this.a=N,this.b=U})}complete(N){return new Promise(U=>{this.a(N),this.d={outcome:0,value:N},U()})}error(N){return new Promise(U=>{this.b(N),this.d={outcome:1,value:N},U()})}cancel(){return this.error(new C.$5)}}e.$Bh=ge;var B;(function(Y){async function N(te){let ie;const de=await Promise.all(te.map(ae=>ae.then(be=>be,be=>{ie||(ie=be)})));if(typeof ie<"u")throw ie;return de}Y.settled=N;function U(te){return new Promise(async(ie,de)=>{try{await te(ie,de)}catch(ae){de(ae)}})}Y.withAsyncBody=U})(B||(e.Promises=B={}));class W{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(N){this.a=void 0,this.b=void 0,this.d=!1,this.promise=N.then(U=>(this.a=U,this.d=!0,U),U=>{throw this.b=U,this.d=!0,U})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=W;class F{constructor(N){this.b=N,this.a=new p.$V(()=>new W(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=F;var z;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(z||(z={}));class _{static fromArray(N){return new _(U=>{U.emitMany(N)})}static fromPromise(N){return new _(async U=>{U.emitMany(await N)})}static fromPromises(N){return new _(async U=>{await Promise.all(N.map(async te=>U.emitOne(await te)))})}static merge(N){return new _(async U=>{await Promise.all(N.map(async te=>{for await(const ie of te)U.emitOne(ie)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new s.$5d,queueMicrotask(async()=>{const U={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(N(U)),this.j()}catch(te){this.k(te)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(N,U){return new _(async te=>{for await(const ie of N)te.emitOne(U(ie))})}map(N){return _.map(this,N)}static filter(N,U){return new _(async te=>{for await(const ie of N)U(ie)&&te.emitOne(ie)})}filter(N){return _.filter(this,N)}static coalesce(N){return _.filter(N,U=>!!U)}coalesce(){return _.coalesce(this)}static async toPromise(N){const U=[];for await(const te of N)U.push(te);return U}toPromise(){return _.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.$Eh=_,_.EMPTY=_.fromArray([]);class Q extends _{constructor(N,U){super(U),this.l=N}cancel(){this.l.cancel()}}e.$Fh=Q;function K(Y){const N=new y.$ce,U=Y(N.token);return new Q(N,async te=>{const ie=N.token.onCancellationRequested(()=>{ie.dispose(),N.dispose(),te.reject(new C.$5)});try{for await(const de of U){if(N.token.isCancellationRequested)return;te.emitOne(de)}ie.dispose(),N.dispose()}catch(de){ie.dispose(),N.dispose(),te.reject(de)}})}e.$Gh=K;class X{constructor(){this.a=new ge,this.b=new _(te=>{if(N){te.reject(N);return}return U&&te.emitMany(U),this.d=ie=>te.reject(ie),this.f=ie=>te.emitOne(ie),this.a.p});let N,U;this.f=te=>{U||(U=[]),U.push(te)},this.d=te=>{N||(N=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(N){this.d(N),this.a.complete()}emitOne(N){this.f(N)}}e.$Hh=X}),define(Ee[77],ke([1,0,18,15,39,24,7,3,17]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;function p(){return Object.create(null)}e.$Sj=p,e.$Tj="**",e.$Uj="/";const D="[/\\\\]",E="[^/\\\\]",w=/\//g;function m(ne,x){switch(ne){case 0:return"";case 1:return`${E}*?`;default:return`(?:${D}|${E}+${D}${x?`|${D}${E}+`:""})*?`}}function d(ne,x){if(!ne)return[];const G=[];let se=!1,ce=!1,re="";for(const ge of ne){switch(ge){case x:if(!se&&!ce){G.push(re),re="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}re+=ge}return re&&G.push(re),G}e.$Vj=d;function c(ne){if(!ne)return"";let x="";const G=d(ne,e.$Uj);if(G.every(se=>se===e.$Tj))x=".*";else{let se=!1;G.forEach((ce,re)=>{if(ce===e.$Tj){if(se)return;x+=m(2,re===G.length-1)}else{let ge=!1,B="",W=!1,F="";for(const z of ce){if(z!=="}"&&ge){B+=z;continue}if(W&&(z!=="]"||!F)){let _;z==="-"?_=z:(z==="^"||z==="!")&&!F?_="^":z===e.$Uj?_="":_=(0,v.$Xe)(z),F+=_;continue}switch(z){case"{":ge=!0;continue;case"[":W=!0;continue;case"}":{const Q=`(?:${d(B,",").map(K=>c(K)).join("|")})`;x+=Q,ge=!1,B="";break}case"]":{x+="["+F+"]",W=!1,F="";break}case"?":x+=E;continue;case"*":x+=m(1);continue;default:x+=(0,v.$Xe)(z)}}re<G.length-1&&(G[re+1]!==e.$Tj||re+2<G.length)&&(x+=D)}se=ce===e.$Tj})}return x}const b=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.$Dc(1e4),r=function(){return!1},o=function(){return null};function n(ne,x){if(!ne)return o;let G;typeof ne!="string"?G=ne.pattern:G=ne,G=G.trim();const se=`${G}_${!!x.trimForExclusions}`;let ce=t.get(se);if(ce)return i(ce,ne);let re;return b.test(G)?ce=$(G.substr(4),G):(re=u.exec(a(G,x)))?ce=A(re[1],G):(x.trimForExclusions?h:g).test(G)?ce=R(G,x):(re=f.exec(a(G,x)))?ce=I(re[1].substr(1),G,!0):(re=l.exec(a(G,x)))?ce=I(re[1],G,!1):ce=O(G),t.set(se,ce),i(ce,ne)}function i(ne,x){if(typeof x=="string")return ne;const G=function(se,ce){return(0,s.$fg)(se,x.base,!P.$e)?ne((0,v.$3e)(se.substr(x.base.length),k.sep),ce):null};return G.allBasenames=ne.allBasenames,G.allPaths=ne.allPaths,G.basenames=ne.basenames,G.patterns=ne.patterns,G}function a(ne,x){return x.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function $(ne,x){return function(G,se){return typeof G=="string"&&G.endsWith(ne)?x:null}}function A(ne,x){const G=`/${ne}`,se=`\\${ne}`,ce=function(ge,B){return typeof ge!="string"?null:B?B===ne?x:null:ge===ne||ge.endsWith(G)||ge.endsWith(se)?x:null},re=[ne];return ce.basenames=re,ce.patterns=[x],ce.allBasenames=re,ce}function R(ne,x){const G=q(ne.slice(1,-1).split(",").map(B=>n(B,x)).filter(B=>B!==o),ne),se=G.length;if(!se)return o;if(se===1)return G[0];const ce=function(B,W){for(let F=0,z=G.length;F<z;F++)if(G[F](B,W))return ne;return null},re=G.find(B=>!!B.allBasenames);re&&(ce.allBasenames=re.allBasenames);const ge=G.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return ge.length&&(ce.allPaths=ge),ce}function I(ne,x,G){const se=k.sep===k.$gc.sep,ce=se?ne:ne.replace(w,k.sep),re=k.sep+ce,ge=k.$gc.sep+ne;let B;return G?B=function(W,F){return typeof W=="string"&&(W===ce||W.endsWith(re)||!se&&(W===ne||W.endsWith(ge)))?x:null}:B=function(W,F){return typeof W=="string"&&(W===ce||!se&&W===ne)?x:null},B.allPaths=[(G?"*/":"./")+ne],B}function O(ne){try{const x=new RegExp(`^${c(ne)}$`);return function(G){return x.lastIndex=0,typeof G=="string"&&x.test(G)?ne:null}}catch{return o}}function M(ne,x,G){return!ne||typeof x!="string"?!1:Z(ne)(x,void 0,G)}e.$Wj=M;function Z(ne,x={}){if(!ne)return r;if(typeof ne=="string"||ee(ne)){const G=n(ne,x);if(G===o)return r;const se=function(ce,re){return!!G(ce,re)};return G.allBasenames&&(se.allBasenames=G.allBasenames),G.allPaths&&(se.allPaths=G.allPaths),se}return j(ne,x)}e.$Xj=Z;function ee(ne){const x=ne;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$Yj=ee;function fe(ne){return ne.allBasenames||[]}e.$Zj=fe;function ue(ne){return ne.allPaths||[]}e.$1j=ue;function j(ne,x){const G=q(Object.getOwnPropertyNames(ne).map(B=>H(B,ne[B],x)).filter(B=>B!==o)),se=G.length;if(!se)return o;if(!G.some(B=>!!B.requiresSiblings)){if(se===1)return G[0];const B=function(z,_){let Q;for(let K=0,X=G.length;K<X;K++){const Y=G[K](z,_);if(typeof Y=="string")return Y;(0,C.$3g)(Y)&&(Q||(Q=[]),Q.push(Y))}return Q?(async()=>{for(const K of Q){const X=await K;if(typeof X=="string")return X}return null})():null},W=G.find(z=>!!z.allBasenames);W&&(B.allBasenames=W.allBasenames);const F=G.reduce((z,_)=>_.allPaths?z.concat(_.allPaths):z,[]);return F.length&&(B.allPaths=F),B}const ce=function(B,W,F){let z,_;for(let Q=0,K=G.length;Q<K;Q++){const X=G[Q];X.requiresSiblings&&F&&(W||(W=(0,k.$nc)(B)),z||(z=W.substr(0,W.length-(0,k.$oc)(B).length)));const Y=X(B,W,z,F);if(typeof Y=="string")return Y;(0,C.$3g)(Y)&&(_||(_=[]),_.push(Y))}return _?(async()=>{for(const Q of _){const K=await Q;if(typeof K=="string")return K}return null})():null},re=G.find(B=>!!B.allBasenames);re&&(ce.allBasenames=re.allBasenames);const ge=G.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return ge.length&&(ce.allPaths=ge),ce}function H(ne,x,G){if(x===!1)return o;const se=n(ne,G);if(se===o)return o;if(typeof x=="boolean")return se;if(x){const ce=x.when;if(typeof ce=="string"){const re=(ge,B,W,F)=>{if(!F||!se(ge,B))return null;const z=ce.replace("$(basename)",()=>W),_=F(z);return(0,C.$3g)(_)?_.then(Q=>Q?ne:null):_?ne:null};return re.requiresSiblings=!0,re}}return se}function q(ne,x){const G=ne.filter(B=>!!B.basenames);if(G.length<2)return ne;const se=G.reduce((B,W)=>{const F=W.basenames;return F?B.concat(F):B},[]);let ce;if(x){ce=[];for(let B=0,W=se.length;B<W;B++)ce.push(x)}else ce=G.reduce((B,W)=>{const F=W.patterns;return F?B.concat(F):B},[]);const re=function(B,W){if(typeof B!="string")return null;if(!W){let z;for(z=B.length;z>0;z--){const _=B.charCodeAt(z-1);if(_===47||_===92)break}W=B.substr(z)}const F=se.indexOf(W);return F!==-1?ce[F]:null};re.basenames=se,re.patterns=ce,re.allBasenames=se;const ge=ne.filter(B=>!B.basenames);return ge.push(re),ge}function J(ne,x){return(0,y.$ub)(ne,x,(G,se)=>typeof G=="string"&&typeof se=="string"?G===se:typeof G!="string"&&typeof se!="string"?G.base===se.base&&G.pattern===se.pattern:!1)}e.$2j=J}),define(Ee[101],ke([1,0,8,153,19,17,4]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class v{constructor(g="",h=!1){if(this.value=g,typeof this.value!="string")throw(0,y.$7)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(g,h=0){return this.value+=w(this.supportThemeIcons?(0,C.$mk)(g):g).replace(/([ \t]+)/g,(f,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,h){return this.value+=`
${m(h,g)}
`,this}appendLink(g,h,f){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(g),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(g,h){const f=new RegExp((0,S.$Xe)(h),"g");return g.replace(f,(l,t)=>g.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$sk=v;function p(u){return D(u)?!u.value:Array.isArray(u)?u.every(p):!0}e.$tk=p;function D(u){return u instanceof v?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$uk=D;function E(u,g){return u===g?!0:!u||!g?!1:u.value===g.value&&u.isTrusted===g.isTrusted&&u.supportThemeIcons===g.supportThemeIcons&&u.supportHtml===g.supportHtml&&(u.baseUri===g.baseUri||!!u.baseUri&&!!g.baseUri&&(0,s.$Kg)(k.URI.from(u.baseUri),k.URI.from(g.baseUri)))}e.$vk=E;function w(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$wk=w;function m(u,g){const h=u.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,f=h>=3?h+1:3;return[`${"`".repeat(f)}${g}`,u,`${"`".repeat(f)}`].join(`
`)}e.$xk=m;function d(u){return u.replace(/"/g,"&quot;")}e.$yk=d;function c(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$zk=c;function b(u){const g=[],h=u.split("|").map(l=>l.trim());u=h[0];const f=h[1];if(f){const l=/height=(\d+)/.exec(f),t=/width=(\d+)/.exec(f),r=l?l[1]:"",o=t?t[1]:"",n=isFinite(parseInt(o)),i=isFinite(parseInt(r));n&&g.push(`width="${o}"`),i&&g.push(`height="${r}"`)}return{href:u,dimensions:g}}e.$Ak=b}),define(Ee[156],ke([1,0,18,39,7,3,19,17]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=void 0;function v(n,i){const{os:a,tildify:$,relative:A}=i;if(A){const O=p(n,A,a);if(typeof O=="string")return O}let R=n.fsPath;if(a===1&&!S.$c?R=R.replace(/\//g,"\\"):a!==1&&S.$c&&(R=R.replace(/\\/g,"/")),a!==1&&$?.userHome){const O=$.userHome.fsPath;let M;n.scheme!==$.userHome.scheme&&n.path[0]===s.$gc.sep&&n.path[1]!==s.$gc.sep?M=$.userHome.with({path:n.path}).fsPath:M=R,R=w(M,O,a)}return(a===1?s.$fc:s.$gc).normalize(D(R,a===1))}e.$9v=v;function p(n,i,a){const $=a===1?s.$fc:s.$gc,A=a===3?k.$Hg:k.$Jg,R=i.getWorkspace(),I=(0,y.$Ob)(R.folders);if(!I)return;n.scheme!==I.uri.scheme&&n.path[0]===s.$gc.sep&&n.path[1]!==s.$gc.sep&&(n=I.uri.with({path:n.path}));const O=i.getWorkspaceFolder(n);if(!O)return;let M;if(A.isEqual(O.uri,n)?M="":M=A.relativePath(O.uri,n)??"",M&&(M=$.normalize(M)),R.folders.length>1&&!i.noPrefix){const Z=O.name?O.name:A.basenameOrAuthority(O.uri);M=M?`${Z} \u2022 ${M}`:Z}return M}function D(n,i=S.$c){return(0,C.$jg)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$0v=D;let E=Object.create(null);function w(n,i,a=S.OS){if(a===1||!n||!i)return n;let $=E.original===i?E.normalized:void 0;$||($=i,S.$c&&($=(0,C.$_f)($)),$=`${(0,P.$4e)($,s.$gc.sep)}${s.$gc.sep}`,E={original:i,normalized:$});let A=n;return S.$c&&(A=(0,C.$_f)(A)),(a===3?A.startsWith($):(0,P.$kf)(A,$))?`~/${A.substr($.length)}`:n}e.$$v=w;function m(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.$_v=m;const d="\u2026",c="\\\\",b="~";function u(n,i=s.sep){const a=new Array(n.length);let $=!1;for(let A=0;A<n.length;A++){const R=n[A];if(R===""){a[A]=`.${i}`;continue}if(!R){a[A]=R;continue}$=!0;let I="",O=R;O.indexOf(c)===0?(I=O.substr(0,O.indexOf(c)+c.length),O=O.substr(O.indexOf(c)+c.length)):O.indexOf(i)===0?(I=O.substr(0,O.indexOf(i)+i.length),O=O.substr(O.indexOf(i)+i.length)):O.indexOf(b)===0&&(I=O.substr(0,O.indexOf(b)+b.length),O=O.substr(O.indexOf(b)+b.length));const M=O.split(i);for(let Z=1;$&&Z<=M.length;Z++)for(let ee=M.length-Z;$&&ee>=0;ee--){$=!1;let fe=M.slice(ee,ee+Z).join(i);for(let ue=0;!$&&ue<n.length;ue++)if(ue!==A&&n[ue]&&n[ue].indexOf(fe)>-1){const j=ee+Z===M.length,H=ee>0&&n[ue].indexOf(i)>-1?i+fe:fe,q=n[ue].endsWith(H);$=!j||q}if(!$){let ue="";(M[0].endsWith(":")||I!=="")&&(ee===1&&(ee=0,Z++,fe=M[0]+i+fe),ee>0&&(ue=M[0]+i),ue=I+ue),ee>0&&(ue=ue+d+i),ue=ue+fe,ee+Z<M.length&&(ue=ue+i+d),a[A]=ue}}$&&(a[A]=R)}return a}e.$aw=u;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function h(n,i=Object.create(null)){const a=[];let $=!1,A="";for(const R of n)if(R==="$"||$&&R==="{")A&&a.push({value:A,type:g.TEXT}),A="",$=!0;else if(R==="}"&&$){const I=i[A];if(typeof I=="string")I.length&&a.push({value:I,type:g.VARIABLE});else if(I){const O=a[a.length-1];(!O||O.type!==g.SEPARATOR)&&a.push({value:I.label,type:g.SEPARATOR})}A="",$=!1}else A+=R;return A&&!$&&a.push({value:A,type:g.TEXT}),a.filter((R,I)=>{if(R.type===g.SEPARATOR){const O=a[I-1],M=a[I+1];return[O,M].every(Z=>Z&&(Z.type===g.VARIABLE||Z.type===g.TEXT)&&Z.value.length>0)}return!0}).map(R=>R.value).join("")}e.$bw=h;function f(n,i){return S.$d||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.$d?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$cw=f;function l(n,i){return S.$d||i?n.replace(/\(&&\w\)|&&/g,""):S.$c?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$dw=l;function t(n){return n.replace(/&/g,"&&")}e.$ew=t;function r(n){if(n.endsWith("]")){const i=n.lastIndexOf(" [",n.length-2);if(i!==-1){const a=o(n.substring(0,i)),$=n.substring(i);return{name:a.name+$,parentPath:a.parentPath}}}return o(n)}e.$fw=r;function o(n){const i=n.indexOf("/")!==-1?s.$gc:s.$fc,a=i.basename(n),$=i.dirname(n);return a.length?{name:a,parentPath:$}:{name:$,parentPath:""}}}),define(Ee[53],ke([1,0,14,4]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function s(E){return E.toJSON()}class S{constructor(w){this.a=w}transformIncoming(w){const m=this.a.transformIncoming(w);return m===w?w:s(C.URI.from(m))}transformOutgoing(w){const m=this.a.transformOutgoing(w);return m===w?w:s(C.URI.from(m))}transformOutgoingURI(w){const m=this.a.transformOutgoing(w);return m===w?w:C.URI.from(m)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$en=S,e.$fn=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function k(E,w,m){if(!E||m>200)return null;if(typeof E=="object"){if(E instanceof C.URI)return w.transformOutgoing(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const c=k(E[d],w,m+1);c!==null&&(E[d]=c)}}return null}function P(E,w){const m=k(E,w,0);return m===null?E:m}e.$gn=P;function v(E,w,m,d){if(!E||d>200)return null;if(typeof E=="object"){if(E.$mid===1)return m?C.URI.revive(w.transformIncoming(E)):w.transformIncoming(E);if(E instanceof y.$se)return null;for(const c in E)if(Object.hasOwnProperty.call(E,c)){const b=v(E[c],w,m,d+1);b!==null&&(E[c]=b)}}return null}function p(E,w){const m=v(E,w,!1,0);return m===null?E:m}e.$hn=p;function D(E,w){const m=v(E,w,!0,0);return m===null?E:m}e.$in=D}),define(Ee[22],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(s){return y.test(s)}e.$zg=C,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let v=0;v<P.length;v++)P[v]=Math.floor(Math.random()*256);return P};const S=new Uint8Array(16),k=[];for(let P=0;P<256;P++)k.push(P.toString(16).padStart(2,"0"));return function(){s(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let v=0,p="";return p+=k[S[v++]],p+=k[S[v++]],p+=k[S[v++]],p+=k[S[v++]],p+="-",p+=k[S[v++]],p+=k[S[v++]],p+="-",p+=k[S[v++]],p+=k[S[v++]],p+="-",p+=k[S[v++]],p+=k[S[v++]],p+="-",p+=k[S[v++]],p+=k[S[v++]],p+=k[S[v++]],p+=k[S[v++]],p+=k[S[v++]],p+=k[S[v++]],p}}()}),define(Ee[157],ke([1,0,18,49,22]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.$Bt=e.$At=e.$zt=void 0;function S(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$zt=S;function k(E,w,m){const d={id:(0,s.$Ag)(),name:E,uri:w,data:m};return{asString:async()=>"",asFile:()=>d,value:void 0}}e.$At=k;class P{constructor(){this.a=new Map}get size(){let w=0;for(const m of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const m=[...this.a.keys()];return C.Iterable.some(this,([d,c])=>c.asFile())&&m.push("files"),D(v(w),m)}get(w){return this.a.get(this.b(w))?.[0]}append(w,m){const d=this.a.get(w);d?d.push(m):this.a.set(this.b(w),[m])}replace(w,m){this.a.set(this.b(w),[m])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,m]of this.a)for(const d of m)yield[w,d]}b(w){return v(w)}}e.$Bt=P;function v(E){return E.toLowerCase()}function p(E,w){return D(v(E),w.map(v))}e.$Ct=p;function D(E,w){if(E==="*/*")return w.length>0;if(w.includes(E))return!0;const m=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!m)return!1;const[d,c,b]=m;return b==="*"?w.some(u=>u.startsWith(c+"/")):!1}e.$Dt=Object.freeze({create:E=>(0,y.$Mb)(E.map(w=>w.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Dt.split(E).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function le(e,y,C){function s(m){return new Promise(d=>y.exists(m,d))}function S(m){return new Promise((d,c)=>{const b=new Date;y.utimes(m,b,b,u=>u?c(u):d())})}function k(m){return new Promise((d,c)=>y.mkdir(m,{recursive:!0},b=>b&&b.code!=="EEXIST"?c(b):d(m)))}function P(m){return new Promise((d,c)=>y.rm(m,{recursive:!0,force:!0,maxRetries:3},b=>b?c(b):d()))}function v(m){return new Promise((d,c)=>y.readFile(m,"utf8",(b,u)=>b?c(b):d(u)))}function p(m,d){return new Promise((c,b)=>y.writeFile(m,d,"utf8",u=>u?b(u):c()))}async function D(m){const d=e.join(m,"languagepacks.json");try{return JSON.parse(await v(d))}catch{}}function E(m,d){try{for(;d;){if(m[d])return d;{const c=d.lastIndexOf("-");if(c>0)d=d.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function w(m,d,c,b,u){const g=function(f){return C.mark("code/didGenerateNls"),Promise.resolve({locale:f,osLocale:u,availableLanguages:{}})};if(C.mark("code/willGenerateNls"),b==="pseudo")return Promise.resolve({locale:b,osLocale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:b,osLocale:u,availableLanguages:{}});if(b&&(b==="en"||b==="en-us"))return Promise.resolve({locale:b,osLocale:u,availableLanguages:{}});const h=b;try{return m?D(d).then(f=>{if(!f)return g(h);const l=E(f,b);if(!l)return g(h);b=l;const t=f[b];let r;return!t||typeof t.hash!="string"||!t.translations||typeof(r=t.translations.vscode)!="string"?g(h):s(r).then(o=>{if(!o)return g(h);const n=t.hash+"."+b,i=e.join(d,"clp",n),a=e.join(i,m),$=e.join(i,"tcf.json"),A=e.join(i,"corrupted.info"),R={locale:h,osLocale:u,availableLanguages:{"*":b},_languagePackId:n,_translationsConfigFile:$,_cacheRoot:i,_resolvedLanguagePackCoreLocation:a,_corruptedFile:A};return s(A).then(I=>{let O;return I?O=P(i):O=Promise.resolve(void 0),O.then(()=>s(a).then(M=>M?(S(a).catch(()=>{}),C.mark("code/didGenerateNls"),R):k(a).then(()=>Promise.all([v(c),v(r)])).then(Z=>{const ee=JSON.parse(Z[0]),fe=JSON.parse(Z[1]).contents,ue=Object.keys(ee.bundles),j=[];for(const H of ue){const q=ee.bundles[H],J=Object.create(null);for(const ne of q){const x=ee.keys[ne],G=ee.messages[ne],se=fe[ne];let ce;if(se){ce=[];for(let re=0;re<x.length;re++){const ge=x[re],B=typeof ge=="string"?ge:ge.key;let W=se[B];W===void 0&&(W=G[re]),ce.push(W)}}else ce=G;J[ne]=ce}j.push(p(e.join(a,H.replace(/\//g,"!")+".nls.json"),JSON.stringify(J)))}return j.push(p($,JSON.stringify(t.translations))),Promise.all(j)}).then(()=>(C.mark("code/didGenerateNls"),R)).catch(Z=>(console.error("Generating translation files failed.",Z),g(b)))))})})}):g(h)}catch(f){return console.error("Generating translation files failed.",f),g(b)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(Ee[158],ke([78,29,42]),function(e,y,C){return le(e,y,C)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),C=require("../common/performance");module.exports=le(e,y,C)}else throw new Error("Unknown context")}(),define(Ee[159],ke([1,0,27]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(k){const P=k.replace(/\-/g,":").toLowerCase();return!C.has(P)}function S(){const k=(0,y.networkInterfaces)();for(const P in k){const v=k[P];if(v){for(const{mac:p}of v)if(s(p))return p}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$jn=S}),define(Ee[102],ke([1,0,27,66,22,159,3]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=void 0,e.$kn=new class{c(w){return this.a||(this.a=C.$ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,m=0;const d=(0,y.networkInterfaces)();for(const c in d){const b=d[c];if(b)for(const{mac:u,internal:g}of b)g||(m+=1,this.c(u.toUpperCase())&&(w+=1))}this.b=m>0?w/m:0}return this.b}};let P;async function v(w){return P||(P=(async()=>await p(w)||s.$Ag())()),P}e.$ln=v;async function p(w){try{const m=await new Promise((c,b)=>{le(["crypto"],c,b)}),d=(0,S.$jn)();return m.createHash("sha256").update(d,"utf8").digest("hex")}catch(m){w(m);return}}const D="Software\\Microsoft\\SQMClient";async function E(w){if(k.$c){const m=await new Promise((d,c)=>{le(["@vscode/windows-registry"],d,c)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch(d){return w(d),""}}return""}e.$mn=E}),define(Ee[160],ke([1,0,29,300,301,3]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bg=void 0;async function k(P){if(S.$d||S.$c)return;let v;for(const p of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{v=await(0,C.open)(p,y.constants.R_OK);break}catch{}if(!v){P("Unable to retrieve release information from known identifier paths.");return}try{const p=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),D={id:"unknown"};for await(const E of(0,s.createInterface)({input:v.createReadStream(),crlfDelay:1/0})){if(!E.includes("="))continue;const w=E.split("=")[0].toUpperCase().trim();if(p.has(w)){const m=E.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?D.id=m:w==="ID_LIKE"?D.id_like=m:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(D.version_id=m)}}return D}catch(p){P(p)}}e.$Bg=k}),define(Ee[23],ke([1,0,29,27,302,15,39,99,7,3,19,4]),function(le,e,y,C,s,S,k,P,v,p,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function m(H,q=w.UNLINK,J){if((0,k.$ig)(H))throw new Error("rimraf - will refuse to recursively delete root");return q===w.UNLINK?c(H):d(H,J)}async function d(H,q=(0,k.$ng)((0,C.tmpdir)())){try{try{await y.promises.rename(H,q)}catch(J){return J.code==="ENOENT"?void 0:c(H)}c(q).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function c(H){return(0,s.promisify)(y.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function b(H){if((0,k.$ig)(H))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function u(H,q){return f(await(q?g(H):(0,s.promisify)(y.readdir)(H)))}async function g(H){try{return await(0,s.promisify)(y.readdir)(H,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const q=[],J=await u(H);for(const ne of J){let x=!1,G=!1,se=!1;try{const ce=await e.Promises.lstat((0,v.$jc)(H,ne));x=ce.isFile(),G=ce.isDirectory(),se=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}q.push({name:ne,isFile:()=>x,isDirectory:()=>G,isSymbolicLink:()=>se})}return q}function h(H){return f(y.readdirSync(H))}e.readdirSync=h;function f(H){return H.map(q=>typeof q=="string"?p.$d?(0,P.$Sl)(q):q:(q.name=p.$d?(0,P.$Sl)(q.name):q.name,q))}async function l(H){const q=await u(H),J=[];for(const ne of q)await r.existsDirectory((0,v.$jc)(H,ne))&&J.push(ne);return J}function t(H,q=1e3){return new Promise(J=>{let ne=!1;const x=setInterval(()=>{ne||(ne=!0,y.access(H,G=>{ne=!1,G&&(clearInterval(x),J(void 0))}))},q)})}e.whenDeleted=t;var r;(function(H){async function q(x){let G;try{if(G=await e.Promises.lstat(x),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(se){if(se.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(p.$c&&se.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ce}throw se}}H.stat=q;async function J(x){try{const{stat:G,symbolicLink:se}=await H.stat(x);return G.isFile()&&se?.dangling!==!0}catch{}return!1}H.existsFile=J;async function ne(x){try{const{stat:G,symbolicLink:se}=await H.stat(x);return G.isDirectory()&&se?.dangling!==!0}catch{}return!1}H.existsDirectory=ne})(r||(e.SymlinkSupport=r={}));const o=new S.$nh;function n(H,q,J){return o.queueFor(E.URI.file(H),()=>{const ne=R(J);return new Promise((x,G)=>$(H,q,ne,se=>se?G(se):x()))},D.$Ig)}let i=!0;function a(H){i=H}e.configureFlushOnWrite=a;function $(H,q,J,ne){if(!i)return y.writeFile(H,q,{mode:J.mode,flag:J.flag},ne);y.open(H,J.flag,J.mode,(x,G)=>{if(x)return ne(x);y.writeFile(G,q,se=>{if(se)return y.close(G,()=>ne(se));y.fdatasync(G,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),a(!1)),y.close(G,re=>ne(re))))})})}function A(H,q,J){const ne=R(J);if(!i)return y.writeFileSync(H,q,{mode:ne.mode,flag:ne.flag});const x=y.openSync(H,ne.flag,ne.mode);try{y.writeFileSync(x,q);try{y.fdatasyncSync(x)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),a(!1)}}finally{y.closeSync(x)}}e.writeFileSync=A;function R(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function I(H,q,J=6e4){if(H!==q)try{p.$c&&typeof J=="number"?await O(H,q,Date.now(),J):await(0,s.promisify)(y.rename)(H,q)}catch(ne){if(H.toLowerCase()!==q.toLowerCase()&&ne.code==="EXDEV"||H.endsWith("."))await M(H,q,{preserveSymlinks:!1}),await m(H,w.MOVE);else throw ne}}async function O(H,q,J,ne,x=0){try{return await(0,s.promisify)(y.rename)(H,q)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-J>=ne)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${G}`),G;if(x===0){let se=!1;try{const{stat:ce}=await r.stat(q);ce.isFile()||(se=!0)}catch{}if(se)throw G}return await(0,S.$fh)(Math.min(100,x*10)),O(H,q,J,ne,x+1)}}async function M(H,q,J){return ee(H,q,{root:{source:H,target:q},options:J,handledSourcePaths:new Set})}const Z=511;async function ee(H,q,J){if(J.handledSourcePaths.has(H))return;J.handledSourcePaths.add(H);const{stat:ne,symbolicLink:x}=await r.stat(H);if(x){if(J.options.preserveSymlinks)try{return await j(H,q,J)}catch{}if(x.dangling)return}return ne.isDirectory()?fe(H,q,ne.mode&Z,J):ue(H,q,ne.mode&Z)}async function fe(H,q,J,ne){await e.Promises.mkdir(q,{recursive:!0,mode:J});const x=await u(H);for(const G of x)await ee((0,v.$jc)(H,G),(0,v.$jc)(q,G),ne)}async function ue(H,q,J){await e.Promises.copyFile(H,q),await e.Promises.chmod(q,J)}async function j(H,q,J){let ne=await e.Promises.readlink(H);(0,k.$fg)(ne,J.root.source,!p.$e)&&(ne=(0,v.$jc)(J.root.target,ne.substr(J.root.source.length+1))),await e.Promises.symlink(ne,q)}e.Promises=new class{get access(){return(0,s.promisify)(y.access)}get stat(){return(0,s.promisify)(y.stat)}get lstat(){return(0,s.promisify)(y.lstat)}get utimes(){return(0,s.promisify)(y.utimes)}get read(){return(H,q,J,ne,x)=>new Promise((G,se)=>{y.read(H,q,J,ne,x,(ce,re,ge)=>ce?se(ce):G({bytesRead:re,buffer:ge}))})}get readFile(){return(0,s.promisify)(y.readFile)}get write(){return(H,q,J,ne,x)=>new Promise((G,se)=>{y.write(H,q,J,ne,x,(ce,re,ge)=>ce?se(ce):G({bytesWritten:re,buffer:ge}))})}get appendFile(){return(0,s.promisify)(y.appendFile)}get fdatasync(){return(0,s.promisify)(y.fdatasync)}get truncate(){return(0,s.promisify)(y.truncate)}get copyFile(){return(0,s.promisify)(y.copyFile)}get open(){return(0,s.promisify)(y.open)}get close(){return(0,s.promisify)(y.close)}get symlink(){return(0,s.promisify)(y.symlink)}get readlink(){return(0,s.promisify)(y.readlink)}get chmod(){return(0,s.promisify)(y.chmod)}get mkdir(){return(0,s.promisify)(y.mkdir)}get unlink(){return(0,s.promisify)(y.unlink)}get rmdir(){return(0,s.promisify)(y.rmdir)}get realpath(){return(0,s.promisify)(y.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return m}get rename(){return I}get copy(){return M}}}),define(Ee[161],ke([1,0,29,7,3,17,23]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.$Fq=void 0;function P(w){if(s.$e)return w;const m=(0,C.$mc)(w);if(w===m)return w;const d=((0,C.$nc)(w)||w).toLowerCase();try{const b=(0,k.readdirSync)(m).filter(u=>u.toLowerCase()===d);if(b.length===1){const u=P(m);if(u)return(0,C.$jc)(u,b[0])}else if(b.length>1){const u=b.indexOf(d);if(u>=0){const g=P(m);if(g)return(0,C.$jc)(g,b[u])}}}catch{}return null}e.$Fq=P;async function v(w){if(s.$e)return w;const m=(0,C.$mc)(w);if(w===m)return w;const d=((0,C.$nc)(w)||w).toLowerCase();try{const b=(await k.Promises.readdir(m)).filter(u=>u.toLowerCase()===d);if(b.length===1){const u=await v(m);if(u)return(0,C.$jc)(u,b[0])}else if(b.length>1){const u=b.indexOf(d);if(u>=0){const g=await v(m);if(g)return(0,C.$jc)(g,b[u])}}}catch{}return null}e.$Gq=v;async function p(w){try{return await k.Promises.realpath(w)}catch{const d=E(w);return await k.Promises.access(d,y.constants.R_OK),d}}e.$Hq=p;function D(w){try{return y.realpathSync(w)}catch{const d=E(w);return y.accessSync(d,y.constants.R_OK),d}}e.$Iq=D;function E(w){return(0,S.$4e)((0,C.$hc)(w),C.sep)}}),define(Ee[162],ke([1,0,79]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.$Dg=e.$Cg=void 0;function C(P,v,p,D=1){let E=!1;return new Promise(w=>{const m=setTimeout(()=>{if(!E)return E=!0,w(0)},p);s(P,v,D,d=>{if(!E)return E=!0,clearTimeout(m),w(d)})})}e.$Cg=C;function s(P,v,p,D){if(v===0)return D(0);const E=new y.Socket;E.once("connect",()=>(k(E),s(P+p,v-1,p,D))),E.once("data",()=>{}),E.once("error",w=>(k(E),w.code!=="ECONNREFUSED"?s(P+p,v-1,p,D):D(P))),E.connect(P,"127.0.0.1")}e.$Dg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function S(P,v,p,D="127.0.0.1"){let E=!1,w,m=1;const d=y.createServer({pauseOnConnect:!0});function c(b,u){E||(E=!0,d.removeAllListeners(),d.close(),w&&clearTimeout(w),u(b))}return new Promise(b=>{w=setTimeout(()=>{c(0,b)},p),d.on("listening",()=>{c(P,b)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&m<v?(P++,m++,d.listen(P,D)):c(0,b)}),d.on("close",()=>{c(0,b)}),d.listen(P,D)})}e.$Eg=S;function k(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(v){console.error(v)}}}),define(Ee[103],ke([1,0,27,7,23]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0;const S=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var v;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(v||(v={}));let p;switch(process.arch){case"ia32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class E{constructor(l,t,r){this.exePath=l,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:f=!1}={}){return f?p===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:f=!1,findPreview:l=!1}={}){const t=w({useAlternateBitness:f});if(!t)return null;const r=C.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(r))return null;let o=-1,n=null;for(const $ of await s.Promises.readdir(r)){let A=-1;if(l){const I=$.indexOf("-");if(I<0)continue;const O=$.substring(0,I);if(!S.test(O)||$.substring(I+1)!=="preview")continue;A=parseInt(O,10)}else{if(!S.test($))continue;A=parseInt($,10)}if(A<=o)continue;const R=C.$jc(r,$,"pwsh.exe");await s.SymlinkSupport.existsFile(R)&&(n=R,o=A)}if(!n)return null;const i=t.includes("x86")?" (x86)":"",a=l?" Preview":"";return new E(n,`PowerShell${a}${i}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const l=C.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const o of await s.Promises.readdir(l))if(t.test(o)){const n=C.$jc(l,o,"pwsh.exe");return new E(n,r)}return null}function c(){const f=C.$jc(y.homedir(),".dotnet","tools","pwsh.exe");return new E(f,".NET Core PowerShell Global Tool")}function b(){const f=C.$jc(process.env.windir,p===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(f,"Windows PowerShell",!0)}async function*u(){let f=await m();f&&(yield f),f=await m({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=c(),f&&(yield f),f=await m({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await m({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=b(),f&&(yield f)}async function*g(){for await(const f of u())await f.exists()&&(yield f)}e.$2l=g;async function h(){for await(const f of g())return f;return null}e.$3l=h}),define(Ee[104],ke([1,0,7,3,28,62,9,23]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$7l=e.$6l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return S.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return S.TerminateResponseCode}});function v(E=s.env){return E.comspec||"cmd.exe"}e.$6l=v;function p(E){let w=[],m=!1;const d=function(c){if(m){w.push(c);return}(!E.send(c,u=>{if(u&&console.error(u),m=!1,w.length>0){const g=w.slice(0);w=[],g.forEach(h=>d(h))}})||C.$c)&&(m=!0)};return{send:d}}e.$7l=p;var D;(function(E){async function w(m,d,c){if(y.$ic(m))return m;if(d===void 0&&(d=s.cwd()),y.$mc(m)!=="."||(c===void 0&&k.$Sf(s.env.PATH)&&(c=s.env.PATH.split(y.$tc)),c===void 0||c.length===0))return y.$jc(d,m);async function u(g){if(await P.Promises.exists(g)){let h;try{h=await P.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(h=await P.Promises.lstat(g))}return h?!h.isDirectory():!1}return!1}for(const g of c){let h;if(y.$ic(g)?h=y.$jc(g,m):h=y.$jc(d,g,m),await u(h))return h;let f=h+".com";if(await u(f)||(f=h+".exe",await u(f)))return f}return y.$jc(d,m)}E.findExecutable=w})(D||(e.win32=D={}))}),define(Ee[105],ke([1,0,54,12]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;function s(k){return new Promise((P,v)=>{let p;const D=new Map;function E(m,d,c,b,u){const g=D.get(d);if(m===k||g){const h={name:w(c),cmd:c,pid:m,ppid:d,load:b,mem:u};D.set(m,h),m===k&&(p=h),g&&(g.children||(g.children=[]),g.children.push(h),g.children.length>1&&(g.children=g.children.sort((f,l)=>f.pid-l.pid)))}}function w(m){const d=/--utility-sub-type=network/i,c=/--crashes-directory/i,b=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(c.exec(m))return"electron-crash-reporter";if(b.exec(m))return"winpty-agent";if(u.exec(m))return"conpty-agent";let h=g.exec(m);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?d.exec(m)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const f=/[a-zA-Z-]+\.js/g;let l="";do h=f.exec(m),h&&(l+=h+" ");while(h);return l&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${l})`:m}if(process.platform==="win32"){const m=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,c)=>{le(["@vscode/windows-process-tree"],d,c)}).then(d=>{d.getProcessList(k,c=>{if(!c){v(new Error(`Root process ${k} not found`));return}d.getProcessCpuUsage(c,b=>{const u=new Map;b.forEach(g=>{const h=m(g.commandLine||"");u.set(g.pid,{name:w(h),cmd:h,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),p=u.get(k),p?(u.forEach(g=>{const h=u.get(g.ppid);h&&(h.children||(h.children=[]),h.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((h,f)=>h.pid-f.pid))}),P(p)):v(new Error(`Root process ${k} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let m=function(){let d=[p];const c=[];for(;d.length;){const u=d.shift();u&&(c.push(u.pid),u.children&&(d=d.concat(u.children)))}let b=JSON.stringify(C.$yg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+c.join(" "),(0,y.exec)(b,{},(u,g,h)=>{if(u||h)v(u||new Error(h.toString()));else{const f=g.toString().split(`
`);for(let l=0;l<c.length;l++){const t=D.get(c[l]);t.load=parseFloat(f[l])}if(!p){v(new Error(`Root process ${k} not found`));return}P(p)}})};(0,y.exec)("which ps",{},(d,c,b)=>{if(d||b)if(process.platform!=="linux")v(d||new Error(b.toString()));else{const u=JSON.stringify(C.$yg.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(u,{},(g,h,f)=>{g||f?v(g||new Error(f.toString())):(S(h,E),m())})}else{const u=c.toString().trim();(0,y.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,f,l)=>{h||l&&!l.includes("screen size is bogus")?v(h||new Error(l.toString())):(S(f,E),process.platform==="linux"?m():p?P(p):v(new Error(`Root process ${k} not found`)))})}})}})}e.$es=s;function S(k,P){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=k.toString().split(`
`);for(const D of p){const E=v.exec(D.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Ee[106],ke([1,0,27,3,103,104]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=void 0;async function k(E,w){return E===1?C.$c?D():S.$6l(w):v(E,w)}e.$8l=k;let P=null;function v(E,w){if(C.$e&&E===2||C.$d&&E===3)return"/bin/bash";if(!P){let m;if(C.$c)m="/bin/bash";else{if(m=w.SHELL,!m)try{m=(0,y.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}P=m}return P}let p=null;async function D(){return p||(p=(await(0,s.$3l)()).exePath),p}}),function(){function le(){function e(){return process.uncHostAllowlist}function y(v){const p=new Set;if(Array.isArray(v))for(const D of v)typeof D=="string"&&p.add(D);return Array.from(p)}function C(){const v=e();return v?Array.from(v):[]}function s(v){if(process.platform!=="win32")return;const p=e();if(p)if(typeof v=="string")p.add(v.toLowerCase());else for(const D of y(v))s(D)}function S(v){if(typeof v!="string")return;const p=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let D;for(const E of p){if(v.indexOf(E)!==0)continue;const m=v.indexOf("\\",E.length);if(m===-1)continue;const d=v.substring(E.length,m);if(d){D=d;break}}return D}function k(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:s,getUNCHost:S,disableUNCAccessRestrictions:k,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return le()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=le():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Le=this&&this.__decorate||function(le,e,y,C){var s=arguments.length,S=s<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,y):C,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(le,e,y,C);else for(var P=le.length-1;P>=0;P--)(k=le[P])&&(S=(s<3?k(S):s>3?k(e,y,S):k(e,y))||S);return s>3&&S&&Object.defineProperty(e,y,S),S};define(Ee[43],ke([1,0,18,15,14,20,75,8,6,2,52,17,9]),function(le,e,y,C,s,S,k,P,v,p,D,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.ProxyChannel=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.RequestInitiator=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;var m;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(m||(m={}));function d(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(c||(c={}));function b(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(u||(u={}));function g(x){let G=0;for(let se=0;;se+=7){const ce=x.read(1);if(G|=(ce.buffer[0]&127)<<se,!(ce.buffer[0]&128))return G}}const h=o(0);function f(x,G){if(G===0){x.write(h);return}let se=0;for(let re=G;re!==0;re=re>>>7)se++;const ce=s.$se.alloc(se);for(let re=0;G!==0;re++)ce.buffer[re]=G&127,G=G>>>7,G>0&&(ce.buffer[re]|=128);x.write(ce)}class l{constructor(G){this.b=G,this.a=0}read(G){const se=this.b.slice(this.a,this.a+G);return this.a+=se.byteLength,se}}e.$Oh=l;class t{constructor(){this.a=[]}get buffer(){return s.$se.concat(this.a)}write(G){this.a.push(G)}}e.$Ph=t;var r;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(r||(r={}));function o(x){const G=s.$se.alloc(1);return G.writeUInt8(x,0),G}const n={Undefined:o(r.Undefined),String:o(r.String),Buffer:o(r.Buffer),VSBuffer:o(r.VSBuffer),Array:o(r.Array),Object:o(r.Object),Uint:o(r.Int)},i=typeof Buffer<"u";function a(x,G){if(typeof G>"u")x.write(n.Undefined);else if(typeof G=="string"){const se=s.$se.fromString(G);x.write(n.String),f(x,se.byteLength),x.write(se)}else if(i&&Buffer.isBuffer(G)){const se=s.$se.wrap(G);x.write(n.Buffer),f(x,se.byteLength),x.write(se)}else if(G instanceof s.$se)x.write(n.VSBuffer),f(x,G.byteLength),x.write(G);else if(Array.isArray(G)){x.write(n.Array),f(x,G.length);for(const se of G)a(x,se)}else if(typeof G=="number"&&(G|0)===G)x.write(n.Uint),f(x,G);else{const se=s.$se.fromString(JSON.stringify(G));x.write(n.Object),f(x,se.byteLength),x.write(se)}}e.$Qh=a;function $(x){switch(x.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return x.read(g(x)).toString();case r.Buffer:return x.read(g(x)).buffer;case r.VSBuffer:return x.read(g(x));case r.Array:{const se=g(x),ce=[];for(let re=0;re<se;re++)ce.push($(x));return ce}case r.Object:return JSON.parse(x.read(g(x)).toString());case r.Int:return g(x)}}e.$Rh=$;class A{constructor(G,se,ce=null,re=1e3){this.h=G,this.j=se,this.k=ce,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.q(ge)),this.m({type:200})}registerChannel(G,se){this.b.set(G,se),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const se=this.o([G.type]);this.k?.logOutgoing(se,0,1,b(G.type));return}case 201:case 202:case 204:case 203:{const se=this.o([G.type,G.id],G.data);this.k?.logOutgoing(se,G.id,1,b(G.type),G.data);return}}}o(G,se=void 0){const ce=new t;return a(ce,G),a(ce,se),this.p(ce.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const se=new l(G),ce=$(se),re=$(se),ge=ce[0];switch(ge){case 100:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d(ge)}: ${ce[2]}.${ce[3]}`,re),this.s({type:ge,id:ce[1],channelName:ce[2],name:ce[3],arg:re});case 102:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d(ge)}: ${ce[2]}.${ce[3]}`,re),this.t({type:ge,id:ce[1],channelName:ce[2],name:ce[3],arg:re});case 101:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d(ge)}`),this.u({type:ge,id:ce[1]});case 103:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d(ge)}`),this.u({type:ge,id:ce[1]})}}s(G){const se=this.b.get(G.channelName);if(!se){this.v(G);return}const ce=new S.$ce;let re;try{re=se.call(this.j,G.name,G.arg,ce.token)}catch(W){re=Promise.reject(W)}const ge=G.id;re.then(W=>{this.m({id:ge,data:W,type:201})},W=>{W instanceof Error?this.m({id:ge,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.m({id:ge,data:W,type:203})}).finally(()=>{B.dispose(),this.d.delete(G.id)});const B=(0,p.$Rc)(()=>ce.cancel());this.d.set(G.id,B)}t(G){const se=this.b.get(G.channelName);if(!se){this.v(G);return}const ce=G.id,ge=se.listen(this.j,G.name,G.arg)(B=>this.m({id:ce,data:B,type:204}));this.d.set(G.id,ge)}u(G){const se=this.d.get(G.id);se&&(se.dispose(),this.d.delete(G.id))}v(G){let se=this.g.get(G.channelName);se||(se=[],this.g.set(G.channelName,se));const ce=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);se.push({request:G,timeoutTimer:ce})}w(G){const se=this.g.get(G);if(se){for(const ce of se)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}e.$Sh=A;var R;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class I{constructor(G,se=null){this.l=G,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=se}getChannel(G){const se=this;return{call(ce,re,ge){return se.a?Promise.reject(new P.$5):se.m(G,ce,re,ge)},listen(ce,re){return se.a?v.Event.None:se.o(G,ce,re)}}}m(G,se,ce,re=S.CancellationToken.None){const ge=this.g++,W={id:ge,type:100,channelName:G,name:se,arg:ce};if(re.isCancellationRequested)return Promise.reject(new P.$5);let F;return new Promise((_,Q)=>{if(re.isCancellationRequested)return Q(new P.$5);const K=()=>{const U=te=>{switch(te.type){case 201:this.f.delete(ge),_(te.data);break;case 202:{this.f.delete(ge);const ie=new Error(te.data.message);ie.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,ie.name=te.data.name,Q(ie);break}case 203:this.f.delete(ge),Q(te.data);break}};this.f.set(ge,U),this.p(W)};let X=null;this.b===u.Idle?K():(X=(0,C.$4g)(U=>this.u()),X.then(()=>{X=null,K()}));const Y=()=>{X?(X.cancel(),X=null):this.p({id:ge,type:101}),Q(new P.$5)},N=re.onCancellationRequested(Y);F=(0,p.$Qc)((0,p.$Rc)(Y),N),this.d.add(F)}).finally(()=>{F.dispose(),this.d.delete(F)})}o(G,se,ce){const re=this.g++,B={id:re,type:102,channelName:G,name:se,arg:ce};let W=null;const F=new v.$5d({onWillAddFirstListener:()=>{W=(0,C.$4g)(_=>this.u()),W.then(()=>{W=null,this.d.add(F),this.p(B)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.d.delete(F),this.p({id:re,type:103}))}}),z=_=>F.fire(_.data);return this.f.set(re,z),F.event}p(G){switch(G.type){case 100:case 102:{const se=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(se,G.id,0,`${d(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const se=this.q([G.type,G.id]);this.j?.logOutgoing(se,G.id,0,d(G.type));return}}}q(G,se=void 0){const ce=new t;return a(ce,G),a(ce,se),this.r(ce.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const se=new l(G),ce=$(se),re=$(se),ge=ce[0];switch(ge){case 200:return this.j?.logIncoming(G.byteLength,0,0,b(ge)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ce[1],0,b(ge),re),this.t({type:ce[0],id:ce[1],data:re})}}t(G){if(G.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}e.$Th=I,Le([k.$Ih],I.prototype,"onDidInitializePromise",null);class O{get connections(){const G=[];return this.f.forEach(se=>G.push(se)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new v.$5d,this.onDidAddConnection=this.g.event,this.h=new v.$5d,this.onDidRemoveConnection=this.h.event,this.j=new p.$Sc,this.j.add(G(({protocol:se,onDidClientDisconnect:ce})=>{const re=v.Event.once(se.onMessage);this.j.add(re(ge=>{const B=new l(ge),W=$(B),F=new A(se,W),z=new I(se);this.a.forEach((Q,K)=>F.registerChannel(K,Q));const _={channelServer:F,channelClient:z,ctx:W};this.f.add(_),this.g.fire(_),this.j.add(ce(()=>{F.dispose(),z.dispose(),this.f.delete(_),this.h.fire(_)}))}))}))}getChannel(G,se){const ce=this;return{call(re,ge,B){let W;if((0,w.$7f)(se)){const z=(0,y.$4b)(ce.connections.filter(se));W=z?Promise.resolve(z):v.Event.toPromise(v.Event.filter(ce.onDidAddConnection,se))}else W=se.routeCall(ce,re,ge);const F=W.then(z=>z.channelClient.getChannel(G));return Z(F).call(re,ge,B)},listen(re,ge){if((0,w.$7f)(se))return ce.k(G,se,re,ge);const B=se.routeEvent(ce,re,ge).then(W=>W.channelClient.getChannel(G));return Z(B).listen(re,ge)}}}k(G,se,ce,re){const ge=this;let B;const W=new v.$5d({onWillAddFirstListener:()=>{B=new p.$Sc;const F=new v.$$d,z=new Map,_=K=>{const Y=K.channelClient.getChannel(G).listen(ce,re),N=F.add(Y);z.set(K,N)},Q=K=>{const X=z.get(K);X&&(X.dispose(),z.delete(K))};ge.connections.filter(se).forEach(_),v.Event.filter(ge.onDidAddConnection,se)(_,void 0,B),ge.onDidRemoveConnection(Q,void 0,B),F.event(W.fire,W,B),B.add(F)},onDidRemoveLastListener:()=>{B?.dispose(),B=void 0}});return W.event}registerChannel(G,se){this.a.set(G,se);for(const ce of this.f)ce.channelServer.registerChannel(G,se)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Uh=O;class M{constructor(G,se,ce=null){const re=new t;a(re,se),G.send(re.buffer),this.a=new I(G,ce),this.d=new A(G,se,ce)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,se){this.d.registerChannel(G,se)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Vh=M;function Z(x){return{call(G,se,ce){return x.then(re=>re.call(G,se,ce))},listen(G,se){const ce=new v.$be;return x.then(re=>ce.input=re.listen(G,se)),ce.event}}}e.$Wh=Z;function ee(x){let G=!1;return{call(se,ce,re){return G?x.call(se,ce,re):(0,C.$fh)(0).then(()=>G=!0).then(()=>x.call(se,ce,re))},listen(se,ce){if(G)return x.listen(se,ce);const re=new v.$be;return(0,C.$fh)(0).then(()=>G=!0).then(()=>re.input=x.listen(se,ce)),re.event}}}e.$Xh=ee;class fe{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const se of G.connections)if(await Promise.resolve(this.a(se.ctx)))return Promise.resolve(se);return await v.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$Yh=fe;var ue;(function(x){function G(ge,B,W){const F=ge,z=W&&W.disableMarshalling,_=new Map;for(const Q in F)ce(Q)&&_.set(Q,v.Event.buffer(F[Q],!0,void 0,B));return new class{listen(Q,K,X){const Y=_.get(K);if(Y)return Y;if(re(K)){const N=F[K];if(typeof N=="function")return N.call(F,X)}throw new P.$bb(`Event not found: ${K}`)}call(Q,K,X){const Y=F[K];if(typeof Y=="function"){if(!z&&Array.isArray(X))for(let U=0;U<X.length;U++)X[U]=(0,D.$Nh)(X[U]);let N=Y.apply(F,X);return N instanceof Promise||(N=Promise.resolve(N)),N}throw new P.$bb(`Method not found: ${K}`)}}}x.fromService=G;function se(ge,B){const W=B&&B.disableMarshalling;return new Proxy({},{get(F,z){if(typeof z=="string")return B?.properties?.has(z)?B.properties.get(z):re(z)?function(_){return ge.listen(z,_)}:ce(z)?ge.listen(z):async function(..._){let Q;B&&!(0,w.$2f)(B.context)?Q=[B.context,..._]:Q=_;const K=await ge.call(z,Q);return W?K:(0,D.$Nh)(K)};throw new P.$bb(`Property not found: ${String(z)}`)}})}x.toService=se;function ce(ge){return ge[0]==="o"&&ge[1]==="n"&&E.$if(ge.charCodeAt(2))}function re(ge){return/^onDynamic/.test(ge)&&E.$if(ge.charCodeAt(9))}})(ue||(e.ProxyChannel=ue={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const G=x.toString();if(G!=="[object Object]")return G}return x}function q(x){return Array.isArray(x)?x.map(H):H(x)}function J(x,G,se,ce,re,ge,B){B=q(B);const W=j[re],F=W[ce%W.length];let z=[`%c[${x}]%c[${String(G).padStart(7," ")}]%c[len: ${String(se).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(ge)?(z=z.concat(B),z.push(")")):z.push(B),console.log.apply(console,z)}class ne{constructor(G,se){this.d=G,this.f=se,this.a=0,this.b=0}logOutgoing(G,se,ce,re,ge){this.b+=G,J(this.d,this.b,G,se,ce,re,ge)}logIncoming(G,se,ce,re,ge){this.a+=G,J(this.f,this.a,G,se,ce,re,ge)}}e.$Zh=ne}),define(Ee[107],ke([1,0,14,6,2,43]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.ProtocolConstants=e.$1h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var P;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let a=0;function $(R,I){if(!i.has(R)){const O=String(++a);i.set(R,O)}return i.get(R)}function A(R,I,O,M){if(!n.enableDiagnostics)return;const Z=$(R,I);if(M instanceof y.$se||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const ee=y.$se.alloc(M.byteLength);ee.set(M),n.records.push({timestamp:Date.now(),id:Z,label:I,type:O,buff:ee})}else n.records.push({timestamp:Date.now(),id:Z,label:I,type:O,data:M})}n.traceSocketEvent=A})(P||(e.SocketDiagnostics=P={}));var v;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let p=null;function D(){return p||(p=y.$se.alloc(0)),p}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,a){if(i===0)return D();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const I=this.a[0];return a&&(this.a.shift(),this.b-=i),I}if(this.a[0].byteLength>i){const I=this.a[0].slice(0,i);return a&&(this.a[0]=this.a[0].slice(i),this.b-=i),I}const $=y.$se.alloc(i);let A=0,R=0;for(;i>0;){const I=this.a[R];if(I.byteLength>i){const O=I.slice(0,i);$.set(O,A),A+=i,a&&(this.a[R]=I.slice(i),this.b-=i),i-=i}else $.set(I,A),A+=I.byteLength,a?(this.a.shift(),this.b-=I.byteLength):R++,i-=I.byteLength}return $}}e.$1h=E;var w;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(w||(w={}));function m(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class c{constructor(i,a,$,A){this.type=i,this.id=a,this.ack=$,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends s.$Tc{constructor(i){super(),this.f=this.B(new C.$5d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,A=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new c($,A,R,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.$se.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(a,i.data)}g(i,a){const $=this.f===0;return this.d.push(i,a),this.f+=i.byteLength+a.byteLength,$}h(){const i=y.$se.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,a){this.g(i,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class g extends s.$Tc{constructor(i){super(),this.f=new C.$5d,this.onMessage=this.f.event,this.g=new C.$5d,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new u(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new c(1,0,0,i))}}e.$2h=g;class h extends S.$Vh{static fromSocket(i,a){return new h(new g(i),a)}get onDidDispose(){return this.b.onDidDispose}constructor(i,a,$=null){super(i,a,$),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$3h=h;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$5d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$4h=f;class l{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,a=this.a;for(;a;)a=a.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let a=0,$=this.a;for(;$;)i[a++]=$.data,$=$.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const a=new l(i);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let a=0;a<r.a;a++)this.c[a]=i-1e3*a;setInterval(()=>{for(let a=r.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),a=(1+r.a)*1e3;let $=0;for(let A=0;A<r.a;A++)i-this.c[A]<=a&&$++;return 1-$/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class o{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new f,this.onControlMessage=this.u.event,this.v=new f,this.onMessage=this.v.event,this.w=new f,this.onDidDispose=this.w.event,this.x=new f,this.onSocketClose=this.x.event,this.y=new f,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??r.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=i.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new c(5,0,0,D());this.p.write(i),this.p.flush()}sendPause(){const i=new c(7,0,0,D());this.p.write(i)}sendResume(){const i=new c(8,0,0,D());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,a){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new c(3,0,this.h,D());this.p.write(i);const a=this.b.toArray();for(let $=0,A=a.length;$<A;$++)this.p.write(a[$]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const a=this.b.peek();if(a&&a.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new c(6,0,0,D())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let $=0,A=a.length;$<A;$++)this.p.write(a[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const a=++this.c;this.h=this.g;const $=new c(1,a,this.h,i);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(i){const a=new c(2,0,0,i);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),a=Date.now()-i.writtenTime,$=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(a>=2e4&&$>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:$});return}const R=Math.max(2e4-a,2e4-$,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new c(3,0,this.h,D());this.p.write(i)}D(){this.h=this.g;const i=new c(9,0,this.h,D());this.p.write(i)}}e.$5h=o}),define(Ee[108],ke([1,0,54,15,14,20,154,8,6,2,21,104,62,43]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class d extends m.$Sh{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",g=>s.$se.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Cq=d;class c{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new v.$5d,this.onDidProcessExit=this.h.event;const h=g&&g.timeout?g.timeout:6e4;this.b=new C.$bh(h),this.d=null,this.f=null}getChannel(u){const g=this;return{call(h,f,l){return g.k(u,h,f,l)},listen(h,f){return g.l(u,h,f)}}}k(u,g,h,f=S.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const l=this.n(u),t=(0,C.$4g)(n=>l.call(g,h,n)),r=f.onCancellationRequested(()=>t.cancel()),o=(0,p.$Rc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{r.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,g,h){if(!this.b)return v.Event.None;this.b.cancel();let f;const l=new v.$5d({onWillAddFirstListener:()=>{f=this.n(u).listen(g,h)(l.fire,l),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,D.$In)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,w.$5l)(g.env),this.d=(0,y.fork)(this.i,u,g);const h=new v.$5d;v.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,k.$yq)(i)){(0,k.log)(i,`IPC Library: ${this.j.serverName}`);return}h.fire(s.$se.wrap(Buffer.from(i,"base64")))});const l=this.j.useQueue?(0,E.$7l)(this.d):this.d,t=i=>this.d&&this.d.connected&&l.send(i.buffer.toString("base64")),r=h.event,o={send:t,onMessage:r};this.f=new m.$Th(o);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,a)=>{process.removeListener("exit",n),this.c.forEach($=>(0,p.$Oc)($)),this.c.clear(),i!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:a})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Dq=c}),define(Ee[163],ke([1,0,15,6,2,52,9]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.StorageState=e.$Bp=e.StorageHint=void 0;var P;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function v(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}e.$Bp=v;var p;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(p||(e.StorageState=p={}));class D extends s.$Tc{constructor(m,d=Object.create(null)){super(),this.r=m,this.s=d,this.b=this.B(new C.$8d),this.onDidChangeStorage=this.b.event,this.c=p.None,this.f=new Map,this.g=this.B(new y.$ch(D.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((d,c)=>this.w(c,d)),m.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(m,d){if(this.c===p.Closed)return;let c=!1;(0,k.$2f)(d)?c=this.f.delete(m):this.f.get(m)!==d&&(this.f.set(m,d),c=!0),c&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===p.None&&(this.c=p.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,d){const c=this.f.get(m);return(0,k.$2f)(c)?d:c}getBoolean(m,d){const c=this.get(m);return(0,k.$2f)(c)?d:c==="true"}getNumber(m,d){const c=this.get(m);return(0,k.$2f)(c)?d:parseInt(c,10)}getObject(m,d){const c=this.get(m);return(0,k.$2f)(c)?d:(0,S.$Mh)(c)}async set(m,d,c=!1){if(this.c===p.Closed)return;if((0,k.$2f)(d))return this.delete(m,c);const b=(0,k.$Uf)(d)||Array.isArray(d)?(0,S.$Lh)(d):String(d);if(this.f.get(m)!==b)return this.f.set(m,b),this.j.set(m,b),this.h.delete(m),this.b.fire({key:m,external:c}),this.D()}async delete(m,d=!1){if(!(this.c===p.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:d}),this.D()}async optimize(){if(this.c!==p.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=p.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$Cp=D,D.a=100;class E{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((d,c)=>this.a.set(c,d)),m.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$Dp=E}),define(Ee[80],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=void 0;class y{constructor(s,S){this.lineNumber=s,this.column=S}with(s=this.lineNumber,S=this.column){return s===this.lineNumber&&S===this.column?this:new y(s,S)}delta(s=0,S=0){return this.with(this.lineNumber+s,this.column+S)}equals(s){return y.equals(this,s)}static equals(s,S){return!s&&!S?!0:!!s&&!!S&&s.lineNumber===S.lineNumber&&s.column===S.column}isBefore(s){return y.isBefore(this,s)}static isBefore(s,S){return s.lineNumber<S.lineNumber?!0:S.lineNumber<s.lineNumber?!1:s.column<S.column}isBeforeOrEqual(s){return y.isBeforeOrEqual(this,s)}static isBeforeOrEqual(s,S){return s.lineNumber<S.lineNumber?!0:S.lineNumber<s.lineNumber?!1:s.column<=S.column}static compare(s,S){const k=s.lineNumber|0,P=S.lineNumber|0;if(k===P){const v=s.column|0,p=S.column|0;return v-p}return k-P}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(s){return new y(s.lineNumber,s.column)}static isIPosition(s){return s&&typeof s.lineNumber=="number"&&typeof s.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$6s=y}),define(Ee[44],ke([1,0,80]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0;class C{constructor(S,k,P,v){S>P||S===P&&k>v?(this.startLineNumber=P,this.startColumn=v,this.endLineNumber=S,this.endColumn=k):(this.startLineNumber=S,this.startColumn=k,this.endLineNumber=P,this.endColumn=v)}isEmpty(){return C.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return C.containsPosition(this,S)}static containsPosition(S,k){return!(k.lineNumber<S.startLineNumber||k.lineNumber>S.endLineNumber||k.lineNumber===S.startLineNumber&&k.column<S.startColumn||k.lineNumber===S.endLineNumber&&k.column>S.endColumn)}static strictContainsPosition(S,k){return!(k.lineNumber<S.startLineNumber||k.lineNumber>S.endLineNumber||k.lineNumber===S.startLineNumber&&k.column<=S.startColumn||k.lineNumber===S.endLineNumber&&k.column>=S.endColumn)}containsRange(S){return C.containsRange(this,S)}static containsRange(S,k){return!(k.startLineNumber<S.startLineNumber||k.endLineNumber<S.startLineNumber||k.startLineNumber>S.endLineNumber||k.endLineNumber>S.endLineNumber||k.startLineNumber===S.startLineNumber&&k.startColumn<S.startColumn||k.endLineNumber===S.endLineNumber&&k.endColumn>S.endColumn)}strictContainsRange(S){return C.strictContainsRange(this,S)}static strictContainsRange(S,k){return!(k.startLineNumber<S.startLineNumber||k.endLineNumber<S.startLineNumber||k.startLineNumber>S.endLineNumber||k.endLineNumber>S.endLineNumber||k.startLineNumber===S.startLineNumber&&k.startColumn<=S.startColumn||k.endLineNumber===S.endLineNumber&&k.endColumn>=S.endColumn)}plusRange(S){return C.plusRange(this,S)}static plusRange(S,k){let P,v,p,D;return k.startLineNumber<S.startLineNumber?(P=k.startLineNumber,v=k.startColumn):k.startLineNumber===S.startLineNumber?(P=k.startLineNumber,v=Math.min(k.startColumn,S.startColumn)):(P=S.startLineNumber,v=S.startColumn),k.endLineNumber>S.endLineNumber?(p=k.endLineNumber,D=k.endColumn):k.endLineNumber===S.endLineNumber?(p=k.endLineNumber,D=Math.max(k.endColumn,S.endColumn)):(p=S.endLineNumber,D=S.endColumn),new C(P,v,p,D)}intersectRanges(S){return C.intersectRanges(this,S)}static intersectRanges(S,k){let P=S.startLineNumber,v=S.startColumn,p=S.endLineNumber,D=S.endColumn;const E=k.startLineNumber,w=k.startColumn,m=k.endLineNumber,d=k.endColumn;return P<E?(P=E,v=w):P===E&&(v=Math.max(v,w)),p>m?(p=m,D=d):p===m&&(D=Math.min(D,d)),P>p||P===p&&v>D?null:new C(P,v,p,D)}equalsRange(S){return C.equalsRange(this,S)}static equalsRange(S,k){return!S&&!k?!0:!!S&&!!k&&S.startLineNumber===k.startLineNumber&&S.startColumn===k.startColumn&&S.endLineNumber===k.endLineNumber&&S.endColumn===k.endColumn}getEndPosition(){return C.getEndPosition(this)}static getEndPosition(S){return new y.$6s(S.endLineNumber,S.endColumn)}getStartPosition(){return C.getStartPosition(this)}static getStartPosition(S){return new y.$6s(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,k){return new C(this.startLineNumber,this.startColumn,S,k)}setStartPosition(S,k){return new C(S,k,this.endLineNumber,this.endColumn)}collapseToStart(){return C.collapseToStart(this)}static collapseToStart(S){return new C(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}collapseToEnd(){return C.collapseToEnd(this)}static collapseToEnd(S){return new C(S.endLineNumber,S.endColumn,S.endLineNumber,S.endColumn)}delta(S){return new C(this.startLineNumber+S,this.startColumn,this.endLineNumber+S,this.endColumn)}static fromPositions(S,k=S){return new C(S.lineNumber,S.column,k.lineNumber,k.column)}static lift(S){return S?new C(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,k){return!(S.endLineNumber<k.startLineNumber||S.endLineNumber===k.startLineNumber&&S.endColumn<k.startColumn||k.endLineNumber<S.startLineNumber||k.endLineNumber===S.startLineNumber&&k.endColumn<S.startColumn)}static areIntersecting(S,k){return!(S.endLineNumber<k.startLineNumber||S.endLineNumber===k.startLineNumber&&S.endColumn<=k.startColumn||k.endLineNumber<S.startLineNumber||k.endLineNumber===S.startLineNumber&&k.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,k){if(S&&k){const p=S.startLineNumber|0,D=k.startLineNumber|0;if(p===D){const E=S.startColumn|0,w=k.startColumn|0;if(E===w){const m=S.endLineNumber|0,d=k.endLineNumber|0;if(m===d){const c=S.endColumn|0,b=k.endColumn|0;return c-b}return m-d}return E-w}return p-D}return(S?1:0)-(k?1:0)}static compareRangesUsingEnds(S,k){return S.endLineNumber===k.endLineNumber?S.endColumn===k.endColumn?S.startLineNumber===k.startLineNumber?S.startColumn-k.startColumn:S.startLineNumber-k.startLineNumber:S.endColumn-k.endColumn:S.endLineNumber-k.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}toJSON(){return this}}e.$7s=C}),define(Ee[164],ke([1,0,44]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class C{static insert(S,k){return{range:new y.$7s(S.lineNumber,S.column,S.lineNumber,S.column),text:k,forceMoveMarkers:!0}}static delete(S){return{range:S,text:null}}static replace(S,k){return{range:S,text:k}}static replaceMove(S,k){return{range:S,text:k,forceMoveMarkers:!0}}}e.$8s=C}),define(Ee[165],ke([1,0,6,2]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0;class s{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$5d,this.onDidChange=this.c.event,this.d=null}handleChange(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,v){return this.a.set(P,v),this.handleChange([P]),(0,C.$Rc)(()=>{this.a.get(P)===v&&(this.a.delete(P),this.handleChange([P]))})}get(P){return this.a.get(P)||null}registerFactory(P,v){this.b.get(P)?.dispose();const p=new S(this,P,v);return this.b.set(P,p),(0,C.$Rc)(()=>{const D=this.b.get(P);!D||D!==p||(this.b.delete(P),D.dispose())})}async getOrCreate(P){const v=this.get(P);if(v)return v;const p=this.b.get(P);return!p||p.isResolved?null:(await p.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const p=this.b.get(P);return!!(!p||p.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ft=s;class S extends C.$Tc{get isResolved(){return this.c}constructor(P,v,p){super(),this.f=P,this.g=v,this.h=p,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const P=await this.h.tokenizationSupport;this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(Ee[166],ke([10,11]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Ee[167],ke([1,0,6,2,166]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;class S extends C.$Tc{constructor(w,m="",d="",c=!0,b){super(),this.h=this.B(new y.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=m,this.u=d,this.w=c,this.C=b}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,m){this.C&&await this.C(w)}}e.$Vi=S;class k extends C.$Tc{constructor(){super(...arguments),this.f=this.B(new y.$5d),this.onWillRun=this.f.event,this.m=this.B(new y.$5d),this.onDidRun=this.m.event}async run(w,m){if(!w.enabled)return;this.f.fire({action:w});let d;try{await this.u(w,m)}catch(c){d=c}this.m.fire({action:w,error:d})}async u(w,m){await w.run(m)}}e.$Wi=k;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let m=[];for(const d of w)d.length&&(m.length?m=[...m,new P,...d]:m=d);return m}async run(){}}e.$Xi=P,P.ID="vs.actions.separator";class v{get actions(){return this.a}constructor(w,m,d,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=m,this.class=c,this.a=d}async run(){}}e.$Yi=v;class p extends S{constructor(){super(p.ID,s.localize(0,null),void 0,!1)}}e.$Zi=p,p.ID="vs.actions.empty";function D(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...w)=>E.run(...w),tooltip:E.label}}e.$1i=D}),define(Ee[168],ke([10,11]),function(le,e){return le.create("vs/base/common/date",e)}),define(Ee[169],ke([1,0,168]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0;const C=60,s=C*60,S=s*24,k=S*7,P=S*30,v=S*365;function p(w,m,d,c){typeof w!="number"&&(w=w.getTime());const b=Math.round((new Date().getTime()-w)/1e3);if(b<-30)return(0,y.localize)(0,null,p(new Date().getTime()+b*1e3,!1));if(!c&&b<30)return(0,y.localize)(1,null);let u;return b<C?(u=b,m?u===1?d?(0,y.localize)(2,null,u):(0,y.localize)(3,null,u):d?(0,y.localize)(4,null,u):(0,y.localize)(5,null,u):u===1?d?(0,y.localize)(6,null,u):(0,y.localize)(7,null,u):d?(0,y.localize)(8,null,u):(0,y.localize)(9,null,u)):b<s?(u=Math.floor(b/C),m?u===1?d?(0,y.localize)(10,null,u):(0,y.localize)(11,null,u):d?(0,y.localize)(12,null,u):(0,y.localize)(13,null,u):u===1?d?(0,y.localize)(14,null,u):(0,y.localize)(15,null,u):d?(0,y.localize)(16,null,u):(0,y.localize)(17,null,u)):b<S?(u=Math.floor(b/s),m?u===1?d?(0,y.localize)(18,null,u):(0,y.localize)(19,null,u):d?(0,y.localize)(20,null,u):(0,y.localize)(21,null,u):u===1?d?(0,y.localize)(22,null,u):(0,y.localize)(23,null,u):d?(0,y.localize)(24,null,u):(0,y.localize)(25,null,u)):b<k?(u=Math.floor(b/S),m?u===1?(0,y.localize)(26,null,u):(0,y.localize)(27,null,u):u===1?(0,y.localize)(28,null,u):(0,y.localize)(29,null,u)):b<P?(u=Math.floor(b/k),m?u===1?d?(0,y.localize)(30,null,u):(0,y.localize)(31,null,u):d?(0,y.localize)(32,null,u):(0,y.localize)(33,null,u):u===1?d?(0,y.localize)(34,null,u):(0,y.localize)(35,null,u):d?(0,y.localize)(36,null,u):(0,y.localize)(37,null,u)):b<v?(u=Math.floor(b/P),m?u===1?d?(0,y.localize)(38,null,u):(0,y.localize)(39,null,u):d?(0,y.localize)(40,null,u):(0,y.localize)(41,null,u):u===1?d?(0,y.localize)(42,null,u):(0,y.localize)(43,null,u):d?(0,y.localize)(44,null,u):(0,y.localize)(45,null,u)):(u=Math.floor(b/v),m?u===1?d?(0,y.localize)(46,null,u):(0,y.localize)(47,null,u):d?(0,y.localize)(48,null,u):(0,y.localize)(49,null,u):u===1?d?(0,y.localize)(50,null,u):(0,y.localize)(51,null,u):d?(0,y.localize)(52,null,u):(0,y.localize)(53,null,u))}e.$Hm=p;function D(w,m){const d=Math.abs(w/1e3);return d<1?m?(0,y.localize)(54,null,w):(0,y.localize)(55,null,w):d<C?m?(0,y.localize)(56,null,Math.round(w)/1e3):(0,y.localize)(57,null,Math.round(w)/1e3):d<s?m?(0,y.localize)(58,null,Math.round(w/(1e3*C))):(0,y.localize)(59,null,Math.round(w/(1e3*C))):d<S?m?(0,y.localize)(60,null,Math.round(w/(1e3*s))):(0,y.localize)(61,null,Math.round(w/(1e3*s))):(0,y.localize)(62,null,Math.round(w/(1e3*S)))}e.$Im=D;function E(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Jm=E}),define(Ee[170],ke([10,11]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Ee[40],ke([1,0,18,9,170]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function S(E,w){return w&&(E.stack||E.stacktrace)?s.localize(0,null,P(E),k(E.stack)||k(E.stacktrace)):P(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?s.localize(1,null,E.message):E.message||s.localize(2,null)}function v(E=null,w=!1){if(!E)return s.localize(3,null);if(Array.isArray(E)){const m=y.$Hb(E),d=v(m[0],w);return m.length>1?s.localize(4,null,d,m.length):d}if(C.$Sf(E))return E;if(E.detail){const m=E.detail;if(m.error)return S(m.error,w);if(m.exception)return S(m.exception,w)}return E.stack?S(E,w):E.message?E.message:s.localize(5,null)}e.$2i=v;function p(E){const w=E;return w instanceof Error&&Array.isArray(w.actions)}e.$3i=p;function D(E,w){let m;return typeof E=="string"?m=new Error(E):m=E,m.actions=w,m}e.$4i=D}),define(Ee[171],ke([10,11]),function(le,e){return le.create("vs/base/common/jsonErrorMessages",e)}),define(Ee[172],ke([1,0,171]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;function C(s){switch(s){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.$0p=C}),define(Ee[173],ke([10,11]),function(le,e){return le.create("vs/base/node/zip",e)}),define(Ee[81],ke([1,0,29,15,7,9,23,173]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.zip=e.$Yp=e.$Xp=void 0,e.$Xp="end of central directory record signature not found";const v=new RegExp(e.$Xp);class p extends Error{constructor(l,t){let r=t.message;switch(l){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=l,this.cause=t}}e.$Yp=p;function D(f){const l=f.externalFileAttributes>>16||33188;return[448,56,7].map(t=>l&t).reduce((t,r)=>t+r,l&61440)}function E(f){if(f instanceof p)return f;let l;return v.test(f.message)&&(l="CorruptZip"),new p(l,f)}function w(f,l,t,r,o,n){const i=s.$mc(l),a=s.$jc(r,i);if(!a.startsWith(r))return Promise.reject(new Error(P.localize(0,null,l)));const $=s.$jc(r,l);let A;return n.onCancellationRequested(()=>{A?.destroy()}),Promise.resolve(k.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((R,I)=>{if(!n.isCancellationRequested)try{A=(0,y.createWriteStream)($,{mode:t}),A.once("close",()=>R()),A.once("error",I),f.once("error",I),f.pipe(A)}catch(O){I(O)}}))}function m(f,l,t,r){let o=(0,C.$4g)(()=>Promise.resolve()),n=0;const i=r.onCancellationRequested(()=>{o.cancel(),f.close()});return new Promise((a,$)=>{const A=new C.$_g,R=I=>{I.isCancellationRequested||(n++,f.readEntry())};f.once("error",$),f.once("close",()=>o.then(()=>{r.isCancellationRequested||f.entryCount===n?a():$(new p("Incomplete",new Error(P.localize(1,null,n,f.entryCount))))},$)),f.readEntry(),f.on("entry",I=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(I.fileName)){R(r);return}const O=I.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(O)){const ee=s.$jc(l,O);o=(0,C.$4g)(fe=>k.Promises.mkdir(ee,{recursive:!0}).then(()=>R(fe)).then(void 0,$));return}const M=c(f,I),Z=D(I);o=(0,C.$4g)(ee=>A.queue(()=>M.then(fe=>w(fe,O,Z,l,t,ee).then(()=>R(ee)))).then(null,$))})}).finally(()=>i.dispose())}async function d(f,l=!1){const{open:t}=await new Promise((r,o)=>{le(["yauzl"],r,o)});return new Promise((r,o)=>{t(f,l?{lazyEntries:!0}:void 0,(n,i)=>{n?o(E(n)):r((0,S.$4f)(i))})})}function c(f,l){return new Promise((t,r)=>{f.openReadStream(l,(o,n)=>{o?r(E(o)):t((0,S.$4f)(n))})})}async function b(f,l){const{ZipFile:t}=await new Promise((r,o)=>{le(["yazl"],r,o)});return new Promise((r,o)=>{const n=new t;l.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const i=(0,y.createWriteStream)(f);n.outputStream.pipe(i),n.outputStream.once("error",o),i.once("error",o),i.once("finish",()=>r(f))})}e.zip=b;function u(f,l,t={},r){const o=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let n=d(f,!0);return t.overwrite&&(n=n.then(i=>k.Promises.rm(l).then(()=>i))),n.then(i=>m(i,l,{sourcePathRegex:o},r))}e.$1p=u;function g(f,l){return d(f).then(t=>new Promise((r,o)=>{t.on("entry",n=>{n.fileName===l&&c(t,n).then(i=>r(i),i=>o(i))}),t.once("close",()=>o(new Error(P.localize(2,null,l))))}))}function h(f,l){return g(f,l).then(t=>new Promise((r,o)=>{const n=[];t.once("error",o),t.on("data",i=>n.push(i)),t.on("end",()=>r(Buffer.concat(n)))}))}e.$2p=h}),define(Ee[174],ke([10,11]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(Ee[175],ke([1,0,51,4,164,44,165,174]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Zt=e.$Yt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$Xt=e.$Wt=e.SymbolKinds=e.SymbolTag=e.$Vt=e.$Ut=e.SymbolKind=e.$Tt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$St=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Rt=e.$Qt=e.$Pt=void 0;class v{constructor(H,q,J){this.offset=H,this.type=q,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Pt=v;class p{constructor(H,q){this.tokens=H,this.endState=q,this._tokenizationResultBrand=void 0}}e.$Qt=p;class D{constructor(H,q){this.tokens=H,this.endState=q,this._encodedTokenizationResultBrand=void 0}}e.$Rt=D;var E;(function(j){j[j.Method=0]="Method",j[j.Function=1]="Function",j[j.Constructor=2]="Constructor",j[j.Field=3]="Field",j[j.Variable=4]="Variable",j[j.Class=5]="Class",j[j.Struct=6]="Struct",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Event=10]="Event",j[j.Operator=11]="Operator",j[j.Unit=12]="Unit",j[j.Value=13]="Value",j[j.Constant=14]="Constant",j[j.Enum=15]="Enum",j[j.EnumMember=16]="EnumMember",j[j.Keyword=17]="Keyword",j[j.Text=18]="Text",j[j.Color=19]="Color",j[j.File=20]="File",j[j.Reference=21]="Reference",j[j.Customcolor=22]="Customcolor",j[j.Folder=23]="Folder",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue",j[j.Snippet=27]="Snippet"})(E||(e.CompletionItemKind=E={}));var w;(function(j){const H=new Map;H.set(0,y.$kk.symbolMethod),H.set(1,y.$kk.symbolFunction),H.set(2,y.$kk.symbolConstructor),H.set(3,y.$kk.symbolField),H.set(4,y.$kk.symbolVariable),H.set(5,y.$kk.symbolClass),H.set(6,y.$kk.symbolStruct),H.set(7,y.$kk.symbolInterface),H.set(8,y.$kk.symbolModule),H.set(9,y.$kk.symbolProperty),H.set(10,y.$kk.symbolEvent),H.set(11,y.$kk.symbolOperator),H.set(12,y.$kk.symbolUnit),H.set(13,y.$kk.symbolValue),H.set(15,y.$kk.symbolEnum),H.set(14,y.$kk.symbolConstant),H.set(15,y.$kk.symbolEnum),H.set(16,y.$kk.symbolEnumMember),H.set(17,y.$kk.symbolKeyword),H.set(27,y.$kk.symbolSnippet),H.set(18,y.$kk.symbolText),H.set(19,y.$kk.symbolColor),H.set(20,y.$kk.symbolFile),H.set(21,y.$kk.symbolReference),H.set(22,y.$kk.symbolCustomColor),H.set(23,y.$kk.symbolFolder),H.set(24,y.$kk.symbolTypeParameter),H.set(25,y.$kk.account),H.set(26,y.$kk.issues);function q(x){let G=H.get(x);return G||(console.info("No codicon found for CompletionItemKind "+x),G=y.$kk.symbolProperty),G}j.toIcon=q;const J=new Map;J.set("method",0),J.set("function",1),J.set("constructor",2),J.set("field",3),J.set("variable",4),J.set("class",5),J.set("struct",6),J.set("interface",7),J.set("module",8),J.set("property",9),J.set("event",10),J.set("operator",11),J.set("unit",12),J.set("value",13),J.set("constant",14),J.set("enum",15),J.set("enum-member",16),J.set("enumMember",16),J.set("keyword",17),J.set("snippet",27),J.set("text",18),J.set("color",19),J.set("file",20),J.set("reference",21),J.set("customcolor",22),J.set("folder",23),J.set("type-parameter",24),J.set("typeParameter",24),J.set("account",25),J.set("issue",26);function ne(x,G){let se=J.get(x);return typeof se>"u"&&!G&&(se=9),se}j.fromString=ne})(w||(e.CompletionItemKinds=w={}));var m;(function(j){j[j.Deprecated=1]="Deprecated"})(m||(e.CompletionItemTag=m={}));var d;(function(j){j[j.None=0]="None",j[j.KeepWhitespace=1]="KeepWhitespace",j[j.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var c;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var b;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(b||(e.InlineCompletionTriggerKind=b={}));class u{constructor(H,q,J,ne){this.range=H,this.text=q,this.completionKind=J,this.isSnippetText=ne}equals(H){return S.$7s.lift(this.range).equalsRange(H.range)&&this.text===H.text&&this.completionKind===H.completionKind&&this.isSnippetText===H.isSnippetText}}e.$St=u;var g;(function(j){j[j.Invoke=1]="Invoke",j[j.Auto=2]="Auto"})(g||(e.CodeActionTriggerType=g={}));var h;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(h||(e.SignatureHelpTriggerKind=h={}));var f;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(f||(e.DocumentHighlightKind=f={}));function l(j){return j&&C.URI.isUri(j.uri)&&S.$7s.isIRange(j.range)&&(S.$7s.isIRange(j.originSelectionRange)||S.$7s.isIRange(j.targetSelectionRange))}e.$Tt=l;var t;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Ut={17:(0,P.localize)(0,null),16:(0,P.localize)(1,null),4:(0,P.localize)(2,null),13:(0,P.localize)(3,null),8:(0,P.localize)(4,null),9:(0,P.localize)(5,null),21:(0,P.localize)(6,null),23:(0,P.localize)(7,null),7:(0,P.localize)(8,null),0:(0,P.localize)(9,null),11:(0,P.localize)(10,null),10:(0,P.localize)(11,null),19:(0,P.localize)(12,null),5:(0,P.localize)(13,null),1:(0,P.localize)(14,null),2:(0,P.localize)(15,null),20:(0,P.localize)(16,null),15:(0,P.localize)(17,null),18:(0,P.localize)(18,null),24:(0,P.localize)(19,null),3:(0,P.localize)(20,null),6:(0,P.localize)(21,null),14:(0,P.localize)(22,null),22:(0,P.localize)(23,null),25:(0,P.localize)(24,null),12:(0,P.localize)(25,null)};function r(j,H){return(0,P.localize)(26,null,j,e.$Ut[H])}e.$Vt=r;var o;(function(j){j[j.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var n;(function(j){const H=new Map;H.set(0,y.$kk.symbolFile),H.set(1,y.$kk.symbolModule),H.set(2,y.$kk.symbolNamespace),H.set(3,y.$kk.symbolPackage),H.set(4,y.$kk.symbolClass),H.set(5,y.$kk.symbolMethod),H.set(6,y.$kk.symbolProperty),H.set(7,y.$kk.symbolField),H.set(8,y.$kk.symbolConstructor),H.set(9,y.$kk.symbolEnum),H.set(10,y.$kk.symbolInterface),H.set(11,y.$kk.symbolFunction),H.set(12,y.$kk.symbolVariable),H.set(13,y.$kk.symbolConstant),H.set(14,y.$kk.symbolString),H.set(15,y.$kk.symbolNumber),H.set(16,y.$kk.symbolBoolean),H.set(17,y.$kk.symbolArray),H.set(18,y.$kk.symbolObject),H.set(19,y.$kk.symbolKey),H.set(20,y.$kk.symbolNull),H.set(21,y.$kk.symbolEnumMember),H.set(22,y.$kk.symbolStruct),H.set(23,y.$kk.symbolEvent),H.set(24,y.$kk.symbolOperator),H.set(25,y.$kk.symbolTypeParameter);function q(J){let ne=H.get(J);return ne||(console.info("No codicon found for SymbolKind "+J),ne=y.$kk.symbolProperty),ne}j.toIcon=q})(n||(e.SymbolKinds=n={}));class i{static asEditOperation(H){return s.$8s.replace(S.$7s.lift(H.range),H.text)}}e.$Wt=i;class a{static fromValue(H){switch(H){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(H)}constructor(H){this.value=H}}e.$Xt=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var $;(function(j){j[j.AIGenerated=1]="AIGenerated"})($||(e.NewSymbolNameTag=$={}));var A;(function(j){function H(q){return!q||typeof q!="object"?!1:typeof q.id=="string"&&typeof q.title=="string"}j.is=H})(A||(e.Command=A={}));var R;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(R||(e.CommentThreadCollapsibleState=R={}));var I;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(I||(e.CommentThreadState=I={}));var O;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(O||(e.CommentMode=O={}));var M;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(M||(e.CommentState=M={}));var Z;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Z||(e.InlayHintKind=Z={}));class ee{constructor(H){this.b=H,this.a=null}dispose(){this.a&&this.a.then(H=>{H&&H.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Yt=ee,e.$Zt=new k.$Ft;var fe;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(fe||(e.ExternalUriOpenerPriority=fe={}));var ue;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ue||(e.InlineEditTriggerKind=ue={}))}),define(Ee[176],ke([10,11]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[177],ke([10,11]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[178],ke([10,11]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[179],ke([10,11]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(Ee[180],ke([10,11]),function(le,e){return le.create("vs/platform/environment/node/argvHelper",e)}),define(Ee[181],ke([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Ee[182],ke([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[183],ke([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Ee[184],ke([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Ee[185],ke([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Ee[186],ke([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Ee[187],ke([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Ee[188],ke([10,11]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[189],ke([10,11]),function(le,e){return le.create("vs/platform/files/common/fileService",e)}),define(Ee[190],ke([10,11]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Ee[191],ke([10,11]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(Ee[192],ke([10,11]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[193],ke([10,11]),function(le,e){return le.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Ee[194],ke([10,11]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Ee[195],ke([10,11]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Ee[196],ke([10,11]),function(le,e){return le.create("vs/platform/shell/node/shellEnv",e)}),define(Ee[197],ke([10,11]),function(le,e){return le.create("vs/platform/telemetry/common/telemetryService",e)}),define(Ee[198],ke([10,11]),function(le,e){return le.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Ee[199],ke([10,11]),function(le,e){return le.create("vs/platform/terminal/common/terminalProfiles",e)}),define(Ee[200],ke([10,11]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[201],ke([10,11]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Ee[202],ke([10,11]),function(le,e){return le.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(Ee[203],ke([10,11]),function(le,e){return le.create("vs/server/node/serverEnvironmentService",e)}),define(Ee[204],ke([10,11]),function(le,e){return le.create("vs/server/node/serverServices",e)}),define(Ee[205],ke([10,11]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[206],ke([10,11]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Ee[207],ke([10,11]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[208],ke([10,11]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(Ee[209],ke([1,0,8,178]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var s;(function(p){p[p.LParen=0]="LParen",p[p.RParen=1]="RParen",p[p.Neg=2]="Neg",p[p.Eq=3]="Eq",p[p.NotEq=4]="NotEq",p[p.Lt=5]="Lt",p[p.LtEq=6]="LtEq",p[p.Gt=7]="Gt",p[p.GtEq=8]="GtEq",p[p.RegexOp=9]="RegexOp",p[p.RegexStr=10]="RegexStr",p[p.True=11]="True",p[p.False=12]="False",p[p.In=13]="In",p[p.Not=14]="Not",p[p.And=15]="And",p[p.Or=16]="Or",p[p.Str=17]="Str",p[p.QuotedStr=18]="QuotedStr",p[p.Error=19]="Error",p[p.EOF=20]="EOF"})(s||(e.TokenType=s={}));function S(...p){switch(p.length){case 1:return(0,C.localize)(0,null,p[0]);case 2:return(0,C.localize)(1,null,p[0],p[1]);case 3:return(0,C.localize)(2,null,p[0],p[1],p[2]);default:return}}const k=(0,C.localize)(3,null),P=(0,C.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(D){return this.c=D,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(S("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(S("&&"));break;case 124:this.h(124)?this.k(16):this.l(S("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(D){return this.r()||this.c.charCodeAt(this.e)!==D?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(D){this.f.push({type:D,offset:this.d})}l(D){const E=this.d,w=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:w};this.g.push({offset:E,lexeme:w,additionalInfo:D}),this.f.push(m)}n(){this.m.lastIndex=this.d;const D=this.m.exec(this.c);if(D){this.e=this.d+D[0].length;const E=this.c.substring(this.d,this.e),w=v.b.get(E);w?this.k(w):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let D=this.e,E=!1,w=!1;for(;;){if(D>=this.c.length){this.e=D,this.l(P);return}const d=this.c.charCodeAt(D);if(E)E=!1;else if(d===47&&!w){D++;break}else d===91?w=!0:d===92?E=!0:d===93&&(w=!1);D++}for(;D<this.c.length&&v.a.has(this.c.charCodeAt(D));)D++;this.e=D;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=v,v.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0))),v.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ee[210],ke([1,0,6,2]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=void 0;class s{constructor(){this.a=new y.$5d,this.b=new y.$5d,this.c=new y.$5d,this.d=new y.$5d}call(P,v,p){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(P,v,p){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$oo=s,s.ChannelName="extensionhostdebugservice";class S extends C.$Tc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,v,p){this.b.call("attach",[P,v,p])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,v){this.b.call("terminate",[P,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,v){return this.b.call("openExtensionDevelopmentHostWindow",[P,v])}}e.$po=S}),define(Ee[211],ke([1,0,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=void 0;class C{constructor(k){this.a=k}listen(k,P,v){throw new Error("Invalid listen")}call(k,P,v){switch(P){case"download":return this.a.download(y.URI.revive(v[0]),y.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$ro=C;class s{constructor(k,P){this.a=k,this.b=P}async download(k,P){const v=this.b();v&&(k=v.transformOutgoingURI(k),P=v.transformOutgoingURI(P)),await this.a.call("download",[k,P])}}e.$so=s}),define(Ee[212],ke([1,0,169,75,12,7,28,19,4]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.$Km=void 0,e.$Km=/^([^.]+\..+)[:=](.+)$/;class p{get appRoot(){return(0,S.$mc)(s.$yg.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,S.$jc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Rg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Rg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,y.$Jm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.$jc)(this.userDataPath,"logs",m)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Rg)(v.URI.file((0,S.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Rg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Rg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Rg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=k.env.VSCODE_PORTABLE;return m?v.URI.file((0,S.$jc)(m,"argv.json")):(0,P.$Rg)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,S.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,S.$kc)(m):(0,S.$hc)((0,S.$jc)(s.$yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?v.URI.file((0,S.$kc)(m)):v.URI.file((0,S.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,S.$kc)(m);const d=k.env.VSCODE_EXTENSIONS;if(d)return d;const c=k.env.VSCODE_PORTABLE;return c?(0,S.$jc)(c,"extensions"):(0,P.$Rg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(d=>/^[^:/?#]+?:\/\//.test(d)?v.URI.parse(d):v.URI.file((0,S.$hc)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?v.URI.parse(m):v.URI.file((0,S.$hc)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$Km.test(m))}get extensionLogLevel(){const m=[];for(const d of this.args.log||[]){const c=e.$Km.exec(d);c&&c[1]&&c[2]&&m.push([c[1],c[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,P.$Rg)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=k.env.VSCODE_PORTABLE;return m?v.URI.file((0,S.$jc)(m,"policy.json")):(0,P.$Rg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,d,c){this.a=m,this.b=d,this.c=c,this.editSessionId=this.args.editSessionId}}e.$Lm=p,Le([C.$Ih],p.prototype,"appRoot",null),Le([C.$Ih],p.prototype,"userHome",null),Le([C.$Ih],p.prototype,"userDataPath",null),Le([C.$Ih],p.prototype,"appSettingsHome",null),Le([C.$Ih],p.prototype,"tmpDir",null),Le([C.$Ih],p.prototype,"cacheHome",null),Le([C.$Ih],p.prototype,"stateResource",null),Le([C.$Ih],p.prototype,"userRoamingDataHome",null),Le([C.$Ih],p.prototype,"userDataSyncHome",null),Le([C.$Ih],p.prototype,"sync",null),Le([C.$Ih],p.prototype,"machineSettingsResource",null),Le([C.$Ih],p.prototype,"workspaceStorageHome",null),Le([C.$Ih],p.prototype,"localHistoryHome",null),Le([C.$Ih],p.prototype,"keyboardLayoutResource",null),Le([C.$Ih],p.prototype,"argvResource",null),Le([C.$Ih],p.prototype,"isExtensionDevelopment",null),Le([C.$Ih],p.prototype,"untitledWorkspacesHome",null),Le([C.$Ih],p.prototype,"builtinExtensionsPath",null),Le([C.$Ih],p.prototype,"extensionsPath",null),Le([C.$Ih],p.prototype,"extensionDevelopmentLocationURI",null),Le([C.$Ih],p.prototype,"extensionDevelopmentKind",null),Le([C.$Ih],p.prototype,"extensionTestsLocationURI",null),Le([C.$Ih],p.prototype,"debugExtensionHost",null),Le([C.$Ih],p.prototype,"logLevel",null),Le([C.$Ih],p.prototype,"extensionLogLevel",null),Le([C.$Ih],p.prototype,"serviceMachineIdResource",null),Le([C.$Ih],p.prototype,"disableTelemetry",null),Le([C.$Ih],p.prototype,"disableWorkspaceTrust",null),Le([C.$Ih],p.prototype,"useInMemorySecretStorage",null),Le([C.$Ih],p.prototype,"policyFile",null);function D(w,m){return E(w["inspect-extensions"],w["inspect-brk-extensions"],5870,m,w.debugId,w.extensionEnvironment)}e.$Mm=D;function E(w,m,d,c,b,u){const h=Number(m||w)||(c?null:d),f=h?!!m:!1;let l;if(u)try{l=JSON.parse(u)}catch{}return{port:h,break:f,debugId:b,env:l}}e.$Nm=E}),define(Ee[67],ke([1,0,303,3,179]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0;const S={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$9l=["tunnel","serve-web"],e.$0l={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(c,b,u=k){const g=c.find(a=>a.length>0&&a[0]!=="-"),h={},f=["_"],l=[],t={};let r;for(const a in b){const $=b[a];$.type==="subcommand"?a===g&&(r=$):($.alias&&(h[a]=$.alias),$.type==="string"||$.type==="string[]"?(f.push(a),$.deprecates&&f.push(...$.deprecates)):$.type==="boolean"&&(l.push(a),$.deprecates&&l.push(...$.deprecates)),$.global&&(t[a]=$))}if(r&&g){const a=t;for(const I in r.options)a[I]=r.options[I];const $=c.filter(I=>I!==g),A=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,R=P($,a,A);return{[g]:R,_:[]}}const o=y(c,{string:f,boolean:l,alias:h}),n={},i=o;n._=o._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(const a in b){const $=b[a];if($.type==="subcommand")continue;$.alias&&delete i[$.alias];let A=i[a];if($.deprecates)for(const R of $.deprecates)i.hasOwnProperty(R)&&(A||(A=i[R],A&&u.onDeprecatedOption(R,$.deprecationMessage||(0,s.localize)(38,null,a))),delete i[R]);if(typeof A<"u"){if($.type==="string[]"){if(Array.isArray(A)||(A=[A]),!$.allowEmptyValue){const R=A.filter(I=>I.length>0);R.length!==A.length&&(u.onEmptyValue(a),A=R.length>0?R:void 0)}}else $.type==="string"&&(Array.isArray(A)?(A=A.pop(),u.onMultipleValues(a,A)):!A&&!$.allowEmptyValue&&(u.onEmptyValue(a),A=void 0));n[a]=A,$.deprecationMessage&&u.onDeprecatedOption(a,$.deprecationMessage)}delete i[a]}for(const a in i)u.onUnknownOption(a);return n}e.$$l=P;function v(c,b){let u="";return b.args&&(Array.isArray(b.args)?u=` <${b.args.join("> <")}>`:u=` <${b.args}>`),b.alias?`-${b.alias} --${c}${u}`:`--${c}${u}`}function p(c,b){const u=[];for(const g in c){const h=c[g],f=v(g,h);u.push([f,h.description])}return D(u,b)}e.$_l=p;function D(c,b){const g=c.reduce((l,t)=>Math.max(l,t[0].length),12)+2+1;if(b-g<25)return c.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=b-g-1,f=[];for(const l of c){const t=l[0],r=w(l[1],h),o=E(g-t.length-2);f.push("  "+t+o+r[0]);for(let n=1;n<r.length;n++)f.push(E(g)+r[n])}return f}function E(c){return" ".repeat(c)}function w(c,b){const u=[];for(;c.length;){const g=c.length<b?c.length:c.lastIndexOf(" ",b),h=c.slice(0,g).trim();c=c.slice(g),u.push(h)}return u}function m(c,b,u,g,h){const f=process.stdout.isTTY&&process.stdout.columns||80,l=h?.noInputFiles!==!0?`[${(0,s.localize)(39,null)}...]`:"",t=[`${c} ${u}`];t.push(""),t.push(`${(0,s.localize)(40,null)}: ${b} [${(0,s.localize)(41,null)}]${l}`),t.push(""),h?.noPipe!==!0&&(C.$c?t.push((0,s.localize)(42,null,b)):t.push((0,s.localize)(43,null,b)),t.push(""));const r={},o=[];for(const n in g){const i=g[n];if(i.type==="subcommand")i.description&&o.push({command:n,description:i.description});else if(i.description&&i.cat){let a=r[i.cat];a||(r[i.cat]=a={}),a[n]=i}}for(const n in r){const i=n,a=r[i];a&&(t.push(S[i]),t.push(...p(a,f)),t.push(""))}return o.length&&(t.push((0,s.localize)(44,null)),t.push(...D(o.map(n=>[n.command,n.description]),f)),t.push("")),t.join(`
`)}e.$am=m;function d(c,b){return`${c||(0,s.localize)(45,null)}
${b||(0,s.localize)(46,null)}
${process.arch}`}e.$bm=d}),define(Ee[213],ke([1,0,304,180,67]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=void 0;function S(E,w){const m=(h,f)=>{console.warn((0,C.localize)(0,null,h,f))},d=h=>{console.warn((0,C.localize)(1,null,h))},c=(h,f)=>{console.warn((0,C.localize)(2,null,h,f))},b=h=>({onUnknownOption:f=>{s.$9l.includes(h)||console.warn((0,C.localize)(3,null,f,h))},onMultipleValues:m,onEmptyValue:d,onDeprecatedOption:c,getSubcommandReporter:s.$9l.includes(h)?b:void 0}),u={onUnknownOption:h=>{console.warn((0,C.localize)(4,null,h))},onMultipleValues:m,onEmptyValue:d,onDeprecatedOption:c,getSubcommandReporter:b},g=(0,s.$$l)(E,s.$0l,w?u:void 0);return g.goto&&g._.forEach(h=>y(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,C.localize)(5,null))),g}function k(E){const w=E.findIndex(m=>!/^-/.test(m));if(w>-1)return[...E.slice(0,w),...E.slice(w+1)]}function P(E){let[,...w]=E;process.env.VSCODE_DEV&&(w=k(w)||[]);const m=!D(process.env);return S(w,m)}e.$cm=P;function v(E){let[,,...w]=E;return process.env.VSCODE_DEV&&(w=k(w)||[]),S(w,!0)}e.$dm=v;function p(E,...w){const m=E.indexOf("--");return m===-1?E.push(...w):E.splice(m,0,...w),E}e.$em=p;function D(E){return E.VSCODE_CLI==="1"}e.$fm=D}),function(){"use strict";function le(e,y,C){function s(k,P){const v=S(k,P),p=[v];return e.isAbsolute(v)||p.unshift(C),e.resolve(...p)}function S(k,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return e.join(p,P);const D=k["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=e.join(E,"AppData","Roaming")}break;case"darwin":p=e.join(y.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(p,P)}return{getUserDataPath:s}}if(typeof define=="function")define(Ee[214],ke([78,27,28]),function(e,y,C){return le(e,y,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=le(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Ee[109],ke([1,0,27,212,214]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=void 0;class S extends C.$Lm{constructor(p,D){super(p,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,s.getUserDataPath)(p,D.nameShort)},D)}}e.$Om=S;function k(v,p){return(0,C.$Nm)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,p,v.extensionEnvironment)}e.$Pm=k;function P(v,p){return(0,C.$Nm)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,p,v.extensionEnvironment)}e.$Qm=P}),define(Ee[215],ke([1,0,9,184]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;function s(k,P,v,p){try{S(k,P,v,p)}catch(D){k.error(D?.message??D)}return P}e.$$p=s;function S(k,P,v,p){const D=(E,w,m)=>{const d=E[w];if((0,y.$Sf)(d)){const c=d,b=c.length;if(b>1&&c[0]==="%"&&c[b-1]==="%"){const u=c.substr(1,b-2);let g=v[u];g===void 0&&p&&(g=p[u]);const h=typeof g=="string"?g:g?.message,f=p?.[u],l=typeof f=="string"?f:f?.message;if(!h){l||k.warn(`[${P.name}]: ${(0,C.localize)(0,null,u)}`);return}if(m&&(w==="title"||w==="category")&&l&&l!==h){const t={value:h,original:l};E[w]=t}else E[w]=h}}else if((0,y.$Uf)(d))for(const c in d)d.hasOwnProperty(c)&&(c==="commands"?D(d,c,!0):D(d,c,m));else if(Array.isArray(d))for(let c=0;c<d.length;c++)D(d,c,m)};for(const E in P)P.hasOwnProperty(E)&&D(P,E)}}),define(Ee[216],ke([1,0,81,187]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;function s(S){return(0,y.$2p)(S,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}e.$gq=s}),define(Ee[82],ke([1,0,19,65,188,55]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function v(u){return u=u.trim(),u==="*"||k.test(u)}e.$mp=v;function p(u){if(!v(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.$np=p;function D(u){if(!u)return null;const g=u.majorBase,h=u.majorMustEqual,f=u.minorBase;let l=u.minorMustEqual;const t=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(g===0||(l=!1),r=!1);let o=0;if(u.preRelease){const n=P.exec(u.preRelease);if(n){const[,i,a,$]=n;o=Date.UTC(Number(i),Number(a)-1,Number($))}}return{majorBase:g,majorMustEqual:h,minorBase:f,minorMustEqual:l,patchBase:t,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:o}}e.$op=D;function E(u,g,h){let f;typeof u=="string"?f=D(p(u)):f=u;let l;g instanceof Date?l=g.getTime():typeof g=="string"&&(l=new Date(g).getTime());let t;if(typeof h=="string"?t=D(p(h)):t=h,!f||!t)return!1;const r=f.majorBase,o=f.minorBase,n=f.patchBase;let i=t.majorBase,a=t.minorBase,$=t.patchBase;const A=t.notBefore;let R=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:o>a?!0:o<a||l&&l<A?!1:n>=$:(r===1&&i===0&&(!R||!I||!O)&&(i=1,a=0,$=0,R=!0,I=!1,O=!1),r<i?!1:r>i?!R:o<a?!1:o>a?!I:n<$?!1:n>$?!O:!(l&&l<A))}e.$pp=E;function w(u,g,h,f,l){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([C.default.Error,s.localize(0,null)]),t;if(typeof f.name!="string")return t.push([C.default.Error,s.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([C.default.Error,s.localize(2,null,"version")]),t;if(!f.engines)return t.push([C.default.Error,s.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([C.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!b(f.extensionDependencies))return t.push([C.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!b(f.activationEvents))return t.push([C.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([C.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([C.default.Warning,s.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([C.default.Error,s.localize(9,null,"main")]),t;{const n=(0,y.$Rg)(h,f.main);(0,y.$Lg)(n,h)||t.push([C.default.Warning,s.localize(10,null,n.path,h.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([C.default.Error,s.localize(11,null,"browser")]),t;{const n=(0,y.$Rg)(h,f.browser);(0,y.$Lg)(n,h)||t.push([C.default.Warning,s.localize(12,null,n.path,h.path)])}}if(!S.valid(f.version))return t.push([C.default.Error,s.localize(13,null)]),t;const r=[];if(!m(u,g,f,l,r))for(const n of r)t.push([C.default.Error,n]);return t}e.$qp=w;function m(u,g,h,f,l){return f||typeof h.main>"u"&&typeof h.browser>"u"?!0:c(u,g,h.engines.vscode,l)}e.$rp=m;function d(u,g,h){return u==="*"||c(g,h,u)}e.$sp=d;function c(u,g,h,f=[]){const l=D(p(h));if(!l)return f.push(s.localize(14,null,h)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return f.push(s.localize(15,null,h)),!1}else if(!l.majorMustEqual)return f.push(s.localize(16,null,h)),!1;return E(u,g,l)?!0:(f.push(s.localize(17,null,u,h)),!1)}function b(u){if(!Array.isArray(u))return!1;for(let g=0,h=u.length;g<h;g++)if(typeof u[g]!="string")return!1;return!0}}),define(Ee[217],ke([1,0,14,22]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function s(S,k,P){let v=P&&P.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const D=(await k.readFile(S.serviceMachineIdResource)).value.toString();v=(0,C.$zg)(D)?D:null}catch{v=null}if(!v){v=(0,C.$Ag)();try{await k.writeFile(S.serviceMachineIdResource,y.$se.fromString(v))}catch{}}return P?.store("storage.serviceMachineId",v,-1,1),v}e.$Mp=s}),define(Ee[68],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class y{constructor(s,S=[],k=!1){this.ctor=s,this.staticArguments=S,this.supportsDelayedInstantiation=k}}e.$bi=y}),define(Ee[110],ke([1,0,68]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.InstantiationType=void 0;const C=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function S(P,v,p){v instanceof y.$bi||(v=new y.$bi(v,[],!!p)),C.push([P,v])}e.$$r=S;function k(){return C}e.$_r=k}),define(Ee[218],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class y{constructor(S,k){this.key=S,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.$Oq=y;class C{constructor(S){this.b=S,this.a=new Map}roots(){const S=[];for(const k of this.a.values())k.outgoing.size===0&&S.push(k);return S}insertEdge(S,k){const P=this.lookupOrInsertNode(S),v=this.lookupOrInsertNode(k);P.outgoing.set(v.key,v),v.incoming.set(P.key,P)}removeNode(S){const k=this.b(S);this.a.delete(k);for(const P of this.a.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(S){const k=this.b(S);let P=this.a.get(k);return P||(P=new y(k,S),this.a.set(k,P)),P}lookup(S){return this.a.get(this.b(S))}isEmpty(){return this.a.size===0}toString(){const S=[];for(const[k,P]of this.a)S.push(`${k}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return S.join(`
`)}findCycleSlow(){for(const[S,k]of this.a){const P=new Set([S]),v=this.c(k,P);if(v)return v}}c(S,k){for(const[P,v]of S.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const p=this.c(v,k);if(p)return p;k.delete(P)}}}e.$Pq=C}),define(Ee[5],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var y;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(v){return v[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(y||(e._util=y={})),e.$di=s("instantiationService");function C(k,P,v){P[y.DI_TARGET]===P?P[y.DI_DEPENDENCIES].push({id:k,index:v}):(P[y.DI_DEPENDENCIES]=[{id:k,index:v}],P[y.DI_TARGET]=P)}function s(k){if(y.serviceIds.has(k))return y.serviceIds.get(k);const P=function(v,p,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,v,D)};return P.toString=()=>k,y.serviceIds.set(k,P),P}e.$ei=s;function S(k){return k}e.$fi=S}),define(Ee[25],ke([1,0,9,4,5]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,s.$ei)("configurationService");function S(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof C.URI)}e.$Li=S;function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof C.URI)}e.$Mi=k;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function v(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=v;function p(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Oi=p;function D(u,g){const h=Object.create(null);for(const f in u)E(h,f,u[f],g);return h}e.$Pi=D;function E(u,g,h,f){const l=g.split("."),t=l.pop();let r=u;for(let o=0;o<l.length;o++){const n=l[o];let i=r[n];switch(typeof i){case"undefined":i=r[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${l.slice(0,o+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=h}catch{f(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.$Qi=E;function w(u,g){const h=g.split(".");m(u,h)}e.$Ri=w;function m(u,g){const h=g.shift();if(g.length===0){delete u[h];return}if(Object.keys(u).indexOf(h)!==-1){const f=u[h];typeof f=="object"&&!Array.isArray(f)&&(m(f,g),Object.keys(f).length===0&&delete u[h])}}function d(u,g,h){function f(r,o){let n=r;for(const i of o){if(typeof n!="object"||n===null)return;n=n[i]}return n}const l=g.split("."),t=f(u,l);return typeof t>"u"?h:t}e.$Si=d;function c(u,g,h){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in u?y.$Uf(u[f])&&y.$Uf(g[f])?c(u[f],g[f],h):h&&(u[f]=g[f]):u[f]=g[f])})}e.$Ti=c;function b(u){return u.replace(/[\[\]]/g,"")}e.$Ui=b}),define(Ee[69],ke([1,0,3,17,209,5,177,8]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",y.$d),v.set("isLinux",y.$e),v.set("isWindows",y.$c),v.set("isWeb",y.$i),v.set("isMacNative",y.$d&&!y.$i),v.set("isEdge",y.$B),v.set("isFirefox",y.$z),v.set("isChrome",y.$y),v.set("isSafari",y.$A);function p(W,F){if(v.get(W)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(W,F)}e.$aj=p;const D=Object.prototype.hasOwnProperty;var E;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const w={regexParsingWithErrorRecovery:!0},m=(0,k.localize)(0,null),d=(0,k.localize)(1,null),c=(0,k.localize)(2,null),b=(0,k.localize)(3,null),u=(0,k.localize)(4,null),g=(0,k.localize)(5,null),h=(0,k.localize)(6,null),f=(0,k.localize)(7,null);class l{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=w){this.k=F,this.d=new s.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const z=this.l();if(!this.E()){const _=this.D(),Q=_.type===17?g:void 0;throw this.h.push({message:u,offset:_.offset,lexeme:s.$_i.getLexeme(_),additionalInfo:Q}),l.c}return z}catch(z){if(z!==l.c)throw z;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(16);){const z=this.o();F.push(z)}return F.length===1?F[0]:t.or(...F)}o(){const F=[this.s()];for(;this.y(15);){const z=this.s();F.push(z)}return F.length===1?F[0]:t.and(...F)}s(){if(this.y(2)){const F=this.D();switch(F.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const z=this.l();return this.A(1,b),z?.negate()}case 17:return this.z(),M.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const z=this.l();return this.A(1,b),z}case 17:{const z=F.lexeme;if(this.z(),this.y(9)){const Q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Q.type!==10)throw this.B("REGEX",Q);const K=Q.lexeme,X=K.lastIndexOf("/"),Y=X===K.length-1?void 0:this.w(K.substring(X+1));let N;try{N=new RegExp(K.substring(1,X),Y)}catch{throw this.B("REGEX",Q)}return H.create(z,N)}switch(Q.type){case 10:case 19:{const K=[Q.lexeme];this.z();let X=this.D(),Y=0;for(let de=0;de<Q.lexeme.length;de++)Q.lexeme.charCodeAt(de)===40?Y++:Q.lexeme.charCodeAt(de)===41&&Y--;for(;!this.E()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let de=0;de<X.lexeme.length;de++)X.lexeme.charCodeAt(de)===40?Y++:Q.lexeme.charCodeAt(de)===41&&Y--}if(Y<0)break;K.push(s.$_i.getLexeme(X)),this.z(),X=this.D()}const N=K.join(""),U=N.lastIndexOf("/"),te=U===N.length-1?void 0:this.w(N.substring(U+1));let ie;try{ie=new RegExp(N.substring(1,U),te)}catch{throw this.B("REGEX",Q)}return t.regex(z,ie)}case 18:{const K=Q.lexeme;this.z();let X=null;if(!(0,C.$Se)(K)){const Y=K.indexOf("/"),N=K.lastIndexOf("/");if(Y!==N&&Y>=0){const U=K.slice(Y+1,N),te=K[N+1]==="i"?"i":"";try{X=new RegExp(U,te)}catch{throw this.B("REGEX",Q)}}}if(X===null)throw this.B("REGEX",Q);return H.create(z,X)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const Q=this.u();return t.notIn(z,Q)}switch(this.D().type){case 3:{this.z();const Q=this.u();if(this.x().type===18)return t.equals(z,Q);switch(Q){case"true":return t.has(z);case"false":return t.not(z);default:return t.equals(z,Q)}}case 4:{this.z();const Q=this.u();if(this.x().type===18)return t.notEquals(z,Q);switch(Q){case"true":return t.not(z);case"false":return t.has(z);default:return t.notEquals(z,Q)}}case 5:return this.z(),ue.create(z,this.u());case 6:return this.z(),j.create(z,this.u());case 7:return this.z(),ee.create(z,this.u());case 8:return this.z(),fe.create(z,this.u());case 13:return this.z(),t.in(z,this.u());default:return t.has(z)}}case 20:throw this.h.push({message:h,offset:F.offset,lexeme:"",additionalInfo:f}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case 17:case 18:return this.z(),F.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,z){if(this.C(F))return this.z();throw this.B(z,this.D())}B(F,z,_){const Q=(0,k.localize)(8,null,F,s.$_i.getLexeme(z)),K=z.offset,X=s.$_i.getLexeme(z);return this.h.push({message:Q,offset:K,lexeme:X,additionalInfo:_}),l.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=l,l.c=new Error;class t{static false(){return i.INSTANCE}static true(){return a.INSTANCE}static has(F){return $.create(F)}static equals(F,z){return A.create(F,z)}static notEquals(F,z){return O.create(F,z)}static regex(F,z){return H.create(F,z)}static in(F,z){return R.create(F,z)}static notIn(F,z){return I.create(F,z)}static not(F){return M.create(F)}static and(...F){return ne.create(F,null,!0)}static or(...F){return x.create(F,null,!0)}static greater(F,z){return ee.create(F,z)}static greaterEquals(F,z){return fe.create(F,z)}static smaller(F,z){return ue.create(F,z)}static smallerEquals(F,z){return j.create(F,z)}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$cj=t,t.c=new l({regexParsingWithErrorRecovery:!1});function r(W){const F=new l({regexParsingWithErrorRecovery:!1});return W.map(z=>(F.parse(z),F.lexingErrors.length>0?F.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,k.localize)(9,null,_.additionalInfo):(0,k.localize)(10,null),offset:_.offset,length:_.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}e.$dj=r;function o(W,F){const z=W?W.substituteConstants():void 0,_=F?F.substituteConstants():void 0;return!z&&!_?!0:!z||!_?!1:z.equals(_)}e.$ej=o;function n(W,F){return W.cmp(F)}class i{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return a.INSTANCE}}e.$fj=i,i.INSTANCE=new i;class a{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return i.INSTANCE}}e.$gj=a,a.INSTANCE=new a;class ${static create(F,z=null){const _=v.get(F);return typeof _=="boolean"?_?a.INSTANCE:i.INSTANCE:new $(F,z)}constructor(F,z){this.key=F,this.c=z,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:se(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=v.get(this.key);return typeof F=="boolean"?F?a.INSTANCE:i.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$hj=$;class A{static create(F,z,_=null){if(typeof z=="boolean")return z?$.create(F,_):M.create(F,_);const Q=v.get(F);return typeof Q=="boolean"?z===(Q?"true":"false")?a.INSTANCE:i.INSTANCE:new A(F,z,_)}constructor(F,z,_){this.c=F,this.d=z,this.f=_,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=v.get(this.c);if(typeof F=="boolean"){const z=F?"true":"false";return this.d===z?a.INSTANCE:i.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$ij=A;class R{static create(F,z){return new R(F,z)}constructor(F,z){this.d=F,this.f=z,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const z=F.getValue(this.f),_=F.getValue(this.d);return Array.isArray(z)?z.includes(_):typeof _=="string"&&typeof z=="object"&&z!==null?D.call(z,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$jj=R;class I{static create(F,z){return new I(F,z)}constructor(F,z){this.d=F,this.f=z,this.type=11,this.c=R.create(F,z)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=I;class O{static create(F,z,_=null){if(typeof z=="boolean")return z?M.create(F,_):$.create(F,_);const Q=v.get(F);return typeof Q=="boolean"?z===(Q?"true":"false")?i.INSTANCE:a.INSTANCE:new O(F,z,_)}constructor(F,z,_){this.c=F,this.d=z,this.f=_,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=v.get(this.c);if(typeof F=="boolean"){const z=F?"true":"false";return this.d===z?i.INSTANCE:a.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$lj=O;class M{static create(F,z=null){const _=v.get(F);return typeof _=="boolean"?_?i.INSTANCE:a.INSTANCE:new M(F,z)}constructor(F,z){this.c=F,this.d=z,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:se(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=v.get(this.c);return typeof F=="boolean"?F?i.INSTANCE:a.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$mj=M;function Z(W,F){if(typeof W=="string"){const z=parseFloat(W);isNaN(z)||(W=z)}return typeof W=="string"||typeof W=="number"?F(W):i.INSTANCE}class ee{static create(F,z,_=null){return Z(z,Q=>new ee(F,Q,_))}constructor(F,z,_){this.c=F,this.d=z,this.f=_,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$nj=ee;class fe{static create(F,z,_=null){return Z(z,Q=>new fe(F,Q,_))}constructor(F,z,_){this.c=F,this.d=z,this.f=_,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$oj=fe;class ue{static create(F,z,_=null){return Z(z,Q=>new ue(F,Q,_))}constructor(F,z,_){this.c=F,this.d=z,this.f=_,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=fe.create(this.c,this.d,this)),this.f}}e.$pj=ue;class j{static create(F,z,_=null){return Z(z,Q=>new j(F,Q,_))}constructor(F,z,_){this.c=F,this.d=z,this.f=_,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$qj=j;class H{static create(F,z){return new H(F,z)}constructor(F,z){this.d=F,this.f=z,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const z=this.f?this.f.source:"",_=F.f?F.f.source:"";return z<_?-1:z>_?1:0}equals(F){if(F.type===this.type){const z=this.f?this.f.source:"",_=F.f?F.f.source:"";return this.d===F.d&&z===_}return!1}substituteConstants(){return this}evaluate(F){const z=F.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$rj=H;class q{static create(F){return new q(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new q(this.c.map(F))}negate(){return this.c}}e.$sj=q;function J(W){let F=null;for(let z=0,_=W.length;z<_;z++){const Q=W[z].substituteConstants();if(W[z]!==Q&&F===null){F=[];for(let K=0;K<z;K++)F[K]=W[K]}F!==null&&(F[z]=Q)}return F===null?W:F}class ne{static create(F,z,_){return ne.d(F,z,_)}constructor(F,z){this.expr=F,this.c=z,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let z=0,_=this.expr.length;z<_;z++){const Q=n(this.expr[z],F.expr[z]);if(Q!==0)return Q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let z=0,_=this.expr.length;z<_;z++)if(!this.expr[z].equals(F.expr[z]))return!1;return!0}return!1}substituteConstants(){const F=J(this.expr);return F===this.expr?this:ne.create(F,this.c,!1)}evaluate(F){for(let z=0,_=this.expr.length;z<_;z++)if(!this.expr[z].evaluate(F))return!1;return!0}static d(F,z,_){const Q=[];let K=!1;for(const X of F)if(X){if(X.type===1){K=!0;continue}if(X.type===0)return i.INSTANCE;if(X.type===6){Q.push(...X.expr);continue}Q.push(X)}if(Q.length===0&&K)return a.INSTANCE;if(Q.length!==0){if(Q.length===1)return Q[0];Q.sort(n);for(let X=1;X<Q.length;X++)Q[X-1].equals(Q[X])&&(Q.splice(X,1),X--);if(Q.length===1)return Q[0];for(;Q.length>1;){const X=Q[Q.length-1];if(X.type!==9)break;Q.pop();const Y=Q.pop(),N=Q.length===0,U=x.create(X.expr.map(te=>ne.create([te,Y],null,_)),null,N);U&&(Q.push(U),Q.sort(n))}if(Q.length===1)return Q[0];if(_){for(let X=0;X<Q.length;X++)for(let Y=X+1;Y<Q.length;Y++)if(Q[X].negate().equals(Q[Y]))return i.INSTANCE;if(Q.length===1)return Q[0]}return new ne(Q,z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const z of this.expr)F.push(...z.keys());return F}map(F){return new ne(this.expr.map(z=>z.map(F)),null)}negate(){if(!this.c){const F=[];for(const z of this.expr)F.push(z.negate());this.c=x.create(F,this,!0)}return this.c}}e.$tj=ne;class x{static create(F,z,_){return x.d(F,z,_)}constructor(F,z){this.expr=F,this.c=z,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let z=0,_=this.expr.length;z<_;z++){const Q=n(this.expr[z],F.expr[z]);if(Q!==0)return Q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let z=0,_=this.expr.length;z<_;z++)if(!this.expr[z].equals(F.expr[z]))return!1;return!0}return!1}substituteConstants(){const F=J(this.expr);return F===this.expr?this:x.create(F,this.c,!1)}evaluate(F){for(let z=0,_=this.expr.length;z<_;z++)if(this.expr[z].evaluate(F))return!0;return!1}static d(F,z,_){let Q=[],K=!1;if(F){for(let X=0,Y=F.length;X<Y;X++){const N=F[X];if(N){if(N.type===0){K=!0;continue}if(N.type===1)return a.INSTANCE;if(N.type===9){Q=Q.concat(N.expr);continue}Q.push(N)}}if(Q.length===0&&K)return i.INSTANCE;Q.sort(n)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let X=1;X<Q.length;X++)Q[X-1].equals(Q[X])&&(Q.splice(X,1),X--);if(Q.length===1)return Q[0];if(_){for(let X=0;X<Q.length;X++)for(let Y=X+1;Y<Q.length;Y++)if(Q[X].negate().equals(Q[Y]))return a.INSTANCE;if(Q.length===1)return Q[0]}return new x(Q,z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const z of this.expr)F.push(...z.keys());return F}map(F){return new x(this.expr.map(z=>z.map(F)),null)}negate(){if(!this.c){const F=[];for(const z of this.expr)F.push(z.negate());for(;F.length>1;){const z=F.shift(),_=F.shift(),Q=[];for(const K of B(z))for(const X of B(_))Q.push(ne.create([K,X],null,!1));F.unshift(x.create(Q,null,!1))}this.c=x.create(F,this,!0)}return this.c}}e.$uj=x;class G extends ${static all(){return G.d.values()}constructor(F,z,_){super(F,null),this.f=z,typeof _=="object"?G.d.push({..._,key:F}):_!==!0&&G.d.push({key:F,description:_,type:z!=null?typeof z:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return A.create(this.key,F)}notEqualsTo(F){return O.create(this.key,F)}}e.$vj=G,G.d=[],e.$wj=(0,S.$ei)("contextKeyService");function se(W,F){return W<F?-1:W>F?1:0}function ce(W,F,z,_){return W<z?-1:W>z?1:F<_?-1:F>_?1:0}function re(W,F){if(W.type===0||F.type===1)return!0;if(W.type===9)return F.type===9?ge(W.expr,F.expr):!1;if(F.type===9){for(const z of F.expr)if(re(W,z))return!0;return!1}if(W.type===6){if(F.type===6)return ge(F.expr,W.expr);for(const z of W.expr)if(re(z,F))return!0;return!1}return W.equals(F)}e.$xj=re;function ge(W,F){let z=0,_=0;for(;z<W.length&&_<F.length;){const Q=W[z].cmp(F[_]);if(Q<0)return!1;Q===0&&z++,_++}return z===W.length}function B(W){return W.type===9?W.expr:[W]}}),define(Ee[219],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.ID=void 0,e.ID="diagnosticsService",e.$Vm=(0,y.$ei)(e.ID);function C(S){return!!S.hostName&&!!S.errorMessage}e.$Wm=C;class s{async getPerformanceInfo(k,P){return{}}async getSystemInfo(k,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,P){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.$Xm=s}),define(Ee[83],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,e.$qo=(0,y.$ei)("downloadService")}),define(Ee[26],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,y.$ei)("environmentService"),e.$mi=(0,y.$fi)(e.$li)}),define(Ee[30],ke([1,0,182,5]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.ExtensionGalleryErrorCode=e.$Mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0,e.$zo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ao=new RegExp(e.$zo),e.$Bo="__web_extension",e.$Co="skipWalkthrough",e.$Do="extensionsSync",e.$Eo="dependecyOrPackExtensionInstall";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Fo=s;function S(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Go=S;function k(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ho=k;function P(h,f){return f==="web"&&!h.includes("web")}e.$Io=P;function v(h,f,l){return P(f,l)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===l}e.$Jo=v;function p(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Ko=p;var D;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var w;(function(h){h.Install="install",h.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var m;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$Lo=(0,C.$ei)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var c;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class b extends Error{constructor(f,l){super(f),this.code=l,this.name=l}}e.$Mo=b;var u;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class g extends Error{constructor(f,l){super(f),this.code=l,this.name=l}}e.$No=g,e.$Oo=(0,C.$ei)("extensionManagementService"),e.$Po="extensionsIdentifiers/disabled",e.$Qo="extensionsIdentifiers/enabled",e.$Ro=(0,C.$ei)("IGlobalExtensionEnablementService"),e.$So=(0,C.$ei)("IExtensionTipsService"),e.$To=(0,y.localize2)(0,"Extensions"),e.$Uo=(0,y.localize2)(1,"Preferences")}),define(Ee[220],ke([1,0,6,2,21,4,53,30]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=void 0;function v(b,u){return b?S.URI.revive(u?u.transformIncoming(b):b):void 0}function p(b,u){return u?u.transformOutgoingURI(b):b}function D(b,u){u=u||k.$fn;const g=b.manifest;return{...(0,k.$in)({...b,manifest:void 0},u),manifest:g}}function E(b,u){return b?.profileLocation?(0,k.$in)(b,u??k.$fn):b}function w(b,u){return u?(0,s.$Kn)(b,g=>g instanceof S.URI?u.transformOutgoingURI(g):void 0):b}class m{constructor(u,g){this.a=u,this.b=g,this.onInstallExtension=y.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,g){const h=this.b(u);switch(g){case"onInstallExtension":return y.Event.map(this.onInstallExtension,f=>({...f,profileLocation:f.profileLocation?p(f.profileLocation,h):f.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,f=>f.map(l=>({...l,local:l.local?w(l.local,h):l.local,profileLocation:l.profileLocation?p(l.profileLocation,h):l.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,f=>({...f,profileLocation:f.profileLocation?p(f.profileLocation,h):f.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,f=>({...f,profileLocation:f.profileLocation?p(f.profileLocation,h):f.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,f=>w(f,h))}throw new Error("Invalid listen")}async call(u,g,h){const f=this.b(u);switch(g){case"zip":{const l=D(h[0],f),t=await this.a.zip(l);return p(t,f)}case"unzip":return this.a.unzip(v(h[0],f));case"install":return this.a.install(v(h[0],f),E(h[1],f));case"installFromLocation":return this.a.installFromLocation(v(h[0],f),v(h[1],f));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],v(h[1],f),v(h[2],f));case"getManifest":return this.a.getManifest(v(h[0],f));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],E(h[1],f));case"installGalleryExtensions":{const l=h[0];return this.a.installGalleryExtensions(l.map(({extension:t,options:r})=>({extension:t,options:E(r,f)??{}})))}case"uninstall":return this.a.uninstall(D(h[0],f),E(h[1],f));case"reinstallFromGallery":return this.a.reinstallFromGallery(D(h[0],f));case"getInstalled":return(await this.a.getInstalled(h[0],v(h[1],f))).map(t=>w(t,f));case"toggleAppliationScope":{const l=await this.a.toggleAppliationScope(D(h[0],f),v(h[1],f));return w(l,f)}case"copyExtensions":return this.a.copyExtensions(v(h[0],f),v(h[1],f));case"updateMetadata":{const l=await this.a.updateMetadata(D(h[0],f),h[1],v(h[2],f));return w(l,f)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Up=m;class d extends C.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.m=u,this.c=this.B(new y.$5d),this.f=this.B(new y.$5d),this.g=this.B(new y.$5d),this.h=this.B(new y.$5d),this.j=this.B(new y.$5d),this.B(this.m.listen("onInstallExtension")(g=>this.n(this.c,{...g,source:this.r(g.source)?S.URI.revive(g.source):g.source,profileLocation:S.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(g=>this.n(this.f,g.map(h=>({...h,local:h.local?D(h.local,null):h.local,source:this.r(h.source)?S.URI.revive(h.source):h.source,profileLocation:S.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(g=>this.n(this.g,{...g,profileLocation:S.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(g=>this.n(this.h,{...g,profileLocation:S.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(D(g,null))))}n(u,g){u.fire(g)}r(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(u){const g=await this.getTargetPlatform();return u.allTargetPlatforms.some(h=>(0,P.$Jo)(h,u.allTargetPlatforms,g))}zip(u){return Promise.resolve(this.m.call("zip",[u]).then(g=>S.URI.revive(g)))}unzip(u){return Promise.resolve(this.m.call("unzip",[u]))}install(u,g){return Promise.resolve(this.m.call("install",[u,g])).then(h=>D(h,null))}installFromLocation(u,g){return Promise.resolve(this.m.call("installFromLocation",[u,g])).then(h=>D(h,null))}async installExtensionsFromProfile(u,g,h){return(await this.m.call("installExtensionsFromProfile",[u,g,h])).map(l=>D(l,null))}getManifest(u){return Promise.resolve(this.m.call("getManifest",[u]))}installFromGallery(u,g){return Promise.resolve(this.m.call("installFromGallery",[u,g])).then(h=>D(h,null))}async installGalleryExtensions(u){return(await this.m.call("installGalleryExtensions",[u])).map(h=>({...h,local:h.local?D(h.local,null):h.local,source:this.r(h.source)?S.URI.revive(h.source):h.source,profileLocation:S.URI.revive(h.profileLocation)}))}uninstall(u,g){return Promise.resolve(this.m.call("uninstall",[u,g]))}reinstallFromGallery(u){return Promise.resolve(this.m.call("reinstallFromGallery",[u])).then(g=>D(g,null))}getInstalled(u=null,g){return Promise.resolve(this.m.call("getInstalled",[u,g])).then(h=>h.map(f=>D(f,null)))}updateMetadata(u,g,h){return Promise.resolve(this.m.call("updateMetadata",[u,g,h])).then(f=>D(f,null))}toggleAppliationScope(u,g){return this.m.call("toggleAppliationScope",[u,g]).then(h=>D(h,null))}copyExtensions(u,g){return this.m.call("copyExtensions",[u,g])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(u,g,h){const f=await this.m.call("download",[u,g,h]);return S.URI.revive(f)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Vp=d;class c{constructor(u){this.a=u}listen(u,g){throw new Error("Invalid listen")}call(u,g,h){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(S.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Wp=c}),define(Ee[16],ke([1,0,66,7,17,9,4,190,5,3,12,60]),function(le,e,y,C,s,S,k,P,v,p,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,v.$ei)("fileService");function w(re){return re.create===!0}e.$Ck=w;var m;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function c(re){const ge=re;return!!ge&&typeof ge.onDidChange=="function"}e.$Dk=c;var b;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function u(re){return!!(re.capabilities&2)}e.$Ek=u;function g(re){return!!(re.capabilities&8)}e.$Fk=g;function h(re){return!!(re.capabilities&131072)}e.$Gk=h;function f(re){return!!(re.capabilities&4)}e.$Hk=f;function l(re){return!!(re.capabilities&16)}e.$Ik=l;function t(re){return u(re)?!!(re.capabilities&16384):!1}e.$Jk=t;function r(re){return u(re)?!!(re.capabilities&32768):!1}e.$Kk=r;function o(re){return!!(re.capabilities&65536)}e.$Lk=o;function n(re){return!!(re.capabilities&2048)}e.$Mk=n;var i;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class a extends Error{static create(ge,B){const W=new a(ge.toString(),B);return R(W,B),W}constructor(ge,B){super(ge),this.code=B}}e.$Nk=a;function $(re,ge){return a.create(re,ge)}e.$Ok=$;function A(re){return re||$((0,P.localize)(0,null),i.Unknown)}e.$Pk=A;function R(re,ge){return re.name=ge?`${ge} (FileSystemError)`:"FileSystemError",re}e.$Qk=R;function I(re){if(!re)return i.Unknown;if(re instanceof a)return re.code;const ge=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ge)return i.Unknown;switch(ge[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$Rk=I;function O(re){if(re instanceof j)return re.fileOperationResult;switch(I(re)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$Sk=O;var M;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class Z{constructor(ge,B,W){this.resource=ge,this.operation=B,this.target=W}isOperation(ge){return this.operation===ge}}e.$Tk=Z;var ee;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(ee||(e.FileChangeType=ee={}));class fe{constructor(ge,B){this.c=B,this.b=void 0,this.d=new E.$V(()=>{const W=y.$ki.forUris(()=>this.c);return W.fill(this.rawAdded.map(F=>[F,!0])),W}),this.f=new E.$V(()=>{const W=y.$ki.forUris(()=>this.c);return W.fill(this.rawUpdated.map(F=>[F,!0])),W}),this.g=new E.$V(()=>{const W=y.$ki.forUris(()=>this.c);return W.fill(this.rawDeleted.map(F=>[F,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of ge){switch(W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}this.b!==fe.a&&(typeof W.cId=="number"?this.b===void 0?this.b=W.cId:this.b!==W.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains(ge,...B){return this.h(ge,{includeChildren:!1},...B)}affects(ge,...B){return this.h(ge,{includeChildren:!0},...B)}h(ge,B,...W){if(!ge)return!1;const F=W.length>0;return!!((!F||W.includes(1))&&(this.d.value.get(ge)||B.includeChildren&&this.d.value.findSuperstr(ge))||(!F||W.includes(0))&&(this.f.value.get(ge)||B.includeChildren&&this.f.value.findSuperstr(ge))||(!F||W.includes(2))&&(this.g.value.findSubstr(ge)||B.includeChildren&&this.g.value.findSuperstr(ge)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ge){return this.b===ge}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=fe,fe.a=null;function ue(re,ge,B){return!re||!ge||re===ge||ge.length>re.length?!1:(ge.charAt(ge.length-1)!==C.sep&&(ge+=C.sep),B?(0,s.$kf)(re,ge):re.indexOf(ge)===0)}e.$Vk=ue;class j extends Error{constructor(ge,B,W){super(ge),this.fileOperationResult=B,this.options=W}}e.$Wk=j;class H extends j{constructor(ge,B,W,F){super(ge,B,F),this.fileOperationResult=B,this.size=W}}e.$Xk=H;class q extends j{constructor(ge,B,W){super(ge,2,W),this.stat=B}}e.$Yk=q;var J;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var ne;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.$7k="";function x(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$8k=x;async function G(re,ge){if(!ge.hasProvider(k.URI.from({scheme:re.scheme})))return new Promise(B=>{const W=ge.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===re.scheme&&F.added&&(W.dispose(),B())})})}e.$9k=G;class se{static formatSize(ge){return(0,S.$Wf)(ge)||(ge=0),ge<se.KB?(0,P.localize)(1,null,ge.toFixed(0)):ge<se.MB?(0,P.localize)(2,null,(ge/se.KB).toFixed(2)):ge<se.GB?(0,P.localize)(3,null,(ge/se.MB).toFixed(2)):ge<se.TB?(0,P.localize)(4,null,(ge/se.GB).toFixed(2)):(0,P.localize)(5,null,(ge/se.TB).toFixed(2))}}e.$0k=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;function ce(re){const ge=typeof re=="string"||re?.scheme===D.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===D.Schemas.file?1024*se.MB:ge?10*se.MB:p.$i?50*se.MB:1024*se.MB}e.$$k=ce}),define(Ee[111],ke([1,0,14,8,191,16]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;async function k(D,E,w,m,d,c){let b;try{await P(D,E,w,m,d,c)}catch(u){b=u}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b<"u"&&w.error(b),w.end()}}e.$nq=k;async function P(D,E,w,m,d,c){v(c);const b=await D.open(E,{create:!1});try{v(c);let u=0,g=0,h=d&&typeof d.length=="number"?d.length:void 0,f=y.$se.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),l=d&&typeof d.position=="number"?d.position:0,t=0;do g=await D.read(b,l,f.buffer,t,f.byteLength-t),l+=g,t+=g,u+=g,typeof h=="number"&&(h-=g),t===f.byteLength&&(await w.write(m(f)),f=y.$se.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),t=0);while(g>0&&(typeof h!="number"||h>0)&&v(c)&&p(u,d));if(t>0){let r=t;typeof h=="number"&&(r=Math.min(t,h)),w.write(m(f.slice(0,r)))}}catch(u){throw(0,S.$Pk)(u)}finally{await D.close(b)}}function v(D){if(D.isCancellationRequested)throw(0,C.$6)();return!0}function p(D,E){if(typeof E?.limits?.size=="number"&&D>E.limits.size)throw(0,S.$Ok)((0,s.localize)(0,null),S.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[56],ke([1,0,77,2,7,3,4,16]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=void 0;function v(u){return u.recursive===!0}e.$pq=v;class p extends C.$Tc{constructor(g,h,f,l){super(),this.h=g,this.j=h,this.m=f,this.n=l,this.c=this.B(new C.$Uc),this.f=void 0,this.g=0}s(){const g=new C.$Sc;this.c.value=g,this.b=this.r(g),this.b.setVerboseLogging(this.m),g.add(this.b.onDidChangeFile(h=>this.h(h))),g.add(this.b.onDidLogMessage(h=>this.j(h))),g.add(this.b.onDidError(h=>this.t(h)))}t(g){this.n.restartOnError?this.g<p.a&&this.f?(this.w(`restarting watcher after error: ${g}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${g}`):this.w(g)}u(g){this.g++,this.s(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.m=g,await this.b?.setVerboseLogging(g)}w(g){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${g}`})}y(g){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}e.$qq=p,p.a=5;class D extends p{constructor(g,h,f){super(g,h,f,{type:"node.js",restartOnError:!1})}}e.$rq=D;class E extends p{constructor(g,h,f){super(g,h,f,{type:"universal",restartOnError:!0})}}e.$sq=E;function w(u){return u.map(g=>({type:g.type,resource:k.URI.revive(g.resource),cId:g.cId}))}e.$tq=w;function m(u){const g=new b;for(const h of u)g.processEvent(h);return g.coalesce()}e.$uq=m;function d(u,g){return typeof g=="string"&&!g.startsWith(y.$Tj)&&!(0,s.$ic)(g)?{base:u,pattern:g}:g}e.$vq=d;function c(u,g){const h=[];for(const f of g)h.push((0,y.$Xj)(d(u,f)));return h}e.$wq=c;class b{constructor(){this.a=new Set,this.b=new Map}c(g){return S.$e?g.resource.fsPath:g.resource.fsPath.toLowerCase()}processEvent(g){const h=this.b.get(this.c(g));let f=!1;if(h){const l=h.type,t=g.type;h.resource.fsPath!==g.resource.fsPath&&(g.type===2||g.type===1)?f=!0:l===1&&t===2?(this.b.delete(this.c(g)),this.a.delete(h)):l===2&&t===1?h.type=0:l===1&&t===0||(h.type=t)}else f=!0;f&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],h=[];return Array.from(this.a).filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,l)=>f.resource.fsPath.length-l.resource.fsPath.length).filter(f=>h.some(l=>(0,P.$Vk)(f.resource.fsPath,l,!S.$e))?!1:(h.push(f.resource.fsPath),!0)).concat(g)}}}),define(Ee[221],ke([1,0,14,40,8,6,2,50,22,16,56]),function(le,e,y,C,s,S,k,P,v,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0,e.$kP="localFilesystem";class E extends k.$Tc{constructor(m,d){super(),this.a=m,this.b=d,this.onDidChangeCapabilities=S.Event.None,this.f=this.B(new S.$5d),this.onDidChangeFile=this.f.event,this.g=this.B(new S.$5d),this.onDidWatchError=this.g.event,this.h=(0,v.$Ag)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,d){const{buffer:c}=await this.a.call("readFile",[m,d]);return c}readFileStream(m,d,c){const b=(0,P.$ge)(g=>y.$se.concat(g.map(h=>y.$se.wrap(h))).buffer),u=new k.$Sc;return u.add(this.a.listen("readFileStream",[m,d])(g=>{if(g instanceof y.$se)b.write(g.buffer);else{if(g==="end")b.end();else{let h;if(g instanceof Error)h=g;else{const f=g;h=(0,p.$Ok)(f.message??(0,C.$2i)(f),f.code??p.FileSystemProviderErrorCode.Unknown)}b.error(h),b.end()}u.dispose()}})),u.add(c.onCancellationRequested(()=>{b.error((0,s.$6)()),b.end(),u.dispose()})),b}writeFile(m,d,c){return this.a.call("writeFile",[m,y.$se.wrap(d),c])}open(m,d){return this.a.call("open",[m,d])}close(m){return this.a.call("close",[m])}async read(m,d,c,b,u){const[g,h]=await this.a.call("read",[m,d,u]);return c.set(g.buffer.slice(0,h),b),h}write(m,d,c,b,u){return this.a.call("write",[m,d,y.$se.wrap(c),b,u])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,d){return this.a.call("delete",[m,d])}rename(m,d,c){return this.a.call("rename",[m,d,c])}copy(m,d,c){return this.a.call("copy",[m,d,c])}cloneFile(m,d){return this.a.call("cloneFile",[m,d])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const d=m;this.f.fire((0,D.$tq)(d))}else{const d=m;this.g.fire(d)}}))}watch(m,d){const c=(0,v.$Ag)();return this.a.call("watch",[this.h,c,m,d]),(0,k.$Rc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$lP=E}),define(Ee[222],ke([1,0,29,15,20,39,2,99,7,3,19,4,161,23,56]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class c extends k.$Tc{constructor(g,h,f,l){super(),this.m=g,this.n=h,this.r=f,this.s=l,this.c=this.B(new C.$th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new C.$sh(t=>this.z(t),c.b)),this.g=(0,d.$wq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$wq)(this.m.path,this.m.includes):void 0,this.j=new s.$ce,this.ready=this.t()}async t(){try{const g=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await m.Promises.stat(g);this.B(await this.w(g,h.isDirectory()))}catch(g){g.code!=="ENOENT"?this.D(g):this.G(g)}}async u(g){let h=g.path;try{h=await m.Promises.realpath(g.path),g.path===h&&(h=await(0,w.$Gq)(g.path)??g.path),g.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${h})`)}catch{}return h}async w(g,h){if(p.$d&&(0,S.$fg)(g,"/Volumes/",!0))return this.D(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.$Tc.None;const f=new s.$ce(this.j.token),l=new k.$Sc;try{const t=E.URI.file(this.m.path),r=(0,v.$nc)(g),o=(0,y.watch)(g);l.add((0,k.$Rc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${g}'`);const n=new Set;if(h)try{for(const a of await m.Promises.readdir(g))n.add(a)}catch(a){this.D(a)}const i=new Map;l.add((0,k.$Rc)(()=>{for(const[,a]of i)a.dispose();i.clear()})),o.on("error",(a,$)=>{this.D(`Failed to watch ${g} for changes using fs.watch() (${a}, ${$})`),this.dispose()}),o.on("change",(a,$)=>{if(f.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${$}`);let A="";if($&&(A=$.toString(),p.$d&&(A=(0,P.$Sl)(A))),!(!A||a!=="change"&&a!=="rename"))if(h)if(a==="rename"){i.get(A)?.dispose();const R=setTimeout(async()=>{if(i.delete(A),A===r&&!await m.Promises.exists(g)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const I=await this.C((0,v.$jc)(g,A));if(f.token.isCancellationRequested)return;let O;I?n.has(A)?O=0:(O=1,n.add(A)):(n.delete(A),O=2),this.y({resource:(0,D.$Rg)(t,A),type:O,cId:this.m.correlationId})},c.a);i.set(A,(0,k.$Rc)(()=>clearTimeout(R)))}else{let R;n.has(A)?R=0:(R=1,n.add(A)),this.y({resource:(0,D.$Rg)(t,A),type:R,cId:this.m.correlationId})}else if(a==="rename"||A!==r){const R=setTimeout(async()=>{const I=await m.Promises.exists(g);f.token.isCancellationRequested||(I?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),l.add(await this.w(g,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);l.clear(),l.add((0,k.$Rc)(()=>clearTimeout(R)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await m.Promises.exists(g)&&!f.token.isCancellationRequested&&this.D(`Failed to watch ${g} for changes using fs.watch() (${t.toString()})`)}return(0,k.$Rc)(()=>{f.dispose(!0),l.dispose()})}y(g,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!h&&this.g.some(f=>f(g.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${g.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(f=>f(g.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}z(g){const h=(0,d.$uq)(g);if(h.length>0){if(this.s)for(const l of h)this.G(` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(g){if(p.$e)return m.Promises.exists(g);try{const h=(0,v.$nc)(g);return(await m.Promises.readdir((0,v.$mc)(g))).some(l=>l===h)}catch(h){return this.G(h),!1}}setVerboseLogging(g){this.s=g}D(g){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}F(g){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}G(g){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Jq=c,c.a=100,c.b=75;async function b(u,g,h,f,l=512){const t=await m.Promises.open(u,"r"),r=Buffer.allocUnsafe(l),o=new s.$ce(f);let n,i=!1;const a={path:u,excludes:[],recursive:!1},$=new c(a,A=>{(async()=>{for(const{type:R}of A)if(R===0){if(i)return;i=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(t,r,0,l,null);if(!I||o.token.isCancellationRequested)break;g(r.slice(0,I))}}catch(I){n=new Error(I),o.dispose(!0)}finally{i=!1}}})()});return await $.ready,h(),new Promise((A,R)=>{o.token.onCancellationRequested(async()=>{$.dispose();try{await m.Promises.close(t)}catch(I){n=new Error(I)}n?R(n):A()})})}e.$Kq=b}),define(Ee[223],ke([1,0,6,77,2,3,222]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class P extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new y.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$5d),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(p){const D=this.j(p),E=D.filter(m=>{const d=this.c.get(m.path);return d?!(0,C.$2j)(d.request.excludes,m.excludes)||!(0,C.$2j)(d.request.includes,m.includes):!0}),w=Array.from(this.c.values()).filter(({request:m})=>!D.find(d=>d.path===m.path&&(0,C.$2j)(d.excludes,m.excludes)&&(0,C.$2j)(d.includes,m.includes))).map(({request:m})=>m.path);E.length&&this.m(`Request to start watching: ${E.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const m of w)this.h(m);for(const m of E)this.g(m)}g(p){const D=new k.$Jq(p,w=>this.a.fire(w),w=>this.b.fire(w),this.f),E={request:p,instance:D};this.c.set(p.path,E)}async stop(){for(const[p]of this.c)this.h(p);this.c.clear()}h(p){const D=this.c.get(p);D&&(this.c.delete(p),D.instance.dispose())}j(p){const D=new Map;for(const E of p){const w=S.$e?E.path:E.path.toLowerCase();let m=D.get(E.correlationId);m||(m=new Map,D.set(E.correlationId,m)),m.set(w,E)}return Array.from(D.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(p){this.f=p;for(const[,D]of this.c)D.instance.setVerboseLogging(p)}m(p){this.f&&this.b.fire({type:"trace",message:this.n(p)})}n(p,D){return D?`[File Watcher (node.js)] ${p} (path: ${D.request.path})`:`[File Watcher (node.js)] ${p}`}}e.$Lq=P}),define(Ee[224],ke([1,0,56,223]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class s extends y.$rq{constructor(k,P,v){super(k,P,v),this.s()}r(k){return k.add(new C.$Lq)}}e.$Mq=s}),define(Ee[225],ke([1,0,12,43,108,56]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class k extends S.$sq{constructor(v,p,D){super(v,p,D),this.s()}r(v){const p=v.add(new s.$Dq(y.$yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(p.onDidProcessExit(({code:D,signal:E})=>this.t(`terminated by itself with code ${D}, signal: ${E}`))),C.ProxyChannel.toService((0,C.$Xh)(p.getChannel("watcher")))}}e.$Eq=k}),define(Ee[84],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class y{constructor(...s){this.a=new Map;for(const[S,k]of s)this.set(S,k)}set(s,S){const k=this.a.get(s);return this.a.set(s,S),k}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$ci=y}),define(Ee[112],ke([1,0,15,8,2,68,218,5,84,98]),function(le,e,y,C,s,S,k,P,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;const D=!1;class E extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class w{constructor(b=new v.$ci,u=!1,g,h=D){this.f=b,this.g=u,this.h=g,this.i=h,this.o=new Set,this.f.set(P.$di,this),this._globalGraph=h?g?._globalGraph??new k.$Pq(f=>f):void 0}createChild(b){return new w(b,this.g,this,this.i)}invokeFunction(b,...u){const g=d.traceInvocation(this.i,b);let h=!1;try{return b({get:l=>{if(h)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(l,g);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...u)}finally{h=!0,g.stop()}}createInstance(b,...u){let g,h;return b instanceof S.$bi?(g=d.traceCreation(this.i,b.ctor),h=this.j(b.ctor,b.staticArguments.concat(u),g)):(g=d.traceCreation(this.i,b),h=this.j(b,u,g)),g.stop(),h}j(b,u=[],g){const h=P._util.getServiceDependencies(b).sort((t,r)=>t.index-r.index),f=[];for(const t of h){const r=this.m(t.id,g);r||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(r)}const l=h.length>0?h[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${b.name} at position ${l+1} conflicts with ${u.length} static arguments`);const t=l-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,l)}return Reflect.construct(b,u.concat(f))}k(b,u){if(this.f.get(b)instanceof S.$bi)this.f.set(b,u);else if(this.h)this.h.k(b,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const u=this.f.get(b);return!u&&this.h?this.h.l(b):u}m(b,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const g=this.l(b);return g instanceof S.$bi?this.q(b,g,u.branch(b,!0)):(u.branch(b,!1),g)}q(b,u,g){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,u,g)}finally{this.o.delete(b)}}r(b,u,g){const h=new k.$Pq(t=>t.id.toString());let f=0;const l=[{id:b,desc:u,_trace:g}];for(;l.length;){const t=l.pop();if(h.lookupOrInsertNode(t),f++>1e3)throw new E(h);for(const r of P._util.getServiceDependencies(t.desc.ctor)){const o=this.l(r.id);if(o||this.u(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),o instanceof S.$bi){const n={id:r.id,desc:o,_trace:t._trace.branch(r.id,!0)};h.insertEdge(t,n),l.push(n)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new E(h);break}for(const{data:r}of t){if(this.l(r.id)instanceof S.$bi){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}h.removeNode(r)}}return this.l(b)}s(b,u,g=[],h,f){if(this.f.get(b)instanceof S.$bi)return this.t(b,u,g,h,f);if(this.h)return this.h.s(b,u,g,h,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(b,u,g=[],h,f){if(h){const l=new w(void 0,this.g,this,this.i);l.c=String(b);const t=new Map,r=new y.$xh(()=>{const o=l.j(u,g,f);for(const[n,i]of t){const a=o[n];if(typeof a=="function")for(const $ of i)$.disposable=a.apply(o,$.listener)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let $=t.get(n);return $||($=new p.$4c,t.set(n,$)),(R,I,O)=>{if(r.isInitialized)return r.value[n](R,I,O);{const M={listener:[R,I,O],disposable:void 0},Z=$.push(M);return(0,s.$Rc)(()=>{Z(),M.disposable?.dispose()})}}}if(n in o)return o[n];const i=r.value;let a=i[n];return typeof a!="function"||(a=a.bind(i),o[n]=a),a},set(o,n,i){return r.value[n]=i,!0},getPrototypeOf(o){return u.prototype}})}else return this.j(u,g,f)}u(b,u){if(u&&console.warn(b),this.g)throw new Error(b)}}e.$Qq=w;var m;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(m||(m={}));class d{static traceInvocation(b,u){return b?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(b,u){return b?new d(1,u.name):d.c}constructor(b,u){this.type=b,this.name=u,this.g=Date.now(),this.h=[]}branch(b,u){const g=new d(3,b.toString());return this.h.push([b,u,g]),g}stop(){const b=Date.now()-this.g;d.f+=b;let u=!1;function g(f,l){const t=[],r=new Array(f+1).join("	");for(const[o,n,i]of l.h)if(n&&i){u=!0,t.push(`${r}CREATES -> ${o}`);const a=g(f+1,i);a&&t.push(a)}else t.push(`${r}uses -> ${o}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(b>2||u)&&d.all.add(h.join(`
`))}}e.$Rq=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(Ee[226],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Bv=void 0,e.$Bv=(0,y.$ei)("labelService");var C;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(C||(e.Verbosity=C={}))});var Ne=this&&this.__param||function(le,e){return function(y,C){e(y,C,le)}};define(Ee[85],ke([1,0,20,2,3,193,30,5]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=void 0;function v(D){return D.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$sr=v,e.$tr=(0,P.$ei)("languagePackService");let p=class extends C.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new y.$ce;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const d=w.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(b=>b.startsWith("lp-"))).map(c=>{const b=c.properties.localizedLanguages?.[0],u=v(c);return{...this.f(u,b,c),extensionId:c.identifier.id,galleryExtension:c}});return d.push(this.f("en","English")),d}f(E,w,m){const d=w??E;let c;if(d!==E&&(c=`(${E})`),E.toLowerCase()===s.$q.toLowerCase()&&(c??(c=""),c+=(0,S.localize)(0,null)),m?.installCount){c??(c="");const b=m.installCount;let u;b>1e6?u=`${Math.floor(b/1e5)/10}M`:b>1e3?u=`${Math.floor(b/1e3)}K`:u=String(b),c+=` $(cloud-download) ${u}`}return{id:E,label:d,description:c}}};e.$ur=p,e.$ur=p=Le([Ne(0,k.$Lo)],p)}),define(Ee[13],ke([1,0,40,6,64,2,24,3,19,9,4,69,5]),function(le,e,y,C,s,S,k,P,v,p,D,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,w.$ei)("logService"),e.$zj=(0,w.$ei)("loggerService");function m(){return new Date().toISOString()}function d(R){return(0,p.$Wf)(R)}e.$Aj=d;var c;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$Bj=c.Info;function b(R,I,O){switch(I){case c.Trace:R.trace(O);break;case c.Debug:R.debug(O);break;case c.Info:R.info(O);break;case c.Warning:R.warn(O);break;case c.Error:R.error(O);break;case c.Off:break;default:throw new Error(`Invalid log level ${I}`)}}e.log=b;function u(R,I=!1){let O="";for(let M=0;M<R.length;M++){let Z=R[M];if(Z instanceof Error&&(Z=(0,y.$2i)(Z,I)),typeof Z=="object")try{Z=JSON.stringify(Z)}catch{}O+=(M>0?" ":"")+Z}return O}class g extends S.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new C.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==c.Off&&this.b<=I}}e.$Dj=g;class h extends g{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...O){this.f(c.Trace)&&this.g(c.Trace,u([I,...O],!0))}debug(I,...O){this.f(c.Debug)&&this.g(c.Debug,u([I,...O]))}info(I,...O){this.f(c.Info)&&this.g(c.Info,u([I,...O]))}warn(I,...O){this.f(c.Warning)&&this.g(c.Warning,u([I,...O]))}error(I,...O){if(this.f(c.Error))if(I instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=I.stack,this.g(c.Error,u(M))}else this.g(c.Error,u([I,...O]))}flush(){}}e.$Ej=h;class f extends g{constructor(I=e.$Bj){super(),this.setLevel(I),this.g=!P.$c}trace(I,...O){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,I,...O):console.log(`[main ${m()}]`,I,...O))}debug(I,...O){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,I,...O):console.log(`[main ${m()}]`,I,...O))}info(I,...O){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,I,...O):console.log(`[main ${m()}]`,I,...O))}warn(I,...O){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,I,...O):console.warn(`[main ${m()}]`,I,...O))}error(I,...O){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,I,...O):console.error(`[main ${m()}]`,I,...O))}flush(){}}e.$Fj=f;class l extends g{constructor(I=e.$Bj,O=!0){super(),this.g=O,this.setLevel(I)}trace(I,...O){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...O):console.log(I,...O))}debug(I,...O){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...O):console.log(I,...O))}info(I,...O){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...O):console.log(I,...O))}warn(I,...O){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...O):console.log(I,...O))}error(I,...O){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...O):console.error(I,...O))}flush(){}}e.$Gj=l;class t extends g{constructor(I,O=e.$Bj){super(),this.g=I,this.setLevel(O)}trace(I,...O){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(I),...O])}debug(I,...O){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(I),...O])}info(I,...O){this.f(c.Info)&&this.g.log(c.Info,[this.h(I),...O])}warn(I,...O){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(I),...O])}error(I,...O){this.f(c.Error)&&this.g.log(c.Error,[this.h(I),...O])}h(I){return typeof I=="string"?I:(0,y.$2i)(I,this.f(c.Trace))}flush(){}}e.$Hj=t;class r extends g{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const O of this.g)O.setLevel(I);super.setLevel(I)}trace(I,...O){for(const M of this.g)M.trace(I,...O)}debug(I,...O){for(const M of this.g)M.debug(I,...O)}info(I,...O){for(const M of this.g)M.info(I,...O)}warn(I,...O){for(const M of this.g)M.warn(I,...O)}error(I,...O){for(const M of this.g)M.error(I,...O)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$Ij=r;class o extends S.$Tc{constructor(I,O,M){if(super(),this.h=I,this.j=O,this.b=new k.$Ac,this.c=this.B(new C.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$5d),this.onDidChangeVisibility=this.g.event,M)for(const Z of M)this.b.set(Z.resource,{logger:void 0,info:Z})}m(I){return(0,p.$Sf)(I)?[...this.b.values()].find(O=>O.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,O){const M=this.n(I),Z=(0,p.$Sf)(I)?I:O?.id??(0,s.$5i)(M.toString()).toString(16);let ee=this.b.get(M)?.logger;const fe=O?.logLevel==="always"?c.Trace:O?.logLevel;ee||(ee=this.s(M,fe??this.getLogLevel(M)??this.h,{...O,id:Z}));const ue={logger:ee,info:{resource:M,id:Z,logLevel:fe,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(ue.info),this.b.set(M,ue),ee}n(I){return(0,p.$Sf)(I)?(0,v.$Rg)(this.j,`${I}.log`):I}setLogLevel(I,O){if(D.URI.isUri(I)){const M=I,Z=O,ee=this.b.get(M);ee&&Z!==ee.info.logLevel&&(ee.info.logLevel=Z===this.h?void 0:Z,ee.logger?.setLevel(Z),this.b.set(ee.info.resource,ee),this.f.fire([M,Z]))}else{this.h=I;for(const[M,Z]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&Z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,O){const M=this.m(I);M&&O!==!M.info.hidden&&(M.info.hidden=!O,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,O]))}getLogLevel(I){let O;return I&&(O=this.b.get(I)?.info.logLevel),O??this.h}registerLogger(I){const O=this.b.get(I.resource);O?O.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const O=this.b.get(I);O&&(O.logger&&O.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=o;class n{constructor(){this.onDidChangeLogLevel=new C.$5d().event}setLevel(I){}getLevel(){return c.Info}trace(I,...O){}debug(I,...O){}info(I,...O){}warn(I,...O){}error(I,...O){}critical(I,...O){}dispose(){}flush(){}}e.$Kj=n;class i extends n{}e.$Lj=i;function a(R){if(R.verbose)return c.Trace;if(typeof R.logLevel=="string"){const I=A(R.logLevel.toLowerCase());if(I!==void 0)return I}return e.$Bj}e.$Mj=a;function $(R){switch(R){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Nj=$;function A(R){switch(R){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Oj=A,e.$Pj=new E.$vj("logLevel",$(c.Info))}),define(Ee[86],ke([1,0,8,5,13]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Rp=(0,C.$ei)("IExtensionSignatureVerificationService");let S=class{constructor(P){this.b=P}c(){return this.a||(this.a=new Promise((P,v)=>le(["@vscode/vsce-sign"],async p=>P(p),v))),this.a}async verify(P,v,p){let D;try{D=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,y.$0)(E)),!1}return D.verify(P,v,p)}};e.$Sp=S,e.$Sp=S=Le([Ne(0,s.$yj)],S)}),define(Ee[227],ke([1,0,18,15,8,6,2,7,56,13]),function(le,e,y,C,s,S,k,P,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;class D extends k.$Tc{constructor(w,m){super(),this.a=w,this.b=m,this.c=this.B(new S.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new S.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$ch(0)),this.w=[],this.y=this.B(new C.$ch(0))}watch(w,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(w,m):this.z(w,m)}n(w,m){const d={path:this.H(w),excludes:m.excludes,includes:m.includes,recursive:m.recursive,correlationId:m.correlationId},c=(0,y.$Ub)(this.j,d);return this.r(),(0,k.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,s.$1)(w))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,v.$tq)(m)),m=>this.G(m),this.a.getLevel()===p.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===p.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const m of this.j)(0,v.$pq)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const m of this.j)(0,v.$pq)(m)&&w.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,m){const d={path:this.H(w),excludes:m.excludes,includes:m.includes,recursive:!1,correlationId:m.correlationId},c=(0,y.$Ub)(this.w,d);return this.C(),(0,k.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,s.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,v.$tq)(w)),w=>this.G(w),this.a.getLevel()===p.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===p.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,P.$hc)(w.fsPath)}}e.$xq=D}),define(Ee[113],ke([1,0,18,15,14,20,6,64,49,2,66,12,42,19,50,189,16,111,13,8]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;let l=f=class extends p.$Tc{constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new k.$5d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.$5d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.$5d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new k.$5d),this.onDidRunOperation=this.r.event,this.X=this.B(new k.$5d),this.Y=this.B(new k.$5d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new k.$5d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$nh)}registerProvider(r,o){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${r}`);const n=new p.$Sc;return this.h.set(r,o),this.c.fire({added:!0,scheme:r,provider:o}),n.add(o.onDidChangeFile(i=>{const a=new b.$Uk(i,!this.S(o));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(i=>this.Z.fire(new Error(i)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:r}))),(0,p.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:o}),this.h.delete(r),(0,p.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const o=[];this.f.fire({scheme:r,join(n){o.push(n)}}),!this.h.has(r)&&await C.Promises.settled(o)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,o){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return v.Iterable.map(this.h,([r,o])=>({scheme:r,capabilities:o.capabilities}))}async j(r){if(!(0,m.$Vg)(r))throw new b.$Wk((0,c.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const o=this.h.get(r.scheme);if(!o){const n=new h.$bb;throw n.message=(0,c.localize)(1,null,r.toString()),n}return o}async m(r){const o=await this.j(r);if((0,b.$Hk)(o)||(0,b.$Ek)(o)||(0,b.$Ik)(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const o=await this.j(r);if((0,b.$Hk)(o)||(0,b.$Ek)(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,o){try{return await this.s(r,o)}catch(n){throw(0,b.$Rk)(n)===b.FileSystemProviderErrorCode.FileNotFound?new b.$Wk((0,c.localize)(2,null,this.sb(r)),1):(0,b.$Pk)(n)}}async s(r,o){const n=await this.j(r),i=this.S(n),a=o?.resolveTo,$=o?.resolveSingleChildDescendants,A=o?.resolveMetadata,R=await n.stat(r);let I;return this.t(n,r,R,void 0,!!A,(O,M)=>(I||(I=D.$ki.forUris(()=>!i),I.set(r,!0),a&&I.fill(!0,a)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&$?M===1:!1))}async t(r,o,n,i,a,$){const{providerExtUri:A}=this.R(r),R={resource:o,name:A.basename(o),isFile:(n.type&b.FileType.File)!==0,isDirectory:(n.type&b.FileType.Directory)!==0,isSymbolicLink:(n.type&b.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&b.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&b.FilePermission.Locked),etag:(0,b.$8k)({mtime:n.mtime,size:n.size}),children:void 0};if(R.isDirectory&&$(R,i)){try{const I=await r.readdir(o),O=await C.Promises.settled(I.map(async([M,Z])=>{try{const ee=A.joinPath(o,M),fe=a?await r.stat(ee):{type:Z};return await this.t(r,ee,fe,I.length,a,$)}catch(ee){return this.b.trace(ee),null}}));R.children=(0,y.$Hb)(O)}catch(I){this.b.trace(I),R.children=[]}return R}return R}async resolveAll(r){return C.Promises.settled(r.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const o=await this.j(r),n=await o.stat(r);return this.t(o,r,n,void 0,!0,()=>!1)}async exists(r){const o=await this.j(r);try{return!!await o.stat(r)}catch{return!1}}async canCreateFile(r,o){try{await this.u(r,o)}catch(n){return n}return!0}async u(r,o){if(!o?.overwrite&&await this.exists(r))throw new b.$Wk((0,c.localize)(3,null,this.sb(r)),3,o)}async createFile(r,o=s.$se.fromString(""),n){await this.u(r,n);const i=await this.writeFile(r,o);return this.r.fire(new b.$Tk(r,0,i)),i}async writeFile(r,o,n){const i=this.qb(await this.n(r),r),{providerExtUri:a}=this.R(i);let $=n;if((0,b.$Kk)(i)&&!$?.atomic){const A=i.enforceAtomicWriteFile?.(r);A&&($={...n,atomic:A})}try{await this.w(i,r,$)||await this.U(i,a.dirname(r));let R;if((0,b.$Ek)(i)&&!(o instanceof s.$se))if((0,d.$ee)(o)){const I=await(0,d.$le)(o,3);I.ended?R=s.$se.concat(I.buffer):R=I}else R=(0,d.$ie)(o,I=>s.$se.concat(I),3);else R=o;!(0,b.$Hk)(i)||(0,b.$Ek)(i)&&R instanceof s.$se||(0,b.$Ek)(i)&&(0,b.$Kk)(i)&&$?.atomic?await this.hb(i,r,$,R):await this.db(i,r,$,R instanceof s.$se?(0,s.$De)(R):R),this.r.fire(new b.$Tk(r,4))}catch(A){throw new b.$Wk((0,c.localize)(4,null,this.sb(r),(0,b.$Pk)(A).toString()),(0,b.$Sk)(A),$)}return this.resolve(r,{resolveMetadata:!0})}async w(r,o,n){const i=!!n?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(o)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(o)));if(!(r.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(o)));if(i)throw new Error((0,c.localize)(8,null,this.sb(o)))}let $;try{$=await r.stat(o)}catch{return}if($.type&b.FileType.Directory)throw new b.$Wk((0,c.localize)(9,null,this.sb(o)),0,n);if(this.rb(o,$),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==b.$7k&&typeof $.mtime=="number"&&typeof $.size=="number"&&n.mtime<$.mtime&&n.etag!==(0,b.$8k)({mtime:n.mtime,size:$.size}))throw new b.$Wk((0,c.localize)(10,null),3,n);return $}async readFile(r,o,n){const i=await this.m(r);return o?.atomic?this.z(i,r,o,n):this.C(i,r,o,n)}async z(r,o,n,i){return new Promise((a,$)=>{this.cb.queueFor(o,async()=>{try{const A=await this.C(r,o,n,i);a(A)}catch(A){$(A)}},this.R(r).providerExtUri)})}async C(r,o,n,i){const a=await this.D(r,o,{...n,preferUnbuffered:!0},i);return{...a,value:await(0,s.$Ee)(a.value)}}async readFileStream(r,o,n){const i=await this.m(r);return this.D(i,r,o,n)}async D(r,o,n,i){const a=new S.$ce(i);let $=n;(0,b.$Jk)(r)&&r.enforceAtomicReadFile?.(o)&&($={...n,atomic:!0});const A=this.J(o,$).then(I=>I,I=>{throw a.dispose(!0),I});let R;try{return typeof $?.etag=="string"&&$.etag!==b.$7k&&await A,$?.atomic&&(0,b.$Jk)(r)||!((0,b.$Hk)(r)||(0,b.$Ik)(r))||(0,b.$Ek)(r)&&$?.preferUnbuffered?R=this.I(r,o,$):(0,b.$Ik)(r)?R=this.G(r,o,a.token,$):R=this.H(r,o,a.token,$),R.on("end",()=>a.dispose()),R.on("error",()=>a.dispose()),{...await A,value:R}}catch(I){throw R&&await(0,d.$je)(R),this.F(I,o,$)}}F(r,o,n){const i=(0,c.localize)(11,null,this.sb(o),(0,b.$Pk)(r).toString());return r instanceof b.$Yk?new b.$Yk(i,r.stat,n):r instanceof b.$Xk?new b.$Xk(i,r.fileOperationResult,r.size,r.options):new b.$Wk(i,(0,b.$Sk)(r),n)}G(r,o,n,i=Object.create(null)){const a=r.readFileStream(o,i,n);return(0,d.$pe)(a,{data:$=>$ instanceof s.$se?$:s.$se.wrap($),error:$=>this.F($,o,i)},$=>s.$se.concat($))}H(r,o,n,i=Object.create(null)){const a=(0,s.$Ie)();return(0,u.$nq)(r,o,a,$=>$,{...i,bufferSize:this.a,errorTransformer:$=>this.F($,o,i)},n),a}I(r,o,n){const i=(0,d.$ge)(a=>s.$se.concat(a));return(async()=>{try{let a;n?.atomic&&(0,b.$Jk)(r)?a=await r.readFile(o,{atomic:!0}):a=await r.readFile(o),typeof n?.position=="number"&&(a=a.slice(n.position)),typeof n?.length=="number"&&(a=a.slice(0,n.length)),this.L(o,a.byteLength,n),i.end(s.$se.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async J(r,o){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new b.$Wk((0,c.localize)(12,null,this.sb(r)),0,o);if(typeof o?.etag=="string"&&o.etag!==b.$7k&&o.etag===n.etag)throw new b.$Yk((0,c.localize)(13,null),n,o);return this.L(r,n.size,o),n}L(r,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new b.$Xk((0,c.localize)(14,null,this.sb(r)),7,o,n)}async canMove(r,o,n){return this.M(r,o,"move",n)}async canCopy(r,o,n){return this.M(r,o,"copy",n)}async M(r,o,n,i){if(r.toString()!==o.toString())try{const a=n==="move"?this.qb(await this.n(r),r):await this.m(r),$=this.qb(await this.n(o),o);await this.Q(a,r,$,o,n,i)}catch(a){return a}return!0}async move(r,o,n){const i=this.qb(await this.n(r),r),a=this.qb(await this.n(o),o),$=await this.N(i,r,a,o,"move",!!n),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$Tk(r,$==="move"?2:3,A)),A}async copy(r,o,n){const i=await this.m(r),a=this.qb(await this.n(o),o),$=await this.N(i,r,a,o,"copy",!!n),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$Tk(r,$==="copy"?3:2,A)),A}async N(r,o,n,i,a,$){if(o.toString()===i.toString())return a;const{exists:A,isSameResourceWithDifferentPathCase:R}=await this.Q(r,o,n,i,a,$);if(A&&!R&&$&&await this.del(i,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(i)),a==="copy"){if(r===n&&(0,b.$Fk)(r))await r.copy(o,i,{overwrite:$});else{const I=await this.resolve(o);I.isDirectory?await this.P(r,I,n,i):await this.O(r,o,n,i)}return a}else return r===n?(await r.rename(o,i,{overwrite:$}),a):(await this.N(r,o,n,i,"copy",$),await this.del(o,{recursive:!0}),"copy")}async O(r,o,n,i){if((0,b.$Hk)(r)&&(0,b.$Hk)(n))return this.jb(r,o,n,i);if((0,b.$Hk)(r)&&(0,b.$Ek)(n))return this.pb(r,o,n,i);if((0,b.$Ek)(r)&&(0,b.$Hk)(n))return this.nb(r,o,n,i);if((0,b.$Ek)(r)&&(0,b.$Ek)(n))return this.lb(r,o,n,i)}async P(r,o,n,i){await n.mkdir(i),Array.isArray(o.children)&&await C.Promises.settled(o.children.map(async a=>{const $=this.R(n).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.P(r,await this.resolve(a.resource),n,$):this.O(r,a.resource,n,$)}))}async Q(r,o,n,i,a,$){let A=!1;if(r===n){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(r);if(O||(A=I.isEqual(o,i)),A&&a==="copy")throw new Error((0,c.localize)(15,null,this.sb(o),this.sb(i)));if(!A&&I.isEqualOrParent(i,o))throw new Error((0,c.localize)(16,null,this.sb(o),this.sb(i)))}const R=await this.exists(i);if(R&&!A){if(!$)throw new b.$Wk((0,c.localize)(17,null,this.sb(o),this.sb(i)),4);if(r===n){const{providerExtUri:I}=this.R(r);if(I.isEqualOrParent(o,i))throw new Error((0,c.localize)(18,null,this.sb(o),this.sb(i)))}}return{exists:R,isSameResourceWithDifferentPathCase:A}}R(r){const o=this.S(r);return{providerExtUri:o?m.$Hg:m.$Jg,isPathCaseSensitive:o}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const o=this.qb(await this.j(r),r);await this.U(o,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$Tk(r,0,n)),n}async U(r,o){const n=[],{providerExtUri:i}=this.R(r);for(;!i.isEqual(o,i.dirname(o));)try{if(!((await r.stat(o)).type&b.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(o)));break}catch(a){if((0,b.$Rk)(a)!==b.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(i.basename(o)),o=i.dirname(o)}for(let a=n.length-1;a>=0;a--){o=i.joinPath(o,n[a]);try{await r.mkdir(o)}catch($){if((0,b.$Rk)($)!==b.FileSystemProviderErrorCode.FileExists)throw $}}}async canDelete(r,o){try{await this.W(r,o)}catch(n){return n}return!0}async W(r,o){const n=this.qb(await this.j(r),r),i=!!o?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(r)));const a=o?.atomic;if(a&&!(n.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(r)));if(i&&a)throw new Error((0,c.localize)(22,null,this.sb(r)));let $;try{$=await n.stat(r)}catch{}if($)this.rb(r,$);else throw new b.$Wk((0,c.localize)(23,null,this.sb(r)),1);if(!!!o?.recursive){const R=await this.resolve(r);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(r)))}return n}async del(r,o){const n=await this.W(r,o);let i=o;if((0,b.$Lk)(n)&&!i?.atomic){const R=n.enforceAtomicDelete?.(r);R&&(i={...o,atomic:R})}const a=!!i?.useTrash,$=!!i?.recursive,A=i?.atomic??!1;await n.delete(r,{recursive:$,useTrash:a,atomic:A}),this.r.fire(new b.$Tk(r,1))}async cloneFile(r,o){const n=await this.j(r),i=this.qb(await this.n(o),o);if(!(n===i&&this.R(n).providerExtUri.isEqual(r,o)))return n===i&&(0,b.$Gk)(n)?n.cloneFile(r,o):(await this.U(i,this.R(i).providerExtUri.dirname(o)),n===i&&(0,b.$Fk)(n)?this.cb.queueFor(r,()=>n.copy(r,o,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,i,o),this.R(n).providerExtUri))}createWatcher(r,o){return this.watch(r,{...o,correlationId:f.ab++})}watch(r,o={recursive:!1,excludes:[]}){const n=new p.$Sc;let i=!1,a=()=>{i=!0};n.add((0,p.$Rc)(()=>a())),(async()=>{try{const A=await this.bb(r,o);i?(0,p.$Oc)(A):a=()=>(0,p.$Oc)(A)}catch(A){this.b.error(A)}})();const $=o.correlationId;if(typeof $=="number"){const A=n.add(new k.$5d);return n.add(this.X.event(I=>{I.correlates($)&&A.fire(I)})),{onDidChange:A.event,dispose:()=>n.dispose()}}return n}async bb(r,o){const n=await this.j(r),i=(0,P.$5i)([this.R(n).providerExtUri.getComparisonKey(r),o]);let a=this.$.get(i);return a||(a={count:0,disposable:n.watch(r,o)},this.$.set(i,a)),a.count+=1,(0,p.$Rc)(()=>{a&&(a.count--,a.count===0&&((0,p.$Oc)(a.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,p.$Oc)(r.disposable);this.$.clear()}async db(r,o,n,i){return this.cb.queueFor(o,async()=>{const a=await r.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,d.$ee)(i)||(0,d.$fe)(i)?await this.eb(r,a,i):await this.fb(r,a,i)}catch($){throw(0,b.$Pk)($)}finally{await r.close(a)}},this.R(r).providerExtUri)}async eb(r,o,n){let i=0,a;if((0,d.$fe)(n)){if(n.buffer.length>0){const $=s.$se.concat(n.buffer);await this.gb(r,o,$,$.byteLength,i,0),i+=$.byteLength}if(n.ended)return;a=n.stream}else a=n;return new Promise(($,A)=>{(0,d.$ke)(a,{onData:async R=>{a.pause();try{await this.gb(r,o,R,R.byteLength,i,0)}catch(I){return A(I)}i+=R.byteLength,setTimeout(()=>a.resume())},onError:R=>A(R),onEnd:()=>$()})})}async fb(r,o,n){let i=0,a;for(;(a=n.read())!==null;)await this.gb(r,o,a,a.byteLength,i,0),i+=a.byteLength}async gb(r,o,n,i,a,$){let A=0;for(;A<i;){const R=await r.write(o,a+A,n.buffer,$+A,i-A);A+=R}}async hb(r,o,n,i){return this.cb.queueFor(o,()=>this.ib(r,o,n,i),this.R(r).providerExtUri)}async ib(r,o,n,i){let a;i instanceof s.$se?a=i:(0,d.$ee)(i)?a=await(0,s.$Ee)(i):(0,d.$fe)(i)?a=await(0,s.$Fe)(i):a=(0,s.$Ce)(i),await r.writeFile(o,a.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,o,n,i){return this.cb.queueFor(i,()=>this.kb(r,o,n,i),this.R(n).providerExtUri)}async kb(r,o,n,i){let a,$;try{a=await r.open(o,{create:!1}),$=await n.open(i,{create:!0,unlock:!1});const A=s.$se.alloc(this.a);let R=0,I=0,O=0;do O=await r.read(a,R,A.buffer,I,A.byteLength-I),await this.gb(n,$,A,O,R,I),R+=O,I+=O,I===A.byteLength&&(I=0);while(O>0)}catch(A){throw(0,b.$Pk)(A)}finally{await C.Promises.settled([typeof a=="number"?r.close(a):Promise.resolve(),typeof $=="number"?n.close($):Promise.resolve()])}}async lb(r,o,n,i){return this.cb.queueFor(i,()=>this.mb(r,o,n,i),this.R(n).providerExtUri)}async mb(r,o,n,i){return n.writeFile(i,await r.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,o,n,i){return this.cb.queueFor(i,()=>this.ob(r,o,n,i),this.R(n).providerExtUri)}async ob(r,o,n,i){const a=await n.open(i,{create:!0,unlock:!1});try{const $=await r.readFile(o);await this.gb(n,a,s.$se.wrap($),$.byteLength,0,0)}catch($){throw(0,b.$Pk)($)}finally{await n.close(a)}}async pb(r,o,n,i){const a=await(0,s.$Ee)(this.H(r,o,S.CancellationToken.None));await this.hb(n,i,void 0,a)}qb(r,o){if(r.capabilities&2048)throw new b.$Wk((0,c.localize)(25,null,this.sb(o)),6);return r}rb(r,o){if((o.permissions??0)&b.FilePermission.Readonly)throw new b.$Wk((0,c.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.$oq=l,l.ab=0,e.$oq=l=f=Le([Ne(0,g.$yj)],l)}),define(Ee[70],ke([1,0,29,305,15,24,14,6,39,2,7,3,19,50,23,192,16,111,227,40,225,224]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0,(()=>{try{(0,C.gracefulify)(y)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.$2i)(r)}`)}})();class t extends g.$xq{constructor(o,n){super(o,n),this.onDidChangeCapabilities=P.Event.None,this.N=new S.$Ac(i=>w.$Ig.getComparisonKey(i)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$e&&(this.J|=1024)),this.J}async stat(o){try{const{stat:n,symbolicLink:i}=await d.SymlinkSupport.stat(this.H(o));return{type:this.M(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:b.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await d.Promises.readdir(this.H(o),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async a=>{try{let $;a.isSymbolicLink()?$=(await this.stat((0,w.$Rg)(o,a.name))).type:$=this.M(a),i.push([a.name,$])}catch($){this.a.trace($)}})),i}catch(n){throw this.fb(n)}}M(o,n){let i;return n?.dangling?i=b.FileType.Unknown:o.isFile()?i=b.FileType.File:o.isDirectory()?i=b.FileType.Directory:i=b.FileType.Unknown,n&&(i|=b.FileType.SymbolicLink),i}async O(o){const n=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const a=new s.$dh;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,p.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(o,n){let i;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),i=await this.O(o));const a=this.H(o);return await d.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{i?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,n,i){const a=(0,m.$ge)($=>k.$se.concat($.map(A=>k.$se.wrap(A))).buffer);return(0,u.$nq)(this,o,a,$=>$.buffer,{...n,bufferSize:256*1024},i),a}async writeFile(o,n,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,w.$Rg)((0,w.$Qg)(o),`${(0,w.$Og)(o)}${i.atomic.postfix}`),n,i):this.S(o,n,i)}async Q(o){try{const n=this.H(o),{symbolicLink:i}=await d.SymlinkSupport.stat(n);if(i)return!1}catch{}return!0}async R(o,n,i,a){const $=new p.$Sc;try{$.add(await this.O(o)),$.add(await this.O(n)),await this.S(n,i,a,!0);try{await this.rename(n,o,{overwrite:!0})}catch(A){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{$.dispose()}}async S(o,n,i,a){let $;try{const A=this.H(o);if(!i.create||!i.overwrite){if(await d.Promises.exists(A)){if(!i.overwrite)throw(0,b.$Ok)((0,c.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,b.$Ok)((0,c.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(o,{create:!0,unlock:i.unlock},a),await this.write($,0,n,0,n.byteLength)}catch(A){throw await this.gb(o,A)}finally{typeof $=="number"&&await this.close($)}}static configureFlushOnWrite(o){t.Y=o}async open(o,n,i){const a=this.H(o);let $;(0,b.$Ck)(n)&&!i&&($=await this.O(o));let A;try{if((0,b.$Ck)(n)&&n.unlock)try{const{stat:I}=await d.SymlinkSupport.stat(a);I.mode&128||await d.Promises.chmod(a,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let R;if((0,b.$Ck)(n)){if(E.$c)try{await d.Promises.truncate(a,0),R="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}R||(R="w")}else R="r";A=await d.Promises.open(a,R)}catch(R){throw $?.dispose(),(0,b.$Ck)(n)?await this.gb(o,R):this.fb(R)}if(this.U.set(A,0),(0,b.$Ck)(n)&&this.X.set(A,o),$){const R=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${a})`),this.W.set(A,$),R&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${a})`),R.dispose())}return A}async close(o){const n=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&t.Y)try{await d.Promises.fdatasync(o)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await d.Promises.close(o)}catch(i){throw this.fb(i)}finally{n&&(this.W.get(o)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,i,a,$){const A=this.Z(o,n);let R=null;try{R=(await d.Promises.read(o,i,a,$,A)).bytesRead}catch(I){throw this.fb(I)}finally{this.$(o,A,R)}return R}Z(o,n){return n===this.U.get(o)?null:n}$(o,n,i){const a=this.U.get(o);typeof a=="number"&&(typeof n=="number"||(typeof i=="number"?this.U.set(o,a+i):this.U.delete(o)))}async write(o,n,i,a,$){return(0,s.$yh)(()=>this.ab(o,n,i,a,$),100,3)}async ab(o,n,i,a,$){const A=this.Z(o,n);let R=null;try{R=(await d.Promises.write(o,i,a,$,A)).bytesWritten}catch(I){throw await this.gb(this.X.get(o),I)}finally{this.$(o,A,R)}return R}async mkdir(o){try{await d.Promises.mkdir(this.H(o))}catch(n){throw this.fb(n)}}async delete(o,n){try{const i=this.H(o);if(n.recursive){let a;n?.atomic!==!1&&n.atomic.postfix&&(a=(0,D.$jc)((0,D.$mc)(i),`${(0,D.$nc)(i)}${n.atomic.postfix}`)),await d.Promises.rm(i,d.RimRafMode.MOVE,a)}else try{await d.Promises.unlink(i)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let $=!1;try{const{stat:A,symbolicLink:R}=await d.SymlinkSupport.stat(i);$=A.isDirectory()&&!R}catch{}if($)await d.Promises.rmdir(i);else throw a}else throw a}}catch(i){throw this.fb(i)}}async rename(o,n,i){const a=this.H(o),$=this.H(n);if(a!==$)try{await this.bb(o,n,"move",i.overwrite),await d.Promises.rename(a,$)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,c.localize)(2,null,(0,D.$nc)(a),(0,D.$nc)((0,D.$mc)($)),A.toString()))),this.fb(A)}}async copy(o,n,i){const a=this.H(o),$=this.H(n);if(a!==$)try{await this.bb(o,n,"copy",i.overwrite),await d.Promises.copy(a,$,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,c.localize)(3,null,(0,D.$nc)(a),(0,D.$nc)((0,D.$mc)($)),A.toString()))),this.fb(A)}}async bb(o,n,i,a){const $=this.H(o),A=this.H(n);let R=!1;if(!!(this.capabilities&1024)||(R=(0,v.$eg)($,A,!0)),R){if(i==="copy")throw(0,b.$Ok)((0,c.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const O=await this.L(o);if(!O)throw(0,b.$Ok)((0,c.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(n);if(M){if(!a)throw(0,b.$Ok)((0,c.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);O.type&b.FileType.File&&M.type&b.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.cb(o,n,!1)}async cb(o,n,i){const a=this.H(o),$=this.H(n),A=!!(this.capabilities&1024);if((0,v.$eg)(a,$,!A))return;const R=new p.$Sc;try{R.add(await this.O(o)),R.add(await this.O(n)),i&&await d.Promises.mkdir((0,D.$mc)($),{recursive:!0}),await d.Promises.copyFile(a,$)}catch(I){if(I.code==="ENOENT"&&!i)return this.cb(o,n,!0);throw this.fb(I)}finally{R.dispose()}}t(o,n,i){return new f.$Eq(a=>o(a),a=>n(a),i)}F(o,n,i){return new l.$Mq(a=>o(a),a=>n(a),i)}fb(o){if(o instanceof b.$Nk)return o;let n=o,i;switch(o.code){case"ENOENT":i=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=b.FileSystemProviderErrorCode.Unknown;break;default:i=b.FileSystemProviderErrorCode.Unknown}return(0,b.$Ok)(n,i)}async gb(o,n){let i=this.fb(n);if(o&&i.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.H(o));a.mode&128||(i=(0,b.$Ok)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return i}}e.$Nq=t,t.I=!1,t.Y=!0}),define(Ee[228],ke([1,0,6,70,2,14,50,20]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=void 0;class v extends s.$Tc{constructor(E,w){super(),this.a=E,this.b=w,this.F=new Map,this.G=new Map}call(E,w,m){const d=this.c(E);switch(w){case"stat":return this.g(d,m[0]);case"readdir":return this.h(d,m[0]);case"open":return this.r(d,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(d,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(d,m[0],m[1],m[2]);case"rename":return this.z(d,m[0],m[1],m[2]);case"copy":return this.C(d,m[0],m[1],m[2]);case"cloneFile":return this.D(d,m[0],m[1]);case"mkdir":return this.w(d,m[0]);case"delete":return this.y(d,m[0],m[1]);case"watch":return this.I(d,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${w} not found`)}listen(E,w,m){const d=this.c(E);switch(w){case"fileChange":return this.H(d,m[0]);case"readFileStream":return this.m(d,m[0],m[1])}throw new Error(`Unknown event ${w}`)}g(E,w){const m=this.f(E,w,!0);return this.a.stat(m)}h(E,w){const m=this.f(E,w);return this.a.readdir(m)}async j(E,w,m){const d=this.f(E,w,!0);this.b.trace(`File action: readFile ${d.path}`);const c=await this.a.readFile(d,m);return S.$se.wrap(c)}m(E,w,m){const d=this.f(E,w,!0),c=new P.$ce,b=new y.$5d({onDidRemoveLastListener:()=>{c.cancel()}});this.b.trace(`File action: readFileStream ${d.path}`);const u=this.a.readFileStream(d,m,c.token);return(0,k.$ke)(u,{onData:g=>b.fire(S.$se.wrap(g)),onError:g=>b.fire(g),onEnd:()=>{b.fire("end"),b.dispose(),c.dispose()}}),b.event}n(E,w,m,d){const c=this.f(E,w);return this.b.trace(`File action: writeFile ${c.path}`),this.a.writeFile(c,m.buffer,d)}r(E,w,m){const d=this.f(E,w,!0);return this.a.open(d,m)}s(E){return this.a.close(E)}async t(E,w,m){const d=S.$se.alloc(m),b=await this.a.read(E,w,d.buffer,0,m);return[d,b]}u(E,w,m,d,c){return this.a.write(E,w,m.buffer,d,c)}w(E,w){const m=this.f(E,w);return this.a.mkdir(m)}y(E,w,m){const d=this.f(E,w);return this.a.delete(d,m)}z(E,w,m,d){const c=this.f(E,w),b=this.f(E,m);return this.a.rename(c,b,d)}C(E,w,m,d){const c=this.f(E,w),b=this.f(E,m);return this.a.copy(c,b,d)}D(E,w,m){const d=this.f(E,w),c=this.f(E,m);return this.a.cloneFile(d,c)}H(E,w){const m=new y.$5d({onWillAddFirstListener:()=>{this.F.set(w,this.L(E,m))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(w)),this.F.delete(w)}});return m.event}async I(E,w,m,d,c){const b=this.F.get(w);if(b){const u=this.f(E,d),g=b.watch(m,u,c);this.G.set(w+m,g)}}async J(E,w){const m=E+w,d=this.G.get(m);d&&((0,s.$Oc)(d),this.G.delete(m))}dispose(){super.dispose();for(const[,E]of this.G)E.dispose();this.G.clear();for(const[,E]of this.F)E.dispose();this.F.clear()}}e.$ks=v;class p extends s.$Tc{constructor(E,w,m,d){super(),this.c=E,this.f=m,this.g=d,this.a=new Map,this.b=this.B(new C.$Nq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(w)}h(E){const w=this.B(new y.$5d);this.B(w.event(m=>{E.fire(m.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this.B(this.b.onDidChangeFile(m=>w.fire(m))),this.B(this.b.onDidWatchError(m=>E.fire(m)))}j(E){}m(E){}watch(E,w,m){const d=this.m(this.g);return Array.isArray(d)&&(m.excludes=[...m.excludes,...d]),this.a.set(E,this.b.watch(w,m)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(E)),this.a.delete(E)})}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),super.dispose()}}e.$ls=p}),define(Ee[114],ke([1,0,4,6,13,2]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.$Mr=void 0;class k extends s.$Jj{constructor(E,w,m,d,c){super(w,m,d),this.r=E,this.t=c,this.B(c.listen("onDidChangeLogLevel",E)(b=>{(0,s.$Aj)(b)?super.setLogLevel(b):super.setLogLevel(y.URI.revive(b[0]),b[1])})),this.B(c.listen("onDidChangeVisibility",E)(([b,u])=>super.setVisibility(y.URI.revive(b),u))),this.B(c.listen("onDidChangeLoggers",E)(({added:b,removed:u})=>{for(const g of b)super.registerLogger({...g,resource:y.URI.revive(g.resource)});for(const g of u)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new s.$Hj({log:(E,w)=>{this.t.call("consoleLog",[E,w])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,w){super.setLogLevel(E,w),this.t.call("setLogLevel",[E,w])}setVisibility(E,w){super.setVisibility(E,w),this.t.call("setVisibility",[this.n(E),w])}s(E,w,m){return new P(this.t,E,w,m,this.r)}static setLogLevel(E,w,m){return E.call("setLogLevel",[w,m])}}e.$Mr=k;class P extends s.$Ej{constructor(E,w,m,d,c){super(d?.logLevel==="always"),this.r=E,this.s=w,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[w,d,c]).then(()=>{this.u(this.n),this.m=!0})}g(E,w){const m=[[E,w]];this.m?this.u(m):this.n.push(...m)}u(E){this.r.call("log",[this.s,E])}}class v{constructor(E,w){this.a=E,this.b=w}listen(E,w){const m=this.b(E);switch(w){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(c=>this.c(c,m)),removed:[...d.removed].map(c=>this.c(c,m))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,d=>[m.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,d=>(0,s.$Aj)(d)?d:[m.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${w}`)}async call(E,w,m){const d=this.b(E);switch(w){case"setLogLevel":return(0,s.$Aj)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(y.URI.revive(d.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,d)))}throw new Error(`Call not found: ${w}`)}c(E,w){return{...E,resource:w.transformOutgoingURI(E.resource)}}}e.$Nr=v;class p extends S.$Tc{constructor(E,w){super(),w.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(m=>w.call("setLogLevel",[m]))),w.call("getRegisteredLoggers").then(m=>{for(const d of m)E.registerLogger({...d,resource:y.URI.revive(d.resource)})}),this.B(w.listen("onDidChangeVisibility")(([m,d])=>E.setVisibility(y.URI.revive(m),d))),this.B(w.listen("onDidChangeLoggers")(({added:m,removed:d})=>{for(const c of m)E.registerLogger({...c,resource:y.URI.revive(c.resource)});for(const c of d)E.deregisterLogger(c.resource)}))}}e.$Or=p}),define(Ee[115],ke([1,0,2,13]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=void 0;class s extends y.$Tc{constructor(k,P=[]){super(),this.a=new C.$Ij([k,...P]),this.B(k.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...P){this.a.trace(k,...P)}debug(k,...P){this.a.debug(k,...P)}info(k,...P){this.a.info(k,...P)}warn(k,...P){this.a.warn(k,...P)}error(k,...P){this.a.error(k,...P)}flush(){this.a.flush()}}e.$DP=s}),define(Ee[229],ke([1,0,16,13]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=void 0;var s;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(s||(s={}));async function S(p,D,E,w,m){try{const d=await new Promise((b,u)=>{le(["@vscode/spdlog"],b,u)});d.setFlushOn(s.Trace);const c=await d.createAsyncRotatingLogger(p,D,E,w);return m?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(d){console.error(d)}return null}function k(p,D,E){switch(D){case C.LogLevel.Trace:p.trace(E);break;case C.LogLevel.Debug:p.debug(E);break;case C.LogLevel.Info:p.info(E);break;case C.LogLevel.Warning:p.warn(E);break;case C.LogLevel.Error:p.error(E);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function P(p,D){switch(D){case C.LogLevel.Trace:p.setLevel(s.Trace);break;case C.LogLevel.Debug:p.setLevel(s.Debug);break;case C.LogLevel.Info:p.setLevel(s.Info);break;case C.LogLevel.Warning:p.setLevel(s.Warning);break;case C.LogLevel.Error:p.setLevel(s.Error);break;case C.LogLevel.Off:p.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class v extends C.$Ej{constructor(D,E,w,m,d){super(),this.m=[],this.setLevel(d),this.n=this.s(D,E,w,m),this.B(this.onDidChangeLogLevel(c=>{this.r&&P(this.r,c)}))}async s(D,E,w,m){const d=w?6:1,c=30/d*y.$0k.MB,b=await S(D,E,c,d,m);if(b){this.r=b,P(this.r,this.getLevel());for(const{level:u,message:g}of this.m)k(this.r,u,g);this.m=[]}}g(D,E){this.r?k(this.r,D,E):this.getLevel()<=D&&this.m.push({level:D,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$sP=v}),define(Ee[116],ke([1,0,22,13,229]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=void 0;class S extends C.$Jj{s(P,v,p){return new s.$sP((0,y.$Ag)(),P.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,v)}}e.$tP=S}),define(Ee[230],ke([1,0,65,194,5]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(S||(e.MarkerTag=S={}));var k;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(k||(e.MarkerSeverity=k={})),function(v){function p(d,c){return c-d}v.compare=p;const D=Object.create(null);D[v.Error]=(0,C.localize)(0,null),D[v.Warning]=(0,C.localize)(1,null),D[v.Info]=(0,C.localize)(2,null);function E(d){return D[d]||""}v.toString=E;function w(d){switch(d){case y.default.Error:return v.Error;case y.default.Warning:return v.Warning;case y.default.Info:return v.Info;case y.default.Ignore:return v.Hint}}v.fromSeverity=w;function m(d){switch(d){case v.Error:return y.default.Error;case v.Warning:return y.default.Warning;case v.Info:return y.default.Info;case v.Hint:return y.default.Ignore}}v.toSeverity=m}(k||(e.MarkerSeverity=k={}));var P;(function(v){const p="";function D(w){return E(w,!0)}v.makeKey=D;function E(w,m){const d=[p];return w.source?d.push(w.source.replace("\xA6","\\\xA6")):d.push(p),w.code?typeof w.code=="string"?d.push(w.code.replace("\xA6","\\\xA6")):d.push(w.code.value.replace("\xA6","\\\xA6")):d.push(p),w.severity!==void 0&&w.severity!==null?d.push(k.toString(w.severity)):d.push(p),w.message&&m?d.push(w.message.replace("\xA6","\\\xA6")):d.push(p),w.startLineNumber!==void 0&&w.startLineNumber!==null?d.push(w.startLineNumber.toString()):d.push(p),w.startColumn!==void 0&&w.startColumn!==null?d.push(w.startColumn.toString()):d.push(p),w.endLineNumber!==void 0&&w.endLineNumber!==null?d.push(w.endLineNumber.toString()):d.push(p),w.endColumn!==void 0&&w.endColumn!==null?d.push(w.endColumn.toString()):d.push(p),d.push(p),d.join("\xA6")}v.makeKeyOptionalMessage=E})(P||(e.IMarkerData=P={})),e.$Mt=(0,s.$ei)("markerService")}),define(Ee[71],ke([1,0,6,49,2,5]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=e.$Wn=void 0,e.$Wn=(0,S.$ei)("policy");class k extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.$5d),this.onDidChange=this.h.event}async updatePolicyDefinitions(p){const D=Object.keys(this.f).length;return this.f={...p,...this.f},D!==Object.keys(this.f).length&&await this.j(p),C.Iterable.reduce(this.g.entries(),(E,[w,m])=>({...E,[w]:m}),{})}getPolicyValue(p){return this.g.get(p)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(p,[D,E])=>({...p,[D]:{definition:E,value:this.g.get(D)}}),{})}}e.$Xn=k;class P{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Yn=P}),define(Ee[57],ke([1,0,28]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const S=s.context.configuration();if(S)C=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,y.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const S=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:S.version})}Object.assign(C,{extensionsGallery:y.env.EXTENSIONS_GALLERY?JSON.parse(y.env.EXTENSIONS_GALLERY):C.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else C={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.87.0",sha256:"155ba715cc1045835951e70a663010c8f91d773d90a3ec504a041fd53b5658b0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.87.0",commit:"e5d145fdf32e82be2a0f8de9a3b05f65b13052b6",date:"2024-02-29T21:33:58.462Z"},Object.keys(C).length===0&&Object.assign(C,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(Ee[31],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,y.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"}),define(Ee[37],ke([1,0,97,9]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0;class s{constructor(){this.a=new Map}add(k,P){y.ok(C.$Sf(k)),y.ok(C.$Uf(P)),y.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,P)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.$Un=new s}),define(Ee[231],ke([1,0,6,37]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=void 0,e.$Vn={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class S{constructor(){this.b=new y.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,p){this.a[s(v)]=p,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const k=new S;C.$Un.add(e.$Vn.JSONContribution,k)}),define(Ee[45],ke([1,0,18,6,9,176,25,231,37]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ConfigurationScope=e.$Zn=e.EditPresentationTypes=void 0;var p;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(p||(e.EditPresentationTypes=p={})),e.$Zn={Configuration:"base.contributions.configuration"};var D;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n="vscode://schemas/settings/resourceLanguage",e.$8n="vscode://schemas/settings/configurationDefaults";const E=v.$Un.as(P.$Vn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new C.$5d,this.onDidSchemaChange=this.i.event,this.j=new C.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$7n,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const o=new Set;this.n(t,r,o),E.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const r=new Set;this.o(t,r),E.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const o=new Set;this.o(r,o),this.n(t,!1,o),E.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const o=[];for(const{overrides:n,source:i}of t)for(const a in n)if(r.add(a),e.$0n.test(a)){const $=this.a.get(a),A=$?.valuesSources??new Map;if(i)for(const M of Object.keys(n[a]))A.set(M,i);const R={...$?.value||{},...n[a]};this.a.set(a,{source:i,value:R,valuesSources:A});const I=(0,k.$Ui)(a),O={type:"object",default:R,description:S.localize(1,null,I),$ref:e.$7n,defaultDefaultValue:R,source:s.$Sf(i)?void 0:i,defaultValueSource:i};o.push(...c(a)),this.d[a]=O,this.b.properties[a]=O}else{this.a.set(a,{value:n[a],source:i});const $=this.d[a];$&&(this.w(a,$),this.r(a,$))}this.m(o)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:o,source:n}of t)for(const i in o){const a=this.a.get(i),$=s.$Sf(n)?n:n?.id,A=s.$Sf(a?.source)?a?.source:a?.source?.id;if($===A)if(r.add(i),this.a.delete(i),e.$0n.test(i))delete this.d[i],delete this.b.properties[i];else{const R=this.d[i];R&&(this.w(i,R),this.r(i,R))}}this.u()}deltaConfiguration(t){let r=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,o){t.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,o),this.c.push(n),this.q(n)})}o(t,r){const o=n=>{if(n.properties)for(const i in n.properties){r.add(i);const a=this.d[i];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>o(i))};for(const n of t){o(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,r=!0,o,n,i=3,a){i=s.$2f(t.scope)?i:t.scope;const $=t.properties;if($)for(const R in $){const I=$[R];if(r&&h(R,I)){delete $[R];continue}if(I.source=o,I.defaultDefaultValue=$[R].default,this.w(R,I),e.$0n.test(R)?I.scope=void 0:(I.scope=s.$2f(I.scope)?i:I.scope,I.restricted=s.$2f(I.restricted)?!!n?.includes(R):I.restricted),$[R].hasOwnProperty("included")&&!$[R].included){this.f[R]=$[R],delete $[R];continue}else this.d[R]=$[R],$[R].policy?.name&&this.e.set($[R].policy.name,R);!$[R].deprecationMessage&&$[R].markdownDeprecationMessage&&($[R].deprecationMessage=$[R].markdownDeprecationMessage),a.add(R)}const A=t.allOf;if(A)for(const R of A)this.p(R,r,o,n,i,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=o=>{const n=o.properties;if(n)for(const a in n)this.r(a,n[a]);o.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$1n.properties[t]=r,r.scope){case 1:e.$2n.properties[t]=r;break;case 2:e.$3n.properties[t]=r;break;case 6:e.$4n.properties[t]=r;break;case 3:e.$5n.properties[t]=r;break;case 4:e.$6n.properties[t]=r;break;case 5:e.$6n.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$1n.properties[t],r.scope){case 1:delete e.$2n.properties[t];break;case 2:delete e.$3n.properties[t];break;case 6:delete e.$4n.properties[t];break;case 3:delete e.$5n.properties[t];break;case 4:case 5:delete e.$6n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,o={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.$7n};this.w(r,o),e.$1n.properties[r]=o,e.$2n.properties[r]=o,e.$3n.properties[r]=o,e.$4n.properties[r]=o,e.$5n.properties[r]=o,e.$6n.properties[r]=o}}v(){const t={type:"object",description:S.localize(4,null),errorMessage:S.localize(5,null),$ref:e.$7n};e.$1n.patternProperties[e.$9n]=t,e.$2n.patternProperties[e.$9n]=t,e.$3n.patternProperties[e.$9n]=t,e.$4n.patternProperties[e.$9n]=t,e.$5n.patternProperties[e.$9n]=t,e.$6n.patternProperties[e.$9n]=t,this.i.fire()}w(t,r){const o=this.a.get(t);let n=o?.value,i=o?.source;s.$Zf(n)&&(n=r.defaultDefaultValue,i=void 0),s.$Zf(n)&&(n=u(r.type)),r.default=n,r.defaultValueSource=i}}const m="\\[([^\\]]+)\\]",d=new RegExp(m,"g");e.$9n=`^(${m})+$`,e.$0n=new RegExp(e.$9n);function c(l){const t=[];if(e.$0n.test(l)){let r=d.exec(l);for(;r?.length;){const o=r[1].trim();o&&t.push(o),r=d.exec(l)}}return(0,y.$Mb)(t)}e.$$n=c;function b(l){return l.reduce((t,r)=>`${t}[${r}]`,"")}e.$_n=b;function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ao=u;const g=new w;v.$Un.add(e.$Zn.Configuration,g);function h(l,t){return l.trim()?e.$0n.test(l)?S.localize(7,null,l):g.getConfigurationProperties()[l]!==void 0?S.localize(8,null,l):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?S.localize(9,null,l,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:S.localize(6,null)}e.$bo=h;function f(){const l=[],t=g.getConfigurationProperties();for(const r of Object.keys(t))l.push([r,t[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$co=f}),define(Ee[117],ke([1,0,18,6,41,2,24,21,9,4,25,45,37]),function(le,e,y,C,s,S,k,P,v,p,D,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function m(r){return Object.isFrozen(r)?r:P.$Jn(r)}class d{constructor(o={},n=[],i=[],a){this.b=o,this.c=n,this.d=i,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(n=>{if(n instanceof d)return n;const i=new c("");return i.parseRaw(n),i.configurationModel});this.f=o.reduce((n,i)=>i===n?i:n.merge(i),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,D.$Si)(this.contents,o):this.contents}inspect(o,n){const i=this;return{get value(){return m(i.rawConfiguration.getValue(o))},get override(){return n?m(i.rawConfiguration.getOverrideValue(o,n)):void 0},get merged(){return m(n?i.rawConfiguration.override(n).getValue(o):i.rawConfiguration.getValue(o))},get overrides(){const a=[];for(const{contents:$,identifiers:A,keys:R}of i.rawConfiguration.overrides){const I=new d($,R).getValue(o);I!==void 0&&a.push({identifiers:A,value:I})}return a.length?m(a):void 0}}}getOverrideValue(o,n){const i=this.i(n);return i?o?(0,D.$Si)(i,o):i:void 0}getKeysForOverrideIdentifier(o){const n=[];for(const i of this.overrides)i.identifiers.includes(o)&&n.push(...i.keys);return y.$Mb(n)}getAllOverrideIdentifiers(){const o=[];for(const n of this.overrides)o.push(...n.identifiers);return y.$Mb(o)}override(o){let n=this.a.get(o);return n||(n=this.g(o),this.a.set(o,n)),n}merge(...o){const n=P.$In(this.contents),i=P.$In(this.overrides),a=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const A of o)if($.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(n,A.contents);for(const R of A.overrides){const[I]=i.filter(O=>y.$ub(O.identifiers,R.identifiers));I?(this.h(I.contents,R.contents),I.keys.push(...R.keys),I.keys=y.$Mb(I.keys)):i.push(P.$In(R))}for(const R of A.keys)a.indexOf(R)===-1&&a.push(R)}return new d(n,a,i,$.every(A=>A instanceof d)?void 0:$)}g(o){const n=this.i(o);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const a of y.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let $=this.contents[a];const A=n[a];A&&(typeof $=="object"&&typeof A=="object"?($=P.$In($),this.h($,A)):$=A),i[a]=$}return new d(i,this.keys,this.overrides)}h(o,n){for(const i of Object.keys(n)){if(i in o&&v.$Uf(o[i])&&v.$Uf(n[i])){this.h(o[i],n[i]);continue}o[i]=P.$In(n[i])}}i(o){let n=null,i=null;const a=$=>{$&&(i?this.h(i,$):i=P.$In($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===o?n=$.contents:$.identifiers.includes(o)&&a($.contents);return a(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,n){this.j(o,n,!0)}setValue(o,n){this.j(o,n,!1)}removeValue(o){const n=this.keys.indexOf(o);n!==-1&&(this.keys.splice(n,1),(0,D.$Ri)(this.contents,o),E.$0n.test(o)&&this.overrides.splice(this.overrides.findIndex(i=>y.$ub(i.identifiers,(0,E.$$n)(o))),1))}j(o,n,i){(0,D.$Qi)(this.contents,o,n,a=>console.error(a)),i=i||this.keys.indexOf(o)===-1,i&&this.keys.push(o),E.$0n.test(o)&&this.overrides.push({identifiers:(0,E.$$n)(o),keys:Object.keys(this.contents[o]),contents:(0,D.$Pi)(this.contents[o],a=>console.error(a))})}}e.$do=d;class c{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,n){if(!v.$2f(o)){const i=this.g(o);this.parseRaw(i,n)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,n){this.a=o;const{contents:i,keys:a,overrides:$,restricted:A,hasExcludedProperties:R}=this.h(o,n);this.b=new d(i,a,$,R?[o]:void 0),this.c=A||[]}g(o){let n={},i=null,a=[];const $=[],A=[];function R(O){Array.isArray(a)?a.push(O):i!==null&&(a[i]=O)}const I={onObjectBegin:()=>{const O={};R(O),$.push(a),a=O,i=null},onObjectProperty:O=>{i=O},onObjectEnd:()=>{a=$.pop()},onArrayBegin:()=>{const O=[];R(O),$.push(a),a=O,i=null},onArrayEnd:()=>{a=$.pop()},onLiteralValue:R,onError:(O,M,Z)=>{A.push({error:O,offset:M,length:Z})}};if(o)try{s.$wn(o,I),n=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}h(o,n){const i=w.$Un.as(E.$Zn.Configuration).getConfigurationProperties(),a=this.i(o,i,!0,n);o=a.raw;const $=(0,D.$Pi)(o,I=>console.error(`Conflict in settings file ${this.f}: ${I}`)),A=Object.keys(o),R=this.j(o,I=>console.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:$,keys:A,overrides:R,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,n,i,a){let $=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:$};const A={},R=[];for(const I in o)if(E.$0n.test(I)&&i){const O=this.i(o[I],n,!1,a);A[I]=O.raw,$=$||O.hasExcludedProperties,R.push(...O.restricted)}else{const O=n[I],M=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&R.push(I),!a.exclude?.includes(I)&&(a.include?.includes(I)||(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&!(a.skipRestricted&&O?.restricted))?A[I]=o[I]:$=!0}return{raw:A,restricted:R,hasExcludedProperties:$}}j(o,n){const i=[];for(const a of Object.keys(o))if(E.$0n.test(a)){const $={};for(const A in o[a])$[A]=o[a][A];i.push({identifiers:(0,E.$$n)(a),keys:Object.keys($),contents:(0,D.$Pi)($,n)})}return i}}e.$eo=c;class b extends S.$Tc{constructor(o,n,i,a){super(),this.c=o,this.f=n,this.g=a,this.b=this.B(new C.$5d),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&i.isEqual($.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fo=b;class u{constructor(o,n,i,a,$,A,R,I,O,M,Z,ee,fe){this.a=o,this.b=n,this.c=i,this.overrideIdentifiers=a,this.d=$,this.f=A,this.g=R,this.h=I,this.i=O,this.j=M,this.k=Z,this.l=ee,this.m=fe}get value(){return m(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class g{constructor(o,n,i,a,$=new d,A=new d,R=new k.$Ac,I=new d,O=new k.$Ac){this.c=o,this.d=n,this.f=i,this.g=a,this.h=$,this.i=A,this.j=R,this.l=I,this.m=O,this.a=null,this.b=new k.$Ac,this.n=null}getValue(o,n,i){return this.p(o,n,i).getValue(o)}updateValue(o,n,i={}){let a;i.resource?(a=this.m.get(i.resource),a||(a=new d,this.m.set(i.resource,a))):a=this.l,n===void 0?a.removeValue(o):a.setValue(o,n),i.resource||(this.a=null)}inspect(o,n,i){const a=this.p(o,n,i),$=this.t(n.resource,i),A=n.resource?this.m.get(n.resource)||this.l:this.l,R=new Set;for(const I of a.overrides)for(const O of I.identifiers)a.getOverrideValue(o,O)!==void 0&&R.add(O);return new u(o,n,a.getValue(o),R.size?[...R]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,$||void 0,A)}keys(o){const n=this.t(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,n){this.j.set(o,n),this.b.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,n){const i=[];if(!n){const{added:a,updated:$,removed:A}=l(this.c,o);n=[...a,...$,...A]}for(const a of n)for(const $ of(0,E.$$n)(a)){const A=this.c.getKeysForOverrideIdentifier($),R=o.getKeysForOverrideIdentifier($),I=[...R.filter(O=>A.indexOf(O)===-1),...A.filter(O=>R.indexOf(O)===-1),...A.filter(O=>!P.$Mn(this.c.override($).getValue(O),o.override($).getValue(O)))];i.push([$,I])}return this.updateDefaultConfiguration(o),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(o){const{added:n,updated:i,removed:a}=l(this.d,o),$=[...n,...i,...a];return $.length&&this.updatePolicyConfiguration(o),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:n,updated:i,removed:a,overrides:$}=l(this.applicationConfiguration,o),A=[...n,...i,...a];return A.length&&this.updateApplicationConfiguration(o),{keys:A,overrides:$}}compareAndUpdateLocalUserConfiguration(o){const{added:n,updated:i,removed:a,overrides:$}=l(this.localUserConfiguration,o),A=[...n,...i,...a];return A.length&&this.updateLocalUserConfiguration(o),{keys:A,overrides:$}}compareAndUpdateRemoteUserConfiguration(o){const{added:n,updated:i,removed:a,overrides:$}=l(this.remoteUserConfiguration,o),A=[...n,...i,...a];return A.length&&this.updateRemoteUserConfiguration(o),{keys:A,overrides:$}}compareAndUpdateWorkspaceConfiguration(o){const{added:n,updated:i,removed:a,overrides:$}=l(this.workspaceConfiguration,o),A=[...n,...i,...a];return A.length&&this.updateWorkspaceConfiguration(o),{keys:A,overrides:$}}compareAndUpdateFolderConfiguration(o,n){const i=this.folderConfigurations.get(o),{added:a,updated:$,removed:A,overrides:R}=l(i,n),I=[...a,...$,...A];return(I.length||!i)&&this.updateFolderConfiguration(o,n),{keys:I,overrides:R}}compareAndDeleteFolderConfiguration(o){const n=this.folderConfigurations.get(o);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:i,updated:a,removed:$,overrides:A}=l(n,void 0);return{keys:[...i,...a,...$],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(o,n,i){let a=this.q(n,i);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}q({resource:o},n){let i=this.r();if(n&&o){const a=n.getFolder(o);a&&(i=this.s(a.uri)||i);const $=this.m.get(o);$&&(i=i.merge($))}return i}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(o){let n=this.b.get(o);if(!n){const i=this.r(),a=this.j.get(o);a?(n=i.merge(a),this.b.set(o,n)):n=i}return n}t(o,n){if(n&&o){const i=n.getFolder(o);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,n)=>{const{contents:i,overrides:a,keys:$}=this.j.get(n);return o.push([n,{contents:i,overrides:a,keys:$}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(n=>o.add(n)),this.userConfiguration.keys.forEach(n=>o.add(n)),this.i.keys.forEach(n=>o.add(n)),this.j.forEach(n=>n.keys.forEach(i=>o.add(i))),[...o.values()]}u(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>o.add(i))),[...o.values()]}v(o){const n=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(o).forEach(a=>n.add(a))),[...n.values()]}static parse(o){const n=this.w(o.defaults),i=this.w(o.policy),a=this.w(o.application),$=this.w(o.user),A=this.w(o.workspace),R=o.folders.reduce((I,O)=>(I.set(p.URI.revive(O[0]),this.w(O[1])),I),new k.$Ac);return new g(n,i,a,$,new d,A,R,new d,new k.$Ac)}static w(o){return new d(o.contents,o.keys,o.overrides)}}e.$go=g;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const o=new Set,n=new Map;for(const a of r)a.keys.forEach($=>o.add($)),a.overrides.forEach(([$,A])=>{const R=(0,k.$xc)(n,$,new Set);A.forEach(I=>R.add(I))});const i=[];return n.forEach((a,$)=>i.push([$,[...a.values()]])),{keys:[...o.values()],overrides:i}}e.$ho=h;class f{constructor(o,n,i,a){this.change=o,this.f=n,this.g=i,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of o.keys)this.affectedKeys.add($);for(const[,$]of o.overrides)for(const A of $)this.affectedKeys.add(A);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(o,n){const i=this.a+o,a=this.d.indexOf(i);if(a<0)return!1;const $=a+i.length;if($>=this.d.length)return!1;const A=this.d.charCodeAt($);if(A!==this.b&&A!==this.c)return!1;if(n){const R=this.previousConfiguration?this.previousConfiguration.getValue(o,n,this.f?.workspace):void 0,I=this.g.getValue(o,n,this.h);return!P.$Mn(R,I)}return!0}}e.$io=f;function l(r,o){const{added:n,removed:i,updated:a}=t(o?.rawConfiguration,r?.rawConfiguration),$=[],A=r?.getAllOverrideIdentifiers()||[],R=o?.getAllOverrideIdentifiers()||[];if(o){const I=R.filter(O=>!A.includes(O));for(const O of I)$.push([O,o.getKeysForOverrideIdentifier(O)])}if(r){const I=A.filter(O=>!R.includes(O));for(const O of I)$.push([O,r.getKeysForOverrideIdentifier(O)])}if(o&&r){for(const I of A)if(R.includes(I)){const O=t({contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)},{contents:o.getOverrideValue(void 0,I)||{},keys:o.getKeysForOverrideIdentifier(I)});$.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:i,updated:a,overrides:$}}function t(r,o){const n=r?o?r.keys.filter($=>o.keys.indexOf($)===-1):[...r.keys]:[],i=o?r?o.keys.filter($=>r.keys.indexOf($)===-1):[...o.keys]:[],a=[];if(r&&o){for(const $ of o.keys)if(r.keys.indexOf($)!==-1){const A=(0,D.$Si)(o.contents,$),R=(0,D.$Si)(r.contents,$);P.$Mn(A,R)||a.push($)}}return{added:n,removed:i,updated:a}}}),define(Ee[232],ke([1,0,18,6,2,21,9,117,45,13,71,37]),function(le,e,y,C,s,S,k,P,v,p,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=void 0;class w extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new C.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$do}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Un.as(v.$Zn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:u})=>this.c(Array.from(b),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,u){this.h(b,E.$Un.as(v.$Zn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new P.$do;const b=E.$Un.as(v.$Zn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,u){const g=this.f();for(const h of b){const f=g[h],l=u[h];f!==void 0?this.b.addValue(h,f):l?this.b.addValue(h,l.default):this.b.removeValue(h)}}}e.$jo=w;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new P.$do}async initialize(){return this.configurationModel}}e.$ko=m;let d=class extends s.$Tc{get configurationModel(){return this.b}constructor(b,u,g){super(),this.c=b,this.f=u,this.g=g,this.a=this.B(new C.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$do}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const u={},g=[],h=E.$Un.as(v.$Zn.Configuration).getConfigurationProperties();for(const f of b){const l=h[f];if(!l){g.push(f);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}g.push(f),u[l.policy.name]={type:l.type}}}return(0,k.$6f)(u)||await this.f.updatePolicyDefinitions(u),g}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const u=E.$Un.as(v.$Zn.Configuration).getPolicyConfigurations(),g=(0,y.$Hb)(b.map(h=>u.get(h)));this.m(g,!0)}m(b,u){this.g.trace("PolicyConfiguration#update",b);const g=E.$Un.as(v.$Zn.Configuration).getConfigurationProperties(),h=[],f=this.b.isEmpty();for(const l of b){const t=g[l]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(f?r!==void 0:!(0,S.$Mn)(this.b.getValue(l),r))&&h.push([l,r])}else this.b.getValue(l)!==void 0&&h.push([l,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const l=this.b;this.b=new P.$do;for(const t of l.keys)this.b.setValue(t,l.getValue(t));for(const[t,r]of h)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);u&&this.a.fire(this.b)}}};e.$lo=d,e.$lo=d=Le([Ne(1,D.$Wn),Ne(2,p.$yj)],d)}),define(Ee[118],ke([1,0,18,15,14,6,41,145,2,21,3,19,25,117,45,232,71]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=void 0;class u extends v.$Tc{constructor(f,l,t,r){super(),this.m=f,this.h=this.B(new S.$5d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new c.$jo),this.c=t instanceof b.$Yn?new c.$ko:this.B(new c.$lo(this.b,t,r)),this.f=this.B(new m.$fo(this.m,{},E.$Ig,l)),this.a=new m.$go(this.b.configurationModel,this.c.configurationModel,new m.$do,new m.$do),this.j=new g(f,l,this),this.g=this.B(new C.$qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:n})=>this.r(o,n))),this.B(this.c.onDidChangeConfiguration(o=>this.s(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[f,l,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$go(f,l,new m.$do,t)}getConfigurationData(){return this.a.toData()}getValue(f,l){const t=typeof f=="string"?f:void 0,r=(0,w.$Li)(f)?f:(0,w.$Li)(l)?l:{};return this.a.getValue(t,r,void 0)}async updateValue(f,l,t,r,o){const n=(0,w.$Mi)(t)?t:(0,w.$Li)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,i=n?r:t;if(i!==void 0&&i!==3&&i!==2)throw new Error(`Unable to write ${f} to target ${i}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,y.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const a=this.inspect(f,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,p.$Mn)(l,a.defaultValue)&&(l=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const A=n.overrideIdentifiers.sort(),R=this.a.localUserConfiguration.overrides.find(I=>(0,y.$ub)([...I.identifiers].sort(),A));R&&(n.overrideIdentifiers=R.identifiers)}const $=n?.overrideIdentifiers?.length?[(0,d.$_n)(n.overrideIdentifiers),f]:[f];await this.j.write($,l),await this.reloadConfiguration()}inspect(f,l={}){return this.a.inspect(f,l,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const f=await this.f.loadConfiguration();this.n(f)}n(f){const l=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(f);this.t(t,l,2)}r(f,l){const t=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(f,l);this.t(r,t,7)}s(f){const l=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(f);this.t(t,l,7)}t(f,l,t){const r=new m.$io(f,{data:l},this.a);r.source=t,this.h.fire(r)}}e.$mo=u;class g{constructor(f,l,t){this.b=f,this.c=l,this.d=t,this.a=new C.$lh}write(f,l){return this.a.queue(()=>this.e(f,l))}async e(f,l){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)t="{}";else throw n}const r=[];if((0,k.$pn)(t,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const o=this.f(t,f,l);t=(0,P.$Hn)(t,o),await this.c.writeFile(this.b,s.$se.fromString(t))}f(f,l,t){const{tabSize:r,insertSpaces:o,eol:n}=this.h;if(!l.length){const i=JSON.stringify(t,null,o?" ".repeat(r):"	");return[{content:i,length:i.length,offset:0}]}return(0,P.$En)(f,l,t,{tabSize:r,insertSpaces:o,eol:n})}get h(){if(!this.g){let f=D.OS===3||D.OS===2?`
`:`\r
`;const l=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});l&&typeof l=="string"&&l!=="auto"&&(f=l),this.g={eol:f,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Ee[119],ke([1,0,8,5]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.RemoteAuthorityResolverErrorCode=e.$il=e.$hl=e.RemoteConnectionType=e.$gl=void 0,e.$gl=(0,C.$ei)("remoteAuthorityResolverService");var s;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class S{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$hl=S;class k{constructor(E,w){this.host=E,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$il=k;var P;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class v extends y.$bb{static isNotAvailable(E){return E instanceof v&&E._code===P.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof v&&E._code===P.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof v&&E._code===P.NoResolverFound}static isInvalidAuthority(E){return E instanceof v&&E._code===P.InvalidAuthority}static isHandled(E){return E instanceof v&&E.isHandled}constructor(E,w=P.Unknown,m){super(E),this._message=E,this._code=w,this._detail=m,this.isHandled=w===P.NotAvailable&&m===!0,Object.setPrototypeOf(this,v.prototype)}}e.$jl=v;function p(D){const E=D.indexOf("+");return E===-1?D:D.substring(0,E)}e.$kl=p}),define(Ee[233],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.$FP=void 0,e.$FP=(0,y.$ei)("IRemoteExtensionsScannerService"),e.$GP="remoteExtensionsScanner"}),define(Ee[58],ke([1,0,12]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function C(p){return p.scheme===y.Schemas.vscodeRemote?p.authority:void 0}e.$ll=C;function s(p){if(!p)return;const D=p.indexOf("+");return D<0?p:p.substr(0,D)}e.$ml=s;function S(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.$nl=S;function k(p){const{host:D,port:E}=v(p);if(typeof E>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:D,port:E}}e.$ol=k;function P(p,D){let{host:E,port:w}=v(p);return typeof w>"u"&&(w=D),{host:E,port:w}}e.$pl=P;function v(p){const D=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const E=p.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const w=p.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:p,port:void 0}}}),define(Ee[35],ke([1,0,17,5,58]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.TargetPlatform=e.ExtensionType=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=void 0,e.$rm="extensions.user.cache",e.$sm="extensions.builtin.cache",e.$tm="undefined_publisher",e.$um=["ui","workspace","web"];function S(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$vm=S,e.$wm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(k||(e.ExtensionType=k={}));var P;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class v{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,u){if(typeof b>"u"||b===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof b=="string"||typeof u=="string"){const g=typeof b=="string"?b:b.value,h=typeof u=="string"?u:u.value;return y.$jf(g,h)}return b._lower===u._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$xm=v;class p{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const u of b)this.add(u)}add(b){this.c.add(v.toKey(b))}delete(b){return this.c.delete(v.toKey(b))}has(b){return this.c.has(v.toKey(b))}}e.$ym=p;class D{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(v.toKey(b))}get(b){return this.c.get(v.toKey(b))}has(b){return this.c.has(v.toKey(b))}set(b,u){this.c.set(v.toKey(b),u)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zm=D;function E(c){return w(c)}e.$Am=E;function w(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$Bm=w;function m(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$Cm=m;function d(c,b){if(b){const u=`onResolveRemoteAuthority:${(0,s.$ml)(b)}`;return!!c.activationEvents?.includes(u)}return!1}e.$Dm=d,e.$Em=(0,C.$ei)("IBuiltinExtensionsScannerService")}),define(Ee[234],ke([1,0,8,35]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=void 0;class s{constructor(){this.a=new Map,this.b=new WeakMap}register(k,P){this.a.set(k,P)}readActivationEvents(k){return this.b.has(k)||this.b.set(k,this.c(k)),this.b.get(k)}createActivationEventsMap(k){const P=Object.create(null);for(const v of k){const p=this.readActivationEvents(v);p.length>0&&(P[C.$xm.toKey(v.identifier)]=p)}return P}c(k){if(typeof k.main>"u"&&typeof k.browser>"u")return[];const P=Array.isArray(k.activationEvents)?k.activationEvents.slice(0):[];for(let v=0;v<P.length;v++)P[v]==="onUri"&&(P[v]=`onUri:${C.$xm.toKey(k.identifier)}`);if(!k.contributes)return P;for(const v in k.contributes){const p=this.a.get(v);if(!p)continue;const D=k.contributes[v],E=Array.isArray(D)?D:[D];try{p(E,P)}catch(w){(0,y.$1)(w)}}return P}}e.$AF=s,e.$BF=new s}),define(Ee[235],ke([1,0,2,35,16]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class S extends y.$Tc{constructor(P,v,p,D,E){super(),this.a=P,this.b=v,this.c=p,this.f=E,this.B(D.onDidInstallExtensions(w=>this.g(w))),this.B(D.onDidUninstallExtension(w=>this.h(w)))}g(P){for(const v of P)v.local&&this.invalidate(v.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,P)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,C.$rm))}catch(v){(0,s.$Sk)(v)!==1&&this.f.error(v)}}}e.$hq=S}),define(Ee[46],ke([1,0,14,8,2,195,45,5,13,37]),function(le,e,y,C,s,S,k,P,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$tp=(0,P.$ei)("requestService");class D{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class E extends s.$Tc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,S.localize)(0,null),when:v.$Pj.isEqualTo((0,v.$Nj)(v.LogLevel.Trace)).serialize()})}async c(l,t,r){const o=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new D(t.headers??{}));try{const n=await r();return this.a.trace(`${o} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${o} - error`,t.type,(0,C.$0)(n)),n}}}e.$up=E;function w(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.$vp=w;function m(f){return f.res.statusCode===204}e.$wp=m;async function d(f){return m(f)?null:(await(0,y.$Ee)(f.stream)).toString()}e.$xp=d;async function c(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);return d(f)}e.$yp=c;async function b(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);if(m(f))return null;const t=(await(0,y.$Ee)(f.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}e.$zp=b;function u(f){h(f)}e.$Ap=u;let g;function h(f){const l=p.$Un.as(k.$Zn.Configuration),t=g;g={id:"http",order:15,title:(0,S.localize)(1,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,S.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(6,null),(0,S.localize)(7,null),(0,S.localize)(8,null),(0,S.localize)(9,null)],default:"override",description:(0,S.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,S.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[g],remove:t?[t]:[]})}h(1)}),define(Ee[236],ke([1,0,20,12,16,46]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=void 0;let k=class{constructor(v,p){this.a=v,this.b=p}async download(v,p,D=y.CancellationToken.None){if(v.scheme===C.Schemas.file||v.scheme===C.Schemas.vscodeRemote){await this.b.copy(v,p);return}const E={type:"GET",url:v.toString(!0)},w=await this.a.request(E,D);if(w.res.statusCode===200)await this.b.writeFile(p,w.stream);else{const m=await(0,S.$yp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${m}`)}}};e.$WP=k,e.$WP=k=Le([Ne(0,S.$tp),Ne(1,s.$Bk)],k)}),define(Ee[237],ke([1,0,14,20]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=void 0;class s{constructor(P){this.a=P}listen(P,v){throw new Error("Invalid listen")}call(P,v,p,D=C.CancellationToken.None){switch(v){case"request":return this.a.request(p[0],D).then(async({res:E,stream:w})=>{const m=await(0,y.$Ee)(w);return[{statusCode:E.statusCode,headers:E.headers},m]});case"resolveProxy":return this.a.resolveProxy(p[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$wr=s;class S{constructor(P){this.a=P}async request(P,v){const[p,D]=await this.a.call("request",[P],v);return{res:p,stream:(0,y.$Ge)(D)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$xr=S}),define(Ee[238],ke([1,0,87,9]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;function s(k,P){return k.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:k.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function S(k,P,v={}){const p=(0,y.parse)(k),D=v.proxyUrl||s(p,P);if(!D)return null;const E=(0,y.parse)(D);if(!/^https?:$/.test(E.protocol||""))return null;const w={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,C.$Yf)(v.strictSSL)?v.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((m,d)=>{le(["http-proxy-agent"],m,d)})).HttpProxyAgent(D,w):new(await new Promise((m,d)=>{le(["https-proxy-agent"],m,d)})).HttpsProxyAgent(D,w)}e.$yr=S}),define(Ee[88],ke([1,0,54,7,196,20,40,8,3,22,106,213,15,148]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=void 0;let d;async function c(u,g,h,f){return h["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$c?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$fm)(f)&&!h["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$fm)(f)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=w.Promises.withAsyncBody(async(l,t)=>{const r=new S.$ce;let o=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(o=(0,m.$gm)(n,1,120)*1e3);const i=setTimeout(()=>{r.dispose(!0),t(new Error((0,s.localize)(0,null)))},o);try{l(await b(g,r.token))}catch(a){!(0,P.$4)(a)&&!r.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,k.$2i)(a)))):l({})}finally{clearTimeout(i),r.dispose()}})),d)}e.$lm=c;async function b(u,g){const h=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",h);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",f);const l=(0,p.$Ag)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"({.*})"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",r);const o=await(0,D.$8l)(v.OS,r);return u.trace("getUnixShellEnvironment#shell",o),new Promise((n,i)=>{if(g.isCancellationRequested)return i(new P.$5);const a=(0,C.$nc)(o);let $,A;const R="";/^pwsh(-preview)?$/.test(a)?($=`& '${process.execPath}' ${R} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,A=["-Login","-Command"]):a==="nu"?($=`^'${process.execPath}' ${R} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,A=["-i","-l","-c"]):a==="xonsh"?($=`import os, json; print("${l}", json.dumps(dict(os.environ)), "${l}")`,A=["-i","-l","-c"]):($=`'${process.execPath}' ${R} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"||a==="csh"?A=["-ic"]:A=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),$);const I=(0,y.spawn)(o,[...A,$],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(I.kill(),i(new P.$5))),I.on("error",Z=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,k.$2i)(Z)),i(Z)});const O=[];I.stdout.on("data",Z=>O.push(Z));const M=[];I.stderr.on("data",Z=>M.push(Z)),I.on("close",(Z,ee)=>{const fe=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",fe);const ue=Buffer.concat(M).toString("utf8");if(ue.trim()&&u.trace("getUnixShellEnvironment#stderr",ue),Z||ee)return i(new Error((0,s.localize)(2,null,Z,ee)));const j=t.exec(fe),H=j?j[1]:"{}";try{const q=JSON.parse(H);h?q.ELECTRON_RUN_AS_NODE=h:delete q.ELECTRON_RUN_AS_NODE,f?q.ELECTRON_NO_ATTACH_CONSOLE=f:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.VSCODE_RESOLVING_ENVIRONMENT,delete q.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",q),n(q)}catch(q){u.error("getUnixShellEnvironment#errorCaught",(0,k.$2i)(q)),i(q)}})})}}),define(Ee[239],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=void 0,e.$uP=(0,y.$ei)("stateReadService"),e.$vP=(0,y.$ei)("stateService")}),define(Ee[240],ke([1,0,15,14,2,9,26,16,13]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=e.$wP=e.SaveStrategy=void 0;var p;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(p||(e.SaveStrategy=p={}));class D extends s.$Tc{constructor(d,c,b,u){super(),this.h=d,this.j=c,this.m=b,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new y.$ch(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.m.error(d)}}getItem(d,c){const b=this.a[d];return(0,S.$2f)(b)?c:b}setItem(d,c){this.setItems([{key:d,data:c}])}setItems(d){let c=!1;for(const{key:b,data:u}of d)this.a[b]!==u&&((0,S.$2f)(u)?(0,S.$Zf)(this.a[b])||(this.a[b]=void 0,c=!0):(this.a[b]=u,c=!0));c&&this.s()}removeItem(d){(0,S.$Zf)(this.a[d])||(this.a[d]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.n.writeFile(this.h,C.$se.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$wP=D;let E=class extends s.$Tc{constructor(d,c,b,u){super(),this.a=this.B(new D(c.stateResource,d,b,u))}async init(){await this.a.init()}getItem(d,c){return this.a.getItem(d,c)}};e.$xP=E,e.$xP=E=Le([Ne(1,k.$li),Ne(2,v.$yj),Ne(3,P.$Bk)],E);class w extends E{setItem(d,c){this.a.setItem(d,c)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$yP=w}),define(Ee[120],ke([1,0,3,28,22]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=void 0;function S(v){if(y.$o===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function k(v,p,D,E,w,m,d,c,b){const u=Object.create(null);u["common.machineId"]=m,u["common.sqmId"]=d,u.sessionID=(0,s.$Ag)()+Date.now(),u.commitHash=E,u.version=w,u["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,y.$b)(y.$o),u["common.nodePlatform"]=C.$dc,u["common.nodeArch"]=D,u["common.product"]=b||"desktop",c&&(u["common.msftInternal"]=c);let g=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),y.$f&&(u["common.snap"]="true");const f=S(p);return f&&(u["common.platformDetail"]=f),u}e.$Vo=k;function P(v){const p=C.env.USERDNSDOMAIN;if(!p)return!1;const D=p.toLowerCase();return v.some(E=>D===E)}e.$Wo=P}),define(Ee[241],ke([1,0,18,8,2,21,16]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function(p){function D(E,w){return E.callstack<w.callstack?-1:E.callstack>w.callstack?1:0}p.compare=D})(P||(e.ErrorEvent=P={}));class v{constructor(D,E=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new s.$Sc,this.c=D,this.d=E;const w=C.$X.addListener(m=>this.j(m));this.h.add((0,s.$Rc)(w)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(D){if(!D||D.code||(D.detail&&D.detail.stack&&(D=D.detail),C.$bb.isErrorNoTelemetry(D)||D instanceof k.$Wk||typeof D?.message=="string"&&D.message.includes("Unable to read file")))return;const E=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,w=D.message?D.message:(0,S.$Nn)(D);E&&this.k({msg:w,callstack:E})}k(D){const E=(0,y.$wb)(this.g,D,P.compare);E<0?(D.count=1,this.g.splice(~E,0,D)):(this.g[E].count||(this.g[E].count=0),this.g[E].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const D of this.g)this.c.publicLogError2("UnhandledError",D);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(Ee[242],ke([1,0,2]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;class C extends y.$Tc{constructor(S,k){super(),this.a=S,this.b=k}async call(S,k,P){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:v}=P;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:p}=P;return this.b?this.b.log(v,p):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(S,k,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$qs=C}),define(Ee[32],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,y.$ei)("telemetryService"),e.$Gl=(0,y.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var C;(function(S){S[S.NONE=0]="NONE",S[S.CRASH=1]="CRASH",S[S.ERROR=2]="ERROR",S[S.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var s;(function(S){S.OFF="off",S.CRASH="crash",S.ERROR="error",S.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(Ee[243],ke([1,0,27,15,41,12,7,3,4,102,23,105,219,16,31,32]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=void 0;const b=new Map;async function u(t,r){const o=`${t}::${r.join(":")}`,n=b.get(o);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,$=new Map,A=2e4;function R(O,M,Z,ee){const fe=M.substring(O.length+1);return C.Promises.withAsyncBody(async ue=>{let j;try{j=await D.Promises.readdir(M,{withFileTypes:!0})}catch{ue();return}if(ee.count>=A){ee.count+=j.length,ee.maxReached=!0,ue();return}let H=j.length;if(H===0){ue();return}let q=j;ee.count+j.length>A&&(ee.maxReached=!0,H=A-ee.count,q=j.slice(0,H)),ee.count+=j.length;for(const J of q)if(J.isDirectory()){if(Z.includes(J.name)||await R(O,(0,k.$jc)(M,J.name),Z,ee),--H===0){ue();return}}else{const ne=J.name.lastIndexOf(".");if(ne>=0){const x=J.name.substring(ne+1);x&&a.set(x,(a.get(x)??0)+1)}for(const x of i)x.relativePathPattern?.test(fe)!==!1&&x.filePattern.test(J.name)&&$.set(x.tag,($.get(x.tag)??0)+1);if(--H===0){ue();return}}})}const I=C.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await R(t,t,r,M);const Z=await f(t);O({configFiles:g($),fileTypes:g(a),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:Z})});return b.set(o,I),I}e.$fs=u;function g(t){return Array.from(t.entries(),([r,o])=>({name:r,count:o})).sort((r,o)=>o.count-r.count)}function h(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/m.$0k.GB).toFixed(2)}GB (${(y.freemem()/m.$0k.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(p.$kn.value()*100)}%`},r=y.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.$gs=h;async function f(t){try{const r=new Map,o=(0,k.$jc)(t,".vscode","launch.json"),n=await D.Promises.readFile(o),i=[],a=(0,s.$pn)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${o}`),[];if((0,s.$yn)(a)==="object"&&a.configurations)for(const $ of a.configurations){const A=$.type;A&&(r.has(A)?r.set(A,r.get(A)+1):r.set(A,1))}return g(r)}catch{return[]}}e.$hs=f;let l=class{constructor(r,o){this.c=r,this.d=o}f(r){const o=[];return o.push(`OS Version:       ${r.os}`),o.push(`CPUs:             ${r.cpus}`),o.push(`Memory (System):  ${r.memory}`),o.push(`VM:               ${r.vmHint}`),o.join(`
`)}g(r){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const n=y.cpus();return n&&n.length>0&&o.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),o.push(`Memory (System):  ${(y.totalmem()/m.$0k.GB).toFixed(2)}GB (${(y.freemem()/m.$0k.GB).toFixed(2)}GB free)`),P.$c||o.push(`Load (avg):       ${y.loadavg().map(i=>Math.round(i)).join(", ")}`),o.push(`VM:               ${Math.round(p.$kn.value()*100)}%`),o.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${r.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(r,o){return Promise.all([(0,E.$es)(r.mainPID),this.k(r)]).then(async n=>{let[i,a]=n,$=this.m(r,i);return o.forEach(A=>{if((0,w.$Wm)(A))$+=`
${A.errorMessage}`,a+=`
${A.errorMessage}`;else if($+=`

Remote: ${A.hostName}`,A.processes&&($+=`
${this.m(r,A.processes)}`),A.workspaceMetadata){a+=`
|  Remote: ${A.hostName}`;for(const R of Object.keys(A.workspaceMetadata)){const I=A.workspaceMetadata[R];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${R}): ${O}`,a+=this.h(I)}}}),{processInfo:$,workspaceInfo:a}})}async getSystemInfo(r,o){const{memory:n,vmHint:i,os:a,cpus:$}=h(),A={os:a,memory:n,cpus:$,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:o};return P.$c||(A.load=`${y.loadavg().map(R=>Math.round(R)).join(", ")}`),P.$e&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(r,o){const n=[];return(0,E.$es)(r.mainPID).then(async i=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,i)),r.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),o.forEach(a=>{if((0,w.$Wm)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.f(a.machineInfo)),a.processes&&n.push(this.m(r,a.processes)),a.workspaceMetadata)for(const $ of Object.keys(a.workspaceMetadata)){const A=a.workspaceMetadata[$];let R=`${A.fileCount} files`;A.maxFilesReached&&(R=`more than ${R}`),n.push(`Folder (${$}): ${R}`),n.push(this.h(A))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const o=[];let i=0;const a=(I,O)=>{const M=` ${I}(${O})`;i+M.length>60?(o.push($),$="|                 ",i=$.length):i+=M.length,$+=M};let $="|      File types:";const A=10,R=r.fileTypes.length>A?A:r.fileTypes.length;for(let I=0;I<R;I++){const O=r.fileTypes[I];a(O.name,O.count)}if(o.push($),r.configFiles.length>=0&&($="|      Conf files:",i=0,r.configFiles.forEach(I=>{a(I.name,I.count)}),o.push($)),r.launchConfigFiles.length>0){let I="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{const M=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=M}),o.push(I)}return o.join(`
`)}j(r){const o=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(o-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const o=[],n=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(o.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const $=v.URI.revive(a);if($.scheme===S.Schemas.file){const A=$.fsPath;n.push(u(A,["node_modules",".git"]).then(R=>{let I=`${R.fileCount} files`;R.maxFilesReached&&(I=`more than ${I}`),o.push(`|    Folder (${(0,k.$nc)(A)}): ${I}`),o.push(this.h(R))}).catch(R=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${R.toString()})`)}))}else o.push(`|    Folder (${$.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>o.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(r,o){const n=new Map;r.windows.forEach(a=>n.set(a.pid,`window [${a.id}] (${a.title})`)),r.pidToNames.forEach(({pid:a,name:$})=>n.set(a,$));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),o&&this.n(r.mainPID,n,i,o,0),i.join(`
`)}n(r,o,n,i,a){const $=a===0;let A;$?A=i.pid===r?`${this.d.applicationName} main`:"remote agent":o.has(i.pid)?A=o.get(i.pid):A=`${"  ".repeat(a)} ${i.name}`;const R=process.platform==="win32"?i.mem:y.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(R/m.$0k.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(i.children)&&i.children.forEach(I=>this.n(r,o,n,I,a+1))}async getWorkspaceFileExtensions(r){const o=new Set;for(const{uri:n}of r.folders){const i=v.URI.revive(n);if(i.scheme!==S.Schemas.file)continue;const a=i.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(A=>o.add(A.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(r){for(const{uri:o}of r.folders){const n=v.URI.revive(o);if(n.scheme!==S.Schemas.file)continue;const i=n.fsPath;try{const a=await u(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),a.fileTypes.forEach($=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})}),a.launchConfigFiles.forEach($=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})}),a.configFiles.forEach($=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})})}catch{}}}};e.$is=l,e.$is=l=Le([Ne(0,c.$Fl),Ne(1,d.$Qj)],l)}),define(Ee[38],ke([1,0,21,9,58,120,32]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0;class P{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$Xo=P;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Yo=v,e.$Zo=new v;class p{async publicLog(r,o,n){}async publicLogError(r,o,n){}}e.$1o=p,e.$2o="telemetry",e.$3o="extensionTelemetryLog",e.$4o={log:()=>null,flush:()=>Promise.resolve(null)};function D(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}e.$5o=D;function E(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$6o=E;function w(t){const r=t.getValue(k.$Nl),o=t.getValue(k.$Ol);if(t.getValue(k.$Pl)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$7o=w;function m(t){const r={},o={},n={};b(t,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const a=n[i];typeof a=="number"?o[i]=a:typeof a=="boolean"?o[i]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${a.length}`),r[i]=a.substring(0,8191)):typeof a<"u"&&a!==null&&(r[i]=a)}return{properties:r,measurements:o}}e.$8o=m;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const r=(0,s.$ml)(t);return d.has(r)?r:"other"}e.$9o=c;function b(t,r,o=0,n){if(t)for(const i of Object.getOwnPropertyNames(t)){const a=t[i],$=n?n+i:i;Array.isArray(a)?r[$]=(0,y.$Nn)(a):a instanceof Date?r[$]=a.toISOString():(0,C.$Uf)(a)?o<2?b(a,r,o+1,$+"."):r[$]=(0,y.$Nn)(a):r[$]=a}}function u(t,r){const o=t.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,S.$Wo)(o)||n}e.$0o=u;function g(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$$o=g;function h(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const n=[];for(const A of r)for(;;){const R=A.exec(t);if(!R)break;n.push([R.index,A.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(o="";;){const A=a.exec(t);if(!A)break;const R=n.some(([I,O])=>A.index<O&&I<a.lastIndex);!i.test(A[0])&&!R&&(o+=t.substring($,A.index)+"<REDACTED: user-file-path>",$=a.lastIndex)}return $<t.length&&(o+=t.substr($)),o}function f(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of r)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function l(t,r){return(0,y.$Kn)(t,o=>{if(o instanceof P||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let n=o.replaceAll("%20"," ");n=h(n,r);for(const i of r)n=n.replace(i,"");return n=f(n),n}})}e.$_o=l}),define(Ee[36],ke([1,0,17,30,35,3,4,8,28,38]),function(le,e,y,C,s,S,k,P,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;function D(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,y.$ef)(o.id,n.id)===0}e.$ap=D;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(n){const i=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new w(n.identifier,i,a)}static parse(n){const i=E.exec(n);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,a="undefined"){this.version=i,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof w?D(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$bp=w;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(o){const n=m.exec(o);return n&&n[1]?[b(n[1]),n[2]]:[b(o),void 0]}e.$cp=d;function c(o,n){return`${o}.${n}`}e.$dp=c;function b(o){return o.toLowerCase()}e.$ep=b;function u(o,n){return b(c(o??s.$tm,n))}e.$fp=u;function g(o,n){const i=[],a=$=>{for(const A of i)if(A.some(R=>D(n(R),n($))))return A;return null};for(const $ of o){const A=a($);A?A.push($):i.push([$])}return i}e.$gp=g;function h(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$hp=h;function f(o){return{id:new p.$Xo(o.identifier.id),name:new p.$Xo(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$ip=f,e.$jp=new s.$xm("pprice.better-merge");function l(o,n){const i=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const $=a.shift();if($&&i.every(A=>!D(A.identifier,{id:$}))){const A=o.filter(R=>D(R.identifier,{id:$}));A.length===1&&(i.push(A[0]),a.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$kp=l;async function t(o,n){if(!S.$e)return!1;let i;try{i=(await o.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await o.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch($){n.debug("Error while getting the os-release file.",(0,P.$0)($))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(o,n){const i=await t(o,n),a=(0,C.$Ho)(i?"alpine":S.$o,v.$ec);return n.debug("ComputeTargetPlatform:",a),a}e.$lp=r}),define(Ee[121],ke([1,0,20,8,12,19,55,4,183,30,36,35]),function(le,e,y,C,s,S,k,P,v,p,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;const w=c=>(0,v.localize)(0,null,c),m=(0,v.localize)(1,null,"ms-dotnettools.csharp");let d=class{constructor(b,u,g){this.a=b,this.b=u,this.d=g}get f(){}async listExtensions(b,u,g){let h=await this.b.getInstalled(1,g);const f=E.$wm.map(t=>t.toLowerCase());if(u&&u!==""){if(f.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}h=h.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),f.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),h=h.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let l;for(const t of h)l!==t.identifier.id&&(l=t.identifier.id,this.a.info(b?`${l}@${t.manifest.version}`:l))}async installExtensions(b,u,g,h){const f=[];try{b.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const l=[],t=[],r=(n,i,a)=>{t.push({id:n,version:i!=="prerelease"?i:void 0,installOptions:{...g,isBuiltin:a,installPreReleaseVersion:i==="prerelease"||g.installPreReleaseVersion}})};for(const n of b)if(n instanceof P.URI)l.push({vsix:n,installOptions:g});else{const[i,a]=(0,D.$cp)(n);r(i,a,!1)}for(const n of u)if(n instanceof P.URI)l.push({vsix:n,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[i,a]=(0,D.$cp)(n);r(i,a,!0)}const o=await this.b.getInstalled(1,g.profileLocation);if(l.length&&await Promise.all(l.map(async({vsix:n,installOptions:i})=>{try{await this.h(n,i,h,o)}catch(a){this.a.error(a),f.push(n.toString())}})),t.length){const n=await this.g(t,o,h);f.push(...n)}}catch(l){throw this.a.error((0,v.localize)(5,null,(0,C.$0)(l))),l}if(f.length)throw new Error((0,v.localize)(6,null,f.join(", ")))}async updateExtensions(b){const u=await this.b.getInstalled(1,b),g=[];for(const t of u)t.identifier.uuid&&g.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,v.localize)(7,null,g.length));const h=await this.d.getExtensions(g,{compatible:!0},y.CancellationToken.None),f=[];for(const t of h)for(const r of u)(0,D.$ap)(r.identifier,t.identifier)&&(0,k.gt)(t.version,r.manifest.version)&&f.push({extension:t,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!f.length){this.a.info((0,v.localize)(8,null));return}this.a.info((0,v.localize)(9,null,f.map(t=>t.extension.identifier.id).join(", ")));const l=await this.b.installGalleryExtensions(f);for(const t of l)t.error?this.a.error((0,v.localize)(10,null,t.identifier.id,(0,C.$0)(t.error))):this.a.info((0,v.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(b,u,g){if(b=b.filter(({id:t,version:r})=>{const o=u.find(n=>(0,D.$ap)(n.identifier,{id:t}));if(o){if(!g&&(!r||r==="prerelease"&&o.preRelease))return this.a.info((0,v.localize)(12,null,t,o.manifest.version,t)),!1;if(r&&o.manifest.version===r)return this.a.info((0,v.localize)(13,null,`${t}@${r}`)),!1}return!0}),!b.length)return[];const h=[],f=[],l=await this.j(b);if(await Promise.all(b.map(async({id:t,version:r,installOptions:o})=>{const n=l.get(t.toLowerCase());if(!n){this.a.error(`${w(r?`${t}@${r}`:t)}
${m}`),h.push(t);return}try{const a=await this.d.getManifest(n,y.CancellationToken.None);if(a&&!this.k(a))return}catch(a){this.a.error(a.message||a.stack||a),h.push(t);return}const i=u.find(a=>(0,D.$ap)(a.identifier,n.identifier));if(i){if(n.version===i.manifest.version){this.a.info((0,v.localize)(14,null,r?`${t}@${r}`:t));return}this.a.info((0,v.localize)(15,null,t,n.version))}o.isBuiltin?this.a.info(r?(0,v.localize)(16,null,t,r):(0,v.localize)(17,null,t)):this.a.info(r?(0,v.localize)(18,null,t,r):(0,v.localize)(19,null,t)),f.push({extension:n,options:{...o,installGivenVersion:!!r}})})),f.length){const t=await this.b.installGalleryExtensions(f);for(const r of t)r.error?(this.a.error((0,v.localize)(20,null,r.identifier.id,(0,C.$0)(r.error))),h.push(r.identifier.id)):this.a.info((0,v.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return h}async h(b,u,g,h){const f=await this.b.getManifest(b);if(!f)throw new Error("Invalid vsix");if(await this.l(f,g,u.profileLocation,h))try{await this.b.install(b,u),this.a.info((0,v.localize)(22,null,(0,S.$Og)(b)))}catch(t){if((0,C.$4)(t))this.a.info((0,v.localize)(23,null,(0,S.$Og)(b)));else throw t}}async j(b){const u=new Map,g=b.some(l=>l.installOptions.installPreReleaseVersion),h=await this.b.getTargetPlatform(),f=[];for(const l of b)p.$Ao.test(l.id)&&f.push({...l,preRelease:g});if(f.length){const l=await this.d.getExtensions(f,{targetPlatform:h},y.CancellationToken.None);for(const t of l)u.set(t.identifier.id.toLowerCase(),t)}return u}k(b){return!0}async l(b,u,g,h){if(!u){const f={id:(0,D.$fp)(b.publisher,b.name)},l=h.find(t=>(0,D.$ap)(f,t.identifier)&&(0,k.gt)(t.manifest.version,b.version));if(l)return this.a.info((0,v.localize)(24,null,l.identifier.id,l.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,u,g){const h=async l=>{if(l instanceof P.URI){const t=await this.b.getManifest(l);return(0,D.$dp)(t.publisher,t.name)}return l},f=[];for(const l of b){const t=await h(l),o=(await this.b.getInstalled(void 0,g)).filter(n=>(0,D.$ap)(n.identifier,{id:t}));if(!o.length)throw new Error(`${this.m(t)}
${m}`);if(o.some(n=>n.type===0)){this.a.info((0,v.localize)(25,null,t));return}if(!u&&o.some(n=>n.isBuiltin)){this.a.info((0,v.localize)(26,null,t));return}this.a.info((0,v.localize)(27,null,t));for(const n of o)await this.b.uninstall(n,{profileLocation:g}),f.push(n);this.f?this.a.info((0,v.localize)(28,null,t,this.f)):this.a.info((0,v.localize)(29,null,t))}}async locateExtension(b){const u=await this.b.getInstalled();b.forEach(g=>{u.forEach(h=>{if(h.identifier.id===g&&h.location.scheme===s.Schemas.file){this.a.info(h.location.fsPath);return}})})}m(b){return this.f?(0,v.localize)(30,null,b,this.f):(0,v.localize)(31,null,b)}};e.$Tp=d,e.$Tp=d=Le([Ne(1,p.$Oo),Ne(2,p.$Lo)],d)}),define(Ee[244],ke([1,0,15,8,2,12,19,55,9,22,23,81,25,26,30,36,86,16,13]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let f=h=class extends s.$Tc{constructor(t,r,o,n,i,a){super(),this.h=r,this.j=o,this.m=n,this.n=i,this.r=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,r,o){await this.g;const n=(0,k.$Rg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,n,a=>this.j.download(t,a,r))}catch(a){throw new d.$Mo(a.message,d.ExtensionManagementErrorCode.Download)}let i=!1;if(o&&this.t(t)){const a=await this.u(t);try{i=await this.n.verify(n.fsPath,a.fsPath,this.r.getLevel()===g.LogLevel.Trace)}catch($){const A=$;if(i=A.code,A.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${A.output}`),i===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(R){this.r.error(R)}throw new d.$Mo(E.$Xp,d.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(a)}catch($){this.r.error($)}}}return i===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:n,verificationStatus:i}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,v.$Yf)(r)?r:!0}async u(t){await this.g;const r=(0,k.$Rg)(this.extensionsDownloadDir,`${this.z(t)}${h.c}`);try{await this.w(t,r,o=>this.j.downloadSignatureArchive(t,o))}catch(o){throw new d.$Mo(o.message,d.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(t,r,o){if(await this.h.exists(r))return;if(r.scheme!==S.Schemas.file){await o(r);return}const n=(0,k.$Rg)(this.extensionsDownloadDir,`.${(0,p.$Ag)()}`);await this.h.exists(n)||await o(n);try{await D.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,C.$0)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],o=[],n=[];for(const $ of t.children)if($.name.endsWith(h.c))n.push($.resource);else{const A=c.$bp.parse($.name);A&&o.push([A,$])}const i=(0,c.$gp)(o,([$])=>$),a=[];for(const $ of i)$.sort((A,R)=>P.rcompare(A[0].version,R[0].version)),r.push(...$.slice(1).map(A=>A[1].resource)),a.push($[0][1]);a.sort(($,A)=>$.mtime-A.mtime),r.push(...a.slice(0,Math.max(0,a.length-this.f)).map($=>$.resource)),r.push(...n),await y.Promises.settled(r.map($=>(this.r.trace("Deleting from cache",$.path),this.h.del($))))}}catch(t){this.r.error(t)}}z(t){return this.f?c.$bp.create(t).toString().toLowerCase():(0,p.$Ag)()}};e.$eq=f,f.c=".sigzip",e.$eq=f=h=Le([Ne(0,m.$mi),Ne(1,u.$Bk),Ne(2,d.$Lo),Ne(3,w.$Ki),Ne(4,b.$Rp),Ne(5,g.$yj)],f)}),define(Ee[245],ke([1,0,6,2,24,36,35]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;class P extends C.$Tc{constructor(p,D,E,w,m,d,c){super(),this.f=p,this.g=D,this.h=E,this.j=w,this.m=m,this.n=d,this.r=c,this.a=this.B(new y.$5d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new C.$3c),this.s().then(null,b=>c.error(b))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(p=>this.u(p.added))),this.B(this.j.onAddExtensions(p=>this.w(p))),this.B(this.j.onDidAddExtensions(p=>this.y(p))),this.B(this.j.onRemoveExtensions(p=>this.z(p))),this.B(this.j.onDidRemoveExtensions(p=>this.C(p))),this.B(this.n.onDidFilesChange(p=>this.D(p)))}async u(p){try{p.length&&await Promise.all(p.map(D=>(this.c.set(D.id,(0,C.$Qc)(this.n.watch(this.m.extUri.dirname(D.extensionsResource)),this.n.watch(D.extensionsResource))),this.G(D.extensionsResource))))}catch(D){throw this.r.error(D),D}}async w(p){for(const D of p.extensions)this.I(this.L(D.identifier,D.version),p.profileLocation)}async y(p){for(const D of p.extensions){const E=this.L(D.identifier,D.version);p.error?this.J(E,p.profileLocation):this.I(E,p.profileLocation)}}async z(p){for(const D of p.extensions)this.J(this.L(D.identifier,D.version),p.profileLocation)}async C(p){const D=[],E=[];for(const w of p.extensions){const m=this.L(w.identifier,w.version);p.error?this.I(m,p.profileLocation):(this.J(m,p.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),E.push(this.f.scanInstalledExtensionAtLocation(w.location).then(d=>{d?D.push(d):this.r.info("Extension not found at the location",w.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(E),D.length&&await this.H(D)}catch(w){this.r.error(w)}}D(p){for(const D of this.h.profiles)p.contains(D.extensionsResource,0,1)&&this.F(D.extensionsResource)}async F(p){const D=[],E=[],w=await this.j.scanProfileExtensions(p),m=new Set,d=new Set;for(const[c,b]of this.b)b.has(p)&&d.add(c);for(const c of w){const b=this.L(c.identifier,c.version);m.add(b),d.has(b)||(D.push(c.identifier),this.I(b,p))}for(const c of d)if(!m.has(c)){const b=this.M(c);b&&(E.push(b.identifier),this.J(c,p))}(D.length||E.length)&&this.a.fire({added:D.length?{extensions:D,profileLocation:p}:void 0,removed:E.length?{extensions:E,profileLocation:p}:void 0})}async G(p){const D=await this.j.scanProfileExtensions(p);for(const E of D)this.I(this.L(E.identifier,E.version),p)}async H(p){p||(p=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),p.length&&await this.f.markAsUninstalled(...p)}I(p,D){let E=this.b.get(p);E||this.b.set(p,E=new s.$Bc(w=>this.m.extUri.getComparisonKey(w))),E.add(D)}J(p,D){const E=this.b.get(p);E&&E.delete(D),E?.size||this.b.delete(p)}L(p,D){return`${k.$xm.toKey(p.id)}@${D}`}M(p){const[D,E]=(0,S.$cp)(p);return E?{identifier:{id:D},version:E}:void 0}}e.$iq=P}),define(Ee[246],ke([1,0,217,38]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;async function s(S,k,P,v,p,D,E){const w={"X-Market-Client-Id":`VSCode ${S}`,"User-Agent":`VSCode ${S} (${k.nameShort})`};if((0,C.$5o)(k,P)&&(0,C.$7o)(v)===3){const m=await(0,y.$Mp)(P,p,D);w["X-Market-User-Id"]=m,w["VSCode-SessionId"]=E.machineId||m}return w}e.$Np=s}),define(Ee[122],ke([1,0,89,18,15,2,12,7,23,26,30,36,13,85,4]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;let c=class extends m.$ur{constructor(h,f,l,t){super(l),this.h=h,this.j=t,this.g=this.B(new b(f,t)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(h,f){const t=(await this.g.getLanguagePacks())[f];if(!t){this.j.warn(`No language pack found for ${f}`);return}const r=t.translations[h];return r?d.URI.file(r):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),f=Object.keys(h).map(l=>{const t=h[l];return{...this.f(l,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return f.push(this.f("en","English")),f.sort((l,t)=>l.label.localeCompare(t.label)),f}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const f=await this.g.getLanguagePacks();Object.keys(f).some(l=>f[l]&&f[l].extensions.some(t=>(0,E.$ap)(t.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,f]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(f);return!(0,C.$ub)(Object.keys(h),Object.keys(l))}};e.$vr=c,e.$vr=c=Le([Ne(0,D.$Oo),Ne(1,p.$mi),Ne(2,D.$Lo),Ne(3,w.$yj)],c);let b=class extends S.$Tc{constructor(h,f){super(),this.j=f,this.c={},this.f=(0,P.$jc)(h.userDataPath,"languagepacks.json"),this.g=new s.$lh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(f=>{Object.keys(f).forEach(l=>delete f[l]),this.m(f,...h)}).then(()=>this.c)}m(h,...f){for(const l of f)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(h,l);Object.keys(h).forEach(l=>this.r(h[l]))}n(h,f){const l=f.identifier,t=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const r of t)if(f.location.scheme===k.Schemas.file&&u(r)){let o=h[r.languageId];o||(o={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},h[r.languageId]=o);const n=o.extensions.filter(i=>(0,E.$ap)(i.extensionIdentifier,l))[0];n?n.version=f.manifest.version:o.extensions.push({extensionIdentifier:l,version:f.manifest.version});for(const i of r.translations)o.translations[i.id]=(0,P.$jc)(f.location.fsPath,i.path)}}r(h){if(h){const f=(0,y.createHash)("md5");for(const l of h.extensions)f.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);h.hash=f.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let f=null;return v.Promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(f=h(l),l)).then(l=>{for(const r of Object.keys(l))l[r]||delete l[r];this.c=l,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>f,l=>this.j.error(l))})}};b=Le([Ne(0,p.$mi),Ne(1,w.$yj)],b);function u(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const h of g.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(Ee[247],ke([1,0,155,8,21,38]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function v(D,E,w){const m=await(0,y.$uD)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,y.$uD)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new m.AppInsightsCore,b=new d.PostChannel,u={instrumentationKey:D,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(w){u.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};u.extensionConfig[b.identifier]=g}return c.initialize(u,[]),c.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),c}class p{constructor(E,w,m,d,c){this.e=E,this.f=w,this.g=m,this.h=c,this.c=k,this.d=P,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=v(this.a,this.e,this.h)),this.b.then(w=>{E(w)},w=>{(0,C.$1)(w),console.error(w)})}}log(E,w){if(!this.a)return;w=(0,s.$Ln)(w,this.g),w=(0,S.$8o)(w);const m=this.f+"/"+E;try{this.i(d=>{d.pluginVersionString=w?.properties.version??"Unknown",d.track({name:m,baseData:{name:m,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$qP=p}),define(Ee[248],ke([1,0,2,21,3,17,197,25,45,57,31,37,32,38]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;let d=class{constructor(u,g,h){this.k=g,this.l=h,this.d={},this.i=new y.$Sc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,S.$Xe)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,S.$Xe)(f.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(f=>{(f.affectsConfiguration(w.$Nl)||f.affectsConfiguration(w.$Pl)||f.affectsConfiguration(w.$Ol))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,m.$7o)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const h=g.usage?3:g.error?2:0;u=Math.min(u,h)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,g,h){this.g<g||(h=(0,C.$Ln)(h,this.d),h=(0,m.$_o)(h,this.j),h=(0,C.$Ln)(h,this.c),this.b.forEach(f=>f.log(u,h)))}publicLog(u,g){this.n(u,3,g)}publicLog2(u,g){this.publicLog(u,g)}publicLogError(u,g){this.h&&this.n(u,2,g)}publicLogError2(u,g){this.publicLogError(u,g)}};e.$Br=d,d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Br=d=Le([Ne(1,P.$Ki),Ne(2,D.$Qj)],d);function c(){const b=(0,k.localize)(0,null,p.default.nameLong),u=p.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",p.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=s.$i?"":(0,k.localize)(3,null),h=(0,k.localize)(4,null),f=(0,k.localize)(5,null),l=(0,k.localize)(6,null),t=(0,k.localize)(7,null),r=`
|       | ${h} | ${f} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,k.localize)(8,null);return`
${b} ${u} ${g}

&nbsp;

${t}
${r}

&nbsp;

${o}
`}E.$Un.as(v.$Zn.Configuration).registerConfiguration({id:w.$Ml,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[w.$Nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Un.as(v.$Zn.Configuration).registerConfiguration({id:w.$Ml,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[w.$Pl]:{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,k.localize)(16,null,p.default.nameLong,p.default.privacyStatementUrl):(0,k.localize)(15,null,p.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${w.$Nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Ee[249],ke([1,0,25,5,31,32,248,38]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=void 0;let v=class extends k.$Br{constructor(D,E,w,m){super(D,w,m),this.o=E}publicLog(D,E){if(!(this.o<3))return super.publicLog(D,E)}publicLog2(D,E){return this.publicLog(D,E)}publicLogError(D,E){return this.o<2?Promise.resolve(void 0):super.publicLogError(D,E)}publicLogError2(D,E){return this.publicLogError(D,E)}async updateInjectedTelemetryLevel(D){if(D===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,D):D,this.o===0&&this.dispose()}};e.$ns=v,e.$ns=v=Le([Ne(2,y.$Ki),Ne(3,s.$Qj)],v),e.$os=new class extends P.$Yo{async updateInjectedTelemetryLevel(){}},e.$ps=(0,C.$fi)(S.$Fl)}),define(Ee[250],ke([1,0,14,20,251,247]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=void 0;async function k(D,E){const w=await E.request(D,C.CancellationToken.None),m=(await(0,y.$Ee)(w.stream)).toString(),d=w.res.statusCode??200;return{headers:w.res.headers,statusCode:d,responseData:m}}async function P(D){const E={method:D.type,headers:D.headers};return new Promise((m,d)=>{const c=s.request(D.url??"",E,b=>{b.on("data",function(u){m({headers:b.headers,statusCode:b.statusCode??200,responseData:u.toString()})}),b.on("error",function(u){d(u)})});c.write(D.data,b=>{b&&d(b)}),c.end()})}async function v(D,E,w){const m=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),d={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:m};try{const c=D?await k(d,D):await P(d);w(c.statusCode,c.headers,c.responseData)}catch{w(0,{})}}class p extends S.$qP{constructor(E,w,m,d,c){const b={sendPOST:(u,g)=>{v(E,u,g)}};super(w,m,d,c,b)}}e.$rP=p}),define(Ee[252],ke([1,0,8,241]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class s extends C.default{i(){(0,y.setUnexpectedErrorHandler)(P=>console.error(P));const k=[];process.on("unhandledRejection",(P,v)=>{k.push(v),setTimeout(()=>{const p=k.indexOf(v);p>=0&&v.catch(D=>{k.splice(p,1),(0,y.$4)(D)||(console.warn(`rejected promise not handled within 1 second: ${D}`),D.stack&&console.warn(`stack trace: ${D.stack}`),P&&(0,y.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const v=k.indexOf(P);v>=0&&k.splice(v,1)}),process.on("uncaughtException",P=>{(0,y.$Z)(P)||(0,y.$1)(P)})}}e.default=s}),define(Ee[123],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(Ee[124],ke([1,0,3,123]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;const s=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class S{constructor(D){this.collections=D,this.a=new Map,this.b=new Map,D.forEach((E,w)=>{this.d(E,w);const m=E.map.entries();let d=m.next();for(;!d.done;){const c=d.value[1],b=d.value[0];let u=this.a.get(b);if(u||(u=[],this.a.set(b,u)),u.length>0&&u[0].type===C.EnvironmentVariableMutatorType.Replace){d=m.next();continue}const g={extensionIdentifier:w,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};g.scope||delete g.scope,u.unshift(g),d=m.next()}})}async applyToProcessEnvironment(D,E,w){let m;y.$c&&(m={},Object.keys(D).forEach(d=>m[d.toLowerCase()]=d));for(const[d,c]of this.getVariableMap(E)){const b=y.$c&&m[d.toLowerCase()]||d;for(const u of c){const g=w?await w(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case C.EnvironmentVariableMutatorType.Append:D[b]=(D[b]||"")+g;break;case C.EnvironmentVariableMutatorType.Prepend:D[b]=g+(D[b]||"");break;case C.EnvironmentVariableMutatorType.Replace:D[b]=g;break}if(u.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${s.get(u.type)}`;D[h]=(D[h]?D[h]+":":"")+d+"="+this.c(g)}}}}c(D){return D.replaceAll(":","\\x3a")}diff(D,E){const w=new Map,m=new Map,d=new Map;if(D.getVariableMap(E).forEach((c,b)=>{const u=this.getVariableMap(E).get(b),g=P(c,u);g&&w.set(b,g)}),this.getVariableMap(E).forEach((c,b)=>{const u=D.getVariableMap(E).get(b),g=P(c,u);g&&d.set(b,g)}),this.getVariableMap(E).forEach((c,b)=>{const u=D.getVariableMap(E).get(b),g=v(c,u);g&&m.set(b,g)}),!(w.size===0&&m.size===0&&d.size===0))return{added:w,changed:m,removed:d}}getVariableMap(D){const E=new Map;for(const w of this.a.values()){const m=w.filter(d=>k(d,D));m.length>0&&E.set(m[0].variable,m)}return E}getDescriptionMap(D){const E=new Map;for(const w of this.b.values()){const m=w.filter(d=>k(d,D,!0));for(const d of m)E.set(d.extensionIdentifier,d.description)}return E}d(D,E){if(!D.descriptionMap)return;const w=D.descriptionMap.entries();let m=w.next();for(;!m.done;){const d=m.value[1],c=m.value[0];let b=this.b.get(c);b||(b=[],this.b.set(c,b));const u={extensionIdentifier:E,scope:d.scope,description:d.description};u.scope||delete u.scope,b.push(u),m=w.next()}}}e.$5r=S;function k(p,D,E=!1){return p.scope?!!(p.scope.workspaceFolder&&D?.workspaceFolder&&p.scope.workspaceFolder.index===D.workspaceFolder.index):E?D===p.scope:!0}function P(p,D){if(!D)return p;const E=new Set;D.forEach(m=>E.add(m.extensionIdentifier));const w=[];return p.forEach(m=>{E.has(m.extensionIdentifier)||w.push(m)}),w.length===0?void 0:w}function v(p,D){if(!D)return;const E=new Map;D.forEach(m=>E.set(m.extensionIdentifier,m));const w=[];return p.forEach(m=>{const d=E.get(m.extensionIdentifier);d&&(m.type!==d.type||m.value!==d.value||m.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&w.push(d)}),w.length===0?void 0:w}}),define(Ee[90],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=e.$Yr=void 0;function y(v){return[...v.entries()]}e.$Yr=y;function C(v){return v?[...v.entries()]:[]}e.$Zr=C;function s(v){return new Map(v)}e.$1r=s;function S(v){return new Map(v??[])}e.$2r=S;function k(v){return Array.from(v.entries()).map(p=>[p[0],y(p[1].map),C(p[1].descriptionMap)])}e.$3r=k;function P(v){return new Map(v.map(p=>[p[0],{map:s(p[1]),descriptionMap:S(p[2])}]))}e.$4r=P}),define(Ee[253],ke([1,0,15,20,6,2,13]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;let P=class extends S.$Tc{constructor(p,D){super(),this.h=D,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$5d),this.onCreateRequest=this.g.event,this.b=p===void 0?15e3:p,this.B((0,S.$Rc)(()=>{for(const E of this.f.values())(0,S.$Oc)(E)}))}createRequest(p){return new Promise((D,E)=>{const w=++this.a;this.c.set(w,D),this.g.fire({requestId:w,...p});const m=new C.$ce;(0,y.$fh)(this.b,m.token).then(()=>E(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,S.$Rc)(()=>m.cancel())])})}acceptReply(p,D){const E=this.c.get(p);E?(this.c.delete(p),(0,S.$Oc)(this.f.get(p)||[]),this.f.delete(p),E(D)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${p}`)}};e.$Pr=P,e.$Pr=P=Le([Ne(1,k.$yj)],P)}),define(Ee[91],ke([1,0,5,69,37]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Ir=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Hr=void 0,e.$Hr=new C.$vj("terminalTabFocusMode",!1,!0);var S;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(S||(e.TerminalSettingPrefix=S={}));var k;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.EnableVisualBell="terminal.integrated.enableVisualBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",l.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",l.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",l.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",l.MouseWheelZoom="terminal.integrated.mouseWheelZoom",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(k||(e.TerminalSettingId=k={}));var P;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh",l.Python="python"})(P||(e.PosixShellType=P={}));var v;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash",l.Python="python"})(v||(e.WindowsShellType=v={}));var p;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(p||(e.TitleEventSource=p={}));var D;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(D||(e.TerminalIpcChannels=D={}));var E;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$Ir=(0,y.$ei)("ptyService");var w;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var m;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var d;(function(l){l.TerminalView="view",l.Editor="editor"})(d||(e.TerminalLocationString=d={}));var c;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var b;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var u;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var g;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var h;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$Jr={Backend:"workbench.contributions.terminal.processBackend"};class f{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const r=this.b(t.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Un.add(e.$Jr.Backend,new f),e.$Kr=(0,y.$ei)("localPtyService"),e.$Lr=(0,y.$ei)("terminalLogService")}),define(Ee[254],ke([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=e.$7O=e.$6O=void 0;function C(k){let P=k;P.includes("\\")&&(P=P.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return P=P.replace(v,""),`'${P}'`}e.$6O=C;function s(k,P,v){if(!k)return"";if(!P)return k;P.match(/[\/\\]$/)&&(P=P.slice(0,P.length-1));const p=k.replace(/\\/g,"/").toLowerCase(),D=P.replace(/\\/g,"/").toLowerCase();return p.includes(D)?`~${v}${k.slice(P.length+1)}`:k}e.$7O=s;function S(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),y.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}e.$8O=S}),define(Ee[255],ke([1,0,51,4,199,100]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0;function k(w,m){const d=[{name:null,description:(0,s.localize)(0,null)}];return d.push(...w.map(c=>({name:c.profileName,description:P(c)}))),m&&d.push(...m.map(c=>({name:c.title,description:v(c)}))),{values:d.map(c=>c.name),markdownDescriptions:d.map(c=>c.description)}}e.$Qr=k;function P(w){let m=`$(${S.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:y.$kk.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?m+=`
- args: "${w.args}"`:m+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(m+=`
- overrideName: ${w.overrideName}`),w.color&&(m+=`
- color: ${w.color}`),w.env&&(m+=`
- env: ${JSON.stringify(w.env)}`),m}function v(w){return`$(${S.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:y.$kk.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function p(w,m){if(!w&&!m)return!0;if(typeof w=="string"&&typeof m=="string")return w===m;if(Array.isArray(w)&&Array.isArray(m)){if(w.length!==m.length)return!1;for(let d=0;d<w.length;d++)if(w[d]!==m[d])return!1;return!0}return!1}e.$Rr=p;function D(w,m){if(!w&&!m)return!0;if(!w||!m)return!1;if(S.ThemeIcon.isThemeIcon(w)&&S.ThemeIcon.isThemeIcon(m))return w.id===m.id&&w.color===m.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof m=="object"&&"light"in m&&"dark"in m){const d=w,c=m;if((C.URI.isUri(d.light)||E(d.light))&&(C.URI.isUri(d.dark)||E(d.dark))&&(C.URI.isUri(c.light)||E(c.light))&&(C.URI.isUri(c.dark)||E(c.dark)))return d.light.path===c.light.path&&d.dark.path===c.dark.path}if(C.URI.isUri(w)&&C.URI.isUri(m)||E(w)||E(m)){const d=w,c=m;return d.path===c.path&&d.scheme===c.scheme}return!1}e.$Sr=D;function E(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.$Tr=E}),define(Ee[256],ke([1,0,51,3,198,45,37,255]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=void 0,e.$Ur={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Vr={type:"string",enum:Array.from((0,y.$jk)(),b=>b.id),markdownEnumDescriptions:Array.from((0,y.$jk)(),b=>`$(${b.id})`)};const v={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$Vr},color:{description:(0,s.localize)(3,null),...e.$Ur},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...v}},D={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...v}};function E(b){const u=b===2?"linux":b===1?"osx":"windows";return(0,s.localize)(7,null,(0,C.$b)(b),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:E(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...v}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...v}},{type:"null"},p]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:E(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...v}},{type:"null"},p]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:E(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...v}},{type:"null"},p]}},"terminal.integrated.useWslProfiles":{description:(0,s.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){k.$Un.as(S.$Zn.Configuration).registerConfiguration(w),c()}e.$Wr=m;let d;function c(b,u){const g=k.$Un.as(S.$Zn.Configuration);let h;b&&(h=(0,P.$Qr)(b?.profiles,u));const f=d;d={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:b?.os===3?h?.values:void 0,markdownEnumDescriptions:b?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:b?.os===2?h?.values:void 0,markdownEnumDescriptions:b?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:b?.os===1?h?.values:void 0,markdownEnumDescriptions:b?.os===1?h?.markdownDescriptions:void 0}}},g.updateConfigurations({add:[d],remove:f?[f]:[]})}e.$Xr=c}),define(Ee[257],ke([1,0,2,12,108,26,109]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=void 0;let P=class extends y.$Tc{constructor(p,D){super(),this.a=p,this.b=D}start(){const p={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:C.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},D=(0,k.$Pm)(this.b.args,this.b.isBuilt);D&&(D.break&&D.port?p.debugBrk=D.port:!D.break&&D.port&&(p.debug=D.port));const E=new s.$Dq(C.$yg.asFileUri("bootstrap-fork").fsPath,p),w=new y.$Sc;return w.add(E),{client:E,store:w,onDidProcessExit:E.onDidProcessExit}}};e.$LP=P,e.$LP=P=Le([Ne(1,S.$li)],P)}),define(Ee[258],ke([1,0,27,12,21,7,3,28,17,9,23,123,90,124]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=void 0;function d(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let i=0;return n&&n.length===4&&(i=parseInt(n[3])),i}e.$6r=d;async function c(n,i,a,$=P.env,A=D.Promises.exists){if(S.$ic(n))return await A(n)?n:void 0;if(i===void 0&&(i=P.cwd()),S.$mc(n)!=="."){const M=S.$jc(i,n);return await A(M)?M:void 0}const I=(0,s.$Pn)($,"PATH");if(a===void 0&&(0,p.$Sf)(I)&&(a=I.split(S.$tc)),a===void 0||a.length===0){const M=S.$jc(i,n);return await A(M)?M:void 0}for(const M of a){let Z;if(S.$ic(M)?Z=S.$jc(M,n):Z=S.$jc(i,M,n),await A(Z))return Z;if(k.$c){let ee=Z+".com";if(await A(ee)||(ee=Z+".exe",await A(ee)))return ee}}const O=S.$jc(i,n);return await A(O)?O:void 0}e.$7r=c;function b(n,i,a,$,A){const R=k.$c&&(!i.windowsEnableConpty||d()<18309);if(!i.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||R)return;const I=n.args,O=P.$dc==="win32"?S.$nc(n.executable).toLowerCase():S.$nc(n.executable),M=S.$mc(C.$yg.asFileUri("").fsPath);let Z;const ee={VSCODE_INJECTION:"1"};if(i.shellIntegration.nonce&&(ee.VSCODE_NONCE=i.shellIntegration.nonce),k.$c){if(O==="pwsh.exe"||O==="powershell.exe")return!I||r(I)?Z=h.get(g.WindowsPwsh):t(I)&&(Z=h.get(g.WindowsPwshLogin)),Z?(Z=[...Z],Z[Z.length-1]=(0,v.$Te)(Z[Z.length-1],M,""),i.shellIntegration.suggestEnabled&&(ee.VSCODE_SUGGEST="1"),{newArgs:Z,envMixin:ee}):void 0;$.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(O){case"bash":return!I||I.length===0?Z=h.get(g.Bash):o(I)&&(ee.VSCODE_SHELL_LOGIN="1",u(i,ee),Z=h.get(g.Bash)),Z?(Z=[...Z],Z[Z.length-1]=(0,v.$Te)(Z[Z.length-1],M),{newArgs:Z,envMixin:ee}):void 0;case"fish":{const fe=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ue=S.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ee.XDG_DATA_DIRS=`${fe}:${ue}`,u(i,ee),{newArgs:void 0,envMixin:ee}}case"pwsh":return!I||r(I)?Z=h.get(g.Pwsh):t(I)&&(Z=h.get(g.PwshLogin)),Z?(i.shellIntegration.suggestEnabled&&(ee.VSCODE_SUGGEST="1"),Z=[...Z],Z[Z.length-1]=(0,v.$Te)(Z[Z.length-1],M,""),{newArgs:Z,envMixin:ee}):void 0;case"zsh":{if(!I||I.length===0?Z=h.get(g.Zsh):o(I)?(Z=h.get(g.ZshLogin),u(i,ee)):(I===h.get(g.Zsh)||I===h.get(g.ZshLogin))&&(Z=I),!Z)return;Z=[...Z],Z[Z.length-1]=(0,v.$Te)(Z[Z.length-1],M);let fe;try{fe=y.userInfo().username}catch{fe="unknown"}const ue=S.$jc(y.tmpdir(),`${fe}-${A.applicationName}-zsh`);ee.ZDOTDIR=ue;const j=a?.ZDOTDIR??y.homedir()??"~";ee.USER_ZDOTDIR=j;const H=[];return H.push({source:S.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:S.$jc(ue,".zshrc")}),H.push({source:S.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:S.$jc(ue,".zprofile")}),H.push({source:S.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:S.$jc(ue,".zshenv")}),H.push({source:S.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:S.$jc(ue,".zlogin")}),{newArgs:Z,envMixin:ee,filesToCopy:H}}}$.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.$8r=b;function u(n,i){if(k.$d&&n.environmentVariableCollections){const a=(0,w.$4r)(n.environmentVariableCollections),A=new m.$5r(a).getVariableMap({workspaceFolder:n.workspaceFolder}).get("PATH"),R=[];if(A)for(const I of A)I.type===E.EnvironmentVariableMutatorType.Prepend&&R.push(I.value);R.length>0&&(i.VSCODE_PATH_PREFIX=R.join(""))}}var g;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(g||(g={}));const h=new Map;h.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(g.Zsh,["-i"]),h.set(g.ZshLogin,["-il"]),h.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const f=["-login","-l"],l=["-nol","-nologo"];function t(n){return typeof n=="string"?f.includes(n.toLowerCase()):n.length===1&&f.includes(n[0].toLowerCase())||n.length===2&&(f.includes(n[0].toLowerCase())||f.includes(n[1].toLowerCase()))&&(l.includes(n[0].toLowerCase())||l.includes(n[1].toLowerCase()))}function r(n){return typeof n=="string"?l.includes(n.toLowerCase()):n.length===0||n?.length===1&&l.includes(n[0].toLowerCase())}function o(n){return n==="string"&&f.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&f.includes(n[0].toLowerCase())}}),define(Ee[259],ke([1,0,54,51,7,3,9,23,103,258,78]),function(le,e,y,C,s,S,k,P,v,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0;var E;(function(a){a.UnixShellsPath="/etc/shells"})(E||(E={}));let w,m=!0;function d(a,$,A,R,I=process.env,O,M,Z,ee){return O=O||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},S.$c?c(A,O,I,M,R.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:R.getValue("terminal.integrated.profiles.windows"),typeof $=="string"?$:R.getValue("terminal.integrated.defaultProfile.windows"),ee,Z):o(O,M,A,a&&typeof a=="object"?{...a}:R.getValue(S.$e?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof $=="string"?$:R.getValue(S.$e?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),ee,Z,I)}e.$9r=d;async function c(a,$,A,R,I,O,M,Z,ee){const fe=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ue=`${process.env.windir}\\${fe?"Sysnative":"System32"}`;let j=!1;(0,p.$6r)()>=16299&&(j=!0),await h(Z);const H=new Map;if(a){H.set("PowerShell",{source:"PowerShell",icon:C.$kk.terminalPowershell,isAutoDetected:!0}),H.set("Windows PowerShell",{path:`${ue}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$kk.terminalPowershell,isAutoDetected:!0}),H.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),H.set("Command Prompt",{path:`${ue}\\cmd.exe`,icon:C.$kk.terminalCmd,isAutoDetected:!0}),H.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),H.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$kk.terminalBash,isAutoDetected:!0});const J=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;H.set("Cmder",{path:`${ue}\\cmd.exe`,args:["/K",J],requiresPath:process.env.CMDER_ROOT?J:{path:J,isUnsafe:!0},isAutoDetected:!0})}n(O,H);const q=await b(H.entries(),M,$,A,R,ee);if(a&&I)try{const J=await t(`${ue}\\${j?"wsl":"bash"}.exe`,M);for(const ne of J)(!O||!(ne.profileName in O))&&q.push(ne)}catch{m&&(R?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return q}async function b(a,$,A,R=process.env,I,O){const M=[];for(const[Z,ee]of a)M.push(u(Z,ee,$,A,R,I,O));return(await Promise.all(M)).filter(Z=>!!Z)}async function u(a,$,A,R,I=process.env,O,M){if($===null)return;let Z,ee,fe;if("source"in $&&!("path"in $)){const q=w?.get($.source);if(!q)return;Z=q.paths,ee=$.args||q.args,$.icon?fe=g($.icon):q.icon&&(fe=q.icon)}else Z=Array.isArray($.path)?$.path:[$.path],ee=S.$c||Array.isArray($.args)?$.args:void 0,fe=g($.icon);let ue;if(M){const q=Z.map(ne=>typeof ne=="string"?ne:ne.path),J=await M(q);ue=new Array(Z.length);for(let ne=0;ne<Z.length;ne++)typeof Z[ne]=="string"?ue[ne]=J[ne]:ue[ne]={path:J[ne],isUnsafe:!0}}else ue=Z.slice();let j;if($.requiresPath){let q;if((0,k.$Sf)($.requiresPath)?q=$.requiresPath:(q=$.requiresPath.path,$.requiresPath.isUnsafe&&(j=q)),!await R.existsFile(q))return}const H=await i(a,A,ue,R,I,ee,$.env,$.overrideName,$.isAutoDetected,j);if(!H){O?.debug("Terminal profile not validated",a,Z);return}return H.isAutoDetected=$.isAutoDetected,H.icon=fe,H.color=$.color,H}function g(a){return typeof a=="string"?{id:a}:a}async function h(a){if(w&&!a)return;const[$,A]=await Promise.all([f(),a||l()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:$,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:A,icon:C.$kk.terminalPowershell})}async function f(){const a=new Set,$=await(0,p.$7r)("git.exe");if($){const I=(0,D.dirname)($);a.add((0,D.resolve)(I,"../.."))}function A(I,O){O&&I.add(O)}A(a,process.env.ProgramW6432),A(a,process.env.ProgramFiles),A(a,process.env["ProgramFiles(X86)"]),A(a,`${process.env.LocalAppData}\\Program`);const R=[];for(const I of a)R.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function l(){const a=[];for await(const $ of(0,v.$2l)())a.push($.exePath);return a}async function t(a,$){const A=[],R=await new Promise((M,Z)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(ee,fe)=>{if(ee)return Z("Problem occurred when getting wsl distros");M(fe)})});if(!R)return[];const I=new RegExp(/[\r?\n]/),O=R.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of O){if(M===""||M.startsWith("docker-desktop"))continue;const Z=`${M} (WSL)`,ee={profileName:Z,path:a,args:["-d",`${M}`],isDefault:Z===$,icon:r(M),isAutoDetected:!1};A.push(ee)}return A}function r(a){return a.includes("Ubuntu")?C.$kk.terminalUbuntu:a.includes("Debian")?C.$kk.terminalDebian:C.$kk.terminalLinux}async function o(a,$,A,R,I,O,M,Z){const ee=new Map;if(A&&await a.existsFile("/etc/shells")){const fe=(await a.readFile("/etc/shells")).toString(),ue=(O||fe.split(`
`)).map(H=>{const q=H.indexOf("#");return q===-1?H:H.substring(0,q)}).filter(H=>H.trim().length>0),j=new Map;for(const H of ue){let q=(0,s.$nc)(H),J=j.get(q)||0;J++,J>1&&(q=`${q} (${J})`),j.set(q,J),ee.set(q,{path:H,isAutoDetected:!0})}}return n(R,ee),await b(ee.entries(),I,a,Z,$,M)}function n(a,$){if(a)for(const[A,R]of Object.entries(a))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?$.delete(A):(R.icon=R.icon||$.get(A)?.icon,$.set(A,R))}async function i(a,$,A,R,I,O,M,Z,ee,fe){if(A.length===0)return Promise.resolve(void 0);const ue=A.shift();if(ue==="")return i(a,$,A,R,I,O,M,Z,ee);const j=typeof ue!="string"&&ue.isUnsafe,H=typeof ue=="string"?ue:ue.path,q={profileName:a,path:H,args:O,env:M,overrideName:Z,isAutoDetected:ee,isDefault:a===$,isUnsafePath:j,requiresUnsafePath:fe};if((0,s.$nc)(H)===H){const ne=I.PATH?I.PATH.split(s.$tc):void 0,x=await(0,p.$7r)(H,void 0,ne,void 0,R.existsFile);return x?(q.path=x,q.isFromPath=!0,q):i(a,$,A,R,I,O)}return await R.existsFile((0,s.$hc)(H))?q:i(a,$,A,R,I,O,M,Z,ee)}}),define(Ee[260],ke([1,0,6,2,3,43,25,13,114,88,253,91,256,259,106,63]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=void 0;var b;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let u=class extends C.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,f,l,t){super(),this.M=h,this.N=f,this.O=l,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new y.$5d),this.onPtyHostExit=this.u.event,this.w=this.B(new y.$5d),this.onPtyHostStart=this.w.event,this.y=this.B(new y.$5d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new y.$5d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new y.$5d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new y.$5d),this.onProcessData=this.D.event,this.F=this.B(new y.$5d),this.onProcessReady=this.F.event,this.G=this.B(new y.$5d),this.onProcessReplay=this.G.event,this.H=this.B(new y.$5d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new y.$5d),this.onDidRequestDetach=this.I.event,this.J=this.B(new y.$5d),this.onDidChangeProperty=this.J.event,this.L=this.B(new y.$5d),this.onProcessExit=this.L.event,(0,w.$Wr)(),this.B(this.M),this.B((0,C.$Rc)(()=>this.W())),this.j=this.B(new D.$Pr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&y.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$c)return process.env;try{return await(0,p.$lm)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),f=h.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),S.ProxyChannel.toService(f.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(r=>{this.u.fire(r.code),!this.m&&!this.q.isDisposed&&(this.n<=b.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=S.ProxyChannel.toService(f.getChannel(E.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(r=>this.D.fire(r))),this.B(t.onProcessReady(r=>this.F.fire(r))),this.B(t.onProcessExit(r=>this.L.fire(r))),this.B(t.onDidChangeProperty(r=>this.J.fire(r))),this.B(t.onProcessReplay(r=>this.G.fire(r))),this.B(t.onProcessOrphanQuestion(r=>this.H.fire(r))),this.B(t.onDidRequestDetach(r=>this.I.fire(r))),this.B(new v.$Or(this.P,f.getChannel(E.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,f,l,t,r,o,n,i,a,$,A){const R=setTimeout(()=>this.$(),E.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(h,f,l,t,r,o,n,i,a,$,A);return clearTimeout(R),I}updateTitle(h,f,l){return this.f.updateTitle(h,f,l)}updateIcon(h,f,l,t){return this.f.updateIcon(h,f,l,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,f){return this.f.detachFromProcess(h,f)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,f){return this.f.shutdown(h,f)}input(h,f){return this.f.input(h,f)}processBinary(h,f){return this.f.processBinary(h,f)}resize(h,f,l){return this.f.resize(h,f,l)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,f){return this.f.acknowledgeDataEvent(h,f)}setUnicodeVersion(h,f){return this.f.setUnicodeVersion(h,f)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new c.$1d,f=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...f]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,f){return this.f.installAutoReply(h,f)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,d.$8l)(h??s.OS,process.env)}async getProfiles(h,f,l,t=!1){const r=await this.S();return(0,m.$9r)(f,l,t,this.N,r,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,f){return this.f.getWslPath(h,f)}getRevivedPtyNewId(h,f){return this.f.getRevivedPtyNewId(h,f)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,f){return this.f.requestDetachInstance(h,f)}async acceptDetachInstanceReply(h,f){return this.f.acceptDetachInstanceReply(h,f)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,f,l){return this.f.reviveTerminalProcesses(h,f,l)}async refreshProperty(h,f){return this.f.refreshProperty(h,f)}async updateProperty(h,f,l){return this.f.updateProperty(h,f,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?E.HeartbeatConstants.ConnectingBeatInterval:E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,f){return this.j.createRequest({workspaceId:h,originalText:f})}async acceptPtyHostResolvedVariables(h,f){this.j.acceptReply(h,f)}};e.$0r=u,e.$0r=u=Le([Ne(1,k.$Ki),Ne(2,P.$yj),Ne(3,P.$zj)],u)}),define(Ee[34],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=void 0,e.$_k=(0,y.$ei)("IUriIdentityService")}),define(Ee[125],ke([1,0,34,110,16,19,149,6,2]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;class p{constructor(w){this.uri=w,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let D=class{constructor(w){this.g=w,this.c=new v.$Sc,this.f=2**16;const m=new Map,d=c=>{let b=m.get(c.scheme);return b===void 0&&(b=w.hasProvider(c)&&!this.g.hasCapability(c,1024),m.set(c.scheme,b)),b};this.c.add(P.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(c=>{m.delete(c.scheme)})),this.extUri=new S.$Gg(d),this.d=new k.$as((c,b)=>this.extUri.compare(c,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,S.$Sg)(w));const m=this.d.get(w);return m?m.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new p(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((d,c)=>d[1].time<c[1].time?1:d[1].time>c[1].time?-1:0);p._clock=0,this.d.clear();const m=this.f*.5;for(let d=0;d<m;d++)this.d.set(w[d][0],w[d][1].touch())}};e.$bs=D,e.$bs=D=Le([Ne(0,s.$Bk)],D),(0,C.$$r)(y.$_k,D,1)}),define(Ee[92],ke([1,0,201,7,66,19,4,5,12]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,P.$ei)("contextService");function p(n){const i=n;return typeof i?.id=="string"&&k.URI.isUri(i.uri)}e.$oi=p;function D(n){return typeof n?.id=="string"&&!p(n)&&!w(n)}e.$pi=D,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function E(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,C.$nc)(n)}:i?e.$qi:e.$ri;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$si=E;function w(n){const i=n;return typeof i?.id=="string"&&k.URI.isUri(i.configPath)}e.$ti=w;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:k.URI.revive(i.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:k.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.$ui=m;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function c(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$vi=c;function b(n){const i=n;return!!(i&&typeof i=="object"&&k.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$wi=b;class u{constructor(i,a,$,A,R){this.h=i,this.j=$,this.k=A,this.l=R,this.c=s.$ki.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=s.$ki.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=u;class g{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,S.$Rg)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=g;function h(n){return new g({uri:n,index:0,name:(0,S.$Ng)(n)},{uri:n.toString()})}e.$zi=h,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,y.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function f(n,i){return S.$Ig.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$Ei=f;function l(n){let i;return k.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===v.Schemas.tmp}e.$Fi=l,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Gi}e.$Hi=t;function r(n,i){return!f(n,i)&&!l(n)}e.$Ii=r;function o(n){return(typeof n=="string"?(0,C.$oc)(n):(0,S.$Pg)(n))===e.$Bi}e.$Ji=o}),define(Ee[33],ke([1,0,64,6,2,19,4,200,26,16,5,13,92,24,34,15,22,17,9]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.ProfileResourceType=void 0;var h;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function f(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&k.URI.isUri(i.location)&&k.URI.isUri(i.globalStorageHome)&&k.URI.isUri(i.settingsResource)&&k.URI.isUri(i.keybindingsResource)&&k.URI.isUri(i.tasksResource)&&k.URI.isUri(i.snippetsHome)&&k.URI.isUri(i.extensionsResource))}e.$al=f,e.$bl=(0,D.$ei)("IUserDataProfilesService");function l(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:k.URI.revive(n.location).with({scheme:i}),globalStorageHome:k.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:k.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:k.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:k.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:k.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:k.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:k.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$cl=l;function t(n,i,a,$,A,R){return{id:n,name:i,location:a,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:R&&A?.useDefaultFlags?.globalState?R.globalStorageHome:(0,S.$Rg)(a,"globalStorage"),settingsResource:R&&A?.useDefaultFlags?.settings?R.settingsResource:(0,S.$Rg)(a,"settings.json"),keybindingsResource:R&&A?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,S.$Rg)(a,"keybindings.json"),tasksResource:R&&A?.useDefaultFlags?.tasks?R.tasksResource:(0,S.$Rg)(a,"tasks.json"),snippetsHome:R&&A?.useDefaultFlags?.snippets?R.snippetsHome:(0,S.$Rg)(a,"snippets"),extensionsResource:R&&A?.useDefaultFlags?.extensions?R.extensionsResource:(0,S.$Rg)(a,"extensions.json"),cacheHome:(0,S.$Rg)($,n),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$dl=t;let r=class extends s.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,a,$,A){super(),this.t=i,this.u=a,this.w=$,this.y=A,this.f=!0,this.h=this.B(new C.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Ac,emptyWindows:new Map},this.profilesHome=(0,S.$Rg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,S.$Rg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),a=[i];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,g.$Sf)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}a.push(t((0,S.$Og)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},i))}}catch(R){this.y.error(R)}const $=new m.$Ac,A=new Map;if(a.length)try{const R=this.Q();if(R.workspaces)for(const[I,O]of Object.entries(R.workspaces)){const M=k.URI.parse(I),Z=a.find(ee=>ee.id===O);Z&&$.set(M,Z)}if(R.emptyWindows)for(const[I,O]of Object.entries(R.emptyWindows)){const M=a.find(Z=>Z.id===O);M&&A.set(I,M)}}catch(R){this.y.error(R)}this.z={profiles:a,workspaces:$,emptyWindows:A}}return this.z}D(){const i=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const a="Temp",$=new RegExp(`${(0,u.$Xe)(a)}\\s(\\d+)`);let A=0;for(const I of this.profiles){const O=$.exec(I.name),M=O?parseInt(O[1]):0;A=M>A?M:A}const R=`${a} ${A+1}`;return this.createProfile((0,y.$5i)((0,b.$Ag)()).toString(16),R,{transient:!0},i)}async createNamedProfile(i,a,$){return this.createProfile((0,y.$5i)((0,b.$Ag)()).toString(16),i,a,$)}async createProfile(i,a,$,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(i,a,$);return A&&await this.setProfileForWorkspace(A,R),R}async F(i,a,$){if(!(0,g.$Sf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(a);return A||(A=(async()=>{try{const R=this.profiles.find(M=>M.name===a||M.id===i);if(R)return R;const I=t(i,a,(0,S.$Rg)(this.profilesHome,i),this.g,$,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(M){O.push(M)}}),await c.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(a)}})(),this.r.set(a,A)),A}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(A=>A.id===i.id);if(!$)throw new Error(`Profile '${i.name}' does not exist`);return $=t($.id,a.name??$.name,$.location,this.g,{shortName:a.shortName??$.shortName,icon:a.icon===null?void 0:a.icon??$.icon,transient:a.transient??$.isTransient,useDefaultFlags:a.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(A=>A.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const $=[];this.m.fire({profile:a,join(A){$.push(A)}});try{await Promise.allSettled($)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(A){(0,p.$Sk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(A=>A.id===a.id);if(!$)throw new Error(`Profile '${a.name}' does not exist`);this.L(i,$)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.G(i);return k.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(i){return(0,w.$oi)(i)?i.uri:(0,w.$ti)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,i.location)))}I(i,a,$){const A=[...this.profiles,...i],R=[];this.s.profiles=[];for(let I of A)I.isDefault||a.some(O=>I.id===O.id)||(I=$.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):R.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(R),this.z=void 0,this.J(i,a,$)}J(i,a,$){this.h.fire({added:i,removed:a,updated:$,all:this.profiles})}L(i,a,$){$=a?.isTransient?!0:$,$||this.L(i,void 0,!0);const A=this.G(i),R=$?this.s:this.C;k.URI.isUri(A)?(R.workspaces.delete(A),a&&R.workspaces.set(A,a)):(R.emptyWindows.delete(A),a&&R.emptyWindows.set(A,a)),$||this.M()}M(){const i={};for(const[$,A]of this.C.workspaces.entries())i[$.toString()]=A.id;const a={};for(const[$,A]of this.C.emptyWindows.entries())a[$.toString()]=A.id;this.R({workspaces:i,emptyWindows:a}),this.z=void 0}N(i){const a={},$=this.D();if(i.workspaces)for(const[R,I]of Object.entries(i.workspaces)){const O=k.URI.parse(I);a[R]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}const A={};if(i.emptyWindows)for(const[R,I]of Object.entries(i.emptyWindows)){const O=k.URI.parse(I);A[R]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}return{workspaces:a,emptyWindows:A}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$el=r,r.b="userDataProfiles",r.c="profileAssociations",e.$el=r=Le([Ne(0,v.$li),Ne(1,p.$Bk),Ne(2,d.$_k),Ne(3,E.$yj)],r);class o extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$fl=o}),define(Ee[261],ke([1,0,18,15,20,8,6,2,3,9,4,181,30,36,35,13,31,32,34,33]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=void 0;let f=class extends P.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,a,$,A,R,I){super(),this.z=i,this.C=a,this.D=$,this.F=A,this.G=R,this.H=I,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new k.$5d),this.s=this.B(new k.$5d),this.t=this.B(new k.$5d),this.u=this.B(new k.$5d),this.w=this.B(new k.$5d),this.y=[],this.B((0,P.$Rc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const a=await this.getTargetPlatform();return i.allTargetPlatforms.some($=>(0,w.$Jo)($,i.allTargetPlatforms,a))}async installFromGallery(i,a={}){try{const A=(await this.installGalleryExtensions([{extension:i,options:a}])).find(({identifier:R})=>(0,m.$ap)(R,i.identifier));if(A?.local)return A?.local;throw A?.error?A.error:new w.$Mo(`Unknown error while installing extension ${i.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch($){throw t($)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new w.$Mo(E.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const a=[],$=[];await Promise.allSettled(i.map(async({extension:A,options:R})=>{try{const I=await this.N(A,!!R?.installGivenVersion,!!R?.installPreReleaseVersion);$.push({...I,options:R})}catch(I){a.push({identifier:A.identifier,operation:2,source:A,error:I})}})),$.length&&a.push(...await this.I($));for(const A of a)A.error&&(this.F.error("Failed to install extension.",A.identifier.id),this.F.error(A.error),A.source&&!D.URI.isUri(A.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,m.$ip)(A.source),error:A.error}));return a}async uninstall(i,a={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,a)}async toggleAppliationScope(i,a){if((0,d.$Am)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let $=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||($=await this.$(i,this.H.defaultProfile.extensionsResource,a));for(const A of this.H.profiles){const R=(await this.getInstalled(1,A.extensionsResource)).find(I=>(0,m.$ap)(I.identifier,i.identifier));R?this.w.fire(R):this.u.fire({identifier:i.identifier,profileLocation:A.extensionsResource})}return $}else{const $=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:$.identifier,operation:2,local:$,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),$}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const a=[],$=new Map,A=[],R=[],I=(M,Z)=>`${m.$bp.create(M).toString()}-${Z.toString()}`,O=(M,Z,ee)=>{const fe=this.Y(M,Z,ee),ue=D.URI.isUri(Z)?Z.path:`${Z.identifier.id.toLowerCase()}-${ee.profileLocation.toString()}`;$.set(ue,{task:fe,manifest:M}),this.n.fire({identifier:fe.identifier,source:Z,profileLocation:ee.profileLocation}),this.F.info("Installing extension:",fe.identifier.id),D.URI.isUri(Z)||this.j.set(I(Z,ee.profileLocation),{task:fe,waitingTasks:[]})};try{for(const{manifest:M,extension:Z,options:ee}of i){const fe=ee.isApplicationScoped||ee.isBuiltin||(0,d.$Am)(M),ue={...ee,installOnlyNewlyAddedFromExtensionPack:D.URI.isUri(Z)?ee.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:fe,profileLocation:fe?this.H.defaultProfile.extensionsResource:ee.profileLocation??this.X()},j=D.URI.isUri(Z)?void 0:this.j.get(I(Z,ue.profileLocation));j?(this.F.info("Extension is already requested to install",j.task.identifier.id),A.push(j.task.waitUntilTaskIsFinished())):O(M,Z,ue)}await Promise.all([...$.values()].map(async({task:M,manifest:Z})=>{if(M.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const ee=await this.M(M.identifier,Z,!!M.options.installOnlyNewlyAddedFromExtensionPack,!!M.options.installPreReleaseVersion,M.options.profileLocation),fe=await this.getInstalled(void 0,M.options.profileLocation),ue={...M.options,donotIncludePackAndDependencies:!0,context:{...M.options.context,[w.$Eo]:!0}};for(const{gallery:j,manifest:H}of(0,y.$Mb)(ee,({gallery:q})=>q.identifier.id)){if($.has(`${j.identifier.id.toLowerCase()}-${ue.profileLocation.toString()}`))continue;const q=this.j.get(I(j,ue.profileLocation));if(q){if(this.J(M,q.task)){const J=q.task.identifier;this.F.info("Waiting for already requested installing extension",J.id,M.identifier.id),q.waitingTasks.push(M),A.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,ne=>ne.some(x=>(0,m.$ap)(x.identifier,J)))).then(ne=>{if(this.F.info("Finished waiting for already requested installing extension",J.id,M.identifier.id),!ne.find(G=>(0,m.$ap)(G.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else fe.some(({identifier:J})=>(0,m.$ap)(J,j.identifier))||O(H,j,ue)}}catch(ee){if(D.URI.isUri(M.source))(0,y.$Lb)(Z.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",M.identifier.id,ee.message),(0,y.$Lb)(Z.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",M.identifier.id,ee.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),ee}})),await this.L([...$.values()].map(async({task:M})=>{const Z=new Date().getTime();try{const ee=await M.run();if(await this.L(this.y.map(fe=>fe.postInstall(ee,M.source,M.options,s.CancellationToken.None))),!D.URI.isUri(M.source)){const fe=M.operation===3,ue=fe?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(r(this.C,fe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$ip)(M.source),verificationStatus:M.verificationStatus,duration:new Date().getTime()-Z,durationSinceUpdate:ue}),v.$i&&M.operation!==3)try{await this.z.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch{}}R.push({local:ee,identifier:M.identifier,operation:M.operation,source:M.source,context:M.options.context,profileLocation:M.profileLocation,applicationScoped:ee.isApplicationScoped})}catch(ee){throw this.F.error("Error while installing the extension",M.identifier.id,(0,S.$0)(ee)),ee}})),A.length&&await this.L(A);for(const M of R)this.F.info("Extension installed successfully:",M.identifier.id),a.push(M);return a}catch(M){R.length&&await Promise.allSettled(R.map(async({local:Z,profileLocation:ee})=>{try{await this.Z(Z,{versionOnly:!0,profileLocation:ee}).run(),this.F.info("Rollback: Uninstalled extension",Z.identifier.id)}catch(fe){this.F.warn("Rollback: Error while uninstalling extension",Z.identifier.id,(0,S.$0)(fe))}}));for(const{task:Z}of $.values())Z.cancel(),a.push({identifier:Z.identifier,operation:2,source:Z.source,context:Z.options.context,profileLocation:Z.profileLocation,error:M});throw M}finally{for(const{task:M}of $.values())M.source&&!D.URI.isUri(M.source)&&this.j.delete(I(M.source,M.profileLocation));a.length&&this.s.fire(a)}}J(i,a){for(const[,{task:$,waitingTasks:A}]of this.j.entries())if($===i&&(A.includes(a)||A.some(R=>this.J(R,a)))||$===a&&A[0]&&!this.J(i,A[0]))return!1;return!0}async L(i){const a=[],$=[],A=await Promise.allSettled(i);for(const R of A)R.status==="fulfilled"?a.push(R.value):$.push(R.reason);if($.length)throw l($);return a}async M(i,a,$,A,R){if(!this.z.isEnabled())return[];const I=await this.getInstalled(void 0,R),O=[],M=[],Z=async(ee,fe)=>{O.push(ee);const ue=fe.extensionDependencies||[],j=[...ue];if(fe.extensionPack){const H=$?I.find(q=>(0,m.$ap)(q.identifier,ee)):void 0;for(const q of fe.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(J=>(0,m.$ap)({id:J},{id:q}))||j.every(J=>!(0,m.$ap)({id:J},{id:q}))&&j.push(q)}if(j.length){const H=j.filter(q=>O.every(J=>!(0,m.$ap)(J,{id:q})));if(H.length){const q=await this.z.getExtensions(H.map(J=>({id:J,preRelease:A})),s.CancellationToken.None);for(const J of q){if(O.find(G=>(0,m.$ap)(G,J.identifier)))continue;const ne=ue.some(G=>(0,m.$ap)({id:G},J.identifier));let x;try{x=await this.N(J,!1,A)}catch(G){if(ne)throw G;this.F.info("Skipping the packed extension as it cannot be installed",J.identifier.id,(0,S.$0)(G));continue}M.push({gallery:x.extension,manifest:x.manifest}),await Z(x.extension.identifier,x.manifest)}}}};return await Z(i,a),M}async N(i,a,$){let A;const R=await this.getExtensionsControlManifest();if(R.malicious.some(M=>(0,m.$ap)(i.identifier,M)))throw new w.$Mo(E.localize(1,null,i.identifier.id),w.ExtensionManagementErrorCode.Malicious);const I=R.deprecated[i.identifier.id.toLowerCase()];if(I?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${I.extension.id}' extension instead.`),A=(await this.z.getExtensions([{id:I.extension.id,preRelease:I.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},s.CancellationToken.None))[0],!A)throw new w.$Mo(E.localize(2,null,i.identifier.id,I.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const M=await this.getTargetPlatform();throw new w.$Mo(E.localize(3,null,i.identifier.id,this.G.nameLong,(0,w.$Fo)(M)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(A=await this.O(i,a,$),!A)throw!$&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],s.CancellationToken.None))[0]?new w.$Mo(E.localize(4,null,i.displayName??i.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$Mo(E.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",A.identifier.id);const O=await this.z.getManifest(A,s.CancellationToken.None);if(O===null)throw new w.$Mo(`Missing manifest for extension ${A.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(O.version!==A.version)throw new w.$Mo(`Cannot install '${A.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:O}}async O(i,a,$){const A=await this.getTargetPlatform();let R=null;return!a&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==$&&(R=(await this.z.getExtensions([{...i.identifier,preRelease:$}],{targetPlatform:A,compatible:!0},s.CancellationToken.None))[0]||null),!R&&await this.z.isExtensionCompatible(i,$,A)&&(R=i),R||(a?R=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:A,compatible:!0},s.CancellationToken.None))[0]||null:R=await this.z.getCompatibleExtension(i,$,A)),R}async P(i,a){const $={...a,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.X()},A=ee=>`${ee.id.toLowerCase()}${$.versionOnly?`-${i.manifest.version}`:""}${$.profileLocation?`@${$.profileLocation.toString()}`:""}`,R=this.m.get(A(i.identifier));if(R)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),R.waitUntilTaskIsFinished();const I=ee=>{const fe=this.Z(ee,$);return this.m.set(A(fe.extension.identifier),fe),$.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,$.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.t.fire({identifier:ee.identifier,profileLocation:$.profileLocation,applicationScoped:ee.isApplicationScoped}),fe},O=(ee,fe)=>{fe?$.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,$.profileLocation.toString(),fe.message):this.F.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,fe.message):$.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,$.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$hp)(ee),error:fe}),this.u.fire({identifier:ee.identifier,error:fe?.code,profileLocation:$.profileLocation,applicationScoped:ee.isApplicationScoped})},M=[],Z=[];try{M.push(I(i));const ee=await this.getInstalled(1,$.profileLocation);if($.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const fe=this.S(i,ee);for(const ue of fe)this.m.has(A(ue.identifier))?this.F.info("Extensions is already requested to uninstall",ue.identifier.id):M.push(I(ue))}$.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(M.map(fe=>fe.extension),ee,i),await this.L(M.map(async fe=>{try{if(await fe.run(),await this.L(this.y.map(ue=>ue.postUninstall(fe.extension,$,s.CancellationToken.None))),fe.extension.identifier.uuid)try{await this.z.reportStatistic(fe.extension.manifest.publisher,fe.extension.manifest.name,fe.extension.manifest.version,"uninstall")}catch{}O(fe.extension)}catch(ue){const j=ue instanceof w.$Mo?ue:new w.$Mo((0,S.$0)(ue),w.ExtensionManagementErrorCode.Internal);throw O(fe.extension,j),j}finally{Z.push(fe)}}))}catch(ee){const fe=ee instanceof w.$Mo?ee:new w.$Mo((0,S.$0)(ee),w.ExtensionManagementErrorCode.Internal);for(const ue of M){try{ue.cancel()}catch{}Z.includes(ue)||O(ue.extension,fe)}throw fe}finally{for(const ee of M)this.m.delete(A(ee.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}Q(i,a,$){for(const A of i){const R=this.U(A,a);if(R.length){const I=R.filter(O=>!i.some(M=>(0,m.$ap)(M.identifier,O.identifier)));if(I.length)throw new Error(this.R(A,I,$))}}}R(i,a,$){return $===i?a.length===1?E.localize(6,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(7,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(8,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(9,null,$.manifest.displayName||$.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(10,null,$.manifest.displayName||$.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(11,null,$.manifest.displayName||$.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}S(i,a,$=[]){if($.indexOf(i)!==-1)return[];$.push(i);const A=i.manifest.extensionPack?i.manifest.extensionPack:[];if(A.length){const R=a.filter(O=>!O.isBuiltin&&A.some(M=>(0,m.$ap)({id:M},O.identifier))),I=[];for(const O of R)I.push(...this.S(O,a,$));return[...R,...I]}return[]}U(i,a){return a.filter($=>$.manifest.extensionDependencies&&$.manifest.extensionDependencies.some(A=>(0,m.$ap)({id:A},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,S.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$3p=f,e.$3p=f=Le([Ne(0,w.$Lo),Ne(1,u.$Fl),Ne(2,g.$_k),Ne(3,c.$yj),Ne(4,b.$Qj),Ne(5,h.$bl)],f);function l(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,$)=>new Error(`${a.message}${a.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}e.$4p=l;function t(n){if(n instanceof w.$Mo)return n;if(n instanceof w.$No){const a=new w.$Mo(n.message,w.ExtensionManagementErrorCode.Gallery);return a.stack=n.stack,a}const i=new w.$Mo(n.message,w.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$5p=t;function r(n,i,{extensionData:a,verificationStatus:$,duration:A,error:R,durationSinceUpdate:I}){let O,M;(0,p.$1f)($)&&($===!0?$="Verified":($===!1||(O=w.ExtensionManagementErrorCode.Signature,M=$),$="Unverified")),R&&(R instanceof w.$Mo||R instanceof w.$No?(O=R.code,R.code===w.ExtensionManagementErrorCode.Signature&&(M=R.message)):O=w.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...a,verificationStatus:$,success:!R,duration:A,errorcode:O,errorcodeDetail:M,durationSinceUpdate:I})}class o{constructor(){this.d=new C.$dh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,C.$4g)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,C.$4g)(i=>new Promise((a,$)=>{const A=i.onCancellationRequested(()=>{A.dispose(),$(new S.$5)})})),this.d.open()),this.g.cancel()}}e.$6p=o}),define(Ee[47],ke([1,0,15,14,2,6,24,4,30,36,16,5,13,33,34,9,8,32]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class h extends Error{constructor(o,n){super(o),this.code=n}}e.$7p=h,e.$8p=(0,E.$ei)("IExtensionsProfileScannerService");let f=class extends s.$Tc{constructor(o,n,i,a,$,A){super(),this.j=o,this.m=n,this.n=i,this.r=a,this.s=$,this.t=A,this.b=this.B(new S.$5d),this.onAddExtensions=this.b.event,this.c=this.B(new S.$5d),this.onDidAddExtensions=this.c.event,this.f=this.B(new S.$5d),this.onRemoveExtensions=this.f.event,this.g=this.B(new S.$5d),this.onDidRemoveExtensions=this.g.event,this.h=new k.$Ac}scanProfileExtensions(o,n){return this.u(o,void 0,n)}async addExtensionsToProfile(o,n){const i=[],a=[];try{return await this.u(n,$=>{const A=[];for(const R of $)o.some(([I])=>(0,p.$ap)(I.identifier,R.identifier)&&I.manifest.version!==R.version)?i.push(R):A.push(R);for(const[R,I]of o){const O=A.findIndex(Z=>(0,p.$ap)(Z.identifier,R.identifier)&&Z.version===R.manifest.version),M={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:I};O===-1?(a.push(M),A.push(M)):A.splice(O,1,M)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),A}),a.length&&this.c.fire({extensions:a,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),a}catch($){throw a.length&&this.c.fire({extensions:a,error:$,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:$,profileLocation:n}),$}}async updateMetadata(o,n){const i=[];return await this.u(n,a=>{const $=[];for(const A of a){const R=o.find(([I])=>(0,p.$ap)(I.identifier,A.identifier)&&I.manifest.version===A.version);R&&(A.metadata={...A.metadata,...R[1]},i.push(A)),$.push(A)}return $}),i}async removeExtensionFromProfile(o,n){const i=[];try{await this.u(n,a=>{const $=[];for(const A of a)(0,p.$ap)(A.identifier,o.identifier)?i.push(A):$.push(A);return i.length&&this.f.fire({extensions:i,profileLocation:n}),$}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(a){throw i.length&&this.g.fire({extensions:i,error:a,profileLocation:n}),a}}async u(o,n,i){return this.F(o).queue(async()=>{let a=[],$;try{const A=await this.m.readFile(o);$=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,D.$Sk)(A)!==1)throw A;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&($=await this.D()),!$&&i?.bailOutWhenFileNotFound)throw new h((0,b.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if($){Array.isArray($)||this.w(o);let A=!1;for(const R of $){l(R)||this.w(o);let I;if((0,c.$Sf)(R.relativeLocation)&&R.relativeLocation)I=this.z(R.relativeLocation);else if((0,c.$Sf)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{I=P.URI.revive(R.location);const O=this.y(I);O&&(A=!0,R.relativeLocation=O)}(0,c.$Zf)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(A=!0,R.metadata.hasPreReleaseVersion=!0),a.push({identifier:R.identifier,location:I,version:R.version,metadata:R.metadata})}A&&await this.m.writeFile(o,C.$se.fromString(JSON.stringify($)))}if(n){a=n(a);const A=a.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(o,C.$se.fromString(JSON.stringify(A)))}return a})}w(o){const n=new h(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(o)).value.toString()}catch($){if((0,D.$Sk)($)===1)return;throw $}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const $=JSON.parse(i);Array.isArray($)&&$.every(A=>l(A))?a=$:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",$)}catch($){this.t.error($)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$se.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch($){if((0,D.$Sk)($)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw $}try{await this.m.del(o)}catch($){(0,D.$Sk)($)!==1&&this.t.error($)}try{await this.m.del(n)}catch($){(0,D.$Sk)($)!==1&&this.t.error($)}return a})()),this.C}F(o){let n=this.h.get(o);return n||(n=new y.$lh,this.h.set(o,n)),n}};e.$9p=f,e.$9p=f=Le([Ne(1,D.$Bk),Ne(2,m.$bl),Ne(3,d.$_k),Ne(4,u.$Fl),Ne(5,w.$yj)],f);function l(r){return(0,c.$Uf)(r)&&(0,v.$Ko)(r.identifier)&&(t(r.location)||(0,c.$Sf)(r.location)&&r.location)&&((0,c.$Zf)(r.relativeLocation)||(0,c.$Sf)(r.relativeLocation))&&r.version&&(0,c.$Sf)(r.version)}function t(r){return r?(0,c.$Sf)(r.path)&&(0,c.$Sf)(r.scheme):!1}}),define(Ee[59],ke([1,0,18,15,21,14,8,41,172,2,12,7,3,19,55,65,9,4,185,26,36,35,82,16,5,13,31,6,52,47,33,34,215]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r,o,n,i,a,$,A,R,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.Translations=void 0;var M;(function(q){function J(ne,x){if(ne===x)return!0;const G=Object.keys(ne),se=new Set;for(const ce of Object.keys(x))se.add(ce);if(G.length!==se.size)return!1;for(const ce of G){if(ne[ce]!==x[ce])return!1;se.delete(ce)}return se.size===0}q.equals=J})(M||(e.Translations=M={})),e.$_p=(0,o.$ei)("IExtensionsScannerService");let Z=class extends p.$Tc{constructor(J,ne,x,G,se,ce,re,ge,B,W,F,z){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=ne,this.r=x,this.s=G,this.t=se,this.u=ce,this.w=re,this.y=ge,this.z=B,this.C=W,this.D=F,this.F=z,this.g=this.B(new a.$5d),this.onDidChangeCache=this.g.event,this.h=(0,m.$Rg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ue,this.s,this.h)),this.m=this.B(this.F.createInstance(ue,this.s,this.h)),this.n=this.B(this.F.createInstance(fe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,f.$lp)(this.w,this.y)),this.G}async scanAllExtensions(J,ne,x){const[G,se]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(ne)]),ce=x?await this.scanExtensionsUnderDevelopment(J,[...G,...se]):[];return this.L(G,se,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const ne=[];ne.push(this.M(!!J.useCache,J.language)),ne.push(this.N(J.language,!!J.checkControlFile));const[x,G]=await Promise.all(ne);return this.J([...x,...G],0,J,!1)}async scanUserExtensions(J){const ne=J.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ne);const x=this.D.extUri.isEqual(J.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,G=await this.P(ne,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,x),se=J.useCache&&!G.devMode&&G.excludeObsolete?this.m:this.n;let ce;try{ce=await se.scanExtensions(G)}catch(re){if(re instanceof A.$7p&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ce=await se.scanExtensions(G);else throw re}return ce=await this.J(ce,1,J,!0),this.y.trace("Scanned user extensions:",ce.length),ce}async scanExtensionsUnderDevelopment(J,ne){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const x=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(G=>G.scheme===D.Schemas.file).map(async G=>{const se=await this.P(G,!1,1,!0,J.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(se)).map(re=>(re.type=ne.find(ge=>(0,f.$ap)(ge.identifier,re.identifier))?.type??re.type,this.n.validate(re,se)))}))).flat();return this.J(x,"development",J,!0)}return[]}async scanExistingExtension(J,ne,x){const G=await this.P(J,!1,ne,!0,x.language,!0,void 0),se=await this.n.scanExtension(G);return!se||!x.includeInvalid&&!se.isValid?null:se}async scanOneOrMultipleExtensions(J,ne,x){const G=await this.P(J,!1,ne,!0,x.language,!0,void 0),se=await this.n.scanOneOrMultipleExtensions(G);return this.J(se,ne,x,!0)}async scanMetadata(J){const ne=(0,m.$Rg)(J,"package.json"),x=(await this.w.readFile(ne)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(J,ne){const x=(0,m.$Rg)(J,"package.json"),G=(await this.w.readFile(x)).value.toString(),se=JSON.parse(G);ne.isMachineScoped===!1&&delete ne.isMachineScoped,ne.isBuiltin===!1&&delete ne.isBuiltin,se.__metadata={...se.__metadata,...ne},await this.w.writeFile((0,m.$Rg)(J,"package.json"),S.$se.fromString(JSON.stringify(se,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof A.$7p&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw J}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.u.addExtensionsToProfile(J.map(ne=>[ne,ne.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,S.$se.fromString(JSON.stringify([])))}catch(ne){(0,r.$Sk)(ne)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.$0)(ne))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.y.error(J)}finally{this.H=void 0}})()),this.H}async J(J,ne,x,G){return x.includeAllVersions||(J=this.L(ne===0?J:void 0,ne===1?J:void 0,ne==="development"?J:void 0,await this.getTargetPlatform(),G)),x.includeInvalid||(J=J.filter(se=>se.isValid)),J.sort((se,ce)=>{const re=E.$nc(se.location.fsPath),ge=E.$nc(ce.location.fsPath);return re<ge?-1:re>ge?1:0})}L(J,ne,x,G,se){const ce=(ge,B,W)=>{if(ge.isValid&&!B.isValid)return!1;if(ge.isValid===B.isValid){if(se&&d.gt(ge.manifest.version,B.manifest.version))return this.y.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${ge.location.path} with version ${ge.manifest.version}`),!1;if(d.eq(ge.manifest.version,B.manifest.version)){if(ge.type===0)return this.y.debug(`Skipping extension ${B.location.path} in favour of system extension ${ge.location.path} with same version`),!1;if(ge.targetPlatform===G)return this.y.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return W?this.y.warn(`Overwriting user extension ${ge.location.path} with ${B.location.path}.`):this.y.debug(`Overwriting user extension ${ge.location.path} with ${B.location.path}.`),!0},re=new l.$zm;return J?.forEach(ge=>{const B=re.get(ge.identifier.id);(!B||ce(B,ge,!1))&&re.set(ge.identifier.id,ge)}),ne?.forEach(ge=>{const B=re.get(ge.identifier.id);if(!B&&J&&ge.type===0){this.y.debug(`Skipping obsolete system extension ${ge.location.path}.`);return}(!B||ce(B,ge,!1))&&re.set(ge.identifier.id,ge)}),x?.forEach(ge=>{const B=re.get(ge.identifier.id);(!B||ce(B,ge,!0))&&re.set(ge.identifier.id,ge),re.set(ge.identifier.id,ge)}),[...re.values()]}async M(J,ne){this.y.trace("Started scanning system extensions");const x=await this.P(this.systemExtensionsLocation,!1,0,!0,ne,!0,void 0),se=await(J&&!x.devMode?this.j:this.n).scanExtensions(x);return this.y.trace("Scanned system extensions:",se.length),se}async N(J,ne){const x=this.z.isBuilt?[]:this.C.builtInExtensions;if(!x?.length)return[];this.y.trace("Started scanning dev system extensions");const G=ne?await this.O():{},se=[],ce=u.URI.file(E.$hc(E.$jc(D.$yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ge of x){const B=G[ge.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":se.push((0,m.$Rg)(ce,ge.name));break;default:se.push(u.URI.file(B));break}}const re=await Promise.all(se.map(async ge=>this.n.scanExtension(await this.P(ge,!1,0,!0,J,!0,void 0))));return this.y.trace("Scanned dev system extensions:",re.length),(0,y.$Hb)(re)}async O(){try{const J=await this.w.readFile(this.r);return JSON.parse(J.value.toString())}catch{return{}}}async P(J,ne,x,G,se,ce,re){const ge=await this.f(se??w.$q),B=await this.Q(J),W=ne&&!this.D.extUri.isEqual(J,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=W?await this.Q(W):void 0;return new ee(J,B,W,F,ne,re,x,G,ce,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,se,ge)}async Q(J){try{const ne=await this.w.stat(J);if(typeof ne.mtime=="number")return ne.mtime}catch{}}};e.$aq=Z,e.$aq=Z=Le([Ne(4,R.$bl),Ne(5,A.$8p),Ne(6,r.$Bk),Ne(7,n.$yj),Ne(8,h.$li),Ne(9,i.$Qj),Ne(10,I.$_k),Ne(11,o.$di)],Z);class ee{constructor(J,ne,x,G,se,ce,re,ge,B,W,F,z,_,Q,K){this.location=J,this.mtime=ne,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=G,this.profile=se,this.profileScanOptions=ce,this.type=re,this.excludeObsolete=ge,this.validate=B,this.productVersion=W,this.productDate=F,this.productCommit=z,this.devMode=_,this.language=Q,this.translations=K}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,ne){return(0,m.$Kg)(J.location,ne.location)&&J.mtime===ne.mtime&&(0,m.$Kg)(J.applicationExtensionslocation,ne.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===ne.applicationExtensionslocationMtime&&J.profile===ne.profile&&s.$Mn(J.profileScanOptions,ne.profileScanOptions)&&J.type===ne.type&&J.excludeObsolete===ne.excludeObsolete&&J.validate===ne.validate&&J.productVersion===ne.productVersion&&J.productDate===ne.productDate&&J.productCommit===ne.productCommit&&J.devMode===ne.devMode&&J.language===ne.language&&M.equals(J.translations,ne.translations)}}e.$bq=ee;let fe=class extends p.$Tc{constructor(J,ne,x,G,se){super(),this.f=J,this.g=ne,this.h=x,this.j=G,this.m=se}async scanExtensions(J){const ne=J.profile?await this.r(J):await this.n(J);let x={};if(J.excludeObsolete&&J.type===1)try{const G=(await this.j.readFile(this.f)).value.toString();x=JSON.parse(G)}catch{}return(0,b.$6f)(x)?ne:ne.filter(G=>!x[f.$bp.create(G).toString()])}async n(J){const ne=await this.j.resolve(J.location);if(!ne.children?.length)return[];const x=await Promise.all(ne.children.map(async G=>{if(!G.isDirectory||J.type===1&&(0,m.$Og)(G.resource).indexOf(".")===0)return null;const se=new ee(G.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(se)}));return(0,y.$Hb)(x).sort((G,se)=>G.location.path<se.location.path?-1:1)}async r(J){let ne=await this.s(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){ne=ne.filter(G=>!G.metadata?.isApplicationScoped);const x=await this.s(J.applicationExtensionslocation,G=>!!G.metadata?.isBuiltin||!!G.metadata?.isApplicationScoped,J);ne.push(...x)}return ne}async s(J,ne,x){const G=await this.g.scanProfileExtensions(J,x.profileScanOptions);if(!G.length)return[];const se=await Promise.all(G.map(async ce=>{if(ne(ce)){const re=new ee(ce.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(re,ce.metadata)}return null}));return(0,y.$Hb)(se)}async scanOneOrMultipleExtensions(J){try{if(await this.j.exists((0,m.$Rg)(J.location,"package.json"))){const ne=await this.scanExtension(J);return ne?[ne]:[]}else return await this.scanExtensions(J)}catch(ne){return this.m.error(`Error scanning extensions at ${J.location.path}:`,(0,k.$0)(ne)),[]}}async scanExtension(J,ne){try{let x=await this.scanExtensionManifest(J.location);if(x){x.publisher||(x.publisher=l.$tm),ne=ne??x.__metadata,delete x.__metadata;const G=(0,f.$fp)(x.publisher,x.name),se=ne?.id?{id:G,uuid:ne.id}:{id:G},ce=ne?.isSystem?0:J.type,re=ce===0||!!ne?.isBuiltin;x=await this.t(J.location,x,ee.createNlsConfiguration(J));const ge={type:ce,identifier:se,manifest:x,location:J.location,isBuiltin:re,targetPlatform:ne?.targetPlatform??"undefined",metadata:ne,isValid:!0,validations:[]};return J.validate?this.validate(ge,J):ge}}catch(x){J.type!==0&&this.m.error(x)}return null}validate(J,ne){let x=!0;const G=(0,t.$qp)(ne.productVersion,ne.productDate,ne.location,J.manifest,J.isBuiltin);for(const[se,ce]of G)se===c.default.Error&&(x=!1,this.m.error(this.z(ne.location,ce)));return J.isValid=x,J.validations=G,J}async scanExtensionManifest(J){const ne=(0,m.$Rg)(J,"package.json");let x;try{x=(await this.j.readFile(ne)).value.toString()}catch(se){return(0,r.$Sk)(se)!==1&&this.m.error(this.z(J,(0,g.localize)(0,null,ne.path,se.message))),null}let G;try{G=JSON.parse(x)}catch{const ce=[];(0,P.$pn)(x,ce);for(const re of ce)this.m.error(this.z(J,(0,g.localize)(1,null,ne.path,re.offset,re.length,(0,v.$0p)(re.error))));return null}return(0,P.$yn)(G)!=="object"?(this.m.error(this.z(J,(0,g.localize)(2,null,ne.path))),null):G}async t(J,ne,x){const G=await this.u(J,ne,x);if(G)try{const se=[],ce=await this.w(G.default,se);if(se.length>0)return se.forEach(ge=>{this.m.error(this.z(J,(0,g.localize)(3,null,G.default?.path,(0,v.$0p)(ge.error))))}),ne;if((0,P.$yn)(G)!=="object")return this.m.error(this.z(J,(0,g.localize)(4,null,G.default?.path))),ne;const re=G.values||Object.create(null);return(0,O.$$p)(this.m,ne,re,ce)}catch{}return ne}async u(J,ne,x){const G=(0,m.$Rg)(J,"package.nls.json"),se=(B,W)=>{W.forEach(F=>{this.m.error(this.z(J,(0,g.localize)(5,null,B?.path,(0,v.$0p)(F.error))))})},ce=B=>{this.m.error(this.z(J,(0,g.localize)(6,null,B?.path)))},re=`${ne.publisher}.${ne.name}`,ge=x.translations[re];if(ge)try{const B=u.URI.file(ge),W=(await this.j.readFile(B)).value.toString(),F=[],z=(0,P.$pn)(W,F);return F.length>0?(se(B,F),{values:void 0,default:G}):(0,P.$yn)(z)!=="object"?(ce(B),{values:void 0,default:G}):{values:z.contents?z.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.j.exists(G))return;let W;try{W=await this.y(J,x)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const F=(await this.j.readFile(W.localized)).value.toString(),z=[],_=(0,P.$pn)(F,z);return z.length>0?(se(W.localized,z),{values:void 0,default:W.original}):(0,P.$yn)(_)!=="object"?(ce(W.localized),{values:void 0,default:W.original}):{values:_,default:W.original}}catch{return{values:void 0,default:W.original}}}}async w(J,ne){if(J)try{const x=(await this.j.readFile(J)).value.toString();return(0,P.$pn)(x,ne)}catch{}}y(J,ne){return new Promise((x,G)=>{const se=ce=>{const re=(0,m.$Rg)(J,`package.nls.${ce}.json`);this.j.exists(re).then(ge=>{ge&&x({localized:re,original:(0,m.$Rg)(J,"package.nls.json")});const B=ce.lastIndexOf("-");B===-1?x({localized:(0,m.$Rg)(J,"package.nls.json"),original:null}):(ce=ce.substring(0,B),se(ce))})};if(ne.devMode||ne.pseudo||!ne.language)return x({localized:(0,m.$Rg)(J,"package.nls.json"),original:null});se(ne.language)})}z(J,ne){return`[${J.path}]: ${ne}`}};fe=Le([Ne(1,A.$8p),Ne(2,I.$_k),Ne(3,r.$Bk),Ne(4,n.$yj)],fe);let ue=class extends fe{constructor(J,ne,x,G,se,ce,re){super(ne,G,se,ce,re),this.G=J,this.H=x,this.D=this.B(new C.$ch(3e3)),this.F=this.B(new a.$5d),this.onDidChangeCache=this.F.event}async scanExtensions(J){const ne=this.M(J),x=await this.I(ne);if(this.C=J,x&&x.input&&ee.equals(x.input,this.C))return this.m.debug("Using cached extensions scan result",J.location.toString()),this.D.trigger(()=>this.L()),x.result.map(se=>(se.location=u.URI.revive(se.location),se));const G=await super.scanExtensions(J);return await this.J(ne,{input:J,result:G}),G}async I(J){try{const ne=await this.j.readFile(J),x=JSON.parse(ne.value.toString());return{result:x.result,input:(0,$.$Nh)(x.input)}}catch(ne){this.m.debug("Error while reading the extension cache file:",J.path,(0,k.$0)(ne))}return null}async J(J,ne){try{await this.j.writeFile(J,S.$se.fromString(JSON.stringify(ne)))}catch(x){this.m.debug("Error while writing the extension cache file:",J.path,(0,k.$0)(x))}}async L(){if(!this.C)return;const J=this.M(this.C),ne=await this.I(J);if(!ne)return;const x=ne.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Mn(G,x))try{this.m.info("Invalidating Cache",x,G),await this.j.del(J),this.F.fire()}catch(se){this.m.error(se)}}M(J){const ne=this.N(J);return this.h.extUri.joinPath(ne.cacheHome,J.type===0?l.$sm:l.$rm)}N(J){return J.type===0?this.H.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ne=>this.h.extUri.isEqual(J.location,ne.extensionsResource))??this.G:this.H.defaultProfile}};ue=Le([Ne(2,R.$bl),Ne(3,A.$8p),Ne(4,I.$_k),Ne(5,r.$Bk),Ne(6,n.$yj)],ue);function j(q,J){const ne=(0,f.$dp)(q.manifest.publisher,q.manifest.name);return{id:ne,identifier:new l.$xm(ne),isBuiltin:q.type===0,isUserBuiltin:q.type===1&&q.isBuiltin,isUnderDevelopment:J,extensionLocation:q.location,uuid:q.identifier.uuid,targetPlatform:q.targetPlatform,...q.manifest}}e.$cq=j;class H extends Z{constructor(J,ne,x,G,se,ce,re,ge,B,W,F,z){super(J,ne,(0,m.$Rg)(x,".vscode-oss-dev","extensions","control.json"),G,se,ce,re,ge,B,W,F,z),this.R=(async()=>{if(w.$t)try{const _=await this.w.readFile(u.URI.file(w.$t));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(J){return this.R}}e.$dq=H}),define(Ee[262],ke([1,0,54,15,40,6,2,12,7,23,13,33]),function(le,e,y,C,s,S,k,P,v,p,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;let w=class extends k.$Tc{constructor(d,c){super(),this.b=d,this.f=c,this.a=new C.$kh(5)}async postUninstall(d){const c=this.g(d,"uninstall");c&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(b)}}));try{await p.Promises.rm(this.m(d))}catch(b){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(b)}}g(d,c){const b=`vscode:${c}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[b]=="string"){const u=d.manifest.scripts[b].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${b} should be a node script`),null):{script:(0,v.$jc)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,c,b,u,g){return new Promise((h,f)=>{const l=this.j(d,c,b,g);let t;const r=o=>{t&&(clearTimeout(t),t=null),o?f(o):h(void 0)};l.on("error",o=>{r((0,s.$2i)(o)||"Unknown")}),l.on("exit",(o,n)=>{r(o?`post-${c} process exited with code ${o}`:void 0)}),u&&(t=setTimeout(()=>{t=null,l.kill(),f("timed out")},5e3))})}j(d,c,b,u){const g={silent:!0,execArgv:void 0},h=(0,y.fork)(d,[`--type=extension-post-${c}`,...b],g);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const f=S.Event.fromNodeEventEmitter(h.stdout,"data"),l=S.Event.fromNodeEventEmitter(h.stderr,"data");f(o=>this.f.info(u.identifier.id,u.manifest.version,`post-${c}`,o)),l(o=>this.f.error(u.identifier.id,u.manifest.version,`post-${c}`,o));const t=S.Event.any(S.Event.map(f,o=>({data:`%c${o}`,format:[""]})),S.Event.map(l,o=>({data:`%c${o}`,format:["color: red"]})));return S.Event.debounce(t,(o,n)=>o?{data:o.data+n.data,format:[...o.format,...n.format]}:{data:n.data,format:n.format},100)(o=>{console.group(u.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),h}m(d){return(0,v.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$fq=w,e.$fq=w=Le([Ne(0,E.$bl),Ne(1,D.$yj)],w)}),define(Ee[126],ke([1,0,15,14,20,40,8,6,64,2,24,12,7,19,55,9,4,22,23,81,186,83,26,261,30,36,47,59,244,262,216,235,245,82,16,5,13,31,32,34,33]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r,o,n,i,a,$,A,R,I,O,M,Z,ee,fe,ue,j,H,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=void 0,e.$jq=(0,ee.$fi)(o.$Oo);const J=".vsctmp";let ne=class extends r.$3p{constructor(B,W,F,z,_,Q,K,X,Y,N,U,te){super(B,W,U,F,N,te),this.eb=_,this.fb=Q,this.gb=K,this.hb=Y,this.db=new Map,this.qb=new D.$Bc;const ie=this.B(X.createInstance(A.$fq));this.ab=this.B(X.createInstance(x,ae=>ie.postUninstall(ae))),this.bb=this.B(new I.$hq(te,Y,U,this,this.F)),this.cb=this.B(X.createInstance($.$eq));const de=this.B(new O.$iq(this,this.eb,te,Q,U,Y,F));this.B(de.onDidChangeExtensionsByAnotherSource(ae=>this.pb(ae))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$lp)(this.hb,this.F)),this.ib}async zip(B){this.F.trace("ExtensionManagementService#zip",B.identifier.id);const W=await this.ob(B),F=await(0,h.zip)((0,m.$Rg)(this.cb.extensionsDownloadDir,(0,u.$Ag)()).fsPath,W);return b.URI.file(F)}async unzip(B){return this.F.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:W,cleanup:F}=await this.kb(B),z=w.$kc(W.fsPath);try{return await(0,R.$gq)(z)}finally{await F()}}getInstalled(B,W=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(B??null,W)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(B){return this.ab.scanUserExtensionAtLocation(B)}async install(B,W={}){this.F.trace("ExtensionManagementService#install",B.toString());const{location:F,cleanup:z}=await this.kb(B);try{const _=await(0,R.$gq)(w.$kc(F.fsPath)),Q=(0,n.$fp)(_.publisher,_.name);if(_.engines&&_.engines.vscode&&!(0,M.$sp)(_.engines.vscode,this.G.version,this.G.date))throw new Error(f.localize(0,null,Q,this.G.version));const X=(await this.I([{manifest:_,extension:F,options:W}])).find(({identifier:Y})=>(0,n.$ap)(Y,{id:Q}));if(X?.local)return X.local;throw X?.error?X.error:(0,r.$5p)(new Error(`Unknown error while installing extension ${Q}`))}finally{await z()}}async installFromLocation(B,W){this.F.trace("ExtensionManagementService#installFromLocation",B.toString());const F=await this.ab.scanUserExtensionAtLocation(B);if(!F||!F.manifest.name||!F.manifest.version)throw new Error(`Cannot find a valid extension from the location ${B.toString()}`);return await this.tb([[F,void 0]],W),this.F.info("Successfully installed extension",F.identifier.id,W.toString()),F}async installExtensionsFromProfile(B,W,F){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",B,W.toString(),F.toString());const z=(await this.ab.scanExtensions(1,W)).filter(_=>B.some(Q=>(0,n.$ap)(Q,_.identifier)));if(z.length){const _=await Promise.all(z.map(Q=>this.ab.scanMetadata(Q,W)));await this.tb(z.map((Q,K)=>[Q,_[K]]),F),this.F.info("Successfully installed extensions",z.map(Q=>Q.identifier.id),F.toString())}return z}async updateMetadata(B,W,F=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",B.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),B=await this.ab.updateMetadata(B,W,F),this.bb.invalidate(F),this.w.fire(B),B}async reinstallFromGallery(B){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.z.isEnabled())throw new Error(f.localize(1,null));const W=await this.getTargetPlatform(),[F]=await this.z.getExtensions([{...B.identifier,preRelease:B.preRelease}],{targetPlatform:W,compatible:!0},s.CancellationToken.None);if(!F)throw new Error(f.localize(2,null));await this.ab.setUninstalled(B);try{await this.ab.removeUninstalledExtension(B)}catch(z){throw new Error(f.localize(3,null,(0,S.$2i)(z)))}return this.installFromGallery(F)}$(B,W,F,z){return this.ab.copyExtension(B,W,F,z)}copyExtensions(B,W){return this.ab.copyExtensions(B,W)}markAsUninstalled(...B){return this.ab.setUninstalled(...B)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(B){this.F.error(B)}}async download(B,W,F){const{location:z}=await this.cb.download(B,W,!F);return z}async kb(B){if(B.scheme===E.Schemas.file)return{location:B,async cleanup(){}};this.F.trace("Downloading extension from",B.toString());const W=(0,m.$Rg)(this.cb.extensionsDownloadDir,(0,u.$Ag)());return await this.gb.download(B,W),this.F.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.hb.del(W)}catch(z){this.F.error(z)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(B,W,F){if(b.URI.isUri(W))return new ce(B,W,F,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const z=n.$bp.create(W).toString();let _=this.db.get(z);return _||(this.db.set(z,_=new se(B,W,F,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),_.waitUntilTaskIsFinished().finally(()=>this.db.delete(z))),_}Z(B,W){return new re(B,W.profileLocation,this.fb)}async ob(B){const W=async z=>{let _=await g.Promises.readdir(z);_=_.map(X=>w.$jc(z,X));const Q=await Promise.all(_.map(X=>g.Promises.stat(X)));let K=Promise.resolve([]);return Q.forEach((X,Y)=>{const N=_[Y];X.isFile()&&(K=K.then(U=>[...U,N])),X.isDirectory()&&(K=K.then(U=>W(N).then(te=>[...U,...te])))}),K};return(await W(B.location.fsPath)).map(z=>({path:`extension/${w.$lc(B.location.fsPath,z)}`,localPath:z}))}async pb({added:B,removed:W}){if(W){const F=B&&this.D.extUri.isEqual(W.profileLocation,B.profileLocation)?W.extensions.filter(z=>B.extensions.every(_=>!(0,n.$ap)(_,z))):W.extensions;for(const z of F)this.F.info("Extensions removed from another source",z.id,W.profileLocation.toString()),this.u.fire({identifier:z,profileLocation:W.profileLocation})}if(B){const z=(await this.ab.scanExtensions(1,B.profileLocation)).filter(_=>B.extensions.some(Q=>(0,n.$ap)(Q,_.identifier)));this.s.fire(z.map(_=>(this.F.info("Extensions added from another source",_.identifier.id,B.profileLocation.toString()),{identifier:_.identifier,local:_,profileLocation:B.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(W=>this.qb.add(W)));const B=await this.hb.resolve(this.eb.userExtensionsLocation);for(const W of B.children??[])W.isDirectory&&this.qb.add(W.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(W=>this.sb(W)))}async sb(B){if(!B.affects(this.eb.userExtensionsLocation,1))return;const W=[];for(const F of B.rawAdded){if(this.qb.has(F)||!this.D.extUri.isEqual(this.D.extUri.dirname(F),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(F,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(F).startsWith(".")||!(await this.hb.stat(F)).isDirectory)continue;const z=await this.ab.scanUserExtensionAtLocation(F);z&&z.installedTimestamp===void 0&&(this.qb.add(F),W.push(z))}W.length&&(await this.tb(W.map(F=>[F,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",W.map(F=>F.identifier.id)))}async tb(B,W){const F=B.map(z=>z[0]);await this.ub(F),await this.fb.addExtensionsToProfile(B,W),this.s.fire(F.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:W})))}async ub(B){const W=await this.ab.getUninstalledExtensions();for(const F of B){const z=n.$bp.create(F);W[z.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",z.id),await this.ab.setInstalled(z),this.F.info("Removed the extension from uninstalled list:",z.id))}}};e.$kq=ne,e.$kq=ne=Le([Ne(0,o.$Lo),Ne(1,j.$Fl),Ne(2,fe.$yj),Ne(3,t.$mi),Ne(4,a.$_p),Ne(5,i.$8p),Ne(6,l.$qo),Ne(7,ee.$di),Ne(8,Z.$Bk),Ne(9,ue.$Qj),Ne(10,H.$_k),Ne(11,q.$bl)],ne);let x=class extends p.$Tc{constructor(B,W,F,z,_,Q){super(),this.j=B,this.m=W,this.n=F,this.s=z,this.t=_,this.u=Q,this.h=this.B(new P.$5d),this.onExtract=this.h.event,this.c=(0,m.$Rg)(this.n.userExtensionsLocation,".obsolete"),this.g=new y.$lh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(B,W){const F={includeInvalid:!0,profileLocation:W};let z=[];return B===null||B===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},F,!1)):B===1&&z.push(...await this.n.scanUserExtensions(F)),z=B!==null?z.filter(_=>_.type===B):z,Promise.all(z.map(_=>this.F(_)))}async scanAllUserExtensions(B){const W=await this.n.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(W.map(F=>this.F(F)))}async scanUserExtensionAtLocation(B){try{const W=await this.n.scanExistingExtension(B,1,{includeInvalid:!0});if(W)return await this.F(W)}catch(W){this.u.error(W)}return null}async extractUserExtension(B,W,F,z,_){const Q=B.toString(),K=b.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$Ag)()}`)),X=b.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,Q));let Y=await this.m.exists(X);if(Y&&z){try{await this.y(B.id,X,"removeExisting")}catch{throw new o.$Mo(f.localize(4,null,X.fsPath,B.id),o.ExtensionManagementErrorCode.Delete)}Y=!1}if(Y)await this.n.updateMetadata(X,F);else try{try{this.u.trace(`Started extracting the extension from ${W} to ${X.fsPath}`),await(0,h.$1p)(W,K.fsPath,{sourcePath:"extension",overwrite:!0},_),this.u.info(`Extracted extension to ${X}:`,B.id)}catch(N){let U=o.ExtensionManagementErrorCode.Extract;throw N instanceof h.$Yp&&(N.type==="CorruptZip"?U=o.ExtensionManagementErrorCode.CorruptZip:N.type==="Incomplete"&&(U=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$Mo(N.message,U)}await this.n.updateMetadata(K,F);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${X.fsPath}`),await this.C(K.fsPath,X.fsPath),this.u.info("Renamed to",X.fsPath)}catch(N){if(N.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.u.info(`Rename failed because of ${(0,k.$0)(N)}. Deleted from extracted location`,K),N}this.h.fire(X)}catch(N){try{await this.m.del(K,{recursive:!0})}catch{}throw N}return this.D(X,1)}async scanMetadata(B,W){return W?(await this.w(B,W))?.metadata:this.n.scanMetadata(B.location)}async w(B,W){return(await this.s.scanProfileExtensions(W)).find(z=>(0,n.$ap)(z.identifier,B.identifier))}async updateMetadata(B,W,F){return F?await this.s.updateMetadata([[B,W]],F):await this.n.updateMetadata(B.location,W),this.D(B.location,B.type,F)}getUninstalledExtensions(){return this.z()}async setUninstalled(...B){const W=B.map(F=>n.$bp.create(F));await this.z(F=>W.forEach(z=>{F[z.toString()]=!0,this.u.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(B){await this.z(W=>delete W[B.toString()])}async removeExtension(B,W){if(this.t.extUri.isEqualOrParent(B.location,this.n.userExtensionsLocation))return this.y(B.identifier.id,B.location,W)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.z(W=>delete W[n.$bp.create(B).toString()])}async copyExtension(B,W,F,z){const _=await this.w(B,W),Q=await this.w(B,F);if(z={..._?.metadata,...z},Q)if(this.t.extUri.isEqual(Q.location,B.location))await this.s.updateMetadata([[B,{...Q.metadata,...z}]],F);else{const K=await this.D(Q.location,B.type,F);await this.s.removeExtensionFromProfile(K,F),await this.s.addExtensionsToProfile([[B,{...Q.metadata,...z}]],F)}else await this.s.addExtensionsToProfile([[B,z]],F);return this.D(B.location,B.type,F)}async copyExtensions(B,W){const F=await this.scanExtensions(1,B),z=await Promise.all(F.filter(_=>!_.isApplicationScoped).map(async _=>[_,await this.scanMetadata(_,B)]));await this.s.addExtensionsToProfile(z,W)}async y(B,W,F){this.u.trace(`Deleting ${F} extension from disk`,B,W.fsPath);const z=this.t.extUri.joinPath(this.t.extUri.dirname(W),`${this.t.extUri.basename(W)}.${(0,v.$5i)((0,u.$Ag)()).toString(16)}${J}`);await this.C(W.fsPath,z.fsPath),await this.m.del(z,{recursive:!0}),this.u.info(`Deleted ${F} extension from disk`,B,W.fsPath)}async z(B){return this.g.queue(async()=>{let W;try{W=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,Z.$Sk)(z)!==1)throw z}let F={};if(W)try{F=JSON.parse(W)}catch{}return B&&(B(F),Object.keys(F).length?await this.m.writeFile(this.c,C.$se.fromString(JSON.stringify(F))):await this.m.del(this.c)),F})}async C(B,W){try{await g.Promises.rename(B,W,2*60*1e3)}catch(F){throw new o.$Mo(F.message||f.localize(5,null,B,W),F.code||o.ExtensionManagementErrorCode.Rename)}}async D(B,W,F){if(F){const _=(await this.n.scanUserExtensions({profileLocation:F})).find(Q=>this.t.extUri.isEqual(Q.location,B));if(_)return this.F(_)}else{const z=await this.n.scanExistingExtension(B,W,{includeInvalid:!0});if(z)return this.F(z)}throw new Error(f.localize(6,null,B.path))}async F(B){const W=await this.m.resolve(B.location);let F,z;return W.children&&(F=W.children.find(({name:_})=>/^readme(\.txt|\.md|)$/i.test(_))?.resource,z=W.children.find(({name:_})=>/^changelog(\.txt|\.md|)$/i.test(_))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:F,changelogUrl:z,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!B.metadata?.hasPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated,pinned:!!B.metadata?.pinned}}async G(){const B=await this.getUninstalledExtensions();if(Object.keys(B).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(B));const W=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const _ of W)B[n.$bp.create(_).toString()]||F.add(_.identifier.id.toLowerCase());try{const _=(0,n.$gp)(W,Q=>Q.identifier);await y.Promises.settled(_.map(async Q=>{const K=Q.sort((X,Y)=>d.rcompare(X.manifest.version,Y.manifest.version))[0];F.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(_){this.u.error(_)}const z=W.filter(_=>_.metadata&&B[n.$bp.create(_).toString()]);await Promise.allSettled(z.map(_=>this.removeUninstalledExtension(_)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let B;try{B=await this.m.resolve(this.n.userExtensionsLocation)}catch(W){(0,Z.$Sk)(W)!==1&&this.u.error(W);return}if(B?.children)try{await Promise.allSettled(B.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(J))){this.u.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.m.del(W.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(F){(0,Z.$Sk)(F)!==1&&this.u.error(F)}}}))}catch{}}};e.$lq=x,e.$lq=x=Le([Ne(1,Z.$Bk),Ne(2,a.$_p),Ne(3,i.$8p),Ne(4,H.$_k),Ne(5,fe.$yj)],x);class G extends r.$6p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$Zf)(this.options.operation)?this.l:this.options.operation}constructor(B,W,F,z,_,Q,K,X,Y){super(),this.identifier=B,this.source=W,this.options=F,this.m=z,this.n=_,this.o=Q,this.p=K,this.q=X,this.s=Y,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(B){const[W,F]=await this.x(B);return this.j=W.isBuiltin||W.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[W,F]],this.j),W}async u({zipPath:B,key:W,metadata:F},z,_){let Q=await this.v(W);return Q?Q=await this.m.updateMetadata(Q,F):(this.s.trace("Extracting extension...",W.id),Q=await this.m.extractUserExtension(W,B,F,z,_),this.s.info("Extracting extension completed.",W.id)),Q}async v(B){return await this.w(B)?(this.s.trace("Removing the extension from uninstalled list:",B.id),await this.m.setInstalled(B),this.s.info("Removed the extension from uninstalled list:",B.id),(await this.m.scanAllUserExtensions(!0)).find(z=>n.$bp.create(z).equals(B))):void 0}async w(B){return!!(await this.m.getUninstalledExtensions())[B.toString()]}}class se extends G{constructor(B,W,F,z,_,Q,K,X,Y,N){super(W.identifier,W,F,_,Q,K,X,Y,N),this.y=W,this.z=z}async x(B){let W;try{W=await this.m.scanExtensions(null,this.options.profileLocation)}catch(K){throw new o.$Mo(K,o.ExtensionManagementErrorCode.Scanning)}const F=W.find(K=>(0,n.$ap)(K.identifier,this.y.identifier));F&&(this.l=3);const z={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,isSystem:F?.type===0?!0:void 0,updated:!!F,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:F?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??F?.pinned,preRelease:(0,c.$Yf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||F?.preRelease};if(F?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(F,z),z]}catch(K){throw new o.$Mo((0,k.$0)(K),o.ExtensionManagementErrorCode.UpdateMetadata)}const{location:_,verificationStatus:Q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=Q,this.B(_.fsPath),[await this.u({zipPath:_.fsPath,key:n.$bp.create(this.y),metadata:z},!1,B),z]}catch(K){try{await this.z.delete(_)}catch(X){this.s.warn("Error while deleting the downloaded file",_.toString(),(0,k.$0)(X))}throw K}}async B(B){try{await(0,R.$gq)(B)}catch(W){throw new o.$Mo((0,r.$4p)(W).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$mq=se;class ce extends G{constructor(B,W,F,z,_,Q,K,X,Y,N){super({id:(0,n.$fp)(B.publisher,B.name)},W,F,_,Q,K,X,Y,N),this.y=B,this.z=W,this.A=z}async h(B){const W=await super.h(B);return this.D(W,B),W}async x(B){const W=new n.$bp(this.identifier,this.y.version),z=(await this.m.scanExtensions(1,this.options.profileLocation)).find(K=>(0,n.$ap)(this.identifier,K.identifier)),_={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned};if(z)if(this.l=3,W.equals(new n.$bp(z.identifier,z.manifest.version)))try{await this.m.removeExtension(z,"existing")}catch{throw new Error(f.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(z.manifest.version,this.y.version)&&await this.m.setUninstalled(z);else{const K=await this.v(W);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(f.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$kc(this.z.fsPath),key:W,metadata:_},!0,B),_]}async D(B,W){try{let[F]=await this.A.getExtensions([{id:B.identifier.id,version:B.manifest.version}],W);if(F||([F]=await this.A.getExtensions([{id:B.identifier.id}],W)),F){const z={id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,hasPreReleaseVersion:B.hasPreReleaseVersion||F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(B,z,this.options.profileLocation)}}catch{}}}class re extends r.$6p{constructor(B,W,F){super(),this.extension=B,this.j=W,this.k=F}async h(B){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Ee[127],ke([1,0,13,33,34,32,47,16,26,4]),function(le,e,y,C,s,S,k,P,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=void 0;let D=class extends k.$9p{constructor(w,m,d,c,b,u){super(p.URI.file(w.extensionsPath),m,d,c,b,u)}};e.$CP=D,e.$CP=D=Le([Ne(0,v.$mi),Ne(1,P.$Bk),Ne(2,C.$bl),Ne(3,s.$_k),Ne(4,S.$Fl),Ne(5,y.$yj)],D)}),define(Ee[263],ke([1,0,15,6,2,42,9,163,5,33]),function(le,e,y,C,s,S,k,P,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Gp=e.$Fp=e.$Ep=void 0,e.$Ep="__$__isNewStorageMarker",e.$Fp="__$__targetStorageMarker",e.$Gp=(0,v.$ei)("storageService");var D;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var E;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var w;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function m(g){const h=g.get(e.$Fp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$Hp=m;class d extends s.$Tc{constructor(h={flushInterval:d.a}){super(),this.m=h,this.b=this.B(new C.$8d),this.c=this.B(new C.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new y.$qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,f,l){return C.Event.filter(this.b.event,t=>t.scope===h&&(f===void 0||t.key===f),l)}n(){this.j.value=(0,y.$uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,S.mark)("code/willInitStorage");try{await this.O()}finally{(0,S.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,f){const{key:l,external:t}=f;if(l===e.$Fp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:l,target:this.J(h)[l],external:t})}w(h){this.f.fire({reason:h})}get(h,f,l){return this.P(f)?.get(h,l)}getBoolean(h,f,l){return this.P(f)?.getBoolean(h,l)}getNumber(h,f,l){return this.P(f)?.getNumber(h,l)}getObject(h,f,l){return this.P(f)?.getObject(h,l)}storeAll(h,f){this.y(()=>{for(const l of h)this.store(l.key,l.value,l.scope,l.target,f)})}store(h,f,l,t,r=!1){if((0,k.$2f)(f)){this.remove(h,l,r);return}this.y(()=>{this.z(h,l,t),this.P(l)?.set(h,f,r)})}remove(h,f,l=!1){this.y(()=>{this.z(h,f,void 0),this.P(f)?.delete(h,l)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,f){const l=[],t=this.J(h);for(const r of Object.keys(t))t[r]===f&&l.push(r);return l}z(h,f,l,t=!1){const r=this.J(f);typeof l=="number"?r[h]!==l&&(r[h]=l,this.P(f)?.set(e.$Fp,JSON.stringify(r),t)):typeof r[h]=="number"&&(delete r[h],this.P(f)?.set(e.$Fp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const f=this.P(h);return f?m(f):Object.create(null)}isNew(h){return this.getBoolean(e.$Ep,h)===!0}async flush(h=D.NONE){this.f.fire({reason:h});const f=this.P(-1),l=this.P(0),t=this.P(1);switch(h){case D.NONE:await y.Promises.settled([f?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await y.Promises.settled([f?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,f=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return u(h,f,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,f){return this.w(D.NONE),(0,p.$al)(h)?this.R(h,f):this.S(h,f)}M(h,f){return!(h.id===f.id||c(f)&&c(h))}N(h,f,l){this.y(()=>{const t=new Set;for(const[r,o]of h)t.add(r),f.get(r)!==o&&this.u(l,{key:r,external:!0});for(const[r]of f.items)t.has(r)||this.u(l,{key:r,external:!0})})}}e.$Ip=d,d.a=60*1e3;function c(g){return g.isDefault||!!g.useDefaultFlags?.globalState}e.$Jp=c;class b extends d{constructor(){super(),this.U=this.B(new P.$Cp(new P.$Dp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$Cp(new P.$Dp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$Cp(new P.$Dp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Kp=b;async function u(g,h,f,l,t,r){const o=M=>{try{return JSON.parse(M)}catch{return M}},n=new Map,i=new Map;g.forEach((M,Z)=>{n.set(Z,M),i.set(Z,o(M))});const a=new Map,$=new Map;h.forEach((M,Z)=>{a.set(Z,M),$.set(Z,o(M))});const A=new Map,R=new Map;f.forEach((M,Z)=>{A.set(Z,M),R.set(Z,o(M))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const I=[];if(n.forEach((M,Z)=>{I.push({key:Z,value:M})}),console.table(I),console.groupEnd(),console.log(i),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];a.forEach((Z,ee)=>{M.push({key:ee,value:Z})}),console.table(M),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${r})`);const O=[];A.forEach((M,Z)=>{O.push({key:Z,value:M})}),console.table(O),console.groupEnd(),console.log(R)}e.$Lp=u}),define(Ee[128],ke([1,0,18,20,8,3,28,9,4,25,26,30,36,82,16,13,31,46,246,263,32,63]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=e.$Op=void 0;const t=S.$i?"web":(0,E.$Ho)(S.$o,k.$ec),r="X-Market-Search-Activity-Id";var o;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...z){return String(z.reduce((_,Q)=>_|Q,0))}var i;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},$={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class I{constructor(_=R){this.d=_}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(_,Q=this.d.pageSize){return new I({...this.d,pageNumber:_,pageSize:Q})}withFilter(_,...Q){const K=[...this.d.criteria,...Q.length?Q.map(X=>({filterType:_,value:X})):[{filterType:_}]];return new I({...this.d,criteria:K})}withSortBy(_){return new I({...this.d,sortBy:_})}withSortOrder(_){return new I({...this.d,sortOrder:_})}withFlags(..._){return new I({...this.d,flags:_.reduce((Q,K)=>Q|K,0)})}withAssetTypes(..._){return new I({...this.d,assetTypes:_})}withSource(_){return new I({...this.d,source:_})}get raw(){const{criteria:_,pageNumber:Q,pageSize:K,sortBy:X,sortOrder:Y,flags:N,assetTypes:U}=this.d;return{filters:[{criteria:_,pageNumber:Q,pageSize:K,sortBy:X,sortOrder:Y}],assetTypes:U,flags:N}}get searchText(){const _=this.d.criteria.filter(Q=>Q.filterType===i.SearchText)[0];return _&&_.value?_.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(_=>String(_.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(z,_){const Q=(z||[]).filter(K=>K.statisticName===_)[0];return Q?Q.value:0}function M(z){const _="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(K=>K.assetType.indexOf(_)===0).reduce((K,X)=>{const Y=fe(z,X.assetType);return Y&&K.push([X.assetType.substring(_.length),Y]),K},[])}function Z(z){if(z.properties){const _=z.properties.filter(X=>X.key===a.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=_.filter(X=>Q.test(X.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return fe(z,a.Repository)}function ee(z){return{uri:`${z.fallbackAssetUri}/${a.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${a.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function fe(z,_){return z.files.filter(K=>K.assetType===_)[0]?{uri:`${z.assetUri}/${_}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${_}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function ue(z,_){const Q=z.properties?z.properties.filter(X=>X.key===_):[],K=Q.length>0&&Q[0].value;return K?K.split(",").map(X=>(0,w.$ep)(X)):[]}function j(z){const _=z.properties?z.properties.filter(Q=>Q.key===$.Engine):[];return _.length>0&&_[0].value||""}function H(z){const _=z.properties?z.properties.filter(Q=>Q.key===$.PreRelease):[];return _.length>0&&_[0].value==="true"}function q(z){const _=z.properties?z.properties.filter(K=>K.key===$.LocalizedLanguages):[],Q=_.length>0&&_[0].value||"";return Q?Q.split(","):[]}function J(z){return z.properties?.find(_=>_.key===$.SponsorLink)?.value}function ne(z){return z.properties?.find(_=>_.key===$.SupportLink)?.value}function x(z){return z.indexOf("preview")!==-1}function G(z){return z.targetPlatform?(0,E.$Go)(z.targetPlatform):"undefined"}function se(z){const _=(0,y.$Mb)(z.versions.map(G)),Q=!!z.tags?.includes(E.$Bo),K=_.indexOf("web");return Q?K===-1&&_.push("web"):K!==-1&&_.splice(K,1),_}function ce(z,_){for(let Q=0;Q<z.length;Q++){const K=z[Q];if(K.version===z[Q-1]?.version){let X=Q;if(G(K)===_)for(;X>0&&z[X-1].version===K.version;)X--;X!==Q&&(z.splice(Q,1),z.splice(X,0,K))}}return z}e.$Op=ce;function re(z,_,Q){z.telemetryData={index:_,querySource:Q,queryActivityId:z.queryContext?.[r]}}function ge(z,_,Q,K){const X=z.versions[0],Y={manifest:fe(_,a.Manifest),readme:fe(_,a.Details),changelog:fe(_,a.Changelog),license:fe(_,a.License),repository:Z(_),download:ee(_),icon:fe(_,a.Icon),signature:fe(_,a.Signature),coreTranslations:M(_)};return{identifier:{id:(0,w.$fp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:_.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(X),description:z.shortDescription??"",installCount:O(z.statistics,"install"),rating:O(z.statistics,"averagerating"),ratingCount:O(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:Q,assets:Y,properties:{dependencies:ue(_,$.Dependency),extensionPack:ue(_,$.ExtensionPack),engine:j(_),localizedLanguages:q(_),targetPlatform:G(_),isPreReleaseVersion:H(_)},hasPreReleaseVersion:H(X),hasReleaseVersion:!0,preview:x(z.flags),isSigned:!!Y.signature,queryContext:K,supportLink:ne(X)}}let B=class{constructor(_,Q,K,X,Y,N,U,te){this.k=Q,this.l=K,this.n=X,this.o=Y,this.q=N,this.u=U,this.w=te;const ie=U.extensionsGallery,de=ie?.servicePPEUrl&&te.getValue("_extensionsGallery.enablePPE");this.d=de?ie.servicePPEUrl:ie?.serviceUrl,this.g=de?void 0:ie?.searchUrl,this.h=ie?.controlUrl,this.j=(0,g.$Np)(U.version,U,this.n,this.w,this.q,_,this.o)}x(_=""){return`${this.d}${_}`}isEnabled(){return!!this.d}async getExtensions(_,Q,K){const X=C.CancellationToken.isCancellationToken(Q)?{}:Q,Y=C.CancellationToken.isCancellationToken(Q)?Q:K,N=[],U=[],te=[],ie=[];let de=!0;for(const ye of _){ye.uuid?U.push(ye.uuid):N.push(ye.id);const Re=!!(ye.version||ye.preRelease);te.push({id:ye.id,uuid:ye.uuid,includePreRelease:Re}),ye.version&&ie.push({id:ye.id,uuid:ye.uuid,version:ye.version}),de=de&&!!ye.hasPreRelease&&!Re}if(!U.length&&!N.length)return[];let ae=new I().withPage(1,_.length);U.length&&(ae=ae.withFilter(i.ExtensionId,...U)),N.length&&(ae=ae.withFilter(i.ExtensionName,...N)),(X.queryAllVersions||de)&&(ae=ae.withFlags(ae.flags,o.IncludeVersions)),X.source&&(ae=ae.withSource(X.source));const{extensions:be}=await this.z(ae,{targetPlatform:X.targetPlatform??t,includePreRelease:te,versions:ie,compatible:!!X.compatible},Y);return X.source&&be.forEach((ye,Re)=>re(ye,Re,X.source)),be}async getCompatibleExtension(_,Q,K){if((0,E.$Io)(_.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(_,Q,K))return _;const X=new I().withFlags(o.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,_.identifier.uuid),{extensions:Y}=await this.z(X,{targetPlatform:K,compatible:!0,includePreRelease:Q},C.CancellationToken.None);return Y[0]||null}async isExtensionCompatible(_,Q,K){if(!(0,E.$Jo)(_.properties.targetPlatform,_.allTargetPlatforms,K)||!Q&&_.properties.isPreReleaseVersion)return!1;let X=_.properties.engine;if(!X){const Y=await this.getManifest(_,C.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");X=Y.engines.vscode}return(0,m.$sp)(X,this.u.version,this.u.date)}async y(_,Q,K,X,Y){if(!(0,E.$Jo)(G(_),X,Y)||Q!=="any"&&H(_)!==(Q==="prerelease"))return!1;if(K)try{const N=await this.E(_);if(!(0,m.$sp)(N,this.u.version,this.u.date))return!1}catch(N){return this.l.error(`Error while getting the engine for the version ${_.version}.`,(0,s.$0)(N)),!1}return!0}async query(_,Q){let K=_.text||"";const X=_.pageSize??50;let Y=new I().withPage(1,X);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ae,be)=>(Y=Y.withFilter(i.Category,be||ae),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ae,be)=>(Y=Y.withFilter(i.Tag,be||ae),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),Y=Y.withFilter(i.SearchText,K)),Y=Y.withSortBy(0)):_.ids?Y=Y.withFilter(i.ExtensionId,..._.ids):_.names?Y=Y.withFilter(i.ExtensionName,..._.names):Y=Y.withSortBy(4),typeof _.sortBy=="number"&&(Y=Y.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(Y=Y.withSortOrder(_.sortOrder)),_.source&&(Y=Y.withSource(_.source));const N=async(de,ae)=>{const{extensions:be,total:ye}=await this.z(de,{targetPlatform:t,compatible:!1,includePreRelease:!!_.includePreRelease},ae);return be.forEach((Re,Me)=>re(Re,(de.pageNumber-1)*de.pageSize+Me,_.source)),{extensions:be,total:ye}},{extensions:U,total:te}=await N(Y,Q),ie=async(de,ae)=>{if(ae.isCancellationRequested)throw new s.$5;const{extensions:be}=await N(Y.withPage(de+1),ae);return be};return{firstPage:U,total:te,pageSize:Y.pageSize,getPage:ie}}async z(_,Q,K){const X=_.flags;_.flags&o.IncludeLatestVersionOnly&&_.flags&o.IncludeVersions&&(_=_.withFlags(_.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(_.flags&o.IncludeLatestVersionOnly)&&!(_.flags&o.IncludeVersions)&&(_=_.withFlags(_.flags,o.IncludeLatestVersionOnly)),Q.versions?.length&&(_=_.withFlags(_.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),_=_.withFlags(_.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:Y,total:N,context:U}=await this.B(_,K);if(!(_.flags&o.IncludeLatestVersionOnly)){const ae=[];for(const be of Y){const ye=await this.A(be,Q,U);ye&&ae.push(ye)}return{extensions:ae,total:N}}const ie=[],de=new Map;for(let ae=0;ae<Y.length;ae++){const be=Y[ae],ye={id:(0,w.$fp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Re=(0,P.$Yf)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find($e=>(0,w.$ap)($e,ye))?.includePreRelease;if(Q.compatible&&(0,E.$Io)(se(be),Q.targetPlatform))continue;const Me=await this.A(be,Q,U);!Me||Me.properties.isPreReleaseVersion&&(!Re||!Me.hasReleaseVersion)||!Me.properties.isPreReleaseVersion&&Me.properties.targetPlatform!==Q.targetPlatform&&Me.hasPreReleaseVersion?de.set(be.extensionId,ae):ie.push([ae,Me])}if(de.size){const ae=new l.$1d,be=new I().withFlags(X&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,de.size).withFilter(i.ExtensionId,...de.keys()),{extensions:ye}=await this.z(be,Q,K);this.o.publicLog2("galleryService:additionalQuery",{duration:ae.elapsed(),count:de.size});for(const Re of ye){const Me=de.get(Re.identifier.uuid);ie.push([Me,Re])}}return{extensions:ie.sort((ae,be)=>ae[0]-be[0]).map(([,ae])=>ae),total:N}}async A(_,Q,K){const X={id:(0,w.$fp)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},Y=Q.versions?.find(ie=>(0,w.$ap)(ie,X))?.version,N=(0,P.$Yf)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(ie=>(0,w.$ap)(ie,X))?.includePreRelease,U=se(_),te=ce(_.versions,Q.targetPlatform);if(Q.compatible&&(0,E.$Io)(U,Q.targetPlatform))return null;for(let ie=0;ie<te.length;ie++){const de=te[ie];if(!(Y&&de.version!==Y)){if(await this.y(de,N?"any":"release",Q.compatible,U,Q.targetPlatform))return ge(_,de,U,K);if(Y&&de.version===Y)return null}}return Y||Q.compatible?null:ge(_,_.versions[0],U)}async B(_,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");_=_.withFlags(_.flags,o.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(o.Unpublished));const K=await this.j,X=JSON.stringify(_.raw),Y={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},N=new l.$1d;let U,te,ie=0;try{if(U=await this.k.request({type:"POST",url:this.g&&_.criteria.some(ae=>ae.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:Y},Q),U.res.statusCode&&U.res.statusCode>=400&&U.res.statusCode<500)return{galleryExtensions:[],total:ie};const de=await(0,u.$zp)(U);if(de){const ae=de.results[0],be=ae.extensions,ye=ae.resultMetadata&&ae.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return ie=ye&&ye.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:ie,context:{[r]:U.res.headers.activityid}}}return{galleryExtensions:[],total:ie}}catch(de){const ae=(0,s.$4)(de)?E.ExtensionGalleryErrorCode.Cancelled:(0,s.$0)(de).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw te=new E.$No((0,s.$0)(de),ae),te}finally{this.o.publicLog2("galleryService:query",{..._.telemetryData,requestBodySize:String(X.length),duration:N.elapsed(),success:!!U&&(0,u.$vp)(U),responseBodySize:U?.res.headers["Content-Length"],statusCode:U?String(U.res.statusCode):void 0,errorCode:te?.code,count:String(ie)})}}async reportStatistic(_,Q,K,X){if(!this.isEnabled())return;const Y=S.$i?this.x(`/itemName/${_}.${Q}/version/${K}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${_}/extensions/${Q}/${K}/stats?statType=${X}`),N=S.$i?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",te={...await this.j,Accept:N};try{await this.k.request({type:"POST",url:Y,headers:te},C.CancellationToken.None)}catch{}}async download(_,Q,K){this.l.trace("ExtensionGalleryService#download",_.identifier.id);const X=(0,w.$ip)(_),Y=new Date().getTime(),N=ae=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:ae}),U=K===2?"install":K===3?"update":"",te=U?{uri:`${_.assets.download.uri}${v.URI.parse(_.assets.download.uri).query?"&":"?"}${U}=true`,fallbackUri:`${_.assets.download.fallbackUri}${v.URI.parse(_.assets.download.fallbackUri).query?"&":"?"}${U}=true`}:_.assets.download,ie=_.queryContext?.[r]?{[r]:_.queryContext[r]}:void 0,de=await this.D(te,ie?{headers:ie}:void 0);await this.q.writeFile(Q,de.stream),N(new Date().getTime()-Y)}async downloadSignatureArchive(_,Q){if(!_.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",_.identifier.id);const K=await this.D(_.assets.signature);await this.q.writeFile(Q,K.stream)}async getReadme(_,Q){if(_.assets.readme){const K=await this.D(_.assets.readme,{},Q);return await(0,u.$yp)(K)||""}return""}async getManifest(_,Q){if(_.assets.manifest){const K=await this.D(_.assets.manifest,{},Q),X=await(0,u.$yp)(K);return X?JSON.parse(X):null}return null}async C(_,Q){const K=fe(_,a.Manifest);if(!K)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Y=await this.D(K,{headers:X});return await(0,u.$zp)(Y)}async getCoreTranslation(_,Q){const K=_.assets.coreTranslations.filter(X=>X[0]===Q.toUpperCase())[0];if(K){const X=await this.D(K[1]),Y=await(0,u.$yp)(X);return Y?JSON.parse(Y):null}return null}async getChangelog(_,Q){if(_.assets.changelog){const K=await this.D(_.assets.changelog,{},Q);return await(0,u.$yp)(K)||""}return""}async getAllCompatibleVersions(_,Q,K){let X=new I().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);_.identifier.uuid?X=X.withFilter(i.ExtensionId,_.identifier.uuid):X=X.withFilter(i.ExtensionName,_.identifier.id);const{galleryExtensions:Y}=await this.B(X,C.CancellationToken.None);if(!Y.length)return[];const N=se(Y[0]);if((0,E.$Io)(N,K))return[];const U=[];await Promise.all(Y[0].versions.map(async de=>{try{await this.y(de,Q?"any":"release",!0,N,K)&&U.push(de)}catch{}}));const te=[],ie=new Set;for(const de of ce(U,K))ie.has(de.version)||(ie.add(de.version),te.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:H(de)}));return te}async D(_,Q={},K=C.CancellationToken.None){const X=await this.j,Y={type:"GET"},N={...X,...Q.headers||{}};Q={...Q,...Y,headers:N};const U=_.uri,te=_.fallbackUri,ie={...Q,url:U};try{const de=await this.k.request(ie,K);if(de.res.statusCode===200)return de;const ae=await(0,u.$yp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ae}`)}catch(de){if((0,s.$4)(de))throw de;const ae=(0,s.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:U,message:ae});const be={...Q,url:te};return this.k.request(be,K)}}async E(_){let Q=j(_);if(!Q){const K=await this.C(_,C.CancellationToken.None);if(!K)throw new Error("Manifest was not found");Q=K.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const _=await this.k.request({type:"GET",url:this.h},C.CancellationToken.None);if(_.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,u.$zp)(_),K=[],X={},Y=[];if(Q){for(const N of Q.malicious)K.push({id:N});if(Q.migrateToPreRelease)for(const[N,U]of Object.entries(Q.migrateToPreRelease))(!U.engine||(0,m.$sp)(U.engine,this.u.version,this.u.date))&&(X[N.toLowerCase()]={disallowInstall:!0,extension:{id:U.id,displayName:U.displayName,autoMigrate:{storage:!!U.migrateStorage},preRelease:!0}});if(Q.deprecated)for(const[N,U]of Object.entries(Q.deprecated))U&&(X[N.toLowerCase()]=(0,P.$Yf)(U)?{}:U);if(Q.search)for(const N of Q.search)Y.push(N)}return{malicious:K,deprecated:X,search:Y}}};B=Le([Ne(1,u.$tp),Ne(2,c.$yj),Ne(3,D.$li),Ne(4,f.$Fl),Ne(5,d.$Bk),Ne(6,b.$Qj),Ne(7,p.$Ki)],B);let W=class extends B{constructor(_,Q,K,X,Y,N,U,te){super(_,Q,K,X,Y,N,U,te)}};e.$Pp=W,e.$Pp=W=Le([Ne(0,h.$Gp),Ne(1,u.$tp),Ne(2,c.$yj),Ne(3,D.$li),Ne(4,f.$Fl),Ne(5,d.$Bk),Ne(6,b.$Qj),Ne(7,p.$Ki)],W);let F=class extends B{constructor(_,Q,K,X,Y,N,U){super(void 0,_,Q,K,X,Y,N,U)}};e.$Qp=F,e.$Qp=F=Le([Ne(0,u.$tp),Ne(1,c.$yj),Ne(2,D.$li),Ne(3,f.$Fl),Ne(4,d.$Bk),Ne(5,b.$Qj),Ne(6,p.$Ki)],F)}),define(Ee[264],ke([1,0,6,2,33,53]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$JP=void 0;class k{constructor(p,D){this.a=p,this.b=D}listen(p,D){const E=this.b(p);switch(D){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(m=>(0,S.$gn)({...m},E)),added:w.added.map(m=>(0,S.$gn)({...m},E)),removed:w.removed.map(m=>(0,S.$gn)({...m},E)),updated:w.updated.map(m=>(0,S.$gn)({...m},E))}))}throw new Error(`Invalid listen ${D}`)}async call(p,D,E){const w=this.b(p);switch(D){case"createProfile":{const m=await this.a.createProfile(E[0],E[1],E[2]);return(0,S.$gn)({...m},w)}case"updateProfile":{let m=(0,s.$cl)((0,S.$hn)(E[0],w),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,E[1]),(0,S.$gn)({...m},w)}case"removeProfile":{const m=(0,s.$cl)((0,S.$hn)(E[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${D}`)}}e.$JP=k;class P extends C.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(p,D,E){super(),this.profilesHome=D,this.f=E,this.a=[],this.b=this.B(new y.$5d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=p.map(w=>(0,s.$cl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const m=w.added.map(b=>(0,s.$cl)(b,this.profilesHome.scheme)),d=w.removed.map(b=>(0,s.$cl)(b,this.profilesHome.scheme)),c=w.updated.map(b=>(0,s.$cl)(b,this.profilesHome.scheme));this.a=w.all.map(b=>(0,s.$cl)(b,this.profilesHome.scheme)),this.b.fire({added:m,removed:d,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(p){this.c=p}isEnabled(){return this.c}async createNamedProfile(p,D,E){const w=await this.f.call("createNamedProfile",[p,D,E]);return(0,s.$cl)(w,this.profilesHome.scheme)}async createProfile(p,D,E,w){const m=await this.f.call("createProfile",[p,D,E,w]);return(0,s.$cl)(m,this.profilesHome.scheme)}async createTransientProfile(p){const D=await this.f.call("createTransientProfile",[p]);return(0,s.$cl)(D,this.profilesHome.scheme)}async setProfileForWorkspace(p,D){await this.f.call("setProfileForWorkspace",[p,D])}removeProfile(p){return this.f.call("removeProfile",[p])}async updateProfile(p,D){const E=await this.f.call("updateProfile",[p,D]);return(0,s.$cl)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$KP=P}),define(Ee[129],ke([1,0,4,26,16,13,239,34,33,9,240]),function(le,e,y,C,s,S,k,P,v,p,D){"use strict";var E,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$AP=e.$zP=void 0;let m=E=class extends v.$el{constructor(u,g,h,f,l){super(h,f,g,l),this.U=u,this.W=h}O(){return this.U.getItem(E.b,[]).map(g=>({...g,location:(0,p.$Sf)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):y.URI.revive(g.location)}))}Q(){const u=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(y.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$zP=m,m.a="profileAssociationsMigration",e.$zP=m=E=Le([Ne(0,k.$uP),Ne(1,P.$_k),Ne(2,C.$mi),Ne(3,s.$Bk),Ne(4,S.$yj)],m);let d=w=class extends m{constructor(u,g,h,f,l){super(u,g,h,f,l),this.$=u}P(u){u.length?this.$.setItem(w.b,u.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem(w.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(w.c,u):this.$.removeItem(w.c)}Q(){const u="workspaceAndProfileInfo",g=this.$.getItem(u,void 0);if(g){this.$.removeItem(u);const f=g.reduce((l,{workspace:t,profile:r})=>(l[y.URI.revive(t).toString()]=y.URI.revive(r).toString(),l),{});this.$.setItem(w.c,{workspaces:f})}const h=super.Q();return this.$.getItem(w.a,!1)||(this.R(h),this.$.setItem(w.a,!0)),h}};e.$AP=d,e.$AP=d=w=Le([Ne(0,k.$vP),Ne(1,P.$_k),Ne(2,C.$mi),Ne(3,s.$Bk),Ne(4,S.$yj)],d);let c=class extends d{constructor(u,g,h,f){super(new D.$yP(0,g,f,h),u,g,h,f)}async init(){return await this.$.init(),super.init()}};e.$BP=c,e.$BP=c=Le([Ne(0,P.$_k),Ne(1,C.$mi),Ne(2,s.$Bk),Ne(3,S.$yj)],c)}),define(Ee[130],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$1m=(0,y.$ei)("extensionHostStatusService");class C{constructor(){this.a=new Map}setExitInfo(S,k){this.a.set(S,k)}getExitInfo(S){return this.a.get(S)||null}}e.$2m=C}),define(Ee[265],ke([1,0,6,15]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;function s(k){let P=0,v=0,p=0;k>=1e3&&(p=Math.floor(k/1e3),k-=p*1e3),p>=60&&(v=Math.floor(p/60),p-=v*60),v>=60&&(P=Math.floor(v/60),v-=P*60);const D=P?`${P}h`:"",E=v?`${v}m`:"",w=p?`${p}s`:"",m=k?`${k}ms`:"";return`${D}${E}${w}${m}`}class S{constructor(P,v,p,D){this.i=P,this.j=v,this.a=new y.$5d,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=p,this.protocol=D,this.e=!1,this.f=new C.$rh(()=>{this.k(`The reconnection grace time of ${s(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new C.$rh(()=>{this.k(`The reconnection short grace time of ${s(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${s(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${s(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,v,p){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,p),this.protocol.endAcceptReconnection()}}e.$0m=S}),define(Ee[93],ke([1,0,29,12,7,158,57]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.InternalNLSConfiguration=e.$Ql=void 0;const P=s.$jc(C.$yg.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function p(d){return new Promise(c=>y.exists(d,c))}function D(d,c){return p(P).then(b=>{if(!b||!k.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const u=`${d}||${c}`;let g=v.get(u);return g||(g=S.getNLSConfiguration(k.default.commit,c,P,d,d).then(h=>(E.is(h)&&(h._languagePackSupport=!0),h.locale!=="en"&&h.locale!=="en-us"&&Object.keys(h.availableLanguages).length===0&&v.delete(u),h)),v.set(u,g)),g})}e.$Ql=D;var E;(function(d){function c(b){const u=b;return u&&typeof u._languagePackId=="string"}d.is=c})(E||(e.InternalNLSConfiguration=E={}));const w=async d=>{try{const c=m(await y.promises.readFile(d,"utf8"));return JSON.parse(c).locale}catch(c){return c.code!=="ENOENT"&&console.warn(c),"en"}};e.$Rl=w;const m=d=>{const c=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return d.replace(c,(b,u,g,h,f)=>{if(h)return"";if(f){const l=f.length;return l>2&&f[l-1]===`
`?f[l-2]==="\r"?`\r
`:`
`:""}else return b})}}),define(Ee[131],ke([1,0,19,4,26,47,59,16,5,13,31,34,33,93]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=void 0;let d=class extends k.$aq{constructor(b,u,g,h,f,l,t,r){super(C.URI.file(f.builtinExtensionsPath),C.URI.file(f.extensionsPath),(0,y.$Rg)(f.userHome,".vscode-oss-dev","extensions","control.json"),b.defaultProfile,b,u,g,h,f,l,t,r),this.R=f}async f(b){const u=await(0,m.$Ql)(b,this.R.userDataPath);if(m.InternalNLSConfiguration.is(u))try{const g=await this.w.readFile(C.URI.file(u._translationsConfigFile));return JSON.parse(g.value.toString())}catch{}return Object.create(null)}};e.$oP=d,e.$oP=d=Le([Ne(0,w.$bl),Ne(1,S.$8p),Ne(2,P.$Bk),Ne(3,p.$yj),Ne(4,s.$mi),Ne(5,D.$Qj),Ne(6,E.$_k),Ne(7,v.$di)],d)}),define(Ee[266],ke([1,0,267,29,7,22,12,23]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var p;(function(b){b[b.None=0]="None",b[b.Optional=1]="Optional",b[b.Mandatory=2]="Mandatory"})(p||(e.ServerConnectionTokenType=p={}));class D{constructor(){this.type=0}validate(u){return!0}}e.$$m=D;class E{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.$_m=E;class w{constructor(u){this.message=u}}e.$an=w;async function m(b,u){const g=b["without-connection-token"],h=b["connection-token"],f=b["connection-token-file"];if(g)return typeof h<"u"||typeof f<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new D;if(typeof f<"u"){if(typeof h<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=C.readFileSync(f).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${f}'.`)}return v.test(l)?new E(l):new w(`The connection token defined in '${f} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof h<"u"?v.test(h)?new E(h):new w(`The connection token '${h} does not adhere to the characters 0-9, a-z, A-Z or -.`):new E(await u())}e.$bn=m;async function d(b){return m(b,async()=>{if(!b["user-data-dir"])return(0,S.$Ag)();const g=s.$jc(b["user-data-dir"],"token");try{const l=(await P.Promises.readFile(g)).toString().replace(/\r?\n$/,"");if(v.test(l))return l}catch{}const h=(0,S.$Ag)();try{await P.Promises.writeFile(g,h,{mode:384})}catch{}return h})}e.$cn=d;function c(b,u,g){if(b.validate(g.query[k.$rg]))return!0;const h=y.parse(u.headers.cookie||"");return b.validate(h[k.$qg])}e.$dn=c}),define(Ee[48],ke([1,0,203,109,67,5,26,75]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":s.$0l["user-data-dir"],"enable-smoke-test-driver":s.$0l["enable-smoke-test-driver"],"disable-telemetry":s.$0l["disable-telemetry"],"disable-workspace-trust":s.$0l["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:s.$0l.log,logsPath:s.$0l.logsPath,"force-disable-user-env":s.$0l["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":s.$0l["extensions-dir"],"extensions-download-dir":s.$0l["extensions-download-dir"],"builtin-extensions-dir":s.$0l["builtin-extensions-dir"],"install-extension":s.$0l["install-extension"],"install-builtin-extension":s.$0l["install-builtin-extension"],"update-extensions":s.$0l["update-extensions"],"uninstall-extension":s.$0l["uninstall-extension"],"list-extensions":s.$0l["list-extensions"],"locate-extension":s.$0l["locate-extension"],"show-versions":s.$0l["show-versions"],category:s.$0l.category,force:s.$0l.force,"do-not-sync":s.$0l["do-not-sync"],"pre-release":s.$0l["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:s.$0l.help,version:s.$0l.version,"locate-shell-integration-path":s.$0l["locate-shell-integration-path"],compatibility:{type:"string"},_:s.$0l._},e.$Sm=(0,S.$fi)(k.$li);class v extends C.$Om{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$Tm=v,Le([P.$Ih],v.prototype,"userRoamingDataHome",null)}),define(Ee[268],ke([1,0,306,251,269,27]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=void 0;class k extends y.AppInsightsCore{constructor(v){super(),this.a=v}track(v){const p=v.baseData||{};p.properties||(p.properties={}),p.measurements||(p.measurements={});try{const D=S.cpus();p.measurements.cores=D.length,p.properties["common.cpuModel"]=D[0].model}catch{}try{p.measurements.memoryFree=S.freemem(),p.measurements.memoryTotal=S.totalmem()}catch{}try{p.properties["common.shell"]=S.userInfo().shell,p.properties["common.release"]=S.release(),p.properties["common.arch"]=S.arch()}catch{}try{const D=(/^http:/.test(this.a)?s:C).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});D.on("error",()=>{}),D.write(JSON.stringify(p)),D.end()}catch{}}}e.$pP=k}),define(Ee[270],ke([1,0,29,23,78,87,267,89,39,61,3,13,48,7,12,22,31,46,20,4,14,9,93,58]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.CacheControl=e.$OP=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(Z,ee,fe,ue){ee.writeHead(fe,{"Content-Type":"text/plain"}),ee.end(ue)}e.$OP=n;var i;(function(Z){Z[Z.NO_CACHING=0]="NO_CACHING",Z[Z.ETAG=1]="ETAG",Z[Z.NO_EXPIRY=2]="NO_EXPIRY"})(i||(e.CacheControl=i={}));async function a(Z,ee,fe,ue,j,H){try{const q=await C.Promises.stat(Z);if(ee===1){const J=`W/"${[q.ino,q.size,q.mtime.getTime()].join("-")}"`;if(ue.headers["if-none-match"]===J)return j.writeHead(304),void j.end();H.Etag=J}else ee===2?H["Cache-Control"]="public, max-age=31536000":ee===0&&(H["Cache-Control"]="no-store");H["Content-Type"]=o[(0,m.$oc)(Z)]||(0,p.$ts)(Z)||"text/plain",j.writeHead(200,H),(0,y.createReadStream)(Z).pipe(j)}catch(q){return q.code!=="ENOENT"?(fe.error(q),console.error(q.toString())):console.error(`File not found: ${Z}`),j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}}e.$PP=a;const $=(0,m.$mc)(d.$yg.asFileUri("").fsPath);let A=class{constructor(ee,fe,ue,j,H){this.f=ee,this.g=fe,this.h=ue,this.i=j,this.j=H,this.a=this.j.extensionsGallery?.resourceUrlTemplate?h.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const q=(0,r.$nl)(H);this.b=`${q}/static`,this.c=`${q}/callback`,this.d="/web-extension-resource"}async handle(ee,fe,ue){try{const j=ue.pathname;return j.startsWith(this.b)&&j.charCodeAt(this.b.length)===47?this.k(ee,fe,ue):j==="/"?this.n(ee,fe,ue):j===this.c?this.p(fe):j.startsWith(this.d)&&j.charCodeAt(this.d.length)===47?this.m(ee,fe,ue):n(ee,fe,404,"Not found.")}catch(j){return this.h.error(j),console.error(j.toString()),n(ee,fe,500,"Internal Server Error.")}}async k(ee,fe,ue){const j=Object.create(null),q=decodeURIComponent(ue.pathname).substring(this.b.length+1),J=(0,m.$jc)($,q);return(0,v.$fg)(J,$,!D.$e)?a(J,this.g.isBuilt?2:1,this.h,ee,fe,j):n(ee,fe,400,"Bad request.")}l(ee){const fe=ee.authority.indexOf(".");return fe!==-1?ee.authority.substring(fe+1):void 0}async m(ee,fe,ue){if(!this.a)return n(ee,fe,500,"No extension gallery service configured.");const j=decodeURIComponent(ue.pathname),H=(0,m.$hc)(j.substring(this.d.length+1)),q=h.URI.parse(H).with({scheme:this.a.scheme,authority:H.substring(0,H.indexOf("/")),path:H.substring(H.indexOf("/")+1)});if(this.l(this.a)!==this.l(q))return n(ee,fe,403,"Request Forbidden");const J={},ne=ge=>{const B=ee.headers[ge];B&&((0,l.$Sf)(B)||B[0])?J[ge]=(0,l.$Sf)(B)?B:B[0]:ge!==ge.toLowerCase()&&ne(ge.toLowerCase())};ne("X-Client-Name"),ne("X-Client-Version"),ne("X-Machine-Id"),ne("X-Client-Commit");const x=await this.i.request({type:"GET",url:q.toString(!0),headers:J},g.CancellationToken.None),G=x.res.statusCode||500;if(G!==200){let ge=null;try{ge=await(0,u.$yp)(x)}catch{}return n(ee,fe,G,ge||`Request failed with status ${G}`)}const se=Object.create(null),ce=ge=>{const B=x.res.headers[ge];B?se[ge]=B:ge!==ge.toLowerCase()&&ce(ge.toLowerCase())};ce("Cache-Control"),ce("Content-Type"),fe.writeHead(200,se);const re=await(0,f.$Ee)(x.stream);return void fe.end(re.buffer)}async n(ee,fe,ue){const j=ue.query[d.$rg];if(typeof j=="string"){const N=Object.create(null);N["Set-Cookie"]=k.serialize(d.$qg,j,{sameSite:"lax",maxAge:60*60*24*7});const U=Object.create(null);for(const ie in ue.query)ie!==d.$rg&&(U[ie]=ue.query[ie]);const te=S.format({pathname:"/",query:U});return N.Location=te,fe.writeHead(302,N),void fe.end()}const H=!this.g.isBuilt&&this.g.args["use-test-resolver"],q=H?"test+test":"remote";if(!q)return n(ee,fe,400,"Bad request.");function J(N){return JSON.stringify(N).replace(/"/g,"&quot;")}let ne;this.g.args["enable-smoke-test-driver"]&&(ne=!1);const x=N=>N&&h.URI.file(s.resolve(N)).with({scheme:d.Schemas.vscodeRemote,authority:q}),G=d.$yg.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,se=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,c.$Ag)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ce=(0,e.$SP)((0,e.$UP)(ee)),re=(0,e.$TP)((0,e.$UP)(ee)),ge={codeServerVersion:this.j.codeServerVersion,rootEndpoint:ce,updateEndpoint:this.g.args["disable-update-check"]?void 0:ce+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?ce+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??ce+"/proxy/{{port}}/",serviceWorker:{scope:re+"/",path:ce+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const N=JSON.parse((await C.Promises.readFile((0,m.$jc)($,"product.overrides.json"))).toString());Object.assign(ge,N)}catch{}const B={remoteAuthority:q,webviewEndpoint:re+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledFileUploads:!this.g.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:ne,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:x(this.g.args["default-folder"]),workspaceUri:x(this.g.args["default-workspace"]),productConfiguration:ge,callbackRoute:this.c},W=this.g.args.locale||await(0,t.$Rl)(this.g.argvResource.fsPath),F=await(0,t.$Ql)(W,this.g.userDataPath),z=this.j.extensionsGallery?.nlsBaseUrl,_={WORKBENCH_WEB_CONFIGURATION:J(B),WORKBENCH_AUTH_SESSION:se?J(se):"",WORKBENCH_WEB_BASE_URL:re+this.b,WORKBENCH_NLS_BASE_URL:re+(z?`${z}${z.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:ce,VS_BASE:re,NLS_CONFIGURATION:J(F)};if(H){const N=[];for(const U of["vscode-test-resolver","github-authentication"]){const te=JSON.parse((await C.Promises.readFile(d.$yg.asFileUri(`${d.$tg}/${U}/package.json`).fsPath)).toString());N.push({extensionPath:U,packageJSON:te})}_.WORKBENCH_BUILTIN_EXTENSIONS=J(N)}let Q;try{Q=(await C.Promises.readFile(G)).toString().replace(/\{\{([^}]+)\}\}/g,(U,te)=>_[te]??"undefined")}catch{return fe.writeHead(404,{"Content-Type":"text/plain"}),void fe.end("Not found")}const Y={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(Q).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(Y["Set-Cookie"]=k.serialize(d.$qg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),fe.writeHead(200,Y),void fe.end(Q)}o(ee){const fe=/<script>([\s\S]+?)<\/script>/img,ue=[];let j;for(;j=fe.exec(ee);){const H=P.createHash("sha256"),q=j[1].replace(/\r\n/g,`
`),J=H.update(Buffer.from(q)).digest().toString("base64");ue.push(`'sha256-${J}'`)}return ue}async p(ee){const fe=d.$yg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,ue=(await C.Promises.readFile(fe)).toString(),j=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(ue).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return ee.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":j}),void ee.end(ue)}};e.$QP=A,e.$QP=A=Le([Ne(1,w.$Sm),Ne(2,E.$yj),Ne(3,u.$tp),Ne(4,b.$Qj)],A);const R=(Z,ee=!1)=>Z.replace(/\/\/+/g,"/").replace(/\/+$/,ee?"/":"");e.$RP=R;const I=Z=>{const ee=(Z.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$RP)("./"+(ee>1?"../".repeat(ee-1):""))};e.$SP=I;const O=Z=>{const ee=Z.split("?",1)[0].split("/");return(0,e.$RP)("./"+ee[ee.length-1])};e.$TP=O;const M=Z=>Z.originalUrl||Z.url;e.$UP=M}),define(Ee[271],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=void 0,e.$vO=(0,y.$ei)("IExtHostInitDataService")}),define(Ee[272],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=e.$fO=void 0,e.$fO=(0,y.$ei)("IExtHostRpcService");class C{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.dispose=S.dispose.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.$gO=C}),define(Ee[72],ke([1,0,53]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;function C(S){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:S,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function s(S){return new y.$en(C(S))}e.$cs=s}),define(Ee[273],ke([1,0,3,42,4,72,53,105,243,7,19]),function(le,e,y,C,s,S,k,P,v,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class E{constructor(m,d,c,b){this.b=m,this.c=d,this.d=c,this.e=b}async call(m,d,c){switch(d){case"getEnvironmentData":{const b=c,u=(0,S.$cs)(b.remoteAuthority);let g=await this.f(b.profile);return g=(0,k.$gn)(g,u),g}case"getExtensionHostExitInfo":{const b=c;return this.e.getExitInfo(b.reconnectionToken)}case"getDiagnosticInfo":{const b=c,u={machineInfo:(0,v.$gs)()},g=b.includeProcesses?(0,P.$es)(process.pid):Promise.resolve();let h=[];const f={};if(b.folders){const l=(0,S.$cs)("");h=b.folders.map(r=>s.URI.revive(l.transformIncoming(r))).filter(r=>r.scheme==="file").map(r=>(0,v.$fs)(r.fsPath,["node_modules",".git"]).then(o=>{f[(0,p.$nc)(r.fsPath)]=o}))}return Promise.all([g,...h]).then(([l,t])=>(u.processes=l||void 0,u.workspaceMetadata=b.folders?f:void 0,u))}}throw new Error(`IPC Command ${d} not found`)}listen(m,d,c){throw new Error("Not supported")}async f(m){m&&!this.d.profiles.some(c=>c.id===m)&&await this.d.createProfile(m,m);let d=!1;if(process.platform==="linux"){const c=process.glibcVersion;d=(c?parseInt(c.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:s.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,D.$Rg)(this.c.logsHome,`exthost${E.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:C.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(c=>({...c}))},isUnsupportedGlibc:d}}}e.$js=E,E.a=1}),define(Ee[274],ke([1,0,4,72,70,7,228]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0;class P extends k.$ks{constructor(D,E){super(new s.$Nq(D),D),this.N=E,this.M=new Map,this.B(this.a)}c(D){let E=this.M.get(D.remoteAuthority);return E||(E=(0,C.$cs)(D.remoteAuthority),this.M.set(D.remoteAuthority,E)),E}f(D,E,w=!1){if(w&&E.path==="/vscode-resource"&&E.query){const m=JSON.parse(E.query).requestResourcePath;return y.URI.from({scheme:"file",path:m})}return y.URI.revive(D.transformIncoming(E))}L(D,E){return new v(D,E,this.b,this.N)}}e.$ms=P;class v extends k.$ls{constructor(D,E,w,m){super(D,E,w,m)}j(D){const E=D.args["file-watcher-polling"];if(E){const w=E.split(S.$tc),m=Number(w[0]);if(m>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:m}}}m(D){if(D.extensionsPath)return[S.$gc.join(D.extensionsPath,"**")]}}}),define(Ee[94],ke([1,0,206,9,4,2,5,37,16,12,40,167,65]),function(le,e,y,C,s,S,k,P,v,p,D,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.$fF=e.EditorsOrder=e.$eF=e.CloseDirection=e.$dF=e.$cF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.EditorInputCapabilities=e.$6E=e.SaveReason=e.Verbosity=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$SE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$UE="workbench.editor.sidebysideEditor",e.$VE="workbench.editors.textDiffEditor",e.$WE="workbench.editors.binaryResourceDiffEditor";var m;(function(B){B[B.PROGRAMMATIC=1]="PROGRAMMATIC",B[B.USER=2]="USER",B[B.EDIT=3]="EDIT",B[B.NAVIGATION=4]="NAVIGATION",B[B.JUMP=5]="JUMP"})(m||(e.EditorPaneSelectionChangeReason=m={}));var d;(function(B){B[B.IDENTICAL=1]="IDENTICAL",B[B.SIMILAR=2]="SIMILAR",B[B.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function c(B){const W=B;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}e.$XE=c;function b(B,W,F){for(const z of F.visibleEditorPanes)if(z.group.id===W&&B.matches(z.input))return z.getViewState()}e.$YE=b;function u(B){if($(B))return!1;const W=B;return s.URI.isUri(W?.resource)}e.$ZE=u;function g(B){if($(B))return!1;const W=B;return W?.original!==void 0&&W.modified!==void 0}e.$1E=g;function h(B){if($(B))return!1;const W=B;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}e.$2E=h;function f(B){if($(B)||g(B))return!1;const W=B;return W?.primary!==void 0&&W.secondary!==void 0}e.$3E=f;function l(B){if($(B))return!1;const W=B;return W?W.resource===void 0||W.resource.scheme===p.Schemas.untitled||W.forceUntitled===!0:!1}e.$4E=l;function t(B){if($(B))return!1;const W=B;return s.URI.isUri(W?.base?.resource)&&s.URI.isUri(W?.input1?.resource)&&s.URI.isUri(W?.input2?.resource)&&s.URI.isUri(W?.result?.resource)}e.$5E=t;var r;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var o;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class n{constructor(){this.a=new Map}registerSource(W,F){let z=this.a.get(W);return z||(z={source:W,label:F},this.a.set(W,z)),z.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$6E=new n;var i;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription",B[B.CanDropIntoEditor=128]="CanDropIntoEditor",B[B.MultipleEditors=256]="MultipleEditors",B[B.Scratchpad=512]="Scratchpad",B[B.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(i||(e.EditorInputCapabilities=i={}));class a extends S.$Tc{}e.$7E=a;function $(B){return B instanceof a}e.$8E=$;function A(B){const W=B;return s.URI.isUri(W?.preferredResource)}function R(B){const W=B;return $(W?.primary)&&$(W?.secondary)}e.$9E=R;function I(B){const W=B;return $(W?.modified)&&$(W?.original)}e.$0E=I;function O(B,W,F,z,_){return ge(z,[(0,E.$1i)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const Q={...F,limits:{size:Number.MAX_VALUE}};B.openEditor(W,Q)}}),(0,E.$1i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>_.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$$E=O;function M(B){return $(B?.editor)}e.$_E=M;function Z(B){const W=B;return M(B)&&W?.group!==void 0}e.$aF=Z;function ee(B){const W=B;return typeof W?.groupId=="number"&&$(W.editor)}e.$bF=ee;var fe;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(fe||(e.EditorCloseContext=fe={}));var ue;(function(B){B[B.GROUP_ACTIVE=0]="GROUP_ACTIVE",B[B.GROUP_INDEX=1]="GROUP_INDEX",B[B.GROUP_LABEL=2]="GROUP_LABEL",B[B.GROUP_LOCKED=3]="GROUP_LOCKED",B[B.EDITOR_OPEN=4]="EDITOR_OPEN",B[B.EDITOR_CLOSE=5]="EDITOR_CLOSE",B[B.EDITOR_MOVE=6]="EDITOR_MOVE",B[B.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",B[B.EDITOR_LABEL=8]="EDITOR_LABEL",B[B.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",B[B.EDITOR_PIN=10]="EDITOR_PIN",B[B.EDITOR_STICKY=11]="EDITOR_STICKY",B[B.EDITOR_DIRTY=12]="EDITOR_DIRTY",B[B.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(ue||(e.GroupModelChangeKind=ue={}));var j;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class H{getOriginalUri(W,F){if(!W)return;if(t(W))return e.$dF.getOriginalUri(W.result,F);if(F?.supportSideBySide){const{primary:_,secondary:Q}=this.a(W);if(_&&Q){if(F?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(_,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:F.filterByScheme})};if(F?.supportSideBySide===j.ANY)return this.getOriginalUri(_,{filterByScheme:F.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:F.filterByScheme});W=F.supportSideBySide===j.PRIMARY?_:Q}}if(g(W)||h(W)||f(W)||t(W))return;const z=A(W)?W.preferredResource:W.resource;return!z||!F||!F.filterByScheme?z:this.b(z,F.filterByScheme)}a(W){return R(W)||f(W)?{primary:W.primary,secondary:W.secondary}:I(W)||g(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,F){if(!W)return;if(t(W))return e.$dF.getCanonicalUri(W.result,F);if(F?.supportSideBySide){const{primary:_,secondary:Q}=this.a(W);if(_&&Q){if(F?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(_,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:F.filterByScheme})};if(F?.supportSideBySide===j.ANY)return this.getCanonicalUri(_,{filterByScheme:F.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:F.filterByScheme});W=F.supportSideBySide===j.PRIMARY?_:Q}}if(g(W)||h(W)||f(W)||t(W))return;const z=W.resource;return!z||!F||!F.filterByScheme?z:this.b(z,F.filterByScheme)}b(W,F){if(Array.isArray(F)){if(F.some(z=>W.scheme===z))return W}else if(F===W.scheme)return W}}var q;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.KEYBOARD=1]="KEYBOARD",B[B.MOUSE=2]="MOUSE"})(q||(e.EditorCloseMethod=q={}));function J(B,W,F,z){if(!B.isSticky(W))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return F===q.MOUSE||F===q.KEYBOARD;case"mouse":return F===q.MOUSE;case"keyboard":return F===q.KEYBOARD}return!1}e.$cF=J,e.$dF=new H;var ne;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(ne||(e.CloseDirection=ne={}));class x{constructor(){this.c=new Map,this.d=new Map}start(W){const F=this.a=W.get(k.$di);for(const[z,_]of this.c)this.e(z,_,F);this.c.clear()}e(W,F,z){const _=z.createInstance(F);this.d.set(W,_)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,C.$4f)(this.b)}registerEditorSerializer(W,F){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,F,this.a):this.c.set(W,F),(0,S.$Rc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}P.$Un.add(e.$SE.EditorFactory,new x);async function G(B,W,F){return!B||!B.length?[]:await Promise.all(B.map(async z=>{const _=s.URI.revive(z.fileUri);if(!_){F.info("Cannot resolve the path because it is not valid.",z);return}if(!await W.canHandleResource(_)){F.info("Cannot resolve the path because it cannot be handled",z);return}let K=z.exists,X=z.type;if(typeof K!="boolean"||typeof X!="number")try{X=(await W.stat(_)).isDirectory?v.FileType.Directory:v.FileType.Unknown,K=!0}catch(N){F.error(N),K=!1}if(!K&&z.openOnlyIfExists){F.info("Cannot resolve the path because it does not exist",z);return}if(X===v.FileType.Directory){F.info("Cannot resolve the path because it is a directory",z);return}const Y={...z.options,pinned:!0};return K?{resource:_,options:Y}:{resource:_,options:Y,forceUntitled:!0}}))}e.$eF=G;var se;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})(se||(e.EditorsOrder=se={}));function ce(B){const W=B;if(!W)return!1;const F=W;if(F.modified)return ce(F.modified);const z=W;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$fF=ce;function re(B){return(0,D.$3i)(B)}e.$gF=re;function ge(B,W,F){const z=(0,D.$4i)(B,W);return z.forceMessage=F?.forceMessage,z.forceSeverity=F?.forceSeverity,z.allowDialog=F?.allowDialog,z}e.$hF=ge}),define(Ee[275],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=void 0,e.$IO=(0,y.$ei)("environmentVariableService")}),define(Ee[276],ke([1,0,7,4,62,3,254,9]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=void 0;function v(l,t){if(t)if(S.$c)for(const r in t){let o=r;for(const i in l)if(r.toLowerCase()===i.toLowerCase()){o=i;break}const n=t[r];n!==void 0&&p(l,o,n)}else Object.keys(t).forEach(r=>{const o=t[r];o!==void 0&&p(l,r,o)})}e.$0O=v;function p(l,t,r){typeof r=="string"?l[t]=r:delete l[t]}function D(l,t,r,o){l.TERM_PROGRAM="vscode",t&&(l.TERM_PROGRAM_VERSION=t),m(l,o)&&(l.LANG=d(r)),l.COLORTERM="truecolor"}e.$$O=D;function E(l,t){if(t)for(const r of Object.keys(t)){const o=t[r];o!=null&&(l[r]=o)}}async function w(l,t){return await Promise.all(Object.entries(t).map(async([r,o])=>{if(typeof o=="string")try{t[r]=await l(o)}catch{t[r]=o}})),t}function m(l,t){if(t==="on")return!0;if(t==="auto"){const r=l.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.$_O=m;function d(l){const t=l?l.split("-"):[],r=t.length;if(r===0)return"en_US.UTF-8";if(r===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$aP=d;async function c(l,t,r,o,n,i){if(l.cwd){const $=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,A=await b($,r);return(0,k.$8O)(A||$)}let a;return!l.ignoreConfigurationCwd&&n&&(r&&(n=await b(n,r,i)),n&&(y.$ic(n)?a=n:o&&(a=y.$jc(o.fsPath,n)))),a||(a=o?o.fsPath:t||""),(0,k.$8O)(a)}e.$bP=c;async function b(l,t,r){if(t)try{return await t(l)}catch(o){r?.error("Could not resolve terminal cwd",o);return}return l}function u(l,t,r){if(r)return o=>r.resolveWithEnvironment(t,l,o)}e.$cP=u;async function g(l,t,r,o,n,i){const a={};if(l.strictEnv)E(a,l.env);else{E(a,i);const $={...t};r&&($&&await w(r,$),l.env&&await w(r,l.env)),S.$d&&(a.VSCODE_NODE_OPTIONS&&(a.NODE_OPTIONS=a.VSCODE_NODE_OPTIONS,delete a.VSCODE_NODE_OPTIONS),a.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(a.NODE_REPL_EXTERNAL_MODULE=a.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete a.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,s.$4l)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),v(a,$),v(a,l.env),D(a,o,S.$q,n)}return a}e.$dP=g;async function h(l,t,r,o,n,i,a=S.$c){let $;if((0,P.$Sf)(l)?$=l:($=l.fsPath,a&&i!==1?$=$.replace(/\\/g,"/"):!a&&i===1&&($=$.replace(/\//g,"\\"))),!t)return $;const A=$.includes(" "),R=$.includes("(")||$.includes(")"),I=y.$nc(t,".exe"),O=I==="pwsh"||r==="pwsh"||I==="powershell"||r==="powershell";if(O&&(A||$.includes("'")))return`& '${$.replace(/'/g,"''")}'`;if(R&&O)return`& '${$}'`;if(i===1){if(o!==void 0)return o==="gitbash"?(0,k.$6O)($.replace(/\\/g,"/")):o==="wsl"?n?.getWslPath($,"win-to-unix")||$:A?`"${$}"`:$;const M=t.toLowerCase();return M.includes("wsl")||M.includes("bash.exe")&&!M.toLowerCase().includes("git")?n?.getWslPath($,"win-to-unix")||$:A?`"${$}"`:$}return(0,k.$6O)($)}e.$eP=h;function f(l,t,r){const o=typeof l=="string"?C.URI.parse(l):l;let n=o?t.getWorkspaceFolder(o)??void 0:void 0;if(!n){const i=r.getLastActiveWorkspaceRoot();n=i?t.getWorkspaceFolder(i)??void 0:void 0}return n}e.$fP=f}),define(Ee[73],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(S){S.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var C;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class s{static fromExtHostTestItem(k,P,v=k.parent){if(k._isRoot)return new s([P]);const p=[k.id];for(let D=v;D&&D.id!==P;D=D.parent)p.push(D.id);return p.push(P),new s(p.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const P=k.indexOf("\0");return P===-1?k:k.slice(0,P)}static fromString(k){return new s(k.split("\0"))}static join(k,P){return new s([...k.path,P])}static joinToString(k,P){return k.toString()+"\0"+P}static parentId(k){const P=k.lastIndexOf("\0");return P===-1?void 0:k.slice(0,P)}static localId(k){const P=k.lastIndexOf("\0");return P===-1?k:k.slice(P+1)}static isChild(k,P){return P.startsWith(k)&&P[k.length]==="\0"}static compare(k,P){return k===P?0:s.isChild(k,P)?2:s.isChild(P,k)?3:1}constructor(k,P=k.length){if(this.path=k,this.d=P,k.length===0||P<1)throw new Error("cannot create test with empty path")}get rootId(){return new s(this.path,1)}get parentId(){return this.d>1?new s(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let k=1;k<=this.d;k++)yield new s(this.path,k)}*idsToRoot(){for(let k=this.d;k>0;k--)yield new s(this.path,k)}compare(k){if(typeof k=="string")return s.compare(this.toString(),k);for(let P=0;P<k.d&&P<this.d;P++)if(k.path[P]!==this.path[P])return 1;return k.d>this.d?2:k.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let k=1;k<this.d;k++)this.c+="\0",this.c+=this.path[k]}return this.c}}e.$RK=s}),define(Ee[95],ke([1,0,4,80,44,73]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$YK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$XK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$WK=e.$VK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$UK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$TK=e.$SK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var k;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(k||(e.TestResultState=k={}));var P;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var v;(function(j){j[j.Run=2]="Run",j[j.Debug=4]="Debug",j[j.Coverage=8]="Coverage",j[j.HasNonDefaultProfile=16]="HasNonDefaultProfile",j[j.HasConfigurable=32]="HasConfigurable",j[j.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.$SK=[2,4,8,16,32,64];const p=j=>"runId"in j;e.$TK=p;var D;(function(j){j.serialize=H=>({range:H.range.toJSON(),uri:H.uri.toJSON()}),j.deserialize=(H,q)=>({range:s.$7s.lift(q.range),uri:H.asCanonicalUri(y.URI.revive(q.uri))})})(D||(e.IRichLocation=D={}));var E;(function(j){j[j.Error=0]="Error",j[j.Output=1]="Output"})(E||(e.TestMessageType=E={}));var w;(function(j){j.serialize=H=>({message:H.message,type:0,expected:H.expected,actual:H.actual,contextValue:H.contextValue,location:H.location&&D.serialize(H.location)}),j.deserialize=(H,q)=>({message:q.message,type:0,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&D.deserialize(H,q.location)})})(w||(e.ITestErrorMessage=w={}));const m=(j,H)=>`${H?"s":"e"}${j}`;e.$UK=m;var d;(function(j){j.serialize=H=>({message:H.message,type:1,offset:H.offset,length:H.length,location:H.location&&D.serialize(H.location)}),j.deserialize=(H,q)=>({message:q.message,type:1,offset:q.offset,length:q.length,location:q.location&&D.deserialize(H,q.location)})})(d||(e.ITestOutputMessage=d={}));var c;(function(j){j.serialize=H=>H.type===0?w.serialize(H):d.serialize(H),j.deserialize=(H,q)=>q.type===0?w.deserialize(H,q):d.deserialize(H,q)})(c||(e.ITestMessage=c={}));var b;(function(j){j.serializeWithoutMessages=H=>({state:H.state,duration:H.duration,messages:[]}),j.serialize=H=>({state:H.state,duration:H.duration,messages:H.messages.map(c.serialize)}),j.deserialize=(H,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(J=>c.deserialize(H,J))})})(b||(e.ITestTaskState=b={}));const u="\0",g=(j,H)=>j+u+H;e.$VK=g;const h=j=>{const H=j.indexOf(u);return{ctrlId:j.slice(0,H),tagId:j.slice(H+1)}};e.$WK=h;var f;(function(j){j.serialize=H=>({extId:H.extId,label:H.label,tags:H.tags,busy:H.busy,children:void 0,uri:H.uri?.toJSON(),range:H.range?.toJSON()||null,description:H.description,error:H.error,sortText:H.sortText}),j.deserialize=(H,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?H.asCanonicalUri(y.URI.revive(q.uri)):void 0,range:q.range?s.$7s.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(f||(e.ITestItem=f={}));var l;(function(j){j[j.NotExpandable=0]="NotExpandable",j[j.Expandable=1]="Expandable",j[j.BusyExpanding=2]="BusyExpanding",j[j.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(j){j.serialize=H=>({expand:H.expand,item:f.serialize(H.item)}),j.deserialize=(H,q)=>({controllerId:S.$RK.root(q.item.extId),expand:q.expand,item:f.deserialize(H,q.item)})})(t||(e.InternalTestItem=t={}));var r;(function(j){j.serialize=H=>{let q;return H.item&&(q={},H.item.label!==void 0&&(q.label=H.item.label),H.item.tags!==void 0&&(q.tags=H.item.tags),H.item.busy!==void 0&&(q.busy=H.item.busy),H.item.uri!==void 0&&(q.uri=H.item.uri?.toJSON()),H.item.range!==void 0&&(q.range=H.item.range?.toJSON()),H.item.description!==void 0&&(q.description=H.item.description),H.item.error!==void 0&&(q.error=H.item.error),H.item.sortText!==void 0&&(q.sortText=H.item.sortText)),{extId:H.extId,expand:H.expand,item:q}},j.deserialize=H=>{let q;return H.item&&(q={},H.item.label!==void 0&&(q.label=H.item.label),H.item.tags!==void 0&&(q.tags=H.item.tags),H.item.busy!==void 0&&(q.busy=H.item.busy),H.item.range!==void 0&&(q.range=H.item.range?s.$7s.lift(H.item.range):null),H.item.description!==void 0&&(q.description=H.item.description),H.item.error!==void 0&&(q.error=H.item.error),H.item.sortText!==void 0&&(q.sortText=H.item.sortText)),{extId:H.extId,expand:H.expand,item:q}}})(r||(e.ITestItemUpdate=r={}));const o=(j,H)=>{H.expand!==void 0&&(j.expand=H.expand),H.item!==void 0&&(j.item=j.item?Object.assign(j.item,H.item):H.item)};e.$XK=o;var n;(function(j){j.serializeWithoutMessages=H=>({...t.serialize(H),ownComputedState:H.ownComputedState,computedState:H.computedState,tasks:H.tasks.map(b.serializeWithoutMessages)}),j.serialize=H=>({...t.serialize(H),ownComputedState:H.ownComputedState,computedState:H.computedState,tasks:H.tasks.map(b.serialize)}),j.deserialize=(H,q)=>({...t.deserialize(H,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(J=>b.deserialize(H,J)),retired:!0})})(n||(e.TestResultItem=n={}));var i;(function(j){j.empty=()=>({covered:0,total:0}),j.sum=(H,q)=>{H.covered+=q.covered,H.total+=q.total}})(i||(e.ICoveredCount=i={}));var a;(function(j){j.serialize=H=>({statement:H.statement,branch:H.branch,declaration:H.declaration,details:H.details?.map(I.serialize),uri:H.uri.toJSON()}),j.deserialize=(H,q)=>({statement:q.statement,branch:q.branch,declaration:q.declaration,details:q.details?.map(I.deserialize),uri:H.asCanonicalUri(y.URI.revive(q.uri))})})(a||(e.IFileCoverage=a={}));function $(j){return{...j,location:j.location?.toJSON()}}function A(j){return j.location=j.location?C.$6s.isIPosition(j.location)?C.$6s.lift(j.location):s.$7s.lift(j.location):void 0,j}e.$YK=3;var R;(function(j){j[j.Declaration=0]="Declaration",j[j.Statement=1]="Statement",j[j.Branch=2]="Branch"})(R||(e.DetailType=R={}));var I;(function(j){j.serialize=H=>H.type===0?M.serialize(H):Z.serialize(H),j.deserialize=H=>H.type===0?M.deserialize(H):Z.deserialize(H)})(I||(e.CoverageDetails=I={}));var O;(function(j){j.serialize=$,j.deserialize=A})(O||(e.IBranchCoverage=O={}));var M;(function(j){j.serialize=$,j.deserialize=A})(M||(e.IDeclarationCoverage=M={}));var Z;(function(j){j.serialize=H=>({...$(H),branches:H.branches?.map(O.serialize)}),j.deserialize=H=>({...A(H),branches:H.branches?.map(O.deserialize)})})(Z||(e.IStatementCoverage=Z={}));var ee;(function(j){j[j.Add=0]="Add",j[j.Update=1]="Update",j[j.DocumentSynced=2]="DocumentSynced",j[j.Remove=3]="Remove",j[j.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",j[j.Retire=5]="Retire",j[j.AddTag=6]="AddTag",j[j.RemoveTag=7]="RemoveTag"})(ee||(e.TestDiffOpType=ee={}));var fe;(function(j){j.deserialize=(H,q)=>q.op===0?{op:q.op,item:t.deserialize(H,q.item)}:q.op===1?{op:q.op,item:r.deserialize(q.item)}:q.op===2?{op:q.op,uri:H.asCanonicalUri(y.URI.revive(q.uri)),docv:q.docv}:q,j.serialize=H=>H.op===0?{op:H.op,item:t.serialize(H.item)}:H.op===1?{op:H.op,item:r.serialize(H.item)}:H})(fe||(e.TestsDiffOp=fe={}));class ue{constructor(H){this.k=H,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(H){const q=this.v();for(const J of H)switch(J.op){case 0:this.l(t.deserialize(this.k,J.item),q);break;case 1:this.o(r.deserialize(J.item),q);break;case 3:this.p(J.itemId,q);break;case 5:this.q(J.itemId);break;case 4:this.updatePendingRoots(J.amount);break;case 6:this.c.set(J.tag.id,J.tag);break;case 7:this.c.delete(J.id);break}q.complete?.()}l(H,q){const J=S.$RK.parentId(H.item.extId)?.toString();let ne;if(!J)ne=this.w(H),this.g.add(ne),this.f.set(H.item.extId,ne);else if(this.f.has(J)){const x=this.f.get(J);x.children.add(H.item.extId),ne=this.w(H,x),this.f.set(H.item.extId,ne)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(H)}`);return}return q.add?.(ne),H.expand===2&&this.h++,ne}o(H,q){const J=this.f.get(H.extId);if(J)return H.expand!==void 0&&(J.expand===2&&this.h--,H.expand===2&&this.h++),(0,e.$XK)(J,H),q.update?.(J),J}p(H,q){const J=this.f.get(H);if(!J)return;const ne=S.$RK.parentId(J.item.extId)?.toString();ne?this.f.get(ne).children.delete(J.item.extId):this.g.delete(J);const x=[[H]];for(;x.length;)for(const G of x.pop()){const se=this.f.get(G);se&&(x.push(se.children),this.f.delete(G),q.remove?.(se,se!==J),se.expand===2&&this.h--)}}q(H){}updatePendingRoots(H){this.j+=H}v(){return{}}}e.$ZK=ue}),define(Ee[132],ke([1,0,15,6,2,97,95,73]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.TestItemEventOp=void 0;var v;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const p=(g,h)=>g===h,E=Object.entries({range:(g,h)=>g===h?!0:!g||!h?!1:g.equalsRange(h),busy:p,label:p,description:p,error:p,sortText:p,tags:(g,h)=>!(g.length!==h.length||g.some(f=>!h.includes(f)))}),w=(g,h)=>{let f;for(const[l,t]of E)t(g[l],h[l])||(f?f[l]=h[l]:f={[l]:h[l]});return f};class m extends s.$Tc{get root(){return this.s.root}constructor(h){super(),this.s=h,this.f=this.B(new y.$qh(()=>this.flushDiff(),200)),this.g=this.B(new C.$5d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(h){this.h=h;for(const f of this.tree.values())this.J(f)}get resolveHandler(){return this.h}collectDiff(){const h=this.m;return this.m=[],h}pushDiff(h){switch(h.op){case 2:{for(const f of this.m)if(f.op===2&&f.uri===h.uri){f.docv=h.docv;return}break}case 1:{const f=this.m[this.m.length-1];if(f){if(f.op===1&&f.item.extId===h.item.extId){(0,k.$XK)(f.item,h.item);return}if(f.op===0&&f.item.item.extId===h.item.extId){(0,k.$XK)(f.item,h.item);return}}break}}this.m.push(h),this.f.isScheduled()||this.f.schedule()}expand(h,f){const l=this.tree.get(h);if(l){if((l.expandLevels===void 0||f>l.expandLevels)&&(l.expandLevels=f),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,f-1):t.wait().then(()=>this.L(l,f-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,f-1)):this.L(l,f-1)}}dispose(){for(const h of this.tree.values())this.s.getApiFor(h.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(h,f){switch(f.op){case 3:this.O(P.$RK.joinToString(h.fullId,f.id));break;case 0:this.z(f.item,h);break;case 5:for(const l of f.ops)this.w(h,l);break;case 1:this.C(f.new,f.old,h.fullId.toString());break;case 2:this.J(h);break;case 4:this.pushDiff({op:1,item:{extId:h.fullId.toString(),item:f.update}});break;case 6:this.y(h.actual.uri);break;default:(0,S.$9c)(f)}}y(h){h&&this.pushDiff({op:2,uri:h,docv:this.s.getDocumentVersion(h)})}z(h,f){const l=P.$RK.fromExtHostTestItem(h,this.root.id,f?.actual),t=this.s.getApiFor(h);t.parent&&t.parent!==f?.actual&&this.s.getChildren(t.parent).delete(h.id);let r=this.tree.get(l.toString());if(!r){r={fullId:l,actual:h,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},h.tags.forEach(this.D,this),this.tree.set(r.fullId.toString(),r),this.G(h,f),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(h)}}),this.I(h,r,f);return}if(r.actual===h){this.H(h,r,f);return}if(r.actual.uri?.toString()!==h.uri?.toString())return this.O(l.toString()),this.z(h,f);const o=this.s.getChildren(r.actual),n=r.actual,i=w(this.s.toITestItem(n),this.s.toITestItem(h));this.s.getApiFor(n).listener=void 0,r.actual=h,r.expand=0,i&&(i.hasOwnProperty("tags")&&(this.C(h.tags,n.tags,l.toString()),delete i.tags),this.w(r,{op:4,update:i})),this.I(h,r,f);for(const[a,$]of o)this.s.getChildren(h).get($.id)||this.O(P.$RK.joinToString(l,$.id));this.y(r.actual.uri)}C(h,f,l){const t=new Set(f.map(r=>r.id));for(const r of h)t.delete(r.id)||this.D(r);this.pushDiff({op:1,item:{extId:l,item:{tags:h.map(r=>(0,k.$VK)(this.s.controllerId,r.id))}}}),t.forEach(this.F,this)}D(h){const f=this.j.get(h.id);f?f.refCount++:(this.j.set(h.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.$VK)(this.s.controllerId,h.id)}}))}F(h){const f=this.j.get(h);f&&!--f.refCount&&(this.j.delete(h),this.pushDiff({op:7,id:(0,k.$VK)(this.s.controllerId,h)}))}G(h,f){this.s.getApiFor(h).parent=f&&f.actual!==this.root?f.actual:void 0}H(h,f,l){this.G(h,l);const t=this.s.getApiFor(h);t.parent=l?.actual,t.listener=r=>this.w(f,r),this.J(f)}I(h,f,l){this.H(h,f,l);for(const[t,r]of this.s.getChildren(h))this.z(r,f)}J(h){let f;this.h?h.resolveBarrier?f=h.resolveBarrier.isOpen()?3:2:f=h.actual.canResolveChildren?1:0:f=0,f!==h.expand&&(h.expand=f,this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:f}}),f===1&&h.expandLevels!==void 0&&this.M(h))}L(h,f){if(f<0)return;const l=[];for(const[t,r]of this.s.getChildren(h.actual)){const o=this.expand(P.$RK.joinToString(h.fullId,r.id),f);(0,y.$3g)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}M(h){if(h.resolveBarrier)return h.resolveBarrier;if(!this.h){const r=new y.$dh;return r.open(),r}h.expand=2,this.N(h);const f=h.resolveBarrier=new y.$dh,l=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(h.actual===this.root?void 0:h.actual)}catch(r){l(r)}return(0,y.$3g)(t)?t.catch(l).then(()=>{f.open(),this.J(h)}):(f.open(),this.J(h)),h.resolveBarrier}N(h){this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:h.expand}})}O(h){const f=this.tree.get(h);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:h});const l=[f];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.F(r.id);this.tree.delete(t.fullId.toString());for(const[r,o]of this.s.getChildren(t.actual))l.push(this.tree.get(P.$RK.joinToString(t.fullId,o.id)))}}}flushDiff(){const h=this.collectDiff();h.length&&this.g.fire(h)}}e.$8N=m;class d extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.$9N=d;class c extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$0N=c;class b extends Error{constructor(h,f,l){super(`TestItem with ID "${h}" is from controller "${f}" and cannot be added as a child of an item from controller "${l}".`)}}e.$$N=b;const u=(g,h,f)=>{let l=new Map;return{get size(){return l.size},forEach(t,r){for(const o of l.values())t.call(r,o,this)},[Symbol.iterator](){return l.entries()},replace(t){const r=new Map,o=new Set(l.keys()),n={op:5,ops:[]};for(const i of t){if(!(i instanceof f))throw new c(i.id);const a=h(i).controllerId;if(a!==g.controllerId)throw new b(i.id,a,g.controllerId);if(r.has(i.id))throw new d(i.id);r.set(i.id,i),o.delete(i.id),n.ops.push({op:0,item:i})}for(const i of o.keys())n.ops.push({op:3,id:i});g.listener?.(n),l=r},add(t){if(!(t instanceof f))throw new c(t.id);l.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){l.delete(t)&&g.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$_N=u}),define(Ee[133],ke([1,0,132]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=void 0;const C=new WeakMap,s=(k,P)=>{const v={controllerId:P};return C.set(k,v),v};e.$aO=s;const S=k=>{const P=C.get(k);if(!P)throw new y.$0N(k?.id||"<unknown>");return P};e.$bO=S}),define(Ee[277],ke([1,0,25,5]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=void 0,e.$cE=".vscode",e.$dE="settings",e.$eE=`${e.$cE}/${e.$dE}.json`,e.$fE="vscode://schemas/settings/default",e.$gE="vscode://schemas/settings/user",e.$hE="vscode://schemas/settings/profile",e.$iE="vscode://schemas/settings/machine",e.$jE="vscode://schemas/settings/workspace",e.$kE="vscode://schemas/settings/folder",e.$lE="vscode://schemas/launch",e.$mE="vscode://schemas/tasks",e.$nE=[1],e.$oE=[2,3,4,5,6],e.$pE=[3,4,5],e.$qE=[1,...e.$pE],e.$rE=[2,3,4,5,6],e.$sE=[3,4,5,6],e.$tE=[4,5,6],e.$uE="tasks",e.$vE="launch",e.$wE=Object.create(null),e.$wE[e.$uE]=`${e.$cE}/${e.$uE}.json`,e.$wE[e.$vE]=`${e.$cE}/${e.$vE}.json`,e.$xE=Object.create(null),e.$xE[e.$uE]=`${e.$uE}.json`,e.$yE=(0,C.$fi)(y.$Ki),e.$zE=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$AE="workbench.settings.applyToAllProfiles"}),define(Ee[134],ke([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.VariableKind=e.$4O=void 0,e.$4O=(0,y.$ei)("configurationResolverService");var C;(function(S){S.Unknown="unknown",S.Env="env",S.Config="config",S.Command="command",S.Input="input",S.ExtensionInstallFolder="extensionInstallFolder",S.WorkspaceFolder="workspaceFolder",S.Cwd="cwd",S.WorkspaceFolderBasename="workspaceFolderBasename",S.UserHome="userHome",S.LineNumber="lineNumber",S.SelectedText="selectedText",S.File="file",S.FileWorkspaceFolder="fileWorkspaceFolder",S.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",S.RelativeFile="relativeFile",S.RelativeFileDirname="relativeFileDirname",S.FileDirname="fileDirname",S.FileExtname="fileExtname",S.FileBasename="fileBasename",S.FileBasenameNoExtension="fileBasenameNoExtension",S.FileDirnameBasename="fileDirnameBasename",S.ExecPath="execPath",S.ExecInstallFolder="execInstallFolder",S.PathSeparator="pathSeparator",S.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class s extends Error{constructor(k,P){super(P),this.variable=k}}e.$5O=s}),define(Ee[278],ke([1,0,7,28,9,21,3,156,207,134,17]),function(le,e,y,C,s,S,k,P,v,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=void 0;class E{constructor(m,d,c,b){this.h=new Map,this.a=m,this.b=d,this.g=c,b&&(this.c=b.then(u=>this.i(u)))}i(m){if(k.$c){const d=Object.create(null);return Object.keys(m).forEach(c=>{d[c.toLowerCase()]=m[c]}),d}return m}resolveWithEnvironment(m,d,c){return this.l({env:this.i(m),userHome:void 0},d?d.uri:void 0,c)}async resolveAsync(m,d){const c={env:await this.c,userHome:await this.g};return this.l(c,m?m.uri:void 0,d)}async j(m,d,c,b){const u=S.$In(d);k.$c&&u.windows?Object.keys(u.windows).forEach(h=>u[h]=u.windows[h]):k.$d&&u.osx?Object.keys(u.osx).forEach(h=>u[h]=u.osx[h]):k.$e&&u.linux&&Object.keys(u.linux).forEach(h=>u[h]=u.linux[h]),delete u.windows,delete u.osx,delete u.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,m?m.uri:void 0,u,c,b)}async resolveAnyAsync(m,d,c){return this.j(m,d,c)}async resolveAnyMap(m,d,c){const b=new Map;return{newConfig:await this.j(m,d,c,b),resolvedVariables:b}}resolveWithInteractionReplace(m,d,c,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,d,c,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,d){if(this.h.has(m))throw new Error("Variable "+m+" is contributed twice.");this.h.set(m,d)}async l(m,d,c,b,u){if(s.$Sf(c))return this.m(m,d,c,b,u);if(Array.isArray(c))return Promise.all(c.map(g=>this.l(m,d,g,b,u)));if(s.$Uf(c)){const g=Object.create(null),h=await Promise.all(Object.keys(c).map(async f=>[await this.m(m,d,f,b,u),await this.l(m,d,c[f],b,u)]));for(const[f,l]of h)g[f]=l;return g}return c}m(m,d,c,b,u){return(0,D.$bf)(c,E.VARIABLE_REGEXP,async(g,h)=>{if(h.includes(E.VARIABLE_LHS))return g;let f=await this.o(m,g,h,d,b);return u?.set(h,f),f!==g&&s.$Sf(f)&&f.match(E.VARIABLE_REGEXP)&&(f=await this.m(m,d,f,b,u)),f})}n(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async o(m,d,c,b,u){let g;const h=c.split(":");h.length>1&&(c=h[0],g=h[1]);const f=r=>{const o=this.a.getFilePath();if(o)return(0,P.$0v)(o);throw new p.$5O(r,(0,v.localize)(0,null,d))},l=r=>{const o=f(r);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,P.$0v)(n)}throw new p.$5O(r,(0,v.localize)(1,null,d,y.$nc(o)))},t=r=>{if(g){const o=this.a.getFolderUri(g);if(o)return o;throw new p.$5O(r,(0,v.localize)(2,null,d,g))}if(b)return b;throw this.a.getWorkspaceFolderCount()>1?new p.$5O(r,(0,v.localize)(3,null,d)):new p.$5O(r,(0,v.localize)(4,null,d))};switch(c){case"env":if(g){if(m.env){const r=m.env[k.$c?g.toLowerCase():g];if(s.$Sf(r))return r}return""}throw new p.$5O(p.VariableKind.Env,(0,v.localize)(5,null,d));case"config":if(g){const r=this.a.getConfigurationValue(b,g);if(s.$2f(r))throw new p.$5O(p.VariableKind.Config,(0,v.localize)(6,null,d,g));if(s.$Uf(r))throw new p.$5O(p.VariableKind.Config,(0,v.localize)(7,null,d,g));return r}throw new p.$5O(p.VariableKind.Config,(0,v.localize)(8,null,d));case"command":return this.p(p.VariableKind.Command,d,g,u,"command");case"input":return this.p(p.VariableKind.Input,d,g,u,"input");case"extensionInstallFolder":if(g){const r=await this.a.getExtension(g);if(!r)throw new p.$5O(p.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,d,g));return this.n(r.extensionLocation)}throw new p.$5O(p.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,d));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,P.$0v)(this.n(t(p.VariableKind.WorkspaceFolder)));case"cwd":return b||g?(0,P.$0v)(this.n(t(p.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.$0v)(y.$nc(this.n(t(p.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new p.$5O(p.VariableKind.UserHome,(0,v.localize)(11,null,d))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new p.$5O(p.VariableKind.LineNumber,(0,v.localize)(12,null,d))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new p.$5O(p.VariableKind.SelectedText,(0,v.localize)(13,null,d))}case"file":return f(p.VariableKind.File);case"fileWorkspaceFolder":return l(p.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$nc(l(p.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return b||g?y.$lc(this.n(t(p.VariableKind.RelativeFile)),f(p.VariableKind.RelativeFile)):f(p.VariableKind.RelativeFile);case"relativeFileDirname":{const r=y.$mc(f(p.VariableKind.RelativeFileDirname));if(b||g){const o=y.$lc(this.n(t(p.VariableKind.RelativeFileDirname)),r);return o.length===0?".":o}return r}case"fileDirname":return y.$mc(f(p.VariableKind.FileDirname));case"fileExtname":return y.$oc(f(p.VariableKind.FileExtname));case"fileBasename":return y.$nc(f(p.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=y.$nc(f(p.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-y.$oc(r).length)}case"fileDirnameBasename":return y.$nc(y.$mc(f(p.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||d}case"execInstallFolder":{const r=this.a.getAppRoot();return r||d}case"pathSeparator":case"/":return y.sep;default:try{const r=g?`${c}:${g}`:c;return this.p(p.VariableKind.Unknown,d,r,u,void 0)}catch{return d}}}}p(m,d,c,b,u){if(c&&b){const g=u===void 0?b[c]:b[u+":"+c];if(typeof g=="string")return g;throw new p.$5O(m,(0,v.localize)(14,null,d))}return d}}e.$gP=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[279],ke([1,0,5,94]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oD=e.$nD=e.OpenEditorContext=e.GroupsOrder=e.$mD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$lD=void 0,e.$lD=(0,y.$ei)("editorGroupsService");var s;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(s||(e.GroupDirection=s={}));var S;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(S||(e.GroupOrientation=S={}));var k;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(k||(e.GroupLocation=k={}));var P;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(P||(e.GroupsArrangement=P={}));var v;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function p(d){const c=d;return(0,C.$8E)(c?.editor)&&(0,C.$8E)(c?.replacement)}e.$mD=p;var D;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D||(e.GroupsOrder=D={}));var E;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function w(d){const c=d;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$nD=w;function m(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$oD=m}),define(Ee[135],ke([1,0,5,279]),function(le,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=void 0,e.$pD=(0,y.$ei)("editorService"),e.$qD=-1,e.$rD=-2,e.$sD=-3;function s(S){const k=S;return typeof S=="number"||(0,C.$nD)(k)}e.$tD=s}),define(Ee[280],ke([1,0,277,119,92,90,134,94,135,12,226,275,91]),function(le,e,y,C,s,S,k,P,v,p,D,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=void 0,e.$iP="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,b,u,g,h,f,l,t,r,o){this.a=c,this.b=b,this.c=u,this.d=g,this.e=h,this.f=f,this.g=l,this.h=t,this.i=r,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,b,u,g,h,f,l,t){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),o=u?this.d.getWorkspaceFolder(u)??void 0:void 0;let n;try{n=(await this.e.resolveAnyMap(o,{shellLaunchConfig:c,configuration:b})).resolvedVariables}catch(Z){this.h.error(Z)}if(n)for(const[Z,ee]of n.entries())(/^config:/.test(Z)||Z==="selectedText"||Z==="lineNumber")&&(r[Z]=ee);const i=[];for(const[Z,ee]of this.f.collections.entries())i.push([Z,(0,S.$Yr)(ee.map),(0,S.$Zr)(ee.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),$=a.options&&a.options.extensionHostEnv,A=this.d.getWorkspace(),R=A.folders,I=u?this.d.getWorkspaceFolder(u):null,O=P.$dF.getOriginalUri(this.i.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[p.Schemas.file,p.Schemas.vscodeUserData,p.Schemas.vscodeRemote]}),M={configuration:b,resolvedVariables:r,envVariableCollections:i,shellLaunchConfig:c,workspaceId:A.id,workspaceName:this.j.getWorkspaceLabel(A),workspaceFolders:R,activeWorkspaceFolder:I,activeFileResource:O,shouldPersistTerminal:h,options:g,cols:f,rows:l,unicodeVersion:t,resolverEnv:$};return await this.b.call("$createProcess",M)}requestDetachInstance(c,b){return this.b.call("$requestDetachInstance",[c,b])}acceptDetachInstanceReply(c,b){return this.b.call("$acceptDetachInstanceReply",[c,b])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,b){return this.b.call("$detachFromProcess",[c,b])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,b){return this.b.call("$processBinary",[c,b])}start(c){return this.b.call("$start",[c])}input(c,b){return this.b.call("$input",[c,b])}acknowledgeDataEvent(c,b){return this.b.call("$acknowledgeDataEvent",[c,b])}setUnicodeVersion(c,b){return this.b.call("$setUnicodeVersion",[c,b])}shutdown(c,b){return this.b.call("$shutdown",[c,b])}resize(c,b,u){return this.b.call("$resize",[c,b,u])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,b,u){return this.b.call("$sendCommandResult",[c,b,u])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,b){return this.b.call("$installAutoReply",[c,b])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,b,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,b,u])}acceptPtyHostResolvedVariables(c,b){return this.b.call("$acceptPtyHostResolvedVariables",[c,b])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,b){return this.b.call("$getWslPath",[c,b])}setTerminalLayoutInfo(c){const u={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(c,b,u){return this.b.call("$updateTitle",[c,b,u])}updateIcon(c,b,u,g){return this.b.call("$updateIcon",[c,b,u,g])}refreshProperty(c,b){return this.b.call("$refreshProperty",[c,b])}updateProperty(c,b,u){return this.b.call("$updateProperty",[c,b,u])}getTerminalLayoutInfo(){const b={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",b)}reviveTerminalProcesses(c,b,u){return this.b.call("$reviveTerminalProcesses",[c,b,u])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$jP=m,e.$jP=m=Le([Ne(2,y.$yE),Ne(3,s.$ni),Ne(4,k.$4O),Ne(5,E.$IO),Ne(6,C.$gl),Ne(7,w.$Lr),Ne(8,v.$pD),Ne(9,D.$Bv)],m)}),define(Ee[281],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.ExtHostConnectionType=void 0;var y;(function(D){D[D.IPC=1]="IPC",D[D.Socket=2]="Socket",D[D.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class C{constructor(E){this.pipeName=E,this.type=1}serialize(E){E[C.ENV_KEY]=this.pipeName}}e.$3m=C,C.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class s{constructor(){this.type=2}serialize(E){E[s.ENV_KEY]="1"}}e.$4m=s,s.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class S{constructor(){this.type=3}serialize(E){E[S.ENV_KEY]="1"}}e.$5m=S,S.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(D){delete D[C.ENV_KEY],delete D[s.ENV_KEY],delete D[S.ENV_KEY]}function P(D,E){k(E),D.serialize(E)}e.$6m=P;function v(D){if(D[C.ENV_KEY])return p(D,new C(D[C.ENV_KEY]));if(D[s.ENV_KEY])return p(D,new s);if(D[S.ENV_KEY])return p(D,new S);throw new Error("No connection information defined in environment!")}e.$7m=v;function p(D,E){return k(D),E}}),define(Ee[282],ke([1,0,14]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Gm=e.$Fm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(C||(e.UIKind=C={}));var s;(function(p){p[p.VersionMismatch=55]="VersionMismatch",p[p.UnexpectedError=81]="UnexpectedError"})(s||(e.ExtensionHostExitCode=s={}));var S;(function(p){p[p.Initialized=0]="Initialized",p[p.Ready=1]="Ready",p[p.Terminate=2]="Terminate"})(S||(e.MessageType=S={}));function k(p){const D=y.$se.alloc(1);switch(p){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.$Fm=k;function P(p,D){if(p.byteLength!==1)return!1;switch(p.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.$Gm=P;var v;(function(p){p.Start="START_NATIVE_LOG",p.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Ee[283],ke([1,0,5,6,13,271,282,58,38,21,4,2,205]),function(le,e,y,C,s,S,k,P,v,p,D,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=e.$yO=e.$xO=e.$wO=void 0;let m=class extends E.$Tc{constructor(u,g){super(),this.s=u,this.t=g,this.a=this.B(new C.$5d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$5d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=D.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=g.createLogger(this.m,{id:v.$3o,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(g.onDidChangeLogLevel(h=>{(0,s.$Aj)(h)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===s.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,g,h){const f=this.getTelemetryDetails(),l=new d(g,h,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}),t=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(u,g,h){this.f=u,this.g=g,this.c=h??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const g=Object.create(null);switch(g["common.extname"]=`${u.publisher}.${u.name}`,g["common.extversion"]=u.version,g["common.vscodemachineid"]=this.s.telemetryInfo.machineId,g["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,g["common.sqmid"]=this.s.telemetryInfo.sqmId,g["common.vscodeversion"]=this.s.version,g["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),g["common.product"]=this.s.environment.appHost,this.s.uiKind){case k.UIKind.Web:g["common.uikind"]="web";break;case k.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.$ml)((0,v.$9o)(this.s.remote.authority)),g}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const g=this.getTelemetryDetails();this.r.forEach((h,f)=>{const l=h.filter(t=>!t.isDisposed);l.length===0?this.r.delete(f):this.r.set(f,l)}),this.r.forEach(h=>{for(const f of h)f.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,g){const f=this.r.get(u.value)?.filter(t=>!t.isDisposed);if(!f)return this.r.delete(u.value),!1;let l=!1;for(const t of f)t.ignoreUnhandledExtHostErrors||(t.logError(g),l=!0);return l}};e.$wO=m,e.$wO=m=Le([Ne(0,S.$vO),Ne(1,s.$zj)],m);class d{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,g,h,f,l,t,r){this.g=h,this.h=f,this.i=l,this.j=t,this.a=new C.$5d,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(u,g){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let g="properties"in u?u.properties??{}:u;return g=(0,v.$_o)(g,[]),this.c&&(g=(0,p.$Ln)(g,this.c)),this.b||(g=(0,p.$Ln)(g,this.j)),"properties"in u?u.properties=g:u=g,u}k(u,g){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(u,g),this.h.trace(u,g))}logUsage(u,g){this.d.isUsageEnabled&&this.k(u,g)}logError(u,g){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,g);else{const h={name:u.name,message:u.message,stack:u.stack,cause:u.cause},f=(0,v.$_o)(h,[]),l=new Error(f.message,{cause:f.cause});l.stack=f.stack,l.name=f.name,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f.sendErrorData(l,g),this.h.trace("exception",g)}}get apiTelemetryLogger(){if(!this.e){const u=this,g={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(g)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$xO=d;function c(b){const u=Date.now()-new Date(b).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$yO=c,e.$zO=(0,y.$ei)("IExtHostTelemetry")}),define(Ee[284],ke([1,0,6,4,36,234,35,5]),function(le,e,y,C,s,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.ActivationKind=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.ExtensionHostStartup=e.$TF=e.$SF=e.$RF=e.$QF=void 0,e.$QF=Object.freeze({identifier:new k.$xm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$RF="extensions.webWorker",e.$SF=(0,P.$ei)("extensionService");class v{constructor(l){this.dependency=l}}e.$TF=v;var p;(function(f){f[f.EagerAutoStart=1]="EagerAutoStart",f[f.EagerManualStart=2]="EagerManualStart",f[f.Lazy=3]="Lazy"})(p||(e.ExtensionHostStartup=p={}));class D{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,r){this.c=l,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:S.$BF.createActivationEventsMap(this.d)}}set(l,t,r){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const o=[],n=[],i=[],a=[],$=E(this.d),A=E(t),R=(ee,fe)=>ee.extensionLocation.toString()===fe.extensionLocation.toString()||ee.isBuiltin===fe.isBuiltin||ee.isUserBuiltin===fe.isUserBuiltin||ee.isUnderDevelopment===fe.isUnderDevelopment;for(const ee of this.d){const fe=A.get(ee.identifier);if(!fe){o.push(ee.identifier),$.delete(ee.identifier);continue}if(!R(ee,fe)){o.push(ee.identifier),$.delete(ee.identifier);continue}}for(const ee of t){const fe=$.get(ee.identifier);if(!fe){n.push(ee);continue}if(!R(fe,ee)){o.push(fe.identifier),$.delete(fe.identifier);continue}}const I=new k.$ym(this.e),O=new k.$ym(r);for(const ee of this.e)O.has(ee)||i.push(ee);for(const ee of r)I.has(ee)||a.push(ee);const M=S.$BF.createActivationEventsMap(n),Z={versionId:l,toRemove:o,toAdd:n,addActivationEvents:M,myToRemove:i,myToAdd:a};return this.delta(Z),Z}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:o,myToAdd:n}=l,i=new k.$ym(t),a=new k.$ym(o);for(let $=0;$<this.d.length;$++)i.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)a.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of r)this.d.push($);for(const $ of n)this.e.push($);return this.f=null,l}containsExtension(l){for(const t of this.e)if(k.$xm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=S.$BF.readActivationEvents(t);for(const o of r)l.add(o)}return l}}e.$UF=D;function E(f){const l=new k.$zm;for(const t of f)l.set(t.identifier,t);return l}function w(f,l){return!0}e.$VF=w;function m(f,l){if(!w(f,l))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.$WF=m;class d{constructor(l,t,r,o){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=o}}e.$XF=d;class c{constructor(l,t){this.description=l,this.value=t}}e.$YF=c;var b;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(b||(e.ActivationKind=b={}));function u(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,s.$fp)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation,targetPlatform:f.targetPlatform,validations:[],isValid:!0}}e.$ZF=u;function g(f,l){return{identifier:new k.$xm((0,s.$dp)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!l,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid,targetPlatform:f.targetPlatform}}e.$1F=g;class h{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$2F=h}),define(Ee[285],ke([1,0,35,208,55]),function(le,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=void 0;function S(k,P,v,p){const D=new y.$zm;return k.forEach(E=>{const w=D.get(E.identifier);w&&p.warn((0,C.localize)(0,null,w.extensionLocation.fsPath,E.extensionLocation.fsPath)),D.set(E.identifier,E)}),P.forEach(E=>{const w=D.get(E.identifier);if(w)if(w.isBuiltin){if(s.gte(w.version,E.version)){p.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}E.isBuiltin=!0}else p.warn((0,C.localize)(1,null,w.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){p.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}D.set(E.identifier,E)}),v.forEach(E=>{p.info((0,C.localize)(2,null,E.extensionLocation.fsPath));const w=D.get(E.identifier);w&&w.isBuiltin&&(E.isBuiltin=!0),D.set(E.identifier,E)}),Array.from(D.values())}e.$EP=S}),define(Ee[286],ke([1,0,7,3,28,4,42,53,69,59,285,12]),function(le,e,y,C,s,S,k,P,v,p,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$HP=void 0;class w{constructor(c,b,u,g,h,f,l){this.c=c,this.d=u,this.f=g,this.g=h,this.h=f,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const t=b.args["install-builtin-extension"];if(t){h.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"]};k.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(t),o,!!b.args.force).then(()=>{k.mark("code/server/didInstallBuiltinExtensions"),h.trace("Finished installing builtin extensions")},n=>{h.error(n)})}const r=b.args["install-extension"];r&&(h.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(r),[],{isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"],isApplicationScoped:!0},!!b.args.force)).then(()=>{h.trace("Finished installing extensions")},o=>{h.error(o)}))}j(c){return c.map(b=>/\.vsix$/i.test(b)?S.URI.file((0,y.$ic)(b)?b:(0,y.$jc)((0,s.cwd)(),b)):b)}whenExtensionsReady(){return this.b}async scanExtensions(c,b,u,g){k.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const h=u?u.filter(l=>l.scheme===E.Schemas.file).map(l=>l.fsPath):void 0;b=b??this.d.defaultProfile.extensionsResource;const f=await this.k(b,c??C.$q,h,g);return this.g.trace("Scanned Extensions",f),this.r(f),k.mark("code/server/didScanExtensions"),f}async scanSingleExtension(c,b,u){await this.a;const g=c.scheme===E.Schemas.file?c.fsPath:null;if(!g)return null;const h=await this.o(g,b,u??C.$q);return h?(this.r([h]),h):null}async k(c,b,u,g){await this.q(b,g);const[h,f,l]=await Promise.all([this.m(b),this.n(c,b),this.l(b,u)]);return(0,D.$EP)(h,f,l,this.g)}async l(c,b){return b?(await Promise.all(b.map(u=>this.f.scanOneOrMultipleExtensions(S.URI.file((0,y.$kc)(u)),1,{language:c})))).flat().map(u=>(0,p.$cq)(u,!0)):[]}async m(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(u=>(0,p.$cq)(u,!1))}async n(c,b){return(await this.f.scanUserExtensions({profileLocation:c,language:b,useCache:!0})).map(g=>(0,p.$cq)(g,!1))}async o(c,b,u){const g=S.URI.file((0,y.$kc)(c)),h=b?0:1,f=await this.f.scanExistingExtension(g,h,{language:u});return f?(0,p.$cq)(f,!1):null}async q(c,b){if(!(c===C.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(g=>g.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(u){this.g.error(u)}if(!b){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${b} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([b],[],{isMachineScoped:!0},!0)}catch(u){this.g.error(u)}}}r(c){const b=(t,r)=>t.replace(/file/g,"vscode-remote"),u=t=>{let r="";return r+=t.global?"g":"",r+=t.ignoreCase?"i":"",r+=t.multiline?"m":"",new RegExp(b(t.source,!0),r)},g=new class{mapDefined(t){return v.$hj.create(t)}mapNot(t){return v.$mj.create(t)}mapEquals(t,r){return t==="resourceScheme"&&typeof r=="string"?v.$ij.create(t,b(r,!1)):v.$ij.create(t,r)}mapNotEquals(t,r){return t==="resourceScheme"&&typeof r=="string"?v.$lj.create(t,b(r,!1)):v.$lj.create(t,r)}mapGreater(t,r){return v.$nj.create(t,r)}mapGreaterEquals(t,r){return v.$oj.create(t,r)}mapSmaller(t,r){return v.$pj.create(t,r)}mapSmallerEquals(t,r){return v.$qj.create(t,r)}mapRegex(t,r){return t==="resourceScheme"&&r?v.$rj.create(t,u(r)):v.$rj.create(t,r)}mapIn(t,r){return v.$jj.create(t,r)}mapNotIn(t,r){return v.$kj.create(t,r)}},h=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const r=v.$cj.deserialize(t.when);if(!r)return;const o=r.map(g);t.when=o.serialize()},f=t=>{if(Array.isArray(t))for(const r of t)h(r);else h(t)},l=t=>{for(const r in t)f(t[r])};c.forEach(t=>{t.contributes&&(t.contributes.menus&&l(t.contributes.menus),t.contributes.keybindings&&f(t.contributes.keybindings),t.contributes.views&&l(t.contributes.views))})}}e.$HP=w;class m{constructor(c,b){this.a=c,this.b=b}listen(c,b){throw new Error("Invalid listen")}async call(c,b,u){const g=this.b(c);switch(b){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const h=u[0],f=u[1]?S.URI.revive(g.transformIncoming(u[1])):void 0,l=Array.isArray(u[2])?u[2].map(o=>S.URI.revive(g.transformIncoming(o))):void 0,t=u[3];return(await this.a.scanExtensions(h,f,l,t)).map(o=>(0,P.$gn)(o,g))}case"scanSingleExtension":{const h=await this.a.scanSingleExtension(S.URI.revive(g.transformIncoming(u[0])),u[1],u[2]);return h?(0,P.$gn)(h,g):null}}throw new Error("Invalid call")}}e.$IP=m}),define(Ee[136],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=void 0;class y{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++y.count}}e.$4v=y,y.count=0;const C=[];function s(P){const v=new y(P);return C[v.nid]=v,v}e.$5v=s;function S(P){return C[P].sid}e.$6v=S;class k{constructor(v){this.value=v}}e.$7v=k}),define(Ee[287],ke([1,0,136]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var s;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(s||(e.TabInputKind=s={}));var S;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(S||(e.TabModelOperationKind=S={}));var k;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(k||(e.WebviewEditorCapabilities=k={}));var P;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var v;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var p;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(p||(e.NotebookEditorRevealType=p={}));var D;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(D||(e.CandidatePortSource=D={}));class E{static mixin(b){return b._id=E.a++,b}}e.$ZL=E,E.a=0;var w;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var m;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(m||(e.ISuggestResultDtoField=m={}));var d;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$1L={MainThreadAuthentication:(0,y.$5v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$5v)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$5v)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$5v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$5v)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$5v)("MainThreadClipboard"),MainThreadCommands:(0,y.$5v)("MainThreadCommands"),MainThreadComments:(0,y.$5v)("MainThreadComments"),MainThreadConfiguration:(0,y.$5v)("MainThreadConfiguration"),MainThreadConsole:(0,y.$5v)("MainThreadConsole"),MainThreadDebugService:(0,y.$5v)("MainThreadDebugService"),MainThreadDecorations:(0,y.$5v)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$5v)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$5v)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$5v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$5v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$5v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$5v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$5v)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$5v)("MainThreadErrors"),MainThreadTreeViews:(0,y.$5v)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$5v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$5v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$5v)("MainThreadLanguages"),MainThreadLogger:(0,y.$5v)("MainThreadLogger"),MainThreadMessageService:(0,y.$5v)("MainThreadMessageService"),MainThreadOutputService:(0,y.$5v)("MainThreadOutputService"),MainThreadProgress:(0,y.$5v)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$5v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$5v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$5v)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$5v)("MainThreadSecretState"),MainThreadStorage:(0,y.$5v)("MainThreadStorage"),MainThreadSpeech:(0,y.$5v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$5v)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$5v)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$5v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$5v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$5v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$5v)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$5v)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$5v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$5v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$5v)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$5v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$5v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$5v)("MainThreadExtensionService"),MainThreadSCM:(0,y.$5v)("MainThreadSCM"),MainThreadSearch:(0,y.$5v)("MainThreadSearch"),MainThreadShare:(0,y.$5v)("MainThreadShare"),MainThreadTask:(0,y.$5v)("MainThreadTask"),MainThreadWindow:(0,y.$5v)("MainThreadWindow"),MainThreadLabelService:(0,y.$5v)("MainThreadLabelService"),MainThreadNotebook:(0,y.$5v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$5v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$5v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$5v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$5v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$5v)("MainThreadInteractive"),MainThreadChat:(0,y.$5v)("MainThreadChat"),MainThreadInlineChat:(0,y.$5v)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$5v)("MainThreadTheming"),MainThreadTunnelService:(0,y.$5v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$5v)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$5v)("MainThreadTimeline"),MainThreadTesting:(0,y.$5v)("MainThreadTesting"),MainThreadLocalization:(0,y.$5v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$5v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$5v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$5v)("MainThreadIssueReporter")},e.$2L={ExtHostCommands:(0,y.$5v)("ExtHostCommands"),ExtHostConfiguration:(0,y.$5v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$5v)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$5v)("ExtHostDebugService"),ExtHostDecorations:(0,y.$5v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$5v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$5v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$5v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$5v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$5v)("ExtHostEditors"),ExtHostTreeViews:(0,y.$5v)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$5v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$5v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$5v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$5v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$5v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$5v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$5v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$5v)("ExtHostStatusBar"),ExtHostShare:(0,y.$5v)("ExtHostShare"),ExtHostExtensionService:(0,y.$5v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$5v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$5v)("ExtHostTerminalService"),ExtHostSCM:(0,y.$5v)("ExtHostSCM"),ExtHostSearch:(0,y.$5v)("ExtHostSearch"),ExtHostTask:(0,y.$5v)("ExtHostTask"),ExtHostWorkspace:(0,y.$5v)("ExtHostWorkspace"),ExtHostWindow:(0,y.$5v)("ExtHostWindow"),ExtHostWebviews:(0,y.$5v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$5v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$5v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$5v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$5v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$5v)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$5v)("ExtHostProgress"),ExtHostComments:(0,y.$5v)("ExtHostComments"),ExtHostSecretState:(0,y.$5v)("ExtHostSecretState"),ExtHostStorage:(0,y.$5v)("ExtHostStorage"),ExtHostUrls:(0,y.$5v)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$5v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$5v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$5v)("ExtHostOutputService"),ExtHostLabelService:(0,y.$5v)("ExtHostLabelService"),ExtHostNotebook:(0,y.$5v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$5v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$5v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$5v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$5v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$5v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$5v)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$5v)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$5v)("ExtHostChat"),ExtHostChatAgents2:(0,y.$5v)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$5v)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$5v)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$5v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$5v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$5v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$5v)("ExtHostTheming"),ExtHostTunnelService:(0,y.$5v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$5v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$5v)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$5v)("ExtHostTimeline"),ExtHostTesting:(0,y.$5v)("ExtHostTesting"),ExtHostTelemetry:(0,y.$5v)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$5v)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$5v)("ExtHostIssueReporter")}}),define(Ee[288],ke([1,0,14,24,12,110,5]),function(le,e,y,C,s,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=(0,k.$ei)("notebookDocumentService");const P=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${P.join("")}]+`),p=7;function D(m){if(m.scheme!==s.Schemas.vscodeNotebookCell)return;const d=m.fragment.indexOf("s");if(d<0)return;const c=parseInt(m.fragment.substring(0,d).replace(v,""),p),b=(0,y.$Le)(m.fragment.substring(d+1)).toString();if(!isNaN(c))return{handle:c,notebook:m.with({scheme:b,fragment:null})}}e.$LJ=D;function E(m,d){const c=d.toString(p),u=`${c.length<P.length?P[c.length-1]:"z"}${c}s${(0,y.$Me)(y.$se.fromString(m.scheme),!0,!0)}`;return m.with({scheme:s.Schemas.vscodeNotebookCell,fragment:u})}e.$MJ=E;class w{constructor(){this.a=new C.$Ac}getNotebook(d){if(d.scheme===s.Schemas.vscodeNotebookCell){const c=D(d);if(c){const b=this.a.get(c.notebook);if(b)return b}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$NJ=w,(0,S.$$r)(e.$KJ,w,1)}),define(Ee[137],ke([1,0,14,77,49,61,12,7,3,69,288]),function(le,e,y,C,s,S,k,P,v,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.$3J=e.CellStatusbarAlignment=e.$2J=e.$1J=e.$ZJ=e.NotebookEditorPriority=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.CellKind=e.$QJ=e.$PJ=e.$OJ=void 0,e.$OJ="workbench.editor.notebook",e.$PJ="workbench.editor.notebookTextDiffEditor",e.$QJ="workbench.editor.interactive";var E;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(E||(e.CellKind=E={})),e.$RJ=["application/json","application/javascript","text/html","image/svg+xml",S.$rs.latex,S.$rs.markdown,"image/png","image/jpeg",S.$rs.text],e.$SJ=[S.$rs.latex,S.$rs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",S.$rs.text],e.$TJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$UJ="_notAvailable";var w;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var m;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var d;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var c;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var b;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var u;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var g;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var h;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var f;(function(q){q.scheme=k.Schemas.vscodeNotebookCell;function J(re,ge){return(0,D.$MJ)(re,ge)}q.generate=J;function ne(re){return(0,D.$LJ)(re)}q.parse=ne;function x(re,ge){return re.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${re.scheme!==k.Schemas.file?re.scheme:""}`})}q.generateCellOutputUri=x;function G(re){if(re.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!ge)return;const B=ge[1]&&ge[1]!==""?ge[1]:void 0,W=ge[2];return{outputId:B,notebook:re.with({scheme:W||k.Schemas.file,fragment:null})}}q.parseCellOutputUri=G;function se(re,ge,B){return q.generate(re,ge).with({scheme:B})}q.generateCellPropertyUri=se;function ce(re,ge){if(re.scheme===ge)return q.parse(re.with({scheme:q.scheme}))}q.parseCellPropertyUri=ce})(f||(e.CellUri=f={}));const l=q=>v.$c?q.replace(/\//g,"\\"):q;class t{constructor(J=[],ne=e.$RJ){this.e=ne,this.d=[...new Set(J)].map(x=>({pattern:x,matches:C.$Xj(l(x))}))}sort(J){const ne=new Map(s.Iterable.map(J,G=>[G,l(G)]));let x=[];for(const{matches:G}of this.d)for(const[se,ce]of ne)if(G(ce)){x.push(se),ne.delete(se);break}return ne.size&&(x=x.concat([...ne.keys()].sort((G,se)=>this.e.indexOf(G)-this.e.indexOf(se)))),x}prioritize(J,ne){const x=this.f(J);if(x===-1){this.d.unshift({pattern:J,matches:C.$Xj(l(J))});return}const G=new Set(ne.map(ce=>this.f(ce,x)));G.delete(-1);const se=Array.from(G).sort();this.d.splice(x+1,0,...se.map(ce=>this.d[ce]));for(let ce=se.length-1;ce>=0;ce--)this.d.splice(se[ce],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ne=this.d.length){const x=l(J);for(let G=0;G<ne;G++)if(this.d[G].matches(x))return G;return-1}}e.$VJ=t;function r(q,J,ne,x=(G,se)=>G===se){const G=[];function se(ge,B,W){if(B===0&&W.length===0)return;const F=G[G.length-1];F&&F.start+F.deleteCount===ge?(F.deleteCount+=B,F.toInsert.push(...W)):G.push({start:ge,deleteCount:B,toInsert:W})}let ce=0,re=0;for(;;){if(ce===q.length){se(ce,0,J.slice(re));break}if(re===J.length){se(ce,q.length-ce,[]);break}const ge=q[ce],B=J[re];if(x(ge,B)){ce+=1,re+=1;continue}ne(B)?(se(ce,1,[]),ce+=1):(se(ce,0,[B]),re+=1)}return G}e.$WJ=r,e.$XJ=new p.$vj("notebookEditorCursorAtBoundary","none"),e.$YJ=new p.$vj("notebookEditorCursorAtLineBoundary","none");var o;(function(q){q.default="default",q.option="option"})(o||(e.NotebookEditorPriority=o={}));function n(q){const J=q;return!!((typeof J.include=="string"||C.$Yj(J.include))&&(typeof J.exclude=="string"||C.$Yj(J.exclude)))}e.$ZJ=n;function i(q,J,ne){if(Array.isArray(q.viewType)&&q.viewType.indexOf(J)>=0||q.viewType===J)return!0;if(q.filenamePattern){const x=n(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,G=n(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(C.$Wj(x,(0,P.$nc)(ne.fsPath).toLowerCase()))return!(G&&C.$Wj(G,(0,P.$nc)(ne.fsPath).toLowerCase()))}return!1}e.$1J=i,e.$2J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var a;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class ${static create(J){return`${$.d}${J}`}static parse(J){if(J.startsWith($.d))return J.substring($.d.length)}}e.$3J=$,$.d="notebook/";function A(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}e.$4J=A;const R=new TextDecoder;function I(q){const J=[];let ne=!1;for(const ce of q)(J.length===0||ne)&&(J.push(ce),ne=!0);let x=Z(J);const G=y.$se.concat(J.map(ce=>y.$se.wrap(ce))),se=H(G);return x=x||se.byteLength!==G.byteLength,{data:se,didCompression:x}}e.$5J=I,e.$6J="\x1B[A";const O=e.$6J.split("").map(q=>q.charCodeAt(0)),M=10;function Z(q){let J=!1;return q.forEach((ne,x)=>{if(x===0||ne.length<e.$6J.length)return;const G=q[x-1],se=ne.subarray(0,e.$6J.length);if(se[0]===O[0]&&se[1]===O[1]&&se[2]===O[2]){const ce=G.lastIndexOf(M);if(ce===-1)return;J=!0,q[x-1]=G.subarray(0,ce),q[x]=ne.subarray(e.$6J.length)}}),J}function ee(q){let J=q;do q=J,J=q.replace(/[^\n]\x08/gm,"");while(J.length<q.length);return q}function fe(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const J=q.match(/^(.*)\r+/m)[1];let ne=q.match(/\r+(.*)$/m)[1];ne=ne+J.slice(ne.length,J.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return q}const ue=8,j=13;function H(q){return!q.buffer.includes(ue)&&!q.buffer.includes(j)?q:y.$se.fromString(fe(ee(R.decode(q.buffer))))}});var Lt=this&&this.__classPrivateFieldSet||function(le,e,y,C,s){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!s)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!s:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?s.call(le,y):s?s.value=y:e.set(le,y),y},tt=this&&this.__classPrivateFieldGet||function(le,e,y,C){if(y==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!C:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?C:y==="a"?C.call(le):C?C.value:e.get(le)};define(Ee[138],ke([1,0,18,8,101,24,61,17,9,4,22,35,16,119,137]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d){"use strict";var c,b,u,g,h,f,l,t,r,o,n,i,a,$,A,R,I,O,M,Z,ee,fe,ue,j,H;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$7N=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$UN=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.TestRunProfileKind=e.TestResultState=e.$AN=e.$zN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$yN=e.NotebookVariablesRequestKind=e.$xN=e.$wN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$vN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.ColorThemeKind=e.$pN=e.$oN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$nN=e.$mN=e.DebugConsoleMode=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$gN=e.$fN=e.FileChangeType=e.$eN=e.NewSymbolNameTag=e.$dN=e.$cN=e.$bN=e.$aN=e.InlineCompletionTriggerKind=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.ConfigurationTarget=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$PM=e.ViewBadge=e.ProgressLocation=e.$OM=e.$NM=e.TaskScope=e.ShellQuoting=e.$MM=e.$LM=e.$KM=e.TaskPanelKind=e.TaskRevealKind=e.$JM=e.TerminalLocation=e.$IM=e.$HM=e.$GM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$FM=e.$EM=e.$DM=e.$CM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$BM=e.StatusBarAlignment=e.ViewColumn=e.$AM=e.$zM=e.$yM=e.$xM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$wM=e.$vM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.LanguageStatusSeverity=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.CodeActionTriggerKind=e.$jM=e.$iM=e.SymbolTag=e.SymbolKind=e.$hM=e.$gM=e.DocumentHighlightKind=e.$fM=e.$eM=e.$dM=e.$cM=e.DiagnosticSeverity=e.DiagnosticTag=e.$bM=e.$aM=e.FileEditType=e.$_L=e.$$L=e.$0L=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function q(T){return Object.assign(T,{apply:function(...oe){if(oe.length===0)return Reflect.construct(T,[]);{const ve=oe.length===1?[]:oe[1];return Reflect.construct(T,ve,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(T,[]);{const[ve,...Ue]=oe;return Reflect.construct(T,Ue,ve.constructor)}}})}var J;(function(T){T[T.Top=0]="Top",T[T.Bottom=1]="Bottom"})(J||(e.TerminalOutputAnchor=J={}));var ne;(function(T){T[T.TerminalCommand=0]="TerminalCommand",T[T.Opener=1]="Opener",T[T.Command=3]="Command"})(ne||(e.TerminalQuickFixType=ne={}));let x=r=class{static from(...L){let oe=L;return new r(function(){if(oe){for(const ve of oe)ve&&typeof ve.dispose=="function"&&ve.dispose();oe=void 0}})}constructor(L){c.set(this,void 0),Lt(this,c,L,"f")}dispose(){typeof tt(this,c,"f")=="function"&&(tt(this,c,"f").call(this),Lt(this,c,void 0,"f"))}};e.$3L=x,c=new WeakMap,e.$3L=x=r=Le([q],x);let G=o=class{static Min(...L){if(L.length===0)throw new TypeError;let oe=L[0];for(let ve=1;ve<L.length;ve++){const Ue=L[ve];Ue.isBefore(oe)&&(oe=Ue)}return oe}static Max(...L){if(L.length===0)throw new TypeError;let oe=L[0];for(let ve=1;ve<L.length;ve++){const Ue=L[ve];Ue.isAfter(oe)&&(oe=Ue)}return oe}static isPosition(L){if(!L)return!1;if(L instanceof o)return!0;const{line:oe,character:ve}=L;return typeof oe=="number"&&typeof ve=="number"}static of(L){if(L instanceof o)return L;if(this.isPosition(L))return new o(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,oe){if(L<0)throw(0,C.$7)("line must be non-negative");if(oe<0)throw(0,C.$7)("character must be non-negative");this.c=L,this.e=oe}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,oe=0){if(L===null||oe===null)throw(0,C.$7)();let ve;return typeof L>"u"?ve=0:typeof L=="number"?ve=L:(ve=typeof L.lineDelta=="number"?L.lineDelta:0,oe=typeof L.characterDelta=="number"?L.characterDelta:0),ve===0&&oe===0?this:new o(this.line+ve,this.character+oe)}with(L,oe=this.character){if(L===null||oe===null)throw(0,C.$7)();let ve;return typeof L>"u"?ve=this.line:typeof L=="number"?ve=L:(ve=typeof L.line=="number"?L.line:this.line,oe=typeof L.character=="number"?L.character:this.character),ve===this.line&&oe===this.character?this:new o(ve,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$4L=G,e.$4L=G=o=Le([q],G);let se=n=class{static isRange(L){return L instanceof n?!0:L?G.isPosition(L.start)&&G.isPosition(L.end):!1}static of(L){if(L instanceof n)return L;if(this.isRange(L))return new n(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,oe,ve,Ue){let Ge,Qe;if(typeof L=="number"&&typeof oe=="number"&&typeof ve=="number"&&typeof Ue=="number"?(Ge=new G(L,oe),Qe=new G(ve,Ue)):G.isPosition(L)&&G.isPosition(oe)&&(Ge=G.of(L),Qe=G.of(oe)),!Ge||!Qe)throw new Error("Invalid arguments");Ge.isBefore(Qe)?(this.c=Ge,this.e=Qe):(this.c=Qe,this.e=Ge)}contains(L){return n.isRange(L)?this.contains(L.start)&&this.contains(L.end):G.isPosition(L)?!(G.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const oe=G.Max(L.start,this.c),ve=G.Min(L.end,this.e);if(!oe.isAfter(ve))return new n(oe,ve)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const oe=G.Min(L.start,this.c),ve=G.Max(L.end,this.end);return new n(oe,ve)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,oe=this.end){if(L===null||oe===null)throw(0,C.$7)();let ve;return L?G.isPosition(L)?ve=L:(ve=L.start||this.start,oe=L.end||this.end):ve=this.start,ve.isEqual(this.c)&&oe.isEqual(this.end)?this:new n(ve,oe)}toJSON(){return[this.start,this.end]}};e.$5L=se,e.$5L=se=n=Le([q],se);let ce=i=class extends se{static isSelection(L){return L instanceof i?!0:L?se.isRange(L)&&G.isPosition(L.anchor)&&G.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,oe,ve,Ue){let Ge,Qe;if(typeof L=="number"&&typeof oe=="number"&&typeof ve=="number"&&typeof Ue=="number"?(Ge=new G(L,oe),Qe=new G(ve,Ue)):G.isPosition(L)&&G.isPosition(oe)&&(Ge=G.of(L),Qe=G.of(oe)),!Ge||!Qe)throw new Error("Invalid arguments");super(Ge,Qe),this.f=Ge,this.g=Qe}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6L=ce,e.$6L=ce=i=Le([q],ce);const re=T=>{if(typeof T!="string"||T.length===0||!/^[0-9A-Za-z_\-]+$/.test(T))throw(0,C.$7)("connectionToken")};class ge{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,oe,ve){if(typeof L!="string"||L.length===0)throw(0,C.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,C.$7)("port");typeof ve<"u"&&re(ve),this.host=L,this.port=Math.round(oe),this.connectionToken=ve}}e.$7L=ge;class B{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,oe){this.makeConnection=L,this.connectionToken=oe,typeof oe<"u"&&re(oe)}}e.$8L=B;class W extends Error{static NotAvailable(L,oe){return new W(L,m.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(L){return new W(L,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,oe=m.RemoteAuthorityResolverErrorCode.Unknown,ve){super(L),this._message=L,this._code=oe,this._detail=ve,Object.setPrototypeOf(this,W.prototype)}}e.$9L=W;var F;(function(T){T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(F||(e.EndOfLine=F={}));var z;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(z||(e.EnvironmentVariableMutatorType=z={}));let _=a=class{static isTextEdit(L){return L instanceof a?!0:L?se.isRange(L)&&typeof L.newText=="string":!1}static replace(L,oe){return new a(L,oe)}static insert(L,oe){return a.replace(new se(L,L),oe)}static delete(L){return a.replace(L,"")}static setEndOfLine(L){const oe=new a(new se(new G(0,0),new G(0,0)),"");return oe.newEol=L,oe}get range(){return this.c}set range(L){if(L&&!se.isRange(L))throw(0,C.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,C.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,C.$7)("newEol");this.f=L}constructor(L,oe){this.c=L,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0L=_,e.$0L=_=a=Le([q],_);let Q=$=class{static isNotebookCellEdit(L){return L instanceof $?!0:L?Bt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,oe){return new $(L,oe)}static insertCells(L,oe){return new $(new Bt(L,L),oe)}static deleteCells(L){return new $(L,[])}static updateCellMetadata(L,oe){const ve=new $(new Bt(L,L),[]);return ve.newCellMetadata=oe,ve}static updateNotebookMetadata(L){const oe=new $(new Bt(0,0),[]);return oe.newNotebookMetadata=L,oe}constructor(L,oe){this.range=L,this.newCells=oe}};e.$$L=Q,e.$$L=Q=$=Le([q],Q);class K{static isSnippetTextEdit(L){return L instanceof K?!0:L?se.isRange(L.range)&&N.isSnippetString(L.snippet):!1}static replace(L,oe){return new K(L,oe)}static insert(L,oe){return K.replace(new se(L,L),oe)}constructor(L,oe){this.range=L,this.snippet=oe}}e.$_L=K;var X;(function(T){T[T.File=1]="File",T[T.Text=2]="Text",T[T.Cell=3]="Cell",T[T.CellReplace=5]="CellReplace",T[T.Snippet=6]="Snippet"})(X||(e.FileEditType=X={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,oe,ve,Ue){this.c.push({_type:1,from:L,to:oe,options:ve,metadata:Ue})}createFile(L,oe,ve){this.c.push({_type:1,from:void 0,to:L,options:oe,metadata:ve})}deleteFile(L,oe,ve){this.c.push({_type:1,from:L,to:void 0,options:oe,metadata:ve})}e(L,oe,ve){this.c.push({_type:3,metadata:ve,uri:L,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(L,oe,ve,Ue){const Ge=oe.start,Qe=oe.end;(Ge!==Qe||ve.length>0)&&this.c.push({_type:5,uri:L,index:Ge,count:Qe-Ge,cells:ve,metadata:Ue})}g(L,oe,ve,Ue){this.c.push({_type:3,metadata:Ue,uri:L,edit:{editType:3,index:oe,metadata:ve}})}replace(L,oe,ve,Ue){this.c.push({_type:2,uri:L,edit:new _(oe,ve),metadata:Ue})}insert(L,oe,ve,Ue){this.replace(L,new se(oe,oe),ve,Ue)}delete(L,oe,ve){this.replace(L,oe,"",ve)}has(L){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===L.toString())}set(L,oe){if(oe)for(const ve of oe){if(!ve)continue;let Ue,Ge;Array.isArray(ve)?(Ue=ve[0],Ge=ve[1]):Ue=ve,Q.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(L,Ue.range.start,Ue.newCellMetadata,Ge):Ue.newNotebookMetadata?this.e(L,Ue.newNotebookMetadata,Ge):this.f(L,Ue.range,Ue.newCells,Ge):K.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:L,range:Ue.range,edit:Ue.snippet,metadata:Ge}):this.c.push({_type:2,uri:L,edit:Ue,metadata:Ge})}else{for(let ve=0;ve<this.c.length;ve++){const Ue=this.c[ve];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===L.toString()&&(this.c[ve]=void 0);break}}(0,y.$Ib)(this.c)}}get(L){const oe=[];for(const ve of this.c)ve._type===2&&ve.uri.toString()===L.toString()&&oe.push(ve.edit);return oe}entries(){const L=new S.$Ac;for(const oe of this.c)if(oe._type===2){let ve=L.get(oe.uri);ve||(ve=[oe.uri,[]],L.set(oe.uri,ve)),ve[1].push(oe.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aM=Y,e.$aM=Y=Le([q],Y);let N=A=class{static isSnippetString(L){return L instanceof A?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=A.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,oe=this.e++){if(typeof L=="function"){const ve=new A;ve.e=this.e,L(ve),this.e=ve.e,L=ve.value}else L=A.c(L);return this.value+="${",this.value+=oe,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,oe=this.e++){const ve=L.map(Ue=>Ue.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ve,this.value+="|}",this}appendVariable(L,oe){if(typeof oe=="function"){const ve=new A;ve.e=this.e,oe(ve),this.e=ve.e,oe=ve.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$bM=N,e.$bM=N=A=Le([q],N);var U;(function(T){T[T.Unnecessary=1]="Unnecessary",T[T.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var te;(function(T){T[T.Hint=3]="Hint",T[T.Information=2]="Information",T[T.Warning=1]="Warning",T[T.Error=0]="Error"})(te||(e.DiagnosticSeverity=te={}));let ie=R=class{static isLocation(L){return L instanceof R?!0:L?se.isRange(L.range)&&p.URI.isUri(L.uri):!1}constructor(L,oe){if(this.uri=L,oe)if(se.isRange(oe))this.range=se.of(oe);else if(G.isPosition(oe))this.range=new se(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cM=ie,e.$cM=ie=R=Le([q],ie);let de=class{static is(L){return L?typeof L.message=="string"&&L.location&&se.isRange(L.location.range)&&p.URI.isUri(L.location.uri):!1}constructor(L,oe){this.location=L,this.message=oe}static isEqual(L,oe){return L===oe?!0:!L||!oe?!1:L.message===oe.message&&L.location.range.isEqual(oe.location.range)&&L.location.uri.toString()===oe.location.uri.toString()}};e.$dM=de,e.$dM=de=Le([q],de);let ae=class{constructor(L,oe,ve=te.Error){if(!se.isRange(L))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=L,this.message=oe,this.severity=ve}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,oe){return L===oe?!0:!L||!oe?!1:L.message===oe.message&&L.severity===oe.severity&&L.code===oe.code&&L.severity===oe.severity&&L.source===oe.source&&L.range.isEqual(oe.range)&&(0,y.$ub)(L.tags,oe.tags)&&(0,y.$ub)(L.relatedInformation,oe.relatedInformation,de.isEqual)}};e.$eM=ae,e.$eM=ae=Le([q],ae);let be=class{constructor(L,oe){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=oe}};e.$fM=be,e.$fM=be=Le([q],be);var ye;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(ye||(e.DocumentHighlightKind=ye={}));let Re=class{constructor(L,oe=ye.Text){this.range=L,this.kind=oe}toJSON(){return{range:this.range,kind:ye[this.kind]}}};e.$gM=Re,e.$gM=Re=Le([q],Re);let Me=class{constructor(L,oe){this.uri=L,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$hM=Me,e.$hM=Me=Le([q],Me);var $e;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var Se;(function(T){T[T.Deprecated=1]="Deprecated"})(Se||(e.SymbolTag=Se={}));let De=I=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,oe,ve,Ue,Ge){this.name=L,this.kind=oe,this.containerName=Ge,typeof ve=="string"&&(this.containerName=ve),Ue instanceof ie?this.location=Ue:ve instanceof se&&(this.location=new ie(Ue,ve)),I.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$iM=De,e.$iM=De=I=Le([q],De);let je=O=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(O.validate)}constructor(L,oe,ve,Ue,Ge){this.name=L,this.detail=oe,this.kind=ve,this.range=Ue,this.selectionRange=Ge,this.children=[],O.validate(this)}};e.$jM=je,e.$jM=je=O=Le([q],je);var Te;(function(T){T[T.Invoke=1]="Invoke",T[T.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let We=class{constructor(L,oe){this.title=L,this.kind=oe}};e.$kM=We,e.$kM=We=Le([q],We);let ze=M=class{constructor(L){this.value=L}append(L){return new M(this.value?this.value+M.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+M.c)}};e.$lM=ze,ze.c=".",e.$lM=ze=M=Le([q],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let Je=class{constructor(L,oe){if(this.range=L,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$mM=Je,e.$mM=Je=Le([q],Je);class _e{constructor(L,oe,ve,Ue,Ge,Qe){this.kind=L,this.name=oe,this.detail=ve,this.uri=Ue,this.range=Ge,this.selectionRange=Qe}}e.$nM=_e;class xe{constructor(L,oe){this.fromRanges=oe,this.from=L}}e.$oM=xe;class nt{constructor(L,oe){this.fromRanges=oe,this.to=L}}e.$pM=nt;var Ke;(function(T){T[T.Information=0]="Information",T[T.Warning=1]="Warning",T[T.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let Ze=class{constructor(L,oe){this.range=L,this.command=oe}get isResolved(){return!!this.command}};e.$qM=Ze,e.$qM=Ze=Le([q],Ze);let me=Z=class{static isMarkdownString(L){return L instanceof Z?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,oe=!1){b.set(this,void 0),Lt(this,b,new s.$sk(L,{supportThemeIcons:oe}),"f")}get value(){return tt(this,b,"f").value}set value(L){tt(this,b,"f").value=L}get isTrusted(){return tt(this,b,"f").isTrusted}set isTrusted(L){tt(this,b,"f").isTrusted=L}get supportThemeIcons(){return tt(this,b,"f").supportThemeIcons}set supportThemeIcons(L){tt(this,b,"f").supportThemeIcons=L}get supportHtml(){return tt(this,b,"f").supportHtml}set supportHtml(L){tt(this,b,"f").supportHtml=L}get baseUri(){return tt(this,b,"f").baseUri}set baseUri(L){tt(this,b,"f").baseUri=L}appendText(L){return tt(this,b,"f").appendText(L),this}appendMarkdown(L){return tt(this,b,"f").appendMarkdown(L),this}appendCodeblock(L,oe){return tt(this,b,"f").appendCodeblock(oe??"",L),this}};e.$rM=me,b=new WeakMap,e.$rM=me=Z=Le([q],me);let Ie=class{constructor(L,oe){this.label=L,this.documentation=oe}};e.$sM=Ie,e.$sM=Ie=Le([q],Ie);let Ae=class{constructor(L,oe){this.label=L,this.documentation=oe,this.parameters=[]}};e.$tM=Ae,e.$tM=Ae=Le([q],Ae);let Oe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$uM=Oe,e.$uM=Oe=Le([q],Oe);var Fe;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(Fe||(e.SignatureHelpTriggerKind=Fe={}));var He;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(He||(e.InlayHintKind=He={}));let Ve=class{constructor(L){this.value=L}};e.$vM=Ve,e.$vM=Ve=Le([q],Ve);let st=class{constructor(L,oe,ve){this.position=L,this.label=oe,this.kind=ve}};e.$wM=st,e.$wM=st=Le([q],st);var it;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(it||(e.CompletionTriggerKind=it={}));var Xe;(function(T){T[T.Text=0]="Text",T[T.Method=1]="Method",T[T.Function=2]="Function",T[T.Constructor=3]="Constructor",T[T.Field=4]="Field",T[T.Variable=5]="Variable",T[T.Class=6]="Class",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Unit=10]="Unit",T[T.Value=11]="Value",T[T.Enum=12]="Enum",T[T.Keyword=13]="Keyword",T[T.Snippet=14]="Snippet",T[T.Color=15]="Color",T[T.File=16]="File",T[T.Reference=17]="Reference",T[T.Folder=18]="Folder",T[T.EnumMember=19]="EnumMember",T[T.Constant=20]="Constant",T[T.Struct=21]="Struct",T[T.Event=22]="Event",T[T.Operator=23]="Operator",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var ct;(function(T){T[T.Deprecated=1]="Deprecated"})(ct||(e.CompletionItemTag=ct={}));let at=class{constructor(L,oe){this.label=L,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$xM=at,e.$xM=at=Le([q],at);let ft=class{constructor(L=[],oe=!1){this.items=L,this.isIncomplete=oe}};e.$yM=ft,e.$yM=ft=Le([q],ft);let lt=class{constructor(L,oe,ve){this.insertText=L,this.range=oe,this.command=ve}};e.$zM=lt,e.$zM=lt=Le([q],lt);let mt=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$AM=mt,e.$AM=mt=Le([q],mt);var zt;(function(T){T[T.Active=-1]="Active",T[T.Beside=-2]="Beside",T[T.One=1]="One",T[T.Two=2]="Two",T[T.Three=3]="Three",T[T.Four=4]="Four",T[T.Five=5]="Five",T[T.Six=6]="Six",T[T.Seven=7]="Seven",T[T.Eight=8]="Eight",T[T.Nine=9]="Nine"})(zt||(e.ViewColumn=zt={}));var qt;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(qt||(e.StatusBarAlignment=qt={}));function Ht(T,L){return`${E.$xm.toKey(T)}.${L}`}e.$BM=Ht;var Rt;(function(T){T[T.Off=0]="Off",T[T.On=1]="On",T[T.Relative=2]="Relative",T[T.Interval=3]="Interval"})(Rt||(e.TextEditorLineNumbersStyle=Rt={}));var kt;(function(T){T[T.Manual=1]="Manual",T[T.AfterDelay=2]="AfterDelay",T[T.FocusOut=3]="FocusOut"})(kt||(e.TextDocumentSaveReason=kt={}));var Ot;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(Ot||(e.TextEditorRevealType=Ot={}));var $t;(function(T){T[T.Keyboard=1]="Keyboard",T[T.Mouse=2]="Mouse",T[T.Command=3]="Command"})($t||(e.TextEditorSelectionChangeKind=$t={}));var bt;(function(T){T[T.Undo=1]="Undo",T[T.Redo=2]="Redo"})(bt||(e.TextDocumentChangeReason=bt={}));var Wt;(function(T){T[T.OpenOpen=0]="OpenOpen",T[T.ClosedClosed=1]="ClosedClosed",T[T.OpenClosed=2]="OpenClosed",T[T.ClosedOpen=3]="ClosedOpen"})(Wt||(e.DecorationRangeBehavior=Wt={})),function(T){function L(oe){switch(oe){case"keyboard":return T.Keyboard;case"mouse":return T.Mouse;case"api":return T.Command}}T.fromValue=L}($t||(e.TextEditorSelectionChangeKind=$t={}));var St;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(St||(e.SyntaxTokenType=St={})),function(T){function L(oe){switch(oe){case T.Other:return"other";case T.Comment:return"comment";case T.String:return"string";case T.RegEx:return"regex"}return"other"}T.toString=L}(St||(e.SyntaxTokenType=St={}));let rt=class{constructor(L,oe){if(oe&&!p.URI.isUri(oe))throw(0,C.$7)("target");if(!se.isRange(L)||L.isEmpty)throw(0,C.$7)("range");this.range=L,this.target=oe}};e.$CM=rt,e.$CM=rt=Le([q],rt);let wt=class{constructor(L,oe,ve,Ue){this.red=L,this.green=oe,this.blue=ve,this.alpha=Ue}};e.$DM=wt,e.$DM=wt=Le([q],wt);let pt=class{constructor(L,oe){if(oe&&!(oe instanceof wt))throw(0,C.$7)("color");if(!se.isRange(L)||L.isEmpty)throw(0,C.$7)("range");this.range=L,this.color=oe}};e.$EM=pt,e.$EM=pt=Le([q],pt);let dt=class{constructor(L){if(!L||typeof L!="string")throw(0,C.$7)("label");this.label=L}};e.$FM=dt,e.$FM=dt=Le([q],dt);var Vt;(function(T){T[T.RGB=0]="RGB",T[T.HEX=1]="HEX",T[T.HSL=2]="HSL"})(Vt||(e.ColorFormat=Vt={}));var Ft;(function(T){T[T.Error=0]="Error",T[T.Warning=1]="Warning",T[T.Information=2]="Information"})(Ft||(e.SourceControlInputBoxValidationType=Ft={}));var Gt;(function(T){T[T.Unknown=0]="Unknown",T[T.Shutdown=1]="Shutdown",T[T.Process=2]="Process",T[T.User=3]="User",T[T.Extension=4]="Extension"})(Gt||(e.TerminalExitReason=Gt={}));class Jt{constructor(L,oe,ve){if(this.startIndex=L,this.length=oe,this.tooltip=ve,typeof L!="number"||L<0)throw(0,C.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,C.$7)("length");if(ve!==void 0&&typeof ve!="string")throw(0,C.$7)("tooltip")}}e.$GM=Jt;class Tt{constructor(L){this.uri=L}}e.$HM=Tt;class jt{constructor(L){this.terminalCommand=L}}e.$IM=jt;var Xt;(function(T){T[T.Panel=1]="Panel",T[T.Editor=2]="Editor"})(Xt||(e.TerminalLocation=Xt={}));class It{constructor(L){if(this.options=L,typeof L!="object")throw(0,C.$7)("options")}}e.$JM=It;var Zt;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(Zt||(e.TaskRevealKind=Zt={}));var Yt;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(Yt||(e.TaskPanelKind=Yt={}));let Dt=ee=class{static from(L){switch(L){case"clean":return ee.Clean;case"build":return ee.Build;case"rebuild":return ee.Rebuild;case"test":return ee.Test;default:return}}constructor(L,oe){if(this.label=oe,typeof L!="string"||typeof oe!="string")throw(0,C.$7)("name");this.c=L}get id(){return this.c}};e.$KM=Dt,Dt.Clean=new ee("clean","Clean"),Dt.Build=new ee("build","Build"),Dt.Rebuild=new ee("rebuild","Rebuild"),Dt.Test=new ee("test","Test"),e.$KM=Dt=ee=Le([q],Dt);function xt(T){let L="";for(let oe=0;oe<T.length;oe++)L+=T[oe].replace(/,/g,",,")+",";return L}let Nt=class{constructor(L,oe,ve){if(typeof L!="string")throw(0,C.$7)("process");this.e=[],this.c=L,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ve):this.f=oe)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,C.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)L.push(oe);return xt(L)}};e.$LM=Nt,e.$LM=Nt=Le([q],Nt);let Qt=class{constructor(L,oe,ve){if(this.f=[],Array.isArray(oe)){if(!L)throw(0,C.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,C.$7)("command");this.e=L,this.f=oe,this.g=ve}else{if(typeof L!="string")throw(0,C.$7)("commandLine");this.c=L,this.g=oe}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,C.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,C.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)L.push(typeof oe=="string"?oe:oe.value);return xt(L)}};e.$MM=Qt,e.$MM=Qt=Le([q],Qt);var _t;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(_t||(e.ShellQuoting=_t={}));var Kt;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace"})(Kt||(e.TaskScope=Kt={}));class en{constructor(L){this.c=L}computeId(){return"customExecution"+(0,D.$Ag)()}set callback(L){this.c=L}get callback(){return this.c}}e.$NM=en;let Ct=fe=class{constructor(L,oe,ve,Ue,Ge,Qe){this.k=!1,this.l=this.definition=L;let et;typeof oe=="string"?(this.o=this.name=oe,this.w=this.source=ve,this.execution=Ue,et=Ge,this.k=!0):oe===Kt.Global||oe===Kt.Workspace?(this.target=oe,this.o=this.name=ve,this.w=this.source=Ue,this.execution=Ge,et=Qe):(this.target=oe,this.o=this.name=ve,this.w=this.source=Ue,this.execution=Ge,et=Qe),typeof et=="string"?(this.r=[et],this.t=!0):Array.isArray(et)?(this.r=et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:fe.e,id:this.q.computeId()}:this.q instanceof Qt?this.l={type:fe.f,id:this.q.computeId()}:this.q instanceof en?this.l={type:fe.c,id:this.q.computeId()}:this.l={type:fe.g,id:(0,D.$Ag)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,C.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,C.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const oe=this.l.type;(fe.g===oe||fe.e===oe||fe.f===oe||fe.c===oe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,C.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$OM=Ct,Ct.c="customExecution",Ct.e="process",Ct.f="shell",Ct.g="$empty",e.$OM=Ct=fe=Le([q],Ct);var tn;(function(T){T[T.SourceControl=1]="SourceControl",T[T.Window=10]="Window",T[T.Notification=15]="Notification"})(tn||(e.ProgressLocation=tn={}));var sn;(function(T){function L(oe){const ve=oe;return(0,v.$Wf)(ve.value)?ve.tooltip&&!(0,v.$Sf)(ve.tooltip)?(console.log("INVALID view badge, invalid tooltip",ve.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ve.value),!1)}T.isViewBadge=L})(sn||(e.ViewBadge=sn={}));let nn=ue=class{static isTreeItem(L,oe){const ve=L;if(ve.checkboxState!==void 0){const Ue=(0,v.$Wf)(ve.checkboxState)?ve.checkboxState:(0,v.$Uf)(ve.checkboxState)&&(0,v.$Wf)(ve.checkboxState.state)?ve.checkboxState.state:void 0,Ge=!(0,v.$Wf)(ve.checkboxState)&&(0,v.$Uf)(ve.checkboxState)?ve.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==we.Checked&&Ue!==we.Unchecked||Ge!==void 0&&!(0,v.$Sf)(Ge))return console.log("INVALID tree item, invalid checkboxState",ve.checkboxState),!1}if(L instanceof ue)return!0;if(ve.label!==void 0&&!(0,v.$Sf)(ve.label)&&!ve.label?.label)return console.log("INVALID tree item, invalid label",ve.label),!1;if(ve.id!==void 0&&!(0,v.$Sf)(ve.id))return console.log("INVALID tree item, invalid id",ve.id),!1;if(ve.iconPath!==void 0&&!(0,v.$Sf)(ve.iconPath)&&!p.URI.isUri(ve.iconPath)&&(!ve.iconPath||!(0,v.$Sf)(ve.iconPath.id))){const Ue=ve.iconPath;if(!Ue||!(0,v.$Sf)(Ue.light)&&!p.URI.isUri(Ue.light)&&!(0,v.$Sf)(Ue.dark)&&!p.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",ve.iconPath),!1}return ve.description!==void 0&&!(0,v.$Sf)(ve.description)&&typeof ve.description!="boolean"?(console.log("INVALID tree item, invalid description",ve.description),!1):ve.resourceUri!==void 0&&!p.URI.isUri(ve.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ve.resourceUri),!1):ve.tooltip!==void 0&&!(0,v.$Sf)(ve.tooltip)&&!(ve.tooltip instanceof me)?(console.log("INVALID tree item, invalid tooltip",ve.tooltip),!1):ve.command!==void 0&&!ve.command.command?(console.log("INVALID tree item, invalid command",ve.command),!1):ve.collapsibleState!==void 0&&ve.collapsibleState<Ut.None&&ve.collapsibleState>Ut.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ve.collapsibleState),!1):ve.contextValue!==void 0&&!(0,v.$Sf)(ve.contextValue)?(console.log("INVALID tree item, invalid contextValue",ve.contextValue),!1):ve.accessibilityInformation!==void 0&&!ve.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ve.accessibilityInformation),!1):!0}constructor(L,oe=Ut.None){this.collapsibleState=oe,p.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$PM=nn,e.$PM=nn=ue=Le([q],nn);var Ut;(function(T){T[T.None=0]="None",T[T.Collapsed=1]="Collapsed",T[T.Expanded=2]="Expanded"})(Ut||(e.TreeItemCollapsibleState=Ut={}));var we;(function(T){T[T.Unchecked=0]="Unchecked",T[T.Checked=1]="Checked"})(we||(e.TreeItemCheckboxState=we={}));let Pe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$QM=Pe,e.$QM=Pe=Le([q],Pe);class he extends Pe{}e.$RM=he;class V extends he{constructor(L){super(""),u.set(this,void 0),Lt(this,u,L,"f")}asFile(){return tt(this,u,"f")}}e.$SM=V,u=new WeakMap;class pe{constructor(L,oe,ve,Ue){this.name=L,this.uri=oe,this._itemId=ve,this.c=Ue}data(){return this.c()}}e.$TM=pe;let Ce=class{constructor(L){g.add(this),h.set(this,new Map);for(const[oe,ve]of L??[]){const Ue=tt(this,h,"f").get(tt(this,g,"m",f).call(this,oe));Ue?Ue.push(ve):tt(this,h,"f").set(tt(this,g,"m",f).call(this,oe),[ve])}}get(L){return tt(this,h,"f").get(tt(this,g,"m",f).call(this,L))?.[0]}set(L,oe){tt(this,h,"f").set(tt(this,g,"m",f).call(this,L),[oe])}forEach(L,oe){for(const[ve,Ue]of tt(this,h,"f"))for(const Ge of Ue)L.call(oe,Ge,ve,this)}*[(h=new WeakMap,g=new WeakSet,Symbol.iterator)](){for(const[L,oe]of tt(this,h,"f"))for(const ve of oe)yield[L,ve]}};e.$UM=Ce,f=function(L){return L.toLowerCase()},e.$UM=Ce=Le([q],Ce);let qe=class{constructor(L){this.insertText=L}};e.$VM=qe,e.$VM=qe=Le([q],qe);let Be=class{constructor(L,oe){this.label=oe,this.insertText=L}};e.$WM=Be,e.$WM=Be=Le([q],Be);let Ye=class{constructor(L,oe){this.id=L,this.color=oe}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$XM=Ye,e.$XM=Ye=Le([q],Ye),Ye.File=new Ye("file"),Ye.Folder=new Ye("folder");let ot=class{constructor(L){this.id=L}};e.$YM=ot,e.$YM=ot=Le([q],ot);var gt;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.WorkspaceFolder=3]="WorkspaceFolder"})(gt||(e.ConfigurationTarget=gt={}));let vt=class{get base(){return this.c}set base(L){this.c=L,this.e=p.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,oe){if(typeof L!="string"&&(!L||!p.URI.isUri(L)&&!p.URI.isUri(L.uri)))throw(0,C.$7)("base");if(typeof oe!="string")throw(0,C.$7)("pattern");typeof L=="string"?this.baseUri=p.URI.file(L):p.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ZM=vt,e.$ZM=vt=Le([q],vt);const ut=new WeakMap;function yt(T,L){ut.set(T,L)}e.$1M=yt;let rn=class{constructor(L,oe,ve,Ue,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof oe=="string"&&(this.condition=oe),typeof ve=="string"&&(this.hitCondition=ve),typeof Ue=="string"&&(this.logMessage=Ue),typeof Ge=="string"&&(this.mode=Ge)}get id(){return this.c||(this.c=ut.get(this)??(0,D.$Ag)()),this.c}};e.$2M=rn,e.$2M=rn=Le([q],rn);let hn=class extends rn{constructor(L,oe,ve,Ue,Ge,Qe){if(super(oe,ve,Ue,Ge,Qe),L===null)throw(0,C.$7)("location");this.location=L}};e.$3M=hn,e.$3M=hn=Le([q],hn);let dn=class extends rn{constructor(L,oe,ve,Ue,Ge,Qe){super(oe,ve,Ue,Ge,Qe),this.functionName=L}};e.$4M=dn,e.$4M=dn=Le([q],dn);let mn=class extends rn{constructor(L,oe,ve,Ue,Ge,Qe,et,ht){if(super(Ue,Ge,Qe,et,ht),!oe)throw(0,C.$7)("dataId");this.label=L,this.dataId=oe,this.canPersist=ve}};e.$5M=mn,e.$5M=mn=Le([q],mn);let gn=class{constructor(L,oe,ve){this.command=L,this.args=oe||[],this.options=ve}};e.$6M=gn,e.$6M=gn=Le([q],gn);let $n=class{constructor(L,oe){this.port=L,this.host=oe}};e.$7M=$n,e.$7M=$n=Le([q],$n);let bn=class{constructor(L){this.path=L}};e.$8M=bn,e.$8M=bn=Le([q],bn);let wn=class{constructor(L){this.implementation=L}};e.$9M=wn,e.$9M=wn=Le([q],wn);let pn=class{constructor(L,oe,ve){this.session=L,this.threadId=oe,this.frameId=ve}};e.$0M=pn,e.$0M=pn=Le([q],pn);let vn=class{constructor(L,oe){this.session=L,this.threadId=oe}};e.$$M=vn,e.$$M=vn=Le([q],vn);let yn=class{constructor(L,oe){this.range=L,this.expression=oe}};e.$_M=yn,e.$_M=yn=Le([q],yn);var jn;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(jn||(e.InlineCompletionTriggerKind=jn={}));let En=class{constructor(L,oe){this.range=L,this.text=oe}};e.$aN=En,e.$aN=En=Le([q],En);let kn=class{constructor(L,oe,ve=!0){this.range=L,this.variableName=oe,this.caseSensitiveLookup=ve}};e.$bN=kn,e.$bN=kn=Le([q],kn);let Dn=class{constructor(L,oe){this.range=L,this.expression=oe}};e.$cN=Dn,e.$cN=Dn=Le([q],Dn);let Pn=class{constructor(L,oe){this.frameId=L,this.stoppedLocation=oe}};e.$dN=Pn,e.$dN=Pn=Le([q],Pn);var Un;(function(T){T[T.AIGenerated=1]="AIGenerated"})(Un||(e.NewSymbolNameTag=Un={}));class Ei{constructor(L,oe){this.newSymbolName=L,this.tags=oe}}e.$eN=Ei;var Bn;(function(T){T[T.Changed=1]="Changed",T[T.Created=2]="Created",T[T.Deleted=3]="Deleted"})(Bn||(e.FileChangeType=Bn={}));let Sn=j=class extends Error{static FileExists(L){return new j(L,w.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(L){return new j(L,w.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(L){return new j(L,w.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(L){return new j(L,w.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(L){return new j(L,w.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(L){return new j(L,w.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(L,oe=w.FileSystemProviderErrorCode.Unknown,ve){super(p.URI.isUri(L)?L.toString(!0):L),this.code=ve?.name??"Unknown",(0,w.$Qk)(this,oe),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof ve=="function"&&Error.captureStackTrace(this,ve)}};e.$fN=Sn,e.$fN=Sn=j=Le([q],Sn);let In=class{constructor(L,oe,ve){this.start=L,this.end=oe,this.kind=ve}};e.$gN=In,e.$gN=In=Le([q],In);var zn;(function(T){T[T.Comment=1]="Comment",T[T.Imports=2]="Imports",T[T.Region=3]="Region"})(zn||(e.FoldingRangeKind=zn={}));var qn;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(qn||(e.CommentThreadCollapsibleState=qn={}));var Hn;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(Hn||(e.CommentMode=Hn={}));var Wn;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(Wn||(e.CommentState=Wn={}));var Vn;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(Vn||(e.CommentThreadState=Vn={}));class ki{constructor(L,oe=[]){this.tokenTypes=L,this.tokenModifiers=oe}}e.$hN=ki;function Di(T){return typeof T>"u"||(0,v.$Tf)(T)}class Cn{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let oe=0,ve=L.tokenTypes.length;oe<ve;oe++)this.k.set(L.tokenTypes[oe],oe);for(let oe=0,ve=L.tokenModifiers.length;oe<ve;oe++)this.l.set(L.tokenModifiers[oe],oe)}}push(L,oe,ve,Ue,Ge){if(typeof L=="number"&&typeof oe=="number"&&typeof ve=="number"&&typeof Ue=="number"&&(typeof Ge=="number"||typeof Ge>"u"))return typeof Ge>"u"&&(Ge=0),this.q(L,oe,ve,Ue,Ge);if(se.isRange(L)&&typeof oe=="string"&&Di(ve))return this.o(L,oe,ve);throw(0,C.$7)()}o(L,oe,ve){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ue=L.start.line,Ge=L.start.character,Qe=L.end.character-L.start.character,et=this.k.get(oe);let ht=0;if(ve)for(const Et of ve){if(!this.l.has(Et))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this.l.get(Et);ht|=1<<Pt>>>0}this.q(Ue,Ge,Qe,et,ht)}q(L,oe,ve,Ue,Ge){if(this.f&&(L<this.c||L===this.c&&oe<this.e)){this.f=!1;const ht=this.g.length/5|0;let Et=0,Pt=0;for(let At=0;At<ht;At++){let Mt=this.g[5*At],on=this.g[5*At+1];Mt===0?(Mt=Et,on+=Pt):Mt+=Et,this.g[5*At]=Mt,this.g[5*At+1]=on,Et=Mt,Pt=on}}let Qe=L,et=oe;this.f&&this.j>0&&(Qe-=this.c,Qe===0&&(et-=this.e)),this.g[this.j++]=Qe,this.g[this.j++]=et,this.g[this.j++]=ve,this.g[this.j++]=Ue,this.g[this.j++]=Ge,this.c=L,this.e=oe}static r(L){const oe=[],ve=L.length/5|0;for(let et=0;et<ve;et++)oe[et]=et;oe.sort((et,ht)=>{const Et=L[5*et],Pt=L[5*ht];if(Et===Pt){const At=L[5*et+1],Mt=L[5*ht+1];return At-Mt}return Et-Pt});const Ue=new Uint32Array(L.length);let Ge=0,Qe=0;for(let et=0;et<ve;et++){const ht=5*oe[et],Et=L[ht+0],Pt=L[ht+1],At=L[ht+2],Mt=L[ht+3],on=L[ht+4],yi=Et-Ge,cr=yi===0?Pt-Qe:Pt,an=5*et;Ue[an+0]=yi,Ue[an+1]=cr,Ue[an+2]=At,Ue[an+3]=Mt,Ue[an+4]=on,Ge=Et,Qe=Pt}return Ue}build(L){return this.f?new An(new Uint32Array(this.g),L):new An(Cn.r(this.g),L)}}e.$iN=Cn;class An{constructor(L,oe){this.resultId=oe,this.data=L}}e.$jN=An;class Pi{constructor(L,oe,ve){this.start=L,this.deleteCount=oe,this.data=ve}}e.$kN=Pi;class Si{constructor(L,oe){this.resultId=oe,this.edits=L}}e.$lN=Si;var Gn;(function(T){T[T.Separate=0]="Separate",T[T.MergeWithParent=1]="MergeWithParent"})(Gn||(e.DebugConsoleMode=Gn={}));class Ii{constructor(L){this.name=L}}e.$mN=Ii;let cn=class{constructor(){}};e.$nN=cn,cn.Back={iconPath:new Ye("arrow-left")},e.$nN=cn=Le([q],cn);var Jn;(function(T){T[T.Separator=-1]="Separator",T[T.Default=0]="Default"})(Jn||(e.QuickPickItemKind=Jn={}));var Xn;(function(T){T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(Xn||(e.InputBoxValidationSeverity=Xn={}));var Zn;(function(T){T[T.UI=1]="UI",T[T.Workspace=2]="Workspace"})(Zn||(e.ExtensionKind=Zn={}));class Ci{static validate(L){if(typeof L.badge=="string"){let oe=(0,P.$tf)(L.badge,0);if(oe<L.badge.length&&(oe+=(0,P.$tf)(L.badge,oe)),L.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Ye.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,oe,ve){this.badge=L,this.tooltip=oe,this.color=ve}}e.$oN=Ci;let Rn=class{constructor(L){this.kind=L}};e.$pN=Rn,e.$pN=Rn=Le([q],Rn);var Yn;(function(T){T[T.Light=1]="Light",T[T.Dark=2]="Dark",T[T.HighContrast=3]="HighContrast",T[T.HighContrastLight=4]="HighContrastLight"})(Yn||(e.ColorThemeKind=Yn={}));class Bt{static isNotebookRange(L){return L instanceof Bt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,oe){if(L<0)throw(0,C.$7)("start must be positive");if(oe<0)throw(0,C.$7)("end must be positive");L<=oe?(this.c=L,this.e=oe):(this.c=oe,this.e=L)}with(L){let oe=this.c,ve=this.e;return L.start!==void 0&&(oe=L.start),L.end!==void 0&&(ve=L.end),oe===this.c&&ve===this.e?this:new Bt(oe,ve)}}e.$qN=Bt;class ln{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(oe=>ln.isNotebookCellData(oe))}static isNotebookCellData(L){return!0}constructor(L,oe,ve,Ue,Ge,Qe,et){this.kind=L,this.value=oe,this.languageId=ve,this.mime=Ue,this.outputs=Ge??[],this.metadata=Qe,this.executionSummary=et,ln.validate(this)}}e.$rN=ln;class Ai{constructor(L){this.cells=L}}e.$sN=Ai;class Qn{static isNotebookCellOutputItem(L){return L instanceof l?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const oe={name:L.name,message:L.message,stack:L.stack};return l.json(oe,"application/vnd.code.notebook.error")}static stdout(L){return l.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return l.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,oe="application/octet-stream"){return new l(L,oe)}static text(L,oe=k.$rs.text){const ve=tt(l,l,"f",t).encode(String(L));return new l(ve,oe)}static json(L,oe="text/x-json"){const ve=JSON.stringify(L,void 0,"	");return l.text(ve,oe)}constructor(L,oe){this.data=L,this.mime=oe;const ve=(0,k.$vs)(oe,!0);if(!ve)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ve}}e.$tN=Qn,l=Qn,t={value:new TextEncoder};class un{static isNotebookCellOutput(L){return L instanceof un?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,oe=!1){const ve=new Set,Ue=new Set;for(let Ge=0;Ge<L.length;Ge++){const Qe=L[Ge],et=(0,k.$vs)(Qe.mime);if(!ve.has(et)||(0,d.$4J)(et)){ve.add(et);continue}Ue.add(Ge),oe&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return Ue.size===0?L:L.filter((Ge,Qe)=>!Ue.has(Qe))}constructor(L,oe,ve){this.items=un.ensureUniqueMimeTypes(L,!0),typeof oe=="string"?(this.id=oe,this.metadata=ve):(this.id=(0,D.$Ag)(),this.metadata=oe??ve)}}e.$uN=un;var Kn;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(Kn||(e.NotebookCellKind=Kn={}));var xn;(function(T){T[T.Idle=1]="Idle",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(xn||(e.NotebookCellExecutionState=xn={}));var _n;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(_n||(e.NotebookCellStatusBarAlignment=_n={}));var ei;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Ri{constructor(L,oe){this.text=L,this.alignment=oe}}e.$vN=Ri;var ti;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred"})(ti||(e.NotebookControllerAffinity=ti={}));var ni;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred",T[T.Hidden=-1]="Hidden"})(ni||(e.NotebookControllerAffinity2=ni={}));class Oi{constructor(L,oe=[]){this.uri=L,this.provides=(0,y.$3b)(oe)}}e.$wN=Oi;class Ni{constructor(L){this.label=L}}e.$xN=Ni;var ii;(function(T){T[T.Named=1]="Named",T[T.Indexed=2]="Indexed"})(ii||(e.NotebookVariablesRequestKind=ii={}));let On=class{constructor(L,oe){this.label=L,this.timestamp=oe}};e.$yN=On,e.$yN=On=Le([q],On);var ri;(function(T){T[T.Production=1]="Production",T[T.Development=2]="Development",T[T.Test=3]="Test"})(ri||(e.ExtensionMode=ri={}));var si;(function(T){T[T.Node=1]="Node",T[T.Webworker=2]="Webworker"})(si||(e.ExtensionRuntime=si={}));var oi;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(oi||(e.StandardTokenType=oi={}));class Mi{constructor(L,oe){this.ranges=L,this.wordPattern=oe}}e.$zN=Mi;class Li{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$AN=Li;var ai;(function(T){T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(ai||(e.TestResultState=ai={}));var ci;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(ci||(e.TestRunProfileKind=ci={}));let Nn=class{constructor(L=void 0,oe=void 0,ve=void 0,Ue=!1){this.include=L,this.exclude=oe,this.profile=ve,this.continuous=Ue}};e.$BN=Nn,e.$BN=Nn=Le([q],Nn);let Mn=H=class{static diff(L,oe,ve){const Ue=new H(L);return Ue.expectedOutput=oe,Ue.actualOutput=ve,Ue}constructor(L){this.message=L}};e.$CN=Mn,e.$CN=Mn=H=Le([q],Mn);let Ln=class{constructor(L){this.id=L}};e.$DN=Ln,e.$DN=Ln=Le([q],Ln);class fn{constructor(L,oe){this.covered=L,this.total=oe}}e.$EN=fn;const Fn=T=>{if(T&&T.covered>T.total)throw new Error(`The total number of covered items (${T.covered}) cannot be greater than the total (${T.total})`)};class Tn{static fromDetails(L,oe){const ve=new fn(0,0),Ue=new fn(0,0),Ge=new fn(0,0);for(const et of oe)if("branches"in et){ve.total+=1,ve.covered+=et.executed?1:0;for(const ht of et.branches)Ue.total+=1,Ue.covered+=ht.executed?1:0}else Ge.total+=1,Ge.covered+=et.executed?1:0;const Qe=new Tn(L,ve,Ue.total>0?Ue:void 0,Ge.total>0?Ge:void 0);return Qe.detailedCoverage=oe,Qe}constructor(L,oe,ve,Ue){this.uri=L,this.statementCoverage=oe,this.branchCoverage=ve,this.declarationCoverage=Ue,Fn(oe),Fn(ve),Fn(Ue)}}e.$FN=Tn;class Fi{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,oe,ve=[]){this.executed=L,this.location=oe,this.branches=ve}}e.$GN=Fi;class Ti{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,oe,ve){this.executed=L,this.location=oe,this.label=ve}}e.$HN=Ti;class ji{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,oe,ve){this.name=L,this.executed=oe,this.location=ve}}e.$IN=ji;var li;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(li||(e.ExternalUriOpenerPriority=li={}));var ui;(function(T){T[T.Untrusted=0]="Untrusted",T[T.Trusted=1]="Trusted",T[T.Unspecified=2]="Unspecified"})(ui||(e.WorkspaceTrustState=ui={}));var fi;(function(T){T[T.Notify=1]="Notify",T[T.OpenBrowser=2]="OpenBrowser",T[T.OpenPreview=3]="OpenPreview",T[T.Silent=4]="Silent",T[T.Ignore=5]="Ignore",T[T.OpenBrowserOnce=6]="OpenBrowserOnce"})(fi||(e.PortAutoForwardAction=fi={}));class Ui{constructor(L,oe,ve,Ue,Ge,Qe){this.kind=L,this.name=oe,this.detail=ve,this.uri=Ue,this.range=Ge,this.selectionRange=Qe}}e.$JN=Ui;class Bi{constructor(L){this.uri=L}}e.$KN=Bi;class zi{constructor(L,oe){this.original=L,this.modified=oe}}e.$LN=zi;class qi{constructor(L,oe,ve,Ue){this.base=L,this.input1=oe,this.input2=ve,this.result=Ue}}e.$MN=qi;class Hi{constructor(L,oe){this.uri=L,this.viewType=oe}}e.$NN=Hi;class Wi{constructor(L){this.viewType=L}}e.$ON=Wi;class Vi{constructor(L,oe){this.uri=L,this.notebookType=oe}}e.$PN=Vi;class Gi{constructor(L,oe,ve){this.original=L,this.modified=oe,this.notebookType=ve}}e.$QN=Gi;class Ji{constructor(){}}e.$RN=Ji;class Xi{constructor(L,oe){this.uri=L,this.inputBoxUri=oe}}e.$SN=Xi;class Zi{constructor(L){this.providerId=L}}e.$TN=Zi;var hi;(function(T){T[T.Down=0]="Down",T[T.Up=1]="Up"})(hi||(e.InteractiveSessionVoteDirection=hi={}));var di;(function(T){T[T.Action=1]="Action",T[T.Toolbar=2]="Toolbar"})(di||(e.ChatCopyKind=di={}));var mi;(function(T){T[T.Short=1]="Short",T[T.Medium=2]="Medium",T[T.Full=3]="Full"})(mi||(e.ChatVariableLevel=mi={}));class Yi{constructor(L,oe){this.label=L,this.values=oe}}e.$UN=Yi;var gi;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful",T[T.Undone=2]="Undone",T[T.Accepted=3]="Accepted",T[T.Bug=4]="Bug"})(gi||(e.InteractiveEditorResponseFeedbackKind=gi={}));var $i;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful"})($i||(e.ChatResultFeedbackKind=$i={}));class Qi{constructor(L){this.value=typeof L=="string"?new me(L):L}}e.$VN=Qi;class Ki{constructor(L,oe){this.value=L,this.baseUri=oe}}e.$WN=Ki;class xi{constructor(L,oe){this.value=L,this.title=oe}}e.$XN=xi;class _i{constructor(L){this.value=L}}e.$YN=_i;class er{constructor(L){this.value=L}}e.$ZN=er;class tr{constructor(L){this.value=L}}e.$1N=tr;class nr{constructor(L,oe,ve,Ue){this.prompt=L,this.command=oe,this.variables=ve,this.participant=Ue}}e.$2N=nr;class ir{constructor(L,oe,ve,Ue){this.response=L,this.result=oe,this.participant=ve,this.command=Ue}}e.$3N=ir;class rr{constructor(L){this.content=L}}e.$4N=rr;class sr{constructor(L,oe){this.content=L,this.name=oe}}e.$5N=sr;class or{constructor(L){this.content=L}}e.$6N=or;var bi;(function(T){T[T.SymbolInformation=1]="SymbolInformation",T[T.CommandInformation=2]="CommandInformation",T[T.SearchInformation=3]="SearchInformation",T[T.SettingInformation=4]="SettingInformation"})(bi||(e.RelatedInformationType=bi={}));var wi;(function(T){T[T.Started=1]="Started",T[T.Recognizing=2]="Recognizing",T[T.Recognized=3]="Recognized",T[T.Stopped=4]="Stopped"})(wi||(e.SpeechToTextStatus=wi={}));var pi;(function(T){T[T.Recognized=1]="Recognized",T[T.Stopped=2]="Stopped"})(pi||(e.KeywordRecognitionStatus=pi={}));class ar{constructor(L,oe){this.text=L,this.range=oe}}e.$7N=ar;var vi;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(vi||(e.InlineEditTriggerKind=vi={}))}),define(Ee[139],ke([1,0,18,14,157,76,101,24,146,52,61,21,19,9,4,44,175,230,133,94,137,73,95,135,284,138]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$eO=e.$dO=e.MarkdownString=e.$cO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var i;(function(we){function Pe(V){const{selectionStartLineNumber:pe,selectionStartColumn:Ce,positionLineNumber:qe,positionColumn:Be}=V,Ye=new n.$4L(pe-1,Ce-1),ot=new n.$4L(qe-1,Be-1);return new n.$6L(Ye,ot)}we.to=Pe;function he(V){const{anchor:pe,active:Ce}=V;return{selectionStartLineNumber:pe.line+1,selectionStartColumn:pe.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}we.from=he})(i||(e.Selection=i={}));var a;(function(we){function Pe(V){if(!V)return;const{start:pe,end:Ce}=V;return{startLineNumber:pe.line+1,startColumn:pe.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}we.from=Pe;function he(V){if(!V)return;const{startLineNumber:pe,startColumn:Ce,endLineNumber:qe,endColumn:Be}=V;return new n.$5L(pe-1,Ce-1,qe-1,Be-1)}we.to=he})(a||(e.Range=a={}));var $;(function(we){function Pe(V){return{uri:V.uri,range:a.from(V.range)}}we.from=Pe;function he(V){return new n.$cM(d.URI.revive(V.uri),a.to(V.range))}we.to=he})($||(e.Location=$={}));var A;(function(we){function Pe(he){switch(he){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}we.to=Pe})(A||(e.TokenType=A={}));var R;(function(we){function Pe(V){return new n.$4L(V.lineNumber-1,V.column-1)}we.to=Pe;function he(V){return{lineNumber:V.line+1,column:V.character+1}}we.from=he})(R||(e.Position=R={}));var I;(function(we){function Pe(pe,Ce,qe){return(0,y.$Hb)((0,y.$3b)(pe).map(Be=>he(Be,Ce,qe)))}we.from=Pe;function he(pe,Ce,qe){if(typeof pe=="string")return{$serialized:!0,language:pe,isBuiltin:qe?.isBuiltin};if(pe)return{$serialized:!0,language:pe.language,scheme:V(pe.scheme,Ce),pattern:Fe.from(pe.pattern)??void 0,exclusive:pe.exclusive,notebookType:pe.notebookType,isBuiltin:qe?.isBuiltin}}function V(pe,Ce){return Ce&&typeof pe=="string"?Ce.transformOutgoingScheme(pe):pe}})(I||(e.DocumentSelector=I={}));var O;(function(we){function Pe(V){switch(V){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}we.from=Pe;function he(V){switch(V){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}we.to=he})(O||(e.DiagnosticTag=O={}));var M;(function(we){function Pe(V){let pe;return V.code&&((0,m.$Sf)(V.code)||(0,m.$Wf)(V.code)?pe=String(V.code):pe={value:String(V.code.value),target:V.code.target}),{...a.from(V.range),message:V.message,source:V.source,code:pe,severity:ee.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(Z.from),tags:Array.isArray(V.tags)?(0,y.$Hb)(V.tags.map(O.from)):void 0}}we.from=Pe;function he(V){const pe=new n.$eM(a.to(V),V.message,ee.to(V.severity));return pe.source=V.source,pe.code=(0,m.$Sf)(V.code)?V.code:V.code?.value,pe.relatedInformation=V.relatedInformation&&V.relatedInformation.map(Z.to),pe.tags=V.tags&&(0,y.$Hb)(V.tags.map(O.to)),pe}we.to=he})(M||(e.Diagnostic=M={}));var Z;(function(we){function Pe(V){return{...a.from(V.location.range),message:V.message,resource:V.location.uri}}we.from=Pe;function he(V){return new n.$dM(new n.$cM(V.resource,a.to(V)),V.message)}we.to=he})(Z||(e.DiagnosticRelatedInformation=Z={}));var ee;(function(we){function Pe(V){switch(V){case n.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}we.from=Pe;function he(V){switch(V){case u.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}we.to=he})(ee||(e.DiagnosticSeverity=ee={}));var fe;(function(we){function Pe(V){return typeof V=="number"&&V>=n.ViewColumn.One?V-1:V===n.ViewColumn.Beside?r.$rD:r.$qD}we.from=Pe;function he(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=he})(fe||(e.ViewColumn=fe={}));function ue(we){return typeof we.range<"u"}function j(we){return we.length===0?!0:!!ue(we[0])}e.$cO=j;var H;(function(we){function Pe(Be){return Be.map(we.from)}we.fromMany=Pe;function he(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function V(Be){let Ye;if(he(Be)){const{language:ut,value:yt}=Be;Ye={value:"```"+ut+`
`+yt+"\n```\n"}}else n.$rM.isMarkdownString(Be)?Ye={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ye={value:Be}:Ye={value:""};const ot=Object.create(null);Ye.uris=ot;const gt=ut=>{try{let yt=d.URI.parse(ut,!0);yt=yt.with({query:pe(yt.query,ot)}),ot[ut]=yt}catch{}return""},vt=new v.marked.Renderer;return vt.link=gt,vt.image=ut=>typeof ut=="string"?gt(k.$Ak(ut).href):"",(0,v.marked)(Ye.value,{renderer:vt}),Ye}we.from=V;function pe(Be,Ye){if(!Be)return Be;let ot;try{ot=(0,p.$Mh)(Be)}catch{}if(!ot)return Be;let gt=!1;return ot=(0,E.$Kn)(ot,vt=>{if(d.URI.isUri(vt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ye[ut]=vt,gt=!0,ut}else return}),gt?JSON.stringify(ot):Be}function Ce(Be){const Ye=new n.$rM(Be.value,Be.supportThemeIcons);return Ye.isTrusted=Be.isTrusted,Ye.supportHtml=Be.supportHtml,Ye.baseUri=Be.baseUri?d.URI.from(Be.baseUri):void 0,Ye}we.to=Ce;function qe(Be){if(Be)return typeof Be=="string"?Be:we.from(Be)}we.fromStrict=qe})(H||(e.MarkdownString=H={}));function q(we){return j(we)?we.map(Pe=>({range:a.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?H.fromMany(Pe.hoverMessage):Pe.hoverMessage?H.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):we.map(Pe=>({range:a.from(Pe)}))}e.$dO=q;function J(we){return typeof we>"u"?we:typeof we=="string"?d.URI.file(we):we}e.$eO=J;var ne;(function(we){function Pe(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?J(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}we.from=Pe})(ne||(e.ThemableDecorationAttachmentRenderOptions=ne={}));var x;(function(we){function Pe(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?J(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?ne.from(he.before):void 0,after:he.after?ne.from(he.after):void 0}}we.from=Pe})(x||(e.ThemableDecorationRenderOptions=x={}));var G;(function(we){function Pe(he){if(typeof he>"u")return he;switch(he){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Pe})(G||(e.DecorationRangeBehavior=G={}));var se;(function(we){function Pe(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?G.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?x.from(he.light):void 0,dark:he.dark?x.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?J(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?ne.from(he.before):void 0,after:he.after?ne.from(he.after):void 0}}we.from=Pe})(se||(e.DecorationRenderOptions=se={}));var ce;(function(we){function Pe(V){return{text:V.newText,eol:V.newEol&&Ze.from(V.newEol),range:a.from(V.range)}}we.from=Pe;function he(V){const pe=new n.$0L(a.to(V.range),V.text);return pe.newEol=typeof V.eol>"u"?void 0:Ze.to(V.eol),pe}we.to=he})(ce||(e.TextEdit=ce={}));var re;(function(we){function Pe(V,pe){const Ce={edits:[]};if(V instanceof n.$aM){const qe=new P.$Bc;for(const Be of V._allEntries())Be._type===1&&d.URI.isUri(Be.to)&&Be.from===void 0&&qe.add(Be.to);for(const Be of V._allEntries())if(Be._type===1){let Ye;Be.options?.contents&&(ArrayBuffer.isView(Be.options.contents)?Ye={type:"base64",value:(0,C.$Me)(C.$se.wrap(Be.options.contents))}:Ye={type:"dataTransferItem",id:Be.options.contents._itemId}),Ce.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contents:Ye},metadata:Be.metadata})}else Be._type===2?Ce.edits.push({resource:Be.uri,textEdit:ce.from(Be.edit),versionId:qe.has(Be.uri)?void 0:pe?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Ce.edits.push({resource:Be.uri,textEdit:{range:a.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:qe.has(Be.uri)?void 0:pe?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Ce.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:pe?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Ce.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:pe?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(ft.from)}})}return Ce}we.from=Pe;function he(V){const pe=new n.$aM,Ce=new P.$Ac;for(const qe of V.edits)if(qe.textEdit){const Be=qe,Ye=d.URI.revive(Be.resource),ot=a.to(Be.textEdit.range),gt=Be.textEdit.text,vt=Be.textEdit.insertAsSnippet;let ut;vt?ut=n.$_L.replace(ot,new n.$bM(gt)):ut=n.$0L.replace(ot,gt);const yt=Ce.get(Ye);yt?yt.push(ut):Ce.set(Ye,[ut])}else pe.renameFile(d.URI.revive(qe.oldResource),d.URI.revive(qe.newResource),qe.options);for(const[qe,Be]of Ce)pe.set(qe,Be);return pe}we.to=he})(re||(e.WorkspaceEdit=re={}));var ge;(function(we){const Pe=Object.create(null);Pe[n.SymbolKind.File]=0,Pe[n.SymbolKind.Module]=1,Pe[n.SymbolKind.Namespace]=2,Pe[n.SymbolKind.Package]=3,Pe[n.SymbolKind.Class]=4,Pe[n.SymbolKind.Method]=5,Pe[n.SymbolKind.Property]=6,Pe[n.SymbolKind.Field]=7,Pe[n.SymbolKind.Constructor]=8,Pe[n.SymbolKind.Enum]=9,Pe[n.SymbolKind.Interface]=10,Pe[n.SymbolKind.Function]=11,Pe[n.SymbolKind.Variable]=12,Pe[n.SymbolKind.Constant]=13,Pe[n.SymbolKind.String]=14,Pe[n.SymbolKind.Number]=15,Pe[n.SymbolKind.Boolean]=16,Pe[n.SymbolKind.Array]=17,Pe[n.SymbolKind.Object]=18,Pe[n.SymbolKind.Key]=19,Pe[n.SymbolKind.Null]=20,Pe[n.SymbolKind.EnumMember]=21,Pe[n.SymbolKind.Struct]=22,Pe[n.SymbolKind.Event]=23,Pe[n.SymbolKind.Operator]=24,Pe[n.SymbolKind.TypeParameter]=25;function he(pe){return typeof Pe[pe]=="number"?Pe[pe]:6}we.from=he;function V(pe){for(const Ce in Pe)if(Pe[Ce]===pe)return Number(Ce);return n.SymbolKind.Property}we.to=V})(ge||(e.SymbolKind=ge={}));var B;(function(we){function Pe(V){switch(V){case n.SymbolTag.Deprecated:return 1}}we.from=Pe;function he(V){switch(V){case 1:return n.SymbolTag.Deprecated}}we.to=he})(B||(e.SymbolTag=B={}));var W;(function(we){function Pe(V){return{name:V.name,kind:ge.from(V.kind),tags:V.tags&&V.tags.map(B.from),containerName:V.containerName,location:K.from(V.location)}}we.from=Pe;function he(V){const pe=new n.$iM(V.name,ge.to(V.kind),V.containerName,K.to(V.location));return pe.tags=V.tags&&V.tags.map(B.to),pe}we.to=he})(W||(e.WorkspaceSymbol=W={}));var F;(function(we){function Pe(V){const pe={name:V.name||"!!MISSING: name!!",detail:V.detail,range:a.from(V.range),selectionRange:a.from(V.selectionRange),kind:ge.from(V.kind),tags:V.tags?.map(B.from)??[]};return V.children&&(pe.children=V.children.map(Pe)),pe}we.from=Pe;function he(V){const pe=new n.$jM(V.name,V.detail,ge.to(V.kind),a.to(V.range),a.to(V.selectionRange));return(0,y.$Lb)(V.tags)&&(pe.tags=V.tags.map(B.to)),V.children&&(pe.children=V.children.map(he)),pe}we.to=he})(F||(e.DocumentSymbol=F={}));var z;(function(we){function Pe(V){const pe=new n.$nM(ge.to(V.kind),V.name,V.detail||"",d.URI.revive(V.uri),a.to(V.range),a.to(V.selectionRange));return pe._sessionId=V._sessionId,pe._itemId=V._itemId,pe}we.to=Pe;function he(V,pe,Ce){if(pe=pe??V._sessionId,Ce=Ce??V._itemId,pe===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:pe,_itemId:Ce,name:V.name,detail:V.detail,kind:ge.from(V.kind),uri:V.uri,range:a.from(V.range),selectionRange:a.from(V.selectionRange),tags:V.tags?.map(B.from)}}we.from=he})(z||(e.CallHierarchyItem=z={}));var _;(function(we){function Pe(he){return new n.$oM(z.to(he.from),he.fromRanges.map(V=>a.to(V)))}we.to=Pe})(_||(e.CallHierarchyIncomingCall=_={}));var Q;(function(we){function Pe(he){return new n.$pM(z.to(he.to),he.fromRanges.map(V=>a.to(V)))}we.to=Pe})(Q||(e.CallHierarchyOutgoingCall=Q={}));var K;(function(we){function Pe(V){return{range:V.range&&a.from(V.range),uri:V.uri}}we.from=Pe;function he(V){return new n.$cM(d.URI.revive(V.uri),a.to(V.range))}we.to=he})(K||(e.location=K={}));var X;(function(we){function Pe(V){const pe=V,Ce=V;return{originSelectionRange:pe.originSelectionRange?a.from(pe.originSelectionRange):void 0,uri:pe.targetUri?pe.targetUri:Ce.uri,range:a.from(pe.targetRange?pe.targetRange:Ce.range),targetSelectionRange:pe.targetSelectionRange?a.from(pe.targetSelectionRange):void 0}}we.from=Pe;function he(V){return{targetUri:d.URI.revive(V.uri),targetRange:a.to(V.range),targetSelectionRange:V.targetSelectionRange?a.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?a.to(V.originSelectionRange):void 0}}we.to=he})(X||(e.DefinitionLink=X={}));var Y;(function(we){function Pe(V){return{range:a.from(V.range),contents:H.fromMany(V.contents)}}we.from=Pe;function he(V){return new n.$fM(V.contents.map(H.to),a.to(V.range))}we.to=he})(Y||(e.Hover=Y={}));var N;(function(we){function Pe(V){return{range:a.from(V.range),expression:V.expression}}we.from=Pe;function he(V){return new n.$_M(a.to(V.range),V.expression)}we.to=he})(N||(e.EvaluatableExpression=N={}));var U;(function(we){function Pe(V){if(V instanceof n.$aN)return{type:"text",range:a.from(V.range),text:V.text};if(V instanceof n.$bN)return{type:"variable",range:a.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof n.$cN)return{type:"expression",range:a.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Pe;function he(V){switch(V.type){case"text":return{range:a.to(V.range),text:V.text};case"variable":return{range:a.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:a.to(V.range),expression:V.expression}}}we.to=he})(U||(e.InlineValue=U={}));var te;(function(we){function Pe(V){return{frameId:V.frameId,stoppedLocation:a.from(V.stoppedLocation)}}we.from=Pe;function he(V){return new n.$dN(V.frameId,a.to(V.stoppedLocation))}we.to=he})(te||(e.InlineValueContext=te={}));var ie;(function(we){function Pe(V){return{range:a.from(V.range),kind:V.kind}}we.from=Pe;function he(V){return new n.$gM(a.to(V.range),V.kind)}we.to=he})(ie||(e.DocumentHighlight=ie={}));var de;(function(we){function Pe(V){return{uri:V.uri,highlights:V.highlights.map(ie.from)}}we.from=Pe;function he(V){return new n.$hM(d.URI.revive(V.uri),V.highlights.map(ie.to))}we.to=he})(de||(e.MultiDocumentHighlight=de={}));var ae;(function(we){function Pe(he){switch(he){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}we.to=Pe})(ae||(e.CompletionTriggerKind=ae={}));var be;(function(we){function Pe(he){return{triggerKind:ae.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}we.to=Pe})(be||(e.CompletionContext=be={}));var ye;(function(we){function Pe(V){switch(V){case n.CompletionItemTag.Deprecated:return 1}}we.from=Pe;function he(V){switch(V){case 1:return n.CompletionItemTag.Deprecated}}we.to=he})(ye||(e.CompletionItemTag=ye={}));var Re;(function(we){const Pe=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function he(Ce){return Pe.get(Ce)??9}we.from=he;const V=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function pe(Ce){return V.get(Ce)??n.CompletionItemKind.Property}we.to=pe})(Re||(e.CompletionItemKind=Re={}));var Me;(function(we){function Pe(he,V){const pe=new n.$xM(he.label);return pe.insertText=he.insertText,pe.kind=Re.to(he.kind),pe.tags=he.tags?.map(ye.to),pe.detail=he.detail,pe.documentation=k.$uk(he.documentation)?H.to(he.documentation):he.documentation,pe.sortText=he.sortText,pe.filterText=he.filterText,pe.preselect=he.preselect,pe.commitCharacters=he.commitCharacters,c.$7s.isIRange(he.range)?pe.range=a.to(he.range):typeof he.range=="object"&&(pe.range={inserting:a.to(he.range.insert),replacing:a.to(he.range.replace)}),pe.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?pe.insertText=new n.$bM(he.insertText):(pe.insertText=he.insertText,pe.textEdit=pe.range instanceof n.$5L?new n.$0L(pe.range,pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(pe.additionalTextEdits=he.additionalTextEdits.map(Ce=>ce.to(Ce))),pe.command=V&&he.command?V.fromInternal(he.command):void 0,pe}we.to=Pe})(Me||(e.CompletionItem=Me={}));var $e;(function(we){function Pe(V){if(typeof V.label!="string"&&!Array.isArray(V.label))throw new TypeError("Invalid label");return{label:V.label,documentation:H.fromStrict(V.documentation)}}we.from=Pe;function he(V){return{label:V.label,documentation:k.$uk(V.documentation)?H.to(V.documentation):V.documentation}}we.to=he})($e||(e.ParameterInformation=$e={}));var Se;(function(we){function Pe(V){return{label:V.label,documentation:H.fromStrict(V.documentation),parameters:Array.isArray(V.parameters)?V.parameters.map($e.from):[],activeParameter:V.activeParameter}}we.from=Pe;function he(V){return{label:V.label,documentation:k.$uk(V.documentation)?H.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map($e.to):[],activeParameter:V.activeParameter}}we.to=he})(Se||(e.SignatureInformation=Se={}));var De;(function(we){function Pe(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(Se.from):[]}}we.from=Pe;function he(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(Se.to):[]}}we.to=he})(De||(e.SignatureHelp=De={}));var je;(function(we){function Pe(he,V){const pe=new n.$wM(R.to(V.position),typeof V.label=="string"?V.label:V.label.map(Te.to.bind(void 0,he)),V.kind&&We.to(V.kind));return pe.textEdits=V.textEdits&&V.textEdits.map(ce.to),pe.tooltip=k.$uk(V.tooltip)?H.to(V.tooltip):V.tooltip,pe.paddingLeft=V.paddingLeft,pe.paddingRight=V.paddingRight,pe}we.to=Pe})(je||(e.InlayHint=je={}));var Te;(function(we){function Pe(he,V){const pe=new n.$vM(V.label);return pe.tooltip=k.$uk(V.tooltip)?H.to(V.tooltip):V.tooltip,b.Command.is(V.command)&&(pe.command=he.fromInternal(V.command)),V.location&&(pe.location=K.to(V.location)),pe}we.to=Pe})(Te||(e.InlayHintLabelPart=Te={}));var We;(function(we){function Pe(V){return V}we.from=Pe;function he(V){return V}we.to=he})(We||(e.InlayHintKind=We={}));var ze;(function(we){function Pe(V){return{range:a.from(V.range),url:V.target,tooltip:V.tooltip}}we.from=Pe;function he(V){let pe;if(V.url)try{pe=typeof V.url=="string"?d.URI.parse(V.url,!0):d.URI.revive(V.url)}catch{}return new n.$CM(a.to(V.range),pe)}we.to=he})(ze||(e.DocumentLink=ze={}));var Je;(function(we){function Pe(V){const pe=new n.$FM(V.label);return V.textEdit&&(pe.textEdit=ce.to(V.textEdit)),V.additionalTextEdits&&(pe.additionalTextEdits=V.additionalTextEdits.map(Ce=>ce.to(Ce))),pe}we.to=Pe;function he(V){return{label:V.label,textEdit:V.textEdit?ce.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(pe=>ce.from(pe)):void 0}}we.from=he})(Je||(e.ColorPresentation=Je={}));var _e;(function(we){function Pe(V){return new n.$DM(V[0],V[1],V[2],V[3])}we.to=Pe;function he(V){return[V.red,V.green,V.blue,V.alpha]}we.from=he})(_e||(e.Color=_e={}));var xe;(function(we){function Pe(V){return{range:a.from(V.range)}}we.from=Pe;function he(V){return new n.$mM(a.to(V.range))}we.to=he})(xe||(e.SelectionRange=xe={}));var nt;(function(we){function Pe(he){switch(he){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}we.to=Pe})(nt||(e.TextDocumentSaveReason=nt={}));var Ke;(function(we){function Pe(V){switch(V){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.Interval:return 3;case n.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Pe;function he(V){switch(V){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 3:return n.TextEditorLineNumbersStyle.Interval;case 1:default:return n.TextEditorLineNumbersStyle.On}}we.to=he})(Ke||(e.TextEditorLineNumbersStyle=Ke={}));var Ze;(function(we){function Pe(V){if(V===n.EndOfLine.CRLF)return 1;if(V===n.EndOfLine.LF)return 0}we.from=Pe;function he(V){if(V===1)return n.EndOfLine.CRLF;if(V===0)return n.EndOfLine.LF}we.to=he})(Ze||(e.EndOfLine=Ze={}));var me;(function(we){function Pe(he){if(typeof he=="object")return he.viewId;switch(he){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Pe})(me||(e.ProgressLocation=me={}));var Ie;(function(we){function Pe(V){const pe={start:V.start+1,end:V.end+1};return V.kind&&(pe.kind=Ae.from(V.kind)),pe}we.from=Pe;function he(V){const pe={start:V.start-1,end:V.end-1};return V.kind&&(pe.kind=Ae.to(V.kind)),pe}we.to=he})(Ie||(e.FoldingRange=Ie={}));var Ae;(function(we){function Pe(V){if(V)switch(V){case n.FoldingRangeKind.Comment:return b.$Xt.Comment;case n.FoldingRangeKind.Imports:return b.$Xt.Imports;case n.FoldingRangeKind.Region:return b.$Xt.Region}}we.from=Pe;function he(V){if(V)switch(V.value){case b.$Xt.Comment.value:return n.FoldingRangeKind.Comment;case b.$Xt.Imports.value:return n.FoldingRangeKind.Imports;case b.$Xt.Region.value:return n.FoldingRangeKind.Region}}we.to=he})(Ae||(e.FoldingRangeKind=Ae={}));var Oe;(function(we){function Pe(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?a.from(he.selection):void 0,override:typeof he.override=="boolean"?h.$TE.id:void 0}}we.from=Pe})(Oe||(e.TextEditorOpenOptions=Oe={}));var Fe;(function(we){function Pe(Ce){return Ce instanceof n.$ZM?Ce.toJSON():typeof Ce=="string"?Ce:he(Ce)||V(Ce)?new n.$ZM(Ce.baseUri??Ce.base,Ce.pattern).toJSON():Ce}we.from=Pe;function he(Ce){const qe=Ce;return qe?d.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function V(Ce){const qe=Ce;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function pe(Ce){return typeof Ce=="string"?Ce:new n.$ZM(d.URI.revive(Ce.baseUri),Ce.pattern)}we.to=pe})(Fe||(e.GlobPattern=Fe={}));var He;(function(we){function Pe(he){if(he){if(Array.isArray(he))return he.map(Pe);if(typeof he=="string")return he;{const V=he;return{language:V.language,scheme:V.scheme,pattern:Fe.from(V.pattern),exclusive:V.exclusive,notebookType:V.notebookType}}}else return}we.from=Pe})(He||(e.LanguageSelector=He={}));var Ve;(function(we){function Pe(V){return!!V&&typeof V=="object"&&"documents"in V&&Array.isArray(V.documents)&&V.documents.every(pe=>Array.isArray(pe)&&pe.every(Ce=>Ce&&typeof Ce=="object"&&"uri"in Ce&&d.URI.isUri(Ce.uri)&&"version"in Ce&&typeof Ce.version=="number"&&"ranges"in Ce&&Array.isArray(Ce.ranges)&&Ce.ranges.every(qe=>qe instanceof n.$5L)))}we.is=Pe;function he(V){return{documents:V.documents.map(pe=>pe.map(Ce=>({uri:d.URI.from(Ce.uri),version:Ce.version,ranges:Ce.ranges.map(qe=>a.from(qe))})))}}we.from=he})(Ve||(e.MappedEditsContext=Ve={}));var st;(function(we){function Pe(V){return{start:V.start,end:V.end}}we.from=Pe;function he(V){return new n.$qN(V.start,V.end)}we.to=he})(st||(e.NotebookRange=st={}));var it;(function(we){function Pe(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}we.to=Pe;function he(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}we.from=he})(it||(e.NotebookCellExecutionSummary=it={}));var Xe;(function(we){function Pe(he){if(he===f.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(he===f.NotebookCellExecutionState.Pending)return;if(he===f.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}we.to=Pe})(Xe||(e.NotebookCellExecutionState=Xe={}));var ct;(function(we){function Pe(V){switch(V){case n.NotebookCellKind.Markup:return f.CellKind.Markup;case n.NotebookCellKind.Code:default:return f.CellKind.Code}}we.from=Pe;function he(V){switch(V){case f.CellKind.Markup:return n.NotebookCellKind.Markup;case f.CellKind.Code:default:return n.NotebookCellKind.Code}}we.to=he})(ct||(e.NotebookCellKind=ct={}));var at;(function(we){function Pe(V){const pe={metadata:V.metadata??Object.create(null),cells:[]};for(const Ce of V.cells)n.$rN.validate(Ce),pe.cells.push(ft.from(Ce));return pe}we.from=Pe;function he(V){const pe=new n.$sN(V.cells.map(ft.to));return(0,m.$6f)(V.metadata)||(pe.metadata=V.metadata),pe}we.to=he})(at||(e.NotebookData=at={}));var ft;(function(we){function Pe(V){return{cellKind:ct.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:it.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(mt.from):[]}}we.from=Pe;function he(V){return new n.$rN(ct.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(mt.to):void 0,V.metadata,V.internalMetadata?it.to(V.internalMetadata):void 0)}we.to=he})(ft||(e.NotebookCellData=ft={}));var lt;(function(we){function Pe(V){return{mime:V.mime,valueBytes:C.$se.wrap(V.data)}}we.from=Pe;function he(V){return new n.$tN(V.valueBytes.buffer,V.mime)}we.to=he})(lt||(e.NotebookCellOutputItem=lt={}));var mt;(function(we){function Pe(V){return{outputId:V.id,items:V.items.map(lt.from),metadata:V.metadata}}we.from=Pe;function he(V){const pe=V.items.map(lt.to);return new n.$uN(pe,V.outputId,V.metadata)}we.to=he})(mt||(e.NotebookCellOutput=mt={}));var zt;(function(we){function Pe(pe){return V(pe)?{include:Fe.from(pe.include)??void 0,exclude:Fe.from(pe.exclude)??void 0}:Fe.from(pe)??void 0}we.from=Pe;function he(pe){return V(pe)?{include:Fe.to(pe.include),exclude:Fe.to(pe.exclude)}:Fe.to(pe)}we.to=he;function V(pe){const Ce=pe;return Ce?!(0,m.$2f)(Ce.include)&&!(0,m.$2f)(Ce.exclude):!1}})(zt||(e.NotebookExclusiveDocumentPattern=zt={}));var qt;(function(we){function Pe(he,V,pe){const Ce=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Ce,pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}we.from=Pe})(qt||(e.NotebookStatusBarItem=qt={}));var Ht;(function(we){function Pe(he,V,pe){const Ce=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:V.toInternal(Ce,pe),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}we.from=Pe})(Ht||(e.NotebookKernelSourceAction=Ht={}));var Rt;(function(we){function Pe(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}we.from=Pe})(Rt||(e.NotebookDocumentContentOptions=Rt={}));var kt;(function(we){function Pe(V){return{uri:V.uri,provides:V.provides}}we.from=Pe;function he(V){return new n.$wN(d.URI.revive(V.uri),V.provides)}we.to=he})(kt||(e.NotebookRendererScript=kt={}));var Ot;(function(we){function Pe(V){return{message:H.fromStrict(V.message)||"",type:0,expected:V.expectedOutput,actual:V.actualOutput,contextValue:V.contextValue,location:V.location&&{range:a.from(V.location.range),uri:V.location.uri}}}we.from=Pe;function he(V){const pe=new n.$CN(typeof V.message=="string"?V.message:H.to(V.message));return pe.actualOutput=V.actual,pe.expectedOutput=V.expected,pe.contextValue=V.contextValue,pe.location=V.location?K.to(V.location):void 0,pe}we.to=he})(Ot||(e.TestMessage=Ot={}));var $t;(function(we){we.namespace=t.$VK,we.denamespace=t.$WK})($t||(e.TestTag=$t={}));var bt;(function(we){function Pe(V){const pe=(0,g.$bO)(V).controllerId;return{extId:l.$RK.fromExtHostTestItem(V,pe).toString(),label:V.label,uri:d.URI.revive(V.uri),busy:V.busy,tags:V.tags.map(Ce=>$t.namespace(pe,Ce.id)),range:c.$7s.lift(a.from(V.range)),description:V.description||null,sortText:V.sortText||null,error:V.error&&H.fromStrict(V.error)||null}}we.from=Pe;function he(V){return{parent:void 0,error:void 0,id:l.$RK.fromString(V.extId).localId,label:V.label,uri:d.URI.revive(V.uri),tags:(V.tags||[]).map(pe=>{const{tagId:Ce}=$t.denamespace(pe);return new n.$DN(Ce)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(V.range||void 0),canResolveChildren:!1,busy:V.busy,description:V.description||void 0,sortText:V.sortText||void 0}}we.toPlain=he})(bt||(e.TestItem=bt={})),function(we){function Pe(V){return{id:V.id}}we.from=Pe;function he(V){return new n.$DN(V.id)}we.to=he}($t||(e.TestTag=$t={}));var Wt;(function(we){const Pe=(V,pe)=>{const Ce=[];for(const[Be,Ye]of pe)l.$RK.compare(Ye.item.extId,Be)===2&&(pe.delete(Be),Ce.push(Ye));const qe={...bt.toPlain(V.item),parent:void 0,taskStates:V.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ye=>Ye.type===0).map(Ot.to)})),children:Ce.map(Be=>Pe(Be,pe))};for(const Be of qe.children)Be.parent=qe;return qe};function he(V){const pe=[],Ce=new Map;for(const qe of V.items){Ce.set(qe.item.extId,qe);const Be=l.$RK.root(qe.item.extId);V.request.targets.some(Ye=>Ye.controllerId===Be&&Ye.testIds.includes(qe.item.extId))&&pe.push(qe)}return{completedAt:V.completedAt,results:pe.map(qe=>Pe(qe,Ce))}}we.to=he})(Wt||(e.TestResults=Wt={}));var St;(function(we){function Pe(Ce){return{covered:Ce.covered,total:Ce.total}}function he(Ce){return"line"in Ce?R.from(Ce):a.from(Ce)}function V(Ce){return"branches"in Ce?{count:Ce.executed,location:he(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(qe=>({count:qe.executed,location:qe.location&&he(qe.location),label:qe.label})):void 0}:{type:0,name:Ce.name,count:Ce.executed,location:he(Ce.location)}}we.fromDetailed=V;function pe(Ce){return{uri:Ce.uri,statement:Pe(Ce.statementCoverage),branch:Ce.branchCoverage&&Pe(Ce.branchCoverage),declaration:Ce.declarationCoverage&&Pe(Ce.declarationCoverage),details:Ce.detailedCoverage?.map(V)}}we.fromFile=pe})(St||(e.TestCoverage=St={}));var rt;(function(we){function Pe(he){switch(he){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}we.to=Pe})(rt||(e.CodeActionTriggerKind=rt={}));var wt;(function(we){function Pe(V){const pe=new n.$JN(ge.to(V.kind),V.name,V.detail||"",d.URI.revive(V.uri),a.to(V.range),a.to(V.selectionRange));return pe._sessionId=V._sessionId,pe._itemId=V._itemId,pe}we.to=Pe;function he(V,pe,Ce){if(pe=pe??V._sessionId,Ce=Ce??V._itemId,pe===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:pe,_itemId:Ce,kind:ge.from(V.kind),name:V.name,detail:V.detail??"",uri:V.uri,range:a.from(V.range),selectionRange:a.from(V.selectionRange),tags:V.tags?.map(B.from)}}we.from=he})(wt||(e.TypeHierarchyItem=wt={}));var pt;(function(we){function Pe(he){if(he)return{value:he.value,tooltip:he.tooltip}}we.from=Pe})(pt||(e.ViewBadge=pt={}));var dt;(function(we){function Pe(Ce,qe,Be){const Ye=qe.fileData;return Ye?new n.$SM(new n.$TM(Ye.name,d.URI.revive(Ye.uri),Ye.id,(0,S.$db)(()=>Be(Ye.id)))):Ce===D.$rs.uriList&&qe.uriListData?new n.$RM(pe(qe.uriListData)):new n.$RM(qe.asString)}we.to=Pe;async function he(Ce,qe){const Be=await qe.asString();if(Ce===D.$rs.uriList)return{asString:Be,fileData:void 0,uriListData:V(Be)};const Ye=qe.asFile();return{asString:Be,fileData:Ye?{name:Ye.name,uri:Ye.uri,id:Ye._itemId??Ye.id}:void 0}}we.from=he;function V(Ce){return s.$Dt.split(Ce).map(qe=>{if(qe.startsWith("#"))return qe;try{return d.URI.parse(qe)}catch{}return qe})}function pe(Ce){return s.$Dt.create(Ce.map(qe=>typeof qe=="string"?qe:d.URI.revive(qe)))}})(dt||(e.DataTransferItem=dt={}));var Vt;(function(we){function Pe(V,pe){const Ce=V.items.map(([qe,Be])=>[qe,dt.to(qe,Be,pe)]);return new n.$UM(Ce)}we.toDataTransfer=Pe;async function he(V){const pe={items:[]},Ce=[];for(const[qe,Be]of V)Ce.push((async()=>{pe.items.push([qe,await dt.from(qe,Be)])})());return await Promise.all(Ce),pe}we.from=he})(Vt||(e.DataTransfer=Vt={}));var Ft;(function(we){function Pe(V,pe){return{kind:"reply",agentId:V.participant??pe?.agentId??"",subCommand:V.command??pe?.command,message:V.prompt,title:V.label}}we.from=Pe;function he(V){return{prompt:V.message,label:V.title,participant:V.agentId,command:V.subCommand}}we.to=he})(Ft||(e.ChatFollowup=Ft={}));var Gt;(function(we){function Pe(he){return"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}we.from=Pe})(Gt||(e.ChatInlineFollowup=Gt={}));var Jt;(function(we){function Pe(V){switch(V.role){case 0:return new n.$4N(V.content);case 1:return new n.$5N(V.content);case 2:return new n.$6N(V.content)}}we.to=Pe;function he(V){if(V instanceof n.$4N)return{role:0,content:V.content};if(V instanceof n.$5N)return{role:1,content:V.content};if(V instanceof n.$6N)return{role:2,content:V.content};throw new Error("Invalid LanguageModelMessage")}we.from=he})(Jt||(e.LanguageModelMessage=Jt={}));var Tt;(function(we){function Pe(pe){const Ce={};for(const qe of Object.keys(pe))Ce[qe]=pe[qe].map(we.to);return Ce}we.objectTo=Pe;function he(pe){return{level:jt.to(pe.level),kind:pe.kind,value:(0,d.$vc)(pe.value)?d.URI.revive(pe.value):pe.value,description:pe.description}}we.to=he;function V(pe){return{level:jt.from(pe.level),kind:pe.kind,value:pe.value,description:pe.description}}we.from=V})(Tt||(e.ChatVariable=Tt={}));var jt;(function(we){function Pe(V){switch(V){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}we.to=Pe;function he(V){switch(V){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}we.from=he})(jt||(e.ChatVariableLevel=jt={}));var Xt;(function(we){function Pe(he){switch(he){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Pe})(Xt||(e.InteractiveEditorResponseFeedbackKind=Xt={}));var It;(function(we){function Pe(V){return{kind:"markdownContent",content:H.from(V.value)}}we.to=Pe;function he(V){return new n.$VN(H.to(V.content))}we.from=he})(It||(e.ChatResponseMarkdownPart=It={}));var Zt;(function(we){function Pe(V){const{value:pe,baseUri:Ce}=V;function qe(Be,Ye){return Be.map(ot=>{const gt=d.URI.joinPath(Ye,ot.name);return{label:ot.name,uri:gt,children:ot.children&&qe(ot.children,gt)}})}return{kind:"treeData",treeData:{label:(0,w.$Og)(Ce),uri:Ce,children:qe(pe,Ce)}}}we.to=Pe;function he(V){const pe=(0,p.$Nh)(V.treeData);function Ce(Ye){return Ye.map(ot=>({name:ot.label,children:ot.children&&Ce(ot.children)}))}const qe=pe.uri,Be=pe.children?Ce(pe.children):[];return new n.$WN(Be,qe)}we.from=he})(Zt||(e.ChatResponseFilesPart=Zt={}));var Yt;(function(we){function Pe(V){return{kind:"inlineReference",name:V.title,inlineReference:d.URI.isUri(V.value)?V.value:$.from(V.value)}}we.to=Pe;function he(V){const pe=(0,p.$Nh)(V);return new n.$XN(d.URI.isUri(pe.inlineReference)?pe.inlineReference:$.to(pe.inlineReference),V.name)}we.from=he})(Yt||(e.ChatResponseAnchorPart=Yt={}));var Dt;(function(we){function Pe(V){return{kind:"progressMessage",content:H.from(V.value)}}we.to=Pe;function he(V){return new n.$YN(V.content.value)}we.from=he})(Dt||(e.ChatResponseProgressPart=Dt={}));var xt;(function(we){function Pe(V,pe,Ce){return{kind:"command",command:pe.toInternal(V.value,Ce)??{command:V.value.command,title:V.value.title}}}we.to=Pe;function he(V,pe){return new n.$ZN(pe.fromInternal(V.command)??{command:V.command.id,title:V.command.title})}we.from=he})(xt||(e.ChatResponseCommandButtonPart=xt={}));var Nt;(function(we){function Pe(V){return{kind:"reference",reference:d.URI.isUri(V.value)?V.value:$.from(V.value)}}we.to=Pe;function he(V){const pe=(0,p.$Nh)(V);return new n.$1N(d.URI.isUri(pe.reference)?pe.reference:$.to(pe.reference))}we.from=he})(Nt||(e.ChatResponseReferencePart=Nt={}));var Qt;(function(we){function Pe(pe){return pe instanceof n.$VN?It.to(pe):pe instanceof n.$XN?Yt.to(pe):pe instanceof n.$1N?Nt.to(pe):pe instanceof n.$YN?Dt.to(pe):pe instanceof n.$WN?Zt.to(pe):{kind:"content",content:""}}we.to=Pe;function he(pe,Ce){switch(pe.kind){case"reference":return Nt.from(pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return V(pe,Ce)}}we.from=he;function V(pe,Ce){switch(pe.kind){case"markdownContent":return It.from(pe);case"inlineReference":return Yt.from(pe);case"progressMessage":return;case"treeData":return Zt.from(pe);case"command":return xt.from(pe,Ce)}}we.fromContent=V})(Qt||(e.ChatResponsePart=Qt={}));var _t;(function(we){function Pe(pe,Ce){return"markdownContent"in Ce?((0,o.$WF)(pe,"chatParticipantAdditions"),{content:H.from(Ce.markdownContent),kind:"markdownContent"}):"content"in Ce?"vulnerabilities"in Ce&&Ce.vulnerabilities?((0,o.$WF)(pe,"chatParticipantAdditions"),{content:Ce.content,vulnerabilities:Ce.vulnerabilities,kind:"vulnerability"}):typeof Ce.content=="string"?{content:Ce.content,kind:"content"}:((0,o.$WF)(pe,"chatParticipantAdditions"),{content:H.from(Ce.content),kind:"markdownContent"}):"documents"in Ce?{documents:Ce.documents.map(qe=>({uri:qe.uri,version:qe.version,ranges:qe.ranges.map(Be=>a.from(Be))})),kind:"usedContext"}:"reference"in Ce?{reference:"uri"in Ce.reference?{uri:Ce.reference.uri,range:a.from(Ce.reference.range)}:Ce.reference,kind:"reference"}:"inlineReference"in Ce?{inlineReference:"uri"in Ce.inlineReference?{uri:Ce.inlineReference.uri,range:a.from(Ce.inlineReference.range)}:Ce.inlineReference,name:Ce.title,kind:"inlineReference"}:"participant"in Ce?((0,o.$WF)(pe,"chatParticipantAdditions"),{agentName:Ce.participant,command:Ce.command,kind:"agentDetection"}):"message"in Ce?{content:H.from(Ce.message),kind:"progressMessage"}:void 0}we.from=Pe;function he(pe){switch(pe.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(pe);case"content":return{content:pe.content};case"usedContext":return{documents:pe.documents.map(Ce=>({uri:d.URI.revive(Ce.uri),version:Ce.version,ranges:Ce.ranges.map(qe=>a.to(qe))}))};case"reference":return{reference:(0,d.$vc)(pe.reference)?d.URI.revive(pe.reference):$.to(pe.reference)};case"agentDetection":return;case"progressMessage":return{message:pe.content.value};case"vulnerability":return{content:pe.content,vulnerabilities:pe.vulnerabilities};default:return}}we.to=he;function V(pe,Ce){switch(pe.kind){case"markdownContent":return{content:pe.content.value};case"inlineReference":return{inlineReference:(0,d.$vc)(pe.inlineReference)?d.URI.revive(pe.inlineReference):$.to(pe.inlineReference),title:pe.name};case"command":return{command:Ce.fromInternal(pe.command)??{command:pe.command.id,title:pe.command.title}};default:return}}we.toProgressContent=V})(_t||(e.ChatResponseProgress=_t={}));var Kt;(function(we){function Pe(he){return{prompt:he.message,command:he.command,variables:he.variables.variables.map(en.to)}}we.to=Pe})(Kt||(e.ChatAgentRequest=Kt={}));var en;(function(we){function Pe(he){return{name:he.name,range:[he.range.start,he.range.endExclusive],values:he.values.map(Tt.to)}}we.to=Pe})(en||(e.ChatAgentResolvedVariable=en={}));var Ct;(function(we){function Pe(he){return{label:he.label,values:he.values.map(Tt.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}we.from=Pe})(Ct||(e.ChatAgentCompletionItem=Ct={}));var tn;(function(we){function Pe(he){return{errorDetails:he.errorDetails,metadata:he.metadata}}we.to=Pe})(tn||(e.ChatAgentResult=tn={}));var sn;(function(we){function Pe(he,V,pe){if(V.action.kind==="vote")return;const Ce=tn.to(he);return V.action.kind==="command"?{action:{kind:"command",commandButton:_t.toProgressContent(V.action.commandButton,pe)},result:Ce}:V.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(V.action.followup)},result:Ce}:{action:V.action,result:Ce}}we.to=Pe})(sn||(e.ChatAgentUserActionEvent=sn={}));var nn;(function(we){function Pe(he,V,pe){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:V.toInternal(he,pe)}we.from=Pe})(nn||(e.TerminalQuickFix=nn={}));var Ut;(function(we){function Pe(he,V){return{id:V,label:he.label,description:he.description,canEdit:he.canEdit,collapsibleState:he.collapsibleState||0,contextValue:he.contextValue}}we.from=Pe})(Ut||(e.DebugTreeItem=Ut={}))}),define(Ee[289],ke([1,0,44,133,73,132,95,139,4]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=void 0;const p=(h,f,l,t)=>{let r=f;return{enumerable:!0,configurable:!1,get(){return r},set(o){if(!l(r,o)){const n=r;r=o,h.listener?.(t(o,n))}}}},D=(h,f)=>h===f,E={range:(h,f)=>h===f?!0:!h||!f?!1:h.isEqual(f),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(h,f)=>!(h.length!==f.length||h.some(l=>!f.find(t=>l.id===t.id)))},w=h=>f=>({op:4,update:h(f)}),m=(h,f)=>({range:(()=>{let l;const t=w(r=>({range:y.$7s.lift(P.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return l},set(r){h.listener?.({op:6}),E.range(l,r)||(l=r,h.listener?.(t(r)))}}})(),label:p(h,f,E.label,w(l=>({label:l}))),description:p(h,void 0,E.description,w(l=>({description:l}))),sortText:p(h,void 0,E.sortText,w(l=>({sortText:l}))),canResolveChildren:p(h,!1,E.canResolveChildren,l=>({op:2,state:l})),busy:p(h,!1,E.busy,w(l=>({busy:l}))),error:p(h,void 0,E.error,w(l=>({error:P.MarkdownString.fromStrict(l)||null}))),tags:p(h,[],E.tags,(l,t)=>({op:1,new:l.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),d=h=>{const f=s.$RK.fromString(h.extId),l=new b(f.controllerId,f.localId,h.label,v.URI.revive(h.uri)||void 0);return l.range=P.Range.to(h.range||void 0),l.description=h.description||void 0,l.sortText=h.sortText||void 0,l.tags=h.tags.map(t=>P.TestTag.to({id:(0,k.$WK)(t).tagId})),l},c=h=>{let f;for(const l of h.tests){const t=d(l.item);(0,C.$bO)(t).parent=f,f=t}return f};e.$rO=c;class b{constructor(f,l,t,r){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const o=(0,C.$aO)(this,f);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof u?void 0:o.parent}},children:{value:(0,S.$_N)(o,C.$bO,b),enumerable:!0,writable:!1},...m(o,t)})}}e.$sO=b;class u extends b{constructor(f,l){super(f,f,l,void 0),this._isRoot=!0}}e.$tO=u;class g extends S.$8N{constructor(f,l,t){super({controllerId:f,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:C.$bO,getChildren:r=>r.children,root:new u(f,l),toITestItem:P.TestItem.from})}}e.$uO=g});var Lt=this&&this.__classPrivateFieldSet||function(le,e,y,C,s){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!s)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!s:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?s.call(le,y):s?s.value=y:e.set(le,y),y},tt=this&&this.__classPrivateFieldGet||function(le,e,y,C){if(y==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!C:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?C:y==="a"?C.call(le):C?C.value:e.get(le)};define(Ee[290],ke([1,0,9,138,139,21,287,18,13,52,44,80,4,2,5,272,289,14,136,40,63,38,283,22]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r){"use strict";var o,n,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=void 0;let a=class{constructor(M,Z,ee){o.set(this,void 0),this.b=new Map,this.c=new Map,n.set(this,void 0),i.set(this,void 0),Lt(this,o,M.getProxy(k.$1L.MainThreadCommands),"f"),this.d=Z,Lt(this,i,ee,"f"),Lt(this,n,M.getProxy(k.$1L.MainThreadTelemetry),"f"),this.converter=new $(this,fe=>{const ue=this.c.get(fe);return ue?.result===R.Void?ue:void 0},Z),this.f=[{processArgument(fe){return(0,p.$Nh)(fe)}},{processArgument(fe){return(0,S.$Kn)(fe,function(ue){if(D.$7s.isIRange(ue))return s.Range.to(ue);if(E.$6s.isIPosition(ue))return s.Position.to(ue);if(D.$7s.isIRange(ue.range)&&w.URI.isUri(ue.uri))return s.location.to(ue);if(ue instanceof u.$se)return ue.buffer.buffer;if(!Array.isArray(ue))return ue})}}]}registerArgumentProcessor(M){this.f.push(M)}registerApiCommand(M){const Z=this.registerCommand(!1,M.id,async(...ee)=>{const fe=M.args.map((j,H)=>{if(!j.validate(ee[H]))throw new Error(`Invalid argument '${j.name}' when running '${M.id}', received: ${typeof ee[H]=="object"?JSON.stringify(ee[H],null,"	"):ee[H]} `);return j.convert(ee[H])}),ue=await this.executeCommand(M.internalId,...fe);return M.result.convert(ue,ee,this.converter)},void 0,{description:M.description,args:M.args,returns:M.result.description});return this.c.set(M.id,M),new C.$3L(()=>{Z.dispose(),this.c.delete(M.id)})}registerCommand(M,Z,ee,fe,ue,j){if(this.d.trace("ExtHostCommands#registerCommand",Z),!Z.trim().length)throw new Error("invalid id");if(this.b.has(Z))throw new Error(`command '${Z}' already exists`);return this.b.set(Z,{callback:ee,thisArg:fe,metadata:ue,extension:j}),M&&tt(this,o,"f").$registerCommand(Z),new C.$3L(()=>{this.b.delete(Z)&&M&&tt(this,o,"f").$unregisterCommand(Z)})}executeCommand(M,...Z){return this.d.trace("ExtHostCommands#executeCommand",M),this.g(M,Z,!0)}async g(M,Z,ee){if(this.b.has(M))return tt(this,o,"f").$fireCommandActivationEvent(M),this.h(M,Z,!1);{let fe=!1;const ue=(0,S.$Kn)(Z,function(j){if(j instanceof C.$4L)return s.Position.from(j);if(j instanceof C.$5L)return s.Range.from(j);if(j instanceof C.$cM)return s.location.from(j);if(C.$qN.isNotebookRange(j))return s.NotebookRange.from(j);if(j instanceof ArrayBuffer)return fe=!0,u.$se.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return fe=!0,u.$se.wrap(j);if(j instanceof u.$se)return fe=!0,j;if(!Array.isArray(j))return j});try{const j=await tt(this,o,"f").$executeCommand(M,fe?new g.$7v(ue):ue,ee);return(0,p.$Nh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(M,Z,!1);throw j}}}async h(M,Z,ee){const fe=this.b.get(M);if(!fe)throw new Error("Unknown command");const{callback:ue,thisArg:j,metadata:H}=fe;if(H?.args)for(let J=0;J<H.args.length;J++)try{(0,y.$0f)(Z[J],H.args[J].constraint)}catch{throw new Error(`Running the contributed command: '${M}' failed. Illegal argument '${H.args[J].name}' - ${H.args[J].description}`)}const q=f.$1d.create();try{return await ue.apply(j,Z)}catch(J){if(M===this.converter.delegatingCommandId){const ne=this.converter.getActualCommand(...Z);ne&&(M=ne.command)}if(this.d.error(J,M,fe.extension?.identifier),!ee)throw J;if(fe.extension?.identifier){const ne=tt(this,i,"f").onExtensionError(fe.extension.identifier,J);this.d.trace("forwarded error to extension?",ne,fe.extension?.identifier)}throw new class extends Error{constructor(){super((0,h.$2i)(J)),this.id=M,this.source=fe.extension?.displayName??fe.extension?.name}}}finally{this.j(fe,M,q.elapsed())}}j(M,Z,ee){M.extension&&tt(this,n,"f").$publicLog2("Extension:ActionExecuted",{extensionId:M.extension.identifier.value,id:new l.$Xo(Z),duration:ee})}$executeContributedCommand(M,...Z){this.d.trace("ExtHostCommands#$executeContributedCommand",M);const ee=this.b.get(M);return ee?(Z=Z.map(fe=>this.f.reduce((ue,j)=>j.processArgument(ue,ee.extension?.identifier),fe)),this.h(M,Z,!0)):Promise.reject(new Error(`Contributed command '${M}' does not exist.`))}getCommands(M=!1){return this.d.trace("ExtHostCommands#getCommands",M),tt(this,o,"f").$getCommands().then(Z=>(M&&(Z=Z.filter(ee=>ee[0]!=="_")),Z))}$getContributedCommandMetadata(){const M=Object.create(null);for(const[Z,ee]of this.b){const{metadata:fe}=ee;fe&&(M[Z]=fe)}return Promise.resolve(M)}};e.$AO=a,o=new WeakMap,n=new WeakMap,i=new WeakMap,e.$AO=a=Le([Ne(0,c.$fO),Ne(1,v.$yj),Ne(2,t.$zO)],a),e.$BO=(0,d.$ei)("IExtHostCommands");class ${constructor(M,Z,ee){this.d=M,this.f=Z,this.g=ee,this.delegatingCommandId=`__vsc${(0,r.$Ag)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(M,Z){if(!M)return;const ee={$ident:void 0,id:M.command,title:M.title,tooltip:M.tooltip};if(!M.command)return ee;const fe=this.f(M.command);if(fe)ee.id=fe.internalId,ee.arguments=fe.args.map((ue,j)=>ue.convert(M.arguments&&M.arguments[j]));else if((0,P.$Lb)(M.arguments)){const ue=`${M.command} /${++this.c}`;this.b.set(ue,M),Z.add((0,m.$Rc)(()=>{this.b.delete(ue),this.g.trace("CommandsConverter#DISPOSE",ue)})),ee.$ident=ue,ee.id=this.delegatingCommandId,ee.arguments=[ue],this.g.trace("CommandsConverter#CREATE",M.command,ue)}return ee}fromInternal(M){return typeof M.$ident=="string"?this.b.get(M.$ident):{command:M.id,title:M.title,arguments:M.arguments}}getActualCommand(...M){return this.b.get(M[0])}h(...M){const Z=this.getActualCommand(...M);return this.g.trace("CommandsConverter#EXECUTE",M[0],Z?Z.command:"MISSING"),Z?this.d.executeCommand(Z.command,...Z.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${M[0]}`)}}e.$CO=$;class A{static Arr(M){return new A(`${M.name}_array`,`Array of ${M.name}, ${M.description}`,Z=>Array.isArray(Z)&&Z.every(ee=>M.validate(ee)),Z=>Z.map(ee=>M.convert(ee)))}constructor(M,Z,ee,fe){this.name=M,this.description=Z,this.validate=ee,this.convert=fe}optional(){return new A(this.name,`(optional) ${this.description}`,M=>M==null||this.validate(M),M=>M===void 0?void 0:M===null?null:this.convert(M))}with(M,Z){return new A(M??this.name,Z??this.description,this.validate,this.convert)}}e.$DO=A,A.Uri=new A("uri","Uri of a text document",O=>w.URI.isUri(O),O=>O),A.Position=new A("position","A position in a text document",O=>C.$4L.isPosition(O),s.Position.from),A.Range=new A("range","A range in a text document",O=>C.$5L.isRange(O),s.Range.from),A.Selection=new A("selection","A selection in a text document",O=>C.$6L.isSelection(O),s.Selection.from),A.Number=new A("number","",O=>typeof O=="number",O=>O),A.String=new A("string","",O=>typeof O=="string",O=>O),A.StringArray=A.Arr(A.String),A.CallHierarchyItem=new A("item","A call hierarchy item",O=>O instanceof C.$nM,s.CallHierarchyItem.from),A.TypeHierarchyItem=new A("item","A type hierarchy item",O=>O instanceof C.$JN,s.TypeHierarchyItem.from),A.TestItem=new A("testItem","A VS Code TestItem",O=>O instanceof b.$sO,s.TestItem.from);class R{constructor(M,Z){this.description=M,this.convert=Z}}e.$EO=R,R.Void=new R("no result",O=>O);class I{constructor(M,Z,ee,fe,ue){this.id=M,this.internalId=Z,this.description=ee,this.args=fe,this.result=ue}}e.$FO=I}),define(Ee[291],ke([1,0,8,2,12,221]),function(le,e,y,C,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=void 0,e.$mP="remoteFilesystem";class k extends S.$lP{static register(v,p,D){const E=v.getConnection();if(!E)return C.$Tc.None;const w=new C.$Sc,m=(async()=>{try{const d=await v.getRawEnvironment();d?p.registerProvider(s.Schemas.vscodeRemote,w.add(new k(d,E))):D.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){D.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.$0)(d))}})();return w.add(p.onWillActivateFileSystemProvider(d=>{d.scheme===s.Schemas.vscodeRemote&&d.join(m)})),w}constructor(v,p){super(p.getChannel(e.$mP),{pathCaseSensitive:v.os===3})}}e.$nP=k}),define(Ee[74],ke([1,0,89,79,27,292,14,8,6,2,7,3,22,43,107]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=void 0;class c{traceSocketEvent(I,O){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,P.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=M=>{this.traceSocketEvent("read",M),I(k.$se.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=M=>{I({type:0,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,P.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,P.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$6h=c;var b;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var u;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(u||(u={}));class g extends p.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,M,Z){super(),this.f=this.B(new v.$5d),this.g=this.B(new v.$5d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:Z}),this.a=this.B(new h(this,O,M,Z,this.f,(ee,fe)=>this.m(ee,fe))),this.B(this.a.onError(ee=>{console.error(ee),(0,P.$1)(ee),this.g.fire({type:0,hadError:!0,error:ee})})),this.b=new d.$1h,this.B(this.socket.onData(ee=>this.n(ee))),this.B(this.socket.onClose(async ee=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ee)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let Z=2;I.byteLength<126?Z+=0:I.byteLength<2**16?Z+=2:Z+=8;const ee=k.$se.alloc(Z),fe=O?64:0,ue=M&15;if(ee.writeUInt8(128|fe|ue,0),I.byteLength<126)ee.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){ee.writeUInt8(126,1);let j=1;ee.writeUInt8(I.byteLength>>>8&255,++j),ee.writeUInt8(I.byteLength>>>0&255,++j)}else{ee.writeUInt8(127,1);let j=1;ee.writeUInt8(0,++j),ee.writeUInt8(0,++j),ee.writeUInt8(0,++j),ee.writeUInt8(0,++j),ee.writeUInt8(I.byteLength>>>24&255,++j),ee.writeUInt8(I.byteLength>>>16&255,++j),ee.writeUInt8(I.byteLength>>>8&255,++j),ee.writeUInt8(I.byteLength>>>0&255,++j)}this.socket.write(k.$se.concat([ee,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),Z=(M&128)>>>7,ee=(M&64)>>>6,fe=M&15,ue=O.readUInt8(1),j=(ue&128)>>>7,H=ue&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=Z,this.j.firstFrameOfMessage&&(this.j.compressed=!!ee),this.j.firstFrameOfMessage=!!Z,this.j.mask=0,this.j.opcode=fe,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),Z=(M&128)>>>7;let ee=M&127,fe=1;ee===126?ee=O.readUInt8(++fe)*2**8+O.readUInt8(++fe):ee===127&&(ee=O.readUInt8(++fe)*0+O.readUInt8(++fe)*0+O.readUInt8(++fe)*0+O.readUInt8(++fe)*0+O.readUInt8(++fe)*2**24+O.readUInt8(++fe)*2**16+O.readUInt8(++fe)*2**8+O.readUInt8(++fe));let ue=0;Z&&(ue=O.readUInt8(++fe)*2**24+O.readUInt8(++fe)*2**16+O.readUInt8(++fe)*2**8+O.readUInt8(++fe)),this.j.state=3,this.j.readLen=ee,this.j.mask=ue,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$7h=g;class h extends p.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.$se.alloc(0)}constructor(I,O,M,Z,ee,fe){super(),this.n=I,this.r=ee,this.s=fe,this.a=this.B(new v.$5d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$5d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$5d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new f(this.n,Z,M,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(ue=>this.a.fire(ue))),this.B(this.f.onError(ue=>this.a.fire(ue)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,I);this.s(M,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((M,Z)=>{I.write(O),I.flush(ee=>M(ee))})}acceptFrame(I,O,M){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,M){return new Promise((Z,ee)=>{I.write(O),M&&I.write(k.$se.fromByteArray([0,0,255,255])),I.flush(fe=>Z(fe))})}}class f extends p.$Tc{get recordedInflateBytes(){return this.j?k.$se.concat(this.f):k.$se.alloc(0)}constructor(I,O,M,Z){super(),this.h=I,this.j=O,this.a=this.B(new v.$5d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,S.createInflateRaw)(Z),this.b.on("error",ee=>{this.h.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this.a.fire(ee)}),this.b.on("data",ee=>{this.h.traceSocketEvent("zlibInflateData",ee),this.g.push(k.$se.wrap(ee))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=k.$se.concat(this.g);this.g.length=0,I(O)})}}class l extends p.$Tc{constructor(I,O){super(),this.g=I,this.a=this.B(new v.$5d),this.onError=this.a.event,this.f=[],this.b=(0,S.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(k.$se.wrap(M))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=k.$se.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(R,I){if(I===0)return;const O=R.byteLength>>>2;for(let j=0;j<O;j++){const H=R.readUInt32BE(j*4);R.writeUInt32BE(H^I,j*4)}const M=O*4,Z=R.byteLength-M,ee=I>>>24&255,fe=I>>>16&255,ue=I>>>8&255;Z>=1&&R.writeUInt8(R.readUInt8(M)^ee,M),Z>=2&&R.writeUInt8(R.readUInt8(M+1)^fe,M+1),Z>=3&&R.writeUInt8(R.readUInt8(M+2)^ue,M+2)}e.$8h=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function o(){const R=(0,w.$Ag)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const I=process.platform!=="darwin"&&e.$8h?e.$8h:(0,s.tmpdir)(),O=(0,D.$jc)(I,`vscode-ipc-${R}.sock`);return i(O),O}e.$9h=o;function n(R,I,O){const Z=(0,y.createHash)("sha256").update(R).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${Z}-${O}-${I}-sock`;const ee=O.substr(0,4),fe=I.substr(0,6);let ue;return process.platform!=="darwin"&&e.$8h&&!process.env.VSCODE_PORTABLE?ue=(0,D.$jc)(e.$8h,`vscode-${Z}-${ee}-${fe}.sock`):ue=(0,D.$jc)(R,`${ee}-${fe}.sock`),i(ue),ue}e.$0h=n;function i(R){const I=r[E.$o];typeof I=="number"&&R.length>=I&&console.warn(`WARNING: IPC handle "${R}" is longer than ${I} chars, try a shorter --user-data-dir`)}class a extends m.$Uh{static b(I){const O=v.Event.fromNodeEventEmitter(I,"connection");return v.Event.map(O,M=>({protocol:new d.$2h(new c(M,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(M,"close"))}))}constructor(I){super(a.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$$h=a;function $(R){return new Promise((I,O)=>{const M=(0,C.createServer)();M.on("error",O),M.listen(R,()=>{M.removeListener("error",O),I(new a(M))})})}e.$_h=$;function A(R,I){return new Promise((O,M)=>{const Z=(0,C.createConnection)(R,()=>{Z.removeListener("error",M),O(d.$3h.fromSocket(new c(Z,`ipc-client${I}`),I))});Z.once("error",M)})}e.$ai=A}),define(Ee[140],ke([1,0,87,15,14,8,9,25,26,88,13,46,238,292]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;let d=class extends E.$up{constructor(g,h,f,l){super(l),this.m=g,this.n=h,this.r=f,this.s(),this.B(g.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,h){const{f,g:l}=this;let t;try{t=await(0,p.$lm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,S.$0)(n)))}const r={...process.env,...t},o=g.agent?g.agent:await(0,w.$yr)(g.url||"",r,{proxyUrl:f,strictSSL:l});return g.agent=o,g.strictSSL=l,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>b(g,h))}async resolveProxy(g){}async loadCertificates(){return(await new Promise((h,f)=>{le(["@vscode/proxy-agent"],h,f)})).loadSystemCertificates({log:this.r})}};e.$zr=d,e.$zr=d=Le([Ne(0,P.$Ki),Ne(1,v.$mi),Ne(2,D.$yj),Ne(3,D.$zj)],d);async function c(u){return((0,y.parse)(u.url).protocol==="https:"?await new Promise((f,l)=>{le(["https"],f,l)}):await new Promise((f,l)=>{le(["http"],f,l)})).request}async function b(u,g){return C.Promises.withAsyncBody(async(h,f)=>{const l=(0,y.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await c(u),r={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,k.$Yf)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(r.auth=u.user+":"+u.password);const o=t(r,n=>{const i=(0,k.$Wf)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)b({...u,url:n.headers.location,followRedirects:i-1},g).then(h,f);else{let a=n;!u.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,m.createGunzip)())),h({res:n,stream:(0,s.$He)(a)})}});o.on("error",f),u.timeout&&o.setTimeout(u.timeout),u.isChromiumNetwork&&o.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&o.write(u.data),o.end(),g.onCancellationRequested(()=>{o.abort(),f(new S.$5)})})}e.$Ar=b}),define(Ee[141],ke([1,0,54,79,93,12,7,14,6,74,88,13,48,3,62,130,2,281,25]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=void 0;async function h(n={},i,a,$,A,R){const I=await(0,s.$Ql)(a,$.userDataPath);let O={};if(i)try{O=await(0,D.$lm)(R,A,$.args,process.env)}catch(j){A.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",j)}const Z={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(I,void 0,0),...n},ee=$.isBuilt?(0,k.$jc)($.appRoot,"bin"):(0,k.$jc)($.appRoot,"resources","server","bin-dev"),fe=(0,k.$jc)(ee,"remote-cli");let ue=t(Z,"PATH");return ue?ue=fe+k.$tc+ue:ue=fe,r(Z,"PATH",ue),$.args["without-browser-env-var"]||(Z.BROWSER=(0,k.$jc)(ee,"helpers",m.$c?"browser.cmd":"browser.sh")),o(Z),Z}e.$8m=h;class f{constructor(i,a){this.socket=i,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let i,a,$;return this.socket instanceof p.$6h?(i=!0,a=!1,$=P.$se.alloc(0)):(i=!1,a=this.socket.permessageDeflate,$=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:i,permessageDeflate:a,inflateBytes:$.buffer.toString("base64")}}}let l=class{constructor(i,a,$,A,R,I,O,M){this.i=i,this.j=R,this.l=I,this.m=O,this.n=M,this.b=new v.$5d,this.onClose=this.b.event,this.c=!m.$c||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new f($,A),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(i){this.l.info(`${this.o}${i}`)}q(i){this.l.error(`${this.o}${i}`)}async r(i,a){const $=new b.$Sc;$.add(a.socket),$.add((0,b.$Rc)(()=>{i.destroy()}));const A=()=>{$.dispose()};$.add(a.socket.onEnd(A)),$.add(a.socket.onClose(A)),$.add(v.Event.fromNodeEventEmitter(i,"end")(A)),$.add(v.Event.fromNodeEventEmitter(i,"close")(A)),$.add(v.Event.fromNodeEventEmitter(i,"error")(A)),$.add(a.socket.onData(R=>i.write(R.buffer))),$.add(v.Event.fromNodeEventEmitter(i,"data")(R=>{a.socket.write(P.$se.wrap(R))})),a.initialDataChunk.byteLength>0&&i.write(a.initialDataChunk.buffer)}async s(i,a){await a.socketDrain();const $=a.toIExtHostSocketMessage();let A;a.socket instanceof p.$6h?A=a.socket.socket:A=a.socket.socket.socket,i.send($,A)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const i={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(i)}acceptReconnection(i,a,$){this.f=i,this.p("The client has reconnected.");const A=new f(a,$);if(!this.g){this.h=A;return}this.s(this.g,A)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(i){try{let a=process.execArgv?process.execArgv.filter(fe=>!/^--inspect(-brk)?=/.test(fe)):[];i.port&&!process.pkg&&(a=[`--inspect${i.break?"-brk":""}=${i.port}`]);const $=await h(i.env,!0,i.language,this.j,this.l,this.n);(0,d.$5l)($);let A;if(this.c)(0,u.$6m)(new u.$4m,$),A=null;else{const{namedPipeServer:fe,pipeName:ue}=await this.u();(0,u.$6m)(new u.$3m(ue),$),A=fe}const R={env:$,execArgv:a,silent:!0};R.execArgv.unshift("--dns-result-order=ipv4first");const I=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];I.push(`--useHostProxy=${O?"true":"false"}`),this.g=y.fork(S.$yg.asFileUri("bootstrap-fork").fsPath,I,R);const M=this.g.pid;this.p(`<${M}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const Z=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),ee=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(Z(fe=>this.p(`<${M}> ${fe}`)),ee(fe=>this.p(`<${M}><stderr> ${fe}`)),this.g.on("error",fe=>{this.q(`<${M}> Extension Host Process had an error`),this.l.error(fe),this.t()}),this.g.on("exit",(fe,ue)=>{this.m.setExitInfo(this.i,{code:fe,signal:ue}),this.p(`<${M}> Extension Host Process exited with code: ${fe}, signal: ${ue}.`),this.t()}),A)A.on("connection",fe=>{A.close(),this.r(fe,this.h)});else{const fe=ue=>{ue.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",fe),this.s(this.g,this.h),this.h=null)};this.g.on("message",fe)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((i,a)=>{const $=(0,p.$9h)(),A=C.createServer();A.on("error",a),A.listen($,()=>{A?.removeListener("error",a),i({pipeName:$,namedPipeServer:A})})})}};e.$9m=l,e.$9m=l=Le([Ne(4,w.$Sm),Ne(5,E.$yj),Ne(6,c.$1m),Ne(7,g.$Ki)],l);function t(n,i){const a=Object.keys(n).filter(A=>A.toLowerCase()===i.toLowerCase()),$=a.length>0?a[0]:i;return n[$]}function r(n,i,a){const $=Object.keys(n).filter(R=>R.toLowerCase()===i.toLowerCase()),A=$.length>0?$[0]:i;n[A]=a}function o(n){for(const i of Object.keys(n))n[i]===null&&delete n[i]}}),define(Ee[293],ke([1,0,84,13,68,118,25,46,140,38,32,30,128,126,86,112,57,2,113,70,12,16,31,48,121,85,122,8,4,7,28,236,83,34,125,67,3,59,131,33,47,71,129,127,115,116,202,294]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r,o,n,i,a,$,A,R,I,O,M,Z,ee,fe,ue,j,H,q,J,ne,x,G,se,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class ge extends u.$Tc{constructor(z,_){super(),this.a=z,this.b=_,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const z=await this.f();await z.invokeFunction(async _=>{const Q=_.get(k.$Ki),K=_.get(C.$yj);fe.$c&&(Q.getValue("security.restrictUNCAccess")===!1?(0,re.disableUNCAccessRestrictions)():(0,re.addUNCHostToAllowlist)(Q.getValue("security.allowedUNCHosts")));try{await this.g(z.createInstance(o.$Tp,new C.$Gj(K.getLevel(),!1)))}catch(X){throw K.error(X),console.error((0,a.$0)(X)),X}})}async f(){const z=new y.$ci,_={_serviceBrand:void 0,...b.default};z.set(t.$Qj,_);const Q=new r.$Tm(this.a,_);z.set(r.$Sm,Q);const K=new se.$tP((0,C.$Mj)(Q),Q.logsHome);z.set(C.$zj,K);const X=new G.$DP(this.B(K.createLogger("remoteCLI",{name:(0,ce.localize)(0,null)})));z.set(C.$yj,X),X.trace(`Remote configuration data at ${this.b}`),X.trace("process arguments:",this.a);const Y=this.B(new g.$oq(X));z.set(l.$Bk,Y),Y.registerProvider(f.Schemas.file,this.B(new h.$Nq(X)));const N=new Z.$bs(Y);z.set(M.$_k,N);const U=this.B(new ne.$BP(N,Q,Y,X));z.set(H.$bl,U);const te=this.B(new S.$mo(U.defaultProfile.settingsResource,Y,new J.$Yn,X));return z.set(k.$Ki,te),await Promise.all([te.initialize(),U.init()]),z.set(P.$tp,new s.$bi(v.$zr)),z.set(O.$qo,new s.$bi(I.$WP)),z.set(D.$Fl,p.$Zo),z.set(E.$Lo,new s.$bi(w.$Qp)),z.set(q.$8p,new s.$bi(x.$CP)),z.set(ue.$_p,new s.$bi(j.$oP)),z.set(d.$Rp,new s.$bi(d.$Sp)),z.set(m.$jq,new s.$bi(m.$kq)),z.set(n.$tr,new s.$bi(i.$vr)),new c.$Qq(z)}async g(z){if(this.a["list-extensions"])return z.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const _={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return z.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),_,!!this.a.force)}else{if(this.a["uninstall-extension"])return z.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return z.updateExtensions();if(this.a["locate-extension"])return z.locateExtension(this.a["locate-extension"])}}h(z){return z.map(_=>/\.vsix$/i.test(_)?$.URI.file((0,A.$ic)(_)?_:(0,A.$jc)((0,R.cwd)(),_)):_)}}function B(F){setTimeout(()=>process.exit(F),0)}async function W(F,z,_){if(F.help){const K=b.default.serverApplicationName+(fe.$c?".cmd":"");console.log((0,ee.$am)(b.default.nameLong,K,b.default.version,_,{noInputFiles:!0,noPipe:!0}));return}if(F.version){console.log((0,ee.$bm)(b.default.version,b.default.commit));return}const Q=new ge(F,z);try{await Q.run(),B(0)}catch{B(1)}finally{Q.dispose()}}e.run=W}),define(Ee[295],ke([1,0,74,269,29,290,4,13,92]),function(le,e,y,C,s,S,k,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=void 0;class p{constructor(w,m,d){this.b=w,this.c=m,this.f=d,this.a=C.createServer((c,b)=>this.h(c,b)),this.g().catch(c=>(m.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,m){const d=(b,u)=>{m.writeHead(b,{"content-type":"application/json"}),m.end(JSON.stringify(u||null),g=>g&&this.c.error(g))},c=[];w.setEncoding("utf8"),w.on("data",b=>c.push(b)),w.on("end",async()=>{try{const b=JSON.parse(c.join(""));let u;switch(b.type){case"open":u=await this.i(b);break;case"openExternal":u=await this.j(b);break;case"status":u=await this.l(b);break;case"extensionManagement":u=await this.k(b);break;default:d(404,`Unknown message type: ${b.type}`);break}d(200,u)}catch(b){const u=b instanceof Error?b.message:JSON.stringify(b);d(500,u),this.c.error("Error while processing pipe request",b)}})}async i(w){const{fileURIs:m,folderURIs:d,forceNewWindow:c,diffMode:b,mergeMode:u,addMode:g,forceReuseWindow:h,gotoLineMode:f,waitMarkerFilePath:l,remoteAuthority:t}=w,r=[];if(Array.isArray(d))for(const a of d)try{r.push({folderUri:k.URI.parse(a)})}catch{}if(Array.isArray(m))for(const a of m)try{(0,v.$Ji)(a)?r.push({workspaceUri:k.URI.parse(a)}):r.push({fileUri:k.URI.parse(a)})}catch{}const o=l?k.URI.file(l):void 0,i={forceNewWindow:c,diffMode:b,mergeMode:u,addMode:g,gotoLineMode:f,forceReuseWindow:h,preferNewWindow:!h&&!o&&!g,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,i)}async j(w){for(const m of w.uris){const d=k.URI.parse(m),c=d.scheme==="file"?d:m;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(w){const m=c=>c?.map(b=>/\.vsix$/i.test(b)?k.URI.parse(b):b),d={list:w.list,install:m(w.install),uninstall:m(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",d)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&s.existsSync(this.f)&&s.unlinkSync(this.f)}}e.$GO=p;let D=class extends p{constructor(w,m){super(w,m,(0,y.$9h)())}};e.$HO=D,e.$HO=D=Le([Ne(0,S.$BO),Ne(1,P.$yj)],D)}),define(Ee[296],ke([1,0,27,6,21,2,7,3,4,74,72,295,124,90,276,278,141,15]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=void 0;class g extends c.$gP{constructor(l,t,r,o,n){super({getFolderUri:i=>{const a=t.filter($=>$.name===i);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(i,a)=>o[`config:${a}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(r)return k.$hc(r.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async i=>{const $=(await n.getInstalled()).find(A=>A.identifier.id===i);return $&&{extensionLocation:$.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(l))}}class h extends S.$Tc{constructor(l,t,r,o,n,i){super(),this.g=l,this.h=t,this.j=r,this.m=o,this.n=n,this.r=i,this.a=0,this.b=new Map,this.c=this.B(new C.$5d),this.onExecuteCommand=this.c.event}async call(l,t,r){switch(t){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,r);case"$createProcess":{const o=(0,D.$cs)(l.remoteAuthority);return this.s(o,r)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,r);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,r);case"$listProcesses":return this.j.listProcesses.apply(this.j,r);case"$getLatency":return this.j.getLatency.apply(this.j,r);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,r);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,r);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,r);case"$start":return this.j.start.apply(this.j,r);case"$input":return this.j.input.apply(this.j,r);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,r);case"$shutdown":return this.j.shutdown.apply(this.j,r);case"$resize":return this.j.resize.apply(this.j,r);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,r);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,r);case"$getCwd":return this.j.getCwd.apply(this.j,r);case"$processBinary":return this.j.processBinary.apply(this.j,r);case"$sendCommandResult":return this.u(r[0],r[1],r[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,r);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,r);case"$getDefaultSystemShell":return this.w.apply(this,r);case"$getProfiles":return this.y.apply(this,r);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(r[0],r[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,r);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,r);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,r);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,r);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,r);case"$updateTitle":return this.j.updateTitle.apply(this.j,r);case"$updateProperty":return this.j.updateProperty.apply(this.j,r);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,r);case"$requestDetachInstance":return this.j.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(r[0],r[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,r);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,r)}throw new Error(`IPC Command ${t} not found`)}listen(l,t,r){switch(t){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||C.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||C.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||C.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||C.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||C.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||C.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${t} not found`)}async s(l,t){const r={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd>"u"?t.shellLaunchConfig.cwd:v.URI.revive(l.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment,reconnectionProperties:t.shellLaunchConfig.reconnectionProperties,type:t.shellLaunchConfig.type,isFeatureTerminal:t.shellLaunchConfig.isFeatureTerminal},o=await(0,b.$8m)(t.resolverEnv,!!t.shellLaunchConfig.useShellEnvironment,P.$q,this.g,this.h,this.r);this.h.trace("baseEnv",o);const n=H=>({uri:v.URI.revive(l.transformIncoming(H.uri)),name:H.name,index:H.index,toResource:()=>{throw new Error("Not implemented")}}),i=t.workspaceFolders.map(n),a=t.activeWorkspaceFolder?n(t.activeWorkspaceFolder):void 0,$=t.activeFileResource?v.URI.revive(l.transformIncoming(t.activeFileResource)):void 0,A=new g(o,i,$,t.resolvedVariables,this.n),R=d.$cP(a,process.env,A),I=await d.$bP(r,y.homedir(),R,a?.uri,t.configuration["terminal.integrated.cwd"],this.h);r.cwd=I;const O=P.$c?"terminal.integrated.env.windows":P.$d?"terminal.integrated.env.osx":"terminal.integrated.env.linux",M=t.configuration[O],Z=await d.$dP(r,M,R,this.m.version,t.configuration["terminal.integrated.detectLocale"],o);if(!r.strictEnv){const H=[];for(const[x,G,se]of t.envVariableCollections)H.push([x,{map:(0,m.$1r)(G),descriptionMap:(0,m.$2r)(se)}]);const q=new Map(H),J=new w.$5r(q),ne=a?a??void 0:void 0;await J.applyToProcessEnvironment(Z,{workspaceFolder:ne},R)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:I,cols:t.cols,rows:t.rows,env:Z});const ee=(0,p.$9h)();Z.VSCODE_IPC_HOOK_CLI=ee;const fe=await this.j.createProcess(r,I,t.cols,t.rows,t.unicodeVersion,Z,o,t.options,t.shouldPersistTerminal,t.workspaceId,t.workspaceName),ue={executeCommand:(H,...q)=>this.t(fe,H,q,l)},j=new E.$GO(ue,this.h,ee);return this.j.onProcessExit(H=>H.id===fe&&j.dispose()),{persistentTerminalId:fe,resolvedShellLaunchConfig:r}}t(l,t,r,o){const{resolve:n,reject:i,promise:a}=(0,u.$0g)(),$=++this.a;this.b.set($,{resolve:n,reject:i,uriTransformer:o});const A=(0,s.$Kn)(r,R=>{if(R&&R.$mid===1)return o.transformOutgoing(R);if(R&&R instanceof v.URI)return o.transformOutgoingURI(R)});return this.c.fire({reqId:$,persistentProcessId:l,commandId:t,commandArgs:A}),a}u(l,t,r){const o=this.b.get(l);if(!o)return;this.b.delete(l);const n=(0,s.$Kn)(r,i=>{if(i&&i.$mid===1)return o.uriTransformer.transformIncoming(i)});t?o.reject(n):o.resolve(n)}w(l){return this.j.getDefaultSystemShell(l)}async y(l,t,r,o){return this.j.getProfiles(l,t,r,o)||[]}z(){return{...process.env}}C(l,t){return this.j.getWslPath(l,t)}D(){return this.j.reduceConnectionGraceTime()}}e.$hP=h}),define(Ee[297],ke([1,0,27,6,2,12,7,102,23,43,25,118,210,83,211,26,128,30,86,121,220,126,16,113,70,68,112,84,85,122,13,57,31,46,237,140,120,32,38,252,91,260,34,125,273,274,242,249,296,72,48,280,291,130,59,131,47,33,268,71,250,116,129,127,115,114,204,286,233,264,257]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r,o,n,i,a,$,A,R,I,O,M,Z,ee,fe,ue,j,H,q,J,ne,x,G,se,ce,re,ge,B,W,F,z,_,Q,K,X,Y,N,U,te,ie,de,ae,be,ye,Re,Me,$e,Se,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.$MP=void 0;const je="monacoworkbench";async function Te(Ze,me,Ie,Ae){const Oe=new a.$ci,Fe=new Je,He={_serviceBrand:void 0,...I.default};Oe.set(O.$Qj,He);const Ve=new W.$Tm(me,He);Oe.set(c.$li,Ve),Oe.set(c.$mi,Ve);const st=new ie.$tP((0,R.$Mj)(Ve),Ve.logsHome);Oe.set(R.$zj,st),Fe.registerChannel("logger",new ye.$Nr(st,rt=>ze(rt.remoteAuthority)));const it=st.createLogger("remoteagent",{name:(0,Re.localize)(0,null)}),Xe=new be.$DP(it,[new _e((0,R.$Mj)(Ve))]);Oe.set(R.$yj,Xe),setTimeout(()=>Ke(Ve.logsHome.with({scheme:S.Schemas.file}).fsPath).then(null,rt=>Xe.error(rt)),1e4),Xe.onDidChangeLogLevel(rt=>(0,R.log)(Xe,rt,`Log level changed to ${(0,R.$Nj)(Xe.getLevel())}`)),Xe.trace(`Remote configuration data at ${Ie}`),Xe.trace("process arguments:",Ve.args),Array.isArray(He.serverGreeting)&&Xe.info(`

${He.serverGreeting.join(`
`)}

`),Fe.registerChannel(w.$oo.ChannelName,new w.$oo);const ct=new p.$Yh(rt=>rt.clientId==="renderer"),at=Ae.add(new r.$oq(Xe));Oe.set(t.$Bk,at),at.registerProvider(S.Schemas.file,Ae.add(new o.$Nq(Xe)));const ft=new x.$bs(at);Oe.set(ne.$_k,ft);const lt=new E.$mo(Ve.machineSettingsResource,at,new U.$Yn,Xe);Oe.set(D.$Ki,lt);const mt=new de.$BP(ft,Ve,at,Xe);Oe.set(Y.$bl,mt),Fe.registerChannel("userDataProfiles",new Se.$JP(mt,rt=>ze(rt.remoteAuthority)));const[,,zt,qt]=await Promise.all([lt.initialize(),mt.init(),(0,P.$ln)(Xe.error.bind(Xe)),(0,P.$mn)(Xe.error.bind(Xe))]),Ht=new _.$2m;Oe.set(_.$1m,Ht);const Rt=new ee.$zr(lt,Ve,Xe,st);Oe.set(M.$tp,Rt);let kt=j.$4o;const Ot=(0,j.$0o)(He,lt);if((0,j.$5o)(He,Ve)){const rt=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";rt?kt=new te.$rP(Rt,!1,je,null,()=>new N.$pP(rt)):!(0,j.$6o)(He,Ve)&&He.aiConfig?.ariaKey&&(kt=new te.$rP(Rt,Ot,je,null,He.aiConfig.ariaKey),Ae.add((0,s.$Rc)(()=>kt?.flush())));const wt={appenders:[kt],commonProperties:(0,fe.$Vo)((0,y.release)(),(0,y.hostname)(),process.arch,He.commit,He.version+"-remote",zt,qt,Ot,"remoteAgent"),piiPaths:(0,j.$$o)(Ve)},pt=Ve.args["telemetry-level"];let dt=3;pt==="all"?dt=3:pt==="error"?dt=2:pt==="crash"?dt=1:pt!==void 0&&(dt=0),Oe.set(re.$ps,new n.$bi(re.$ns,[wt,dt]))}else Oe.set(re.$ps,re.$os);Oe.set(u.$Lo,new n.$bi(b.$Qp));const $t=Fe.getChannel("download",ct);Oe.set(m.$qo,new d.$so($t,()=>ze("renderer"))),Oe.set(X.$8p,new n.$bi(ae.$CP)),Oe.set(Q.$_p,new n.$bi(K.$oP)),Oe.set(g.$Rp,new n.$bi(g.$Sp)),Oe.set(l.$jq,new n.$bi(l.$kq));const bt=new i.$Qq(Oe);Oe.set($.$tr,bt.createInstance(A.$vr));const Wt=bt.createInstance(De.$LP,{graceTime:108e5,shortGraceTime:3e5,scrollback:lt.getValue("terminal.integrated.persistentSessionScrollback")??100}),St=bt.createInstance(J.$0r,Wt);return Oe.set(q.$Ir,St),bt.invokeFunction(rt=>{const wt=rt.get(l.$jq),pt=rt.get(Q.$_p),dt=rt.get(u.$Lo),Vt=rt.get($.$tr),Ft=new G.$js(Ze,Ve,mt,Ht);Fe.registerChannel("remoteextensionsenvironment",Ft);const Gt=new ce.$qs(rt.get(re.$ps),kt);Fe.registerChannel("telemetry",Gt),Fe.registerChannel(F.$iP,new ge.$hP(Ve,Xe,St,He,wt,lt));const Jt=new Me.$HP(bt.createInstance(h.$Tp,Xe),Ve,mt,pt,Xe,dt,Vt);Fe.registerChannel($e.$GP,new Me.$IP(Jt,It=>ze(It.remoteAuthority)));const Tt=new se.$ms(Xe,Ve);Fe.registerChannel(z.$mP,Tt),Fe.registerChannel("request",new Z.$wr(rt.get(M.$tp)));const jt=new f.$Up(wt,It=>ze(It.remoteAuthority));Fe.registerChannel("extensions",jt);const Xt=p.ProxyChannel.fromService(rt.get($.$tr),Ae);return Fe.registerChannel("languagePacks",Xt),Jt.whenExtensionsReady().then(()=>wt.cleanUp()),Ae.add(new H.default(rt.get(ue.$Fl))),{telemetryService:rt.get(ue.$Fl)}}),{socketServer:Fe,instantiationService:bt}}e.$MP=Te;const We=Object.create(null);function ze(Ze){return We[Ze]||(We[Ze]=(0,B.$cs)(Ze)),We[Ze]}class Je extends p.$Uh{constructor(){const me=new C.$5d;super(me.event),this.b=me}acceptConnection(me,Ie){this.b.fire({protocol:me,onDidClientDisconnect:Ie})}}e.$NP=Je;class _e extends R.$Dj{constructor(me=R.$Bj){super(),this.setLevel(me),this.g=!!process.stdout.isTTY}trace(me,...Ie){this.f(R.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,me,...Ie):console.log(`[${xe()}]`,me,...Ie))}debug(me,...Ie){this.f(R.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,me,...Ie):console.log(`[${xe()}]`,me,...Ie))}info(me,...Ie){this.f(R.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,me,...Ie):console.log(`[${xe()}]`,me,...Ie))}warn(me,...Ie){this.f(R.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${xe()}]\x1B[0m`,me,...Ie):console.warn(`[${xe()}]`,me,...Ie))}error(me,...Ie){this.f(R.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${xe()}]\x1B[0m`,me,...Ie):console.error(`[${xe()}]`,me,...Ie))}flush(){}}function xe(){const Ze=new Date;return`${nt(Ze.getHours())}:${nt(Ze.getMinutes())}:${nt(Ze.getSeconds())}`}function nt(Ze){return Ze<10?`0${Ze}`:String(Ze)}async function Ke(Ze){const me=k.$nc(Ze),Ie=k.$mc(Ze),Fe=(await v.Promises.readdir(Ie)).filter(Ve=>/^\d{8}T\d{6}$/.test(Ve)).sort().filter(Ve=>Ve!==me),He=Fe.slice(0,Math.max(0,Fe.length-9));await Promise.all(He.map(Ve=>v.Promises.rm(k.$jc(Ie,Ve))))}}),define(Ee[298],ke([1,0,89,29,79,299,87,96,14,8,39,2,12,7,42,3,17,4,22,160,162,294,107,74,25,5,13,31,58,32,141,265,266,48,297,270]),function(le,e,y,C,s,S,k,P,v,p,D,E,w,m,d,c,b,u,g,h,f,l,t,r,o,n,i,a,$,A,R,I,O,M,Z,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;const fe=5*60*1e3;let ue=class extends E.$Tc{constructor(J,ne,x,G,se,ce,re,ge){super(),this.n=J,this.r=ne,this.s=x,this.t=se,this.u=ce,this.w=re,this.y=ge,this.h=H.create(this.u),this.j=(0,$.$nl)(ce),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=G?this.y.createInstance(ee.$QP,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(J,ne){if(J.method!=="GET")return(0,ee.$OP)(J,ne,405,`Unsupported method ${J.method}`);if(!J.url)return(0,ee.$OP)(J,ne,400,"Bad request.");const x=k.parse(J.url,!0);let G=x.pathname;if(!G)return(0,ee.$OP)(J,ne,400,"Bad request.");if(G.startsWith(this.j)&&G.charCodeAt(this.j.length)===47&&(G=G.substring(this.j.length)),G==="/version")return ne.writeHead(200,{"Content-Type":"text/plain"}),void ne.end(this.u.commit||"");if(G==="/delay-shutdown")return this.N(),ne.writeHead(200),void ne.end("OK");if(!(0,O.$dn)(this.r,J,x))return(0,ee.$OP)(J,ne,403,"Forbidden.");if(G==="/vscode-remote-resource"){const se=x.query.path;if(typeof se!="string")return(0,ee.$OP)(J,ne,400,"Bad request.");let ce;try{ce=u.URI.from({scheme:w.Schemas.file,path:se}).fsPath}catch{return(0,ee.$OP)(J,ne,400,"Bad request.")}const re=Object.create(null);this.t.isBuilt&&((0,D.$fg)(ce,this.t.builtinExtensionsPath,!c.$e)||(0,D.$fg)(ce,this.t.extensionsPath,!c.$e))&&(re["Cache-Control"]="public, max-age=31536000"),re.Vary="Origin";const ge=J.headers.origin;return ge&&this.h.matches(ge)&&(re["Access-Control-Allow-Origin"]=ge),(0,ee.$PP)(ce,1,this.w,J,ne,re)}if(this.g){this.g.handle(J,ne,x);return}return ne.writeHead(404,{"Content-Type":"text/plain"}),void ne.end("Not found")}handleUpgrade(J,ne){let x=(0,g.$Ag)(),G=!1,se=!1;if(J.url){const F=k.parse(J.url,!0).query;typeof F.reconnectionToken=="string"&&(x=F.reconnectionToken),F.reconnection==="true"&&(G=!0),F.skipWebSocketFrames==="true"&&(se=!0)}if(J.headers.upgrade===void 0||J.headers.upgrade.toLowerCase()!=="websocket"){ne.end("HTTP/1.1 400 Bad Request");return}const ce=J.headers["sec-websocket-key"],re=y.createHash("sha1");re.update(ce+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const B=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${re.digest("base64")}`];let W=!1;if(!se&&!this.t.args["disable-websocket-compression"]&&J.headers["sec-websocket-extensions"]){const F=Array.isArray(J.headers["sec-websocket-extensions"])?J.headers["sec-websocket-extensions"]:[J.headers["sec-websocket-extensions"]];for(const z of F)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(z)){if(/\b(permessage-deflate)\b/.test(z)){W=!0,B.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(z)){W=!0,B.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ne.write(B.join(`\r
`)+`\r
\r
`),ne.setTimeout(0),ne.setNoDelay(!0),se?this.D(new r.$6h(ne,`server-connection-${x}`),G,x):this.D(new r.$7h(new r.$6h(ne,`server-connection-${x}`),W,null,!0),G,x)}handleServerError(J){this.w.error("Error occurred in server"),this.w.error(J)}z(J){let ne;return J instanceof r.$6h?ne=J.socket:ne=J.socket.socket,ne.remoteAddress||"<unknown>"}async C(J,ne,x){const G=ne.getSocket();this.w.error(`${J} ${x}.`);const se={type:"error",reason:x};ne.sendControl(v.$se.fromString(JSON.stringify(se))),ne.dispose(),await G.drain(),G.dispose()}D(J,ne,x){const G=this.z(J),se=`[${G}][${x.substr(0,8)}]`,ce=new t.$5h({socket:J}),re=this.s?new this.s.validator:null,ge=this.s?new this.s.signer:null;let B;(function(_){_[_.WaitingForAuth=0]="WaitingForAuth",_[_.WaitingForConnectionType=1]="WaitingForConnectionType",_[_.Done=2]="Done",_[_.Error=3]="Error"})(B||(B={}));let W=0;const F=_=>{W=3,z.dispose(),this.C(se,ce,_)},z=ce.onControlMessage(_=>{if(W===0){let Q;try{Q=JSON.parse(_.toString())}catch{return F("Malformed first message")}if(Q.type!=="auth")return F("Invalid first message");if(this.r.type===2&&!this.r.validate(Q.auth))return F("Unauthorized client refused: auth mismatch");let K=(0,g.$Ag)();if(ge)try{K=ge.sign(Q.data)}catch{}let X=(0,g.$Ag)();if(re)try{X=re.createNewMessage(X)}catch{}const Y={type:"sign",data:X,signedData:K};ce.sendControl(v.$se.fromString(JSON.stringify(Y))),W=1}else if(W===1){let Q;try{Q=JSON.parse(_.toString())}catch{return F("Malformed second message")}if(Q.type!=="connectionType")return F("Invalid second message");if(typeof Q.signedData!="string")return F("Invalid second message field type");const K=Q.commit,X=this.u.commit;if(K&&X&&K!==X)return F("Client refused: version mismatch");let Y=!1;if(!re)Y=!0;else if(this.r.validate(Q.signedData))Y=!0;else try{Y=re.validate(Q.signedData)==="ok"}catch{}if(!Y){if(this.t.isBuilt)return F("Unauthorized client refused");this.w.error(`${se} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const N in this.b)this.b[N].shortenReconnectionGraceTimeIfNecessary();for(const N in this.a)this.a[N].shortenReconnectionGraceTimeIfNecessary();W=2,z.dispose(),this.F(G,se,ce,J,ne,x,Q)}})}async F(J,ne,x,G,se,ce,re){const ge=re.desiredConnectionType===1?`${ne}[ManagementConnection]`:re.desiredConnectionType===2?`${ne}[ExtensionHostConnection]`:ne;if(re.desiredConnectionType===1)if(se){if(!this.b[ce])return this.f.has(ce)?this.C(ge,x,"Unknown reconnection token (seen before)"):this.C(ge,x,"Unknown reconnection token (never seen)");x.sendControl(v.$se.fromString(JSON.stringify({type:"ok"})));const B=x.readEntireBuffer();x.dispose(),this.b[ce].acceptReconnection(J,G,B)}else{if(this.b[ce])return this.C(ge,x,"Duplicate reconnection token");x.sendControl(v.$se.fromString(JSON.stringify({type:"ok"})));const B=new I.$0m(this.w,ce,J,x);this.n.acceptConnection(B.protocol,B.onClose),this.b[ce]=B,this.f.add(ce),B.onClose(()=>{delete this.b[ce]})}else if(re.desiredConnectionType===2){const B=re.args||{language:"en"},W=await this.I(B);if(W.port&&this.w.trace(`${ge} - startParams debug port ${W.port}`),this.w.trace(`${ge} - startParams language: ${W.language}`),this.w.trace(`${ge} - startParams env: ${JSON.stringify(W.env)}`),se){if(!this.a[ce])return this.f.has(ce)?this.C(ge,x,"Unknown reconnection token (seen before)"):this.C(ge,x,"Unknown reconnection token (never seen)");x.sendPause(),x.sendControl(v.$se.fromString(JSON.stringify(W.port?{debugPort:W.port}:{})));const F=x.readEntireBuffer();x.dispose(),this.a[ce].acceptReconnection(J,G,F)}else{if(this.a[ce])return this.C(ge,x,"Duplicate reconnection token");x.sendPause(),x.sendControl(v.$se.fromString(JSON.stringify(W.port?{debugPort:W.port}:{})));const F=x.readEntireBuffer();x.dispose();const z=this.y.createInstance(R.$9m,ce,J,G,F);this.a[ce]=z,this.f.add(ce),z.onClose(()=>{delete this.a[ce],this.J()}),z.start(W)}}else if(re.desiredConnectionType===3){const B=re.args;this.G(x,B)}else return this.C(ge,x,"Unknown initial data received")}async G(J,ne){const x=J.getSocket().socket,G=J.readEntireBuffer();J.dispose(),x.pause();const se=await this.H(ne.host,ne.port);G.byteLength>0&&se.write(G.buffer),se.on("end",()=>x.end()),se.on("close",()=>x.end()),se.on("error",()=>x.destroy()),x.on("end",()=>se.end()),x.on("close",()=>se.end()),x.on("error",()=>se.destroy()),se.pipe(x),x.pipe(se)}H(J,ne){return new Promise((x,G)=>{const se=s.createConnection({host:J,port:ne,autoSelectFamily:!0},()=>{se.removeListener("error",G),se.pause(),x(se)});se.once("error",G)})}I(J){return typeof J.port=="number"?(0,f.$Cg)(J.port,10,5e3).then(ne=>(J.port=ne,J)):(J.debugId=void 0,J.port=void 0,J.break=void 0,Promise.resolve(J))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(J=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!J?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},fe))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ue=Le([Ne(4,M.$Sm),Ne(5,a.$Qj),Ne(6,i.$yj),Ne(7,n.$di)],ue);async function j(q,J,ne){const x=await(0,O.$cn)(J);x instanceof O.$an&&(console.warn(x.message),process.exit(1));function G(Y){(0,p.setUnexpectedErrorHandler)(N=>{(0,p.$Z)(N)&&N.stack&&/unexpectedErrorHandler/.test(N.stack)||Y(N)})}const se=[];G(Y=>{se.push(Y),console.error(Y)});let ce=!1;process.on("SIGPIPE",()=>{ce||(ce=!0,(0,p.$1)(new Error("Unexpected SIGPIPE")))});const re=new E.$Sc,{socketServer:ge,instantiationService:B}=await(0,Z.$MP)(x,J,ne,re);B.invokeFunction(Y=>{const N=Y.get(i.$yj);se.forEach(U=>N.error(U)),se.length=0,G(U=>N.error(U))}),B.invokeFunction(Y=>{const N=Y.get(o.$Ki);c.$c&&(N.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(N.getValue("security.allowedUNCHosts")))}),B.invokeFunction(Y=>{const N=Y.get(i.$yj);if(c.$c&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const U=(0,m.$jc)(process.env.HOMEDRIVE,"node_modules"),te=(0,m.$mc)((0,m.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ie=(0,m.$jc)(te,"node_modules");if(C.existsSync(U)||C.existsSync(ie)){const de=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${U}
* ${ie}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;N.warn(de),console.warn(de),process.exit(0)}}});const W=B.invokeFunction(Y=>{const N=Y.get(i.$yj);if(C.existsSync((0,m.$jc)(w.$yg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(te){N.error(te)}return null}),F=C.existsSync(w.$yg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(F&&q&&typeof q!="string"){const Y=x.type!==0?`?${w.$rg}=${x.value}`:"";console.log(`Web UI available at http://localhost${q.port===80?"":`:${q.port}`}/${Y}`)}const z=B.createInstance(ue,ge,x,W,F);d.mark("code/server/ready");const _=S.performance.now(),Q=global.vscodeServerStartTime,K=global.vscodeServerListenTime,X=global.vscodeServerCodeLoadedTime;if(B.invokeFunction(async Y=>{const N=Y.get(A.$Fl);if(N.publicLog2("serverStart",{startTime:Q,startedTime:K,codeLoadedTime:X,readyTime:_}),c.$e){const U=Y.get(i.$yj),te=await(0,h.$Bg)(U.error.bind(U));te&&N.publicLog2("serverPlatformInfo",{platformId:te.id,platformVersionId:te.version_id,platformIdLike:te.id_like})}}),J["print-startup-performance"]){const Y=P.$U.get();let N="";N+=`

### Load AMD-module
`,N+=P.$U.toMarkdownTable(["Module","Duration"],Y.amdLoad),N+=`

### Load commonjs-module
`,N+=P.$U.toMarkdownTable(["Module","Duration"],Y.nodeRequire),N+=`

### Invoke AMD-module factory
`,N+=P.$U.toMarkdownTable(["Module","Duration"],Y.amdInvoke),N+=`

### Invoke commonjs-module
`,N+=P.$U.toMarkdownTable(["Module","Duration"],Y.nodeEval),N+=`Start-up time: ${K-Q}
`,N+=`Code loading time: ${X-Q}
`,N+=`Initialized time: ${_-Q}
`,N+=`
`,console.log(N)}return z}e.$VP=j;class H{static create(J){const ne=J.webEndpointUrlTemplate,x=J.commit,G=J.quality;if(!ne||!x||!G)return new H(null);const se=(0,g.$Ag)(),re=new URL(ne.replace("{{uuid}}",se).replace("{{commit}}",x).replace("{{quality}}",G)).origin,ge=(0,b.$Xe)(re).replace(se,"[a-zA-Z0-9\\-]+");try{const B=(0,b.$7e)(`^${ge}$`,!0,{matchCase:!1});return new H(B)}catch{return new H(null)}}constructor(J){this.a=J}matches(J){return this.a?this.a.test(J):!1}}}),define(Ee[307],ke([1,0,27,29,12,293,298,67,7,299,48,57,42]),function(le,e,y,C,s,S,k,P,v,p,D,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=p.performance.now();const m={onMultipleValues:(g,h)=>{console.error(`Option '${g}' can only be defined once. Using value ${h}.`)},onEmptyValue:g=>{console.error(`Ignoring option '${g}': Value must not be empty.`)},onUnknownOption:g=>{console.error(`Ignoring option '${g}': not supported for server.`)},onDeprecatedOption:(g,h)=>{console.warn(`Option '${g}' is deprecated: ${h}`)}};function d(){return(0,P.$$l)(process.argv.slice(2),D.$Rm,m)}function c(g){const h=g["server-data-dir"]||g["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$jc)(y.homedir(),E.default.serverDataFolderName||".vscode-remote"),f=g["user-data-dir"]||(0,v.$jc)(h,"data"),l=(0,v.$jc)(f,"User"),t=(0,v.$jc)(l,"globalStorage"),r=(0,v.$jc)(l,"History"),o=(0,v.$jc)(f,"Machine");g["user-data-dir"]=f;const n=(0,v.$mc)(s.$yg.asFileUri("").fsPath),i=g["builtin-extensions-dir"]||(0,v.$jc)(n,"extensions");return g["builtin-extensions-dir"]=i,g["extensions-dir"]=g["extensions-dir"]||(0,v.$jc)(h,"extensions"),[h,g["extensions-dir"],f,l,o,t,r].forEach(a=>{try{C.existsSync(a)||C.mkdirSync(a,{mode:448})}catch($){console.error($)}}),h}function b(g=d()){return(0,S.run)(g,c(g),D.$Rm)}e.spawnCli=b;function u(g,h=d()){return(0,k.$VP)(g,h,c(h))}e.createServer=u})}).call(this);

//# sourceMappingURL=server.main.js.map
