"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/platform","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/process","child_process","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/model","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(re){for(var e=[],D=0,O=re.length;D<O;D++)e[D]=Se[re[D]];return e};define(Se[159],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const f=new Map,R=new Map,L=new Map,w=new Map;function $(S,E){S.has(E.detail)||S.set(E.detail,-E.timestamp)}function k(S,E){const u=S.get(E.detail);u&&(u>=0||S.set(E.detail,u+E.timestamp))}let M=[];typeof re=="function"&&typeof re.getStats=="function"&&(M=re.getStats().slice(0).sort((S,E)=>S.timestamp-E.timestamp));for(const S of M)switch(S.type){case 10:$(f,S);break;case 11:case 12:k(f,S);break;case 21:$(R,S);break;case 22:k(R,S);break;case 33:$(L,S);break;case 34:k(L,S);break;case 31:$(w,S);break;case 32:k(w,S);break}let I=0;L.forEach(S=>I+=S);function p(S){const E=[];return S.forEach((u,b)=>E.push([b,u])),E}return{amdLoad:p(f),amdInvoke:p(R),nodeRequire:p(L),nodeEval:p(w),nodeRequireTotal:I}}static toMarkdownTable(f,R){let L="";const w=[];return f.forEach(($,k)=>{w[k]=$.length}),R.forEach($=>{$.forEach((k,M)=>{typeof k>"u"&&(k=$[M]="-");const I=k.toString().length;w[M]=Math.max(I,w[M])})}),f.forEach(($,k)=>{L+=`| ${$+" ".repeat(w[k]-$.toString().length)} `}),L+=`|
`,f.forEach(($,k)=>{L+=`| ${"-".repeat(w[k])} `}),L+=`|
`,R.forEach($=>{$.forEach((k,M)=>{typeof k<"u"&&(L+=`| ${k+" ".repeat(w[M]-k.toString().length)} `)}),L+=`|
`}),L}}e.$U=D}),define(Se[160],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(u,b,o){const i=O(u,b);if(i!==-1)return u[i]}e.$fb=D;function O(u,b,o=u.length-1){for(let i=o;i>=0;i--){const n=u[i];if(b(n))return i}return-1}e.$gb=O;function f(u,b){const o=R(u,b);return o===-1?void 0:u[o]}e.$hb=f;function R(u,b,o=0,i=u.length){let n=o,s=i;for(;n<s;){const a=Math.floor((n+s)/2);b(u[a])?n=a+1:s=a}return n-1}e.$ib=R;function L(u,b){const o=w(u,b);return o===u.length?void 0:u[o]}e.$jb=L;function w(u,b,o=0,i=u.length){let n=o,s=i;for(;n<s;){const a=Math.floor((n+s)/2);b(u[a])?s=a:n=a+1}return n}e.$kb=w;function $(u,b,o=0,i=u.length){const n=w(u,b,o,i);return n===u.length?-1:n}e.$lb=$;class k{constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(k.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!b(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const o=R(this.e,b,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=k,k.assertInvariants=!1;function M(u,b){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];b(n,o)>0&&(o=n)}return o}e.$nb=M;function I(u,b){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];b(n,o)>=0&&(o=n)}return o}e.$ob=I;function p(u,b){return M(u,(o,i)=>-b(o,i))}e.$pb=p;function S(u,b){if(u.length===0)return-1;let o=0;for(let i=1;i<u.length;i++){const n=u[i];b(n,u[o])>0&&(o=i)}return o}e.$qb=S;function E(u,b){for(const o of u){const i=b(o);if(i!==void 0)return i}}e.$rb=E}),define(Se[73],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=void 0;function D(L,w){const $=Object.create(null);for(const k of L){const M=w(k);let I=$[M];I||(I=$[M]=[]),I.push(k)}return $}e.$E=D;function O(L,w){const $=[],k=[];for(const M of L)w.has(M)||$.push(M);for(const M of w)L.has(M)||k.push(M);return{removed:$,added:k}}e.$F=O;function f(L,w){const $=[],k=[];for(const[M,I]of L)w.has(M)||$.push(I);for(const[M,I]of w)L.has(M)||k.push(I);return{removed:$,added:k}}e.$G=f;function R(L,w){const $=new Set;for(const k of w)L.has(k)&&$.add(k);return $}e.$H=R}),define(Se[53],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function D(L){return(w,$,k)=>{let M=null,I=null;if(typeof k.value=="function"?(M="value",I=k.value):typeof k.get=="function"&&(M="get",I=k.get),!I)throw new Error("not supported");k[M]=L(I,$)}}function O(L,w,$){let k=null,M=null;if(typeof $.value=="function"?(k="value",M=$.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",M=$.get),!M)throw new Error("not supported");const I=`$memoize$${w}`;$[k]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,p)}),this[I]}}e.$Ih=O;function f(L,w,$){return D((k,M)=>{const I=`$debounce$${M}`,p=`$debounce$result$${M}`;return function(...S){this[p]||(this[p]=$?$():void 0),clearTimeout(this[I]),w&&(this[p]=w(this[p],...S),S=[this[p]]),this[I]=setTimeout(()=>{k.apply(this,S),this[p]=$?$():void 0},L)}})}e.$Jh=f;function R(L,w,$){return D((k,M)=>{const I=`$throttle$timer$${M}`,p=`$throttle$result$${M}`,S=`$throttle$lastRun$${M}`,E=`$throttle$pending$${M}`;return function(...u){if(this[p]||(this[p]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),w&&(this[p]=w(this[p],...u)),this[E])return;const b=this[S]+L;b<=Date.now()?(this[S]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0):(this[E]=!0,this[I]=setTimeout(()=>{this[E]=!1,this[S]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0},b-Date.now()))}})}e.$Kh=R}),define(Se[14],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(d=>{d(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function O(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=O;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=f;function R(a){k(a)||e.$X.onUnexpectedError(a)}e.$1=R;function L(a){k(a)||e.$X.onUnexpectedExternalError(a)}e.$2=L;function w(a){if(a instanceof Error){const{name:t,message:d}=a,l=a.stacktrace||a.stack;return{$isError:!0,name:t,message:d,stack:l,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$3=w;const $="Canceled";function k(a){return a instanceof M?!0:a instanceof Error&&a.name===$&&a.message===$}e.$4=k;class M extends Error{constructor(){super($),this.name=this.message}}e.$5=M;function I(){const a=new Error($);return a.name=a.message,a}e.$6=I;function p(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=p;function S(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=S;class E extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=E;function u(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=u;class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=b;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const d=new n;return d.message=t.message,d.stack=t.stack,d}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(Se[19],De([1,0,14,160]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function f(se,ce=0){return se[se.length-(1+ce)]}e.$sb=f;function R(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.$tb=R;function L(se,ce,le=(de,q)=>de===q){if(se===ce)return!0;if(!se||!ce||se.length!==ce.length)return!1;for(let de=0,q=se.length;de<q;de++)if(!le(se[de],ce[de]))return!1;return!0}e.$ub=L;function w(se,ce){const le=se.length-1;ce<le&&(se[ce]=se[le]),se.pop()}e.$vb=w;function $(se,ce,le){return k(se.length,de=>le(se[de],ce))}e.$wb=$;function k(se,ce){let le=0,de=se-1;for(;le<=de;){const q=(le+de)/2|0,_=ce(q);if(_<0)le=q+1;else if(_>0)de=q-1;else return q}return-(le+1)}e.$xb=k;function M(se,ce,le){if(se=se|0,se>=ce.length)throw new TypeError("invalid index");const de=ce[Math.floor(ce.length*Math.random())],q=[],_=[],ge=[];for(const me of ce){const Ae=le(me,de);Ae<0?q.push(me):Ae>0?_.push(me):ge.push(me)}return se<q.length?M(se,q,le):se<q.length+ge.length?ge[0]:M(se-(q.length+ge.length),_,le)}e.$yb=M;function I(se,ce){const le=[];let de;for(const q of se.slice(0).sort(ce))!de||ce(de[0],q)!==0?(de=[q],le.push(de)):de.push(q);return le}e.$zb=I;function*p(se,ce){let le,de;for(const q of se)de!==void 0&&ce(de,q)?le.push(q):(le&&(yield le),le=[q]),de=q;le&&(yield le)}e.$Ab=p;function S(se,ce){for(let le=0;le<=se.length;le++)ce(le===0?void 0:se[le-1],le===se.length?void 0:se[le])}e.$Bb=S;function E(se,ce){for(let le=0;le<se.length;le++)ce(le===0?void 0:se[le-1],se[le],le+1===se.length?void 0:se[le+1])}e.$Cb=E;function u(se,ce,le){const de=[];function q(me,Ae,ye){if(Ae===0&&ye.length===0)return;const Re=de[de.length-1];Re&&Re.start+Re.deleteCount===me?(Re.deleteCount+=Ae,Re.toInsert.push(...ye)):de.push({start:me,deleteCount:Ae,toInsert:ye})}let _=0,ge=0;for(;;){if(_===se.length){q(_,0,ce.slice(ge));break}if(ge===ce.length){q(_,se.length-_,[]);break}const me=se[_],Ae=ce[ge],ye=le(me,Ae);ye===0?(_+=1,ge+=1):ye<0?(q(_,1,[]),_+=1):ye>0&&(q(_,0,[Ae]),ge+=1)}return de}e.$Db=u;function b(se,ce,le){const de=u(se,ce,le),q=[],_=[];for(const ge of de)q.push(...se.slice(ge.start,ge.start+ge.deleteCount)),_.push(...ge.toInsert);return{removed:q,added:_}}e.$Eb=b;function o(se,ce,le){if(le===0)return[];const de=se.slice(0,le).sort(ce);return n(se,ce,de,le,se.length),de}e.top=o;function i(se,ce,le,de,q){return le===0?Promise.resolve([]):new Promise((_,ge)=>{(async()=>{const me=se.length,Ae=se.slice(0,le).sort(ce);for(let ye=le,Re=Math.min(le+de,me);ye<me;ye=Re,Re=Math.min(Re+de,me)){if(ye>le&&await new Promise(Le=>setTimeout(Le)),q&&q.isCancellationRequested)throw new D.$5;n(se,ce,Ae,ye,Re)}return Ae})().then(_,ge)})}e.$Gb=i;function n(se,ce,le,de,q){for(const _=le.length;de<q;de++){const ge=se[de];if(ce(ge,le[_-1])<0){le.pop();const me=(0,O.$kb)(le,Ae=>ce(ge,Ae)<0);le.splice(me,0,ge)}}}function s(se){return se.filter(ce=>!!ce)}e.$Hb=s;function a(se){let ce=0;for(let le=0;le<se.length;le++)se[le]&&(se[ce]=se[le],ce+=1);se.length=ce}e.$Ib=a;function t(se,ce,le){se.splice(le,0,se.splice(ce,1)[0])}e.$Jb=t;function d(se){return!Array.isArray(se)||se.length===0}e.$Kb=d;function l(se){return Array.isArray(se)&&se.length>0}e.$Lb=l;function r(se,ce=le=>le){const le=new Set;return se.filter(de=>{const q=ce(de);return le.has(q)?!1:(le.add(q),!0)})}e.$Mb=r;function c(se){const ce=new Set;return le=>{const de=se(le);return ce.has(de)?!1:(ce.add(de),!0)}}e.$Nb=c;function h(se,ce){return se.length>0?se[0]:ce}e.$Ob=h;function g(se,ce){return se.length>0?se[se.length-1]:ce}e.$Pb=g;function C(se,ce,le=(de,q)=>de===q){let de=0;for(let q=0,_=Math.min(se.length,ce.length);q<_&&le(se[q],ce[q]);q++)de++;return de}e.$Qb=C;function v(se){return[].concat(...se)}e.$Rb=v;function m(se,ce){let le=typeof ce=="number"?se:0;typeof ce=="number"?le=se:(le=0,ce=se);const de=[];if(le<=ce)for(let q=le;q<ce;q++)de.push(q);else for(let q=le;q>ce;q--)de.push(q);return de}e.$Sb=m;function y(se,ce,le){return se.reduce((de,q)=>(de[ce(q)]=le?le(q):q,de),Object.create(null))}e.$Tb=y;function P(se,ce){return se.push(ce),()=>j(se,ce)}e.$Ub=P;function j(se,ce){const le=se.indexOf(ce);if(le>-1)return se.splice(le,1),ce}e.$Vb=j;function U(se,ce,le){const de=se.slice(0,ce),q=se.slice(ce);return de.concat(le,q)}e.$Wb=U;function z(se,ce){let le;if(typeof ce=="number"){let de=ce;le=()=>{const q=Math.sin(de++)*179426549;return q-Math.floor(q)}}else le=Math.random;for(let de=se.length-1;de>0;de-=1){const q=Math.floor(le()*(de+1)),_=se[de];se[de]=se[q],se[q]=_}}e.$Xb=z;function N(se,ce){const le=se.indexOf(ce);le>-1&&(se.splice(le,1),se.unshift(ce))}e.$Yb=N;function A(se,ce){const le=se.indexOf(ce);le>-1&&(se.splice(le,1),se.push(ce))}e.$Zb=A;function T(se,ce){for(const le of ce)se.push(le)}e.$1b=T;function F(se,ce){return Array.isArray(se)?se.map(ce):ce(se)}e.$2b=F;function G(se){return Array.isArray(se)?se:[se]}e.$3b=G;function K(se){return se[Math.floor(Math.random()*se.length)]}e.$4b=K;function X(se,ce,le){const de=Z(se,ce),q=se.length,_=le.length;se.length=q+_;for(let ge=q-1;ge>=de;ge--)se[ge+_]=se[ge];for(let ge=0;ge<_;ge++)se[ge+de]=le[ge]}e.$5b=X;function Q(se,ce,le,de){const q=Z(se,ce);let _=se.splice(q,le);return _===void 0&&(_=[]),X(se,q,de),_}e.$6b=Q;function Z(se,ce){return ce<0?Math.max(ce+se.length,0):Math.min(ce,se.length)}var ie;(function(se){function ce(_){return _<0}se.isLessThan=ce;function le(_){return _<=0}se.isLessThanOrEqual=le;function de(_){return _>0}se.isGreaterThan=de;function q(_){return _===0}se.isNeitherLessOrGreaterThan=q,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function ee(se,ce){return(le,de)=>ce(se(le),se(de))}e.$7b=ee;function we(...se){return(ce,le)=>{for(const de of se){const q=de(ce,le);if(!ie.isNeitherLessOrGreaterThan(q))return q}return ie.neitherLessOrGreaterThan}}e.$8b=we;const ue=(se,ce)=>se-ce;e.$9b=ue;const ae=(se,ce)=>(0,e.$9b)(se?1:0,ce?1:0);e.$0b=ae;function H(se){return(ce,le)=>-se(ce,le)}e.$$b=H;class fe{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let le=this.c;for(;le<this.g.length&&ce(this.g[le]);)le++;const de=le===this.c?null:this.g.slice(this.c,le);return this.c=le,de}takeFromEndWhile(ce){let le=this.d;for(;le>=0&&ce(this.g[le]);)le--;const de=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,de}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const le=this.g.slice(this.c,this.c+ce);return this.c+=ce,le}}e.$_b=fe;class he{constructor(ce){this.iterate=ce}forEach(ce){this.iterate(le=>(ce(le),!0))}toArray(){const ce=[];return this.iterate(le=>(ce.push(le),!0)),ce}filter(ce){return new he(le=>this.iterate(de=>ce(de)?le(de):!0))}map(ce){return new he(le=>this.iterate(de=>le(ce(de))))}some(ce){let le=!1;return this.iterate(de=>(le=ce(de),!le)),le}findFirst(ce){let le;return this.iterate(de=>ce(de)?(le=de,!1):!0),le}findLast(ce){let le;return this.iterate(de=>(ce(de)&&(le=de),!0)),le}findLastMaxBy(ce){let le,de=!0;return this.iterate(q=>((de||ie.isGreaterThan(ce(q,le)))&&(de=!1,le=q),!0)),le}}e.$ac=he,he.empty=new he(se=>{})}),define(Se[61],De([1,0,14]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function O(k,M){if(!k)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=O;function f(k,M="Unreachable"){throw new Error(M)}e.$9c=f;function R(k){if(!k)throw new D.$cb("Assertion Failed")}e.$0c=R;function L(k){k||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}e.$$c=L;function w(k){if(!k()){debugger;k(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$_c=w;function $(k,M){let I=0;for(;I<k.length-1;){const p=k[I],S=k[I+1];if(!M(p,S))return!1;I++}return!0}e.$ad=$}),define(Se[74],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(O,f){const R=this;let L=!1,w;return function(){if(L)return w;if(L=!0,f)try{w=O.apply(R,arguments)}finally{f()}else w=O.apply(R,arguments);return w}}e.$db=D}),define(Se[122],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0;class D{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$kO=D,e.$lO=new D("id#")}),define(Se[48],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(O){function f(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=f;const R=Object.freeze([]);function L(){return R}O.empty=L;function*w(t){yield t}O.single=w;function $(t){return f(t)?t:w(t)}O.wrap=$;function k(t){return t||R}O.from=k;function*M(t){for(let d=t.length-1;d>=0;d--)yield t[d]}O.reverse=M;function I(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=I;function p(t){return t[Symbol.iterator]().next().value}O.first=p;function S(t,d){for(const l of t)if(d(l))return!0;return!1}O.some=S;function E(t,d){for(const l of t)if(d(l))return l}O.find=E;function*u(t,d){for(const l of t)d(l)&&(yield l)}O.filter=u;function*b(t,d){let l=0;for(const r of t)yield d(r,l++)}O.map=b;function*o(...t){for(const d of t)yield*d}O.concat=o;function i(t,d,l){let r=l;for(const c of t)r=d(r,c);return r}O.reduce=i;function*n(t,d,l=t.length){for(d<0&&(d+=t.length),l<0?l+=t.length:l>t.length&&(l=t.length);d<l;d++)yield t[d]}O.slice=n;function s(t,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,t];const r=t[Symbol.iterator]();for(let c=0;c<d;c++){const h=r.next();if(h.done)return[l,O.empty()];l.push(h.value)}return[l,{[Symbol.iterator](){return r}}]}O.consume=s;async function a(t){const d=[];for await(const l of t)d.push(l);return Promise.resolve(d)}O.asyncToArray=a})(D||(e.Iterable=D={}))}),define(Se[161],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,d=!1){let l=0;const r=t.length;let c="",h=0,g=16,C=0;function v(N){let A=0,T=0;for(;A<N;){const F=t.charCodeAt(l);if(F>=48&&F<=57)T=T*16+F-48;else if(F>=65&&F<=70)T=T*16+F-65+10;else if(F>=97&&F<=102)T=T*16+F-97+10;else break;l++,A++}return A<N&&(T=-1),T}function m(N){l=N,c="",h=0,g=16,C=0}function y(){const N=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&k(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&k(t.charCodeAt(l)))for(l++;l<t.length&&k(t.charCodeAt(l));)l++;else return C=3,t.substring(N,l);let A=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&k(t.charCodeAt(l))){for(l++;l<t.length&&k(t.charCodeAt(l));)l++;A=l}else C=3;return t.substring(N,A)}function P(){let N="",A=l;for(;;){if(l>=r){N+=t.substring(A,l),C=2;break}const T=t.charCodeAt(l);if(T===34){N+=t.substring(A,l),l++;break}if(T===92){if(N+=t.substring(A,l),l++,l>=r){C=2;break}switch(t.charCodeAt(l++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const G=v(4);G>=0?N+=String.fromCharCode(G):C=4;break}default:C=5}A=l;continue}if(T>=0&&T<=31)if($(T)){N+=t.substring(A,l),C=2;break}else C=6;l++}return N}function j(){if(c="",C=0,h=l,l>=r)return h=r,g=17;let N=t.charCodeAt(l);if(w(N)){do l++,c+=String.fromCharCode(N),N=t.charCodeAt(l);while(w(N));return g=15}if($(N))return l++,c+=String.fromCharCode(N),N===13&&t.charCodeAt(l)===10&&(l++,c+=`
`),g=14;switch(N){case 123:return l++,g=1;case 125:return l++,g=2;case 91:return l++,g=3;case 93:return l++,g=4;case 58:return l++,g=6;case 44:return l++,g=5;case 34:return l++,c=P(),g=10;case 47:{const A=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<r&&!$(t.charCodeAt(l));)l++;return c=t.substring(A,l),g=12}if(t.charCodeAt(l+1)===42){l+=2;const T=r-1;let F=!1;for(;l<T;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,F=!0;break}l++}return F||(l++,C=1),c=t.substring(A,l),g=13}return c+=String.fromCharCode(N),l++,g=16}case 45:if(c+=String.fromCharCode(N),l++,l===r||!k(t.charCodeAt(l)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=y(),g=11;default:for(;l<r&&U(N);)l++,N=t.charCodeAt(l);if(h!==l){switch(c=t.substring(h,l),c){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return c+=String.fromCharCode(N),l++,g=16}}function U(N){if(w(N)||$(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let N;do N=j();while(N>=12&&N<=15);return N}return{setPosition:m,getPosition:()=>l,scan:d?z:j,getToken:()=>g,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>l-h,getTokenError:()=>C}}e.$nn=L;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function I(t,d){const l=[],r=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function C(v,m,y,P){h.value=v,h.offset=m,h.length=y,h.type=P,h.colonOffset=void 0,c=h}try{n(t,{onObjectBegin:(v,m)=>{if(d<=v)throw r;c=void 0,g=d>v,l.push("")},onObjectProperty:(v,m,y)=>{if(d<m||(C(v,m,y,"property"),l[l.length-1]=v,d<=m+y))throw r},onObjectEnd:(v,m)=>{if(d<=v)throw r;c=void 0,l.pop()},onArrayBegin:(v,m)=>{if(d<=v)throw r;c=void 0,l.push(0)},onArrayEnd:(v,m)=>{if(d<=v)throw r;c=void 0,l.pop()},onLiteralValue:(v,m,y)=>{if(d<m||(C(v,m,y,a(v)),d<=m+y))throw r},onSeparator:(v,m,y)=>{if(d<=m)throw r;if(v===":"&&c&&c.type==="property")c.colonOffset=m,g=!1,c=void 0;else if(v===","){const P=l[l.length-1];typeof P=="number"?l[l.length-1]=P+1:(g=!0,l[l.length-1]=""),c=void 0}}})}catch(v){if(v!==r)throw v}return{path:l,previousNode:c,isAtPropertyKey:g,matches:v=>{let m=0;for(let y=0;m<v.length&&y<l.length;y++)if(v[m]===l[y]||v[m]==="*")m++;else if(v[m]!=="**")return!1;return m===v.length}}}e.$on=I;function p(t,d=[],l=R.DEFAULT){let r=null,c=[];const h=[];function g(v){Array.isArray(c)?c.push(v):r!==null&&(c[r]=v)}return n(t,{onObjectBegin:()=>{const v={};g(v),h.push(c),c=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const v=[];g(v),h.push(c),c=v,r=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:g,onError:(v,m,y)=>{d.push({error:v,offset:m,length:y})}},l),c[0]}e.$pn=p;function S(t,d=[],l=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function h(v){return r.children.push(v),v}n(t,{onObjectBegin:v=>{r=h({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,m,y)=>{r=h({type:"property",offset:m,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:m,length:y,parent:r})},onObjectEnd:(v,m)=>{r.length=v+m-r.offset,r=r.parent,c(v+m)},onArrayBegin:(v,m)=>{r=h({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,m)=>{r.length=v+m-r.offset,r=r.parent,c(v+m)},onLiteralValue:(v,m,y)=>{h({type:a(v),offset:m,length:y,parent:r,value:v}),c(m+y)},onSeparator:(v,m,y)=>{r.type==="property"&&(v===":"?r.colonOffset=m:v===","&&c(m))},onError:(v,m,y)=>{d.push({error:v,offset:m,length:y})}},l);const C=r.children[0];return C&&delete C.parent,C}e.$qn=S;function E(t,d){if(!t)return;let l=t;for(const r of d)if(typeof r=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let c=!1;for(const h of l.children)if(Array.isArray(h.children)&&h.children[0].value===r){l=h.children[1],c=!0;break}if(!c)return}else{const c=r;if(l.type!=="array"||c<0||!Array.isArray(l.children)||c>=l.children.length)return;l=l.children[c]}return l}e.$rn=E;function u(t){if(!t.parent||!t.parent.children)return[];const d=u(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;d.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&d.push(l)}return d}e.$sn=u;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":{const d=Object.create(null);for(const l of t.children){const r=l.children[1];r&&(d[l.children[0].value]=b(r))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$tn=b;function o(t,d,l=!1){return d>=t.offset&&d<t.offset+t.length||l&&d===t.offset+t.length}e.$un=o;function i(t,d,l=!1){if(o(t,d,l)){const r=t.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=d;c++){const h=i(r[c],d,l);if(h)return h}return t}}e.$vn=i;function n(t,d,l=R.DEFAULT){const r=L(t,!1);function c(ee){return ee?()=>ee(r.getTokenOffset(),r.getTokenLength()):()=>!0}function h(ee){return ee?we=>ee(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const g=c(d.onObjectBegin),C=h(d.onObjectProperty),v=c(d.onObjectEnd),m=c(d.onArrayBegin),y=c(d.onArrayEnd),P=h(d.onLiteralValue),j=h(d.onSeparator),U=c(d.onComment),z=h(d.onError),N=l&&l.disallowComments,A=l&&l.allowTrailingComma;function T(){for(;;){const ee=r.scan();switch(r.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:N||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(ee){case 12:case 13:N?F(10):U();break;case 16:F(1);break;case 15:case 14:break;default:return ee}}}function F(ee,we=[],ue=[]){if(z(ee),we.length+ue.length>0){let ae=r.getToken();for(;ae!==17;){if(we.indexOf(ae)!==-1){T();break}else if(ue.indexOf(ae)!==-1)break;ae=T()}}}function G(ee){const we=r.getTokenValue();return ee?P(we):C(we),T(),!0}function K(){switch(r.getToken()){case 11:{let ee=0;try{ee=JSON.parse(r.getTokenValue()),typeof ee!="number"&&(F(2),ee=0)}catch{F(2)}P(ee);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function X(){return r.getToken()!==10?(F(3,[],[2,5]),!1):(G(!1),r.getToken()===6?(j(":"),T(),ie()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function Q(){g(),T();let ee=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ee||F(4,[],[]),j(","),T(),r.getToken()===2&&A)break}else ee&&F(6,[],[]);X()||F(4,[],[2,5]),ee=!0}return v(),r.getToken()!==2?F(7,[2],[]):T(),!0}function Z(){m(),T();let ee=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ee||F(4,[],[]),j(","),T(),r.getToken()===4&&A)break}else ee&&F(6,[],[]);ie()||F(4,[],[4,5]),ee=!0}return y(),r.getToken()!==4?F(8,[4],[]):T(),!0}function ie(){switch(r.getToken()){case 3:return Z();case 1:return Q();case 10:return G(!0);default:return K()}}return T(),r.getToken()===17?l.allowEmptyContent?!0:(F(4,[],[]),!1):ie()?(r.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.$wn=n;function s(t,d){const l=L(t),r=[];let c,h=0,g;do switch(g=l.getPosition(),c=l.scan(),c){case 12:case 13:case 17:h!==g&&r.push(t.substring(h,g)),d!==void 0&&r.push(l.getTokenValue().replace(/[^\r\n]/g,d)),h=l.getPosition();break}while(c!==17);return r.join("")}e.$xn=s;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$yn=a}),define(Se[44],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(Se[75],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{constructor(R){this.element=R,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let R=this.a;for(;R!==D.Undefined;){const L=R.next;R.prev=D.Undefined,R.next=D.Undefined,R=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const w=new D(R);if(this.a===D.Undefined)this.a=w,this.b=w;else if(L){const k=this.b;this.b=w,w.prev=k,k.next=w}else{const k=this.a;this.a=w,w.next=k,k.prev=w}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(w))}}shift(){if(this.a!==D.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==D.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==D.Undefined&&R.next!==D.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===D.Undefined&&R.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):R.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):R.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==D.Undefined;)yield R.element,R=R.next}}e.$4c=O}),define(Se[28],De([1,0]),function(re,e){"use strict";var D,O,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function R(n,s,a){let t=n.get(s);return t===void 0&&(t=a,n.set(s,t)),t}e.$xc=R;function L(n){const s=[];return n.forEach((a,t)=>{s.push(`${t} => ${a}`)}),`Map(${n.size}) {${s.join(", ")}}`}e.$yc=L;function w(n){const s=[];return n.forEach(a=>{s.push(a)}),`Set(${n.size}) {${s.join(", ")}}`}e.$zc=w;class ${constructor(s,a){this.uri=s,this.value=a}}function k(n){return Array.isArray(n)}class M{constructor(s,a){if(this[D]="ResourceMap",s instanceof M)this.d=new Map(s.d),this.e=a??M.c;else if(k(s)){this.d=new Map,this.e=a??M.c;for(const[t,d]of s)this.set(t,d)}else this.d=new Map,this.e=s??M.c}set(s,a){return this.d.set(this.e(s),new $(s,a)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,a){typeof a<"u"&&(s=s.bind(a));for(const[t,d]of this.d)s(d.value,d.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$Ac=M,M.c=n=>n.toString();class I{constructor(s,a){this[O]="ResourceSet",!s||typeof s=="function"?this.c=new M(s):(this.c=new M(a),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,a){this.c.forEach((t,d)=>s.call(a,d,d,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var p;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class S{constructor(){this[f]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,a=0){const t=this.c.get(s);if(t)return a!==0&&this.l(t,a),t.value}set(s,a,t=0){let d=this.c.get(s);if(d)d.value=a,t!==0&&this.l(d,t);else{switch(d={key:s,value:a,next:void 0,previous:void 0},t){case 0:this.j(d);break;case 1:this.i(d);break;case 2:this.j(d);break;default:this.j(d);break}this.c.set(s,d),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const a=this.c.get(s);if(a)return this.c.delete(s),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.k(s),this.f--,s.value}forEach(s,a){const t=this.g;let d=this.d;for(;d;){if(a?s.bind(a)(d.value,d.key,this):s(d.value,d.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const s=this,a=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const l={value:t.key,done:!1};return t=t.next,l}else return{value:void 0,done:!0}}};return d}values(){const s=this,a=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const l={value:t.value,done:!1};return t=t.next,l}else return{value:void 0,done:!0}}};return d}entries(){const s=this,a=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const l={value:[t.key,t.value],done:!1};return t=t.next,l}else return{value:void 0,done:!0}}};return d}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>s;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}j(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}k(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const a=s.next,t=s.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}s.next=void 0,s.previous=void 0,this.g++}l(s,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(s===this.d)return;const t=s.next,d=s.previous;s===this.e?(d.next=void 0,this.e=d):(t.previous=d,d.next=t),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(a===2){if(s===this.e)return;const t=s.next,d=s.previous;s===this.d?(t.previous=void 0,this.d=t):(t.previous=d,d.next=t),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((a,t)=>{s.push([t,a])}),s}fromJSON(s){this.clear();for(const[a,t]of s)this.set(a,t)}}e.$Cc=S;class E extends S{constructor(s,a=1){super(),this.m=s,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(s){this.m=s,this.o()}get ratio(){return this.n}set ratio(s){this.n=Math.min(Math.max(0,s),1),this.o()}get(s,a=2){return super.get(s,a)}peek(s){return super.get(s,0)}set(s,a){return super.set(s,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=E;class u{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let a=this.c.get(s)||0;return a===0?!1:(a--,a===0?this.c.delete(s):this.c.set(s,a),!0)}has(s){return this.c.has(s)}}e.$Ec=u;class b{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[a,t]of s)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(s,a){this.c.set(s,a),this.d.set(a,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const a=this.c.get(s);return a===void 0?!1:(this.c.delete(s),this.d.delete(a),!0)}forEach(s,a){this.c.forEach((t,d)=>{s.call(a,t,d,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=b;class o{constructor(){this.c=new Map}add(s,a){let t=this.c.get(s);t||(t=new Set,this.c.set(s,t)),t.add(a)}delete(s,a){const t=this.c.get(s);t&&(t.delete(a),t.size===0&&this.c.delete(s))}forEach(s,a){const t=this.c.get(s);t&&t.forEach(a)}get(s){const a=this.c.get(s);return a||new Set}}e.$Gc=o;function i(n,s){if(n===s)return!0;if(n.size!==s.size)return!1;for(const[a,t]of n)if(!s.has(a)||s.get(a)!==t)return!1;for(const[a]of s)if(!n.has(a))return!1;return!0}e.$Hc=i}),define(Se[3],De([1,0,19,73,28,74,48]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const w=!1;let $=null;class k{constructor(){this.b=new Map}c(P){let j=this.b.get(P);return j||(j={parent:null,source:null,isSingleton:!1,value:P,idx:k.a++},this.b.set(P,j)),j}trackDisposable(P){const j=this.c(P);j.source||(j.source=new Error().stack)}setParent(P,j){const U=this.c(P);U.parent=j}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,j){const U=j.get(P);if(U)return U;const z=P.parent?this.f(this.c(P.parent),j):P;return j.set(P,z),z}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,P).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(P=10,j){let U;if(j)U=j;else{const F=new Map,G=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,F).isSingleton);if(G.length===0)return;const K=new Set(G.map(X=>X.value));if(U=G.filter(X=>!(X.parent&&K.has(X.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(F){function G(X,Q){for(;X.length>0&&Q.some(Z=>typeof Z=="string"?Z===X[0]:X[0].match(Z));)X.shift()}const K=F.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return G(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const N=new f.$Gc;for(const F of U){const G=z(F);for(let K=0;K<=G.length;K++)N.add(G.slice(0,K).join(`
`),F)}U.sort((0,D.$7b)(F=>F.idx,D.$9b));let A="",T=0;for(const F of U.slice(0,P)){T++;const G=z(F),K=[];for(let X=0;X<G.length;X++){let Q=G[X];Q=`(shared with ${N.get(G.slice(0,X+1).join(`
`)).size}/${U.length} leaks) at ${Q}`;const ie=N.get(G.slice(0,X).join(`
`)),ee=(0,O.$E)([...ie].map(we=>z(we)[X]),we=>we);delete ee[G[X]];for(const[we,ue]of Object.entries(ee))K.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${we}`);K.unshift(Q)}A+=`


==================== Leaking disposable ${T}/${U.length}: ${F.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return U.length>P&&(A+=`


... and ${U.length-P} more leaking disposables

`),{leaks:U,details:A}}}e.$Ic=k,k.a=0;function M(y){$=y}if(e.$Jc=M,w){const y="__is_disposable_tracked__";M(new class{trackDisposable(P){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(j)},3e3)}setParent(P,j){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function I(y){return $?.trackDisposable(y),y}e.$Kc=I;function p(y){$?.markAsDisposed(y)}e.$Lc=p;function S(y,P){$?.setParent(y,P)}function E(y,P){if($)for(const j of y)$.setParent(j,P)}function u(y){return $?.markAsSingleton(y),y}e.$Mc=u;function b(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=b;function o(y){if(L.Iterable.is(y)){const P=[];for(const j of y)if(j)try{j.dispose()}catch(U){P.push(U)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=o;function i(y){for(const P of y)b(P)&&P.dispose();return[]}e.$Pc=i;function n(...y){const P=s(()=>o(y));return E(y,P),P}e.$Qc=n;function s(y){const P=I({dispose:(0,R.$db)(()=>{p(P),y()})});return P}e.$Rc=s;class a{constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return S(P,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),S(P,null))}}e.$Sc=a,a.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new a,I(this),S(this.q,this)}dispose(){p(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t,t.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&S(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&S(P,null),P}}e.$Uc=d;class l{constructor(P){this.a=new d,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=l;class r{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=r;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(P){let j=P;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,p(this))},this}}e.$Xc=c;class h{constructor(){this.a=new Map}acquire(P,...j){let U=this.a.get(P);U||(U={counter:0,object:this.b(P,...j)},this.a.set(P,U));const{object:z}=U,N=(0,R.$db)(()=>{--U.counter===0&&(this.c(P,U.object),this.a.delete(P))});return U.counter++,{object:z,dispose:N}}}e.$Yc=h;class g{constructor(P){this.a=P}async acquire(P,...j){const U=this.a.acquire(P,...j);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Zc=g;class C{constructor(P){this.object=P}dispose(){}}e.$1c=C;function v(y){const P=new a;try{y(P)}finally{P.dispose()}}e.$2c=v;class m{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,j,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(P)?.dispose(),this.a.set(P,j)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=m}),function(re,e){typeof define=="function"&&define.amd?define(Se[162],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ce,le){for(var de=0;de<le.length;de++){var q=le[de];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(ce,q.key,q)}}function D(ce,le,de){return le&&e(ce.prototype,le),de&&e(ce,de),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function O(ce,le){if(ce){if(typeof ce=="string")return f(ce,le);var de=Object.prototype.toString.call(ce).slice(8,-1);if(de==="Object"&&ce.constructor&&(de=ce.constructor.name),de==="Map"||de==="Set")return Array.from(ce);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return f(ce,le)}}function f(ce,le){(le==null||le>ce.length)&&(le=ce.length);for(var de=0,q=new Array(le);de<le;de++)q[de]=ce[de];return q}function R(ce,le){var de=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(de)return(de=de.call(ce)).next.bind(de);if(Array.isArray(ce)||(de=O(ce))||le&&ce&&typeof ce.length=="number"){de&&(ce=de);var q=0;return function(){return q>=ce.length?{done:!0}:{done:!1,value:ce[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=L();function w(ce){re.defaults=ce}var $=/[&<>"']/,k=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(le){return p[le]};function E(ce,le){if(le){if($.test(ce))return ce.replace(k,S)}else if(M.test(ce))return ce.replace(I,S);return ce}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(ce){return ce.replace(u,function(le,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ce,le){ce=typeof ce=="string"?ce:ce.source,le=le||"";var de={replace:function(_,ge){return ge=ge.source||ge,ge=ge.replace(o,"$1"),ce=ce.replace(_,ge),de},getRegex:function(){return new RegExp(ce,le)}};return de}var n=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(ce,le,de){if(ce){var q;try{q=decodeURIComponent(b(de)).replace(n,"").toLowerCase()}catch{return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}le&&!s.test(de)&&(de=c(le,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},d=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ce,le){t[" "+ce]||(d.test(ce)?t[" "+ce]=ce+"/":t[" "+ce]=v(ce,"/",!0)),ce=t[" "+ce];var de=ce.indexOf(":")===-1;return le.substring(0,2)==="//"?de?le:ce.replace(l,"$1")+le:le.charAt(0)==="/"?de?le:ce.replace(r,"$1")+le:ce+le}var h={exec:function(){}};function g(ce){for(var le=1,de,q;le<arguments.length;le++){de=arguments[le];for(q in de)Object.prototype.hasOwnProperty.call(de,q)&&(ce[q]=de[q])}return ce}function C(ce,le){var de=ce.replace(/\|/g,function(ge,me,Ae){for(var ye=!1,Re=me;--Re>=0&&Ae[Re]==="\\";)ye=!ye;return ye?"|":" |"}),q=de.split(/ \|/),_=0;if(q[0].trim()||q.shift(),q.length>0&&!q[q.length-1].trim()&&q.pop(),q.length>le)q.splice(le);else for(;q.length<le;)q.push("");for(;_<q.length;_++)q[_]=q[_].trim().replace(/\\\|/g,"|");return q}function v(ce,le,de){var q=ce.length;if(q===0)return"";for(var _=0;_<q;){var ge=ce.charAt(q-_-1);if(ge===le&&!de)_++;else if(ge!==le&&de)_++;else break}return ce.slice(0,q-_)}function m(ce,le){if(ce.indexOf(le[1])===-1)return-1;for(var de=ce.length,q=0,_=0;_<de;_++)if(ce[_]==="\\")_++;else if(ce[_]===le[0])q++;else if(ce[_]===le[1]&&(q--,q<0))return _;return-1}function y(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ce,le){if(le<1)return"";for(var de="";le>1;)le&1&&(de+=ce),le>>=1,ce+=ce;return de+ce}function j(ce,le,de,q){var _=le.href,ge=le.title?E(le.title):null,me=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){q.state.inLink=!0;var Ae={type:"link",raw:de,href:_,title:ge,text:me,tokens:q.inlineTokens(me)};return q.state.inLink=!1,Ae}return{type:"image",raw:de,href:_,title:ge,text:E(me)}}function U(ce,le){var de=ce.match(/^(\s+)(?:```)/);if(de===null)return le;var q=de[1];return le.split(`
`).map(function(_){var ge=_.match(/^\s+/);if(ge===null)return _;var me=ge[0];return me.length>=q.length?_.slice(q.length):_}).join(`
`)}var z=function(){function ce(de){this.options=de||re.defaults}var le=ce.prototype;return le.space=function(q){var _=this.rules.block.newline.exec(q);if(_&&_[0].length>0)return{type:"space",raw:_[0]}},le.code=function(q){var _=this.rules.block.code.exec(q);if(_){var ge=_[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:_[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:v(ge,`
`)}}},le.fences=function(q){var _=this.rules.block.fences.exec(q);if(_){var ge=_[0],me=U(ge,_[3]||"");return{type:"code",raw:ge,lang:_[2]?_[2].trim():_[2],text:me}}},le.heading=function(q){var _=this.rules.block.heading.exec(q);if(_){var ge=_[2].trim();if(/#$/.test(ge)){var me=v(ge,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ge=me.trim())}return{type:"heading",raw:_[0],depth:_[1].length,text:ge,tokens:this.lexer.inline(ge)}}},le.hr=function(q){var _=this.rules.block.hr.exec(q);if(_)return{type:"hr",raw:_[0]}},le.blockquote=function(q){var _=this.rules.block.blockquote.exec(q);if(_){var ge=_[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:_[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},le.list=function(q){var _=this.rules.block.list.exec(q);if(_){var ge,me,Ae,ye,Re,Le,ze,B,V,x,Y,$e,ve=_[1].trim(),Te=ve.length>1,Ve={type:"list",raw:"",ordered:Te,start:Te?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Te?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Te?ve:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");q&&($e=!1,!(!(_=Qe.exec(q))||this.rules.block.hr.test(q)));){if(ge=_[0],q=q.substring(ge.length),B=_[2].split(`
`,1)[0],V=q.split(`
`,1)[0],this.options.pedantic?(ye=2,Y=B.trimLeft()):(ye=_[2].search(/[^ ]/),ye=ye>4?1:ye,Y=B.slice(ye),ye+=_[1].length),Le=!1,!B&&/^ *$/.test(V)&&(ge+=V+`
`,q=q.substring(V.length+1),$e=!0),!$e)for(var tt=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,ye-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),dt=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,ye-1)+"}#");q&&(x=q.split(`
`,1)[0],B=x,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(dt.test(B)||ot.test(B)||tt.test(B)||at.test(q)));){if(B.search(/[^ ]/)>=ye||!B.trim())Y+=`
`+B.slice(ye);else if(!Le)Y+=`
`+B;else break;!Le&&!B.trim()&&(Le=!0),ge+=x+`
`,q=q.substring(x.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test(ge)&&(ze=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(Y),me&&(Ae=me[0]!=="[ ] ",Y=Y.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ge,task:!!me,checked:Ae,loose:!1,text:Y}),Ve.raw+=ge}Ve.items[Ve.items.length-1].raw=ge.trimRight(),Ve.items[Ve.items.length-1].text=Y.trimRight(),Ve.raw=Ve.raw.trimRight();var rt=Ve.items.length;for(Re=0;Re<rt;Re++){this.lexer.state.top=!1,Ve.items[Re].tokens=this.lexer.blockTokens(Ve.items[Re].text,[]);var Pe=Ve.items[Re].tokens.filter(function(Ge){return Ge.type==="space"}),Ie=Pe.every(function(Ge){for(var te=Ge.raw.split(""),oe=0,Ce=R(te),Ke;!(Ke=Ce()).done;){var xe=Ke.value;if(xe===`
`&&(oe+=1),oe>1)return!0}return!1});!Ve.loose&&Pe.length&&Ie&&(Ve.loose=!0,Ve.items[Re].loose=!0)}return Ve}},le.html=function(q){var _=this.rules.block.html.exec(q);if(_){var ge={type:"html",raw:_[0],pre:!this.options.sanitizer&&(_[1]==="pre"||_[1]==="script"||_[1]==="style"),text:_[0]};if(this.options.sanitize){var me=this.options.sanitizer?this.options.sanitizer(_[0]):E(_[0]);ge.type="paragraph",ge.text=me,ge.tokens=this.lexer.inline(me)}return ge}},le.def=function(q){var _=this.rules.block.def.exec(q);if(_){_[3]&&(_[3]=_[3].substring(1,_[3].length-1));var ge=_[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:_[0],href:_[2],title:_[3]}}},le.table=function(q){var _=this.rules.block.table.exec(q);if(_){var ge={type:"table",header:C(_[1]).map(function(ze){return{text:ze}}),align:_[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:_[3]&&_[3].trim()?_[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=_[0];var me=ge.align.length,Ae,ye,Re,Le;for(Ae=0;Ae<me;Ae++)/^ *-+: *$/.test(ge.align[Ae])?ge.align[Ae]="right":/^ *:-+: *$/.test(ge.align[Ae])?ge.align[Ae]="center":/^ *:-+ *$/.test(ge.align[Ae])?ge.align[Ae]="left":ge.align[Ae]=null;for(me=ge.rows.length,Ae=0;Ae<me;Ae++)ge.rows[Ae]=C(ge.rows[Ae],ge.header.length).map(function(ze){return{text:ze}});for(me=ge.header.length,ye=0;ye<me;ye++)ge.header[ye].tokens=this.lexer.inline(ge.header[ye].text);for(me=ge.rows.length,ye=0;ye<me;ye++)for(Le=ge.rows[ye],Re=0;Re<Le.length;Re++)Le[Re].tokens=this.lexer.inline(Le[Re].text);return ge}}},le.lheading=function(q){var _=this.rules.block.lheading.exec(q);if(_)return{type:"heading",raw:_[0],depth:_[2].charAt(0)==="="?1:2,text:_[1],tokens:this.lexer.inline(_[1])}},le.paragraph=function(q){var _=this.rules.block.paragraph.exec(q);if(_){var ge=_[1].charAt(_[1].length-1)===`
`?_[1].slice(0,-1):_[1];return{type:"paragraph",raw:_[0],text:ge,tokens:this.lexer.inline(ge)}}},le.text=function(q){var _=this.rules.block.text.exec(q);if(_)return{type:"text",raw:_[0],text:_[0],tokens:this.lexer.inline(_[0])}},le.escape=function(q){var _=this.rules.inline.escape.exec(q);if(_)return{type:"escape",raw:_[0],text:E(_[1])}},le.tag=function(q){var _=this.rules.inline.tag.exec(q);if(_)return!this.lexer.state.inLink&&/^<a /i.test(_[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(_[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(_[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(_[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:_[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):E(_[0]):_[0]}},le.link=function(q){var _=this.rules.inline.link.exec(q);if(_){var ge=_[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var me=v(ge.slice(0,-1),"\\");if((ge.length-me.length)%2===0)return}else{var Ae=m(_[2],"()");if(Ae>-1){var ye=_[0].indexOf("!")===0?5:4,Re=ye+_[1].length+Ae;_[2]=_[2].substring(0,Ae),_[0]=_[0].substring(0,Re).trim(),_[3]=""}}var Le=_[2],ze="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Le);B&&(Le=B[1],ze=B[3])}else ze=_[3]?_[3].slice(1,-1):"";return Le=Le.trim(),/^</.test(Le)&&(this.options.pedantic&&!/>$/.test(ge)?Le=Le.slice(1):Le=Le.slice(1,-1)),j(_,{href:Le&&Le.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},_[0],this.lexer)}},le.reflink=function(q,_){var ge;if((ge=this.rules.inline.reflink.exec(q))||(ge=this.rules.inline.nolink.exec(q))){var me=(ge[2]||ge[1]).replace(/\s+/g," ");if(me=_[me.toLowerCase()],!me||!me.href){var Ae=ge[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return j(ge,me,ge[0],this.lexer)}},le.emStrong=function(q,_,ge){ge===void 0&&(ge="");var me=this.rules.inline.emStrong.lDelim.exec(q);if(me&&!(me[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=me[1]||me[2]||"";if(!Ae||Ae&&(ge===""||this.rules.inline.punctuation.exec(ge))){var ye=me[0].length-1,Re,Le,ze=ye,B=0,V=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,_=_.slice(-1*q.length+ye);(me=V.exec(_))!=null;)if(Re=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Re){if(Le=Re.length,me[3]||me[4]){ze+=Le;continue}else if((me[5]||me[6])&&ye%3&&!((ye+Le)%3)){B+=Le;continue}if(ze-=Le,!(ze>0)){if(Le=Math.min(Le,Le+ze+B),Math.min(ye,Le)%2){var x=q.slice(1,ye+me.index+Le);return{type:"em",raw:q.slice(0,ye+me.index+Le+1),text:x,tokens:this.lexer.inlineTokens(x)}}var Y=q.slice(2,ye+me.index+Le-1);return{type:"strong",raw:q.slice(0,ye+me.index+Le+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}}}}},le.codespan=function(q){var _=this.rules.inline.code.exec(q);if(_){var ge=_[2].replace(/\n/g," "),me=/[^ ]/.test(ge),Ae=/^ /.test(ge)&&/ $/.test(ge);return me&&Ae&&(ge=ge.substring(1,ge.length-1)),ge=E(ge,!0),{type:"codespan",raw:_[0],text:ge}}},le.br=function(q){var _=this.rules.inline.br.exec(q);if(_)return{type:"br",raw:_[0]}},le.del=function(q){var _=this.rules.inline.del.exec(q);if(_)return{type:"del",raw:_[0],text:_[2],tokens:this.lexer.inlineTokens(_[2])}},le.autolink=function(q,_){var ge=this.rules.inline.autolink.exec(q);if(ge){var me,Ae;return ge[2]==="@"?(me=E(this.options.mangle?_(ge[1]):ge[1]),Ae="mailto:"+me):(me=E(ge[1]),Ae=me),{type:"link",raw:ge[0],text:me,href:Ae,tokens:[{type:"text",raw:me,text:me}]}}},le.url=function(q,_){var ge;if(ge=this.rules.inline.url.exec(q)){var me,Ae;if(ge[2]==="@")me=E(this.options.mangle?_(ge[0]):ge[0]),Ae="mailto:"+me;else{var ye;do ye=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(ye!==ge[0]);me=E(ge[0]),ge[1]==="www."?Ae="http://"+me:Ae=me}return{type:"link",raw:ge[0],text:me,href:Ae,tokens:[{type:"text",raw:me,text:me}]}}},le.inlineText=function(q,_){var ge=this.rules.inline.text.exec(q);if(ge){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):E(ge[0]):ge[0]:me=E(this.options.smartypants?_(ge[0]):ge[0]),{type:"text",raw:ge[0],text:me}}},ce}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=i(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=i(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=i(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=i(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=i(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=i(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=g({},N),N.gfm=g({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=i(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=i(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=g({},N.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=i(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=i(N._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=i(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=i(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=i(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=i(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=i(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=i(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=i(A.reflink).replace("label",A._label).replace("ref",N._label).getRegex(),A.nolink=i(A.nolink).replace("ref",N._label).getRegex(),A.reflinkSearch=i(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=g({},A),A.pedantic=g({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=g({},A.normal,{escape:i(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=i(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=g({},A.gfm,{br:i(A.br).replace("{2,}","*").getRegex(),text:i(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ce){var le="",de,q,_=ce.length;for(de=0;de<_;de++)q=ce.charCodeAt(de),Math.random()>.5&&(q="x"+q.toString(16)),le+="&#"+q+";";return le}var G=function(){function ce(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||re.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var q={block:N.normal,inline:A.normal};this.options.pedantic?(q.block=N.pedantic,q.inline=A.pedantic):this.options.gfm&&(q.block=N.gfm,this.options.breaks?q.inline=A.breaks:q.inline=A.gfm),this.tokenizer.rules=q}ce.lex=function(q,_){var ge=new ce(_);return ge.lex(q)},ce.lexInline=function(q,_){var ge=new ce(_);return ge.inlineTokens(q)};var le=ce.prototype;return le.lex=function(q){q=q.replace(/\r\n|\r/g,`
`),this.blockTokens(q,this.tokens);for(var _;_=this.inlineQueue.shift();)this.inlineTokens(_.src,_.tokens);return this.tokens},le.blockTokens=function(q,_){var ge=this;_===void 0&&(_=[]),this.options.pedantic?q=q.replace(/\t/g,"    ").replace(/^ +$/gm,""):q=q.replace(/^( *)(\t+)/gm,function(ze,B,V){return B+"    ".repeat(V.length)});for(var me,Ae,ye,Re;q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(me=ze.call({lexer:ge},q,_))?(q=q.substring(me.raw.length),_.push(me),!0):!1}))){if(me=this.tokenizer.space(q)){q=q.substring(me.raw.length),me.raw.length===1&&_.length>0?_[_.length-1].raw+=`
`:_.push(me);continue}if(me=this.tokenizer.code(q)){q=q.substring(me.raw.length),Ae=_[_.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+me.raw,Ae.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):_.push(me);continue}if(me=this.tokenizer.fences(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.heading(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.hr(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.blockquote(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.list(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.html(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.def(q)){q=q.substring(me.raw.length),Ae=_[_.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+me.raw,Ae.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.lheading(q)){q=q.substring(me.raw.length),_.push(me);continue}if(ye=q,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,B=q.slice(1),V=void 0;ge.options.extensions.startBlock.forEach(function(x){V=x.call({lexer:this},B),typeof V=="number"&&V>=0&&(ze=Math.min(ze,V))}),ze<1/0&&ze>=0&&(ye=q.substring(0,ze+1))}(),this.state.top&&(me=this.tokenizer.paragraph(ye))){Ae=_[_.length-1],Re&&Ae.type==="paragraph"?(Ae.raw+=`
`+me.raw,Ae.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):_.push(me),Re=ye.length!==q.length,q=q.substring(me.raw.length);continue}if(me=this.tokenizer.text(q)){q=q.substring(me.raw.length),Ae=_[_.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+me.raw,Ae.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):_.push(me);continue}if(q){var Le="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return this.state.top=!0,_},le.inline=function(q,_){return _===void 0&&(_=[]),this.inlineQueue.push({src:q,tokens:_}),_},le.inlineTokens=function(q,_){var ge=this;_===void 0&&(_=[]);var me,Ae,ye,Re=q,Le,ze,B;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Le=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)V.includes(Le[0].slice(Le[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,Le.index)+"["+P("a",Le[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Le=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,Le.index)+"["+P("a",Le[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Le=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,Le.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;)if(ze||(B=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(me=Y.call({lexer:ge},q,_))?(q=q.substring(me.raw.length),_.push(me),!0):!1}))){if(me=this.tokenizer.escape(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.tag(q)){q=q.substring(me.raw.length),Ae=_[_.length-1],Ae&&me.type==="text"&&Ae.type==="text"?(Ae.raw+=me.raw,Ae.text+=me.text):_.push(me);continue}if(me=this.tokenizer.link(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(me.raw.length),Ae=_[_.length-1],Ae&&me.type==="text"&&Ae.type==="text"?(Ae.raw+=me.raw,Ae.text+=me.text):_.push(me);continue}if(me=this.tokenizer.emStrong(q,Re,B)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.codespan(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.br(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.del(q)){q=q.substring(me.raw.length),_.push(me);continue}if(me=this.tokenizer.autolink(q,F)){q=q.substring(me.raw.length),_.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(q,F))){q=q.substring(me.raw.length),_.push(me);continue}if(ye=q,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=1/0,$e=q.slice(1),ve=void 0;ge.options.extensions.startInline.forEach(function(Te){ve=Te.call({lexer:this},$e),typeof ve=="number"&&ve>=0&&(Y=Math.min(Y,ve))}),Y<1/0&&Y>=0&&(ye=q.substring(0,Y+1))}(),me=this.tokenizer.inlineText(ye,T)){q=q.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(B=me.raw.slice(-1)),ze=!0,Ae=_[_.length-1],Ae&&Ae.type==="text"?(Ae.raw+=me.raw,Ae.text+=me.text):_.push(me);continue}if(q){var x="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return _},D(ce,null,[{key:"rules",get:function(){return{block:N,inline:A}}}]),ce}(),K=function(){function ce(de){this.options=de||re.defaults}var le=ce.prototype;return le.code=function(q,_,ge){var me=(_||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(q,me);Ae!=null&&Ae!==q&&(ge=!0,q=Ae)}return q=q.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+E(me,!0)+'">'+(ge?q:E(q,!0))+`</code></pre>
`:"<pre><code>"+(ge?q:E(q,!0))+`</code></pre>
`},le.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},le.html=function(q){return q},le.heading=function(q,_,ge,me){if(this.options.headerIds){var Ae=this.options.headerPrefix+me.slug(ge);return"<h"+_+' id="'+Ae+'">'+q+"</h"+_+`>
`}return"<h"+_+">"+q+"</h"+_+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(q,_,ge){var me=_?"ol":"ul",Ae=_&&ge!==1?' start="'+ge+'"':"";return"<"+me+Ae+`>
`+q+"</"+me+`>
`},le.listitem=function(q){return"<li>"+q+`</li>
`},le.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(q){return"<p>"+q+`</p>
`},le.table=function(q,_){return _&&(_="<tbody>"+_+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+_+`</table>
`},le.tablerow=function(q){return`<tr>
`+q+`</tr>
`},le.tablecell=function(q,_){var ge=_.header?"th":"td",me=_.align?"<"+ge+' align="'+_.align+'">':"<"+ge+">";return me+q+("</"+ge+`>
`)},le.strong=function(q){return"<strong>"+q+"</strong>"},le.em=function(q){return"<em>"+q+"</em>"},le.codespan=function(q){return"<code>"+q+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(q){return"<del>"+q+"</del>"},le.link=function(q,_,ge){if(q=a(this.options.sanitize,this.options.baseUrl,q),q===null)return ge;var me='<a href="'+E(q)+'"';return _&&(me+=' title="'+_+'"'),me+=">"+ge+"</a>",me},le.image=function(q,_,ge){if(q=a(this.options.sanitize,this.options.baseUrl,q),q===null)return ge;var me='<img src="'+q+'" alt="'+ge+'"';return _&&(me+=' title="'+_+'"'),me+=this.options.xhtml?"/>":">",me},le.text=function(q){return q},ce}(),X=function(){function ce(){}var le=ce.prototype;return le.strong=function(q){return q},le.em=function(q){return q},le.codespan=function(q){return q},le.del=function(q){return q},le.html=function(q){return q},le.text=function(q){return q},le.link=function(q,_,ge){return""+ge},le.image=function(q,_,ge){return""+ge},le.br=function(){return""},ce}(),Q=function(){function ce(){this.seen={}}var le=ce.prototype;return le.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(q,_){var ge=q,me=0;if(this.seen.hasOwnProperty(ge)){me=this.seen[q];do me++,ge=q+"-"+me;while(this.seen.hasOwnProperty(ge))}return _||(this.seen[q]=me,this.seen[ge]=0),ge},le.slug=function(q,_){_===void 0&&(_={});var ge=this.serialize(q);return this.getNextSafeSlug(ge,_.dryrun)},ce}(),Z=function(){function ce(de){this.options=de||re.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Q}ce.parse=function(q,_){var ge=new ce(_);return ge.parse(q)},ce.parseInline=function(q,_){var ge=new ce(_);return ge.parseInline(q)};var le=ce.prototype;return le.parse=function(q,_){_===void 0&&(_=!0);var ge="",me,Ae,ye,Re,Le,ze,B,V,x,Y,$e,ve,Te,Ve,Qe,tt,at,dt,ot,rt=q.length;for(me=0;me<rt;me++){if(Y=q[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(ot=this.options.extensions.renderers[Y.type].call({parser:this},Y),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){ge+=ot||"";continue}switch(Y.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,b(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(V="",B="",Re=Y.header.length,Ae=0;Ae<Re;Ae++)B+=this.renderer.tablecell(this.parseInline(Y.header[Ae].tokens),{header:!0,align:Y.align[Ae]});for(V+=this.renderer.tablerow(B),x="",Re=Y.rows.length,Ae=0;Ae<Re;Ae++){for(ze=Y.rows[Ae],B="",Le=ze.length,ye=0;ye<Le;ye++)B+=this.renderer.tablecell(this.parseInline(ze[ye].tokens),{header:!1,align:Y.align[ye]});x+=this.renderer.tablerow(B)}ge+=this.renderer.table(V,x);continue}case"blockquote":{x=this.parse(Y.tokens),ge+=this.renderer.blockquote(x);continue}case"list":{for($e=Y.ordered,ve=Y.start,Te=Y.loose,Re=Y.items.length,x="",Ae=0;Ae<Re;Ae++)Qe=Y.items[Ae],tt=Qe.checked,at=Qe.task,Ve="",Qe.task&&(dt=this.renderer.checkbox(tt),Te?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=dt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=dt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:dt}):Ve+=dt),Ve+=this.parse(Qe.tokens,Te),x+=this.renderer.listitem(Ve,at,tt);ge+=this.renderer.list(x,$e,ve);continue}case"html":{ge+=this.renderer.html(Y.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(x=Y.tokens?this.parseInline(Y.tokens):Y.text;me+1<rt&&q[me+1].type==="text";)Y=q[++me],x+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);ge+=_?this.renderer.paragraph(x):x;continue}default:{var Pe='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return ge},le.parseInline=function(q,_){_=_||this.renderer;var ge="",me,Ae,ye,Re=q.length;for(me=0;me<Re;me++){if(Ae=q[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(ye=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),ye!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){ge+=ye||"";continue}switch(Ae.type){case"escape":{ge+=_.text(Ae.text);break}case"html":{ge+=_.html(Ae.text);break}case"link":{ge+=_.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,_));break}case"image":{ge+=_.image(Ae.href,Ae.title,Ae.text);break}case"strong":{ge+=_.strong(this.parseInline(Ae.tokens,_));break}case"em":{ge+=_.em(this.parseInline(Ae.tokens,_));break}case"codespan":{ge+=_.codespan(Ae.text);break}case"br":{ge+=_.br();break}case"del":{ge+=_.del(this.parseInline(Ae.tokens,_));break}case"text":{ge+=_.text(Ae.text);break}default:{var Le='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return ge},ce}();function ie(ce,le,de){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof le=="function"&&(de=le,le=null),le=g({},ie.defaults,le||{}),y(le),de){var q=le.highlight,_;try{_=G.lex(ce,le)}catch(Re){return de(Re)}var ge=function(Le){var ze;if(!Le)try{le.walkTokens&&ie.walkTokens(_,le.walkTokens),ze=Z.parse(_,le)}catch(B){Le=B}return le.highlight=q,Le?de(Le):de(null,ze)};if(!q||q.length<3||(delete le.highlight,!_.length))return ge();var me=0;ie.walkTokens(_,function(Re){Re.type==="code"&&(me++,setTimeout(function(){q(Re.text,Re.lang,function(Le,ze){if(Le)return ge(Le);ze!=null&&ze!==Re.text&&(Re.text=ze,Re.escaped=!0),me--,me===0&&ge()})},0))}),me===0&&ge();return}function Ae(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Re.message+"",!0)+"</pre>";throw Re}try{var ye=G.lex(ce,le);if(le.walkTokens){if(le.async)return Promise.all(ie.walkTokens(ye,le.walkTokens)).then(function(){return Z.parse(ye,le)}).catch(Ae);ie.walkTokens(ye,le.walkTokens)}return Z.parse(ye,le)}catch(Re){Ae(Re)}}ie.options=ie.setOptions=function(ce){return g(ie.defaults,ce),w(ie.defaults),ie},ie.getDefaults=L,ie.defaults=re.defaults,ie.use=function(){for(var ce=arguments.length,le=new Array(ce),de=0;de<ce;de++)le[de]=arguments[de];var q=g.apply(void 0,[{}].concat(le)),_=ie.defaults.extensions||{renderers:{},childTokens:{}},ge;le.forEach(function(me){if(me.extensions&&(ge=!0,me.extensions.forEach(function(ye){if(!ye.name)throw new Error("extension name required");if(ye.renderer){var Re=_.renderers?_.renderers[ye.name]:null;Re?_.renderers[ye.name]=function(){for(var Le=arguments.length,ze=new Array(Le),B=0;B<Le;B++)ze[B]=arguments[B];var V=ye.renderer.apply(this,ze);return V===!1&&(V=Re.apply(this,ze)),V}:_.renderers[ye.name]=ye.renderer}if(ye.tokenizer){if(!ye.level||ye.level!=="block"&&ye.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");_[ye.level]?_[ye.level].unshift(ye.tokenizer):_[ye.level]=[ye.tokenizer],ye.start&&(ye.level==="block"?_.startBlock?_.startBlock.push(ye.start):_.startBlock=[ye.start]:ye.level==="inline"&&(_.startInline?_.startInline.push(ye.start):_.startInline=[ye.start]))}ye.childTokens&&(_.childTokens[ye.name]=ye.childTokens)})),me.renderer&&function(){var ye=ie.defaults.renderer||new K,Re=function(B){var V=ye[B];ye[B]=function(){for(var x=arguments.length,Y=new Array(x),$e=0;$e<x;$e++)Y[$e]=arguments[$e];var ve=me.renderer[B].apply(ye,Y);return ve===!1&&(ve=V.apply(ye,Y)),ve}};for(var Le in me.renderer)Re(Le);q.renderer=ye}(),me.tokenizer&&function(){var ye=ie.defaults.tokenizer||new z,Re=function(B){var V=ye[B];ye[B]=function(){for(var x=arguments.length,Y=new Array(x),$e=0;$e<x;$e++)Y[$e]=arguments[$e];var ve=me.tokenizer[B].apply(ye,Y);return ve===!1&&(ve=V.apply(ye,Y)),ve}};for(var Le in me.tokenizer)Re(Le);q.tokenizer=ye}(),me.walkTokens){var Ae=ie.defaults.walkTokens;q.walkTokens=function(ye){var Re=[];return Re.push(me.walkTokens.call(this,ye)),Ae&&(Re=Re.concat(Ae.call(this,ye))),Re}}ge&&(q.extensions=_),ie.setOptions(q)})},ie.walkTokens=function(ce,le){for(var de=[],q=function(){var Ae=ge.value;switch(de=de.concat(le.call(ie,Ae)),Ae.type){case"table":{for(var ye=R(Ae.header),Re;!(Re=ye()).done;){var Le=Re.value;de=de.concat(ie.walkTokens(Le.tokens,le))}for(var ze=R(Ae.rows),B;!(B=ze()).done;)for(var V=B.value,x=R(V),Y;!(Y=x()).done;){var $e=Y.value;de=de.concat(ie.walkTokens($e.tokens,le))}break}case"list":{de=de.concat(ie.walkTokens(Ae.items,le));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[Ae.type]?ie.defaults.extensions.childTokens[Ae.type].forEach(function(ve){de=de.concat(ie.walkTokens(Ae[ve],le))}):Ae.tokens&&(de=de.concat(ie.walkTokens(Ae.tokens,le)))}},_=R(ce),ge;!(ge=_()).done;)q();return de},ie.parseInline=function(ce,le){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");le=g({},ie.defaults,le||{}),y(le);try{var de=G.lexInline(ce,le);return le.walkTokens&&ie.walkTokens(de,le.walkTokens),Z.parseInline(de,le)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(q.message+"",!0)+"</pre>";throw q}},ie.Parser=Z,ie.parser=Z.parse,ie.Renderer=K,ie.TextRenderer=X,ie.Lexer=G,ie.lexer=G.lex,ie.Tokenizer=z,ie.Slugger=Q,ie.parse=ie;var ee=ie.options,we=ie.setOptions,ue=ie.use,ae=ie.walkTokens,H=ie.parseInline,fe=ie,he=Z.parse,se=G.lex;re.Lexer=G,re.Parser=Z,re.Renderer=K,re.Slugger=Q,re.TextRenderer=X,re.Tokenizer=z,re.getDefaults=L,re.lexer=se,re.marked=ie,re.options=ee,re.parse=fe,re.parseInline=H,re.parser=he,re.setOptions=we,re.use=ue,re.walkTokens=ae,Object.defineProperty(re,"__esModule",{value:!0})}),define(Se[163],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0;function D(u){const b=R(u);if(b&&b.length>0)return new Uint32Array(b)}e.$3j=D;let O=0;const f=new Uint32Array(10);function R(u){if(O=0,L(u,I,4352),O>0||(L(u,p,4449),O>0)||(L(u,S,4520),O>0)||(L(u,E,12593),O))return f.subarray(0,O);if(u>=44032&&u<=55203){const b=u-44032,o=b%588,i=Math.floor(b/588),n=Math.floor(o/28),s=o%28-1;if(i<I.length?L(i,I,0):4352+i-12593<E.length&&L(4352+i,E,12593),n<p.length?L(n,p,0):4449+n-12593<E.length&&L(4449+n-12593,E,12593),s>=0&&(s<S.length?L(s,S,0):4520+s-12593<E.length&&L(4520+s-12593,E,12593)),O>0)return f.subarray(0,O)}}function L(u,b,o){u>=o&&u<o+b.length&&w(b[u-o])}function w(u){u!==0&&(f[O++]=u&255,u>>8&&(f[O++]=u>>8&255),u>>16&&(f[O++]=u>>16&255))}var $;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(k||(k={}));var M;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(M||(M={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),E=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[76],De([1,0,28]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=void 0;const O=new D.$Dc(1e4);function f(k){return $(k,"NFC",O)}e.$Sl=f;const R=new D.$Dc(1e4);function L(k){return $(k,"NFD",R)}e.$Tl=L;const w=/[^\u0000-\u0080]/;function $(k,M,I){if(!k)return k;const p=I.get(k);if(p)return p;let S;return w.test(k)?S=k.normalize(M):S=k,I.set(k,S),S}e.$Ul=function(){const k=/[\u0300-\u036f]/g;return function(M){return L(M).replace(k,"")}}()}),define(Se[123],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.rot=e.$gm=void 0;function D(w,$,k){return Math.min(Math.max(w,$),k)}e.$gm=D;function O(w,$){return($+w%$)%$}e.rot=O;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$im=f;class R{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$jm=R;class L{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$km=L}),function(){function re(f){const R=[];typeof f=="number"&&R.push("code/timeOrigin",f);function L($){R.push($,Date.now())}function w(){const $=[];for(let k=0;k<R.length;k+=2)$.push({name:R[k],startTime:R[k+1]});return $}return{mark:L,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(f+L.startTime)});return R}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function D(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),define(Se[9],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D=e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.$b=e.Platform=e.$a=void 0,e.$a="en";let D=!1,O=!1,f=!1,R=!1,L=!1,w=!1,$=!1,k=!1,M=!1,I=!1,p,S=e.$a,E=e.$a,u,b;const o=globalThis;let i;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?i=o.vscode.process:typeof process<"u"&&(i=process);const n=typeof i?.versions?.electron=="string",s=n&&i?.type==="renderer";if(typeof i=="object"){D=i.platform==="win32",O=i.platform==="darwin",f=i.platform==="linux",R=f&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,$=n,M=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$a,S=e.$a;const v=i.env.VSCODE_NLS_CONFIG;if(v)try{const m=JSON.parse(v),y=m.availableLanguages["*"];p=m.locale,E=m.osLocale,S=y||e.$a,u=m._translationsConfigFile}catch{}L=!0}else if(typeof navigator=="object"&&!s){b=navigator.userAgent,D=b.indexOf("Windows")>=0,O=b.indexOf("Macintosh")>=0,k=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=b.indexOf("Linux")>=0,I=b?.indexOf("Mobi")>=0,w=!0,p=e.$a,S=p,E=navigator.language;const v=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),m=v&&v.getAttribute("data-settings");if(m)try{const y=JSON.parse(m),P=y.availableLanguages["*"];p=y.locale,E=y.osLocale,S=P||e.$a,u=y._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var a;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(a||(e.Platform=a={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$b=t;let d=0;O?d=1:D?d=3:f&&(d=2),e.$c=D,e.$d=O,e.$e=f,e.$f=R,e.$g=L,e.$h=$,e.$i=w,e.$j=w&&typeof o.importScripts=="function",e.$k=e.$j?o.origin:void 0,e.$l=k,e.$m=I,e.$n=M,e.$o=d,e.$p=b,e.$q=S;var l;(function(v){function m(){return e.$q}v.value=m;function y(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}v.isDefaultVariant=y;function P(){return e.$q==="en"}v.isDefault=P})(l||(e.Language=l={})),e.$r=p,e.$s=E,e.$t=u,e.$u=typeof o.postMessage=="function"&&!o.importScripts,e.$v=(()=>{if(e.$u){const v=[];o.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let P=0,j=v.length;P<j;P++){const U=v[P];if(U.id===y.data.vscodeScheduleAsyncWork){v.splice(P,1),U.callback();return}}});let m=0;return y=>{const P=++m;v.push({id:P,callback:y}),o.postMessage({vscodeScheduleAsyncWork:P},"*")}}return v=>setTimeout(v)})();var r;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=O||k?2:D?1:3;let c=!0,h=!1;function g(){if(!h){h=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,c=new Uint16Array(v.buffer)[0]===513}return c}e.$x=g,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function C(v){return parseFloat(v)>=20}e.$D=C}),define(Se[49],De([1,0,9]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const R=f.process;O={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.$c?"win32":D.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(Se[17],De([1,0,49]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,f=97,R=90,L=122,w=46,$=47,k=92,M=58,I=63;class p extends Error{constructor(d,l,r){let c;typeof l=="string"&&l.indexOf("not ")===0?(c="must not be",l=l.replace(/^not /,"")):c="must be";const h=d.indexOf(".")!==-1?"property":"argument";let g=`The "${d}" ${h} ${c} of type ${l}`;g+=`. Received type ${typeof r}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,d){if(t===null||typeof t!="object")throw new p(d,"Object",t)}function E(t,d){if(typeof t!="string")throw new p(d,"string",t)}const u=D.$dc==="win32";function b(t){return t===$||t===k}function o(t){return t===$}function i(t){return t>=O&&t<=R||t>=f&&t<=L}function n(t,d,l,r){let c="",h=0,g=-1,C=0,v=0;for(let m=0;m<=t.length;++m){if(m<t.length)v=t.charCodeAt(m);else{if(r(v))break;v=$}if(r(v)){if(!(g===m-1||C===1))if(C===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==w||c.charCodeAt(c.length-2)!==w){if(c.length>2){const y=c.lastIndexOf(l);y===-1?(c="",h=0):(c=c.slice(0,y),h=c.length-1-c.lastIndexOf(l)),g=m,C=0;continue}else if(c.length!==0){c="",h=0,g=m,C=0;continue}}d&&(c+=c.length>0?`${l}..`:"..",h=2)}else c.length>0?c+=`${l}${t.slice(g+1,m)}`:c=t.slice(g+1,m),h=m-g-1;g=m,C=0}else v===w&&C!==-1?++C:C=-1}return c}function s(t,d){S(d,"pathObject");const l=d.dir||d.root,r=d.base||`${d.name||""}${d.ext||""}`;return l?l===d.root?`${l}${r}`:`${l}${t}${r}`:r}e.$fc={resolve(...t){let d="",l="",r=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],E(h,"path"),h.length===0)continue}else d.length===0?h=D.cwd():(h=D.env[`=${d}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==d.toLowerCase()&&h.charCodeAt(2)===k)&&(h=`${d}\\`));const g=h.length;let C=0,v="",m=!1;const y=h.charCodeAt(0);if(g===1)b(y)&&(C=1,m=!0);else if(b(y))if(m=!0,b(h.charCodeAt(1))){let P=2,j=P;for(;P<g&&!b(h.charCodeAt(P));)P++;if(P<g&&P!==j){const U=h.slice(j,P);for(j=P;P<g&&b(h.charCodeAt(P));)P++;if(P<g&&P!==j){for(j=P;P<g&&!b(h.charCodeAt(P));)P++;(P===g||P!==j)&&(v=`\\\\${U}\\${h.slice(j,P)}`,C=P)}}}else C=1;else i(y)&&h.charCodeAt(1)===M&&(v=h.slice(0,2),C=2,g>2&&b(h.charCodeAt(2))&&(m=!0,C=3));if(v.length>0)if(d.length>0){if(v.toLowerCase()!==d.toLowerCase())continue}else d=v;if(r){if(d.length>0)break}else if(l=`${h.slice(C)}\\${l}`,r=m,m&&d.length>0)break}return l=n(l,!r,"\\",b),r?`${d}\\${l}`:`${d}${l}`||"."},normalize(t){E(t,"path");const d=t.length;if(d===0)return".";let l=0,r,c=!1;const h=t.charCodeAt(0);if(d===1)return o(h)?"\\":t;if(b(h))if(c=!0,b(t.charCodeAt(1))){let C=2,v=C;for(;C<d&&!b(t.charCodeAt(C));)C++;if(C<d&&C!==v){const m=t.slice(v,C);for(v=C;C<d&&b(t.charCodeAt(C));)C++;if(C<d&&C!==v){for(v=C;C<d&&!b(t.charCodeAt(C));)C++;if(C===d)return`\\\\${m}\\${t.slice(v)}\\`;C!==v&&(r=`\\\\${m}\\${t.slice(v,C)}`,l=C)}}}else l=1;else i(h)&&t.charCodeAt(1)===M&&(r=t.slice(0,2),l=2,d>2&&b(t.charCodeAt(2))&&(c=!0,l=3));let g=l<d?n(t.slice(l),!c,"\\",b):"";return g.length===0&&!c&&(g="."),g.length>0&&b(t.charCodeAt(d-1))&&(g+="\\"),r===void 0?c?`\\${g}`:g:c?`${r}\\${g}`:`${r}${g}`},isAbsolute(t){E(t,"path");const d=t.length;if(d===0)return!1;const l=t.charCodeAt(0);return b(l)||d>2&&i(l)&&t.charCodeAt(1)===M&&b(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let d,l;for(let h=0;h<t.length;++h){const g=t[h];E(g,"path"),g.length>0&&(d===void 0?d=l=g:d+=`\\${g}`)}if(d===void 0)return".";let r=!0,c=0;if(typeof l=="string"&&b(l.charCodeAt(0))){++c;const h=l.length;h>1&&b(l.charCodeAt(1))&&(++c,h>2&&(b(l.charCodeAt(2))?++c:r=!1))}if(r){for(;c<d.length&&b(d.charCodeAt(c));)c++;c>=2&&(d=`\\${d.slice(c)}`)}return e.$fc.normalize(d)},relative(t,d){if(E(t,"from"),E(d,"to"),t===d)return"";const l=e.$fc.resolve(t),r=e.$fc.resolve(d);if(l===r||(t=l.toLowerCase(),d=r.toLowerCase(),t===d))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===k;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===k;)h--;const g=h-c;let C=0;for(;C<d.length&&d.charCodeAt(C)===k;)C++;let v=d.length;for(;v-1>C&&d.charCodeAt(v-1)===k;)v--;const m=v-C,y=g<m?g:m;let P=-1,j=0;for(;j<y;j++){const z=t.charCodeAt(c+j);if(z!==d.charCodeAt(C+j))break;z===k&&(P=j)}if(j!==y){if(P===-1)return r}else{if(m>y){if(d.charCodeAt(C+j)===k)return r.slice(C+j+1);if(j===2)return r.slice(C+j)}g>y&&(t.charCodeAt(c+j)===k?P=j:j===2&&(P=3)),P===-1&&(P=0)}let U="";for(j=c+P+1;j<=h;++j)(j===h||t.charCodeAt(j)===k)&&(U+=U.length===0?"..":"\\..");return C+=P,U.length>0?`${U}${r.slice(C,v)}`:(r.charCodeAt(C)===k&&++C,r.slice(C,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const d=e.$fc.resolve(t);if(d.length<=2)return t;if(d.charCodeAt(0)===k){if(d.charCodeAt(1)===k){const l=d.charCodeAt(2);if(l!==I&&l!==w)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(i(d.charCodeAt(0))&&d.charCodeAt(1)===M&&d.charCodeAt(2)===k)return`\\\\?\\${d}`;return t},dirname(t){E(t,"path");const d=t.length;if(d===0)return".";let l=-1,r=0;const c=t.charCodeAt(0);if(d===1)return b(c)?t:".";if(b(c)){if(l=r=1,b(t.charCodeAt(1))){let C=2,v=C;for(;C<d&&!b(t.charCodeAt(C));)C++;if(C<d&&C!==v){for(v=C;C<d&&b(t.charCodeAt(C));)C++;if(C<d&&C!==v){for(v=C;C<d&&!b(t.charCodeAt(C));)C++;if(C===d)return t;C!==v&&(l=r=C+1)}}}}else i(c)&&t.charCodeAt(1)===M&&(l=d>2&&b(t.charCodeAt(2))?3:2,r=l);let h=-1,g=!0;for(let C=d-1;C>=r;--C)if(b(t.charCodeAt(C))){if(!g){h=C;break}}else g=!1;if(h===-1){if(l===-1)return".";h=l}return t.slice(0,h)},basename(t,d){d!==void 0&&E(d,"ext"),E(t,"path");let l=0,r=-1,c=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===M&&(l=2),d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let g=d.length-1,C=-1;for(h=t.length-1;h>=l;--h){const v=t.charCodeAt(h);if(b(v)){if(!c){l=h+1;break}}else C===-1&&(c=!1,C=h+1),g>=0&&(v===d.charCodeAt(g)?--g===-1&&(r=h):(g=-1,r=C))}return l===r?r=C:r===-1&&(r=t.length),t.slice(l,r)}for(h=t.length-1;h>=l;--h)if(b(t.charCodeAt(h))){if(!c){l=h+1;break}}else r===-1&&(c=!1,r=h+1);return r===-1?"":t.slice(l,r)},extname(t){E(t,"path");let d=0,l=-1,r=0,c=-1,h=!0,g=0;t.length>=2&&t.charCodeAt(1)===M&&i(t.charCodeAt(0))&&(d=r=2);for(let C=t.length-1;C>=d;--C){const v=t.charCodeAt(C);if(b(v)){if(!h){r=C+1;break}continue}c===-1&&(h=!1,c=C+1),v===w?l===-1?l=C:g!==1&&(g=1):l!==-1&&(g=-1)}return l===-1||c===-1||g===0||g===1&&l===c-1&&l===r+1?"":t.slice(l,c)},format:s.bind(null,"\\"),parse(t){E(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const l=t.length;let r=0,c=t.charCodeAt(0);if(l===1)return b(c)?(d.root=d.dir=t,d):(d.base=d.name=t,d);if(b(c)){if(r=1,b(t.charCodeAt(1))){let P=2,j=P;for(;P<l&&!b(t.charCodeAt(P));)P++;if(P<l&&P!==j){for(j=P;P<l&&b(t.charCodeAt(P));)P++;if(P<l&&P!==j){for(j=P;P<l&&!b(t.charCodeAt(P));)P++;P===l?r=P:P!==j&&(r=P+1)}}}}else if(i(c)&&t.charCodeAt(1)===M){if(l<=2)return d.root=d.dir=t,d;if(r=2,b(t.charCodeAt(2))){if(l===3)return d.root=d.dir=t,d;r=3}}r>0&&(d.root=t.slice(0,r));let h=-1,g=r,C=-1,v=!0,m=t.length-1,y=0;for(;m>=r;--m){if(c=t.charCodeAt(m),b(c)){if(!v){g=m+1;break}continue}C===-1&&(v=!1,C=m+1),c===w?h===-1?h=m:y!==1&&(y=1):h!==-1&&(y=-1)}return C!==-1&&(h===-1||y===0||y===1&&h===C-1&&h===g+1?d.base=d.name=t.slice(g,C):(d.name=t.slice(g,h),d.base=t.slice(g,C),d.ext=t.slice(h,C))),g>0&&g!==r?d.dir=t.slice(0,g-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(u){const t=/\\/g;return()=>{const d=D.cwd().replace(t,"/");return d.slice(d.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let d="",l=!1;for(let r=t.length-1;r>=-1&&!l;r--){const c=r>=0?t[r]:a();E(c,"path"),c.length!==0&&(d=`${c}/${d}`,l=c.charCodeAt(0)===$)}return d=n(d,!l,"/",o),l?`/${d}`:d.length>0?d:"."},normalize(t){if(E(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===$,l=t.charCodeAt(t.length-1)===$;return t=n(t,!d,"/",o),t.length===0?d?"/":l?"./":".":(l&&(t+="/"),d?`/${t}`:t)},isAbsolute(t){return E(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let d;for(let l=0;l<t.length;++l){const r=t[l];E(r,"path"),r.length>0&&(d===void 0?d=r:d+=`/${r}`)}return d===void 0?".":e.$gc.normalize(d)},relative(t,d){if(E(t,"from"),E(d,"to"),t===d||(t=e.$gc.resolve(t),d=e.$gc.resolve(d),t===d))return"";const l=1,r=t.length,c=r-l,h=1,g=d.length-h,C=c<g?c:g;let v=-1,m=0;for(;m<C;m++){const P=t.charCodeAt(l+m);if(P!==d.charCodeAt(h+m))break;P===$&&(v=m)}if(m===C)if(g>C){if(d.charCodeAt(h+m)===$)return d.slice(h+m+1);if(m===0)return d.slice(h+m)}else c>C&&(t.charCodeAt(l+m)===$?v=m:m===0&&(v=0));let y="";for(m=l+v+1;m<=r;++m)(m===r||t.charCodeAt(m)===$)&&(y+=y.length===0?"..":"/..");return`${y}${d.slice(h+v)}`},toNamespacedPath(t){return t},dirname(t){if(E(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===$;let l=-1,r=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===$){if(!r){l=c;break}}else r=!1;return l===-1?d?"/":".":d&&l===1?"//":t.slice(0,l)},basename(t,d){d!==void 0&&E(d,"ext"),E(t,"path");let l=0,r=-1,c=!0,h;if(d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let g=d.length-1,C=-1;for(h=t.length-1;h>=0;--h){const v=t.charCodeAt(h);if(v===$){if(!c){l=h+1;break}}else C===-1&&(c=!1,C=h+1),g>=0&&(v===d.charCodeAt(g)?--g===-1&&(r=h):(g=-1,r=C))}return l===r?r=C:r===-1&&(r=t.length),t.slice(l,r)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!c){l=h+1;break}}else r===-1&&(c=!1,r=h+1);return r===-1?"":t.slice(l,r)},extname(t){E(t,"path");let d=-1,l=0,r=-1,c=!0,h=0;for(let g=t.length-1;g>=0;--g){const C=t.charCodeAt(g);if(C===$){if(!c){l=g+1;break}continue}r===-1&&(c=!1,r=g+1),C===w?d===-1?d=g:h!==1&&(h=1):d!==-1&&(h=-1)}return d===-1||r===-1||h===0||h===1&&d===r-1&&d===l+1?"":t.slice(d,r)},format:s.bind(null,"/"),parse(t){E(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const l=t.charCodeAt(0)===$;let r;l?(d.root="/",r=1):r=0;let c=-1,h=0,g=-1,C=!0,v=t.length-1,m=0;for(;v>=r;--v){const y=t.charCodeAt(v);if(y===$){if(!C){h=v+1;break}continue}g===-1&&(C=!1,g=v+1),y===w?c===-1?c=v:m!==1&&(m=1):c!==-1&&(m=-1)}if(g!==-1){const y=h===0&&l?1:h;c===-1||m===0||m===1&&c===g-1&&c===h+1?d.base=d.name=t.slice(y,g):(d.name=t.slice(y,c),d.base=t.slice(y,g),d.ext=t.slice(c,g))}return h>0?d.dir=t.slice(0,h-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Se[124],De([1,0,44,17]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=void 0;const f=new D.$V(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),R=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(C,v,m=!1){const y=C||"",P=v||"",j=f.value.collator.compare(y,P);return f.value.collatorIsNumeric&&j===0&&y!==P?y<P?-1:1:j}e.$Uq=w;function $(C,v){const m=R.value.collator;return C=C||"",v=v||"",s(m,C,v)}e.$Vq=$;function k(C,v){const m=R.value.collator;return C=C||"",v=v||"",l(C,v)||s(m,C,v)}e.$Wq=k;function M(C,v){const m=R.value.collator;return C=C||"",v=v||"",d(C,v)||s(m,C,v)}e.$Xq=M;function I(C,v){return C=C||"",v=v||"",C===v?0:C<v?-1:1}e.$Yq=I;function p(C,v){const[m,y]=i(C),[P,j]=i(v);let U=f.value.collator.compare(y,j);if(U===0){if(f.value.collatorIsNumeric&&y!==j)return y<j?-1:1;if(U=f.value.collator.compare(m,P),f.value.collatorIsNumeric&&U===0&&m!==P)return m<P?-1:1}return U}e.$Zq=p;function S(C,v){C=C||"",v=v||"";const m=n(C),y=n(v),P=R.value.collator,j=L.value.collator;return s(j,m,y)||s(P,C,v)}e.$1q=S;function E(C,v){C=C||"",v=v||"";const m=n(C),y=n(v),P=R.value.collator,j=L.value.collator;return s(j,m,y)||l(C,v)||s(P,C,v)}e.$2q=E;function u(C,v){C=C||"",v=v||"";const m=n(C),y=n(v),P=R.value.collator,j=L.value.collator;return s(j,m,y)||d(C,v)||s(P,C,v)}e.$3q=u;function b(C,v){C=C||"",v=v||"";const m=n(C).toLowerCase(),y=n(v).toLowerCase();return m!==y?m<y?-1:1:C!==v?C<v?-1:1:0}e.$4q=b;const o=/^(.*?)(\.([^.]*))?$/;function i(C,v=!1){const m=C?o.exec(C):[];let y=[m&&m[1]||"",m&&m[3]||""];return v&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(C){const v=C?o.exec(C):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function s(C,v,m){const y=C.compare(v,m);return y!==0?y:v.length!==m.length?v.length<m.length?-1:1:0}function a(C){const v=C.charAt(0);return v.toLocaleUpperCase()!==v}function t(C){const v=C.charAt(0);return v.toLocaleLowerCase()!==v}function d(C,v){return a(C)&&t(v)?-1:t(C)&&a(v)?1:0}function l(C,v){return t(C)&&a(v)?-1:a(C)&&t(v)?1:0}function r(C,v,m=!1){return m||(C=C&&C.toLowerCase(),v=v&&v.toLowerCase()),C===v?0:C<v?-1:1}function c(C,v,m=!1){const y=C.split(O.sep),P=v.split(O.sep),j=y.length-1,U=P.length-1;let z,N;for(let A=0;;A++){if(z=j===A,N=U===A,z&&N)return w(y[A],P[A],m);if(z)return-1;if(N)return 1;const T=r(y[A],P[A],m);if(T!==0)return T}}e.$5q=c;function h(C,v,m){const y=C.toLowerCase(),P=v.toLowerCase(),j=g(C,v,m);if(j)return j;const U=y.endsWith(m),z=P.endsWith(m);if(U!==z)return U?-1:1;const N=w(y,P);return N!==0?N:y.localeCompare(P)}e.$6q=h;function g(C,v,m){const y=C.toLowerCase(),P=v.toLowerCase(),j=y.startsWith(m),U=P.startsWith(m);if(j!==U)return j?-1:1;if(j&&U){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}e.$7q=g}),define(Se[98],De([1,0,17]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=e.$ss=e.$rs=void 0,e.$rs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(M){const I=(0,D.$oc)(M),p=O[I.toLowerCase()];return p!==void 0?p:L(M)}e.$ss=R;function L(M){const I=(0,D.$oc)(M);return f[I.toLowerCase()]}e.$ts=L;function w(M){for(const I in f)if(f[I]===M)return I}e.$us=w;const $=/^(.+)\/(.+?)(;.+)?$/;function k(M,I){const p=$.exec(M);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:M}e.$vs=k}),define(Se[99],De([1,0,9]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.TerminateResponseCode=e.Source=void 0;var O;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(O||(e.Source=O={}));var f;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function R(w,...$){const k=$.reduce((p,S)=>(p[S]=!0,p),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(w).filter(p=>!k[p]).forEach(p=>{for(let S=0;S<M.length;S++)if(p.search(M[S])!==-1){delete w[p];break}})}e.$4l=R;function L(w){w&&(delete w.DEBUG,D.$d&&delete w.DYLD_LIBRARY_PATH,D.$e&&delete w.LD_PRELOAD)}e.$5l=L}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:re)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function D(O){if(e[O])return e[O].exports;var f=e[O]={i:O,l:!1,exports:{}};return re[O].call(f.exports,f,f.exports,D),f.l=!0,f.exports}return D.m=re,D.c=e,D.d=function(O,f,R){D.o(O,f)||Object.defineProperty(O,f,{enumerable:!0,get:R})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,f){if(1&f&&(O=D(O)),8&f||4&f&&typeof O=="object"&&O&&O.__esModule)return O;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:O}),2&f&&typeof O!="string")for(var L in O)D.d(R,L,function(w){return O[w]}.bind(null,L));return R},D.n=function(O){var f=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(f,"a",f),f},D.o=function(O,f){return Object.prototype.hasOwnProperty.call(O,f)},D.p="",D(D.s=0)}([function(re,e,D){(function(O){var f;e=re.exports=ue,f=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],$=e.src=[],k=0,M=k++;$[M]="0|[1-9]\\d*";var I=k++;$[I]="[0-9]+";var p=k++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=k++;$[S]="("+$[M]+")\\.("+$[M]+")\\.("+$[M]+")";var E=k++;$[E]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var u=k++;$[u]="(?:"+$[M]+"|"+$[p]+")";var b=k++;$[b]="(?:"+$[I]+"|"+$[p]+")";var o=k++;$[o]="(?:-("+$[u]+"(?:\\."+$[u]+")*))";var i=k++;$[i]="(?:-?("+$[b]+"(?:\\."+$[b]+")*))";var n=k++;$[n]="[0-9A-Za-z-]+";var s=k++;$[s]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var a=k++,t="v?"+$[S]+$[o]+"?"+$[s]+"?";$[a]="^"+t+"$";var d="[v=\\s]*"+$[E]+$[i]+"?"+$[s]+"?",l=k++;$[l]="^"+d+"$";var r=k++;$[r]="((?:<|>)?=?)";var c=k++;$[c]=$[I]+"|x|X|\\*";var h=k++;$[h]=$[M]+"|x|X|\\*";var g=k++;$[g]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[o]+")?"+$[s]+"?)?)?";var C=k++;$[C]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[i]+")?"+$[s]+"?)?)?";var v=k++;$[v]="^"+$[r]+"\\s*"+$[g]+"$";var m=k++;$[m]="^"+$[r]+"\\s*"+$[C]+"$";var y=k++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=k++;$[P]="(?:~>?)";var j=k++;$[j]="(\\s*)"+$[P]+"\\s+",w[j]=new RegExp($[j],"g");var U=k++;$[U]="^"+$[P]+$[g]+"$";var z=k++;$[z]="^"+$[P]+$[C]+"$";var N=k++;$[N]="(?:\\^)";var A=k++;$[A]="(\\s*)"+$[N]+"\\s+",w[A]=new RegExp($[A],"g");var T=k++;$[T]="^"+$[N]+$[g]+"$";var F=k++;$[F]="^"+$[N]+$[C]+"$";var G=k++;$[G]="^"+$[r]+"\\s*("+d+")$|^$";var K=k++;$[K]="^"+$[r]+"\\s*("+t+")$|^$";var X=k++;$[X]="(\\s*)"+$[r]+"\\s*("+d+"|"+$[g]+")",w[X]=new RegExp($[X],"g");var Q=k++;$[Q]="^\\s*("+$[g]+")\\s+-\\s+("+$[g]+")\\s*$";var Z=k++;$[Z]="^\\s*("+$[C]+")\\s+-\\s+("+$[C]+")\\s*$";var ie=k++;$[ie]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)f(ee,$[ee]),w[ee]||(w[ee]=new RegExp($[ee]));function we(V,x){if(V instanceof ue)return V;if(typeof V!="string"||V.length>R||!(x?w[l]:w[a]).test(V))return null;try{return new ue(V,x)}catch{return null}}function ue(V,x){if(V instanceof ue){if(V.loose===x)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ue))return new ue(V,x);f("SemVer",V,x),this.loose=x;var Y=V.trim().match(x?w[l]:w[a]);if(!Y)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+Y[1],this.minor=+Y[2],this.patch=+Y[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");Y[4]?this.prerelease=Y[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ve=+$e;if(ve>=0&&ve<L)return ve}return $e}):this.prerelease=[],this.build=Y[5]?Y[5].split("."):[],this.format()}e.parse=we,e.valid=function(V,x){var Y=we(V,x);return Y?Y.version:null},e.clean=function(V,x){var Y=we(V.trim().replace(/^[=v]+/,""),x);return Y?Y.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(V){return f("SemVer.compare",this.version,this.loose,V),V instanceof ue||(V=new ue(V,this.loose)),this.compareMain(V)||this.comparePre(V)},ue.prototype.compareMain=function(V){return V instanceof ue||(V=new ue(V,this.loose)),H(this.major,V.major)||H(this.minor,V.minor)||H(this.patch,V.patch)},ue.prototype.comparePre=function(V){if(V instanceof ue||(V=new ue(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var x=0;do{var Y=this.prerelease[x],$e=V.prerelease[x];if(f("prerelease compare",x,Y,$e),Y===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Y===void 0)return-1;if(Y!==$e)return H(Y,$e)}while(++x)},ue.prototype.inc=function(V,x){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Y=this.prerelease.length;--Y>=0;)typeof this.prerelease[Y]=="number"&&(this.prerelease[Y]++,Y=-2);Y===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,x,Y,$e){typeof Y=="string"&&($e=Y,Y=void 0);try{return new ue(V,Y).inc(x,$e).version}catch{return null}},e.diff=function(V,x){if(ce(V,x))return null;var Y=we(V),$e=we(x);if(Y.prerelease.length||$e.prerelease.length){for(var ve in Y)if((ve==="major"||ve==="minor"||ve==="patch")&&Y[ve]!==$e[ve])return"pre"+ve;return"prerelease"}for(var ve in Y)if((ve==="major"||ve==="minor"||ve==="patch")&&Y[ve]!==$e[ve])return ve},e.compareIdentifiers=H;var ae=/^[0-9]+$/;function H(V,x){var Y=ae.test(V),$e=ae.test(x);return Y&&$e&&(V=+V,x=+x),Y&&!$e?-1:$e&&!Y?1:V<x?-1:V>x?1:0}function fe(V,x,Y){return new ue(V,Y).compare(new ue(x,Y))}function he(V,x,Y){return fe(V,x,Y)>0}function se(V,x,Y){return fe(V,x,Y)<0}function ce(V,x,Y){return fe(V,x,Y)===0}function le(V,x,Y){return fe(V,x,Y)!==0}function de(V,x,Y){return fe(V,x,Y)>=0}function q(V,x,Y){return fe(V,x,Y)<=0}function _(V,x,Y,$e){var ve;switch(x){case"===":typeof V=="object"&&(V=V.version),typeof Y=="object"&&(Y=Y.version),ve=V===Y;break;case"!==":typeof V=="object"&&(V=V.version),typeof Y=="object"&&(Y=Y.version),ve=V!==Y;break;case"":case"=":case"==":ve=ce(V,Y,$e);break;case"!=":ve=le(V,Y,$e);break;case">":ve=he(V,Y,$e);break;case">=":ve=de(V,Y,$e);break;case"<":ve=se(V,Y,$e);break;case"<=":ve=q(V,Y,$e);break;default:throw new TypeError("Invalid operator: "+x)}return ve}function ge(V,x){if(V instanceof ge){if(V.loose===x)return V;V=V.value}if(!(this instanceof ge))return new ge(V,x);f("comparator",V,x),this.loose=x,this.parse(V),this.semver===me?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(V,x){return H(x,V)},e.major=function(V,x){return new ue(V,x).major},e.minor=function(V,x){return new ue(V,x).minor},e.patch=function(V,x){return new ue(V,x).patch},e.compare=fe,e.compareLoose=function(V,x){return fe(V,x,!0)},e.rcompare=function(V,x,Y){return fe(x,V,Y)},e.sort=function(V,x){return V.sort(function(Y,$e){return e.compare(Y,$e,x)})},e.rsort=function(V,x){return V.sort(function(Y,$e){return e.rcompare(Y,$e,x)})},e.gt=he,e.lt=se,e.eq=ce,e.neq=le,e.gte=de,e.lte=q,e.cmp=_,e.Comparator=ge;var me={};function Ae(V,x){if(V instanceof Ae)return V.loose===x?V:new Ae(V.raw,x);if(V instanceof ge)return new Ae(V.value,x);if(!(this instanceof Ae))return new Ae(V,x);if(this.loose=x,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(Y){return this.parseRange(Y.trim())},this).filter(function(Y){return Y.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ye(V){return!V||V.toLowerCase()==="x"||V==="*"}function Re(V,x,Y,$e,ve,Te,Ve,Qe,tt,at,dt,ot,rt){return((x=ye(Y)?"":ye($e)?">="+Y+".0.0":ye(ve)?">="+Y+"."+$e+".0":">="+x)+" "+(Qe=ye(tt)?"":ye(at)?"<"+(+tt+1)+".0.0":ye(dt)?"<"+tt+"."+(+at+1)+".0":ot?"<="+tt+"."+at+"."+dt+"-"+ot:"<="+Qe)).trim()}function Le(V,x){for(var Y=0;Y<V.length;Y++)if(!V[Y].test(x))return!1;if(x.prerelease.length){for(Y=0;Y<V.length;Y++)if(f(V[Y].semver),V[Y].semver!==me&&V[Y].semver.prerelease.length>0){var $e=V[Y].semver;if($e.major===x.major&&$e.minor===x.minor&&$e.patch===x.patch)return!0}return!1}return!0}function ze(V,x,Y){try{x=new Ae(x,Y)}catch{return!1}return x.test(V)}function B(V,x,Y,$e){var ve,Te,Ve,Qe,tt;switch(V=new ue(V,$e),x=new Ae(x,$e),Y){case">":ve=he,Te=q,Ve=se,Qe=">",tt=">=";break;case"<":ve=se,Te=de,Ve=he,Qe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(V,x,$e))return!1;for(var at=0;at<x.set.length;++at){var dt=x.set[at],ot=null,rt=null;if(dt.forEach(function(Pe){Pe.semver===me&&(Pe=new ge(">=0.0.0")),ot=ot||Pe,rt=rt||Pe,ve(Pe.semver,ot.semver,$e)?ot=Pe:Ve(Pe.semver,rt.semver,$e)&&(rt=Pe)}),ot.operator===Qe||ot.operator===tt||(!rt.operator||rt.operator===Qe)&&Te(V,rt.semver)||rt.operator===tt&&Ve(V,rt.semver))return!1}return!0}ge.prototype.parse=function(V){var x=this.loose?w[G]:w[K],Y=V.match(x);if(!Y)throw new TypeError("Invalid comparator: "+V);this.operator=Y[1],this.operator==="="&&(this.operator=""),Y[2]?this.semver=new ue(Y[2],this.loose):this.semver=me},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(V){return f("Comparator.test",V,this.loose),this.semver===me||(typeof V=="string"&&(V=new ue(V,this.loose)),_(V,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(V,x){if(!(V instanceof ge))throw new TypeError("a Comparator is required");var Y;if(this.operator==="")return Y=new Ae(V.value,x),ze(this.value,Y,x);if(V.operator==="")return Y=new Ae(this.value,x),ze(V.semver,Y,x);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Te=this.semver.version===V.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Qe=_(this.semver,"<",V.semver,x)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),tt=_(this.semver,">",V.semver,x)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ve||Te&&Ve||Qe||tt},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var x=this.loose;V=V.trim(),f("range",V,x);var Y=x?w[Z]:w[Q];V=V.replace(Y,Re),f("hyphen replace",V),V=V.replace(w[X],"$1$2$3"),f("comparator trim",V,w[X]),V=(V=(V=V.replace(w[j],"$1~")).replace(w[A],"$1^")).split(/\s+/).join(" ");var $e=x?w[G]:w[K],ve=V.split(" ").map(function(Te){return function(Ve,Qe){return f("comp",Ve),Ve=function(tt,at){return tt.trim().split(/\s+/).map(function(dt){return function(ot,rt){f("caret",ot,rt);var Pe=rt?w[F]:w[T];return ot.replace(Pe,function(Ie,Ge,te,oe,Ce){var Ke;return f("caret",ot,Ie,Ge,te,oe,Ce),ye(Ge)?Ke="":ye(te)?Ke=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":ye(oe)?Ke=Ge==="0"?">="+Ge+"."+te+".0 <"+Ge+"."+(+te+1)+".0":">="+Ge+"."+te+".0 <"+(+Ge+1)+".0.0":Ce?(f("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ke=Ge==="0"?te==="0"?">="+Ge+"."+te+"."+oe+Ce+" <"+Ge+"."+te+"."+(+oe+1):">="+Ge+"."+te+"."+oe+Ce+" <"+Ge+"."+(+te+1)+".0":">="+Ge+"."+te+"."+oe+Ce+" <"+(+Ge+1)+".0.0"):(f("no pr"),Ke=Ge==="0"?te==="0"?">="+Ge+"."+te+"."+oe+" <"+Ge+"."+te+"."+(+oe+1):">="+Ge+"."+te+"."+oe+" <"+Ge+"."+(+te+1)+".0":">="+Ge+"."+te+"."+oe+" <"+(+Ge+1)+".0.0"),f("caret return",Ke),Ke})}(dt,at)}).join(" ")}(Ve,Qe),f("caret",Ve),Ve=function(tt,at){return tt.trim().split(/\s+/).map(function(dt){return function(ot,rt){var Pe=rt?w[z]:w[U];return ot.replace(Pe,function(Ie,Ge,te,oe,Ce){var Ke;return f("tilde",ot,Ie,Ge,te,oe,Ce),ye(Ge)?Ke="":ye(te)?Ke=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":ye(oe)?Ke=">="+Ge+"."+te+".0 <"+Ge+"."+(+te+1)+".0":Ce?(f("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ke=">="+Ge+"."+te+"."+oe+Ce+" <"+Ge+"."+(+te+1)+".0"):Ke=">="+Ge+"."+te+"."+oe+" <"+Ge+"."+(+te+1)+".0",f("tilde return",Ke),Ke})}(dt,at)}).join(" ")}(Ve,Qe),f("tildes",Ve),Ve=function(tt,at){return f("replaceXRanges",tt,at),tt.split(/\s+/).map(function(dt){return function(ot,rt){ot=ot.trim();var Pe=rt?w[m]:w[v];return ot.replace(Pe,function(Ie,Ge,te,oe,Ce,Ke){f("xRange",ot,Ie,Ge,te,oe,Ce,Ke);var xe=ye(te),st=xe||ye(oe),Ne=st||ye(Ce);return Ge==="="&&Ne&&(Ge=""),xe?Ie=Ge===">"||Ge==="<"?"<0.0.0":"*":Ge&&Ne?(st&&(oe=0),Ne&&(Ce=0),Ge===">"?(Ge=">=",st?(te=+te+1,oe=0,Ce=0):Ne&&(oe=+oe+1,Ce=0)):Ge==="<="&&(Ge="<",st?te=+te+1:oe=+oe+1),Ie=Ge+te+"."+oe+"."+Ce):st?Ie=">="+te+".0.0 <"+(+te+1)+".0.0":Ne&&(Ie=">="+te+"."+oe+".0 <"+te+"."+(+oe+1)+".0"),f("xRange return",Ie),Ie})}(dt,at)}).join(" ")}(Ve,Qe),f("xrange",Ve),Ve=function(tt,at){return f("replaceStars",tt,at),tt.trim().replace(w[ie],"")}(Ve,Qe),f("stars",Ve),Ve}(Te,x)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Te){return!!Te.match($e)})),ve=ve.map(function(Te){return new ge(Te,x)})},Ae.prototype.intersects=function(V,x){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Y){return Y.every(function($e){return V.set.some(function(ve){return ve.every(function(Te){return $e.intersects(Te,x)})})})})},e.toComparators=function(V,x){return new Ae(V,x).set.map(function(Y){return Y.map(function($e){return $e.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new ue(V,this.loose));for(var x=0;x<this.set.length;x++)if(Le(this.set[x],V))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(V,x,Y){var $e=null,ve=null;try{var Te=new Ae(x,Y)}catch{return null}return V.forEach(function(Ve){Te.test(Ve)&&($e&&ve.compare(Ve)!==-1||(ve=new ue($e=Ve,Y)))}),$e},e.minSatisfying=function(V,x,Y){var $e=null,ve=null;try{var Te=new Ae(x,Y)}catch{return null}return V.forEach(function(Ve){Te.test(Ve)&&($e&&ve.compare(Ve)!==1||(ve=new ue($e=Ve,Y)))}),$e},e.validRange=function(V,x){try{return new Ae(V,x).range||"*"}catch{return null}},e.ltr=function(V,x,Y){return B(V,x,"<",Y)},e.gtr=function(V,x,Y){return B(V,x,">",Y)},e.outside=B,e.prerelease=function(V,x){var Y=we(V,x);return Y&&Y.prerelease.length?Y.prerelease:null},e.intersects=function(V,x,Y){return V=new Ae(V,Y),x=new Ae(x,Y),V.intersects(x)},e.coerce=function(V){if(V instanceof ue)return V;if(typeof V!="string")return null;var x=V.match(w[y]);return x==null?null:we((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,D(1))},function(re,e){var D,O,f=re.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function w(b){if(D===setTimeout)return setTimeout(b,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(b,0);try{return D(b,0)}catch{try{return D.call(null,b,0)}catch{return D.call(this,b,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{O=typeof clearTimeout=="function"?clearTimeout:L}catch{O=L}})();var $,k=[],M=!1,I=-1;function p(){M&&$&&(M=!1,$.length?k=$.concat(k):I=-1,k.length&&S())}function S(){if(!M){var b=w(p);M=!0;for(var o=k.length;o;){for($=k,k=[];++I<o;)$&&$[I].run();I=-1,o=k.length}$=null,M=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===L||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(b)}}function E(b,o){this.fun=b,this.array=o}function u(){}f.nextTick=function(b){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];k.push(new E(b,o)),k.length!==1||M||w(S)},E.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=u,f.addListener=u,f.once=u,f.off=u,f.removeListener=u,f.removeAllListeners=u,f.emit=u,f.prependListener=u,f.prependOnceListener=u,f.listeners=function(b){return[]},f.binding=function(b){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(b){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(Se[39],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(R){return new O(R)}constructor(R){this.c=D&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1d=O}),define(Se[4],De([1,0,14,74,3,75,39]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.Event=void 0;const w=!1,$=!1;var k;(function(v){v.None=()=>f.$Tc.None;function m(q){if($){const{onDidAddListener:_}=q,ge=E.create();let me=0;q.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),_?.()}}}function y(q,_){return K(q,()=>{},0,void 0,!0,void 0,_)}v.defer=y;function P(q){return(_,ge=null,me)=>{let Ae=!1,ye;return ye=q(Re=>{if(!Ae)return ye?ye.dispose():Ae=!0,_.call(ge,Re)},null,me),Ae&&ye.dispose(),ye}}v.once=P;function j(q,_,ge){return F((me,Ae=null,ye)=>q(Re=>me.call(Ae,_(Re)),null,ye),ge)}v.map=j;function U(q,_,ge){return F((me,Ae=null,ye)=>q(Re=>{_(Re),me.call(Ae,Re)},null,ye),ge)}v.forEach=U;function z(q,_,ge){return F((me,Ae=null,ye)=>q(Re=>_(Re)&&me.call(Ae,Re),null,ye),ge)}v.filter=z;function N(q){return q}v.signal=N;function A(...q){return(_,ge=null,me)=>{const Ae=(0,f.$Qc)(...q.map(ye=>ye(Re=>_.call(ge,Re))));return G(Ae,me)}}v.any=A;function T(q,_,ge,me){let Ae=ge;return j(q,ye=>(Ae=_(Ae,ye),Ae),me)}v.reduce=T;function F(q,_){let ge;const me={onWillAddFirstListener(){ge=q(Ae.fire,Ae)},onDidRemoveLastListener(){ge?.dispose()}};_||m(me);const Ae=new n(me);return _?.add(Ae),Ae.event}function G(q,_){return _ instanceof Array?_.push(q):_&&_.add(q),q}function K(q,_,ge=100,me=!1,Ae=!1,ye,Re){let Le,ze,B,V=0,x;const Y={leakWarningThreshold:ye,onWillAddFirstListener(){Le=q(ve=>{V++,ze=_(ze,ve),me&&!B&&($e.fire(ze),ze=void 0),x=()=>{const Te=ze;ze=void 0,B=void 0,(!me||V>1)&&$e.fire(Te),V=0},typeof ge=="number"?(clearTimeout(B),B=setTimeout(x,ge)):B===void 0&&(B=0,queueMicrotask(x))})},onWillRemoveListener(){Ae&&V>0&&x?.()},onDidRemoveLastListener(){x=void 0,Le.dispose()}};Re||m(Y);const $e=new n(Y);return Re?.add($e),$e.event}v.debounce=K;function X(q,_=0,ge){return v.debounce(q,(me,Ae)=>me?(me.push(Ae),me):[Ae],_,void 0,!0,void 0,ge)}v.accumulate=X;function Q(q,_=(me,Ae)=>me===Ae,ge){let me=!0,Ae;return z(q,ye=>{const Re=me||!_(ye,Ae);return me=!1,Ae=ye,Re},ge)}v.latch=Q;function Z(q,_,ge){return[v.filter(q,_,ge),v.filter(q,me=>!_(me),ge)]}v.split=Z;function ie(q,_=!1,ge=[],me){let Ae=ge.slice(),ye=q(ze=>{Ae?Ae.push(ze):Le.fire(ze)});me&&me.add(ye);const Re=()=>{Ae?.forEach(ze=>Le.fire(ze)),Ae=null},Le=new n({onWillAddFirstListener(){ye||(ye=q(ze=>Le.fire(ze)),me&&me.add(ye))},onDidAddFirstListener(){Ae&&(_?setTimeout(Re):Re())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return me&&me.add(Le),Le.event}v.buffer=ie;function ee(q,_){return(me,Ae,ye)=>{const Re=_(new ue);return q(function(Le){const ze=Re.evaluate(Le);ze!==we&&me.call(Ae,ze)},void 0,ye)}}v.chain=ee;const we=Symbol("HaltChainable");class ue{constructor(){this.f=[]}map(_){return this.f.push(_),this}forEach(_){return this.f.push(ge=>(_(ge),ge)),this}filter(_){return this.f.push(ge=>_(ge)?ge:we),this}reduce(_,ge){let me=ge;return this.f.push(Ae=>(me=_(me,Ae),me)),this}latch(_=(ge,me)=>ge===me){let ge=!0,me;return this.f.push(Ae=>{const ye=ge||!_(Ae,me);return ge=!1,me=Ae,ye?Ae:we}),this}evaluate(_){for(const ge of this.f)if(_=ge(_),_===we)break;return _}}function ae(q,_,ge=me=>me){const me=(...Le)=>Re.fire(ge(...Le)),Ae=()=>q.on(_,me),ye=()=>q.removeListener(_,me),Re=new n({onWillAddFirstListener:Ae,onDidRemoveLastListener:ye});return Re.event}v.fromNodeEventEmitter=ae;function H(q,_,ge=me=>me){const me=(...Le)=>Re.fire(ge(...Le)),Ae=()=>q.addEventListener(_,me),ye=()=>q.removeEventListener(_,me),Re=new n({onWillAddFirstListener:Ae,onDidRemoveLastListener:ye});return Re.event}v.fromDOMEventEmitter=H;function fe(q){return new Promise(_=>P(q)(_))}v.toPromise=fe;function he(q){const _=new n;return q.then(ge=>{_.fire(ge)},()=>{_.fire(void 0)}).finally(()=>{_.dispose()}),_.event}v.fromPromise=he;function se(q,_,ge){return _(ge),q(me=>_(me))}v.runAndSubscribe=se;class ce{constructor(_,ge){this._observable=_,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{_.addObserver(this)},onDidRemoveLastListener:()=>{_.removeObserver(this)}};ge||m(me),this.emitter=new n(me),ge&&ge.add(this.emitter)}beginUpdate(_){this.f++}handlePossibleChange(_){}handleChange(_,ge){this.g=!0}endUpdate(_){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function le(q,_){return new ce(q,_).emitter.event}v.fromObservable=le;function de(q){return(_,ge,me)=>{let Ae=0,ye=!1;const Re={beginUpdate(){Ae++},endUpdate(){Ae--,Ae===0&&(q.reportChanges(),ye&&(ye=!1,_.call(ge)))},handlePossibleChange(){},handleChange(){ye=!0}};q.addObserver(Re),q.reportChanges();const Le={dispose(){q.removeObserver(Re)}};return me instanceof f.$Sc?me.add(Le):Array.isArray(me)&&me.push(Le),Le}}v.fromObservableLight=de})(k||(e.Event=k={}));class M{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${M.f++}`,M.all.add(this)}start(m){this.g=new L.$1d,this.listenerCount=m}stop(){if(this.g){const m=this.g.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.g=void 0}}}e.$3d=M,M.all=new Set,M.f=0;let I=-1;function p(v){const m=I;return I=v,{dispose(){I=m}}}e.$4d=p;class S{constructor(m,y=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=y,this.g=0}dispose(){this.f?.clear()}check(m,y){const P=this.threshold;if(P<=0||y<P)return;this.f||(this.f=new Map);const j=this.f.get(m.value)||0;if(this.f.set(m.value,j+1),this.g-=1,this.g<=0){this.g=P*.5;let U,z=0;for(const[N,A]of this.f)(!U||z<A)&&(U=N,z=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${z}):`),console.warn(U)}return()=>{const U=this.f.get(m.value)||0;this.f.set(m.value,U-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class b{constructor(m){this.value=m,this.id=u++}}const o=2,i=(v,m)=>{if(v instanceof b)m(v);else for(let y=0;y<v.length;y++){const P=v[y];P&&m(P)}};class n{constructor(m){this.w=0,this.f=m,this.g=I>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new M(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const m=this.t;queueMicrotask(()=>{i(m,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(m,y,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Tc.None;if(this.m)return f.$Tc.None;y&&(m=m.bind(y));const j=new b(m);let U,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(j.stack=E.create(),U=this.g.check(j.stack,this.w+1)),w&&(j.stack=z??E.create()),this.t?this.t instanceof b?(this.u??(this.u=new a),this.t=[this.t,j]):this.t.push(j):(this.f?.onWillAddFirstListener?.(this),this.t=j,this.f?.onDidAddFirstListener?.(this)),this.w++;const N=(0,f.$Rc)(()=>{U?.(),this.x(j)});return P instanceof f.$Sc?P.add(N):Array.isArray(P)&&P.push(N),N}),this.q}x(m){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,P=y.indexOf(m);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[P]=void 0;const j=this.u.current===this;if(this.w*o<=y.length){let U=0;for(let z=0;z<y.length;z++)y[z]?y[U++]=y[z]:j&&(this.u.end--,U<this.u.i&&this.u.i--);y.length=U}}y(m,y){if(!m)return;const P=this.f?.onListenerError||D.$1;if(!P){m.value(y);return}try{m.value(y)}catch(j){P(j)}}z(m){const y=m.current.t;for(;m.i<m.end;)this.y(y[m.i++],m.value);m.reset()}fire(m){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,m);else{const y=this.u;y.enqueue(this,m,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$5d=n;const s=()=>new a;e.$6d=s;class a{constructor(){this.i=-1,this.end=0}enqueue(m,y,P){this.i=0,this.end=P,this.current=m,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(m,y,P){if(this.t)for(this.h||(this.h=new R.$4c),i(this.t,j=>this.h.push([j.value,m]));this.h.size>0&&!y.isCancellationRequested;){const[j,U]=this.h.shift(),z=[],N={...U,token:y,waitUntil:A=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");P&&(A=P(A,j)),z.push(A)}};try{j(N)}catch(A){(0,D.$1)(A);continue}Object.freeze(z),await Promise.allSettled(z).then(A=>{for(const T of A)T.status==="rejected"&&(0,D.$1)(T.reason)})}}}e.$7d=t;class d extends n{get isPaused(){return this.h!==0}constructor(m){super(m),this.h=0,this.s=new R.$4c,this.A=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.A(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.w&&(this.h!==0?this.s.push(m):super.fire(m))}}e.$8d=d;class l extends d{constructor(m){super(m),this.k=m.delay??100}fire(m){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(m)}}e.$9d=l;class r extends n{constructor(m){super(m),this.h=[],this.k=m?.merge}fire(m){this.hasListeners()&&(this.h.push(m),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$0d=r;class c{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(m){const y={event:m,listener:null};this.h.push(y),this.g&&this.m(y);const P=()=>{this.g&&this.o(y);const j=this.h.indexOf(y);this.h.splice(j,1)};return(0,f.$Rc)((0,O.$db)(P))}j(){this.g=!0,this.h.forEach(m=>this.m(m))}k(){this.g=!1,this.h.forEach(m=>this.o(m))}m(m){m.listener=m.event(y=>this.f.fire(y))}o(m){m.listener?.dispose(),m.listener=null}dispose(){this.f.dispose();for(const m of this.h)m.listener?.dispose();this.h=[]}}e.$$d=c;class h{constructor(m,y,P,j){this.f=new f.$Sc;const U=this.f.add(new c),z=this.f.add(new f.$3c);function N(A){z.set(A,U.add(j(A)))}for(const A of m)N(A);this.f.add(y(A=>{N(A)})),this.f.add(P(A=>{z.deleteAndDispose(A)})),this.event=U.event}dispose(){this.f.dispose()}}e.$_d=h;class g{constructor(){this.f=[]}wrapEvent(m){return(y,P,j)=>m(U=>{const z=this.f[this.f.length-1];z?z.push(()=>y.call(P,U)):y.call(P,U)},void 0,j)}bufferEvents(m){const y=[];this.f.push(y);const P=m();return this.f.pop(),y.forEach(j=>j()),P}}e.$ae=g;class C{constructor(){this.f=!1,this.g=k.None,this.h=f.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(m){this.g=m,this.f&&(this.h.dispose(),this.h=m(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$be=C}),define(Se[22],De([1,0,4]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.CancellationToken=void 0;const O=Object.freeze(function(w,$){const k=setTimeout(w.bind($),0);return{dispose(){clearTimeout(k)}}});var f;(function(w){function $(k){return k===w.None||k===w.Cancelled||k instanceof R?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}w.isCancellationToken=$,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(f||(e.CancellationToken=f={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=f.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=f.None}}e.$ce=L}),define(Se[164],De([1,0,22]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=void 0;class O{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new D.$ce,$=this.b(w.token);return this.a={promise:$,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$Ne=O;class f{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const $=JSON.stringify(w);return this.b!==$&&(this.b=$,this.a=this.c(w)),this.a}}e.$Oe=f;class R{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const $=this.b(w);return this.a.set(w,$),$}}e.$Pe=R}),define(Se[100],De([1,0,14,3]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function f(s){const a=s;return a?typeof a.read=="function":!1}e.$de=f;function R(s){const a=s;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$ee=R;function L(s){const a=s;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$fe=L;function w(s,a){return new $(s,a)}e.$ge=w;class ${constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,D.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let d;switch(a){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const l=d.indexOf(t);l>=0&&d.splice(l,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(s,a){const t=[];let d;for(;(d=s.read())!==null;)t.push(d);return a(t)}e.$he=k;function M(s,a,t){const d=[];let l;for(;(l=s.read())!==null&&d.length<t;)d.push(l);return l===null&&d.length>0?a(d):{read:()=>{if(d.length>0)return d.shift();if(typeof l<"u"){const r=l;return l=void 0,r}return s.read()}}}e.$ie=M;function I(s,a){return new Promise((t,d)=>{const l=[];p(s,{onData:r=>{a&&l.push(r)},onError:r=>{a?d(r):t(void 0)},onEnd:()=>{t(a?a(l):void 0)}})})}e.$je=I;function p(s,a,t){s.on("error",d=>{t?.isCancellationRequested||a.onError(d)}),s.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),s.on("data",d=>{t?.isCancellationRequested||a.onData(d)})}e.$ke=p;function S(s,a){return new Promise((t,d)=>{const l=new O.$Sc,r=[],c=C=>{if(r.push(C),r.length>a)return l.dispose(),s.pause(),t({stream:s,buffer:r,ended:!1})},h=C=>(l.dispose(),d(C)),g=()=>(l.dispose(),t({stream:s,buffer:r,ended:!0}));l.add((0,O.$Rc)(()=>s.removeListener("error",h))),s.on("error",h),l.add((0,O.$Rc)(()=>s.removeListener("end",g))),s.on("end",g),l.add((0,O.$Rc)(()=>s.removeListener("data",c))),s.on("data",c)})}e.$le=S;function E(s,a){const t=w(a);return t.end(s),t}e.$me=E;function u(){const s=w(()=>{throw new Error("not supported")});return s.end(),s}e.$ne=u;function b(s){let a=!1;return{read:()=>a?null:(a=!0,s)}}e.$oe=b;function o(s,a,t){const d=w(t);return p(s,{onData:l=>d.write(a.data(l)),onError:l=>d.error(a.error?a.error(l):l),onEnd:()=>d.end()}),d}e.$pe=o;function i(s,a,t){let d=!1;return{read:()=>{const l=a.read();return d?l:(d=!0,l!==null?t([s,l]):s)}}}e.$qe=i;function n(s,a,t){let d=!1;const l=w(t);return p(a,{onData:r=>d?l.write(r):(d=!0,l.write(t([s,r]))),onError:r=>l.error(r),onEnd:()=>{d||(d=!0,l.write(s)),l.end()}}),l}e.$re=n}),define(Se[21],De([1,0,44,100]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const f=typeof Buffer<"u",R=new D.$V(()=>new Uint8Array(256));let L,w;class ${static alloc(y){return f?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return f&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&f?new $(Buffer.from(y)):(L||(L=new TextEncoder),new $(L.encode(y)))}static fromByteArray(y){const P=$.alloc(y.length);for(let j=0,U=y.length;j<U;j++)P.buffer[j]=y[j];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let z=0,N=y.length;z<N;z++)P+=y[z].byteLength}const j=$.alloc(P);let U=0;for(let z=0,N=y.length;z<N;z++){const A=y[z];j.set(A,U),U+=A.byteLength}return j}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return f?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(y,P){return new $(this.buffer.subarray(y,P))}set(y,P){if(y instanceof $)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return p(this.buffer,y)}writeUInt32BE(y,P){S(this.buffer,y,P)}readUInt32LE(y){return E(this.buffer,y)}writeUInt32LE(y,P){u(this.buffer,y,P)}readUInt8(y){return b(this.buffer,y)}writeUInt8(y,P){o(this.buffer,y,P)}indexOf(y,P=0){return k(this.buffer,y instanceof $?y.buffer:y,P)}}e.$se=$;function k(m,y,P=0){const j=y.byteLength,U=m.byteLength;if(j===0)return 0;if(j===1)return m.indexOf(y[0]);if(j>U-P)return-1;const z=R.value;z.fill(y.length);for(let F=0;F<y.length;F++)z[y[F]]=y.length-F-1;let N=P+y.length-1,A=N,T=-1;for(;N<U;)if(m[N]===y[A]){if(A===0){T=N;break}N--,A--}else N+=Math.max(y.length-A,z[m[N]]),A=y.length-1;return T}e.$te=k;function M(m,y){return m[y+0]<<0>>>0|m[y+1]<<8>>>0}e.$ue=M;function I(m,y,P){m[P+0]=y&255,y=y>>>8,m[P+1]=y&255}e.$ve=I;function p(m,y){return m[y]*2**24+m[y+1]*2**16+m[y+2]*2**8+m[y+3]}e.$we=p;function S(m,y,P){m[P+3]=y,y=y>>>8,m[P+2]=y,y=y>>>8,m[P+1]=y,y=y>>>8,m[P]=y}e.$xe=S;function E(m,y){return m[y+0]<<0>>>0|m[y+1]<<8>>>0|m[y+2]<<16>>>0|m[y+3]<<24>>>0}e.$ye=E;function u(m,y,P){m[P+0]=y&255,y=y>>>8,m[P+1]=y&255,y=y>>>8,m[P+2]=y&255,y=y>>>8,m[P+3]=y&255}e.$ze=u;function b(m,y){return m[y]}e.$Ae=b;function o(m,y,P){m[P]=y}e.$Be=o;function i(m){return O.$he(m,y=>$.concat(y))}e.$Ce=i;function n(m){return O.$oe(m)}e.$De=n;function s(m){return O.$je(m,y=>$.concat(y))}e.$Ee=s;async function a(m){return m.ended?$.concat(m.buffer):$.concat([...m.buffer,await s(m.stream)])}e.$Fe=a;function t(m){return O.$me(m,y=>$.concat(y))}e.$Ge=t;function d(m){return O.$pe(m,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}e.$He=d;function l(m){return O.$ge(y=>$.concat(y),m)}e.$Ie=l;function r(m,y){return O.$qe(m,y,P=>$.concat(P))}e.$Je=r;function c(m,y){return O.$re(m,y,P=>$.concat(P))}e.$Ke=c;function h(m){let y=0,P=0,j=0;const U=new Uint8Array(Math.floor(m.length/4*3)),z=A=>{switch(P){case 3:U[j++]=y|A,P=0;break;case 2:U[j++]=y|A>>>2,y=A<<6,P=3;break;case 1:U[j++]=y|A>>>4,y=A<<4,P=2;break;default:y=A<<2,P=1}};for(let A=0;A<m.length;A++){const T=m.charCodeAt(A);if(T>=65&&T<=90)z(T-65);else if(T>=97&&T<=122)z(T-97+26);else if(T>=48&&T<=57)z(T-48+52);else if(T===43||T===45)z(62);else if(T===47||T===95)z(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${m[A]}`)}}const N=j;for(;P>0;)z(0);return $.wrap(U).slice(0,N)}e.$Le=h;const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:m},y=!0,P=!1){const j=P?C:g;let U="";const z=m.byteLength%3;let N=0;for(;N<m.byteLength-z;N+=3){const A=m[N+0],T=m[N+1],F=m[N+2];U+=j[A>>>2],U+=j[(A<<4|T>>>4)&63],U+=j[(T<<2|F>>>6)&63],U+=j[F&63]}if(z===1){const A=m[N+0];U+=j[A>>>2],U+=j[A<<4&63],y&&(U+="==")}else if(z===2){const A=m[N+0],T=m[N+1];U+=j[A>>>2],U+=j[(A<<4|T>>>4)&63],U+=j[T<<2&63],y&&(U+="=")}return U}e.$Me=v}),define(Se[12],De([1,0,164,44]),function(re,e,D,O){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rf=e.$Qf=e.$Pf=e.$Of=e.GraphemeBreakType=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=void 0;function R(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$Se=R;const L=/{(\d+)}/g;function w(Pe,...Ie){return Ie.length===0?Pe:Pe.replace(L,function(Ge,te){const oe=parseInt(te,10);return isNaN(oe)||oe<0||oe>=Ie.length?Ge:Ie[oe]})}e.$Te=w;const $=/{([^}]+)}/g;function k(Pe,Ie){return Object.keys(Ie).length===0?Pe:Pe.replace($,(Ge,te)=>Ie[te]??Ge)}e.$Ue=k;function M(Pe){return Pe.replace(/[<>"'&]/g,Ie=>{switch(Ie){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ie})}e.$Ve=M;function I(Pe){return Pe.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.$We=I;function p(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Xe=p;function S(Pe,Ie){let Ge=0;const te=Ie.charCodeAt(0);for(let oe=Pe.length-1;oe>=0;oe--)Pe.charCodeAt(oe)===te&&Ge++;return Ge}e.$Ye=S;function E(Pe,Ie,Ge="\u2026"){return Pe.length<=Ie?Pe:`${Pe.substr(0,Ie)}${Ge}`}e.$Ze=E;function u(Pe,Ie,Ge="\u2026"){if(Pe.length<=Ie)return Pe;const te=Math.ceil(Ie/2)-Ge.length/2,oe=Math.floor(Ie/2)-Ge.length/2;return`${Pe.substr(0,te)}${Ge}${Pe.substr(Pe.length-oe)}`}e.$1e=u;function b(Pe,Ie=" "){const Ge=o(Pe,Ie);return i(Ge,Ie)}e.$2e=b;function o(Pe,Ie){if(!Pe||!Ie)return Pe;const Ge=Ie.length;if(Ge===0||Pe.length===0)return Pe;let te=0;for(;Pe.indexOf(Ie,te)===te;)te=te+Ge;return Pe.substring(te)}e.$3e=o;function i(Pe,Ie){if(!Pe||!Ie)return Pe;const Ge=Ie.length,te=Pe.length;if(Ge===0||te===0)return Pe;let oe=te,Ce=-1;for(;Ce=Pe.lastIndexOf(Ie,oe-1),!(Ce===-1||Ce+Ge!==oe);){if(Ce===0)return"";oe=Ce}return Pe.substring(0,oe)}e.$4e=i;function n(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$5e=n;function s(Pe){return Pe.replace(/\*/g,"")}e.$6e=s;function a(Pe,Ie,Ge={}){if(!Pe)throw new Error("Cannot create regex from empty string");Ie||(Pe=p(Pe)),Ge.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let te="";return Ge.global&&(te+="g"),Ge.matchCase||(te+="i"),Ge.multiline&&(te+="m"),Ge.unicode&&(te+="u"),new RegExp(Pe,te)}e.$7e=a;function t(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$8e=t;function d(Pe){return Pe.split(/\r\n|\r|\n/)}e.$9e=d;function l(Pe){const Ie=[],Ge=Pe.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(Ge.length/2);te++)Ie.push(Ge[2*te]+(Ge[2*te+1]??""));return Ie}e.$0e=l;function r(Pe){for(let Ie=0,Ge=Pe.length;Ie<Ge;Ie++){const te=Pe.charCodeAt(Ie);if(te!==32&&te!==9)return Ie}return-1}e.$$e=r;function c(Pe,Ie=0,Ge=Pe.length){for(let te=Ie;te<Ge;te++){const oe=Pe.charCodeAt(te);if(oe!==32&&oe!==9)return Pe.substring(Ie,te)}return Pe.substring(Ie,Ge)}e.$_e=c;function h(Pe,Ie=Pe.length-1){for(let Ge=Ie;Ge>=0;Ge--){const te=Pe.charCodeAt(Ge);if(te!==32&&te!==9)return Ge}return-1}e.$af=h;function g(Pe,Ie,Ge){const te=[];let oe=0;for(const Ce of Pe.matchAll(Ie)){if(te.push(Pe.slice(oe,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");oe=Ce.index+Ce[0].length,te.push(Ge(Ce[0],...Ce.slice(1),Ce.index,Pe,Ce.groups))}return te.push(Pe.slice(oe)),Promise.all(te).then(Ce=>Ce.join(""))}e.$bf=g;function C(Pe,Ie){return Pe<Ie?-1:Pe>Ie?1:0}e.$cf=C;function v(Pe,Ie,Ge=0,te=Pe.length,oe=0,Ce=Ie.length){for(;Ge<te&&oe<Ce;Ge++,oe++){const st=Pe.charCodeAt(Ge),Ne=Ie.charCodeAt(oe);if(st<Ne)return-1;if(st>Ne)return 1}const Ke=te-Ge,xe=Ce-oe;return Ke<xe?-1:Ke>xe?1:0}e.$df=v;function m(Pe,Ie){return y(Pe,Ie,0,Pe.length,0,Ie.length)}e.$ef=m;function y(Pe,Ie,Ge=0,te=Pe.length,oe=0,Ce=Ie.length){for(;Ge<te&&oe<Ce;Ge++,oe++){let st=Pe.charCodeAt(Ge),Ne=Ie.charCodeAt(oe);if(st===Ne)continue;if(st>=128||Ne>=128)return v(Pe.toLowerCase(),Ie.toLowerCase(),Ge,te,oe,Ce);j(st)&&(st-=32),j(Ne)&&(Ne-=32);const bt=st-Ne;if(bt!==0)return bt}const Ke=te-Ge,xe=Ce-oe;return Ke<xe?-1:Ke>xe?1:0}e.$ff=y;function P(Pe){return Pe>=48&&Pe<=57}e.$gf=P;function j(Pe){return Pe>=97&&Pe<=122}e.$hf=j;function U(Pe){return Pe>=65&&Pe<=90}e.$if=U;function z(Pe,Ie){return Pe.length===Ie.length&&y(Pe,Ie)===0}e.$jf=z;function N(Pe,Ie){const Ge=Ie.length;return Ie.length>Pe.length?!1:y(Pe,Ie,0,Ge)===0}e.$kf=N;function A(Pe,Ie){const Ge=Math.min(Pe.length,Ie.length);let te;for(te=0;te<Ge;te++)if(Pe.charCodeAt(te)!==Ie.charCodeAt(te))return te;return Ge}e.$lf=A;function T(Pe,Ie){const Ge=Math.min(Pe.length,Ie.length);let te;const oe=Pe.length-1,Ce=Ie.length-1;for(te=0;te<Ge;te++)if(Pe.charCodeAt(oe-te)!==Ie.charCodeAt(Ce-te))return te;return Ge}e.$mf=T;function F(Pe){return 55296<=Pe&&Pe<=56319}e.$nf=F;function G(Pe){return 56320<=Pe&&Pe<=57343}e.$of=G;function K(Pe,Ie){return(Pe-55296<<10)+(Ie-56320)+65536}e.$pf=K;function X(Pe,Ie,Ge){const te=Pe.charCodeAt(Ge);if(F(te)&&Ge+1<Ie){const oe=Pe.charCodeAt(Ge+1);if(G(oe))return K(te,oe)}return te}e.$qf=X;function Q(Pe,Ie){const Ge=Pe.charCodeAt(Ie-1);if(G(Ge)&&Ie>1){const te=Pe.charCodeAt(Ie-2);if(F(te))return K(te,Ge)}return Ge}class Z{get offset(){return this.e}constructor(Ie,Ge=0){this.c=Ie,this.d=Ie.length,this.e=Ge}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=Q(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=X(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.$rf=Z;class ie{get offset(){return this.c.offset}constructor(Ie,Ge=0){this.c=new Z(Ie,Ge)}nextGraphemeLength(){const Ie=Te.getInstance(),Ge=this.c,te=Ge.offset;let oe=Ie.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const Ce=Ge.offset,Ke=Ie.getGraphemeBreakType(Ge.nextCodePoint());if($e(oe,Ke)){Ge.setOffset(Ce);break}oe=Ke}return Ge.offset-te}prevGraphemeLength(){const Ie=Te.getInstance(),Ge=this.c,te=Ge.offset;let oe=Ie.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const Ce=Ge.offset,Ke=Ie.getGraphemeBreakType(Ge.prevCodePoint());if($e(Ke,oe)){Ge.setOffset(Ce);break}oe=Ke}return te-Ge.offset}eol(){return this.c.eol()}}e.$sf=ie;function ee(Pe,Ie){return new ie(Pe,Ie).nextGraphemeLength()}e.$tf=ee;function we(Pe,Ie){return new ie(Pe,Ie).prevGraphemeLength()}e.$uf=we;function ue(Pe,Ie){Ie>0&&G(Pe.charCodeAt(Ie))&&Ie--;const Ge=Ie+ee(Pe,Ie);return[Ge-we(Pe,Ge),Ge]}e.$vf=ue;function ae(Pe){const Ie=new ie(Pe);let Ge=0;for(;!Ie.eol();)Ge++,Ie.nextGraphemeLength();return Ge}e.$wf=ae;let H;function fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function he(Pe){return H||(H=fe()),H.test(Pe)}e.$xf=he;const se=/^[\t\n\r\x20-\x7E]*$/;function ce(Pe){return se.test(Pe)}e.$yf=ce,e.$zf=/[\u2028\u2029]/;function le(Pe){return e.$zf.test(Pe)}e.$Af=le;function de(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$Bf=de;function q(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$Cf=q;function _(Pe,Ie,Ge=""){const te=Pe.trimStart();if(te.length<Ie)return te;const oe=/\b/g;let Ce=0;for(;oe.test(te)&&!(te.length-oe.lastIndex<Ie);)Ce=oe.lastIndex,oe.lastIndex+=1;return Ce===0?te:Ge+te.substring(Ce).trimStart()}e.$Df=_;const ge=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,me=/\x1b\].*?\x07/g;function Ae(Pe){return Pe&&(Pe=Pe.replace(ge,"").replace(me,"")),Pe}e.$Ef=Ae,e.$Ff="\uFEFF";function ye(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$Gf=ye;function Re(Pe){return ye(Pe)?Pe.substr(1):Pe}e.$Hf=Re;function Le(Pe,Ie){if(!Pe||!Ie||Pe.length<Ie.length)return!1;const Ge=Ie.length,te=Pe.toLowerCase();let oe=0,Ce=-1;for(;oe<Ge;){const Ke=te.indexOf(Ie[oe],Ce+1);if(Ke<0)return!1;Ce=Ke,oe++}return!0}e.$If=Le;function ze(Pe,Ie=!1){return Pe?(Ie&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$Jf=ze;function B(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$Kf=B;function V(Pe,Ie=1){if(Ie===0)return"";let Ge=-1;do Ge=Pe.indexOf(`
`,Ge+1),Ie--;while(Ie>0&&Ge>=0);return Ge===-1?Pe:(Pe[Ge-1]==="\r"&&Ge--,Pe.substr(0,Ge))}e.$Lf=V;function x(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$Mf=x;function Y(Pe){return Te.getInstance().getGraphemeBreakType(Pe)}e.$Nf=Y;function $e(Pe,Ie){return Pe===0?Ie!==5&&Ie!==7:Pe===2&&Ie===3?!1:Pe===4||Pe===2||Pe===3||Ie===4||Ie===2||Ie===3?!0:!(Pe===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(Pe===11||Pe===9)&&(Ie===9||Ie===10)||(Pe===12||Pe===10)&&Ie===10||Ie===5||Ie===13||Ie===7||Pe===1||Pe===13&&Ie===14||Pe===6&&Ie===6)}var ve;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(ve||(e.GraphemeBreakType=ve={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=Ve()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ge=this.d,te=Ge.length/3;let oe=1;for(;oe<=te;)if(Ie<Ge[3*oe])oe=2*oe;else if(Ie>Ge[3*oe+1])oe=2*oe+1;else return Ge[3*oe+2];return 0}}Te.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(Pe,Ie){if(Pe===0)return 0;const Ge=tt(Pe,Ie);if(Ge!==void 0)return Ge;const te=new Z(Ie,Pe);return te.prevCodePoint(),te.offset}e.$Of=Qe;function tt(Pe,Ie){const Ge=new Z(Ie,Pe);let te=Ge.prevCodePoint();for(;at(te)||te===65039||te===8419;){if(Ge.offset===0)return;te=Ge.prevCodePoint()}if(!q(te))return;let oe=Ge.offset;return oe>0&&Ge.prevCodePoint()===8205&&(oe=Ge.offset),oe}function at(Pe){return 127995<=Pe&&Pe<=127999}var dt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(dt||(dt={})),e.$Pf="\xA0";class ot{static getInstance(Ie){return f.d.get(Array.from(Ie))}static getLocales(){return f.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Qf=ot,f=ot,ot.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ot.d=new D.$Oe(Pe=>{function Ie(Ne){const bt=new Map;for(let Ct=0;Ct<Ne.length;Ct+=2)bt.set(Ne[Ct],Ne[Ct+1]);return bt}function Ge(Ne,bt){const Ct=new Map(Ne);for(const[At,qt]of bt)Ct.set(At,qt);return Ct}function te(Ne,bt){if(!Ne)return bt;const Ct=new Map;for(const[At,qt]of Ne)bt.has(At)&&Ct.set(At,qt);return Ct}const oe=f.c.value;let Ce=Pe.filter(Ne=>!Ne.startsWith("_")&&Ne in oe);Ce.length===0&&(Ce=["_default"]);let Ke;for(const Ne of Ce){const bt=Ie(oe[Ne]);Ke=te(Ke,bt)}const xe=Ie(oe._common),st=Ge(xe,Ke);return new f(st)}),ot.e=new O.$V(()=>Object.keys(f.c.value).filter(Pe=>!Pe.startsWith("_")));class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Ie){return rt.e().has(Ie)}static get codePoints(){return rt.e()}}e.$Rf=rt,rt.d=void 0}),define(Se[125],De([1,0,28,163,12]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.FuzzyScore=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.or=void 0;function R(...ye){return function(Re,Le){for(let ze=0,B=ye.length;ze<B;ze++){const V=ye[ze](Re,Le);if(V)return V}return null}}e.or=R,e.$5j=L.bind(void 0,!1),e.$6j=L.bind(void 0,!0);function L(ye,Re,Le){if(!Le||Le.length<Re.length)return null;let ze;return ye?ze=f.$kf(Le,Re):ze=Le.indexOf(Re)===0,ze?Re.length>0?[{start:0,end:Re.length}]:[]:null}function w(ye,Re){const Le=Re.toLowerCase().indexOf(ye.toLowerCase());return Le===-1?null:[{start:Le,end:Le+ye.length}]}e.$7j=w;function $(ye,Re){return k(ye.toLowerCase(),Re.toLowerCase(),0,0)}e.$8j=$;function k(ye,Re,Le,ze){if(Le===ye.length)return[];if(ze===Re.length)return null;if(ye[Le]===Re[ze]){let B=null;return(B=k(ye,Re,Le+1,ze+1))?s({start:ze,end:ze+1},B):null}return k(ye,Re,Le,ze+1)}function M(ye){return 97<=ye&&ye<=122}function I(ye){return 65<=ye&&ye<=90}e.$9j=I;function p(ye){return 48<=ye&&ye<=57}function S(ye){return ye===32||ye===9||ye===10||ye===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ye=>E.add(ye.charCodeAt(0)));function u(ye){return S(ye)||E.has(ye)}function b(ye,Re){return ye===Re||u(ye)&&u(Re)}const o=new Map;function i(ye){if(o.has(ye))return o.get(ye);let Re;const Le=(0,O.$3j)(ye);return Le&&(Re=Le),o.set(ye,Re),Re}function n(ye){return M(ye)||I(ye)||p(ye)}function s(ye,Re){return Re.length===0?Re=[ye]:ye.end===Re[0].start?Re[0].start=ye.start:Re.unshift(ye),Re}function a(ye,Re){for(let Le=Re;Le<ye.length;Le++){const ze=ye.charCodeAt(Le);if(I(ze)||p(ze)||Le>0&&!n(ye.charCodeAt(Le-1)))return Le}return ye.length}function t(ye,Re,Le,ze){if(Le===ye.length)return[];if(ze===Re.length)return null;if(ye[Le]!==Re[ze].toLowerCase())return null;{let B=null,V=ze+1;for(B=t(ye,Re,Le+1,ze+1);!B&&(V=a(Re,V))<Re.length;)B=t(ye,Re,Le+1,V),V++;return B===null?null:s({start:ze,end:ze+1},B)}}function d(ye){let Re=0,Le=0,ze=0,B=0,V=0;for(let Te=0;Te<ye.length;Te++)V=ye.charCodeAt(Te),I(V)&&Re++,M(V)&&Le++,n(V)&&ze++,p(V)&&B++;const x=Re/ye.length,Y=Le/ye.length,$e=ze/ye.length,ve=B/ye.length;return{upperPercent:x,lowerPercent:Y,alphaPercent:$e,numericPercent:ve}}function l(ye){const{upperPercent:Re,lowerPercent:Le}=ye;return Le===0&&Re>.6}function r(ye){const{upperPercent:Re,lowerPercent:Le,alphaPercent:ze,numericPercent:B}=ye;return Le>.2&&Re<.8&&ze>.6&&B<.2}function c(ye){let Re=0,Le=0,ze=0,B=0;for(let V=0;V<ye.length;V++)ze=ye.charCodeAt(V),I(ze)&&Re++,M(ze)&&Le++,S(ze)&&B++;return(Re===0||Le===0)&&B===0?ye.length<=30:Re<=5}function h(ye,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!c(ye))return null;Re.length>60&&(Re=Re.substring(0,60));const Le=d(Re);if(!r(Le)){if(!l(Le))return null;Re=Re.toLowerCase()}let ze=null,B=0;for(ye=ye.toLowerCase();B<Re.length&&(ze=t(ye,Re,0,B))===null;)B=a(Re,B+1);return ze}e.$0j=h;function g(ye,Re,Le=!1){if(!Re||Re.length===0)return null;let ze=null,B=0;for(ye=ye.toLowerCase(),Re=Re.toLowerCase();B<Re.length&&(ze=C(ye,Re,0,B,Le),ze===null);)B=v(Re,B+1);return ze}e.$$j=g;function C(ye,Re,Le,ze,B){let V=0;if(Le===ye.length)return[];if(ze===Re.length)return null;if(!b(ye.charCodeAt(Le),Re.charCodeAt(ze))){const $e=i(ye.charCodeAt(Le));if(!$e)return null;for(let ve=0;ve<$e.length;ve++)if(!b($e[ve],Re.charCodeAt(ze+ve)))return null;V+=$e.length-1}let x=null,Y=ze+V+1;if(x=C(ye,Re,Le+1,Y,B),!B)for(;!x&&(Y=v(Re,Y))<Re.length;)x=C(ye,Re,Le+1,Y,B),Y++;if(!x)return null;if(ye.charCodeAt(Le)!==Re.charCodeAt(ze)){const $e=i(ye.charCodeAt(Le));if(!$e)return x;for(let ve=0;ve<$e.length;ve++)if($e[ve]!==Re.charCodeAt(ze+ve))return x}return s({start:ze,end:ze+V+1},x)}function v(ye,Re){for(let Le=Re;Le<ye.length;Le++)if(u(ye.charCodeAt(Le))||Le>0&&u(ye.charCodeAt(Le-1)))return Le;return ye.length}const m=R(e.$6j,h,w),y=R(e.$6j,h,$),P=new D.$Dc(1e4);function j(ye,Re,Le=!1){if(typeof ye!="string"||typeof Re!="string")return null;let ze=P.get(ye);ze||(ze=new RegExp(f.$5e(ye),"i"),P.set(ye,ze));const B=ze.exec(Re);return B?[{start:B.index,end:B.index+B[0].length}]:Le?y(ye,Re):m(ye,Re)}e.$_j=j;function U(ye,Re){const Le=le(ye,ye.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Le?N(Le):null}e.$ak=U;function z(ye,Re,Le,ze,B,V){const x=Math.min(13,ye.length);for(;Le<x;Le++){const Y=le(ye,Re,Le,ze,B,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Y)return Y}return[0,V]}e.$bk=z;function N(ye){if(typeof ye>"u")return[];const Re=[],Le=ye[1];for(let ze=ye.length-1;ze>1;ze--){const B=ye[ze]+Le,V=Re[Re.length-1];V&&V.end===B?V.end=B+1:Re.push({start:B,end:B+1})}return Re}e.$ck=N;const A=128;function T(){const ye=[],Re=[];for(let Le=0;Le<=A;Le++)Re[Le]=0;for(let Le=0;Le<=A;Le++)ye.push(Re.slice(0));return ye}function F(ye){const Re=[];for(let Le=0;Le<=ye;Le++)Re[Le]=0;return Re}const G=F(2*A),K=F(2*A),X=T(),Q=T(),Z=T(),ie=!1;function ee(ye,Re,Le,ze,B){function V(Y,$e,ve=" "){for(;Y.length<$e;)Y=ve+Y;return Y}let x=` |   |${ze.split("").map(Y=>V(Y,3)).join("|")}
`;for(let Y=0;Y<=Le;Y++)Y===0?x+=" |":x+=`${Re[Y-1]}|`,x+=ye[Y].slice(0,B+1).map($e=>V($e.toString(),3)).join("|")+`
`;return x}function we(ye,Re,Le,ze){ye=ye.substr(Re),Le=Le.substr(ze),console.log(ee(Q,ye,ye.length,Le,Le.length)),console.log(ee(Z,ye,ye.length,Le,Le.length)),console.log(ee(X,ye,ye.length,Le,Le.length))}function ue(ye,Re){if(Re<0||Re>=ye.length)return!1;const Le=ye.codePointAt(Re);switch(Le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!f.$Cf(Le)}}function ae(ye,Re){if(Re<0||Re>=ye.length)return!1;switch(ye.charCodeAt(Re)){case 32:case 9:return!0;default:return!1}}function H(ye,Re,Le){return Re[ye]!==Le[ye]}function fe(ye,Re,Le,ze,B,V,x=!1){for(;Re<Le&&B<V;)ye[Re]===ze[B]&&(x&&(G[Re]=B),Re+=1),B+=1;return Re===Le}e.$dk=fe;var he;(function(ye){ye[ye.Diag=1]="Diag",ye[ye.Left=2]="Left",ye[ye.LeftLeft=3]="LeftLeft"})(he||(he={}));var se;(function(ye){ye.Default=[-100,0];function Re(Le){return!Le||Le.length===2&&Le[0]===-100&&Le[1]===0}ye.isDefault=Re})(se||(e.FuzzyScore=se={}));class ce{constructor(Re,Le){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Le}}e.$ek=ce,ce.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function le(ye,Re,Le,ze,B,V,x=ce.default){const Y=ye.length>A?A:ye.length,$e=ze.length>A?A:ze.length;if(Le>=Y||V>=$e||Y-Le>$e-V||!fe(Re,Le,Y,B,V,$e,!0))return;de(Y,$e,Le,V,Re,B);let ve=1,Te=1,Ve=Le,Qe=V;const tt=[!1];for(ve=1,Ve=Le;Ve<Y;ve++,Ve++){const Pe=G[Ve],Ie=K[Ve],Ge=Ve+1<Y?K[Ve+1]:$e;for(Te=Pe-V+1,Qe=Pe;Qe<Ge;Te++,Qe++){let te=Number.MIN_SAFE_INTEGER,oe=!1;Qe<=Ie&&(te=q(ye,Re,Ve,Le,ze,B,Qe,$e,V,X[ve-1][Te-1]===0,tt));let Ce=0;te!==Number.MAX_SAFE_INTEGER&&(oe=!0,Ce=te+Q[ve-1][Te-1]);const Ke=Qe>Pe,xe=Ke?Q[ve][Te-1]+(X[ve][Te-1]>0?-5:0):0,st=Qe>Pe+1&&X[ve][Te-1]>0,Ne=st?Q[ve][Te-2]+(X[ve][Te-2]>0?-5:0):0;if(st&&(!Ke||Ne>=xe)&&(!oe||Ne>=Ce))Q[ve][Te]=Ne,Z[ve][Te]=3,X[ve][Te]=0;else if(Ke&&(!oe||xe>=Ce))Q[ve][Te]=xe,Z[ve][Te]=2,X[ve][Te]=0;else if(oe)Q[ve][Te]=Ce,Z[ve][Te]=1,X[ve][Te]=X[ve-1][Te-1]+1;else throw new Error("not possible")}}if(ie&&we(ye,Le,ze,V),!tt[0]&&!x.firstMatchCanBeWeak)return;ve--,Te--;const at=[Q[ve][Te],V];let dt=0,ot=0;for(;ve>=1;){let Pe=Te;do{const Ie=Z[ve][Pe];if(Ie===3)Pe=Pe-2;else if(Ie===2)Pe=Pe-1;else break}while(Pe>=1);dt>1&&Re[Le+ve-1]===B[V+Te-1]&&!H(Pe+V-1,ze,B)&&dt+1>X[ve][Pe]&&(Pe=Te),Pe===Te?dt++:dt=1,ot||(ot=Pe),ve--,Te=Pe-1,at.push(Te)}$e===Y&&x.boostFullMatch&&(at[0]+=2);const rt=ot-Y;return at[0]-=rt,at}e.$fk=le;function de(ye,Re,Le,ze,B,V){let x=ye-1,Y=Re-1;for(;x>=Le&&Y>=ze;)B[x]===V[Y]&&(K[x]=Y,x--),Y--}function q(ye,Re,Le,ze,B,V,x,Y,$e,ve,Te){if(Re[Le]!==V[x])return Number.MIN_SAFE_INTEGER;let Ve=1,Qe=!1;return x===Le-ze?Ve=ye[Le]===B[x]?7:5:H(x,B,V)&&(x===0||!H(x-1,B,V))?(Ve=ye[Le]===B[x]?7:5,Qe=!0):ue(V,x)&&(x===0||!ue(V,x-1))?Ve=5:(ue(V,x-1)||ae(V,x-1))&&(Ve=5,Qe=!0),Ve>1&&Le===ze&&(Te[0]=!0),Qe||(Qe=H(x,B,V)||ue(V,x-1)||ae(V,x-1)),Le===ze?x>$e&&(Ve-=Qe?3:5):ve?Ve+=Qe?2:0:Ve+=Qe?0:1,x+1===Y&&(Ve-=Qe?3:5),Ve}function _(ye,Re,Le,ze,B,V,x){return me(ye,Re,Le,ze,B,V,!0,x)}e.$gk=_;function ge(ye,Re,Le,ze,B,V,x){return me(ye,Re,Le,ze,B,V,!1,x)}e.$hk=ge;function me(ye,Re,Le,ze,B,V,x,Y){let $e=le(ye,Re,Le,ze,B,V,Y);if($e&&!x)return $e;if(ye.length>=3){const ve=Math.min(7,ye.length-1);for(let Te=Le+1;Te<ve;Te++){const Ve=Ae(ye,Te);if(Ve){const Qe=le(Ve,Ve.toLowerCase(),Le,ze,B,V,Y);Qe&&(Qe[0]-=3,(!$e||Qe[0]>$e[0])&&($e=Qe))}}}return $e}function Ae(ye,Re){if(Re+1>=ye.length)return;const Le=ye[Re],ze=ye[Re+1];if(Le!==ze)return ye.slice(0,Re)+ze+Le+ye.slice(Re+2)}}),define(Se[54],De([1,0,12]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0;function O(o){return f(o,0)}e.$5i=O;function f(o,i){switch(typeof o){case"object":return o===null?R(349,i):Array.isArray(o)?$(o,i):k(o,i);case"string":return w(o,i);case"boolean":return L(o,i);case"number":return R(o,i);case"undefined":return R(937,i);default:return R(617,i)}}e.$6i=f;function R(o,i){return(i<<5)-i+o|0}e.$7i=R;function L(o,i){return R(o?433:863,i)}function w(o,i){i=R(149417,i);for(let n=0,s=o.length;n<s;n++)i=R(o.charCodeAt(n),i);return i}e.$8i=w;function $(o,i){return i=R(104579,i),o.reduce((n,s)=>f(s,n),i)}function k(o,i){return i=R(181387,i),Object.keys(o).sort().reduce((n,s)=>(n=w(s,n),f(o[s],n)),i)}class M{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$9i=M;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(o,i,n=32){const s=n-i,a=~((1<<s)-1);return(o<<i|(a&o)>>>s)>>>0}function S(o,i=0,n=o.byteLength,s=0){for(let a=0;a<n;a++)o[i+a]=s}function E(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function u(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):E((o>>>0).toString(16),i/4)}e.$0i=u;class b{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const s=this.p;let a=this.r,t=this.u,d,l;for(t!==0?(d=t,l=-1,t=0):(d=i.charCodeAt(0),l=0);;){let r=d;if(D.$nf(d))if(l+1<n){const c=i.charCodeAt(l+1);D.$of(c)?(l++,r=D.$pf(d,c)):r=65533}else{t=d;break}else D.$of(d)&&(r=65533);if(a=this.w(s,a,r),l++,l<n)d=i.charCodeAt(l);else break}this.r=a,this.u=t}w(i,n,s){return s<128?i[n++]=s:s<2048?(i[n++]=192|(s&1984)>>>6,i[n++]=128|(s&63)>>>0):s<65536?(i[n++]=224|(s&61440)>>>12,i[n++]=128|(s&4032)>>>6,i[n++]=128|(s&63)>>>0):(i[n++]=240|(s&1835008)>>>18,i[n++]=128|(s&258048)>>>12,i[n++]=128|(s&4032)>>>6,i[n++]=128|(s&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=b.g,n=this.q;for(let g=0;g<64;g+=4)i.setUint32(g,n.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)i.setUint32(g,p(i.getUint32(g-12,!1)^i.getUint32(g-32,!1)^i.getUint32(g-56,!1)^i.getUint32(g-64,!1),1),!1);let s=this.h,a=this.l,t=this.m,d=this.n,l=this.o,r,c,h;for(let g=0;g<80;g++)g<20?(r=a&t|~a&d,c=1518500249):g<40?(r=a^t^d,c=1859775393):g<60?(r=a&t|a&d|t&d,c=2400959708):(r=a^t^d,c=3395469782),h=p(s,5)+r+l+c+i.getUint32(g*4,!1)&4294967295,l=d,d=t,t=p(a,30),a=s,s=h;this.h=this.h+s&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+d&4294967295,this.o=this.o+l&4294967295}}e.$$i=b,b.g=new DataView(new ArrayBuffer(320))}),define(Se[126],De([1,0,124,125,54,17,9,12]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=e.$0q=e.$9q=e.$8q=void 0;const $=0,k=[$,[]];function M(F,G,K,X){if(!F||!G)return k;const Q=F.length,Z=G.length;if(Q<Z)return k;const ie=F.toLowerCase();return I(G,K,Z,F,ie,Q,X)}e.$8q=M;function I(F,G,K,X,Q,Z,ie){const ee=[],we=[];for(let fe=0;fe<K;fe++){const he=fe*Z,se=he-Z,ce=fe>0,le=F[fe],de=G[fe];for(let q=0;q<Z;q++){const _=q>0,ge=he+q,me=ge-1,Ae=se+q-1,ye=_?ee[me]:0,Re=ce&&_?ee[Ae]:0,Le=ce&&_?we[Ae]:0;let ze;!Re&&ce?ze=0:ze=p(le,de,X,Q,q,Le),ze&&Re+ze>=ye&&(ie||ce||Q.startsWith(G,q))?(we[ge]=Le+1,ee[ge]=Re+ze):(we[ge]=$,ee[ge]=ye)}}const ue=[];let ae=K-1,H=Z-1;for(;ae>=0&&H>=0;){const fe=ae*Z+H;we[fe]===$||(ue.push(H),ae--),H--}return[ee[K*Z-1],ue.reverse()]}function p(F,G,K,X,Q,Z){let ie=0;if(!S(G,X[Q]))return ie;if(ie+=1,Z>0&&(ie+=Z*5),F===K[Q]&&(ie+=1),Q===0)ie+=8;else{const ee=E(K.charCodeAt(Q-1));ee?ie+=ee:(0,O.$9j)(K.charCodeAt(Q))&&Z===0&&(ie+=2)}return ie}function S(F,G){return F===G?!0:F==="/"||F==="\\"?G==="/"||G==="\\":!1}function E(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function b(F,G,K=0,X=0){const Q=G;return Q.values&&Q.values.length>1?o(F,Q.values,K,X):i(F,G,K,X)}e.$9q=b;function o(F,G,K,X){let Q=0;const Z=[];for(const ie of G){const[ee,we]=i(F,ie,K,X);if(typeof ee!="number")return u;Q+=ee,Z.push(...we)}return[Q,C(Z)]}function i(F,G,K,X){const Q=(0,O.$fk)(G.original,G.originalLowercase,K,F,F.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,O.$ck)(Q)]:u}const n=Object.freeze({score:0}),s=1<<18,a=1<<17,t=65536;function d(F,G,K,X){const Q=X.values?X.values:[X];return(0,f.$5i)({[X.normalized]:{values:Q.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:F,description:G,allowNonContiguousMatches:K}})}function l(F,G,K,X,Q){if(!F||!G.normalized)return n;const Z=X.getItemLabel(F);if(!Z)return n;const ie=X.getItemDescription(F),ee=d(Z,ie,K,G),we=Q[ee];if(we)return we;const ue=r(Z,ie,X.getItemPath(F),G,K);return Q[ee]=ue,ue}e.$0q=l;function r(F,G,K,X,Q){const Z=!K||!X.containsPathSeparator;return K&&(L.$e?X.pathNormalized===K:(0,w.$jf)(X.pathNormalized,K))?{score:s,labelMatch:[{start:0,end:F.length}],descriptionMatch:G?[{start:0,end:G.length}]:void 0}:X.values&&X.values.length>1?c(F,G,K,X.values,Z,Q):h(F,G,K,X,Z,Q)}function c(F,G,K,X,Q,Z){let ie=0;const ee=[],we=[];for(const ue of X){const{score:ae,labelMatch:H,descriptionMatch:fe}=h(F,G,K,ue,Q,Z);if(ae===$)return n;ie+=ae,H&&ee.push(...H),fe&&we.push(...fe)}return{score:ie,labelMatch:C(ee),descriptionMatch:C(we)}}function h(F,G,K,X,Q,Z){if(Q||!G){const[ie,ee]=M(F,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(ie){const we=(0,O.$6j)(X.normalized,F);let ue;if(we){ue=a;const ae=Math.round(X.normalized.length/F.length*100);ue+=ae}else ue=t;return{score:ue+ie,labelMatch:we||g(ee)}}}if(G){let ie=G;K&&(ie=`${G}${R.sep}`);const ee=ie.length,we=`${ie}${F}`,[ue,ae]=M(we,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(ue){const H=g(ae),fe=[],he=[];return H.forEach(se=>{se.start<ee&&se.end>ee?(fe.push({start:0,end:se.end-ee}),he.push({start:se.start,end:ee})):se.start>=ee?fe.push({start:se.start-ee,end:se.end-ee}):he.push(se)}),{score:ue,labelMatch:fe,descriptionMatch:he}}}return n}function g(F){const G=[];if(!F)return G;let K;for(const X of F)K&&K.end===X?K.end+=1:(K={start:X,end:X+1},G.push(K));return G}function C(F){const G=F.sort((Q,Z)=>Q.start-Z.start),K=[];let X;for(const Q of G)!X||!v(X,Q)?(X=Q,K.push(Q)):(X.start=Math.min(X.start,Q.start),X.end=Math.max(X.end,Q.end));return K}function v(F,G){return!(F.end<G.start||G.end<F.start)}function m(F,G,K,X,Q,Z){const ie=l(F,K,X,Q,Z),ee=l(G,K,X,Q,Z),we=ie.score,ue=ee.score;if((we===s||ue===s)&&we!==ue)return we===s?-1:1;if(we>t||ue>t){if(we!==ue)return we>ue?-1:1;if(we<a&&ue<a){const le=P(ie.labelMatch,ee.labelMatch);if(le!==0)return le}const se=Q.getItemLabel(F)||"",ce=Q.getItemLabel(G)||"";if(se.length!==ce.length)return se.length-ce.length}if(we!==ue)return we>ue?-1:1;const ae=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,H=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(ae&&!H)return-1;if(H&&!ae)return 1;const fe=y(F,ie,Q),he=y(G,ee,Q);return fe&&he&&fe!==he?he>fe?-1:1:j(F,G,K,Q)}e.$$q=m;function y(F,G,K){let X=-1,Q=-1;if(G.descriptionMatch&&G.descriptionMatch.length?X=G.descriptionMatch[0].start:G.labelMatch&&G.labelMatch.length&&(X=G.labelMatch[0].start),G.labelMatch&&G.labelMatch.length){if(Q=G.labelMatch[G.labelMatch.length-1].end,G.descriptionMatch&&G.descriptionMatch.length){const Z=K.getItemDescription(F);Z&&(Q+=Z.length)}}else G.descriptionMatch&&G.descriptionMatch.length&&(Q=G.descriptionMatch[G.descriptionMatch.length-1].end);return Q-X}function P(F,G){if(!F&&!G||(!F||!F.length)&&(!G||!G.length))return 0;if(!G||!G.length)return-1;if(!F||!F.length)return 1;const K=F[0].start,Q=F[F.length-1].end-K,Z=G[0].start,ee=G[G.length-1].end-Z;return Q===ee?0:ee<Q?1:-1}function j(F,G,K,X){const Q=X.getItemLabel(F)||"",Z=X.getItemLabel(G)||"",ie=X.getItemDescription(F),ee=X.getItemDescription(G),we=Q.length+(ie?ie.length:0),ue=Z.length+(ee?ee.length:0);if(we!==ue)return we-ue;const ae=X.getItemPath(F),H=X.getItemPath(G);return ae&&H&&ae.length!==H.length?ae.length-H.length:Q!==Z?(0,D.$6q)(Q,Z,K.normalized):ie&&ee&&ie!==ee?(0,D.$6q)(ie,ee,K.normalized):ae&&H&&ae!==H?(0,D.$6q)(ae,H,K.normalized):0}function U(F){return F.startsWith('"')&&F.endsWith('"')}const z=" ";function N(F){typeof F!="string"&&(F="");const G=F.toLowerCase(),{pathNormalized:K,normalized:X,normalizedLowercase:Q}=A(F),Z=K.indexOf(R.sep)>=0,ie=U(F);let ee;const we=F.split(z);if(we.length>1)for(const ue of we){const ae=U(ue),{pathNormalized:H,normalized:fe,normalizedLowercase:he}=A(ue);fe&&(ee||(ee=[]),ee.push({original:ue,originalLowercase:ue.toLowerCase(),pathNormalized:H,normalized:fe,normalizedLowercase:he,expectContiguousMatch:ae}))}return{original:F,originalLowercase:G,pathNormalized:K,normalized:X,normalizedLowercase:Q,values:ee,containsPathSeparator:Z,expectContiguousMatch:ie}}e.$_q=N;function A(F){let G;L.$c?G=F.replace(/\//g,R.sep):G=F.replace(/\\/g,R.sep);const K=(0,w.$6e)(G).replace(/\s|"/g,"");return{pathNormalized:G,normalized:K,normalizedLowercase:K.toLowerCase()}}function T(F){return Array.isArray(F)?N(F.map(G=>G.original).join(z)):N(F.original)}e.$ar=T}),define(Se[40],De([1,0,12]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(O||(O={})),function(f){const R="error",L="warning",w="warn",$="info",k="ignore";function M(p){return p?D.$jf(R,p)?f.Error:D.$jf(L,p)||D.$jf(w,p)?f.Warning:D.$jf($,p)?f.Info:f.Ignore:f.Ignore}f.fromValue=M;function I(p){switch(p){case f.Error:return R;case f.Warning:return L;case f.Info:return $;default:return k}}f.toString=I}(O||(O={})),e.default=O}),define(Se[165],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(Se[77],De([1,0,19,12]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class f{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const E=S.charCodeAt(0),u=this.b.charCodeAt(this.c);return E-u}value(){return this.b[this.c]}}e.$gi=f;class R{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,O.$df)(S,this.b,0,S.length,this.c,this.d):(0,O.$ff)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=R;class L{constructor(S=!0,E=!0){this.f=S,this.g=E}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let E=S.length-1;E>=0;E--,this.c--){const u=this.b.charCodeAt(E);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const E=this.b.charCodeAt(this.e);if(E===47||this.f&&E===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,O.$df)(S,this.b,0,S.length,this.d,this.e):(0,O.$ff)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=L;var w;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(w||(w={}));class ${constructor(S,E){this.f=S,this.g=E,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,O.$ef)(S,this.c.scheme);if(this.d[this.e]===2)return(0,O.$ef)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,O.$cf)(S,this.c.query);if(this.d[this.e]===5)return(0,O.$cf)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(M||(M={}));class I{static forUris(S=()=>!1,E=()=>!1){return new I(new $(S,E))}static forPaths(S=!1){return new I(new L(void 0,!S))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new R)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,E){if(E){const u=E.slice(0);(0,D.$Xb)(u);for(const b of u)this.set(b,S)}else{const u=S.slice(0);(0,D.$Xb)(u);for(const b of u)this.set(b[0],b[1])}}set(S,E){const u=this.b.reset(S);let b;this.c||(this.c=new k,this.c.segment=u.value());const o=[];for(b=this.c;;){const n=u.cmp(b.segment);if(n>0)b.left||(b.left=new k,b.left.segment=u.value()),o.push([-1,b]),b=b.left;else if(n<0)b.right||(b.right=new k,b.right.segment=u.value()),o.push([1,b]),b=b.right;else if(u.hasNext())u.next(),b.mid||(b.mid=new k,b.mid.segment=u.value()),o.push([0,b]),b=b.mid;else break}const i=b.value;b.value=E,b.key=S;for(let n=o.length-1;n>=0;n--){const s=o[n][1];s.updateHeight();const a=s.balanceFactor();if(a<-1||a>1){const t=o[n][0],d=o[n+1][0];if(t===1&&d===1)o[n][1]=s.rotateLeft();else if(t===-1&&d===-1)o[n][1]=s.rotateRight();else if(t===1&&d===-1)s.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=s.rotateLeft();else if(t===-1&&d===1)s.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=s.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(S){return this.d(S)?.value}d(S){const E=this.b.reset(S);let u=this.c;for(;u;){const b=E.cmp(u.segment);if(b>0)u=u.left;else if(b<0)u=u.right;else if(E.hasNext())E.next(),u=u.mid;else break}return u}has(S){const E=this.d(S);return!(E?.value===void 0&&E?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,E){const u=this.b.reset(S),b=[];let o=this.c;for(;o;){const i=u.cmp(o.segment);if(i>0)b.push([-1,o]),o=o.left;else if(i<0)b.push([1,o]),o=o.right;else if(u.hasNext())u.next(),b.push([0,o]),o=o.mid;else break}if(o){if(E?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:s,segment:a}=i;this.e(i.key,!1),o.key=n,o.value=s,o.segment=a}}else{const i=o.left??o.right;if(b.length>0){const[n,s]=b[b.length-1];switch(n){case-1:s.left=i;break;case 0:s.mid=i;break;case 1:s.right=i;break}}else this.c=i}for(let i=b.length-1;i>=0;i--){const n=b[i][1];n.updateHeight();const s=n.balanceFactor();if(s>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),b[i][1]=n.rotateLeft()):s<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),b[i][1]=n.rotateRight()),i>0)switch(b[i-1][0]){case-1:b[i-1][1].left=b[i][1];break;case 1:b[i-1][1].right=b[i][1];break;case 0:b[i-1][1].mid=b[i][1];break}else this.c=b[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const E=this.b.reset(S);let u=this.c,b;for(;u;){const o=E.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(E.hasNext())E.next(),b=u.value||b,u=u.mid;else break}return u&&u.value||b}findSuperstr(S){return this.g(S,!1)}g(S,E){const u=this.b.reset(S);let b=this.c;for(;b;){const o=u.cmp(b.segment);if(o>0)b=b.left;else if(o<0)b=b.right;else if(u.hasNext())u.next(),b=b.mid;else return b.mid?this.h(b.mid):E?b.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[E,u]of this)S(u,E)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const E=[];return this.j(S,E),E[Symbol.iterator]()}j(S,E){S&&(S.left&&this.j(S.left,E),S.value&&E.push([S.key,S.value]),S.mid&&this.j(S.mid,E),S.right&&this.j(S.right,E))}_isBalanced(){const S=E=>{if(!E)return!0;const u=E.balanceFactor();return u<-1||u>1?!1:S(E.left)&&S(E.right)};return S(this.c)}}e.$ki=I}),define(Se[18],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=void 0;function D(a){return typeof a=="string"}e.$Sf=D;function O(a){return Array.isArray(a)&&a.every(t=>D(t))}e.$Tf=O;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Uf=f;function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Vf=R;function L(a){return typeof a=="number"&&!isNaN(a)}e.$Wf=L;function w(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Xf=w;function $(a){return a===!0||a===!1}e.$Yf=$;function k(a){return typeof a>"u"}e.$Zf=k;function M(a){return!I(a)}e.$1f=M;function I(a){return k(a)||a===null}e.$2f=I;function p(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$3f=p;function S(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$4f=S;function E(...a){const t=[];for(let d=0;d<a.length;d++){const l=a[d];if(I(l))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);t.push(l)}return t}e.$5f=E;const u=Object.prototype.hasOwnProperty;function b(a){if(!f(a))return!1;for(const t in a)if(u.call(a,t))return!1;return!0}e.$6f=b;function o(a){return typeof a=="function"}e.$7f=o;function i(...a){return a.length>0&&a.every(o)}e.$8f=i;function n(a,t){const d=Math.min(a.length,t.length);for(let l=0;l<d;l++)s(a[l],t[l])}e.$9f=n;function s(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!I(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$0f=s}),define(Se[78],De([1,0,18]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=void 0;const O=Object.create(null);function f(w,$){if((0,D.$Sf)($)){const k=O[$];if(k===void 0)throw new Error(`${w} references an unknown codicon: ${$}`);$=k}return O[w]=$,{id:w}}function R(){return O}e.$ik=R;function L(){return Object.values(e.$kk)}e.$jk=L,e.$kk={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugBreakpointPending:f("debug-breakpoint-pending",60377),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),lightbulbSparkle:f("lightbulb-sparkle",60447),lightbulbSparkleAutofix:f("lightbulb-sparkle-autofix",60447),robot:f("robot",60448),sparkleFilled:f("sparkle-filled",60449),diffSingle:f("diff-single",60450),diffMultiple:f("diff-multiple",60451),surroundWith:f("surround-with",60452),gitStash:f("git-stash",60454),gitStashApply:f("git-stash-apply",60455),gitStashPop:f("git-stash-pop",60456),runAllCoverage:f("run-all-coverage",60461),runCoverage:f("run-all-coverage",60460),coverage:f("coverage",60462),githubProject:f("github-project",60463),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(Se[34],De([1,0,17,9,12,18]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function L(h){return h===47||h===92}e.$$f=L;function w(h){return h.replace(/[\\/]/g,D.$gc.sep)}e.$_f=w;function $(h){return h.indexOf("/")===-1&&(h=w(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$ag=$;function k(h,g=D.$gc.sep){if(!h)return"";const C=h.length,v=h.charCodeAt(0);if(L(v)){if(L(h.charCodeAt(1))&&!L(h.charCodeAt(2))){let y=3;const P=y;for(;y<C&&!L(h.charCodeAt(y));y++);if(P!==y&&!L(h.charCodeAt(y+1))){for(y+=1;y<C;y++)if(L(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,g)}}return g}else if(o(v)&&h.charCodeAt(1)===58)return L(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let m=h.indexOf("://");if(m!==-1){for(m+=3;m<C;m++)if(L(h.charCodeAt(m)))return h.slice(0,m+1)}return""}e.$bg=k;function M(h){if(!O.$c||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let C=2;const v=C;for(;C<h.length&&(g=h.charCodeAt(C),g!==92);C++);return!(v===C||(g=h.charCodeAt(C+1),isNaN(g)||g===92))}e.$cg=M;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(h,g=O.$c){const C=g?I:p;return!(!h||h.length===0||/^\s+$/.test(h)||(C.lastIndex=0,C.test(h))||g&&S.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}e.$dg=E;function u(h,g,C){const v=h===g;return!C||v?v:!h||!g?!1:(0,f.$jf)(h,g)}e.$eg=u;function b(h,g,C,v=D.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(C){if(!(0,f.$kf)(h,g))return!1;if(g.length===h.length)return!0;let y=g.length;return g.charAt(g.length-1)===v&&y--,h.charAt(y)===v}return g.charAt(g.length-1)!==v&&(g+=v),h.indexOf(g)===0}e.$fg=b;function o(h){return h>=65&&h<=90||h>=97&&h<=122}e.$gg=o;function i(h,g){return O.$c&&h.endsWith(":")&&(h+=D.sep),(0,D.$ic)(h)||(h=(0,D.$jc)(g,h)),h=(0,D.$hc)(h),O.$c?(h=(0,f.$4e)(h,D.sep),h.endsWith(":")&&(h+=D.sep)):(h=(0,f.$4e)(h,D.sep),h||(h=D.sep)),h}e.$hg=i;function n(h){const g=(0,D.$hc)(h);return O.$c?h.length>3?!1:s(g)&&(h.length===2||g.charCodeAt(2)===92):g===D.$gc.sep}e.$ig=n;function s(h,g=O.$c){return g?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$jg=s;function a(h,g=O.$c){return s(h,g)?h[0]:void 0}e.$kg=a;function t(h,g,C){return g.length>h.length?-1:h===g?0:(C&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}e.$lg=t;function d(h){const g=h.split(":");let C,v,m;for(const y of g){const P=Number(y);(0,R.$Wf)(P)?v===void 0?v=P:m===void 0&&(m=P):C=C?[C,y].join(":"):y}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:v!==void 0?v:void 0,column:m!==void 0?m:v!==void 0?1:void 0}}e.$mg=d;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,g,C=8){let v="";for(let y=0;y<C;y++){let P;y===0&&O.$c&&!g&&(C===3||C===4)?P=r:P=l,v+=P.charAt(Math.floor(Math.random()*P.length))}let m;return g?m=`${g}-${v}`:m=v,h?(0,D.$jc)(h,m):m}e.$ng=c}),define(Se[24],De([1,0,18]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=void 0;function O(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,s])=>{i[n]=s&&typeof s=="object"?O(s):s}),i}e.$In=O;function f(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const s in n)if(R.call(n,s)){const a=n[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$Vf)(a)&&i.push(a)}}return o}e.$Jn=f;const R=Object.prototype.hasOwnProperty;function L(o,i){return w(o,i,new Set)}e.$Kn=L;function w(o,i,n){if((0,D.$2f)(o))return o;const s=i(o);if(typeof s<"u")return s;if(Array.isArray(o)){const a=[];for(const t of o)a.push(w(t,i,n));return a}if((0,D.$Uf)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)R.call(o,t)&&(a[t]=w(o[t],i,n));return n.delete(o),a}return o}function $(o,i,n=!0){return(0,D.$Uf)(o)?((0,D.$Uf)(i)&&Object.keys(i).forEach(s=>{s in o?n&&((0,D.$Uf)(o[s])&&(0,D.$Uf)(i[s])?$(o[s],i[s],n):o[s]=i[s]):o[s]=i[s]}),o):i}e.$Ln=$;function k(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,s;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!k(o[n],i[n]))return!1}else{const a=[];for(s in o)a.push(s);a.sort();const t=[];for(s in i)t.push(s);if(t.sort(),!k(a,t))return!1;for(n=0;n<a.length;n++)if(!k(o[a[n]],i[a[n]]))return!1}return!0}e.$Mn=k;function M(o){const i=new Set;return JSON.stringify(o,(n,s)=>{if((0,D.$Uf)(s)||Array.isArray(s)){if(i.has(s))return"[Circular]";i.add(s)}return s})}e.$Nn=M;function I(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],d=i[a];k(t,d)||(n[a]=d)}),n}e.$On=I;function p(o,i){const n=i.toLowerCase(),s=Object.keys(o).find(a=>a.toLowerCase()===n);return s?o[s]:o[i]}e.$Pn=p;function S(o,i){const n=Object.create(null);for(const[s,a]of Object.entries(o))i(s,a)&&(n[s]=a);return n}e.$Qn=S;function E(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$Rn=E;function u(o){const i=[];for(const n of E(o))typeof o[n]=="function"&&i.push(n);return i}e.$Sn=u;function b(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},s={};for(const a of o)s[a]=n(a);return s}e.$Tn=b}),define(Se[55],De([1,0,78]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$lk=e.ThemeColor=void 0;var O;(function(L){function w($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=w})(O||(e.ThemeColor=O={}));function f(L){return{id:L}}e.$lk=f;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(i){const n=w.exec(i.id);if(!n)return $(D.$kk.error);const[,s,a]=n,t=["codicon","codicon-"+s];return a&&t.push("codicon-modifier-"+a.substring(1)),t}L.asClassNameArray=$;function k(i){return $(i).join(" ")}L.asClassName=k;function M(i){return"."+$(i).join(".")}L.asCSSSelector=M;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}L.isThemeIcon=I;const p=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function S(i){const n=p.exec(i);if(!n)return;const[,s]=n;return{id:s}}L.fromString=S;function E(i){return{id:i}}L.fromId=E;function u(i,n){let s=i.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),n&&(s=`${s}~${n}`),{id:s}}L.modify=u;function b(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}L.getModifier=b;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}L.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(Se[166],De([1,0,125,12,55]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;const R="$(",L=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${L.source}`,"g");function $(o){return o.replace(w,(i,n)=>n?i:`\\${i}`)}e.$mk=$;const k=new RegExp(`\\\\${L.source}`,"g");function M(o){return o.replace(k,i=>`\\${i}`)}e.$nk=M;const I=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function p(o){return o.indexOf(R)===-1?o:o.replace(I,(i,n,s,a)=>s?i:n||a||"")}e.$ok=p;function S(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$pk=S;const E=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(o){E.lastIndex=0;let i="";const n=[];let s=0;for(;;){const a=E.lastIndex,t=E.exec(o),d=o.substring(a,t?.index);if(d.length>0){i+=d;for(let l=0;l<d.length;l++)n.push(s)}if(!t)break;s+=t[0].length}return{text:i,iconOffsets:n}}e.$qk=u;function b(o,i,n=!1){const{text:s,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.$_j)(o,s,n);const t=(0,O.$3e)(s," "),d=s.length-t.length,l=(0,D.$_j)(o,t,n);if(l)for(const r of l){const c=a[r.start+d]+d;r.start+=c,r.end+=c}return l}e.$rk=b}),define(Se[127],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.Constants=void 0;var D;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function O(R){return R<0?0:R>255?255:R|0}e.$Qe=O;function f(R){return R<0?0:R>4294967295?4294967295:R|0}e.$Re=f}),define(Se[2],De([1,0,17,9]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,R=/^\//,L=/^\/\//;function w(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!f.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(r,c){return!r&&!c?"file":r}function k(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const M="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(c){return c instanceof S?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,g,C,v,m=!1){typeof c=="object"?(this.scheme=c.scheme||M,this.authority=c.authority||M,this.path=c.path||M,this.query=c.query||M,this.fragment=c.fragment||M):(this.scheme=$(c,m),this.authority=h||M,this.path=k(this.scheme,g||M),this.query=C||M,this.fragment=v||M,w(this,m))}get fsPath(){return s(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:g,path:C,query:v,fragment:m}=c;return h===void 0?h=this.scheme:h===null&&(h=M),g===void 0?g=this.authority:g===null&&(g=M),C===void 0?C=this.path:C===null&&(C=M),v===void 0?v=this.query:v===null&&(v=M),m===void 0?m=this.fragment:m===null&&(m=M),h===this.scheme&&g===this.authority&&C===this.path&&v===this.query&&m===this.fragment?this:new b(h,g,C,v,m)}static parse(c,h=!1){const g=p.exec(c);return g?new b(g[2]||M,l(g[4]||M),l(g[5]||M),l(g[7]||M),l(g[9]||M),h):new b(M,M,M,M,M)}static file(c){let h=M;if(O.$c&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const g=c.indexOf(I,2);g===-1?(h=c.substring(2),c=I):(h=c.substring(2,g),c=c.substring(g)||I)}return new b("file",h,c,M,M)}static from(c,h){return new b(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return O.$c&&c.scheme==="file"?g=S.file(D.$fc.join(s(c,!0),...h)).path:g=D.$gc.join(c.path,...h),c.with({path:g})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof S)return c;{const h=new b(c);return h._formatted=c.external??null,h._fsPath=c._sep===u?c.fsPath??null:null,h}}else return c}}e.URI=S;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}e.$vc=E;const u=O.$c?1:void 0;class b extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=u),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(r,c,h){let g,C=-1;for(let v=0;v<r.length;v++){const m=r.charCodeAt(v);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||c&&m===47||h&&m===91||h&&m===93||h&&m===58)C!==-1&&(g+=encodeURIComponent(r.substring(C,v)),C=-1),g!==void 0&&(g+=r.charAt(v));else{g===void 0&&(g=r.substr(0,v));const y=o[m];y!==void 0?(C!==-1&&(g+=encodeURIComponent(r.substring(C,v)),C=-1),g+=y):C===-1&&(C=v)}}return C!==-1&&(g+=encodeURIComponent(r.substring(C))),g!==void 0?g:r}function n(r){let c;for(let h=0;h<r.length;h++){const g=r.charCodeAt(h);g===35||g===63?(c===void 0&&(c=r.substr(0,h)),c+=o[g]):c!==void 0&&(c+=r[h])}return c!==void 0?c:r}function s(r,c){let h;return r.authority&&r.path.length>1&&r.scheme==="file"?h=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?h=r.path.substr(1):h=r.path[1].toLowerCase()+r.path.substr(2):h=r.path,O.$c&&(h=h.replace(/\//g,"\\")),h}e.$wc=s;function a(r,c){const h=c?n:i;let g="",{scheme:C,authority:v,path:m,query:y,fragment:P}=r;if(C&&(g+=C,g+=":"),(v||C==="file")&&(g+=I,g+=I),v){let j=v.indexOf("@");if(j!==-1){const U=v.substr(0,j);v=v.substr(j+1),j=U.lastIndexOf(":"),j===-1?g+=h(U,!1,!1):(g+=h(U.substr(0,j),!1,!1),g+=":",g+=h(U.substr(j+1),!1,!0)),g+="@"}v=v.toLowerCase(),j=v.lastIndexOf(":"),j===-1?g+=h(v,!1,!0):(g+=h(v.substr(0,j),!1,!0),g+=v.substr(j))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const j=m.charCodeAt(1);j>=65&&j<=90&&(m=`/${String.fromCharCode(j+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const j=m.charCodeAt(0);j>=65&&j<=90&&(m=`${String.fromCharCode(j+32)}:${m.substr(2)}`)}g+=h(m,!0,!1)}return y&&(g+="?",g+=h(y,!1,!1)),P&&(g+="#",g+=c?P:i(P,!1,!1)),g}function t(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+t(r.substr(3)):r}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(r){return r.match(d)?r.replace(d,c=>t(c)):r}}),define(Se[167],De([1,0,2]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Aq=e.$zq=e.$yq=void 0;function O(k){const M=k;return M&&typeof M.type=="string"&&typeof M.severity=="string"}e.$yq=O;function f(k){const M=[];let I;try{const p=JSON.parse(k.arguments),S=p[p.length-1];S&&S.__$stack&&(p.pop(),I=S.__$stack),M.push(...p)}catch{M.push("Unable to log remote console arguments",k.arguments)}return{args:M,stack:I}}e.$zq=f;function R(k){if(typeof k!="string")return R(f(k).stack);const M=k;if(M){const I=L(M),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Aq=R;function L(k){if(!k)return k;const M=k.indexOf(`
`);return M===-1?k:k.substring(0,M)}function w(k,M){const{args:I,stack:p}=f(k),S=typeof I[0]=="string"&&I.length===1;let E=L(p);E&&(E=`(${E.trim()})`);let u=[];if(typeof I[0]=="string"?E&&S?u=[`%c[${M}] %c${I[0]} %c${E}`,$("blue"),$(""),$("grey")]:u=[`%c[${M}] %c${I[0]}`,$("blue"),$(""),...I.slice(1)]:u=[`%c[${M}]%`,$("blue"),...I],E&&!S&&u.push(E),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,u)}e.log=w;function $(k){return`color: ${k}`}}),define(Se[56],De([1,0,21,2]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function f($){return JSON.stringify($,L)}e.$Lh=f;function R($){let k=JSON.parse($);return k=w(k),k}e.$Mh=R;function L($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function w($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return O.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$se||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let M=0;M<$.length;++M)$[M]=w($[M],k+1);else for(const M in $)Object.hasOwnProperty.call($,M)&&($[M]=w($[M],k+1))}return $}e.$Nh=w}),define(Se[16],De([1,0,14,9,12,2]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var L;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.codeSetting="code-setting",p.codeFeature="code-feature"})(L||(e.Schemas=L={}));function w(p,S){return R.URI.isUri(p)?(0,f.$jf)(p.scheme,S):(0,f.$kf)(p,S+":")}e.$og=w;function $(p,...S){return S.some(E=>w(p,E))}e.$pg=$,e.$qg="vscode-tkn",e.$rg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${L.vscodeRemoteResource}`}set(S,E,u){this.a[S]=E,this.b[S]=u}setConnectionToken(S,E){this.c[S]=E}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)try{return this.e(S)}catch(n){return D.$1(n),S}const E=S.authority;let u=this.a[E];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[E],o=this.c[E];let i=`path=${encodeURIComponent(S.path)}`;return typeof o=="string"&&(i+=`&${e.$rg}=${encodeURIComponent(o)}`),R.URI.from({scheme:O.$i?this.d:L.vscodeRemoteResource,authority:`${u}:${b}`,path:O.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:i})}}e.$sg=new k,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class M{asBrowserUri(S){const E=this.b(S,re);return this.uriToBrowserUri(E)}uriToBrowserUri(S){return S.scheme===L.vscodeRemote?e.$sg.rewrite(S):S.scheme===L.file&&(O.$g||O.$k===`${L.vscodeFileResource}://${M.a}`)?S.with({scheme:L.vscodeFileResource,authority:S.authority||M.a,query:null,fragment:null}):S}asFileUri(S){const E=this.b(S,re);return this.uriToFileUri(E)}uriToFileUri(S){return S.scheme===L.vscodeFileResource?S.with({scheme:L.file,authority:S.authority!==M.a?S.authority:null,query:null,fragment:null}):S}b(S,E){return R.URI.isUri(S)?S:R.URI.parse(E.toUrl(S))}}M.a=e.$xg,e.$yg=new M;var I;(function(p){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(S.get("3"));const E="vscode-coi";function u(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:R.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const n=i?.get(E);if(n)return S.get(n)}p.getHeadersFromQuery=u;function b(o,i,n){if(!globalThis.crossOriginIsolated)return;const s=i&&n?"3":n?"2":"1";o instanceof URLSearchParams?o.set(E,s):o[E]=s}p.addSearchParam=b})(I||(e.COI=I={}))}),define(Se[168],De([1,0,159,16,9,2]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=void 0;class L{constructor(p,S,E){this.id=p,this.dependencies=S,this.callback=E}}class w{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,S,E)=>{typeof p!="string"&&(E=S,S=p,p=null),(typeof S!="object"||!Array.isArray(S))&&(E=S,S=null),this.c.push(new L(p,S,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const S=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!S)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(p){return new Promise((S,E)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const b=()=>{u.removeEventListener("load",o),u.removeEventListener("error",i)},o=n=>{b(),S(this.c.pop())},i=n=>{b(),E(n)};u.addEventListener("load",o),u.addEventListener("error",i),this.f&&(p=this.f.createScriptURL(p)),u.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(u)})}i(p){return new Promise((S,E)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),S(this.c.pop())}catch(u){E(u)}})}async j(p){try{const S=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,b=R.URI.parse(p).fsPath,o=S.readFileSync(b).toString(),i=u.wrap(o.replace(/^#!.*/,""));return new E.Script(i).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}w.INSTANCE=new w;const $=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function M(I,p,S){if(D.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[I]&&(I=k[I]);const E=`${I}/${p}`;if($.has(E))return $.get(E);let u;if(/^\w[\w\d+.-]*:\/\//.test(E))u=E;else{const n=`${S&&!f.$i?O.$vg:O.$ug}/${E}`;u=O.$yg.asBrowserUri(n).toString(!0)}const b=w.INSTANCE.load(u);return $.set(E,b),b}else return await new Promise((E,u)=>{re([I],E,u)})}e.$uD=M}),define(Se[23],De([1,0,34,16,17,9,12,2]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function $(S){return(0,w.$wc)(S,!0)}e.$Fg=$;class k{constructor(E){this.a=E}compare(E,u,b=!1){return E===u?0:(0,L.$cf)(this.getComparisonKey(E,b),this.getComparisonKey(u,b))}isEqual(E,u,b=!1){return E===u?!0:!E||!u?!1:this.getComparisonKey(E,b)===this.getComparisonKey(u,b)}getComparisonKey(E,u=!1){return E.with({path:this.a(E)?E.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(E){return this.a(E)}isEqualOrParent(E,u,b=!1){if(E.scheme===u.scheme){if(E.scheme===O.Schemas.file)return D.$fg($(E),$(u),this.a(E))&&E.query===u.query&&(b||E.fragment===u.fragment);if((0,e.$Wg)(E.authority,u.authority))return D.$fg(E.path,u.path,this.a(E),"/")&&E.query===u.query&&(b||E.fragment===u.fragment)}return!1}joinPath(E,...u){return w.URI.joinPath(E,...u)}basenameOrAuthority(E){return(0,e.$Og)(E)||E.authority}basename(E){return f.$gc.basename(E.path)}extname(E){return f.$gc.extname(E.path)}dirname(E){if(E.path.length===0)return E;let u;return E.scheme===O.Schemas.file?u=w.URI.file(f.$mc($(E))).path:(u=f.$gc.dirname(E.path),E.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),u="/")),E.with({path:u})}normalizePath(E){if(!E.path.length)return E;let u;return E.scheme===O.Schemas.file?u=w.URI.file(f.$hc($(E))).path:u=f.$gc.normalize(E.path),E.with({path:u})}relativePath(E,u){if(E.scheme!==u.scheme||!(0,e.$Wg)(E.authority,u.authority))return;if(E.scheme===O.Schemas.file){const i=f.$lc($(E),$(u));return R.$c?D.$_f(i):i}let b=E.path||"/";const o=u.path||"/";if(this.a(E)){let i=0;for(const n=Math.min(b.length,o.length);i<n&&!(b.charCodeAt(i)!==o.charCodeAt(i)&&b.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);b=o.substr(0,i)+b.substr(i)}return f.$gc.relative(b,o)}resolvePath(E,u){if(E.scheme===O.Schemas.file){const b=w.URI.file(f.$kc($(E),u));return E.with({authority:b.authority,path:b.path})}return u=D.$ag(u),E.with({path:f.$gc.resolve(E.path,u)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,u){return E===u||E!==void 0&&u!==void 0&&(0,L.$jf)(E,u)}hasTrailingPathSeparator(E,u=f.sep){if(E.scheme===O.Schemas.file){const b=$(E);return b.length>D.$bg(b).length&&b[b.length-1]===u}else{const b=E.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,u=f.sep){return(0,e.$Xg)(E,u)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,u=f.sep){let b=!1;if(E.scheme===O.Schemas.file){const o=$(E);b=o!==void 0&&o.length===D.$bg(o).length&&o[o.length-1]===u}else{u="/";const o=E.path;b=o.length===1&&o.charCodeAt(o.length-1)===47}return!b&&!(0,e.$Xg)(E,u)?E.with({path:E.path+"/"}):E}}e.$Gg=k,e.$Hg=new k(()=>!1),e.$Ig=new k(S=>S.scheme===O.Schemas.file?!R.$e:!0),e.$Jg=new k(S=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function M(S,E){const u=[];for(let b=0;b<S.length;b++){const o=E(S[b]);S.some((i,n)=>n===b?!1:(0,e.$Lg)(o,E(i)))||u.push(S[b])}return u}e.$1g=M;var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function E(u){const b=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(n=>{const[s,a]=n.split(":");s&&a&&b.set(s,a)});const i=u.path.substring(0,u.path.indexOf(";"));return i&&b.set(S.META_DATA_MIME,i),b}S.parseMetaData=E})(I||(e.DataUri=I={}));function p(S,E,u){if(E){let b=S.path;return b&&b[0]!==f.$gc.sep&&(b=f.$gc.sep+b),S.with({scheme:u,authority:E,path:b})}return S.with({scheme:u})}e.$2g=p}),define(Se[8],De([1,0,22,14,4,3,23,9,165,44]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function M(de){return!!de&&typeof de.then=="function"}e.$3g=M;function I(de){const q=new D.$ce,_=de(q.token),ge=new Promise((me,Ae)=>{const ye=q.token.onCancellationRequested(()=>{ye.dispose(),Ae(new O.$5)});Promise.resolve(_).then(Re=>{ye.dispose(),q.dispose(),me(Re)},Re=>{ye.dispose(),q.dispose(),Ae(Re)})});return new class{cancel(){q.cancel(),q.dispose()}then(me,Ae){return ge.then(me,Ae)}catch(me){return this.then(void 0,me)}finally(me){return ge.finally(me)}}}e.$4g=I;function p(de,q,_){return new Promise((ge,me)=>{const Ae=q.onCancellationRequested(()=>{Ae.dispose(),ge(_)});de.then(ge,me).finally(()=>Ae.dispose())})}e.$5g=p;function S(de,q){return new Promise((_,ge)=>{const me=q.onCancellationRequested(()=>{me.dispose(),ge(new O.$5)});de.then(_,ge).finally(()=>me.dispose())})}e.$6g=S;async function E(de){let q=-1;const _=de.map((ge,me)=>ge.then(Ae=>(q=me,Ae)));try{return await Promise.race(_)}finally{de.forEach((ge,me)=>{me!==q&&ge.cancel()})}}e.$7g=E;function u(de,q,_){let ge;const me=setTimeout(()=>{ge?.(void 0),_?.()},q);return Promise.race([de.finally(()=>clearTimeout(me)),new Promise(Ae=>ge=Ae)])}e.$8g=u;function b(de){return new Promise((q,_)=>{const ge=de();M(ge)?ge.then(q,_):q(ge)})}e.$9g=b;function o(){let de,q;return{promise:new Promise((ge,me)=>{de=ge,q=me}),resolve:de,reject:q}}e.$0g=o;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const _=()=>{if(this.b=null,this.f)return;const ge=this.queue(this.d);return this.d=null,ge};this.b=new Promise(ge=>{this.a.then(_,_).then(ge)})}return new Promise((_,ge)=>{this.b.then(_,ge)})}return this.a=q(),new Promise((_,ge)=>{this.a.then(me=>{this.a=null,_(me)},me=>{this.a=null,ge(me)})})}dispose(){this.f=!0}}e.$$g=i;class n{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$_g=n;class s{constructor(){this.a=new Map}queue(q,_){const me=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(q)===me&&this.a.delete(q)});return this.a.set(q,me),me}}e.$ah=s;const a=(de,q)=>{let _=!0;const ge=setTimeout(()=>{_=!1,q()},de);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ge),_=!1}}},t=de=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,de())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class d{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,_=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((me,Ae)=>{this.d=me,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ge=()=>{this.a=null,this.d?.(null)};return this.a=_===$.$2d?t(ge):a(_,ge),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=d;class l{constructor(q){this.a=new d(q),this.b=new i}trigger(q,_){return this.a.trigger(()=>this.b.queue(q),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=l;class r{constructor(){this.a=!1,this.b=new Promise((q,_)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=r;class c extends r{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$eh=c;function h(de,q){return q?new Promise((_,ge)=>{const me=setTimeout(()=>{Ae.dispose(),_()},de),Ae=q.onCancellationRequested(()=>{clearTimeout(me),Ae.dispose(),ge(new O.$5)})}):I(_=>h(de,_))}e.$fh=h;function g(de,q=0,_){const ge=setTimeout(()=>{de(),_&&me.dispose()},q),me=(0,R.$Rc)(()=>{clearTimeout(ge),_?.deleteAndLeak(me)});return _?.add(me),me}e.$gh=g;function C(de){const q=[];let _=0;const ge=de.length;function me(){return _<ge?de[_++]():null}function Ae(ye){ye!=null&&q.push(ye);const Re=me();return Re?Re.then(Ae):Promise.resolve(q)}return Promise.resolve(null).then(Ae)}e.$hh=C;function v(de,q=ge=>!!ge,_=null){let ge=0;const me=de.length,Ae=()=>{if(ge>=me)return Promise.resolve(_);const ye=de[ge++];return Promise.resolve(ye()).then(Le=>q(Le)?Promise.resolve(Le):Ae())};return Ae()}e.$ih=v;function m(de,q=ge=>!!ge,_=null){if(de.length===0)return Promise.resolve(_);let ge=de.length;const me=()=>{ge=-1;for(const Ae of de)Ae.cancel?.()};return new Promise((Ae,ye)=>{for(const Re of de)Re.then(Le=>{--ge>=0&&q(Le)?(me(),Ae(Le)):ge===0&&Ae(_)}).catch(Le=>{--ge>=0&&(me(),ye(Le))})})}e.$jh=m;class y{constructor(q){this.a=0,this.b=!1,this.f=q,this.g=[],this.d=0,this.h=new f.$5d}whenIdle(){return this.size>0?f.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((_,ge)=>{this.g.push({factory:q,c:_,e:ge}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const q=this.g.shift();this.d++;const _=q.factory();_.then(q.c,q.e),_.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=y;class P extends y{constructor(){super(1)}}e.$lh=P;class j{constructor(){this.a=new Z,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$mh=j;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new we;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueSize(q,_=L.$Hg){const ge=_.getComparisonKey(q);return this.a.get(ge)?.size??0}queueFor(q,_,ge=L.$Hg){const me=ge.getComparisonKey(q);let Ae=this.a.get(me);if(!Ae){Ae=new P;const ye=this.f++,Re=f.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$3c),this.d.set(ye,Re),this.a.set(me,Ae)}return Ae.queue(_)}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=U;class z{constructor(q,_){this.a=-1,typeof q=="function"&&typeof _=="number"&&this.setIfNotSet(q,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},_)}setIfNotSet(q,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},_))}}e.$oh=z;class N{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(q,_,ge=globalThis){this.cancel();const me=ge.setInterval(()=>{q()},_);this.d=(0,R.$Rc)(()=>{ge.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$ph=N;class A{constructor(q,_){this.b=-1,this.a=q,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=A;class T{constructor(q,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=q,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=T;class F extends A{constructor(q,_){super(q,_),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$sh=F;class G extends R.$Tc{constructor(q,_){super(),this.g=q,this.h=_,this.a=[],this.b=this.B(new R.$Uc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of q)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(de,q)=>{(0,w.$v)(()=>{if(_)return;const ge=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$vh=(de,q,_)=>{const ge=de.requestIdleCallback(q,typeof _=="number"?{timeout:_}:void 0);let me=!1;return{dispose(){me||(me=!0,de.cancelIdleCallback(ge))}}},e.$uh=de=>(0,e.$vh)(globalThis,de)}();class K{constructor(q,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(ge){this.l=ge}finally{this.g=!0}},this.f=(0,e.$vh)(q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=K;class X extends K{constructor(q){super(globalThis,q)}}e.$xh=X;async function Q(de,q,_){let ge;for(let me=0;me<_;me++)try{return await de()}catch(Ae){ge=Ae,await h(q)}throw ge}e.$yh=Q;class Z{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,_,ge){return this.a={taskId:q,cancel:()=>ge?.(),promise:_},_.then(()=>this.d(q),()=>this.d(q)),_}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{const{promise:_,resolve:ge,reject:me}=o();this.b={run:q,promise:_,promiseResolve:ge,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=Z;class ie{constructor(q,_=()=>Date.now()){this.d=q,this.f=_,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Ah=ie;var ee;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(ee||(ee={}));class we{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,_)=>{this.a=q,this.b=_})}complete(q){return new Promise(_=>{this.a(q),this.d={outcome:0,value:q},_()})}error(q){return new Promise(_=>{this.b(q),this.d={outcome:1,value:q},_()})}cancel(){return this.error(new O.$5)}}e.$Bh=we;var ue;(function(de){async function q(ge){let me;const Ae=await Promise.all(ge.map(ye=>ye.then(Re=>Re,Re=>{me||(me=Re)})));if(typeof me<"u")throw me;return Ae}de.settled=q;function _(ge){return new Promise(async(me,Ae)=>{try{await ge(me,Ae)}catch(ye){Ae(ye)}})}de.withAsyncBody=_})(ue||(e.Promises=ue={}));class ae{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=q.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=ae;class H{constructor(q){this.b=q,this.a=new k.$V(()=>new ae(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=H;var fe;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(fe||(fe={}));class he{static fromArray(q){return new he(_=>{_.emitMany(q)})}static fromPromise(q){return new he(async _=>{_.emitMany(await q)})}static fromPromises(q){return new he(async _=>{await Promise.all(q.map(async ge=>_.emitOne(await ge)))})}static merge(q){return new he(async _=>{await Promise.all(q.map(async ge=>{for await(const me of ge)_.emitOne(me)}))})}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new f.$5d,queueMicrotask(async()=>{const _={emitOne:ge=>this.g(ge),emitMany:ge=>this.h(ge),reject:ge=>this.k(ge)};try{await Promise.resolve(q(_)),this.j()}catch(ge){this.k(ge)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(q,_){return new he(async ge=>{for await(const me of q)ge.emitOne(_(me))})}map(q){return he.map(this,q)}static filter(q,_){return new he(async ge=>{for await(const me of q)_(me)&&ge.emitOne(me)})}filter(q){return he.filter(this,q)}static coalesce(q){return he.filter(q,_=>!!_)}coalesce(){return he.coalesce(this)}static async toPromise(q){const _=[];for await(const ge of q)_.push(ge);return _}toPromise(){return he.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$Eh=he,he.EMPTY=he.fromArray([]);class se extends he{constructor(q,_){super(_),this.l=q}cancel(){this.l.cancel()}}e.$Fh=se;function ce(de){const q=new D.$ce,_=de(q.token);return new se(q,async ge=>{const me=q.token.onCancellationRequested(()=>{me.dispose(),q.dispose(),ge.reject(new O.$5)});try{for await(const Ae of _){if(q.token.isCancellationRequested)return;ge.emitOne(Ae)}me.dispose(),q.dispose()}catch(Ae){me.dispose(),q.dispose(),ge.reject(Ae)}})}e.$Gh=ce;class le{constructor(){this.a=new we,this.b=new he(ge=>{if(q){ge.reject(q);return}return _&&ge.emitMany(_),this.d=me=>ge.reject(me),this.f=me=>ge.emitOne(me),this.a.p});let q,_;this.f=ge=>{_||(_=[]),_.push(ge)},this.d=ge=>{q||(q=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(q){this.d(q),this.a.complete()}emitOne(q){this.f(q)}}e.$Hh=le}),define(Se[35],De([1,0,19,8,34,28,17,9,12]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;function k(){return Object.create(null)}e.$Sj=k,e.$Tj="**",e.$Uj="/";const M="[/\\\\]",I="[^/\\\\]",p=/\//g;function S(K,X){switch(K){case 0:return"";case 1:return`${I}*?`;default:return`(?:${M}|${I}+${M}${X?`|${M}${I}+`:""})*?`}}function E(K,X){if(!K)return[];const Q=[];let Z=!1,ie=!1,ee="";for(const we of K){switch(we){case X:if(!Z&&!ie){Q.push(ee),ee="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ee+=we}return ee&&Q.push(ee),Q}e.$Vj=E;function u(K){if(!K)return"";let X="";const Q=E(K,e.$Uj);if(Q.every(Z=>Z===e.$Tj))X=".*";else{let Z=!1;Q.forEach((ie,ee)=>{if(ie===e.$Tj){if(Z)return;X+=S(2,ee===Q.length-1)}else{let we=!1,ue="",ae=!1,H="";for(const fe of ie){if(fe!=="}"&&we){ue+=fe;continue}if(ae&&(fe!=="]"||!H)){let he;fe==="-"?he=fe:(fe==="^"||fe==="!")&&!H?he="^":fe===e.$Uj?he="":he=(0,$.$Xe)(fe),H+=he;continue}switch(fe){case"{":we=!0;continue;case"[":ae=!0;continue;case"}":{const se=`(?:${E(ue,",").map(ce=>u(ce)).join("|")})`;X+=se,we=!1,ue="";break}case"]":{X+="["+H+"]",ae=!1,H="";break}case"?":X+=I;continue;case"*":X+=S(1);continue;default:X+=(0,$.$Xe)(fe)}}ee<Q.length-1&&(Q[ee+1]!==e.$Tj||ee+2<Q.length)&&(X+=M)}Z=ie===e.$Tj})}return X}const b=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),d=function(){return!1},l=function(){return null};function r(K,X){if(!K)return l;let Q;typeof K!="string"?Q=K.pattern:Q=K,Q=Q.trim();const Z=`${Q}_${!!X.trimForExclusions}`;let ie=t.get(Z);if(ie)return c(ie,K);let ee;return b.test(Q)?ie=g(Q.substr(4),Q):(ee=o.exec(h(Q,X)))?ie=C(ee[1],Q):(X.trimForExclusions?n:i).test(Q)?ie=v(Q,X):(ee=s.exec(h(Q,X)))?ie=m(ee[1].substr(1),Q,!0):(ee=a.exec(h(Q,X)))?ie=m(ee[1],Q,!1):ie=y(Q),t.set(Z,ie),c(ie,K)}function c(K,X){if(typeof X=="string")return K;const Q=function(Z,ie){return(0,f.$fg)(Z,X.base,!w.$e)?K((0,$.$3e)(Z.substr(X.base.length),L.sep),ie):null};return Q.allBasenames=K.allBasenames,Q.allPaths=K.allPaths,Q.basenames=K.basenames,Q.patterns=K.patterns,Q}function h(K,X){return X.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function g(K,X){return function(Q,Z){return typeof Q=="string"&&Q.endsWith(K)?X:null}}function C(K,X){const Q=`/${K}`,Z=`\\${K}`,ie=function(we,ue){return typeof we!="string"?null:ue?ue===K?X:null:we===K||we.endsWith(Q)||we.endsWith(Z)?X:null},ee=[K];return ie.basenames=ee,ie.patterns=[X],ie.allBasenames=ee,ie}function v(K,X){const Q=F(K.slice(1,-1).split(",").map(ue=>r(ue,X)).filter(ue=>ue!==l),K),Z=Q.length;if(!Z)return l;if(Z===1)return Q[0];const ie=function(ue,ae){for(let H=0,fe=Q.length;H<fe;H++)if(Q[H](ue,ae))return K;return null},ee=Q.find(ue=>!!ue.allBasenames);ee&&(ie.allBasenames=ee.allBasenames);const we=Q.reduce((ue,ae)=>ae.allPaths?ue.concat(ae.allPaths):ue,[]);return we.length&&(ie.allPaths=we),ie}function m(K,X,Q){const Z=L.sep===L.$gc.sep,ie=Z?K:K.replace(p,L.sep),ee=L.sep+ie,we=L.$gc.sep+K;let ue;return Q?ue=function(ae,H){return typeof ae=="string"&&(ae===ie||ae.endsWith(ee)||!Z&&(ae===K||ae.endsWith(we)))?X:null}:ue=function(ae,H){return typeof ae=="string"&&(ae===ie||!Z&&ae===K)?X:null},ue.allPaths=[(Q?"*/":"./")+K],ue}function y(K){try{const X=new RegExp(`^${u(K)}$`);return function(Q){return X.lastIndex=0,typeof Q=="string"&&X.test(Q)?K:null}}catch{return l}}function P(K,X,Q){return!K||typeof X!="string"?!1:j(K)(X,void 0,Q)}e.$Wj=P;function j(K,X={}){if(!K)return d;if(typeof K=="string"||U(K)){const Q=r(K,X);if(Q===l)return d;const Z=function(ie,ee){return!!Q(ie,ee)};return Q.allBasenames&&(Z.allBasenames=Q.allBasenames),Q.allPaths&&(Z.allPaths=Q.allPaths),Z}return A(K,X)}e.$Xj=j;function U(K){const X=K;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$Yj=U;function z(K){return K.allBasenames||[]}e.$Zj=z;function N(K){return K.allPaths||[]}e.$1j=N;function A(K,X){const Q=F(Object.getOwnPropertyNames(K).map(ue=>T(ue,K[ue],X)).filter(ue=>ue!==l)),Z=Q.length;if(!Z)return l;if(!Q.some(ue=>!!ue.requiresSiblings)){if(Z===1)return Q[0];const ue=function(fe,he){let se;for(let ce=0,le=Q.length;ce<le;ce++){const de=Q[ce](fe,he);if(typeof de=="string")return de;(0,O.$3g)(de)&&(se||(se=[]),se.push(de))}return se?(async()=>{for(const ce of se){const le=await ce;if(typeof le=="string")return le}return null})():null},ae=Q.find(fe=>!!fe.allBasenames);ae&&(ue.allBasenames=ae.allBasenames);const H=Q.reduce((fe,he)=>he.allPaths?fe.concat(he.allPaths):fe,[]);return H.length&&(ue.allPaths=H),ue}const ie=function(ue,ae,H){let fe,he;for(let se=0,ce=Q.length;se<ce;se++){const le=Q[se];le.requiresSiblings&&H&&(ae||(ae=(0,L.$nc)(ue)),fe||(fe=ae.substr(0,ae.length-(0,L.$oc)(ue).length)));const de=le(ue,ae,fe,H);if(typeof de=="string")return de;(0,O.$3g)(de)&&(he||(he=[]),he.push(de))}return he?(async()=>{for(const se of he){const ce=await se;if(typeof ce=="string")return ce}return null})():null},ee=Q.find(ue=>!!ue.allBasenames);ee&&(ie.allBasenames=ee.allBasenames);const we=Q.reduce((ue,ae)=>ae.allPaths?ue.concat(ae.allPaths):ue,[]);return we.length&&(ie.allPaths=we),ie}function T(K,X,Q){if(X===!1)return l;const Z=r(K,Q);if(Z===l)return l;if(typeof X=="boolean")return Z;if(X){const ie=X.when;if(typeof ie=="string"){const ee=(we,ue,ae,H)=>{if(!H||!Z(we,ue))return null;const fe=ie.replace("$(basename)",()=>ae),he=H(fe);return(0,O.$3g)(he)?he.then(se=>se?K:null):he?K:null};return ee.requiresSiblings=!0,ee}}return Z}function F(K,X){const Q=K.filter(ue=>!!ue.basenames);if(Q.length<2)return K;const Z=Q.reduce((ue,ae)=>{const H=ae.basenames;return H?ue.concat(H):ue},[]);let ie;if(X){ie=[];for(let ue=0,ae=Z.length;ue<ae;ue++)ie.push(X)}else ie=Q.reduce((ue,ae)=>{const H=ae.patterns;return H?ue.concat(H):ue},[]);const ee=function(ue,ae){if(typeof ue!="string")return null;if(!ae){let fe;for(fe=ue.length;fe>0;fe--){const he=ue.charCodeAt(fe-1);if(he===47||he===92)break}ae=ue.substr(fe)}const H=Z.indexOf(ae);return H!==-1?ie[H]:null};ee.basenames=Z,ee.patterns=ie,ee.allBasenames=Z;const we=K.filter(ue=>!ue.basenames);return we.push(ee),we}function G(K,X){return(0,D.$ub)(K,X,(Q,Z)=>typeof Q=="string"&&typeof Z=="string"?Q===Z:typeof Q!="string"&&typeof Z!="string"?Q.base===Z.base&&Q.pattern===Z.pattern:!1)}e.$2j=G}),define(Se[79],De([1,0,14,166,23,12,2]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=p(this.supportThemeIcons?(0,O.$mk)(i):i).replace(/([ \t]+)/g,(s,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${S(n,i)}
`,this}appendLink(i,n,s){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(i,n){const s=new RegExp((0,R.$Xe)(n),"g");return i.replace(s,(a,t)=>i.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.$sk=$;function k(o){return M(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.$tk=k;function M(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$uk=M;function I(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,f.$Kg)(L.URI.from(o.baseUri),L.URI.from(i.baseUri)))}e.$vk=I;function p(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$wk=p;function S(o,i){const n=o.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,s=n>=3?n+1:3;return[`${"`".repeat(s)}${i}`,o,`${"`".repeat(s)}`].join(`
`)}e.$xk=S;function E(o){return o.replace(/"/g,"&quot;")}e.$yk=E;function u(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$zk=u;function b(o){const i=[],n=o.split("|").map(a=>a.trim());o=n[0];const s=n[1];if(s){const a=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),d=a?a[1]:"",l=t?t[1]:"",r=isFinite(parseInt(l)),c=isFinite(parseInt(d));r&&i.push(`width="${l}"`),c&&i.push(`height="${d}"`)}return{href:o,dimensions:i}}e.$Ak=b}),define(Se[101],De([1,0,19,34,17,9,23,12]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=void 0;function $(r,c){const{os:h,tildify:g,relative:C}=c;if(C){const y=k(r,C,h);if(typeof y=="string")return y}let v=r.fsPath;if(h===1&&!R.$c?v=v.replace(/\//g,"\\"):h!==1&&R.$c&&(v=v.replace(/\\/g,"/")),h!==1&&g?.userHome){const y=g.userHome.fsPath;let P;r.scheme!==g.userHome.scheme&&r.path[0]===f.$gc.sep&&r.path[1]!==f.$gc.sep?P=g.userHome.with({path:r.path}).fsPath:P=v,v=p(P,y,h)}return(h===1?f.$fc:f.$gc).normalize(M(v,h===1))}e.$9v=$;function k(r,c,h){const g=h===1?f.$fc:f.$gc,C=h===3?L.$Hg:L.$Jg,v=c.getWorkspace(),m=(0,D.$Ob)(v.folders);if(!m)return;r.scheme!==m.uri.scheme&&r.path[0]===f.$gc.sep&&r.path[1]!==f.$gc.sep&&(r=m.uri.with({path:r.path}));const y=c.getWorkspaceFolder(r);if(!y)return;let P;if(C.isEqual(y.uri,r)?P="":P=C.relativePath(y.uri,r)??"",P&&(P=g.normalize(P)),v.folders.length>1&&!c.noPrefix){const j=y.name?y.name:C.basenameOrAuthority(y.uri);P=P?`${j} \u2022 ${P}`:j}return P}function M(r,c=R.$c){return(0,O.$jg)(r,c)?r.charAt(0).toUpperCase()+r.slice(1):r}e.$0v=M;let I=Object.create(null);function p(r,c,h=R.OS){if(h===1||!r||!c)return r;let g=I.original===c?I.normalized:void 0;g||(g=c,R.$c&&(g=(0,O.$_f)(g)),g=`${(0,w.$4e)(g,f.$gc.sep)}${f.$gc.sep}`,I={original:c,normalized:g});let C=r;return R.$c&&(C=(0,O.$_f)(C)),(h===3?C.startsWith(g):(0,w.$kf)(C,g))?`~/${C.substr(g.length)}`:r}e.$$v=p;function S(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.$_v=S;const E="\u2026",u="\\\\",b="~";function o(r,c=f.sep){const h=new Array(r.length);let g=!1;for(let C=0;C<r.length;C++){const v=r[C];if(v===""){h[C]=`.${c}`;continue}if(!v){h[C]=v;continue}g=!0;let m="",y=v;y.indexOf(u)===0?(m=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(c)===0?(m=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(b)===0&&(m=y.substr(0,y.indexOf(b)+b.length),y=y.substr(y.indexOf(b)+b.length));const P=y.split(c);for(let j=1;g&&j<=P.length;j++)for(let U=P.length-j;g&&U>=0;U--){g=!1;let z=P.slice(U,U+j).join(c);for(let N=0;!g&&N<r.length;N++)if(N!==C&&r[N]&&r[N].indexOf(z)>-1){const A=U+j===P.length,T=U>0&&r[N].indexOf(c)>-1?c+z:z,F=r[N].endsWith(T);g=!A||F}if(!g){let N="";(P[0].endsWith(":")||m!=="")&&(U===1&&(U=0,j++,z=P[0]+c+z),U>0&&(N=P[0]+c),N=m+N),U>0&&(N=N+E+c),N=N+z,U+j<P.length&&(N=N+c+E),h[C]=N}}g&&(h[C]=v)}return h}e.$aw=o;var i;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(r,c=Object.create(null)){const h=[];let g=!1,C="";for(const v of r)if(v==="$"||g&&v==="{")C&&h.push({value:C,type:i.TEXT}),C="",g=!0;else if(v==="}"&&g){const m=c[C];if(typeof m=="string")m.length&&h.push({value:m,type:i.VARIABLE});else if(m){const y=h[h.length-1];(!y||y.type!==i.SEPARATOR)&&h.push({value:m.label,type:i.SEPARATOR})}C="",g=!1}else C+=v;return C&&!g&&h.push({value:C,type:i.TEXT}),h.filter((v,m)=>{if(v.type===i.SEPARATOR){const y=h[m-1],P=h[m+1];return[y,P].every(j=>j&&(j.type===i.VARIABLE||j.type===i.TEXT)&&j.value.length>0)}return!0}).map(v=>v.value).join("")}e.$bw=n;function s(r,c){return R.$d||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$d?"&":"&&"):r.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$cw=s;function a(r,c){return R.$d||c?r.replace(/\(&&\w\)|&&/g,""):R.$c?r.replace(/&&|&/g,h=>h==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.$dw=a;function t(r){return r.replace(/&/g,"&&")}e.$ew=t;function d(r){if(r.endsWith("]")){const c=r.lastIndexOf(" [",r.length-2);if(c!==-1){const h=l(r.substring(0,c)),g=r.substring(c);return{name:h.name+g,parentPath:h.parentPath}}}return l(r)}e.$fw=d;function l(r){const c=r.indexOf("/")!==-1?f.$gc:f.$fc,h=c.basename(r),g=c.dirname(r);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}}),define(Se[128],De([1,0,21,2]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function f(I){return I.toJSON()}class R{constructor(p){this.a=p}transformIncoming(p){const S=this.a.transformIncoming(p);return S===p?p:f(O.URI.from(S))}transformOutgoing(p){const S=this.a.transformOutgoing(p);return S===p?p:f(O.URI.from(S))}transformOutgoingURI(p){const S=this.a.transformOutgoing(p);return S===p?p:O.URI.from(S)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$en=R,e.$fn=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,p,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof O.URI)return p.transformOutgoing(I);for(const E in I)if(Object.hasOwnProperty.call(I,E)){const u=L(I[E],p,S+1);u!==null&&(I[E]=u)}}return null}function w(I,p){const S=L(I,p,0);return S===null?I:S}e.$gn=w;function $(I,p,S,E){if(!I||E>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?O.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof D.$se)return null;for(const u in I)if(Object.hasOwnProperty.call(I,u)){const b=$(I[u],p,S,E+1);b!==null&&(I[u]=b)}}return null}function k(I,p){const S=$(I,p,!1,0);return S===null?I:S}e.$hn=k;function M(I,p){const S=$(I,p,!0,0);return S===null?I:S}e.$in=M}),define(Se[30],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(f){return D.test(f)}e.$zg=O,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(w){for(let $=0;$<w.length;$++)w[$]=Math.floor(Math.random()*256);return w};const R=new Uint8Array(16),L=[];for(let w=0;w<256;w++)L.push(w.toString(16).padStart(2,"0"));return function(){f(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,k="";return k+=L[R[$++]],k+=L[R[$++]],k+=L[R[$++]],k+=L[R[$++]],k+="-",k+=L[R[$++]],k+=L[R[$++]],k+="-",k+=L[R[$++]],k+=L[R[$++]],k+="-",k+=L[R[$++]],k+=L[R[$++]],k+="-",k+=L[R[$++]],k+=L[R[$++]],k+=L[R[$++]],k+=L[R[$++]],k+=L[R[$++]],k+=L[R[$++]],k}}()}),define(Se[169],De([1,0,19,48,30]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.$Bt=e.$At=e.$zt=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$zt=R;function L(I,p,S){const E={id:(0,f.$Ag)(),name:I,uri:p,data:S};return{asString:async()=>"",asFile:()=>E,value:void 0}}e.$At=L;class w{constructor(){this.a=new Map}get size(){let p=0;for(const S of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const S=[...this.a.keys()];return O.Iterable.some(this,([E,u])=>u.asFile())&&S.push("files"),M($(p),S)}get(p){return this.a.get(this.b(p))?.[0]}append(p,S){const E=this.a.get(p);E?E.push(S):this.a.set(this.b(p),[S])}replace(p,S){this.a.set(this.b(p),[S])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,S]of this.a)for(const E of S)yield[p,E]}b(p){return $(p)}}e.$Bt=w;function $(I){return I.toLowerCase()}function k(I,p){return M($(I),p.map($))}e.$Ct=k;function M(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[E,u,b]=S;return b==="*"?p.some(o=>o.startsWith(u+"/")):!1}e.$Dt=Object.freeze({create:I=>(0,D.$Mb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Dt.split(I).filter(p=>!p.startsWith("#"))})}),define(Se[31],De([1,0,57,62,387,8,34,76,17,9,23,2]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function S(T,F=p.UNLINK,G){if((0,L.$ig)(T))throw new Error("rimraf - will refuse to recursively delete root");return F===p.UNLINK?u(T):E(T,G)}async function E(T,F=(0,L.$ng)((0,O.tmpdir)())){try{try{await D.promises.rename(T,F)}catch(G){return G.code==="ENOENT"?void 0:u(T)}u(F).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function u(T){return(0,f.promisify)(D.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function b(T){if((0,L.$ig)(T))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function o(T,F){return s(await(F?i(T):(0,f.promisify)(D.readdir)(T)))}async function i(T){try{return await(0,f.promisify)(D.readdir)(T,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const F=[],G=await o(T);for(const K of G){let X=!1,Q=!1,Z=!1;try{const ie=await e.Promises.lstat((0,$.$jc)(T,K));X=ie.isFile(),Q=ie.isDirectory(),Z=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}F.push({name:K,isFile:()=>X,isDirectory:()=>Q,isSymbolicLink:()=>Z})}return F}function n(T){return s(D.readdirSync(T))}e.readdirSync=n;function s(T){return T.map(F=>typeof F=="string"?k.$d?(0,w.$Sl)(F):F:(F.name=k.$d?(0,w.$Sl)(F.name):F.name,F))}async function a(T){const F=await o(T),G=[];for(const K of F)await d.existsDirectory((0,$.$jc)(T,K))&&G.push(K);return G}function t(T,F=1e3){return new Promise(G=>{let K=!1;const X=setInterval(()=>{K||(K=!0,D.access(T,Q=>{K=!1,Q&&(clearInterval(X),G(void 0))}))},F)})}e.whenDeleted=t;var d;(function(T){async function F(X){let Q;try{if(Q=await e.Promises.lstat(X),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(k.$c&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ie}throw Z}}T.stat=F;async function G(X){try{const{stat:Q,symbolicLink:Z}=await T.stat(X);return Q.isFile()&&Z?.dangling!==!0}catch{}return!1}T.existsFile=G;async function K(X){try{const{stat:Q,symbolicLink:Z}=await T.stat(X);return Q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}T.existsDirectory=K})(d||(e.SymlinkSupport=d={}));const l=new R.$nh;function r(T,F,G){return l.queueFor(I.URI.file(T),()=>{const K=v(G);return new Promise((X,Q)=>g(T,F,K,Z=>Z?Q(Z):X()))},M.$Ig)}let c=!0;function h(T){c=T}e.configureFlushOnWrite=h;function g(T,F,G,K){if(!c)return D.writeFile(T,F,{mode:G.mode,flag:G.flag},K);D.open(T,G.flag,G.mode,(X,Q)=>{if(X)return K(X);D.writeFile(Q,F,Z=>{if(Z)return D.close(Q,()=>K(Z));D.fdatasync(Q,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),h(!1)),D.close(Q,ee=>K(ee))))})})}function C(T,F,G){const K=v(G);if(!c)return D.writeFileSync(T,F,{mode:K.mode,flag:K.flag});const X=D.openSync(T,K.flag,K.mode);try{D.writeFileSync(X,F);try{D.fdatasyncSync(X)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),h(!1)}}finally{D.closeSync(X)}}e.writeFileSync=C;function v(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function m(T,F,G=6e4){if(T!==F)try{k.$c&&typeof G=="number"?await y(T,F,Date.now(),G):await(0,f.promisify)(D.rename)(T,F)}catch(K){if(T.toLowerCase()!==F.toLowerCase()&&K.code==="EXDEV"||T.endsWith("."))await P(T,F,{preserveSymlinks:!1}),await S(T,p.MOVE);else throw K}}async function y(T,F,G,K,X=0){try{return await(0,f.promisify)(D.rename)(T,F)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-G>=K)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Q}`),Q;if(X===0){let Z=!1;try{const{stat:ie}=await d.stat(F);ie.isFile()||(Z=!0)}catch{}if(Z)throw Q}return await(0,R.$fh)(Math.min(100,X*10)),y(T,F,G,K,X+1)}}async function P(T,F,G){return U(T,F,{root:{source:T,target:F},options:G,handledSourcePaths:new Set})}const j=511;async function U(T,F,G){if(G.handledSourcePaths.has(T))return;G.handledSourcePaths.add(T);const{stat:K,symbolicLink:X}=await d.stat(T);if(X){if(G.options.preserveSymlinks)try{return await A(T,F,G)}catch{}if(X.dangling)return}return K.isDirectory()?z(T,F,K.mode&j,G):N(T,F,K.mode&j)}async function z(T,F,G,K){await e.Promises.mkdir(F,{recursive:!0,mode:G});const X=await o(T);for(const Q of X)await U((0,$.$jc)(T,Q),(0,$.$jc)(F,Q),K)}async function N(T,F,G){await e.Promises.copyFile(T,F),await e.Promises.chmod(F,G)}async function A(T,F,G){let K=await e.Promises.readlink(T);(0,L.$fg)(K,G.root.source,!k.$e)&&(K=(0,$.$jc)(G.root.target,K.substr(G.root.source.length+1))),await e.Promises.symlink(K,F)}e.Promises=new class{get access(){return(0,f.promisify)(D.access)}get stat(){return(0,f.promisify)(D.stat)}get lstat(){return(0,f.promisify)(D.lstat)}get utimes(){return(0,f.promisify)(D.utimes)}get read(){return(T,F,G,K,X)=>new Promise((Q,Z)=>{D.read(T,F,G,K,X,(ie,ee,we)=>ie?Z(ie):Q({bytesRead:ee,buffer:we}))})}get readFile(){return(0,f.promisify)(D.readFile)}get write(){return(T,F,G,K,X)=>new Promise((Q,Z)=>{D.write(T,F,G,K,X,(ie,ee,we)=>ie?Z(ie):Q({bytesWritten:ee,buffer:we}))})}get appendFile(){return(0,f.promisify)(D.appendFile)}get fdatasync(){return(0,f.promisify)(D.fdatasync)}get truncate(){return(0,f.promisify)(D.truncate)}get copyFile(){return(0,f.promisify)(D.copyFile)}get open(){return(0,f.promisify)(D.open)}get close(){return(0,f.promisify)(D.close)}get symlink(){return(0,f.promisify)(D.symlink)}get readlink(){return(0,f.promisify)(D.readlink)}get chmod(){return(0,f.promisify)(D.chmod)}get mkdir(){return(0,f.promisify)(D.mkdir)}get unlink(){return(0,f.promisify)(D.unlink)}get rmdir(){return(0,f.promisify)(D.rmdir)}get realpath(){return(0,f.promisify)(D.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return r}get rm(){return S}get rename(){return m}get copy(){return P}}}),define(Se[102],De([1,0,57,17,9,12,31]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.$Fq=void 0;function w(p){if(f.$e)return p;const S=(0,O.$mc)(p);if(p===S)return p;const E=((0,O.$nc)(p)||p).toLowerCase();try{const b=(0,L.readdirSync)(S).filter(o=>o.toLowerCase()===E);if(b.length===1){const o=w(S);if(o)return(0,O.$jc)(o,b[0])}else if(b.length>1){const o=b.indexOf(E);if(o>=0){const i=w(S);if(i)return(0,O.$jc)(i,b[o])}}}catch{}return null}e.$Fq=w;async function $(p){if(f.$e)return p;const S=(0,O.$mc)(p);if(p===S)return p;const E=((0,O.$nc)(p)||p).toLowerCase();try{const b=(await L.Promises.readdir(S)).filter(o=>o.toLowerCase()===E);if(b.length===1){const o=await $(S);if(o)return(0,O.$jc)(o,b[0])}else if(b.length>1){const o=b.indexOf(E);if(o>=0){const i=await $(S);if(i)return(0,O.$jc)(i,b[o])}}}catch{}return null}e.$Gq=$;async function k(p){try{return await L.Promises.realpath(p)}catch{const E=I(p);return await L.Promises.access(E,D.constants.R_OK),E}}e.$Hq=k;function M(p){try{return D.realpathSync(p)}catch{const E=I(p);return D.accessSync(E,D.constants.R_OK),E}}e.$Iq=M;function I(p){return(0,R.$4e)((0,O.$hc)(p),O.sep)}}),define(Se[170],De([1,0,63]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.$Dg=e.$Cg=void 0;function O(w,$,k,M=1){let I=!1;return new Promise(p=>{const S=setTimeout(()=>{if(!I)return I=!0,p(0)},k);f(w,$,M,E=>{if(!I)return I=!0,clearTimeout(S),p(E)})})}e.$Cg=O;function f(w,$,k,M){if($===0)return M(0);const I=new D.Socket;I.once("connect",()=>(L(I),f(w+k,$-1,k,M))),I.once("data",()=>{}),I.once("error",p=>(L(I),p.code!=="ECONNREFUSED"?f(w+k,$-1,k,M):M(w))),I.connect(w,"127.0.0.1")}e.$Dg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(w,$,k,M="127.0.0.1"){let I=!1,p,S=1;const E=D.createServer({pauseOnConnect:!0});function u(b,o){I||(I=!0,E.removeAllListeners(),E.close(),p&&clearTimeout(p),o(b))}return new Promise(b=>{p=setTimeout(()=>{u(0,b)},k),E.on("listening",()=>{u(w,b)}),E.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&S<$?(w++,S++,E.listen(w,M)):u(0,b)}),E.on("close",()=>{u(0,b)}),E.listen(w,M)})}e.$Eg=R;function L(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch($){console.error($)}}}),define(Se[103],De([1,0,17,9,49,99,18,31]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$7l=e.$6l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(I=f.env){return I.comspec||"cmd.exe"}e.$6l=$;function k(I){let p=[],S=!1;const E=function(u){if(S){p.push(u);return}(!I.send(u,o=>{if(o&&console.error(o),S=!1,p.length>0){const i=p.slice(0);p=[],i.forEach(n=>E(n))}})||O.$c)&&(S=!0)};return{send:E}}e.$7l=k;var M;(function(I){async function p(S,E,u){if(D.$ic(S))return S;if(E===void 0&&(E=f.cwd()),D.$mc(S)!=="."||(u===void 0&&L.$Sf(f.env.PATH)&&(u=f.env.PATH.split(D.$tc)),u===void 0||u.length===0))return D.$jc(E,S);async function o(i){if(await w.Promises.exists(i)){let n;try{n=await w.Promises.stat(i)}catch(s){s.message.startsWith("EACCES")&&(n=await w.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of u){let n;if(D.$ic(i)?n=D.$jc(i,S):n=D.$jc(E,i,S),await o(n))return n;let s=n+".com";if(await o(s)||(s=n+".exe",await o(s)))return s}return D.$jc(E,S)}I.findExecutable=p})(M||(e.win32=M={}))});var Je=this&&this.__decorate||function(re,e,D,O){var f=arguments.length,R=f<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(re,e,D,O);else for(var w=re.length-1;w>=0;w--)(L=re[w])&&(R=(f<3?L(R):f>3?L(e,D,R):L(e,D))||R);return f>3&&R&&Object.defineProperty(e,D,R),R};define(Se[80],De([1,0,19,8,21,22,53,14,4,3,56,12,18]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.ProxyChannel=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.RequestInitiator=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;var S;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(S||(S={}));function E(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(u||(u={}));function b(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(o||(o={}));function i(X){let Q=0;for(let Z=0;;Z+=7){const ie=X.read(1);if(Q|=(ie.buffer[0]&127)<<Z,!(ie.buffer[0]&128))return Q}}const n=l(0);function s(X,Q){if(Q===0){X.write(n);return}let Z=0;for(let ee=Q;ee!==0;ee=ee>>>7)Z++;const ie=f.$se.alloc(Z);for(let ee=0;Q!==0;ee++)ie.buffer[ee]=Q&127,Q=Q>>>7,Q>0&&(ie.buffer[ee]|=128);X.write(ie)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const Z=this.b.slice(this.a,this.a+Q);return this.a+=Z.byteLength,Z}}e.$Oh=a;class t{constructor(){this.a=[]}get buffer(){return f.$se.concat(this.a)}write(Q){this.a.push(Q)}}e.$Ph=t;var d;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(d||(d={}));function l(X){const Q=f.$se.alloc(1);return Q.writeUInt8(X,0),Q}const r={Undefined:l(d.Undefined),String:l(d.String),Buffer:l(d.Buffer),VSBuffer:l(d.VSBuffer),Array:l(d.Array),Object:l(d.Object),Uint:l(d.Int)},c=typeof Buffer<"u";function h(X,Q){if(typeof Q>"u")X.write(r.Undefined);else if(typeof Q=="string"){const Z=f.$se.fromString(Q);X.write(r.String),s(X,Z.byteLength),X.write(Z)}else if(c&&Buffer.isBuffer(Q)){const Z=f.$se.wrap(Q);X.write(r.Buffer),s(X,Z.byteLength),X.write(Z)}else if(Q instanceof f.$se)X.write(r.VSBuffer),s(X,Q.byteLength),X.write(Q);else if(Array.isArray(Q)){X.write(r.Array),s(X,Q.length);for(const Z of Q)h(X,Z)}else if(typeof Q=="number"&&(Q|0)===Q)X.write(r.Uint),s(X,Q);else{const Z=f.$se.fromString(JSON.stringify(Q));X.write(r.Object),s(X,Z.byteLength),X.write(Z)}}e.$Qh=h;function g(X){switch(X.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return X.read(i(X)).toString();case d.Buffer:return X.read(i(X)).buffer;case d.VSBuffer:return X.read(i(X));case d.Array:{const Z=i(X),ie=[];for(let ee=0;ee<Z;ee++)ie.push(g(X));return ie}case d.Object:return JSON.parse(X.read(i(X)).toString());case d.Int:return i(X)}}e.$Rh=g;class C{constructor(Q,Z,ie=null,ee=1e3){this.h=Q,this.j=Z,this.k=ie,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(Q,Z){this.b.set(Q,Z),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const Z=this.o([Q.type]);this.k?.logOutgoing(Z,0,1,b(Q.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(Z,Q.id,1,b(Q.type),Q.data);return}}}o(Q,Z=void 0){const ie=new t;return h(ie,Q),h(ie,Z),this.p(ie.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const Z=new a(Q),ie=g(Z),ee=g(Z),we=ie[0];switch(we){case 100:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${E(we)}: ${ie[2]}.${ie[3]}`,ee),this.s({type:we,id:ie[1],channelName:ie[2],name:ie[3],arg:ee});case 102:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${E(we)}: ${ie[2]}.${ie[3]}`,ee),this.t({type:we,id:ie[1],channelName:ie[2],name:ie[3],arg:ee});case 101:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${E(we)}`),this.u({type:we,id:ie[1]});case 103:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${E(we)}`),this.u({type:we,id:ie[1]})}}s(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const ie=new R.$ce;let ee;try{ee=Z.call(this.j,Q.name,Q.arg,ie.token)}catch(ae){ee=Promise.reject(ae)}const we=Q.id;ee.then(ae=>{this.m({id:we,data:ae,type:201})},ae=>{ae instanceof Error?this.m({id:we,data:{message:ae.message,name:ae.name,stack:ae.stack?ae.stack.split?ae.stack.split(`
`):ae.stack:void 0},type:202}):this.m({id:we,data:ae,type:203})}).finally(()=>{ue.dispose(),this.d.delete(Q.id)});const ue=(0,k.$Rc)(()=>ie.cancel());this.d.set(Q.id,ue)}t(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const ie=Q.id,we=Z.listen(this.j,Q.name,Q.arg)(ue=>this.m({id:ie,data:ue,type:204}));this.d.set(Q.id,we)}u(Q){const Z=this.d.get(Q.id);Z&&(Z.dispose(),this.d.delete(Q.id))}v(Q){let Z=this.g.get(Q.channelName);Z||(Z=[],this.g.set(Q.channelName,Z));const ie=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:Q,timeoutTimer:ie})}w(Q){const Z=this.g.get(Q);if(Z){for(const ie of Z)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Sh=C;var v;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class m{constructor(Q,Z=null){this.l=Q,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=Z}getChannel(Q){const Z=this;return{call(ie,ee,we){return Z.a?Promise.reject(new w.$5):Z.m(Q,ie,ee,we)},listen(ie,ee){return Z.a?$.Event.None:Z.o(Q,ie,ee)}}}m(Q,Z,ie,ee=R.CancellationToken.None){const we=this.g++,ae={id:we,type:100,channelName:Q,name:Z,arg:ie};if(ee.isCancellationRequested)return Promise.reject(new w.$5);let H;return new Promise((he,se)=>{if(ee.isCancellationRequested)return se(new w.$5);const ce=()=>{const _=ge=>{switch(ge.type){case 201:this.f.delete(we),he(ge.data);break;case 202:{this.f.delete(we);const me=new Error(ge.data.message);me.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,me.name=ge.data.name,se(me);break}case 203:this.f.delete(we),se(ge.data);break}};this.f.set(we,_),this.p(ae)};let le=null;this.b===o.Idle?ce():(le=(0,O.$4g)(_=>this.u()),le.then(()=>{le=null,ce()}));const de=()=>{le?(le.cancel(),le=null):this.p({id:we,type:101}),se(new w.$5)},q=ee.onCancellationRequested(de);H=(0,k.$Qc)((0,k.$Rc)(de),q),this.d.add(H)}).finally(()=>{H.dispose(),this.d.delete(H)})}o(Q,Z,ie){const ee=this.g++,ue={id:ee,type:102,channelName:Q,name:Z,arg:ie};let ae=null;const H=new $.$5d({onWillAddFirstListener:()=>{ae=(0,O.$4g)(he=>this.u()),ae.then(()=>{ae=null,this.d.add(H),this.p(ue)})},onDidRemoveLastListener:()=>{ae?(ae.cancel(),ae=null):(this.d.delete(H),this.p({id:ee,type:103}))}}),fe=he=>H.fire(he.data);return this.f.set(ee,fe),H.event}p(Q){switch(Q.type){case 100:case 102:{const Z=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(Z,Q.id,0,`${E(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const Z=this.q([Q.type,Q.id]);this.j?.logOutgoing(Z,Q.id,0,E(Q.type));return}}}q(Q,Z=void 0){const ie=new t;return h(ie,Q),h(ie,Z),this.r(ie.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const Z=new a(Q),ie=g(Z),ee=g(Z),we=ie[0];switch(we){case 200:return this.j?.logIncoming(Q.byteLength,0,0,b(we)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ie[1],0,b(we),ee),this.t({type:ie[0],id:ie[1],data:ee})}}t(Q){if(Q.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Th=m,Je([L.$Ih],m.prototype,"onDidInitializePromise",null);class y{get connections(){const Q=[];return this.f.forEach(Z=>Q.push(Z)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new $.$5d,this.onDidAddConnection=this.g.event,this.h=new $.$5d,this.onDidRemoveConnection=this.h.event,this.j=new k.$Sc,this.j.add(Q(({protocol:Z,onDidClientDisconnect:ie})=>{const ee=$.Event.once(Z.onMessage);this.j.add(ee(we=>{const ue=new a(we),ae=g(ue),H=new C(Z,ae),fe=new m(Z);this.a.forEach((se,ce)=>H.registerChannel(ce,se));const he={channelServer:H,channelClient:fe,ctx:ae};this.f.add(he),this.g.fire(he),this.j.add(ie(()=>{H.dispose(),fe.dispose(),this.f.delete(he),this.h.fire(he)}))}))}))}getChannel(Q,Z){const ie=this;return{call(ee,we,ue){let ae;if((0,p.$7f)(Z)){const fe=(0,D.$4b)(ie.connections.filter(Z));ae=fe?Promise.resolve(fe):$.Event.toPromise($.Event.filter(ie.onDidAddConnection,Z))}else ae=Z.routeCall(ie,ee,we);const H=ae.then(fe=>fe.channelClient.getChannel(Q));return j(H).call(ee,we,ue)},listen(ee,we){if((0,p.$7f)(Z))return ie.k(Q,Z,ee,we);const ue=Z.routeEvent(ie,ee,we).then(ae=>ae.channelClient.getChannel(Q));return j(ue).listen(ee,we)}}}k(Q,Z,ie,ee){const we=this;let ue;const ae=new $.$5d({onWillAddFirstListener:()=>{ue=new k.$Sc;const H=new $.$$d,fe=new Map,he=ce=>{const de=ce.channelClient.getChannel(Q).listen(ie,ee),q=H.add(de);fe.set(ce,q)},se=ce=>{const le=fe.get(ce);le&&(le.dispose(),fe.delete(ce))};we.connections.filter(Z).forEach(he),$.Event.filter(we.onDidAddConnection,Z)(he,void 0,ue),we.onDidRemoveConnection(se,void 0,ue),H.event(ae.fire,ae,ue),ue.add(H)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return ae.event}registerChannel(Q,Z){this.a.set(Q,Z);for(const ie of this.f)ie.channelServer.registerChannel(Q,Z)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Uh=y;class P{constructor(Q,Z,ie=null){const ee=new t;h(ee,Z),Q.send(ee.buffer),this.a=new m(Q,ie),this.d=new C(Q,Z,ie)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,Z){this.d.registerChannel(Q,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Vh=P;function j(X){return{call(Q,Z,ie){return X.then(ee=>ee.call(Q,Z,ie))},listen(Q,Z){const ie=new $.$be;return X.then(ee=>ie.input=ee.listen(Q,Z)),ie.event}}}e.$Wh=j;function U(X){let Q=!1;return{call(Z,ie,ee){return Q?X.call(Z,ie,ee):(0,O.$fh)(0).then(()=>Q=!0).then(()=>X.call(Z,ie,ee))},listen(Z,ie){if(Q)return X.listen(Z,ie);const ee=new $.$be;return(0,O.$fh)(0).then(()=>Q=!0).then(()=>ee.input=X.listen(Z,ie)),ee.event}}}e.$Xh=U;class z{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const Z of Q.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await $.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Yh=z;var N;(function(X){function Q(we,ue,ae){const H=we,fe=ae&&ae.disableMarshalling,he=new Map;for(const se in H)ie(se)&&he.set(se,$.Event.buffer(H[se],!0,void 0,ue));return new class{listen(se,ce,le){const de=he.get(ce);if(de)return de;if(ee(ce)){const q=H[ce];if(typeof q=="function")return q.call(H,le)}throw new w.$bb(`Event not found: ${ce}`)}call(se,ce,le){const de=H[ce];if(typeof de=="function"){if(!fe&&Array.isArray(le))for(let _=0;_<le.length;_++)le[_]=(0,M.$Nh)(le[_]);let q=de.apply(H,le);return q instanceof Promise||(q=Promise.resolve(q)),q}throw new w.$bb(`Method not found: ${ce}`)}}}X.fromService=Q;function Z(we,ue){const ae=ue&&ue.disableMarshalling;return new Proxy({},{get(H,fe){if(typeof fe=="string")return ue?.properties?.has(fe)?ue.properties.get(fe):ee(fe)?function(he){return we.listen(fe,he)}:ie(fe)?we.listen(fe):async function(...he){let se;ue&&!(0,p.$2f)(ue.context)?se=[ue.context,...he]:se=he;const ce=await we.call(fe,se);return ae?ce:(0,M.$Nh)(ce)};throw new w.$bb(`Property not found: ${String(fe)}`)}})}X.toService=Z;function ie(we){return we[0]==="o"&&we[1]==="n"&&I.$if(we.charCodeAt(2))}function ee(we){return/^onDynamic/.test(we)&&I.$if(we.charCodeAt(9))}})(N||(e.ProxyChannel=N={}));const A=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Q=X.toString();if(Q!=="[object Object]")return Q}return X}function F(X){return Array.isArray(X)?X.map(T):T(X)}function G(X,Q,Z,ie,ee,we,ue){ue=F(ue);const ae=A[ee],H=ae[ie%ae.length];let fe=[`%c[${X}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(we)?(fe=fe.concat(ue),fe.push(")")):fe.push(ue),console.log.apply(console,fe)}class K{constructor(Q,Z){this.d=Q,this.f=Z,this.a=0,this.b=0}logOutgoing(Q,Z,ie,ee,we){this.b+=Q,G(this.d,this.b,Q,Z,ie,ee,we)}logIncoming(Q,Z,ie,ee,we){this.a+=Q,G(this.f,this.a,Q,Z,ie,ee,we)}}e.$Zh=K}),define(Se[81],De([1,0,21,4,3,80]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.ProtocolConstants=e.$1h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var w;(function(r){r.enableDiagnostics=!1,r.records=[];const c=new WeakMap;let h=0;function g(v,m){if(!c.has(v)){const y=String(++h);c.set(v,y)}return c.get(v)}function C(v,m,y,P){if(!r.enableDiagnostics)return;const j=g(v,m);if(P instanceof D.$se||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const U=D.$se.alloc(P.byteLength);U.set(P),r.records.push({timestamp:Date.now(),id:j,label:m,type:y,buff:U})}else r.records.push({timestamp:Date.now(),id:j,label:m,type:y,data:P})}r.traceSocketEvent=C})(w||(e.SocketDiagnostics=w={}));var $;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let k=null;function M(){return k||(k=D.$se.alloc(0)),k}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return M();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const m=this.a[0];return h&&(this.a.shift(),this.b-=c),m}if(this.a[0].byteLength>c){const m=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),m}const g=D.$se.alloc(c);let C=0,v=0;for(;c>0;){const m=this.a[v];if(m.byteLength>c){const y=m.slice(0,c);g.set(y,C),C+=c,h&&(this.a[v]=m.slice(c),this.b-=c),c-=c}else g.set(m,C),C+=m.byteLength,h?(this.a.shift(),this.b-=m.byteLength):v++,c-=m.byteLength}return g}}e.$1h=I;var p;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(p||(p={}));function S(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(E||(e.ProtocolConstants=E={}));class u{constructor(c,h,g,C){this.type=c,this.id=h,this.ack=g,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends f.$Tc{constructor(c){super(),this.f=this.B(new O.$5d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,C=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new u(g,C,v,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.$se.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const g=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,g}h(){const c=D.$se.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends f.$Tc{constructor(c){super(),this.f=new O.$5d,this.onMessage=this.f.event,this.g=new O.$5d,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new u(1,0,0,c))}}e.$2h=i;class n extends R.$Vh{static fromSocket(c,h){return new n(new i(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,g=null){super(c,h,g),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$3h=n;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$5d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$4h=s;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,g=this.a;for(;g;)c[h++]=g.data,g=g.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new a(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class d{static getInstance(){return d.b||(d.b=new d),d.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<d.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=d.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+d.a)*1e3;let g=0;for(let C=0;C<d.a;C++)c-this.c[C]<=h&&g++;return 1-g/d.a}hasHighLoad(){return this.d()>=.5}}d.a=10,d.b=null;class l{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??d.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Sc,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new u(5,0,0,M());this.p.write(c),this.p.flush()}sendPause(){const c=new u(7,0,0,M());this.p.write(c)}sendResume(){const c=new u(8,0,0,M());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new f.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new u(3,0,this.h,M());this.p.write(c);const h=this.b.toArray();for(let g=0,C=h.length;g<C;g++)this.p.write(h[g]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new u(6,0,0,M())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let g=0,C=h.length;g<C;g++)this.p.write(h[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const g=new u(1,h,this.h,c);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(c){const h=new u(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,g=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(h>=2e4&&g>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:g});return}const v=Math.max(2e4-h,2e4-g,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new u(3,0,this.h,M());this.p.write(c)}D(){this.h=this.g;const c=new u(9,0,this.h,M());this.p.write(c)}}e.$5h=l}),define(Se[171],De([1,0,50,8,21,22,167,14,4,3,24,103,99,80]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class E extends S.$Sh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>f.$se.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Cq=E;class u{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$5d,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new O.$bh(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,s,a){return i.k(o,n,s,a)},listen(n,s){return i.l(o,n,s)}}}k(o,i,n,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(w.$6());this.b.cancel();const a=this.n(o),t=(0,O.$4g)(r=>a.call(i,n,r)),d=s.onCancellationRequested(()=>t.cancel()),l=(0,k.$Rc)(()=>t.cancel());return this.c.add(l),t.finally(()=>{d.dispose(),this.c.delete(l),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return $.Event.None;this.b.cancel();let s;const a=new $.$5d({onWillAddFirstListener:()=>{s=this.n(o).listen(i,n)(a.fire,a),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,M.$In)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,p.$5l)(i.env),this.d=(0,D.fork)(this.i,o,i);const n=new $.$5d;$.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,L.$yq)(c)){(0,L.log)(c,`IPC Library: ${this.j.serverName}`);return}n.fire(f.$se.wrap(Buffer.from(c,"base64")))});const a=this.j.useQueue?(0,I.$7l)(this.d):this.d,t=c=>this.d&&this.d.connected&&a.send(c.buffer.toString("base64")),d=n.event,l={send:t,onMessage:d};this.f=new S.$Th(l);const r=()=>this.o();process.once("exit",r),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,h)=>{process.removeListener("exit",r),this.c.forEach(g=>(0,k.$Oc)(g)),this.c.clear(),c!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:h})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Dq=u}),define(Se[172],De([1,0,8,4,3,56,18]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.StorageState=e.$Bp=e.StorageHint=void 0;var w;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function $(p){const S=p;return S?.changed instanceof Map||S?.deleted instanceof Set}e.$Bp=$;var k;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(k||(e.StorageState=k={}));class M extends f.$Tc{constructor(S,E=Object.create(null)){super(),this.r=S,this.s=E,this.b=this.B(new O.$8d),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new D.$ch(M.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((E,u)=>this.w(u,E)),S.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(S,E){if(this.c===k.Closed)return;let u=!1;(0,L.$2f)(E)?u=this.f.delete(S):this.f.get(S)!==E&&(this.f.set(S,E),u=!0),u&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,E){const u=this.f.get(S);return(0,L.$2f)(u)?E:u}getBoolean(S,E){const u=this.get(S);return(0,L.$2f)(u)?E:u==="true"}getNumber(S,E){const u=this.get(S);return(0,L.$2f)(u)?E:parseInt(u,10)}getObject(S,E){const u=this.get(S);return(0,L.$2f)(u)?E:(0,R.$Mh)(u)}async set(S,E,u=!1){if(this.c===k.Closed)return;if((0,L.$2f)(E))return this.delete(S,u);const b=(0,L.$Uf)(E)||Array.isArray(E)?(0,R.$Lh)(E):String(E);if(this.f.get(S)!==b)return this.f.set(S,b),this.j.set(S,b),this.h.delete(S),this.b.fire({key:S,external:u}),this.D()}async delete(S,E=!1){if(!(this.c===k.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:E}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$Cp=M,M.a=100;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((E,u)=>this.a.set(u,E)),S.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$Dp=I}),define(Se[129],De([1,0,127]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$rt=void 0;class O{constructor(w){const $=(0,D.$Qe)(w);this.c=$,this.a=O.d($),this.b=new Map}static d(w){const $=new Uint8Array(256);return $.fill(w),$}set(w,$){const k=(0,D.$Qe)($);w>=0&&w<256?this.a[w]=k:this.b.set(w,k)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$rt=O;var f;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(f||(f={}));class R{constructor(){this.a=new O(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$st=R}),define(Se[173],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.StringEOL=void 0;var D;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function O(f){let R=0,L=0,w=0,$=0;for(let k=0,M=f.length;k<M;k++){const I=f.charCodeAt(k);I===13?(R===0&&(L=k),R++,k+1<M&&f.charCodeAt(k+1)===10?($|=2,k++):$|=3,w=k+1):I===10&&($|=1,R===0&&(L=k),R++,w=k+1)}return R===0&&(L=f.length),[R,L,f.length-w,$]}e.$Gt=O}),define(Se[51],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=void 0;class D{constructor(f,R){this.lineNumber=f,this.column=R}with(f=this.lineNumber,R=this.column){return f===this.lineNumber&&R===this.column?this:new D(f,R)}delta(f=0,R=0){return this.with(this.lineNumber+f,this.column+R)}equals(f){return D.equals(this,f)}static equals(f,R){return!f&&!R?!0:!!f&&!!R&&f.lineNumber===R.lineNumber&&f.column===R.column}isBefore(f){return D.isBefore(this,f)}static isBefore(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<R.column}isBeforeOrEqual(f){return D.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<=R.column}static compare(f,R){const L=f.lineNumber|0,w=R.lineNumber|0;if(L===w){const $=f.column|0,k=R.column|0;return $-k}return L-w}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new D(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$6s=D}),define(Se[29],De([1,0,51]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0;class O{constructor(R,L,w,$){R>w||R===w&&L>$?(this.startLineNumber=w,this.startColumn=$,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=w,this.endColumn=$)}isEmpty(){return O.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return O.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return O.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return O.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return O.plusRange(this,R)}static plusRange(R,L){let w,$,k,M;return L.startLineNumber<R.startLineNumber?(w=L.startLineNumber,$=L.startColumn):L.startLineNumber===R.startLineNumber?(w=L.startLineNumber,$=Math.min(L.startColumn,R.startColumn)):(w=R.startLineNumber,$=R.startColumn),L.endLineNumber>R.endLineNumber?(k=L.endLineNumber,M=L.endColumn):L.endLineNumber===R.endLineNumber?(k=L.endLineNumber,M=Math.max(L.endColumn,R.endColumn)):(k=R.endLineNumber,M=R.endColumn),new O(w,$,k,M)}intersectRanges(R){return O.intersectRanges(this,R)}static intersectRanges(R,L){let w=R.startLineNumber,$=R.startColumn,k=R.endLineNumber,M=R.endColumn;const I=L.startLineNumber,p=L.startColumn,S=L.endLineNumber,E=L.endColumn;return w<I?(w=I,$=p):w===I&&($=Math.max($,p)),k>S?(k=S,M=E):k===S&&(M=Math.min(M,E)),w>k||w===k&&$>M?null:new O(w,$,k,M)}equalsRange(R){return O.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(R){return new D.$6s(R.endLineNumber,R.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(R){return new D.$6s(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new O(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new O(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(R){return new O(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(R){return new O(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new O(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new O(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new O(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const k=R.startLineNumber|0,M=L.startLineNumber|0;if(k===M){const I=R.startColumn|0,p=L.startColumn|0;if(I===p){const S=R.endLineNumber|0,E=L.endLineNumber|0;if(S===E){const u=R.endColumn|0,b=L.endColumn|0;return u-b}return S-E}return I-p}return k-M}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$7s=O}),define(Se[174],De([1,0,29]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class O{static insert(R,L){return{range:new D.$7s(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$8s=O}),define(Se[175],De([1,0,51,29]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.SelectionDirection=void 0;var f;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class R extends O.$7s{constructor(w,$,k,M){super(w,$,k,M),this.selectionStartLineNumber=w,this.selectionStartColumn=$,this.positionLineNumber=k,this.positionColumn=M}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return R.selectionsEqual(this,w)}static selectionsEqual(w,$){return w.selectionStartLineNumber===$.selectionStartLineNumber&&w.selectionStartColumn===$.selectionStartColumn&&w.positionLineNumber===$.positionLineNumber&&w.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,$){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,w,$):new R(w,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$6s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$6s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,$){return this.getDirection()===0?new R(w,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,w,$)}static fromPositions(w,$=w){return new R(w.lineNumber,w.column,$.lineNumber,$.column)}static fromRange(w,$){return $===0?new R(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new R(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new R(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,$){if(w&&!$||!w&&$)return!1;if(!w&&!$)return!0;if(w.length!==$.length)return!1;for(let k=0,M=w.length;k<M;k++)if(!this.selectionsEqual(w[k],$[k]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,$,k,M,I){return I===0?new R(w,$,k,M):new R(k,M,w,$)}}e.$9s=R}),define(Se[176],De([1,0,12,9,21]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=void 0;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let w;function $(){return w||(w=new TextDecoder("UTF-16BE")),w}let k;function M(){return k||(k=O.$x()?L():$()),k}e.$mt=M;function I(E,u,b){const o=new Uint16Array(E.buffer,u,b);return b>0&&(o[0]===65279||o[0]===65534)?p(E,u,b):L().decode(o)}e.$nt=I;function p(E,u,b){const o=[];let i=0;for(let n=0;n<b;n++){const s=f.$ue(E,u);u+=2,o[i++]=String.fromCharCode(s)}return o.join("")}class S{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return M().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const b=this.a-this.d;b<=1&&(b===0||D.$nf(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const b=u.length;if(this.d+b>=this.a){this.f(),this.c[this.c.length]=u;return}for(let o=0;o<b;o++)this.b[this.d++]=u.charCodeAt(o)}}e.$ot=S}),define(Se[177],De([1,0,21,176]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=void 0;function f($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,M,I,p){this.oldPosition=k,this.oldText=M,this.newPosition=I,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,M,I){const p=M.length;D.$xe(k,p,I),I+=4;for(let S=0;S<p;S++)D.$ve(k,M.charCodeAt(S),I),I+=2;return I}static d(k,M){const I=D.$we(k,M);return M+=4,(0,O.$nt)(k,M,I)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(k,M){return D.$xe(k,this.oldPosition,M),M+=4,D.$xe(k,this.newPosition,M),M+=4,M=R.c(k,this.oldText,M),M=R.c(k,this.newText,M),M}static read(k,M,I){const p=D.$we(k,M);M+=4;const S=D.$we(k,M);M+=4;const E=R.d(k,M);M+=R.a(E);const u=R.d(k,M);return M+=R.a(u),I.push(new R(p,E,S,u)),M}}e.$pt=R;function L($,k){return $===null||$.length===0?k:new w($,k).compress()}e.$qt=L;class w{constructor(k,M){this.a=k,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,M=0,I=this.n(k),p=this.l(M);for(;k<this.f||M<this.h;){if(I===null){this.k(p),p=this.l(++M);continue}if(p===null){this.m(I),I=this.n(++k);continue}if(p.oldEnd<=I.newPosition){this.k(p),p=this.l(++M);continue}if(I.newEnd<=p.oldPosition){this.m(I),I=this.n(++k);continue}if(p.oldPosition<I.newPosition){const[o,i]=w.r(p,I.newPosition-p.oldPosition);this.k(o),p=i;continue}if(I.newPosition<p.oldPosition){const[o,i]=w.q(I,p.oldPosition-I.newPosition);this.m(o),I=i;continue}let u,b;if(p.oldEnd===I.newEnd)u=I,b=p,I=this.n(++k),p=this.l(++M);else if(p.oldEnd<I.newEnd){const[o,i]=w.q(I,p.oldLength);u=o,b=p,I=i,p=this.l(++M)}else{const[o,i]=w.r(p,I.newLength);u=I,b=o,I=this.n(++k),p=i}this.d[this.e++]=new R(u.oldPosition,u.oldText,b.newPosition,b.newText),this.g+=u.newLength-u.oldLength,this.j+=b.newLength-b.oldLength}const S=w.s(this.d);return w.t(S)}k(k){this.d[this.e++]=w.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=w.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,M){return new R(M.oldPosition-k,M.oldText,M.newPosition,M.newText)}static p(k,M){return new R(M.oldPosition,M.oldText,M.newPosition+k,M.newText)}static q(k,M){const I=k.newText.substr(0,M),p=k.newText.substr(M);return[new R(k.oldPosition,k.oldText,k.newPosition,I),new R(k.oldEnd,"",k.newPosition+M,p)]}static r(k,M){const I=k.oldText.substr(0,M),p=k.oldText.substr(M);return[new R(k.oldPosition,I,k.newPosition,k.newText),new R(k.oldPosition+M,p,k.newEnd,"")]}static s(k){if(k.length===0)return k;const M=[];let I=0,p=k[0];for(let S=1;S<k.length;S++){const E=k[S];p.oldEnd===E.oldPosition?p=new R(p.oldPosition,p.oldText+E.oldText,p.newPosition,p.newText+E.newText):(M[I++]=p,p=E)}return M[I++]=p,M}static t(k){if(k.length===0)return k;const M=[];let I=0;for(let p=0;p<k.length;p++){const S=k[p];S.oldText!==S.newText&&(M[I++]=S)}return M}}}),define(Se[178],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0,e.$Es={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[179],De([1,0,129]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$tt=e.WordCharacterClass=void 0;var O;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class f extends D.$rt{constructor(w){super(0);for(let $=0,k=w.length;$<k;$++)this.set(w.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$tt=f;function R(L){const w={};return $=>(w.hasOwnProperty($)||(w[$]=L($)),w[$])}e.$ut=R(L=>new f(L))}),define(Se[130],De([1,0,48,3,75]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=e.$Is=e.$Hs=e.$Gs=e.$Fs=void 0,e.$Fs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Fs)I.indexOf(S)>=0||(p+="\\"+S);return p+="\\s]+)",new RegExp(p,"g")}e.$Gs=R();function L(I){let p=e.$Gs;if(I&&I instanceof RegExp)if(I.global)p=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),p=new RegExp(I.source,S)}return p.lastIndex=0,p}e.$Hs=L;const w=new f.$4c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(I){const p=w.unshift(I);return(0,O.$Rc)(p)}e.$Is=$;function k(I,p,S,E,u){if(p=L(p),u||(u=D.Iterable.first(w)),S.length>u.maxLen){let s=I-u.maxLen/2;return s<0?s=0:E+=s,S=S.substring(s,I+u.maxLen/2),k(I,p,S,E,u)}const b=Date.now(),o=I-1-E;let i=-1,n=null;for(let s=1;!(Date.now()-b>=u.timeBudget);s++){const a=o-u.windowSize*s;p.lastIndex=Math.max(0,a);const t=M(p,S,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const s={word:n[0],startColumn:E+1+n.index,endColumn:E+1+n.index+n[0].length};return p.lastIndex=0,s}return null}e.$Js=k;function M(I,p,S,E){let u;for(;u=I.exec(p);){const b=u.index||0;if(b<=S&&I.lastIndex>=S)return u;if(E>0&&b>E)return null}return null}}),define(Se[180],De([1,0,35,17]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=e.$Nt=void 0;function f(L,w,$,k,M,I){if(Array.isArray(L)){let p=0;for(const S of L){const E=f(S,w,$,k,M,I);if(E===10)return E;E>p&&(p=E)}return p}else{if(typeof L=="string")return k?L==="*"?5:L===$?10:0:0;if(L){const{language:p,pattern:S,scheme:E,hasAccessToAllModels:u,notebookType:b}=L;if(!k&&!u)return 0;b&&M&&(w=M);let o=0;if(E)if(E===w.scheme)o=10;else if(E==="*")o=5;else return 0;if(p)if(p===$)o=10;else if(p==="*")o=Math.max(o,5);else return 0;if(b)if(b===I)o=10;else if(b==="*"&&I!==void 0)o=Math.max(o,5);else return 0;if(S){let i;if(typeof S=="string"?i=S:i={...S,base:(0,O.$hc)(S.base)},i===w.fsPath||(0,D.$Wj)(i,w.fsPath))o=10;else return 0}return o}else return 0}}e.$Nt=f;function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}e.$Ot=R}),define(Se[181],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6t=e.$5t=e.IndentAction=void 0;var D;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class O{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let $=0,k=w.notIn.length;$<k;$++)switch(w.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,$){if(w.getTokenCount()===0)return!0;const k=w.findTokenIndexAtOffset($-2),M=w.getStandardTokenType(k);return this.isOK(M)}g(w,$){for(let k=w;k<=$;k++){const M=String.fromCharCode(k);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$5t=O;class f{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of w)R(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),R(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),R(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),R(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&R(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$6t=f;function R(L,w,$){L.has(w)?L.get(w).push($):L.set(w,[$])}}),define(Se[182],De([1,0,129]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_1=e.$$1=e.$01=e.State=void 0;var O;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class f{constructor(E,u,b){const o=new Uint8Array(E*u);for(let i=0,n=E*u;i<n;i++)o[i]=b;this.a=o,this.rows=E,this.cols=u}get(E,u){return this.a[E*this.cols+u]}set(E,u,b){this.a[E*this.cols+u]=b}}class R{constructor(E){let u=0,b=0;for(let i=0,n=E.length;i<n;i++){const[s,a,t]=E[i];a>u&&(u=a),s>b&&(b=s),t>b&&(b=t)}u++,b++;const o=new f(b,u,0);for(let i=0,n=E.length;i<n;i++){const[s,a,t]=E[i];o.set(s,a,t)}this.a=o,this.b=u}nextState(E,u){return u<0||u>=this.b?0:this.a.get(E,u)}}e.$01=R;let L=null;function w(){return L===null&&(L=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var $;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})($||($={}));let k=null;function M(){if(k===null){k=new D.$rt(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<S.length;u++)k.set(S.charCodeAt(u),1);const E=".,;:";for(let u=0;u<E.length;u++)k.set(E.charCodeAt(u),2)}return k}class I{static a(E,u,b,o,i){let n=i-1;do{const s=u.charCodeAt(n);if(E.get(s)!==2)break;n--}while(n>o);if(o>0){const s=u.charCodeAt(o-1),a=u.charCodeAt(n);(s===40&&a===41||s===91&&a===93||s===123&&a===125)&&n--}return{range:{startLineNumber:b,startColumn:o+1,endLineNumber:b,endColumn:n+2},url:u.substring(o,n+1)}}static computeLinks(E,u=w()){const b=M(),o=[];for(let i=1,n=E.getLineCount();i<=n;i++){const s=E.getLineContent(i),a=s.length;let t=0,d=0,l=0,r=1,c=!1,h=!1,g=!1,C=!1;for(;t<a;){let v=!1;const m=s.charCodeAt(t);if(r===13){let y;switch(m){case 40:c=!0,y=0;break;case 41:y=c?0:1;break;case 91:g=!0,h=!0,y=0;break;case 93:g=!1,y=h?0:1;break;case 123:C=!0,y=0;break;case 125:y=C?0:1;break;case 39:case 34:case 96:l===m?y=1:l===39||l===34||l===96?y=0:y=1;break;case 42:y=l===42?1:0;break;case 124:y=l===124?1:0;break;case 32:y=g?0:1;break;default:y=b.get(m)}y===1&&(o.push(I.a(b,s,i,d,t)),v=!0)}else if(r===12){let y;m===91?(h=!0,y=0):y=b.get(m),y===1?v=!0:r=13}else r=u.nextState(r,m),r===0&&(v=!0);v&&(r=1,c=!1,h=!1,C=!1,d=t+1,l=m),t++}r===13&&o.push(I.a(b,s,i,d,a))}return o}}e.$$1=I;function p(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}e.$_1=p}),define(Se[82],De([1,0,24]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.ModelConstants=e.PositionAffinity=e.$ov=e.TrackedRangeStickiness=e.$nv=e.$mv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var O;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var f;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(f||(e.GlyphMarginLane=f={}));var R;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var w;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(w||(e.EndOfLinePreference=w={}));var $;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var k;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class M{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$Mn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$mv=M;class I{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$nv=I;var p;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function S(s){return s&&typeof s.read=="function"}e.$ov=S;var E;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(E||(e.PositionAffinity=E={}));var u;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class b{constructor(a,t,d,l,r,c){this.identifier=a,this.range=t,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=r,this._isTracked=c}}e.$pv=b;class o{constructor(a,t,d){this.regex=a,this.wordSeparators=t,this.simpleSearch=d}}e.$qv=o;class i{constructor(a,t,d){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=d}}e.$rv=i;function n(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}e.$sv=n}),define(Se[183],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=e.$7B=e.NodeColor=e.$6B=void 0;class D{constructor(b,o){this.piece=b,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$7B)return f(this.right);let b=this;for(;b.parent!==e.$7B&&b.parent.left!==b;)b=b.parent;return b.parent===e.$7B?e.$7B:b.parent}prev(){if(this.left!==e.$7B)return R(this.left);let b=this;for(;b.parent!==e.$7B&&b.parent.right!==b;)b=b.parent;return b.parent===e.$7B?e.$7B:b.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$6B=D;var O;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$7B=new D(null,0),e.$7B.parent=e.$7B,e.$7B.left=e.$7B,e.$7B.right=e.$7B,e.$7B.color=0;function f(u){for(;u.left!==e.$7B;)u=u.left;return u}e.$8B=f;function R(u){for(;u.right!==e.$7B;)u=u.right;return u}e.$9B=R;function L(u){return u===e.$7B?0:u.size_left+u.piece.length+L(u.right)}function w(u){return u===e.$7B?0:u.lf_left+u.piece.lineFeedCnt+w(u.right)}function $(){e.$7B.parent=e.$7B}function k(u,b){const o=b.right;o.size_left+=b.size_left+(b.piece?b.piece.length:0),o.lf_left+=b.lf_left+(b.piece?b.piece.lineFeedCnt:0),b.right=o.left,o.left!==e.$7B&&(o.left.parent=b),o.parent=b.parent,b.parent===e.$7B?u.root=o:b.parent.left===b?b.parent.left=o:b.parent.right=o,o.left=b,b.parent=o}e.$0B=k;function M(u,b){const o=b.left;b.left=o.right,o.right!==e.$7B&&(o.right.parent=b),o.parent=b.parent,b.size_left-=o.size_left+(o.piece?o.piece.length:0),b.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),b.parent===e.$7B?u.root=o:b===b.parent.right?b.parent.right=o:b.parent.left=o,o.right=b,b.parent=o}e.$$B=M;function I(u,b){let o,i;if(b.left===e.$7B?(i=b,o=i.right):b.right===e.$7B?(i=b,o=i.left):(i=f(b.right),o=i.right),i===u.root){u.root=o,o.color=0,b.detach(),$(),u.root.parent=e.$7B;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===b?(o.parent=i.parent,E(u,o)):(i.parent===b?o.parent=i:o.parent=i.parent,E(u,o),i.left=b.left,i.right=b.right,i.parent=b.parent,i.color=b.color,b===u.root?u.root=i:b===b.parent.left?b.parent.left=i:b.parent.right=i,i.left!==e.$7B&&(i.left.parent=i),i.right!==e.$7B&&(i.right.parent=i),i.size_left=b.size_left,i.lf_left=b.lf_left,E(u,i)),b.detach(),o.parent.left===o){const a=L(o),t=w(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const d=a-o.parent.size_left,l=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,S(u,o.parent,d,l)}}if(E(u,o.parent),n){$();return}let s;for(;o!==u.root&&o.color===0;)o===o.parent.left?(s=o.parent.right,s.color===1&&(s.color=0,o.parent.color=1,k(u,o.parent),s=o.parent.right),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.right.color===0&&(s.left.color=0,s.color=1,M(u,s),s=o.parent.right),s.color=o.parent.color,o.parent.color=0,s.right.color=0,k(u,o.parent),o=u.root)):(s=o.parent.left,s.color===1&&(s.color=0,o.parent.color=1,M(u,o.parent),s=o.parent.left),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.left.color===0&&(s.right.color=0,s.color=1,k(u,s),s=o.parent.left),s.color=o.parent.color,o.parent.color=0,s.left.color=0,M(u,o.parent),o=u.root));o.color=0,$()}e.$_B=I;function p(u,b){for(E(u,b);b!==u.root&&b.parent.color===1;)if(b.parent===b.parent.parent.left){const o=b.parent.parent.right;o.color===1?(b.parent.color=0,o.color=0,b.parent.parent.color=1,b=b.parent.parent):(b===b.parent.right&&(b=b.parent,k(u,b)),b.parent.color=0,b.parent.parent.color=1,M(u,b.parent.parent))}else{const o=b.parent.parent.left;o.color===1?(b.parent.color=0,o.color=0,b.parent.parent.color=1,b=b.parent.parent):(b===b.parent.left&&(b=b.parent,M(u,b)),b.parent.color=0,b.parent.parent.color=1,k(u,b.parent.parent))}u.root.color=0}e.$aC=p;function S(u,b,o,i){for(;b!==u.root&&b!==e.$7B;)b.parent.left===b&&(b.parent.size_left+=o,b.parent.lf_left+=i),b=b.parent}e.$bC=S;function E(u,b){let o=0,i=0;if(b!==u.root){for(;b!==u.root&&b===b.parent.right;)b=b.parent;if(b!==u.root)for(b=b.parent,o=L(b.left)-b.size_left,i=w(b.left)-b.lf_left,b.size_left+=o,b.lf_left+=i;b!==u.root&&(o!==0||i!==0);)b.parent.left===b&&(b.parent.size_left+=o,b.parent.lf_left+=i),b=b.parent}}e.$cC=E}),define(Se[184],De([1,0,19,127]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.$vv=void 0;class f{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,k){$=(0,O.$Re)($);const M=this.a,I=this.b,p=k.length;return p===0?!1:(this.a=new Uint32Array(M.length+p),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($),$+p),this.a.set(k,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue($,k){return $=(0,O.$Re)($),k=(0,O.$Re)(k),this.a[$]===k?!1:(this.a[$]=k,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,k){$=(0,O.$Re)($),k=(0,O.$Re)(k);const M=this.a,I=this.b;if($>=M.length)return!1;const p=M.length-$;return k>=p&&(k=p),k===0?!1:(this.a=new Uint32Array(M.length-k),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($+k),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,O.$Re)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),$>=this.a.length&&($=this.a.length-1);for(let M=k;M<=$;M++)this.b[M]=this.b[M-1]+this.a[M];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let k=0,M=this.a.length-1,I=0,p=0,S=0;for(;k<=M;)if(I=k+(M-k)/2|0,p=this.b[I],S=p-this.a[I],$<S)M=I-1;else if($>=p)k=I+1;else break;return new L(I,$-S)}}e.$vv=f;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const k=this.e[$],M=k>0?this.d[k-1]:0;return new L(k,$-M)}removeValues($,k){this.a.splice($,k),this.f($)}insertValues($,k){this.a=(0,D.$Wb)(this.a,$,k),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,k=this.a.length;$<k;$++){const M=this.a[$],I=$>0?this.d[$-1]:0;this.d[$]=I+M;for(let p=0;p<M;p++)this.e[I+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,k){this.a[$]!==k&&(this.a[$]=k,this.f($))}}e.$wv=R;class L{constructor($,k){this.index=$,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=k}}e.$xv=L}),define(Se[185],De([1,0,12,51,184]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=void 0;class R{constructor(w,$,k,M){this.d=w,this.f=$,this.g=k,this.h=M,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const $=w.changes;for(const k of $)this.o(k.range),this.p(new O.$6s(k.range.startLineNumber,k.range.startColumn),k.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,$=this.f.length,k=new Uint32Array($);for(let M=0;M<$;M++)k[M]=this.f[M].length+w;this.j=new f.$vv(k)}}n(w,$){this.f[w]=$,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,$){if($.length===0)return;const k=(0,D.$9e)($);if(k.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+k[0]+this.f[w.lineNumber-1].substring(w.column-1));return}k[k.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+k[0]);const M=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this.f.splice(w.lineNumber+I-1,0,k[I]),M[I-1]=k[I].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,M)}}e.$yv=R}),define(Se[104],De([1,0,12,179,51,29,82]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=e.$hC=e.$gC=e.$fC=e.$eC=e.$dC=void 0;const w=999;class ${constructor(i,n,s,a){this.searchString=i,this.isRegex=n,this.matchCase=s,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=k(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$7e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let s=!this.isRegex&&!i;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new L.$qv(n,this.wordSeparators?(0,O.$ut)(this.wordSeparators):null,s?this.searchString:null)}}e.$dC=$;function k(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const s=o.charCodeAt(i);if(s===10)return!0;if(s===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$eC=k;function M(o,i,n){if(!n)return new L.$nv(o,null);const s=[];for(let a=0,t=i.length;a<t;a++)s[a]=i[a];return new L.$nv(o,s)}e.$fC=M;class I{constructor(i){const n=[];let s=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[s++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let s=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;s<a;){const t=s+((a-s)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(s=t,a=t):s=t+1}return s+1}}class p{static findMatches(i,n,s,a,t){const d=n.parseSearchRequest();return d?d.regex.multiline?this.b(i,s,new b(d.wordSeparators,d.regex),a,t):this.c(i,s,d,a,t):[]}static a(i,n,s,a,t,d){let l,r=0;a?(r=a.findLineFeedCountBeforeOffset(t),l=n+t+r):l=n+t;let c;if(a){const v=a.findLineFeedCountBeforeOffset(t+d.length)-r;c=l+d.length+v}else c=l+d.length;const h=i.getPositionAt(l),g=i.getPositionAt(c);return new R.$7s(h.lineNumber,h.column,g.lineNumber,g.column)}static b(i,n,s,a,t){const d=i.getOffsetAt(n.getStartPosition()),l=i.getValueInRange(n,1),r=i.getEOL()===`\r
`?new I(l):null,c=[];let h=0,g;for(s.reset(0);g=s.next(l);)if(c[h++]=M(this.a(i,d,l,r,g.index,g[0]),g,a),h>=t)return c;return c}static c(i,n,s,a,t){const d=[];let l=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return l=this.d(s,c,n.startLineNumber,n.startColumn-1,l,d,a,t),d}const r=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);l=this.d(s,r,n.startLineNumber,n.startColumn-1,l,d,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&l<t;c++)l=this.d(s,i.getLineContent(c),c,0,l,d,a,t);if(l<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);l=this.d(s,c,n.endLineNumber,0,l,d,a,t)}return d}static d(i,n,s,a,t,d,l,r){const c=i.wordSeparators;if(!l&&i.simpleSearch){const C=i.simpleSearch,v=C.length,m=n.length;let y=-v;for(;(y=n.indexOf(C,y+v))!==-1;)if((!c||u(c,n,m,y,v))&&(d[t++]=new L.$nv(new R.$7s(s,y+1+a,s,y+1+v+a),null),t>=r))return t;return t}const h=new b(i.wordSeparators,i.regex);let g;h.reset(0);do if(g=h.next(n),g&&(d[t++]=M(new R.$7s(s,g.index+1+a,s,g.index+1+g[0].length+a),g,l),t>=r))return t;while(g);return t}static findNextMatch(i,n,s,a){const t=n.parseSearchRequest();if(!t)return null;const d=new b(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,s,d,a):this.f(i,s,d,a)}static e(i,n,s,a){const t=new f.$6s(n.lineNumber,1),d=i.getOffsetAt(t),l=i.getLineCount(),r=i.getValueInRange(new R.$7s(t.lineNumber,t.column,l,i.getLineMaxColumn(l)),1),c=i.getEOL()===`\r
`?new I(r):null;s.reset(n.column-1);const h=s.next(r);return h?M(this.a(i,d,r,c,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new f.$6s(1,1),s,a):null}static f(i,n,s,a){const t=i.getLineCount(),d=n.lineNumber,l=i.getLineContent(d),r=this.g(s,l,d,n.column,a);if(r)return r;for(let c=1;c<=t;c++){const h=(d+c-1)%t,g=i.getLineContent(h+1),C=this.g(s,g,h+1,1,a);if(C)return C}return null}static g(i,n,s,a,t){i.reset(a-1);const d=i.next(n);return d?M(new R.$7s(s,d.index+1,s,d.index+1+d[0].length),d,t):null}static findPreviousMatch(i,n,s,a){const t=n.parseSearchRequest();if(!t)return null;const d=new b(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,s,d,a):this.j(i,s,d,a)}static h(i,n,s,a){const t=this.b(i,new R.$7s(1,1,n.lineNumber,n.column),s,a,10*w);if(t.length>0)return t[t.length-1];const d=i.getLineCount();return n.lineNumber!==d||n.column!==i.getLineMaxColumn(d)?this.h(i,new f.$6s(d,i.getLineMaxColumn(d)),s,a):null}static j(i,n,s,a){const t=i.getLineCount(),d=n.lineNumber,l=i.getLineContent(d).substring(0,n.column-1),r=this.k(s,l,d,a);if(r)return r;for(let c=1;c<=t;c++){const h=(t+d-c-1)%t,g=i.getLineContent(h+1),C=this.k(s,g,h+1,a);if(C)return C}return null}static k(i,n,s,a){let t=null,d;for(i.reset(0);d=i.next(n);)t=M(new R.$7s(s,d.index+1,s,d.index+1+d[0].length),d,a);return t}}e.$gC=p;function S(o,i,n,s,a){if(s===0)return!0;const t=i.charCodeAt(s-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const d=i.charCodeAt(s);if(o.get(d)!==0)return!0}return!1}function E(o,i,n,s,a){if(s+a===n)return!0;const t=i.charCodeAt(s+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const d=i.charCodeAt(s+a-1);if(o.get(d)!==0)return!0}return!1}function u(o,i,n,s,a){return S(o,i,n,s,a)&&E(o,i,n,s,a)}e.$hC=u;class b{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let s;do{if(this.b+this.c===n||(s=this.a.exec(i),!s))return null;const a=s.index,t=s[0].length;if(a===this.b&&t===this.c){if(t===0){D.$qf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||u(this._wordSeparators,i,n,a,t))return s}while(s);return null}}e.$iC=b}),define(Se[131],De([1,0,51,29,82,183,104]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=void 0;const w=65535;function $(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class k{constructor(i,n,s,a,t){this.lineStarts=i,this.cr=n,this.lf=s,this.crlf=a,this.isBasicASCII=t}}function M(o,i=!0){const n=[0];let s=1;for(let a=0,t=o.length;a<t;a++){const d=o.charCodeAt(a);d===13?a+1<t&&o.charCodeAt(a+1)===10?(n[s++]=a+2,a++):n[s++]=a+1:d===10&&(n[s++]=a+1)}return i?$(n):n}e.$jC=M;function I(o,i){o.length=0,o[0]=0;let n=1,s=0,a=0,t=0,d=!0;for(let r=0,c=i.length;r<c;r++){const h=i.charCodeAt(r);h===13?r+1<c&&i.charCodeAt(r+1)===10?(t++,o[n++]=r+2,r++):(s++,o[n++]=r+1):h===10?(a++,o[n++]=r+1):d&&h!==9&&(h<32||h>126)&&(d=!1)}const l=new k($(o),s,a,t,d);return o.length=0,l}e.$kC=I;class p{constructor(i,n,s,a,t){this.bufferIndex=i,this.start=n,this.end=s,this.lineFeedCnt=a,this.length=t}}e.$lC=p;class S{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$mC=S;class E{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$7B&&i.iterate(i.root,s=>(s!==R.$7B&&this.a.push(s.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const s=this.b[n];if(s.nodeStartOffset<=i&&s.nodeStartOffset+s.node.piece.length>=i)return s}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const s=this.b[n];if(s.nodeStartLineNumber&&s.nodeStartLineNumber<i&&s.nodeStartLineNumber+s.node.piece.lineFeedCnt>=i)return s}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const s=this.b;for(let a=0;a<s.length;a++){const t=s[a];if(t.node.parent===null||t.nodeStartOffset>=i){s[a]=null,n=!0;continue}}if(n){const a=[];for(const t of s)t!==null&&a.push(t);this.b=a}}}class b{constructor(i,n,s){this.create(i,n,s)}create(i,n,s){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=R.$7B,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=s;let a=null;for(let t=0,d=i.length;t<d;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=M(i[t].buffer));const l=new p(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,l)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=w,s=n-Math.floor(n/3),a=s*2;let t="",d=0;const l=[];if(this.iterate(this.root,r=>{const c=this.R(r),h=c.length;if(d<=s||d+h<a)return t+=c,d+=h,!0;const g=t.replace(/\r\n|\r|\n/g,i);return l.push(new S(g,M(g))),t=c,d=h,!0}),d>0){const r=t.replace(/\r\n|\r|\n/g,i);l.push(new S(r,M(r)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new E(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===R.$7B)return!0;const t=this.R(a),d=t.length,l=i.G(n),r=i.G(n+d),c=i.getValueInRange2(l,r);return n+=d,t===c})}getOffsetAt(i,n){let s=0,a=this.root;for(;a!==R.$7B;)if(a.left!==R.$7B&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){s+=a.size_left;const t=this.B(a,i-a.lf_left-2);return s+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right;return s}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,s=0;const a=i;for(;n!==R.$7B;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(s+=n.lf_left+t.index,t.index===0){const d=this.getOffsetAt(s+1,1),l=a-d;return new D.$6s(s+1,l+1)}return new D.$6s(s+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,s+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$7B){const t=this.getOffsetAt(s+1,1),d=a-i-t;return new D.$6s(s+1,d+1)}else n=n.right;return new D.$6s(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const s=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(s,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const l=i.node,r=this.a[l.piece.bufferIndex].buffer,c=this.u(l.piece.bufferIndex,l.piece.start);return r.substring(c+i.remainder,c+n.remainder)}let s=i.node;const a=this.a[s.piece.bufferIndex].buffer,t=this.u(s.piece.bufferIndex,s.piece.start);let d=a.substring(t+i.remainder,t+s.piece.length);for(s=s.next();s!==R.$7B;){const l=this.a[s.piece.bufferIndex].buffer,r=this.u(s.piece.bufferIndex,s.piece.start);if(s===n.node){d+=l.substring(r,r+n.remainder);break}else d+=l.substr(r,s.piece.length);s=s.next()}return d}getLinesContent(){const i=[];let n=0,s="",a=!1;return this.iterate(this.root,t=>{if(t===R.$7B)return!0;const d=t.piece;let l=d.length;if(l===0)return!0;const r=this.a[d.bufferIndex].buffer,c=this.a[d.bufferIndex].lineStarts,h=d.start.line,g=d.end.line;let C=c[h]+d.start.column;if(a&&(r.charCodeAt(C)===10&&(C++,l--),i[n++]=s,s="",a=!1,l===0))return!0;if(h===g)return!this.f&&r.charCodeAt(C+l-1)===13?(a=!0,s+=r.substr(C,l-1)):s+=r.substr(C,l),!0;s+=this.f?r.substring(C,Math.max(C,c[h+1]-this.e)):r.substring(C,c[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=s;for(let v=h+1;v<g;v++)s=this.f?r.substring(c[v],c[v+1]-this.e):r.substring(c[v],c[v+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=s;return!this.f&&r.charCodeAt(c[g]+d.end.column-1)===13?(a=!0,d.end.column===0?n--:s=r.substr(c[g],d.end.column-1)):s=r.substr(c[g],d.end.column),!0}),a&&(i[n++]=s,s=""),i[n++]=s,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const s=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return s.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const s=this.H(i,n+1);return this.l(s)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,s,a,t,d,l,r,c,h,g){const C=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),m=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,d);let P;const j={line:0,column:0};let U,z;n._wordSeparators?(U=C.buffer.substring(m,y),z=N=>N+m,n.reset(0)):(U=C.buffer,z=N=>N,n.reset(m));do if(P=n.next(U),P){if(z(P.index)>=y)return h;this.s(i,z(P.index)-v,j);const N=this.t(i.piece.bufferIndex,t,j),A=j.line===t.line?j.column-t.column+a:j.column+1,T=A+P[0].length;if(g[h++]=(0,L.$fC)(new O.$7s(s+N,A,s+N,T),P,r),z(P.index)+P[0].length>=y||h>=c)return h}while(P);return h}findMatchesLineByLine(i,n,s,a){const t=[];let d=0;const l=new L.$iC(n.wordSeparators,n.regex);let r=this.H(i.startLineNumber,i.startColumn);if(r===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let h=this.s(r.node,r.remainder);const g=this.s(c.node,c.remainder);if(r.node===c.node)return this.findMatchesInNode(r.node,l,i.startLineNumber,i.startColumn,h,g,n,s,a,d,t),t;let C=i.startLineNumber,v=r.node;for(;v!==c.node;){const y=this.t(v.piece.bufferIndex,h,v.piece.end);if(y>=1){const j=this.a[v.piece.bufferIndex].lineStarts,U=this.u(v.piece.bufferIndex,v.piece.start),z=j[h.line+y],N=C===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(v,l,C,N,h,this.s(v,z-U),n,s,a,d,t),d>=a)return t;C+=y}const P=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const j=this.getLineContent(C).substring(P,i.endColumn-1);return d=this.n(n,l,j,i.endLineNumber,P,d,t,s,a),t}if(d=this.n(n,l,this.getLineContent(C).substr(P),C,P,d,t,s,a),d>=a)return t;C++,r=this.H(C,1),v=r.node,h=this.s(r.node,r.remainder)}if(C===i.endLineNumber){const y=C===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(C).substring(y,i.endColumn-1);return d=this.n(n,l,P,i.endLineNumber,y,d,t,s,a),t}const m=C===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(c.node,l,C,m,h,g,n,s,a,d,t),t}n(i,n,s,a,t,d,l,r,c){const h=i.wordSeparators;if(!r&&i.simpleSearch){const C=i.simpleSearch,v=C.length,m=s.length;let y=-v;for(;(y=s.indexOf(C,y+v))!==-1;)if((!h||(0,L.$hC)(h,s,m,y,v))&&(l[d++]=new f.$nv(new O.$7s(a,y+1+t,a,y+1+v+t),null),d>=c))return d;return d}let g;n.reset(0);do if(g=n.next(s),g&&(l[d++]=(0,L.$fC)(new O.$7s(a,g.index+1+t,a,g.index+1+g[0].length+t),g,r),d>=c))return d;while(g);return d}insert(i,n,s=!1){if(this.f=this.f&&s,this.j.lineNumber=0,this.j.value="",this.root!==R.$7B){const{node:a,remainder:t,nodeStartOffset:d}=this.G(i),l=a.piece,r=l.bufferIndex,c=this.s(a,t);if(a.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&n.length<w){this.F(a,n),this.y();return}if(d===i)this.o(n,a),this.h.validate(i);else if(d+a.piece.length>i){const h=[];let g=new p(l.bufferIndex,c,l.end,this.t(l.bufferIndex,c,l.end),this.u(r,l.end)-this.u(r,c));if(this.K()&&this.M(n)&&this.I(a,t)===10){const y={line:g.start.line+1,column:0};g=new p(g.bufferIndex,y,g.end,this.t(g.bufferIndex,y,g.end),g.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const y=this.s(a,t-1);this.C(a,y),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,c);else this.C(a,c);const C=this.w(n);g.length>0&&this.S(a,g);let v=a;for(let m=0;m<C.length;m++)v=this.S(v,C[m]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let d=1;d<a.length;d++)t=this.S(t,a[d])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$7B)return;const s=this.G(i),a=this.G(i+n),t=s.node,d=a.node;if(t===d){const C=this.s(t,s.remainder),v=this.s(t,a.remainder);if(s.nodeStartOffset===i){if(n===t.piece.length){const m=t.next();(0,R.$_B)(this,t),this.N(m),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(s.nodeStartOffset+t.piece.length===i+n){this.C(t,C),this.O(t),this.y();return}this.E(t,C,v),this.y();return}const l=[],r=this.s(t,s.remainder);this.C(t,r),this.h.validate(i),t.piece.length===0&&l.push(t);const c=this.s(d,a.remainder);this.D(d,c),d.piece.length===0&&l.push(d);const h=t.next();for(let C=h;C!==R.$7B&&C!==d;C=C.next())l.push(C);const g=t.piece.length===0?t.prev():t;this.v(l),this.O(g),this.y()}o(i,n){const s=[];if(this.K()&&this.M(i)&&this.L(n)){const d=n.piece,l={line:d.start.line+1,column:0},r=new p(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);n.piece=r,i+=`
`,(0,R.$bC)(this,n,-1,-1),n.piece.length===0&&s.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let d=a.length-2;d>=0;d--)t=this.T(t,a[d]);this.N(t),this.v(s)}q(i,n){this.Q(i,n)&&(i+=`
`);const s=this.w(i),a=this.S(n,s[0]);let t=a;for(let d=1;d<s.length;d++)t=this.S(t,s[d]);this.N(a)}s(i,n,s){const a=i.piece,t=i.piece.bufferIndex,d=this.a[t].lineStarts,r=d[a.start.line]+a.start.column+n;let c=a.start.line,h=a.end.line,g=0,C=0,v=0;for(;c<=h&&(g=c+(h-c)/2|0,v=d[g],g!==h);)if(C=d[g+1],r<v)h=g-1;else if(r>=C)c=g+1;else break;return s?(s.line=g,s.column=r-v,null):{line:g,column:r-v}}t(i,n,s){if(s.column===0)return s.line-n.line;const a=this.a[i].lineStarts;if(s.line===a.length-1)return s.line-n.line;const t=a[s.line+1],d=a[s.line]+s.column;if(t>d+1)return s.line-n.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?s.line-n.line+1:s.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$_B)(this,i[n])}w(i){if(i.length>w){const h=[];for(;i.length>w;){const C=i.charCodeAt(w-1);let v;C===13||C>=55296&&C<=56319?(v=i.substring(0,w-1),i=i.substring(w-1)):(v=i.substring(0,w),i=i.substring(w));const m=M(v);h.push(new p(this.a.length,{line:0,column:0},{line:m.length-1,column:v.length-m[m.length-1]},m.length-1,v.length)),this.a.push(new S(v,m))}const g=M(i);return h.push(new p(this.a.length,{line:0,column:0},{line:g.length-1,column:i.length-g[g.length-1]},g.length-1,i.length)),this.a.push(new S(i,g)),h}let n=this.a[0].buffer.length;const s=M(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<s.length;h++)s[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<s.length;h++)s[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=t-this.a[0].lineStarts[d],r={line:d,column:l},c=new p(0,a,r,this.t(0,a,r),t-n);return this.g=r,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let s=this.root,a="";const t=this.h.get2(i);if(t){s=t.node;const d=this.B(s,i-t.nodeStartLineNumber-1),l=this.a[s.piece.bufferIndex].buffer,r=this.u(s.piece.bufferIndex,s.piece.start);if(t.nodeStartLineNumber+s.piece.lineFeedCnt===i)a=l.substring(r+d,r+s.piece.length);else{const c=this.B(s,i-t.nodeStartLineNumber);return l.substring(r+d,r+c-n)}}else{let d=0;const l=i;for(;s!==R.$7B;)if(s.left!==R.$7B&&s.lf_left>=i-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>i-1){const r=this.B(s,i-s.lf_left-2),c=this.B(s,i-s.lf_left-1),h=this.a[s.piece.bufferIndex].buffer,g=this.u(s.piece.bufferIndex,s.piece.start);return d+=s.size_left,this.h.set({node:s,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-s.lf_left)}),h.substring(g+r,g+c-n)}else if(s.lf_left+s.piece.lineFeedCnt===i-1){const r=this.B(s,i-s.lf_left-2),c=this.a[s.piece.bufferIndex].buffer,h=this.u(s.piece.bufferIndex,s.piece.start);a=c.substring(h+r,h+s.piece.length);break}else i-=s.lf_left+s.piece.lineFeedCnt,d+=s.size_left+s.piece.length,s=s.right}for(s=s.next();s!==R.$7B;){const d=this.a[s.piece.bufferIndex].buffer;if(s.piece.lineFeedCnt>0){const l=this.B(s,0),r=this.u(s.piece.bufferIndex,s.piece.start);return a+=d.substring(r,r+l-n),a}else{const l=this.u(s.piece.bufferIndex,s.piece.start);a+=d.substr(l,s.piece.length)}s=s.next()}return a}y(){let i=this.root,n=1,s=0;for(;i!==R.$7B;)n+=i.lf_left+i.piece.lineFeedCnt,s+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=s,this.h.validate(this.c)}A(i,n){const s=i.piece,a=this.s(i,n),t=a.line-s.start.line;if(this.u(s.bufferIndex,s.end)-this.u(s.bufferIndex,s.start)===n){const d=this.t(i.piece.bufferIndex,s.start,a);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const s=i.piece,a=this.a[s.bufferIndex].lineStarts,t=s.start.line+n+1;return t>s.end.line?a[s.end.line]+s.end.column-a[s.start.line]-s.start.column:a[t]-a[s.start.line]-s.start.column}C(i,n){const s=i.piece,a=s.lineFeedCnt,t=this.u(s.bufferIndex,s.end),d=n,l=this.u(s.bufferIndex,d),r=this.t(s.bufferIndex,s.start,d),c=r-a,h=l-t,g=s.length+h;i.piece=new p(s.bufferIndex,s.start,d,r,g),(0,R.$bC)(this,i,h,c)}D(i,n){const s=i.piece,a=s.lineFeedCnt,t=this.u(s.bufferIndex,s.start),d=n,l=this.t(s.bufferIndex,d,s.end),r=this.u(s.bufferIndex,d),c=l-a,h=t-r,g=s.length+h;i.piece=new p(s.bufferIndex,d,s.end,l,g),(0,R.$bC)(this,i,h,c)}E(i,n,s){const a=i.piece,t=a.start,d=a.end,l=a.length,r=a.lineFeedCnt,c=n,h=this.t(a.bufferIndex,a.start,c),g=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new p(a.bufferIndex,a.start,c,h,g),(0,R.$bC)(this,i,g-l,h-r);const C=new p(a.bufferIndex,s,d,this.t(a.bufferIndex,s,d),this.u(a.bufferIndex,d)-this.u(a.bufferIndex,s)),v=this.S(i,C);this.N(v)}F(i,n){this.Q(n,i)&&(n+=`
`);const s=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=M(n,!1);for(let v=0;v<t.length;v++)t[v]+=a;if(s){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],r={line:d,column:l},c=i.piece.length+n.length,h=i.piece.lineFeedCnt,g=this.t(0,i.piece.start,r),C=g-h;i.piece=new p(i.piece.bufferIndex,i.piece.start,r,g,c),this.g=r,(0,R.$bC)(this,i,n.length,C)}G(i){let n=this.root;const s=this.h.get(i);if(s)return{node:s.node,nodeStartOffset:s.nodeStartOffset,remainder:i-s.nodeStartOffset};let a=0;for(;n!==R.$7B;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let s=this.root,a=0;for(;s!==R.$7B;)if(s.left!==R.$7B&&s.lf_left>=i-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>i-1){const t=this.B(s,i-s.lf_left-2),d=this.B(s,i-s.lf_left-1);return a+=s.size_left,{node:s,remainder:Math.min(t+n-1,d),nodeStartOffset:a}}else if(s.lf_left+s.piece.lineFeedCnt===i-1){const t=this.B(s,i-s.lf_left-2);if(t+n-1<=s.piece.length)return{node:s,remainder:t+n-1,nodeStartOffset:a};n-=s.piece.length-t;break}else i-=s.lf_left+s.piece.lineFeedCnt,a+=s.size_left+s.piece.length,s=s.right;for(s=s.next();s!==R.$7B;){if(s.piece.lineFeedCnt>0){const t=this.B(s,0),d=this.J(s);return{node:s,remainder:Math.min(n-1,t),nodeStartOffset:d}}else if(s.piece.length>=n-1){const t=this.J(s);return{node:s,remainder:n-1,nodeStartOffset:t}}else n-=s.piece.length;s=s.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const s=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return s.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$7B||i.piece.lineFeedCnt===0)return!1;const n=i.piece,s=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=s[a]+n.start.column;return a===s.length-1||s[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$7B||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const s=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new p(i.piece.bufferIndex,i.piece.start,t,l,d),(0,R.$bC)(this,i,-1,-1),i.piece.length===0&&s.push(i);const r={line:n.piece.start.line+1,column:0},c=n.piece.length-1,h=this.t(n.piece.bufferIndex,r,n.piece.end);n.piece=new p(n.piece.bufferIndex,r,n.piece.end,h,c),(0,R.$bC)(this,n,-1,-1),n.piece.length===0&&s.push(n);const g=this.w(`\r
`);this.S(i,g[0]);for(let C=0;C<s.length;C++)(0,R.$_B)(this,s[C])}Q(i,n){if(this.K()&&this.M(i)){const s=n.next();if(this.L(s)){if(i+=`
`,s.piece.length===1)(0,R.$_B)(this,s);else{const a=s.piece,t={line:a.start.line+1,column:0},d=a.length-1,l=this.t(a.bufferIndex,t,a.end);s.piece=new p(a.bufferIndex,t,a.end,l,d),(0,R.$bC)(this,s,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$7B)return n(R.$7B);const s=this.iterate(i.left,n);return s&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$7B)return"";const n=this.a[i.piece.bufferIndex],s=i.piece,a=this.u(s.bufferIndex,s.start),t=this.u(s.bufferIndex,s.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],s=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(s,a)}S(i,n){const s=new R.$6B(n,1);if(s.left=R.$7B,s.right=R.$7B,s.parent=R.$7B,s.size_left=0,s.lf_left=0,this.root===R.$7B)this.root=s,s.color=0;else if(i.right===R.$7B)i.right=s,s.parent=i;else{const t=(0,R.$8B)(i.right);t.left=s,s.parent=t}return(0,R.$aC)(this,s),s}T(i,n){const s=new R.$6B(n,1);if(s.left=R.$7B,s.right=R.$7B,s.parent=R.$7B,s.size_left=0,s.lf_left=0,this.root===R.$7B)this.root=s,s.color=0;else if(i.left===R.$7B)i.left=s,s.parent=i;else{const a=(0,R.$9B)(i.left);a.right=s,s.parent=a}return(0,R.$aC)(this,s),s}U(i){let n="";return this.iterate(i,s=>(n+=this.R(s),!0)),n}}e.$nC=b}),define(Se[186],De([1,0,4,12,29,82,131,173,177,3]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=void 0;class M extends k.$Tc{constructor(p,S,E,u,b,o,i){super(),this.m=this.B(new D.$5d),this.onDidChangeContent=this.m.event,this.f=S,this.j=!o,this.g=u,this.h=b,this.c=new L.$nC(p,E,i)}equals(p){return!(p instanceof M)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,S){return this.c.getOffsetAt(p,S)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,S){const E=p+S,u=this.getPositionAt(p),b=this.getPositionAt(E);return new f.$7s(u.lineNumber,u.column,b.lineNumber,b.column)}getValueInRange(p,S=0){if(p.isEmpty())return"";const E=this.n(S);return this.c.getValueInRange(p,E)}getValueLengthInRange(p,S=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const E=this.getOffsetAt(p.startLineNumber,p.startColumn),u=this.getOffsetAt(p.endLineNumber,p.endColumn);let b=0;const o=this.n(S),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,s=p.endLineNumber-p.startLineNumber;b=n*s}return u-E+b}getCharacterCountInRange(p,S=0){if(this.j){let E=0;const u=p.startLineNumber,b=p.endLineNumber;for(let o=u;o<=b;o++){const i=this.getLineContent(o),n=o===u?p.startColumn-1:0,s=o===b?p.endColumn-1:i.length;for(let a=n;a<s;a++)O.$nf(i.charCodeAt(a))?(E=E+1,a=a+1):E=E+1}return E+=this.n(S).length*(b-u),E}return this.getValueLengthInRange(p,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,S){return this.c.getLineCharCode(p,S)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const S=O.$$e(this.getLineContent(p));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(p){const S=O.$af(this.getLineContent(p));return S===-1?0:S+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,S,E){let u=this.g,b=this.h,o=this.j,i=!0,n=[];for(let c=0;c<p.length;c++){const h=p[c];i&&h._isTracked&&(i=!1);const g=h.range;if(h.text){let P=!0;o||(P=!O.$yf(h.text),o=P),!u&&P&&(u=O.$xf(h.text)),!b&&P&&(b=O.$Af(h.text))}let C="",v=0,m=0,y=0;if(h.text){let P;[v,m,y,P]=(0,w.$Gt)(h.text);const j=this.getEOL();P===0||P===(j===`\r
`?2:1)?C=h.text:C=h.text.replace(/\r\n|\r|\n/g,j)}n[c]={sortIndex:c,identifier:h.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:C,eolCount:v,firstLineLength:m,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(M.u);let s=!1;for(let c=0,h=n.length-1;c<h;c++){const g=n[c].range.getEndPosition(),C=n[c+1].range.getStartPosition();if(C.isBeforeOrEqual(g)){if(C.isBefore(g))throw new Error("Overlapping ranges are not allowed!");s=!0}}i&&(n=this.s(n));const a=E||S?M._getInverseEditRanges(n):[],t=[];if(S)for(let c=0;c<n.length;c++){const h=n[c],g=a[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let C=g.startLineNumber;C<=g.endLineNumber;C++){let v="";C===g.startLineNumber&&(v=this.getLineContent(h.range.startLineNumber),O.$$e(v)!==-1)||t.push({lineNumber:C,oldContent:v})}}let d=null;if(E){let c=0;d=[];for(let h=0;h<n.length;h++){const g=n[h],C=a[h],v=this.getValueInRange(g.range),m=g.rangeOffset+c;c+=g.text.length-v.length,d[h]={sortIndex:g.sortIndex,identifier:g.identifier,range:C,text:v,textChange:new $.$pt(g.rangeOffset,v,m,g.text)}}s||d.sort((h,g)=>h.sortIndex-g.sortIndex)}this.g=u,this.h=b,this.j=o;const l=this.t(n);let r=null;if(S&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),r=[];for(let c=0,h=t.length;c<h;c++){const g=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===g)continue;const C=t[c].oldContent,v=this.getLineContent(g);v.length===0||v===C||O.$$e(v)!==-1||r.push(g)}}return this.m.fire(),new R.$rv(d,l,r)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let S=!1;const E=p[0].range,u=p[p.length-1].range,b=new f.$7s(E.startLineNumber,E.startColumn,u.endLineNumber,u.endColumn);let o=E.startLineNumber,i=E.startColumn;const n=[];for(let l=0,r=p.length;l<r;l++){const c=p[l],h=c.range;S=S||c.forceMoveMarkers,n.push(this.getValueInRange(new f.$7s(o,i,h.startLineNumber,h.startColumn))),c.text.length>0&&n.push(c.text),o=h.endLineNumber,i=h.endColumn}const s=n.join(""),[a,t,d]=(0,w.$Gt)(s);return{sortIndex:0,identifier:p[0].identifier,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b,0),text:s,eolCount:a,firstLineLength:t,lastLineLength:d,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(p){p.sort(M.w);const S=[];for(let E=0;E<p.length;E++){const u=p[E],b=u.range.startLineNumber,o=u.range.startColumn,i=u.range.endLineNumber,n=u.range.endColumn;if(b===i&&o===n&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const s=new f.$7s(b,o,i,n);S.push({range:s,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return S}findMatchesLineByLine(p,S,E,u){return this.c.findMatchesLineByLine(p,S,E,u)}getPieceTree(){return this.c}static _getInverseEditRange(p,S){const E=p.startLineNumber,u=p.startColumn,[b,o,i]=(0,w.$Gt)(S);let n;if(S.length>0){const s=b+1;s===1?n=new f.$7s(E,u,E,u+o):n=new f.$7s(E,u,E+s-1,i+1)}else n=new f.$7s(E,u,E,u);return n}static _getInverseEditRanges(p){const S=[];let E=0,u=0,b=null;for(let o=0,i=p.length;o<i;o++){const n=p[o];let s,a;b?b.range.endLineNumber===n.range.startLineNumber?(s=E,a=u+(n.range.startColumn-b.range.endColumn)):(s=E+(n.range.startLineNumber-b.range.endLineNumber),a=n.range.startColumn):(s=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const d=n.eolCount+1;d===1?t=new f.$7s(s,a,s,a+n.firstLineLength):t=new f.$7s(s,a,s+d-1,n.lastLineLength+1)}else t=new f.$7s(s,a,s,a);E=t.endLineNumber,u=t.endColumn,S.push(t),b=n}return S}static u(p,S){const E=f.$7s.compareRangesUsingEnds(p.range,S.range);return E===0?p.sortIndex-S.sortIndex:E}static w(p,S){const E=f.$7s.compareRangesUsingEnds(p.range,S.range);return E===0?S.sortIndex-p.sortIndex:-E}}e.$oC=M}),define(Se[187],De([1,0,12,131,186]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pC=void 0;class R{constructor($,k,M,I,p,S,E,u,b){this.a=$,this.b=k,this.c=M,this.d=I,this.e=p,this.f=S,this.g=E,this.h=u,this.j=b}k($){const k=this.c+this.d+this.e,M=this.c+this.e;return k===0?$===1?`
`:`\r
`:M>k/2?`\r
`:`
`}create($){const k=this.k($),M=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let p=0,S=M.length;p<S;p++){const E=M[p].buffer.replace(/\r\n|\r|\n/g,k),u=(0,O.$jC)(E);M[p]=new O.$mC(E,u)}const I=new f.$oC(M,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$Gf($)&&(this.b=D.$Ff,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,O.$kC)(this.e,$);this.a.push(new O.$mC($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=D.$xf($)),this.k||(this.k=D.$Af($)))}finish($=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,O.$jC)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$pC=L}),define(Se[132],De([1,0,21,9]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cab=e.$bab=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function R(I){for(let p=0,S=I.length;p<S;p+=4){const E=I[p+0],u=I[p+1],b=I[p+2],o=I[p+3];I[p+0]=o,I[p+1]=b,I[p+2]=u,I[p+3]=E}}function L(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return O.$x()||R(p),D.$se.wrap(p)}function w(I){const p=I.buffer;if(O.$x()||R(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const S=new Uint8Array(p.byteLength);return S.set(p),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(I){const p=new Uint32Array(k(I));let S=0;if(p[S++]=I.id,I.type==="full")p[S++]=1,p[S++]=I.data.length,p.set(I.data,S),S+=I.data.length;else{p[S++]=2,p[S++]=I.deltas.length;for(const E of I.deltas)p[S++]=E.start,p[S++]=E.deleteCount,E.data?(p[S++]=E.data.length,p.set(E.data,S),S+=E.data.length):p[S++]=0}return L(p)}e.$bab=$;function k(I){let p=0;if(p+=2,I.type==="full")p+=1+I.data.length;else{p+=1,p+=3*I.deltas.length;for(const S of I.deltas)S.data&&(p+=S.data.length)}return p}function M(I){const p=w(I);let S=0;const E=p[S++];if(p[S++]===1){const i=p[S++],n=p.subarray(S,S+i);return S+=i,{id:E,type:"full",data:n}}const b=p[S++],o=[];for(let i=0;i<b;i++){const n=p[S++],s=p[S++],a=p[S++];let t;a>0&&(t=p.subarray(S,S+a),S+=a),o[i]={start:n,deleteCount:s,data:t}}return{id:E,type:"delta",deltas:o}}e.$cab=M}),define(Se[188],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9=e.$I9=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$I9=D;class O{constructor(R){this.identifier=R}}e.$J9=O}),define(Se[189],De([1,0,4,3]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$5d,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,$){return this.a.set(w,$),this.handleChange([w]),(0,O.$Rc)(()=>{this.a.get(w)===$&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,$){this.b.get(w)?.dispose();const k=new R(this,w,$);return this.b.set(w,k),(0,O.$Rc)(()=>{const M=this.b.get(w);!M||M!==k||(this.b.delete(w),M.dispose())})}async getOrCreate(w){const $=this.get(w);if($)return $;const k=this.b.get(w);return!k||k.isResolved?null:(await k.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const k=this.b.get(w);return!!(!k||k.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ft=f;class R extends O.$Tc{get isResolved(){return this.c}constructor(w,$,k){super(),this.f=w,this.g=$,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(Se[190],De([10,11]),function(re,e){return re.create("vs/base/common/actions",e)}),define(Se[191],De([1,0,4,3,190]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;class R extends O.$Tc{constructor(p,S="",E="",u=!0,b){super(),this.h=this.B(new D.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=S,this.u=E,this.w=u,this.C=b}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,S){this.C&&await this.C(p)}}e.$Vi=R;class L extends O.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$5d),this.onWillRun=this.f.event,this.m=this.B(new D.$5d),this.onDidRun=this.m.event}async run(p,S){if(!p.enabled)return;this.f.fire({action:p});let E;try{await this.u(p,S)}catch(u){E=u}this.m.fire({action:p,error:E})}async u(p,S){await p.run(S)}}e.$Wi=L;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let S=[];for(const E of p)E.length&&(S.length?S=[...S,new w,...E]:S=E);return S}async run(){}}e.$Xi=w,w.ID="vs.actions.separator";class ${get actions(){return this.a}constructor(p,S,E,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=S,this.class=u,this.a=E}async run(){}}e.$Yi=$;class k extends R{constructor(){super(k.ID,f.localize(0,null),void 0,!1)}}e.$Zi=k,k.ID="vs.actions.empty";function M(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...p)=>I.run(...p),tooltip:I.label}}e.$1i=M}),define(Se[192],De([10,11]),function(re,e){return re.create("vs/base/common/date",e)}),define(Se[193],De([1,0,192]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0;const O=60,f=O*60,R=f*24,L=R*7,w=R*30,$=R*365;function k(p,S,E,u){typeof p!="number"&&(p=p.getTime());const b=Math.round((new Date().getTime()-p)/1e3);if(b<-30)return(0,D.localize)(0,null,k(new Date().getTime()+b*1e3,!1));if(!u&&b<30)return(0,D.localize)(1,null);let o;return b<O?(o=b,S?o===1?E?(0,D.localize)(2,null,o):(0,D.localize)(3,null,o):E?(0,D.localize)(4,null,o):(0,D.localize)(5,null,o):o===1?E?(0,D.localize)(6,null,o):(0,D.localize)(7,null,o):E?(0,D.localize)(8,null,o):(0,D.localize)(9,null,o)):b<f?(o=Math.floor(b/O),S?o===1?E?(0,D.localize)(10,null,o):(0,D.localize)(11,null,o):E?(0,D.localize)(12,null,o):(0,D.localize)(13,null,o):o===1?E?(0,D.localize)(14,null,o):(0,D.localize)(15,null,o):E?(0,D.localize)(16,null,o):(0,D.localize)(17,null,o)):b<R?(o=Math.floor(b/f),S?o===1?E?(0,D.localize)(18,null,o):(0,D.localize)(19,null,o):E?(0,D.localize)(20,null,o):(0,D.localize)(21,null,o):o===1?E?(0,D.localize)(22,null,o):(0,D.localize)(23,null,o):E?(0,D.localize)(24,null,o):(0,D.localize)(25,null,o)):b<L?(o=Math.floor(b/R),S?o===1?(0,D.localize)(26,null,o):(0,D.localize)(27,null,o):o===1?(0,D.localize)(28,null,o):(0,D.localize)(29,null,o)):b<w?(o=Math.floor(b/L),S?o===1?E?(0,D.localize)(30,null,o):(0,D.localize)(31,null,o):E?(0,D.localize)(32,null,o):(0,D.localize)(33,null,o):o===1?E?(0,D.localize)(34,null,o):(0,D.localize)(35,null,o):E?(0,D.localize)(36,null,o):(0,D.localize)(37,null,o)):b<$?(o=Math.floor(b/w),S?o===1?E?(0,D.localize)(38,null,o):(0,D.localize)(39,null,o):E?(0,D.localize)(40,null,o):(0,D.localize)(41,null,o):o===1?E?(0,D.localize)(42,null,o):(0,D.localize)(43,null,o):E?(0,D.localize)(44,null,o):(0,D.localize)(45,null,o)):(o=Math.floor(b/$),S?o===1?E?(0,D.localize)(46,null,o):(0,D.localize)(47,null,o):E?(0,D.localize)(48,null,o):(0,D.localize)(49,null,o):o===1?E?(0,D.localize)(50,null,o):(0,D.localize)(51,null,o):E?(0,D.localize)(52,null,o):(0,D.localize)(53,null,o))}e.$Hm=k;function M(p,S){const E=Math.abs(p/1e3);return E<1?S?(0,D.localize)(54,null,p):(0,D.localize)(55,null,p):E<O?S?(0,D.localize)(56,null,Math.round(p)/1e3):(0,D.localize)(57,null,Math.round(p)/1e3):E<f?S?(0,D.localize)(58,null,Math.round(p/(1e3*O))):(0,D.localize)(59,null,Math.round(p/(1e3*O))):E<R?S?(0,D.localize)(60,null,Math.round(p/(1e3*f))):(0,D.localize)(61,null,Math.round(p/(1e3*f))):(0,D.localize)(62,null,Math.round(p/(1e3*R)))}e.$Im=M;function I(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Jm=I}),define(Se[194],De([10,11]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Se[41],De([1,0,19,18,194]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function R(I,p){return p&&(I.stack||I.stacktrace)?f.localize(0,null,w(I),L(I.stack)||L(I.stacktrace)):w(I)}function L(I){return Array.isArray(I)?I.join(`
`):I}function w(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function $(I=null,p=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const S=D.$Hb(I),E=$(S[0],p);return S.length>1?f.localize(4,null,E,S.length):E}if(O.$Sf(I))return I;if(I.detail){const S=I.detail;if(S.error)return R(S.error,p);if(S.exception)return R(S.exception,p)}return I.stack?R(I,p):I.message?I.message:f.localize(5,null)}e.$2i=$;function k(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}e.$3i=k;function M(I,p){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=p,S}e.$4i=M}),define(Se[195],De([10,11]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Se[133],De([1,0,19,24,9,178,130,195]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=k;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class I{constructor(oe,Ce,Ke,xe){this.id=oe,this.name=Ce,this.defaultValue=Ke,this.schema=xe}applyUpdate(oe,Ce){return S(oe,Ce)}compute(oe,Ce,Ke){return Ke}}class p{constructor(oe,Ce){this.newValue=oe,this.didChange=Ce}}e.ApplyUpdateResult=p;function S(te,oe){if(typeof te!="object"||typeof oe!="object"||!te||!oe)return new p(oe,te!==oe);if(Array.isArray(te)||Array.isArray(oe)){const Ke=Array.isArray(te)&&Array.isArray(oe)&&D.$ub(te,oe);return new p(oe,!Ke)}let Ce=!1;for(const Ke in oe)if(oe.hasOwnProperty(Ke)){const xe=S(te[Ke],oe[Ke]);xe.didChange&&(te[Ke]=xe.newValue,Ce=!0)}return new p(te,Ce)}class E{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return this.defaultValue}}class u{constructor(oe,Ce,Ke,xe){this.id=oe,this.name=Ce,this.defaultValue=Ke,this.schema=xe}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ce,Ke){return Ke}}function b(te,oe){return typeof te>"u"?oe:te==="false"?!1:!!te}e.boolean=b;class o extends u{constructor(oe,Ce,Ke,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ke),super(oe,Ce,Ke,xe)}validate(oe){return b(oe,this.defaultValue)}}function i(te,oe,Ce,Ke){if(typeof te>"u")return oe;let xe=parseInt(te,10);return isNaN(xe)?oe:(xe=Math.max(Ce,xe),xe=Math.min(Ke,xe),xe|0)}e.clampedInt=i;class n extends u{static clampedInt(oe,Ce,Ke,xe){return i(oe,Ce,Ke,xe)}constructor(oe,Ce,Ke,xe,st,Ne=void 0){typeof Ne<"u"&&(Ne.type="integer",Ne.default=Ke,Ne.minimum=xe,Ne.maximum=st),super(oe,Ce,Ke,Ne),this.minimum=xe,this.maximum=st}validate(oe){return n.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function s(te,oe,Ce,Ke){if(typeof te>"u")return oe;const xe=a.float(te,oe);return a.clamp(xe,Ce,Ke)}e.clampedFloat=s;class a extends u{static clamp(oe,Ce,Ke){return oe<Ce?Ce:oe>Ke?Ke:oe}static float(oe,Ce){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ce;const Ke=parseFloat(oe);return isNaN(Ke)?Ce:Ke}constructor(oe,Ce,Ke,xe,st){typeof st<"u"&&(st.type="number",st.default=Ke),super(oe,Ce,Ke,st),this.validationFn=xe}validate(oe){return this.validationFn(a.float(oe,this.defaultValue))}}class t extends u{static string(oe,Ce){return typeof oe!="string"?Ce:oe}constructor(oe,Ce,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ke),super(oe,Ce,Ke,xe)}validate(oe){return t.string(oe,this.defaultValue)}}function d(te,oe,Ce,Ke){return typeof te!="string"?oe:Ke&&te in Ke?Ke[te]:Ce.indexOf(te)===-1?oe:te}e.stringSet=d;class l extends u{constructor(oe,Ce,Ke,xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=xe,st.default=Ke),super(oe,Ce,Ke,st),this.c=xe}validate(oe){return d(oe,this.defaultValue,this.c)}}class r extends I{constructor(oe,Ce,Ke,xe,st,Ne,bt=void 0){typeof bt<"u"&&(bt.type="string",bt.enum=st,bt.default=xe),super(oe,Ce,Ke,bt),this.c=st,this.d=Ne}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function c(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ce,Ke){return Ke===0?oe.accessibilitySupport:Ke}}class g extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:w.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertSpace:b(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function v(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function y(te){switch(te){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function P(te){switch(te){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class j extends E{constructor(){super(141)}compute(oe,Ce,Ke){const xe=["monaco-editor"];return Ce.get(39)&&xe.push(Ce.get(39)),oe.extraEditorClassName&&xe.push(oe.extraEditorClassName),Ce.get(74)==="default"?xe.push("mouse-default"):Ce.get(74)==="copy"&&xe.push("mouse-copy"),Ce.get(111)&&xe.push("showUnused"),Ce.get(139)&&xe.push("showDeprecated"),xe.join(" ")}}class U extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(oe,Ce,Ke){return Ke&&oe.emptySelectionClipboard}}class z extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:w.localize(16,null),included:f.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:w.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{cursorMoveOnType:b(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":d(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":d(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Ce.loop,this.defaultValue.loop)}}}class N extends I{constructor(){super(51,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"||oe.length===0?N.OFF:oe==="true"?N.ON:oe:oe?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class A extends I{constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?A.OFF:oe==="true"?A.TRANSLATE:oe:oe?A.TRANSLATE:A.OFF}compute(oe,Ce,Ke){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=A,A.OFF="normal",A.TRANSLATE="translate";class T extends E{constructor(){super(50)}compute(oe,Ce,Ke){return oe.fontInfo}}class F extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(oe){const Ce=a.float(oe,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ce,6,100)}compute(oe,Ce,Ke){return oe.fontInfo.fontSize}}class G extends I{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(n.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}G.c=["normal","bold","100","200","300","400","500","600","700","800","900"],G.d=1,G.e=1e3;class K extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:Ke,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:Ke,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:Ke,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:Ke,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:Ke,description:w.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{multiple:d(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??d(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??d(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??d(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??d(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??d(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends I{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:w.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:b(Ce.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:b(Ce.above,this.defaultValue.above)}}}var Q;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class Z extends E{constructor(){super(144)}compute(oe,Ce,Ke){return Z.computeLayout(Ce,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ce=oe.height/oe.lineHeight,Ke=Math.floor(oe.paddingTop/oe.lineHeight);let xe=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(xe=Math.max(xe,Ce-1));const st=(Ke+oe.viewLineCount+xe)/(oe.pixelRatio*oe.height),Ne=Math.floor(oe.viewLineCount/st);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:xe,desiredRatio:st,minimapLineCount:Ne}}static c(oe,Ce){const Ke=oe.outerWidth,xe=oe.outerHeight,st=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Ne=Ce.stableMinimapLayoutInput,bt=Ne&&oe.outerHeight===Ne.outerHeight&&oe.lineHeight===Ne.lineHeight&&oe.typicalHalfwidthCharacterWidth===Ne.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Ne.pixelRatio&&oe.scrollBeyondLastLine===Ne.scrollBeyondLastLine&&oe.paddingTop===Ne.paddingTop&&oe.paddingBottom===Ne.paddingBottom&&oe.minimap.enabled===Ne.minimap.enabled&&oe.minimap.side===Ne.minimap.side&&oe.minimap.size===Ne.minimap.size&&oe.minimap.showSlider===Ne.minimap.showSlider&&oe.minimap.renderCharacters===Ne.minimap.renderCharacters&&oe.minimap.maxColumn===Ne.minimap.maxColumn&&oe.minimap.scale===Ne.minimap.scale&&oe.verticalScrollbarWidth===Ne.verticalScrollbarWidth&&oe.isViewportWrapping===Ne.isViewportWrapping,Ct=oe.lineHeight,At=oe.typicalHalfwidthCharacterWidth,qt=oe.scrollBeyondLastLine,Gt=oe.minimap.renderCharacters;let Rt=st>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const Zt=oe.minimap.maxColumn,xt=oe.minimap.size,si=oe.minimap.side,oi=oe.verticalScrollbarWidth,et=oe.viewLineCount,jt=oe.remainingWidth,_t=oe.isViewportWrapping,$t=Gt?2:3;let pt=Math.floor(st*xe);const Kt=pt/st;let zt=!1,Wt=!1,ft=$t*Rt,Mt=Rt/st,ei=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Ut,extraLinesBeforeFirstLine:Ot,extraLinesBeyondLastLine:Lt,desiredRatio:ri,minimapLineCount:Bt}=Z.computeContainedMinimapLineCount({viewLineCount:et,scrollBeyondLastLine:qt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:xe,lineHeight:Ct,pixelRatio:st});if(et/Bt>1)zt=!0,Wt=!0,Rt=1,ft=1,Mt=Rt/st;else{let Nt=!1,Pt=Rt+1;if(xt==="fit"){const yt=Math.ceil((Ot+et+Lt)*ft);_t&&bt&&jt<=Ce.stableFitRemainingWidth?(Nt=!0,Pt=Ce.stableFitMaxMinimapScale):Nt=yt>pt}if(xt==="fill"||Nt){zt=!0;const yt=Rt;ft=Math.min(Ct*st,Math.max(1,Math.floor(1/ri))),_t&&bt&&jt<=Ce.stableFitRemainingWidth&&(Pt=Ce.stableFitMaxMinimapScale),Rt=Math.min(Pt,Math.max(1,Math.floor(ft/$t))),Rt>yt&&(ei=Math.min(2,Rt/yt)),Mt=Rt/st/ei,pt=Math.ceil(Math.max(Ut,Ot+et+Lt)*ft),_t?(Ce.stableMinimapLayoutInput=oe,Ce.stableFitRemainingWidth=jt,Ce.stableFitMaxMinimapScale=Rt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const ti=Math.floor(Zt*Mt),Xe=Math.min(ti,Math.max(0,Math.floor((jt-oi-2)*Mt/(At+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Vt=Math.floor(st*Xe);const Yt=Vt/st;Vt=Math.floor(Vt*ei);const ni=Gt?1:2,vt=si==="left"?0:Ke-Xe-oi;return{renderMinimap:ni,minimapLeft:vt,minimapWidth:Xe,minimapHeightIsEditorHeight:zt,minimapIsSampling:Wt,minimapScale:Rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Vt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Yt,minimapCanvasOuterHeight:Kt}}static computeLayout(oe,Ce){const Ke=Ce.outerWidth|0,xe=Ce.outerHeight|0,st=Ce.lineHeight|0,Ne=Ce.lineNumbersDigitCount|0,bt=Ce.typicalHalfwidthCharacterWidth,Ct=Ce.maxDigitWidth,At=Ce.pixelRatio,qt=Ce.viewLineCount,Gt=oe.get(136),Rt=Gt==="inherit"?oe.get(135):Gt,Zt=Rt==="inherit"?oe.get(131):Rt,xt=oe.get(134),si=Ce.isDominatedByLongLines,oi=oe.get(57),et=oe.get(68).renderType!==0,jt=oe.get(69),_t=oe.get(105),$t=oe.get(84),pt=oe.get(73),Kt=oe.get(103),zt=Kt.verticalScrollbarSize,Wt=Kt.verticalHasArrows,ft=Kt.arrowSize,Mt=Kt.horizontalScrollbarSize,ei=oe.get(43),ti=oe.get(110)!=="never";let Xe=oe.get(66);ei&&ti&&(Xe+=16);let Vt=0;if(et){const St=Math.max(Ne,jt);Vt=Math.round(St*Ct)}let Yt=0;oi&&(Yt=st*Ce.glyphMarginDecorationLaneCount);let ni=0,vt=ni+Yt,Ut=vt+Vt,Ot=Ut+Xe;const Lt=Ke-Yt-Vt-Xe;let ri=!1,Bt=!1,Jt=-1;Rt==="inherit"&&si?(ri=!0,Bt=!0):Zt==="on"||Zt==="bounded"?Bt=!0:Zt==="wordWrapColumn"&&(Jt=xt);const Nt=Z.c({outerWidth:Ke,outerHeight:xe,lineHeight:st,typicalHalfwidthCharacterWidth:bt,pixelRatio:At,scrollBeyondLastLine:_t,paddingTop:$t.top,paddingBottom:$t.bottom,minimap:pt,verticalScrollbarWidth:zt,viewLineCount:qt,remainingWidth:Lt,isViewportWrapping:Bt},Ce.memory||new M);Nt.renderMinimap!==0&&Nt.minimapLeft===0&&(ni+=Nt.minimapWidth,vt+=Nt.minimapWidth,Ut+=Nt.minimapWidth,Ot+=Nt.minimapWidth);const Pt=Lt-Nt.minimapWidth,yt=Math.max(1,Math.floor((Pt-zt-2)/bt)),kt=Wt?ft:0;return Bt&&(Jt=Math.max(1,yt),Zt==="bounded"&&(Jt=Math.min(Jt,xt))),{width:Ke,height:xe,glyphMarginLeft:ni,glyphMarginWidth:Yt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:vt,lineNumbersWidth:Vt,decorationsLeft:Ut,decorationsWidth:Xe,contentLeft:Ot,contentWidth:Pt,minimap:Nt,viewportColumn:yt,isWordWrapMinified:ri,isViewportWrapping:Bt,wrappingColumn:Jt,verticalScrollbarWidth:zt,horizontalScrollbarHeight:Mt,overviewRuler:{top:kt,width:zt,height:xe-2*kt,right:0}}}}e.EditorLayoutInfoComputer=Z;class ie extends I{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(oe){return d(oe,"simple",["simple","advanced"])}compute(oe,Ce,Ke){return Ce.get(2)===2?"advanced":Ke}}var ee;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(ee||(e.ShowLightbulbIconMode=ee={}));class we extends I{constructor(){const oe={enabled:ee.OnCode};super(65,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ee.Off,ee.OnCode,ee.On],default:oe.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:d(oe.enabled,this.defaultValue.enabled,[ee.Off,ee.OnCode,ee.On])}}}class ue extends I{constructor(){const oe={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:w.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:b(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ae extends I{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,f.$d?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,f.$d?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:w.localize(65,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:d(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:b(Ce.padding,this.defaultValue.padding)}}}class H extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):n.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ce,Ke){return Ke<0?n.clampedInt(-Ke*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class fe extends a{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>a.clamp(oe,0,150),{markdownDescription:w.localize(66,null)})}compute(oe,Ce,Ke){return oe.fontInfo.lineHeight}}class he extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:oe.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:w.localize(77,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),autohide:b(Ce.autohide,this.defaultValue.autohide),size:d(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Ce.side,this.defaultValue.side,["right","left"]),showSlider:d(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ce.scale,1,1,3),maxColumn:n.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function se(te){return te==="ctrlCmd"?f.$d?"metaKey":"ctrlKey":"altKey"}class ce extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(79,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{top:n.clampedInt(Ce.top,0,0,1e3),bottom:n.clampedInt(Ce.bottom,0,0,1e3)}}}class le extends I{constructor(){const oe={enabled:!0,cycle:!0};super(86,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:w.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:w.localize(81,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),cycle:b(Ce.cycle,this.defaultValue.cycle)}}}class de extends E{constructor(){super(142)}compute(oe,Ce,Ke){return oe.pixelRatio}}class q extends I{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(82,null),w.localize(83,null),w.localize(84,null)]}];super(89,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:oe.strings,description:w.localize(85,null)},comments:{anyOf:Ce,default:oe.comments,description:w.localize(86,null)},other:{anyOf:Ce,default:oe.other,description:w.localize(87,null)}},default:oe,markdownDescription:w.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const At=oe?"on":"off";return{comments:At,strings:At,other:At}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ce,comments:Ke,strings:xe}=oe,st=["on","inline","off"];let Ne,bt,Ct;return typeof Ce=="boolean"?Ne=Ce?"on":"off":Ne=d(Ce,this.defaultValue.other,st),typeof Ke=="boolean"?bt=Ke?"on":"off":bt=d(Ke,this.defaultValue.comments,st),typeof xe=="boolean"?Ct=xe?"on":"off":Ct=d(xe,this.defaultValue.strings,st),{other:Ne,comments:bt,strings:Ct}}}var _;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class ge extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(89,null),w.localize(90,null),w.localize(91,null),w.localize(92,null)],default:"on",description:w.localize(93,null)})}validate(oe){let Ce=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ce=4,Ke=oe):oe==="interval"?Ce=3:oe==="relative"?Ce=2:oe==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ke}}}function me(te){const oe=te.get(98);return oe==="editable"?te.get(91):oe!=="on"}e.filterValidationDecorations=me;class Ae extends I{constructor(){const oe=[],Ce={type:"number",description:w.localize(94,null)};super(102,"rulers",oe,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:w.localize(95,null),format:"color-hex"}}}]},default:oe,description:w.localize(96,null)})}validate(oe){if(Array.isArray(oe)){const Ce=[];for(const Ke of oe)if(typeof Ke=="number")Ce.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const xe=Ke;Ce.push({column:n.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Ce.sort((Ke,xe)=>Ke.column-xe.column),Ce}return this.defaultValue}}class ye extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Re(te,oe){if(typeof te!="string")return oe;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class Le extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(97,null),w.localize(98,null),w.localize(99,null)],default:"auto",description:w.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(101,null),w.localize(102,null),w.localize(103,null)],default:"auto",description:w.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:w.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:w.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:w.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:oe.ignoreHorizontalScrollbarInContentHeight,description:w.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe,Ke=n.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=n.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Re(Ce.vertical,this.defaultValue.vertical),horizontal:Re(Ce.horizontal,this.defaultValue.horizontal),useShadows:b(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ce.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:n.clampedInt(Ce.verticalSliderSize,xe,0,1e3),scrollByPage:b(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:b(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:w.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:w.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:w.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:w.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:w.localize(115,null)}})}applyUpdate(oe,Ce){let Ke=!1;Ce.allowedCharacters&&oe&&(O.$Mn(oe.allowedCharacters,Ce.allowedCharacters)||(oe={...oe,allowedCharacters:Ce.allowedCharacters},Ke=!0)),Ce.allowedLocales&&oe&&(O.$Mn(oe.allowedLocales,Ce.allowedLocales)||(oe={...oe,allowedLocales:Ce.allowedLocales},Ke=!0));const xe=super.applyUpdate(oe,Ce);return Ke?new p(xe.newValue,!0):xe}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{nonBasicASCII:$e(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:b(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:b(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$e(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$e(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,Ce){if(typeof oe!="object"||!oe)return Ce;const Ke={};for(const[xe,st]of Object.entries(oe))st===!0&&(Ke[xe]=!0);return Ke}}class B extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:w.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(117,null),w.localize(118,null),w.localize(119,null)],description:w.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:w.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:oe.fontFamily,description:w.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),mode:d(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:b(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:b(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class V extends I{constructor(){const oe={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",oe,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:oe.enabled,description:w.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(124,null),w.localize(125,null),w.localize(126,null)],description:w.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:oe.fontFamily,description:w.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:oe.backgroundColoring,description:w.localize(129,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),showToolbar:d(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:b(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:b(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class x extends I{constructor(){const oe={enabled:R.$Es.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Es.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:w.localize(131,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:b(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null)],default:oe.bracketPairs,description:w.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(136,null),w.localize(137,null),w.localize(138,null)],default:oe.bracketPairsHorizontal,description:w.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:w.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:w.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(142,null),w.localize(143,null),w.localize(144,null)],default:oe.highlightActiveIndentation,description:w.localize(145,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{bracketPairs:$e(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$e(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:b(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:b(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:$e(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $e(te,oe,Ce){const Ke=Ce.indexOf(te);return Ke===-1?oe:Ce[Ke]}class ve extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(146,null),w.localize(147,null)],default:oe.insertMode,description:w.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:w.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:w.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:w.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(152,null),w.localize(153,null),w.localize(154,null),w.localize(155,null)],default:oe.selectionMode,markdownDescription:w.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:w.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:w.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:w.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:w.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:w.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertMode:d(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:b(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:b(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:b(Ce.preview,this.defaultValue.preview),previewMode:d(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:b(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Ce.showMethods,this.defaultValue.showMethods),showFunctions:b(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:b(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:b(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:b(Ce.showFields,this.defaultValue.showFields),showVariables:b(Ce.showVariables,this.defaultValue.showVariables),showClasses:b(Ce.showClasses,this.defaultValue.showClasses),showStructs:b(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:b(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Ce.showModules,this.defaultValue.showModules),showProperties:b(Ce.showProperties,this.defaultValue.showProperties),showEvents:b(Ce.showEvents,this.defaultValue.showEvents),showOperators:b(Ce.showOperators,this.defaultValue.showOperators),showUnits:b(Ce.showUnits,this.defaultValue.showUnits),showValues:b(Ce.showValues,this.defaultValue.showValues),showConstants:b(Ce.showConstants,this.defaultValue.showConstants),showEnums:b(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Ce.showKeywords,this.defaultValue.showKeywords),showWords:b(Ce.showWords,this.defaultValue.showWords),showColors:b(Ce.showColors,this.defaultValue.showColors),showFiles:b(Ce.showFiles,this.defaultValue.showFiles),showReferences:b(Ce.showReferences,this.defaultValue.showReferences),showFolders:b(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:b(Ce.showUsers,this.defaultValue.showUsers),showIssues:b(Ce.showIssues,this.defaultValue.showIssues)}}}class Te extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(195,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:b(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Qe extends I{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(196,null),w.localize(197,null),w.localize(198,null),w.localize(199,null)],description:w.localize(200,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ce,Ke){return Ce.get(2)===2?0:Ke}}class tt extends E{constructor(){super(145)}compute(oe,Ce,Ke){const xe=Ce.get(144);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class at extends I{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(203,null),w.localize(204,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),showDropSelector:d(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class dt extends I{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(207,null),w.localize(208,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:b(Ce.enabled,this.defaultValue.enabled),showPasteSelector:d(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ot="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",Pe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$d?rt:f.$e?Pe:ot,fontWeight:"normal",fontSize:f.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ie(te){return e.editorOptionsRegistry[te.id]=te,te}var Ge;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",te[te.quickSuggestions=89]="quickSuggestions",te[te.quickSuggestionsDelay=90]="quickSuggestionsDelay",te[te.readOnly=91]="readOnly",te[te.readOnlyMessage=92]="readOnlyMessage",te[te.renameOnType=93]="renameOnType",te[te.renderControlCharacters=94]="renderControlCharacters",te[te.renderFinalNewline=95]="renderFinalNewline",te[te.renderLineHighlight=96]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=98]="renderValidationDecorations",te[te.renderWhitespace=99]="renderWhitespace",te[te.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",te[te.roundedSelection=101]="roundedSelection",te[te.rulers=102]="rulers",te[te.scrollbar=103]="scrollbar",te[te.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=105]="scrollBeyondLastLine",te[te.scrollPredominantAxis=106]="scrollPredominantAxis",te[te.selectionClipboard=107]="selectionClipboard",te[te.selectionHighlight=108]="selectionHighlight",te[te.selectOnLineNumbers=109]="selectOnLineNumbers",te[te.showFoldingControls=110]="showFoldingControls",te[te.showUnused=111]="showUnused",te[te.snippetSuggestions=112]="snippetSuggestions",te[te.smartSelect=113]="smartSelect",te[te.smoothScrolling=114]="smoothScrolling",te[te.stickyScroll=115]="stickyScroll",te[te.stickyTabStops=116]="stickyTabStops",te[te.stopRenderingLineAfter=117]="stopRenderingLineAfter",te[te.suggest=118]="suggest",te[te.suggestFontSize=119]="suggestFontSize",te[te.suggestLineHeight=120]="suggestLineHeight",te[te.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",te[te.suggestSelection=122]="suggestSelection",te[te.tabCompletion=123]="tabCompletion",te[te.tabIndex=124]="tabIndex",te[te.unicodeHighlighting=125]="unicodeHighlighting",te[te.unusualLineTerminators=126]="unusualLineTerminators",te[te.useShadowDOM=127]="useShadowDOM",te[te.useTabStops=128]="useTabStops",te[te.wordBreak=129]="wordBreak",te[te.wordSeparators=130]="wordSeparators",te[te.wordWrap=131]="wordWrap",te[te.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=134]="wordWrapColumn",te[te.wordWrapOverride1=135]="wordWrapOverride1",te[te.wordWrapOverride2=136]="wordWrapOverride2",te[te.wrappingIndent=137]="wrappingIndent",te[te.wrappingStrategy=138]="wrappingStrategy",te[te.showDeprecated=139]="showDeprecated",te[te.inlayHints=140]="inlayHints",te[te.editorClassName=141]="editorClassName",te[te.pixelRatio=142]="pixelRatio",te[te.tabFocusMode=143]="tabFocusMode",te[te.layoutInfo=144]="layoutInfo",te[te.wrappingInfo=145]="wrappingInfo",te[te.defaultColorDecorators=146]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ge||(e.EditorOption=Ge={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ie(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(209,null)})),acceptSuggestionOnEnter:Ie(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(210,null),""],markdownDescription:w.localize(211,null)})),accessibilitySupport:Ie(new h),accessibilityPageSize:Ie(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(212,null),tags:["accessibility"]})),ariaLabel:Ie(new t(4,"ariaLabel",w.localize(213,null))),ariaRequired:Ie(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ie(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Ie(new l(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(215,null),w.localize(216,null),""],description:w.localize(217,null)})),autoClosingComments:Ie(new l(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(218,null),w.localize(219,null),""],description:w.localize(220,null)})),autoClosingDelete:Ie(new l(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(221,null),""],description:w.localize(222,null)})),autoClosingOvertype:Ie(new l(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(223,null),""],description:w.localize(224,null)})),autoClosingQuotes:Ie(new l(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(225,null),w.localize(226,null),""],description:w.localize(227,null)})),autoIndent:Ie(new r(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[w.localize(228,null),w.localize(229,null),w.localize(230,null),w.localize(231,null),w.localize(232,null)],description:w.localize(233,null)})),automaticLayout:Ie(new o(13,"automaticLayout",!1)),autoSurround:Ie(new l(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(234,null),w.localize(235,null),w.localize(236,null),""],description:w.localize(237,null)})),bracketPairColorization:Ie(new x),bracketPairGuides:Ie(new Y),stickyTabStops:Ie(new o(116,"stickyTabStops",!1,{description:w.localize(238,null)})),codeLens:Ie(new o(17,"codeLens",!0,{description:w.localize(239,null)})),codeLensFontFamily:Ie(new t(18,"codeLensFontFamily","",{description:w.localize(240,null)})),codeLensFontSize:Ie(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(241,null)})),colorDecorators:Ie(new o(20,"colorDecorators",!0,{description:w.localize(242,null)})),colorDecoratorActivatedOn:Ie(new l(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(243,null),w.localize(244,null),w.localize(245,null)],description:w.localize(246,null)})),colorDecoratorsLimit:Ie(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(247,null)})),columnSelection:Ie(new o(22,"columnSelection",!1,{description:w.localize(248,null)})),comments:Ie(new g),contextmenu:Ie(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ie(new o(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(249,null)})),cursorBlinking:Ie(new r(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:w.localize(250,null)})),cursorSmoothCaretAnimation:Ie(new l(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(251,null),w.localize(252,null),w.localize(253,null)],description:w.localize(254,null)})),cursorStyle:Ie(new r(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:w.localize(255,null)})),cursorSurroundingLines:Ie(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(256,null)})),cursorSurroundingLinesStyle:Ie(new l(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(257,null),w.localize(258,null)],markdownDescription:w.localize(259,null)})),cursorWidth:Ie(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(260,null)})),disableLayerHinting:Ie(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ie(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ie(new o(34,"domReadOnly",!1)),dragAndDrop:Ie(new o(35,"dragAndDrop",!0,{description:w.localize(261,null)})),emptySelectionClipboard:Ie(new U),dropIntoEditor:Ie(new at),stickyScroll:Ie(new ue),experimentalWhitespaceRendering:Ie(new l(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(262,null),w.localize(263,null),w.localize(264,null)],description:w.localize(265,null)})),extraEditorClassName:Ie(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ie(new a(40,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:w.localize(266,null)})),find:Ie(new z),fixedOverflowWidgets:Ie(new o(42,"fixedOverflowWidgets",!1)),folding:Ie(new o(43,"folding",!0,{description:w.localize(267,null)})),foldingStrategy:Ie(new l(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),foldingHighlight:Ie(new o(45,"foldingHighlight",!0,{description:w.localize(271,null)})),foldingImportsByDefault:Ie(new o(46,"foldingImportsByDefault",!1,{description:w.localize(272,null)})),foldingMaximumRegions:Ie(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(273,null)})),unfoldOnClickAfterEndOfLine:Ie(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(274,null)})),fontFamily:Ie(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(275,null)})),fontInfo:Ie(new T),fontLigatures2:Ie(new N),fontSize:Ie(new F),fontWeight:Ie(new G),fontVariations:Ie(new A),formatOnPaste:Ie(new o(55,"formatOnPaste",!1,{description:w.localize(276,null)})),formatOnType:Ie(new o(56,"formatOnType",!1,{description:w.localize(277,null)})),glyphMargin:Ie(new o(57,"glyphMargin",!0,{description:w.localize(278,null)})),gotoLocation:Ie(new K),hideCursorInOverviewRuler:Ie(new o(59,"hideCursorInOverviewRuler",!1,{description:w.localize(279,null)})),hover:Ie(new X),inDiffEditor:Ie(new o(61,"inDiffEditor",!1)),letterSpacing:Ie(new a(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>a.clamp(te,-5,20),{description:w.localize(280,null)})),lightbulb:Ie(new we),lineDecorationsWidth:Ie(new H),lineHeight:Ie(new fe),lineNumbers:Ie(new ge),lineNumbersMinChars:Ie(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ie(new o(70,"linkedEditing",!1,{description:w.localize(281,null)})),links:Ie(new o(71,"links",!0,{description:w.localize(282,null)})),matchBrackets:Ie(new l(72,"matchBrackets","always",["always","near","never"],{description:w.localize(283,null)})),minimap:Ie(new he),mouseStyle:Ie(new l(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ie(new a(75,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:w.localize(284,null)})),mouseWheelZoom:Ie(new o(76,"mouseWheelZoom",!1,{markdownDescription:f.$d?w.localize(285,null):w.localize(286,null)})),multiCursorMergeOverlapping:Ie(new o(77,"multiCursorMergeOverlapping",!0,{description:w.localize(287,null)})),multiCursorModifier:Ie(new r(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[w.localize(288,null),w.localize(289,null)],markdownDescription:w.localize(290,null)})),multiCursorPaste:Ie(new l(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(291,null),w.localize(292,null)],markdownDescription:w.localize(293,null)})),multiCursorLimit:Ie(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(294,null)})),occurrencesHighlight:Ie(new l(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(295,null),w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),overviewRulerBorder:Ie(new o(82,"overviewRulerBorder",!0,{description:w.localize(299,null)})),overviewRulerLanes:Ie(new n(83,"overviewRulerLanes",3,0,3)),padding:Ie(new ce),pasteAs:Ie(new dt),parameterHints:Ie(new le),peekWidgetDefaultFocus:Ie(new l(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(300,null),w.localize(301,null)],description:w.localize(302,null)})),definitionLinkOpensInPeek:Ie(new o(88,"definitionLinkOpensInPeek",!1,{description:w.localize(303,null)})),quickSuggestions:Ie(new q),quickSuggestionsDelay:Ie(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(304,null)})),readOnly:Ie(new o(91,"readOnly",!1)),readOnlyMessage:Ie(new ye),renameOnType:Ie(new o(93,"renameOnType",!1,{description:w.localize(305,null),markdownDeprecationMessage:w.localize(306,null)})),renderControlCharacters:Ie(new o(94,"renderControlCharacters",!0,{description:w.localize(307,null),restricted:!0})),renderFinalNewline:Ie(new l(95,"renderFinalNewline",f.$e?"dimmed":"on",["off","on","dimmed"],{description:w.localize(308,null)})),renderLineHighlight:Ie(new l(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(309,null)],description:w.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Ie(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(311,null)})),renderValidationDecorations:Ie(new l(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ie(new l(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(312,null),w.localize(313,null),w.localize(314,null),""],description:w.localize(315,null)})),revealHorizontalRightPadding:Ie(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ie(new o(101,"roundedSelection",!0,{description:w.localize(316,null)})),rulers:Ie(new Ae),scrollbar:Ie(new Le),scrollBeyondLastColumn:Ie(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(317,null)})),scrollBeyondLastLine:Ie(new o(105,"scrollBeyondLastLine",!0,{description:w.localize(318,null)})),scrollPredominantAxis:Ie(new o(106,"scrollPredominantAxis",!0,{description:w.localize(319,null)})),selectionClipboard:Ie(new o(107,"selectionClipboard",!0,{description:w.localize(320,null),included:f.$e})),selectionHighlight:Ie(new o(108,"selectionHighlight",!0,{description:w.localize(321,null)})),selectOnLineNumbers:Ie(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ie(new l(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(322,null),w.localize(323,null),w.localize(324,null)],description:w.localize(325,null)})),showUnused:Ie(new o(111,"showUnused",!0,{description:w.localize(326,null)})),showDeprecated:Ie(new o(139,"showDeprecated",!0,{description:w.localize(327,null)})),inlayHints:Ie(new ae),snippetSuggestions:Ie(new l(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(328,null),w.localize(329,null),w.localize(330,null),w.localize(331,null)],description:w.localize(332,null)})),smartSelect:Ie(new Te),smoothScrolling:Ie(new o(114,"smoothScrolling",!1,{description:w.localize(333,null)})),stopRenderingLineAfter:Ie(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ie(new ve),inlineSuggest:Ie(new B),inlineEdit:Ie(new V),inlineCompletionsAccessibilityVerbose:Ie(new o(148,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(334,null)})),suggestFontSize:Ie(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ie(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ie(new o(121,"suggestOnTriggerCharacters",!0,{description:w.localize(337,null)})),suggestSelection:Ie(new l(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(338,null),w.localize(339,null),w.localize(340,null)],description:w.localize(341,null)})),tabCompletion:Ie(new l(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(342,null),w.localize(343,null),w.localize(344,null)],description:w.localize(345,null)})),tabIndex:Ie(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ie(new ze),unusualLineTerminators:Ie(new l(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(346,null),w.localize(347,null),w.localize(348,null)],description:w.localize(349,null)})),useShadowDOM:Ie(new o(127,"useShadowDOM",!0)),useTabStops:Ie(new o(128,"useTabStops",!0,{description:w.localize(350,null)})),wordBreak:Ie(new l(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(351,null),w.localize(352,null)],description:w.localize(353,null)})),wordSeparators:Ie(new t(130,"wordSeparators",L.$Fs,{description:w.localize(354,null)})),wordWrap:Ie(new l(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(355,null),w.localize(356,null),w.localize(357,null),w.localize(358,null)],description:w.localize(359,null)})),wordWrapBreakAfterCharacters:Ie(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ie(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ie(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(360,null)})),wordWrapOverride1:Ie(new l(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ie(new l(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ie(new j),defaultColorDecorators:Ie(new o(146,"defaultColorDecorators",!1,{markdownDescription:w.localize(361,null)})),pixelRatio:Ie(new de),tabFocusMode:Ie(new o(143,"tabFocusMode",!1,{markdownDescription:w.localize(362,null)})),layoutInfo:Ie(new Z),wrappingInfo:Ie(new tt),wrappingIndent:Ie(new Qe),wrappingStrategy:Ie(new ie)}}),define(Se[196],De([10,11]),function(re,e){return re.create("vs/editor/common/languages",e)}),define(Se[83],De([1,0,78,2,174,29,189,196]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Zt=e.$Yt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$Xt=e.$Wt=e.SymbolKinds=e.SymbolTag=e.$Vt=e.$Ut=e.SymbolKind=e.$Tt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$St=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Rt=e.$Qt=e.$Pt=void 0;class ${constructor(T,F,G){this.offset=T,this.type=F,this.language=G,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Pt=$;class k{constructor(T,F){this.tokens=T,this.endState=F,this._tokenizationResultBrand=void 0}}e.$Qt=k;class M{constructor(T,F){this.tokens=T,this.endState=F,this._encodedTokenizationResultBrand=void 0}}e.$Rt=M;var I;(function(A){A[A.Method=0]="Method",A[A.Function=1]="Function",A[A.Constructor=2]="Constructor",A[A.Field=3]="Field",A[A.Variable=4]="Variable",A[A.Class=5]="Class",A[A.Struct=6]="Struct",A[A.Interface=7]="Interface",A[A.Module=8]="Module",A[A.Property=9]="Property",A[A.Event=10]="Event",A[A.Operator=11]="Operator",A[A.Unit=12]="Unit",A[A.Value=13]="Value",A[A.Constant=14]="Constant",A[A.Enum=15]="Enum",A[A.EnumMember=16]="EnumMember",A[A.Keyword=17]="Keyword",A[A.Text=18]="Text",A[A.Color=19]="Color",A[A.File=20]="File",A[A.Reference=21]="Reference",A[A.Customcolor=22]="Customcolor",A[A.Folder=23]="Folder",A[A.TypeParameter=24]="TypeParameter",A[A.User=25]="User",A[A.Issue=26]="Issue",A[A.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(A){const T=new Map;T.set(0,D.$kk.symbolMethod),T.set(1,D.$kk.symbolFunction),T.set(2,D.$kk.symbolConstructor),T.set(3,D.$kk.symbolField),T.set(4,D.$kk.symbolVariable),T.set(5,D.$kk.symbolClass),T.set(6,D.$kk.symbolStruct),T.set(7,D.$kk.symbolInterface),T.set(8,D.$kk.symbolModule),T.set(9,D.$kk.symbolProperty),T.set(10,D.$kk.symbolEvent),T.set(11,D.$kk.symbolOperator),T.set(12,D.$kk.symbolUnit),T.set(13,D.$kk.symbolValue),T.set(15,D.$kk.symbolEnum),T.set(14,D.$kk.symbolConstant),T.set(15,D.$kk.symbolEnum),T.set(16,D.$kk.symbolEnumMember),T.set(17,D.$kk.symbolKeyword),T.set(27,D.$kk.symbolSnippet),T.set(18,D.$kk.symbolText),T.set(19,D.$kk.symbolColor),T.set(20,D.$kk.symbolFile),T.set(21,D.$kk.symbolReference),T.set(22,D.$kk.symbolCustomColor),T.set(23,D.$kk.symbolFolder),T.set(24,D.$kk.symbolTypeParameter),T.set(25,D.$kk.account),T.set(26,D.$kk.issues);function F(X){let Q=T.get(X);return Q||(console.info("No codicon found for CompletionItemKind "+X),Q=D.$kk.symbolProperty),Q}A.toIcon=F;const G=new Map;G.set("method",0),G.set("function",1),G.set("constructor",2),G.set("field",3),G.set("variable",4),G.set("class",5),G.set("struct",6),G.set("interface",7),G.set("module",8),G.set("property",9),G.set("event",10),G.set("operator",11),G.set("unit",12),G.set("value",13),G.set("constant",14),G.set("enum",15),G.set("enum-member",16),G.set("enumMember",16),G.set("keyword",17),G.set("snippet",27),G.set("text",18),G.set("color",19),G.set("file",20),G.set("reference",21),G.set("customcolor",22),G.set("folder",23),G.set("type-parameter",24),G.set("typeParameter",24),G.set("account",25),G.set("issue",26);function K(X,Q){let Z=G.get(X);return typeof Z>"u"&&!Q&&(Z=9),Z}A.fromString=K})(p||(e.CompletionItemKinds=p={}));var S;(function(A){A[A.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var E;(function(A){A[A.None=0]="None",A[A.KeepWhitespace=1]="KeepWhitespace",A[A.InsertAsSnippet=4]="InsertAsSnippet"})(E||(e.CompletionItemInsertTextRule=E={}));var u;(function(A){A[A.Invoke=0]="Invoke",A[A.TriggerCharacter=1]="TriggerCharacter",A[A.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var b;(function(A){A[A.Automatic=0]="Automatic",A[A.Explicit=1]="Explicit"})(b||(e.InlineCompletionTriggerKind=b={}));class o{constructor(T,F,G,K){this.range=T,this.text=F,this.completionKind=G,this.isSnippetText=K}equals(T){return R.$7s.lift(this.range).equalsRange(T.range)&&this.text===T.text&&this.completionKind===T.completionKind&&this.isSnippetText===T.isSnippetText}}e.$St=o;var i;(function(A){A[A.Invoke=1]="Invoke",A[A.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(A){A[A.Invoke=1]="Invoke",A[A.TriggerCharacter=2]="TriggerCharacter",A[A.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var s;(function(A){A[A.Text=0]="Text",A[A.Read=1]="Read",A[A.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function a(A){return A&&O.URI.isUri(A.uri)&&R.$7s.isIRange(A.range)&&(R.$7s.isIRange(A.originSelectionRange)||R.$7s.isIRange(A.targetSelectionRange))}e.$Tt=a;var t;(function(A){A[A.File=0]="File",A[A.Module=1]="Module",A[A.Namespace=2]="Namespace",A[A.Package=3]="Package",A[A.Class=4]="Class",A[A.Method=5]="Method",A[A.Property=6]="Property",A[A.Field=7]="Field",A[A.Constructor=8]="Constructor",A[A.Enum=9]="Enum",A[A.Interface=10]="Interface",A[A.Function=11]="Function",A[A.Variable=12]="Variable",A[A.Constant=13]="Constant",A[A.String=14]="String",A[A.Number=15]="Number",A[A.Boolean=16]="Boolean",A[A.Array=17]="Array",A[A.Object=18]="Object",A[A.Key=19]="Key",A[A.Null=20]="Null",A[A.EnumMember=21]="EnumMember",A[A.Struct=22]="Struct",A[A.Event=23]="Event",A[A.Operator=24]="Operator",A[A.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Ut={17:(0,w.localize)(0,null),16:(0,w.localize)(1,null),4:(0,w.localize)(2,null),13:(0,w.localize)(3,null),8:(0,w.localize)(4,null),9:(0,w.localize)(5,null),21:(0,w.localize)(6,null),23:(0,w.localize)(7,null),7:(0,w.localize)(8,null),0:(0,w.localize)(9,null),11:(0,w.localize)(10,null),10:(0,w.localize)(11,null),19:(0,w.localize)(12,null),5:(0,w.localize)(13,null),1:(0,w.localize)(14,null),2:(0,w.localize)(15,null),20:(0,w.localize)(16,null),15:(0,w.localize)(17,null),18:(0,w.localize)(18,null),24:(0,w.localize)(19,null),3:(0,w.localize)(20,null),6:(0,w.localize)(21,null),14:(0,w.localize)(22,null),22:(0,w.localize)(23,null),25:(0,w.localize)(24,null),12:(0,w.localize)(25,null)};function d(A,T){return(0,w.localize)(26,null,A,e.$Ut[T])}e.$Vt=d;var l;(function(A){A[A.Deprecated=1]="Deprecated"})(l||(e.SymbolTag=l={}));var r;(function(A){const T=new Map;T.set(0,D.$kk.symbolFile),T.set(1,D.$kk.symbolModule),T.set(2,D.$kk.symbolNamespace),T.set(3,D.$kk.symbolPackage),T.set(4,D.$kk.symbolClass),T.set(5,D.$kk.symbolMethod),T.set(6,D.$kk.symbolProperty),T.set(7,D.$kk.symbolField),T.set(8,D.$kk.symbolConstructor),T.set(9,D.$kk.symbolEnum),T.set(10,D.$kk.symbolInterface),T.set(11,D.$kk.symbolFunction),T.set(12,D.$kk.symbolVariable),T.set(13,D.$kk.symbolConstant),T.set(14,D.$kk.symbolString),T.set(15,D.$kk.symbolNumber),T.set(16,D.$kk.symbolBoolean),T.set(17,D.$kk.symbolArray),T.set(18,D.$kk.symbolObject),T.set(19,D.$kk.symbolKey),T.set(20,D.$kk.symbolNull),T.set(21,D.$kk.symbolEnumMember),T.set(22,D.$kk.symbolStruct),T.set(23,D.$kk.symbolEvent),T.set(24,D.$kk.symbolOperator),T.set(25,D.$kk.symbolTypeParameter);function F(G){let K=T.get(G);return K||(console.info("No codicon found for SymbolKind "+G),K=D.$kk.symbolProperty),K}A.toIcon=F})(r||(e.SymbolKinds=r={}));class c{static asEditOperation(T){return f.$8s.replace(R.$7s.lift(T.range),T.text)}}e.$Wt=c;class h{static fromValue(T){switch(T){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(T)}constructor(T){this.value=T}}e.$Xt=h,h.Comment=new h("comment"),h.Imports=new h("imports"),h.Region=new h("region");var g;(function(A){A[A.AIGenerated=1]="AIGenerated"})(g||(e.NewSymbolNameTag=g={}));var C;(function(A){function T(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}A.is=T})(C||(e.Command=C={}));var v;(function(A){A[A.Collapsed=0]="Collapsed",A[A.Expanded=1]="Expanded"})(v||(e.CommentThreadCollapsibleState=v={}));var m;(function(A){A[A.Unresolved=0]="Unresolved",A[A.Resolved=1]="Resolved"})(m||(e.CommentThreadState=m={}));var y;(function(A){A[A.Editing=0]="Editing",A[A.Preview=1]="Preview"})(y||(e.CommentMode=y={}));var P;(function(A){A[A.Published=0]="Published",A[A.Draft=1]="Draft"})(P||(e.CommentState=P={}));var j;(function(A){A[A.Type=1]="Type",A[A.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class U{constructor(T){this.b=T,this.a=null}dispose(){this.a&&this.a.then(T=>{T&&T.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Yt=U,e.$Zt=new L.$Ft;var z;(function(A){A[A.None=0]="None",A[A.Option=1]="Option",A[A.Default=2]="Default",A[A.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}));var N;(function(A){A[A.Invoke=0]="Invoke",A[A.Automatic=1]="Automatic"})(N||(e.InlineEditTriggerKind=N={}))}),define(Se[197],De([10,11]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[198],De([10,11]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[199],De([10,11]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(Se[200],De([10,11]),function(re,e){return re.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[201],De([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[202],De([10,11]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[203],De([10,11]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[204],De([10,11]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Se[205],De([10,11]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(Se[206],De([10,11]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[207],De([10,11]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Se[208],De([10,11]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[209],De([10,11]),function(re,e){return re.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[210],De([10,11]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(Se[211],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[212],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Se[213],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[214],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[215],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[216],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[217],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[218],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[219],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[220],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[221],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[222],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[223],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[224],De([10,11]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[225],De([10,11]),function(re,e){return re.create("vs/workbench/common/configuration",e)}),define(Se[226],De([10,11]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Se[227],De([10,11]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(Se[228],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[229],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[230],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[231],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[232],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[233],De([10,11]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[234],De([10,11]),function(re,e){return re.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[235],De([10,11]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[236],De([10,11]),function(re,e){return re.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[237],De([10,11]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[238],De([1,0,14,199]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var f;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(f||(e.TokenType=f={}));function R(...k){switch(k.length){case 1:return(0,O.localize)(0,null,k[0]);case 2:return(0,O.localize)(1,null,k[0],k[1]);case 3:return(0,O.localize)(2,null,k[0],k[1],k[2]);default:return}}const L=(0,O.localize)(3,null),w=(0,O.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const I=this.d,p=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:M}),this.f.push(S)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const I=this.c.substring(this.d,this.e),p=$.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,I=!1,p=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(w);return}const E=this.c.charCodeAt(M);if(I)I=!1;else if(E===47&&!p){M++;break}else E===91?p=!0:E===92?I=!0:E===93&&(p=!1);M++}for(;M<this.c.length&&$.a.has(this.c.charCodeAt(M));)M++;this.e=M;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=$,$.a=new Set(["i","g","s","m","y","u"].map(k=>k.charCodeAt(0))),$.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Se[239],De([1,0,23,40,202,388]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||L.test(o)}e.$mp=$;function k(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$np=k;function M(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,s=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let d=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),d=!1);let l=0;if(o.preRelease){const r=w.exec(o.preRelease);if(r){const[,c,h,g]=r;l=Date.UTC(Number(c),Number(h)-1,Number(g))}}return{majorBase:i,majorMustEqual:n,minorBase:s,minorMustEqual:a,patchBase:t,patchMustEqual:d,isMinimum:o.hasGreaterEquals,notBefore:l}}e.$op=M;function I(o,i,n){let s;typeof o=="string"?s=M(k(o)):s=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=M(k(n)):t=n,!s||!t)return!1;const d=s.majorBase,l=s.minorBase,r=s.patchBase;let c=t.majorBase,h=t.minorBase,g=t.patchBase;const C=t.notBefore;let v=t.majorMustEqual,m=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?d>c?!0:d<c?!1:l>h?!0:l<h||a&&a<C?!1:r>=g:(d===1&&c===0&&(!v||!m||!y)&&(c=1,h=0,g=0,v=!0,m=!1,y=!1),d<c?!1:d>c?!v:l<h?!1:l>h?!m:r<g?!1:r>g?!y:!(a&&a<C))}e.$pp=I;function p(o,i,n,s,a){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([O.default.Error,f.localize(0,null)]),t;if(typeof s.name!="string")return t.push([O.default.Error,f.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([O.default.Error,f.localize(2,null,"version")]),t;if(!s.engines)return t.push([O.default.Error,f.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([O.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!b(s.extensionDependencies))return t.push([O.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!b(s.activationEvents))return t.push([O.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([O.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([O.default.Warning,f.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([O.default.Error,f.localize(9,null,"main")]),t;{const r=(0,D.$Rg)(n,s.main);(0,D.$Lg)(r,n)||t.push([O.default.Warning,f.localize(10,null,r.path,n.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([O.default.Error,f.localize(11,null,"browser")]),t;{const r=(0,D.$Rg)(n,s.browser);(0,D.$Lg)(r,n)||t.push([O.default.Warning,f.localize(12,null,r.path,n.path)])}}if(!R.valid(s.version))return t.push([O.default.Error,f.localize(13,null)]),t;const d=[];if(!S(o,i,s,a,d))for(const r of d)t.push([O.default.Error,r]);return t}e.$qp=p;function S(o,i,n,s,a){return s||typeof n.main>"u"&&typeof n.browser>"u"?!0:u(o,i,n.engines.vscode,a)}e.$rp=S;function E(o,i,n){return o==="*"||u(i,n,o)}e.$sp=E;function u(o,i,n,s=[]){const a=M(k(n));if(!a)return s.push(f.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return s.push(f.localize(15,null,n)),!1}else if(!a.majorMustEqual)return s.push(f.localize(16,null,n)),!1;return I(o,i,a)?!0:(s.push(f.localize(17,null,o,n)),!1)}function b(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Se[105],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class D{constructor(f,R=[],L=!1){this.ctor=f,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$bi=D}),define(Se[84],De([1,0,105]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.InstantiationType=void 0;const O=[];var f;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function R(w,$,k){$ instanceof D.$bi||($=new D.$bi($,[],!!k)),O.push([w,$])}e.$$r=R;function L(){return O}e.$_r=L}),define(Se[240],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class D{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Oq=D;class O{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const w=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(L);w.outgoing.set($.key,$),$.incoming.set(w.key,w)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const w of this.a.values())w.outgoing.delete(L),w.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let w=this.a.get(L);return w||(w=new D(L,R),this.a.set(L,w)),w}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,w]of this.a)R.push(`${L}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const w=new Set([R]),$=this.c(L,w);if($)return $}}c(R,L){for(const[w,$]of R.outgoing){if(L.has(w))return[...L,w].join(" -> ");L.add(w);const k=this.c($,L);if(k)return k;L.delete(w)}}}e.$Pq=O}),define(Se[5],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function w($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=w})(D||(e._util=D={})),e.$di=f("instantiationService");function O(L,w,$){w[D.DI_TARGET]===w?w[D.DI_DEPENDENCIES].push({id:L,index:$}):(w[D.DI_DEPENDENCIES]=[{id:L,index:$}],w[D.DI_TARGET]=w)}function f(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const w=function($,k,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(w,$,M)};return w.toString=()=>L,D.serviceIds.set(L,w),w}e.$ei=f;function R(L){return L}e.$fi=R}),define(Se[52],De([1,0,18,2,5]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,f.$ei)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}e.$Li=R;function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}e.$Mi=L;var w;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=$;function k(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Oi=k;function M(o,i){const n=Object.create(null);for(const s in o)I(n,s,o[s],i);return n}e.$Pi=M;function I(o,i,n,s){const a=i.split("."),t=a.pop();let d=o;for(let l=0;l<a.length;l++){const r=a[l];let c=d[r];switch(typeof c){case"undefined":c=d[r]=Object.create(null);break;case"object":break;default:s(`Ignoring ${i} as ${a.slice(0,l+1).join(".")} is ${JSON.stringify(c)}`);return}d=c}if(typeof d=="object"&&d!==null)try{d[t]=n}catch{s(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(d)}`)}else s(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(d)}`)}e.$Qi=I;function p(o,i){const n=i.split(".");S(o,n)}e.$Ri=p;function S(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const s=o[n];typeof s=="object"&&!Array.isArray(s)&&(S(s,i),Object.keys(s).length===0&&delete o[n])}}function E(o,i,n){function s(d,l){let r=d;for(const c of l){if(typeof r!="object"||r===null)return;r=r[c]}return r}const a=i.split("."),t=s(o,a);return typeof t>"u"?n:t}e.$Si=E;function u(o,i,n){Object.keys(i).forEach(s=>{s!=="__proto__"&&(s in o?D.$Uf(o[s])&&D.$Uf(i[s])?u(o[s],i[s],n):n&&(o[s]=i[s]):o[s]=i[s])})}e.$Ti=u;function b(o){return o.replace(/[\[\]]/g,"")}e.$Ui=b}),define(Se[45],De([1,0,9,12,238,5,198,14]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$d),$.set("isLinux",D.$e),$.set("isWindows",D.$c),$.set("isWeb",D.$i),$.set("isMacNative",D.$d&&!D.$i),$.set("isEdge",D.$B),$.set("isFirefox",D.$z),$.set("isChrome",D.$y),$.set("isSafari",D.$A);function k(ae,H){if($.get(ae)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(ae,H)}e.$aj=k;const M=Object.prototype.hasOwnProperty;var I;(function(ae){ae[ae.False=0]="False",ae[ae.True=1]="True",ae[ae.Defined=2]="Defined",ae[ae.Not=3]="Not",ae[ae.Equals=4]="Equals",ae[ae.NotEquals=5]="NotEquals",ae[ae.And=6]="And",ae[ae.Regex=7]="Regex",ae[ae.NotRegex=8]="NotRegex",ae[ae.Or=9]="Or",ae[ae.In=10]="In",ae[ae.NotIn=11]="NotIn",ae[ae.Greater=12]="Greater",ae[ae.GreaterEquals=13]="GreaterEquals",ae[ae.Smaller=14]="Smaller",ae[ae.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},S=(0,L.localize)(0,null),E=(0,L.localize)(1,null),u=(0,L.localize)(2,null),b=(0,L.localize)(3,null),o=(0,L.localize)(4,null),i=(0,L.localize)(5,null),n=(0,L.localize)(6,null),s=(0,L.localize)(7,null);class a{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(H=p){this.k=H,this.d=new f.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(H){if(H===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(H).scan(),this.g=0,this.h=[];try{const fe=this.l();if(!this.E()){const he=this.D(),se=he.type===17?i:void 0;throw this.h.push({message:o,offset:he.offset,lexeme:f.$_i.getLexeme(he),additionalInfo:se}),a.c}return fe}catch(fe){if(fe!==a.c)throw fe;return}}l(){return this.m()}m(){const H=[this.o()];for(;this.y(16);){const fe=this.o();H.push(fe)}return H.length===1?H[0]:t.or(...H)}o(){const H=[this.s()];for(;this.y(15);){const fe=this.s();H.push(fe)}return H.length===1?H[0]:t.and(...H)}s(){if(this.y(2)){const H=this.D();switch(H.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const fe=this.l();return this.A(1,b),fe?.negate()}case 17:return this.z(),P.create(H.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",H)}}return this.t()}t(){const H=this.D();switch(H.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const fe=this.l();return this.A(1,b),fe}case 17:{const fe=H.lexeme;if(this.z(),this.y(9)){const se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),se.type!==10)throw this.B("REGEX",se);const ce=se.lexeme,le=ce.lastIndexOf("/"),de=le===ce.length-1?void 0:this.w(ce.substring(le+1));let q;try{q=new RegExp(ce.substring(1,le),de)}catch{throw this.B("REGEX",se)}return T.create(fe,q)}switch(se.type){case 10:case 19:{const ce=[se.lexeme];this.z();let le=this.D(),de=0;for(let Ae=0;Ae<se.lexeme.length;Ae++)se.lexeme.charCodeAt(Ae)===40?de++:se.lexeme.charCodeAt(Ae)===41&&de--;for(;!this.E()&&le.type!==15&&le.type!==16;){switch(le.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Ae=0;Ae<le.lexeme.length;Ae++)le.lexeme.charCodeAt(Ae)===40?de++:se.lexeme.charCodeAt(Ae)===41&&de--}if(de<0)break;ce.push(f.$_i.getLexeme(le)),this.z(),le=this.D()}const q=ce.join(""),_=q.lastIndexOf("/"),ge=_===q.length-1?void 0:this.w(q.substring(_+1));let me;try{me=new RegExp(q.substring(1,_),ge)}catch{throw this.B("REGEX",se)}return t.regex(fe,me)}case 18:{const ce=se.lexeme;this.z();let le=null;if(!(0,O.$Se)(ce)){const de=ce.indexOf("/"),q=ce.lastIndexOf("/");if(de!==q&&de>=0){const _=ce.slice(de+1,q),ge=ce[q+1]==="i"?"i":"";try{le=new RegExp(_,ge)}catch{throw this.B("REGEX",se)}}}if(le===null)throw this.B("REGEX",se);return T.create(fe,le)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const se=this.u();return t.notIn(fe,se)}switch(this.D().type){case 3:{this.z();const se=this.u();if(this.x().type===18)return t.equals(fe,se);switch(se){case"true":return t.has(fe);case"false":return t.not(fe);default:return t.equals(fe,se)}}case 4:{this.z();const se=this.u();if(this.x().type===18)return t.notEquals(fe,se);switch(se){case"true":return t.not(fe);case"false":return t.has(fe);default:return t.notEquals(fe,se)}}case 5:return this.z(),N.create(fe,this.u());case 6:return this.z(),A.create(fe,this.u());case 7:return this.z(),U.create(fe,this.u());case 8:return this.z(),z.create(fe,this.u());case 13:return this.z(),t.in(fe,this.u());default:return t.has(fe)}}case 20:throw this.h.push({message:n,offset:H.offset,lexeme:"",additionalInfo:s}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const H=this.D();switch(H.type){case 17:case 18:return this.z(),H.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(H){return H.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(H){return this.C(H)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(H,fe){if(this.C(H))return this.z();throw this.B(fe,this.D())}B(H,fe,he){const se=(0,L.localize)(8,null,H,f.$_i.getLexeme(fe)),ce=fe.offset,le=f.$_i.getLexeme(fe);return this.h.push({message:se,offset:ce,lexeme:le,additionalInfo:he}),a.c}C(H){return this.D().type===H}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=a,a.c=new Error;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(H){return g.create(H)}static equals(H,fe){return C.create(H,fe)}static notEquals(H,fe){return y.create(H,fe)}static regex(H,fe){return T.create(H,fe)}static in(H,fe){return v.create(H,fe)}static notIn(H,fe){return m.create(H,fe)}static not(H){return P.create(H)}static and(...H){return K.create(H,null,!0)}static or(...H){return X.create(H,null,!0)}static greater(H,fe){return U.create(H,fe)}static greaterEquals(H,fe){return z.create(H,fe)}static smaller(H,fe){return N.create(H,fe)}static smallerEquals(H,fe){return A.create(H,fe)}static deserialize(H){return H==null?void 0:this.c.parse(H)}}e.$cj=t,t.c=new a({regexParsingWithErrorRecovery:!1});function d(ae){const H=new a({regexParsingWithErrorRecovery:!1});return ae.map(fe=>(H.parse(fe),H.lexingErrors.length>0?H.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,L.localize)(9,null,he.additionalInfo):(0,L.localize)(10,null),offset:he.offset,length:he.lexeme.length})):H.parsingErrors.length>0?H.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}e.$dj=d;function l(ae,H){const fe=ae?ae.substituteConstants():void 0,he=H?H.substituteConstants():void 0;return!fe&&!he?!0:!fe||!he?!1:fe.equals(he)}e.$ej=l;function r(ae,H){return ae.cmp(H)}class c{constructor(){this.type=0}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!1}serialize(){return"false"}keys(){return[]}map(H){return this}negate(){return h.INSTANCE}}e.$fj=c,c.INSTANCE=new c;class h{constructor(){this.type=1}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!0}serialize(){return"true"}keys(){return[]}map(H){return this}negate(){return c.INSTANCE}}e.$gj=h,h.INSTANCE=new h;class g{static create(H,fe=null){const he=$.get(H);return typeof he=="boolean"?he?h.INSTANCE:c.INSTANCE:new g(H,fe)}constructor(H,fe){this.key=H,this.c=fe,this.type=2}cmp(H){return H.type!==this.type?this.type-H.type:Z(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=$.get(this.key);return typeof H=="boolean"?H?h.INSTANCE:c.INSTANCE:this}evaluate(H){return!!H.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(H){return H.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$hj=g;class C{static create(H,fe,he=null){if(typeof fe=="boolean")return fe?g.create(H,he):P.create(H,he);const se=$.get(H);return typeof se=="boolean"?fe===(se?"true":"false")?h.INSTANCE:c.INSTANCE:new C(H,fe,he)}constructor(H,fe,he){this.c=H,this.d=fe,this.f=he,this.type=4}cmp(H){return H.type!==this.type?this.type-H.type:ie(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=$.get(this.c);if(typeof H=="boolean"){const fe=H?"true":"false";return this.d===fe?h.INSTANCE:c.INSTANCE}return this}evaluate(H){return H.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(H){return H.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$ij=C;class v{static create(H,fe){return new v(H,fe)}constructor(H,fe){this.d=H,this.f=fe,this.type=10,this.c=null}cmp(H){return H.type!==this.type?this.type-H.type:ie(this.d,this.f,H.d,H.f)}equals(H){return H.type===this.type?this.d===H.d&&this.f===H.f:!1}substituteConstants(){return this}evaluate(H){const fe=H.getValue(this.f),he=H.getValue(this.d);return Array.isArray(fe)?fe.includes(he):typeof he=="string"&&typeof fe=="object"&&fe!==null?M.call(fe,he):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(H){return H.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$jj=v;class m{static create(H,fe){return new m(H,fe)}constructor(H,fe){this.d=H,this.f=fe,this.type=11,this.c=v.create(H,fe)}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(H){return H.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=m;class y{static create(H,fe,he=null){if(typeof fe=="boolean")return fe?P.create(H,he):g.create(H,he);const se=$.get(H);return typeof se=="boolean"?fe===(se?"true":"false")?c.INSTANCE:h.INSTANCE:new y(H,fe,he)}constructor(H,fe,he){this.c=H,this.d=fe,this.f=he,this.type=5}cmp(H){return H.type!==this.type?this.type-H.type:ie(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=$.get(this.c);if(typeof H=="boolean"){const fe=H?"true":"false";return this.d===fe?c.INSTANCE:h.INSTANCE}return this}evaluate(H){return H.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(H){return H.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$lj=y;class P{static create(H,fe=null){const he=$.get(H);return typeof he=="boolean"?he?c.INSTANCE:h.INSTANCE:new P(H,fe)}constructor(H,fe){this.c=H,this.d=fe,this.type=3}cmp(H){return H.type!==this.type?this.type-H.type:Z(this.c,H.c)}equals(H){return H.type===this.type?this.c===H.c:!1}substituteConstants(){const H=$.get(this.c);return typeof H=="boolean"?H?c.INSTANCE:h.INSTANCE:this}evaluate(H){return!H.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(H){return H.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$mj=P;function j(ae,H){if(typeof ae=="string"){const fe=parseFloat(ae);isNaN(fe)||(ae=fe)}return typeof ae=="string"||typeof ae=="number"?H(ae):c.INSTANCE}class U{static create(H,fe,he=null){return j(fe,se=>new U(H,se,he))}constructor(H,fe,he){this.c=H,this.d=fe,this.f=he,this.type=12}cmp(H){return H.type!==this.type?this.type-H.type:ie(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$nj=U;class z{static create(H,fe,he=null){return j(fe,se=>new z(H,se,he))}constructor(H,fe,he){this.c=H,this.d=fe,this.f=he,this.type=13}cmp(H){return H.type!==this.type?this.type-H.type:ie(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$oj=z;class N{static create(H,fe,he=null){return j(fe,se=>new N(H,se,he))}constructor(H,fe,he){this.c=H,this.d=fe,this.f=he,this.type=14}cmp(H){return H.type!==this.type?this.type-H.type:ie(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$pj=N;class A{static create(H,fe,he=null){return j(fe,se=>new A(H,se,he))}constructor(H,fe,he){this.c=H,this.d=fe,this.f=he,this.type=15}cmp(H){return H.type!==this.type?this.type-H.type:ie(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$qj=A;class T{static create(H,fe){return new T(H,fe)}constructor(H,fe){this.d=H,this.f=fe,this.type=7,this.c=null}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.d<H.d)return-1;if(this.d>H.d)return 1;const fe=this.f?this.f.source:"",he=H.f?H.f.source:"";return fe<he?-1:fe>he?1:0}equals(H){if(H.type===this.type){const fe=this.f?this.f.source:"",he=H.f?H.f.source:"";return this.d===H.d&&fe===he}return!1}substituteConstants(){return this}evaluate(H){const fe=H.getValue(this.d);return this.f?this.f.test(fe):!1}serialize(){const H=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${H}`}keys(){return[this.d]}map(H){return H.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=F.create(this)),this.c}}e.$rj=T;class F{static create(H){return new F(H)}constructor(H){this.c=H,this.type=8}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(H){return new F(this.c.map(H))}negate(){return this.c}}e.$sj=F;function G(ae){let H=null;for(let fe=0,he=ae.length;fe<he;fe++){const se=ae[fe].substituteConstants();if(ae[fe]!==se&&H===null){H=[];for(let ce=0;ce<fe;ce++)H[ce]=ae[ce]}H!==null&&(H[fe]=se)}return H===null?ae:H}class K{static create(H,fe,he){return K.d(H,fe,he)}constructor(H,fe){this.expr=H,this.c=fe,this.type=6}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let fe=0,he=this.expr.length;fe<he;fe++){const se=r(this.expr[fe],H.expr[fe]);if(se!==0)return se}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let fe=0,he=this.expr.length;fe<he;fe++)if(!this.expr[fe].equals(H.expr[fe]))return!1;return!0}return!1}substituteConstants(){const H=G(this.expr);return H===this.expr?this:K.create(H,this.c,!1)}evaluate(H){for(let fe=0,he=this.expr.length;fe<he;fe++)if(!this.expr[fe].evaluate(H))return!1;return!0}static d(H,fe,he){const se=[];let ce=!1;for(const le of H)if(le){if(le.type===1){ce=!0;continue}if(le.type===0)return c.INSTANCE;if(le.type===6){se.push(...le.expr);continue}se.push(le)}if(se.length===0&&ce)return h.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(r);for(let le=1;le<se.length;le++)se[le-1].equals(se[le])&&(se.splice(le,1),le--);if(se.length===1)return se[0];for(;se.length>1;){const le=se[se.length-1];if(le.type!==9)break;se.pop();const de=se.pop(),q=se.length===0,_=X.create(le.expr.map(ge=>K.create([ge,de],null,he)),null,q);_&&(se.push(_),se.sort(r))}if(se.length===1)return se[0];if(he){for(let le=0;le<se.length;le++)for(let de=le+1;de<se.length;de++)if(se[le].negate().equals(se[de]))return c.INSTANCE;if(se.length===1)return se[0]}return new K(se,fe)}}serialize(){return this.expr.map(H=>H.serialize()).join(" && ")}keys(){const H=[];for(const fe of this.expr)H.push(...fe.keys());return H}map(H){return new K(this.expr.map(fe=>fe.map(H)),null)}negate(){if(!this.c){const H=[];for(const fe of this.expr)H.push(fe.negate());this.c=X.create(H,this,!0)}return this.c}}e.$tj=K;class X{static create(H,fe,he){return X.d(H,fe,he)}constructor(H,fe){this.expr=H,this.c=fe,this.type=9}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let fe=0,he=this.expr.length;fe<he;fe++){const se=r(this.expr[fe],H.expr[fe]);if(se!==0)return se}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let fe=0,he=this.expr.length;fe<he;fe++)if(!this.expr[fe].equals(H.expr[fe]))return!1;return!0}return!1}substituteConstants(){const H=G(this.expr);return H===this.expr?this:X.create(H,this.c,!1)}evaluate(H){for(let fe=0,he=this.expr.length;fe<he;fe++)if(this.expr[fe].evaluate(H))return!0;return!1}static d(H,fe,he){let se=[],ce=!1;if(H){for(let le=0,de=H.length;le<de;le++){const q=H[le];if(q){if(q.type===0){ce=!0;continue}if(q.type===1)return h.INSTANCE;if(q.type===9){se=se.concat(q.expr);continue}se.push(q)}}if(se.length===0&&ce)return c.INSTANCE;se.sort(r)}if(se.length!==0){if(se.length===1)return se[0];for(let le=1;le<se.length;le++)se[le-1].equals(se[le])&&(se.splice(le,1),le--);if(se.length===1)return se[0];if(he){for(let le=0;le<se.length;le++)for(let de=le+1;de<se.length;de++)if(se[le].negate().equals(se[de]))return h.INSTANCE;if(se.length===1)return se[0]}return new X(se,fe)}}serialize(){return this.expr.map(H=>H.serialize()).join(" || ")}keys(){const H=[];for(const fe of this.expr)H.push(...fe.keys());return H}map(H){return new X(this.expr.map(fe=>fe.map(H)),null)}negate(){if(!this.c){const H=[];for(const fe of this.expr)H.push(fe.negate());for(;H.length>1;){const fe=H.shift(),he=H.shift(),se=[];for(const ce of ue(fe))for(const le of ue(he))se.push(K.create([ce,le],null,!1));H.unshift(X.create(se,null,!1))}this.c=X.create(H,this,!0)}return this.c}}e.$uj=X;class Q extends g{static all(){return Q.d.values()}constructor(H,fe,he){super(H,null),this.f=fe,typeof he=="object"?Q.d.push({...he,key:H}):he!==!0&&Q.d.push({key:H,description:he,type:fe!=null?typeof fe:void 0})}bindTo(H){return H.createKey(this.key,this.f)}getValue(H){return H.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(H){return C.create(this.key,H)}notEqualsTo(H){return y.create(this.key,H)}}e.$vj=Q,Q.d=[],e.$wj=(0,R.$ei)("contextKeyService");function Z(ae,H){return ae<H?-1:ae>H?1:0}function ie(ae,H,fe,he){return ae<fe?-1:ae>fe?1:H<he?-1:H>he?1:0}function ee(ae,H){if(ae.type===0||H.type===1)return!0;if(ae.type===9)return H.type===9?we(ae.expr,H.expr):!1;if(H.type===9){for(const fe of H.expr)if(ee(ae,fe))return!0;return!1}if(ae.type===6){if(H.type===6)return we(H.expr,ae.expr);for(const fe of ae.expr)if(ee(fe,H))return!0;return!1}return ae.equals(H)}e.$xj=ee;function we(ae,H){let fe=0,he=0;for(;fe<ae.length&&he<H.length;){const se=ae[fe].cmp(H[he]);if(se<0)return!1;se===0&&fe++,he++}return fe===ae.length}function ue(ae){return ae.type===9?ae.expr:[ae]}}),define(Se[241],De([1,0,23,40,200,5,101,9,24]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.ConfirmResult=e.$iw=e.$hw=e.$gw=void 0,e.$gw=(0,R.$ei)("dialogService");var k;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(k||(k={}));class M{a(b){return this.d(b,k.Confirmation)}b(b){return this.d(b,k.Prompt)}c(b){return this.d(b,k.Input)}d(b,o){const i=[];switch(o){case k.Confirmation:{const n=b;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(1,null));break}case k.Prompt:{const n=b;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(s=>s.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case k.Input:{const n=b;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(b){if(typeof b=="string")return b;if(typeof b=="number")return b===O.default.Info?"info":b===O.default.Error?"error":b===O.default.Warning?"warning":"none"}f(b,o,i){const n=[...b.buttons??[]];b.cancelButton&&typeof b.cancelButton!="string"&&typeof b.cancelButton!="boolean"&&n.push(b.cancelButton);let s=n[o]?.run({checkboxChecked:i});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:i}}}e.$hw=M,e.$iw=(0,R.$ei)("fileDialogService");var I;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function S(u){const b=[];return b.push(...u.slice(0,p).map(o=>typeof o=="string"?o:(0,D.$Og)(o))),u.length>p&&(u.length-p===1?b.push((0,f.localize)(7,null)):b.push((0,f.localize)(8,null,u.length-p))),b.push(""),b.join(`
`)}e.$jw=S;function E(u,b){const o=(0,$.$In)(u);let i=(o.buttons??[]).map(t=>(0,L.$dw)(t)),n=(u.buttons||[]).map((t,d)=>d),s=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(w.$e||w.$d){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const d=n[a];n.splice(a,1),n.splice(1,0,d),a=1}w.$e&&i.length>1&&(i=i.reverse(),n=n.reverse(),s=i.length-1,typeof t=="string"&&(a=s-1))}else if(w.$c&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const d=n[a];n.splice(a,1),n.push(d),a=i.length-1}}return o.buttons=i,o.defaultId=s,o.cancelId=a,o.noLink=!0,o.title=o.title||b.nameLong,{options:o,buttonIndeces:n}}e.$kw=E}),define(Se[134],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,D.$ei)("environmentService"),e.$mi=(0,D.$fi)(e.$li)}),define(Se[135],De([1,0,201,5]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.ExtensionGalleryErrorCode=e.$Mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0,e.$zo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ao=new RegExp(e.$zo),e.$Bo="__web_extension",e.$Co="skipWalkthrough",e.$Do="extensionsSync",e.$Eo="dependecyOrPackExtensionInstall";function f(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Fo=f;function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Go=R;function L(n,s){switch(n){case 3:return s==="x64"?"win32-x64":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ho=L;function w(n,s){return s==="web"&&!n.includes("web")}e.$Io=w;function $(n,s,a){return w(s,a)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===a}e.$Jo=$;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Ko=k;var M;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var I;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var p;(function(n){n.Install="install",n.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var S;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$Lo=(0,O.$ei)("extensionGalleryService");var E;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var u;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class b extends Error{constructor(s,a){super(s),this.code=a,this.name=a}}e.$Mo=b;var o;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(s,a){super(s),this.code=a,this.name=a}}e.$No=i,e.$Oo=(0,O.$ei)("extensionManagementService"),e.$Po="extensionsIdentifiers/disabled",e.$Qo="extensionsIdentifiers/enabled",e.$Ro=(0,O.$ei)("IGlobalExtensionEnablementService"),e.$So=(0,O.$ei)("IExtensionTipsService"),e.$To=(0,D.localize2)(0,"Extensions"),e.$Uo=(0,D.localize2)(1,"Preferences")}),define(Se[242],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v4b=e.$u4b=void 0,e.$u4b=(0,D.$ei)("externalTerminal"),e.$v4b="Terminal.app"}),define(Se[243],De([1,0,50,53,16,17,9,99,31,103,203,242]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=e.$s_b=e.$r_b=void 0;const p=M.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends S{openTerminal(a,t){return this.spawnTerminal(D,a,k.$6l(),t)}spawnTerminal(a,t,d,l){const r=t.windowsExec||E.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const c=R.$nc(r,".exe").toLowerCase();if(c==="cmder")return a.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return r.indexOf(" ")>=0&&h.push('""'),h.push(r),c==="wt"&&h.push("-d ."),new Promise((g,C)=>{const v=o(process),m=a.spawn(d,h,{cwd:l,env:v,detached:!0});m.on("error",C),m.on("exit",()=>g())})}async runInTerminal(a,t,d,l,r){const c="windowsExec"in r&&r.windowsExec?r.windowsExec:E.getDefaultTerminalWindows(),h=await E.f();return new Promise((g,C)=>{const v=`"${t} - ${p}"`,m=`""${d.join('" "')}" & pause"`,y=Object.assign({},o(process),l);Object.keys(y).filter(N=>y[N]===null).forEach(N=>delete y[N]);const P={cwd:t,env:y,windowsVerbatimArguments:!0};let j,U;R.$nc(c,".exe")==="wt"?(j=c,U=["-d",".",E.b,"/c",m]):h?(j=h,U=["-d",".",c,"/c",m]):(j=E.b,U=["/c","start",v,"/wait",c,"/c",m]),D.spawn(j,U,P).on("error",N=>{C(i(N))}),g(void 0)})}static getDefaultTerminalWindows(){if(!E.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return E.d}static async f(){try{const a=await k.win32.findExecutable("wt");return await $.Promises.exists(a)?a:void 0}catch{return}}}e.$r_b=E,E.b="cmd.exe",Je([O.$Ih],E,"f",null);class u extends S{openTerminal(a,t){return this.spawnTerminal(D,a,t)}runInTerminal(a,t,d,l,r){const c=r.osxExec||I.$v4b;return new Promise((h,g)=>{if(c===I.$v4b||c==="iTerm.app"){const C=c===I.$v4b?"TerminalHelper":"iTermHelper",m=[f.$yg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",a||p,"-w",t];for(const j of d)m.push("-a"),m.push(j);if(l){const j=Object.assign({},o(process),l);for(const U in j){const z=j[U];z===null?(m.push("-u"),m.push(U)):(m.push("-e"),m.push(`${U}=${z}`))}}let y="";const P=D.spawn(u.b,m);P.on("error",j=>{g(i(j))}),P.stderr.on("data",j=>{y+=j.toString()}),P.on("exit",j=>{if(j===0)h(void 0);else if(y){const U=y.split(`
`,1);g(new Error(U[0]))}else g(new Error(M.localize(1,null,C,j)))})}else g(new Error(M.localize(2,null,c)))})}spawnTerminal(a,t,d){const l=t.osxExec||I.$v4b;return new Promise((r,c)=>{const h=["-a",l];d&&h.push(d);const g=o(process),C=a.spawn("/usr/bin/open",h,{cwd:d,env:g});C.on("error",c),C.on("exit",()=>r())})}}e.$s_b=u,u.b="/usr/bin/osascript";class b extends S{openTerminal(a,t){return this.spawnTerminal(D,a,t)}runInTerminal(a,t,d,l,r){const c=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((h,g)=>{const C=[];c.then(v=>{v.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const m=`${n(d)}; echo; read -p "${b.b}" -n1;`;C.push(`''${m}''`);const y=Object.assign({},o(process),l);Object.keys(y).filter(z=>y[z]===null).forEach(z=>delete y[z]);const P={cwd:t,env:y};let j="";const U=D.spawn(v,C,P);U.on("error",z=>{g(i(z))}),U.stderr.on("data",z=>{j+=z.toString()}),U.on("exit",z=>{if(z===0)h(void 0);else if(j){const N=j.split(`
`,1);g(new Error(N[0]))}else g(new Error(M.localize(4,null,v,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!L.$e)b.d=Promise.resolve("xterm");else{const a=await $.Promises.exists("/etc/debian_version");b.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return b.d}spawnTerminal(a,t,d){const l=t.linuxExec?Promise.resolve(t.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{l.then(h=>{const g=o(process),C=a.spawn(h,[],{cwd:d,env:g});C.on("error",c),C.on("exit",()=>r())})})}}e.$t_b=b,b.b=M.localize(3,null);function o(s){const a={...s.env};return(0,w.$4l)(a),a}function i(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(M.localize(5,null,s.path)):s}function n(s){let a="";for(const t of s)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(Se[32],De([1,0,77,17,12,18,2,204,5,9,16,44]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,$.$ei)("fileService");function p(ee){return ee.create===!0}e.$Ck=p;var S;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var E;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(E||(e.FilePermission=E={}));function u(ee){const we=ee;return!!we&&typeof we.onDidChange=="function"}e.$Dk=u;var b;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function o(ee){return!!(ee.capabilities&2)}e.$Ek=o;function i(ee){return!!(ee.capabilities&8)}e.$Fk=i;function n(ee){return!!(ee.capabilities&131072)}e.$Gk=n;function s(ee){return!!(ee.capabilities&4)}e.$Hk=s;function a(ee){return!!(ee.capabilities&16)}e.$Ik=a;function t(ee){return o(ee)?!!(ee.capabilities&16384):!1}e.$Jk=t;function d(ee){return o(ee)?!!(ee.capabilities&32768):!1}e.$Kk=d;function l(ee){return!!(ee.capabilities&65536)}e.$Lk=l;function r(ee){return!!(ee.capabilities&2048)}e.$Mk=r;var c;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create(we,ue){const ae=new h(we.toString(),ue);return v(ae,ue),ae}constructor(we,ue){super(we),this.code=ue}}e.$Nk=h;function g(ee,we){return h.create(ee,we)}e.$Ok=g;function C(ee){return ee||g((0,w.localize)(0,null),c.Unknown)}e.$Pk=C;function v(ee,we){return ee.name=we?`${we} (FileSystemError)`:"FileSystemError",ee}e.$Qk=v;function m(ee){if(!ee)return c.Unknown;if(ee instanceof h)return ee.code;const we=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!we)return c.Unknown;switch(we[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$Rk=m;function y(ee){if(ee instanceof A)return ee.fileOperationResult;switch(m(ee)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$Sk=y;var P;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class j{constructor(we,ue,ae){this.resource=we,this.operation=ue,this.target=ae}isOperation(we){return this.operation===we}}e.$Tk=j;var U;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class z{constructor(we,ue){this.c=ue,this.b=void 0,this.d=new I.$V(()=>{const ae=D.$ki.forUris(()=>this.c);return ae.fill(this.rawAdded.map(H=>[H,!0])),ae}),this.f=new I.$V(()=>{const ae=D.$ki.forUris(()=>this.c);return ae.fill(this.rawUpdated.map(H=>[H,!0])),ae}),this.g=new I.$V(()=>{const ae=D.$ki.forUris(()=>this.c);return ae.fill(this.rawDeleted.map(H=>[H,!0])),ae}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ae of we){switch(ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}this.b!==z.a&&(typeof ae.cId=="number"?this.b===void 0?this.b=ae.cId:this.b!==ae.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(we,...ue){return this.h(we,{includeChildren:!1},...ue)}affects(we,...ue){return this.h(we,{includeChildren:!0},...ue)}h(we,ue,...ae){if(!we)return!1;const H=ae.length>0;return!!((!H||ae.includes(1))&&(this.d.value.get(we)||ue.includeChildren&&this.d.value.findSuperstr(we))||(!H||ae.includes(0))&&(this.f.value.get(we)||ue.includeChildren&&this.f.value.findSuperstr(we))||(!H||ae.includes(2))&&(this.g.value.findSubstr(we)||ue.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=z,z.a=null;function N(ee,we,ue){return!ee||!we||ee===we||we.length>ee.length?!1:(we.charAt(we.length-1)!==O.sep&&(we+=O.sep),ue?(0,f.$kf)(ee,we):ee.indexOf(we)===0)}e.$Vk=N;class A extends Error{constructor(we,ue,ae){super(we),this.fileOperationResult=ue,this.options=ae}}e.$Wk=A;class T extends A{constructor(we,ue,ae,H){super(we,ue,H),this.fileOperationResult=ue,this.size=ae}}e.$Xk=T;class F extends A{constructor(we,ue,ae){super(we,2,ae),this.stat=ue}}e.$Yk=F;var G;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var K;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$7k="";function X(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$8k=X;async function Q(ee,we){if(!we.hasProvider(L.URI.from({scheme:ee.scheme})))return new Promise(ue=>{const ae=we.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===ee.scheme&&H.added&&(ae.dispose(),ue())})})}e.$9k=Q;class Z{static formatSize(we){return(0,R.$Wf)(we)||(we=0),we<Z.KB?(0,w.localize)(1,null,we.toFixed(0)):we<Z.MB?(0,w.localize)(2,null,(we/Z.KB).toFixed(2)):we<Z.GB?(0,w.localize)(3,null,(we/Z.MB).toFixed(2)):we<Z.TB?(0,w.localize)(4,null,(we/Z.GB).toFixed(2)):(0,w.localize)(5,null,(we/Z.TB).toFixed(2))}}e.$0k=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;function ie(ee){const we=typeof ee=="string"||ee?.scheme===M.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===M.Schemas.file?1024*Z.MB:we?10*Z.MB:k.$i?50*Z.MB:1024*Z.MB}e.$$k=ie}),define(Se[244],De([1,0,21,14,205,32]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;async function L(M,I,p,S,E,u){let b;try{await w(M,I,p,S,E,u)}catch(o){b=o}finally{b&&E.errorTransformer&&(b=E.errorTransformer(b)),typeof b<"u"&&p.error(b),p.end()}}e.$nq=L;async function w(M,I,p,S,E,u){$(u);const b=await M.open(I,{create:!1});try{$(u);let o=0,i=0,n=E&&typeof E.length=="number"?E.length:void 0,s=D.$se.alloc(Math.min(E.bufferSize,typeof n=="number"?n:E.bufferSize)),a=E&&typeof E.position=="number"?E.position:0,t=0;do i=await M.read(b,a,s.buffer,t,s.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===s.byteLength&&(await p.write(S(s)),s=D.$se.alloc(Math.min(E.bufferSize,typeof n=="number"?n:E.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(u)&&k(o,E));if(t>0){let d=t;typeof n=="number"&&(d=Math.min(t,n)),p.write(S(s.slice(0,d)))}}catch(o){throw(0,R.$Pk)(o)}finally{await M.close(b)}}function $(M){if(M.isCancellationRequested)throw(0,O.$6)();return!0}function k(M,I){if(typeof I?.limits?.size=="number"&&M>I.limits.size)throw(0,R.$Ok)((0,f.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[85],De([1,0,35,3,17,9,2,32]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=void 0;function $(o){return o.recursive===!0}e.$pq=$;class k extends O.$Tc{constructor(i,n,s,a){super(),this.h=i,this.j=n,this.m=s,this.n=a,this.c=this.B(new O.$Uc),this.f=void 0,this.g=0}s(){const i=new O.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<k.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$qq=k,k.a=5;class M extends k{constructor(i,n,s){super(i,n,s,{type:"node.js",restartOnError:!1})}}e.$rq=M;class I extends k{constructor(i,n,s){super(i,n,s,{type:"universal",restartOnError:!0})}}e.$sq=I;function p(o){return o.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}e.$tq=p;function S(o){const i=new b;for(const n of o)i.processEvent(n);return i.coalesce()}e.$uq=S;function E(o,i){return typeof i=="string"&&!i.startsWith(D.$Tj)&&!(0,f.$ic)(i)?{base:o,pattern:i}:i}e.$vq=E;function u(o,i){const n=[];for(const s of i)n.push((0,D.$Xj)(E(o,s)));return n}e.$wq=u;class b{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$e?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let s=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,a)=>s.resource.fsPath.length-a.resource.fsPath.length).filter(s=>n.some(a=>(0,w.$Vk)(s.resource.fsPath,a,!R.$e))?!1:(n.push(s.resource.fsPath),!0)).concat(i)}}}),define(Se[245],De([1,0,57,8,22,34,3,76,17,9,23,2,102,31,85]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class u extends L.$Tc{constructor(i,n,s,a){super(),this.m=i,this.n=n,this.r=s,this.s=a,this.c=this.B(new O.$th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$sh(t=>this.z(t),u.b)),this.g=(0,E.$wq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,E.$wq)(this.m.path,this.m.includes):void 0,this.j=new f.$ce,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await S.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await S.Promises.realpath(i.path),i.path===n&&(n=await(0,p.$Gq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(k.$d&&(0,R.$fg)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Tc.None;const s=new f.$ce(this.j.token),a=new L.$Sc;try{const t=I.URI.file(this.m.path),d=(0,$.$nc)(i),l=(0,D.watch)(i);a.add((0,L.$Rc)(()=>{l.removeAllListeners(),l.close()})),this.G(`Started watching: '${i}'`);const r=new Set;if(n)try{for(const h of await S.Promises.readdir(i))r.add(h)}catch(h){this.D(h)}const c=new Map;a.add((0,L.$Rc)(()=>{for(const[,h]of c)h.dispose();c.clear()})),l.on("error",(h,g)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${g})`),this.dispose()}),l.on("change",(h,g)=>{if(s.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${g}`);let C="";if(g&&(C=g.toString(),k.$d&&(C=(0,w.$Sl)(C))),!(!C||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){c.get(C)?.dispose();const v=setTimeout(async()=>{if(c.delete(C),C===d&&!await S.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.C((0,$.$jc)(i,C));if(s.token.isCancellationRequested)return;let y;m?r.has(C)?y=0:(y=1,r.add(C)):(r.delete(C),y=2),this.y({resource:(0,M.$Rg)(t,C),type:y,cId:this.m.correlationId})},u.a);c.set(C,(0,L.$Rc)(()=>clearTimeout(v)))}else{let v;r.has(C)?v=0:(v=1,r.add(C)),this.y({resource:(0,M.$Rg)(t,C),type:v,cId:this.m.correlationId})}else if(h==="rename"||C!==d){const v=setTimeout(async()=>{const m=await S.Promises.exists(i);s.token.isCancellationRequested||(m?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},u.a);a.clear(),a.add((0,L.$Rc)(()=>clearTimeout(v)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await S.Promises.exists(i)&&!s.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,L.$Rc)(()=>{s.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(s=>s(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(s=>s(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,E.$uq)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(k.$e)return S.Promises.exists(i);try{const n=(0,$.$nc)(i);return(await S.Promises.readdir((0,$.$mc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Jq=u,u.a=100,u.b=75;async function b(o,i,n,s,a=512){const t=await S.Promises.open(o,"r"),d=Buffer.allocUnsafe(a),l=new f.$ce(s);let r,c=!1;const h={path:o,excludes:[],recursive:!1},g=new u(h,C=>{(async()=>{for(const{type:v}of C)if(v===0){if(c)return;c=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:m}=await S.Promises.read(t,d,0,a,null);if(!m||l.token.isCancellationRequested)break;i(d.slice(0,m))}}catch(m){r=new Error(m),l.dispose(!0)}finally{c=!1}}})()});return await g.ready,n(),new Promise((C,v)=>{l.token.onCancellationRequested(async()=>{g.dispose();try{await S.Promises.close(t)}catch(m){r=new Error(m)}r?v(r):C()})})}e.$Kq=b}),define(Se[246],De([1,0,4,35,3,9,245]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class w extends f.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$5d),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(k){const M=this.j(k),I=M.filter(S=>{const E=this.c.get(S.path);return E?!(0,O.$2j)(E.request.excludes,S.excludes)||!(0,O.$2j)(E.request.includes,S.includes):!0}),p=Array.from(this.c.values()).filter(({request:S})=>!M.find(E=>E.path===S.path&&(0,O.$2j)(E.excludes,S.excludes)&&(0,O.$2j)(E.includes,S.includes))).map(({request:S})=>S.path);I.length&&this.m(`Request to start watching: ${I.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const S of p)this.h(S);for(const S of I)this.g(S)}g(k){const M=new L.$Jq(k,p=>this.a.fire(p),p=>this.b.fire(p),this.f),I={request:k,instance:M};this.c.set(k.path,I)}async stop(){for(const[k]of this.c)this.h(k);this.c.clear()}h(k){const M=this.c.get(k);M&&(this.c.delete(k),M.instance.dispose())}j(k){const M=new Map;for(const I of k){const p=R.$e?I.path:I.path.toLowerCase();let S=M.get(I.correlationId);S||(S=new Map,M.set(I.correlationId,S)),S.set(p,I)}return Array.from(M.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(k){this.f=k;for(const[,M]of this.c)M.instance.setVerboseLogging(k)}m(k){this.f&&this.b.fire({type:"trace",message:this.n(k)})}n(k,M){return M?`[File Watcher (node.js)] ${k} (path: ${M.request.path})`:`[File Watcher (node.js)] ${k}`}}e.$Lq=w}),define(Se[247],De([1,0,85,246]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class f extends D.$rq{constructor(L,w,$){super(L,w,$),this.s()}r(L){return L.add(new O.$Lq)}}e.$Mq=f}),define(Se[248],De([1,0,16,80,171,85]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class L extends R.$sq{constructor($,k,M){super($,k,M),this.s()}r($){const k=$.add(new f.$Dq(D.$yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(k.onDidProcessExit(({code:M,signal:I})=>this.t(`terminated by itself with code ${M}, signal: ${I}`))),O.ProxyChannel.toService((0,O.$Xh)(k.getChannel("watcher")))}}e.$Eq=L}),define(Se[106],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class D{constructor(...f){this.a=new Map;for(const[R,L]of f)this.set(R,L)}set(f,R){const L=this.a.get(f);return this.a.set(f,R),L}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$ci=D}),define(Se[249],De([1,0,8,14,3,105,240,5,106,75]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;const M=!1;class I extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class p{constructor(b=new $.$ci,o=!1,i,n=M){this.f=b,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(w.$di,this),this._globalGraph=n?i?._globalGraph??new L.$Pq(s=>s):void 0}createChild(b){return new p(b,this.g,this,this.i)}invokeFunction(b,...o){const i=E.traceInvocation(this.i,b);let n=!1;try{return b({get:a=>{if(n)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(b,...o){let i,n;return b instanceof R.$bi?(i=E.traceCreation(this.i,b.ctor),n=this.j(b.ctor,b.staticArguments.concat(o),i)):(i=E.traceCreation(this.i,b),n=this.j(b,o,i)),i.stop(),n}j(b,o=[],i){const n=w._util.getServiceDependencies(b).sort((t,d)=>t.index-d.index),s=[];for(const t of n){const d=this.m(t.id,i);d||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(d)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${b.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(b,o.concat(s))}k(b,o){if(this.f.get(b)instanceof R.$bi)this.f.set(b,o);else if(this.h)this.h.k(b,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const o=this.f.get(b);return!o&&this.h?this.h.l(b):o}m(b,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const i=this.l(b);return i instanceof R.$bi?this.q(b,i,o.branch(b,!0)):(o.branch(b,!1),i)}q(b,o,i){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,o,i)}finally{this.o.delete(b)}}r(b,o,i){const n=new L.$Pq(t=>t.id.toString());let s=0;const a=[{id:b,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),s++>1e3)throw new I(n);for(const d of w._util.getServiceDependencies(t.desc.ctor)){const l=this.l(d.id);if(l||this.u(`[createInstance] ${b} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),l instanceof R.$bi){const r={id:d.id,desc:l,_trace:t._trace.branch(d.id,!0)};n.insertEdge(t,r),a.push(r)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new I(n);break}for(const{data:d}of t){if(this.l(d.id)instanceof R.$bi){const r=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,r)}n.removeNode(d)}}return this.l(b)}s(b,o,i=[],n,s){if(this.f.get(b)instanceof R.$bi)return this.t(b,o,i,n,s);if(this.h)return this.h.s(b,o,i,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(b,o,i=[],n,s){if(n){const a=new p(void 0,this.g,this,this.i);a.c=String(b);const t=new Map,d=new D.$xh(()=>{const l=a.j(o,i,s);for(const[r,c]of t){const h=l[r];if(typeof h=="function")for(const g of c)g.disposable=h.apply(l,g.listener)}return t.clear(),l});return new Proxy(Object.create(null),{get(l,r){if(!d.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let g=t.get(r);return g||(g=new k.$4c,t.set(r,g)),(v,m,y)=>{if(d.isInitialized)return d.value[r](v,m,y);{const P={listener:[v,m,y],disposable:void 0},j=g.push(P);return(0,f.$Rc)(()=>{j(),P.disposable?.dispose()})}}}if(r in l)return l[r];const c=d.value;let h=c[r];return typeof h!="function"||(h=h.bind(c),l[r]=h),h},set(l,r,c){return d.value[r]=c,!0},getPrototypeOf(l){return o.prototype}})}else return this.j(o,i,s)}u(b,o){if(o&&console.warn(b),this.g)throw new Error(b)}}e.$Qq=p;var S;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(S||(S={}));class E{static traceInvocation(b,o){return b?new E(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(b,o){return b?new E(1,o.name):E.c}constructor(b,o){this.type=b,this.name=o,this.g=Date.now(),this.h=[]}branch(b,o){const i=new E(3,b.toString());return this.h.push([b,o,i]),i}stop(){const b=Date.now()-this.g;E.f+=b;let o=!1;function i(s,a){const t=[],d=new Array(s+1).join("	");for(const[l,r,c]of a.h)if(r&&c){o=!0,t.push(`${d}CREATES -> ${l}`);const h=i(s+1,c);h&&t.push(h)}else t.push(`${d}uses -> ${l}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(b>2||o)&&E.all.add(n.join(`
`))}}e.$Rq=E,E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0}),define(Se[13],De([1,0,41,4,54,3,28,9,23,18,2,45,5]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,p.$ei)("logService"),e.$zj=(0,p.$ei)("loggerService");function S(){return new Date().toISOString()}function E(v){return(0,k.$Wf)(v)}e.$Aj=E;var u;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$Bj=u.Info;function b(v,m,y){switch(m){case u.Trace:v.trace(y);break;case u.Debug:v.debug(y);break;case u.Info:v.info(y);break;case u.Warning:v.warn(y);break;case u.Error:v.error(y);break;case u.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=b;function o(v,m=!1){let y="";for(let P=0;P<v.length;P++){let j=v[P];if(j instanceof Error&&(j=(0,D.$2i)(j,m)),typeof j=="object")try{j=JSON.stringify(j)}catch{}y+=(P>0?" ":"")+j}return y}class i extends R.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new O.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==u.Off&&this.b<=m}}e.$Dj=i;class n extends i{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...y){this.f(u.Trace)&&this.g(u.Trace,o([m,...y],!0))}debug(m,...y){this.f(u.Debug)&&this.g(u.Debug,o([m,...y]))}info(m,...y){this.f(u.Info)&&this.g(u.Info,o([m,...y]))}warn(m,...y){this.f(u.Warning)&&this.g(u.Warning,o([m,...y]))}error(m,...y){if(this.f(u.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.g(u.Error,o(P))}else this.g(u.Error,o([m,...y]))}flush(){}}e.$Ej=n;class s extends i{constructor(m=e.$Bj){super(),this.setLevel(m),this.g=!w.$c}trace(m,...y){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...y):console.log(`[main ${S()}]`,m,...y))}debug(m,...y){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...y):console.log(`[main ${S()}]`,m,...y))}info(m,...y){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...y):console.log(`[main ${S()}]`,m,...y))}warn(m,...y){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,m,...y):console.warn(`[main ${S()}]`,m,...y))}error(m,...y){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,m,...y):console.error(`[main ${S()}]`,m,...y))}flush(){}}e.$Fj=s;class a extends i{constructor(m=e.$Bj,y=!0){super(),this.g=y,this.setLevel(m)}trace(m,...y){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...y):console.log(m,...y))}debug(m,...y){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...y):console.log(m,...y))}info(m,...y){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...y):console.log(m,...y))}warn(m,...y){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...y):console.log(m,...y))}error(m,...y){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...y):console.error(m,...y))}flush(){}}e.$Gj=a;class t extends i{constructor(m,y=e.$Bj){super(),this.g=m,this.setLevel(y)}trace(m,...y){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(m),...y])}debug(m,...y){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(m),...y])}info(m,...y){this.f(u.Info)&&this.g.log(u.Info,[this.h(m),...y])}warn(m,...y){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(m),...y])}error(m,...y){this.f(u.Error)&&this.g.log(u.Error,[this.h(m),...y])}h(m){return typeof m=="string"?m:(0,D.$2i)(m,this.f(u.Trace))}flush(){}}e.$Hj=t;class d extends i{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const y of this.g)y.setLevel(m);super.setLevel(m)}trace(m,...y){for(const P of this.g)P.trace(m,...y)}debug(m,...y){for(const P of this.g)P.debug(m,...y)}info(m,...y){for(const P of this.g)P.info(m,...y)}warn(m,...y){for(const P of this.g)P.warn(m,...y)}error(m,...y){for(const P of this.g)P.error(m,...y)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose();super.dispose()}}e.$Ij=d;class l extends R.$Tc{constructor(m,y,P){if(super(),this.h=m,this.j=y,this.b=new L.$Ac,this.c=this.B(new O.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$5d),this.onDidChangeVisibility=this.g.event,P)for(const j of P)this.b.set(j.resource,{logger:void 0,info:j})}m(m){return(0,k.$Sf)(m)?[...this.b.values()].find(y=>y.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,y){const P=this.n(m),j=(0,k.$Sf)(m)?m:y?.id??(0,f.$5i)(P.toString()).toString(16);let U=this.b.get(P)?.logger;const z=y?.logLevel==="always"?u.Trace:y?.logLevel;U||(U=this.s(P,z??this.getLogLevel(P)??this.h,{...y,id:j}));const N={logger:U,info:{resource:P,id:j,logLevel:z,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(N.info),this.b.set(P,N),U}n(m){return(0,k.$Sf)(m)?(0,$.$Rg)(this.j,`${m}.log`):m}setLogLevel(m,y){if(M.URI.isUri(m)){const P=m,j=y,U=this.b.get(P);U&&j!==U.info.logLevel&&(U.info.logLevel=j===this.h?void 0:j,U.logger?.setLevel(j),this.b.set(U.info.resource,U),this.f.fire([P,j]))}else{this.h=m;for(const[P,j]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,y){const P=this.m(m);P&&y!==!P.info.hidden&&(P.info.hidden=!y,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,y]))}getLogLevel(m){let y;return m&&(y=this.b.get(m)?.info.logLevel),y??this.h}registerLogger(m){const y=this.b.get(m.resource);y?y.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const y=this.b.get(m);y&&(y.logger&&y.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=l;class r{constructor(){this.onDidChangeLogLevel=new O.$5d().event}setLevel(m){}getLevel(){return u.Info}trace(m,...y){}debug(m,...y){}info(m,...y){}warn(m,...y){}error(m,...y){}critical(m,...y){}dispose(){}flush(){}}e.$Kj=r;class c extends r{}e.$Lj=c;function h(v){if(v.verbose)return u.Trace;if(typeof v.logLevel=="string"){const m=C(v.logLevel.toLowerCase());if(m!==void 0)return m}return e.$Bj}e.$Mj=h;function g(v){switch(v){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$Nj=g;function C(v){switch(v){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$Oj=C,e.$Pj=new I.$vj("logLevel",g(u.Info))}),define(Se[250],De([1,0,19,8,14,4,3,17,85,13]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;class M extends L.$Tc{constructor(p,S){super(),this.a=p,this.b=S,this.c=this.B(new R.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$ch(0)),this.w=[],this.y=this.B(new O.$ch(0))}watch(p,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(p,S):this.z(p,S)}n(p,S){const E={path:this.H(p),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},u=(0,D.$Ub)(this.j,E);return this.r(),(0,L.$Rc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,f.$1)(p))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,$.$tq)(S)),S=>this.G(S),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const S of this.j)(0,$.$pq)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const S of this.j)(0,$.$pq)(S)&&p.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,S){const E={path:this.H(p),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},u=(0,D.$Ub)(this.w,E);return this.C(),(0,L.$Rc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,f.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,$.$tq)(p)),p=>this.G(p),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,w.$hc)(p.fsPath)}}e.$xq=M}),define(Se[251],De([1,0,57,389,8,28,21,4,34,3,17,9,23,100,31,206,32,244,250,41,248,247]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(d){console.error(`Error enabling graceful-fs: ${(0,n.$2i)(d)}`)}})();class t extends i.$xq{constructor(l,r){super(l,r),this.onDidChangeCapabilities=w.Event.None,this.N=new R.$Ac(c=>p.$Ig.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$e&&(this.J|=1024)),this.J}async stat(l){try{const{stat:r,symbolicLink:c}=await E.SymlinkSupport.stat(this.H(l));return{type:this.M(r,c),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:b.FilePermission.Locked}}catch(r){throw this.fb(r)}}async L(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const r=await E.Promises.readdir(this.H(l),{withFileTypes:!0}),c=[];return await Promise.all(r.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,p.$Rg)(l,h.name))).type:g=this.M(h),c.push([h.name,g])}catch(g){this.a.trace(g)}})),c}catch(r){throw this.fb(r)}}M(l,r){let c;return r?.dangling?c=b.FileType.Unknown:l.isFile()?c=b.FileType.File:l.isDirectory()?c=b.FileType.Directory:c=b.FileType.Unknown,r&&(c|=b.FileType.SymbolicLink),c}async O(l){const r=this.H(l);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let c;for(;c=this.N.get(l);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await c.wait();const h=new f.$dh;return this.N.set(l,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,k.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.N.get(l)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.N.delete(l)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),h.open()})}async readFile(l,r){let c;try{r?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(l)})`),c=await this.O(l));const h=this.H(l);return await E.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{c?.dispose()}}P(l){t.I&&this.a.trace(l)}readFileStream(l,r,c){const h=(0,S.$ge)(g=>L.$se.concat(g.map(C=>L.$se.wrap(C))).buffer);return(0,o.$nq)(this,l,h,g=>g.buffer,{...r,bufferSize:256*1024},c),h}async writeFile(l,r,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(l)?this.R(l,(0,p.$Rg)((0,p.$Qg)(l),`${(0,p.$Og)(l)}${c.atomic.postfix}`),r,c):this.S(l,r,c)}async Q(l){try{const r=this.H(l),{symbolicLink:c}=await E.SymlinkSupport.stat(r);if(c)return!1}catch{}return!0}async R(l,r,c,h){const g=new k.$Sc;try{g.add(await this.O(l)),g.add(await this.O(r)),await this.S(r,c,h,!0);try{await this.rename(r,l,{overwrite:!0})}catch(C){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{g.dispose()}}async S(l,r,c,h){let g;try{const C=this.H(l);if(!c.create||!c.overwrite){if(await E.Promises.exists(C)){if(!c.overwrite)throw(0,b.$Ok)((0,u.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,b.$Ok)((0,u.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(l,{create:!0,unlock:c.unlock},h),await this.write(g,0,r,0,r.byteLength)}catch(C){throw await this.gb(l,C)}finally{typeof g=="number"&&await this.close(g)}}static configureFlushOnWrite(l){t.Y=l}async open(l,r,c){const h=this.H(l);let g;(0,b.$Ck)(r)&&!c&&(g=await this.O(l));let C;try{if((0,b.$Ck)(r)&&r.unlock)try{const{stat:m}=await E.SymlinkSupport.stat(h);m.mode&128||await E.Promises.chmod(h,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let v;if((0,b.$Ck)(r)){if(I.$c)try{await E.Promises.truncate(h,0),v="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}v||(v="w")}else v="r";C=await E.Promises.open(h,v)}catch(v){throw g?.dispose(),(0,b.$Ck)(r)?await this.gb(l,v):this.fb(v)}if(this.U.set(C,0),(0,b.$Ck)(r)&&this.X.set(C,l),g){const v=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${h})`),this.W.set(C,g),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${h})`),v.dispose())}return C}async close(l){const r=this.W.get(l);try{if(this.U.delete(l),this.X.delete(l)&&t.Y)try{await E.Promises.fdatasync(l)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await E.Promises.close(l)}catch(c){throw this.fb(c)}finally{r&&(this.W.get(l)===r&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.W.delete(l)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),r.dispose())}}async read(l,r,c,h,g){const C=this.Z(l,r);let v=null;try{v=(await E.Promises.read(l,c,h,g,C)).bytesRead}catch(m){throw this.fb(m)}finally{this.$(l,C,v)}return v}Z(l,r){return r===this.U.get(l)?null:r}$(l,r,c){const h=this.U.get(l);typeof h=="number"&&(typeof r=="number"||(typeof c=="number"?this.U.set(l,h+c):this.U.delete(l)))}async write(l,r,c,h,g){return(0,f.$yh)(()=>this.ab(l,r,c,h,g),100,3)}async ab(l,r,c,h,g){const C=this.Z(l,r);let v=null;try{v=(await E.Promises.write(l,c,h,g,C)).bytesWritten}catch(m){throw await this.gb(this.X.get(l),m)}finally{this.$(l,C,v)}return v}async mkdir(l){try{await E.Promises.mkdir(this.H(l))}catch(r){throw this.fb(r)}}async delete(l,r){try{const c=this.H(l);if(r.recursive){let h;r?.atomic!==!1&&r.atomic.postfix&&(h=(0,M.$jc)((0,M.$mc)(c),`${(0,M.$nc)(c)}${r.atomic.postfix}`)),await E.Promises.rm(c,E.RimRafMode.MOVE,h)}else try{await E.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let g=!1;try{const{stat:C,symbolicLink:v}=await E.SymlinkSupport.stat(c);g=C.isDirectory()&&!v}catch{}if(g)await E.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.fb(c)}}async rename(l,r,c){const h=this.H(l),g=this.H(r);if(h!==g)try{await this.bb(l,r,"move",c.overwrite),await E.Promises.rename(h,g)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,u.localize)(2,null,(0,M.$nc)(h),(0,M.$nc)((0,M.$mc)(g)),C.toString()))),this.fb(C)}}async copy(l,r,c){const h=this.H(l),g=this.H(r);if(h!==g)try{await this.bb(l,r,"copy",c.overwrite),await E.Promises.copy(h,g,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,u.localize)(3,null,(0,M.$nc)(h),(0,M.$nc)((0,M.$mc)(g)),C.toString()))),this.fb(C)}}async bb(l,r,c,h){const g=this.H(l),C=this.H(r);let v=!1;if(!!(this.capabilities&1024)||(v=(0,$.$eg)(g,C,!0)),v){if(c==="copy")throw(0,b.$Ok)((0,u.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const y=await this.L(l);if(!y)throw(0,b.$Ok)((0,u.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(r);if(P){if(!h)throw(0,b.$Ok)((0,u.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);y.type&b.FileType.File&&P.type&b.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,r){return this.cb(l,r,!1)}async cb(l,r,c){const h=this.H(l),g=this.H(r),C=!!(this.capabilities&1024);if((0,$.$eg)(h,g,!C))return;const v=new k.$Sc;try{v.add(await this.O(l)),v.add(await this.O(r)),c&&await E.Promises.mkdir((0,M.$mc)(g),{recursive:!0}),await E.Promises.copyFile(h,g)}catch(m){if(m.code==="ENOENT"&&!c)return this.cb(l,r,!0);throw this.fb(m)}finally{v.dispose()}}t(l,r,c){return new s.$Eq(h=>l(h),h=>r(h),c)}F(l,r,c){return new a.$Mq(h=>l(h),h=>r(h),c)}fb(l){if(l instanceof b.$Nk)return l;let r=l,c;switch(l.code){case"ENOENT":c=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=b.FileSystemProviderErrorCode.Unknown;break;default:c=b.FileSystemProviderErrorCode.Unknown}return(0,b.$Ok)(r,c)}async gb(l,r){let c=this.fb(r);if(l&&c.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await E.SymlinkSupport.stat(this.H(l));h.mode&128||(c=(0,b.$Ok)(r,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$Nq=t,t.I=!1,t.Y=!0}),define(Se[252],De([1,0,3,13]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=void 0;class f extends D.$Tc{constructor(L,w=[]){super(),this.a=new O.$Ij([L,...w]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...w){this.a.trace(L,...w)}debug(L,...w){this.a.debug(L,...w)}info(L,...w){this.a.info(L,...w)}warn(L,...w){this.a.warn(L,...w)}error(L,...w){this.a.error(L,...w)}flush(){this.a.flush()}}e.$DP=f}),define(Se[253],De([1,0,32,13]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=void 0;var f;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(f||(f={}));async function R(k,M,I,p,S){try{const E=await new Promise((b,o)=>{re(["@vscode/spdlog"],b,o)});E.setFlushOn(f.Trace);const u=await E.createAsyncRotatingLogger(k,M,I,p);return S?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(E){console.error(E)}return null}function L(k,M,I){switch(M){case O.LogLevel.Trace:k.trace(I);break;case O.LogLevel.Debug:k.debug(I);break;case O.LogLevel.Info:k.info(I);break;case O.LogLevel.Warning:k.warn(I);break;case O.LogLevel.Error:k.error(I);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function w(k,M){switch(M){case O.LogLevel.Trace:k.setLevel(f.Trace);break;case O.LogLevel.Debug:k.setLevel(f.Debug);break;case O.LogLevel.Info:k.setLevel(f.Info);break;case O.LogLevel.Warning:k.setLevel(f.Warning);break;case O.LogLevel.Error:k.setLevel(f.Error);break;case O.LogLevel.Off:k.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${M}`)}}class $ extends O.$Ej{constructor(M,I,p,S,E){super(),this.m=[],this.setLevel(E),this.n=this.s(M,I,p,S),this.B(this.onDidChangeLogLevel(u=>{this.r&&w(this.r,u)}))}async s(M,I,p,S){const E=p?6:1,u=30/E*D.$0k.MB,b=await R(M,I,u,E,S);if(b){this.r=b,w(this.r,this.getLevel());for(const{level:o,message:i}of this.m)L(this.r,o,i);this.m=[]}}g(M,I){this.r?L(this.r,M,I):this.getLevel()<=M&&this.m.push({level:M,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$sP=$}),define(Se[136],De([1,0,40,207,5]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function k(E,u){return u-E}$.compare=k;const M=Object.create(null);M[$.Error]=(0,O.localize)(0,null),M[$.Warning]=(0,O.localize)(1,null),M[$.Info]=(0,O.localize)(2,null);function I(E){return M[E]||""}$.toString=I;function p(E){switch(E){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=p;function S(E){switch(E){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=S}(L||(e.MarkerSeverity=L={}));var w;(function($){const k="";function M(p){return I(p,!0)}$.makeKey=M;function I(p,S){const E=[k];return p.source?E.push(p.source.replace("\xA6","\\\xA6")):E.push(k),p.code?typeof p.code=="string"?E.push(p.code.replace("\xA6","\\\xA6")):E.push(p.code.value.replace("\xA6","\\\xA6")):E.push(k),p.severity!==void 0&&p.severity!==null?E.push(L.toString(p.severity)):E.push(k),p.message&&S?E.push(p.message.replace("\xA6","\\\xA6")):E.push(k),p.startLineNumber!==void 0&&p.startLineNumber!==null?E.push(p.startLineNumber.toString()):E.push(k),p.startColumn!==void 0&&p.startColumn!==null?E.push(p.startColumn.toString()):E.push(k),p.endLineNumber!==void 0&&p.endLineNumber!==null?E.push(p.endLineNumber.toString()):E.push(k),p.endColumn!==void 0&&p.endColumn!==null?E.push(p.endColumn.toString()):E.push(k),E.push(k),E.join("\xA6")}$.makeKeyOptionalMessage=I})(w||(e.IMarkerData=w={})),e.$Mt=(0,f.$ei)("markerService")}),define(Se[254],De([1,0,4,40,5]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.NotificationsFilter=e.$Dv=e.NeverShowAgainScope=e.NotificationPriority=e.$Cv=e.Severity=void 0,e.Severity=O.default,e.$Cv=(0,f.$ei)("notificationService");var R;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function w(I){if(I){const p=I;return typeof p.id=="string"&&typeof p.label=="string"}return!1}e.$Dv=w;var $;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new M,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$Ev=k;class M{infinite(){}done(){}total(p){}worked(p){}}e.$Fv=M}),define(Se[255],De([1,0,49]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const R=f.context.configuration();if(R)O=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:R.version})}Object.assign(O,{extensionsGallery:D.env.EXTENSIONS_GALLERY?JSON.parse(D.env.EXTENSIONS_GALLERY):O.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else O={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.87.0",sha256:"155ba715cc1045835951e70a663010c8f91d773d90a3ec504a041fd53b5658b0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.87.0",commit:"e5d145fdf32e82be2a0f8de9a3b05f65b13052b6",date:"2024-02-29T21:33:58.462Z"},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(Se[137],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,D.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"});var He=this&&this.__param||function(re,e){return function(D,O){e(D,O,re)}};define(Se[107],De([1,0,8,22,3,5]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.ProgressLocation=e.$Gv=void 0,e.$Gv=(0,R.$ei)("progressService");var L;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$Hv=Object.freeze({total(){},worked(){},done(){}});class w{get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$Iv=w,w.None=Object.freeze({report(){}});class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const S=this.d;this.d=()=>{S?.(),p()}}):Promise.resolve()}}e.$Jv=$;let k=class extends f.$Tc{constructor(p,S){super(),this.a=new D.$Bh,S.withProgress(p,E=>(this.b=E,this.c&&E.report(this.c),this.a.p)),this.B((0,f.$Rc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$Kv=k,e.$Kv=k=Je([He(1,e.$Gv)],k);class M extends f.$Tc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new f.$Sc)}start(p){this.stop();const S=++this.a,E=new O.$ce;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,f.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Rc)(()=>E.cancel())),this.b.add((0,f.$Rc)(()=>this.c?this.c.done():void 0)),{id:S,token:E.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$Lv=M,e.$Mv=(0,R.$ei)("editorProgressService")}),define(Se[37],De([1,0,61,18]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0;class f{constructor(){this.a=new Map}add(L,w){D.ok(O.$Sf(L)),D.ok(O.$Uf(w)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,w)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Un=new f}),define(Se[108],De([1,0,4,37]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=void 0,e.$Vn={JSONContribution:"base.contributions.json"};function f(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class R{constructor(){this.b=new D.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[f($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;O.$Un.add(e.$Vn.JSONContribution,L)}),define(Se[86],De([1,0,19,4,18,197,52,108,37]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ConfigurationScope=e.$Zn=e.EditPresentationTypes=void 0;var k;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$Zn={Configuration:"base.contributions.configuration"};var M;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n="vscode://schemas/settings/resourceLanguage",e.$8n="vscode://schemas/settings/configurationDefaults";const I=$.$Un.as(w.$Vn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$5d,this.onDidSchemaChange=this.i.event,this.j=new O.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$7n,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const l=new Set;this.n(t,d,l),I.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:l})}deregisterConfigurations(t){const d=new Set;this.o(t,d),I.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const l=new Set;this.o(d,l),this.n(t,!1,l),I.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:l})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const l=[];for(const{overrides:r,source:c}of t)for(const h in r)if(d.add(h),e.$0n.test(h)){const g=this.a.get(h),C=g?.valuesSources??new Map;if(c)for(const P of Object.keys(r[h]))C.set(P,c);const v={...g?.value||{},...r[h]};this.a.set(h,{source:c,value:v,valuesSources:C});const m=(0,L.$Ui)(h),y={type:"object",default:v,description:R.localize(1,null,m),$ref:e.$7n,defaultDefaultValue:v,source:f.$Sf(c)?void 0:c,defaultValueSource:c};l.push(...u(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:r[h],source:c});const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}this.m(l)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:l,source:r}of t)for(const c in l){const h=this.a.get(c),g=f.$Sf(r)?r:r?.id,C=f.$Sf(h?.source)?h?.source:h?.source?.id;if(g===C)if(d.add(c),this.a.delete(c),e.$0n.test(c))delete this.d[c],delete this.b.properties[c];else{const v=this.d[c];v&&(this.w(c,v),this.r(c,v))}}this.u()}deltaConfiguration(t){let d=!1;const l=new Set;t.removedDefaults&&(this.l(t.removedDefaults,l),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,l),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,l),t.addedConfigurations&&this.n(t.addedConfigurations,!1,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,l){t.forEach(r=>{this.p(r,d,r.extensionInfo,r.restrictedProperties,void 0,l),this.c.push(r),this.q(r)})}o(t,d){const l=r=>{if(r.properties)for(const c in r.properties){d.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,r.properties[c])}r.allOf?.forEach(c=>l(c))};for(const r of t){l(r);const c=this.c.indexOf(r);c!==-1&&this.c.splice(c,1)}}p(t,d=!0,l,r,c=3,h){c=f.$2f(t.scope)?c:t.scope;const g=t.properties;if(g)for(const v in g){const m=g[v];if(d&&n(v,m)){delete g[v];continue}if(m.source=l,m.defaultDefaultValue=g[v].default,this.w(v,m),e.$0n.test(v)?m.scope=void 0:(m.scope=f.$2f(m.scope)?c:m.scope,m.restricted=f.$2f(m.restricted)?!!r?.includes(v):m.restricted),g[v].hasOwnProperty("included")&&!g[v].included){this.f[v]=g[v],delete g[v];continue}else this.d[v]=g[v],g[v].policy?.name&&this.e.set(g[v].policy.name,v);!g[v].deprecationMessage&&g[v].markdownDeprecationMessage&&(g[v].deprecationMessage=g[v].markdownDeprecationMessage),h.add(v)}const C=t.allOf;if(C)for(const v of C)this.p(v,d,l,r,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=l=>{const r=l.properties;if(r)for(const h in r)this.r(h,r[h]);l.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$1n.properties[t]=d,d.scope){case 1:e.$2n.properties[t]=d;break;case 2:e.$3n.properties[t]=d;break;case 6:e.$4n.properties[t]=d;break;case 3:e.$5n.properties[t]=d;break;case 4:e.$6n.properties[t]=d;break;case 5:e.$6n.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$1n.properties[t],d.scope){case 1:delete e.$2n.properties[t];break;case 2:delete e.$3n.properties[t];break;case 6:delete e.$4n.properties[t];break;case 3:delete e.$5n.properties[t];break;case 4:case 5:delete e.$6n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,l={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$7n};this.w(d,l),e.$1n.properties[d]=l,e.$2n.properties[d]=l,e.$3n.properties[d]=l,e.$4n.properties[d]=l,e.$5n.properties[d]=l,e.$6n.properties[d]=l}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$7n};e.$1n.patternProperties[e.$9n]=t,e.$2n.patternProperties[e.$9n]=t,e.$3n.patternProperties[e.$9n]=t,e.$4n.patternProperties[e.$9n]=t,e.$5n.patternProperties[e.$9n]=t,e.$6n.patternProperties[e.$9n]=t,this.i.fire()}w(t,d){const l=this.a.get(t);let r=l?.value,c=l?.source;f.$Zf(r)&&(r=d.defaultDefaultValue,c=void 0),f.$Zf(r)&&(r=o(d.type)),d.default=r,d.defaultValueSource=c}}const S="\\[([^\\]]+)\\]",E=new RegExp(S,"g");e.$9n=`^(${S})+$`,e.$0n=new RegExp(e.$9n);function u(a){const t=[];if(e.$0n.test(a)){let d=E.exec(a);for(;d?.length;){const l=d[1].trim();l&&t.push(l),d=E.exec(a)}}return(0,D.$Mb)(t)}e.$$n=u;function b(a){return a.reduce((t,d)=>`${t}[${d}]`,"")}e.$_n=b;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ao=o;const i=new p;$.$Un.add(e.$Zn.Configuration,i);function n(a,t){return a.trim()?e.$0n.test(a)?R.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$bo=n;function s(){const a=[],t=i.getConfigurationProperties();for(const d of Object.keys(t))a.push([d,t[d].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$co=s}),define(Se[256],De([1,0,19,4,161,3,28,24,18,2,52,86,37]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function S(d){return Object.isFrozen(d)?d:w.$Jn(d)}class E{constructor(l={},r=[],c=[],h){this.b=l,this.c=r,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const l=this.raw.map(r=>{if(r instanceof E)return r;const c=new u("");return c.parseRaw(r),c.configurationModel});this.f=l.reduce((r,c)=>c===r?c:r.merge(c),l[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,M.$Si)(this.contents,l):this.contents}inspect(l,r){const c=this;return{get value(){return S(c.rawConfiguration.getValue(l))},get override(){return r?S(c.rawConfiguration.getOverrideValue(l,r)):void 0},get merged(){return S(r?c.rawConfiguration.override(r).getValue(l):c.rawConfiguration.getValue(l))},get overrides(){const h=[];for(const{contents:g,identifiers:C,keys:v}of c.rawConfiguration.overrides){const m=new E(g,v).getValue(l);m!==void 0&&h.push({identifiers:C,value:m})}return h.length?S(h):void 0}}}getOverrideValue(l,r){const c=this.i(r);return c?l?(0,M.$Si)(c,l):c:void 0}getKeysForOverrideIdentifier(l){const r=[];for(const c of this.overrides)c.identifiers.includes(l)&&r.push(...c.keys);return D.$Mb(r)}getAllOverrideIdentifiers(){const l=[];for(const r of this.overrides)l.push(...r.identifiers);return D.$Mb(l)}override(l){let r=this.a.get(l);return r||(r=this.g(l),this.a.set(l,r)),r}merge(...l){const r=w.$In(this.contents),c=w.$In(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const C of l)if(g.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(r,C.contents);for(const v of C.overrides){const[m]=c.filter(y=>D.$ub(y.identifiers,v.identifiers));m?(this.h(m.contents,v.contents),m.keys.push(...v.keys),m.keys=D.$Mb(m.keys)):c.push(w.$In(v))}for(const v of C.keys)h.indexOf(v)===-1&&h.push(v)}return new E(r,h,c,g.every(C=>C instanceof E)?void 0:g)}g(l){const r=this.i(l);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const c={};for(const h of D.$Mb([...Object.keys(this.contents),...Object.keys(r)])){let g=this.contents[h];const C=r[h];C&&(typeof g=="object"&&typeof C=="object"?(g=w.$In(g),this.h(g,C)):g=C),c[h]=g}return new E(c,this.keys,this.overrides)}h(l,r){for(const c of Object.keys(r)){if(c in l&&$.$Uf(l[c])&&$.$Uf(r[c])){this.h(l[c],r[c]);continue}l[c]=w.$In(r[c])}}i(l){let r=null,c=null;const h=g=>{g&&(c?this.h(c,g):c=w.$In(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===l?r=g.contents:g.identifiers.includes(l)&&h(g.contents);return h(r),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,r){this.j(l,r,!0)}setValue(l,r){this.j(l,r,!1)}removeValue(l){const r=this.keys.indexOf(l);r!==-1&&(this.keys.splice(r,1),(0,M.$Ri)(this.contents,l),I.$0n.test(l)&&this.overrides.splice(this.overrides.findIndex(c=>D.$ub(c.identifiers,(0,I.$$n)(l))),1))}j(l,r,c){(0,M.$Qi)(this.contents,l,r,h=>console.error(h)),c=c||this.keys.indexOf(l)===-1,c&&this.keys.push(l),I.$0n.test(l)&&this.overrides.push({identifiers:(0,I.$$n)(l),keys:Object.keys(this.contents[l]),contents:(0,M.$Pi)(this.contents[l],h=>console.error(h))})}}e.$do=E;class u{constructor(l){this.f=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,r){if(!$.$2f(l)){const c=this.g(l);this.parseRaw(c,r)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,r){this.a=l;const{contents:c,keys:h,overrides:g,restricted:C,hasExcludedProperties:v}=this.h(l,r);this.b=new E(c,h,g,v?[l]:void 0),this.c=C||[]}g(l){let r={},c=null,h=[];const g=[],C=[];function v(y){Array.isArray(h)?h.push(y):c!==null&&(h[c]=y)}const m={onObjectBegin:()=>{const y={};v(y),g.push(h),h=y,c=null},onObjectProperty:y=>{c=y},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const y=[];v(y),g.push(h),h=y,c=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:v,onError:(y,P,j)=>{C.push({error:y,offset:P,length:j})}};if(l)try{f.$wn(l,m),r=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return r}h(l,r){const c=p.$Un.as(I.$Zn.Configuration).getConfigurationProperties(),h=this.i(l,c,!0,r);l=h.raw;const g=(0,M.$Pi)(l,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),C=Object.keys(l),v=this.j(l,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:g,keys:C,overrides:v,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(l,r,c,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:g};const C={},v=[];for(const m in l)if(I.$0n.test(m)&&c){const y=this.i(l[m],r,!1,h);C[m]=y.raw,g=g||y.hasExcludedProperties,v.push(...y.restricted)}else{const y=r[m],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&v.push(m),!h.exclude?.includes(m)&&(h.include?.includes(m)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&y?.restricted))?C[m]=l[m]:g=!0}return{raw:C,restricted:v,hasExcludedProperties:g}}j(l,r){const c=[];for(const h of Object.keys(l))if(I.$0n.test(h)){const g={};for(const C in l[h])g[C]=l[h][C];c.push({identifiers:(0,I.$$n)(h),keys:Object.keys(g),contents:(0,M.$Pi)(g,r)})}return c}}e.$eo=u;class b extends R.$Tc{constructor(l,r,c,h){super(),this.c=l,this.f=r,this.g=h,this.b=this.B(new O.$5d),this.onDidChange=this.b.event,this.a=new u(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&c.isEqual(g.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fo=b;class o{constructor(l,r,c,h,g,C,v,m,y,P,j,U,z){this.a=l,this.b=r,this.c=c,this.overrideIdentifiers=h,this.d=g,this.f=C,this.g=v,this.h=m,this.i=y,this.j=P,this.k=j,this.l=U,this.m=z}get value(){return S(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,r,c,h,g=new E,C=new E,v=new L.$Ac,m=new E,y=new L.$Ac){this.c=l,this.d=r,this.f=c,this.g=h,this.h=g,this.i=C,this.j=v,this.l=m,this.m=y,this.a=null,this.b=new L.$Ac,this.n=null}getValue(l,r,c){return this.p(l,r,c).getValue(l)}updateValue(l,r,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new E,this.m.set(c.resource,h))):h=this.l,r===void 0?h.removeValue(l):h.setValue(l,r),c.resource||(this.a=null)}inspect(l,r,c){const h=this.p(l,r,c),g=this.t(r.resource,c),C=r.resource?this.m.get(r.resource)||this.l:this.l,v=new Set;for(const m of h.overrides)for(const y of m.identifiers)h.getOverrideValue(l,y)!==void 0&&v.add(y);return new o(l,r,h.getValue(l),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,g||void 0,C)}keys(l){const r=this.t(void 0,l);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(l){this.c=l,this.a=null,this.b.clear()}updatePolicyConfiguration(l){this.d=l}updateApplicationConfiguration(l){this.f=l,this.a=null,this.b.clear()}updateLocalUserConfiguration(l){this.g=l,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(l){this.h=l,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(l){this.i=l,this.a=null,this.b.clear()}updateFolderConfiguration(l,r){this.j.set(l,r),this.b.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.b.delete(l)}compareAndUpdateDefaultConfiguration(l,r){const c=[];if(!r){const{added:h,updated:g,removed:C}=a(this.c,l);r=[...h,...g,...C]}for(const h of r)for(const g of(0,I.$$n)(h)){const C=this.c.getKeysForOverrideIdentifier(g),v=l.getKeysForOverrideIdentifier(g),m=[...v.filter(y=>C.indexOf(y)===-1),...C.filter(y=>v.indexOf(y)===-1),...C.filter(y=>!w.$Mn(this.c.override(g).getValue(y),l.override(g).getValue(y)))];c.push([g,m])}return this.updateDefaultConfiguration(l),{keys:r,overrides:c}}compareAndUpdatePolicyConfiguration(l){const{added:r,updated:c,removed:h}=a(this.d,l),g=[...r,...c,...h];return g.length&&this.updatePolicyConfiguration(l),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:r,updated:c,removed:h,overrides:g}=a(this.applicationConfiguration,l),C=[...r,...c,...h];return C.length&&this.updateApplicationConfiguration(l),{keys:C,overrides:g}}compareAndUpdateLocalUserConfiguration(l){const{added:r,updated:c,removed:h,overrides:g}=a(this.localUserConfiguration,l),C=[...r,...c,...h];return C.length&&this.updateLocalUserConfiguration(l),{keys:C,overrides:g}}compareAndUpdateRemoteUserConfiguration(l){const{added:r,updated:c,removed:h,overrides:g}=a(this.remoteUserConfiguration,l),C=[...r,...c,...h];return C.length&&this.updateRemoteUserConfiguration(l),{keys:C,overrides:g}}compareAndUpdateWorkspaceConfiguration(l){const{added:r,updated:c,removed:h,overrides:g}=a(this.workspaceConfiguration,l),C=[...r,...c,...h];return C.length&&this.updateWorkspaceConfiguration(l),{keys:C,overrides:g}}compareAndUpdateFolderConfiguration(l,r){const c=this.folderConfigurations.get(l),{added:h,updated:g,removed:C,overrides:v}=a(c,r),m=[...h,...g,...C];return(m.length||!c)&&this.updateFolderConfiguration(l,r),{keys:m,overrides:v}}compareAndDeleteFolderConfiguration(l){const r=this.folderConfigurations.get(l);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:c,updated:h,removed:g,overrides:C}=a(r,void 0);return{keys:[...c,...h,...g],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(l,r,c){let h=this.q(r,c);return r.overrideIdentifier&&(h=h.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(l)!==void 0&&(h=h.merge(this.d)),h}q({resource:l},r){let c=this.r();if(r&&l){const h=r.getFolder(l);h&&(c=this.s(h.uri)||c);const g=this.m.get(l);g&&(c=c.merge(g))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(l){let r=this.b.get(l);if(!r){const c=this.r(),h=this.j.get(l);h?(r=c.merge(h),this.b.set(l,r)):r=c}return r}t(l,r){if(r&&l){const c=r.getFolder(l);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((l,r)=>{const{contents:c,overrides:h,keys:g}=this.j.get(r);return l.push([r,{contents:c,overrides:h,keys:g}]),l},[])}}allKeys(){const l=new Set;return this.c.keys.forEach(r=>l.add(r)),this.userConfiguration.keys.forEach(r=>l.add(r)),this.i.keys.forEach(r=>l.add(r)),this.j.forEach(r=>r.keys.forEach(c=>l.add(c))),[...l.values()]}u(){const l=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>l.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>l.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>l.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(c=>l.add(c))),[...l.values()]}v(l){const r=new Set;return this.c.getKeysForOverrideIdentifier(l).forEach(c=>r.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(c=>r.add(c)),this.i.getKeysForOverrideIdentifier(l).forEach(c=>r.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(l).forEach(h=>r.add(h))),[...r.values()]}static parse(l){const r=this.w(l.defaults),c=this.w(l.policy),h=this.w(l.application),g=this.w(l.user),C=this.w(l.workspace),v=l.folders.reduce((m,y)=>(m.set(k.URI.revive(y[0]),this.w(y[1])),m),new L.$Ac);return new i(r,c,h,g,new E,C,v,new E,new L.$Ac)}static w(l){return new E(l.contents,l.keys,l.overrides)}}e.$go=i;function n(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,r=new Map;for(const h of d)h.keys.forEach(g=>l.add(g)),h.overrides.forEach(([g,C])=>{const v=(0,L.$xc)(r,g,new Set);C.forEach(m=>v.add(m))});const c=[];return r.forEach((h,g)=>c.push([g,[...h.values()]])),{keys:[...l.values()],overrides:c}}e.$ho=n;class s{constructor(l,r,c,h){this.change=l,this.f=r,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const g of l.keys)this.affectedKeys.add(g);for(const[,g]of l.overrides)for(const C of g)this.affectedKeys.add(C);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(l,r){const c=this.a+l,h=this.d.indexOf(c);if(h<0)return!1;const g=h+c.length;if(g>=this.d.length)return!1;const C=this.d.charCodeAt(g);if(C!==this.b&&C!==this.c)return!1;if(r){const v=this.previousConfiguration?this.previousConfiguration.getValue(l,r,this.f?.workspace):void 0,m=this.g.getValue(l,r,this.h);return!w.$Mn(v,m)}return!0}}e.$io=s;function a(d,l){const{added:r,removed:c,updated:h}=t(l?.rawConfiguration,d?.rawConfiguration),g=[],C=d?.getAllOverrideIdentifiers()||[],v=l?.getAllOverrideIdentifiers()||[];if(l){const m=v.filter(y=>!C.includes(y));for(const y of m)g.push([y,l.getKeysForOverrideIdentifier(y)])}if(d){const m=C.filter(y=>!v.includes(y));for(const y of m)g.push([y,d.getKeysForOverrideIdentifier(y)])}if(l&&d){for(const m of C)if(v.includes(m)){const y=t({contents:d.getOverrideValue(void 0,m)||{},keys:d.getKeysForOverrideIdentifier(m)},{contents:l.getOverrideValue(void 0,m)||{},keys:l.getKeysForOverrideIdentifier(m)});g.push([m,[...y.added,...y.removed,...y.updated]])}}return{added:r,removed:c,updated:h,overrides:g}}function t(d,l){const r=d?l?d.keys.filter(g=>l.keys.indexOf(g)===-1):[...d.keys]:[],c=l?d?l.keys.filter(g=>d.keys.indexOf(g)===-1):[...l.keys]:[],h=[];if(d&&l){for(const g of l.keys)if(d.keys.indexOf(g)!==-1){const C=(0,M.$Si)(l.contents,g),v=(0,M.$Si)(d.contents,g);w.$Mn(C,v)||h.push(g)}}return{added:r,removed:c,updated:h}}}),define(Se[257],De([1,0,21,4,3,81]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ytb=e.$xtb=e.$wtb=e.$vtb=void 0;const L=(k,M,I)=>{const p=new Uint8Array(16);for(let u=0;u<16;u++)p[u]=Math.round(Math.random()*256);const S=(0,D.$Me)(D.$se.wrap(p));return[`GET ws://localhost${k}?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$vtb=L,e.$wtb=D.$se.fromString(`\r
\r
`);async function w(k,M,I,p,S){k.write(D.$se.fromString((0,e.$vtb)(M,I,p)));const E=new f.$Sc;try{return await new Promise((u,b)=>{let o;E.add(k.onData(i=>{o?o=D.$se.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$wtb);if(n===-1)return;u(k),k.pauseData();const s=o.slice(n+e.$wtb.byteLength);s.byteLength&&S.onData.fire(s)})),E.add(k.onClose(i=>b(i??new Error("socket closed")))),E.add(k.onEnd(()=>b(new Error("socket ended"))))})}catch(u){throw k.dispose(),u}finally{E.dispose()}}e.$xtb=w;class $ extends f.$Tc{constructor(M,I){super(),this.g=M,this.a=this.B(new O.$8d),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new O.$5d),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(M,I){R.SocketDiagnostics.traceSocketEvent(this,this.g,M,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ytb=$}),define(Se[64],De([1,0,14,5]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.RemoteAuthorityResolverErrorCode=e.$il=e.$hl=e.RemoteConnectionType=e.$gl=void 0,e.$gl=(0,O.$ei)("remoteAuthorityResolverService");var f;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$hl=R;class L{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$il=L;var w;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class $ extends D.$bb{static isNotAvailable(I){return I instanceof $&&I._code===w.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof $&&I._code===w.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof $&&I._code===w.NoResolverFound}static isInvalidAuthority(I){return I instanceof $&&I._code===w.InvalidAuthority}static isHandled(I){return I instanceof $&&I.isHandled}constructor(I,p=w.Unknown,S){super(I),this._message=I,this._code=p,this._detail=S,this.isHandled=p===w.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$jl=$;function k(M){const I=M.indexOf("+");return I===-1?M:M.substring(0,I)}e.$kl=k}),define(Se[65],De([1,0,16]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function O(k){return k.scheme===D.Schemas.vscodeRemote?k.authority:void 0}e.$ll=O;function f(k){if(!k)return;const M=k.indexOf("+");return M<0?k:k.substr(0,M)}e.$ml=f;function R(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.$nl=R;function L(k){const{host:M,port:I}=$(k);if(typeof I>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:M,port:I}}e.$ol=L;function w(k,M){let{host:I,port:p}=$(k);return typeof p>"u"&&(p=M),{host:I,port:p}}e.$pl=w;function $(k){const M=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const I=k.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=k.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:k,port:void 0}}}),define(Se[25],De([1,0,12,5,65]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.TargetPlatform=e.ExtensionType=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=void 0,e.$rm="extensions.user.cache",e.$sm="extensions.builtin.cache",e.$tm="undefined_publisher",e.$um=["ui","workspace","web"];function R(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$vm=R,e.$wm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(L||(e.ExtensionType=L={}));var w;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class ${constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,o){if(typeof b>"u"||b===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof b=="string"||typeof o=="string"){const i=typeof b=="string"?b:b.value,n=typeof o=="string"?o:o.value;return D.$jf(i,n)}return b._lower===o._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$xm=$;class k{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const o of b)this.add(o)}add(b){this.c.add($.toKey(b))}delete(b){return this.c.delete($.toKey(b))}has(b){return this.c.has($.toKey(b))}}e.$ym=k;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete($.toKey(b))}get(b){return this.c.get($.toKey(b))}has(b){return this.c.has($.toKey(b))}set(b,o){this.c.set($.toKey(b),o)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zm=M;function I(u){return p(u)}e.$Am=I;function p(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$Bm=p;function S(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$Cm=S;function E(u,b){if(b){const o=`onResolveRemoteAuthority:${(0,f.$ml)(b)}`;return!!u.activationEvents?.includes(o)}return!1}e.$Dm=E,e.$Em=(0,O.$ei)("IBuiltinExtensionsScannerService")}),define(Se[138],De([1,0,14,25]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(L,w){this.a.set(L,w)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const w=Object.create(null);for(const $ of L){const k=this.readActivationEvents($);k.length>0&&(w[O.$xm.toKey($.identifier)]=k)}return w}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const w=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<w.length;$++)w[$]==="onUri"&&(w[$]=`onUri:${O.$xm.toKey(L.identifier)}`);if(!L.contributes)return w;for(const $ in L.contributes){const k=this.a.get($);if(!k)continue;const M=L.contributes[$],I=Array.isArray(M)?M:[M];try{k(I,w)}catch(p){(0,D.$1)(p)}}return w}}e.$AF=f,e.$BF=new f}),define(Se[258],De([1,0,8,21,22,14,4,3,58,39,30,81,64,65]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.PersistentConnectionEventType=e.$wl=e.$vl=e.$ul=e.ConnectionType=void 0;const E=30*1e3;var u;(function(ae){ae[ae.Management=1]="Management",ae[ae.ExtensionHost=2]="ExtensionHost",ae[ae.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function b(ae){switch(ae){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(ae){const H=new f.$ce;return setTimeout(()=>H.cancel(),ae),H.token}function i(ae,H){if(ae.isCancellationRequested||H.isCancellationRequested)return f.CancellationToken.Cancelled;const fe=new f.$ce;return ae.onCancellationRequested(()=>fe.cancel()),H.onCancellationRequested(()=>fe.cancel()),fe.token}class n{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new w.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,D.$0g)(),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function s(ae,H){const fe=new n(H);return fe.registerDisposable(ae.onControlMessage(he=>{const se=JSON.parse(he.toString()),ce=Q(se);ce?fe.reject(ce):fe.resolve(se)})),fe.promise}function a(ae,H,fe,he,se,ce,le,de){const q=new n(de),_=k.$1d.create(!1);return ae.info(`Creating a socket (${le})...`),$.mark(`code/willCreateSocket/${ce}`),H.connect(fe,he,se,le).then(ge=>{q.didTimeout?($.mark(`code/didCreateSocketError/${ce}`),ae.info(`Creating a socket (${le}) finished after ${_.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):($.mark(`code/didCreateSocketOK/${ce}`),ae.info(`Creating a socket (${le}) was successful after ${_.elapsed()} ms.`),q.resolve(ge))},ge=>{$.mark(`code/didCreateSocketError/${ce}`),ae.info(`Creating a socket (${le}) returned an error after ${_.elapsed()} ms.`),ae.error(ge),q.reject(ge)}),q.promise}function t(ae,H){const fe=new n(H);return ae.then(he=>{fe.didTimeout||fe.resolve(he)},he=>{fe.didTimeout||fe.reject(he)}),fe.promise}async function d(ae,H,fe,he){const se=we(ae,H);ae.logService.trace(`${se} 1/6. invoking socketFactory.connect().`);let ce;try{ce=await a(ae.logService,ae.remoteSocketFactoryService,ae.connectTo,(0,S.$nl)(ae),`reconnectionToken=${ae.reconnectionToken}&reconnection=${ae.reconnectionProtocol?"true":"false"}`,b(H),`renderer-${b(H)}-${ae.reconnectionToken}`,he)}catch(ge){throw ae.logService.error(`${se} socketFactory.connect() failed or timed out. Error:`),ae.logService.error(ge),ge}ae.logService.trace(`${se} 2/6. socketFactory.connect() was successful.`);let le,de;ae.reconnectionProtocol?(ae.reconnectionProtocol.beginAcceptReconnection(ce,null),le=ae.reconnectionProtocol,de=!1):(le=new I.$5h({socket:ce}),de=!0),ae.logService.trace(`${se} 3/6. sending AuthRequest control message.`);const q=await t(ae.signService.createNewMessage((0,M.$Ag)()),he),_={type:"auth",auth:ae.connectionToken||"00000000000000000000",data:q.data};le.sendControl(O.$se.fromString(JSON.stringify(_)));try{const ge=await s(le,i(he,o(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(ae.logService.trace(`${se} 4/6. received SignRequest control message.`),!await t(ae.signService.validate(q,ge.signedData),he)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const Ae=await t(ae.signService.sign(ge.data),he),ye={type:"connectionType",commit:ae.commit,signedData:Ae,desiredConnectionType:H};return fe&&(ye.args=fe),ae.logService.trace(`${se} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(O.$se.fromString(JSON.stringify(ye))),{protocol:le,ownsProtocol:de}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(ae.logService.error(`${se} the handshake timed out. Error:`),ae.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(ae.logService.error(`${se} received error control message when negotiating connection. Error:`),ae.logService.error(ge)),de&&X(le),ge}}async function l(ae,H,fe,he){const se=Date.now(),ce=we(ae,H),{protocol:le,ownsProtocol:de}=await d(ae,H,fe,he),q=new n(he);return q.registerDisposable(le.onControlMessage(_=>{const ge=JSON.parse(_.toString()),me=Q(ge);me?(ae.logService.error(`${ce} received error control message when negotiating connection. Error:`),ae.logService.error(me),de&&X(le),q.reject(me)):(ae.reconnectionProtocol?.endAcceptReconnection(),ae.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${ue(se)}!`),q.resolve({protocol:le,firstMessage:ge}))})),q.promise}async function r(ae,H){const{protocol:fe}=await l(ae,1,void 0,H);return{protocol:fe}}async function c(ae,H,fe){const{protocol:he,firstMessage:se}=await l(ae,2,H,fe),ce=se&&se.debugPort;return{protocol:he,debugPort:ce}}async function h(ae,H,fe){const he=Date.now(),se=we(ae,3),{protocol:ce}=await d(ae,3,H,fe);return ae.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${ue(he)}!`),ce}async function g(ae,H,fe){const{connectTo:he,connectionToken:se}=await ae.addressProvider.getAddress();return{commit:ae.commit,quality:ae.quality,connectTo:he,connectionToken:se,reconnectionToken:H,reconnectionProtocol:fe,remoteSocketFactoryService:ae.remoteSocketFactoryService,signService:ae.signService,logService:ae.logService}}async function C(ae,H,fe){return m(ae,async he=>{const{protocol:se}=await r(he,f.CancellationToken.None);return new G(ae,H,fe,he.reconnectionToken,se)})}e.$ul=C;async function v(ae,H){return m(ae,async fe=>{const{protocol:he,debugPort:se}=await c(fe,H,f.CancellationToken.None);return new K(ae,H,fe.reconnectionToken,he,se)})}e.$vl=v;async function m(ae,H){for(let he=1;;he++)try{const se=(0,M.$Ag)(),ce=await g(ae,se,null);return await H(ce)}catch(se){if(he<5)ae.logService.error(`[remote-connection][attempt ${he}] An error occurred in initial connection! Will retry... Error:`),ae.logService.error(se);else throw ae.logService.error(`[remote-connection][attempt ${he}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ae.logService.error(se),F.triggerPermanentFailure(0,0,p.$jl.isHandled(se)),se}}async function y(ae,H,fe){const he=await g(ae,(0,M.$Ag)(),null);return await h(he,{host:H,port:fe},f.CancellationToken.None)}e.$wl=y;function P(ae){return(0,D.$4g)(H=>new Promise((fe,he)=>{const se=setTimeout(fe,ae*1e3);H.onCancellationRequested(()=>{clearTimeout(se),fe()})}))}var j;(function(ae){ae[ae.ConnectionLost=0]="ConnectionLost",ae[ae.ReconnectionWait=1]="ReconnectionWait",ae[ae.ReconnectionRunning=2]="ReconnectionRunning",ae[ae.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ae[ae.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class U{constructor(H,fe){this.reconnectionToken=H,this.millisSinceLastIncomingData=fe,this.type=0}}e.$xl=U;class z{constructor(H,fe,he,se){this.reconnectionToken=H,this.millisSinceLastIncomingData=fe,this.durationSeconds=he,this.c=se,this.type=1}skipWait(){this.c.cancel()}}e.$yl=z;class N{constructor(H,fe,he){this.reconnectionToken=H,this.millisSinceLastIncomingData=fe,this.attempt=he,this.type=2}}e.$zl=N;class A{constructor(H,fe,he){this.reconnectionToken=H,this.millisSinceLastIncomingData=fe,this.attempt=he,this.type=4}}e.$Al=A;class T{constructor(H,fe,he,se){this.reconnectionToken=H,this.millisSinceLastIncomingData=fe,this.attempt=he,this.handled=se,this.type=3}}e.$Bl=T;class F extends w.$Tc{static triggerPermanentFailure(H,fe,he){this._permanentFailure=!0,this.f=H,this.g=fe,this.h=he,this.j.forEach(se=>se.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(H=>H.y())}static debugPauseSocketWriting(){this.j.forEach(H=>H.F())}get n(){return this.c||F._permanentFailure}constructor(H,fe,he,se,ce){super(),this.t=H,this.u=fe,this.reconnectionToken=he,this.protocol=se,this.w=ce,this.m=this.B(new L.$5d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new A(this.reconnectionToken,0,0)),this.B(se.onSocketClose(le=>{const de=ee(this.t,this.reconnectionToken,!0);le?le.type===0?(this.u.logService.info(`${de} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${de} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${de} received socket close event.`),this.y()})),this.B(se.onSocketTimeout(le=>{const de=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${de} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),F.j.push(this),this.B((0,w.$Rc)(()=>{const le=F.j.indexOf(this);le>=0&&F.j.splice(le,1)})),this.n&&this.D(F.f,F.g,F.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const H=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const fe=[0,5,5,10,10,10,10,10,30];let he=-1;do{he++;const se=he<fe.length?fe[he]:fe[fe.length-1];try{if(se>0){const le=P(se);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se,le)),this.u.logService.info(`${H} waiting for ${se} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he+1)),this.u.logService.info(`${H} resolving connection...`);const ce=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${H} connecting to ${ce.connectTo}...`),await this.G(ce,o(E)),this.u.logService.info(`${H} reconnected!`),this.m.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he+1));break}catch(ce){if(ce.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),he+1,!1);break}if(he>360){this.u.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),he+1,!1);break}if(p.$jl.isTemporarilyNotAvailable(ce)){this.u.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((ce.code==="ETIMEDOUT"||ce.code==="ENETUNREACH"||ce.code==="ECONNREFUSED"||ce.code==="ECONNRESET")&&ce.syscall==="connect"){this.u.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((0,R.$4)(ce)){this.u.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if(ce instanceof p.$jl){this.u.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),he+1,p.$jl.isHandled(ce));break}this.u.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),he+1,!1);break}}while(!this.n&&!this.s)}C(H,fe,he){this.w?F.triggerPermanentFailure(H,fe,he):this.D(H,fe,he)}D(H,fe,he){this.m.fire(new T(this.reconnectionToken,H,fe,he)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Cl=F,F._permanentFailure=!1,F.f=0,F.g=0,F.h=!1,F.j=[];class G extends F{constructor(H,fe,he,se,ce){super(1,H,se,ce,!0),this.client=this.B(new I.$3h(ce,{remoteAuthority:fe,clientId:he},H.ipcLogger))}async G(H,fe){await r(H,fe)}}e.$Dl=G;class K extends F{constructor(H,fe,he,se,ce){super(2,H,he,se,!1),this.H=fe,this.debugPort=ce}async G(H,fe){await c(H,this.H,fe)}}e.$El=K;function X(ae){try{ae.acceptDisconnect();const H=ae.getSocket();ae.dispose(),H.dispose()}catch(H){(0,R.$1)(H)}}function Q(ae){if(ae&&ae.type==="error"){const H=new Error(`Connection error: ${ae.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function Z(ae,H){for(;ae.length<H;)ae+=" ";return ae}function ie(ae,H){return`[remote-connection][${Z(b(ae),13)}][${H.substr(0,5)}\u2026]`}function ee(ae,H,fe){return`${ie(ae,H)}[${fe?"reconnect":"initial"}]`}function we(ae,H){return`${ee(H,ae.reconnectionToken,!!ae.reconnectionProtocol)}[${ae.connectTo}]`}function ue(ae){return`${Date.now()-ae} ms`}}),define(Se[259],De([1,0,3,5]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql=(0,O.$ei)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(L,w){var $;return($=this.a)[L]??($[L]=[]),this.a[L].push(w),(0,D.$Rc)(()=>{const k=this.a[L]?.indexOf(w);typeof k=="number"&&k>=0&&this.a[L]?.splice(k,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,w,$,k){const M=this.b(L);if(!M)throw new Error(`No socket factory found for ${L}`);return M.connect(L,w,$,k)}}e.$rl=f}),define(Se[260],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=void 0;class D{constructor(){this.b=new Map}async createNewMessage(f){try{const R=await this.c();if(R){const L=String(D.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,R){if(!f.id)return!0;const L=this.b.get(f.id);if(!L)return!1;this.b.delete(f.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$M8b=D,D.a=1}),define(Se[109],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0,e.$sl="signService",e.$tl=(0,D.$ei)(e.$sl)}),define(Se[139],De([1,0,260]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class O extends D.$M8b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>re(["vsda"],R,L))}}e.$Gac=O}),define(Se[261],De([1,0,9,49,30]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=void 0;function R($){if(D.$o===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,k,M,I,p,S,E,u,b){const o=Object.create(null);o["common.machineId"]=S,o["common.sqmId"]=E,o.sessionID=(0,f.$Ag)()+Date.now(),o.commitHash=I,o.version=p,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$b)(D.$o),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=M,o["common.product"]=b||"desktop",u&&(o["common.msftInternal"]=u);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$f&&(o["common.snap"]="true");const s=R(k);return s&&(o["common.platformDetail"]=s),o}e.$Vo=L;function w($){const k=O.env.USERDNSDOMAIN;if(!k)return!1;const M=k.toLowerCase();return $.some(I=>M===I)}e.$Wo=w}),define(Se[262],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,D.$ei)("telemetryService"),e.$Gl=(0,D.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var O;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var f;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(Se[87],De([1,0,24,18,65,261,262]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0;class w{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$Xo=w;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Yo=$,e.$Zo=new $;class k{async publicLog(d,l,r){}async publicLogError(d,l,r){}}e.$1o=k,e.$2o="telemetry",e.$3o="extensionTelemetryLog",e.$4o={log:()=>null,flush:()=>Promise.resolve(null)};function M(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}e.$5o=M;function I(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$6o=I;function p(t){const d=t.getValue(L.$Nl),l=t.getValue(L.$Ol);if(t.getValue(L.$Pl)===!1||l===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$7o=p;function S(t){const d={},l={},r={};b(t,r);for(let c in r){c=c.length>150?c.substr(c.length-149):c;const h=r[c];typeof h=="number"?l[c]=h:typeof h=="boolean"?l[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),d[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(d[c]=h)}return{properties:d,measurements:l}}e.$8o=S;const E=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const d=(0,f.$ml)(t);return E.has(d)?d:"other"}e.$9o=u;function b(t,d,l=0,r){if(t)for(const c of Object.getOwnPropertyNames(t)){const h=t[c],g=r?r+c:c;Array.isArray(h)?d[g]=(0,D.$Nn)(h):h instanceof Date?d[g]=h.toISOString():(0,O.$Uf)(h)?l<2?b(h,d,l+1,g+"."):d[g]=(0,D.$Nn)(h):d[g]=h}}function o(t,d){const l=t.msftInternalDomains||[],r=d.getValue("telemetry.internalTesting");return(0,R.$Wo)(l)||r}e.$0o=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$$o=i;function n(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let l=t;const r=[];for(const C of d)for(;;){const v=C.exec(t);if(!v)break;r.push([v.index,C.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(l="";;){const C=h.exec(t);if(!C)break;const v=r.some(([m,y])=>C.index<y&&m<h.lastIndex);!c.test(C[0])&&!v&&(l+=t.substring(g,C.index)+"<REDACTED: user-file-path>",g=h.lastIndex)}return g<t.length&&(l+=t.substr(g)),l}function s(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of d)if(l.regex.test(t))return`<REDACTED: ${l.label}>`;return t}function a(t,d){return(0,D.$Kn)(t,l=>{if(l instanceof w||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let r=l.replaceAll("%20"," ");r=n(r,d);for(const c of d)r=r.replace(c,"");return r=s(r),r}})}e.$_o=a}),define(Se[263],De([1,0,12,135,25,9,2,14,49,87]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;function M(l,r){return l.uuid&&r.uuid?l.uuid===r.uuid:l.id===r.id?!0:(0,D.$ef)(l.id,r.id)===0}e.$ap=M;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(r){const c=r.manifest?r.manifest.version:r.version,h=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new p(r.identifier,c,h)}static parse(r){const c=I.exec(r);return c&&c[1]&&c[2]?new p({id:c[1]},c[2],c[4]||void 0):null}constructor(r,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof p?M(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$bp=p;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(l){const r=S.exec(l);return r&&r[1]?[b(r[1]),r[2]]:[b(l),void 0]}e.$cp=E;function u(l,r){return`${l}.${r}`}e.$dp=u;function b(l){return l.toLowerCase()}e.$ep=b;function o(l,r){return b(u(l??f.$tm,r))}e.$fp=o;function i(l,r){const c=[],h=g=>{for(const C of c)if(C.some(v=>M(r(v),r(g))))return C;return null};for(const g of l){const C=h(g);C?C.push(g):c.push([g])}return c}e.$gp=i;function n(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.$hp=n;function s(l){return{id:new k.$Xo(l.identifier.id),name:new k.$Xo(l.name),galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),isSigned:l.isSigned,...l.telemetryData}}e.$ip=s,e.$jp=new f.$xm("pprice.better-merge");function a(l,r){const c=[],h=r.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const g=h.shift();if(g&&c.every(C=>!M(C.identifier,{id:g}))){const C=l.filter(v=>M(v.identifier,{id:g}));C.length===1&&(c.push(C[0]),h.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$kp=a;async function t(l,r){if(!R.$e)return!1;let c;try{c=(await l.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await l.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){r.debug("Error while getting the os-release file.",(0,w.$0)(g))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(l,r){const c=await t(l,r),h=(0,O.$Ho)(c?"alpine":R.$o,$.$ec);return r.debug("ComputeTargetPlatform:",h),h}e.$lp=d}),define(Se[264],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=e.$Yr=void 0;function D($){return[...$.entries()]}e.$Yr=D;function O($){return $?[...$.entries()]:[]}e.$Zr=O;function f($){return new Map($)}e.$1r=f;function R($){return new Map($??[])}e.$2r=R;function L($){return Array.from($.entries()).map(k=>[k[0],D(k[1].map),O(k[1].descriptionMap)])}e.$3r=L;function w($){return new Map($.map(k=>[k[0],{map:f(k[1]),descriptionMap:R(k[2])}]))}e.$4r=w}),define(Se[265],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ptb=void 0;class D{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,R,L=5){const w=R($=>{const k=typeof $=="string"?$:$.data;let M=this.a.get(f);if(M){M.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(f),L);M={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),w.dispose()}},this.a.set(f,M)});return w}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const R=this.a.get(f);R&&(this.a.delete(f),this.b(f,R.data.join("")))}}e.$Ptb=D}),define(Se[266],De([1,0,8,78,55,4,18,2,208,108,37]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.IconFontDefinition=e.IconContribution=e.$Jw=void 0,e.$Jw={IconContribution:"base.contributions.icons"};var I;(function(s){function a(t,d){let l=t.defaults;for(;f.ThemeIcon.isThemeIcon(l);){const r=E.getIcon(l.id);if(!r)return;l=r.defaults}return l}s.getDefinition=a})(I||(e.IconContribution=I={}));var p;(function(s){function a(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=a;function t(d){const l=r=>(0,L.$Sf)(r)?r:void 0;if(d&&Array.isArray(d.src)&&d.src.every(r=>(0,L.$Sf)(r.format)&&(0,L.$Sf)(r.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(r=>({format:r.format,location:w.URI.parse(r.location)}))}}s.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class S{constructor(){this.a=new R.$5d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,d,l){const r=this.b[a];if(r){if(d&&!r.description){r.description=d,this.d.properties[a].markdownDescription=`${d} $(${a})`;const g=this.e.enum.indexOf(a);g!==-1&&(this.e.enumDescriptions[g]=d),this.a.fire()}return r}const c={id:a,description:d,defaults:t,deprecationMessage:l};this.b[a]=c;const h={$ref:"#/definitions/icons"};return l&&(h.deprecationMessage=l),d&&(h.markdownDescription=`${d}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const d=this.f[a];return d||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(r,c)=>r.id.localeCompare(c.id),t=r=>{for(;f.ThemeIcon.isThemeIcon(r.defaults);)r=this.b[r.defaults.id];return`codicon codicon-${r?r.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(r=>this.b[r]);for(const r of l.filter(c=>!!c.description).sort(a))d.push(`|<i class="${t(r)}"></i>|${r.id}|${f.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const r of l.filter(c=>!f.ThemeIcon.isThemeIcon(c.defaults)).sort(a))d.push(`|<i class="${t(r)}"></i>|${r.id}|`);return d.join(`
`)}}const E=new S;M.$Un.add(e.$Jw.IconContribution,E);function u(s,a,t,d){return E.registerIcon(s,a,t,d)}e.$Kw=u;function b(){return E}e.$Lw=b;function o(){const s=(0,O.$ik)();for(const a in s){const t="\\"+s[a].toString(16);E.registerIcon(a,{fontCharacter:t})}}o(),e.$Mw="vscode://schemas/icons";const i=M.$Un.as(k.$Vn.JSONContribution);i.registerSchema(e.$Mw,E.getIconSchema());const n=new D.$qh(()=>i.notifySchemaChanged(e.$Mw),200);E.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Nw=u("widget-close",O.$kk.close,(0,$.localize)(2,null)),e.$Ow=u("goto-previous-location",O.$kk.arrowUp,(0,$.localize)(3,null)),e.$Pw=u("goto-next-location",O.$kk.arrowDown,(0,$.localize)(4,null)),e.$Qw=f.ThemeIcon.modify(O.$kk.sync,"spin"),e.$Rw=f.ThemeIcon.modify(O.$kk.loading,"spin")}),define(Se[88],De([1,0,4,52,5,13]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.ProvidedOnAutoForward=e.$Pv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ov=e.$Nv=void 0,e.$Nv=(0,f.$ei)("tunnelService"),e.$Ov=(0,f.$ei)("sharedTunnelsService");var L;(function(b){b.Http="http",b.Https="https"})(L||(e.TunnelProtocol=L={}));var w;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(w||(e.TunnelPrivacyId=w={}));function $(b){return!!b.forwardPort}e.$Pv=$;var k;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function M(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(o)return{address:o[1],port:+o[2]}}e.$Qv=M,e.$Rv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(b){return e.$Rv.indexOf(b)>=0}e.$Sv=I,e.$Tv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(b){return e.$Tv.indexOf(b)>=0}e.$Uv=p;function S(b,o,i,n){if(i===1)return!1;if(i===2&&p(o)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(s?.length===4&&parseInt(s[1])>=18)return!1}return b<1024}e.$Vv=S;class E{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new D.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Wv=E;let u=class{constructor(o,i){this.k=o,this.l=i,this.a=new D.$5d,this.onTunnelOpened=this.a.event,this.b=new D.$5d,this.onTunnelClosed=this.b.event,this.c=new D.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const n of i){const s=Array.from(n.values());for(const a of s){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,s,a){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:s,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(p(o)||I(o))&&(o=e.$Rv[0]);const n=this.s(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,s,a,t=!1,d,l){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const r=this.f??o;if(!r)return;if(i||(i="localhost"),s||(s=this.m),this.f&&this.j.has(n)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.t(r,i,n,s,a,t,d,l);return c?c.then(h=>{if(h){if(typeof h=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,n),h}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,n);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&h.privacy!==d&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async p(o,i,n){if(n.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const s=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),s}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const s=n.get(i);s.refcount=0,await this.p(o,i,s)}}q(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async r(o,i){const n=this.e.get(o);if(n){const s=n.get(i),a=s?await s.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}s(o,i){const n=[o];I(o)?(n.push(...e.$Rv),n.push(...e.$Tv)):p(o)&&n.push(...e.$Tv);const s=n.map(a=>this.e.get(a));for(const a of s){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!M(o)}u(o,i,n,s,a,t,d){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${s}.`);const l=n;this.j.add(l);const r=s===void 0?n:s,c={elevationRequired:a?this.isPortPrivileged(r):!1},h={remoteAddress:{host:i,port:n},localAddressPort:s,privacy:t,public:t?t!==w.Private:void 0,protocol:d},g=o.forwardPort(h,c);return g?(this.q(i,n,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(l)})):this.j.delete(l),g}};e.$Xv=u,e.$Xv=u=Je([He(0,R.$yj),He(1,O.$Ki)],u)}),define(Se[267],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=void 0,e.$_k=(0,D.$ei)("IUriIdentityService")}),define(Se[268],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Yv=void 0,e.$Yv=(0,D.$ei)("editSessionIdentityService");var O;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[269],De([1,0,16]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=void 0;function O($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$xL=O;function f($){if($.folders.length)return $.folders.every(k=>O(k.uri))?$.folders[0].uri:void 0;if($.configuration&&O($.configuration))return $.configuration}e.$yL=f;function R($){return f($)?.scheme}e.$zL=R;function L($){return f($)?.authority}e.$AL=L;function w($){return f($)!==void 0}e.$BL=w}),define(Se[42],De([1,0,210,17,77,23,2,5,16]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,w.$ei)("contextService");function k(r){const c=r;return typeof c?.id=="string"&&L.URI.isUri(c.uri)}e.$oi=k;function M(r){return typeof r?.id=="string"&&!k(r)&&!p(r)}e.$pi=M,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function I(r,c){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,O.$nc)(r)}:c?e.$qi:e.$ri;const h=r;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$si=I;function p(r){const c=r;return typeof c?.id=="string"&&L.URI.isUri(c.configPath)}e.$ti=p;function S(r){const c=r;if(c?.uri)return{id:c.id,uri:L.URI.revive(c.uri)};const h=r;if(h?.configPath)return{id:h.id,configPath:L.URI.revive(h.configPath)};if(r?.id)return{id:r.id}}e.$ui=S;var E;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function u(r){const c=r;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$vi=u;function b(r){const c=r;return!!(c&&typeof c=="object"&&L.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$wi=b;class o{constructor(c,h,g,C,v){this.h=c,this.j=g,this.k=C,this.l=v,this.c=f.$ki.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=f.$ki.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=o;class i{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.$Rg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=i;function n(r){return new i({uri:r,index:0,name:(0,R.$Ng)(r)},{uri:r.toString()})}e.$zi=n,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,D.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function s(r,c){return R.$Ig.isEqualOrParent(r,c.untitledWorkspacesHome)}e.$Ei=s;function a(r){let c;return L.URI.isUri(r)?c=r:c=r.configuration,c?.scheme===$.Schemas.tmp}e.$Fi=a,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(r){return r.id===e.$Gi}e.$Hi=t;function d(r,c){return!s(r,c)&&!a(r)}e.$Ii=d;function l(r){return(typeof r=="string"?(0,O.$oc)(r):(0,R.$Pg)(r))===e.$Bi}e.$Ji=l}),define(Se[270],De([1,0,54,4,3,23,2,209,134,32,5,13,42,28,267,8,30,12,18]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.ProfileResourceType=void 0;var n;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function s(r){const c=r;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&L.URI.isUri(c.location)&&L.URI.isUri(c.globalStorageHome)&&L.URI.isUri(c.settingsResource)&&L.URI.isUri(c.keybindingsResource)&&L.URI.isUri(c.tasksResource)&&L.URI.isUri(c.snippetsHome)&&L.URI.isUri(c.extensionsResource))}e.$al=s,e.$bl=(0,M.$ei)("IUserDataProfilesService");function a(r,c){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:L.URI.revive(r.location).with({scheme:c}),globalStorageHome:L.URI.revive(r.globalStorageHome).with({scheme:c}),settingsResource:L.URI.revive(r.settingsResource).with({scheme:c}),keybindingsResource:L.URI.revive(r.keybindingsResource).with({scheme:c}),tasksResource:L.URI.revive(r.tasksResource).with({scheme:c}),snippetsHome:L.URI.revive(r.snippetsHome).with({scheme:c}),extensionsResource:L.URI.revive(r.extensionsResource).with({scheme:c}),cacheHome:L.URI.revive(r.cacheHome).with({scheme:c}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.$cl=a;function t(r,c,h,g,C,v){return{id:r,name:c,location:h,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:v&&C?.useDefaultFlags?.globalState?v.globalStorageHome:(0,R.$Rg)(h,"globalStorage"),settingsResource:v&&C?.useDefaultFlags?.settings?v.settingsResource:(0,R.$Rg)(h,"settings.json"),keybindingsResource:v&&C?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,R.$Rg)(h,"keybindings.json"),tasksResource:v&&C?.useDefaultFlags?.tasks?v.tasksResource:(0,R.$Rg)(h,"tasks.json"),snippetsHome:v&&C?.useDefaultFlags?.snippets?v.snippetsHome:(0,R.$Rg)(h,"snippets"),extensionsResource:v&&C?.useDefaultFlags?.extensions?v.extensionsResource:(0,R.$Rg)(h,"extensions.json"),cacheHome:(0,R.$Rg)(g,r),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$dl=t;let d=class extends f.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,g,C){super(),this.t=c,this.u=h,this.w=g,this.y=C,this.f=!0,this.h=this.B(new O.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$Rg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$Rg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$Sf)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}h.push(t((0,R.$Og)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},c))}}catch(v){this.y.error(v)}const g=new S.$Ac,C=new Map;if(h.length)try{const v=this.Q();if(v.workspaces)for(const[m,y]of Object.entries(v.workspaces)){const P=L.URI.parse(m),j=h.find(U=>U.id===y);j&&g.set(P,j)}if(v.emptyWindows)for(const[m,y]of Object.entries(v.emptyWindows)){const P=h.find(j=>j.id===y);P&&C.set(m,P)}}catch(v){this.y.error(v)}this.z={profiles:h,workspaces:g,emptyWindows:C}}return this.z}D(){const c=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",g=new RegExp(`${(0,o.$Xe)(h)}\\s(\\d+)`);let C=0;for(const m of this.profiles){const y=g.exec(m.name),P=y?parseInt(y[1]):0;C=P>C?P:C}const v=`${h} ${C+1}`;return this.createProfile((0,D.$5i)((0,b.$Ag)()).toString(16),v,{transient:!0},c)}async createNamedProfile(c,h,g){return this.createProfile((0,D.$5i)((0,b.$Ag)()).toString(16),c,h,g)}async createProfile(c,h,g,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(c,h,g);return C&&await this.setProfileForWorkspace(C,v),v}async F(c,h,g){if(!(0,i.$Sf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(h);return C||(C=(async()=>{try{const v=this.profiles.find(P=>P.name===h||P.id===c);if(v)return v;const m=t(c,h,(0,R.$Rg)(this.profilesHome,c),this.g,g,this.defaultProfile);await this.u.createFolder(m.location);const y=[];return this.j.fire({profile:m,join(P){y.push(P)}}),await u.Promises.settled(y),this.I([m],[],[]),m}finally{this.r.delete(h)}})(),this.r.set(h,C)),C}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(C=>C.id===c.id);if(!g)throw new Error(`Profile '${c.name}' does not exist`);return g=t(g.id,h.name??g.name,g.location,this.g,{shortName:h.shortName??g.shortName,icon:h.icon===null?void 0:h.icon??g.icon,transient:h.transient??g.isTransient,useDefaultFlags:h.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(C=>C.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const g=[];this.m.fire({profile:h,join(C){g.push(C)}});try{await Promise.allSettled(g)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(C){(0,k.$Sk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(C=>C.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,g)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return L.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,p.$oi)(c)?c.uri:(0,p.$ti)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,g){const C=[...this.profiles,...c],v=[];this.s.profiles=[];for(let m of C)m.isDefault||h.some(y=>m.id===y.id)||(m=g.find(y=>m.id===y.id)??m,m.isTransient?this.s.profiles.push(m):v.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags}));this.P(v),this.z=void 0,this.J(c,h,g)}J(c,h,g){this.h.fire({added:c,removed:h,updated:g,all:this.profiles})}L(c,h,g){g=h?.isTransient?!0:g,g||this.L(c,void 0,!0);const C=this.G(c),v=g?this.s:this.C;L.URI.isUri(C)?(v.workspaces.delete(C),h&&v.workspaces.set(C,h)):(v.emptyWindows.delete(C),h&&v.emptyWindows.set(C,h)),g||this.M()}M(){const c={};for(const[g,C]of this.C.workspaces.entries())c[g.toString()]=C.id;const h={};for(const[g,C]of this.C.emptyWindows.entries())h[g.toString()]=C.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},g=this.D();if(c.workspaces)for(const[v,m]of Object.entries(c.workspaces)){const y=L.URI.parse(m);h[v]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}const C={};if(c.emptyWindows)for(const[v,m]of Object.entries(c.emptyWindows)){const y=L.URI.parse(m);C[v]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:C}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$el=d,d.b="userDataProfiles",d.c="profileAssociations",e.$el=d=Je([He(0,$.$li),He(1,k.$Bk),He(2,E.$_k),He(3,I.$yj)],d);class l extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$fl=l}),define(Se[271],De([1,0,8,4,3,58,18,172,5,270]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Gp=e.$Fp=e.$Ep=void 0,e.$Ep="__$__isNewStorageMarker",e.$Fp="__$__targetStorageMarker",e.$Gp=(0,$.$ei)("storageService");var M;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(M||(e.WillSaveStateReason=M={}));var I;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function S(i){const n=i.get(e.$Fp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$Hp=S;class E extends f.$Tc{constructor(n={flushInterval:E.a}){super(),this.m=n,this.b=this.B(new O.$8d),this.c=this.B(new O.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new D.$qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,s,a){return O.Event.filter(this.b.event,t=>t.scope===n&&(s===void 0||t.key===s),a)}n(){this.j.value=(0,D.$uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,s){const{key:a,external:t}=s;if(a===e.$Fp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,s,a){return this.P(s)?.get(n,a)}getBoolean(n,s,a){return this.P(s)?.getBoolean(n,a)}getNumber(n,s,a){return this.P(s)?.getNumber(n,a)}getObject(n,s,a){return this.P(s)?.getObject(n,a)}storeAll(n,s){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,s)})}store(n,s,a,t,d=!1){if((0,L.$2f)(s)){this.remove(n,a,d);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,s,d)})}remove(n,s,a=!1){this.y(()=>{this.z(n,s,void 0),this.P(s)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,s){const a=[],t=this.J(n);for(const d of Object.keys(t))t[d]===s&&a.push(d);return a}z(n,s,a,t=!1){const d=this.J(s);typeof a=="number"?d[n]!==a&&(d[n]=a,this.P(s)?.set(e.$Fp,JSON.stringify(d),t)):typeof d[n]=="number"&&(delete d[n],this.P(s)?.set(e.$Fp,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const s=this.P(n);return s?S(s):Object.create(null)}isNew(n){return this.getBoolean(e.$Ep,n)===!0}async flush(n=M.NONE){this.f.fire({reason:n});const s=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case M.NONE:await D.Promises.settled([s?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await D.Promises.settled([s?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,s=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(n,s,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,s){return this.w(M.NONE),(0,k.$al)(n)?this.R(n,s):this.S(n,s)}M(n,s){return!(n.id===s.id||u(s)&&u(n))}N(n,s,a){this.y(()=>{const t=new Set;for(const[d,l]of n)t.add(d),s.get(d)!==l&&this.u(a,{key:d,external:!0});for(const[d]of s.items)t.has(d)||this.u(a,{key:d,external:!0})})}}e.$Ip=E,E.a=60*1e3;function u(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$Jp=u;class b extends E{constructor(){super(),this.U=this.B(new w.$Cp(new w.$Dp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$Cp(new w.$Dp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$Cp(new w.$Dp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Kp=b;async function o(i,n,s,a,t,d){const l=P=>{try{return JSON.parse(P)}catch{return P}},r=new Map,c=new Map;i.forEach((P,j)=>{r.set(j,P),c.set(j,l(P))});const h=new Map,g=new Map;n.forEach((P,j)=>{h.set(j,P),g.set(j,l(P))});const C=new Map,v=new Map;s.forEach((P,j)=>{C.set(j,P),v.set(j,l(P))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const m=[];if(r.forEach((P,j)=>{m.push({key:j,value:P})}),console.table(m),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];h.forEach((j,U)=>{P.push({key:U,value:j})}),console.table(P),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${d})`);const y=[];C.forEach((P,j)=>{y.push({key:j,value:P})}),console.table(y),console.groupEnd(),console.log(v)}e.$Lp=o}),define(Se[110],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class D{constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const R=this.c++;return this.b.set(R,f),this.e(),R}get(f,R){return this.b.has(f)?this.b.get(f)[R]:void 0}delete(f){this.b.delete(f),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Lhc=D,D.a=!1}),define(Se[59],De([1,0,16,23,5]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=void 0;class R{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new O.$Gg(w=>{const $=this.b.get(w.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(w,$){$===null?this.b.delete(w.scheme):this.b.set(w.scheme,$)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$Qhc=R,e.$Rhc=(0,f.$ei)("IExtHostFileSystemInfo")}),define(Se[27],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=void 0,e.$vO=(0,D.$ei)("IExtHostInitDataService")}),define(Se[272],De([1,0,216,13,252,27]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=void 0;let L=class extends f.$DP{constructor($,k,M){const I=M.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=M.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(k.createLogger(I,{name:p}))}};e.$Vjc=L,e.$Vjc=L=Je([He(1,O.$zj),He(2,R.$vO)],L)}),define(Se[273],De([1,0,8]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=void 0;class O{constructor(L,w,$){this.h=new Map,this.a=L,this.b=w,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new D.$qh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of k.values())M.complete()}catch(M){for(const I of k.values())I.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,w){let $=this.f[L];return typeof $>"u"&&($=w),$}update(L,w){this.f[L]=w;const $=this.h.get(L);if($!==void 0)return $.p;const k=new D.$Bh;return this.h.set(L,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$xic=O;class f extends O{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,w){super(L.identifier.value,!0,w),this.j=L}}e.$yic=f}),define(Se[274],De([1,0,4,2]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class f{constructor(L){this.c=L,this.a=new D.$5d,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$5d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,w,$,k){const I=this.c.getNotebookDocument(O.URI.revive(L)).acceptModelChanged(w.value,$,k);this.b.fire(I)}$acceptDirtyStateChanged(L,w){this.c.getNotebookDocument(O.URI.revive(L)).acceptDirty(w)}$acceptModelSaved(L){const w=this.c.getNotebookDocument(O.URI.revive(L));this.a.fire(w.apiNotebook)}}e.$ljc=f}),define(Se[20],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=e.$fO=void 0,e.$fO=(0,D.$ei)("IExtHostRpcService");class O{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$gO=O});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[275],De([1,0,25,4]),function(re,e,D,O){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class R{constructor(w,$){f.set(this,void 0),this.b=new O.$5d,this.onDidChange=this.b.event,this.a=D.$xm.toKey(w.identifier),it(this,f,$,"f"),qe(this,f,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(w){return qe(this,f,"f").get(this.a,w)}store(w,$){return qe(this,f,"f").store(this.a,w,$)}delete(w){return qe(this,f,"f").delete(this.a,w)}}e.$Fic=R,f=new WeakMap}),define(Se[66],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0,e.$8hc=(0,D.$ei)("IURITransformerService");class O{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$9hc=O}),define(Se[276],De([1,0,21]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnb=e.$inb=void 0;class O{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function f(w,$){if($.serializeBuffersForPostMessage){const k=new O,I=JSON.stringify(w,(S,E)=>{if(E instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(E)};if(ArrayBuffer.isView(E)){const u=R(E);if(u)return{$$vscode_array_buffer_reference$$:!0,index:k.add(E.buffer),view:{type:u,byteLength:E.byteLength,byteOffset:E.byteOffset}}}return E}),p=k.buffers.map(S=>{const E=new Uint8Array(S);return D.$se.wrap(E)});return{message:I,buffers:p}}else return{message:JSON.stringify(w),buffers:[]}}e.$inb=f;function R(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(w,$){const k=$.map(p=>{const S=new ArrayBuffer(p.byteLength);return new Uint8Array(S).set(p.buffer),S}),M=$.length?(p,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const E=S,{index:u}=E,b=k[u];if(E.view)switch(E.view.type){case 1:return new Int8Array(b,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return S}:void 0;return{message:JSON.parse(w,M),arrayBuffers:k}}e.$jnb=L}),define(Se[277],De([1,0,111,390,391,63,2,13,392]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;const k=!1;function M(n,s,a,t,d,l){const r=l.environment.useHostProxy,c=typeof r=="boolean"?r:!l.remote.isRemote,h={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:b.bind(void 0,t,d,s,{},l.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(s),addCertificatesV2:()=>S(s),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case w.LogLevel.Trace:return $.LogLevel.Trace;case w.LogLevel.Debug:return $.LogLevel.Debug;case w.LogLevel.Info:return $.LogLevel.Info;case w.LogLevel.Warning:return $.LogLevel.Warning;case w.LogLevel.Error:return $.LogLevel.Error;case w.LogLevel.Off:return $.LogLevel.Off;default:return m(v)}function m(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const v=[];if(l.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const m=n.loadCertificates();m.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),v.push(m)}return(await Promise.all(v)).flat()},env:process.env},g=(0,$.createProxyResolver)(h),C=I(h,g);return u(a,C)}e.$rkc=M;function I(n,s){return{http:Object.assign(D,(0,$.createHttpPatch)(n,D,s)),https:Object.assign(O,(0,$.createHttpPatch)(n,O,s)),net:Object.assign(R,(0,$.createNetPatch)(n,R)),tls:Object.assign(f,(0,$.createTlsPatch)(n,f))}}function p(n){const s=n.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",k)&&!!s.get("systemCertificates")}function S(n){const s=n.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",k)&&!!s.get("systemCertificates")}const E=new Map;function u(n,s){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,d=t._load;t._load=function(r,c,h){if(r==="net")return s.net;if(r==="tls")return s.tls;if(r!=="http"&&r!=="https")return d.apply(this,arguments);const g=a.findSubstr(L.URI.file(c.filename));let C=E.get(g);if(C||E.set(g,C={}),!C[r]){const v=s[r];C[r]={...v}}return C[r]}})}async function b(n,s,a,t,d,l,r,c){const h=t[l];r&&(t[l]=r),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${l}`,`proxyAuthenticate:${r}`,`proxyAuthenticateCache:${h}`);const g=r||h,C=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(i(s,C,d),C.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const v=await new Promise((U,z)=>{re(["kerberos"],U,z)}),m=new URL(l),y=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${m.hostname}`:`HTTP@${m.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${l}`,`spn:${y}`),"Negotiate "+await(await v.initializeClient(y)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let o=!1;function i(n,s,a){o||!s.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Se[278],De([1,0,128]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;function O(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function f(R){return new D.$en(O(R))}e.$cs=f}),define(Se[140],De([1,0,226,18,2,3,5,37,32,16,41,191,40]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.$fF=e.EditorsOrder=e.$eF=e.CloseDirection=e.$dF=e.$cF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.EditorInputCapabilities=e.$6E=e.SaveReason=e.Verbosity=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$SE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$UE="workbench.editor.sidebysideEditor",e.$VE="workbench.editors.textDiffEditor",e.$WE="workbench.editors.binaryResourceDiffEditor";var S;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var E;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(E||(e.EditorPaneSelectionCompareResult=E={}));function u(ue){const ae=ue;return!!ae&&typeof ae.getSelection=="function"&&!!ae.onDidChangeSelection}e.$XE=u;function b(ue,ae,H){for(const fe of H.visibleEditorPanes)if(fe.group.id===ae&&ue.matches(fe.input))return fe.getViewState()}e.$YE=b;function o(ue){if(g(ue))return!1;const ae=ue;return f.URI.isUri(ae?.resource)}e.$ZE=o;function i(ue){if(g(ue))return!1;const ae=ue;return ae?.original!==void 0&&ae.modified!==void 0}e.$1E=i;function n(ue){if(g(ue))return!1;const ae=ue;return!ae||ae.resources&&!Array.isArray(ae.resources)?!1:!!ae.resources||!!ae.multiDiffSource}e.$2E=n;function s(ue){if(g(ue)||i(ue))return!1;const ae=ue;return ae?.primary!==void 0&&ae.secondary!==void 0}e.$3E=s;function a(ue){if(g(ue))return!1;const ae=ue;return ae?ae.resource===void 0||ae.resource.scheme===k.Schemas.untitled||ae.forceUntitled===!0:!1}e.$4E=a;function t(ue){if(g(ue))return!1;const ae=ue;return f.URI.isUri(ae?.base?.resource)&&f.URI.isUri(ae?.input1?.resource)&&f.URI.isUri(ae?.input2?.resource)&&f.URI.isUri(ae?.result?.resource)}e.$5E=t;var d;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class r{constructor(){this.a=new Map}registerSource(ae,H){let fe=this.a.get(ae);return fe||(fe={source:ae,label:H},this.a.set(ae,fe)),fe.source}getSourceLabel(ae){return this.a.get(ae)?.label??ae}}e.$6E=new r;var c;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad",ue[ue.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class h extends R.$Tc{}e.$7E=h;function g(ue){return ue instanceof h}e.$8E=g;function C(ue){const ae=ue;return f.URI.isUri(ae?.preferredResource)}function v(ue){const ae=ue;return g(ae?.primary)&&g(ae?.secondary)}e.$9E=v;function m(ue){const ae=ue;return g(ae?.modified)&&g(ae?.original)}e.$0E=m;function y(ue,ae,H,fe,he){return we(fe,[(0,I.$1i)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const se={...H,limits:{size:Number.MAX_VALUE}};ue.openEditor(ae,se)}}),(0,I.$1i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>he.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$$E=y;function P(ue){return g(ue?.editor)}e.$_E=P;function j(ue){const ae=ue;return P(ue)&&ae?.group!==void 0}e.$aF=j;function U(ue){const ae=ue;return typeof ae?.groupId=="number"&&g(ae.editor)}e.$bF=U;var z;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var N;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LABEL=2]="GROUP_LABEL",ue[ue.GROUP_LOCKED=3]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=4]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=5]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=6]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=8]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=10]="EDITOR_PIN",ue[ue.EDITOR_STICKY=11]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=12]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var A;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(A||(e.SideBySideEditor=A={}));class T{getOriginalUri(ae,H){if(!ae)return;if(t(ae))return e.$dF.getOriginalUri(ae.result,H);if(H?.supportSideBySide){const{primary:he,secondary:se}=this.a(ae);if(he&&se){if(H?.supportSideBySide===A.BOTH)return{primary:this.getOriginalUri(he,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===A.ANY)return this.getOriginalUri(he,{filterByScheme:H.filterByScheme})??this.getOriginalUri(se,{filterByScheme:H.filterByScheme});ae=H.supportSideBySide===A.PRIMARY?he:se}}if(i(ae)||n(ae)||s(ae)||t(ae))return;const fe=C(ae)?ae.preferredResource:ae.resource;return!fe||!H||!H.filterByScheme?fe:this.b(fe,H.filterByScheme)}a(ae){return v(ae)||s(ae)?{primary:ae.primary,secondary:ae.secondary}:m(ae)||i(ae)?{primary:ae.modified,secondary:ae.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ae,H){if(!ae)return;if(t(ae))return e.$dF.getCanonicalUri(ae.result,H);if(H?.supportSideBySide){const{primary:he,secondary:se}=this.a(ae);if(he&&se){if(H?.supportSideBySide===A.BOTH)return{primary:this.getCanonicalUri(he,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===A.ANY)return this.getCanonicalUri(he,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:H.filterByScheme});ae=H.supportSideBySide===A.PRIMARY?he:se}}if(i(ae)||n(ae)||s(ae)||t(ae))return;const fe=ae.resource;return!fe||!H||!H.filterByScheme?fe:this.b(fe,H.filterByScheme)}b(ae,H){if(Array.isArray(H)){if(H.some(fe=>ae.scheme===fe))return ae}else if(H===ae.scheme)return ae}}var F;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(F||(e.EditorCloseMethod=F={}));function G(ue,ae,H,fe){if(!ue.isSticky(ae))return!1;switch(fe.preventPinnedEditorClose){case"keyboardAndMouse":return H===F.MOUSE||H===F.KEYBOARD;case"mouse":return H===F.MOUSE;case"keyboard":return H===F.KEYBOARD}return!1}e.$cF=G,e.$dF=new T;var K;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class X{constructor(){this.c=new Map,this.d=new Map}start(ae){const H=this.a=ae.get(L.$di);for(const[fe,he]of this.c)this.e(fe,he,H);this.c.clear()}e(ae,H,fe){const he=fe.createInstance(H);this.d.set(ae,he)}registerFileEditorFactory(ae){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ae}getFileEditorFactory(){return(0,O.$4f)(this.b)}registerEditorSerializer(ae,H){if(this.c.has(ae)||this.d.has(ae))throw new Error(`A editor serializer with type ID '${ae}' was already registered.`);return this.a?this.e(ae,H,this.a):this.c.set(ae,H),(0,R.$Rc)(()=>{this.c.delete(ae),this.d.delete(ae)})}getEditorSerializer(ae){return this.d.get(typeof ae=="string"?ae:ae.typeId)}}w.$Un.add(e.$SE.EditorFactory,new X);async function Q(ue,ae,H){return!ue||!ue.length?[]:await Promise.all(ue.map(async fe=>{const he=f.URI.revive(fe.fileUri);if(!he){H.info("Cannot resolve the path because it is not valid.",fe);return}if(!await ae.canHandleResource(he)){H.info("Cannot resolve the path because it cannot be handled",fe);return}let ce=fe.exists,le=fe.type;if(typeof ce!="boolean"||typeof le!="number")try{le=(await ae.stat(he)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ce=!0}catch(q){H.error(q),ce=!1}if(!ce&&fe.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",fe);return}if(le===$.FileType.Directory){H.info("Cannot resolve the path because it is a directory",fe);return}const de={...fe.options,pinned:!0};return ce?{resource:he,options:de}:{resource:he,options:de,forceUntitled:!0}}))}e.$eF=Q;var Z;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function ie(ue){const ae=ue;if(!ae)return!1;const H=ae;if(H.modified)return ie(H.modified);const fe=ae;return!!(fe.contributionsState&&fe.viewState&&Array.isArray(fe.cursorState))}e.$fF=ie;function ee(ue){return(0,M.$3i)(ue)}e.$gF=ee;function we(ue,ae,H){const fe=(0,M.$4i)(ue,ae);return fe.forceMessage=H?.forceMessage,fe.forceSeverity=H?.forceSeverity,fe.allowDialog=H?.allowDialog,fe}e.$hF=we}),define(Se[279],De([1,0,4,227,5,3,28,37,19,24,78,266]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$nF=e.ViewContentGroups=e.$mF=e.$lF=e.ViewContainerLocation=e.Extensions=e.$kF=e.$jF=e.$iF=void 0,e.$iF="views",e.$jF=(0,O.localize)(0,null),e.$kF=(0,I.$Kw)("default-view-icon",M.$kk.window,(0,O.localize)(1,null));var p;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var S;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$lF=[0,1,2];function E(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$mF=E;class u extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$5d),this.onDidRegister=this.c.event,this.f=this.B(new D.$5d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(l,r,c){const h=this.get(l.id);if(h)return h;const g=l;return g.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,L.$xc)(this.g,r,[]).push(g),c?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:r}),g}deregisterViewContainer(l){for(const r of this.g.keys()){const c=this.g.get(r),h=c?.indexOf(l);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(r),this.f.fire({viewContainer:l,viewContainerLocation:r});return}}}get(l){return this.all.filter(r=>r.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(c=>c?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(r=>this.getViewContainerLocation(r)===l)}}w.$Un.add(p.ViewContainersRegistry,new u);var b;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(b||(e.ViewContentGroups=b={}));function o(d,l){const r=d.group??b.More,c=l.group??b.More;return r!==c?r.localeCompare(c):(d.order??5)-(l.order??5)}class i extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$5d),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$5d),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$5d),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$5d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(l,r){this.registerViews2([{views:l,viewContainer:r}])}registerViews2(l){l.forEach(({views:r,viewContainer:c})=>this.r(r,c)),this.c.fire(l)}deregisterViews(l,r){const c=this.s(l,r);c.length&&this.f.fire({views:c,viewContainer:r})}moveViews(l,r){for(const c of this.m.keys())if(c!==r){const h=this.s(l,c);h.length&&(this.r(h,r),this.g.fire({views:h,from:c,to:r}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const r of this.j){const c=(this.m.get(r)||[]).filter(h=>h.id===l)[0];if(c)return c}return null}getViewContainer(l){for(const r of this.j)if((this.m.get(r)||[]).filter(h=>h.id===l)[0])return r;return null}registerViewWelcomeContent(l,r){return this.n.add(l,r),this.h.fire(l),(0,R.$Rc)(()=>{this.n.delete(l,r),this.h.fire(l)})}registerViewWelcomeContent2(l,r){const c=new Map;for(const[h,g]of r)this.n.add(l,g),c.set(h,(0,R.$Rc)(()=>{this.n.delete(l,g),this.h.fire(l)}));return this.h.fire(l),c}getViewWelcomeContent(l){const r=[];return this.n.forEach(l,c=>r.push(c)),r.sort(o)}r(l,r){let c=this.m.get(r);c||(c=[],this.m.set(r,c),this.j.push(r));for(const h of l){if(this.getView(h.id)!==null)throw new Error((0,O.localize)(2,null,h.id));c.push(h)}}s(l,r){const c=this.m.get(r);if(!c)return[];const h=[],g=[];for(const C of c)l.includes(C)?h.push(C):g.push(C);return h.length&&(g.length?this.m.set(r,g):(this.m.delete(r),this.j.splice(this.j.indexOf(r),1))),h}}w.$Un.add(p.ViewsRegistry,new i),e.$nF=(0,f.$ei)("viewDescriptorService");var n;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var s;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(s||(e.TreeItemCollapsibleState=s={}));class a{constructor(l,r){this.c=!1,this.d=!1,(0,k.$Ln)(this,l),this.d=!!r,this.resolve=async c=>{if(r&&!this.c){const h=await r(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$oF=a;class t extends Error{constructor(l){super((0,O.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$pF=t}),define(Se[280],De([1,0,2,29,5]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$xF=e.$wF=void 0;function R(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof D.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(O.$7s.isIRange)}e.$wF=R;function L(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(R)}e.$xF=L;var w;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$yF=(0,f.$ei)("IChatService"),e.$zF="accessibility.voice.keywordActivation"}),define(Se[141],De([1,0,4,8,228]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new D.$5d,this.o=new D.$5d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(w){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=w}onEvent(w){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=w}onRequest(w){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.u("response",w)}sendRequest(w,$,k,M){const I={command:w};if($&&Object.keys($).length>0&&(I.arguments=$),this.u("request",I),typeof M=="number"){const p=setTimeout(()=>{clearTimeout(p);const S=this.f.get(I.seq);if(S){this.f.delete(I.seq);const E={type:"response",seq:0,request_seq:I.seq,success:!1,command:w,message:(0,f.localize)(0,null,M,w)};S(E)}},M)}return k&&this.f.set(I.seq,k),I.seq}acceptMessage(w){this.k?this.k(w):(this.m.push(w),this.m.length===1&&this.s())}q(w,$){return w.type!=="event"||$.type!=="event"}async s(){let w;for(;this.m.length;){if((!w||this.q(this.m[0],w))&&await(0,O.$fh)(0),w=this.m.shift(),!w)return;switch(w.type){case"event":this.j?.(w);break;case"request":this.g?.(w);break;case"response":{const $=w,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}u(w,$){$.type=w,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach(($,k)=>w.set(k,$)),await(0,O.$fh)(500),w.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Onb=R}),define(Se[281],De([1,0,2,229,45,5]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$zI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$yI=e.MemoryRangeType=e.$xI=e.State=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=void 0,e.$oH="workbench.view.debug",e.$pH="workbench.debug.variablesView",e.$qH="workbench.debug.watchExpressionsView",e.$rH="workbench.debug.callStackView",e.$sH="workbench.debug.loadedScriptsView",e.$tH="workbench.debug.breakPointsView",e.$uH="workbench.debug.disassemblyView",e.$vH="workbench.panel.repl",e.$wH="workbench.panel.repl.view",e.$xH=new f.$vj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$yH=new f.$vj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$zH=new f.$vj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$AH="debugUx",e.$BH=new f.$vj(e.$AH,"default",{type:"string",description:O.localize(3,null)}),e.$CH=new f.$vj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$DH=new f.$vj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$EH=new f.$vj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$FH=new f.$vj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$GH=new f.$vj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$HH=new f.$vj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$IH=new f.$vj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$JH=new f.$vj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$KH=new f.$vj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$LH=new f.$vj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$MH=new f.$vj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$NH=new f.$vj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$OH=new f.$vj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$PH=new f.$vj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$QH=new f.$vj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$RH=new f.$vj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$SH=new f.$vj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$TH=new f.$vj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$UH=new f.$vj("breakpointHasModes",!1,{type:"boolean",description:O.localize(22,null)}),e.$VH=new f.$vj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(23,null)}),e.$WH=new f.$vj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(24,null)}),e.$XH=new f.$vj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(25,null)}),e.$YH=new f.$vj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(26,null)}),e.$ZH=new f.$vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(27,null)}),e.$1H=new f.$vj("stepBackSupported",!1,{type:"boolean",description:O.localize(28,null)}),e.$2H=new f.$vj("restartFrameSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$3H=new f.$vj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(30,null)}),e.$4H=new f.$vj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(31,null)}),e.$5H=new f.$vj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$6H=new f.$vj("breakpointsExist",!1,{type:"boolean",description:O.localize(33,null)}),e.$7H=new f.$vj("debuggersAvailable",!1,{type:"boolean",description:O.localize(34,null)}),e.$8H=new f.$vj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(35,null)}),e.$9H=new f.$vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(36,null)}),e.$0H=new f.$vj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(37,null)}),e.$$H=new f.$vj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$_H=new f.$vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$aI=new f.$vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$bI=new f.$vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$cI=new f.$vj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$dI=new f.$vj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$eI=new f.$vj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(44,null)}),e.$fI=new f.$vj("variableIsReadonly",!1,{type:"boolean",description:O.localize(45,null)}),e.$gI=new f.$vj("variableValue",!1,{type:"string",description:O.localize(46,null)}),e.$hI=new f.$vj("variableType",!1,{type:"string",description:O.localize(47,null)}),e.$iI=new f.$vj("variableName",!1,{type:"string",description:O.localize(48,null)}),e.$jI=new f.$vj("variableLanguage",!1,{type:"string",description:O.localize(49,null)}),e.$kI=new f.$vj("variableExtensionId",!1,{type:"string",description:O.localize(50,null)}),e.$lI=new f.$vj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(51,null)}),e.$mI=new f.$vj("multiSessionRepl",!1,{type:"boolean",description:O.localize(52,null)}),e.$nI=new f.$vj("multiSessionDebug",!1,{type:"boolean",description:O.localize(53,null)}),e.$oI=new f.$vj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(54,null)}),e.$pI=new f.$vj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(55,null)}),e.$qI=new f.$vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(56,null)}),e.$rI=new f.$vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(57,null)});const L=o=>O.localize(58,null,o);e.$sI=L,e.$tI="editor.contrib.debug",e.$uI="editor.contrib.breakpoint",e.$vI="debug",e.$wI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(59,null)};var w;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(w||(e.State=w={}));function $(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$xI=$;var k;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$yI="vscode-debug-memory";var M;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(M||(e.DebugConfigurationProviderTriggerKind=M={}));var I;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(I||(e.DebuggerString=I={})),e.$zI=(0,R.$ei)("debugService");var p;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE",o[o.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var S;(function(o){o[o.Command=0]="Command",o[o.Tree=1]="Tree"})(S||(e.DebugVisualizationType=S={}));var E;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(E||(e.DebugTreeItemCollapsibleState=E={}));var u;(function(o){o.deserialize=i=>i,o.serialize=i=>i})(u||(e.IDebugVisualizationTreeItem=u={}));var b;(function(o){o.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:D.URI.revive(i.iconPath.light),dark:D.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),o.serialize=i=>i})(b||(e.IDebugVisualization=b={}))}),define(Se[282],De([1,0,12,2,17,24,16,29,22,19]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0;const M=/{([^}]+)}/g;function I(C,v,m){return C.replace(M,function(y,P){return v&&P.length>0&&P[0]!=="_"?y:m&&m.hasOwnProperty(P)?m[P]:y})}e.$qG=I;function p(C){const v={};for(const m of Object.keys(C))m.startsWith("!")||(v[m]=C[m]);return v}e.$rG=p;function S(C){return C.configuration.request==="attach"&&!E(C)&&(!C.parentSession||S(C.parentSession))}e.$sG=S;function E(C){let v=C.configuration.type;if(v)return v==="vslsShare"&&(v=C.configuration.adapterProxy.configuration.type),(0,D.$jf)(v,"extensionhost")||(0,D.$jf)(v,"pwa-extensionhost")?C:C.parentSession?E(C.parentSession):void 0}e.$tG=E;function u(C){return C.type&&(C.label||C.program||C.runtime)}e.$uG=u;function b(C,v,m){let y,P=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=j.exec(C);){const z=U.index+1,N=z+U[0].length;if(z<=v&&N>=m){y=U[0],P=z;break}}if(y){const z=/\w+/g;let N=null;for(;(N=z.exec(y))&&!(N.index+1+P+N[0].length>=m););N&&(y=y.substring(0,z.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}e.$vG=b;async function o(C,v,m,y){if(C.evaluatableExpressionProvider.has(v)){const P=C.evaluatableExpressionProvider.ordered(v),j=(0,k.$Hb)(await Promise.all(P.map(async U=>{try{return await U.provideEvaluatableExpression(v,m,y??$.CancellationToken.None)}catch{return}})));if(j.length>0){let U=j[0].expression;const z=j[0].range;return U||(U=v.getLineContent(m.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:U}}}else{const P=v.getLineContent(m.lineNumber),{start:j,end:U}=b(P,m.column,m.column),z=P.substring(j-1,U);return{matchingExpression:z,range:new w.$7s(m.lineNumber,j,m.lineNumber,j+z.length)}}return null}e.$wG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(C){return!!(C&&C.match(i))}e.$xG=n;function s(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(n(C.path))return O.URI.parse(C.path);if((0,f.$ic)(C.path))return O.URI.file(C.path)}return C.path}function a(C){if(typeof C.path=="object"){const v=O.URI.revive(C.path);if(v)return v.scheme===L.Schemas.file?v.fsPath:v.toString()}return C.path}function t(C,v){const m=v?s:a,y=(0,R.$In)(C);return l(y,(P,j)=>{P&&j&&(j.path=m(j))}),y}e.$yG=t;function d(C,v){const m=v?s:a,y=(0,R.$In)(C);return l(y,(P,j)=>{!P&&j&&(j.path=m(j))}),y}e.$zG=d;function l(C,v){switch(C.type){case"event":{const m=C;switch(m.event){case"output":v(!1,m.body.source);break;case"loadedSource":v(!1,m.body.source);break;case"breakpoint":v(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=C;switch(m.command){case"setBreakpoints":v(!0,m.arguments.source);break;case"breakpointLocations":v(!0,m.arguments.source);break;case"source":v(!0,m.arguments.source);break;case"gotoTargets":v(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(y=>v(!1,y));break;default:break}break}case"response":{const m=C;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(y=>v(!1,y.source));break;case"loadedSources":m.body.sources.forEach(y=>v(!1,y));break;case"scopes":m.body.scopes.forEach(y=>v(!1,y.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(y=>v(!1,y.source));break;case"setBreakpoints":m.body.breakpoints.forEach(y=>v(!1,y.source));break;case"disassemble":m.body?.instructions.forEach(P=>v(!1,P.location));break;default:break}break}}}function r(C){return C.filter(v=>!v.presentation?.hidden).sort((v,m)=>v.presentation?m.presentation?v.presentation.group?m.presentation.group?v.presentation.group!==m.presentation.group?v.presentation.group.localeCompare(m.presentation.group):c(v.presentation.order,m.presentation.order):-1:m.presentation.group?1:c(v.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$AG=r;function c(C,v){return typeof C!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:C-v}async function h(C,v){const m=C.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(m!=="none"&&(await v.saveAll(),m==="allEditorsInActiveGroup")){const y=v.activeEditorPane;y&&y.input.resource?.scheme===L.Schemas.untitled&&await v.save({editor:y.input,groupId:y.group.id})}await C.reloadConfiguration()}e.$BG=h;const g=(C,v)=>!C||!v?C===v:C.name===v.name&&C.path===v.path&&C.sourceReference===v.sourceReference;e.$CG=g}),define(Se[283],De([1,0,50,63,24,17,9,12,31,230,141]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=e.$4jc=e.$3jc=e.$2jc=void 0;class I extends M.$Onb{constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",n=>this.v(n))}sendMessage(o){if(this.l){const i=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${I.a}${i}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(I.a);if(i!==-1){const s=this.p.toString("utf8",0,i).split(I.b);for(const a of s){const t=a.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+I.a.length);continue}}break}}}e.$2jc=I,I.a=`\r
\r
`,I.b=/\r?\n/,I.i=/: */;class p extends I{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",s=>{n?this.n.fire(s):i(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$3jc=p;class S extends p{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$4jc=S;class E extends p{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.path,o)}}e.$5jc=E;class u extends I{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(R.$ic(o)){if(!await $.Promises.exists(o))throw new Error(k.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let s=process.env;if(n.env&&Object.keys(n.env).length>0&&(s=f.$Ln(f.$In(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const d=D.fork(i[0],i.slice(1),t);if(!d.pid)throw new Error(k.localize(2,null,i[0]));this.x=d}else throw new Error(k.localize(3,null));else{const a={env:s};n.cwd&&(a.cwd=n.cwd),this.x=D.spawn(o,i,a)}this.x.on("error",a=>{this.n.fire(a)}),this.x.on("exit",(a,t)=>{this.o.fire(a)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.n.fire(a)}),this.x.stdin.on("error",a=>{this.n.fire(a)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),L.$c?new Promise((o,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,a,t){if(s)return i(s)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=R.$jc(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(R.$ic(o.program)?n.program=o.program:n.program=R.$jc(i,o.program)),o.args&&(n.args=o.args);const s=o;return s.win&&(n.win=u.A(s.win,i)),s.winx86&&(n.winx86=u.A(s.winx86,i)),s.windows&&(n.windows=u.A(s.windows,i)),s.osx&&(n.osx=u.A(s.osx,i)),s.linux&&(n.linux=u.A(s.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const r of o)if(r.contributes){const c=r.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&w.$jf(h.type,i)).forEach(h=>{const g=u.A(h,r.extensionLocation.fsPath);n=f.$Ln(n,g,r.isBuiltin)})}let s;L.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=n.winx86||n.win||n.windows:L.$c?s=n.win||n.windows:L.$d?s=n.osx:L.$e&&(s=n.linux),s=s||n;const a=s.program||n.program,t=s.args||n.args,d=s.runtime||n.runtime,l=s.runtimeArgs||n.runtimeArgs;if(d)return{type:"executable",command:d,args:(l||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$6jc=u}),define(Se[284],De([1,0,50,34,9]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=e.$7jc=void 0;function R(k,M){return new Promise((I,p)=>{let S="";const E=D.spawn(k,M);E.pid&&E.stdout.on("data",u=>{S+=u.toString()}),E.on("error",u=>{p(u)}),E.on("close",u=>{I(S)})})}async function L(k){if(k)if(f.$c){const M=await new Promise((I,p)=>{re(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{M.getProcessTree(k,p=>{I(!!p&&p.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(k)]).then(M=>{const I=M.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},M=>!0);return Promise.resolve(!0)}e.$7jc=L;var w;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(w||(w={}));function $(k,M,I,p,S){k=k.trim().toLowerCase();let E;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?E=1:k.indexOf("cmd.exe")>=0?E=0:k.indexOf("bash")>=0?E=2:f.$c?E=0:E=2;let u,b=" ";switch(E){case 1:if(u=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),p){const o=(0,O.$kg)(p);o&&(b+=`${o}:; `),b+=`cd ${u(p)}; `}if(S)for(const o in S){const i=S[o];i===null?b+=`Remove-Item env:${o}; `:b+=`\${env:${o}}='${i}'; `}if(M.length>0){const o=M.shift(),i=I?o:u(o);b+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of M)b+=n==="<"||n===">"||I?n:u(n),b+=" "}break;case 0:if(u=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),p){const o=(0,O.$kg)(p);o&&(b+=`${o}: && `),b+=`cd ${u(p)} && `}if(S){b+='cmd /C "';for(const o in S){let i=S[o];i===null?b+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),b+=`set "${o}=${i}" && `)}}for(const o of M)b+=o==="<"||o===">"||I?o:u(o),b+=" ";S&&(b+='"');break;case 2:{u=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(p&&(b+=`cd ${u(p)} ; `),S){b+="/usr/bin/env";for(const i in S){const n=S[i];n===null?b+=` -u ${o(i)}`:b+=` ${o(`${i}=${n}`)}`}b+=" "}for(const i of M)b+=i==="<"||i===">"||I?i:u(i),b+=" ";break}}return b}e.$8jc=$}),define(Se[285],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.CellExecutionUpdateType=void 0;var O;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$8J=(0,D.$ei)("INotebookExecutionService")}),define(Se[286],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gb=e.$0gb=e.ProxyKernelState=e.$9gb=void 0,e.$9gb=100;var O;(function(f){f[f.Disconnected=1]="Disconnected",f[f.Connected=2]="Connected",f[f.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$0gb=(0,D.$ei)("INotebookKernelService"),e.$$gb=(0,D.$ei)("INotebookKernelHistoryService")}),define(Se[287],De([1,0,3,29,187,104]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vTb=void 0;class L extends D.$Tc{constructor($,k,M){super(),this._source=$,this.b=k,this.c=M,this.a=void 0}f($){const k=$.getLineCount();return new O.$7s(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new f.$pC;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:M,disposable:I}=k.create(1);this.b=M,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new f.$pC;k.acceptChunk($);const M=k.finish(!0),{textBuffer:I,disposable:p}=M.create(1);return this.B(p),I})),this.a}findInInputs($){const M=new R.$dC($,!1,!1,null).parseSearchRequest();if(!M)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,M,!0,5e3)}findInOutputs($){const M=new R.$dC($,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(I=>{const p=I.findMatchesLineByLine(this.f(I),M,!0,5e3);if(p.length!==0)return{textBuffer:I,matches:p}}).filter(I=>!!I):[]}}e.$vTb=L}),define(Se[67],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(R){R.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var O;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class f{static fromExtHostTestItem(L,w,$=L.parent){if(L._isRoot)return new f([w]);const k=[L.id];for(let M=$;M&&M.id!==w;M=M.parent)k.push(M.id);return k.push(w),new f(k.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const w=L.indexOf("\0");return w===-1?L:L.slice(0,w)}static fromString(L){return new f(L.split("\0"))}static join(L,w){return new f([...L.path,w])}static joinToString(L,w){return L.toString()+"\0"+w}static parentId(L){const w=L.lastIndexOf("\0");return w===-1?void 0:L.slice(0,w)}static localId(L){const w=L.lastIndexOf("\0");return w===-1?L:L.slice(w+1)}static isChild(L,w){return w.startsWith(L)&&w[L.length]==="\0"}static compare(L,w){return L===w?0:f.isChild(L,w)?2:f.isChild(w,L)?3:1}constructor(L,w=L.length){if(this.path=L,this.d=w,L.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new f(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new f(this.path,L)}compare(L){if(typeof L=="string")return f.compare(this.toString(),L);for(let w=0;w<L.d&&w<this.d;w++)if(L.path[w]!==this.path[w])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$RK=f}),define(Se[89],De([1,0,2,51,29,67]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$YK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$XK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$WK=e.$VK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$UK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$TK=e.$SK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var w;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var $;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$SK=[2,4,8,16,32,64];const k=A=>"runId"in A;e.$TK=k;var M;(function(A){A.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),A.deserialize=(T,F)=>({range:f.$7s.lift(F.range),uri:T.asCanonicalUri(D.URI.revive(F.uri))})})(M||(e.IRichLocation=M={}));var I;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(I||(e.TestMessageType=I={}));var p;(function(A){A.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&M.serialize(T.location)}),A.deserialize=(T,F)=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&M.deserialize(T,F.location)})})(p||(e.ITestErrorMessage=p={}));const S=(A,T)=>`${T?"s":"e"}${A}`;e.$UK=S;var E;(function(A){A.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&M.serialize(T.location)}),A.deserialize=(T,F)=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&M.deserialize(T,F.location)})})(E||(e.ITestOutputMessage=E={}));var u;(function(A){A.serialize=T=>T.type===0?p.serialize(T):E.serialize(T),A.deserialize=(T,F)=>F.type===0?p.deserialize(T,F):E.deserialize(T,F)})(u||(e.ITestMessage=u={}));var b;(function(A){A.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),A.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(u.serialize)}),A.deserialize=(T,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(G=>u.deserialize(T,G))})})(b||(e.ITestTaskState=b={}));const o="\0",i=(A,T)=>A+o+T;e.$VK=i;const n=A=>{const T=A.indexOf(o);return{ctrlId:A.slice(0,T),tagId:A.slice(T+1)}};e.$WK=n;var s;(function(A){A.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),A.deserialize=(T,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?T.asCanonicalUri(D.URI.revive(F.uri)):void 0,range:F.range?f.$7s.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(s||(e.ITestItem=s={}));var a;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(A){A.serialize=T=>({expand:T.expand,item:s.serialize(T.item)}),A.deserialize=(T,F)=>({controllerId:R.$RK.root(F.item.extId),expand:F.expand,item:s.deserialize(T,F.item)})})(t||(e.InternalTestItem=t={}));var d;(function(A){A.serialize=T=>{let F;return T.item&&(F={},T.item.label!==void 0&&(F.label=T.item.label),T.item.tags!==void 0&&(F.tags=T.item.tags),T.item.busy!==void 0&&(F.busy=T.item.busy),T.item.uri!==void 0&&(F.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(F.range=T.item.range?.toJSON()),T.item.description!==void 0&&(F.description=T.item.description),T.item.error!==void 0&&(F.error=T.item.error),T.item.sortText!==void 0&&(F.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:F}},A.deserialize=T=>{let F;return T.item&&(F={},T.item.label!==void 0&&(F.label=T.item.label),T.item.tags!==void 0&&(F.tags=T.item.tags),T.item.busy!==void 0&&(F.busy=T.item.busy),T.item.range!==void 0&&(F.range=T.item.range?f.$7s.lift(T.item.range):null),T.item.description!==void 0&&(F.description=T.item.description),T.item.error!==void 0&&(F.error=T.item.error),T.item.sortText!==void 0&&(F.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:F}}})(d||(e.ITestItemUpdate=d={}));const l=(A,T)=>{T.expand!==void 0&&(A.expand=T.expand),T.item!==void 0&&(A.item=A.item?Object.assign(A.item,T.item):T.item)};e.$XK=l;var r;(function(A){A.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(b.serializeWithoutMessages)}),A.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(b.serialize)}),A.deserialize=(T,F)=>({...t.deserialize(T,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(G=>b.deserialize(T,G)),retired:!0})})(r||(e.TestResultItem=r={}));var c;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(T,F)=>{T.covered+=F.covered,T.total+=F.total}})(c||(e.ICoveredCount=c={}));var h;(function(A){A.serialize=T=>({statement:T.statement,branch:T.branch,declaration:T.declaration,details:T.details?.map(m.serialize),uri:T.uri.toJSON()}),A.deserialize=(T,F)=>({statement:F.statement,branch:F.branch,declaration:F.declaration,details:F.details?.map(m.deserialize),uri:T.asCanonicalUri(D.URI.revive(F.uri))})})(h||(e.IFileCoverage=h={}));function g(A){return{...A,location:A.location?.toJSON()}}function C(A){return A.location=A.location?O.$6s.isIPosition(A.location)?O.$6s.lift(A.location):f.$7s.lift(A.location):void 0,A}e.$YK=3;var v;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(v||(e.DetailType=v={}));var m;(function(A){A.serialize=T=>T.type===0?P.serialize(T):j.serialize(T),A.deserialize=T=>T.type===0?P.deserialize(T):j.deserialize(T)})(m||(e.CoverageDetails=m={}));var y;(function(A){A.serialize=g,A.deserialize=C})(y||(e.IBranchCoverage=y={}));var P;(function(A){A.serialize=g,A.deserialize=C})(P||(e.IDeclarationCoverage=P={}));var j;(function(A){A.serialize=T=>({...g(T),branches:T.branches?.map(y.serialize)}),A.deserialize=T=>({...C(T),branches:T.branches?.map(y.deserialize)})})(j||(e.IStatementCoverage=j={}));var U;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var z;(function(A){A.deserialize=(T,F)=>F.op===0?{op:F.op,item:t.deserialize(T,F.item)}:F.op===1?{op:F.op,item:d.deserialize(F.item)}:F.op===2?{op:F.op,uri:T.asCanonicalUri(D.URI.revive(F.uri)),docv:F.docv}:F,A.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:d.serialize(T.item)}:T})(z||(e.TestsDiffOp=z={}));class N{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const F=this.v();for(const G of T)switch(G.op){case 0:this.l(t.deserialize(this.k,G.item),F);break;case 1:this.o(d.deserialize(G.item),F);break;case 3:this.p(G.itemId,F);break;case 5:this.q(G.itemId);break;case 4:this.updatePendingRoots(G.amount);break;case 6:this.c.set(G.tag.id,G.tag);break;case 7:this.c.delete(G.id);break}F.complete?.()}l(T,F){const G=R.$RK.parentId(T.item.extId)?.toString();let K;if(!G)K=this.w(T),this.g.add(K),this.f.set(T.item.extId,K);else if(this.f.has(G)){const X=this.f.get(G);X.children.add(T.item.extId),K=this.w(T,X),this.f.set(T.item.extId,K)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return F.add?.(K),T.expand===2&&this.h++,K}o(T,F){const G=this.f.get(T.extId);if(G)return T.expand!==void 0&&(G.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$XK)(G,T),F.update?.(G),G}p(T,F){const G=this.f.get(T);if(!G)return;const K=R.$RK.parentId(G.item.extId)?.toString();K?this.f.get(K).children.delete(G.item.extId):this.g.delete(G);const X=[[T]];for(;X.length;)for(const Q of X.pop()){const Z=this.f.get(Q);Z&&(X.push(Z.children),this.f.delete(Q),F.remove?.(Z,Z!==G),Z.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$ZK=N}),define(Se[112],De([1,0,8,4,3,61,89,67]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(i,n)=>i===n,I=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:k,label:k,description:k,error:k,sortText:k,tags:(i,n)=>!(i.length!==n.length||i.some(s=>!n.includes(s)))}),p=(i,n)=>{let s;for(const[a,t]of I)t(i[a],n[a])||(s?s[a]=n[a]:s={[a]:n[a]});return s};class S extends f.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$qh(()=>this.flushDiff(),200)),this.g=this.B(new O.$5d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const s of this.m)if(s.op===2&&s.uri===n.uri){s.docv=n.docv;return}break}case 1:{const s=this.m[this.m.length-1];if(s){if(s.op===1&&s.item.extId===n.item.extId){(0,L.$XK)(s.item,n.item);return}if(s.op===0&&s.item.item.extId===n.item.extId){(0,L.$XK)(s.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,s){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||s>a.expandLevels)&&(a.expandLevels=s),a.expand===1){const t=this.M(a);return t.isOpen()?this.L(a,s-1):t.wait().then(()=>this.L(a,s-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.L(a,s-1)):this.L(a,s-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,s){switch(s.op){case 3:this.O(w.$RK.joinToString(n.fullId,s.id));break;case 0:this.z(s.item,n);break;case 5:for(const a of s.ops)this.w(n,a);break;case 1:this.C(s.new,s.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:s.update}});break;case 6:this.y(n.actual.uri);break;default:(0,R.$9c)(s)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,s){const a=w.$RK.fromExtHostTestItem(n,this.root.id,s?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(n.id);let d=this.tree.get(a.toString());if(!d){d={fullId:a,actual:n,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(n,s),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(n)}}),this.I(n,d,s);return}if(d.actual===n){this.H(n,d,s);return}if(d.actual.uri?.toString()!==n.uri?.toString())return this.O(a.toString()),this.z(n,s);const l=this.s.getChildren(d.actual),r=d.actual,c=p(this.s.toITestItem(r),this.s.toITestItem(n));this.s.getApiFor(r).listener=void 0,d.actual=n,d.expand=0,c&&(c.hasOwnProperty("tags")&&(this.C(n.tags,r.tags,a.toString()),delete c.tags),this.w(d,{op:4,update:c})),this.I(n,d,s);for(const[h,g]of l)this.s.getChildren(n).get(g.id)||this.O(w.$RK.joinToString(a,g.id));this.y(d.actual.uri)}C(n,s,a){const t=new Set(s.map(d=>d.id));for(const d of n)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(d=>(0,L.$VK)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(n){const s=this.j.get(n.id);s?s.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$VK)(this.s.controllerId,n.id)}}))}F(n){const s=this.j.get(n);s&&!--s.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,L.$VK)(this.s.controllerId,n)}))}G(n,s){this.s.getApiFor(n).parent=s&&s.actual!==this.root?s.actual:void 0}H(n,s,a){this.G(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=d=>this.w(s,d),this.J(s)}I(n,s,a){this.H(n,s,a);for(const[t,d]of this.s.getChildren(n))this.z(d,s)}J(n){let s;this.h?n.resolveBarrier?s=n.resolveBarrier.isOpen()?3:2:s=n.actual.canResolveChildren?1:0:s=0,s!==n.expand&&(n.expand=s,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:s}}),s===1&&n.expandLevels!==void 0&&this.M(n))}L(n,s){if(s<0)return;const a=[];for(const[t,d]of this.s.getChildren(n.actual)){const l=this.expand(w.$RK.joinToString(n.fullId,d.id),s);(0,D.$3g)(l)&&a.push(l)}if(a.length)return Promise.all(a).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const d=new D.$dh;return d.open(),d}n.expand=2,this.N(n);const s=n.resolveBarrier=new D.$dh,a=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(d){a(d)}return(0,D.$3g)(t)?t.catch(a).then(()=>{s.open(),this.J(n)}):(s.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const s=this.tree.get(n);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[s];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,l]of this.s.getChildren(t.actual))a.push(this.tree.get(w.$RK.joinToString(t.fullId,l.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$8N=S;class E extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$9N=E;class u extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$0N=u;class b extends Error{constructor(n,s,a){super(`TestItem with ID "${n}" is from controller "${s}" and cannot be added as a child of an item from controller "${a}".`)}}e.$$N=b;const o=(i,n,s)=>{let a=new Map;return{get size(){return a.size},forEach(t,d){for(const l of a.values())t.call(d,l,this)},[Symbol.iterator](){return a.entries()},replace(t){const d=new Map,l=new Set(a.keys()),r={op:5,ops:[]};for(const c of t){if(!(c instanceof s))throw new u(c.id);const h=n(c).controllerId;if(h!==i.controllerId)throw new b(c.id,h,i.controllerId);if(d.has(c.id))throw new E(c.id);d.set(c.id,c),l.delete(c.id),r.ops.push({op:0,item:c})}for(const c of l.keys())r.ops.push({op:3,id:c});i.listener?.(r),a=d},add(t){if(!(t instanceof s))throw new u(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$_N=o}),define(Se[142],De([1,0,112]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=void 0;const O=new WeakMap,f=(L,w)=>{const $={controllerId:w};return O.set(L,$),$};e.$aO=f;const R=L=>{const w=O.get(L);if(!w)throw new D.$0N(L?.id||"<unknown>");return w};e.$bO=R}),define(Se[113],De([1,0,16,2]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kxb=e.$Jxb=e.$Ixb=e.$Hxb=e.$Gxb=void 0,e.$Gxb="vscode-cdn.net",e.$Hxb=`vscode-resource.${e.$Gxb}`,e.$Ixb=`'self' https://*.${e.$Gxb}`;function f(w,$){return w.scheme===D.Schemas.http||w.scheme===D.Schemas.https?w:($&&$.authority&&$.isRemote&&w.scheme===D.Schemas.file&&(w=O.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:w.path})),O.URI.from({scheme:D.Schemas.https,authority:`${w.scheme}+${R(w.authority)}.${e.$Hxb}`,path:w.path,fragment:w.fragment,query:w.query}))}e.$Jxb=f;function R(w){return w.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function L(w){return w.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}e.$Kxb=L}),define(Se[288],De([1,0,4,3,113]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class R{constructor(w,$,k){this.d=w,this.e=$,this.f=k,this.a=0,this.b=new O.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const M=$.getVisibleTextEditors();for(const I of this.c.values())M.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,$,k,M,I){let p;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===w){p=n;break}if(!p)throw new Error("not a visible editor");const S=this,E=this.a++,u=new D.$5d,b=new D.$5d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,f.$Jxb)(n,S.f)}get cspSource(){return f.$Ixb}set options(n){this.b=n,S.d.$setOptions(E,n)}get options(){return this.b}set html(n){this.a=n,S.d.$setHtml(E,n)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(n){return S.d.$postMessage(E,n)}},i=new class{constructor(){this.editor=w,this.line=$,this.height=k,this.webview=o,this.onDidDispose=b.event}dispose(){S.c.has(E)&&(S.c.delete(E),S.d.$disposeEditorInset(E),b.fire(),b.dispose(),u.dispose())}};return this.d.$createEditorInset(E,p.id,p.value.document.uri,$+1,k,M||{},I.identifier,I.extensionLocation),this.c.set(E,{editor:w,inset:i,onDidReceiveMessage:u}),i}$onDidDispose(w){const $=this.c.get(w);$&&$.inset.dispose()}$onDidReceiveMessage(w,$){this.c.get(w)?.onDidReceiveMessage.fire($)}}e.$6hc=R}),define(Se[143],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.$7K=void 0,e.$7K="__",e.$8K=(0,D.$ei)("IAuthenticationService")}),define(Se[289],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.VariableKind=e.$4O=void 0,e.$4O=(0,D.$ei)("configurationResolverService");var O;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class f extends Error{constructor(L,w){super(w),this.variable=L}}e.$5O=f}),define(Se[290],De([1,0,17,49,18,24,9,101,233,289,12]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=void 0;class I{constructor(S,E,u,b){this.h=new Map,this.a=S,this.b=E,this.g=u,b&&(this.c=b.then(o=>this.i(o)))}i(S){if(L.$c){const E=Object.create(null);return Object.keys(S).forEach(u=>{E[u.toLowerCase()]=S[u]}),E}return S}resolveWithEnvironment(S,E,u){return this.l({env:this.i(S),userHome:void 0},E?E.uri:void 0,u)}async resolveAsync(S,E){const u={env:await this.c,userHome:await this.g};return this.l(u,S?S.uri:void 0,E)}async j(S,E,u,b){const o=R.$In(E);L.$c&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):L.$d&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):L.$e&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,S?S.uri:void 0,o,u,b)}async resolveAnyAsync(S,E,u){return this.j(S,E,u)}async resolveAnyMap(S,E,u){const b=new Map;return{newConfig:await this.j(S,E,u,b),resolvedVariables:b}}resolveWithInteractionReplace(S,E,u,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,E,u,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,E){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,E)}async l(S,E,u,b,o){if(f.$Sf(u))return this.m(S,E,u,b,o);if(Array.isArray(u))return Promise.all(u.map(i=>this.l(S,E,i,b,o)));if(f.$Uf(u)){const i=Object.create(null),n=await Promise.all(Object.keys(u).map(async s=>[await this.m(S,E,s,b,o),await this.l(S,E,u[s],b,o)]));for(const[s,a]of n)i[s]=a;return i}return u}m(S,E,u,b,o){return(0,M.$bf)(u,I.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(I.VARIABLE_LHS))return i;let s=await this.o(S,i,n,E,b);return o?.set(n,s),s!==i&&f.$Sf(s)&&s.match(I.VARIABLE_REGEXP)&&(s=await this.m(S,E,s,b,o)),s})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,E,u,b,o){let i;const n=u.split(":");n.length>1&&(u=n[0],i=n[1]);const s=d=>{const l=this.a.getFilePath();if(l)return(0,w.$0v)(l);throw new k.$5O(d,(0,$.localize)(0,null,E))},a=d=>{const l=s(d);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,w.$0v)(r)}throw new k.$5O(d,(0,$.localize)(1,null,E,D.$nc(l)))},t=d=>{if(i){const l=this.a.getFolderUri(i);if(l)return l;throw new k.$5O(d,(0,$.localize)(2,null,E,i))}if(b)return b;throw this.a.getWorkspaceFolderCount()>1?new k.$5O(d,(0,$.localize)(3,null,E)):new k.$5O(d,(0,$.localize)(4,null,E))};switch(u){case"env":if(i){if(S.env){const d=S.env[L.$c?i.toLowerCase():i];if(f.$Sf(d))return d}return""}throw new k.$5O(k.VariableKind.Env,(0,$.localize)(5,null,E));case"config":if(i){const d=this.a.getConfigurationValue(b,i);if(f.$2f(d))throw new k.$5O(k.VariableKind.Config,(0,$.localize)(6,null,E,i));if(f.$Uf(d))throw new k.$5O(k.VariableKind.Config,(0,$.localize)(7,null,E,i));return d}throw new k.$5O(k.VariableKind.Config,(0,$.localize)(8,null,E));case"command":return this.p(k.VariableKind.Command,E,i,o,"command");case"input":return this.p(k.VariableKind.Input,E,i,o,"input");case"extensionInstallFolder":if(i){const d=await this.a.getExtension(i);if(!d)throw new k.$5O(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,E,i));return this.n(d.extensionLocation)}throw new k.$5O(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,E));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,w.$0v)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return b||i?(0,w.$0v)(this.n(t(k.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$0v)(D.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new k.$5O(k.VariableKind.UserHome,(0,$.localize)(11,null,E))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new k.$5O(k.VariableKind.LineNumber,(0,$.localize)(12,null,E))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new k.$5O(k.VariableKind.SelectedText,(0,$.localize)(13,null,E))}case"file":return s(k.VariableKind.File);case"fileWorkspaceFolder":return a(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(a(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return b||i?D.$lc(this.n(t(k.VariableKind.RelativeFile)),s(k.VariableKind.RelativeFile)):s(k.VariableKind.RelativeFile);case"relativeFileDirname":{const d=D.$mc(s(k.VariableKind.RelativeFileDirname));if(b||i){const l=D.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),d);return l.length===0?".":l}return d}case"fileDirname":return D.$mc(s(k.VariableKind.FileDirname));case"fileExtname":return D.$oc(s(k.VariableKind.FileExtname));case"fileBasename":return D.$nc(s(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=D.$nc(s(k.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-D.$oc(d).length)}case"fileDirnameBasename":return D.$nc(D.$mc(s(k.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||E}case"execInstallFolder":{const d=this.a.getAppRoot();return d||E}case"pathSeparator":case"/":return D.sep;default:try{const d=i?`${u}:${i}`:u;return this.p(k.VariableKind.Unknown,E,d,o,void 0)}catch{return E}}}}p(S,E,u,b,o){if(u&&b){const i=o===void 0?b[u]:b[o+":"+u];if(typeof i=="string")return i;throw new k.$5O(S,(0,$.localize)(14,null,E))}return E}}e.$gP=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[144],De([1,0,5,140]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oD=e.$nD=e.OpenEditorContext=e.GroupsOrder=e.$mD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$lD=void 0,e.$lD=(0,D.$ei)("editorGroupsService");var f;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var R;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var w;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EXPAND=1]="EXPAND",E[E.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var $;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(E){const u=E;return(0,O.$8E)(u?.editor)&&(0,O.$8E)(u?.replacement)}e.$mD=k;var M;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var I;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(E){const u=E;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$nD=p;function S(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$oD=S}),define(Se[291],De([1,0,5,144]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=void 0,e.$pD=(0,D.$ei)("editorService"),e.$qD=-1,e.$rD=-2,e.$sD=-3;function f(R){const L=R;return typeof R=="number"||(0,O.$nD)(L)}e.$tD=f}),define(Se[145],De([1,0,5,134]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=void 0,e.$lL=(0,D.$fi)(O.$li)}),define(Se[146],De([1,0,25,4,17,3,8]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=e.$O9b=e.$N9b=e.$M9b=void 0;class w{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$M9b=w;class ${static isHostExtension(i,n,s){if(n.getExtensionDescription(i))return!1;const a=s.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,n){this.j=i,this.c=new O.$5d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(u),this.f=new D.$zm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const s of n)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=b(this.e,n),this.e=this.e.concat(i);const s=$.l(this.e);return this.e=b(this.e,s.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,s)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,r){this.addNode(l),this.addNode(r),this.c.has(l)?this.c.get(l).push(r):this.c.set(l,[r])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,r){const c=n.getArcs(l);for(let h=0;h<c.length;h++)if(!r.has(c[h]))return!1;return!0}getNodes(){return this.e}},s=new D.$zm;for(const l of i)if(s.set(l.identifier,l),l.extensionDependencies)for(const r of l.extensionDependencies)n.addArc(D.$xm.toKey(l.identifier),D.$xm.toKey(r));const a=new Set;n.getNodes().filter(l=>n.getArcs(l).length===0).forEach(l=>a.add(l));const t=n.getNodes().filter(l=>!a.has(l));let d;do{d=!1;for(let l=0;l<t.length;l++){const r=t[l];n.hasOnlyGoodArcs(r,a)&&(t.splice(l,1),l--,a.add(r),d=!0)}}while(d);return t.map(l=>s.get(l))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$N9b=$;class k{constructor(i,n){this.versionId=i,this.extensions=n}}e.$O9b=k;class M{constructor(i){this.d=new S,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new I(this,n)}deltaExtensions(i,n,s){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,s)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$P9b=M;class I extends R.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$Q9b=I;class p{constructor(i){this.name=i;const n=(0,L.$0g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class S{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new p(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const s=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{n&&(clearTimeout(s),n=!1,this.d=!1,this.e())};i.resolve((0,R.$Rc)(a))}}var E;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(E||(E={}));function u(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,s=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==s)return n-s;const a=f.$gc.basename(o.extensionLocation.path),t=f.$gc.basename(i.extensionLocation.path);return a<t?-1:a>t?1:0}function b(o,i){const n=new D.$ym(i);return o.filter(s=>!n.has(s.identifier))}}),define(Se[292],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.ExtHostConnectionType=void 0;var D;(function(M){M[M.IPC=1]="IPC",M[M.Socket=2]="Socket",M[M.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class O{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[O.ENV_KEY]=this.pipeName}}e.$3m=O,O.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class f{constructor(){this.type=2}serialize(I){I[f.ENV_KEY]="1"}}e.$4m=f,f.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(I){I[R.ENV_KEY]="1"}}e.$5m=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function L(M){delete M[O.ENV_KEY],delete M[f.ENV_KEY],delete M[R.ENV_KEY]}function w(M,I){L(I),M.serialize(I)}e.$6m=w;function $(M){if(M[O.ENV_KEY])return k(M,new O(M[O.ENV_KEY]));if(M[f.ENV_KEY])return k(M,new f);if(M[R.ENV_KEY])return k(M,new R);throw new Error("No connection information defined in environment!")}e.$7m=$;function k(M,I){return L(M),I}}),define(Se[114],De([1,0,21]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Gm=e.$Fm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(O||(e.UIKind=O={}));var f;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var R;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(k){const M=D.$se.alloc(1);switch(k){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.$Fm=L;function w(k,M){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.$Gm=w;var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Se[90],De([1,0,5,4,13,27,114,65,87,24,2,3,219]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=e.$yO=e.$xO=e.$wO=void 0;let S=class extends I.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new O.$5d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$5d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$3o,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,f.$Aj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const s=this.getTelemetryDetails(),a=new E(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$ml)((0,$.$9o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,s)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(s):this.r.set(s,a)}),this.r.forEach(n=>{for(const s of n)s.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const s=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!s)return this.r.delete(o.value),!1;let a=!1;for(const t of s)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$wO=S,e.$wO=S=Je([He(0,R.$vO),He(1,f.$zj)],S);class E{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,s,a,t,d){this.g=n,this.h=s,this.i=a,this.j=t,this.a=new O.$5d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,$.$_o)(i,[]),this.c&&(i=(0,k.$Ln)(i,this.c)),this.b||(i=(0,k.$Ln)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},s=(0,$.$_o)(n,[]),a=new Error(s.message,{cause:s.cause});a.stack=s.stack,a.name=s.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$xO=E;function u(b){const o=Date.now()-new Date(b).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$yO=u,e.$zO=(0,D.$ei)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,263,138,25,5]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.ActivationKind=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.ExtensionHostStartup=e.$TF=e.$SF=e.$RF=e.$QF=void 0,e.$QF=Object.freeze({identifier:new L.$xm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$RF="extensions.webWorker",e.$SF=(0,w.$ei)("extensionService");class ${constructor(a){this.dependency=a}}e.$TF=$;var k;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,d){this.c=a,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$BF.createActivationEventsMap(this.d)}}set(a,t,d){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const l=[],r=[],c=[],h=[],g=I(this.d),C=I(t),v=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.d){const z=C.get(U.identifier);if(!z){l.push(U.identifier),g.delete(U.identifier);continue}if(!v(U,z)){l.push(U.identifier),g.delete(U.identifier);continue}}for(const U of t){const z=g.get(U.identifier);if(!z){r.push(U);continue}if(!v(z,U)){l.push(z.identifier),g.delete(z.identifier);continue}}const m=new L.$ym(this.e),y=new L.$ym(d);for(const U of this.e)y.has(U)||c.push(U);for(const U of d)m.has(U)||h.push(U);const P=R.$BF.createActivationEventsMap(r),j={versionId:a,toRemove:l,toAdd:r,addActivationEvents:P,myToRemove:c,myToAdd:h};return this.delta(j),j}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:l,myToAdd:r}=a,c=new L.$ym(t),h=new L.$ym(l);for(let g=0;g<this.d.length;g++)c.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)h.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of d)this.d.push(g);for(const g of r)this.e.push(g);return this.f=null,a}containsExtension(a){for(const t of this.e)if(L.$xm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=R.$BF.readActivationEvents(t);for(const l of d)a.add(l)}return a}}e.$UF=M;function I(s){const a=new L.$zm;for(const t of s)a.set(t.identifier,t);return a}function p(s,a){return!0}e.$VF=p;function S(s,a){if(!p(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.$WF=S;class E{constructor(a,t,d,l){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=l}}e.$XF=E;class u{constructor(a,t){this.description=a,this.value=t}}e.$YF=u;var b;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(b||(e.ActivationKind=b={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,f.$fp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.$ZF=o;function i(s,a){return{identifier:new L.$xm((0,f.$dp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform}}e.$1F=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$2F=n}),define(Se[293],De([1,0,14,146,25,26,13,8]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=e.$ric=e.$qic=e.$pic=void 0;class ${constructor(o,i,n,s){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=s}}e.$pic=$,$.NONE=new $(!1,-1,-1,-1);class k{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$qic=k;class M{constructor(o,i,n,s,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=s,this.exports=a,this.subscriptions=t}}e.$ric=M;class I extends M{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$sic=I;class p extends M{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$tic=p;class S extends M{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(o,i,n,s){this.g=s,this.a=o,this.b=i,this.c=n,this.d=new f.$zm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(s=>({id:s.identifier,reason:{startup:i,extensionId:s.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new S(a));return this.c.onExtensionActivationError(o.id,a,new R.$TF(o.id.value)),t}const n=[],s=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of s){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const d=this.a.getExtensionDescription(a);if(d){if(!d.main&&!d.browser)continue;n.push(this.j({id:d.identifier,reason:o.reason}));continue}const l=i.displayName||i.identifier.value,r=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${a}'`),c=this.k(o,i.displayName,[],new S(r));return this.c.onExtensionActivationError(i.identifier,r,new R.$TF(a)),c}return this.k(o,i.displayName,n,null)}k(o,i,n,s){const a=new u(o.id,i,o.reason,n,s,this.c,this.g);return this.d.set(o.id,a),a}l(o){return O.$N9b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$uic=E,e.$uic=E=Je([He(3,L.$yj)],E);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,s,a,t,d){this.c=o,this.d=i,this.f=n,this.g=s,this.h=a,this.j=t,this.k=d,this.a=new w.$dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new S(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new S(i),this.b&&D.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};u=Je([He(6,L.$yj)],u)}),define(Se[294],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[295],De([1,0,235,14,40,135,108,37,25,294,137,138]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=void 0;const p=w.$Un.as(L.$Vn.JSONContribution);class S{constructor(a,t,d){this.a=a,this.b=t,this.c=d}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$KF=S;class E{static a(a){const t=new $.$ym;for(let d=0,l=a.length;d<l;d++)t.add(a[d].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new E(t,[]);if(!t||!t.length)return new E([],a);const d=this.a(a),l=this.a(t),r=t.filter(h=>!d.has(h.description.identifier)),c=a.filter(h=>!l.has(h.description.identifier));return new E(r,c)}constructor(a,t){this.added=a,this.removed=t}}e.$LF=E;class u{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=E.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,O.$1)(a)}}}e.$MF=u;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$NF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$wm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$zo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$zo}},extensionKind:{description:D.localize(52,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new u(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&I.$BF.register(a.extensionPoint,a.activationEventsGenerator),e.$NF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,p.registerSchema(o,e.$NF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$OF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.$Un.add(n.ExtensionsRegistry,new i),e.$PF=w.$Un.as(n.ExtensionsRegistry),p.registerSchema(o,e.$NF),p.registerSchema(M.$Rj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Se[296],De([1,0,231,18,24,295,45,4]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var k;(function(p){function S(E,u,b){if(!E)return;const o=O.$Sf(E.type)?E.type:void 0;if(!o||o.length===0){b.error(D.localize(3,null));return}const i=[];if(Array.isArray(E.required))for(const n of E.required)O.$Sf(n)&&i.push(n);return{extensionId:u.value,taskType:o,required:i,properties:E.properties?f.$In(E.properties):{},when:E.when?L.$cj.deserialize(E.when):void 0}}p.from=S})(k||(k={}));const M=R.$PF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,S)=>{for(const E of p)E.type&&S.push(`onTaskType:${E.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class I{constructor(){this.d=new w.$5d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,E)=>{M.setHandler((u,b)=>{this.c=void 0;try{for(const o of b.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of b.added){const i=o.value;for(const n of i){const s=k.from(n,o.description.identifier,o.collector);s&&(this.a[s.taskType]=s)}}(b.removed.length>0||b.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const E of this.all()){const u={type:"object",additionalProperties:!1};E.required.length>0&&(u.required=E.required.slice(0)),E.properties!==void 0?u.properties=f.$In(E.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[E.taskType]},S.push(u)}this.c={oneOf:S}}return this.c}}e.$dH=new I}),define(Se[297],De([1,0,232,18,23,24,45,296]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$nH=e.JsonSchemaVersion=e.ExecutionEngine=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$hH=e.ShellQuoting=e.$gH=e.$fH=e.$eH=void 0,e.$eH="settings",e.$fH=new L.$vj("taskRunning",!1,D.localize(0,null)),e.$gH=D.localize2(2,"Tasks");var $;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$hH="$customized",function(A){function T(F){if(!F)return A.Strong;switch(F.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=T}($||(e.ShellQuoting=$={}));var k;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var M;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(M||(e.RevealKind=M={})),function(A){function T(F){switch(F.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=T}(M||(e.RevealKind=M={}));var I;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(A){function T(F){switch(F.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=T}(I||(e.RevealProblemKind=I={}));var p;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(p||(e.PanelKind=p={})),function(A){function T(F){switch(F.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=T}(p||(e.PanelKind=p={}));var S;(function(A){A.defaults={echo:!0,reveal:M.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var E;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(E||(e.RuntimeType=E={})),function(A){function T(G){switch(G.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=T;function F(G){switch(G){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=F}(E||(e.RuntimeType=E={}));var u;(function(A){function T(F){return O.$Sf(F)?F:F.value}A.value=T})(u||(e.CommandString=u={}));var b;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function T(G){return G===A.Clean._id||G===A.Build._id||G===A.Rebuild._id||G===A.Test._id}A.is=T;function F(G){if(G!==void 0)return O.$Sf(G)?T(G)?{_id:G,isDefault:!1}:void 0:G}A.from=F})(b||(e.TaskGroup=b={}));var o;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function T(F){switch(F){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=T})(i||(e.TaskSourceKind=i={}));var n;(function(A){A.parallel="parallel",A.sequence="sequence"})(n||(e.DependsOrder=n={}));var s;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(s||(e.RunOnOptions=s={}));var a;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:s.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(T,F,G,K,X,Q){this._label="",this._id=T,F&&(this._label=F),G&&(this.type=G),this.runOptions=K,this.configurationProperties=X,this._source=Q}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,F=!1){if(T===void 0)return!1;if(O.$Sf(T))return T===this._label||T===this.configurationProperties.identifier||F&&T===this._id;const G=this.getDefinition(!0);return G!==void 0&&G._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$iH=t;class d extends t{constructor(T,F,G,K,X,Q,Z,ie){super(T,G,void 0,Z,ie,F),this.command={},this._source=F,this.hasDefinedMatchers=Q,X&&(this.command=X)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case E.Shell:F="shell";break;case E.Process:F="process";break;case E.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(T){return T instanceof d}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$eH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(F+=this._source.kind);const G={type:e.$hH,folder:T,id:F};return JSON.stringify(G)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Og(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new d(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$jH=d;class l extends t{constructor(T,F,G,K,X,Q,Z){super(T,G,K,Q,Z,F),this._source=F,this.configures=X}static is(T){return T instanceof l}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Og(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$eH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(F+=this._source.kind);const G={type:e.$hH,folder:T,id:F};return JSON.stringify(G)}}e.$kH=l;class r extends t{constructor(T,F,G,K,X,Q,Z,ie,ee){super(T,G,K,ie,ee,F),this.defines=X,this.hasDefinedMatchers=Z,this.command=Q,this.icon=ee.icon,this.hide=ee.hide}clone(){return new r(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof r}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new r(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$lH=r;class c extends t{constructor(T,F,G,K,X,Q){super(T,G,K,X,Q,F),this._source=F}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$mH=c;var h;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(A){A._default=A.Terminal}(h||(e.ExecutionEngine=h={}));var g;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class C{constructor(T){this.c=new Map;for(let F=0;F<T.length;F++)this.c.set(T[F].uri.toString(),F)}compare(T,F){const G=T.getWorkspaceFolder(),K=F.getWorkspaceFolder();if(G&&K){let X=this.c.get(G.uri.toString());X=X===void 0?0:X+1;let Q=this.c.get(K.uri.toString());return Q=Q===void 0?0:Q+1,X===Q?T._label.localeCompare(F._label):X-Q}else return!G&&K?-1:G&&!K?1:0}}e.$nH=C;var v;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(v||(e.TaskEventKind=v={}));var m;(function(A){A.SingleRun="singleRun",A.Background="background"})(m||(e.TaskRunType=m={}));var y;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(A){function T(ie){return{taskId:ie._id,taskName:ie.configurationProperties.name,runType:ie.configurationProperties.isBackground?"background":"singleRun",group:ie.configurationProperties.group,__task:ie}}function F(ie,ee,we){return{...T(ie),kind:"start",terminalId:ee,resolvedVariables:we}}A.start=F;function G(ie,ee,we){return{...T(ie),kind:"processStarted",terminalId:ee,processId:we}}A.processStarted=G;function K(ie,ee,we){return{...T(ie),kind:"processEnded",terminalId:ee,exitCode:we}}A.processEnded=K;function X(ie,ee,we){return{...T(ie),kind:"terminated",exitReason:we,terminalId:ee}}A.terminated=X;function Q(ie,ee,we){return{...T(ee),kind:ie,terminalId:we}}A.general=Q;function Z(){return{kind:"changed"}}A.changed=Z})(P||(e.TaskEvent=P={}));var j;(function(A){function T(G){const K=Object.keys(G).sort();let X="";for(const Q of K){let Z=G[Q];Z instanceof Object?Z=T(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),X+=Q+","+Z+","}return X}function F(G){const X={_key:T(G),type:G.taskType};return Object.assign(X,G),X}A.create=F})(j||(e.KeyedTaskIdentifier=j={}));var U;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var z;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var N;(function(A){function T(F,G){const K=w.$dH.get(F.type);if(K===void 0){const ie=R.$In(F);return delete ie._key,j.create(ie)}const X=Object.create(null);X.type=K.taskType;const Q=new Set;K.required.forEach(ie=>Q.add(ie));const Z=K.properties;for(const ie of Object.keys(Z)){const ee=F[ie];if(ee!=null)X[ie]=ee;else if(Q.has(ie)){const we=Z[ie];if(we.default!==void 0)X[ie]=R.$In(we.default);else switch(we.type){case"boolean":X[ie]=!1;break;case"number":case"integer":X[ie]=0;break;case"string":X[ie]="";break;default:G.error(D.localize(1,null,JSON.stringify(F,void 0,0),ie));return}}}return j.create(X)}A.createTaskIdentifier=T})(N||(e.TaskDefinition=N={}))}),define(Se[298],De([1,0,14]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9b=e.$R9b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,w)=>{this.b=L,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,D.$1)(L))}then(L,w){return this.j().then(L,w)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$R9b=O;class f extends O{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$S9b=f}),define(Se[68],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=void 0;class D{constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$4v=D,D.count=0;const O=[];function f(w){const $=new D(w);return O[$.nid]=$,$}e.$5v=f;function R(w){return O[w].sid}e.$6v=R;class L{constructor($){this.value=$}}e.$7v=L}),define(Se[6],De([1,0,68]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var f;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var R;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var w;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var $;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var M;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class I{static mixin(b){return b._id=I.a++,b}}e.$ZL=I,I.a=0;var p;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var S;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var E;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(E||(e.ExtHostTestingResource=E={})),e.$1L={MainThreadAuthentication:(0,D.$5v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$5v)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$5v)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$5v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$5v)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$5v)("MainThreadClipboard"),MainThreadCommands:(0,D.$5v)("MainThreadCommands"),MainThreadComments:(0,D.$5v)("MainThreadComments"),MainThreadConfiguration:(0,D.$5v)("MainThreadConfiguration"),MainThreadConsole:(0,D.$5v)("MainThreadConsole"),MainThreadDebugService:(0,D.$5v)("MainThreadDebugService"),MainThreadDecorations:(0,D.$5v)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$5v)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$5v)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$5v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$5v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$5v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$5v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$5v)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$5v)("MainThreadErrors"),MainThreadTreeViews:(0,D.$5v)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$5v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$5v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$5v)("MainThreadLanguages"),MainThreadLogger:(0,D.$5v)("MainThreadLogger"),MainThreadMessageService:(0,D.$5v)("MainThreadMessageService"),MainThreadOutputService:(0,D.$5v)("MainThreadOutputService"),MainThreadProgress:(0,D.$5v)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$5v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$5v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$5v)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$5v)("MainThreadSecretState"),MainThreadStorage:(0,D.$5v)("MainThreadStorage"),MainThreadSpeech:(0,D.$5v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$5v)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$5v)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$5v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$5v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$5v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$5v)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$5v)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$5v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$5v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$5v)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$5v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$5v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$5v)("MainThreadExtensionService"),MainThreadSCM:(0,D.$5v)("MainThreadSCM"),MainThreadSearch:(0,D.$5v)("MainThreadSearch"),MainThreadShare:(0,D.$5v)("MainThreadShare"),MainThreadTask:(0,D.$5v)("MainThreadTask"),MainThreadWindow:(0,D.$5v)("MainThreadWindow"),MainThreadLabelService:(0,D.$5v)("MainThreadLabelService"),MainThreadNotebook:(0,D.$5v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$5v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$5v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$5v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$5v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$5v)("MainThreadInteractive"),MainThreadChat:(0,D.$5v)("MainThreadChat"),MainThreadInlineChat:(0,D.$5v)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$5v)("MainThreadTheming"),MainThreadTunnelService:(0,D.$5v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$5v)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$5v)("MainThreadTimeline"),MainThreadTesting:(0,D.$5v)("MainThreadTesting"),MainThreadLocalization:(0,D.$5v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$5v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$5v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$5v)("MainThreadIssueReporter")},e.$2L={ExtHostCommands:(0,D.$5v)("ExtHostCommands"),ExtHostConfiguration:(0,D.$5v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$5v)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$5v)("ExtHostDebugService"),ExtHostDecorations:(0,D.$5v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$5v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$5v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$5v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$5v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$5v)("ExtHostEditors"),ExtHostTreeViews:(0,D.$5v)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$5v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$5v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$5v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$5v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$5v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$5v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$5v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$5v)("ExtHostStatusBar"),ExtHostShare:(0,D.$5v)("ExtHostShare"),ExtHostExtensionService:(0,D.$5v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$5v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$5v)("ExtHostTerminalService"),ExtHostSCM:(0,D.$5v)("ExtHostSCM"),ExtHostSearch:(0,D.$5v)("ExtHostSearch"),ExtHostTask:(0,D.$5v)("ExtHostTask"),ExtHostWorkspace:(0,D.$5v)("ExtHostWorkspace"),ExtHostWindow:(0,D.$5v)("ExtHostWindow"),ExtHostWebviews:(0,D.$5v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$5v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$5v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$5v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$5v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$5v)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$5v)("ExtHostProgress"),ExtHostComments:(0,D.$5v)("ExtHostComments"),ExtHostSecretState:(0,D.$5v)("ExtHostSecretState"),ExtHostStorage:(0,D.$5v)("ExtHostStorage"),ExtHostUrls:(0,D.$5v)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$5v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$5v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$5v)("ExtHostOutputService"),ExtHostLabelService:(0,D.$5v)("ExtHostLabelService"),ExtHostNotebook:(0,D.$5v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$5v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$5v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$5v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$5v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$5v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$5v)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$5v)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$5v)("ExtHostChat"),ExtHostChatAgents2:(0,D.$5v)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$5v)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$5v)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$5v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$5v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$5v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$5v)("ExtHostTheming"),ExtHostTunnelService:(0,D.$5v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$5v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$5v)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$5v)("ExtHostTimeline"),ExtHostTesting:(0,D.$5v)("ExtHostTesting"),ExtHostTelemetry:(0,D.$5v)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$5v)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$5v)("ExtHostIssueReporter")}}),define(Se[91],De([1,0,5,13,6,20]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=e.$Nhc=void 0,e.$Nhc=(0,D.$ei)("IExtHostApiDeprecationService");let L=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(f.$1L.MainThreadTelemetry)}report($,k,M){const I=this.d($,k);this.a.has(I)||(this.a.add(I),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$Ohc=L,e.$Ohc=L=Je([He(0,R.$fO),He(1,O.$yj)],L),e.$Phc=Object.freeze(new class{report(w,$,k){}})}),define(Se[299],De([1,0,48,3,6]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class R{constructor($,k){this.extension=$,this.provider=k,this.handle=R.a++}}R.a=0;class L{constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(f.$1L.MainThreadChat)}registerChatProvider($,k,M){const I=new R($,M);return this.b.set(I.handle,I),this.d.$registerChatProvider(I.handle,k),(0,O.$Rc)(()=>{this.d.$unregisterChatProvider(I.handle),this.b.delete(I.handle)})}transferChatSession($,k){const M=D.Iterable.find(this.c.keys(),I=>this.c.get(I)===$)??0;typeof M=="number"&&this.d.$transferChatSession(M,k)}sendInteractiveRequestToProvider($,k){this.d.$sendRequestToProvider($,k)}async $prepareChat($,k){const M=this.b.get($);if(!M)return;const I=await M.provider.prepareSession(k);if(!I)return;const p=L.a++;return this.c.set(p,I),{id:p,requesterUsername:I.requester?.name,requesterAvatarIconUri:I.requester?.icon,responderUsername:I.responder?.name,responderAvatarIconUri:I.responder?.icon,inputPlaceholder:I.inputPlaceholder}}$releaseSession($){this.c.delete($)}}e.$Zhc=L,L.a=0}),define(Se[300],De([1,0,6]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class O{constructor(R){const L=R.getProxy(D.$1L.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(w){return L.$writeText(w)}})}}e.$4hc=O}),define(Se[301],De([1,0,24,6,27,20]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=void 0;let L=class{constructor(M,I){this.a=M.getProxy(O.$1L.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(M,I){const p=this,S=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){p.e(M,I,S,arguments)}})}e(M,I,p,S){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:$(S,this.b)}),this.c&&this.f(M,p,S)}};e.$Ujc=L,e.$Ujc=L=Je([He(0,R.$fO),He(1,f.$vO)],L);const w=1e5;function $(k,M){const I=[];if(k.length)for(let p=0;p<k.length;p++){let S=k[p];if(typeof S>"u")S="undefined";else if(S instanceof Error){const E=S;E.stack?S=E.stack:S=E.toString()}I.push(S)}if(M){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,D.$Nn)(I);return p.length>w?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(Se[302],De([1,0,2,6,26]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class R{constructor(w){this.a=w.getProxy(O.$1L.MainThreadDialogs)}showOpenDialog(w,$){return $?.allowUIResources&&(0,f.$WF)(w,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(M=>D.URI.revive(M)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then($=>$?D.URI.revive($):void 0)}}e.$Yic=R}),define(Se[303],De([1,0,3,6]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class f{constructor(L){this.b=0,this.a=L.getProxy(O.$1L.MainThreadLabelService)}$registerResourceLabelFormatter(L){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,L),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$hjc=f}),define(Se[115],De([1,0,9,12,2,5,13,6,27,20]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=e.$Gic=void 0;let M=class{constructor(p,S,E){this.f=E,this.d=new Map,this.a=S.getProxy(w.$1L.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===D.$a}getMessage(p,S){const{message:E,args:u,comment:b}=S;if(this.c)return(0,O.$Ue)(E,u??{});let o=E;b&&b.length>0&&(o+=`/${Array.isArray(b)?b.join(""):b}`);const i=this.d.get(p)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$Ue)(i??E,u??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let S;const E=await this.g(p);if(!E){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(E),b=JSON.parse(u);S=p.isBuiltin?b.contents?.bundle:b}catch(u){this.f.error(`Failed to load translations for ${p.identifier.value} from ${E}: ${u.message}`);return}S&&this.d.set(p.identifier.value,{contents:S,uri:E})}async g(p){if(p.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return f.URI.revive(S)}return p.l10n?f.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Gic=M,e.$Gic=M=Je([He(0,$.$vO),He(1,k.$fO),He(2,L.$yj)],M),e.$Hic=(0,R.$ei)("IExtHostLocalizationService")}),define(Se[147],De([1,0,13,6,27,20,2,56]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;let $=class extends D.$Jj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(S=>(0,w.$Nh)(S))),this.r=I.getProxy(O.$1L.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(L.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,S){return new k(this.r,I,p,S)}};e.$Tjc=$,e.$Tjc=$=Je([He(0,R.$fO),He(1,f.$vO)],$);class k extends D.$Ej{constructor(I,p,S,E){super(E?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(p,E).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const S=[[I,p]];this.m?this.u(S):this.n.push(...S)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[116],De([1,0,6,5,3,20,21]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=e.$Iic=void 0,e.$Iic=(0,O.$ei)("IExtHostManagedSockets");let w=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(D.$1L.MainThreadManagedSockets)}setFactory(I,p){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,S=await this.c.makeConnection(),E=new f.$Sc;return this.d.set(p,new k(p,S,E)),E.add((0,f.$Rc)(()=>this.d.delete(p))),E.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),E.dispose()})),E.add(S.onDidClose(u=>{this.a.$onDidManagedSocketClose(p,u?.stack??u?.message),E.dispose()})),E.add(S.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(p,L.$se.wrap(u)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Jic=w,e.$Jic=w=Je([He(0,R.$fO)],w);class ${constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class k extends f.$Tc{constructor(I,p,S){super(),this.socketId=I,this.actual=p,this.B(S)}}}),define(Se[304],De([1,0,6,13,26]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;function R(w){return w&&w.title}let L=class{constructor($,k){this.b=k,this.a=$.getProxy(D.$1L.MainThreadMessageService)}showMessage($,k,M,I,p){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let E;typeof I=="string"||R(I)?E=[I,...p]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,E=p),S.useCustom&&(0,f.$WF)($,"resolvers");const u=[];let b=!1;for(let o=0;o<E.length;o++){const i=E[o];if(typeof i=="string")u.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:s}=i;u.push({title:n,isCloseAffordance:!!s,handle:o}),s&&(b?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):b=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(k,M,S,u).then(o=>{if(typeof o=="number")return E[o]})}};e.$jjc=L,e.$jjc=L=Je([He(1,O.$yj)],L)}),define(Se[305],De([1,0,3,18,2,26,6]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;class w{constructor(k){this.b=new Map,this.a=k.getProxy(L.$1L.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,M,I){if((0,R.$WF)(k,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,I),this.a.$registerProfileContentHandler(M,I.name,I.description,k.identifier.value),(0,D.$Rc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(k,M,I,p){const S=this.b.get(k);if(!S)throw new Error(`Unknown handler with id: ${k}`);return S.saveProfile(M,I,p)}async $readProfile(k,M,I){const p=this.b.get(k);if(!p)throw new Error(`Unknown handler with id: ${k}`);return p.readProfile((0,O.$Sf)(M)?M:f.URI.revive(M),I)}}e.$sjc=w}),define(Se[117],De([1,0,6,4,5]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=void 0;class R{constructor(w){this.b=new O.$5d,this.onDidChangePassword=this.b.event,this.a=w.getProxy(D.$1L.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,$){return this.a.$getPassword(w,$)}store(w,$,k){return this.a.$setPassword(w,$,k)}delete(w,$){return this.a.$deletePassword(w,$)}}e.$Dic=R,e.$Eic=(0,f.$ei)("IExtHostSecretState")}),define(Se[306],De([1,0,22,3,6]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;class R{constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(f.$1L.MainThreadSpeech)}async $createSpeechToTextSession(w,$,k){const M=this.c.get(w);if(!M)return;const I=new O.$Sc,p=new D.$ce;this.d.set($,p);const S=I.add(M.provideSpeechToTextSession(p.token,k?{language:k}:void 0));I.add(S.onDidChange(E=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,E)})),I.add(p.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createKeywordRecognitionSession(w,$){const k=this.c.get(w);if(!k)return;const M=new O.$Sc,I=new D.$ce;this.d.set($,I);const p=M.add(k.provideKeywordRecognitionSession(I.token));M.add(p.onDidChange(S=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),M.add(I.token.onCancellationRequested(()=>M.dispose()))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,$,k){const M=R.a++;return this.c.set(M,k),this.b.$registerProvider(M,$,{extension:w,displayName:w.value}),(0,O.$Rc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$zjc=R,R.a=1}),define(Se[118],De([1,0,6,4,5]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;class R{constructor(w,$){this.c=$,this.b=new O.$5d,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(D.$1L.MainThreadStorage)}registerExtensionStorageKeysToSync(w,$){this.a.$registerExtensionStorageKeysToSync(w,$)}async initializeExtensionStorage(w,$,k){const M=await this.a.$initializeExtensionStorage(w,$);let I;return M&&(I=this.d(w,$,M)),I||k}setValue(w,$,k){return this.a.$setValue(w,$,k)}$acceptValue(w,$,k){const M=this.d(w,$,k);M&&this.b.fire({shared:w,key:$,value:M})}d(w,$,k){try{return JSON.parse(k)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${w}): ${M}`)}}}e.$vic=R,e.$wic=(0,f.$ei)("IExtHostStorage")}),define(Se[307],De([1,0,3,16,2,6]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class L{constructor($){this.c=new Map,this.b=$.getProxy(R.$1L.MainThreadUriOpeners)}registerExternalUriOpener($,k,M,I){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const p=I.schemes.find(S=>!L.a.has(S));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(k,M),this.b.$registerUriOpener(k,I.schemes,$,I.label),(0,D.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,M){const I=this.c.get($);if(!I)throw new Error(`Unknown opener with id: ${$}`);const p=f.URI.revive(k);return I.canOpenExternalUri(p,M)}async $openUri($,k,M){const I=this.c.get($);if(!I)throw new Error(`Unknown opener id: '${$}'`);return I.openExternalUri(f.URI.revive(k.resolvedUri),{sourceUri:f.URI.revive(k.sourceUri)},M)}}e.$Njc=L,L.a=new Set([O.Schemas.http,O.Schemas.https])}),define(Se[308],De([1,0,6,2,3,14,25]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=void 0;class w{constructor(k){this.c=new L.$ym,this.d=new Map,this.b=k.getProxy(D.$1L.MainThreadUrls)}registerUriHandler(k,M){const I=k.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=w.a++;return this.c.add(I),this.d.set(p,M),this.b.$registerUriHandler(p,I,k.displayName||k.name),(0,f.$Rc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(k,M){const I=this.d.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(O.URI.revive(M))}catch(p){(0,R.$1)(p)}return Promise.resolve(void 0)}async createAppUri(k){return O.URI.revive(await this.b.$createAppUri(k))}}e.$Ojc=w,w.a=0});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[92],De([1,0,4,3,16,24,2,239,276,113,6]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";var I,p,S,E,u,b,o,i,n,s,a,t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=e.$iic=e.$hic=e.$gic=void 0;class l{constructor(P,j,U,z,N,A,T){I.set(this,void 0),p.set(this,void 0),S.set(this,void 0),E.set(this,void 0),u.set(this,void 0),b.set(this,void 0),o.set(this,""),i.set(this,void 0),n.set(this,!1),s.set(this,!1),a.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new D.$5d,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new D.$5d),this._onDidDispose=qe(this,d,"f").event,it(this,I,P,"f"),it(this,p,j,"f"),it(this,i,U,"f"),it(this,E,z,"f"),it(this,u,N,"f"),it(this,b,A,"f"),it(this,a,r(A),"f"),it(this,t,c(A),"f"),it(this,S,T,"f")}dispose(){it(this,n,!0,"f"),qe(this,d,"f").fire(),qe(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(P){return it(this,s,!0,"f"),(0,k.$Jxb)(P,qe(this,E,"f"))}get cspSource(){const P=qe(this,b,"f").extensionLocation;if(P.scheme===f.Schemas.https||P.scheme===f.Schemas.http){let j=P.toString();return j.endsWith("/")||(j+="/"),j+" "+k.$Ixb}return k.$Ixb}get html(){return this.a(),qe(this,o,"f")}set html(P){this.a(),qe(this,o,"f")!==P&&(it(this,o,P,"f"),qe(this,t,"f")&&!qe(this,s,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(P)&&(it(this,s,!0,"f"),qe(this,S,"f").report("Webview vscode-resource: uris",qe(this,b,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),qe(this,p,"f").$setHtml(qe(this,I,"f"),this.b(P)))}get options(){return this.a(),qe(this,i,"f")}set options(P){this.a(),R.$Mn(qe(this,i,"f"),P)||qe(this,p,"f").$setOptions(qe(this,I,"f"),C(qe(this,b,"f"),qe(this,u,"f"),P)),it(this,i,P,"f")}async postMessage(P){if(qe(this,n,"f"))return!1;const j=(0,$.$inb)(P,{serializeBuffersForPostMessage:qe(this,a,"f")});return qe(this,p,"f").$postMessage(qe(this,I,"f"),j.message,...j.buffers)}a(){if(qe(this,n,"f"))throw new Error("Webview is disposed")}b(P){if(!qe(this,t,"f"))return P;const j=qe(this,b,"f").extensionLocation?.scheme===f.Schemas.vscodeRemote,U=qe(this,b,"f").extensionLocation.scheme===f.Schemas.vscodeRemote?qe(this,b,"f").extensionLocation.authority:void 0;return P.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,N,A,T,F,G)=>{const K=L.URI.from({scheme:T||"file",path:decodeURIComponent(F)}),X=(0,k.$Jxb)(K,{isRemote:j,authority:U}).toString();return`${N}${X}${G}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,N,A,T,F,G)=>{const K=L.URI.from({scheme:T||"file",path:decodeURIComponent(F)}),X=(0,k.$Jxb)(K,{isRemote:j,authority:U}).toString();return`${N}${X}${G}`})}}e.$gic=l,I=new WeakMap,p=new WeakMap,S=new WeakMap,E=new WeakMap,u=new WeakMap,b=new WeakMap,o=new WeakMap,i=new WeakMap,n=new WeakMap,s=new WeakMap,a=new WeakMap,t=new WeakMap,d=new WeakMap;function r(y){try{const P=(0,w.$op)((0,w.$np)(y.engines.vscode));return!!P&&P.majorBase>=1&&P.minorBase>=57}catch{return!1}}e.$hic=r;function c(y){try{const P=(0,w.$op)((0,w.$np)(y.engines.vscode));return P?P.majorBase<1||P.majorBase===1&&P.minorBase<60:!1}catch{return!1}}class h extends O.$Tc{constructor(P,j,U,z,N){super(),this.c=j,this.f=U,this.g=z,this.h=N,this.b=new Map,this.a=P.getProxy(M.$1L.MainThreadWebviews)}dispose(){super.dispose();for(const P of this.b.values())P.dispose();this.b.clear()}$onMessage(P,j,U){const z=this.j(P);if(z){const{message:N}=(0,$.$jnb)(j,U.value);z._onMessageEmitter.fire(N)}}$onMissingCsp(P,j){this.g.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(P,j,U){const z=new l(P,this.a,v(j),this.c,this.f,U,this.h);this.b.set(P,z);const N=z._onDidDispose(()=>{N.dispose(),this.deleteWebview(P)});return z}deleteWebview(P){this.b.delete(P)}j(P){return this.b.get(P)}}e.$iic=h;function g(y){return{id:y.identifier,location:y.extensionLocation}}e.$jic=g;function C(y,P,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||m(y,P)}}e.$kic=C;function v(y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots?.map(P=>L.URI.from(P))}}function m(y,P){return[...(P?.getWorkspaceFolders()||[]).map(j=>j.uri),y.extensionLocation]}}),define(Se[148],De([1,0,4,6,2,16,12,5,20,26]),function(re,e,D,O,f,R,L,w,$,k){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=e.$Qjc=void 0;let I=M=class{getState(S){const E=this.d;return{get focused(){return E.focused},get active(){return(0,k.$WF)(S,"windowActivity"),E.active}}}constructor(S){this.c=new D.$5d,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=S.getProxy(O.$1L.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:u})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,E){E!==this.d[S]&&(this.d={...this.d,[S]:E},this.c.fire(this.d))}openUri(S,E){let u;if(typeof S=="string"){u=S;try{S=f.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,L.$Se)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,u,E)}async asExternalUri(S,E){if((0,L.$Se)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(S,E);return f.URI.from(u)}};e.$Qjc=I,I.a={focused:!0,active:!0},e.$Qjc=I=M=Je([He(0,$.$fO)],I),e.$Rjc=(0,w.$ei)("IExtHostWindow")}),define(Se[309],De([1,0,301,27,20]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;const R=1024*1024;let L=class extends D.$Ujc{constructor($,k){super($,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,k,M){const I=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),k.apply(console,M),I.write(`
END_NATIVE_LOG
`),this.g=!1}j($,k){const M=process[$],I=M.write;let p="";Object.defineProperty(M,"write",{set:()=>{},get:()=>(S,E,u)=>{if(!this.g){p+=S.toString(E);const b=p.length>R?p.length:p.lastIndexOf(`
`);b!==-1&&(console[k](p.slice(0,b)),p=p.slice(b+1))}I.call(M,S,E,u)}})}};e.$tkc=L,e.$tkc=L=Je([He(0,f.$fO),He(1,O.$vO)],L)}),define(Se[310],De([1,0,147,16,253,30]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class L extends D.$Tjc{s($,k,M){return $.scheme===O.Schemas.file?new f.$sP(M?.name||(0,R.$Ag)(),$.fsPath,!M?.donotRotate,!!M?.donotUseFormatters,k):super.s($,k,M)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Fkc=L}),define(Se[311],De([1,0,8,21,22,14,4,3,128,298,68]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$V9b=e.ResponsiveState=e.RequestInitiator=e.$U9b=e.$T9b=void 0;function p(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const S="$$ref$$",E={[S]:-1};class u{constructor(P,j){this.jsonString=P,this.referencedBuffers=j}}function b(y,P=null,j=!1){const U=[];return{jsonString:(j?p:JSON.stringify)(y,(N,A)=>{if(typeof A>"u")return E;if(typeof A=="object"){if(A instanceof O.$se){const T=U.push(A)-1;return{[S]:T}}if(P)return P(N,A)}return A}),referencedBuffers:U}}e.$T9b=b;function o(y,P,j){return JSON.parse(y,(U,z)=>{if(z){const N=z[S];if(typeof N=="number")return P[N];if(j&&z.$mid===1)return j.transformIncoming(z)}return z})}e.$U9b=o;function i(y,P){return JSON.stringify(y,P)}function n(y){return y?(P,j)=>j&&j.$mid===1?y.transformOutgoing(j):j:null}var s;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var a;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},d=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class r extends w.$Tc{constructor(P,j=null,U=null){super(),this[I]=!0,this.b=this.B(new L.$5d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=j,this.g=U,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,N=M.$4v.count;z<N;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$qh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const j=this.w[P];delete this.w[P],j.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+r.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+r.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$hn)(P,this.g):P}getProxy(P){const{nid:j,sid:U}=P;return this.s[j]||(this.s[j]=this.J(j,U)),this.s[j]}J(P,j){const U={get:(z,N)=>(typeof N=="string"&&!z[N]&&N.charCodeAt(0)===36&&(z[N]=(...A)=>this.U(P,N,A)),N===l?j:z[N])};return new Proxy(Object.create(null),U)}set(P,j){return this.m[P.nid]=j,j}assertRegistered(P){for(let j=0,U=P.length;j<U;j++){const z=P[j];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(P){if(this.j)return;const j=P.byteLength,U=h.read(P,0),z=U.readUInt8(),N=U.readUInt32();switch(z){case 1:case 2:{let{rpcId:A,method:T,args:F}=C.deserializeRequestJSONArgs(U);this.g&&(F=(0,$.$hn)(F,this.g)),this.M(j,N,A,T,F,z===2);break}case 3:case 4:{let{rpcId:A,method:T,args:F}=C.deserializeRequestMixedArgs(U);this.g&&(F=(0,$.$hn)(F,this.g)),this.M(j,N,A,T,F,z===4);break}case 5:{this.f?.logIncoming(j,N,0,"ack"),this.G(N);break}case 6:{this.N(j,N);break}case 7:{this.O(j,N,void 0);break}case 9:{let A=C.deserializeReplyOKJSON(U);this.g&&(A=(0,$.$hn)(A,this.g)),this.O(j,N,A);break}case 10:{const A=C.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(j,N,A);break}case 8:{const A=C.deserializeReplyOKVSBuffer(U);this.O(j,N,A);break}case 11:{let A=C.deserializeReplyErrError(U);this.g&&(A=(0,$.$hn)(A,this.g)),this.P(j,N,A);break}case 12:{this.P(j,N,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,j,U,z,N,A){this.f?.logIncoming(P,j,1,`receiveRequest ${(0,M.$6v)(U)}.${z}(`,N);const T=String(j);let F,G;if(A){const X=new f.$ce;N.push(X.token),F=this.Q(U,z,N),G=()=>X.cancel()}else F=this.Q(U,z,N),G=t;this.u[T]=G;const K=C.serializeAcknowledged(j);this.f?.logOutgoing(K.byteLength,j,1,"ack"),this.c.send(K),F.then(X=>{delete this.u[T];const Q=C.serializeReplyOK(j,X,this.h);this.f?.logOutgoing(Q.byteLength,j,1,"reply:",X),this.c.send(Q)},X=>{delete this.u[T];const Q=C.serializeReplyErr(j,X);this.f?.logOutgoing(Q.byteLength,j,1,"replyErr:",X),this.c.send(Q)})}N(P,j){this.f?.logIncoming(P,j,1,"receiveCancel");const U=String(j);this.u[U]?.()}O(P,j,U){this.f?.logIncoming(P,j,0,"receiveReply:",U);const z=String(j);if(!this.w.hasOwnProperty(z))return;const N=this.w[z];delete this.w[z],N.resolveOk(U)}P(P,j,U){this.f?.logIncoming(P,j,0,"receiveReplyErr:",U);const z=String(j);if(!this.w.hasOwnProperty(z))return;const N=this.w[z];delete this.w[z];let A;U&&(U.$isError?(A=new Error,A.name=U.name,A.message=U.message,A.stack=U.stack):A=U),N.resolveErr(A)}Q(P,j,U){try{return Promise.resolve(this.S(P,j,U))}catch(z){return Promise.reject(z)}}S(P,j,U){const z=this.m[P];if(!z)throw new Error("Unknown actor "+(0,M.$6v)(P));const N=z[j];if(typeof N!="function")throw new Error("Unknown method "+j+" on actor "+(0,M.$6v)(P));return N.apply(z,U)}U(P,j,U){if(this.j)return new k.$S9b;let z=null;if(U.length>0&&f.CancellationToken.isCancellationToken(U[U.length-1])&&(z=U.pop()),z&&z.isCancellationRequested)return Promise.reject(R.$6());const N=C.serializeRequestArguments(U,this.h),A=++this.t,T=String(A),F=new k.$R9b,G=new w.$Sc;z&&G.add(z.onCancellationRequested(()=>{const X=C.serializeCancel(A);this.f?.logOutgoing(X.byteLength,A,0,"cancel"),this.c.send(C.serializeCancel(A))})),this.w[T]=new c(F,G),this.F(A);const K=C.serializeRequest(A,P,j,N,!!z);return this.f?.logOutgoing(K.byteLength,A,0,`request: ${(0,M.$6v)(P)}.${j}(`,U),this.c.send(K),F}}e.$V9b=r,I=d,r.a=3*1e3;class c{constructor(P,j){this.a=P,this.b=j}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,j,U){const z=new h(O.$se.alloc(U+1+4),0);return z.writeUInt8(P),z.writeUInt32(j),z}static read(P,j){return new h(P,j)}get buffer(){return this.a}constructor(P,j){this.a=P,this.b=j}static sizeUInt8(){return 1}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P);return this.b+=P,j}static sizeMixedArray(P){let j=0;j+=1;for(let U=0,z=P.length;U<z;U++){const N=P[U];switch(j+=1,N.type){case 1:j+=this.sizeLongString(N.value);break;case 2:j+=this.sizeVSBuffer(N.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(N.value);for(let A=0;A<N.buffers.length;++A)j+=this.sizeVSBuffer(N.buffers[A]);break;case 4:break}}return j}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let j=0,U=P.length;j<U;j++){const z=P[j];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let N=0;N<z.buffers.length;++N)this.writeBuffer(z.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const j=new Array(P);for(let U=0;U<P;U++)switch(this.readUInt8()){case 1:j[U]=this.readLongString();break;case 2:j[U]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),A=this.readLongString(),T=[];for(let F=0;F<N;++F)T.push(this.readVSBuffer());j[U]=new M.$7v(o(A,T,null));break}case 4:j[U]=void 0;break}return j}}h.sizeUInt32=4;var g;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(g||(g={}));class C{static a(P){for(let j=0,U=P.length;j<U;j++)if(P[j]instanceof O.$se||P[j]instanceof M.$7v||typeof P[j]>"u")return!0;return!1}static serializeRequestArguments(P,j){if(this.a(P)){const U=[];for(let z=0,N=P.length;z<N;z++){const A=P[z];if(A instanceof O.$se)U[z]={type:2,value:A};else if(typeof A>"u")U[z]={type:4};else if(A instanceof M.$7v){const{jsonString:T,referencedBuffers:F}=b(A.value,j);U[z]={type:3,value:O.$se.fromString(T),buffers:F}}else U[z]={type:1,value:O.$se.fromString(i(A,j))}}return{type:1,args:U}}return{type:0,args:i(P,j)}}static serializeRequest(P,j,U,z,N){switch(z.type){case 0:return this.b(P,j,U,z.args,N);case 1:return this.c(P,j,U,z.args,N)}}static b(P,j,U,z,N){const A=O.$se.fromString(U),T=O.$se.fromString(z);let F=0;F+=h.sizeUInt8(),F+=h.sizeShortString(A),F+=h.sizeLongString(T);const G=h.alloc(N?2:1,P,F);return G.writeUInt8(j),G.writeShortString(A),G.writeLongString(T),G.buffer}static deserializeRequestJSONArgs(P){const j=P.readUInt8(),U=P.readShortString(),z=P.readLongString();return{rpcId:j,method:U,args:JSON.parse(z)}}static c(P,j,U,z,N){const A=O.$se.fromString(U);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(A),T+=h.sizeMixedArray(z);const F=h.alloc(N?4:3,P,T);return F.writeUInt8(j),F.writeShortString(A),F.writeMixedArray(z),F.buffer}static deserializeRequestMixedArgs(P){const j=P.readUInt8(),U=P.readShortString(),z=P.readMixedArray(),N=new Array(z.length);for(let A=0,T=z.length;A<T;A++){const F=z[A];typeof F=="string"?N[A]=JSON.parse(F):N[A]=F}return{rpcId:j,method:U,args:N}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,j,U){if(typeof j>"u")return this.d(P);if(j instanceof O.$se)return this.e(P,j);if(j instanceof M.$7v){const{jsonString:z,referencedBuffers:N}=b(j.value,U,!0);return this.g(P,z,N)}else return this.f(P,p(j,U))}static d(P){return h.alloc(7,P,0).buffer}static e(P,j){let U=0;U+=h.sizeVSBuffer(j);const z=h.alloc(8,P,U);return z.writeVSBuffer(j),z.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,j){const U=O.$se.fromString(j);let z=0;z+=h.sizeLongString(U);const N=h.alloc(9,P,z);return N.writeLongString(U),N.buffer}static g(P,j,U){const z=O.$se.fromString(j);let N=0;N+=h.sizeUInt32,N+=h.sizeLongString(z);for(const T of U)N+=h.sizeVSBuffer(T);const A=h.alloc(10,P,N);A.writeUInt32(U.length),A.writeLongString(z);for(const T of U)A.writeBuffer(T);return A.buffer}static deserializeReplyOKJSON(P){const j=P.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(P,j){const U=P.readUInt32(),z=P.readLongString(),N=[];for(let A=0;A<U;++A)N.push(P.readVSBuffer());return new M.$7v(o(z,N,j))}static serializeReplyErr(P,j){const U=j?p(R.$3(j),null):void 0;if(typeof U!="string")return this.h(P);const z=O.$se.fromString(U);let N=0;N+=h.sizeLongString(z);const A=h.alloc(11,P,N);return A.writeLongString(z),A.buffer}static deserializeReplyErrError(P){const j=P.readLongString();return JSON.parse(j)}static h(P){return h.alloc(12,P,0).buffer}}var v;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var m;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(m||(m={}))}),define(Se[312],De([1,0,21,28,16,84,5]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=(0,L.$ei)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${w.join("")}]+`),k=7;function M(S){if(S.scheme!==f.Schemas.vscodeNotebookCell)return;const E=S.fragment.indexOf("s");if(E<0)return;const u=parseInt(S.fragment.substring(0,E).replace($,""),k),b=(0,D.$Le)(S.fragment.substring(E+1)).toString();if(!isNaN(u))return{handle:u,notebook:S.with({scheme:b,fragment:null})}}e.$LJ=M;function I(S,E){const u=E.toString(k),o=`${u.length<w.length?w[u.length-1]:"z"}${u}s${(0,D.$Me)(D.$se.fromString(S.scheme),!0,!0)}`;return S.with({scheme:f.Schemas.vscodeNotebookCell,fragment:o})}e.$MJ=I;class p{constructor(){this.a=new O.$Ac}getNotebook(E){if(E.scheme===f.Schemas.vscodeNotebookCell){const u=M(E);if(u){const b=this.a.get(u.notebook);if(b)return b}}return this.a.get(E)}addNotebookDocument(E){this.a.set(E.uri,E)}removeNotebookDocument(E){this.a.delete(E.uri)}}e.$NJ=p,(0,R.$$r)(e.$KJ,p,1)}),define(Se[119],De([1,0,21,35,48,98,16,17,9,45,312]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.$3J=e.CellStatusbarAlignment=e.$2J=e.$1J=e.$ZJ=e.NotebookEditorPriority=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.CellKind=e.$QJ=e.$PJ=e.$OJ=void 0,e.$OJ="workbench.editor.notebook",e.$PJ="workbench.editor.notebookTextDiffEditor",e.$QJ="workbench.editor.interactive";var I;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(I||(e.CellKind=I={})),e.$RJ=["application/json","application/javascript","text/html","image/svg+xml",R.$rs.latex,R.$rs.markdown,"image/png","image/jpeg",R.$rs.text],e.$SJ=[R.$rs.latex,R.$rs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$rs.text],e.$TJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$UJ="_notAvailable";var p;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var S;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var E;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var u;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(u||(e.NotebookRendererMatch=u={}));var b;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var o;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var s;(function(F){F.scheme=L.Schemas.vscodeNotebookCell;function G(ee,we){return(0,M.$MJ)(ee,we)}F.generate=G;function K(ee){return(0,M.$LJ)(ee)}F.parse=K;function X(ee,we){return ee.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${we??""},${ee.scheme!==L.Schemas.file?ee.scheme:""}`})}F.generateCellOutputUri=X;function Q(ee){if(ee.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const we=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ee.fragment);if(!we)return;const ue=we[1]&&we[1]!==""?we[1]:void 0,ae=we[2];return{outputId:ue,notebook:ee.with({scheme:ae||L.Schemas.file,fragment:null})}}F.parseCellOutputUri=Q;function Z(ee,we,ue){return F.generate(ee,we).with({scheme:ue})}F.generateCellPropertyUri=Z;function ie(ee,we){if(ee.scheme===we)return F.parse(ee.with({scheme:F.scheme}))}F.parseCellPropertyUri=ie})(s||(e.CellUri=s={}));const a=F=>$.$c?F.replace(/\//g,"\\"):F;class t{constructor(G=[],K=e.$RJ){this.e=K,this.d=[...new Set(G)].map(X=>({pattern:X,matches:O.$Xj(a(X))}))}sort(G){const K=new Map(f.Iterable.map(G,Q=>[Q,a(Q)]));let X=[];for(const{matches:Q}of this.d)for(const[Z,ie]of K)if(Q(ie)){X.push(Z),K.delete(Z);break}return K.size&&(X=X.concat([...K.keys()].sort((Q,Z)=>this.e.indexOf(Q)-this.e.indexOf(Z)))),X}prioritize(G,K){const X=this.f(G);if(X===-1){this.d.unshift({pattern:G,matches:O.$Xj(a(G))});return}const Q=new Set(K.map(ie=>this.f(ie,X)));Q.delete(-1);const Z=Array.from(Q).sort();this.d.splice(X+1,0,...Z.map(ie=>this.d[ie]));for(let ie=Z.length-1;ie>=0;ie--)this.d.splice(Z[ie],1)}toArray(){return this.d.map(G=>G.pattern)}f(G,K=this.d.length){const X=a(G);for(let Q=0;Q<K;Q++)if(this.d[Q].matches(X))return Q;return-1}}e.$VJ=t;function d(F,G,K,X=(Q,Z)=>Q===Z){const Q=[];function Z(we,ue,ae){if(ue===0&&ae.length===0)return;const H=Q[Q.length-1];H&&H.start+H.deleteCount===we?(H.deleteCount+=ue,H.toInsert.push(...ae)):Q.push({start:we,deleteCount:ue,toInsert:ae})}let ie=0,ee=0;for(;;){if(ie===F.length){Z(ie,0,G.slice(ee));break}if(ee===G.length){Z(ie,F.length-ie,[]);break}const we=F[ie],ue=G[ee];if(X(we,ue)){ie+=1,ee+=1;continue}K(ue)?(Z(ie,1,[]),ie+=1):(Z(ie,0,[ue]),ee+=1)}return Q}e.$WJ=d,e.$XJ=new k.$vj("notebookEditorCursorAtBoundary","none"),e.$YJ=new k.$vj("notebookEditorCursorAtLineBoundary","none");var l;(function(F){F.default="default",F.option="option"})(l||(e.NotebookEditorPriority=l={}));function r(F){const G=F;return!!((typeof G.include=="string"||O.$Yj(G.include))&&(typeof G.exclude=="string"||O.$Yj(G.exclude)))}e.$ZJ=r;function c(F,G,K){if(Array.isArray(F.viewType)&&F.viewType.indexOf(G)>=0||F.viewType===G)return!0;if(F.filenamePattern){const X=r(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Q=r(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(O.$Wj(X,(0,w.$nc)(K.fsPath).toLowerCase()))return!(Q&&O.$Wj(Q,(0,w.$nc)(K.fsPath).toLowerCase()))}return!1}e.$1J=c,e.$2J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var h;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class g{static create(G){return`${g.d}${G}`}static parse(G){if(G.startsWith(g.d))return G.substring(g.d.length)}}e.$3J=g,g.d="notebook/";function C(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$4J=C;const v=new TextDecoder;function m(F){const G=[];let K=!1;for(const ie of F)(G.length===0||K)&&(G.push(ie),K=!0);let X=j(G);const Q=D.$se.concat(G.map(ie=>D.$se.wrap(ie))),Z=T(Q);return X=X||Z.byteLength!==Q.byteLength,{data:Z,didCompression:X}}e.$5J=m,e.$6J="\x1B[A";const y=e.$6J.split("").map(F=>F.charCodeAt(0)),P=10;function j(F){let G=!1;return F.forEach((K,X)=>{if(X===0||K.length<e.$6J.length)return;const Q=F[X-1],Z=K.subarray(0,e.$6J.length);if(Z[0]===y[0]&&Z[1]===y[1]&&Z[2]===y[2]){const ie=Q.lastIndexOf(P);if(ie===-1)return;G=!0,F[X-1]=Q.subarray(0,ie),F[X]=K.subarray(e.$6J.length)}}),G}function U(F){let G=F;do F=G,G=F.replace(/[^\n]\x08/gm,"");while(G.length<F.length);return F}function z(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const G=F.match(/^(.*)\r+/m)[1];let K=F.match(/\r+(.*)$/m)[1];K=K+G.slice(K.length,G.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,K)}return F}const N=8,A=13;function T(F){return!F.buffer.includes(N)&&!F.buffer.includes(A)?F:D.$se.fromString(z(U(v.decode(F.buffer))))}});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[7],De([1,0,19,14,79,28,98,12,18,2,30,25,32,64,119]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E){"use strict";var u,b,o,i,n,s,a,t,d,l,r,c,h,g,C,v,m,y,P,j,U,z,N,A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$7N=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$UN=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.TestRunProfileKind=e.TestResultState=e.$AN=e.$zN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$yN=e.NotebookVariablesRequestKind=e.$xN=e.$wN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$vN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.ColorThemeKind=e.$pN=e.$oN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$nN=e.$mN=e.DebugConsoleMode=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$gN=e.$fN=e.FileChangeType=e.$eN=e.NewSymbolNameTag=e.$dN=e.$cN=e.$bN=e.$aN=e.InlineCompletionTriggerKind=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.ConfigurationTarget=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$PM=e.ViewBadge=e.ProgressLocation=e.$OM=e.$NM=e.TaskScope=e.ShellQuoting=e.$MM=e.$LM=e.$KM=e.TaskPanelKind=e.TaskRevealKind=e.$JM=e.TerminalLocation=e.$IM=e.$HM=e.$GM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$FM=e.$EM=e.$DM=e.$CM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$BM=e.StatusBarAlignment=e.ViewColumn=e.$AM=e.$zM=e.$yM=e.$xM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$wM=e.$vM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.LanguageStatusSeverity=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.CodeActionTriggerKind=e.$jM=e.$iM=e.SymbolTag=e.SymbolKind=e.$hM=e.$gM=e.DocumentHighlightKind=e.$fM=e.$eM=e.$dM=e.$cM=e.DiagnosticSeverity=e.DiagnosticTag=e.$bM=e.$aM=e.FileEditType=e.$_L=e.$$L=e.$0L=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(J){return Object.assign(J,{apply:function(...pe){if(pe.length===0)return Reflect.construct(J,[]);{const Fe=pe.length===1?[]:pe[1];return Reflect.construct(J,Fe,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(J,[]);{const[Fe,...Ze]=pe;return Reflect.construct(J,Ze,Fe.constructor)}}})}var G;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(G||(e.TerminalOutputAnchor=G={}));var K;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let X=d=class{static from(...W){let pe=W;return new d(function(){if(pe){for(const Fe of pe)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();pe=void 0}})}constructor(W){u.set(this,void 0),it(this,u,W,"f")}dispose(){typeof qe(this,u,"f")=="function"&&(qe(this,u,"f").call(this),it(this,u,void 0,"f"))}};e.$3L=X,u=new WeakMap,e.$3L=X=d=Je([F],X);let Q=l=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Fe=1;Fe<W.length;Fe++){const Ze=W[Fe];Ze.isBefore(pe)&&(pe=Ze)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Fe=1;Fe<W.length;Fe++){const Ze=W[Fe];Ze.isAfter(pe)&&(pe=Ze)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof l)return!0;const{line:pe,character:Fe}=W;return typeof pe=="number"&&typeof Fe=="number"}static of(W){if(W instanceof l)return W;if(this.isPosition(W))return new l(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,O.$7)("line must be non-negative");if(pe<0)throw(0,O.$7)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,O.$7)();let Fe;return typeof W>"u"?Fe=0:typeof W=="number"?Fe=W:(Fe=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Fe===0&&pe===0?this:new l(this.line+Fe,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,O.$7)();let Fe;return typeof W>"u"?Fe=this.line:typeof W=="number"?Fe=W:(Fe=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Fe===this.line&&pe===this.character?this:new l(Fe,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$4L=Q,e.$4L=Q=l=Je([F],Q);let Z=r=class{static isRange(W){return W instanceof r?!0:W?Q.isPosition(W.start)&&Q.isPosition(W.end):!1}static of(W){if(W instanceof r)return W;if(this.isRange(W))return new r(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Fe,Ze){let nt,ht;if(typeof W=="number"&&typeof pe=="number"&&typeof Fe=="number"&&typeof Ze=="number"?(nt=new Q(W,pe),ht=new Q(Fe,Ze)):Q.isPosition(W)&&Q.isPosition(pe)&&(nt=Q.of(W),ht=Q.of(pe)),!nt||!ht)throw new Error("Invalid arguments");nt.isBefore(ht)?(this.c=nt,this.e=ht):(this.c=ht,this.e=nt)}contains(W){return r.isRange(W)?this.contains(W.start)&&this.contains(W.end):Q.isPosition(W)?!(Q.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=Q.Max(W.start,this.c),Fe=Q.Min(W.end,this.e);if(!pe.isAfter(Fe))return new r(pe,Fe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=Q.Min(W.start,this.c),Fe=Q.Max(W.end,this.end);return new r(pe,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,O.$7)();let Fe;return W?Q.isPosition(W)?Fe=W:(Fe=W.start||this.start,pe=W.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&pe.isEqual(this.end)?this:new r(Fe,pe)}toJSON(){return[this.start,this.end]}};e.$5L=Z,e.$5L=Z=r=Je([F],Z);let ie=c=class extends Z{static isSelection(W){return W instanceof c?!0:W?Z.isRange(W)&&Q.isPosition(W.anchor)&&Q.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Fe,Ze){let nt,ht;if(typeof W=="number"&&typeof pe=="number"&&typeof Fe=="number"&&typeof Ze=="number"?(nt=new Q(W,pe),ht=new Q(Fe,Ze)):Q.isPosition(W)&&Q.isPosition(pe)&&(nt=Q.of(W),ht=Q.of(pe)),!nt||!ht)throw new Error("Invalid arguments");super(nt,ht),this.f=nt,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6L=ie,e.$6L=ie=c=Je([F],ie);const ee=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,O.$7)("connectionToken")};class we{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Fe){if(typeof W!="string"||W.length===0)throw(0,O.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,O.$7)("port");typeof Fe<"u"&&ee(Fe),this.host=W,this.port=Math.round(pe),this.connectionToken=Fe}}e.$7L=we;class ue{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&ee(pe)}}e.$8L=ue;class ae extends Error{static NotAvailable(W,pe){return new ae(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new ae(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=S.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(W),this._message=W,this._code=pe,this._detail=Fe,Object.setPrototypeOf(this,ae.prototype)}}e.$9L=ae;var H;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var fe;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let he=h=class{static isTextEdit(W){return W instanceof h?!0:W?Z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new h(W,pe)}static insert(W,pe){return h.replace(new Z(W,W),pe)}static delete(W){return h.replace(W,"")}static setEndOfLine(W){const pe=new h(new Z(new Q(0,0),new Q(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!Z.isRange(W))throw(0,O.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,O.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,O.$7)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0L=he,e.$0L=he=h=Je([F],he);let se=g=class{static isNotebookCellEdit(W){return W instanceof g?!0:W?mt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new g(W,pe)}static insertCells(W,pe){return new g(new mt(W,W),pe)}static deleteCells(W){return new g(W,[])}static updateCellMetadata(W,pe){const Fe=new g(new mt(W,W),[]);return Fe.newCellMetadata=pe,Fe}static updateNotebookMetadata(W){const pe=new g(new mt(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$$L=se,e.$$L=se=g=Je([F],se);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?Z.isRange(W.range)&&q.isSnippetString(W.snippet):!1}static replace(W,pe){return new ce(W,pe)}static insert(W,pe){return ce.replace(new Z(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$_L=ce;var le;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(le||(e.FileEditType=le={}));let de=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Fe,Ze){this.c.push({_type:1,from:W,to:pe,options:Fe,metadata:Ze})}createFile(W,pe,Fe){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Fe})}deleteFile(W,pe,Fe){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Fe})}e(W,pe,Fe){this.c.push({_type:3,metadata:Fe,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Fe,Ze){const nt=pe.start,ht=pe.end;(nt!==ht||Fe.length>0)&&this.c.push({_type:5,uri:W,index:nt,count:ht-nt,cells:Fe,metadata:Ze})}g(W,pe,Fe,Ze){this.c.push({_type:3,metadata:Ze,uri:W,edit:{editType:3,index:pe,metadata:Fe}})}replace(W,pe,Fe,Ze){this.c.push({_type:2,uri:W,edit:new he(pe,Fe),metadata:Ze})}insert(W,pe,Fe,Ze){this.replace(W,new Z(pe,pe),Fe,Ze)}delete(W,pe,Fe){this.replace(W,pe,"",Fe)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Fe of pe){if(!Fe)continue;let Ze,nt;Array.isArray(Fe)?(Ze=Fe[0],nt=Fe[1]):Ze=Fe,se.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(W,Ze.range.start,Ze.newCellMetadata,nt):Ze.newNotebookMetadata?this.e(W,Ze.newNotebookMetadata,nt):this.f(W,Ze.range,Ze.newCells,nt):ce.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:W,range:Ze.range,edit:Ze.snippet,metadata:nt}):this.c.push({_type:2,uri:W,edit:Ze,metadata:nt})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Ze=this.c[Fe];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===W.toString()&&(this.c[Fe]=void 0);break}}(0,D.$Ib)(this.c)}}get(W){const pe=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===W.toString()&&pe.push(Fe.edit);return pe}entries(){const W=new R.$Ac;for(const pe of this.c)if(pe._type===2){let Fe=W.get(pe.uri);Fe||(Fe=[pe.uri,[]],W.set(pe.uri,Fe)),Fe[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aM=de,e.$aM=de=Je([F],de);let q=C=class{static isSnippetString(W){return W instanceof C?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=C.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Fe=new C;Fe.e=this.e,W(Fe),this.e=Fe.e,W=Fe.value}else W=C.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Fe=W.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Fe=new C;Fe.e=this.e,pe(Fe),this.e=Fe.e,pe=Fe.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$bM=q,e.$bM=q=C=Je([F],q);var _;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(_||(e.DiagnosticTag=_={}));var ge;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(ge||(e.DiagnosticSeverity=ge={}));let me=v=class{static isLocation(W){return W instanceof v?!0:W?Z.isRange(W.range)&&k.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(Z.isRange(pe))this.range=Z.of(pe);else if(Q.isPosition(pe))this.range=new Z(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cM=me,e.$cM=me=v=Je([F],me);let Ae=class{static is(W){return W?typeof W.message=="string"&&W.location&&Z.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$dM=Ae,e.$dM=Ae=Je([F],Ae);let ye=class{constructor(W,pe,Fe=ge.Error){if(!Z.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Fe}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,D.$ub)(W.tags,pe.tags)&&(0,D.$ub)(W.relatedInformation,pe.relatedInformation,Ae.isEqual)}};e.$eM=ye,e.$eM=ye=Je([F],ye);let Re=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$fM=Re,e.$fM=Re=Je([F],Re);var Le;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(Le||(e.DocumentHighlightKind=Le={}));let ze=class{constructor(W,pe=Le.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:Le[this.kind]}}};e.$gM=ze,e.$gM=ze=Je([F],ze);let B=class{constructor(W,pe){this.uri=W,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(W=>W.toJSON())}}};e.$hM=B,e.$hM=B=Je([F],B);var V;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(V||(e.SymbolKind=V={}));var x;(function(J){J[J.Deprecated=1]="Deprecated"})(x||(e.SymbolTag=x={}));let Y=m=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Fe,Ze,nt){this.name=W,this.kind=pe,this.containerName=nt,typeof Fe=="string"&&(this.containerName=Fe),Ze instanceof me?this.location=Ze:Fe instanceof Z&&(this.location=new me(Ze,Fe)),m.validate(this)}toJSON(){return{name:this.name,kind:V[this.kind],location:this.location,containerName:this.containerName}}};e.$iM=Y,e.$iM=Y=m=Je([F],Y);let $e=y=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(y.validate)}constructor(W,pe,Fe,Ze,nt){this.name=W,this.detail=pe,this.kind=Fe,this.range=Ze,this.selectionRange=nt,this.children=[],y.validate(this)}};e.$jM=$e,e.$jM=$e=y=Je([F],$e);var ve;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(ve||(e.CodeActionTriggerKind=ve={}));let Te=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$kM=Te,e.$kM=Te=Je([F],Te);let Ve=P=class{constructor(W){this.value=W}append(W){return new P(this.value?this.value+P.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+P.c)}};e.$lM=Ve,Ve.c=".",e.$lM=Ve=P=Je([F],Ve),Ve.Empty=new Ve(""),Ve.QuickFix=Ve.Empty.append("quickfix"),Ve.Refactor=Ve.Empty.append("refactor"),Ve.RefactorExtract=Ve.Refactor.append("extract"),Ve.RefactorInline=Ve.Refactor.append("inline"),Ve.RefactorMove=Ve.Refactor.append("move"),Ve.RefactorRewrite=Ve.Refactor.append("rewrite"),Ve.Source=Ve.Empty.append("source"),Ve.SourceOrganizeImports=Ve.Source.append("organizeImports"),Ve.SourceFixAll=Ve.Source.append("fixAll"),Ve.Notebook=Ve.Empty.append("notebook");let Qe=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$mM=Qe,e.$mM=Qe=Je([F],Qe);class tt{constructor(W,pe,Fe,Ze,nt,ht){this.kind=W,this.name=pe,this.detail=Fe,this.uri=Ze,this.range=nt,this.selectionRange=ht}}e.$nM=tt;class at{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$oM=at;class dt{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$pM=dt;var ot;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(ot||(e.LanguageStatusSeverity=ot={}));let rt=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$qM=rt,e.$qM=rt=Je([F],rt);let Pe=j=class{static isMarkdownString(W){return W instanceof j?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){b.set(this,void 0),it(this,b,new f.$sk(W,{supportThemeIcons:pe}),"f")}get value(){return qe(this,b,"f").value}set value(W){qe(this,b,"f").value=W}get isTrusted(){return qe(this,b,"f").isTrusted}set isTrusted(W){qe(this,b,"f").isTrusted=W}get supportThemeIcons(){return qe(this,b,"f").supportThemeIcons}set supportThemeIcons(W){qe(this,b,"f").supportThemeIcons=W}get supportHtml(){return qe(this,b,"f").supportHtml}set supportHtml(W){qe(this,b,"f").supportHtml=W}get baseUri(){return qe(this,b,"f").baseUri}set baseUri(W){qe(this,b,"f").baseUri=W}appendText(W){return qe(this,b,"f").appendText(W),this}appendMarkdown(W){return qe(this,b,"f").appendMarkdown(W),this}appendCodeblock(W,pe){return qe(this,b,"f").appendCodeblock(pe??"",W),this}};e.$rM=Pe,b=new WeakMap,e.$rM=Pe=j=Je([F],Pe);let Ie=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$sM=Ie,e.$sM=Ie=Je([F],Ie);let Ge=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$tM=Ge,e.$tM=Ge=Je([F],Ge);let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$uM=te,e.$uM=te=Je([F],te);var oe;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(oe||(e.SignatureHelpTriggerKind=oe={}));var Ce;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Ce||(e.InlayHintKind=Ce={}));let Ke=class{constructor(W){this.value=W}};e.$vM=Ke,e.$vM=Ke=Je([F],Ke);let xe=class{constructor(W,pe,Fe){this.position=W,this.label=pe,this.kind=Fe}};e.$wM=xe,e.$wM=xe=Je([F],xe);var st;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Ne;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(Ne||(e.CompletionItemKind=Ne={}));var bt;(function(J){J[J.Deprecated=1]="Deprecated"})(bt||(e.CompletionItemTag=bt={}));let Ct=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$xM=Ct,e.$xM=Ct=Je([F],Ct);let At=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$yM=At,e.$yM=At=Je([F],At);let qt=class{constructor(W,pe,Fe){this.insertText=W,this.range=pe,this.command=Fe}};e.$zM=qt,e.$zM=qt=Je([F],qt);let Gt=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$AM=Gt,e.$AM=Gt=Je([F],Gt);var Rt;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(Rt||(e.ViewColumn=Rt={}));var Zt;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(Zt||(e.StatusBarAlignment=Zt={}));function xt(J,W){return`${I.$xm.toKey(J)}.${W}`}e.$BM=xt;var si;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval"})(si||(e.TextEditorLineNumbersStyle=si={}));var oi;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(oi||(e.TextDocumentSaveReason=oi={}));var et;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(et||(e.TextEditorRevealType=et={}));var jt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var _t;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var $t;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})($t||(e.DecorationRangeBehavior=$t={})),function(J){function W(pe){switch(pe){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(jt||(e.TextEditorSelectionChangeKind=jt={}));var pt;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(pt||(e.SyntaxTokenType=pt={})),function(J){function W(pe){switch(pe){case J.Other:return"other";case J.Comment:return"comment";case J.String:return"string";case J.RegEx:return"regex"}return"other"}J.toString=W}(pt||(e.SyntaxTokenType=pt={}));let Kt=class{constructor(W,pe){if(pe&&!k.URI.isUri(pe))throw(0,O.$7)("target");if(!Z.isRange(W)||W.isEmpty)throw(0,O.$7)("range");this.range=W,this.target=pe}};e.$CM=Kt,e.$CM=Kt=Je([F],Kt);let zt=class{constructor(W,pe,Fe,Ze){this.red=W,this.green=pe,this.blue=Fe,this.alpha=Ze}};e.$DM=zt,e.$DM=zt=Je([F],zt);let Wt=class{constructor(W,pe){if(pe&&!(pe instanceof zt))throw(0,O.$7)("color");if(!Z.isRange(W)||W.isEmpty)throw(0,O.$7)("range");this.range=W,this.color=pe}};e.$EM=Wt,e.$EM=Wt=Je([F],Wt);let ft=class{constructor(W){if(!W||typeof W!="string")throw(0,O.$7)("label");this.label=W}};e.$FM=ft,e.$FM=ft=Je([F],ft);var Mt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Mt||(e.ColorFormat=Mt={}));var ei;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var ti;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));class Xe{constructor(W,pe,Fe){if(this.startIndex=W,this.length=pe,this.tooltip=Fe,typeof W!="number"||W<0)throw(0,O.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,O.$7)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,O.$7)("tooltip")}}e.$GM=Xe;class Vt{constructor(W){this.uri=W}}e.$HM=Vt;class Yt{constructor(W){this.terminalCommand=W}}e.$IM=Yt;var ni;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(ni||(e.TerminalLocation=ni={}));class vt{constructor(W){if(this.options=W,typeof W!="object")throw(0,O.$7)("options")}}e.$JM=vt;var Ut;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(Ut||(e.TaskRevealKind=Ut={}));var Ot;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(Ot||(e.TaskPanelKind=Ot={}));let Lt=U=class{static from(W){switch(W){case"clean":return U.Clean;case"build":return U.Build;case"rebuild":return U.Rebuild;case"test":return U.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,O.$7)("name");this.c=W}get id(){return this.c}};e.$KM=Lt,Lt.Clean=new U("clean","Clean"),Lt.Build=new U("build","Build"),Lt.Rebuild=new U("rebuild","Rebuild"),Lt.Test=new U("test","Test"),e.$KM=Lt=U=Je([F],Lt);function ri(J){let W="";for(let pe=0;pe<J.length;pe++)W+=J[pe].replace(/,/g,",,")+",";return W}let Bt=class{constructor(W,pe,Fe){if(typeof W!="string")throw(0,O.$7)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Fe):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,O.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return ri(W)}};e.$LM=Bt,e.$LM=Bt=Je([F],Bt);let Jt=class{constructor(W,pe,Fe){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,O.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,O.$7)("command");this.e=W,this.f=pe,this.g=Fe}else{if(typeof W!="string")throw(0,O.$7)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,O.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,O.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return ri(W)}};e.$MM=Jt,e.$MM=Jt=Je([F],Jt);var Nt;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Nt||(e.ShellQuoting=Nt={}));var Pt;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Pt||(e.TaskScope=Pt={}));class yt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,M.$Ag)()}set callback(W){this.c=W}get callback(){return this.c}}e.$NM=yt;let kt=z=class{constructor(W,pe,Fe,Ze,nt,ht){this.k=!1,this.l=this.definition=W;let wt;typeof pe=="string"?(this.o=this.name=pe,this.w=this.source=Fe,this.execution=Ze,wt=nt,this.k=!0):pe===Pt.Global||pe===Pt.Workspace?(this.target=pe,this.o=this.name=Fe,this.w=this.source=Ze,this.execution=nt,wt=ht):(this.target=pe,this.o=this.name=Fe,this.w=this.source=Ze,this.execution=nt,wt=ht),typeof wt=="string"?(this.r=[wt],this.t=!0):Array.isArray(wt)?(this.r=wt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(W){this.j=W}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:z.e,id:this.q.computeId()}:this.q instanceof Jt?this.l={type:z.f,id:this.q.computeId()}:this.q instanceof yt?this.l={type:z.c,id:this.q.computeId()}:this.l={type:z.g,id:(0,M.$Ag)()}}get definition(){return this.l}set definition(W){if(W==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=W}get scope(){return this.m}set target(W){this.B(),this.m=W}get name(){return this.o}set name(W){if(typeof W!="string")throw(0,O.$7)("name");this.B(),this.o=W}get execution(){return this.q}set execution(W){W===null&&(W=void 0),this.B(),this.q=W;const pe=this.l.type;(z.g===pe||z.e===pe||z.f===pe||z.c===pe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(W){if(Array.isArray(W))this.B(),this.r=W,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.B(),this.u=W}get source(){return this.w}set source(W){if(typeof W!="string"||W.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=W}get group(){return this.x}set group(W){W===null&&(W=void 0),this.B(),this.x=W}get detail(){return this.A}set detail(W){W===null&&(W=void 0),this.A=W}get presentationOptions(){return this.y}set presentationOptions(W){W==null&&(W=Object.create(null)),this.B(),this.y=W}get runOptions(){return this.z}set runOptions(W){W==null&&(W=Object.create(null)),this.B(),this.z=W}};e.$OM=kt,kt.c="customExecution",kt.e="process",kt.f="shell",kt.g="$empty",e.$OM=kt=z=Je([F],kt);var St;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(St||(e.ProgressLocation=St={}));var mi;(function(J){function W(pe){const Fe=pe;return(0,$.$Wf)(Fe.value)?Fe.tooltip&&!(0,$.$Sf)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}J.isViewBadge=W})(mi||(e.ViewBadge=mi={}));let Qt=N=class{static isTreeItem(W,pe){const Fe=W;if(Fe.checkboxState!==void 0){const Ze=(0,$.$Wf)(Fe.checkboxState)?Fe.checkboxState:(0,$.$Uf)(Fe.checkboxState)&&(0,$.$Wf)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,nt=!(0,$.$Wf)(Fe.checkboxState)&&(0,$.$Uf)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Me.Checked&&Ze!==Me.Unchecked||nt!==void 0&&!(0,$.$Sf)(nt))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(W instanceof N)return!0;if(Fe.label!==void 0&&!(0,$.$Sf)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,$.$Sf)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,$.$Sf)(Fe.iconPath)&&!k.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,$.$Sf)(Fe.iconPath.id))){const Ze=Fe.iconPath;if(!Ze||!(0,$.$Sf)(Ze.light)&&!k.URI.isUri(Ze.light)&&!(0,$.$Sf)(Ze.dark)&&!k.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,$.$Sf)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!k.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,$.$Sf)(Fe.tooltip)&&!(Fe.tooltip instanceof Pe)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<hi.None&&Fe.collapsibleState>hi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,$.$Sf)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(W,pe=hi.None){this.collapsibleState=pe,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$PM=Qt,e.$PM=Qt=N=Je([F],Qt);var hi;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(hi||(e.TreeItemCollapsibleState=hi={}));var Me;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(Me||(e.TreeItemCheckboxState=Me={}));let je=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$QM=je,e.$QM=je=Je([F],je);class Ee extends je{}e.$RM=Ee;class ne extends Ee{constructor(W){super(""),o.set(this,void 0),it(this,o,W,"f")}asFile(){return qe(this,o,"f")}}e.$SM=ne,o=new WeakMap;class Oe{constructor(W,pe,Fe,Ze){this.name=W,this.uri=pe,this._itemId=Fe,this.c=Ze}data(){return this.c()}}e.$TM=Oe;let Ue=class{constructor(W){i.add(this),n.set(this,new Map);for(const[pe,Fe]of W??[]){const Ze=qe(this,n,"f").get(qe(this,i,"m",s).call(this,pe));Ze?Ze.push(Fe):qe(this,n,"f").set(qe(this,i,"m",s).call(this,pe),[Fe])}}get(W){return qe(this,n,"f").get(qe(this,i,"m",s).call(this,W))?.[0]}set(W,pe){qe(this,n,"f").set(qe(this,i,"m",s).call(this,W),[pe])}forEach(W,pe){for(const[Fe,Ze]of qe(this,n,"f"))for(const nt of Ze)W.call(pe,nt,Fe,this)}*[(n=new WeakMap,i=new WeakSet,Symbol.iterator)](){for(const[W,pe]of qe(this,n,"f"))for(const Fe of pe)yield[W,Fe]}};e.$UM=Ue,s=function(W){return W.toLowerCase()},e.$UM=Ue=Je([F],Ue);let _e=class{constructor(W){this.insertText=W}};e.$VM=_e,e.$VM=_e=Je([F],_e);let Ye=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$WM=Ye,e.$WM=Ye=Je([F],Ye);let lt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$XM=lt,e.$XM=lt=Je([F],lt),lt.File=new lt("file"),lt.Folder=new lt("folder");let Dt=class{constructor(W){this.id=W}};e.$YM=Dt,e.$YM=Dt=Je([F],Dt);var Xt;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(Xt||(e.ConfigurationTarget=Xt={}));let It=class{get base(){return this.c}set base(W){this.c=W,this.e=k.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,O.$7)("base");if(typeof pe!="string")throw(0,O.$7)("pattern");typeof W=="string"?this.baseUri=k.URI.file(W):k.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ZM=It,e.$ZM=It=Je([F],It);const Tt=new WeakMap;function ii(J,W){Tt.set(J,W)}e.$1M=ii;let ci=class{constructor(W,pe,Fe,Ze,nt){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Ze=="string"&&(this.logMessage=Ze),typeof nt=="string"&&(this.mode=nt)}get id(){return this.c||(this.c=Tt.get(this)??(0,M.$Ag)()),this.c}};e.$2M=ci,e.$2M=ci=Je([F],ci);let pi=class extends ci{constructor(W,pe,Fe,Ze,nt,ht){if(super(pe,Fe,Ze,nt,ht),W===null)throw(0,O.$7)("location");this.location=W}};e.$3M=pi,e.$3M=pi=Je([F],pi);let gt=class extends ci{constructor(W,pe,Fe,Ze,nt,ht){super(pe,Fe,Ze,nt,ht),this.functionName=W}};e.$4M=gt,e.$4M=gt=Je([F],gt);let Fi=class extends ci{constructor(W,pe,Fe,Ze,nt,ht,wt,Ht){if(super(Ze,nt,ht,wt,Ht),!pe)throw(0,O.$7)("dataId");this.label=W,this.dataId=pe,this.canPersist=Fe}};e.$5M=Fi,e.$5M=Fi=Je([F],Fi);let li=class{constructor(W,pe,Fe){this.command=W,this.args=pe||[],this.options=Fe}};e.$6M=li,e.$6M=li=Je([F],li);let $i=class{constructor(W,pe){this.port=W,this.host=pe}};e.$7M=$i,e.$7M=$i=Je([F],$i);let Si=class{constructor(W){this.path=W}};e.$8M=Si,e.$8M=Si=Je([F],Si);let Ni=class{constructor(W){this.implementation=W}};e.$9M=Ni,e.$9M=Ni=Je([F],Ni);let Ti=class{constructor(W,pe,Fe){this.session=W,this.threadId=pe,this.frameId=Fe}};e.$0M=Ti,e.$0M=Ti=Je([F],Ti);let ji=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$$M=ji,e.$$M=ji=Je([F],ji);let Di=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$_M=Di,e.$_M=Di=Je([F],Di);var Ji;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Ci=class{constructor(W,pe){this.range=W,this.text=pe}};e.$aN=Ci,e.$aN=Ci=Je([F],Ci);let di=class{constructor(W,pe,Fe=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Fe}};e.$bN=di,e.$bN=di=Je([F],di);let zi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$cN=zi,e.$cN=zi=Je([F],zi);let vi=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$dN=vi,e.$dN=vi=Je([F],vi);var Ii;(function(J){J[J.AIGenerated=1]="AIGenerated"})(Ii||(e.NewSymbolNameTag=Ii={}));class fn{constructor(W,pe){this.newSymbolName=W,this.tags=pe}}e.$eN=fn;var Qi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let bi=A=class extends Error{static FileExists(W){return new A(W,p.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(W){return new A(W,p.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(W){return new A(W,p.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(W){return new A(W,p.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(W){return new A(W,p.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(W){return new A(W,p.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}constructor(W,pe=p.FileSystemProviderErrorCode.Unknown,Fe){super(k.URI.isUri(W)?W.toString(!0):W),this.code=Fe?.name??"Unknown",(0,p.$Qk)(this,pe),Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$fN=bi,e.$fN=bi=A=Je([F],bi);let Ui=class{constructor(W,pe,Fe){this.start=W,this.end=pe,this.kind=Fe}};e.$gN=Ui,e.$gN=Ui=Je([F],Ui);var Xi;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Yi;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(Yi||(e.CommentThreadCollapsibleState=Yi={}));var yi;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(yi||(e.CommentMode=yi={}));var Zi;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var xi;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(xi||(e.CommentThreadState=xi={}));class Bi{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$hN=Bi;function _i(J){return typeof J>"u"||(0,$.$Tf)(J)}class Wi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,W){this.m=!0;for(let pe=0,Fe=W.tokenTypes.length;pe<Fe;pe++)this.k.set(W.tokenTypes[pe],pe);for(let pe=0,Fe=W.tokenModifiers.length;pe<Fe;pe++)this.l.set(W.tokenModifiers[pe],pe)}}push(W,pe,Fe,Ze,nt){if(typeof W=="number"&&typeof pe=="number"&&typeof Fe=="number"&&typeof Ze=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.q(W,pe,Fe,Ze,nt);if(Z.isRange(W)&&typeof pe=="string"&&_i(Fe))return this.o(W,pe,Fe);throw(0,O.$7)()}o(W,pe,Fe){if(!this.m)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ze=W.start.line,nt=W.start.character,ht=W.end.character-W.start.character,wt=this.k.get(pe);let Ht=0;if(Fe)for(const ai of Fe){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const ui=this.l.get(ai);Ht|=1<<ui>>>0}this.q(Ze,nt,ht,wt,Ht)}q(W,pe,Fe,Ze,nt){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ai=0,ui=0;for(let gi=0;gi<Ht;gi++){let wi=this.g[5*gi],Gi=this.g[5*gi+1];wi===0?(wi=ai,Gi+=ui):wi+=ai,this.g[5*gi]=wi,this.g[5*gi+1]=Gi,ai=wi,ui=Gi}}let ht=W,wt=pe;this.f&&this.j>0&&(ht-=this.c,ht===0&&(wt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=wt,this.g[this.j++]=Fe,this.g[this.j++]=Ze,this.g[this.j++]=nt,this.c=W,this.e=pe}static r(W){const pe=[],Fe=W.length/5|0;for(let wt=0;wt<Fe;wt++)pe[wt]=wt;pe.sort((wt,Ht)=>{const ai=W[5*wt],ui=W[5*Ht];if(ai===ui){const gi=W[5*wt+1],wi=W[5*Ht+1];return gi-wi}return ai-ui});const Ze=new Uint32Array(W.length);let nt=0,ht=0;for(let wt=0;wt<Fe;wt++){const Ht=5*pe[wt],ai=W[Ht+0],ui=W[Ht+1],gi=W[Ht+2],wi=W[Ht+3],Gi=W[Ht+4],Fn=ai-nt,cr=Fn===0?ui-ht:ui,Ki=5*wt;Ze[Ki+0]=Fn,Ze[Ki+1]=cr,Ze[Ki+2]=gi,Ze[Ki+3]=wi,Ze[Ki+4]=Gi,nt=ai,ht=ui}return Ze}build(W){return this.f?new Pi(new Uint32Array(this.g),W):new Pi(Wi.r(this.g),W)}}e.$iN=Wi;class Pi{constructor(W,pe){this.resultId=pe,this.data=W}}e.$jN=Pi;class en{constructor(W,pe,Fe){this.start=W,this.deleteCount=pe,this.data=Fe}}e.$kN=en;class gn{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$lN=gn;var tn;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(tn||(e.DebugConsoleMode=tn={}));class mn{constructor(W){this.name=W}}e.$mN=mn;let Ai=class{constructor(){}};e.$nN=Ai,Ai.Back={iconPath:new lt("arrow-left")},e.$nN=Ai=Je([F],Ai);var Ri;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(Ri||(e.QuickPickItemKind=Ri={}));var qi;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(qi||(e.InputBoxValidationSeverity=qi={}));var Be;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(Be||(e.ExtensionKind=Be={}));class fi{static validate(W){if(typeof W.badge=="string"){let pe=(0,w.$tf)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,w.$tf)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!lt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Fe){this.badge=W,this.tooltip=pe,this.color=Fe}}e.$oN=fi;let Li=class{constructor(W){this.kind=W}};e.$pN=Li,e.$pN=Li=Je([F],Li);var ct;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(ct||(e.ColorThemeKind=ct={}));class mt{static isNotebookRange(W){return W instanceof mt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,O.$7)("start must be positive");if(pe<0)throw(0,O.$7)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Fe=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Fe=W.end),pe===this.c&&Fe===this.e?this:new mt(pe,Fe)}}e.$qN=mt;class Mi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>Mi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Fe,Ze,nt,ht,wt){this.kind=W,this.value=pe,this.languageId=Fe,this.mime=Ze,this.outputs=nt??[],this.metadata=ht,this.executionSummary=wt,Mi.validate(this)}}e.$rN=Mi;class $n{constructor(W){this.cells=W}}e.$sN=$n;class Vi{static isNotebookCellOutputItem(W){return W instanceof a?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return a.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return a.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return a.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new a(W,pe)}static text(W,pe=L.$rs.text){const Fe=qe(a,a,"f",t).encode(String(W));return new a(Fe,pe)}static json(W,pe="text/x-json"){const Fe=JSON.stringify(W,void 0,"	");return a.text(Fe,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Fe=(0,L.$vs)(pe,!0);if(!Fe)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$tN=Vi,a=Vi,t={value:new TextEncoder};class Oi{static isNotebookCellOutput(W){return W instanceof Oi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Fe=new Set,Ze=new Set;for(let nt=0;nt<W.length;nt++){const ht=W[nt],wt=(0,L.$vs)(ht.mime);if(!Fe.has(wt)||(0,E.$4J)(wt)){Fe.add(wt);continue}Ze.add(nt),pe&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ze.size===0?W:W.filter((nt,ht)=>!Ze.has(ht))}constructor(W,pe,Fe){this.items=Oi.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Fe):(this.id=(0,M.$Ag)(),this.metadata=pe??Fe)}}e.$uN=Oi;var Ei;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var nn;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class on{constructor(W,pe){this.text=W,this.alignment=pe}}e.$vN=on;var an;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(an||(e.NotebookControllerAffinity=an={}));var cn;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(cn||(e.NotebookControllerAffinity2=cn={}));class bn{constructor(W,pe=[]){this.uri=W,this.provides=(0,D.$3b)(pe)}}e.$wN=bn;class wn{constructor(W){this.label=W}}e.$xN=wn;var ln;(function(J){J[J.Named=1]="Named",J[J.Indexed=2]="Indexed"})(ln||(e.NotebookVariablesRequestKind=ln={}));let Hi=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$yN=Hi,e.$yN=Hi=Je([F],Hi);var un;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var hn;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(hn||(e.ExtensionRuntime=hn={}));var dn;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(dn||(e.StandardTokenType=dn={}));class pn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$zN=pn;class vn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$AN=vn;var be;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(be||(e.TestResultState=be={}));var ke;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(ke||(e.TestRunProfileKind=ke={}));let We=class{constructor(W=void 0,pe=void 0,Fe=void 0,Ze=!1){this.include=W,this.exclude=pe,this.profile=Fe,this.continuous=Ze}};e.$BN=We,e.$BN=We=Je([F],We);let ut=T=class{static diff(W,pe,Fe){const Ze=new T(W);return Ze.expectedOutput=pe,Ze.actualOutput=Fe,Ze}constructor(W){this.message=W}};e.$CN=ut,e.$CN=ut=T=Je([F],ut);let Et=class{constructor(W){this.id=W}};e.$DN=Et,e.$DN=Et=Je([F],Et);class Ft{constructor(W,pe){this.covered=W,this.total=pe}}e.$EN=Ft;const ki=J=>{if(J&&J.covered>J.total)throw new Error(`The total number of covered items (${J.covered}) cannot be greater than the total (${J.total})`)};class yn{static fromDetails(W,pe){const Fe=new Ft(0,0),Ze=new Ft(0,0),nt=new Ft(0,0);for(const wt of pe)if("branches"in wt){Fe.total+=1,Fe.covered+=wt.executed?1:0;for(const Ht of wt.branches)Ze.total+=1,Ze.covered+=Ht.executed?1:0}else nt.total+=1,nt.covered+=wt.executed?1:0;const ht=new yn(W,Fe,Ze.total>0?Ze:void 0,nt.total>0?nt:void 0);return ht.detailedCoverage=pe,ht}constructor(W,pe,Fe,Ze){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Fe,this.declarationCoverage=Ze,ki(pe),ki(Fe),ki(Ze)}}e.$FN=yn;class Nn{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,pe,Fe=[]){this.executed=W,this.location=pe,this.branches=Fe}}e.$GN=Nn;class Tn{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,pe,Fe){this.executed=W,this.location=pe,this.label=Fe}}e.$HN=Tn;class jn{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,pe,Fe){this.name=W,this.executed=pe,this.location=Fe}}e.$IN=jn;var En;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(En||(e.ExternalUriOpenerPriority=En={}));var kn;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(kn||(e.WorkspaceTrustState=kn={}));var Sn;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn||(e.PortAutoForwardAction=Sn={}));class zn{constructor(W,pe,Fe,Ze,nt,ht){this.kind=W,this.name=pe,this.detail=Fe,this.uri=Ze,this.range=nt,this.selectionRange=ht}}e.$JN=zn;class Un{constructor(W){this.uri=W}}e.$KN=Un;class Bn{constructor(W,pe){this.original=W,this.modified=pe}}e.$LN=Bn;class Wn{constructor(W,pe,Fe,Ze){this.base=W,this.input1=pe,this.input2=Fe,this.result=Ze}}e.$MN=Wn;class qn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$NN=qn;class Vn{constructor(W){this.viewType=W}}e.$ON=Vn;class Hn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$PN=Hn;class Gn{constructor(W,pe,Fe){this.original=W,this.modified=pe,this.notebookType=Fe}}e.$QN=Gn;class Kn{constructor(){}}e.$RN=Kn;class Jn{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$SN=Jn;class Qn{constructor(W){this.providerId=W}}e.$TN=Qn;var Dn;(function(J){J[J.Down=0]="Down",J[J.Up=1]="Up"})(Dn||(e.InteractiveSessionVoteDirection=Dn={}));var Cn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var In;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class Xn{constructor(W,pe){this.label=W,this.values=pe}}e.$UN=Xn;var Pn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted",J[J.Bug=4]="Bug"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}));var An;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful"})(An||(e.ChatResultFeedbackKind=An={}));class Yn{constructor(W){this.value=typeof W=="string"?new Pe(W):W}}e.$VN=Yn;class Zn{constructor(W,pe){this.value=W,this.baseUri=pe}}e.$WN=Zn;class xn{constructor(W,pe){this.value=W,this.title=pe}}e.$XN=xn;class _n{constructor(W){this.value=W}}e.$YN=_n;class er{constructor(W){this.value=W}}e.$ZN=er;class tr{constructor(W){this.value=W}}e.$1N=tr;class ir{constructor(W,pe,Fe,Ze){this.prompt=W,this.command=pe,this.variables=Fe,this.participant=Ze}}e.$2N=ir;class nr{constructor(W,pe,Fe,Ze){this.response=W,this.result=pe,this.participant=Fe,this.command=Ze}}e.$3N=nr;class rr{constructor(W){this.content=W}}e.$4N=rr;class sr{constructor(W,pe){this.content=W,this.name=pe}}e.$5N=sr;class or{constructor(W){this.content=W}}e.$6N=or;var Rn;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var Ln;(function(J){J[J.Started=1]="Started",J[J.Recognizing=2]="Recognizing",J[J.Recognized=3]="Recognized",J[J.Stopped=4]="Stopped"})(Ln||(e.SpeechToTextStatus=Ln={}));var Mn;(function(J){J[J.Recognized=1]="Recognized",J[J.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class ar{constructor(W,pe){this.text=W,this.range=pe}}e.$7N=ar;var On;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(Se[313],De([1,0,6,7]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class f{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$1L.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,w,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(L);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(w,$)??[]}getRelatedInformation(L,w,$){return this.c.$getAiRelatedInformation(w,$)}registerRelatedInformationProvider(L,w,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,w),new O.$3L(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Mhc=f}),define(Se[314],De([1,0,4,6,7,25,143]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class w{constructor(M){this.b=new Map,this.c=new D.$5d,this.onDidChangeSessions=this.c.event,this.d=new $,this.f=new $,this.a=M.getProxy(O.$1L.MainThreadAuthentication)}async getSession(M,I,p,S={}){const E=R.$xm.toKey(M.identifier),u=[...p].sort().join(" ");return await this.d.getOrCreate(`${E} ${I} ${u}`,async()=>{await this.a.$ensureProvider(I);const b=M.displayName||M.name;return this.a.$getSession(I,p,E,b,S)})}async getSessions(M,I,p){const S=R.$xm.toKey(M.identifier),E=[...p].sort().join(" ");return await this.f.getOrCreate(`${S} ${E}`,async()=>{await this.a.$ensureProvider(I);const u=M.displayName||M.name;return this.a.$getSessions(I,p,S,u)})}async removeSession(M,I){const p=this.b.get(M);return p?p.provider.removeSession(I):this.a.$removeSession(M,I)}registerAuthenticationProvider(M,I,p,S){if(this.b.get(M))throw new Error(`An authentication provider with id '${M}' is already registered.`);this.b.set(M,{label:I,provider:p,options:S??{supportsMultipleAccounts:!1}});const E=p.onDidChangeSessions(u=>this.a.$sendDidChangeSessions(M,u));return this.a.$registerAuthenticationProvider(M,I,S?.supportsMultipleAccounts??!1),new f.$3L(()=>{E.dispose(),this.b.delete(M),this.a.$unregisterAuthenticationProvider(M)})}$createSession(M,I,p){const S=this.b.get(M);if(S)return Promise.resolve(S.provider.createSession(I,p));throw new Error(`Unable to find authentication provider with handle: ${M}`)}$removeSession(M,I){const p=this.b.get(M);if(p)return Promise.resolve(p.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${M}`)}$getSessions(M,I){const p=this.b.get(M);if(p)return Promise.resolve(p.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${M}`)}$onDidChangeAuthenticationSessions(M,I){return M.startsWith(L.$7K)||this.c.fire({provider:{id:M,label:I}}),Promise.resolve()}}e.$Xhc=w;class ${constructor(){this.a=new Map}getOrCreate(M,I){const p=this.a.get(M);if(p)return p;const S=I().finally(()=>this.a.delete(M));return this.a.set(M,S),S}}}),define(Se[149],De([1,0,2,6,7,5,20,13,19,12,17,26]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=e.$Wic=void 0;let S=p=class{constructor(u,b){this.h=b,this.f=new Map,this.g=u.getProxy(O.$1L.MainThreadDecorations)}registerFileDecorationProvider(u,b){const o=p.c++;this.f.set(o,{provider:u,extensionDescription:b}),this.g.$registerDecorationProvider(o,b.identifier.value);const i=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const s=(0,$.$3b)(n);if(s.length<=p.d){this.g.$onDidChange(o,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",b.identifier.value,s.length);const a=s.map(l=>({uri:l,rank:(0,k.$Ye)(l.path,"/")})),t=(0,$.$zb)(a,(l,r)=>l.rank-r.rank||(0,k.$cf)(l.uri.path,r.uri.path)),d=[];e:for(const l of t){let r;for(const c of l){const h=(0,M.$mc)(c.uri.path);if(r!==h&&(r=h,d.push(c.uri)>=p.d))break e}}this.g.$onDidChange(o,d)});return new f.$3L(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(u,b,o){if(!this.f.has(u))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:s}=this.f.get(u);return await Promise.all(b.map(async a=>{try{const{uri:t,id:d}=a,l=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),o));if(!l)return;try{f.$oN.validate(l),l.badge&&typeof l.badge!="string"&&(0,I.$WF)(s,"codiconDecoration"),i[d]=[l.propagate,l.tooltip,l.badge,l.color]}catch(r){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${r}`)}}catch(t){this.h.error(t)}})),i}};e.$Wic=S,S.c=0,S.d=250,e.$Wic=S=p=Je([He(0,L.$fO),He(1,w.$yj)],S),e.$Xic=(0,R.$ei)("IExtHostDecorations")}),define(Se[315],De([1,0,14,2,7,6,16,22,12]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class k{constructor(I,p,S){this.d=p,this.e=S,this.b=new Map,this.c=I.getProxy(R.$1L.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(L.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=k.a++;this.b.set(S,p),this.c.$registerTextContentProvider(S,I);let E;if(typeof p.onDidChange=="function"){let u;E=p.onDidChange(async b=>{if(b.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(b))return;u&&await u;const o=this.$provideTextDocumentContent(S,b).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(b);if(!n)return;const s=(0,$.$9e)(i);if(!n.equalLines(s))return this.c.$onVirtualDocumentChange(b,i)}).catch(D.$1).finally(()=>{u===o&&(u=void 0)});u=o})}return new f.$3L(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(I,p){const S=this.b.get(I);return S?Promise.resolve(S.provideTextDocumentContent(O.URI.revive(p),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$Zic=k,k.a=0}),define(Se[150],De([1,0,61,16,12,185,130,7,19]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=e.$hO=void 0;const k=new Map;function M(E,u){u?k.set(E,u):k.delete(E)}e.$hO=M;function I(E){return k.get(E)}class p extends R.$yv{constructor(u,b,o,i,n,s,a){super(b,o,i,n),this.c=u,this.m=s,this.q=a,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,$.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===O.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(b){return b?u.s(b):u.getText()},get eol(){return u.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(b){return u.t(b)},offsetAt(b){return u.u(b)},positionAt(b){return u.v(b)},validateRange(b){return u.w(b)},validatePosition(b){return u.x(b)},getWordRangeAtPosition(b,o){return u.y(b,o)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,D.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,D.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const b=this.w(u);if(b.isEmpty)return"";if(b.isSingleLine)return this.f[b.start.line].substring(b.start.character,b.end.character);const o=this.g,i=b.start.line,n=b.end.line,s=[];s.push(this.f[i].substring(b.start.character));for(let a=i+1;a<n;a++)s.push(this.f[a]);return s.push(this.f[n].substring(0,b.end.character)),s.join(o)}t(u){let b;if(u instanceof w.$4L?b=u.line:typeof u=="number"&&(b=u),typeof b!="number"||b<0||b>=this.f.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new S(b,this.f[b],b===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const b=this.j.getIndexOf(u),o=this.f[b.index].length;return new w.$4L(b.index,Math.min(b.remainder,o))}w(u){if(!(u instanceof w.$5L))throw new Error("Invalid argument");const b=this.x(u.start),o=this.x(u.end);return b===u.start&&o===u.end?u:new w.$5L(b.line,b.character,o.line,o.character)}x(u){if(!(u instanceof w.$4L))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:b,character:o}=u,i=!1;if(b<0)b=0,o=0,i=!0;else if(b>=this.f.length)b=this.f.length-1,o=this.f[b].length,i=!0;else{const n=this.f[b].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new w.$4L(b,o):u}y(u,b){const o=this.x(u);if(!b)b=I(this.m);else if((0,f.$8e)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const i=(0,L.$Js)(o.character+1,(0,L.$Hs)(b),this.f[o.line],0);if(i)return new w.$5L(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$iO=p;class S{constructor(u,b,o){this.a=u,this.b=b,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$5L(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$5L(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$jO=S}),define(Se[316],De([1,0,6,7]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;class f{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$1L.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,w,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(L);if(!k)throw new Error("Embedding vector provider not found");const M=await k.provideEmbeddingVector(w,$);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(L,w,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(w,k),new O.$3L(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$2ic=f}),define(Se[69],De([1,0,6,32,7,21,5,20,59,3,8,23,16]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;let E=S=class{constructor(b,o){this.b=new Map,this.c=new M.$nh,this.a=b.getProxy(D.$1L.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let s;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),s=await a.impl.stat(n)):s=await i.a.$stat(n),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===O.FilePermission.Readonly?1:void 0}}catch(s){S.e(s)}},async readDirectory(n){try{const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),(await s.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(s){return S.e(s)}},async createDirectory(n){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(s.impl,s.extUri,n)):await i.a.$mkdir(n)}catch(s){return S.e(s)}},async readFile(n){try{const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),(await s.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(s){return S.e(s)}},async writeFile(n,s){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(a.impl.writeFile(n,s,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,R.$se.wrap(s))}catch(a){return S.e(a)}},async delete(n,s){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly&&!s?.useTrash?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...s})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(a){return S.e(a)}},async rename(n,s,a){try{return await i.a.$rename(n,s,{overwrite:!1,...a})}catch(t){return S.e(t)}},async copy(n,s,a){try{return await i.a.$copy(n,s,{overwrite:!1,...a})}catch(t){return S.e(t)}},isWritableFileSystem(n){const s=o.getCapabilities(n);if(typeof s=="number")return!(s&2048)}})}async d(b,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await b.stat(i)).type&O.FileType.Directory))throw f.$fN.FileExists(`Unable to create folder '${i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(O.$Rk(s)!==O.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(o.basename(i)),i=o.dirname(i)}for(let s=n.length-1;s>=0;s--){i=o.joinPath(i,n[s]);try{await b.createDirectory(i)}catch(a){if(O.$Rk(a)!==O.FileSystemProviderErrorCode.FileExists)throw a}}}static e(b){if(b instanceof f.$fN)throw b;if(b instanceof O.$Nk)switch(b.code){case O.FileSystemProviderErrorCode.FileExists:throw f.$fN.FileExists(b.message);case O.FileSystemProviderErrorCode.FileNotFound:throw f.$fN.FileNotFound(b.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw f.$fN.FileNotADirectory(b.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw f.$fN.FileIsADirectory(b.message);case O.FileSystemProviderErrorCode.NoPermissions:throw f.$fN.NoPermissions(b.message);case O.FileSystemProviderErrorCode.Unavailable:throw f.$fN.Unavailable(b.message);default:throw new f.$fN(b.message,b.name)}if(!(b instanceof Error))throw new f.$fN(String(b));if(b.name==="ENOPRO"||b.message.includes("ENOPRO"))throw f.$fN.Unavailable(b.message);switch(b.name){case O.FileSystemProviderErrorCode.FileExists:throw f.$fN.FileExists(b.message);case O.FileSystemProviderErrorCode.FileNotFound:throw f.$fN.FileNotFound(b.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw f.$fN.FileNotADirectory(b.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw f.$fN.FileIsADirectory(b.message);case O.FileSystemProviderErrorCode.NoPermissions:throw f.$fN.NoPermissions(b.message);case O.FileSystemProviderErrorCode.Unavailable:throw f.$fN.Unavailable(b.message);default:throw new f.$fN(b.message,b.name)}}addFileSystemProvider(b,o,i){return this.b.set(b,{impl:o,extUri:i?.isCaseSensitive?I.$Hg:I.$Jg,isReadonly:!!i?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(b))}getFileSystemProviderExtUri(b){return this.b.get(b)?.extUri??I.$Hg}};e.$cic=E,e.$cic=E=S=Je([He(0,w.$fO),He(1,$.$Rhc)],E),e.$dic=(0,L.$ei)("IExtHostConsumerFileSystem")}),define(Se[317],De([1,0,6,7]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;class f{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(D.$1L.MainThreadIssueReporter)}async $getIssueReporterUri(L,w){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(L);if(!$)throw new Error("Issue request handler not found");const k=await $.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(L,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueData(w);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(L,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueTemplate(w);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(L,w){const $=L.identifier.value;return this.a.set($,w),this.c.$registerIssueUriRequestHandler($),new O.$3L(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(L,w){const $=L.identifier.value;return this.b.set($,w),this.c.$registerIssueDataProvider($),new O.$3L(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$gjc=f}),define(Se[93],De([1,0,5,27,13,69,2]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=e.$eic=void 0,e.$eic=(0,D.$ei)("IExtensionStoragePaths");let w=class{constructor(k,M,I){this.d=M,this.f=I,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(k){return L.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,M=await this.g(k);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(L.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this.c)return L.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return L.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fic=w,e.$fic=w=Je([He(0,O.$vO),He(1,f.$yj),He(2,R.$dic)],w)}),define(Se[318],De([1,0,7,20,4]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;let R=class{constructor(w){this.a=new D.$pN(D.ColorThemeKind.Dark),this.b=new f.$5d}get activeColorTheme(){return this.a}$onColorThemeChange(w){let $;switch(w){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$pN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jjc=R,e.$Jjc=R=Je([He(0,O.$fO)],R)}),define(Se[70],De([1,0,22,4,3,222,5,13,88,6,27,20,7]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zAb=e.$yAb=e.TunnelDtoConverter=void 0;class S extends $.$Wv{}var E;(function(b){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}b.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}b.fromServiceTunnel=i})(E||(e.TunnelDtoConverter=E={})),e.$yAb=(0,L.$ei)("IExtHostTunnelService");let u=class extends f.$Tc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$5d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(k.$1L.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const s=new S(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new p.$3L(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,s,a){const t=[];for(const l of o){const r=this.r.get(l);if(!r)return[];t.push(...await Promise.all(i.map(async c=>{let h;try{h=await r.provider.providePortAttributes({port:c,pid:n,commandLine:s},a)}catch{h=await r.provider.providePortAttributes(c,n,s,a)}return{providedAttributes:h,port:c}})))}const d=t.filter(l=>!!l.providedAttributes);return d.length>0?d.map(l=>({autoForwardAction:l.providedAttributes.autoForwardAction,port:l.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,a)=>await o.provideTunnel(s,a,new D.$ce().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,f.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let s=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const s=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:s,disposeListener:a}),E.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(s=>this.f(s.host,s.port,s.detail??""))),n=o.filter((s,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(s=>s.port).join(", ")} to ${n.map(s=>s.port).join(", ")}`),n}};e.$zAb=u,e.$zAb=u=Je([He(0,I.$fO),He(1,M.$vO),He(2,w.$yj)],u)}),define(Se[15],De([1,0,19,21,169,74,79,28,162,56,98,24,23,18,2,29,83,136,142,140,119,67,89,291,26,7]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$eO=e.$dO=e.MarkdownString=e.$cO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var c;(function(Me){function je(ne){const{selectionStartLineNumber:Oe,selectionStartColumn:Ue,positionLineNumber:_e,positionColumn:Ye}=ne,lt=new r.$4L(Oe-1,Ue-1),Dt=new r.$4L(_e-1,Ye-1);return new r.$6L(lt,Dt)}Me.to=je;function Ee(ne){const{anchor:Oe,active:Ue}=ne;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Me.from=Ee})(c||(e.Selection=c={}));var h;(function(Me){function je(ne){if(!ne)return;const{start:Oe,end:Ue}=ne;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Me.from=je;function Ee(ne){if(!ne)return;const{startLineNumber:Oe,startColumn:Ue,endLineNumber:_e,endColumn:Ye}=ne;return new r.$5L(Oe-1,Ue-1,_e-1,Ye-1)}Me.to=Ee})(h||(e.Range=h={}));var g;(function(Me){function je(ne){return{uri:ne.uri,range:h.from(ne.range)}}Me.from=je;function Ee(ne){return new r.$cM(E.URI.revive(ne.uri),h.to(ne.range))}Me.to=Ee})(g||(e.Location=g={}));var C;(function(Me){function je(Ee){switch(Ee){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=je})(C||(e.TokenType=C={}));var v;(function(Me){function je(ne){return new r.$4L(ne.lineNumber-1,ne.column-1)}Me.to=je;function Ee(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Ee})(v||(e.Position=v={}));var m;(function(Me){function je(Oe,Ue,_e){return(0,D.$Hb)((0,D.$3b)(Oe).map(Ye=>Ee(Ye,Ue,_e)))}Me.from=je;function Ee(Oe,Ue,_e){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:_e?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ne(Oe.scheme,Ue),pattern:oe.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:_e?.isBuiltin}}function ne(Oe,Ue){return Ue&&typeof Oe=="string"?Ue.transformOutgoingScheme(Oe):Oe}})(m||(e.DocumentSelector=m={}));var y;(function(Me){function je(ne){switch(ne){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=je;function Ee(ne){switch(ne){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=Ee})(y||(e.DiagnosticTag=y={}));var P;(function(Me){function je(ne){let Oe;return ne.code&&((0,S.$Sf)(ne.code)||(0,S.$Wf)(ne.code)?Oe=String(ne.code):Oe={value:String(ne.code.value),target:ne.code.target}),{...h.from(ne.range),message:ne.message,source:ne.source,code:Oe,severity:U.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(j.from),tags:Array.isArray(ne.tags)?(0,D.$Hb)(ne.tags.map(y.from)):void 0}}Me.from=je;function Ee(ne){const Oe=new r.$eM(h.to(ne),ne.message,U.to(ne.severity));return Oe.source=ne.source,Oe.code=(0,S.$Sf)(ne.code)?ne.code:ne.code?.value,Oe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(j.to),Oe.tags=ne.tags&&(0,D.$Hb)(ne.tags.map(y.to)),Oe}Me.to=Ee})(P||(e.Diagnostic=P={}));var j;(function(Me){function je(ne){return{...h.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=je;function Ee(ne){return new r.$dM(new r.$cM(ne.resource,h.to(ne)),ne.message)}Me.to=Ee})(j||(e.DiagnosticRelatedInformation=j={}));var U;(function(Me){function je(ne){switch(ne){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Me.from=je;function Ee(ne){switch(ne){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=Ee})(U||(e.DiagnosticSeverity=U={}));var z;(function(Me){function je(ne){return typeof ne=="number"&&ne>=r.ViewColumn.One?ne-1:ne===r.ViewColumn.Beside?d.$rD:d.$qD}Me.from=je;function Ee(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ee})(z||(e.ViewColumn=z={}));function N(Me){return typeof Me.range<"u"}function A(Me){return Me.length===0?!0:!!N(Me[0])}e.$cO=A;var T;(function(Me){function je(Ye){return Ye.map(Me.from)}Me.fromMany=je;function Ee(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function ne(Ye){let lt;if(Ee(Ye)){const{language:Tt,value:ii}=Ye;lt={value:"```"+Tt+`
`+ii+"\n```\n"}}else r.$rM.isMarkdownString(Ye)?lt={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?lt={value:Ye}:lt={value:""};const Dt=Object.create(null);lt.uris=Dt;const Xt=Tt=>{try{let ii=E.URI.parse(Tt,!0);ii=ii.with({query:Oe(ii.query,Dt)}),Dt[Tt]=ii}catch{}return""},It=new $.marked.Renderer;return It.link=Xt,It.image=Tt=>typeof Tt=="string"?Xt(L.$Ak(Tt).href):"",(0,$.marked)(lt.value,{renderer:It}),lt}Me.from=ne;function Oe(Ye,lt){if(!Ye)return Ye;let Dt;try{Dt=(0,k.$Mh)(Ye)}catch{}if(!Dt)return Ye;let Xt=!1;return Dt=(0,I.$Kn)(Dt,It=>{if(E.URI.isUri(It)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Tt]=It,Xt=!0,Tt}else return}),Xt?JSON.stringify(Dt):Ye}function Ue(Ye){const lt=new r.$rM(Ye.value,Ye.supportThemeIcons);return lt.isTrusted=Ye.isTrusted,lt.supportHtml=Ye.supportHtml,lt.baseUri=Ye.baseUri?E.URI.from(Ye.baseUri):void 0,lt}Me.to=Ue;function _e(Ye){if(Ye)return typeof Ye=="string"?Ye:Me.from(Ye)}Me.fromStrict=_e})(T||(e.MarkdownString=T={}));function F(Me){return A(Me)?Me.map(je=>({range:h.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?T.fromMany(je.hoverMessage):je.hoverMessage?T.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Me.map(je=>({range:h.from(je)}))}e.$dO=F;function G(Me){return typeof Me>"u"?Me:typeof Me=="string"?E.URI.file(Me):Me}e.$eO=G;var K;(function(Me){function je(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?G(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Me.from=je})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var X;(function(Me){function je(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?G(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?K.from(Ee.before):void 0,after:Ee.after?K.from(Ee.after):void 0}}Me.from=je})(X||(e.ThemableDecorationRenderOptions=X={}));var Q;(function(Me){function je(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=je})(Q||(e.DecorationRangeBehavior=Q={}));var Z;(function(Me){function je(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?Q.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?X.from(Ee.light):void 0,dark:Ee.dark?X.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?G(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?K.from(Ee.before):void 0,after:Ee.after?K.from(Ee.after):void 0}}Me.from=je})(Z||(e.DecorationRenderOptions=Z={}));var ie;(function(Me){function je(ne){return{text:ne.newText,eol:ne.newEol&&rt.from(ne.newEol),range:h.from(ne.range)}}Me.from=je;function Ee(ne){const Oe=new r.$0L(h.to(ne.range),ne.text);return Oe.newEol=typeof ne.eol>"u"?void 0:rt.to(ne.eol),Oe}Me.to=Ee})(ie||(e.TextEdit=ie={}));var ee;(function(Me){function je(ne,Oe){const Ue={edits:[]};if(ne instanceof r.$aM){const _e=new w.$Bc;for(const Ye of ne._allEntries())Ye._type===1&&E.URI.isUri(Ye.to)&&Ye.from===void 0&&_e.add(Ye.to);for(const Ye of ne._allEntries())if(Ye._type===1){let lt;Ye.options?.contents&&(ArrayBuffer.isView(Ye.options.contents)?lt={type:"base64",value:(0,O.$Me)(O.$se.wrap(Ye.options.contents))}:lt={type:"dataTransferItem",id:Ye.options.contents._itemId}),Ue.edits.push({oldResource:Ye.from,newResource:Ye.to,options:{...Ye.options,contents:lt},metadata:Ye.metadata})}else Ye._type===2?Ue.edits.push({resource:Ye.uri,textEdit:ie.from(Ye.edit),versionId:_e.has(Ye.uri)?void 0:Oe?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===6?Ue.edits.push({resource:Ye.uri,textEdit:{range:h.from(Ye.range),text:Ye.edit.value,insertAsSnippet:!0},versionId:_e.has(Ye.uri)?void 0:Oe?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===3?Ue.edits.push({metadata:Ye.metadata,resource:Ye.uri,cellEdit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ye.uri)}):Ye._type===5&&Ue.edits.push({metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ye.uri),cellEdit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(At.from)}})}return Ue}Me.from=je;function Ee(ne){const Oe=new r.$aM,Ue=new w.$Ac;for(const _e of ne.edits)if(_e.textEdit){const Ye=_e,lt=E.URI.revive(Ye.resource),Dt=h.to(Ye.textEdit.range),Xt=Ye.textEdit.text,It=Ye.textEdit.insertAsSnippet;let Tt;It?Tt=r.$_L.replace(Dt,new r.$bM(Xt)):Tt=r.$0L.replace(Dt,Xt);const ii=Ue.get(lt);ii?ii.push(Tt):Ue.set(lt,[Tt])}else Oe.renameFile(E.URI.revive(_e.oldResource),E.URI.revive(_e.newResource),_e.options);for(const[_e,Ye]of Ue)Oe.set(_e,Ye);return Oe}Me.to=Ee})(ee||(e.WorkspaceEdit=ee={}));var we;(function(Me){const je=Object.create(null);je[r.SymbolKind.File]=0,je[r.SymbolKind.Module]=1,je[r.SymbolKind.Namespace]=2,je[r.SymbolKind.Package]=3,je[r.SymbolKind.Class]=4,je[r.SymbolKind.Method]=5,je[r.SymbolKind.Property]=6,je[r.SymbolKind.Field]=7,je[r.SymbolKind.Constructor]=8,je[r.SymbolKind.Enum]=9,je[r.SymbolKind.Interface]=10,je[r.SymbolKind.Function]=11,je[r.SymbolKind.Variable]=12,je[r.SymbolKind.Constant]=13,je[r.SymbolKind.String]=14,je[r.SymbolKind.Number]=15,je[r.SymbolKind.Boolean]=16,je[r.SymbolKind.Array]=17,je[r.SymbolKind.Object]=18,je[r.SymbolKind.Key]=19,je[r.SymbolKind.Null]=20,je[r.SymbolKind.EnumMember]=21,je[r.SymbolKind.Struct]=22,je[r.SymbolKind.Event]=23,je[r.SymbolKind.Operator]=24,je[r.SymbolKind.TypeParameter]=25;function Ee(Oe){return typeof je[Oe]=="number"?je[Oe]:6}Me.from=Ee;function ne(Oe){for(const Ue in je)if(je[Ue]===Oe)return Number(Ue);return r.SymbolKind.Property}Me.to=ne})(we||(e.SymbolKind=we={}));var ue;(function(Me){function je(ne){switch(ne){case r.SymbolTag.Deprecated:return 1}}Me.from=je;function Ee(ne){switch(ne){case 1:return r.SymbolTag.Deprecated}}Me.to=Ee})(ue||(e.SymbolTag=ue={}));var ae;(function(Me){function je(ne){return{name:ne.name,kind:we.from(ne.kind),tags:ne.tags&&ne.tags.map(ue.from),containerName:ne.containerName,location:ce.from(ne.location)}}Me.from=je;function Ee(ne){const Oe=new r.$iM(ne.name,we.to(ne.kind),ne.containerName,ce.to(ne.location));return Oe.tags=ne.tags&&ne.tags.map(ue.to),Oe}Me.to=Ee})(ae||(e.WorkspaceSymbol=ae={}));var H;(function(Me){function je(ne){const Oe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:h.from(ne.range),selectionRange:h.from(ne.selectionRange),kind:we.from(ne.kind),tags:ne.tags?.map(ue.from)??[]};return ne.children&&(Oe.children=ne.children.map(je)),Oe}Me.from=je;function Ee(ne){const Oe=new r.$jM(ne.name,ne.detail,we.to(ne.kind),h.to(ne.range),h.to(ne.selectionRange));return(0,D.$Lb)(ne.tags)&&(Oe.tags=ne.tags.map(ue.to)),ne.children&&(Oe.children=ne.children.map(Ee)),Oe}Me.to=Ee})(H||(e.DocumentSymbol=H={}));var fe;(function(Me){function je(ne){const Oe=new r.$nM(we.to(ne.kind),ne.name,ne.detail||"",E.URI.revive(ne.uri),h.to(ne.range),h.to(ne.selectionRange));return Oe._sessionId=ne._sessionId,Oe._itemId=ne._itemId,Oe}Me.to=je;function Ee(ne,Oe,Ue){if(Oe=Oe??ne._sessionId,Ue=Ue??ne._itemId,Oe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ue,name:ne.name,detail:ne.detail,kind:we.from(ne.kind),uri:ne.uri,range:h.from(ne.range),selectionRange:h.from(ne.selectionRange),tags:ne.tags?.map(ue.from)}}Me.from=Ee})(fe||(e.CallHierarchyItem=fe={}));var he;(function(Me){function je(Ee){return new r.$oM(fe.to(Ee.from),Ee.fromRanges.map(ne=>h.to(ne)))}Me.to=je})(he||(e.CallHierarchyIncomingCall=he={}));var se;(function(Me){function je(Ee){return new r.$pM(fe.to(Ee.to),Ee.fromRanges.map(ne=>h.to(ne)))}Me.to=je})(se||(e.CallHierarchyOutgoingCall=se={}));var ce;(function(Me){function je(ne){return{range:ne.range&&h.from(ne.range),uri:ne.uri}}Me.from=je;function Ee(ne){return new r.$cM(E.URI.revive(ne.uri),h.to(ne.range))}Me.to=Ee})(ce||(e.location=ce={}));var le;(function(Me){function je(ne){const Oe=ne,Ue=ne;return{originSelectionRange:Oe.originSelectionRange?h.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ue.uri,range:h.from(Oe.targetRange?Oe.targetRange:Ue.range),targetSelectionRange:Oe.targetSelectionRange?h.from(Oe.targetSelectionRange):void 0}}Me.from=je;function Ee(ne){return{targetUri:E.URI.revive(ne.uri),targetRange:h.to(ne.range),targetSelectionRange:ne.targetSelectionRange?h.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?h.to(ne.originSelectionRange):void 0}}Me.to=Ee})(le||(e.DefinitionLink=le={}));var de;(function(Me){function je(ne){return{range:h.from(ne.range),contents:T.fromMany(ne.contents)}}Me.from=je;function Ee(ne){return new r.$fM(ne.contents.map(T.to),h.to(ne.range))}Me.to=Ee})(de||(e.Hover=de={}));var q;(function(Me){function je(ne){return{range:h.from(ne.range),expression:ne.expression}}Me.from=je;function Ee(ne){return new r.$_M(h.to(ne.range),ne.expression)}Me.to=Ee})(q||(e.EvaluatableExpression=q={}));var _;(function(Me){function je(ne){if(ne instanceof r.$aN)return{type:"text",range:h.from(ne.range),text:ne.text};if(ne instanceof r.$bN)return{type:"variable",range:h.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof r.$cN)return{type:"expression",range:h.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=je;function Ee(ne){switch(ne.type){case"text":return{range:h.to(ne.range),text:ne.text};case"variable":return{range:h.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:h.to(ne.range),expression:ne.expression}}}Me.to=Ee})(_||(e.InlineValue=_={}));var ge;(function(Me){function je(ne){return{frameId:ne.frameId,stoppedLocation:h.from(ne.stoppedLocation)}}Me.from=je;function Ee(ne){return new r.$dN(ne.frameId,h.to(ne.stoppedLocation))}Me.to=Ee})(ge||(e.InlineValueContext=ge={}));var me;(function(Me){function je(ne){return{range:h.from(ne.range),kind:ne.kind}}Me.from=je;function Ee(ne){return new r.$gM(h.to(ne.range),ne.kind)}Me.to=Ee})(me||(e.DocumentHighlight=me={}));var Ae;(function(Me){function je(ne){return{uri:ne.uri,highlights:ne.highlights.map(me.from)}}Me.from=je;function Ee(ne){return new r.$hM(E.URI.revive(ne.uri),ne.highlights.map(me.to))}Me.to=Ee})(Ae||(e.MultiDocumentHighlight=Ae={}));var ye;(function(Me){function je(Ee){switch(Ee){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=je})(ye||(e.CompletionTriggerKind=ye={}));var Re;(function(Me){function je(Ee){return{triggerKind:ye.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Me.to=je})(Re||(e.CompletionContext=Re={}));var Le;(function(Me){function je(ne){switch(ne){case r.CompletionItemTag.Deprecated:return 1}}Me.from=je;function Ee(ne){switch(ne){case 1:return r.CompletionItemTag.Deprecated}}Me.to=Ee})(Le||(e.CompletionItemTag=Le={}));var ze;(function(Me){const je=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ee(Ue){return je.get(Ue)??9}Me.from=Ee;const ne=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Oe(Ue){return ne.get(Ue)??r.CompletionItemKind.Property}Me.to=Oe})(ze||(e.CompletionItemKind=ze={}));var B;(function(Me){function je(Ee,ne){const Oe=new r.$xM(Ee.label);return Oe.insertText=Ee.insertText,Oe.kind=ze.to(Ee.kind),Oe.tags=Ee.tags?.map(Le.to),Oe.detail=Ee.detail,Oe.documentation=L.$uk(Ee.documentation)?T.to(Ee.documentation):Ee.documentation,Oe.sortText=Ee.sortText,Oe.filterText=Ee.filterText,Oe.preselect=Ee.preselect,Oe.commitCharacters=Ee.commitCharacters,u.$7s.isIRange(Ee.range)?Oe.range=h.to(Ee.range):typeof Ee.range=="object"&&(Oe.range={inserting:h.to(Ee.range.insert),replacing:h.to(Ee.range.replace)}),Oe.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Oe.insertText=new r.$bM(Ee.insertText):(Oe.insertText=Ee.insertText,Oe.textEdit=Oe.range instanceof r.$5L?new r.$0L(Oe.range,Oe.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Ee.additionalTextEdits.map(Ue=>ie.to(Ue))),Oe.command=ne&&Ee.command?ne.fromInternal(Ee.command):void 0,Oe}Me.to=je})(B||(e.CompletionItem=B={}));var V;(function(Me){function je(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:T.fromStrict(ne.documentation)}}Me.from=je;function Ee(ne){return{label:ne.label,documentation:L.$uk(ne.documentation)?T.to(ne.documentation):ne.documentation}}Me.to=Ee})(V||(e.ParameterInformation=V={}));var x;(function(Me){function je(ne){return{label:ne.label,documentation:T.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(V.from):[],activeParameter:ne.activeParameter}}Me.from=je;function Ee(ne){return{label:ne.label,documentation:L.$uk(ne.documentation)?T.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(V.to):[],activeParameter:ne.activeParameter}}Me.to=Ee})(x||(e.SignatureInformation=x={}));var Y;(function(Me){function je(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(x.from):[]}}Me.from=je;function Ee(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(x.to):[]}}Me.to=Ee})(Y||(e.SignatureHelp=Y={}));var $e;(function(Me){function je(Ee,ne){const Oe=new r.$wM(v.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(ve.to.bind(void 0,Ee)),ne.kind&&Te.to(ne.kind));return Oe.textEdits=ne.textEdits&&ne.textEdits.map(ie.to),Oe.tooltip=L.$uk(ne.tooltip)?T.to(ne.tooltip):ne.tooltip,Oe.paddingLeft=ne.paddingLeft,Oe.paddingRight=ne.paddingRight,Oe}Me.to=je})($e||(e.InlayHint=$e={}));var ve;(function(Me){function je(Ee,ne){const Oe=new r.$vM(ne.label);return Oe.tooltip=L.$uk(ne.tooltip)?T.to(ne.tooltip):ne.tooltip,b.Command.is(ne.command)&&(Oe.command=Ee.fromInternal(ne.command)),ne.location&&(Oe.location=ce.to(ne.location)),Oe}Me.to=je})(ve||(e.InlayHintLabelPart=ve={}));var Te;(function(Me){function je(ne){return ne}Me.from=je;function Ee(ne){return ne}Me.to=Ee})(Te||(e.InlayHintKind=Te={}));var Ve;(function(Me){function je(ne){return{range:h.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=je;function Ee(ne){let Oe;if(ne.url)try{Oe=typeof ne.url=="string"?E.URI.parse(ne.url,!0):E.URI.revive(ne.url)}catch{}return new r.$CM(h.to(ne.range),Oe)}Me.to=Ee})(Ve||(e.DocumentLink=Ve={}));var Qe;(function(Me){function je(ne){const Oe=new r.$FM(ne.label);return ne.textEdit&&(Oe.textEdit=ie.to(ne.textEdit)),ne.additionalTextEdits&&(Oe.additionalTextEdits=ne.additionalTextEdits.map(Ue=>ie.to(Ue))),Oe}Me.to=je;function Ee(ne){return{label:ne.label,textEdit:ne.textEdit?ie.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Oe=>ie.from(Oe)):void 0}}Me.from=Ee})(Qe||(e.ColorPresentation=Qe={}));var tt;(function(Me){function je(ne){return new r.$DM(ne[0],ne[1],ne[2],ne[3])}Me.to=je;function Ee(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Ee})(tt||(e.Color=tt={}));var at;(function(Me){function je(ne){return{range:h.from(ne.range)}}Me.from=je;function Ee(ne){return new r.$mM(h.to(ne.range))}Me.to=Ee})(at||(e.SelectionRange=at={}));var dt;(function(Me){function je(Ee){switch(Ee){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=je})(dt||(e.TextDocumentSaveReason=dt={}));var ot;(function(Me){function je(ne){switch(ne){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.Interval:return 3;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=je;function Ee(ne){switch(ne){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 3:return r.TextEditorLineNumbersStyle.Interval;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=Ee})(ot||(e.TextEditorLineNumbersStyle=ot={}));var rt;(function(Me){function je(ne){if(ne===r.EndOfLine.CRLF)return 1;if(ne===r.EndOfLine.LF)return 0}Me.from=je;function Ee(ne){if(ne===1)return r.EndOfLine.CRLF;if(ne===0)return r.EndOfLine.LF}Me.to=Ee})(rt||(e.EndOfLine=rt={}));var Pe;(function(Me){function je(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=je})(Pe||(e.ProgressLocation=Pe={}));var Ie;(function(Me){function je(ne){const Oe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Oe.kind=Ge.from(ne.kind)),Oe}Me.from=je;function Ee(ne){const Oe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Oe.kind=Ge.to(ne.kind)),Oe}Me.to=Ee})(Ie||(e.FoldingRange=Ie={}));var Ge;(function(Me){function je(ne){if(ne)switch(ne){case r.FoldingRangeKind.Comment:return b.$Xt.Comment;case r.FoldingRangeKind.Imports:return b.$Xt.Imports;case r.FoldingRangeKind.Region:return b.$Xt.Region}}Me.from=je;function Ee(ne){if(ne)switch(ne.value){case b.$Xt.Comment.value:return r.FoldingRangeKind.Comment;case b.$Xt.Imports.value:return r.FoldingRangeKind.Imports;case b.$Xt.Region.value:return r.FoldingRangeKind.Region}}Me.to=Ee})(Ge||(e.FoldingRangeKind=Ge={}));var te;(function(Me){function je(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?h.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?n.$TE.id:void 0}}Me.from=je})(te||(e.TextEditorOpenOptions=te={}));var oe;(function(Me){function je(Ue){return Ue instanceof r.$ZM?Ue.toJSON():typeof Ue=="string"?Ue:Ee(Ue)||ne(Ue)?new r.$ZM(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Me.from=je;function Ee(Ue){const _e=Ue;return _e?E.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ne(Ue){const _e=Ue;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Oe(Ue){return typeof Ue=="string"?Ue:new r.$ZM(E.URI.revive(Ue.baseUri),Ue.pattern)}Me.to=Oe})(oe||(e.GlobPattern=oe={}));var Ce;(function(Me){function je(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(je);if(typeof Ee=="string")return Ee;{const ne=Ee;return{language:ne.language,scheme:ne.scheme,pattern:oe.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=je})(Ce||(e.LanguageSelector=Ce={}));var Ke;(function(Me){function je(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&E.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(_e=>_e instanceof r.$5L)))}Me.is=je;function Ee(ne){return{documents:ne.documents.map(Oe=>Oe.map(Ue=>({uri:E.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(_e=>h.from(_e))})))}}Me.from=Ee})(Ke||(e.MappedEditsContext=Ke={}));var xe;(function(Me){function je(ne){return{start:ne.start,end:ne.end}}Me.from=je;function Ee(ne){return new r.$qN(ne.start,ne.end)}Me.to=Ee})(xe||(e.NotebookRange=xe={}));var st;(function(Me){function je(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=je;function Ee(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Ee})(st||(e.NotebookCellExecutionSummary=st={}));var Ne;(function(Me){function je(Ee){if(Ee===s.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ee===s.NotebookCellExecutionState.Pending)return;if(Ee===s.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Me.to=je})(Ne||(e.NotebookCellExecutionState=Ne={}));var bt;(function(Me){function je(ne){switch(ne){case r.NotebookCellKind.Markup:return s.CellKind.Markup;case r.NotebookCellKind.Code:default:return s.CellKind.Code}}Me.from=je;function Ee(ne){switch(ne){case s.CellKind.Markup:return r.NotebookCellKind.Markup;case s.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=Ee})(bt||(e.NotebookCellKind=bt={}));var Ct;(function(Me){function je(ne){const Oe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ue of ne.cells)r.$rN.validate(Ue),Oe.cells.push(At.from(Ue));return Oe}Me.from=je;function Ee(ne){const Oe=new r.$sN(ne.cells.map(At.to));return(0,S.$6f)(ne.metadata)||(Oe.metadata=ne.metadata),Oe}Me.to=Ee})(Ct||(e.NotebookData=Ct={}));var At;(function(Me){function je(ne){return{cellKind:bt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:st.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Gt.from):[]}}Me.from=je;function Ee(ne){return new r.$rN(bt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Gt.to):void 0,ne.metadata,ne.internalMetadata?st.to(ne.internalMetadata):void 0)}Me.to=Ee})(At||(e.NotebookCellData=At={}));var qt;(function(Me){function je(ne){return{mime:ne.mime,valueBytes:O.$se.wrap(ne.data)}}Me.from=je;function Ee(ne){return new r.$tN(ne.valueBytes.buffer,ne.mime)}Me.to=Ee})(qt||(e.NotebookCellOutputItem=qt={}));var Gt;(function(Me){function je(ne){return{outputId:ne.id,items:ne.items.map(qt.from),metadata:ne.metadata}}Me.from=je;function Ee(ne){const Oe=ne.items.map(qt.to);return new r.$uN(Oe,ne.outputId,ne.metadata)}Me.to=Ee})(Gt||(e.NotebookCellOutput=Gt={}));var Rt;(function(Me){function je(Oe){return ne(Oe)?{include:oe.from(Oe.include)??void 0,exclude:oe.from(Oe.exclude)??void 0}:oe.from(Oe)??void 0}Me.from=je;function Ee(Oe){return ne(Oe)?{include:oe.to(Oe.include),exclude:oe.to(Oe.exclude)}:oe.to(Oe)}Me.to=Ee;function ne(Oe){const Ue=Oe;return Ue?!(0,S.$2f)(Ue.include)&&!(0,S.$2f)(Ue.exclude):!1}})(Rt||(e.NotebookExclusiveDocumentPattern=Rt={}));var Zt;(function(Me){function je(Ee,ne,Oe){const Ue=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ue,Oe),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Me.from=je})(Zt||(e.NotebookStatusBarItem=Zt={}));var xt;(function(Me){function je(Ee,ne,Oe){const Ue=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ne.toInternal(Ue,Oe),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Me.from=je})(xt||(e.NotebookKernelSourceAction=xt={}));var si;(function(Me){function je(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Me.from=je})(si||(e.NotebookDocumentContentOptions=si={}));var oi;(function(Me){function je(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=je;function Ee(ne){return new r.$wN(E.URI.revive(ne.uri),ne.provides)}Me.to=Ee})(oi||(e.NotebookRendererScript=oi={}));var et;(function(Me){function je(ne){return{message:T.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:h.from(ne.location.range),uri:ne.location.uri}}}Me.from=je;function Ee(ne){const Oe=new r.$CN(typeof ne.message=="string"?ne.message:T.to(ne.message));return Oe.actualOutput=ne.actual,Oe.expectedOutput=ne.expected,Oe.contextValue=ne.contextValue,Oe.location=ne.location?ce.to(ne.location):void 0,Oe}Me.to=Ee})(et||(e.TestMessage=et={}));var jt;(function(Me){Me.namespace=t.$VK,Me.denamespace=t.$WK})(jt||(e.TestTag=jt={}));var _t;(function(Me){function je(ne){const Oe=(0,i.$bO)(ne).controllerId;return{extId:a.$RK.fromExtHostTestItem(ne,Oe).toString(),label:ne.label,uri:E.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ue=>jt.namespace(Oe,Ue.id)),range:u.$7s.lift(h.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&T.fromStrict(ne.error)||null}}Me.from=je;function Ee(ne){return{parent:void 0,error:void 0,id:a.$RK.fromString(ne.extId).localId,label:ne.label,uri:E.URI.revive(ne.uri),tags:(ne.tags||[]).map(Oe=>{const{tagId:Ue}=jt.denamespace(Oe);return new r.$DN(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Ee})(_t||(e.TestItem=_t={})),function(Me){function je(ne){return{id:ne.id}}Me.from=je;function Ee(ne){return new r.$DN(ne.id)}Me.to=Ee}(jt||(e.TestTag=jt={}));var $t;(function(Me){const je=(ne,Oe)=>{const Ue=[];for(const[Ye,lt]of Oe)a.$RK.compare(lt.item.extId,Ye)===2&&(Oe.delete(Ye),Ue.push(lt));const _e={..._t.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(lt=>lt.type===0).map(et.to)})),children:Ue.map(Ye=>je(Ye,Oe))};for(const Ye of _e.children)Ye.parent=_e;return _e};function Ee(ne){const Oe=[],Ue=new Map;for(const _e of ne.items){Ue.set(_e.item.extId,_e);const Ye=a.$RK.root(_e.item.extId);ne.request.targets.some(lt=>lt.controllerId===Ye&&lt.testIds.includes(_e.item.extId))&&Oe.push(_e)}return{completedAt:ne.completedAt,results:Oe.map(_e=>je(_e,Ue))}}Me.to=Ee})($t||(e.TestResults=$t={}));var pt;(function(Me){function je(Ue){return{covered:Ue.covered,total:Ue.total}}function Ee(Ue){return"line"in Ue?v.from(Ue):h.from(Ue)}function ne(Ue){return"branches"in Ue?{count:Ue.executed,location:Ee(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(_e=>({count:_e.executed,location:_e.location&&Ee(_e.location),label:_e.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:Ee(Ue.location)}}Me.fromDetailed=ne;function Oe(Ue){return{uri:Ue.uri,statement:je(Ue.statementCoverage),branch:Ue.branchCoverage&&je(Ue.branchCoverage),declaration:Ue.declarationCoverage&&je(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(ne)}}Me.fromFile=Oe})(pt||(e.TestCoverage=pt={}));var Kt;(function(Me){function je(Ee){switch(Ee){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=je})(Kt||(e.CodeActionTriggerKind=Kt={}));var zt;(function(Me){function je(ne){const Oe=new r.$JN(we.to(ne.kind),ne.name,ne.detail||"",E.URI.revive(ne.uri),h.to(ne.range),h.to(ne.selectionRange));return Oe._sessionId=ne._sessionId,Oe._itemId=ne._itemId,Oe}Me.to=je;function Ee(ne,Oe,Ue){if(Oe=Oe??ne._sessionId,Ue=Ue??ne._itemId,Oe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ue,kind:we.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:h.from(ne.range),selectionRange:h.from(ne.selectionRange),tags:ne.tags?.map(ue.from)}}Me.from=Ee})(zt||(e.TypeHierarchyItem=zt={}));var Wt;(function(Me){function je(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Me.from=je})(Wt||(e.ViewBadge=Wt={}));var ft;(function(Me){function je(Ue,_e,Ye){const lt=_e.fileData;return lt?new r.$SM(new r.$TM(lt.name,E.URI.revive(lt.uri),lt.id,(0,R.$db)(()=>Ye(lt.id)))):Ue===M.$rs.uriList&&_e.uriListData?new r.$RM(Oe(_e.uriListData)):new r.$RM(_e.asString)}Me.to=je;async function Ee(Ue,_e){const Ye=await _e.asString();if(Ue===M.$rs.uriList)return{asString:Ye,fileData:void 0,uriListData:ne(Ye)};const lt=_e.asFile();return{asString:Ye,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}Me.from=Ee;function ne(Ue){return f.$Dt.split(Ue).map(_e=>{if(_e.startsWith("#"))return _e;try{return E.URI.parse(_e)}catch{}return _e})}function Oe(Ue){return f.$Dt.create(Ue.map(_e=>typeof _e=="string"?_e:E.URI.revive(_e)))}})(ft||(e.DataTransferItem=ft={}));var Mt;(function(Me){function je(ne,Oe){const Ue=ne.items.map(([_e,Ye])=>[_e,ft.to(_e,Ye,Oe)]);return new r.$UM(Ue)}Me.toDataTransfer=je;async function Ee(ne){const Oe={items:[]},Ue=[];for(const[_e,Ye]of ne)Ue.push((async()=>{Oe.items.push([_e,await ft.from(_e,Ye)])})());return await Promise.all(Ue),Oe}Me.from=Ee})(Mt||(e.DataTransfer=Mt={}));var ei;(function(Me){function je(ne,Oe){return{kind:"reply",agentId:ne.participant??Oe?.agentId??"",subCommand:ne.command??Oe?.command,message:ne.prompt,title:ne.label}}Me.from=je;function Ee(ne){return{prompt:ne.message,label:ne.title,participant:ne.agentId,command:ne.subCommand}}Me.to=Ee})(ei||(e.ChatFollowup=ei={}));var ti;(function(Me){function je(Ee){return"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",when:Ee.when??"",args:Ee.args}:{kind:"reply",message:Ee.message,title:Ee.title,tooltip:Ee.tooltip}}Me.from=je})(ti||(e.ChatInlineFollowup=ti={}));var Xe;(function(Me){function je(ne){switch(ne.role){case 0:return new r.$4N(ne.content);case 1:return new r.$5N(ne.content);case 2:return new r.$6N(ne.content)}}Me.to=je;function Ee(ne){if(ne instanceof r.$4N)return{role:0,content:ne.content};if(ne instanceof r.$5N)return{role:1,content:ne.content};if(ne instanceof r.$6N)return{role:2,content:ne.content};throw new Error("Invalid LanguageModelMessage")}Me.from=Ee})(Xe||(e.LanguageModelMessage=Xe={}));var Vt;(function(Me){function je(Oe){const Ue={};for(const _e of Object.keys(Oe))Ue[_e]=Oe[_e].map(Me.to);return Ue}Me.objectTo=je;function Ee(Oe){return{level:Yt.to(Oe.level),kind:Oe.kind,value:(0,E.$vc)(Oe.value)?E.URI.revive(Oe.value):Oe.value,description:Oe.description}}Me.to=Ee;function ne(Oe){return{level:Yt.from(Oe.level),kind:Oe.kind,value:Oe.value,description:Oe.description}}Me.from=ne})(Vt||(e.ChatVariable=Vt={}));var Yt;(function(Me){function je(ne){switch(ne){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=je;function Ee(ne){switch(ne){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=Ee})(Yt||(e.ChatVariableLevel=Yt={}));var ni;(function(Me){function je(Ee){switch(Ee){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=je})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var vt;(function(Me){function je(ne){return{kind:"markdownContent",content:T.from(ne.value)}}Me.to=je;function Ee(ne){return new r.$VN(T.to(ne.content))}Me.from=Ee})(vt||(e.ChatResponseMarkdownPart=vt={}));var Ut;(function(Me){function je(ne){const{value:Oe,baseUri:Ue}=ne;function _e(Ye,lt){return Ye.map(Dt=>{const Xt=E.URI.joinPath(lt,Dt.name);return{label:Dt.name,uri:Xt,children:Dt.children&&_e(Dt.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,p.$Og)(Ue),uri:Ue,children:_e(Oe,Ue)}}}Me.to=je;function Ee(ne){const Oe=(0,k.$Nh)(ne.treeData);function Ue(lt){return lt.map(Dt=>({name:Dt.label,children:Dt.children&&Ue(Dt.children)}))}const _e=Oe.uri,Ye=Oe.children?Ue(Oe.children):[];return new r.$WN(Ye,_e)}Me.from=Ee})(Ut||(e.ChatResponseFilesPart=Ut={}));var Ot;(function(Me){function je(ne){return{kind:"inlineReference",name:ne.title,inlineReference:E.URI.isUri(ne.value)?ne.value:g.from(ne.value)}}Me.to=je;function Ee(ne){const Oe=(0,k.$Nh)(ne);return new r.$XN(E.URI.isUri(Oe.inlineReference)?Oe.inlineReference:g.to(Oe.inlineReference),ne.name)}Me.from=Ee})(Ot||(e.ChatResponseAnchorPart=Ot={}));var Lt;(function(Me){function je(ne){return{kind:"progressMessage",content:T.from(ne.value)}}Me.to=je;function Ee(ne){return new r.$YN(ne.content.value)}Me.from=Ee})(Lt||(e.ChatResponseProgressPart=Lt={}));var ri;(function(Me){function je(ne,Oe,Ue){return{kind:"command",command:Oe.toInternal(ne.value,Ue)??{command:ne.value.command,title:ne.value.title}}}Me.to=je;function Ee(ne,Oe){return new r.$ZN(Oe.fromInternal(ne.command)??{command:ne.command.id,title:ne.command.title})}Me.from=Ee})(ri||(e.ChatResponseCommandButtonPart=ri={}));var Bt;(function(Me){function je(ne){return{kind:"reference",reference:E.URI.isUri(ne.value)?ne.value:g.from(ne.value)}}Me.to=je;function Ee(ne){const Oe=(0,k.$Nh)(ne);return new r.$1N(E.URI.isUri(Oe.reference)?Oe.reference:g.to(Oe.reference))}Me.from=Ee})(Bt||(e.ChatResponseReferencePart=Bt={}));var Jt;(function(Me){function je(Oe){return Oe instanceof r.$VN?vt.to(Oe):Oe instanceof r.$XN?Ot.to(Oe):Oe instanceof r.$1N?Bt.to(Oe):Oe instanceof r.$YN?Lt.to(Oe):Oe instanceof r.$WN?Ut.to(Oe):{kind:"content",content:""}}Me.to=je;function Ee(Oe,Ue){switch(Oe.kind){case"reference":return Bt.from(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ne(Oe,Ue)}}Me.from=Ee;function ne(Oe,Ue){switch(Oe.kind){case"markdownContent":return vt.from(Oe);case"inlineReference":return Ot.from(Oe);case"progressMessage":return;case"treeData":return Ut.from(Oe);case"command":return ri.from(Oe,Ue)}}Me.fromContent=ne})(Jt||(e.ChatResponsePart=Jt={}));var Nt;(function(Me){function je(Oe,Ue){return"markdownContent"in Ue?((0,l.$WF)(Oe,"chatParticipantAdditions"),{content:T.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,l.$WF)(Oe,"chatParticipantAdditions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,l.$WF)(Oe,"chatParticipantAdditions"),{content:T.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(_e=>({uri:_e.uri,version:_e.version,ranges:_e.ranges.map(Ye=>h.from(Ye))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:h.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:h.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"participant"in Ue?((0,l.$WF)(Oe,"chatParticipantAdditions"),{agentName:Ue.participant,command:Ue.command,kind:"agentDetection"}):"message"in Ue?{content:T.from(Ue.message),kind:"progressMessage"}:void 0}Me.from=je;function Ee(Oe){switch(Oe.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Oe);case"content":return{content:Oe.content};case"usedContext":return{documents:Oe.documents.map(Ue=>({uri:E.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(_e=>h.to(_e))}))};case"reference":return{reference:(0,E.$vc)(Oe.reference)?E.URI.revive(Oe.reference):g.to(Oe.reference)};case"agentDetection":return;case"progressMessage":return{message:Oe.content.value};case"vulnerability":return{content:Oe.content,vulnerabilities:Oe.vulnerabilities};default:return}}Me.to=Ee;function ne(Oe,Ue){switch(Oe.kind){case"markdownContent":return{content:Oe.content.value};case"inlineReference":return{inlineReference:(0,E.$vc)(Oe.inlineReference)?E.URI.revive(Oe.inlineReference):g.to(Oe.inlineReference),title:Oe.name};case"command":return{command:Ue.fromInternal(Oe.command)??{command:Oe.command.id,title:Oe.command.title}};default:return}}Me.toProgressContent=ne})(Nt||(e.ChatResponseProgress=Nt={}));var Pt;(function(Me){function je(Ee){return{prompt:Ee.message,command:Ee.command,variables:Ee.variables.variables.map(yt.to)}}Me.to=je})(Pt||(e.ChatAgentRequest=Pt={}));var yt;(function(Me){function je(Ee){return{name:Ee.name,range:[Ee.range.start,Ee.range.endExclusive],values:Ee.values.map(Vt.to)}}Me.to=je})(yt||(e.ChatAgentResolvedVariable=yt={}));var kt;(function(Me){function je(Ee){return{label:Ee.label,values:Ee.values.map(Vt.from),insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation}}Me.from=je})(kt||(e.ChatAgentCompletionItem=kt={}));var St;(function(Me){function je(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Me.to=je})(St||(e.ChatAgentResult=St={}));var mi;(function(Me){function je(Ee,ne,Oe){if(ne.action.kind==="vote")return;const Ue=St.to(Ee);return ne.action.kind==="command"?{action:{kind:"command",commandButton:Nt.toProgressContent(ne.action.commandButton,Oe)},result:Ue}:ne.action.kind==="followUp"?{action:{kind:"followUp",followup:ei.to(ne.action.followup)},result:Ue}:{action:ne.action,result:Ue}}Me.to=je})(mi||(e.ChatAgentUserActionEvent=mi={}));var Qt;(function(Me){function je(Ee,ne,Oe){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:ne.toInternal(Ee,Oe)}Me.from=je})(Qt||(e.TerminalQuickFix=Qt={}));var hi;(function(Me){function je(Ee,ne){return{id:ne,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Me.from=je})(hi||(e.DebugTreeItem=hi={}))}),define(Se[319],De([1,0,6,20,15]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;let R=class{constructor(w,$){this.a=w.getProxy(D.$1L.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>$.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,$,k){const M=f.WorkspaceEdit.from(w,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,k?.isRefactoring??!1)}};e.$Yhc=R,e.$Yhc=R=Je([He(0,O.$fO)],R)}),define(Se[320],De([1,0,19,8,41,4,48,3,39,18,2,211,25,6,15,7,280,26]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class i{constructor(t,d,l,r,c,h){this.j=t,this.k=d,this.l=l,this.m=r,this.n=c,this.o=h,this.b=$.$1d.create(!1),this.d=!1}close(){this.d=!0}get timings(){return{firstProgress:this.g,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.i){let d=function(r){if(t.d){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,r),c}};const t=this;this.b.reset();const l=r=>{typeof this.g>"u"&&"content"in r&&(this.g=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.i={markdown(r){d(this.markdown);const c=new u.$VN(r),h=E.ChatResponseMarkdownPart.to(c);return l(h),this},filetree(r,c){d(this.filetree);const h=new u.$WN(r,c),g=E.ChatResponseFilesPart.to(h);return l(g),this},anchor(r,c){d(this.anchor);const h=new u.$XN(r,c),g=E.ChatResponseAnchorPart.to(h);return l(g),this},button(r){d(this.anchor);const c=new u.$ZN(r),h=E.ChatResponseCommandButtonPart.to(c,t.n,t.o);return l(h),this},progress(r){d(this.progress);const c=new u.$YN(r),h=E.ChatResponseProgressPart.to(c);return l(h),this},reference(r){d(this.reference);const c=new u.$1N(r),h=E.ChatResponseReferencePart.to(c);return l(h),this},push(r){d(this.push);const c=E.ChatResponsePart.to(r);return l(c),this},report(r){if(d(this.report),"placeholder"in r&&"resolvedContent"in r)return;const c=E.ChatResponseProgress.from(t.j,r);if(!c){t.m.error("Unknown progress type: "+JSON.stringify(r));return}return l(c),this}}}return this.i}}class n{constructor(t,d,l){this.j=d,this.k=l,this.d=new Map,this.i=new w.$3c,this.g=t.getProxy(S.$1L.MainThreadChatAgents2)}createChatAgent(t,d,l){const r=n.b++,c=new s(t,d,this.g,r,l);return this.d.set(r,c),this.g.$registerAgent(r,t.identifier,d,{}),c.apiAgent}async $invokeAgent(t,d,l,r){const c=this.d.get(t);if(!c)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.i.get(d.sessionId);h||(h=new w.$Sc,this.i.set(d.sessionId,h));const g=new i(c.extension,d,this.g,this.j,this.k.converter,h);try{const C=await this.l(d.agentId,l),v=c.invoke(E.ChatAgentRequest.to(d),{history:C},g.apiObject,r);return await(0,O.$5g)(Promise.resolve(v).then(m=>{if(m?.metadata)try{JSON.stringify(m.metadata)}catch(y){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.j.error(`[${c.extension.identifier.value}] [@${c.id}] ${P}`,c.extension),{errorDetails:{message:P},timings:g.timings}}return{errorDetails:m?.errorDetails,timings:g.timings,metadata:m?.metadata}}),r)}catch(C){return this.j.error(C,c.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,f.$2i)(C)),responseIsIncomplete:!0}}}finally{g.close()}}async l(t,d){const l=[];for(const r of d.history){const c=E.ChatAgentResult.to(r.result),h=t===r.request.agentId?c:{...c,metadata:void 0};l.push(new u.$2N(r.request.message,r.request.command,r.request.variables.variables.map(E.ChatAgentResolvedVariable.to),{extensionId:"",name:r.request.agentId}));const g=(0,D.$Hb)(r.response.map(C=>E.ChatResponsePart.fromContent(C,this.k.converter)));l.push(new u.$3N(g,h,{extensionId:"",name:r.request.agentId},r.request.command))}return l}$releaseSession(t){this.i.deleteAndDispose(t)}async $provideSlashCommands(t,d,l){const r=this.d.get(t);if(!r)return[];const c=await this.l(r.id,d);try{return await r.provideSlashCommands({history:c},l)}catch(h){const g=(0,f.$2i)(h);return this.j.error(`[${r.extension.identifier.value}] [@${r.id}] Error while providing slash commands: ${g}`),[]}}async $provideFollowups(t,d,l,r){const c=this.d.get(d);if(!c)return Promise.resolve([]);const h=E.ChatAgentResult.to(l);return(await c.provideFollowups(h,r)).filter(g=>{const C=!g.participant||L.Iterable.some(this.d.values(),v=>v.id===g.participant&&p.$xm.equals(v.extension.identifier,c.extension.identifier));return C||this.j.warn(`[@${c.id}] ChatFollowup refers to an invalid participant: ${g.participant}`),C}).map(g=>E.ChatFollowup.from(g,t))}$acceptFeedback(t,d,l,r){const c=this.d.get(t);if(!c)return;const h=E.ChatAgentResult.to(d);let g;switch(l){case b.InteractiveSessionVoteDirection.Down:g=u.ChatResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:g=u.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(r?{result:h,kind:g,reportIssue:r}:{result:h,kind:g}))}$acceptAction(t,d,l){const r=this.d.get(t);if(!r||l.action.kind==="vote")return;const c=E.ChatAgentUserActionEvent.to(d,l,this.k.converter);c&&r.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(t,d,l){const r=this.d.get(t);return r?(await r.invokeCompletionProvider(d,l)).map(E.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,d){const l=this.d.get(t);if(l)return await l.provideWelcomeMessage(d)}async $provideSampleQuestions(t,d){const l=this.d.get(t);if(l)return(await l.provideSampleQuestions(d)).map(r=>E.ChatFollowup.from(r,void 0))}}e.$1hc=n,n.b=0;class s{constructor(t,d,l,r,c){this.extension=t,this.id=d,this.y=l,this.z=r,this.A=c,this.q=new R.$5d,this.s=new R.$5d}acceptFeedback(t){this.q.fire(t)}acceptAction(t){this.s.fire(t)}async invokeCompletionProvider(t,d){return this.u?await this.u.provider.provideCompletionItems(t,d)??[]:[]}async provideSlashCommands(t,d){if(!this.b)return[];const l=await this.b.provideCommands(t,d);return l?l.map(r=>("isSticky2"in r&&(0,o.$WF)(this.extension,"chatParticipantAdditions"),{name:r.name,description:r.description??"",followupPlaceholder:r.isSticky2?.placeholder,isSticky:r.isSticky2?.isSticky??r.isSticky,sampleRequest:r.sampleRequest})):[]}async provideFollowups(t,d){if(!this.d)return[];const l=await this.d.provideFollowups(t,d);return l?l.filter(r=>!(r&&"commandId"in r)).filter(r=>!(r&&"message"in r)):[]}async provideWelcomeMessage(t){if(!this.w)return[];const d=await this.w.provideWelcomeMessage(t);return d?d.map(l=>typeof l=="string"?l:E.MarkdownString.from(l)):[]}async provideSampleQuestions(t){if(!this.w||!this.w.provideSampleQuestions)return[];const d=await this.w.provideSampleQuestions(t);return d||[]}get apiAgent(){let t=!1,d=!1;const l=()=>{t||d||(d=!0,queueMicrotask(()=>{this.y.$updateAgent(this.z,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof M.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof u.$XM?this.j:void 0,hasSlashCommands:this.b!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.p,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:E.MarkdownString.from(this.l),helpTextVariablesPrefix:!this.m||typeof this.m=="string"?this.m:E.MarkdownString.from(this.m),helpTextPostfix:!this.n||typeof this.n=="string"?this.n:E.MarkdownString.from(this.n),sampleRequest:this.o,supportIssueReporting:this.t,isSticky:this.x}),d=!1}))},r=this;return{get name(){return r.id},get description(){return r.g??""},set description(c){r.g=c,l()},get fullName(){return(0,o.$WF)(r.extension,"defaultChatParticipant"),r.i??r.extension.displayName??r.extension.name},set fullName(c){(0,o.$WF)(r.extension,"defaultChatParticipant"),r.i=c,l()},get iconPath(){return r.j},set iconPath(c){r.j=c,l()},get requestHandler(){return r.A},set requestHandler(c){(0,k.$3f)(typeof c=="function","Invalid request handler"),r.A=c},get commandProvider(){return r.b},set commandProvider(c){r.b=c,l()},get followupProvider(){return r.d},set followupProvider(c){r.d=c,l()},get isDefault(){return(0,o.$WF)(r.extension,"defaultChatParticipant"),r.k},set isDefault(c){(0,o.$WF)(r.extension,"defaultChatParticipant"),r.k=c,l()},get helpTextPrefix(){return(0,o.$WF)(r.extension,"defaultChatParticipant"),r.l},set helpTextPrefix(c){if((0,o.$WF)(r.extension,"defaultChatParticipant"),!r.k)throw new Error("helpTextPrefix is only available on the default chat agent");r.l=c,l()},get helpTextVariablesPrefix(){return(0,o.$WF)(r.extension,"defaultChatParticipant"),r.m},set helpTextVariablesPrefix(c){if((0,o.$WF)(r.extension,"defaultChatParticipant"),!r.k)throw new Error("helpTextVariablesPrefix is only available on the default chat agent");r.m=c,l()},get helpTextPostfix(){return(0,o.$WF)(r.extension,"defaultChatParticipant"),r.n},set helpTextPostfix(c){if((0,o.$WF)(r.extension,"defaultChatParticipant"),!r.k)throw new Error("helpTextPostfix is only available on the default chat agent");r.n=c,l()},get isSecondary(){return(0,o.$WF)(r.extension,"defaultChatParticipant"),r.p},set isSecondary(c){(0,o.$WF)(r.extension,"defaultChatParticipant"),r.p=c,l()},get sampleRequest(){return r.o},set sampleRequest(c){r.o=c,l()},get supportIssueReporting(){return(0,o.$WF)(r.extension,"chatParticipantAdditions"),r.t},set supportIssueReporting(c){(0,o.$WF)(r.extension,"chatParticipantAdditions"),r.t=c,l()},get onDidReceiveFeedback(){return r.q.event},set participantVariableProvider(c){if((0,o.$WF)(r.extension,"chatParticipantAdditions"),r.u=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");r.y.$registerAgentCompletionsProvider(r.z,c.triggerCharacters)}else r.y.$unregisterAgentCompletionsProvider(r.z)},get participantVariableProvider(){return(0,o.$WF)(r.extension,"chatParticipantAdditions"),r.u},set welcomeMessageProvider(c){(0,o.$WF)(r.extension,"defaultChatParticipant"),r.w=c,l()},get welcomeMessageProvider(){return(0,o.$WF)(r.extension,"defaultChatParticipant"),r.w},onDidPerformAction:(0,o.$VF)(this.extension,"chatParticipantAdditions")?this.s.event:void 0,get isSticky(){return r.x},set isSticky(c){r.x=c,l()},dispose(){t=!0,r.b=void 0,r.d=void 0,r.q.dispose(),r.y.$unregisterAgent(r.z)}}}invoke(t,d,l,r){return this.A(t,d,l,r)}}}),define(Se[321],De([1,0,22,3,6,15,107,25,8,4,212,143,41]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;class S{constructor(o,i){this.option=o,this.stream=new $.$Hh,this.stream=i??new $.$Hh}}class E{constructor(o,i){this.cts=i,this.a=new Map,this.b=new $.$Hh,this.c=!1;const n=this;this.apiObject={result:o,stream:n.b.asyncIterable},o.then(()=>{for(const s of this.d())s.resolve()}).catch(s=>{s instanceof Error||(s=new Error((0,p.$2i)(s),{cause:s}));for(const a of this.d())a.reject(s)}).finally(()=>{this.c=!0})}*d(){if(this.a.size>0)for(const[,o]of this.a)yield o.stream;else yield this.b}handleFragment(o){if(this.c)return;let i=this.a.get(o.index);i||(this.a.size===0?i=new S(o.index,this.b):i=new S(o.index),this.a.set(o.index,i)),i.stream.emitOne(o.part)}}class u{constructor(o,i,n){this.j=i,this.k=n,this.c=new k.$5d,this.d=new k.$5d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new w.$zm,this.i=new Map,this.b=o.getProxy(f.$1L.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(o,i,n,s){const a=u.a++;this.f.set(a,{extension:o.identifier,provider:n});let t;return s.auth&&(t={providerLabel:o.displayName||o.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this.b.$registerProvider(a,i,{extension:o.identifier,model:s.name??"",auth:t}),(0,O.$Rc)(()=>{this.f.delete(a),this.b.$unregisterProvider(a)})}async $provideLanguageModelResponse(o,i,n,s,a,t){const d=this.f.get(o);if(!d)return;const l=new L.$Iv(async r=>{if(t.isCancellationRequested){this.j.warn(`[CHAT](${d.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(i,{index:r.index,part:r.part})});return d.provider.provideLanguageModelResponse2(s.map(R.LanguageModelMessage.to),a,w.$xm.toKey(n),l,t)}$updateLanguageModels(o){const i=[],n=[];if(o.added)for(const s of o.added)this.g.add(s),i.push(s);if(o.removed)for(const s of o.removed){this.g.delete(s),n.push(s);for(const[a,t]of this.i)t.languageModelId===s&&(t.res.cts.cancel(),this.i.delete(a))}this.d.fire(Object.freeze({added:Object.freeze(i),removed:Object.freeze(n)}))}getLanguageModelIds(){return Array.from(this.g)}$updateModelAccesslist(o){const i=new Array;for(const{from:n,to:s,enabled:a}of o){const t=this.h.get(n)??new w.$ym;if(t.has(s)!==a){a?t.add(s):t.delete(s),this.h.set(n,t);const l={from:n,to:s};i.push(l),this.c.fire(l)}}}async requestLanguageModelAccess(o,i,n){const s=o.identifier,a=n?.justification,t=await this.b.$prepareChatAccess(s,i,a);if(!t)throw new Error(`Language model '${i}' NOT found`);this.m(s,t)&&await this.l(o,{identifier:t.extension,displayName:t.auth.providerLabel},a);const d=this;return{get model(){return t.model},get isRevoked(){return d.m(s,t)&&!d.h.get(s)?.has(t.extension)||!d.g.has(i)},get onDidChangeAccess(){const l=k.Event.filter(d.d.event,c=>c.removed.includes(i)),r=k.Event.filter(d.c.event,c=>w.$xm.equals(c.from,s)&&w.$xm.equals(c.to,t.extension));return k.Event.signal(k.Event.any(l,r))},makeChatRequest(l,r,c){if(d.m(s,t)&&!d.h.get(s)?.has(t.extension))throw new Error("Access to chat has been revoked");if(!d.g.has(i))throw new Error("Language Model has been removed");const h=new D.$ce(c),g=Math.random()*1e6|0,C=d.b.$fetchResponse(s,i,g,l.map(R.LanguageModelMessage.from),r??{},h.token),v=new E(C,h);return d.i.set(g,{languageModelId:i,res:v}),C.finally(()=>{d.i.delete(g),h.dispose()}),v.apiObject}}}async $handleResponseFragment(o,i){const n=this.i.get(o);n&&n.res.handleFragment(i)}async l(o,i,n){const s=I.$7K+i.identifier.value;if(!await this.k.getSession(o,s,[],{silent:!0}))try{const t=n?(0,M.localize)(0,null,i.displayName,n):(0,M.localize)(1,null,i.displayName);await this.k.getSession(o,s,[],{forceNewSession:{detail:t}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:o.identifier,to:i.identifier,enabled:!0}])}m(o,i){return!!i.auth&&!w.$xm.equals(i.extension,o)}}e.$2hc=u,u.a=1}),define(Se[322],De([1,0,14,3,6,15,7,26]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;class ${constructor(I){this.b=new Map,this.c=I.getProxy(f.$1L.MainThreadChatVariables)}async $resolveVariable(I,p,S,E){const u=this.b.get(I);if(u)try{if(u.resolver.resolve2){(0,w.$WF)(u.extension,"chatParticipantAdditions");const b=new k(p,this.c),o=await u.resolver.resolve2(u.data.name,{prompt:S},b.apiObject,E);if(o)return o.map(R.ChatVariable.from)}else{const b=await u.resolver.resolve(u.data.name,{prompt:S},E);if(b)return b.map(R.ChatVariable.from)}}catch(b){(0,D.$2)(b)}}registerVariableResolver(I,p,S,E){const u=$.a++;return this.b.set(u,{extension:I,data:{name:p,description:S},resolver:E}),this.c.$registerVariable(u,{name:p,description:S}),(0,O.$Rc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$3hc=$,$.a=0;class k{constructor(I,p){this.c=I,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(E){if(I.a){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,E),u}};const I=this,S=E=>{this.d.$handleProgressChunk(this.c,E)};this.b={progress(E){p(this.progress);const u=new L.$YN(E),b=R.ChatResponseProgressPart.to(u);return S(b),this},reference(E){p(this.reference);const u=new L.$1N(E),b=R.ChatResponseReferencePart.to(u);return S(b),this},push(E){p(this.push);const u=R.ChatResponsePart.to(E);return S(u),this}}}return this.b}}}),define(Se[323],De([1,0,8,53,4,3,2,83,25,15,7,6,26]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;function S(E,u,b){const o=E.getProxy(I.$1L.MainThreadComments);class i{constructor(){this.b=new Map,this.c=new $.$zm,u.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const g=this.b.get(h.handle);return g?g.value:h}else if(h&&h.$mid===7){const g=this.b.get(h.commentControlHandle);if(!g)return h;const C=g.getCommentThread(h.commentThreadHandle);return C?C.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const g=this.b.get(h.thread.commentControlHandle);if(!g)return h;const C=g.getCommentThread(h.thread.commentThreadHandle);return C?h.$mid===8?C.value:{thread:C.value,text:h.text}:h}else if(h&&h.$mid===10){const g=this.b.get(h.thread.commentControlHandle);if(!g)return h;const C=g.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const v=h.commentUniqueId,m=C.getCommentByUniqueId(v);return m||h}else if(h&&h.$mid===11){const g=this.b.get(h.thread.commentControlHandle);if(!g)return h;const C=g.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const v=h.text,m=h.commentUniqueId,y=C.getCommentByUniqueId(m);return y?(typeof y.body=="string"?y.body=v:y.body=new M.$rM(v),y):h}return h}})}createCommentController(h,g,C){const v=i.a++,m=new s(h,v,g,C);this.b.set(m.handle,m);const y=this.c.get(h.identifier)||[];return y.push(m),this.c.set(h.identifier,y),m.value}async $createCommentThreadTemplate(h,g,C){const v=this.b.get(h);v&&v.$createCommentThreadTemplate(g,C)}async $setActiveComment(h,g){const C=this.b.get(h);C&&C.$setActiveComment(g??void 0)}async $updateCommentThreadTemplate(h,g,C){const v=this.b.get(h);v&&v.$updateCommentThreadTemplate(g,C)}$deleteCommentThread(h,g){this.b.get(h)?.$deleteCommentThread(g)}$provideCommentingRanges(h,g,C){const v=this.b.get(h);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const m=b.getDocument(L.URI.revive(g));return(0,D.$9g)(async()=>{const y=await v.commentingRangeProvider.provideCommentingRanges(m,C);let P;return Array.isArray(y)?P={ranges:y,fileComments:!1}:y?P={ranges:y.ranges||[],fileComments:y.fileComments||!1}:P=y??void 0,P}).then(y=>{let P;return y&&(P={ranges:y.ranges.map(j=>k.Range.from(j)),fileComments:y.fileComments}),P})}$toggleReaction(h,g,C,v,m){const y=this.b.get(h);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,D.$9g)(()=>{const P=y.getCommentThread(g);if(P){const j=P.getCommentByUniqueId(v.uniqueIdInThread);if(y!==void 0&&j&&y.reactionHandler)return y.reactionHandler(j,d(m))}return Promise.resolve(void 0)})}}i.a=0;class n{set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,g,C,v,m,y,P,j){this.m=g,this.n=C,this.o=v,this.p=m,this.q=y,this.extensionDescription=P,this.r=j,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$5d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Uc,this.l.value=new R.$Sc,this.n===void 0&&(this.n=`${h}.${this.handle}`),o.$createCommentThread(g,this.handle,this.n,this.o,k.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{o.$deleteCommentThread(g,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(z){U.range=z},get comments(){return U.comments},set comments(z){U.comments=z},get collapsibleState(){return U.collapsibleState},set collapsibleState(z){U.collapsibleState=z},get canReply(){return U.canReply},set canReply(z){U.canReply=z},get contextValue(){return U.contextValue},set contextValue(z){U.contextValue=z},get label(){return U.label},set label(z){U.label=z},get state(){return U.state},set state(z){U.state=z},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Sc);const h=C=>Object.prototype.hasOwnProperty.call(this.b,C),g={};h("range")&&(g.range=k.Range.from(this.p)),h("label")&&(g.label=this.label),h("contextValue")&&(g.contextValue=this.contextValue??null),h("comments")&&(g.comments=this.q.map(C=>a(this,C,this.k,this.extensionDescription))),h("collapsibleState")&&(g.collapseState=l(this.g)),h("canReply")&&(g.canReply=this.canReply),h("state")&&(g.state=r(this.h)),h("isTemplate")&&(g.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,g)}getCommentByUniqueId(h){for(const g of this.k){const C=g[0],v=g[1];if(h===v)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}n.a=0,Je([(0,O.$Jh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class s{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$WF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$WF)(this.h,"activeComment"),this.f}constructor(h,g,C,v){this.h=h,this.i=g,this.j=C,this.k=v,this.a=new Map,o.$registerCommentController(this.handle,C,v,this.h.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(y){m.options=y},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(y){m.commentingRangeProvider=y},get reactionHandler(){return m.reactionHandler},set reactionHandler(y){m.reactionHandler=y},get activeCommentThread(){return m.activeCommentThread},createCommentThread(y,P,j){return m.createCommentThread(y,P,j).value},dispose:()=>{m.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(h,g,C){g===void 0&&(0,p.$WF)(this.h,"fileComments");const v=new n(this.id,this.handle,void 0,h,g,C,this.h,!1);return this.a.set(v.handle,v),v}$setActiveComment(h){if(!h){this.e=void 0,this.f=void 0;return}const g=this.a.get(h.commentThreadHandle);g&&(this.e=h.uniqueIdInThread?g.getCommentByUniqueId(h.uniqueIdInThread):void 0,this.f=g)}$createCommentThreadTemplate(h,g){const C=new n(this.id,this.handle,void 0,L.URI.revive(h),k.Range.to(g),[],this.h,!0);return C.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(h,g){const C=this.a.get(h);C&&(C.range=k.Range.to(g))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.g.forEach(h=>h.dispose())}}function a(c,h,g,C){let v=g.get(h);return v||(v=++c.commentHandle,g.set(h,v)),h.state!==void 0&&(0,p.$WF)(C,"commentsDraftState"),h.reactions?.some(m=>m.reactors!==void 0)&&(0,p.$WF)(C,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:v,body:typeof h.body=="string"?h.body:k.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(m=>t(m)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?k.$eO(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted,reactors:c.reactors&&c.reactors.length>0&&typeof c.reactors[0]!="string"?c.reactors.map(h=>h.name):c.reactors}}function d(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?L.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1,reactors:c.reactors?.map(h=>({name:h}))}}function l(c){if(c!==void 0)switch(c){case M.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function r(c){if(c!==void 0)switch(c){case M.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}return new i}e.$7hc=S}),define(Se[324],De([1,0,22,54,3,16,23,2,15,92,110,6,7]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class S{constructor(d,l){this.document=d,this.b=l,this.a=1,this.c=new M.$Lhc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,l){await this.f(d).undo(),l||this.disposeBackup()}async redo(d,l){await this.f(d).redo(),l||this.disposeBackup()}disposeEdits(d){for(const l of d)this.c.delete(l)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=a(this.document.uri)+this.a++;return(0,L.$Rg)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const l=this.c.get(d,0);if(!l)throw new Error("No edit found");return l}}class E{constructor(){this.a=new Map}get(d,l){return this.a.get(this.b(d,l))}add(d,l,r){const c=this.b(d,l.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${d} resource:${l.uri}`);const h=new S(l,r);return this.a.set(c,h),h}delete(d,l){const r=this.b(d,l.uri);this.a.delete(r)}b(d,l){return`${d}@@@${l}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class b{constructor(){this.a=new Map}addTextProvider(d,l,r){return this.b(0,d,l,r)}addCustomProvider(d,l,r){return this.b(1,d,l,r)}get(d){return this.a.get(d)}b(d,l,r,c){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,{type:d,extension:r,provider:c}),new p.$3L(()=>this.a.delete(l))}}class o{constructor(d,l,r,c,h){this.d=l,this.f=r,this.g=c,this.h=h,this.b=new b,this.c=new E,this.a=d.getProxy(I.$1L.MainThreadCustomEditors)}registerCustomEditorProvider(d,l,r,c){const h=new f.$Sc;return n(r)?(h.add(this.b.addTextProvider(l,d,r)),this.a.$registerTextEditorProvider((0,k.$jic)(d),l,c.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.$hic)(d))):(h.add(this.b.addCustomProvider(l,d,r)),i(r)&&h.add(r.onDidChangeCustomDocument(g=>{const C=this.i(l,g.document.uri);if(s(g)){const v=C.addEdit(g);this.a.$onDidEdit(g.document.uri,l,v,g.label)}else this.a.$onContentChange(g.document.uri,l)})),this.a.$registerCustomEditorProvider((0,k.$jic)(d),l,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,k.$hic)(d))),p.$3L.from(h,new p.$3L(()=>{this.a.$unregisterEditorProvider(l)}))}async $createCustomDocument(d,l,r,c,h){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${l}'`);const C=w.URI.revive(d),v=await g.provider.openCustomDocument(C,{backupId:r,untitledDocumentData:c?.buffer},h);let m;return i(g.provider)&&this.f&&(m=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(l,v,m),{editable:i(g.provider)}}async $disposeCustomDocument(d,l){const r=this.b.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${l}'`);const c=w.URI.revive(d),{document:h}=this.i(l,c);this.c.delete(l,h),h.dispose()}async $resolveCustomEditor(d,l,r,c,h,g){const C=this.b.get(r);if(!C)throw new Error(`No provider found for '${r}'`);const v=$.ViewColumn.to(h),m=this.g.createNewWebview(l,c.contentOptions,C.extension),y=this.h.createNewWebviewPanel(l,r,c.title,v,c.options,m,c.active),P=w.URI.revive(d);switch(C.type){case 1:{const{document:j}=this.i(r,P);return C.provider.resolveCustomEditor(j,y,g)}case 0:{const j=this.d.getDocument(P);return C.provider.resolveCustomTextEditor(j,y,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,l,r){this.i(l,d).disposeEdits(r)}async $onMoveCustomEditor(d,l,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const h=this.h.getWebviewPanel(d);if(!h)throw new Error("No webview found");const g=w.URI.revive(l),C=this.d.getDocument(g);await c.provider.moveCustomTextEditor(C,h,D.CancellationToken.None)}async $undo(d,l,r,c){return this.i(l,d).undo(r,c)}async $redo(d,l,r,c){return this.i(l,d).redo(r,c)}async $revert(d,l,r){const c=this.i(l,d);await this.j(l).revertCustomDocument(c.document,r),c.disposeBackup()}async $onSave(d,l,r){const c=this.i(l,d);await this.j(l).saveCustomDocument(c.document,r),c.disposeBackup()}async $onSaveAs(d,l,r,c){const h=this.i(l,d);return this.j(l).saveCustomDocumentAs(h.document,w.URI.revive(r),c)}async $backup(d,l,r){const c=this.i(l,d),g=await this.j(l).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},r);return c.updateBackup(g),g.id}i(d,l){const r=this.c.get(d,w.URI.revive(l));if(!r)throw new Error("No custom document found");return r}j(d){const r=this.b.get(d)?.provider;if(!r||!i(r))throw new Error("Custom document is not editable");return r}}e.$mic=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const d=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,O.$5i)(d)+""}});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[325],De([1,0,213,136,2,6,7,15,4,13,28,59]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";var p,S,E,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=void 0;class b{constructor(n,s,a,t,d,l,r,c){this.d=n,this.e=s,this.f=a,this.g=t,this.h=d,p.set(this,void 0),S.set(this,void 0),E.set(this,void 0),this.c=!1,this.f=Math.max(t,a),it(this,E,new M.$Ac(h=>l.getComparisonKey(h)),"f"),it(this,p,r,"f"),it(this,S,c,"f")}dispose(){this.c||(qe(this,S,"f").fire([...qe(this,E,"f").keys()]),qe(this,p,"f")?.$clear(this.e),qe(this,E,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(n,s){if(!n){this.clear();return}this.j();let a=[];if(f.URI.isUri(n)){if(!s){this.delete(n);return}qe(this,E,"f").set(n,s.slice()),a=[n]}else if(Array.isArray(n)){a=[];let l;n=[...n].sort(b.k);for(const r of n){const[c,h]=r;if((!l||c.toString()!==l.toString())&&(l&&qe(this,E,"f").get(l).length===0&&qe(this,E,"f").delete(l),l=c,a.push(c),qe(this,E,"f").set(c,[])),h)qe(this,E,"f").get(c)?.push(...h);else{const g=qe(this,E,"f").get(c);g&&(g.length=0)}}}if(qe(this,S,"f").fire(a),!qe(this,p,"f"))return;const t=[];let d=0;for(const l of a){let r=[];const c=qe(this,E,"f").get(l);if(c)if(c.length>this.g){r=[];const h=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const C of c)if(C.severity===h[g]&&r.push({...w.Diagnostic.from(C),modelVersionId:this.h(l)})===this.g)break e;r.push({severity:O.MarkerSeverity.Info,message:(0,D.localize)(0,null,c.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=c.map(h=>({...w.Diagnostic.from(h),modelVersionId:this.h(l)}));if(t.push([l,r]),d+=r.length,d>this.f)break}qe(this,p,"f").$changeMany(this.e,t)}delete(n){this.j(),qe(this,S,"f").fire([n]),qe(this,E,"f").delete(n),qe(this,p,"f")?.$changeMany(this.e,[[n,void 0]])}clear(){this.j(),qe(this,S,"f").fire([...qe(this,E,"f").keys()]),qe(this,E,"f").clear(),qe(this,p,"f")?.$clear(this.e)}forEach(n,s){this.j();for(const[a,t]of this)n.call(s,a,t,this)}*[(p=new WeakMap,S=new WeakMap,E=new WeakMap,Symbol.iterator)](){this.j();for(const n of qe(this,E,"f").keys())yield[n,this.get(n)]}get(n){this.j();const s=qe(this,E,"f").get(n);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(n){return this.j(),Array.isArray(qe(this,E,"f").get(n))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(n,s){return n[0].toString()<s[0].toString()?-1:n[0].toString()>s[0].toString()?1:0}}e.$Shc=b;let o=u=class{static _mapper(n){const s=new M.$Ac;for(const a of n)s.set(a,a);return{uris:Object.freeze(Array.from(s.values()))}}constructor(n,s,a,t){this.j=s,this.k=a,this.l=t,this.g=new Map,this.h=new $.$9d({merge:d=>d.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,u._mapper),this.f=n.getProxy(R.$1L.MainThreadDiagnostics)}createDiagnosticCollection(n,s){const{g:a,f:t,h:d,j:l,k:r,l:c}=this,h=new class{$changeMany(v,m){t.$changeMany(v,m),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",n.value,v,m.length===0?"CLEARING":m)}$clear(v){t.$clear(v),l.trace("[DiagnosticCollection] remove all (extension, owner)",n.value,v)}dispose(){t.dispose()}};let g;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,g=s;else if(!a.has(s))g=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do g=s+u.c++;while(a.has(g))}return new class extends b{constructor(){super(s,g,u.e,u.d,v=>c.getDocument(v)?.version,r.extUri,h,d),a.set(g,this)}dispose(){super.dispose(),a.delete(g)}}}getDiagnostics(n){if(n)return this.m(n);{const s=new Map,a=[];for(const t of this.g.values())t.forEach((d,l)=>{let r=s.get(d.toString());typeof r>"u"&&(r=a.length,s.set(d.toString(),r),a.push([d,[]])),a[r][1]=a[r][1].concat(...l)});return a}}m(n){let s=[];for(const a of this.g.values())a.has(n)&&(s=s.concat(a.get(n)));return s}$acceptMarkersChange(n){if(!this.n){const s="_generated_mirror",a=new b(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(s,a),this.n=a}for(const[s,a]of n)this.n.set(f.URI.revive(s),a.map(w.Diagnostic.to))}};e.$Thc=o,o.c=0,o.d=1e3,o.e=1.1*u.d,e.$Thc=o=u=Je([He(1,k.$yj),He(2,I.$Rhc)],o)}),define(Se[326],De([1,0,2,14,7,15,75]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;class w{constructor(k,M,I,p={timeout:1500,errors:3}){this.c=k,this.d=M,this.f=I,this.g=p,this.a=new L.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(M,I,p)=>{const E={dispose:this.a.push([M,I,k])};return Array.isArray(p)&&p.push(E),E}}async $participateInSave(k,M){const I=D.URI.revive(k);let p=!1;const S=setTimeout(()=>p=!0,this.g.timeout),E=[];try{for(const u of[...this.a]){if(p)break;const b=this.d.getDocument(I),o=await this.h(u,{document:b,reason:R.TextDocumentSaveReason.to(M)});E.push(o)}}finally{clearTimeout(S)}return E}h([k,M,I],p){const S=this.b.get(k);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(I,k,M,p).then(()=>!0,E=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const u=this.b.get(k);this.b.set(k,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,M,I,p){const S=[],E=Date.now(),{document:u,reason:b}=p,{version:o}=u,i=Object.freeze({document:u,reason:b,waitUntil(n){if(Object.isFrozen(S))throw(0,O.$8)("waitUntil can not be called async");S.push(Promise.resolve(n))}});try{M.apply(I,[i])}catch(n){return Promise.reject(n)}return Object.freeze(S),new Promise((n,s)=>{const a=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),s(t)})}).then(n=>{const s={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof f.$0L))for(const{newText:t,newEol:d,range:l}of a)s.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:t,eol:d&&R.EndOfLine.from(d)}});if(s.edits.length!==0)return o===u.version?this.f.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.$1ic=w}),define(Se[327],De([1,0,4,3,2,6,150,15,18,24,7]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class I{constructor(S,E){this.a=new D.$5d,this.b=new D.$5d,this.c=new D.$5d,this.d=new D.$5d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Sc,this.h=new Map,this.f=S.getProxy(R.$1L.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(u=>{for(const b of u)this.b.fire(b.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const b of u)this.a.fire(b.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const E=this.g.getDocument(S);if(E)return E}getDocument(S){const E=this.getDocumentData(S);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return E.document}ensureDocumentData(S){const E=this.g.getDocument(S);if(E)return Promise.resolve(E);let u=this.h.get(S.toString());return u||(u=this.f.$tryOpenDocument(S).then(b=>{this.h.delete(S.toString());const o=f.URI.revive(b);return(0,$.$4f)(this.g.getDocument(o))},b=>(this.h.delete(S.toString()),Promise.reject(b))),this.h.set(S.toString(),u)),u}createDocumentData(S){return this.f.$tryCreateDocument(S).then(E=>f.URI.revive(E))}$acceptModelLanguageChanged(S,E){const u=f.URI.revive(S),b=this.g.getDocument(u);if(!b)throw new Error("unknown document");this.b.fire(b.document),b._acceptLanguageId(E),this.a.fire(b.document)}$acceptModelSaved(S){const E=f.URI.revive(S),u=this.g.getDocument(E);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(S,E){const u=f.URI.revive(S),b=this.g.getDocument(u);if(!b)throw new Error("unknown document");b._acceptIsDirty(E),this.c.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,E,u){const b=f.URI.revive(S),o=this.g.getDocument(b);if(!o)throw new Error("unknown document");o._acceptIsDirty(u),o.onEvents(E);let i;E.isUndoing?i=M.TextDocumentChangeReason.Undo:E.isRedoing&&(i=M.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Jn)({document:o.document,contentChanges:E.changes.map(n=>({range:w.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(S,E){(0,L.$hO)(S,E)}}e.$Uhc=I}),define(Se[71],De([1,0,73,4,18,2,5,6,20,15,7]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=e.$nic=void 0,e.$nic=(0,L.$ei)("IExtHostEditorTabs");class I{constructor(b,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(b)}get apiObject(){if(!this.a){const b=this,o={get isActive(){return b.b.id===b.e()},get label(){return b.b.label},get input(){return b.c},get isDirty(){return b.b.isDirty},get isPinned(){return b.b.isPinned},get isPreview(){return b.b.isPreview},get group(){return b.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(b){this.b=b,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$KN(R.URI.revive(this.b.input.uri));case 2:return new M.$LN(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new M.$MN(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new M.$NN(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$ON(this.b.input.viewType);case 4:return new M.$PN(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$QN(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$RN;case 9:return new M.$SN(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$TN(this.b.input.providerId);default:return}}}class p{constructor(b,o){this.c=[],this.d="",this.b=b,this.e=o;for(const i of b.tabs)i.isActive&&(this.d=i.id),this.c.push(new I(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const b=this,o={get isActive(){return b.b.groupId===b.e()},get viewColumn(){return k.ViewColumn.to(b.b.viewColumn)},get activeTab(){return b.c.find(i=>i.tabId===b.d)?.apiObject},get tabs(){return Object.freeze(b.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(b){this.b=b}acceptTabOperation(b){if(b.kind===0){const i=new I(b.tabDto,this,()=>this.activeTabId());return this.c.splice(b.index,0,i),b.tabDto.isActive&&(this.d=i.tabId),i}else if(b.kind===1){const i=this.c.splice(b.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${b.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(b.kind===3){if(b.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(b.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${b.oldIndex} which does not exist`);return this.c.splice(b.index,0,i),i}const o=this.c.find(i=>i.tabId===b.tabDto.id);if(!o)throw new Error("INVALID tab");return b.tabDto.isActive?this.d=b.tabDto.id:this.d===b.tabDto.id&&!b.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(b.tabDto),o}activeTabId(){return this.d}}let S=class{constructor(b){this.b=new O.$5d,this.c=new O.$5d,this.e=[],this.a=b.getProxy(w.$1L.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const b=this,o={onDidChangeTabGroups:b.c.event,onDidChangeTabs:b.b.event,get all(){return Object.freeze(b.e.map(i=>i.apiObject))},get activeTabGroup(){const i=b.d;return(0,f.$4f)(b.e.find(s=>s.groupId===i)?.apiObject)},close:async(i,n)=>{const s=Array.isArray(i)?i:[i];return s.length?E(s[0])?this.j(s,n):this.i(s,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(b){const o=new Set(this.e.map(l=>l.groupId)),i=new Set(b.map(l=>l.groupId)),n=(0,D.$F)(o,i),s=this.e.filter(l=>n.removed.includes(l.groupId)).map(l=>l.apiObject),a=[],t=[];this.e=b.map(l=>{const r=new p(l,()=>this.d);return n.added.includes(r.groupId)?a.push(r.apiObject):t.push(r.apiObject),r});const d=(0,f.$4f)(b.find(l=>l.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:a,closed:s,changed:t}))}$acceptTabGroupUpdate(b){const o=this.e.find(i=>i.groupId===b.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(b),b.isActive&&(this.d=b.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(b){const o=this.e.find(n=>n.groupId===b.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(b);switch(b.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(b){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===b)return i}h(b){return this.e.find(o=>o.apiObject===b)}async i(b,o){const i=[];for(const n of b){const s=this.g(n);if(!s)throw new Error("Tab close: Invalid tab not found!");i.push(s.tabId)}return this.a.$closeTab(i,o)}async j(b,o){const i=[];for(const n of b){const s=this.h(n);if(!s)throw new Error("Group close: Invalid group not found!");i.push(s.groupId)}return this.a.$closeGroup(i,o)}};e.$oic=S,e.$oic=S=Je([He(0,$.$fO)],S);function E(u){return u.tabs!==void 0}}),define(Se[328],De([1,0,2,6,3,7,15,182,12,21,26,79]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class p{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const b=this.a.indexOf(u);b>=0&&(this.a.splice(b,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),b=[];let o,i,n=14,s=14;for(const a of u){let t=o?(0,$.$lf)(o,a):0;for(t===0?i=1:i=s;t<a.length;t++)t+1===a.length?(n=s,s=9):s+=1,b.push([i,a.toUpperCase().charCodeAt(t),s]),b.push([i,a.toLowerCase().charCodeAt(t),s]),i=s;o=a,s=n}b.push([9,58,10]),b.push([10,47,12]),this.b=new w.$01(b)}}provideDocumentLinks(u){this.c();const b=[],o=w.$$1.computeLinks({getLineContent(i){return u.lineAt(i-1).text},getLineCount(){return u.lineCount}},this.b);for(const i of o){const n=L.DocumentLink.to(i);n.target&&b.push(n)}return b}}class S{constructor(u,b){this.i=b,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(O.$1L.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,b,o,i={}){if(S.j(o),this.d.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const n=this.h++;this.b.add(b),this.d.add(b),this.c.set(n,o);let s=2;i.isCaseSensitive&&(s+=1024),i.isReadonly&&(s+=2048),typeof o.copy=="function"&&(s+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,M.$WF)(u,"fsChunks"),s+=4);let a;i.isReadonly&&(0,I.$uk)(i.isReadonly)&&i.isReadonly.value!==""&&(a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,b,s,a).catch(d=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${b}`),console.error(d)});const t=o.onDidChangeFile(d=>{const l=[];for(const r of d){const{uri:c,type:h}=r;if(c.scheme!==b)continue;let g;switch(h){case R.FileChangeType.Changed:g=0;break;case R.FileChangeType.Created:g=1;break;case R.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:c,type:g})}this.a.$onFileSystemChange(n,l)});return(0,f.$Rc)(()=>{t.dispose(),this.b.delete(b),this.d.delete(b),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:b,ctime:o,mtime:i,size:n,permissions:s}=u;return{type:b,ctime:o,mtime:i,size:n,permissions:s}}$stat(u,b){return Promise.resolve(this.l(u).stat(D.URI.revive(b))).then(o=>S.k(o))}$readdir(u,b){return Promise.resolve(this.l(u).readDirectory(D.URI.revive(b)))}$readFile(u,b){return Promise.resolve(this.l(u).readFile(D.URI.revive(b))).then(o=>k.$se.wrap(o))}$writeFile(u,b,o,i){return Promise.resolve(this.l(u).writeFile(D.URI.revive(b),o.buffer,i))}$delete(u,b,o){return Promise.resolve(this.l(u).delete(D.URI.revive(b),o))}$rename(u,b,o,i){return Promise.resolve(this.l(u).rename(D.URI.revive(b),D.URI.revive(o),i))}$copy(u,b,o,i){const n=this.l(u);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(b),D.URI.revive(o),i))}$mkdir(u,b){return Promise.resolve(this.l(u).createDirectory(D.URI.revive(b)))}$watch(u,b,o,i){const n=this.l(u).watch(D.URI.revive(o),i);this.f.set(b,n)}$unwatch(u,b){const o=this.f.get(b);o&&(o.dispose(),this.f.delete(b))}$open(u,b,o){const i=this.l(u);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(b),o))}$close(u,b){const o=this.l(u);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(b))}$read(u,b,o,i){const n=this.l(u);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const s=k.$se.alloc(i);return Promise.resolve(n.read(b,o,s.buffer,0,i)).then(a=>s.slice(0,a))}$write(u,b,o,i){const n=this.l(u);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(b,o,i.buffer,0,i.byteLength))}l(u){const b=this.c.get(u);if(!b){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return b}}e.$3ic=S}),define(Se[329],De([1,0,4,35,2,6,15,7,44]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,E,u,b,o,i){this.a=Math.random(),this.b=new D.$5d,this.c=new D.$5d,this.d=new D.$5d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,O.$Xj)(o),s=typeof o=="string",a=i?.correlate,t=b(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(a&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const r=f.URI.revive(l);n(r.fsPath)&&(!s||E.getWorkspaceFolder(r))&&this.b.fire(r)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const r=f.URI.revive(l);n(r.fsPath)&&(!s||E.getWorkspaceFolder(r))&&this.c.fire(r)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const r=f.URI.revive(l);n(r.fsPath)&&(!s||E.getWorkspaceFolder(r))&&this.d.fire(r)}}});this.g=w.$3L.from(this.i(S,u,o,i,i?.correlate),this.b,this.c,this.d,t)}i(S,E,u,b,o){const i=w.$3L.from();if(typeof u=="string")return i;const n=S.getProxy(R.$1L.MainThreadFileSystemEventService);let s=!1;return(u.pattern.includes(O.$Tj)||u.pattern.includes(O.$Uj))&&(s=!0),n.$watch(E.identifier.value,this.a,u.baseUri,{recursive:s,excludes:b?.excludes??[]},!!o),w.$3L.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(S){this.a=S,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(f.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(f.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(S,E,u){this.j=S,this.k=E,this.l=u,this.a=new D.$5d,this.b=new D.$5d,this.c=new D.$5d,this.d=new D.$5d,this.g=new D.$7d,this.h=new D.$7d,this.i=new D.$7d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,E,u,b){return new k(this.j,S,E,this.a.event,L.GlobPattern.from(u),b)}$onFileEvent(S){this.a.fire(new M(S))}$onDidRunFileOperation(S,E){switch(S){case 2:this.b.fire(Object.freeze({files:E.map(u=>({oldUri:f.URI.revive(u.source),newUri:f.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(u=>f.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(u=>f.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,E){return(u,b,o)=>{const i=function(s){u.call(b,s)};return i.extension=S,E.event(i,void 0,o)}}async $onWillRunFileOperation(S,E,u,b){switch(S){case 2:return await this.n(this.g,{files:E.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},u,b);case 1:return await this.n(this.i,{files:E.map(o=>f.URI.revive(o.target))},u,b);case 0:case 3:return await this.n(this.h,{files:E.map(o=>f.URI.revive(o.target))},u,b)}}async n(S,E,u,b){const o=new Set,i=[];if(await S.fireAsync(E,b,async(s,a)=>{const t=Date.now(),d=await Promise.resolve(s);d instanceof w.$aM&&(i.push([a.extension,d]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",a.extension.identifier)}),b.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,s]of i){const{edits:a}=L.WorkspaceEdit.from(s,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.$4ic=I}),define(Se[330],De([1,0,19,8,22,14,122,3,24,39,12,18,2,29,175,83,132,215,25,15,7,26,110,6]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class l{constructor(B,V){this.d=B,this.e=V}async provideDocumentSymbols(B,V){const x=this.d.getDocument(B),Y=await this.e.provideDocumentSymbols(x,V);if(!(0,D.$Kb)(Y))return Y[0]instanceof s.$jM?Y.map(n.DocumentSymbol.from):l.f(Y)}static f(B){B=B.slice(0).sort((Y,$e)=>{let ve=Y.location.range.start.compareTo($e.location.range.start);return ve===0&&(ve=$e.location.range.end.compareTo(Y.location.range.end)),ve});const V=[],x=[];for(const Y of B){const $e={name:Y.name||"!!MISSING: name!!",kind:n.SymbolKind.from(Y.kind),tags:Y.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:n.Range.from(Y.location.range),selectionRange:n.Range.from(Y.location.range),children:[]};for(;;){if(x.length===0){x.push($e),V.push($e);break}const ve=x[x.length-1];if(S.$7s.containsRange(ve.range,$e.range)&&!S.$7s.equalsRange(ve.range,$e.range)){ve.children?.push($e),x.push($e);break}x.pop()}}return V}}class r{constructor(B,V,x,Y,$e,ve){this.f=B,this.g=V,this.h=x,this.j=Y,this.k=$e,this.l=ve,this.d=new t.$Lhc("CodeLens"),this.e=new Map}async provideCodeLenses(B,V){const x=this.f.getDocument(B),Y=await this.h.provideCodeLenses(x,V);if(!Y||V.isCancellationRequested)return;const $e=this.d.add(Y),ve=new w.$Sc;this.e.set($e,ve);const Te={cacheId:$e,lenses:[]};for(let Ve=0;Ve<Y.length;Ve++)Te.lenses.push({cacheId:[$e,Ve],range:n.Range.from(Y[Ve].range),command:this.g.toInternal(Y[Ve].command,ve)});return Te}async resolveCodeLens(B,V){const x=B.cacheId&&this.d.get(...B.cacheId);if(!x)return;let Y;if(typeof this.h.resolveCodeLens!="function"||x.isResolved?Y=x:Y=await this.h.resolveCodeLens(x,V),Y||(Y=x),V.isCancellationRequested)return;const $e=B.cacheId&&this.e.get(B.cacheId[0]);if($e){if(!Y.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return B.command=this.g.toInternal(Y.command,$e),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function c(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class h{constructor(B,V){this.d=B,this.e=V}async provideDefinition(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideDefinition(Y,$e,x);return c(ve)}}class g{constructor(B,V){this.d=B,this.e=V}async provideDeclaration(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideDeclaration(Y,$e,x);return c(ve)}}class C{constructor(B,V){this.d=B,this.e=V}async provideImplementation(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideImplementation(Y,$e,x);return c(ve)}}class v{constructor(B,V){this.d=B,this.e=V}async provideTypeDefinition(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideTypeDefinition(Y,$e,x);return c(ve)}}class m{constructor(B,V){this.d=B,this.e=V}async provideHover(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideHover(Y,$e,x);if(!(!ve||(0,D.$Kb)(ve.contents)))return ve.range||(ve.range=Y.getWordRangeAtPosition($e)),ve.range||(ve.range=new s.$5L($e,$e)),n.Hover.from(ve)}}class y{constructor(B,V){this.d=B,this.e=V}async provideEvaluatableExpression(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideEvaluatableExpression(Y,$e,x);if(ve)return n.EvaluatableExpression.from(ve)}}class P{constructor(B,V){this.d=B,this.e=V}async provideInlineValues(B,V,x,Y){const $e=this.d.getDocument(B),ve=await this.e.provideInlineValues($e,n.Range.to(V),n.InlineValueContext.to(x),Y);if(Array.isArray(ve))return ve.map(Te=>n.InlineValue.from(Te))}}class j{constructor(B,V){this.d=B,this.e=V}async provideDocumentHighlights(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideDocumentHighlights(Y,$e,x);if(Array.isArray(ve))return ve.map(n.DocumentHighlight.from)}}class U{constructor(B,V){this.d=B,this.e=V}async provideMultiDocumentHighlights(B,V,x,Y){const $e=this.d.getDocument(B),ve=x.map(Qe=>this.d.getDocument(Qe)),Te=n.Position.to(V),Ve=await this.e.provideMultiDocumentHighlights($e,Te,ve,Y);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class z{constructor(B,V){this.d=B,this.e=V}async provideLinkedEditingRanges(B,V,x){const Y=this.d.getDocument(B),$e=n.Position.to(V),ve=await this.e.provideLinkedEditingRanges(Y,$e,x);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,D.$Hb)(ve.ranges.map(n.Range.from)),wordPattern:ve.wordPattern}}}class N{constructor(B,V){this.d=B,this.e=V}async provideReferences(B,V,x,Y){const $e=this.d.getDocument(B),ve=n.Position.to(V),Te=await this.e.provideReferences($e,ve,x,Y);if(Array.isArray(Te))return Te.map(n.location.from)}}class A{constructor(B,V,x,Y,$e,ve,Te){this.g=B,this.h=V,this.j=x,this.k=Y,this.l=$e,this.m=ve,this.n=Te,this.e=new t.$Lhc("CodeAction"),this.f=new Map}async provideCodeActions(B,V,x,Y){const $e=this.g.getDocument(B),ve=E.$9s.isISelection(V)?n.Selection.to(V):n.Range.to(V),Te=[];for(const ot of this.j.getDiagnostics(B))if(ve.intersection(ot.range)&&Te.push(ot)>A.d)break;const Ve={diagnostics:Te,only:x.only?new s.$lM(x.only):void 0,triggerKind:n.CodeActionTriggerKind.to(x.trigger)},Qe=await this.k.provideCodeActions($e,ve,Ve,Y);if(!(0,D.$Lb)(Qe)||Y.isCancellationRequested)return;const tt=this.e.add(Qe),at=new w.$Sc;this.f.set(tt,at);const dt=[];for(let ot=0;ot<Qe.length;ot++){const rt=Qe[ot];if(rt)if(A.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),dt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,at)});else{Ve.only&&(rt.kind?Ve.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Pe=rt.ranges??[];dt.push({cacheId:[tt,ot],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,at),diagnostics:rt.diagnostics&&rt.diagnostics.map(n.Diagnostic.from),edit:rt.edit&&n.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,a.$VF)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,a.$VF)(this.m,"codeActionRanges")?(0,D.$Hb)(Pe.map(n.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:tt,actions:dt}}async resolveCodeAction(B,V){const[x,Y]=B,$e=this.e.get(x,Y);if(!$e||A.o($e))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction($e,V)??$e;let Te;ve.edit&&(Te=n.WorkspaceEdit.from(ve.edit,void 0));let Ve;if(ve.command){const Qe=this.f.get(x);Qe&&(Ve=this.h.toInternal(ve.command,Qe))}return{edit:Te,command:Ve}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}A.d=1e3;class T{static toInternalProviderId(B,V){return B+"."+V}constructor(B,V,x,Y,$e){this.d=B,this.e=V,this.f=x,this.g=Y,this.h=$e}async prepareDocumentPaste(B,V,x,Y){if(!this.f.prepareDocumentPaste)return;const $e=this.e.getDocument(B),ve=V.map(Qe=>n.Range.to(Qe)),Te=n.DataTransfer.toDataTransfer(x,()=>{throw new R.$$});if(await this.f.prepareDocumentPaste($e,ve,Te,Y),Y.isCancellationRequested)return;const Ve=Array.from(Te).filter(([,Qe])=>!(Qe instanceof s.$RM));return n.DataTransfer.from(Ve)}async providePasteEdits(B,V,x,Y,$e){if(!this.f.provideDocumentPasteEdits)return;const ve=this.e.getDocument(V),Te=x.map(tt=>n.Range.to(tt)),Ve=n.DataTransfer.toDataTransfer(Y,async tt=>(await this.d.$resolvePasteFileData(this.g,B,tt)).buffer),Qe=await this.f.provideDocumentPasteEdits(ve,Te,Ve,$e);if(Qe)return{label:Qe.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Qe.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:T.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?n.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class F{constructor(B,V){this.d=B,this.e=V}async provideDocumentFormattingEdits(B,V,x){const Y=this.d.getDocument(B),$e=await this.e.provideDocumentFormattingEdits(Y,V,x);if(Array.isArray($e))return $e.map(n.TextEdit.from)}}class G{constructor(B,V){this.d=B,this.e=V}async provideDocumentRangeFormattingEdits(B,V,x,Y){const $e=this.d.getDocument(B),ve=n.Range.to(V),Te=await this.e.provideDocumentRangeFormattingEdits($e,ve,x,Y);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,V,x,Y){(0,I.$3f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const $e=this.d.getDocument(B),ve=V.map(n.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits($e,ve,x,Y);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}}class K{constructor(B,V){this.d=B,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,V,x,Y,$e){const ve=this.d.getDocument(B),Te=n.Position.to(V),Ve=await this.e.provideOnTypeFormattingEdits(ve,Te,x,Y,$e);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class X{constructor(B,V){this.e=B,this.f=V,this.d=new t.$Lhc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,V){const x=await this.e.provideWorkspaceSymbols(B,V);if(!(0,D.$Lb)(x))return{symbols:[]};const Y=this.d.add(x),$e={cacheId:Y,symbols:[]};for(let ve=0;ve<x.length;ve++){const Te=x[ve];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}$e.symbols.push({...n.WorkspaceSymbol.from(Te),cacheId:[Y,ve]})}return $e}async resolveWorkspaceSymbol(B,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const x=this.d.get(...B.cacheId);if(x){const Y=await this.e.resolveWorkspaceSymbol(x,V);return Y&&(0,$.$Ln)(B,n.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Q{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,V,x){this.d=B,this.e=V,this.f=x}async provideRenameEdits(B,V,x,Y){const $e=this.d.getDocument(B),ve=n.Position.to(V);try{const Te=await this.e.provideRenameEdits($e,ve,x,Y);return Te?n.WorkspaceEdit.from(Te):void 0}catch(Te){const Ve=Q.g(Te);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(B,V,x){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(B),$e=n.Position.to(V);try{const ve=await this.e.prepareRename(Y,$e,x);let Te,Ve;if(s.$5L.isRange(ve)?(Te=ve,Ve=Y.getText(ve)):(0,I.$Uf)(ve)&&(Te=ve.range,Ve=ve.placeholder),!Te||!Ve)return;if(Te.start.line>$e.line||Te.end.line<$e.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Te),text:Ve}}catch(ve){const Te=Q.g(ve);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ve)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,V,x){this.d=B,this.e=V,this.f=x}async provideNewSymbolNames(B,V,x){const Y=this.d.getDocument(B),$e=n.Range.to(V);try{const ve=await this.e.provideNewSymbolNames(Y,$e,x);return ve?ve.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(ve){this.f.error(Z.g(ve)??JSON.stringify(ve,null,"	"));return}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ie{constructor(B,V){this.resultId=B,this.tokens=V}}class ee{constructor(B,V){this.f=B,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,V,x){const Y=this.f.getDocument(B),$e=V!==0?this.d.get(V):null;let ve=typeof $e?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,$e.resultId,x):await this.g.provideDocumentSemanticTokens(Y,x);return $e&&this.d.delete(V),ve?(ve=ee.h(ve),this.o(ee.n($e,ve),ve)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ee.j(B)?ee.k(B)?B:new s.$jN(new Uint32Array(B.data),B.resultId):ee.l(B)?ee.m(B)?B:new s.$lN(B.edits.map(V=>new s.$kN(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const V of B.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(B,V){if(!ee.j(V)||!B||!B.tokens)return V;const x=B.tokens,Y=x.length,$e=V.data,ve=$e.length;let Te=0;const Ve=Math.min(Y,ve);for(;Te<Ve&&x[Te]===$e[Te];)Te++;if(Te===Y&&Te===ve)return new s.$lN([],V.resultId);let Qe=0;const tt=Ve-Te;for(;Qe<tt&&x[Y-Qe-1]===$e[ve-Qe-1];)Qe++;return new s.$lN([{start:Te,deleteCount:Y-Te-Qe,data:$e.subarray(Te,ve-Qe)}],V.resultId)}o(B,V){if(ee.j(B)){const x=this.e++;return this.d.set(x,new ie(B.resultId,B.data)),(0,b.$bab)({id:x,type:"full",data:B.data})}if(ee.l(B)){const x=this.e++;return ee.j(V)?this.d.set(x,new ie(V.resultId,V.data)):this.d.set(x,new ie(B.resultId)),(0,b.$bab)({id:x,type:"delta",deltas:(B.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class we{constructor(B,V){this.d=B,this.e=V}async provideDocumentRangeSemanticTokens(B,V,x){const Y=this.d.getDocument(B),$e=await this.e.provideDocumentRangeSemanticTokens(Y,n.Range.to(V),x);return $e?this.f($e):null}f(B){return(0,b.$bab)({id:0,type:"full",data:B.data})}}class ue{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,V,x,Y,$e){this.f=B,this.g=V,this.h=x,this.j=Y,this.k=$e,this.d=new t.$Lhc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,V,x,Y){const $e=this.f.getDocument(B),ve=n.Position.to(V),Te=$e.getWordRangeAtPosition(ve)||new s.$5L(ve,ve),Ve=Te.with({end:ve}),Qe=new k.$1d,tt=await this.h.provideCompletionItems($e,ve,Y,n.CompletionContext.to(x));if(!tt||Y.isCancellationRequested)return;const at=Array.isArray(tt)?new s.$yM(tt):tt,dt=ue.supportsResolving(this.h)?this.d.add(at.items):this.d.add([]),ot=new w.$Sc;this.e.set(dt,ot);const rt=[],Pe={x:dt,b:rt,a:{replace:n.Range.from(Te),insert:n.Range.from(Ve)},c:at.isIncomplete||void 0,d:Qe.elapsed()};for(let Ie=0;Ie<at.items.length;Ie++){const Ge=at.items[Ie],te=this.l(Ge,[dt,Ie],Ve,Te);rt.push(te)}return Pe}async resolveCompletionItem(B,V){if(typeof this.h.resolveCompletionItem!="function")return;const x=this.d.get(...B);if(!x)return;const Y=this.l(x,B),$e=await this.h.resolveCompletionItem(x,V);if(!$e)return;const ve=this.l($e,B);return(Y.h!==ve.h||Y.i!==ve.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Y.n!==ve.n||Y.o!==ve.o||!(0,$.$Mn)(Y.p,ve.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Y,d:ve.d,c:ve.c,l:ve.l,h:ve.h,i:ve.i,n:ve.n,o:ve.o,p:ve.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,V,x,Y){const $e=this.e.get(V[0]);if(!$e)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(B.command,$e),Te={x:V,a:B.label,b:B.kind!==void 0?n.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(n.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:n.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(n.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=B.textEdit.newText):typeof B.insertText=="string"?Te.h=B.insertText:B.insertText instanceof s.$bM&&(Te.h=B.insertText.value,Te.i|=4);let Ve;return B.textEdit?Ve=B.textEdit.range:B.range&&(Ve=B.range),s.$5L.isRange(Ve)?Te.j=n.Range.from(Ve):Ve&&(!x?.isEqual(Ve.inserting)||!Y?.isEqual(Ve.replacing))&&(Te.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Te}}class ae{async provideInlineCompletions(B,V,x,Y){}disposeCompletions(B){}handleDidShowCompletionItem(B,V,x){}handlePartialAccept(B,V,x){}}class H extends ae{constructor(B,V,x,Y){super(),this.f=B,this.g=V,this.h=x,this.j=Y,this.d=new he,this.e=(0,a.$VF)(this.f,"inlineCompletionsAdditions"),this.k={[u.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[u.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,a.$VF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,V,x,Y){const $e=this.g.getDocument(B),ve=n.Position.to(V),Te=await this.h.provideInlineCompletionItems($e,ve,{selectedCompletionInfo:x.selectedSuggestionInfo?{range:n.Range.to(x.selectedSuggestionInfo.range),text:x.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[x.triggerKind]},Y);if(!Te||Y.isCancellationRequested)return;const Ve=Array.isArray(Te)?Te:Te.items,Qe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],tt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let at;return{pid:this.d.createReferenceId({dispose(){at?.dispose()},items:Ve}),items:Ve.map((ot,rt)=>{let Pe;ot.command&&(at||(at=new w.$Sc),Pe=this.j.toInternal(ot.command,at));const Ie=ot.insertText;return{insertText:typeof Ie=="string"?Ie:{snippet:Ie.value},filterText:ot.filterText,range:ot.range?n.Range.from(ot.range):void 0,command:Pe,idx:rt,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Qe.map(ot=>(at||(at=new w.$Sc),this.j.toInternal(ot,at))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,V,x){const Y=this.d.get(B)?.items[V];Y&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Y,x)}handlePartialAccept(B,V,x){const Y=this.d.get(B)?.items[V];Y&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Y,x)}}class fe{async provideInlineEdits(B,V,x){const Y=this.f.getDocument(B),$e=await this.g.provideInlineEdit(Y,{triggerKind:this.e[V.triggerKind]},x);if(!$e||x.isCancellationRequested)return;let ve;const Te=this.d.createReferenceId({dispose(){ve?.dispose()},item:$e});let Ve;$e.accepted&&(ve||(ve=new w.$Sc),Ve=this.h.toInternal($e.accepted,ve));let Qe;return $e.rejected&&(ve||(ve=new w.$Sc),Qe=this.h.toInternal($e.rejected,ve)),{pid:Te,text:$e.text,range:n.Range.from($e.range),accepted:Ve,rejected:Qe}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,V,x,Y){this.f=V,this.g=x,this.h=Y,this.d=new he,this.e={[u.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[u.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class he{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const V=this.e++;return this.d.set(V,B),V}disposeReferenceId(B){const V=this.d.get(B);return this.d.delete(B),V}get(B){return this.d.get(B)}}class se{constructor(B,V){this.e=B,this.f=V,this.d=new t.$Lhc("SignatureHelp")}async provideSignatureHelp(B,V,x,Y){const $e=this.e.getDocument(B),ve=n.Position.to(V),Te=this.g(x),Ve=await this.f.provideSignatureHelp($e,ve,Y,Te);if(Ve){const Qe=this.d.add([Ve]);return{...n.SignatureHelp.from(Ve),id:Qe}}}g(B){let V;if(B.activeSignatureHelp){const x=n.SignatureHelp.to(B.activeSignatureHelp),Y=this.d.get(B.activeSignatureHelp.id,0);Y?(V=Y,V.activeSignature=x.activeSignature,V.activeParameter=x.activeParameter):V=x}return{...B,activeSignatureHelp:V}}releaseSignatureHelp(B){this.d.delete(B)}}class ce{constructor(B,V,x,Y,$e){this.f=B,this.g=V,this.h=x,this.j=Y,this.k=$e,this.d=new t.$Lhc("InlayHints"),this.e=new Map}async provideInlayHints(B,V,x){const Y=this.f.getDocument(B),$e=n.Range.to(V),ve=await this.h.provideInlayHints(Y,$e,x);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(x.isCancellationRequested)return;const Te=this.d.add(ve);this.e.set(Te,new w.$Sc);const Ve={hints:[],cacheId:Te};for(let Qe=0;Qe<ve.length;Qe++)this.l(ve[Qe],$e)&&Ve.hints.push(this.m(ve[Qe],[Te,Qe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ve}async resolveInlayHint(B,V){if(typeof this.h.resolveInlayHint!="function")return;const x=this.d.get(...B);if(!x)return;const Y=await this.h.resolveInlayHint(x,V);if(Y&&this.l(Y))return this.m(Y,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,V){return B.label.length===0||Array.isArray(B.label)&&B.label.every(x=>x.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(V&&!V.contains(B.position))}m(B,V){const x=this.e.get(V[0]);if(!x)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:V,tooltip:n.MarkdownString.fromStrict(B.tooltip),position:n.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(n.TextEdit.from),kind:B.kind&&n.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")Y.label=B.label;else{const $e=[];Y.label=$e;for(const ve of B.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:ve.value,tooltip:n.MarkdownString.fromStrict(ve.tooltip)};s.$cM.isLocation(ve.location)&&(Te.location=n.location.from(ve.location)),ve.command&&(Te.command=this.g.toInternal(ve.command,x)),$e.push(Te)}}return Y}}class le{constructor(B,V){this.e=B,this.f=V,this.d=new t.$Lhc("DocumentLink")}async provideLinks(B,V){const x=this.e.getDocument(B),Y=await this.f.provideDocumentLinks(x,V);if(!(!Array.isArray(Y)||Y.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(le.g).map(n.DocumentLink.from)};{const $e=this.d.add(Y),ve={links:[],cacheId:$e};for(let Te=0;Te<Y.length;Te++){if(!le.g(Y[Te]))continue;const Ve=n.DocumentLink.from(Y[Te]);Ve.cacheId=[$e,Te],ve.links.push(Ve)}return ve}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,V){if(typeof this.f.resolveDocumentLink!="function")return;const x=this.d.get(...B);if(!x)return;const Y=await this.f.resolveDocumentLink(x,V);if(!(!Y||!le.g(Y)))return n.DocumentLink.from(Y)}releaseLinks(B){this.d.delete(B)}}class de{constructor(B,V){this.d=B,this.e=V}async provideColors(B,V){const x=this.d.getDocument(B),Y=await this.e.provideDocumentColors(x,V);return Array.isArray(Y)?Y.map(ve=>({color:n.Color.from(ve.color),range:n.Range.from(ve.range)})):[]}async provideColorPresentations(B,V,x){const Y=this.d.getDocument(B),$e=n.Range.to(V.range),ve=n.Color.to(V.color),Te=await this.e.provideColorPresentations(ve,{document:Y,range:$e},x);if(Array.isArray(Te))return Te.map(n.ColorPresentation.from)}}class q{constructor(B,V){this.d=B,this.e=V}async provideFoldingRanges(B,V,x){const Y=this.d.getDocument(B),$e=await this.e.provideFoldingRanges(Y,V,x);if(Array.isArray($e))return $e.map(n.FoldingRange.from)}}class _{constructor(B,V,x){this.d=B,this.e=V,this.f=x}async provideSelectionRanges(B,V,x){const Y=this.d.getDocument(B),$e=V.map(n.Position.to),ve=await this.e.provideSelectionRanges(Y,$e,x);if(!(0,D.$Lb)(ve))return[];if(ve.length!==$e.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Ve=0;Ve<$e.length;Ve++){const Qe=[];Te.push(Qe);let tt=$e[Ve],at=ve[Ve];for(;;){if(!at.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(n.SelectionRange.from(at)),!at.parent)break;tt=at.range,at=at.parent}}return Te}}class ge{constructor(B,V){this.f=B,this.g=V,this.d=new L.$kO(""),this.e=new Map}async prepareSession(B,V,x){const Y=this.f.getDocument(B),$e=n.Position.to(V),ve=await this.g.prepareCallHierarchy(Y,$e,x);if(!ve)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ve)?ve.map(Ve=>this.h(Te,Ve)):[this.h(Te,ve)]}async provideCallsTo(B,V,x){const Y=this.j(B,V);if(!Y)throw new Error("missing call hierarchy item");const $e=await this.g.provideCallHierarchyIncomingCalls(Y,x);if($e)return $e.map(ve=>({from:this.h(B,ve.from),fromRanges:ve.fromRanges.map(Te=>n.Range.from(Te))}))}async provideCallsFrom(B,V,x){const Y=this.j(B,V);if(!Y)throw new Error("missing call hierarchy item");const $e=await this.g.provideCallHierarchyOutgoingCalls(Y,x);if($e)return $e.map(ve=>({to:this.h(B,ve.to),fromRanges:ve.fromRanges.map(Te=>n.Range.from(Te))}))}releaseSession(B){this.e.delete(B)}h(B,V){const x=this.e.get(B),Y=n.CallHierarchyItem.from(V,B,x.size.toString(36));return x.set(Y._itemId,V),Y}j(B,V){return this.e.get(B)?.get(V)}}class me{constructor(B,V){this.f=B,this.g=V,this.d=new L.$kO(""),this.e=new Map}async prepareSession(B,V,x){const Y=this.f.getDocument(B),$e=n.Position.to(V),ve=await this.g.prepareTypeHierarchy(Y,$e,x);if(!ve)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ve)?ve.map(Ve=>this.h(Te,Ve)):[this.h(Te,ve)]}async provideSupertypes(B,V,x){const Y=this.j(B,V);if(!Y)throw new Error("missing type hierarchy item");const $e=await this.g.provideTypeHierarchySupertypes(Y,x);if($e)return $e.map(ve=>this.h(B,ve))}async provideSubtypes(B,V,x){const Y=this.j(B,V);if(!Y)throw new Error("missing type hierarchy item");const $e=await this.g.provideTypeHierarchySubtypes(Y,x);if($e)return $e.map(ve=>this.h(B,ve))}releaseSession(B){this.e.delete(B)}h(B,V){const x=this.e.get(B),Y=n.TypeHierarchyItem.from(V,B,x.size.toString(36));return x.set(Y._itemId,V),Y}j(B,V){return this.e.get(B)?.get(V)}}class Ae{static toInternalProviderId(B,V){return B+"."+V}constructor(B,V,x,Y,$e){this.d=B,this.e=V,this.f=x,this.g=Y,this.h=$e}async provideDocumentOnDropEdits(B,V,x,Y,$e){const ve=this.e.getDocument(V),Te=n.Position.to(x),Ve=n.DataTransfer.toDataTransfer(Y,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,tt)).buffer),Qe=await this.f.provideDocumentDropEdits(ve,Te,Ve,$e);if(Qe)return{label:Qe.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Qe.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:Ae.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?n.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class ye{constructor(B,V){this.d=B,this.e=V}async provideMappedEdits(B,V,x,Y){const $e=p.URI.revive(B),ve=this.d.getDocument($e),Te=x.documents.map(tt=>tt.map(at=>({uri:p.URI.revive(at.uri),version:at.version,ranges:at.ranges.map(dt=>n.Range.to(dt))}))),Ve={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(ve,V,Ve,Y);return Qe?n.WorkspaceEdit.from(Qe):null}}class Re{constructor(B,V){this.adapter=B,this.extension=V}}class Le{constructor(B,V,x,Y,$e,ve,Te,Ve){this.g=V,this.h=x,this.j=Y,this.k=$e,this.l=ve,this.m=Te,this.n=Ve,this.f=new Map,this.e=B.getProxy(d.$1L.MainThreadLanguageFeatures)}o(B,V){return n.DocumentSelector.from(B,this.g,V)}p(B){return new s.$3L(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Le.d++}async s(B,V,x,Y,$e,ve=!1){const Te=this.f.get(B);if(!Te||!(Te.adapter instanceof V))return Y;const Ve=Date.now();ve||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${x.toString().replace(/[\r\n]/g,"")}'`);const Qe=x(Te.adapter,Te.extension);return Promise.resolve(Qe).catch(tt=>{(0,R.$4)(tt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Te.extension.identifier,tt))}).finally(()=>{ve||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),f.CancellationToken.isCancellationToken($e)?(0,O.$6g)(Qe,$e):Qe}t(B,V){const x=this.q();return this.f.set(x,new Re(B,V)),x}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,V,x,Y){const $e=this.t(new l(this.h,x),B),ve=Y&&Y.label||Le.u(B);return this.e.$registerDocumentSymbolProvider($e,this.o(V,B),ve),this.p($e)}$provideDocumentSymbols(B,V,x){return this.s(B,l,Y=>Y.provideDocumentSymbols(p.URI.revive(V),x),void 0,x)}registerCodeLensProvider(B,V,x){const Y=this.q(),$e=typeof x.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new Re(new r(this.h,this.j.converter,x,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(Y,this.o(V,B),$e);let ve=this.p(Y);if($e!==void 0){const Te=x.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent($e));ve=s.$3L.from(ve,Te)}return ve}$provideCodeLenses(B,V,x){return this.s(B,r,Y=>Y.provideCodeLenses(p.URI.revive(V),x),void 0,x)}$resolveCodeLens(B,V,x){return this.s(B,r,Y=>Y.resolveCodeLens(V,x),void 0,void 0)}$releaseCodeLenses(B,V){this.s(B,r,x=>Promise.resolve(x.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(B,V,x){const Y=this.t(new h(this.h,x),B);return this.e.$registerDefinitionSupport(Y,this.o(V,B)),this.p(Y)}$provideDefinition(B,V,x,Y){return this.s(B,h,$e=>$e.provideDefinition(p.URI.revive(V),x,Y),[],Y)}registerDeclarationProvider(B,V,x){const Y=this.t(new g(this.h,x),B);return this.e.$registerDeclarationSupport(Y,this.o(V,B)),this.p(Y)}$provideDeclaration(B,V,x,Y){return this.s(B,g,$e=>$e.provideDeclaration(p.URI.revive(V),x,Y),[],Y)}registerImplementationProvider(B,V,x){const Y=this.t(new C(this.h,x),B);return this.e.$registerImplementationSupport(Y,this.o(V,B)),this.p(Y)}$provideImplementation(B,V,x,Y){return this.s(B,C,$e=>$e.provideImplementation(p.URI.revive(V),x,Y),[],Y)}registerTypeDefinitionProvider(B,V,x){const Y=this.t(new v(this.h,x),B);return this.e.$registerTypeDefinitionSupport(Y,this.o(V,B)),this.p(Y)}$provideTypeDefinition(B,V,x,Y){return this.s(B,v,$e=>$e.provideTypeDefinition(p.URI.revive(V),x,Y),[],Y)}registerHoverProvider(B,V,x,Y){const $e=this.t(new m(this.h,x),B);return this.e.$registerHoverProvider($e,this.o(V,B)),this.p($e)}$provideHover(B,V,x,Y){return this.s(B,m,$e=>$e.provideHover(p.URI.revive(V),x,Y),void 0,Y)}registerEvaluatableExpressionProvider(B,V,x,Y){const $e=this.t(new y(this.h,x),B);return this.e.$registerEvaluatableExpressionProvider($e,this.o(V,B)),this.p($e)}$provideEvaluatableExpression(B,V,x,Y){return this.s(B,y,$e=>$e.provideEvaluatableExpression(p.URI.revive(V),x,Y),void 0,Y)}registerInlineValuesProvider(B,V,x,Y){const $e=typeof x.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new P(this.h,x),B);this.e.$registerInlineValuesProvider(ve,this.o(V,B),$e);let Te=this.p(ve);if($e!==void 0){const Ve=x.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent($e));Te=s.$3L.from(Te,Ve)}return Te}$provideInlineValues(B,V,x,Y,$e){return this.s(B,P,ve=>ve.provideInlineValues(p.URI.revive(V),x,Y,$e),void 0,$e)}registerDocumentHighlightProvider(B,V,x){const Y=this.t(new j(this.h,x),B);return this.e.$registerDocumentHighlightProvider(Y,this.o(V,B)),this.p(Y)}registerMultiDocumentHighlightProvider(B,V,x){const Y=this.t(new U(this.h,x),B);return this.e.$registerMultiDocumentHighlightProvider(Y,this.o(V,B)),this.p(Y)}$provideDocumentHighlights(B,V,x,Y){return this.s(B,j,$e=>$e.provideDocumentHighlights(p.URI.revive(V),x,Y),void 0,Y)}$provideMultiDocumentHighlights(B,V,x,Y,$e){return this.s(B,U,ve=>ve.provideMultiDocumentHighlights(p.URI.revive(V),x,Y.map(Te=>p.URI.revive(Te)),$e),void 0,$e)}registerLinkedEditingRangeProvider(B,V,x){const Y=this.t(new z(this.h,x),B);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(V,B)),this.p(Y)}$provideLinkedEditingRanges(B,V,x,Y){return this.s(B,z,async $e=>{const ve=await $e.provideLinkedEditingRanges(p.URI.revive(V),x,Y);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Le.w(ve.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(B,V,x){const Y=this.t(new N(this.h,x),B);return this.e.$registerReferenceSupport(Y,this.o(V,B)),this.p(Y)}$provideReferences(B,V,x,Y,$e){return this.s(B,N,ve=>ve.provideReferences(p.URI.revive(V),x,Y,$e),void 0,$e)}registerCodeActionProvider(B,V,x,Y){const $e=new w.$Sc,ve=this.t(new A(this.h,this.j.converter,this.k,x,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ve,this.o(V,B),{providedKinds:Y?.providedCodeActionKinds?.map(Te=>Te.value),documentation:Y?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,$e)}))},Le.u(B),!!x.resolveCodeAction),$e.add(this.p(ve)),$e}$provideCodeActions(B,V,x,Y,$e){return this.s(B,A,ve=>ve.provideCodeActions(p.URI.revive(V),x,Y,$e),void 0,$e)}$resolveCodeAction(B,V,x){return this.s(B,A,Y=>Y.resolveCodeAction(V,x),{},void 0)}$releaseCodeActions(B,V){this.s(B,A,x=>Promise.resolve(x.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(B,V,x){const Y=this.t(new F(this.h,x),B);return this.e.$registerDocumentFormattingSupport(Y,this.o(V,B),B.identifier,B.displayName||B.name),this.p(Y)}$provideDocumentFormattingEdits(B,V,x,Y){return this.s(B,F,$e=>$e.provideDocumentFormattingEdits(p.URI.revive(V),x,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(B,V,x){const Y=typeof x.provideDocumentRangesFormattingEdits=="function",$e=this.t(new G(this.h,x),B);return this.e.$registerRangeFormattingSupport($e,this.o(V,B),B.identifier,B.displayName||B.name,Y),this.p($e)}$provideDocumentRangeFormattingEdits(B,V,x,Y,$e){return this.s(B,G,ve=>ve.provideDocumentRangeFormattingEdits(p.URI.revive(V),x,Y,$e),void 0,$e)}$provideDocumentRangesFormattingEdits(B,V,x,Y,$e){return this.s(B,G,ve=>ve.provideDocumentRangesFormattingEdits(p.URI.revive(V),x,Y,$e),void 0,$e)}registerOnTypeFormattingEditProvider(B,V,x,Y){const $e=this.t(new K(this.h,x),B);return this.e.$registerOnTypeFormattingSupport($e,this.o(V,B),Y,B.identifier),this.p($e)}$provideOnTypeFormattingEdits(B,V,x,Y,$e,ve){return this.s(B,K,Te=>Te.provideOnTypeFormattingEdits(p.URI.revive(V),x,Y,$e,ve),void 0,ve)}registerWorkspaceSymbolProvider(B,V){const x=this.t(new X(V,this.l),B);return this.e.$registerNavigateTypeSupport(x,typeof V.resolveWorkspaceSymbol=="function"),this.p(x)}$provideWorkspaceSymbols(B,V,x){return this.s(B,X,Y=>Y.provideWorkspaceSymbols(V,x),{symbols:[]},x)}$resolveWorkspaceSymbol(B,V,x){return this.s(B,X,Y=>Y.resolveWorkspaceSymbol(V,x),void 0,void 0)}$releaseWorkspaceSymbols(B,V){this.s(B,X,x=>x.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(B,V,x){const Y=this.t(new Q(this.h,x,this.l),B);return this.e.$registerRenameSupport(Y,this.o(V,B),Q.supportsResolving(x)),this.p(Y)}$provideRenameEdits(B,V,x,Y,$e){return this.s(B,Q,ve=>ve.provideRenameEdits(p.URI.revive(V),x,Y,$e),void 0,$e)}$resolveRenameLocation(B,V,x,Y){return this.s(B,Q,$e=>$e.resolveRenameLocation(p.URI.revive(V),x,Y),void 0,Y)}registerNewSymbolNamesProvider(B,V,x){const Y=this.t(new Z(this.h,x,this.l),B);return this.e.$registerNewSymbolNamesProvider(Y,this.o(V,B)),this.p(Y)}$provideNewSymbolNames(B,V,x,Y){return this.s(B,Z,$e=>$e.provideNewSymbolNames(p.URI.revive(V),x,Y),void 0,Y)}registerDocumentSemanticTokensProvider(B,V,x,Y){const $e=this.t(new ee(this.h,x),B),ve=typeof x.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider($e,this.o(V,B),Y,ve);let Te=this.p($e);if(ve){const Ve=x.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(ve));Te=s.$3L.from(Te,Ve)}return Te}$provideDocumentSemanticTokens(B,V,x,Y){return this.s(B,ee,$e=>$e.provideDocumentSemanticTokens(p.URI.revive(V),x,Y),null,Y)}$releaseDocumentSemanticTokens(B,V){this.s(B,ee,x=>x.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,V,x,Y){const $e=this.t(new we(this.h,x),B);return this.e.$registerDocumentRangeSemanticTokensProvider($e,this.o(V,B),Y),this.p($e)}$provideDocumentRangeSemanticTokens(B,V,x,Y){return this.s(B,we,$e=>$e.provideDocumentRangeSemanticTokens(p.URI.revive(V),x,Y),null,Y)}registerCompletionItemProvider(B,V,x,Y){const $e=this.t(new ue(this.h,this.j.converter,x,this.m,B),B);return this.e.$registerCompletionsProvider($e,this.o(V,B),Y,ue.supportsResolving(x),B.identifier),this.p($e)}$provideCompletionItems(B,V,x,Y,$e){return this.s(B,ue,ve=>ve.provideCompletionItems(p.URI.revive(V),x,Y,$e),void 0,$e)}$resolveCompletionItem(B,V,x){return this.s(B,ue,Y=>Y.resolveCompletionItem(V,x),void 0,x)}$releaseCompletionItems(B,V){this.s(B,ue,x=>x.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(B,V,x,Y){const $e=new H(B,this.h,x,this.j.converter),ve=this.t($e,B);return this.e.$registerInlineCompletionsSupport(ve,this.o(V,B),$e.supportsHandleEvents,i.$xm.toKey(B.identifier.value),Y?.yieldTo?.map(Te=>i.$xm.toKey(Te))||[]),this.p(ve)}$provideInlineCompletions(B,V,x,Y,$e){return this.s(B,ae,ve=>ve.provideInlineCompletions(p.URI.revive(V),x,Y,$e),void 0,$e)}$handleInlineCompletionDidShow(B,V,x,Y){this.s(B,ae,async $e=>{$e.handleDidShowCompletionItem(V,x,Y)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,V,x,Y){this.s(B,ae,async $e=>{$e.handlePartialAccept(V,x,Y)},void 0,void 0)}$freeInlineCompletionsList(B,V){this.s(B,ae,async x=>{x.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(B,V,x){const Y=new fe(B,this.h,x,this.j.converter),$e=this.t(Y,B);return this.e.$registerInlineEditProvider($e,this.o(V,B),B.identifier),this.p($e)}$provideInlineEdit(B,V,x,Y){return this.s(B,fe,$e=>$e.provideInlineEdits(p.URI.revive(V),x,Y),void 0,Y)}$freeInlineEdit(B,V){this.s(B,fe,async x=>{x.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(B,V,x,Y){const $e=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,ve=this.t(new se(this.h,x),B);return this.e.$registerSignatureHelpProvider(ve,this.o(V,B),$e),this.p(ve)}$provideSignatureHelp(B,V,x,Y,$e){return this.s(B,se,ve=>ve.provideSignatureHelp(p.URI.revive(V),x,Y,$e),void 0,$e)}$releaseSignatureHelp(B,V){this.s(B,se,x=>x.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(B,V,x){const Y=typeof x.onDidChangeInlayHints=="function"?this.q():void 0,$e=this.t(new ce(this.h,this.j.converter,x,this.l,B),B);this.e.$registerInlayHintsProvider($e,this.o(V,B),typeof x.resolveInlayHint=="function",Y,Le.u(B));let ve=this.p($e);if(Y!==void 0){const Te=x.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(Y));ve=s.$3L.from(ve,Te)}return ve}$provideInlayHints(B,V,x,Y){return this.s(B,ce,$e=>$e.provideInlayHints(p.URI.revive(V),x,Y),void 0,Y)}$resolveInlayHint(B,V,x){return this.s(B,ce,Y=>Y.resolveInlayHint(V,x),void 0,x)}$releaseInlayHints(B,V){this.s(B,ce,x=>x.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(B,V,x){const Y=this.t(new le(this.h,x),B);return this.e.$registerDocumentLinkProvider(Y,this.o(V,B),typeof x.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(B,V,x){return this.s(B,le,Y=>Y.provideLinks(p.URI.revive(V),x),void 0,x,V.scheme==="output")}$resolveDocumentLink(B,V,x){return this.s(B,le,Y=>Y.resolveLink(V,x),void 0,void 0,!0)}$releaseDocumentLinks(B,V){this.s(B,le,x=>x.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(B,V,x){const Y=this.t(new de(this.h,x),B);return this.e.$registerDocumentColorProvider(Y,this.o(V,B)),this.p(Y)}$provideDocumentColors(B,V,x){return this.s(B,de,Y=>Y.provideColors(p.URI.revive(V),x),[],x)}$provideColorPresentations(B,V,x,Y){return this.s(B,de,$e=>$e.provideColorPresentations(p.URI.revive(V),x,Y),void 0,Y)}registerFoldingRangeProvider(B,V,x){const Y=this.q(),$e=typeof x.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new Re(new q(this.h,x),B)),this.e.$registerFoldingRangeProvider(Y,this.o(V,B),B.identifier,$e);let ve=this.p(Y);if($e!==void 0){const Te=x.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent($e));ve=s.$3L.from(ve,Te)}return ve}$provideFoldingRanges(B,V,x,Y){return this.s(B,q,$e=>$e.provideFoldingRanges(p.URI.revive(V),x,Y),void 0,Y)}registerSelectionRangeProvider(B,V,x){const Y=this.t(new _(this.h,x,this.l),B);return this.e.$registerSelectionRangeProvider(Y,this.o(V,B)),this.p(Y)}$provideSelectionRanges(B,V,x,Y){return this.s(B,_,$e=>$e.provideSelectionRanges(p.URI.revive(V),x,Y),[],Y)}registerCallHierarchyProvider(B,V,x){const Y=this.t(new ge(this.h,x),B);return this.e.$registerCallHierarchyProvider(Y,this.o(V,B)),this.p(Y)}$prepareCallHierarchy(B,V,x,Y){return this.s(B,ge,$e=>Promise.resolve($e.prepareSession(p.URI.revive(V),x,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(B,V,x,Y){return this.s(B,ge,$e=>$e.provideCallsTo(V,x,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(B,V,x,Y){return this.s(B,ge,$e=>$e.provideCallsFrom(V,x,Y),void 0,Y)}$releaseCallHierarchy(B,V){this.s(B,ge,x=>Promise.resolve(x.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(B,V,x){const Y=this.t(new me(this.h,x),B);return this.e.$registerTypeHierarchyProvider(Y,this.o(V,B)),this.p(Y)}$prepareTypeHierarchy(B,V,x,Y){return this.s(B,me,$e=>Promise.resolve($e.prepareSession(p.URI.revive(V),x,Y)),void 0,Y)}$provideTypeHierarchySupertypes(B,V,x,Y){return this.s(B,me,$e=>$e.provideSupertypes(V,x,Y),void 0,Y)}$provideTypeHierarchySubtypes(B,V,x,Y){return this.s(B,me,$e=>$e.provideSubtypes(V,x,Y),void 0,Y)}$releaseTypeHierarchy(B,V){this.s(B,me,x=>Promise.resolve(x.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(B,V,x,Y){const $e=this.q();this.f.set($e,new Re(new Ae(this.e,this.h,x,$e,B),B));const ve=(0,a.$VF)(B,"dropMetadata")&&Y?Ae.toInternalProviderId(B.identifier.value,Y.id):void 0;return this.e.$registerDocumentOnDropEditProvider($e,this.o(V,B),ve,(0,a.$VF)(B,"dropMetadata")?Y:void 0),this.p($e)}$provideDocumentOnDropEdits(B,V,x,Y,$e,ve){return this.s(B,Ae,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(V,p.URI.revive(x),Y,$e,ve)),void 0,void 0)}registerMappedEditsProvider(B,V,x){const Y=this.t(new ye(this.h,x),B);return this.e.$registerMappedEditsProvider(Y,this.o(V,B)),this.p(Y)}$provideMappedEdits(B,V,x,Y,$e){return this.s(B,ye,ve=>Promise.resolve(ve.provideMappedEdits(V,x,Y,$e)),null,$e)}registerDocumentPasteEditProvider(B,V,x,Y){const $e=this.q();this.f.set($e,new Re(new T(this.e,this.h,x,$e,B),B));const ve=T.toInternalProviderId(B.identifier.value,Y.id);return this.e.$registerPasteEditProvider($e,this.o(V,B),ve,{supportsCopy:!!x.prepareDocumentPaste,supportsPaste:!!x.provideDocumentPasteEdits,copyMimeTypes:Y.copyMimeTypes,pasteMimeTypes:Y.pasteMimeTypes}),this.p($e)}$prepareDocumentPaste(B,V,x,Y,$e){return this.s(B,T,ve=>ve.prepareDocumentPaste(p.URI.revive(V),x,Y,$e),void 0,$e)}$providePasteEdits(B,V,x,Y,$e,ve){return this.s(B,T,Te=>Te.providePasteEdits(V,p.URI.revive(x),Y,$e,ve),void 0,ve)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:Le.w(B.decreaseIndentPattern),increaseIndentPattern:Le.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Le.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Le.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:Le.w(B.beforeText),afterText:B.afterText?Le.w(B.afterText):void 0,previousLineText:B.previousLineText?Le.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(Le.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(V=>s.SyntaxTokenType.toString(V)):void 0}}static D(B){return B.map(Le.C)}setLanguageConfiguration(B,V,x){const{wordPattern:Y}=x;if(Y&&(0,M.$8e)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(V,Y):this.h.setWordDefinitionFor(V,void 0),x.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),x.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const $e=this.q(),ve={comments:x.comments,brackets:x.brackets,wordPattern:x.wordPattern?Le.w(x.wordPattern):void 0,indentationRules:x.indentationRules?Le.y(x.indentationRules):void 0,onEnterRules:x.onEnterRules?Le.B(x.onEnterRules):void 0,__electricCharacterSupport:x.__electricCharacterSupport,__characterPairSupport:x.__characterPairSupport,autoClosingPairs:x.autoClosingPairs?Le.D(x.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration($e,V,ve),this.p($e)}$setWordDefinitions(B){for(const V of B)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$Vhc=Le,Le.d=0}),define(Se[331],De([1,0,6,15,7,40,8,3,26]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class k{constructor(I,p,S,E){this.c=p,this.d=S,this.e=E,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(D.$1L.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,p){await this.a.$changeLanguage(I,p);const S=this.c.getDocumentData(I);if(!S)throw new Error(`document '${I.toString()}' NOT found`);return S.document}async tokenAtPosition(I,p){const S=I.version,E=O.Position.from(p),u=await this.a.$tokensAtPosition(I.uri,E),b={type:f.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new f.$5L(p.line,p.character,p.line,p.character)};if(!u)return b;const o={range:O.Range.to(u.range),type:O.TokenType.to(u.type)};return!o.range.contains(p)||S!==I.version?b:o}createLanguageStatusItem(I,p,S){const E=this.f++,u=this.a,b=this.g,o=`${I.identifier.value}/${p}`;if(b.has(o))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);b.add(o);const i={selector:S,id:p,name:I.displayName??I.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const s=new w.$Sc,a=()=>{if(n?.dispose(),!b.has(o)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$gh)(()=>{s.clear(),this.a.$setLanguageStatus(E,{id:o,name:i.name??I.displayName??I.name,source:I.displayName??I.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?R.default.Error:i.severity===f.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,s),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){s.dispose(),n?.dispose(),u.$removeLanguageStatus(E),b.delete(o)},get id(){return i.id},get name(){return i.name},set name(d){i.name=d,a()},get selector(){return i.selector},set selector(d){i.selector=d,a()},get text(){return i.text},set text(d){i.text=d,a()},set text2(d){(0,$.$WF)(I,"languageStatusText"),i.text=d,a()},get text2(){return(0,$.$WF)(I,"languageStatusText"),i.text},get detail(){return i.detail},set detail(d){i.detail=d,a()},get severity(){return i.severity},set severity(d){i.severity=d,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(d){i.accessibilityInformation=d,a()},get command(){return i.command},set command(d){i.command=d,a()},get busy(){return i.busy},set busy(d){i.busy=d,a()}};return a(),t}}e.$ijc=k}),define(Se[332],De([1,0,16,2,15,7,119]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=void 0;class w{constructor(I,p,S,E){this.start=I,this.deletedCount=p,this.deletedItems=S,this.items=E}asApiEvent(){return{range:new R.$qN(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,p,S){this.notebook=I,this.h=p,this.j=S,this.handle=S.handle,this.uri=O.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(f.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(E){I.g=E},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(S)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,p,S){const E=S.map(f.NotebookCellOutputItem.to),u=this.a.find(b=>b.id===I);if(u&&(p||(u.items.length=0),u.items.push(...E),u.items.length>1&&u.items.every(b=>L.$4J(b.mime)))){const b=new Map,o=[];u.items.forEach(i=>{let n;b.has(i.mime)?n=b.get(i.mime):(n=[],b.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),u.items.length=0,o.forEach(i=>{const n=L.$5J(b.get(i));u.items.push({mime:i,data:n.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$6ic=$;class k{constructor(I,p,S,E,u){this.k=I,this.l=p,this.m=S,this.uri=E,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(S){return S=I.n(S),I.b[S].apiCell},getCells(S){return(S?I.p(S):I.b).map(u=>u.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,S){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:S});const E={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},u=[];for(const o of I.rawEvents)o.kind===L.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,E.contentChanges):o.kind===L.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,E.contentChanges):o.kind===L.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===L.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),u.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),u.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const b=new Map;for(let o=0;o<u.length;o++){const i=u[o],n=b.get(i.cell);if(n===void 0){const s=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});b.set(i.cell,s-1)}else E.cellChanges[n]={...E.cellChanges[n],...i}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,S=I.end|0;return p<0&&(p=0),S>this.b.length&&(S=this.b.length),I.with({start:p,end:S})}p(I){I=this.o(I);const p=[];for(let S=I.start;S<I.end;S++)p.push(this.b[S]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,S){if(this.j)return;const E=[],u=[],b=[];if(I.reverse().forEach(o=>{const n=o[2].map(t=>{const d=new $(this,this.l,t);return p||u.push($.asModelAddData(t)),d}),s=new w(o[0],o[1],[],n),a=this.b.splice(o[0],o[1],...n);for(const t of a)b.push(t.uri),s.deletedItems.push(t.apiCell);E.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:b}),S)for(const o of E)S.push(o.asApiEvent())}s(I,p,S,E){const u=this.b.splice(I,p);this.b.splice(S,0,...u);const b=[new w(I,p,u.map(o=>o.apiCell),[]),new w(S,0,[],u)];for(const o of b)E.push(o.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,S,E){this.b[I].setOutputItems(p,S,E)}v(I,p){const S=this.b[I];S.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(S.uri,p)}w(I,p){const S=this.b[I];S.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){if(O.URI.isUri(I)){const p=L.CellUri.parse(I);if(!p||p.notebook.toString()!==this.uri.toString())return;I=p.handle}return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$7ic=k,k.a=0}),define(Se[333],De([1,0,4,2,15,7]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class L{constructor($,k,M,I={timeout:1500,errors:3}){this.b=$,this.c=k,this.d=M,this.f=I,this.a=new D.$7d}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(k,M,I)=>{const p=function(E){k.call(M,E)};return p.extension=$,this.a.event(p,void 0,I)}}async $participateInSave($,k,M){const I=O.URI.revive($),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:f.TextDocumentSaveReason.to(k)},M,async(u,b)=>{const o=Date.now(),i=await await Promise.resolve(u);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",b.extension.identifier),!M.isCancellationRequested&&i&&(i instanceof R.$aM?S.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",b.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(S.length===0)return!0;const E={edits:[]};for(const u of S){const{edits:b}=f.WorkspaceEdit.from(u);E.edits=E.edits.concat(b)}return this.d.$tryApplyWorkspaceEdit(E)}}e.$kjc=L}),define(Se[151],De([1,0,14,15,7]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class R{constructor(w,$,k,M,I,p){this.id=w,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=M,this.c=p}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection($){this.selections=[$]},get selections(){return w.a},set selections($){if(!Array.isArray($)||!$.every(f.$qN.isNotebookRange))throw(0,D.$7)("selections");w.a=$,w.g($)},get visibleRanges(){return w.b},revealRange($,k){w.f.$tryRevealRange(w.id,O.NotebookRange.from($),k??f.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(O.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$8ic=R,R.apiEditorsToExtHost=new WeakMap}),define(Se[334],De([1,0,4,13,15]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;let R=class{constructor(w,$){this.c=w,this.d=$,this.a=new D.$5d,this.b=new D.$5d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,$);const k=this.d.getEditorById(w);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(f.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(f.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const $ in w)this.d.getEditorById($)._acceptViewColumn(f.ViewColumn.to(w[$]))}};e.$mjc=R,e.$mjc=R=Je([He(0,O.$yj)],R)}),define(Se[335],De([1,0,4,6,151]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;class R{constructor(w,$){this.c=$,this.a=new Map,this.b=w.getProxy(O.$1L.MainThreadNotebookRenderers)}$postRendererMessage(w,$,k){const M=this.c.getEditorById(w);this.a.get($)?.fire({editor:M.apiEditor,message:k})}createRendererMessaging(w,$){if(!w.contributes?.notebookRenderer?.some(M=>M.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(M,I,p)=>this.d($).event(M,I,p),postMessage:(M,I)=>{f.$8ic.apiEditorsToExtHost.has(M)&&([M,I]=[I,M]);const p=I&&f.$8ic.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,$,M)}}}d(w){let $=this.a.get(w);return $||($=new D.$5d({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(w)}}),this.a.set(w,$),$)}}e.$pjc=R}),define(Se[336],De([1,0,15,107,22,53,14]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;class w{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,p,S){const E=this.b++,{title:u,location:b,cancellable:o}=p,i={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(E,{location:D.ProgressLocation.from(b),title:u,source:i,cancellable:o},I.isUnderDevelopment?void 0:I.identifier.value).catch(L.$2),this.d(E,S,!!o)}d(I,p,S){let E;S&&(E=new f.$ce,this.c.set(I,E));const u=o=>{this.a.$progressEnd(o),this.c.delete(o),E?.dispose()};let b;try{b=p(new k(this.a,I),S&&E?E.token:f.CancellationToken.None)}catch(o){throw u(I),o}return b.then(o=>u(I),o=>u(I)),b}$acceptProgressCanceled(I){const p=this.c.get(I);p&&(p.cancel(),this.c.delete(I))}}e.$tjc=w;function $(M,I){return M.message=I.message,typeof I.increment=="number"&&(typeof M.increment=="number"?M.increment+=I.increment:M.increment=I.increment),M}class k extends O.$Iv{constructor(I,p){super(S=>this.throttledReport(S)),this.c=I,this.d=p}throttledReport(I){this.c.$progressReport(this.d,I)}}Je([(0,R.$Kh)(100,(M,I)=>$(M,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Se[337],De([1,0,2,6,8,15]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=void 0;class L{constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(O.$1L.MainThreadQuickDiff)}$provideOriginalResource($,k,M){const I=D.URI.revive(k),p=this.c.get($);return p?(0,f.$9g)(()=>p.provideOriginalResource(I,M)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,k,M,I){const p=L.a++;return this.c.set(p,k),this.b.$registerQuickDiffProvider(p,R.DocumentSelector.from($,this.d),M,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$ujc=L,L.a=0}),define(Se[338],De([1,0,22,4,3,6,2,7,14,19,40,55,26,15]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;function E(u,b,o){const i=u.getProxy(R.$1L.MainThreadQuickOpen);class n{constructor(g,C){this.e=new Map,this.f=0,this.a=g,this.b=C}showQuickPick(g,C,v,m=D.CancellationToken.None){this.c=void 0;const y=Promise.resolve(C),P=++this.f,j=i.$show(P,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},m),U={},z=j.then(()=>U);return Promise.race([z,y]).then(N=>{if(N===U)return;const A=(0,p.$VF)(g,"quickPickItemTooltip");return y.then(T=>{const F=[];for(let G=0;G<T.length;G++){const K=T[G];if(typeof K=="string")F.push({label:K,handle:G});else if(K.kind===w.QuickPickItemKind.Separator)F.push({type:"separator",label:K.label});else{K.tooltip&&!A&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const X=K.iconPath?l(K.iconPath):void 0;F.push({label:K.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:K.description,detail:K.detail,picked:K.picked,alwaysShow:K.alwaysShow,tooltip:A?S.MarkdownString.fromStrict(K.tooltip):void 0,handle:G})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=G=>{v.onDidSelectItem(T[G])}),i.$setItems(P,F),j.then(G=>{if(typeof G=="number")return T[G];if(Array.isArray(G))return G.map(K=>T[K])})})}).then(void 0,N=>{if(!(0,$.$4)(N))return i.$setError(P,N),Promise.reject(N)})}$onItemSelected(g){this.c?.(g)}showInput(g,C=D.CancellationToken.None){return this.d=g?.validateInput,i.$input(g,typeof this.d=="function",C).then(void 0,v=>{if(!(0,$.$4)(v))return Promise.reject(v)})}async $validateInput(g){if(!this.d)return;const C=await this.d(g);if(!C||typeof C=="string")return C;let v;switch(C.severity){case w.InputBoxValidationSeverity.Info:v=M.default.Info;break;case w.InputBoxValidationSeverity.Warning:v=M.default.Warning;break;case w.InputBoxValidationSeverity.Error:v=M.default.Error;break;default:v=C.message?M.default.Error:M.default.Ignore;break}return{content:C.message,severity:v}}async showWorkspaceFolderPick(g,C=D.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!v)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(y=>y.uri.toString()===v.uri.toString())}createQuickPick(g){const C=new r(g,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox(g){const C=new c(g,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue(g,C){this.e.get(g)?._fireDidChangeValue(C)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,C){const v=this.e.get(g);v instanceof r&&v._fireDidChangeActive(C)}$onDidChangeSelection(g,C){const v=this.e.get(g);v instanceof r&&v._fireDidChangeSelection(C)}$onDidTriggerButton(g,C){this.e.get(g)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(g,C,v){const m=this.e.get(g);m instanceof r&&m._fireDidTriggerItemButton(C,v)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class s{constructor(g,C){this.x=g,this.y=C,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$5d,this.q=new O.$5d,this.r=new O.$5d,this.s=new O.$5d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((C,v)=>{const m=C===w.$nN.Back?-1:v;this.o.set(m,C)}),this.z({buttons:g.map((C,v)=>({...l(C.iconPath),tooltip:C.tooltip,handle:C===w.$nN.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const C=this.o.get(g);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(g){if(!this.v){for(const C of Object.keys(g)){const v=g[C];this.u[C]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}s.a=1;function a(h){if(h instanceof w.$XM)return{id:h.id};const g=d(h),C=t(h);return{dark:typeof g=="string"?L.URI.file(g):g,light:typeof C=="string"?L.URI.file(C):C}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function d(h){return typeof h=="object"&&"dark"in h?h.dark:h}function l(h){const g=a(h);let C,v;return"id"in g?v=I.ThemeIcon.asClassName(g):C=g,{iconPath:C,iconClass:v}}class r extends s{constructor(g,C){super(g.identifier,C),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$5d,this.L=[],this.M=new O.$5d,this.N=new O.$5d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((m,y)=>{this.C.set(y,m),this.D.set(m,y)});const C=(0,p.$VF)(this.O,"quickPickItemTooltip"),v=[];for(let m=0;m<g.length;m++){const y=g[m];if(y.kind===w.QuickPickItemKind.Separator)v.push({type:"separator",label:y.label});else{y.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?l(y.iconPath):void 0;v.push({handle:m,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:C?S.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((j,U)=>({...l(j.iconPath),tooltip:j.tooltip,handle:U}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive(g){const C=(0,k.$Hb)(g.map(v=>this.C.get(v)));this.J=C,this.K.fire(C)}_fireDidChangeSelection(g){const C=(0,k.$Hb)(g.map(v=>this.C.get(v)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton(g,C){const v=this.C.get(g);if(!v||!v.buttons||!v.buttons.length)return;const m=v.buttons[C];m&&this.N.fire({button:m,item:v})}}class c extends s{constructor(g,C){super(g.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:M.default.Error}):this.z({validationMessage:g.message,severity:g.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new n(b,o)}e.$vjc=E});var qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)},it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D};define(Se[339],De([1,0,2,4,53,3,8,6,19,124,13,25,55,15,26,16,9]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b){"use strict";var o,i,n,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=e.$wjc=void 0;function a(z){return z instanceof D.URI}function t(z,N){return z.scheme===u.Schemas.file&&N.scheme===u.Schemas.file&&b.$e?z.toString()===N.toString():z.toString().toLowerCase()===N.toString().toLowerCase()}function d(z){if(z)return typeof z.iconPath=="string"?D.URI.file(z.iconPath):D.URI.isUri(z.iconPath)||p.ThemeIcon.isThemeIcon(z.iconPath)?z.iconPath:void 0}function l(z){if(z.icon){if(D.URI.isUri(z.icon))return z.icon;if(p.ThemeIcon.isThemeIcon(z.icon))return z.icon;{const N=z.icon;return{light:N.light,dark:N.dark}}}else return}function r(z,N){if(!z.iconPath&&!N.iconPath)return 0;if(z.iconPath){if(!N.iconPath)return 1}else return-1;const A=typeof z.iconPath=="string"?z.iconPath:D.URI.isUri(z.iconPath)?z.iconPath.fsPath:z.iconPath.id,T=typeof N.iconPath=="string"?N.iconPath:D.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,k.$5q)(A,T)}function c(z,N){let A=0;if(z.strikeThrough!==N.strikeThrough)return z.strikeThrough?1:-1;if(z.faded!==N.faded)return z.faded?1:-1;if(z.tooltip!==N.tooltip)return(z.tooltip||"").localeCompare(N.tooltip||"");if(A=r(z,N),A!==0)return A;if(z.light&&N.light)A=r(z.light,N.light);else{if(z.light)return 1;if(N.light)return-1}if(A!==0)return A;if(z.dark&&N.dark)A=r(z.dark,N.dark);else{if(z.dark)return 1;if(N.dark)return-1}return A}function h(z,N){if(z.command!==N.command)return z.command<N.command?-1:1;if(z.title!==N.title)return z.title<N.title?-1:1;if(z.tooltip!==N.tooltip){if(z.tooltip!==void 0&&N.tooltip!==void 0)return z.tooltip<N.tooltip?-1:1;if(z.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(z.arguments===N.arguments)return 0;if(z.arguments)if(N.arguments){if(z.arguments.length!==N.arguments.length)return z.arguments.length-N.arguments.length}else return 1;else return-1;for(let A=0;A<z.arguments.length;A++){const T=z.arguments[A],F=N.arguments[A];if(T!==F&&!(a(T)&&a(F)&&t(T,F)))return T<F?-1:1}return 0}function g(z,N){let A=(0,k.$5q)(z.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(A!==0)return A;if(z.command&&N.command)A=h(z.command,N.command);else{if(z.command)return 1;if(N.command)return-1}if(A!==0)return A;if(z.decorations&&N.decorations)A=c(z.decorations,N.decorations);else{if(z.decorations)return 1;if(N.decorations)return-1}if(z.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)A=(0,k.$5q)(z.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(z.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(z.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)A=(0,k.$5q)(z.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(z.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return A}function C(z,N){for(let A=0;A<z.length;A++)if(z[A]!==N[A])return!1;return!0}function v(z,N){return z.command===N.command&&z.title===N.title&&z.tooltip===N.tooltip&&(z.arguments&&N.arguments?C(z.arguments,N.arguments):z.arguments===N.arguments)}function m(z,N){return(0,$.$ub)(z,N,v)}class y{get value(){return this.d}set value(N){N=N??"",qe(this,o,"f").$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){qe(this,o,"f").$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,E.$WF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,E.$WF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,qe(this,o,"f").$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,qe(this,o,"f").$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,qe(this,o,"f").$setInputBoxVisibility(this.l,N))}get document(){return(0,E.$WF)(this.k,"scmTextDocument"),qe(this,i,"f").getDocument(this.m)}constructor(N,A,T,F,G){this.k=N,this.l=F,this.m=G,o.set(this,void 0),i.set(this,void 0),this.d="",this.e=new O.$5d,this.f="",this.h=!0,this.j=!0,it(this,i,A,"f"),it(this,o,T,"f")}showValidationMessage(N,A){(0,E.$WF)(this.k,"scmValidation"),qe(this,o,"f").$showValidationMessage(this.l,N,A)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$wjc=y,o=new WeakMap,i=new WeakMap;class P{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,A,T,F,G,K,X){this.q=N,this.s=A,this.t=T,this.u=F,this.v=G,this.multiDiffEditorEnableViewChanges=K,this.w=X,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$5d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$5d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,A){const T=this.h.get(N);return T?(0,L.$9g)(()=>this.s.executeCommand(T.command,...T.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(g),T=(0,$.$Db)(this.o,N,g).map(K=>{const X=K.toInsert.map(Q=>{const Z=this.e++;this.g.set(Z,Q);const ie=Q.resourceUri;let ee;if(Q.command)if(Q.command.command==="vscode.open"||Q.command.command==="vscode.diff"||Q.command.command==="vscode.changes"){const ge=new R.$Sc;ee=this.s.converter.toInternal(Q.command,ge),this.j.set(Z,ge)}else this.h.set(Z,Q.command);const we=(0,E.$VF)(this.w,"scmMultiDiffEditor"),ue=we?Q.multiDiffEditorOriginalUri:void 0,ae=we?Q.multiFileDiffEditorModifiedUri:void 0,H=d(Q.decorations),fe=Q.decorations&&d(Q.decorations.light)||H,he=Q.decorations&&d(Q.decorations.dark)||H,se=[fe,he],ce=Q.decorations&&Q.decorations.tooltip||"",le=Q.decorations&&!!Q.decorations.strikeThrough,de=Q.decorations&&!!Q.decorations.faded,q=Q.contextValue||"";return{rawResource:[Z,ie,se,ce,le,de,q,ee,ue,ae],handle:Z}});return{start:K.start,deleteCount:K.deleteCount,toInsert:X}}),F=T.map(({start:K,deleteCount:X,toInsert:Q})=>[K,X,Q.map(Z=>Z.rawResource)]),G=T.reverse();for(const{start:K,deleteCount:X,toInsert:Q}of G){const Z=Q.map(ee=>ee.handle),ie=this.n.splice(K,X,...Z);for(const ee of ie)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=N,F}dispose(){this.l=!0,this.m.fire()}}P.d=0;class j{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,qe(this,n,"f").$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let A;(0,E.$VF)(this.x,"quickDiffProvider")&&(A=N?.label),qe(this,n,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:A})}get historyProvider(){return(0,E.$WF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,E.$WF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new R.$Sc,qe(this,n,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,qe(this,n,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,qe(this,n,"f").$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new R.$Sc,this.o=N;const A=this.y.converter.toInternal(N,this.n.value);qe(this,n,"f").$updateSourceControl(this.w,{acceptInputCommand:A})}get actionButton(){return(0,E.$WF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,E.$WF)(this.x,"scmActionButton"),this.p.value=new R.$Sc,this.q=N;const A=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(T=>T.map(F=>this.y.converter.toInternal(F,this.p.value))),description:N.description,enabled:N.enabled}:void 0;qe(this,n,"f").$updateSourceControl(this.w,{actionButton:A??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&m(this.t,N))return;this.s.value=new R.$Sc,this.t=N;const A=(N||[]).map(T=>this.y.converter.toInternal(T,this.s.value));qe(this,n,"f").$updateSourceControl(this.w,{statusBarCommands:A})}get selected(){return this.u}constructor(N,A,T,F,G,K,X){this.x=N,this.y=F,this.z=G,this.A=K,this.B=X,n.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Uc,this.m=void 0,this.n=new R.$Uc,this.o=void 0,this.p=new R.$Uc,this.s=new R.$Uc,this.t=void 0,this.u=!1,this.v=new O.$5d,this.onDidChangeSelection=this.v.event,this.w=j.d++,this.C=new Map,this.D=new Set,it(this,n,T,"f");const Q=D.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${G}/scm${this.w}/input`,query:X?`rootUri=${encodeURIComponent(X.toString())}`:void 0});this.f=new y(N,A,qe(this,n,"f"),this.w,Q),qe(this,n,"f").$registerSourceControl(this.w,G,K,X,Q)}createResourceGroup(N,A,T){const F=(0,E.$VF)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,G=new P(qe(this,n,"f"),this.y,this.w,N,A,F,this.x),K=O.Event.once(G.onDidDispose)(()=>this.C.delete(G));return this.C.set(G,K),this.eventuallyAddResourceGroups(),G}eventuallyAddResourceGroups(){const N=[],A=[];for(const[T,F]of this.C){F.dispose();const G=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});O.Event.once(T.onDidDispose)(()=>{this.D.delete(T),G.dispose(),this.e.delete(T.handle),qe(this,n,"f").$unregisterGroup(this.w,T.handle)}),N.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const K=T._takeResourceStateSnapshot();K.length>0&&A.push([T.handle,K]),this.e.set(T.handle,T)}qe(this,n,"f").$registerGroups(this.w,N,A),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(A=>{const T=A._takeResourceStateSnapshot();T.length!==0&&N.push([A.handle,T])}),N.length>0&&qe(this,n,"f").$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),qe(this,n,"f").$unregisterSourceControl(this.w)}}n=new WeakMap,j.d=0,Je([(0,f.$Jh)(100)],j.prototype,"eventuallyAddResourceGroups",null),Je([(0,f.$Jh)(100)],j.prototype,"eventuallyUpdateResourceStates",null);let U=s=class{get onDidChangeActiveProvider(){return this.j.event}constructor(N,A,T,F){this.l=A,this.m=T,this.n=F,this.g=new Map,this.h=new I.$zm,this.j=new O.$5d,this.e=N.getProxy(w.$1L.MainThreadSCM),this.f=N.getProxy(w.$1L.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:G=>{if(G&&G.$mid===3){const K=this.g.get(G.sourceControlHandle);if(!K)return G;const X=K.getResourceGroup(G.groupHandle);return X?X.getResourceState(G.handle):G}else if(G&&G.$mid===4){const K=this.g.get(G.sourceControlHandle);return K?K.getResourceGroup(G.groupHandle):G}else if(G&&G.$mid===5){const K=this.g.get(G.handle);return K||G}return G}})}createSourceControl(N,A,T,F){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,A,T,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const G=s.d++,K=new j(N,this.m,this.e,this.l,A,T,F);this.g.set(G,K);const X=this.h.get(N.identifier)||[];return X.push(K),this.h.set(N.identifier,X),K}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const A=this.h.get(N.identifier),T=A&&A[A.length-1];return T&&T.inputBox}$provideOriginalResource(N,A,T){const F=D.URI.revive(A);this.n.trace("ExtHostSCM#$provideOriginalResource",N,F.toString());const G=this.g.get(N);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$9g)(()=>G.quickDiffProvider.provideOriginalResource(F,T)).then(K=>K||null)}$onInputBoxValueChange(N,A){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const T=this.g.get(N);return T&&T.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(N,A,T,F){this.n.trace("ExtHostSCM#$executeResourceCommand",N,A,T);const G=this.g.get(N);if(!G)return Promise.resolve(void 0);const K=G.getResourceGroup(A);return K?K.$executeResourceCommand(T,F):Promise.resolve(void 0)}$validateInput(N,A,T){this.n.trace("ExtHostSCM#$validateInput",N);const F=this.g.get(N);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,L.$9g)(()=>F.inputBox.validateInput(A,T)).then(G=>{if(!G)return Promise.resolve(void 0);const K=S.MarkdownString.fromStrict(G.message);return K?Promise.resolve([K,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,A,T,F){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(A,T,F)??void 0}async $provideHistoryItems(N,A,T,F){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(A,T,F))?.map(X=>({...X,icon:l(X)}))??void 0}async $provideHistoryItemSummary(N,A,T,F){const G=this.g.get(N)?.historyProvider;if(typeof G?.provideHistoryItemSummary!="function")return;const K=await G.provideHistoryItemSummary(A,T,F);return K?{...K,icon:l(K)}:void 0}async $provideHistoryItemChanges(N,A,T,F){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(A,T,F)??void 0}};e.$xjc=U,U.d=0,e.$xjc=U=s=Je([He(3,M.$yj)],U)}),define(Se[340],De([1,0,6,15,2]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class R{constructor(w,$){this.d=$,this.c=new Map,this.b=w.getProxy(D.$1L.MainThreadShare)}async $provideShare(w,$,k){return await this.c.get(w)?.provideShare({selection:O.Range.to($.selection),resourceUri:f.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(w,$){const k=R.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,O.DocumentSelector.from(w,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$yjc=R,R.a=0});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[341],De([1,0,7,6,218,3,15,18]),function(re,e,D,O,f,R,L,w){"use strict";var $,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=void 0;class M{constructor(E,u,b,o,i,n=D.StatusBarAlignment.Left,s){if($.set(this,void 0),k.set(this,void 0),this.i=!1,this.k="",this.q=new R.$Sc,it(this,$,E,"f"),it(this,k,u,"f"),i&&o){this.c=(0,D.$BM)(o.identifier,i);const a=b.get(this.c);a&&(n=a.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,s=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(M.a++);this.e=o,this.f=i,this.g=n,this.h=this.u(s)}u(E){if((0,w.$Wf)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(E){this.k=E,this.v()}set name(E){this.m=E,this.v()}set tooltip(E){this.l=E,this.v()}set color(E){this.n=E,this.v()}set backgroundColor(E){E&&!M.b.has(E.id)&&(E=void 0),this.o=E,this.v()}set command(E){this.r?.fromApi!==E&&(this.p&&this.q.add(this.p),this.p=new R.$Sc,typeof E=="string"?this.r={fromApi:E,internal:qe(this,k,"f").toInternal({title:"",command:E},this.p)}:E?this.r={fromApi:E,internal:qe(this,k,"f").toInternal(E,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(E){this.t=E,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,qe(this,$,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let E;this.e?this.f?E=`${this.e.identifier.value}.${this.f}`:E=this.e.identifier.value:E=this.f;let u;this.m?u=this.m:u=(0,f.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=M.b.get(this.o.id));const o=L.MarkdownString.fromStrict(this.l);qe(this,$,"f").$setEntry(this.c,E,this.e?.identifier.value,u,this.k,o,this.r?.internal,b,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ajc=M,$=new WeakMap,k=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new D.$YM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$YM("statusBarItem.warningForeground")]]);class I{constructor(E){this.b=[],this.a=E.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(E){const u={message:E};return this.b.unshift(u),this.c(),new D.$3L(()=>{const b=this.b.indexOf(u);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class p{constructor(E,u){this.e=new Map,this.a=E.getProxy(O.$1L.MainThreadStatusBar),this.b=u,this.c=new I(this)}$acceptStaticEntries(E){for(const u of E)this.e.set(u.entryId,u)}createStatusBarEntry(E,u,b,o){return new M(this.a,this.b,this.e,E,u,b,o)}setStatusBarMessage(E,u){const b=this.c.setMessage(E);let o;return typeof u=="number"?o=setTimeout(()=>b.dispose(),u):typeof u<"u"&&u.then(()=>b.dispose(),()=>b.dispose()),new D.$3L(()=>{b.dispose(),clearTimeout(o)})}}e.$Bjc=p}),define(Se[152],De([1,0,29,142,67,112,89,15,2]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=void 0;const k=(n,s,a,t)=>{let d=s;return{enumerable:!0,configurable:!1,get(){return d},set(l){if(!a(d,l)){const r=d;d=l,n.listener?.(t(l,r))}}}},M=(n,s)=>n===s,I={range:(n,s)=>n===s?!0:!n||!s?!1:n.isEqual(s),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(n,s)=>!(n.length!==s.length||n.some(a=>!s.find(t=>a.id===t.id)))},p=n=>s=>({op:4,update:n(s)}),S=(n,s)=>({range:(()=>{let a;const t=p(d=>({range:D.$7s.lift(w.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return a},set(d){n.listener?.({op:6}),I.range(a,d)||(a=d,n.listener?.(t(d)))}}})(),label:k(n,s,I.label,p(a=>({label:a}))),description:k(n,void 0,I.description,p(a=>({description:a}))),sortText:k(n,void 0,I.sortText,p(a=>({sortText:a}))),canResolveChildren:k(n,!1,I.canResolveChildren,a=>({op:2,state:a})),busy:k(n,!1,I.busy,p(a=>({busy:a}))),error:k(n,void 0,I.error,p(a=>({error:w.MarkdownString.fromStrict(a)||null}))),tags:k(n,[],I.tags,(a,t)=>({op:1,new:a.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),E=n=>{const s=f.$RK.fromString(n.extId),a=new b(s.controllerId,s.localId,n.label,$.URI.revive(n.uri)||void 0);return a.range=w.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>w.TestTag.to({id:(0,L.$WK)(t).tagId})),a},u=n=>{let s;for(const a of n.tests){const t=E(a.item);(0,O.$bO)(t).parent=s,s=t}return s};e.$rO=u;class b{constructor(s,a,t,d){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const l=(0,O.$aO)(this,s);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof o?void 0:l.parent}},children:{value:(0,R.$_N)(l,O.$bO,b),enumerable:!0,writable:!1},...S(l,t)})}}e.$sO=b;class o extends b{constructor(s,a){super(s,s,a,void 0),this._isRoot=!0}}e.$tO=o;class i extends R.$8N{constructor(s,a,t){super({controllerId:s,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:O.$bO,getChildren:d=>d.children,root:new o(s,a),toITestItem:w.TestItem.from})}}e.$uO=i});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[33],De([1,0,18,7,15,24,6,19,13,56,29,51,2,3,5,20,152,21,68,41,39,87,90,30]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d){"use strict";var l,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=void 0;let h=class{constructor(P,j,U){l.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),c.set(this,void 0),it(this,l,P.getProxy(L.$1L.MainThreadCommands),"f"),this.d=j,it(this,c,U,"f"),it(this,r,P.getProxy(L.$1L.MainThreadTelemetry),"f"),this.converter=new g(this,z=>{const N=this.c.get(z);return N?.result===v.Void?N:void 0},j),this.f=[{processArgument(z){return(0,k.$Nh)(z)}},{processArgument(z){return(0,R.$Kn)(z,function(N){if(M.$7s.isIRange(N))return f.Range.to(N);if(I.$6s.isIPosition(N))return f.Position.to(N);if(M.$7s.isIRange(N.range)&&p.URI.isUri(N.uri))return f.location.to(N);if(N instanceof o.$se)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const j=this.registerCommand(!1,P.id,async(...U)=>{const z=P.args.map((A,T)=>{if(!A.validate(U[T]))throw new Error(`Invalid argument '${A.name}' when running '${P.id}', received: ${typeof U[T]=="object"?JSON.stringify(U[T],null,"	"):U[T]} `);return A.convert(U[T])}),N=await this.executeCommand(P.internalId,...z);return P.result.convert(N,U,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new O.$3L(()=>{j.dispose(),this.c.delete(P.id)})}registerCommand(P,j,U,z,N,A){if(this.d.trace("ExtHostCommands#registerCommand",j),!j.trim().length)throw new Error("invalid id");if(this.b.has(j))throw new Error(`command '${j}' already exists`);return this.b.set(j,{callback:U,thisArg:z,metadata:N,extension:A}),P&&qe(this,l,"f").$registerCommand(j),new O.$3L(()=>{this.b.delete(j)&&P&&qe(this,l,"f").$unregisterCommand(j)})}executeCommand(P,...j){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,j,!0)}async g(P,j,U){if(this.b.has(P))return qe(this,l,"f").$fireCommandActivationEvent(P),this.h(P,j,!1);{let z=!1;const N=(0,R.$Kn)(j,function(A){if(A instanceof O.$4L)return f.Position.from(A);if(A instanceof O.$5L)return f.Range.from(A);if(A instanceof O.$cM)return f.location.from(A);if(O.$qN.isNotebookRange(A))return f.NotebookRange.from(A);if(A instanceof ArrayBuffer)return z=!0,o.$se.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return z=!0,o.$se.wrap(A);if(A instanceof o.$se)return z=!0,A;if(!Array.isArray(A))return A});try{const A=await qe(this,l,"f").$executeCommand(P,z?new i.$7v(N):N,U);return(0,k.$Nh)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this.g(P,j,!1);throw A}}}async h(P,j,U){const z=this.b.get(P);if(!z)throw new Error("Unknown command");const{callback:N,thisArg:A,metadata:T}=z;if(T?.args)for(let G=0;G<T.args.length;G++)try{(0,D.$0f)(j[G],T.args[G].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${T.args[G].name}' - ${T.args[G].description}`)}const F=s.$1d.create();try{return await N.apply(A,j)}catch(G){if(P===this.converter.delegatingCommandId){const K=this.converter.getActualCommand(...j);K&&(P=K.command)}if(this.d.error(G,P,z.extension?.identifier),!U)throw G;if(z.extension?.identifier){const K=qe(this,c,"f").onExtensionError(z.extension.identifier,G);this.d.trace("forwarded error to extension?",K,z.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$2i)(G)),this.id=P,this.source=z.extension?.displayName??z.extension?.name}}}finally{this.j(z,P,F.elapsed())}}j(P,j,U){P.extension&&qe(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new a.$Xo(j),duration:U})}$executeContributedCommand(P,...j){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const U=this.b.get(P);return U?(j=j.map(z=>this.f.reduce((N,A)=>A.processArgument(N,U.extension?.identifier),z)),this.h(P,j,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),qe(this,l,"f").$getCommands().then(j=>(P&&(j=j.filter(U=>U[0]!=="_")),j))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[j,U]of this.b){const{metadata:z}=U;z&&(P[j]=z)}return Promise.resolve(P)}};e.$AO=h,l=new WeakMap,r=new WeakMap,c=new WeakMap,e.$AO=h=Je([He(0,u.$fO),He(1,$.$yj),He(2,t.$zO)],h),e.$BO=(0,E.$ei)("IExtHostCommands");class g{constructor(P,j,U){this.d=P,this.f=j,this.g=U,this.delegatingCommandId=`__vsc${(0,d.$Ag)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,j){if(!P)return;const U={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return U;const z=this.f(P.command);if(z)U.id=z.internalId,U.arguments=z.args.map((N,A)=>N.convert(P.arguments&&P.arguments[A]));else if((0,w.$Lb)(P.arguments)){const N=`${P.command} /${++this.c}`;this.b.set(N,P),j.add((0,S.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),U.$ident=N,U.id=this.delegatingCommandId,U.arguments=[N],this.g.trace("CommandsConverter#CREATE",P.command,N)}return U}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const j=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],j?j.command:"MISSING"),j?this.d.executeCommand(j.command,...j.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$CO=g;class C{static Arr(P){return new C(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,j=>Array.isArray(j)&&j.every(U=>P.validate(U)),j=>j.map(U=>P.convert(U)))}constructor(P,j,U,z){this.name=P,this.description=j,this.validate=U,this.convert=z}optional(){return new C(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,j){return new C(P??this.name,j??this.description,this.validate,this.convert)}}e.$DO=C,C.Uri=new C("uri","Uri of a text document",y=>p.URI.isUri(y),y=>y),C.Position=new C("position","A position in a text document",y=>O.$4L.isPosition(y),f.Position.from),C.Range=new C("range","A range in a text document",y=>O.$5L.isRange(y),f.Range.from),C.Selection=new C("selection","A selection in a text document",y=>O.$6L.isSelection(y),f.Selection.from),C.Number=new C("number","",y=>typeof y=="number",y=>y),C.String=new C("string","",y=>typeof y=="string",y=>y),C.StringArray=C.Arr(C.String),C.CallHierarchyItem=new C("item","A call hierarchy item",y=>y instanceof O.$nM,f.CallHierarchyItem.from),C.TypeHierarchyItem=new C("item","A type hierarchy item",y=>y instanceof O.$JN,f.TypeHierarchyItem.from),C.TestItem=new C("testItem","A VS Code TestItem",y=>y instanceof b.$sO,f.TestItem.from);class v{constructor(P,j){this.description=P,this.convert=j}}e.$EO=v,v.Void=new v("no result",y=>y);class m{constructor(P,j,U,z,N){this.id=P,this.internalId=j,this.description=U,this.args=z,this.result=N}}e.$FO=m}),define(Se[342],De([1,0,19,16,2,83,132,45,33,15,7]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;const I=[new $.$FO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of DocumentHighlight-instances.",S(k.DocumentHighlight.to))),new $.$FO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$DO.Uri],new $.$EO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,b)=>{if((0,D.$Kb)(u))return;class o extends M.$iM{static to(n){const s=new o(n.name,k.SymbolKind.to(n.kind),n.containerName||"",new M.$cM(b[0],k.Range.to(n.range)));return s.detail=n.detail,s.range=s.location.range,s.selectionRange=k.Range.to(n.selectionRange),s.children=n.children?n.children.map(o.to):[],s}}return u.map(o.to)})),new $.$FO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$DO.Uri,new $.$DO("options","Formatting options",u=>!0,u=>u)],new $.$EO("A promise that resolves to an array of TextEdits.",S(k.TextEdit.to))),new $.$FO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$DO.Uri,$.$DO.Range,new $.$DO("options","Formatting options",u=>!0,u=>u)],new $.$EO("A promise that resolves to an array of TextEdits.",S(k.TextEdit.to))),new $.$FO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$DO.Uri,$.$DO.Position,new $.$DO("ch","Trigger character",u=>typeof u=="string",u=>u),new $.$DO("options","Formatting options",u=>!0,u=>u)],new $.$EO("A promise that resolves to an array of TextEdits.",S(k.TextEdit.to))),new $.$FO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$FO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$FO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$FO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$FO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of Location-instances.",S(k.location.to))),new $.$FO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of Hover-instances.",S(k.Hover.to))),new $.$FO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$DO.Uri,new $.$DO("position","A position in a text document",u=>Array.isArray(u)&&u.every(b=>M.$4L.isPosition(b)),u=>u.map(k.Position.from))],new $.$EO("A promise that resolves to an array of ranges.",u=>u.map(b=>{let o;for(const i of b.reverse())o=new M.$mM(k.Range.to(i),o);return o}))),new $.$FO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$DO.String.with("query","Search string")],new $.$EO("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(k.WorkspaceSymbol.to))),new $.$FO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(k.CallHierarchyItem.to))),new $.$FO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$DO.CallHierarchyItem],new $.$EO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(k.CallHierarchyIncomingCall.to))),new $.$FO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$DO.CallHierarchyItem],new $.$EO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(k.CallHierarchyOutgoingCall.to))),new $.$FO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:k.Range.to(u.range),placeholder:u.text}})),new $.$FO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$DO.Uri,$.$DO.Position,$.$DO.String.with("newName","The new symbol name")],new $.$EO("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return k.WorkspaceEdit.to(u)}})),new $.$FO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$DO.Uri,$.$DO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$EO("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(k.DocumentLink.to))),new $.$FO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$DO.Uri],new $.$EO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$hN(u.tokenTypes,u.tokenModifiers)})),new $.$FO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$DO.Uri],new $.$EO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const b=(0,L.$cab)(u);if(b.type==="full")return new M.$jN(b.data,void 0)})),new $.$FO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$DO.Uri,$.$DO.Range.optional()],new $.$EO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$hN(u.tokenTypes,u.tokenModifiers)})),new $.$FO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$DO.Uri,$.$DO.Range],new $.$EO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const b=(0,L.$cab)(u);if(b.type==="full")return new M.$jN(b.data,void 0)})),new $.$FO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$DO.Uri,$.$DO.Position,$.$DO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$DO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$EO("A promise that resolves to a CompletionList-instance.",(u,b,o)=>{if(!u)return new M.$yM([]);const i=u.suggestions.map(n=>k.CompletionItem.to(n,o));return new M.$yM(i,u.incomplete)})),new $.$FO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$DO.Uri,$.$DO.Position,$.$DO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$EO("A promise that resolves to SignatureHelp.",u=>{if(u)return k.SignatureHelp.to(u)})),new $.$FO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$DO.Uri,$.$DO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$EO("A promise that resolves to an array of CodeLens-instances.",(u,b,o)=>S(i=>new M.$qM(k.Range.to(i.range),i.command&&o.fromInternal(i.command)))(u))),new $.$FO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$DO.Uri,new $.$DO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>M.$5L.isRange(u),u=>M.$6L.isSelection(u)?k.Selection.from(u):k.Range.from(u)),$.$DO.String.with("kind","Code action kind to return code actions for").optional(),$.$DO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$EO("A promise that resolves to an array of Command-instances.",(u,b,o)=>S(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new M.$kM(i.title,i.kind?new M.$lM(i.kind):void 0);return i.edit&&(n.edit=k.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(u))),new $.$FO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$DO.Uri],new $.$EO("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(b=>new M.$EM(k.Range.to(b.range),k.Color.to(b.color))):[])),new $.$FO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$DO("color","The color to show and insert",u=>u instanceof M.$DM,k.Color.from),new $.$DO("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:k.Range.from(u.range)}))],new $.$EO("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(k.ColorPresentation.to):[])),new $.$FO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$DO.Uri,$.$DO.Range],new $.$EO("A promise that resolves to an array of Inlay objects",(u,b,o)=>u.map(k.InlayHint.to.bind(void 0,o)))),new $.$FO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$DO.Uri],new $.$EO("A promise that resolves to an array of FoldingRange objects",(u,b)=>{if(u)return u.map(k.FoldingRange.to)})),new $.$FO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$EO("A promise that resolves to an array of NotebookContentProvider static info objects.",S(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(b=>k.NotebookExclusiveDocumentPattern.to(b))})))),new $.$FO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$DO.Uri,$.$DO.Range,new $.$DO("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof M.$5L,u=>k.InlineValueContext.from(u))],new $.$EO("A promise that resolves to an array of InlineValue objects",u=>u.map(k.InlineValue.to))),new $.$FO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$DO("uriOrString","Uri-instance or string (only http/https)",u=>f.URI.isUri(u)||typeof u=="string"&&(0,O.$pg)(u,O.Schemas.http,O.Schemas.https),u=>u),new $.$DO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[k.ViewColumn.from(u),void 0]:[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)])).optional(),$.$DO.String.with("label","").optional()],$.$EO.Void),new $.$FO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$DO.Uri.with("resource","Resource to open"),$.$DO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$DO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[k.ViewColumn.from(u),void 0]:[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)])).optional()],$.$EO.Void),new $.$FO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$DO.Uri.with("left","Left-hand side resource of the diff editor"),$.$DO.Uri.with("right","Right-hand side resource of the diff editor"),$.$DO.String.with("title","Human readable title for the diff editor").optional(),new $.$DO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)]).optional()],$.$EO.Void),new $.$FO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$DO.String.with("title","Human readable title for the changes editor"),new $.$DO("resourceList","List of resources to compare",u=>{for(const b of u){if(b.length!==3)return!1;const[o,i,n]=b;if(!f.URI.isUri(o)||!f.URI.isUri(i)&&i!==void 0&&i!==null||!f.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},u=>u)],$.$EO.Void),new $.$FO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$DO.Uri,$.$DO.Position],new $.$EO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(k.TypeHierarchyItem.to))),new $.$FO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$DO.TypeHierarchyItem],new $.$EO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(k.TypeHierarchyItem.to))),new $.$FO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$DO.TypeHierarchyItem],new $.$EO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(k.TypeHierarchyItem.to))),new $.$FO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$DO.TestItem],$.$EO.Void),new $.$FO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$DO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$EO.Void),new $.$FO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$DO.String.with("name","The context key name"),new $.$DO("value","The context key value",()=>!0,u=>u)],$.$EO.Void),new $.$FO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$DO.Uri,$.$DO.StringArray,new $.$DO("MappedEditsContext","Mapped Edits Context",u=>k.MappedEditsContext.is(u),u=>k.MappedEditsContext.from(u))],new $.$EO("A promise that resolves to a workspace edit or null",u=>u?k.WorkspaceEdit.to(u):null))];class p{static register(b){I.forEach(b.registerApiCommand,b),this.a(b)}static a(b){b.registerCommand(!1,"_validateWhenClauses",w.$dj)}}e.$Whc=p;function S(u){return b=>{if(Array.isArray(b))return b.map(u)}}function E(u){if(!Array.isArray(u))return;const b=[];for(const o of u)R.$Tt(o)?b.push(k.DefinitionLink.to(o)):b.push(k.location.to(o));return b}}),define(Se[343],De([1,0,8,3,2,6,33,15,7]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;class k{constructor(S,E){this.extension=S,this.provider=E,this.handle=k.a++}}k.a=0;class M{constructor(S){this.session=S,this.responses=[]}}class I{constructor(S,E,u,b){this.f=u,this.g=b,this.b=new Map,this.d=new Map,this.e=S.getProxy(R.$1L.MainThreadInlineChat),E.registerApiCommand(new L.$FO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new L.$DO("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?w.Range.from(o.initialRange):void 0,initialSelection:$.$6L.isSelection(o.initialSelection)?w.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?w.Position.from(o.position):void 0}})],L.$EO.Void))}registerProvider(S,E,u){const b=new k(S,E);return this.b.set(b.handle,b),this.e.$registerInteractiveEditorProvider(b.handle,u?.label??S.displayName??S.name,S.identifier.value,typeof E.handleInteractiveEditorResponseFeedback=="function",typeof E.provideFollowups=="function",u?.supportReportIssue??!1),(0,O.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(b.handle),this.b.delete(b.handle)})}async $prepareSession(S,E,u,b){const o=this.b.get(S);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(f.URI.revive(E)),n=w.Selection.to(u),s=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},b);if(!s)return;if(s.wholeRange&&!s.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=I.a++;return this.d.set(a,new M(s)),{id:a,placeholder:s.placeholder,input:s.input,slashCommands:s.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:w.Range.from(s.wholeRange),message:s.message}}async $provideResponse(S,E,u,b){const o=this.b.get(S);if(!o)return;const i=this.d.get(E.id);if(!i)return;const n={prompt:u.prompt,selection:w.Selection.to(u.selection),wholeRange:w.Range.to(u.wholeRange),attempt:u.attempt,live:u.live,previewDocument:this.f.getDocument(f.URI.revive(u.previewDocument)),withIntentDetection:u.withIntentDetection};let s=!1;const a={report:async C=>{if(!u.live&&C.edits?.length)throw new Error("Progress reporting is only supported for live sessions");s||b.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:C.message,edits:C.edits?.map(w.TextEdit.from),editsShouldBeInstant:C.editsShouldBeInstant,slashCommand:C.slashCommand?.command,markdownFragment:$.$rM.isMarkdownString(C.content)?C.content.value:C.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,b));let d;try{d=await(0,D.$5g)(t,b)}finally{s=!0}if(!d)return;const l=i.responses.push(d)-1,r={wholeRange:w.Range.from(d.wholeRange),placeholder:d.placeholder};if(!I.h(d))return{...r,id:l,type:"editorEdit",message:w.MarkdownString.from(d.contents),edits:[]};const{edits:c,contents:h}=d,g=h!==void 0?w.MarkdownString.from(h):void 0;return c instanceof $.$aM?{...r,id:l,type:"bulkEdit",edits:w.WorkspaceEdit.from(c),message:g}:{...r,id:l,type:"editorEdit",edits:c.map(w.TextEdit.from),message:g}}async $provideFollowups(S,E,u,b){const o=this.b.get(S),i=this.d.get(E),n=i?.responses[u];if(o&&n&&o.provider.provideFollowups){const s=Promise.resolve(o.provider.provideFollowups(i.session,n,b));return(await(0,D.$5g)(s,b))?.map(w.ChatInlineFollowup.from)}}$handleFeedback(S,E,u,b){const o=this.b.get(S),i=this.d.get(E),n=i?.responses[u];if(o&&n){const s=w.InteractiveEditorResponseFeedbackKind.to(b);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,s)}}$releaseSession(S,E){}static h(S){return typeof S=="object"&&typeof S.edits=="object"}}e.$5ic=I,I.a=0}),define(Se[344],De([1,0,2,33]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;class f{constructor(L,w,$,k,M){this.a=w,this.b=$,this.c=k;const I=new O.$FO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$DO("showOptions","Show Options",p=>!0,p=>p),new O.$DO("resource","Interactive resource Uri",p=>!0,p=>p),new O.$DO("controllerId","Notebook controller Id",p=>!0,p=>p),new O.$DO("title","Interactive editor title",p=>!0,p=>p)],new O.$EO("Notebook and input URI",p=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const S=this.a.getEditorById(p.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri),notebookEditor:S.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(L,w,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$fjc=f}),define(Se[345],De([1,0,19,8,22,4,3,28,2,25,13,6,33,15,7,113,285,26,68,286]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=void 0;let s=class{constructor(g,C,v,m,y){this.m=C,this.n=v,this.o=m,this.q=y,this.b=new w.$Ac,this.c=new w.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$5d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(I.$1L.MainThreadNotebookKernels);const P=new p.$FO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$DO("options","Select kernel options",U=>!0,U=>{if(U&&"notebookEditor"in U&&"id"in U){const z=this.n.getIdByEditor(U.notebookEditor);return{id:U.id,extension:U.extension,notebookEditorId:z}}else if(U&&"notebookEditor"in U){const z=this.n.getIdByEditor(U.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${U.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return U})],p.$EO.Void),j=new p.$FO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$DO.Uri],new p.$EO("A promise that resolves to an array of variables",(U,z)=>U.map(N=>({name:N.name,value:N.value,type:N.type,editable:!1}))));this.o.registerApiCommand(P),this.o.registerApiCommand(j)}createNotebookController(g,C,v,m,y,P){for(const we of this.j.values())if(we.controller.id===C&&k.$xm.equals(g.identifier,we.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const j=this.k++,U=this;this.q.trace(`NotebookController[${j}], CREATED by ${g.identifier.value}, ${C}`);const z=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${g.identifier}'`);let N=!1;const A=new R.$5d,T=new R.$5d,F={id:c(g.identifier,C),notebookType:v,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:m||g.identifier.value,preloads:P?P.map(S.NotebookRendererScript.from):[]};let G=y??z,K,X;this.a.$addKernel(j,F).catch(we=>{console.log(we),N=!0});let Q=0;const Z=()=>{if(N)return;const we=++Q;Promise.resolve().then(()=>{we===Q&&this.a.$updateKernel(j,F)})},ie=new w.$Ac,ee={get id(){return C},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return F.label},set label(we){F.label=we??g.displayName??g.name,Z()},get detail(){return F.detail??""},set detail(we){F.detail=we,Z()},get description(){return F.description??""},set description(we){F.description=we,Z()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(we){F.supportedLanguages=we,Z()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(we){F.supportsExecutionOrder=we,Z()},get rendererScripts(){return F.preloads?F.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(we){G=we??z},get interruptHandler(){return K},set interruptHandler(we){K=we,F.supportsInterrupt=!!we,Z()},set variableProvider(we){(0,o.$WF)(g,"notebookVariableProvider"),X=we,F.hasVariableProvider=!!we,we?.onDidChangeVariables(ue=>U.a.$variablesUpdated(ue.uri)),Z()},get variableProvider(){return X},createNotebookCellExecution(we){if(N)throw new Error("notebook controller is DISPOSED");if(!ie.has(we.notebook.uri))throw U.q.trace(`NotebookController[${j}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return U._createNotebookCellExecution(we,c(g.identifier,this.id))},createNotebookExecution(we){if((0,o.$WF)(g,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!ie.has(we.uri))throw U.q.trace(`NotebookController[${j}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return U._createNotebookExecution(we,c(g.identifier,this.id))},dispose:()=>{N||(this.q.trace(`NotebookController[${j}], DISPOSED`),N=!0,this.j.delete(j),A.dispose(),T.dispose(),this.a.$removeKernel(j))},updateNotebookAffinity(we,ue){ue===E.NotebookControllerAffinity2.Hidden&&(0,o.$WF)(g,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(j,we.uri,ue)},onDidReceiveMessage:T.event,postMessage(we,ue){return(0,o.$WF)(g,"notebookMessaging"),U.a.$postMessage(j,ue&&U.n.getIdByEditor(ue),we)},asWebviewUri(we){return(0,o.$WF)(g,"notebookMessaging"),(0,u.$Jxb)(we,U.m.remote)}};return this.j.set(j,{extensionId:g.identifier,controller:ee,onDidReceiveMessage:T,onDidChangeSelection:A,associatedNotebooks:ie}),ee}getIdByController(g){for(const[C,v]of this.j)if(v.controller===g)return c(v.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,C){const v=this.g++,m=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(v,C);const y={dispose:()=>{this.f.delete(v),m.a.$removeKernelDetectionTask(v)}};return this.f.set(v,y),y}registerKernelSourceActionProvider(g,C,v){const m=this.i++,y=typeof v.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,P=this;this.h.set(m,v),this.q.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,C);let j;return y!==void 0&&(j=v.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(m),P.a.$removeKernelSourceActionProvider(m,m),j?.dispose()}}}async $provideKernelSourceActions(g,C){const v=this.h.get(g);if(v){const m=new L.$Sc;return(await v.provideNotebookKernelSourceActions(C)??[]).map(P=>S.NotebookKernelSourceAction.from(P,this.o.converter,m))}return[]}$acceptNotebookAssociation(g,C,v){const m=this.j.get(g);if(m){const y=this.n.getNotebookDocument($.URI.revive(C));v?m.associatedNotebooks.set(y.uri,!0):m.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,y.uri.toString(),v),m.onDidChangeSelection.fire({selected:v,notebook:y.apiNotebook})}}async $executeCells(g,C,v){const m=this.j.get(g);if(!m)return;const y=this.n.getNotebookDocument($.URI.revive(C)),P=[];for(const j of v){const U=y.getCell(j);U&&P.push(U.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,y.uri.toString(),P.length),await m.controller.executeHandler.call(m.controller,P,y.apiNotebook,m.controller)}catch(j){this.q.error(`NotebookController[${g}] execute cells FAILED`,j),console.error(j)}}async $cancelCells(g,C,v){const m=this.j.get(g);if(!m)return;const y=this.n.getNotebookDocument($.URI.revive(C));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,y.apiNotebook);else for(const P of v){const j=y.getCell(P);j&&this.b.get(j.uri)?.cancel()}if(m.controller.interruptHandler){const P=this.c.get(y.uri);v.length&&Array.isArray(P)&&P.length&&P.forEach(j=>j.dispose())}}async $provideVariables(g,C,v,m,y,P,j){const U=this.j.get(g);if(!U)return;const z=this.n.getNotebookDocument($.URI.revive(v)),N=U.controller.variableProvider;if(!N)return;let A;if(m!==void 0){if(A=this.s[m],!A)return}else this.s={};const T=y==="named"?E.NotebookVariablesRequestKind.Named:E.NotebookVariablesRequestKind.Indexed,F=N.provideVariables(z.apiNotebook,A,T,P,j);let G=0;for await(const K of F){if(j.isCancellationRequested)return;const X={id:this.r++,name:K.variable.name,value:K.variable.value,type:K.variable.type,hasNamedChildren:K.hasNamedChildren,indexedChildrenCount:K.indexedChildrenCount,extensionId:U.extensionId.value};if(this.s[X.id]=K.variable,this.a.$receiveVariable(C,X),G++>=n.$9gb)return}}$acceptKernelMessageFromRenderer(g,C,v){const m=this.j.get(g);if(!m)return;const y=this.n.getEditorById(C);m.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:v}))}$cellExecutionChanged(g,C,v){const y=this.n.getNotebookDocument($.URI.revive(g)).getCell(C);if(y){const P=v?S.NotebookCellExecutionState.to(v):E.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution(g,C){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const y=new t(C,m,this.a);this.b.set(m.uri,y);const P=y.onDidChangeState(()=>{y.state===a.Resolved&&(y.dispose(),P.dispose(),this.b.delete(m.uri))});return y.asApiObject()}_createNotebookExecution(g,C){const v=this.n.getNotebookDocument(g.uri),m=g.getCells().find(j=>{const U=v.getCellFromApiCell(j);return U&&this.b.has(U.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const y=new l(C,v,this.a),P=y.onDidChangeState(()=>{y.state===d.Resolved&&(y.dispose(),P.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[y,P]),y.asApiObject()}};e.$njc=s,e.$njc=s=Je([He(4,M.$yj)],s);var a;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(a||(a={}));class t extends L.$Tc{get state(){return this.f}constructor(g,C,v){super(),this.m=C,this.n=v,this.b=t.a++,this.c=new R.$5d,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new f.$ce),this.h=new r(10,m=>this.s(m)),this.j=C.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const C=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new i.$7v(C))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let C=this.m;if(g&&(C=this.m.notebook.getCellFromApiCell(g)),!C)throw new Error("INVALID cell");return C.handle}y(g){return g.map(C=>{const v=E.$uN.ensureUniqueMimeTypes(C.items,!0);return v===C.items?S.NotebookCellOutput.from(C):S.NotebookCellOutput.from({items:v,id:C.id,metadata:C.metadata})})}async z(g,C,v){const m=this.w(C),y=this.y((0,D.$3b)(g));return this.r({editType:b.CellExecutionUpdateType.Output,cellHandle:m,append:v,outputs:y})}async C(g,C,v){return g=E.$uN.ensureUniqueMimeTypes((0,D.$3b)(g),!0),this.r({editType:b.CellExecutionUpdateType.OutputItems,items:g.map(S.NotebookCellOutputItem.from),outputId:C.id,append:v})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(v){g.j=v,g.s([{editType:b.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(v){if(g.f===a.Resolved||g.f===a.Started)throw new Error("Cannot call start again");g.f=a.Started,g.c.fire(),g.s({editType:b.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,m){if(g.f===a.Resolved)throw new Error("Cannot call resolve twice");g.f=a.Resolved,g.c.fire(),g.h.flush(),g.n.$completeExecution(g.b,new i.$7v({runEndTime:m,lastRunSuccess:v}))},clearOutput(v){return g.t(),g.z([],v,!1)},appendOutput(v,m){return g.t(),g.z(v,m,!0)},replaceOutput(v,m){return g.t(),g.z(v,m,!1)},appendOutputItems(v,m){return g.t(),g.C(v,m,!0)},replaceOutputItems(v,m){return g.t(),g.C(v,m,!1)}})}}t.a=0;var d;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(d||(d={}));class l extends L.$Tc{get state(){return this.f}constructor(g,C,v){super(),this.h=C,this.j=v,this.b=l.a++,this.c=new R.$5d,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new f.$ce),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}l.a=0;class r{constructor(g,C){this.f=g,this.g=C,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new O.$Bh,this.b=Date.now(),(0,O.$fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const C=this.a;return this.a=[],this.g(C).finally(()=>g.complete())}}function c(h,g){return`${h.value}/${g}`}e.$ojc=c}),define(Se[46],De([1,0,4,6,5,2,20,3,7,220,14,264,22,30,265,55,8,15,33]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=e.$Bic=e.$Aic=e.$zic=void 0,e.$zic=(0,f.$ei)("IExtHostTerminalService");class n{constructor(v,m,y,P){this.l=v,this._id=m,this.m=y,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const j=this;this.value={get name(){return j.n||""},get processId(){return j.b},get creationOptions(){return j.m},get exitStatus(){return j.h},get state(){return j.j},get selection(){return j.k},sendText(U,z=!0){j.q(),j.l.$sendText(j._id,U,z)},show(U){j.q(),j.l.$show(j._id,U)},hide(){j.q(),j.l.$hide(j._id)},dispose(){j.a||(j.a=!0,j.l.$dispose(j._id))},get dimensions(){if(!(j.d===void 0||j.g===void 0))return{columns:j.d,rows:j.g}}}}async create(v,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??m?.cwd??void 0,env:v.env??void 0,icon:c(v.iconPath)??void 0,color:u.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(v.location,m?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,m,y,P,j){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:u.ThemeColor.isThemeColor(j)?j.id:void 0,location:m?.location||this.o(v,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,m){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in v?{viewColumn:o.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,m){this.h=Object.freeze({code:v,reason:m})}setDimensions(v,m){return v===this.d&&m===this.g||v===0||m===0?!1:(this.d=v,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(m=>{m!==v&&(this.b=Promise.resolve(v))})}}e.$Aic=n;class s{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new D.$5d,this.onProcessData=this.a.event,this.b=new D.$5d,this.d=new D.$5d,this.onDidChangeProperty=this.d.event,this.f=new D.$5d,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,m){this.g.setDimensions?.({columns:v,rows:m})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends w.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,m,y){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$5d,this.onDidCloseTerminal=this.H.event,this.I=new D.$5d,this.onDidOpenTerminal=this.I.event,this.J=new D.$5d,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$5d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$5d,this.onDidChangeTerminalState=this.M.event,this.N=new D.$5d,this.onDidChangeShell=this.N.event,this.O=new D.$5d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$5d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(O.$1L.MainThreadTerminalService),this.y=new E.$Ptb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:P=>{const j=U=>{const z=U;return this.W(z.instanceId)?.value};switch(P?.$mid){case 15:return j(P);default:{if(Array.isArray(P))for(let U=0;U<P.length&&P[U].$mid===15;U++)P[U]=j(P[U]);return P}}}}),this.B({dispose:()=>{for(const[P,j]of this.g)j.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,m){const y=new n(this.a,(0,S.$Ag)(),v,v.name),P=new s(v.pty);return y.createExtensionTerminal(v.location,m,this.R(v,m).resolvedExtHostIdentifier,c(v.iconPath),h(v.color)).then(j=>{const U=this.S(j,P);this.h[j]=U}),this.f.push(y),y.value}R(v,m){if(m=m||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const y=v.location.parentTerminal;if(y){const P=this.f.find(j=>j.value===y);P&&(m.resolvedExtHostIdentifier=P._id)}}else v.location&&typeof v.location!="object"?m.location=v.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(v,m){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const P=new s(m),j=this.S(v,P);this.h[v]=j}async $acceptActiveTerminalChanged(v){const m=this.b;if(v===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const y=this.W(v);y&&(this.b=y,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,m){const y=this.W(v);y&&this.O.fire({terminal:y.value,data:m})}async $acceptTerminalDimensions(v,m,y){const P=this.W(v);P&&P.setDimensions(m,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(v,m){const y=this.W(v);y&&this.P.fire({terminal:y.value,...m})}async $acceptTerminalMaximumDimensions(v,m,y){this.g.get(v)?.resize(m,y)}async $acceptTerminalTitleChange(v,m){const y=this.W(v);y&&(y.name=m)}async $acceptTerminalClosed(v,m,y){const P=this.Y(this.f,v);if(P!==null){const j=this.f.splice(P,1)[0];j.setExitStatus(m,y),this.H.fire(j.value)}}$acceptTerminalOpened(v,m,y,P){if(m){const z=this.Y(this.f,m);if(z!==null){this.f[z]._id=v,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const j={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},U=new n(this.a,v,j,y);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(v,m){this.W(v)?._setProcessId(m)}async $startExtensionTerminal(v,m){const y=this.W(v);if(!y)return{message:(0,k.localize)(0,null,v)};y.isOpen||await new Promise(j=>{const U=this.onDidOpenTerminal(async z=>{z===y.value&&(U.dispose(),j())})});const P=this.g.get(v);P?P.startSendingEvents(m):this.j[v]={initialDimensions:m}}S(v,m){const y=new w.$Sc;y.add(m.onProcessReady(j=>this.a.$sendProcessReady(v,j.pid,j.cwd,j.windowsPty))),y.add(m.onDidChangeProperty(j=>this.a.$sendProcessProperty(v,j))),this.y.startBuffering(v,m.onProcessData),y.add(m.onProcessExit(j=>this.U(v,j))),this.g.set(v,m);const P=this.j[v];return P&&m instanceof s&&(m.startSendingEvents(P.initialDimensions),delete this.j[v]),y}$acceptProcessAckDataEvent(v,m){this.g.get(v)?.acknowledgeDataEvent(m)}$acceptProcessInput(v,m){this.g.get(v)?.input(m)}$acceptTerminalInteraction(v){const m=this.W(v);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(v,m){this.W(v)?.setSelection(m)}$acceptProcessResize(v,m,y){try{this.g.get(v)?.resize(m,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(v,m){this.g.get(v)?.shutdown(m)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(m=>this.a.$sendProcessProperty(v,{type:"cwd",value:m}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new $.$3L(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,m,y){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,y),this.a.$registerProfileProvider(m,v.identifier.value),new $.$3L(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(v,m,y){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,y),this.a.$registerQuickFixProvider(v,m),new $.$3L(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,m){const y=new p.$ce().token;if(y.isCancellationRequested)return;const P=this.D.get(v);if(!P)return;const j=await P.provideTerminalQuickFixes(m,y);if(j===null||Array.isArray(j)&&j.length===0)return;const U=new w.$Sc;if(this.w.value=U,!Array.isArray(j))return j?o.TerminalQuickFix.from(j,this.Q.converter,U):void 0;const z=[];for(const N of j){const A=o.TerminalQuickFix.from(N,this.Q.converter,U);A&&z.push(A)}return z}async $createContributedProfileTerminal(v,m){const y=new p.$ce().token;let P=await this.C.get(v)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(v,m){const y=this.W(v);if(!y)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const j=new p.$ce;this.G.set(v,j);const U=[],z={terminal:y.value,line:m},N=[];for(const F of this.z)N.push(b.Promises.withAsyncBody(async G=>{j.token.onCancellationRequested(()=>G({provider:F,links:[]}));const K=await F.provideTerminalLinks(z,j.token)||[];j.token.isCancellationRequested||G({provider:F,links:K})}));const A=await Promise.all(N);if(j.token.isCancellationRequested)return[];const T=new Map;for(const F of A)F&&F.links.length>0&&U.push(...F.links.map(G=>{const K={id:a++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return T.set(K.id,{provider:F.provider,link:G}),K}));return this.F.set(v,T),U}$activateLink(v,m){const y=this.F.get(v)?.get(m);y&&y.provider.handleTerminalLink(y.link)}U(v,m){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const y=this.h[v];y&&(y.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,m)}W(v){return this.X(this.f,v)}X(v,m){const y=this.Y(v,m);return y!==null?v[y]:null}Y(v,m){const y=v.findIndex(P=>P._id===m);return y===-1?null:y}getEnvironmentVariableCollection(v){let m=this.n.get(v.identifier.value);return m||(m=new d,this.$(v.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(v,m){const y=(0,I.$Yr)(m.map),P=(0,I.$Zr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(v,m.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(v){v.forEach(m=>{const y=m[0],P=new d(m[1]);this.$(y,P)})}$acceptDefaultProfile(v,m){const y=this.s;this.s=v,this.u=m,y?.path!==v.path&&this.N.fire(v.path)}$(v,m){this.n.set(v,m),m.onDidChangeCollection(()=>{this.Z(v,m)})}};e.$Bic=t,e.$Bic=t=Je([He(1,i.$BO),He(2,L.$fO)],t);class d{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$5d,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const m=this.h(v);let y=this.a.get(m);return y||(y=new l(this,v),this.a.set(m,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(v,m,y,P){this.f(v,{value:m,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(v,m,y,P){this.f(v,{value:m,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(v,m,y,P){this.f(v,{value:m,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(v,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(v,m.scope),P=this.map.get(y),j=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==j.applyAtProcessCreation||P.options?.applyAtShellIntegration!==j.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const U=this.g(v,m.scope),z={variable:v,...m,options:j};this.map.set(U,z),this.d.fire()}}get(v,m){const y=this.g(v,m),P=this.map.get(y);return P?g(P):void 0}g(v,m){const y=this.h(m);return y.length?`${v}:::${y}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const m=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(v)&&m.set(P.variable,g(P));return m}delete(v,m){const y=this.g(v,m);this.map.delete(y),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[m,y]of this.map)y.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(m);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,m){const y=this.h(m),P=this.descriptionMap.get(y);if(!P||P.description!==v){let j;typeof v=="string"?j=v:j=v?.value.split(`

`)[0];const U={description:j,scope:m};this.descriptionMap.set(y,U),this.d.fire()}}getDescription(v){const m=this.h(v);return this.descriptionMap.get(m)?.description}k(v){const m=this.h(v);this.descriptionMap.delete(m)}}class l{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,m){this.b=v,this.d=m,this.a=new D.$5d}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,m,y){this.b.replace(v,m,y,this.d)}append(v,m,y){this.b.append(v,m,y,this.d)}prepend(v,m,y){this.b.prepend(v,m,y,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,m){this.b.getVariableMap(this.d).forEach((y,P)=>v.call(m,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let r=class extends t{constructor(v,m){super(!1,v,m)}createTerminal(v,m,y){throw new M.$_}createTerminalFromOptions(v,m){throw new M.$_}};e.$Cic=r,e.$Cic=r=Je([He(0,i.$BO),He(1,L.$fO)],r);function c(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function h(C){return u.ThemeColor.isThemeColor(C)?C:void 0}function g(C){const v={...C};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}});var qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)},it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D};define(Se[346],De([1,0,8,21,22,4,74,54,3,24,18,30,13,6,20,152,15,7,67,112,89,26]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a){"use strict";var t,d,l,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=e.$Gjc=e.$Fjc=void 0;let h=class extends $.$Tc{constructor(K,X,Q,Z){super(),this.w=Z,this.f=this.B(new R.$5d),this.g=new Map,this.s=this.B(new R.$5d),this.onResultsChanged=this.f.event,this.results=[],this.h=K.getProxy(S.$1L.MainThreadTesting),this.m=new N(this.h),this.j=new m(this.h,X),Q.registerArgumentProcessor({processArgument:ie=>{switch(ie?.$mid){case 16:{const ee=ie,we=ee.tests[ee.tests.length-1].item.extId;return this.g.get(i.$RK.root(we))?.collection.tree.get(we)?.actual??(0,u.$rO)(ie)}case 18:{const{extId:ee,message:we}=ie;return{test:this.g.get(i.$RK.root(ee))?.collection.tree.get(ee)?.actual,message:b.TestMessage.to(we)}}default:return ie}}}),Q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ie=await Q.executeCommand("_testing.getExplorerSelection"),ee=we=>{const ue=this.g.get(i.$RK.root(we));if(ue)return i.$RK.isRoot(we)?ue.controller:ue.collection.tree.get(we)?.actual};return{include:ie?.include.map(ee).filter(M.$1f)||[],exclude:ie?.exclude.map(ee).filter(M.$1f)||[]}})}createTestController(K,X,Q,Z){if(this.g.has(X))throw new Error(`Attempt to insert a duplicate controller with ID "${X}"`);const ie=new $.$Sc,ee=ie.add(new u.$uO(X,Q,this.w));ee.root.label=Q;const we=new Map,ue=new Set,ae=this.h,H={items:ee.root.children,get label(){return Q},set label(he){Q=he,ee.root.label=he,ae.$updateController(X,{label:Q})},get refreshHandler(){return Z},set refreshHandler(he){Z=he,ae.$updateController(X,{canRefresh:!!he})},get id(){return X},createRunProfile:(he,se,ce,le,de,q)=>{let _=(0,w.$5i)(he);for(;we.has(_);)_++;return new T(this.h,we,ue,this.s.event,X,_,he,se,ce,le,de,q)},createTestItem(he,se,ce){return new u.$sO(X,he,se,ce)},createTestRun:(he,se,ce=!0)=>this.j.createTestRun(K,X,ee,he,se,ce),invalidateTestResults:he=>{if(he===void 0)this.h.$markTestRetired(void 0);else{const se=he instanceof Array?he:[he];this.h.$markTestRetired(se.map(ce=>i.$RK.fromExtHostTestItem(ce,X).toString()))}},set resolveHandler(he){ee.resolveHandler=he},get resolveHandler(){return ee.resolveHandler},dispose:()=>{ie.dispose()}};ae.$registerTestController(X,Q,!!Z),ie.add((0,$.$Rc)(()=>ae.$unregisterTestController(X)));const fe={controller:H,collection:ee,profiles:we,extension:K,activeProfiles:ue};return this.g.set(X,fe),ie.add((0,$.$Rc)(()=>this.g.delete(X))),ie.add(ee.onDidGenerateDiff(he=>ae.$publishDiff(X,he.map(s.TestsDiffOp.serialize)))),H}createTestObserver(){return this.m.checkout()}async runTests(K,X=f.CancellationToken.None){const Q=y(K);if(!Q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const Z=this.g.get(Q.controllerId);if(!Z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:K.include?.map(ie=>i.$RK.fromExtHostTestItem(ie,Z.collection.root.id).toString())??[Z.collection.root.id],profileGroup:F[Q.kind],profileId:Q.profileId,controllerId:Q.controllerId}],exclude:K.exclude?.map(ie=>ie.id)},X)}$syncTests(){for(const{collection:K}of this.g.values())K.flushDiff();return Promise.resolve()}async $provideFileCoverage(K,X,Q){return await this.j.getCoverageReport(K,X)?.provideFileCoverage(Q)??[]}async $resolveFileCoverage(K,X,Q,Z){return await this.j.getCoverageReport(K,X)?.resolveFileCoverage(Q,Z)??[]}$configureRunProfile(K,X){this.g.get(K)?.profiles.get(X)?.configureHandler?.()}$setDefaultRunProfiles(K){const X=new Map;for(const[Q,Z]of Object.entries(K)){const ie=this.g.get(Q);if(!ie)continue;const ee=new Map,we=Z.filter(ae=>!ie.activeProfiles.has(ae)),ue=[...ie.activeProfiles].filter(ae=>!Z.includes(ae));for(const ae of we)ee.set(ae,!0),ie.activeProfiles.add(ae);for(const ae of ue)ee.set(ae,!1),ie.activeProfiles.delete(ae);ee.size&&X.set(Q,ee)}this.s.fire(X)}async $refreshTests(K,X){await this.g.get(K)?.controller.refreshHandler?.(X)}$publishTestResults(K){this.results=Object.freeze(K.map(X=>(0,k.$Jn)(b.TestResults.to(X))).concat(this.results).sort((X,Q)=>Q.completedAt-X.completedAt).slice(0,32)),this.f.fire()}async $expandTest(K,X){const Q=this.g.get(i.$RK.fromString(K).controllerId)?.collection;Q&&(await Q.expand(K,X<0?1/0:X),Q.flushDiff())}$acceptDiff(K){this.m.applyDiff(K.map(X=>s.TestsDiffOp.deserialize({asCanonicalUri:Q=>Q},X)))}async $runControllerTests(K,X){return Promise.all(K.map(Q=>this.y(Q,!1,X)))}async $startContinuousRun(K,X){const Q=new f.$ce(X),Z=await Promise.all(K.map(ie=>this.y(ie,!0,Q.token)));return!X.isCancellationRequested&&!Z.some(ie=>ie.error)&&await new Promise(ie=>X.onCancellationRequested(ie)),Q.dispose(!0),Z}async y(K,X,Q){const Z=this.g.get(K.controllerId);if(!Z)return{};const{collection:ie,profiles:ee,extension:we}=Z,ue=ee.get(K.profileId);if(!ue)return{};const ae=K.testIds.map(se=>ie.tree.get(se)).filter(M.$1f),H=K.excludeExtIds.map(se=>Z.collection.tree.get(se)).filter(M.$1f).filter(se=>ae.some(ce=>ce.fullId.compare(se.fullId)===2));if(!ae.length)return{};const fe=new o.$BN(ae.some(se=>se.actual instanceof u.$tO)?void 0:ae.map(se=>se.actual),H.map(se=>se.actual),ue,X),he=(0,s.$TK)(K)&&this.j.prepareForMainThreadTestRun(fe,P.fromInternal(K,Z.collection),we,Q);try{return await ue.runHandler(fe,Q),{}}catch(se){return{error:String(se)}}finally{he&&(he.hasRunningTasks&&!Q.isCancellationRequested&&await R.Event.toPromise(he.onEnd),he.dispose())}}$cancelExtensionTestRun(K){K===void 0?this.j.cancelAllRuns():this.j.cancelRunById(K)}};e.$Fjc=h,e.$Fjc=h=Je([He(0,E.$fO),He(1,p.$yj)],h);const g=1e4;var C;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(C||(C={}));class v extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(K,X,Q,Z,ie){super(),this.s=K,this.w=X,this.y=Q,this.z=Z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$5d),this.m=this.B(new R.$5d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new f.$ce(ie));const ee=this.B(new D.$qh(()=>this.C(),g));this.B(this.h.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(K){const X=this.s.id,Q=this.s.controllerId,Z=(0,I.$Ag)(),ie=this.y,ee=this.m;let we;const ue=he=>(se,...ce)=>{if(H){this.z.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.s.isIncluded(se)&&(this.F(se),he(se,...ce))},ae=(he,se)=>{const ce=se instanceof Array?se.map(b.TestMessage.from):[b.TestMessage.from(se)];if(he.uri&&he.range){const le={range:b.Range.from(he.range),uri:he.uri};for(const de of ce)de.location=de.location||le}this.w.$appendTestMessagesInRun(X,Z,i.$RK.fromExtHostTestItem(he,Q).toString(),ce)};let H=!1;const fe={isPersisted:this.s.isPersisted,token:this.h.token,name:K,get coverageProvider(){return we?.provider},set coverageProvider(he){(0,a.$WF)(ie,"testCoverage"),we=he&&new j(he),ee.fire({taskId:Z,runId:X,coverage:we})},enqueued:ue(he=>{this.w.$updateTestStateInRun(X,Z,i.$RK.fromExtHostTestItem(he,Q).toString(),1)}),skipped:ue(he=>{this.w.$updateTestStateInRun(X,Z,i.$RK.fromExtHostTestItem(he,Q).toString(),5)}),started:ue(he=>{this.w.$updateTestStateInRun(X,Z,i.$RK.fromExtHostTestItem(he,Q).toString(),2)}),errored:ue((he,se,ce)=>{ae(he,se),this.w.$updateTestStateInRun(X,Z,i.$RK.fromExtHostTestItem(he,Q).toString(),6,ce)}),failed:ue((he,se,ce)=>{ae(he,se),this.w.$updateTestStateInRun(X,Z,i.$RK.fromExtHostTestItem(he,Q).toString(),4,ce)}),passed:ue((he,se)=>{this.w.$updateTestStateInRun(X,Z,i.$RK.fromExtHostTestItem(he,this.s.controllerId).toString(),3,se)}),appendOutput:(he,se,ce)=>{H||(ce&&(this.s.isIncluded(ce)?this.F(ce):ce=void 0),this.w.$appendOutputToRun(X,Z,O.$se.fromString(he),se&&b.location.from(se),ce&&i.$RK.fromExtHostTestItem(ce,Q).toString()))},end:()=>{H||(H=!0,this.w.$finishedTestRunTask(X,Z),this.f.delete(Z),this.f.size||this.D())}};return this.f.set(Z,{run:fe}),this.w.$startedTestRunTask(X,{id:Z,name:K,running:!0}),fe}C(){for(const{run:K}of this.f.values())K.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(K){if(!(K instanceof u.$sO))throw new n.$0N(K.id);if(this.g.has(i.$RK.fromExtHostTestItem(K,this.s.controllerId).toString()))return;const X=[],Q=this.s.colllection.root;for(;;){const Z=b.TestItem.from(K);if(X.unshift(Z),this.g.has(Z.extId)||(this.g.add(Z.extId),K===Q))break;K=K.parent||Q}this.w.$addTestsToRun(this.s.controllerId,this.s.id,X)}dispose(){this.D(),super.dispose()}}class m{get trackers(){return this.c.values()}constructor(K,X){this.g=K,this.h=X,this.c=new Map,this.f=[]}getCoverageReport(K,X){return this.f.find(Q=>Q.runId===K)?.coverage.get(X)}prepareForMainThreadTestRun(K,X,Q,Z){return this.j(K,X,Q,Z)}cancelRunById(K){for(const X of this.c.values())if(X.id===K){X.cancel();return}}cancelAllRuns(){for(const K of this.c.values())K.cancel()}createTestRun(K,X,Q,Z,ie,ee){const we=this.c.get(Z);if(we)return we.createRun(ie);const ue=P.fromPublic(X,Q,Z,ee),ae=y(Z);this.g.$startedExtensionTestRun({controllerId:X,continuous:!!Z.continuous,profile:ae&&{group:F[ae.kind],id:ae.profileId},exclude:Z.exclude?.map(fe=>i.$RK.fromExtHostTestItem(fe,Q.root.id).toString())??[],id:ue.id,include:Z.include?.map(fe=>i.$RK.fromExtHostTestItem(fe,Q.root.id).toString())??[Q.root.id],persist:ee});const H=this.j(Z,ue,K);return R.Event.once(H.onEnd)(()=>{this.g.$finishedExtensionTestRun(ue.id),H.dispose()}),H.createRun(ie)}j(K,X,Q,Z){const ie=new v(X,this.g,Q,this.h,Z);this.c.set(K,ie);let ee;const we=ie.onDidCoverage(({runId:ue,taskId:ae,coverage:H})=>{ee||(ee={runId:ue,coverage:new Map},this.f.unshift(ee),this.f.length>s.$YK&&this.f.pop()),ee.coverage.set(ae,H),this.g.$signalCoverageAvailable(ue,ae,!!H)});return R.Event.once(ie.onEnd)(()=>{this.c.delete(K),we.dispose()}),ie}}e.$Gjc=m;const y=G=>{if(G.profile){if(!(G.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class P{static fromPublic(K,X,Q,Z){return new P(K,(0,I.$Ag)(),Q.include?.map(ie=>i.$RK.fromExtHostTestItem(ie,K).toString())??[K],Q.exclude?.map(ie=>i.$RK.fromExtHostTestItem(ie,K).toString())??[],Z,X)}static fromInternal(K,X){return new P(K.controllerId,K.runId,K.testIds,K.excludeExtIds,!0,X)}constructor(K,X,Q,Z,ie,ee){this.controllerId=K,this.id=X,this.isPersisted=ie,this.colllection=ee,this.c=Q.map(we=>we+"\0"),this.f=Z.map(we=>we+"\0")}isIncluded(K){const X=i.$RK.fromExtHostTestItem(K,this.controllerId).toString()+"\0";for(const Q of this.f)if(X===Q||X.startsWith(Q))return!1;for(const Q of this.c)if(X===Q||X.startsWith(Q))return!0;return!1}}e.$Hjc=P;class j{constructor(K){this.provider=K}async provideFileCoverage(K){this.c||(this.c=(async()=>this.provider.provideFileCoverage(K))());try{return(await this.c)?.map(b.TestCoverage.fromFile)??[]}catch(X){throw this.c=void 0,X}}async resolveFileCoverage(K,X){const Q=await this.c;let Z=Q?.[K];return!this.provider||!Q||!Z?[]:(Z.detailedCoverage||(Z=Q[K]=await this.provider.resolveFileCoverage?.(Z,X)??Z),Z.detailedCoverage?.map(b.TestCoverage.fromDetailed)??[])}}class U{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(K){this.j=K,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(K){this.c.add(K)}update(K){Object.assign(K.revived,b.TestItem.toPlain(K.item)),this.c.has(K)||this.f.add(K)}remove(K){if(this.c.has(K)){this.c.delete(K);return}this.f.delete(K);const X=i.$RK.parentId(K.item.extId);if(X&&this.h.has(X.toString())){this.h.add(K.item.extId);return}this.g.add(K)}getChangeEvent(){const{c:K,f:X,g:Q}=this;return{get added(){return[...K].map(Z=>Z.revived)},get updated(){return[...X].map(Z=>Z.revived)},get removed(){return[...Q].map(Z=>Z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class z extends s.$ZK{constructor(){super(...arguments),this.s=new R.$5d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(K){return this.f.get(K)}getMirroredTestDataByReference(K){return this.f.get(K.id)}w(K,X){return{...K,revived:b.TestItem.toPlain(K.item),depth:X?X.depth+1:0,children:new Set}}v(){return new U(this.s)}}class N{constructor(K){this.f=K}checkout(){this.c||(this.c=this.g());const K=this.c;return K.observers++,{onDidChangeTest:K.tests.onDidChangeTests,get tests(){return[...K.tests.rootTests].map(X=>X.revived)},dispose:(0,L.$db)(()=>{--K.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(K){return this.c?.tests.getMirroredTestDataByReference(K)}applyDiff(K){this.c?.tests.apply(K)}g(){const K=new z({asCanonicalUri:X=>X});return this.f.$subscribeToDiffs(),{observers:0,tests:K}}}const A=(G,K,X,Q)=>{X?Object.assign(X,Q):K.$updateTestRunConfig(G.controllerId,G.profileId,Q)};class T{get label(){return this.f}set label(K){K!==this.f&&(this.f=K,A(this,qe(this,t,"f"),qe(this,r,"f"),{label:K}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(K){K!==this.g&&(this.g=K,A(this,qe(this,t,"f"),qe(this,r,"f"),{supportsContinuousRun:K}))}get isDefault(){return qe(this,d,"f").has(this.profileId)}set isDefault(K){K!==this.isDefault&&(K?qe(this,d,"f").add(this.profileId):qe(this,d,"f").delete(this.profileId),A(this,qe(this,t,"f"),qe(this,r,"f"),{isDefault:K}))}get tag(){return this._tag}set tag(K){K?.id!==this._tag?.id&&(this._tag=K,A(this,qe(this,t,"f"),qe(this,r,"f"),{tag:K?b.TestTag.namespace(this.controllerId,K.id):null}))}get configureHandler(){return this.c}set configureHandler(K){K!==this.c&&(this.c=K,A(this,qe(this,t,"f"),qe(this,r,"f"),{hasConfigurationHandler:!!K}))}get onDidChangeDefault(){return R.Event.chain(qe(this,l,"f"),K=>K.map(X=>X.get(this.controllerId)?.get(this.profileId)).filter(M.$1f))}constructor(K,X,Q,Z,ie,ee,we,ue,ae,H=!1,fe=void 0,he=!1){this.controllerId=ie,this.profileId=ee,this.f=we,this.kind=ue,this.runHandler=ae,this._tag=fe,this.g=he,t.set(this,void 0),d.set(this,void 0),l.set(this,void 0),r.set(this,void 0),c.set(this,void 0),it(this,t,K,"f"),it(this,c,X,"f"),it(this,d,Q,"f"),it(this,l,Z,"f"),X.set(ee,this);const se=F[ue];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ue}`);H&&Q.add(ee),it(this,r,{profileId:ee,controllerId:ie,tag:fe?b.TestTag.namespace(this.controllerId,fe.id):null,label:we,group:se,isDefault:H,hasConfigurationHandler:!1,supportsContinuousRun:he},"f"),queueMicrotask(()=>{qe(this,r,"f")&&(qe(this,t,"f").$publishTestRunProfile(qe(this,r,"f")),it(this,r,void 0,"f"))})}dispose(){qe(this,c,"f")?.delete(this.profileId)&&(it(this,c,void 0,"f"),qe(this,t,"f").$removeTestProfile(this.controllerId,this.profileId)),it(this,r,void 0,"f")}}e.$Ijc=T,t=new WeakMap,d=new WeakMap,l=new WeakMap,r=new WeakMap,c=new WeakMap;const F={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Se[153],De([1,0,61,14,122,15,7]),function(re,e,D,O,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oO=e.$nO=e.$mO=void 0;class w{constructor(p,S,E){const u=w.c.nextId();p.$registerTextEditorDecorationType(S.identifier,u,R.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:u,dispose(){p.$removeTextEditorDecorationType(u)}})}}e.$mO=w,w.c=new f.$kO("TextEditorDecorationType");class ${constructor(p,S){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,S){this.k();let E=null;if(p instanceof L.$4L)E=new L.$5L(p,p);else if(p instanceof L.$5L)E=p;else throw new Error("Unrecognized location");this.l(E,S,!1)}insert(p,S){this.k(),this.l(new L.$5L(p,p),S,!0)}delete(p){this.k();let S=null;if(p instanceof L.$5L)S=p;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(p,S,E){const u=this.c.validateRange(p);this.g.push({range:u,text:S,forceMoveMarkers:E})}setEndOfLine(p){if(this.k(),p!==L.EndOfLine.LF&&p!==L.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=p}}class k{constructor(p,S,E,u){this.c=p,this.d=S,this._accept(E),this.e=u;const b=this;this.value={get tabSize(){return b.f},set tabSize(o){b.n(o)},get indentSize(){return b.g},set indentSize(o){b.p(o)},get insertSpaces(){return b.j},set insertSpaces(o){b.s(o)},get cursorStyle(){return b.k},set cursorStyle(o){b.t(o)},get lineNumbers(){return b.l},set lineNumbers(o){b.u(o)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}n(p){const S=this.m(p);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}p(p){const S=this.o(p);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const S=this.q(p);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(p)})))}assign(p){const S={};let E=!1;if(typeof p.tabSize<"u"){const u=this.m(p.tabSize);u==="auto"?(E=!0,S.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,E=!0,S.tabSize=u)}if(typeof p.indentSize<"u"){const u=this.o(p.indentSize);u==="tabSize"?(E=!0,S.indentSize=u):typeof u=="number"&&this.h!==u&&(this.g=u,this.h=u,E=!0,S.indentSize=u)}if(typeof p.insertSpaces<"u"){const u=this.q(p.insertSpaces);u==="auto"?(E=!0,S.insertSpaces=u):this.j!==u&&(this.j=u,E=!0,S.insertSpaces=u)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,E=!0,S.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,E=!0,S.lineNumbers=R.TextEditorLineNumbersStyle.from(p.lineNumbers)),E&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(p,S){S.catch(E=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(E)})}}e.$nO=k;class M{constructor(p,S,E,u,b,o,i,n){this.id=p,this.j=S,this.k=E,this.g=!1,this.h=new Set,this.c=b,this.d=new k(this.j,this.id,o,E),this.e=i,this.f=n;const s=this;this.value=Object.freeze({get document(){return u.value},set document(a){throw new O.$9("document")},get selection(){return s.c&&s.c[0]},set selection(a){if(!(a instanceof L.$6L))throw(0,O.$7)("selection");s.c=[a],s.l()},get selections(){return s.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof L.$6L)))throw(0,O.$7)("selections");s.c=a,s.l()},get visibleRanges(){return s.e},set visibleRanges(a){throw new O.$9("visibleRanges")},get options(){return s.d.value},set options(a){s.g||s.d.assign(a)},get viewColumn(){return s.f},set viewColumn(a){throw new O.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new $(u.value,t);return a(d),s.m(d)},insertSnippet(a,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=s.c.map(r=>R.Range.from(r));else if(t instanceof L.$4L){const{lineNumber:r,column:c}=R.Position.from(t);l=[{startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c}]}else if(t instanceof L.$5L)l=[R.Range.from(t)];else{l=[];for(const r of t)if(r instanceof L.$5L)l.push(R.Range.from(r));else{const{lineNumber:c,column:h}=R.Position.from(r);l.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return S.$tryInsertSnippet(p,u.value.version,a.value,l,d)},setDecorations(a,t){const d=t.length===0;d&&!s.h.has(a.key)||(d?s.h.delete(a.key):s.h.add(a.key),s.n(()=>{if(R.$cO(t))return S.$trySetDecorations(p,a.key,R.$dO(t));{const l=new Array(4*t.length);for(let r=0,c=t.length;r<c;r++){const h=t[r];l[4*r]=h.start.line+1,l[4*r+1]=h.start.character+1,l[4*r+2]=h.end.line+1,l[4*r+3]=h.end.character+1}return S.$trySetDecorationsFast(p,a.key,l)}}))},revealRange(a,t){s.n(()=>S.$tryRevealRange(p,R.Range.from(a),t||L.TextEditorRevealType.Default))},show(a){S.$tryShowEditor(p,R.ViewColumn.from(a))},hide(){S.$tryHideEditor(p)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,D.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,D.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,D.ok)(!this.g),this.f=p}_acceptSelections(p){(0,D.ok)(!this.g),this.c=p}async l(){const p=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const S=p.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const E=S.edits.map(b=>b.range);E.sort((b,o)=>b.end.line===o.end.line?b.end.character===o.end.character?b.start.line===o.start.line?b.start.character-o.start.character:b.start.line-o.start.line:b.end.character-o.end.character:b.end.line-o.end.line);for(let b=0,o=E.length-1;b<o;b++){const i=E[b].end;if(E[b+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=S.edits.map(b=>({range:R.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,u,{setEndOfLine:typeof S.setEndOfLine=="number"?R.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$oO=M}),define(Se[72],De([1,0,61,4,3,2,5,6,150,20,153,15,13,28,16,48,44]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=e.$pO=void 0;class o{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(s,a){this.h=s,this.i=a,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new O.$5d,this.e=new O.$5d,this.f=new O.$5d,this.g=new O.$5d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const a=[],t=[],d=[];if(s.removedDocuments)for(const l of s.removedDocuments){const r=R.URI.revive(l),c=this.c.get(r);c?.unref()&&(this.c.delete(r),a.push(c.value))}if(s.addedDocuments)for(const l of s.addedDocuments){const r=R.URI.revive(l.uri);let c=this.c.get(r);if(c&&r.scheme!==E.Schemas.vscodeNotebookCell&&r.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);c||(c=new o(new $.$iO(this.h.getProxy(w.$1L.MainThreadDocuments),r,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty)),this.c.set(r,c),t.push(c.value)),c.ref()}if(s.removedEditors)for(const l of s.removedEditors){const r=this.b.get(l);this.b.delete(l),r&&d.push(r)}if(s.addedEditors)for(const l of s.addedEditors){const r=R.URI.revive(l.documentUri);D.ok(this.c.has(r),`document '${r}' does not exist`),D.ok(!this.b.has(l.id),`editor '${l.id}' already exists!`);const c=this.c.get(r).value,h=new M.$oO(l.id,this.h.getProxy(w.$1L.MainThreadTextEditors),this.i,new b.$V(()=>c.document),l.selections.map(I.Selection.to),l.options,l.visibleRanges.map(g=>I.Range.to(g)),typeof l.editorPosition=="number"?I.ViewColumn.to(l.editorPosition):void 0);this.b.set(l.id,h)}s.newActiveEditor!==void 0&&(D.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,f.$Oc)(a),(0,f.$Oc)(d),s.removedDocuments&&this.e.fire(a),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(l=>l.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return u.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const a=this.b.get(this.a);return s?a:a?.value}allEditors(){return[...this.b.values()]}};e.$pO=i,e.$pO=i=Je([He(0,k.$fO),He(1,p.$yj)],i),e.$qO=(0,L.$ei)("IExtHostDocumentsAndEditors")}),define(Se[347],De([1,0,19,4,6,153,15,7]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class ${constructor(M,I){this.i=I,this.a=new O.$5d,this.b=new O.$5d,this.c=new O.$5d,this.d=new O.$5d,this.f=new O.$5d,this.g=new O.$5d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(f.$1L.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const I=this.i.allEditors();return M?I:I.map(p=>p.value)}async showTextDocument(M,I,p){let S;typeof I=="number"?S={position:L.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?S={position:L.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?L.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:S={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(M.uri,S),u=E&&this.i.getEditor(E);if(u)return u.value;throw E?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,I){return new R.$mO(this.h,M,I).value}$acceptEditorPropertiesChanged(M,I){const p=this.i.getEditor(M);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const S=I.selections.selections.map(L.Selection.to);p._acceptSelections(S)}if(I.visibleRanges){const S=D.$Hb(I.visibleRanges.map(L.Range.to));p._acceptVisibleRanges(S)}if(I.options&&this.b.fire({textEditor:p.value,options:{...I.options,lineNumbers:L.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const S=w.TextEditorSelectionChangeKind.fromValue(I.selections.source),E=I.selections.selections.map(L.Selection.to);this.a.fire({textEditor:p.value,selections:E,kind:S})}if(I.visibleRanges){const S=D.$Hb(I.visibleRanges.map(L.Range.to));this.c.fire({textEditor:p.value,visibleRanges:S})}}$acceptEditorPositionData(M){for(const I in M){const p=this.i.getEditor(I);if(!p)throw new Error("Unknown text editor");const S=L.ViewColumn.to(M[I]);p.value.viewColumn!==S&&(p._acceptViewColumn(S),this.d.fire({textEditor:p.value,viewColumn:S}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.$5hc=$}),define(Se[348],De([1,0,2,5,6,3,7,15,25,18]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,O.$ei)("IExtHostTimeline");class M{constructor(S,E){this.b=new Map,this.c=new Map,this.a=S.getProxy(f.$1L.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(u,b)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&$.$xm.equals(b,this.b.get(u.source)?.extension)){const o=u.uri===void 0?void 0:D.URI.revive(u.uri);return this.c.get(u.source)?.get(I(o))?.get(u.handle)}else return;return u}})}async $getTimeline(S,E,u,b){return this.b.get(S)?.provider.provideTimeline(D.URI.revive(E),u,b)}registerTimelineProvider(S,E,u,b){const o=new R.$Sc,i=this.d(E.id,b,o).bind(this);let n;E.onDidChange&&(n=E.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:E.id}),this));const s=this.c;return this.f({...E,scheme:S,onDidChange:void 0,async provideTimeline(a,t,d){t?.resetCache&&(o.clear(),s.get(E.id)?.clear());const l=await E.provideTimeline(a,t,d);if(l==null)return;const r=i(a,t);return{...l,source:E.id,items:l.items.map(r)}},dispose(){for(const a of s.values())a.get(E.id)?.clear();n?.dispose(),o.dispose()}},u)}d(S,E,u){return(b,o)=>{let i;if(o?.cacheResults){let n=this.c.get(S);n===void 0&&(n=new Map,this.c.set(S,n));const s=I(b);i=n.get(s),i===void 0&&(i=new Map,n.set(s,i))}return n=>{const{iconPath:s,...a}=n,t=`${S}|${n.id??n.timestamp}`;i?.set(t,n);let d,l,r;n.iconPath&&(s instanceof L.$XM?r={id:s.id,color:s.color}:D.URI.isUri(s)?(d=s,l=s):{light:d,dark:l}=s);let c;return L.$rM.isMarkdownString(a.tooltip)?c=w.MarkdownString.from(a.tooltip):(0,k.$Sf)(a.tooltip)?c=a.tooltip:L.$rM.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=w.MarkdownString.from(a.detail)):(0,k.$Sf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:S,command:n.command?E.toInternal(n.command,u):void 0,icon:d,iconDark:l,themeIcon:r,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(S,E){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:E}),(0,R.$Rc)(()=>{for(const b of this.c.values())b.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$Ljc=M;function I(p){return p?.toString()}}),define(Se[349],De([1,0,221,23,2,4,3,279,8,7,18,19,15,79,22,188,26]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;function o(s,a){if((0,M.$Sf)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class i extends L.$Tc{constructor(a,t,d){super(),this.f=a,this.g=t,this.h=d,this.a=new Map,this.b=new u.$I9;function l(r){return r&&r.$treeViewId&&(r.$treeItemHandle||r.$selectedTreeItems||r.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:r=>l(r)?this.r(r):Array.isArray(r)&&r.length>0?r.map(c=>l(c)?this.r(c):c):r})}registerTreeDataProvider(a,t,d){const l=this.createTreeView(a,{treeDataProvider:t},d);return{dispose:()=>l.dispose()}}createTreeView(a,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=t.dragAndDropController?.dropMimeTypes??[],r=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,g=this.m(a,t,d),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:l,dragMimeTypes:r,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(a,C),m={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,b.$WF)(d,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,b.$WF)(d,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(y){(0,S.$uk)(y)&&(0,b.$WF)(d,"treeViewMarkdownMessage"),g.message=y},get title(){return g.title},set title(y){g.title=y},get description(){return g.description},set description(y){g.description=y},get badge(){return g.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?g.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(g.badge=void 0)},reveal:(y,P)=>g.reveal(y,P),dispose:async()=>{await v,this.a.delete(a),g.dispose()}};return this.B(m),m}$getChildren(a,t){const d=this.a.get(a);return d?d.getChildren(t):Promise.reject(new w.$pF(a))}async $handleDrop(a,t,d,l,r,c,h,g){const C=this.a.get(a);if(!C)return Promise.reject(new w.$pF(a));const v=p.DataTransfer.toDataTransfer(d,async m=>(await this.f.$resolveDropFileData(a,t,m)).buffer);return h===a&&g&&await this.j(v,C,g,r,c),C.onDrop(v,l,r)}async j(a,t,d,l,r){const c=this.b.removeDragOperationTransfer(r);if(c)(await c)?.forEach((h,g)=>{h&&a.set(g,h)});else if(r&&t.handleDrag){const h=t.handleDrag(d,a,l);this.b.addDragOperationTransfer(r,h),await h}return a}async $handleDrag(a,t,d,l){const r=this.a.get(a);if(!r)return Promise.reject(new w.$pF(a));const c=await this.j(new k.$UM,r,t,l,d);if(!(!c||l.isCancellationRequested))return p.DataTransfer.from(c)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new w.$pF(a);return t.hasResolve}$resolve(a,t,d){const l=this.a.get(a);if(!l)throw new w.$pF(a);return l.resolveTreeItem(t,d)}$setExpanded(a,t,d){const l=this.a.get(a);if(!l)throw new w.$pF(a);l.setExpanded(t,d)}$setSelectionAndFocus(a,t,d){const l=this.a.get(a);if(!l)throw new w.$pF(a);l.setSelectionAndFocus(t,d)}$setVisible(a,t){const d=this.a.get(a);if(!d){if(!t)return;throw new w.$pF(a)}d.setVisible(t)}$changeCheckboxState(a,t){const d=this.a.get(a);if(!d)throw new w.$pF(a);d.setCheckboxState(t)}m(a,t,d){const l=this.B(new n(a,t,this.f,this.g.converter,this.h,d));return this.a.set(a,l),l}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Mjc=i;class n extends L.$Tc{get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,M.$2f)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,d,l,r,c){if(super(),this.I=a,this.J=d,this.L=l,this.M=r,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$5d),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$5d),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$5d),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$5d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$5d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$5d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$5d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new E.$ce,c.contributes&&c.contributes.views)for(const v in c.contributes.views)for(const m of c.contributes.views[v])m.id===a&&(this.P=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let h,g;const C=R.Event.debounce(this.F.event,(v,m)=>(v||(v={message:!1,elements:[]}),m.element!==!1&&(h||(h=new Promise(y=>g=y),this.G=this.G.then(()=>h)),Array.isArray(m.element)?v.elements.push(...m.element):v.elements.push(m.element)),m.message&&(v.message=!0),v),200,!0);this.B(C(({message:v,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const y=g;return h=null,this.$(m).then(()=>y())})),v&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let d=this.X(a);return d||(d=await this.Y(t)),d?d.map(l=>l.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const d=(0,M.$2f)(t.select)?!0:t.select,l=(0,M.$2f)(t.focus)?!1:t.focus,r=(0,M.$2f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(c=>this.W(a,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(g=>g.item)},{select:d,focus:l,expand:r})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:d,focus:l,expand:r})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=p.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const d=this.getExtensionElement(a);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(a,t){const d=!(0,I.$ub)(this.s,a);this.s=a;const l=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),l&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async d=>{const l=this.getExtensionElement(d.treeItemHandle);return l?{extensionItem:l,treeItem:await this.f.getTreeItem(l),newState:d.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(a,t,d){const l=[];for(const r of a){const c=this.getExtensionElement(r);c&&l.push(c)}if(!(!this.g?.handleDrag||l.length===0))return await this.g.handleDrag(l,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,d){const l=t?this.getExtensionElement(t):void 0;if(!(!l&&t||!this.g?.handleDrop))return(0,$.$9g)(()=>this.g?.handleDrop?this.g.handleDrop(l,a,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(a);if(d){const l=this.m.get(d);if(l){const r=await this.f.resolveTreeItem(l.extensionItem,d,t)??l.extensionItem;return this.hb(r),l.item.tooltip=this.eb(r.tooltip),l.item.command=this.fb(l.disposableStore,r.command),l.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(l=>(d.push(l),d))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$9g)(()=>this.f.getParent(a))}W(a,t){const d=this.m.get(a);return d?Promise.resolve(d):(0,$.$9g)(()=>this.f.getTreeItem(a)).then(l=>this.kb(a,l,t,!0)).then(l=>this.getChildren(t?t.item.handle:void 0).then(()=>{const r=this.getExtensionElement(l);if(r){const c=this.m.get(r);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${l} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const d=this.getExtensionElement(a);t=d?this.m.get(d):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new E.$ce(this.Z.token);try{const d=a?this.m.get(a):void 0,l=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const r=(0,I.$Hb)(l||[]),c=await Promise.all((0,I.$Hb)(r).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const h=c.map((g,C)=>g?this.db(r[C],g,d):null);return(0,I.$Hb)(h)}finally{t.dispose()}}$(a){if(a.some(d=>!d))return this.Z.dispose(!0),this.Z=new E.$ce,this.tb(),this.J.$refresh(this.I);{const d=this.ab(a);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(a){const t=new Set,d=a.map(r=>this.m.get(r));for(const r of d)if(r&&!t.has(r.item.handle)){let c=r;for(;c&&c.parent&&d.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(r.item.handle)}const l=[];return t.forEach(r=>{const c=this.j.get(r);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&l.push(r)}}),l}bb(a){const t={};return Promise.all(a.map(d=>this.cb(d).then(l=>{l&&(t[d]=l.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,$.$9g)(()=>this.f.getTreeItem(t)).then(l=>{if(l){const r=this.ib(t,l,d.parent);return this.pb(t,r,d,d.parent),d.dispose(),r}return null})}return Promise.resolve(null)}db(a,t,d){const l=this.ib(a,t,d);if(t.id&&this.j.has(l.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(a,l),this.qb(l,d),l}eb(a){return k.$rM.isMarkdownString(a)?p.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,d,l;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,d=a.checkboxState.tooltip,l=a.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:l}}hb(a){if(!k.$PM.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,d){this.hb(t);const l=this.B(new L.$Sc),r=this.kb(a,t,d),c=this.lb(t);return{item:{handle:r,parentHandle:d?d.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(l,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,M.$2f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:l,dispose(){l.dispose()}}}jb(a){return a.iconPath instanceof k.$XM?a.iconPath:void 0}kb(a,{id:t,label:d,resourceUri:l},r,c){if(t)return`${n.b}/${t}`;const h=o(d,this.N),g=r?r.item.handle:n.a;let C=h?h.label:l?(0,O.$Og)(l):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const v=this.m.has(a)?this.m.get(a).item.handle:void 0,m=this.X(r)||[];let y,P=0;do{if(y=`${g}/${P}:${C}`,c||!this.j.has(y)||v===y)break;P++}while(P<=m.length);return y}lb(a){if(a.iconPath&&!(a.iconPath instanceof k.$XM))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof k.$XM)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,d,l){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(a,t);const r=this.X(l)||[],c=r.filter(h=>h.item.handle===d.item.handle)[0];c&&r.splice(r.indexOf(c),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const d of t.children){const l=this.j.get(d.item.handle);l&&this.sb(l)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const d of t.children){const l=this.j.get(d.item.handle);l&&this.sb(l)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}n.a="0",n.b="1"});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[350],De([1,0,4,3,2,30,15,92,6,7]),function(re,e,D,O,f,R,L,w,$,k){"use strict";var M,I,p,S,E,u,b,o,i,n,s,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class d extends O.$Tc{constructor(h,g,C,v){super(),M.set(this,void 0),I.set(this,void 0),p.set(this,void 0),S.set(this,void 0),E.set(this,void 0),u.set(this,void 0),b.set(this,void 0),o.set(this,void 0),i.set(this,!0),n.set(this,void 0),s.set(this,!1),a.set(this,this.B(new D.$5d)),this.onDidDispose=qe(this,a,"f").event,t.set(this,this.B(new D.$5d)),this.onDidChangeViewState=qe(this,t,"f").event,it(this,M,h,"f"),it(this,I,g,"f"),it(this,S,C,"f"),it(this,p,v.viewType,"f"),it(this,E,v.panelOptions,"f"),it(this,o,v.viewColumn,"f"),it(this,u,v.title,"f"),it(this,n,v.active,"f")}dispose(){qe(this,s,"f")||(it(this,s,!0,"f"),qe(this,a,"f").fire(),qe(this,I,"f").$disposeWebview(qe(this,M,"f")),qe(this,S,"f").dispose(),super.dispose())}get webview(){return this.c(),qe(this,S,"f")}get viewType(){return this.c(),qe(this,p,"f")}get title(){return this.c(),qe(this,u,"f")}set title(h){this.c(),qe(this,u,"f")!==h&&(it(this,u,h,"f"),qe(this,I,"f").$setTitle(qe(this,M,"f"),h))}get iconPath(){return this.c(),qe(this,b,"f")}set iconPath(h){this.c(),qe(this,b,"f")!==h&&(it(this,b,h,"f"),qe(this,I,"f").$setIconPath(qe(this,M,"f"),f.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return qe(this,E,"f")}get viewColumn(){if(this.c(),!(typeof qe(this,o,"f")=="number"&&qe(this,o,"f")<0))return qe(this,o,"f")}get active(){return this.c(),qe(this,n,"f")}get visible(){return this.c(),qe(this,i,"f")}_updateViewState(h){qe(this,s,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(it(this,n,h.active,"f"),it(this,i,h.visible,"f"),it(this,o,h.viewColumn,"f"),qe(this,t,"f").fire({webviewPanel:this}))}reveal(h,g){this.c(),qe(this,I,"f").$reveal(qe(this,M,"f"),{viewColumn:typeof h>"u"?void 0:L.ViewColumn.from(h),preserveFocus:!!g})}c(){if(qe(this,s,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,I=new WeakMap,p=new WeakMap,S=new WeakMap,E=new WeakMap,u=new WeakMap,b=new WeakMap,o=new WeakMap,i=new WeakMap,n=new WeakMap,s=new WeakMap,a=new WeakMap,t=new WeakMap;class l extends O.$Tc{static c(){return(0,R.$Ag)()}constructor(h,g,C){super(),this.j=g,this.m=C,this.g=new Map,this.h=new Map,this.f=h.getProxy($.$1L.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(h=>h.dispose()),this.g.clear()}createWebviewPanel(h,g,C,v,m={}){const y=typeof v=="object"?v.viewColumn:v,P={viewColumn:L.ViewColumn.from(y),preserveFocus:typeof v=="object"&&!!v.preserveFocus},j=(0,w.$hic)(h),U=l.c();this.f.$createWebviewPanel((0,w.$jic)(h),U,g,{title:C,panelOptions:r(m),webviewOptions:(0,w.$kic)(h,this.m,m),serializeBuffersForPostMessage:j},P);const z=this.j.createNewWebview(U,m,h);return this.createNewWebviewPanel(U,g,C,y,m,z,!0)}$onDidChangeWebviewPanelViewStates(h){const g=Object.keys(h);g.sort((C,v)=>{const m=h[C],y=h[v];return m.active?1:y.active?-1:+m.visible-+y.visible});for(const C of g){const v=this.getWebviewPanel(C);if(!v)continue;const m=h[C];v._updateViewState({active:m.active,visible:m.visible,viewColumn:L.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this.g.delete(h),this.j.deleteWebview(h)}registerWebviewPanelSerializer(h,g,C){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:C,extension:h}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,w.$hic)(h)}),new k.$3L(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(h,g,C,v){const m=this.h.get(g);if(!m)throw new Error(`No serializer found for '${g}'`);const{serializer:y,extension:P}=m,j=this.j.createNewWebview(h,C.webviewOptions,P),U=this.createNewWebviewPanel(h,g,C.title,v,C.panelOptions,j,C.active);await y.deserializeWebviewPanel(U,C.state)}createNewWebviewPanel(h,g,C,v,m,y,P){const j=new d(h,this.f,y,{viewType:g,title:C,viewColumn:v,panelOptions:m,active:P});return this.g.set(h,j),j}getWebviewPanel(h){return this.g.get(h)}}e.$lic=l;function r(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[351],De([1,0,4,3,92,15,6,7]),function(re,e,D,O,f,R,L,w){"use strict";var $,k,M,I,p,S,E,u,b,o,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;class n extends O.$Tc{constructor(t,d,l,r,c,h){super(),$.set(this,void 0),k.set(this,void 0),M.set(this,void 0),I.set(this,void 0),p.set(this,!1),S.set(this,void 0),E.set(this,void 0),u.set(this,void 0),b.set(this,void 0),o.set(this,this.B(new D.$5d)),this.onDidChangeVisibility=qe(this,o,"f").event,i.set(this,this.B(new D.$5d)),this.onDidDispose=qe(this,i,"f").event,it(this,M,l,"f"),it(this,E,r,"f"),it(this,$,t,"f"),it(this,k,d,"f"),it(this,I,c,"f"),it(this,S,h,"f")}dispose(){qe(this,p,"f")||(it(this,p,!0,"f"),qe(this,i,"f").fire(),qe(this,I,"f").dispose(),super.dispose())}get title(){return this.a(),qe(this,E,"f")}set title(t){this.a(),qe(this,E,"f")!==t&&(it(this,E,t,"f"),qe(this,k,"f").$setWebviewViewTitle(qe(this,$,"f"),t))}get description(){return this.a(),qe(this,u,"f")}set description(t){this.a(),qe(this,u,"f")!==t&&(it(this,u,t,"f"),qe(this,k,"f").$setWebviewViewDescription(qe(this,$,"f"),t))}get visible(){return qe(this,S,"f")}get webview(){return qe(this,I,"f")}get viewType(){return qe(this,M,"f")}_setVisible(t){t===qe(this,S,"f")||qe(this,p,"f")||(it(this,S,t,"f"),qe(this,o,"f").fire())}get badge(){return this.a(),qe(this,b,"f")}set badge(t){this.a(),!(t?.value===qe(this,b,"f")?.value&&t?.tooltip===qe(this,b,"f")?.tooltip)&&(it(this,b,R.ViewBadge.from(t),"f"),qe(this,k,"f").$setWebviewViewBadge(qe(this,$,"f"),t))}show(t){this.a(),qe(this,k,"f").$show(qe(this,$,"f"),!!t)}a(){if(qe(this,p,"f"))throw new Error("Webview is disposed")}}$=new WeakMap,k=new WeakMap,M=new WeakMap,I=new WeakMap,p=new WeakMap,S=new WeakMap,E=new WeakMap,u=new WeakMap,b=new WeakMap,o=new WeakMap,i=new WeakMap;class s{constructor(t,d){this.d=d,this.b=new Map,this.c=new Map,this.a=t.getProxy(L.$1L.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,l,r){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:l,extension:t}),this.a.$registerWebviewViewProvider((0,f.$jic)(t),d,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$hic)(t)}),new w.$3L(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,l,r,c){const h=this.b.get(d);if(!h)throw new Error(`No view provider found for '${d}'`);const{provider:g,extension:C}=h,v=this.d.createNewWebview(t,{},C),m=new n(t,this.a,d,l,v,!0);this.c.set(t,m),await g.resolveWebviewView(m,{state:r},c)}async $onDidChangeWebviewViewVisibility(t,d){this.e(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.e(t);this.c.delete(t),d.dispose(),this.d.deleteWebview(t)}e(t){const d=this.c.get(t);if(!d)throw new Error("No webview found");return d}}e.$Pjc=s}),define(Se[352],De([1,0,69,16,13,251,32,9]),function(re,e,D,O,f,R,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;let $=class{constructor(I,p){I.addFileSystemProvider(O.Schemas.file,new k(p),{isCaseSensitive:w.$e})}};e.$ukc=$,e.$ukc=$=Je([He(0,D.$dic),He(1,f.$yj)],$);class k{constructor(I){this.b=I,this.a=new R.$Nq(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,S){return this.a.writeFile(I,p,{...S,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,S){return this.a.rename(I,p,S)}copy(I,p,S){return this.a.copy(I,p,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(Se[353],De([1,0,17,62,30,33,3,6,2,20]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;let M=class extends L.$Tc{constructor(p,S){super();const E=p.getProxy(w.$1L.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async u=>{const b=$.URI.file((0,D.$jc)((0,O.tmpdir)(),(0,f.$Ag)()));return await E.$download(u,b),b})}};e.$skc=M,e.$skc=M=Je([He(0,k.$fO),He(1,R.$BO)],M)}),define(Se[354],De([1,0,57,17,2,93,3,16,8,31]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;class M extends R.$fic{constructor(){super(...arguments),this.i=null}async g(t){const d=await super.g(t);if(d.scheme!==w.Schemas.file)return d;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const l=d.fsPath;let r=0;do{let c;r===0?c=l:c=/[/\\]$/.test(l)?`${l.substr(0,l.length-1)}-${r}`:`${l}-${r}`,await I(c);const h=O.$jc(c,"vscode.lock"),g=await u(this.d,h,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),f.URI.file(c);r++}while(r<10);return d}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Ekc=M;async function I(a){try{await k.Promises.stat(a);return}catch{}try{await k.Promises.mkdir(a,{recursive:!0})}catch{}}const p=1e3,S=10*60*1e3;class E extends L.$Tc{constructor(t,d){super(),this.b=t,this.c=d,this.a=this.B(new $.$ph),this.a.cancelAndSet(async()=>{const l=await b(t,d);(!l||l.pid!==process.pid)&&(t.info(`Lock '${d}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(d,new Date,new Date)}catch(r){t.error(r),t.info(`Lock '${d}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(d),{flag:"w"})}catch(d){this.b.error(d)}}}async function u(a,t,d){try{const r={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(r),{flag:"wx"})}catch(r){a.error(r)}const l=await b(a,t);return!l||l.pid!==process.pid?d?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new E(a,t))}async function b(a,t){let d;try{d=await k.Promises.readFile(t)}catch(l){return a.error(l),null}try{return JSON.parse(String(d))}catch(l){return a.error(l),null}}async function o(a,t){let d;try{d=await k.Promises.stat(t)}catch(l){return a.error(l),0}return d.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const d=await b(a,t);if(!d)return a.info(`Lock '${t}': Could not read pid of lock holder.`),s(a,t);if(d.willReleaseAt){let g=d.willReleaseAt-Date.now();if(g<5e3){for(g>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,$.$fh)(Math.min(100,g)),await o(a,t)===0)return s(a,t);g=d.willReleaseAt-Date.now()}return s(a,t)}}if(!i(d.pid))return a.info(`Lock '${t}': The pid ${d.pid} appears to be gone.`),s(a,t);const l=await o(a,t),r=Date.now()-l;if(r<=S)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$fh)(2e3);const c=await o(a,t),h=Date.now()-c;return h<=S?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(a,t))}async function s(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return u(a,t,!0)}}),define(Se[355],De([1,0,30,20,46,33]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;let L=class extends f.$Bic{constructor($,k){super(!0,$,k)}createTerminal($,k,M){return this.createTerminalFromOptions({name:$,shellPath:k,shellArgs:M})}createTerminalFromOptions($,k){const M=new f.$Aic(this.a,(0,D.$Ag)(),$,$.name);return this.f.push(M),M.create($,this.R($,k)),M.value}};e.$Zjc=L,e.$Zjc=L=Je([He(0,R.$BO),He(1,O.$fO)],L)}),define(Se[356],De([1,0,4,37,45,5]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.OutputChannelUpdateMode=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=void 0,e.$_K="text/x-code-output",e.$aL="output",e.$bL="Log",e.$cL="text/x-code-log-output",e.$dL="log",e.$eL="workbench.panel.output",e.$fL=new f.$vj("inOutput",!1),e.$gL=new f.$vj("activeLogOutput",!1),e.$hL=new f.$vj("outputView.scrollLock",!1),e.$iL=(0,R.$ei)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$jL={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new D.$5d,this.onDidRegisterChannel=this.b.event,this.c=new D.$5d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(M=>k.push(M)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}O.$Un.add(e.$jL.OutputChannels,new w),e.$kL=new f.$vj("activeOutputChannel","")}),define(Se[154],De([1,0,6,5,20,25,13,356,69,27,59,193,21,18,32,4,3]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=e.$qjc=void 0;class o extends L.$Ej{get disposed(){return this.n}constructor(a,t,d,l,r){super(),this.id=a,this.name=t,this.r=d,this.s=l,this.extension=r,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=p.$se.fromString(t).byteLength,(0,L.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,d,l,r,c){this.i=t,this.j=d,this.k=l,this.l=r,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(D.$1L.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$Jm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(a,t,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const l=typeof t=="object"&&t.log,r=(0,S.$Sf)(t)?t:void 0;if((0,S.$Sf)(r)&&!r.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([C])=>R.$xm.equals(d.identifier,C))?.[1];h&&(c=(0,L.$Oj)(h));const g=l?this.o(a,c,d):this.n(a,r,d);return g.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),l?this.r(a,c??this.m.getLevel(),g):this.q(a,g)}async n(a,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const l=await this.c,r=this.k.extUri.joinPath(l,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(r,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,r,t,d.identifier.value);return new o(h,a,c,this.a,d)}async o(a,t,d){const l=await this.p(d),r=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(l,`${r}.log`),h=`${d.identifier.value}.${r}`,g=this.l.createLogger(c,{id:h,name:a,logLevel:t,extensionId:d.identifier.value});return new i(h,a,g,this.a,d)}p(a){let t=this.d.get(a.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(l){if((0,E.$Rk)(l)!==E.FileSystemProviderErrorCode.FileExists)throw l}return d})())}return t}q(a,t){let d=!1;const l=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return a},append(r){l(),t.then(c=>c.append(r))},appendLine(r){l(),t.then(c=>c.appendLine(r))},clear(){l(),t.then(r=>r.clear())},replace(r){l(),t.then(c=>c.replace(r))},show(r,c){l(),t.then(h=>h.show(r,c))},hide(){l(),t.then(r=>r.hide())},dispose(){d=!0,t.then(r=>r.dispose())}}}r(a,t,d){const l=new b.$Sc,r=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},c=l.add(new u.$5d);function h(g){t=g,c.fire(g)}return d.then(g=>{l.add(g),g.logLevel!==t&&h(g.logLevel),l.add(g.onDidChangeLogLevel(C=>h(C)))}),{...this.q(a,d),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(g,...C){r(),d.then(v=>v.trace(g,...C))},debug(g,...C){r(),d.then(v=>v.debug(g,...C))},info(g,...C){r(),d.then(v=>v.info(g,...C))},warn(g,...C){r(),d.then(v=>v.warn(g,...C))},error(g,...C){r(),d.then(v=>v.error(g,...C))},dispose(){l.dispose()}}}};e.$qjc=n,e.$qjc=n=Je([He(0,f.$fO),He(1,k.$vO),He(2,$.$dic),He(3,M.$Rhc),He(4,L.$zj),He(5,L.$yj)],n),e.$rjc=(0,O.$ei)("IExtHostOutputService")}),define(Se[155],De([1,0,5,8]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$Ym=(0,D.$ei)("remoteAgentService"),e.$Zm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let R=1/0;for(let w=0;w<this.maxSampleCount;w++){const $=await f.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,O.$fh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((w,$)=>w+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((w,$)=>w+$,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[357],De([1,0,225,86,37,42,52,3,4,155,9,24,8]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=void 0,e.$HI=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$II=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$JI=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$KI=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$LI={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new $.$5d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const E=new S;f.$Un.add(e.$LI.ConfigurationMigration,E);let u=class extends w.$Tc{constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async s=>{for(const a of s.added)await this.f(a,E.migrations)})),this.c(E.migrations),this.B(E.onDidRegisterConfigurationMigration(s=>this.c(s)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(s=>this.g(s,i?.uri))])}async g(i,n){const s=this.a.inspect(i.key,{resource:n}),a=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of a){const l=s[t];if(!l)continue;const r=[];if(l.value!==void 0){const c=await this.h(i,t,l.value,n,void 0);for(const h of c??[])r.push([h,[]])}for(const{identifiers:c,value:h}of l.overrides??[])if(h!==void 0){const g=await this.h(i,t,h,n,c);for(const C of g??[])r.push([C,c])}r.length&&await Promise.allSettled(r.map(async([[c,h],g])=>this.a.updateValue(c,h.value,{resource:n,overrideIdentifiers:g},d)))}}async h(i,n,s,a,t){const d=r=>{const h=this.a.inspect(r,{resource:a})[n];if(h)return t?h.overrides?.find(({identifiers:g})=>(0,I.$Mn)(g,t))?.value:h.value},l=await i.migrateFn(s,d);return Array.isArray(l)?l:[[i.key,l]]}};e.$MI=u,u.ID="workbench.contrib.configurationMigration",e.$MI=u=Je([He(0,L.$Ki),He(1,R.$ni)],u);let b=class extends w.$Tc{constructor(i){super(),this.b=i,this.a=new p.$Bh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!M.$c&&(await this.b.getEnvironment())?.os!==1)return;f.$Un.as(O.$Zn.Configuration).registerConfiguration({...e.$JI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})}};e.$NI=b,b.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$NI=b=Je([He(0,k.$Ym)],b)}),define(Se[358],De([1,0,35,16,17,23,234,357,86,5,37]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7eb=e.$6eb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$5eb=e.$4eb=void 0,e.$4eb=(0,k.$ei)("editorResolverService"),e.$5eb="workbench.editorAssociations";const I=M.$Un.as($.$Zn.Configuration),p={...w.$II,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(p);var S;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(S||(e.RegisteredEditorPriority=S={}));var E;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(E||(e.ResolvedStatus=E={}));function u(o){switch(o){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}e.$6eb=u;function b(o,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,R.$Og)(i);return D.$Wj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$7eb=b}),define(Se[359],De([1,0,34,16,17,9,23,2,5,269,42,145,155]),function(re,e,D,O,f,R,L,w,$,k,M,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=void 0,e.$CL=(0,$.$ei)("pathService");let E=S=class{constructor(b,o,i,n){this.d=b,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??b})()}hasValidBasename(b,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(b,n,o)):this.h(b,o,i)}h(b,o,i){return b.scheme===O.Schemas.file||b.scheme===O.Schemas.vscodeRemote?(0,D.$dg)(i??(0,L.$Og)(b),o===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(b,o){if(b.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,k.$zL)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const s=o.getWorkspace().configuration;return s?s.scheme:O.Schemas.file}userHome(b){return b?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(b=>b===1?f.$fc:f.$gc)}async fileURI(b){let o="";if(await this.a===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const n=b.indexOf("/",2);n===-1?(o=b.substring(2),b="/"):(o=b.substring(2,n),b=b.substring(n)||"/")}return w.URI.from({scheme:O.Schemas.file,authority:o,path:b,query:"",fragment:""})}};e.$DL=E,e.$DL=E=S=Je([He(1,p.$Ym),He(2,I.$lL),He(3,M.$ni)],E)}),define(Se[360],De([1,0,236,19,53,4,54,3,2,52,241,13,64,271,88,42,145,26,22,18,24,45]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=e.$vL=e.$uL=e.OnPortForward=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.TunnelSource=e.TunnelCloseReason=e.$oL=e.$nL=e.$mL=void 0;const t=10*1e3,d="remote.tunnels.toRestore",l="remote.tunnels.toRestoreExpiration",r=1e3*60*60*24*14;e.$mL="onTunnel",e.$nL=new a.$vj("forwardedPortsViewEnabled",!1,D.localize(0,null));function c(z){const N=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.$oL=c;var h;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var g;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$pL={source:g.User,description:D.localize(1,null)},e.$qL={source:g.Auto,description:D.localize(2,null)};function C(z,N,A){const T=z.get(m(N,A));if(T)return T;if((0,E.$Sv)(N))for(const F of E.$Rv){const G=m(F,A);if(z.has(G))return z.get(G)}else if((0,E.$Uv)(N))for(const F of E.$Tv){const G=m(F,A);if(z.has(G))return z.get(G)}}e.$rL=C;function v(z,N,A){const T=C(z,N,A);if(T)return T;const F=(0,E.$Uv)(N)?"localhost":(0,E.$Sv)(N)?"0.0.0.0":void 0;if(F)return C(z,F,A)}e.$sL=v;function m(z,N){return z+":"+N}e.$tL=m;var y;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(y||(e.OnPortForward=y={}));function P(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$uL=P;class j extends w.$Tc{constructor(N){super(),this.r=N,this.j=[],this.n=new R.$5d,this.onDidChangeAttributes=this.n.event,this.B(N.onDidChangeConfiguration(A=>{(A.affectsConfiguration(j.c)||A.affectsConfiguration(j.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(N,A,T){let F=this.w(N,A,T,this.j,0);const G={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const K=this.j[F];K.key===N?(G.onAutoForward=K.onAutoForward??G.onAutoForward,G.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:G.elevateIfNeeded,G.label=K.label??G.label,G.requireLocalPort=K.requireLocalPort,G.protocol=K.protocol):(G.onAutoForward=G.onAutoForward??K.onAutoForward,G.elevateIfNeeded=G.elevateIfNeeded!==void 0?G.elevateIfNeeded:K.elevateIfNeeded,G.label=G.label??K.label,G.requireLocalPort=G.requireLocalPort!==void 0?G.requireLocalPort:void 0,G.protocol=G.protocol??K.protocol),F=this.w(N,A,T,this.j,F+1)}return G.onAutoForward!==void 0||G.elevateIfNeeded!==void 0||G.label!==void 0||G.requireLocalPort!==void 0||G.protocol!==void 0?G:this.C()}t(N){return N.start!==void 0&&N.end!==void 0}u(N){return N.host!==void 0&&N.port!==void 0&&(0,n.$Sf)(N.host)&&(0,n.$Wf)(N.port)}w(N,A,T,F,G){if(G>=F.length)return-1;const K=!(0,E.$Sv)(A)&&!(0,E.$Uv)(A),Q=F.slice(G).findIndex(Z=>(0,n.$Wf)(Z.key)?K?!1:Z.key===N:this.t(Z.key)?K?!1:N>=Z.key.start&&N<=Z.key.end:this.u(Z.key)?N===Z.key.port&&A===Z.key.host:T?Z.key.test(T):!1);return Q>=0?Q+G:-1}y(){const N=this.r.getValue(j.c);if(!N||!(0,n.$Uf)(N))return[];const A=[];for(const F in N){if(F===void 0)continue;const G=N[F];let K;if(Number(F))K=Number(F);else if((0,n.$Sf)(F))if(j.g.test(F)){const X=F.match(j.g);K={start:Number(X[1]),end:Number(X[2])}}else if(j.h.test(F)){const X=F.match(j.h);K={host:X[1],port:Number(X[2])}}else{let X;try{X=RegExp(F)}catch{}X&&(K=X)}K&&A.push({key:K,elevateIfNeeded:G.elevateIfNeeded,onAutoForward:G.onAutoForward,label:G.label,requireLocalPort:G.requireLocalPort,protocol:G.protocol})}const T=this.r.getValue(j.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(A)}z(N){function A(T,F){return(0,n.$Wf)(T.key)?T.key:F.t(T.key)?T.key.start:F.u(T.key)?T.key.port:Number.MAX_VALUE}return N.sort((T,F)=>A(T,this)-A(F,this))}C(){return this.m}static providedActionToAction(N){switch(N){case E.ProvidedOnAutoForward.Notify:return y.Notify;case E.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case E.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case E.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case E.ProvidedOnAutoForward.Silent:return y.Silent;case E.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(N,A,T){const G=this.r.inspect(j.c).userRemoteValue;let K;!G||!(0,n.$Uf)(G)?K={}:K=(0,s.$In)(G),K[`${N}`]||(K[`${N}`]={});for(const X in A)K[`${N}`][X]=A[X];return this.r.updateValue(j.c,K,T)}}e.$vL=j,j.c="remote.portsAttributes",j.f="remote.otherPortsAttributes",j.g=/^(\d+)\-(\d+)$/,j.h=/^([a-z0-9\-]+):(\d{1,5})$/;let U=class extends w.$Tc{constructor(N,A,T,F,G,K,X,Q,Z,ie){super(),this.H=N,this.I=A,this.J=T,this.L=F,this.M=G,this.N=K,this.O=X,this.P=Q,this.Q=Z,this.R=ie,this.c=new Map,this.g=new R.$5d,this.onForwardPort=this.g.event,this.h=new R.$5d,this.onClosePort=this.h.event,this.j=new R.$5d,this.onPortName=this.j.event,this.n=new R.$5d,this.onCandidatesChanged=this.n.event,this.t=new R.$5d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$5d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new j(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const we=await this.getAttributes(ee.map(ue=>({port:ue.tunnelRemotePort,host:ue.tunnelRemoteHost})));for(const ue of ee)if(ue.localAddress){const ae=m(ue.tunnelRemoteHost,ue.tunnelRemotePort),H=v(this.m??new Map,ue.tunnelRemoteHost,ue.tunnelRemotePort);this.forwarded.set(ae,{remotePort:ue.tunnelRemotePort,remoteHost:ue.tunnelRemoteHost,localAddress:ue.localAddress,protocol:we?.get(ue.tunnelRemotePort)?.protocol??E.TunnelProtocol.Http,localUri:await this.X(ue.localAddress,we?.get(ue.tunnelRemotePort)),localPort:ue.tunnelLocalPort,runningProcess:H?.detail,hasRunningProcess:!!H,pid:H?.pid,privacy:ue.privacy,source:e.$pL}),this.f.set(ae,ue)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const we=m(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!v(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!v(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!v(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ue=v(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),ae=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(we,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:ae?.protocol??E.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,ae),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ue?.detail,hasRunningProcess:!!ue,pid:ue?.pid,privacy:ee.privacy,source:e.$pL})}await this.cb(),this.f.set(we,ee),this.g.fire(this.forwarded.get(we))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,h.Other))),this.U()}S(){return this.Q.extensions.find(N=>N.activationEvents?.includes(e.$mL))?(this.R.createKey(e.$nL.key,!0),!0):!1}U(){if(this.S())return;const N=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&N.dispose()}))}async W(N,A){const T=m(N.host,N.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(N))}X(N,A){if(N.startsWith("http"))return $.URI.parse(N);const T=A?.protocol??"http";return $.URI.parse(`${T}://${N}`)}async Y(N){const A=this.N.getWorkspace(),T=A.configuration?(0,L.$5i)(A.configuration.path):A.folders.length>0?(0,L.$5i)(A.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${N}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(d)}async $(){return this.Y(l)}async ab(){const N=this.I.get(d,1);if(N)return this.I.remove(d,1),await this.cb(),N;const A=await this.Z();if(A)return this.I.get(A,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const N=await this.s;if(N&&N!==this.y){const A=JSON.parse(N)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${A.map(T=>T.remotePort).join(", ")}`);for(const T of A){const F=v(this.detected,T.remoteHost,T.remotePort);T.source.source!==g.Extension&&!F||T.source.source===g.Extension&&F?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===g.Extension&&!F&&this.D.set(m(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const N=await this.Z();this.w=this.B(new w.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async A=>{A.key===N&&(this.s=Promise.resolve(this.I.get(N,0)),await this.restoreForwarded())}))}}bb(){const N=this.I.keys(0,0).filter(A=>A.startsWith(l));for(const A of N){const T=this.I.getNumber(A,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const F=A.replace(l,d);this.I.remove(A,0),this.I.remove(F,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=Array.from(this.forwarded.values()),A=N.map(K=>({remoteHost:K.remoteHost,remotePort:K.remotePort,localPort:K.localPort,name:K.name,localAddress:K.localAddress,localUri:K.localUri,protocol:K.protocol,source:K.source}));let T;N.length>0&&(T=JSON.stringify(A));const F=await this.Z(),G=await this.$();!T&&F&&G?(this.I.remove(F,0),this.I.remove(G,0)):T!==this.y&&F&&G&&(this.I.store(F,T,0,0),this.I.store(G,Date.now()+r,0,0)),this.y=T}}async eb(N,A,T){if(!N.tunnelLocalPort||!T?.requireLocalPort||N.tunnelLocalPort===A)return;const F=new Date;if(this.db.getTime()+t>F.getTime())return;this.db=F;const G=D.localize(3,null,A,N.tunnelRemotePort,N.tunnelLocalPort);return this.P.info(G)}async forward(N,A){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(N,A)}async fb(N,A){await this.Q.activateByEvent(e.$mL);const T=v(this.forwarded,N.remote.host,N.remote.port);A=A??(A!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const F=N.local!==void 0?N.local:N.remote.port;let G;if(T)return this.hb(T,N,A);{const K=this.L.remoteAuthority,X=K?{getAddress:async()=>(await this.M.resolveAuthority(K)).authority}:void 0,Q=m(N.remote.host,N.remote.port);this.c.set(Q,!0),N=this.gb(Q,N);const Z=await this.H.openTunnel(X,N.remote.host,N.remote.port,void 0,F,N.elevateIfNeeded?N.elevateIfNeeded:A?.elevateIfNeeded,N.privacy,A?.protocol);if(typeof Z=="string")G=Z;else if(Z&&Z.localAddress){const ie=v(this.m??new Map,N.remote.host,N.remote.port),ee=Z.protocol?Z.protocol===E.TunnelProtocol.Https?E.TunnelProtocol.Https:E.TunnelProtocol.Http:A?.protocol??E.TunnelProtocol.Http,we={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:A?.label??N.name,closeable:!0,localAddress:Z.localAddress,protocol:ee,localUri:await this.X(Z.localAddress,A),runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,source:N.source??e.$pL,privacy:Z.privacy};return this.forwarded.set(Q,we),this.f.set(Q,Z),this.c.delete(Q),await this.cb(),await this.eb(Z,F,A),this.g.fire(we),Z}this.c.delete(Q)}return G}gb(N,A){const T=this.D.has(N)?this.D:this.F.has(N)?this.F:void 0;if(T){const F=T.get(N);T.delete(N),F&&(A.name=F.name??A.name,A.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??A.local,A.privacy=A.privacy)}return A}async hb(N,A,T){const F=T?.label??A.name;let G;(function(X){X[X.None=0]="None",X[X.Fire=1]="Fire",X[X.Reopen=2]="Reopen"})(G||(G={}));let K=G.None;switch(F!==N.name&&(N.name=F,K=G.Fire),(T?.protocol||N.protocol!==E.TunnelProtocol.Http)&&T?.protocol!==N.protocol&&(A.source=N.source,K=G.Reopen),A.privacy&&N.privacy!==A.privacy&&(K=G.Reopen),K){case G.Fire:{this.g.fire();break}case G.Reopen:await this.close(N.remoteHost,N.remotePort,h.User),await this.fb(A,T)}return v(this.f,A.remote.host,A.remote.port)}async name(N,A,T){const F=v(this.forwarded,N,A),G=m(N,A);if(F){F.name=T,await this.cb(),this.j.fire({host:N,port:A});return}else this.detected.has(G)&&(this.detected.get(G).name=T,this.j.fire({host:N,port:A}))}async close(N,A,T){const F=m(N,A),G=this.forwarded.get(F);return T===h.AutoForwardEnd&&G&&G.source.source===g.Auto&&this.F.set(F,{local:G.localPort,name:G.name,privacy:G.privacy}),await this.H.closeTunnel(N,A),this.W({host:N,port:A},T)}address(N,A){const T=m(N,A);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(N){if(N)for(const A of N){const T=v(this.m??new Map,A.remoteAddress.host,A.remoteAddress.port),F=typeof A.localAddress=="string"?A.localAddress:m(A.localAddress.host,A.localAddress.port);this.detected.set(m(A.remoteAddress.host,A.remoteAddress.port),{remoteHost:A.remoteAddress.host,remotePort:A.remoteAddress.port,localAddress:F,protocol:E.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:E.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(A.remoteAddress.host,A.remoteAddress.port,F,E.TunnelPrivacyId.ConstantPrivate,E.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(N){this.r=N}async setCandidates(N){let A=N;this.r&&(A=await this.r(N));const T=this.ib(A);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(F=>F.port).join(", ")}`),this.n.fire(T)}ib(N){const A=this.m??new Map,T=new Map;return this.m=T,N.forEach(F=>{const G=m(F.host,F.port);T.set(G,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),A.has(G)&&A.delete(G);const K=v(this.forwarded,F.host,F.port);K&&(K.runningProcess=F.detail,K.hasRunningProcess=!0,K.pid=F.pid)}),A.forEach((F,G)=>{const K=c(G);if(!K)return;const X=v(this.forwarded,K.host,K.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0);const Q=v(this.detected,K.host,K.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0)}),A}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const N=Array.from(this.forwarded.values()),A=await this.getAttributes(N.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(A)for(const T of N){const F=A.get(T.remotePort);(F?.protocol||T.protocol!==E.TunnelProtocol.Http)&&F?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},F),F&&F.label&&F.label!==T.name&&await this.name(T.remoteHost,T.remotePort,F.label)}}async getAttributes(N,A=!0){const T=new Map,F=new Map;N.forEach(Z=>{const ie=v(this.m??new Map,E.$Rv[0],Z.port)??Z;if(ie){T.set(Z.port,ie);const ee=P(ie)?ie.pid:void 0;F.has(ee)||F.set(ee,[]),F.get(ee)?.push(Z.port)}});const G=new Map;if(N.forEach(Z=>{const ie=this.configPortsAttributes.getAttributes(Z.port,Z.host,T.get(Z.port)?.detail);ie&&G.set(Z.port,ie)}),this.G.length===0||!A)return G.size>0?G:void 0;const K=await Promise.all((0,O.$Rb)(this.G.map(Z=>Array.from(F.entries()).map(ie=>{const ee=ie[1],we=T.get(ee[0]);return Z.providePortAttributes(ee,we?.pid,we?.detail,new i.$ce().token)})))),X=new Map;if(K.forEach(Z=>Z.forEach(ie=>{ie&&X.set(ie.port,ie)})),!G&&!X)return;const Q=new Map;return N.forEach(Z=>{const ie=G.get(Z.port),ee=X.get(Z.port);Q.set(Z.port,{elevateIfNeeded:ie?.elevateIfNeeded,label:ie?.label,onAutoForward:ie?.onAutoForward??j.providedActionToAction(ee?.autoForwardAction),requireLocalPort:ie?.requireLocalPort,protocol:ie?.protocol})}),Q}addAttributesProvider(N){this.G.push(N)}};e.$wL=U,Je([(0,f.$Jh)(1e3)],U.prototype,"cb",null),e.$wL=U=Je([He(0,E.$Nv),He(1,S.$Gp),He(2,k.$Ki),He(3,b.$lL),He(4,p.$gl),He(5,u.$ni),He(6,I.$yj),He(7,M.$gw),He(8,o.$SF),He(9,a.$wj)],U)}),define(Se[94],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$eK=e.$dK=void 0;class D{constructor(L,w){this.line=L,this.character=w}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,w){return new D(0,0)}with(L){return new D(0,0)}}e.$dK=D;class O{constructor(L,w,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(L,w),this.end=new D($,k)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new O(0,0,0,0)}with(L){return new O(0,0,0,0)}}e.$eK=O;var f;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(Se[36],De([1,0,19,35,24,34,12,5,17,14,94,8]),function(re,e,D,O,f,R,L,w,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.SearchErrorCode=e.$tK=e.$sK=e.SearchSortOrder=e.ViewMode=e.$rK=e.$qK=e.$pK=e.$oK=e.SearchCompletionExitCode=e.$nK=e.$mK=e.$lK=e.QueryType=e.SearchProviderType=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$fK="workbench.view.search",e.$gK="workbench.panel.search",e.$hK="workbench.view.search",e.$iK="search-result",e.$jK="search.exclude";const p="\u27EA ",S=" characters skipped \u27EB",E=(p.length+S.length+5)*2;e.$kK=(0,w.$ei)("searchService");var u;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(u||(e.SearchProviderType=u={}));var b;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(b||(e.QueryType=b={}));function o(Z){return!!Z.preview}e.$lK=o;function i(Z){return!!Z.resource}e.$mK=i;function n(Z){return!!Z.message}e.$nK=n;var s;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class a{constructor(ie){this.resource=ie,this.results=[]}}e.$oK=a;class t{constructor(ie,ee,we,ue){this.ranges=ee,this.webviewIndex=ue;const ae=Array.isArray(ee)?ee:[ee];if(we&&we.matchLines===1&&d(ae)){ie=(0,L.$Lf)(ie,we.matchLines);let H="",fe=0,he=0;const se=Math.floor(we.charsPerLine/5),ce=[];for(const le of ae){const de=Math.max(le.startColumn-se,0),q=le.startColumn+we.charsPerLine;if(de>he+se+E){const _=p+(de-he)+S;H+=_+ie.slice(de,q),fe+=de-(he+_.length)}else H+=ie.slice(he,q);ce.push(new r(0,le.startColumn-fe,le.endColumn-fe)),he=q}this.preview={text:H,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const H=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ie,matches:(0,D.$2b)(ee,fe=>new l(fe.startLineNumber-H,fe.startColumn,fe.endLineNumber-H,fe.endColumn))}}}}e.$pK=t;function d(Z){const ie=Z[0].startLineNumber;for(const ee of Z)if(ee.startLineNumber!==ie||ee.endLineNumber!==ie)return!1;return!0}class l{constructor(ie,ee,we,ue){this.startLineNumber=ie,this.startColumn=ee,this.endLineNumber=we,this.endColumn=ue}}e.$qK=l;class r extends l{constructor(ie,ee,we){super(ie,ee,ie,we)}}e.$rK=r;var c;(function(Z){Z.List="list",Z.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function g(Z,ie=!0){const ee=Z&&Z.files&&Z.files.exclude,we=ie&&Z&&Z.search&&Z.search.exclude;if(!ee&&!we)return;if(!ee||!we)return ee||we;let ue=Object.create(null);return ue=f.$Ln(ue,f.$In(ee)),ue=f.$Ln(ue,f.$In(we),!0),ue}e.$sK=g;function C(Z,ie){return Z.excludePattern&&O.$Wj(Z.excludePattern,ie)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&O.$Wj(Z.includePattern,ie)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(ee=>{const we=ee.folder.fsPath;if(R.$fg(ie,we)){const ue=$.$lc(we,ie);return!ee.includePattern||!!O.$Wj(ee.includePattern,ue)}else return!1}):!1:!0}e.$tK=C;var v;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class m extends Error{constructor(ie,ee){super(ie),this.code=ee}}e.$uK=m;function y(Z){const ie=Z.message;if((0,k.$4)(Z))return new m(ie,v.canceled);try{const ee=JSON.parse(ie);return new m(ee.message,ee.code)}catch{return new m(ie,v.other)}}e.$vK=y;function P(Z){const ie={message:Z.message,code:Z.code};return new Error(JSON.stringify(ie))}e.$wK=P;function j(Z){return Z.type==="error"?!0:Z.type==="success"}e.$xK=j;function U(Z){return Z.type==="success"}e.$yK=U;function z(Z){return!!Z.path}e.$zK=z;function N(Z,ie,ee=!0){const we=Z.searchPath?Z.searchPath:Z.relativePath;return ee?(0,L.$If)(we,ie):O.$Wj(ie,we)}e.$AK=N;class A{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$BK=A;function T(Z,ie){const ee={...Z||{},...ie||{}};return Object.keys(ee).filter(we=>{const ue=ee[we];return typeof ue=="boolean"&&ue})}e.$CK=T;class F{constructor(ie,ee){this.c=null,this.a={...ie.excludePattern||{},...ee.excludePattern||{}},this.b=O.$Xj(this.a);let we=ie.includePattern;ee.includePattern&&(we?we={...we,...ee.includePattern}:we=ee.includePattern),we&&(this.c=O.$Xj(we))}matchesExcludesSync(ie,ee,we){return!!(this.b&&this.b(ie,ee,we))}includedInQuerySync(ie,ee,we){return!(this.b&&this.b(ie,ee,we)||this.c&&!this.c(ie,ee,we))}includedInQuery(ie,ee,we){const ue=this.b(ie,ee,we),ae=()=>this.c?!!this.c(ie,ee,we):!0;return(0,I.$3g)(ue)?ue.then(H=>H?!1:ae()):ae()}hasSiblingExcludeClauses(){return G(this.a)}}e.$DK=F;function G(Z){for(const ie in Z)if(typeof Z[ie]!="boolean")return!0;return!1}function K(Z){if(!Z)return;let ie;return ee=>(ie||(ie=(Z()||Promise.resolve([])).then(we=>we?Q(we):{})),ie.then(we=>!!we[ee]))}e.$EK=K;function X(Z){if(!Z)return;let ie;return ee=>{if(!ie){const we=Z();ie=we?Q(we):{}}return!!ie[ee]}}e.$FK=X;function Q(Z){const ie={};for(const ee of Z)ie[ee]=!0;return ie}}),define(Se[38],De([1,0,19,8,22,4,3,77,16,123,23,12,2,223,5,13,254,42,59,27,20,15,7,66,36,6,56]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d,l,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=e.$0hc=void 0;function h(U,z,N){return new M.$Gg(A=>m(A,N)).isEqual(U,z)}function g(U,z,N){return h(U.uri,z.uri,N)?0:(0,I.$cf)(U.uri.toString(),z.uri.toString())}function C(U,z,N){return U.index!==z.index?U.index<z.index?-1:1:h(U.uri,z.uri,N)?(0,I.$cf)(U.name,z.name):(0,I.$cf)(U.uri.toString(),z.uri.toString())}function v(U,z,N,A){const T=U.slice(0).sort((G,K)=>N(G,K,A)),F=z.slice(0).sort((G,K)=>N(G,K,A));return(0,D.$Eb)(T,F,(G,K)=>N(G,K,A))}function m(U,z){const N=z.getCapabilities(U.scheme);return!(N&&N&1024)}class y extends o.$xi{static toExtHostWorkspace(z,N,A,T){if(!z)return{workspace:null,added:[],removed:[]};const{id:F,name:G,folders:K,configuration:X,transient:Q,isUntitled:Z}=z,ie=[],ee=N;N?K.forEach((H,fe)=>{const he=p.URI.revive(H.uri),se=y.o(A||N,he,T);se?(se.name=H.name,se.index=H.index,ie.push(se)):ie.push({uri:he,name:H.name,index:fe})}):ie.push(...K.map(({uri:H,name:fe,index:he})=>({uri:p.URI.revive(H),name:fe,index:he}))),ie.sort((H,fe)=>H.index<fe.index?-1:1);const we=new y(F,G,ie,!!Q,X?p.URI.revive(X):null,!!Z,H=>m(H,T)),{added:ue,removed:ae}=v(ee?ee.workspaceFolders:[],we.workspaceFolders,g,T);return{workspace:we,added:ue,removed:ae}}static o(z,N,A){for(let T=0;T<z.folders.length;T++){const F=z.workspaceFolders[T];if(h(F.uri,N,A))return F}}constructor(z,N,A,T,F,G,K){super(z,A.map(X=>new o.$yi(X)),T,F,K),this.t=N,this.u=G,this.q=[],this.s=w.$ki.forUris(K),A.forEach(X=>{this.q.push(X),this.s.set(X.uri,X)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,N){return N&&this.s.get(z)&&(z=(0,M.$Qg)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let P=class{constructor(z,N,A,T,F){this.c=new R.$5d,this.onDidChangeWorkspace=this.c.event,this.g=new R.$5d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$7d,this.C=new Map,this.h=T,this.s=A,this.t=F,this.j=new k.$im,this.k=new O.$dh,this.o=z.getProxy(r.$1L.MainThreadWorkspace),this.q=z.getProxy(r.$1L.MainThreadMessageService);const G=N.workspace;this.l=G?new y(G.id,G.name,[],!!G.transient,G.configuration?p.URI.revive(G.configuration):null,!!G.isUntitled,K=>m(K,A)):void 0}$initializeWorkspace(z,N){this.v=N,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,M.$Og)((0,M.$Qg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,N,A,...T){const F=[];if(Array.isArray(T)&&T.forEach(Z=>{p.URI.isUri(Z.uri)&&!F.some(ie=>h(ie.uri,Z.uri,this.s))&&F.push({uri:Z.uri,name:Z.name||(0,M.$Ng)(Z.uri)})}),this.n||[N,A].some(Z=>typeof Z!="number"||Z<0)||A===0&&F.length===0)return!1;const G=this.x?this.x.workspaceFolders:[];if(N+A>G.length)return!1;const K=G.slice(0);K.splice(N,A,...F.map(Z=>({uri:Z.uri,name:Z.name||(0,M.$Ng)(Z.uri),index:void 0})));for(let Z=0;Z<K.length;Z++){const ie=K[Z];if(K.some((ee,we)=>we!==Z&&h(ie.uri,ee.uri,this.s)))return!1}K.forEach((Z,ie)=>Z.index=ie);const{added:X,removed:Q}=v(G,K,C,this.s);if(X.length===0&&Q.length===0)return!1;if(this.o){const Z=z.displayName||z.name;this.o.$updateWorkspaceFolders(Z,N,A,F).then(void 0,ie=>{this.n=void 0;const ee={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(b.Severity.Error,(0,S.localize)(0,null,Z,ie.toString()),ee,[])})}return this.y(K),!0}getWorkspaceFolder(z,N){if(this.x)return this.x.getWorkspaceFolder(z,N)}async getWorkspaceFolder2(z,N){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,N)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,N){let A,T="";if(typeof z=="string"?(A=p.URI.file(z),T=z):typeof z<"u"&&(A=z,T=z.fsPath),!A)return T;const F=this.getWorkspaceFolder(A,!0);if(!F)return T;typeof N>"u"&&this.x&&(N=this.x.folders.length>1);let G=(0,M.$Tg)(F.uri,A);return N&&F.name&&(G=`${F.name}/${G}`),G}y(z){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:N,added:A,removed:T}=y.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=N||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:T}))}findFiles(z,N,A,T,F=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let G="",K=!0;return N===null?K=!1:N!==void 0&&(typeof N=="string"?G=N:G=N.pattern),this.z(z,void 0,{exclude:G,maxResults:A,useDefaultExcludes:K,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},F)}findFiles2(z,N={},A,T=f.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,z,N,T)}async z(z,N,A,T=f.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const F=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,G={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:F,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let K;if(z){const{includePattern:X,folder:Q}=j(a.GlobPattern.from(z));K=Q,G.includePattern=X}else{const{includePattern:X,folder:Q}=j(a.GlobPattern.from(N));K=Q,G.filePattern=X}return this.o.$startFileSearch(K??null,G,T).then(X=>Array.isArray(X)?X.map(Q=>p.URI.revive(Q)):[])}async findTextInFiles(z,N,A,T,F=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const G=this.j.getNext(),K=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:X,folder:Q}=j(a.GlobPattern.from(N.include)),Z=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ie={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:K,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:X,excludePattern:Z},ee=!1;if(this.u[G]=we=>{if(ee)return;const ue=p.URI.revive(we.resource);we.results.forEach(ae=>{const H=(0,c.$Nh)(ae);(0,l.$lK)(H)?A({uri:ue,preview:{text:H.preview.text,matches:(0,D.$2b)(H.preview.matches,fe=>new t.$5L(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,D.$2b)(H.ranges,fe=>new t.$5L(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):A({uri:ue,text:H.text,lineNumber:H.lineNumber})})},F.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(z,Q??null,ie,G,F);return delete this.u[G],we||{}}catch(we){throw delete this.u[G],we}}$handleTextSearchResult(z,N){this.u[N]?.(z)}async save(z){const N=await this.o.$save(z,{saveAs:!1});return p.URI.revive(N)}async saveAs(z){const N=await this.o.$save(z,{saveAs:!0});return p.URI.revive(N)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,N){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,N);const A=this.t.transformOutgoingScheme(z),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,A),(0,L.$Rc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(z,N){this.h.info("Getting edit session identifier for workspaceFolder",z);const A=await this.resolveWorkspaceFolder(p.URI.revive(z));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const T=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!T),!T)return;const F=await T.provideEditSessionIdentity(A,N);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(z,N,A,T){this.h.info("Getting edit session identifier for workspaceFolder",z);const F=await this.resolveWorkspaceFolder(p.URI.revive(z));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const G=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!G),!G)return;const K=await G.provideEditSessionIdentityMatch?.(N,A,T);if(this.h.info("Provider returned edit session identifier match result: ",K),!!K)return K}getOnWillCreateEditSessionIdentityEvent(z){return(N,A,T)=>{const F=function(K){N.call(A,K)};return F.extension=z,this.B.event(F,void 0,T)}}async $onWillCreateEditSessionIdentity(z,N,A){const T=await this.resolveWorkspaceFolder(p.URI.revive(z));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},N,async(F,G)=>{const K=Date.now();await Promise.resolve(F),Date.now()-K>A&&this.h.warn("SLOW edit session create-participant",G.extension.identifier)}),N.isCancellationRequested}registerCanonicalUriProvider(z,N){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,N);const A=this.t.transformOutgoingScheme(z),T=this.A++;return this.o.$registerCanonicalUriProvider(T,A),(0,L.$Rc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(z,N,A){const T=this.C.get(z.scheme);if(!T)return;const F=await T.provideCanonicalUri?.(p.URI.revive(z),N,A);if(F)return F}async $provideCanonicalUri(z,N,A){return this.provideCanonicalUri(p.URI.revive(z),{targetScheme:N},A)}};e.$0hc=P,e.$0hc=P=Je([He(0,s.$fO),He(1,n.$vO),He(2,i.$Rhc),He(3,u.$yj),He(4,d.$8hc)],P),e.$$hc=(0,E.$ei)("IExtHostWorkspace");function j(U){let z,N;return U&&(typeof U=="string"?z=U:(z=U.pattern,N=p.URI.revive(U.baseUri))),{includePattern:z,folder:N}}}),define(Se[43],De([1,0,24,4,38,6,7,256,86,18,8,5,20,13,2]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=e.$_hc=void 0;function u(d,l){if(l){const r=l.split(".");let c=d;for(let h=0;c&&h<r.length;h++)c=c[r[h]];return c}}function b(d){return d instanceof E.URI}function o(d){return d&&d.uri instanceof E.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&d.uri instanceof E.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function s(d){if(b(d))return{resource:d};if(o(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(n(d))return{resource:d.uri};if(d===null)return{resource:null}}let a=class{constructor(l,r,c){this.a=l.getProxy(R.$1L.MainThreadConfiguration),this.c=r,this.b=c,this.d=new M.$dh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new t(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,r){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(l,r))}};e.$_hc=a,e.$_hc=a=Je([He(0,p.$fO),He(1,f.$$hc),He(2,S.$yj)],a);class t{constructor(l,r,c,h){this.a=new O.$5d,this.b=l,this.f=h,this.c=r,this.e=w.$go.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,r){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$go.parse(l),this.d=this.k(l.configurationScopes),this.a.fire(this.j(r,c))}getConfiguration(l,r,c){const h=s(r)||{},g=this.g(l?u(this.e.getValue(void 0,h,this.c.workspace),l):this.e.getValue(void 0,h,this.c.workspace));l&&this.h(l,h,c?.identifier);function C(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(m){return typeof u(g,m)<"u"},get:(m,y)=>{this.h(l?`${l}.${m}`:m,h,c?.identifier);let P=u(g,m);if(typeof P>"u")P=y;else{let j;const U=(z,N)=>{if((0,k.$Uf)(z)){let A;const T=()=>{j=j||(0,D.$In)(g),A=A||u(j,N)};return new Proxy(z,{get:(F,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return T(),()=>A;if(j)return A=A||u(j,N),A[G];const K=F[G];return typeof G=="string"?U(K,`${N}.${G}`):K},set:(F,G,K)=>(T(),A&&(A[G]=K),!0),deleteProperty:(F,G)=>(T(),A&&delete A[G],!0),defineProperty:(F,G,K)=>(T(),A&&Object.defineProperty(A,G,K),!0)})}return Array.isArray(z)?(0,D.$In)(z):z};P=U(P,m)}return P},update:(m,y,P,j)=>{m=l?`${l}.${m}`:m;const U=C(P);return y!==void 0?this.b.$updateConfigurationOption(U,m,y,h,j):this.b.$removeConfigurationOption(U,m,h,j)},inspect:m=>{m=l?`${l}.${m}`:m;const y=this.e.inspect(m,h,this.c.workspace);if(y)return{key:m,defaultValue:(0,D.$In)(y.policy?.value??y.default?.value),globalValue:(0,D.$In)(y.user?.value??y.application?.value),workspaceValue:(0,D.$In)(y.workspace?.value),workspaceFolderValue:(0,D.$In)(y.workspaceFolder?.value),defaultLanguageValue:(0,D.$In)(y.default?.override),globalLanguageValue:(0,D.$In)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,D.$In)(y.workspace?.override),workspaceFolderLanguageValue:(0,D.$In)(y.workspaceFolder?.override),languageIds:(0,D.$In)(y.overrideIdentifiers)}}};return typeof g=="object"&&(0,D.$Ln)(v,g,!1),Object.freeze(v)}g(l){const r=c=>(0,k.$Uf)(c)?new Proxy(c,{get:(h,g)=>r(h[g]),set:(h,g,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return r(l)}h(l,r,c){const h=$.$0n.test(l)?4:this.d.get(l),g=c?`[${c.value}] `:"";if(h===4){typeof r?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){r?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,r){const c=new w.$io(l,r,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,g)=>c.affectsConfiguration(h,s(g))})}k(l){return l.reduce((r,c)=>(r.set(c[0],c[1]),r),new Map)}}e.$aic=t,e.$bic=(0,I.$ei)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[95],De([1,0,2,8,4,6,7,38,72,43,22,46,20,27,5,16,9,13,91,297,14]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=e.$Cjc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(z){function N(T){if(T!=null)return T}z.from=N;function A(T){if(T!=null)return T}z.to=A})(t||(t={}));var d;(function(z){function N(T){if(T!=null)return T}z.from=N;function A(T){if(T!=null)return T}z.to=A})(d||(d={}));var l;(function(z){function N(T){if(T!=null)return T}z.from=N;function A(T){if(T!=null)return T}z.to=A})(l||(l={}));var r;(function(z){function N(F){if(F){const G=F;return G&&!!G.process}else return!1}z.is=N;function A(F){if(F==null)return;const G={process:F.process,args:F.args};return F.options&&(G.options=l.from(F.options)),G}z.from=A;function T(F){if(F!=null)return new L.$LM(F.process,F.args,F.options)}z.to=T})(r||(r={}));var c;(function(z){function N(T){if(T!=null)return T}z.from=N;function A(T){if(T!=null)return T}z.to=A})(c||(c={}));var h;(function(z){function N(F){if(F){const G=F;return G&&(!!G.commandLine||!!G.command)}else return!1}z.is=N;function A(F){if(F==null)return;const G={};return F.commandLine!==void 0?G.commandLine=F.commandLine:(G.command=F.command,G.args=F.args),F.options&&(G.options=c.from(F.options)),G}z.from=A;function T(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new L.$MM(F.commandLine,F.options):new L.$MM(F.command,F.args?F.args:[],F.options)}z.to=T})(h||(h={}));var g;(function(z){function N(F){if(F){const G=F;return G&&G.customExecution==="customExecution"}else return!1}z.is=N;function A(F){return{customExecution:"customExecution"}}z.from=A;function T(F,G){return G.get(F)}z.to=T})(g||(e.CustomExecutionDTO=g={}));var C;(function(z){function N(A,T){let F;return A.scope!==void 0&&typeof A.scope!="number"?F=A.scope.uri:A.scope!==void 0&&typeof A.scope=="number"&&(A.scope===L.TaskScope.Workspace&&T&&T.workspaceFile?F=T.workspaceFile:F=n.$eH),{id:A._id,workspaceFolder:F}}z.from=N})(C||(e.TaskHandleDTO=C={}));var v;(function(z){function N(A){if(A!=null)return{_id:A.id,isDefault:A.isDefault}}z.from=N})(v||(v={}));var m;(function(z){function N(F,G){if(F==null)return[];const K=[];for(const X of F){const Q=A(X,G);Q&&K.push(Q)}return K}z.fromMany=N;function A(F,G){if(F==null)return;let K;F.execution instanceof L.$LM?K=r.from(F.execution):F.execution instanceof L.$MM?K=h.from(F.execution):F.execution&&F.execution instanceof L.$NM&&(K=g.from(F.execution));const X=t.from(F.definition);let Q;return F.scope?typeof F.scope=="number"?Q=F.scope:Q=F.scope.uri:Q=L.TaskScope.Workspace,!X||!Q?void 0:{_id:F._id,definition:X,name:F.name,source:{extensionId:G.identifier.value,label:F.source,scope:Q},execution:K,isBackground:F.isBackground,group:v.from(F.group),presentationOptions:d.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}z.from=A;async function T(F,G,K){if(F==null)return;let X;r.is(F.execution)?X=r.to(F.execution):h.is(F.execution)?X=h.to(F.execution):g.is(F.execution)&&(X=g.to(F._id,K));const Q=t.to(F.definition);let Z;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Z=F.source.scope:Z=await G.resolveWorkspaceFolder(D.URI.revive(F.source.scope)):Z=L.TaskScope.Workspace),!Q||!Z)return;const ie=new L.$OM(Q,Z,F.name,F.source.label,X,F.problemMatchers);return F.isBackground!==void 0&&(ie.isBackground=F.isBackground),F.group!==void 0&&(ie.group=L.$KM.from(F.group._id),ie.group&&F.group.isDefault&&(ie.group=new L.$KM(ie.group.id,ie.group.label),F.group.isDefault===!0&&(ie.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ie.presentationOptions=d.to(F.presentationOptions)),F._id&&(ie._id=F._id),F.detail&&(ie.detail=F.detail),ie}z.to=T})(m||(e.TaskDTO=m={}));var y;(function(z){function N(T){return T}z.from=N;function A(T){if(T)return Object.assign(Object.create(null),T)}z.to=A})(y||(y={}));class P{constructor(N,A,T){this._id=A,this.a=T,a.set(this,void 0),it(this,a,N,"f")}get task(){return this.a}terminate(){qe(this,a,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}a=new WeakMap;let j=class{constructor(N,A,T,F,G,K,X,Q){this.q=new f.$5d,this.r=new f.$5d,this.s=new f.$5d,this.u=new f.$5d,this.a=N.getProxy(R.$1L.MainThreadTask),this.b=T,this.c=F,this.d=G,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=X,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,A,T){if(!T)return new L.$3L(()=>{});const F=this.x();return this.j.set(F,{type:A,provider:T,extension:N}),this.a.$registerTaskProvider(F,A),new L.$3L(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(N,A){this.a.$registerTaskSystem(N,A)}fetchTasks(N){return this.a.$fetchTasks(y.from(N)).then(async A=>{const T=[];for(const F of A){const G=await m.to(F,this.b,this.m);G&&T.push(G)}return T})}get taskExecutions(){const N=[];return this.k.forEach(A=>N.push(A)),N}terminateTask(N){if(!(N instanceof P))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,A,T){const F=this.m.get(N.id);F&&(this.o.set(N.id,F),this.e.attachPtyToTerminal(A,await F.callback(T))),this.p=N.id,this.q.fire({execution:await this.z(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){if(!this.l.has(N.id))return;const A=await this.z(N);this.l.delete(N.id),this.k.delete(N.id),this.B(N),this.r.fire({execution:A})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const A=await this.z(N.id);this.s.fire({execution:A,processId:N.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(N){const A=await this.z(N.id);this.u.fire({execution:A,exitCode:N.exitCode})}$provideTasks(N,A){const T=this.j.get(N);if(!T)return Promise.reject(new Error("no handler found"));const F=[],G=(0,O.$9g)(()=>T.provider.provideTasks(M.CancellationToken.None)).then(K=>this.v(A,F,T,K));return new Promise(K=>{G.then(X=>{Promise.all(F).then(()=>{K(X)})})})}async $resolveTask(N,A){const T=this.j.get(N);if(!T)return Promise.reject(new Error("no handler found"));if(A.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${A.definition.type}] cannot be resolved by provider of type [${T.type}].`);const F=await m.to(A,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const G=await T.provider.resolveTask(F,M.CancellationToken.None);if(!G)return;this.A(G,T);const K=m.from(G,T.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(K.execution)&&await this.y(K,G,!0),await this.w(K)}x(){return this.h++}async y(N,A,T){const F=await this.a.$createTaskId(N);!T&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,A.execution)),this.m.set(F,A.execution)}async z(N,A){if(typeof N=="string"){const G=this.l.get(N);if(!G)throw new s.$bb("Unexpected: The specified task is missing an execution");return G}const T=this.l.get(N.id);if(T)return T;let F;return A?F=Promise.resolve(new P(this,N.id,A)):F=m.to(N.task,this.b,this.m).then(G=>{if(!G)throw new s.$bb("Unexpected: Task does not exist.");return new P(this,N.id,G)}),this.l.set(N.id,F),F.then(G=>(this.k.set(N.id,G),G))}A(N,A){N._deprecated&&this.g.report("Task.constructor",A.extension,"Use the Task constructor that takes a `scope` instead.")}B(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const T=this.n.values();let F=T.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=T.next()}};e.$Cjc=j,e.$Cjc=j=Je([He(0,p.$fO),He(1,S.$vO),He(2,w.$$hc),He(3,$.$qO),He(4,k.$bic),He(5,I.$zic),He(6,o.$yj),He(7,i.$Nhc)],j);let U=class extends j{constructor(N,A,T,F,G,K,X,Q){super(N,A,T,F,G,K,X,Q),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:b.$b(0)})}async executeTask(N,A){if(!A.execution)throw new Error("Tasks to execute must include an execution");const T=m.from(A,N);if(T===void 0)throw new Error("Task is not valid");if(g.is(T.execution))await this.y(T,A,!1);else throw new s.$_;const F=await this.z(await this.a.$getTaskExecution(T),A);return this.a.$executeTask(T).catch(G=>{throw new Error(G)}),F}v(N,A,T,F){const G=[];if(F)for(const K of F){if(this.A(K,T),!K.definition||!N[K.definition.type]){const Q=K.source?K.source:"No task source";this.f.warn(`The task [${Q}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const X=m.from(K,T.extension);X&&g.is(X.execution)?(G.push(X),A.push(this.y(X,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:T.extension}}async w(N){if(g.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,A){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,A,T){}};e.$Djc=U,e.$Djc=U=Je([He(0,p.$fO),He(1,S.$vO),He(2,w.$$hc),He(3,$.$qO),He(4,k.$bic),He(5,I.$zic),He(6,o.$yj),He(7,i.$Nhc)],U),e.$Ejc=(0,E.$ei)("IExtHostTask")}),define(Se[361],De([1,0,36,29]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.$LK=void 0;function f(L){return"cellResults"in L}e.$LK=f,e.$MK="rawCell#";function R(L,w){let $=-1;const k=[];let M=[];return L.forEach(p=>{p.range.startLineNumber!==$&&M.length>0&&(k.push([...M]),M=[]),M.push(p),$=p.range.endLineNumber}),M.length>0&&k.push([...M]),k.map(p=>{const S=[],E=p[0].range.startLineNumber,u=p[p.length-1].range.endLineNumber;for(let b=E;b<=u;b++)S.push(w.getLineContent(b));return new D.$pK(S.join(`
`)+`
`,p.map(b=>new O.$7s(b.range.startLineNumber-1,b.range.startColumn-1,b.range.endLineNumber-1,b.range.endColumn-1)))})}e.$NK=R}),define(Se[362],De([1,0,217,21,4,3,28,12,18,2,32,110,6,33,15,7,68,332,151,24,16,287,361,358]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,h,g,C,v,m){this.q=g,this.r=C,this.s=v,this.t=m,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new f.$5d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$5d,this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$5d,this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$5d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Lhc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=c.getProxy(p.$1L.MainThreadNotebook),this.c=c.getProxy(p.$1L.MainThreadNotebookDocuments),this.d=c.getProxy(p.$1L.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,j=y.cell.handle,z=this.g.get(P)?.getCell(j);if(z)return z.apiCell}if(y&&y.$mid===14){const P=y.uri,j=this.g.get(P);if(j)return j.apiNotebook}return y}}),l.B(h)}getEditorById(c){const h=this.h.get(c);if(!h)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(c){for(const[h,g]of this.h)if(g.apiEditor===c)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,h){const g=this.g.get(c);if(!g&&!h)throw new Error(`NO notebook document for '${c}'`);return g}static u(c,h){if(!h)return;const g=h.filenamePattern.map(C=>E.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(h.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:h.displayName,filenamePattern:g,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,h,g){const C=l.a++,v=typeof g.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(C,g),this.b.$registerNotebookCellStatusBarItemProvider(C,v,h);let m;return v!==void 0&&(m=g.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(v))),new u.$3L(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,v),m?.dispose()})}async createNotebookDocument(c){const h=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&E.NotebookData.from(c.content)});return k.URI.revive(h)}async openNotebookDocument(c){const h=this.g.get(c);if(h)return h.apiNotebook;const g=await this.c.$tryOpenNotebook(c),C=this.g.get(k.URI.revive(g));return(0,$.$4f)(C?.apiNotebook)}async showNotebookDocument(c,h){k.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let g;typeof h=="object"?g={position:E.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(E.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,g),v=C&&this.h.get(C)?.apiEditor;if(v)return v;throw C?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,h,g,C){const v=this.f.get(c),m=k.URI.revive(h),y=this.g.get(m);if(!y||!v)return;const P=y.getCellFromIndex(g);if(!P)return;const j=await v.provideCellStatusBarItems(P.apiCell,C);if(!j)return;const U=new R.$Sc,z=this.p.add([U]),A=(Array.isArray(j)?j:[j]).map(T=>E.NotebookStatusBarItem.from(T,this.i,U));return{cacheId:z,items:A}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,h,g,C,v){if((0,w.$Se)(h))throw new Error("viewType cannot be empty or just whitespace");const m=this.w++;return this.x.set(m,{viewType:h,serializer:g,options:C}),this.b.$registerNotebookSerializer(m,{id:c.identifier,location:c.extensionLocation},h,E.NotebookDocumentContentOptions.from(C),l.u(c,v)),(0,R.$Rc)(()=>{this.b.$unregisterNotebookSerializer(m)})}async $dataToNotebook(c,h,g){const C=this.x.get(c);if(!C)throw new Error("NO serializer found");const v=await C.serializer.deserializeNotebook(h.buffer,g);return new b.$7v(E.NotebookData.from(v))}async $notebookToData(c,h,g){const C=this.x.get(c);if(!C)throw new Error("NO serializer found");const v=await C.serializer.serializeNotebook(E.NotebookData.to(h.value),g);return O.$se.wrap(v)}async $saveNotebook(c,h,g,C,v){const m=k.URI.revive(h),y=this.x.get(c);if(!y)throw new Error("NO serializer found");const P=this.g.get(m);if(!P)throw new Error("Document NOT found");if(P.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(m.scheme))throw new M.$Wk((0,D.localize)(0,null,this.z(m)),6);await this.y(m,C);const j={metadata:(0,n.$Qn)(P.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of P.apiNotebook.getCells()){const F=new u.$rN(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);F.metadata=(0,n.$Qn)(T.metadata,G=>!(y.options?.transientCellMetadata??{})[G]),j.cells.push(F)}const U=await y.serializer.serializeNotebook(j,v);await this.s.value.writeFile(m,U);const z=this.s.getFileSystemProviderExtUri(m.scheme),N=await this.s.value.stat(m);return{name:z.basename(m),isFile:(N.type&M.FileType.File)!==0,isDirectory:(N.type&M.FileType.Directory)!==0,isSymbolicLink:(N.type&M.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(m.scheme),locked:!!((N.permissions??0)&M.FilePermission.Locked),etag:M.$8k({mtime:N.mtime,size:N.size}),children:void 0}}async $searchInNotebooks(c,h,g,C,v){const m=this.x.get(c)?.serializer;if(!m)return{limitHit:!1,results:[]};const y=new L.$Bc;await(async(N,A,T)=>{await Promise.all(N.map(async F=>await Promise.all(F.filenamePatterns.map(G=>{const K={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:G};return this.t.doInternalFileSearchWithCustomCallback(K,A,X=>{X.forEach(Q=>{y.has(Q)||C.some(ie=>F.isFromSettings&&!ie.isFromSettings?!1:ie.filenamePatterns.some(ee=>(0,d.$7eb)(ee,Q)))||y.add(Q)})}).catch(X=>{if(X.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw X})}))))})(g,v,h);const j=new L.$Ac;let U=!1;const z=Array.from(y).map(async N=>{const A=[];try{if(v.isCancellationRequested)return;if(h.maxResults&&[...j.values()].reduce((K,X)=>K+X.cellResults.length,0)>h.maxResults){U=!0;return}const T=[],F=this.g.get(N);if(F)F.apiNotebook.getCells().forEach(X=>T.push({input:X.document.getText(),outputs:X.outputs.flatMap(Q=>Q.items.map(Z=>Z.data.toString()))}));else{const K=await this.s.value.readFile(N),X=O.$se.fromString(K.toString()),Q=await m.deserializeNotebook(X.buffer,v);if(v.isCancellationRequested)return;E.NotebookData.from(Q).cells.forEach(ie=>T.push({input:ie.source,outputs:ie.outputs.flatMap(ee=>ee.items.map(we=>we.valueBytes.toString()))}))}if(v.isCancellationRequested)return;T.forEach((K,X)=>{const Q=h.contentPattern.pattern,Z=new a.$vTb(K.input,void 0,K.outputs),ie=Z.findInInputs(Q),ee=Z.findInOutputs(Q),we=ee.flatMap(ue=>(0,t.$NK)(ue.matches,ue.textBuffer)).map((ue,ae)=>(ue.webviewIndex=ae,ue));if(ie.length>0||ee.length>0){const ue={index:X,contentResults:(0,t.$NK)(ie,Z.inputTextBuffer),webviewResults:we};A.push(ue)}});const G={resource:N,cellResults:A};j.set(N,G);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...j.values()]}}async y(c,h){const g=await this.s.value.stat(c);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==M.$7k&&typeof g.mtime=="number"&&typeof g.size=="number"&&h.mtime<g.mtime&&h.etag!==M.$8k({mtime:h.mtime,size:g.size}))throw new M.$Wk((0,D.localize)(1,null),3,h)}z(c){return c.scheme===s.Schemas.file?c.fsPath:c.toString()}A(c,h,g){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const C=new i.$8ic(h,this.d,c,g.visibleRanges.map(E.NotebookRange.to),g.selections.map(E.NotebookRange.to),typeof g.viewColumn=="number"?E.ViewColumn.to(g.viewColumn):void 0);this.h.set(h,C)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const g of c.value.removedDocuments){const C=k.URI.revive(g),v=this.g.get(C);v&&(v.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(m=>m.document.uri)}),this.n.fire(v.apiNotebook));for(const m of this.h.values())m.notebookData.uri.toString()===C.toString()&&this.h.delete(m.id)}if(c.value.addedDocuments){const g=[];for(const C of c.value.addedDocuments){const v=k.URI.revive(C.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const m=new o.$7ic(this.c,this.q,this.r,v,C);g.push(...C.cells.map(y=>o.$6ic.asModelAddData(y))),this.g.get(v)?.dispose(),this.g.set(v,m),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(m.apiNotebook)}}if(c.value.addedEditors)for(const g of c.value.addedEditors){if(this.h.has(g.id))return;const C=k.URI.revive(g.documentUri),v=this.g.get(C);v&&this.A(v,g.id,g)}const h=[];if(c.value.removedEditors)for(const g of c.value.removedEditors){const C=this.h.get(g);C&&(this.h.delete(g),this.k?.id===C.id&&(this.k=void 0),h.push(C))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const g=new Set;this.l.forEach(C=>g.add(C.id));for(const C of this.h.values()){const v=g.has(C.id);C._acceptVisibility(v)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(c){const h=S.$DO.String.with("notebookType","A notebook type"),g=new S.$FO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new S.$DO("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>O.$se.wrap(v))],new S.$EO("Notebook Data",v=>E.NotebookData.to(v.value))),C=new S.$FO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new S.$DO("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new b.$7v(E.NotebookData.from(v)))],new S.$EO("Bytes",v=>v.buffer));c.registerApiCommand(g),c.registerApiCommand(C)}}e.$ejc=l,l.a=0}),define(Se[363],De([1,0,17,22,41,35,23,39,36]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;class k{constructor(p,S,E){this.k=p,this.l=S,this.o=E,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&R.$Xj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&R.$Xj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const S=this.k.folderQueries||[];return new Promise((E,u)=>{const b=o=>{this.f++,p(o)};if(this.g)return E({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=D.$nc(i);this.j&&this.j(i,n)||this.v(b,{base:o,basename:n})}),Promise.all(S.map(o=>this.p(o,b))).then(o=>{E({limitHit:this.e,stats:o[0]||void 0})},o=>{u(new Error((0,f.$2i)(o)))})})}async p(p,S){const E=new O.$ce,u=this.q(p),b=this.r(),o=new $.$DK(this.k,p),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(E),n=w.$1d.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,E.token),a=n.elapsed(),t=w.$1d.create();return this.g&&!this.e||(s&&s.forEach(d=>{const l=D.$gc.relative(p.folder.path,d.path);if(i){const r=D.$nc(d.path);this.v(S,{base:p.folder,relativePath:l,basename:r});return}this.s(b,p.folder,l,S)}),this.g&&!this.e)?null:(this.u(b,o,S),{providerTime:a,postProcessTime:t.elapsed()})}finally{E.dispose(),this.h.delete(E)}}q(p){const S=(0,$.$CK)(this.k.includePattern,p.includePattern),E=(0,$.$CK)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:E,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},S,E,u){if(E===this.a){const o=D.$nc(this.a);this.v(u,{base:S,relativePath:this.a,basename:o})}function b(o){const i=D.$nc(o),n=D.$mc(o);let s=p[n];s||(s=p[n]=[],b(n)),s.push({base:S,relativePath:o,basename:i})}b(E)}u({rootEntries:p,pathToEntries:S},E,u){const b=this,o=this.a;function i(n){const s=(0,$.$FK)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const d=n[a],{relativePath:l,basename:r}=d;if(E.matchesExcludesSync(l,r,o!==r?s:void 0))continue;const c=S[l];if(c)i(c);else{if(l===o)continue;b.v(u,d)}if(b.e)break}}i(p)}v(p,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(S))}}class M{constructor(){this.b=new Map}fileSearch(p,S,E,u){const b=this.c(p.cacheKey),o=new k(p,S,b&&b.token);let i=0;const n=s=>{i+=s.length,E(s.map(a=>this.d(a)))};return this.e(o,M.a,n,u).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:s.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new O.$ce),this.b.get(p)}d(p){return p.relativePath?{resource:L.$Rg(p.base,p.relativePath)}:{resource:p.base}}e(p,S,E,u){const b=u.onCancellationRequested(()=>{p.cancel()}),o=n=>{n&&(i.push(n),S>0&&i.length>=S&&(E(i),i=[]))};let i=[];return p.search(o).then(n=>(i.length&&E(i),b.dispose(),n),n=>(i.length&&E(i),b.dispose(),Promise.reject(n)))}}e.$9ic=M,M.a=512}),define(Se[364],De([1,0,19,73,35,101,28,16,17,23,12,18,2,104,237,52,13,42,144,359,36]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=void 0;let a=class{constructor(m,y,P,j,U){this.a=m,this.b=y,this.c=P,this.d=j,this.e=U}text(m,y,P={}){m=this.f(m,P);const j=this.a.getValue(),U=y&&y.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(y?.map(o.$zi),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:j.search.usePCRE2||U||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(m,y){const P=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const j={...m,wordSeparators:P.editor.wordSeparators};return this.j(m,y)&&(j.isCaseSensitive=!0),this.k(m)&&(j.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),j}file(m,y={}){return{...this.h(m,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(m,y){return m?(m=Array.isArray(m)?m.map(c):c(m),y?this.parseSearchPaths(m):{pattern:d(...Array.isArray(m)?m:[m])}):{}}h(m=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),j=this.g(y.excludePattern,y.expandPatterns),U=m.length>1,z=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,y,j)):m.map(T=>this.r(T,y,j,U))).filter(T=>!!T),N={_reason:y._reason,folderQueries:z,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:j.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=D.$Hb(D.$Rb(this.c.groups.map(K=>K.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const F=T.filter(K=>(0,s.$tK)(N,K.fsPath)),G=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(G)),{...N,...G}}const A=y.extraFileResources&&y.extraFileResources.filter(T=>(0,s.$tK)(N,T.fsPath));return N.extraFileResources=A&&A.length?A:void 0,N}i(m){const y=[],P=new L.$Ac,j={};let U=!1;return m.forEach(z=>{if(z.scheme===w.Schemas.walkThrough)return;if((0,k.$Vg)(z)){const A=this.b.getWorkspaceFolder(z)?.uri??z.with({path:$.$mc(z.fsPath)});let T=P.get(A);T||(U=!0,T={folder:A,includePattern:{}},y.push(T),P.set(A,T));const F=$.$lc(A.fsPath,z.fsPath);(0,I.$4f)(T.includePattern)[F.replace(/\\/g,"/")]=!0}else z.fsPath&&(U=!0,j[z.fsPath]=!0)}),{folderQueries:y,includePattern:j,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(m,y){if(y.isSmartCase){if(m.isRegExp){if(M.$Jf(m.pattern,!0))return!0}else if(M.$Jf(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,S.$eC)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const y=G=>$.$ic(G)||/^\.\.?([\/\\]|$)/.test(G),j=(Array.isArray(m)?m:l(m)).map(G=>{const K=this.e.resolvedUserHome;return K?(0,R.$_v)(G,K.scheme===w.Schemas.file?K.fsPath:K.path):G}),U=O.$E(j,G=>y(G)?"searchPaths":"exprSegments"),z=(U.exprSegments||[]).map(G=>M.$4e(G,"/")).map(G=>M.$4e(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),r(G))),N={},A=this.m(U.searchPaths||[]);A&&A.length&&(N.searchPaths=A);const T=D.$Rb(z),F=d(...T);return F&&(N.pattern=F),N}l(m,y){return y.disregardExcludeSettings?void 0:(0,s.$sK)(m,!y.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const y=m.flatMap(j=>{let{pathPortion:U,globPortion:z}=t(j);return z&&(z=h(z)),this.n(U).flatMap(A=>this.o(A,z))}),P=new Map;return y.forEach(j=>{const U=j.searchPath.toString(),z=P.get(U);z?j.pattern&&(z.pattern=z.pattern||{},z.pattern[j.pattern]=!0):P.set(U,{searchPath:j.searchPath,pattern:j.pattern?d(j.pattern):void 0})}),Array.from(P.values())}n(m){if($.$ic(m)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==w.Schemas.file?[{searchPath:y[0].uri.with({path:m})}]:[{searchPath:p.URI.file($.$hc(m))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(m=c(m),m.startsWith("../")||m===".."){const j=$.$gc.resolve(y.path,m);return[{searchPath:y.with({path:j})}]}const P=h(m);return[{searchPath:y,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const y=m.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(U=>{const z=y.match(new RegExp(`^${M.$Xe(U.name)}(?:/(.*)|$)`));return z?{match:z,folder:U}:null}).filter(I.$1f);if(j.length)return j.map(U=>{const z=U.match[1];return{searchPath:U.folder.uri,pattern:z&&h(z)}});{const U=m.match(/\.[\/\\](.+)[\/\\]?/),z=U?U[1]:m,N=E.localize(0,null,z);throw new Error(N)}}}}o(m,y){const P=m.pattern&&y?`${m.pattern}/${y}`:m.pattern||y,j=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&j.push({searchPath:m.searchPath,pattern:P+"/**"}),j}q(m,y,P){const j=this.r((0,o.$zi)(m.searchPath),y,P,!1);return j?{...j,includePattern:m.pattern}:null}r(m,y,P,j){let U;const z=p.URI.isUri(m)?m:m.uri;if(P.searchPaths){const G=P.searchPaths.filter(K=>(0,k.$Kg)(K.searchPath,z))[0];if(G&&!G.pattern)return null;G&&(U=G.pattern)}const N=this.a.getValue({resource:z}),T={...this.l(N,y)||{},...U||{}},F=p.URI.isUri(m)?(0,k.$Og)(m):m.name;return{folder:z,folderName:j?F:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!N.search.followSymlinks}}};e.$EL=a,e.$EL=a=Je([He(0,u.$Ki),He(1,o.$ni),He(2,i.$lD),He(3,b.$yj),He(4,n.$CL)],a);function t(v){const m=v.match(/[\*\{\}\(\)\[\]\?]/);if(m){const y=m.index,P=v.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let j=v.substr(0,P.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:v.substr((P.index||0)+1)}}}return{pathPortion:v}}function d(...v){return v.length?v.reduce((m,y)=>(m[y]=!0,m),Object.create(null)):void 0}function l(v){return f.$Vj(v,",").map(m=>m.trim()).filter(m=>!!m.length)}function r(v){return[`**/${v}/**`,`**/${v}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function c(v){return v.replace(/\\/g,"/")}function h(v){return c(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(v){return v.replace(/([?*[\]])/g,"[$1]")}function C(v,m){v=D.$Mb(v,j=>j.toString());const y=[],P=m.getWorkspace();return v&&v.forEach(j=>{let U;if(m.getWorkbenchState()===2)U=(0,k.$Tg)(P.folders[0].uri,j),U&&U!=="."&&(U="./"+U);else{const z=m.getWorkspaceFolder(j);if(z){const N=z.name;if(P.folders.filter(T=>T.name===N).length===1){const T=(0,k.$Tg)(z.uri,j);T===""?U=`./${z.name}`:U=`./${z.name}/${T}`}else U=j.fsPath}}U&&y.push(g(U))}),y}e.$FL=C}),define(Se[365],De([1,0,23,2,22,14,5,364,36,42,8]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wub=e.$vub=void 0;const I=7e3;function p(b,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],s=[];for(const c of i)if(/^workspaceContains:/.test(c)){const h=c.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||b.forceUsingSearch?s.push(h):n.push(h)}if(n.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:a,resolve:t}=(0,M.$0g)(),d=c=>t({activationEvent:c}),l=Promise.all(n.map(c=>S(b,c,d))).then(()=>{}),r=E(b,o.identifier,s,d);return Promise.all([l,r]).then(()=>{t(void 0)}),a}e.$vub=p;async function S(b,o,i){for(const n of b.folders)if(await b.exists(D.$Rg(O.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function E(b,o,i,n){if(i.length===0)return Promise.resolve(void 0);const s=new f.$ce,a=b.checkExists(b.folders,i,s.token),t=setTimeout(async()=>{s.cancel(),b.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},I);let d=!1;try{d=await a}catch(l){R.$4(l)||R.$1(l)}s.dispose(),clearTimeout(t),d&&n(`workspaceContains:${i.join(",")}`)}function u(b,o,i,n){const s=b.get(L.$di),a=b.get($.$kK),d=s.createInstance(w.$EL).file(o.map(l=>(0,k.$zi)(O.URI.revive(l))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(d,n).then(l=>!!l.limitHit,l=>R.$4(l)?!1:Promise.reject(l))}e.$wub=u});var it=this&&this.__classPrivateFieldSet||function(re,e,D,O,f){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!f:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?f.call(re,D):f?f.value=D:e.set(re,D),D},qe=this&&this.__classPrivateFieldGet||function(re,e,D,O){if(D==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!O:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?O:D==="a"?O.call(re):O?O.value:e.get(re)};define(Se[47],De([1,0,214,17,58,23,8,3,77,2,13,6,43,293,118,38,26,146,14,25,21,273,7,64,5,27,93,20,106,70,46,4,365,117,275,16,115,39,9,116]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d,l,r,c,h,g,C,v,m,y,P,j,U,z,N,A,T){"use strict";var F,G,K,X;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=e.$Nic=e.$Mic=e.$Lic=e.$Kic=void 0,e.$Kic=(0,l.$ei)("IHostUtils");let Q=X=class extends w.$Tc{constructor(he,se,ce,le,de,q,_,ge,me,Ae,ye,Re){super(),this.X=Re,this.a=this.B(new m.$5d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=se,this.g=ce,this.f=_,this.j=le,this.m=de,this.s=q,this.t=me,this.u=Ae,this.w=ye,this.y=this.g.getProxy(I.$1L.MainThreadWorkspace),this.z=this.g.getProxy(I.$1L.MainThreadTelemetry),this.C=this.g.getProxy(I.$1L.MainThreadExtensionService),this.D=new L.$dh,this.F=new L.$dh,this.G=new L.$dh,this.H=new L.$dh,this.I=new H(this.f.extensions.activationEvents),this.L=new o.$N9b(this.I,this.f.extensions.allExtensions);const Le=new n.$ym(this.f.extensions.myExtensions);this.J=new o.$N9b(this.I,ue(this.L,Le)),A.$n&&(this.s.info(`Creating extension host with the following global extensions: ${ee(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ee(this.J)}`)),this.M=new E.$vic(this.g,this.s),this.N=new P.$Dic(this.g),this.O=ge,this.h=he.createChild(new g.$ci([E.$wic,this.M],[P.$Eic,this.N])),this.P=this.B(new S.$uic(this.J,this.L,{onExtensionActivationError:(ze,B,V)=>{this.C.$onExtensionActivationError(ze,i.$3(B),V)},actualActivateExtension:async(ze,B)=>{if(o.$N9b.isHostExtension(ze,this.J,this.L))return await this.C.$activateExtension(ze,B),new S.$tic;const V=this.J.getExtensionDescription(ze);return this.db(V,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(he){i.$1(he)}}async Y(){this.O.onWillDeactivateAll();let he=[];try{he=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(he)}terminate(he,se=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${he}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const ce=this.Y();Promise.race([(0,L.$fh)(5e3),ce]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${se}`):this.s.info(`Extension host exiting with code ${se}`),this.s.flush(),this.s.dispose(),this.c.exit(se)})}isActivated(he){return this.G.isOpen()?this.P.isActivated(he):!1}async getExtension(he){const se=await this.C.$getExtension(he);return se&&{...se,identifier:new n.$xm(se.identifier.value),extensionLocation:k.URI.revive(se.extensionLocation)}}Z(he,se){return this.P.activateByEvent(he,se)}$(he,se){return this.P.activateById(he,se)}activateByIdWithErrors(he,se){return this.$(he,se).then(()=>{const ce=this.P.getActivatedExtension(he);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(he=>this.J)}getExtensionExports(he){if(this.G.isOpen())return this.P.getActivatedExtension(he).exports;try{return this.P.getActivatedExtension(he).exports}catch{return null}}async ab(he){if(he.scheme===U.Schemas.file&&this.c.fsRealpath){const se=await this.c.fsRealpath(he.fsPath);return k.URI.file(se)}return he}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(he=>new ae(he))),this.Q}async bb(he){const se=$.$ki.forUris(ce=>R.$Ig.ignorePathCasing(ce));return await Promise.all(he.map(async ce=>{if(this.ub(ce)){const le=await this.ab(ce.extensionLocation);se.set(le,ce)}})),se}cb(he){let se=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(he))return se;const ce=this.P.getActivatedExtension(he);if(!ce)return se;try{typeof ce.module.deactivate=="function"&&(se=Promise.resolve(ce.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${he.value}':`),this.s.error(le)}try{(0,w.$Oc)(ce.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${he.value}':`),this.s.error(le)}return se}async db(he,se){return this.f.remote.isRemote?this.C.$onWillActivateExtension(he.identifier):await this.C.$onWillActivateExtension(he.identifier),this.fb(he,se).then(ce=>{const le=ce.activationTimes;return this.C.$onDidActivateExtension(he.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,se),this.eb(he,se,"success",le),ce},ce=>{throw this.eb(he,se,"failure"),ce})}eb(he,se,ce,le){const de=ie(he,se);this.z.$publicLog2("extensionActivationTimes",{...de,...le||{},outcome:ce})}fb(he,se){const ce=ie(he,se);this.z.$publicLog2("activatePlugin",ce);const le=this.ub(he);if(!le)return Promise.resolve(new S.$sic(S.$pic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${he.identifier.value}, startup: ${se.startup}, activationEvent: '${se.activationEvent}'${he.identifier.value!==se.extensionId.value?`, root cause: ${se.extensionId.value}`:""}`),this.s.flush();const de=new S.$qic(se.startup);return Promise.all([this.vb(he,(0,R.$Rg)(he.extensionLocation,le),de),this.gb(he)]).then(q=>(f.mark(`code/extHost/willActivateExtension/${he.identifier.value}`),X.hb(this.s,he.identifier,q[0],q[1],de))).then(q=>(f.mark(`code/extHost/didActivateExtension/${he.identifier.value}`),q))}gb(he){const se=new a.$yic(he,this.M),ce=new a.$xic(he.identifier.value,!1,this.M),le=new j.$Fic(he,this.N),de=he.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,q=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${he.identifier.value}`),Promise.all([se.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const _=this;let ge,me;const Ae=(0,b.$VF)(he,"ipc")?this.f.messagePorts?.get(n.$xm.toKey(he.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ce,secrets:le,subscriptions:[],get extensionUri(){return he.extensionLocation},get extensionPath(){return he.extensionLocation.fsPath},asAbsolutePath(ye){return O.$jc(he.extensionLocation.fsPath,ye)},get storagePath(){return _.O.workspaceValue(he)?.fsPath},get globalStoragePath(){return _.O.globalValue(he).fsPath},get logPath(){return O.$jc(_.f.logsLocation.fsPath,he.identifier.value)},get logUri(){return k.URI.joinPath(_.f.logsLocation,he.identifier.value)},get storageUri(){return _.O.workspaceValue(he)},get globalStorageUri(){return _.O.globalValue(he)},get extensionMode(){return de},get extension(){return ge===void 0&&(ge=new we(_,he.identifier,he,q,!1)),ge},get extensionRuntime(){return(0,b.$WF)(he,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(he)},get messagePassingProtocol(){if(!me){if(!Ae)return;const ye=m.Event.buffer(m.Event.fromDOMEventEmitter(Ae,"message",Re=>Re.data));Ae.start(),me={onDidReceiveMessage:ye,postMessage:Ae.postMessage.bind(Ae)}}return me}})})}static hb(he,se,ce,le,de){return ce=ce||{activate:void 0,deactivate:void 0},this.ib(he,se,ce,le,de).then(q=>new S.$ric(!1,null,de.build(),ce,q,le.subscriptions))}static ib(he,se,ce,le,de){if(typeof ce.activate=="function")try{de.activateCallStart(),he.trace(`ExtensionService#_callActivateOptional ${se.value}`);const q=typeof global=="object"?global:self,_=ce.activate.apply(q,[le]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(_).then(ge=>(de.activateResolveStop(),ge))}catch(q){return Promise.reject(q)}else return Promise.resolve(ce)}jb(he,se){this.$(he.identifier,{startup:!1,extensionId:he.identifier,activationEvent:se}).then(void 0,ce=>{this.s.error(ce)})}kb(he,se=0){const le=Date.now();(0,A.$v)(()=>{for(let de=se;de<he.length;de+=1){const q=he[de];for(const _ of q.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-le>50){this.kb(he,de);break}else this.jb(q,_)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(he=>{const se=he.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ce=this.J.getAllExtensionDescriptions();if(se)this.kb(ce);else for(const le of ce)if(le.activationEvents)for(const de of le.activationEvents)de==="onStartupFinished"&&this.jb(le,de)})}mb(){const he=this.Z("*",!0).then(void 0,q=>{this.s.error(q)});this.B(this.j.onDidChangeWorkspace(q=>this.nb(q.added)));const se=this.j.workspace?this.j.workspace.folders:[],ce=this.nb(se),le=this.pb(),de=Promise.all([le,he,ce]).then(()=>{});return Promise.race([de,(0,L.$fh)(1e4)]).then(()=>{this.lb()}),de}nb(he){return he.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(se=>this.ob(he,se))).then(()=>{})}async ob(he,se){if(this.isActivated(se.identifier))return;const ce=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:he.map(q=>q.uri),forceUsingSearch:ce||!this.c.fsExists,exists:q=>this.c.fsExists(q.fsPath),checkExists:(q,_,ge)=>this.y.$checkExists(q,_,ge)},de=await(0,y.$vub)(le,se);if(de)return this.$(se.identifier,{startup:!0,extensionId:se.identifier,activationEvent:de.activationEvent}).then(void 0,q=>this.s.error(q))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(he){throw console.error(he),he}}async qb(){const{extensionDevelopmentLocationURI:he,extensionTestsLocationURI:se}=this.f.environment;if(!he||!se)throw new Error(D.localize(0,null));const ce=await this.vb(null,se,new S.$qic(!1));if(!ce||typeof ce.run!="function")throw new Error(D.localize(1,null,se.toString()));return new Promise((le,de)=>{const q=(me,Ae)=>{me?(A.$n&&this.s.error("Test runner called back with error",me),de(me)):(A.$n&&(Ae?this.s.info(`Test runner called back with ${Ae} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof Ae=="number"&&Ae>0?1:0))},_=(0,R.$Fg)(se),ge=ce.run(_,q);ge&&ge.then&&ge.then(()=>{A.$n&&this.s.info("Test runner finished successfully."),le(0)}).catch(me=>{A.$n&&this.s.error("Test runner finished with error",me),de(me instanceof Error&&me.stack?me.stack:String(me))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$fh)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(he,se){return this.R[he]=se,(0,w.$Rc)(()=>{delete this.R[he]})}async getRemoteExecServer(he){const{resolver:se}=await this.sb(he);return se?.resolveExecServer?.(he,{resolveAttempt:0})}async sb(he){const se=he.indexOf("+");if(se===-1)throw new t.$9L("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ce=he.substr(0,se);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this.R[ce]}}async $resolveAuthority(he,se){const ce=N.$1d.create(!1),le=()=>`[resolveAuthority(${(0,d.$kl)(he)},${se})][${ce.elapsed()}ms] `,de=Y=>this.s.info(`${le()}${Y}`),q=Y=>this.s.warn(`${le()}${Y}`),_=(Y,$e=void 0)=>this.s.error(`${le()}${Y}`,$e),ge=Y=>{if(Y instanceof t.$9L)return{type:"error",error:{code:Y._code,message:Y._message,detail:Y._detail}};throw Y},me=async Y=>{de(`activating resolver for ${Y}...`);const{resolver:$e,authorityPrefix:ve}=await this.sb(Y);if(!$e)throw _(`no resolver for ${ve}`),new t.$9L(`No remote extension installed to resolve ${ve}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:$e,authorityPrefix:ve,remoteAuthority:Y}},Ae=he.split(/@|%40/g).reverse();de(`activating remote resolvers ${Ae.join(" -> ")}`);let ye;try{ye=await Promise.all(Ae.map(me)).catch(async Y=>{if(!(Y instanceof t.$9L)||Y._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Y;return q(`resolving nested authorities failed: ${Y.message}`),[await me(he)]})}catch(Y){return ge(Y)}const Re=new L.$ph;Re.cancelAndSet(()=>de("waiting..."),1e3);let Le,ze;for(const[Y,{authorityPrefix:$e,resolver:ve,remoteAuthority:Te}]of ye.entries())try{if(Y===ye.length-1)de("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${$e}`),Le=await ve.resolve(Te,{resolveAttempt:se,execServer:ze}),f.mark(`code/extHost/didResolveAuthorityOK/${$e}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ve,t.$8L.isManagedResolvedAuthority(Le)?Le:void 0));else{if(de(`invoking resolveExecServer() for ${Te}`),f.mark(`code/extHost/willResolveExecServer/${$e}`),ze=await ve.resolveExecServer?.(Te,{resolveAttempt:se,execServer:ze}),!ze)throw new t.$9L(`Exec server was not available for ${Te}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${$e}`)}}catch(Ve){return f.mark(`code/extHost/didResolveAuthorityError/${$e}`),_("returned an error",Ve),Re.dispose(),ge(Ve)}Re.dispose();const B={environmentTunnels:Le.environmentTunnels,features:Le.tunnelFeatures?{elevation:Le.tunnelFeatures.elevation,privacyOptions:Le.tunnelFeatures.privacyOptions,protocol:Le.tunnelFeatures.protocol===void 0?!0:Le.tunnelFeatures.protocol}:void 0},V={extensionHostEnv:Le.extensionHostEnv,isTrusted:Le.isTrusted,authenticationSession:Le.authenticationSessionForInitializingExtensions?{id:Le.authenticationSessionForInitializingExtensions.id,providerId:Le.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$8L.isManagedResolvedAuthority(Le)?"managed authority":`${Le.host}:${Le.port}`}`);let x;if(t.$8L.isManagedResolvedAuthority(Le)){const Y=se;this.X.setFactory(Y,Le.makeConnection),x={authority:he,connectTo:new d.$hl(Y),connectionToken:Le.connectionToken}}else x={authority:he,connectTo:new d.$il(Le.host,Le.port),connectionToken:Le.connectionToken};return{type:"ok",value:{authority:x,options:V,tunnelInformation:B}}}async $getCanonicalURI(he,se){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$kl)(he)})`);const{resolver:ce}=await this.sb(he);if(!ce)return null;const le=k.URI.revive(se);if(typeof ce.getCanonicalURI>"u")return le;const de=await(0,L.$9g)(()=>ce.getCanonicalURI(le));return de||le}$startExtensionHost(he){he.toAdd.forEach(le=>le.extensionLocation=k.URI.revive(le.extensionLocation));const{globalRegistry:se,myExtensions:ce}=Z(this.I,this.L,this.J,he);return this.L.set(se.getAllExtensionDescriptions()),this.J.set(ce),A.$n&&(this.s.info(`$startExtensionHost: global extensions: ${ee(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ee(this.J)}`)),this.rb()}$activateByEvent(he,se){return se===1?this.D.wait().then(ce=>this.Z(he,!1)):this.G.wait().then(ce=>this.Z(he,!1))}async $activate(he,se){return await this.G.wait(),this.J.getExtensionDescription(he)?(await this.$(he,se),!0):!1}async $deltaExtensions(he){he.toAdd.forEach(q=>q.extensionLocation=k.URI.revive(q.extensionLocation));const{globalRegistry:se,myExtensions:ce}=Z(this.I,this.L,this.J,he),le=await this.bb(ce);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(se.getAllExtensionDescriptions()),this.J.set(ce),A.$n&&(this.s.info(`$deltaExtensions: global extensions: ${ee(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ee(this.J)}`)),Promise.resolve(void 0)}async $test_latency(he){return he}async $test_up(he){return he.byteLength}async $test_down(he){const se=s.$se.alloc(he),ce=Math.random()%256;for(let le=0;le<he;le++)se.writeUInt8(ce,le);return se}async $updateRemoteConnectionData(he){this.W=he,this.a.fire()}};e.$Lic=Q,e.$Lic=Q=X=Je([He(0,l.$di),He(1,e.$Kic),He(2,h.$fO),He(3,u.$$hc),He(4,p.$bic),He(5,M.$yj),He(6,r.$vO),He(7,c.$eic),He(8,C.$yAb),He(9,v.$zic),He(10,z.$Hic),He(11,T.$Iic)],Q);function Z(fe,he,se,ce){fe.addActivationEvents(ce.addActivationEvents);const le=new o.$N9b(fe,he.getAllExtensionDescriptions());le.deltaExtensions(ce.toAdd,ce.toRemove);const de=new n.$ym(se.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of ce.myToRemove)de.delete(_);for(const _ of ce.myToAdd)de.add(_);const q=ue(le,de);return{globalRegistry:le,myExtensions:q}}function ie(fe,he){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:he.activationEvent,reasonId:he.extensionId.value}}function ee(fe){return fe.getAllExtensionDescriptions().map(he=>he.identifier.value).join(",")}e.$Mic=(0,l.$ei)("IExtHostExtensionService");class we{constructor(he,se,ce,le,de){F.set(this,void 0),G.set(this,void 0),K.set(this,void 0),it(this,F,he,"f"),it(this,G,se,"f"),it(this,K,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=O.$hc((0,R.$Fg)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=le,this.isFromDifferentExtensionHost=de}get isActive(){return qe(this,F,"f").isActivated(qe(this,K,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return qe(this,F,"f").getExtensionExports(qe(this,K,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await qe(this,F,"f").activateByIdWithErrors(qe(this,K,"f"),{startup:!1,extensionId:qe(this,G,"f"),activationEvent:"api"}),this.exports}}e.$Nic=we,F=new WeakMap,G=new WeakMap,K=new WeakMap;function ue(fe,he){return fe.getAllExtensionDescriptions().filter(se=>he.has(se.identifier))}class ae{constructor(he){this.a=he}setSearchTree(he){this.a=he}findSubstr(he){return this.a.findSubstr(he)}forEach(he){return this.a.forEach(he)}}e.$Oic=ae;class H{constructor(he){this.a=new n.$zm,this.addActivationEvents(he)}readActivationEvents(he){return this.a.get(he.identifier)??[]}addActivationEvents(he){for(const se of Object.keys(he))this.a.set(se,he[se])}}}),define(Se[366],De([1,0,58,2,6,43,26,25,20,27,5,47,13,12]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;let u=class{constructor(s,a,t,d,l,r,c){this.c=s,this.d=a,this.f=t,this.g=d,this.h=l,this.i=r,this.j=c,this.a=new Map,this.b=[]}async install(){this.k(),D.mark("code/extHost/willWaitForConfig");const s=await this.g.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this.h.getExtensionPathIndex();this.register(new o(this.c,a,this.d,s,this.j)),this.register(this.f.createInstance(b)),this.i.remote.isRemote&&this.register(this.f.createInstance(i,a,this.i.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const a of s.nodeModuleName)this.a.set(a,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(a=>s.alternativeModuleName(a))}};e.$Wjc=u,e.$Wjc=u=Je([He(2,M.$di),He(3,R.$bic),He(4,I.$Mic),He(5,k.$vO),He(6,p.$yj)],u);let b=E=class{constructor(s){if(s.environment.appRoot&&E.a.size){const a=(0,S.$Xe)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${l}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const a=this.b.exec(this.c(s));if(!a)return;const[,t,d,l]=a,r=E.a.get(d);if(r!==void 0)return console.warn(`${d} as been renamed to ${r}, please update your imports`),t+r+l}c(s){return s.replace(/\\/g,"/")}};b.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),b=E=Je([He(0,k.$vO)],b);class o{constructor(s,a,t,d,l){this.c=s,this.d=a,this.e=t,this.f=d,this.g=l,this.nodeModuleName="vscode",this.a=new w.$zm}load(s,a){const t=this.d.findSubstr(a);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((l,r)=>d+=`	${r} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${d}`),this.b=this.c(L.$QF,this.e,this.f)}return this.b}}let i=class{constructor(s,a,t){this.e=s,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$1L.MainThreadTelemetry);const d=t.getProxy(f.$1L.MainThreadWindow);this.c=(l,r)=>{const c=O.URI.parse(l);return r?this.g(l,r):c.scheme==="http"||c.scheme==="https"?d.$openUri(c,l,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?d.$openUri(c,l,{}):this.g(l,r)}}load(s,a,t){const d=this.e.findSubstr(a);return d&&(this.a=d.identifier.value,this.h()),this.b=t(s),this.c}g(s,a){return this.i(),this.b(s,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([He(2,$.$fO)],i)}),define(Se[60],De([1,0,44,3,17,49,5,72,71,47,7,38,290,43]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=e.$Pic=void 0,e.$Pic=(0,L.$ei)("IExtHostVariableResolverProvider");class E extends p.$gP{constructor(o,i,n,s,a,t,d){function l(){if(n){const r=n.activeEditor();if(r)return r.document.uri;const c=s.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof M.$LN||c.input instanceof M.$QN)return c.input.modified;if(c.input instanceof M.$KN||c.input instanceof M.$PN||c.input instanceof M.$NN)return c.input.uri}}}super({getFolderUri:r=>{const c=t.folders.filter(h=>h.name===r);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(r,c)=>a.getConfiguration(void 0,r).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const r=l();if(r)return f.$hc(r.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const r=l();if(r){const c=i.getWorkspaceFolder(r);if(c)return f.$hc(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const r=n.activeEditor();if(r&&!r.selection.isEmpty)return r.document.getText(r.selection)}},getLineNumber:()=>{if(n){const r=n.activeEditor();if(r)return String(r.selection.end.line+1)}},getExtension:r=>o.getExtension(r)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(R.env))}}let u=class extends O.$Tc{constructor(o,i,n,s,a){super(),this.b=o,this.c=i,this.g=n,this.h=s,this.j=a,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),l={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async r=>{l.folders=await this.c.getWorkspaceFolders2()||[]})),new E(this.b,this.c,this.g,this.j,t,l,this.m())})}getResolver(){return this.a.value}m(){}};e.$Qic=u,e.$Qic=u=Je([He(0,k.$Mic),He(1,I.$$hc),He(2,w.$qO),He(3,S.$bic),He(4,$.$nic)],u)}),define(Se[96],De([1,0,8,4,2,25,5,6,71,47,20,7,38,141,282,43,60,3,55,33,15]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=e.$Uic=e.$Tic=e.$Sic=e.$Ric=void 0,e.$Ric=(0,L.$ei)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,C,v,m,y,P,j){this.N=C,this.O=v,this.P=m,this.Q=y,this.R=P,this.S=j,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$5d,this.o=new O.$5d,this.q=new O.$5d,this.w=new O.$5d,this.l=g.getProxy(w.$1L.MainThreadDebugService),this.A=new O.$5d,this.C=new O.$5d,this.y=new d(this.l),this.z=new Map,this.O.getExtensionRegistry().then(U=>{U.onDidChange(z=>{this.V(U)}),this.V(U)})}async $getVisualizerTreeItem(g,C){const v=this.W(C);if(!v)return;const m=await this.H.get(g)?.getTreeItem?.(v);return m?this.U(g,m):void 0}registerDebugVisualizationTree(g,C,v){const m=R.$xm.toKey(g.identifier),y=this.jb(m,C);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${C}' is already registered`);return this.H.set(y,v),this.l.$registerDebugVisualizerTree(y,!!v.editItem),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(C)})}async $getVisualizerTreeItemChildren(g,C){const v=this.J.get(C)?.item;return v?(await this.H.get(g)?.getChildren?.(v))?.map(y=>this.U(g,y))||[]:[]}async $editVisualizerTreeItem(g,C){const v=this.J.get(g);if(!v)return;const m=await this.H.get(v.provider)?.editItem?.(v.item,C);return this.U(v.provider,m||v.item)}$disposeVisualizedTree(g){const C=this.J.get(g);if(!C)return;const v=[C.children];for(const m of v)if(m)for(const y of m)v.push(this.J.get(y)?.children),this.J.delete(y)}U(g,C){let v=this.I.get(C);return v||(v=this.F++,this.I.set(C,v),this.J.set(v,{provider:g,item:C})),s.DebugTreeItem.from(C,v)}asDebugSourceUri(g,C){const v=g;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let m=`debug:${encodeURIComponent(v.path||"")}`,y="?";return C&&(m+=`${y}session=${encodeURIComponent(C.id)}`,y="&"),m+=`${y}ref=${v.sourceReference}`,f.URI.parse(m)}else{if(v.path)return f.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const C=[];for(const v of g.getAllExtensionDescriptions())if(v.contributes){const m=v.contributes.debuggers;if(m&&m.length>0)for(const y of m)(0,E.$uG)(y)&&C.push(y.type)}this.l.$registerDebugTypes(C)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(C=>g.push(C)),g}async $resolveDebugVisualizer(g,C){const v=this.L.get(g);if(!v)throw new Error(`No debug visualizer found with id '${g}'`);let{v:m,provider:y,extensionId:P}=v;if(m.visualization||(m=await y.resolveDebugVisualization?.(m,C)||m,v.v=m),!m.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,m.visualization)}async $executeDebugVisualizerCommand(g){const C=this.L.get(g);if(!C)throw new Error(`No debug visualizer found with id '${g}'`);const v=C.v.visualization;v&&"command"in v&&this.S.executeCommand(v.command,...v.arguments||[])}W(g){const C=this.m.get(g.sessionId);return C&&{session:C.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,C,v,m){const y=this.W(v),P=this.jb(g,C),j=this.G.get(P);if(!y||!j)return[];const U=await j.provideDebugVisualization(y,m);return U?U.map(z=>{const N=++this.M;this.L.set(N,{v:z,provider:j,extensionId:g});const A=z.iconPath?this.lb(z.iconPath):void 0;return{id:N,name:z.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(g,z.visualization)}}):[]}$disposeDebugVisualizers(g){for(const C of g)this.L.delete(C)}registerDebugVisualizationProvider(g,C,v){if(!g.contributes?.debugVisualizers?.some(P=>P.id===C))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${C})`);const m=R.$xm.toKey(g.identifier),y=this.jb(m,C);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${C}' is already registered`);return this.G.set(y,v),this.l.$registerDebugVisualizer(m,C),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizer(m,C),this.G.delete(C)})}addBreakpoints(g){const C=g.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(C,[],[]);const v=[],m=new Map;for(const y of C)if(y instanceof I.$3M){let P=m.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},m.set(y.location.uri.toString(),P),v.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof I.$4M&&v.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(v)}removeBreakpoints(g){const C=g.filter(P=>this.z.delete(P.id));this.gb([],C,[]);const v=C.filter(P=>P instanceof I.$3M).map(P=>P.id),m=C.filter(P=>P instanceof I.$4M).map(P=>P.id),y=C.filter(P=>P instanceof I.$5M).map(P=>P.id);return this.l.$unregisterBreakpoints(v,m,y)}startDebugging(g,C,v){return this.l.$startDebugging(g?g.uri:void 0,C,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,C,v){if(!C)return new I.$3L(()=>{});const m=this.d++;return this.f.push({type:g,handle:m,provider:C}),this.l.$registerDebugConfigurationProvider(g,v,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,m),new I.$3L(()=>{this.f=this.f.filter(y=>y.provider!==C),this.l.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(g,C,v){if(!v)return new I.$3L(()=>{});if(!this.cb(g,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.$(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:C,handle:m,factory:v}),this.l.$registerDebugAdapterDescriptorFactory(C,m),new I.$3L(()=>{this.h=this.h.filter(y=>y.factory!==v),this.l.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(g,C){if(!C)return new I.$3L(()=>{});const v=this.j++;return this.k.push({type:g,handle:v,factory:C}),new I.$3L(()=>{this.k=this.k.filter(m=>m.factory!==C)})}async $runInTerminal(g,C){return Promise.resolve(void 0)}async $substituteVariables(g,C){let v;const m=await this.ib(g);return m&&(v={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(v,C)}X(g,C){if(g.type==="implementation")return new r(g.implementation)}Y(){}async $startDASession(g,C){const v=this,m=await this.hb(C);return this.eb(this.$(m.type),m).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const P=this.Z(y),j=this.X(P,m);if(!j)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const U=j;return this.D.set(g,U),this.db(m).then(z=>(z&&this.E.set(g,z),U.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const A=N,T={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const F=await this.K.sign(A.arguments.value);T.body={signature:F},U.sendResponse(T)}else throw new Error("no signer")}catch(F){T.success=!1,T.message=F.message,U.sendResponse(T)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(N),N=(0,E.$zG)(N,!0),v.l.$acceptDAMessage(g,N)}),U.onError(N=>{z&&z.onError&&z.onError(N),this.l.$acceptDAError(g,N.name,N.message,N.stack)}),U.onExit(N=>{z&&z.onExit&&z.onExit(N??void 0,void 0),this.l.$acceptDAExit(g,N??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),U.startSession()))})}$sendDAMessage(g,C){C=(0,E.$yG)(C,!1);const v=this.E.get(g);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(C),this.D.get(g)?.sendMessage(C)}$stopDASession(g){const C=this.E.get(g);this.E.delete(g),C&&C.onWillStopSession&&C.onWillStopSession();const v=this.D.get(g);return this.D.delete(g),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const C=[],v=[],m=[];if(g.added)for(const y of g.added){const P=y.id;if(P&&!this.z.has(P)){let j;if(y.type==="function")j=new I.$4M(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")j=new I.$5M(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const U=f.URI.revive(y.uri);j=new I.$3M(new I.$cM(U,new I.$4L(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,I.$1M)(j,P),this.z.set(P,j),C.push(j)}}if(g.removed)for(const y of g.removed){const P=this.z.get(y);P&&(this.z.delete(y),v.push(P))}if(g.changed){for(const y of g.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof I.$4M&&y.type==="function"){const j=P;j.enabled=y.enabled,j.condition=y.condition,j.hitCondition=y.hitCondition,j.logMessage=y.logMessage,j.functionName=y.functionName}else if(P instanceof I.$3M&&y.type==="source"){const j=P;j.enabled=y.enabled,j.condition=y.condition,j.hitCondition=y.hitCondition,j.logMessage=y.logMessage,j.location=new I.$cM(f.URI.revive(y.uri),new I.$4L(y.line,y.character))}m.push(P)}}}this.gb(C,v,m)}async $acceptStackFrameFocus(g){let C;const v=g.sessionId?await this.hb(g.sessionId):void 0;if(!v)throw new Error("no DebugSession found for debug focus context");g.kind==="thread"?C=new I.$$M(v.api,g.threadId):C=new I.$0M(v.api,g.threadId,g.frameId),this.B=C,this.C.fire(this.B)}$provideDebugConfigurations(g,C,v){return(0,D.$9g)(async()=>{const m=this.bb(g);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(C);return m.provideDebugConfigurations(y,v)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(g,C,v,m){return(0,D.$9g)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(C);return y.resolveDebugConfiguration(P,v,m)})}$resolveDebugConfigurationWithSubstitutedVariables(g,C,v,m){return(0,D.$9g)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(C);return y.resolveDebugConfigurationWithSubstitutedVariables(P,v,m)})}async $provideDebugAdapter(g,C){const v=this.ab(g);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.hb(C);return this.eb(v,m).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(g){const C=await this.hb(g);this.n.fire(C.api)}async $acceptDebugSessionTerminated(g){const C=await this.hb(g);C&&(this.o.fire(C.api),this.m.delete(C.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,C){(await this.hb(g))?._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(g,C){const m={session:(await this.hb(g)).api,event:C.event,body:C.body};this.w.fire(m)}Z(g){if(g instanceof I.$6M)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof I.$7M)return{type:"server",port:g.port,host:g.host};if(g instanceof I.$8M)return{type:"pipeServer",path:g.path};if(g instanceof I.$9M)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const C=this.h.filter(v=>v.type===g);if(C.length>0)return C[0].factory}ab(g){const C=this.h.filter(v=>v.handle===g);if(C.length>0)return C[0].factory}bb(g){const C=this.f.filter(v=>v.handle===g);if(C.length>0)return C[0].provider}cb(g,C){if(g.contributes){const v=g.contributes.debuggers;if(v&&v.length>0){for(const m of v)if(m.label&&m.type&&m.type===C)return!0}}return!1}db(g){const v=g.configuration.type,m=this.k.filter(y=>y.type===v||y.type==="*").map(y=>(0,D.$9g)(()=>y.factory.createDebugAdapterTracker(g.api)).then(P=>P,P=>null));return Promise.race([Promise.all(m).then(y=>{const P=y.filter(j=>!!j);if(P.length>0)return new l(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(g,C){const v=C.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new I.$7M(v));if(g){const y=await this.O.getExtensionRegistry();return(0,D.$9g)(()=>g.createDebugAdapterDescriptor(C.api,this.fb(C,y))).then(P=>{if(P)return P})}const m=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(C,m))}fb(g,C){}gb(g,C,v){(g.length>0||C.length>0||v.length>0)&&this.A.fire(Object.freeze({added:g,removed:C,changed:v}))}async hb(g){if(g)if(typeof g=="string"){const C=this.m.get(g);if(C)return C}else{let C=this.m.get(g.id);if(!C){const v=await this.ib(g.folderUri),m=g.parent?this.m.get(g.parent):void 0;C=new t(this.l,g.id,g.type,g.name,v,g.configuration,m?.api),this.m.set(C.id,C),this.l.$sessionCached(C.id)}return C}throw new Error("cannot find session")}ib(g){if(g){const C=f.URI.revive(g);return this.N.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}jb(g,C){return`${g}\0${C}`}kb(g,C){if(C){if("title"in C&&"command"in C)return{type:0};if("treeId"in C)return{type:1,id:`${g}\0${C.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const C=this.mb(g);let v,m;return"id"in C?m=i.ThemeIcon.asClassName(C):v=C,{iconPath:v,iconClass:m}}mb(g){if(g instanceof I.$XM)return{id:g.id};const C=typeof g=="object"&&"dark"in g?g.dark:g,v=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof C=="string"?f.URI.file(C):C,light:typeof v=="string"?f.URI.file(v):v}}};e.$Sic=a,e.$Sic=a=Je([He(0,M.$fO),He(1,p.$$hc),He(2,k.$Mic),He(3,u.$bic),He(4,$.$nic),He(5,b.$Pic),He(6,n.$BO)],a);class t{constructor(g,C,v,m,y,P,j){this.f=g,this.g=C,this.h=v,this.j=m,this.k=y,this.l=P,this.m=j}get api(){const g=this;return this.d??(this.d=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(C){g.j=C,g.f.$setDebugSessionName(g.g,C)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(C,v){return g.f.$customDebugAdapterRequest(g.g,C,v)},getDebugProtocolBreakpoint(C){return g.f.$getDebugProtocolBreakpoint(g.g,C.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$Tic=t;class d{constructor(g){this.value=Object.freeze({append(C){g.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.$Uic=d;class l{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(C=>C.onError?C.onError(g):void 0)}onExit(g,C){this.d.forEach(v=>v.onExit?v.onExit(g,C):void 0)}}class r extends S.$Onb{constructor(g){super(),this.h=g,g.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends a{constructor(g,C,v,m,y,P,j){super(g,C,v,m,y,P,j)}};e.$Vic=c,e.$Vic=c=Je([He(0,M.$fO),He(1,p.$$hc),He(2,k.$Mic),He(3,u.$bic),He(4,$.$nic),He(5,b.$Pic),He(6,n.$BO)],c)}),define(Se[367],De([1,0,14,58,2,6,311,13,84,106,27,249,20,66,47,90]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=e.$Xjc=void 0;class b{static async installEarlyHandler(n){Error.stackTraceLimit=100;const s=n.get(w.$yj),t=n.get(p.$fO).getProxy(R.$1L.MainThreadErrors);D.setUnexpectedErrorHandler(d=>{s.error(d);const l=D.$3(d);t.$onUnexpectedError(l)})}static async installFullHandler(n){const s=n.get(w.$yj),a=n.get(p.$fO),t=n.get(E.$Mic),d=n.get(u.$zO),l=a.getProxy(R.$1L.MainThreadExtensionService),r=a.getProxy(R.$1L.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function g(m,y){if(h.has(m))return h.get(m).stack;let P="",j,U;for(const N of y)P+=`
	at ${N.toString()}`,U=N.getFileName(),!j&&U&&(j=c.findSubstr(f.URI.file(U)));const z=`${m.name||"Error"}: ${m.message||""}${P}`;return h.set(m,{extensionIdentifier:j?.identifier,stack:z}),z}const C=Symbol("prepareStackTrace wrapped");let v=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(m){if(m===g||!m||m[C]){v=m||g;return}v=function(y,P){return g(y,P),m.call(Error,y,P)},Object.assign(v,{[C]:!0})}}),D.setUnexpectedErrorHandler(m=>{s.error(m);const y=D.$3(m),P=h.get(m);if(!P?.extensionIdentifier){r.$onUnexpectedError(y);return}l.$onExtensionRuntimeError(P.extensionIdentifier,y);const j=d.onExtensionError(P.extensionIdentifier,m);s.trace("forwarded error to extension?",j,P)})}}e.$Xjc=b;class o{constructor(n,s,a,t,d){this.a=a,this.b=new L.$V9b(n,null,t),s=o.e(s,this.b);const l=new k.$ci(...(0,$.$_r)());l.set(M.$vO,{_serviceBrand:void 0,...s,messagePorts:d}),l.set(p.$fO,new p.$gO(this.b)),l.set(S.$8hc,new S.$9hc(t)),l.set(E.$Kic,a);const r=new I.$Qq(l,!0);r.invokeFunction(b.installEarlyHandler),this.d=r.invokeFunction(c=>c.get(w.$yj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=r.invokeFunction(c=>c.get(E.$Mic)),this.c.initialize(),r.invokeFunction(b.installFullHandler)}async asBrowserUri(n){const s=this.b.getProxy(R.$1L.MainThreadExtensionService);return f.URI.revive(await s.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,s){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=f.URI.revive(s.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(s.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=f.URI.revive(s.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=f.URI.revive(s.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=f.URI.revive(s.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=f.URI.revive(s.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=f.URI.revive(s.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=f.URI.revive(s.transformIncomingURIs(n.logsLocation)),n.workspace=s.transformIncomingURIs(n.workspace),n}}e.$Yjc=o}),define(Se[368],De([1,0,8,9,224,243,139,96,71,47,20,46,7,60,38,283,284,43,33]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;let n=class extends w.$Sic{constructor(l,r,c,h,g,C,v,m){super(l,r,c,h,C,v,m),this.pb=g,this.nb=new t}X(l,r){switch(l.type){case"server":return new u.$4jc(l);case"pipeServer":return new u.$5jc(l);case"executable":return new u.$6jc(l,r.type)}return super.X(l,r)}fb(l,r){const c=u.$6jc.platformAdapterExecutable(r.getAllExtensionDescriptions(),l.type);if(c)return new p.$6M(c.command,c.args,c.options)}Y(){return new L.$Gac}async $runInTerminal(l,r){if(l.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(N=>{this.nb.onTerminalClosed(N)}));const c=await this.P.getConfigProvider(),h=this.pb.getDefaultShell(!0),g=this.pb.getDefaultShellArgs(!0),C=l.title||f.localize(0,null),v=JSON.stringify({shell:h,shellArgs:g});let m=await this.nb.checkout(v,C),y,P=!1;if(m)y=l.cwd;else{const N={shellPath:h,shellArgs:g,cwd:l.cwd,name:C,iconPath:new p.$XM("debug")};P=!0,m=this.pb.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.nb.insert(m,v)}m.show(!0);const j=await m.processId;P?await new Promise(N=>setTimeout(N,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0||h.indexOf("cmd.exe")>=0?m.sendText("cls"):h.indexOf("bash")>=0?m.sendText("clear"):O.$c?m.sendText("cls"):m.sendText("clear"));const U=(0,b.$8jc)(h,l.args,!!l.argsCanBeInterpretedByShell,y,l.env);m.sendText(U);const z=this.onDidTerminateDebugSession(N=>{N.id===r&&(this.nb.free(m),z.dispose())});return j}else if(l.kind==="external")return a(l,await this.P.getConfigProvider());return super.$runInTerminal(l,r)}};e.$9jc=n,e.$9jc=n=Je([He(0,M.$fO),He(1,E.$$hc),He(2,k.$Mic),He(3,o.$bic),He(4,I.$zic),He(5,$.$nic),He(6,S.$Pic),He(7,i.$BO)],n);let s;function a(d,l){if(!s)if(O.$c)s=new R.$r_b;else if(O.$d)s=new R.$s_b;else if(O.$e)s=new R.$t_b;else throw new Error("external terminals not supported on this platform");const r=l.getConfiguration("terminal");return s.runInTerminal(d.title,d.cwd,d.args,d.env||{},r.external||{})}class t{constructor(){this.b=new Map}async checkout(l,r){const h=[...this.b.entries()].map(([g,C])=>(0,D.$4g)(async v=>{if(g.name!==r||C.lastUsedAt!==-1&&await(0,b.$7jc)(await g.processId))return null;const m=Date.now();return C.lastUsedAt+t.a>m||v.isCancellationRequested||C.config!==l?null:(C.lastUsedAt=m,g)}));return await(0,D.$jh)(h,g=>!!g)}insert(l,r){this.b.set(l,{lastUsedAt:Date.now(),config:r})}free(l){const r=this.b.get(l);r&&(r.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}t.a=1e3}),define(Se[369],De([1,0,17,2,103,38,72,43,42,46,20,27,95,16,13,91,23,62,60]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;let n=class extends p.$Cjc{constructor(a,t,d,l,r,c,h,g,C){super(a,t,d,l,r,c,h,g),this.C=d,this.D=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const d=t;if(!t.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const l=p.TaskHandleDTO.from(d,this.C),r=await this.a.$getTaskExecution(l);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.z(r,t);return this.a.$executeTask(l).catch(()=>{}),c}else{const l=p.TaskDTO.from(t,a);if(l===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(l.execution)&&await this.y(l,t,!1);const r=await this.z(await this.a.$getTaskExecution(l),t);return this.a.$executeTask(l).catch(()=>{}),r}}v(a,t,d,l){const r=[];if(l)for(const c of l){this.A(c,d),(!c.definition||!a[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=p.TaskDTO.from(c,d.extension);h&&(r.push(h),p.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,c,!0)))}return{tasks:r,extension:d.extension}}async w(a){return a}async G(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const d=O.URI.file((0,o.homedir)());t=new $.$yi({uri:d,name:b.$Og(d),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const d=O.URI.revive(a),l={process:void 0,variables:Object.create(null)},r=await this.b.resolveWorkspaceFolder(d),c=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),g=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(c);for(const C of t.variables)l.variables[C]=await h.resolveAsync(g,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(D.$tc);for(let v=0;v<C.length;v++)C[v]=await h.resolveAsync(g,C[v])}l.process=await f.win32.findExecutable(await h.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(g,t.process.cwd):void 0,C)}return l}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,d){return f.win32.findExecutable(a,t,d)}};e.$1jc=n,e.$1jc=n=Je([He(0,M.$fO),He(1,I.$vO),He(2,R.$$hc),He(3,L.$qO),He(4,w.$bic),He(5,k.$zic),He(6,E.$yj),He(7,u.$Nhc),He(8,i.$Pic)],n)}),define(Se[370],De([1,0,62,60]),function(re,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class f extends O.$Qic{m(){return(0,D.homedir)()}}e.$Gkc=f}),define(Se[156],De([1,0,19,8,22,41,16,17,23,2,36]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=e.$$ic=e.$0ic=void 0;class I{constructor(i,n,s,a){this.d=i,this.e=n,this.f=s,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const s=this.d.folderQueries||[],a=new f.$ce(n);return new Promise((t,d)=>{this.a=new S(i);let l=!1;const r=(c,h)=>{if(!l&&!this.b){const g=this.h(c);u(c)&&typeof this.d.maxResults=="number"&&this.c+g>this.d.maxResults&&(this.b=!0,l=!0,a.cancel(),c=this.j(c,this.d.maxResults-this.c));const C=this.h(c);this.c+=C,(C>0||!u(c))&&this.a.add(c,h)}};Promise.all(s.map((c,h)=>this.k(c,g=>r(g,h),a.token))).then(c=>{a.dispose(),this.a.flush();const h=c.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||h,messages:(0,D.$Rb)(c.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.g}})},c=>{a.dispose();const h=(0,R.$2i)(c);d(new Error(h))})})}h(i){return u(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const s=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:s.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,s){const a=new M.$DK(this.d,i),t=[],d={report:c=>{if(!this.l(c))return;const h=i.folder.scheme===L.Schemas.file?(0,M.$EK)(()=>this.f.readdir($.$Qg(c.uri))):void 0,g=$.$Tg(i.folder,c.uri);if(g){const C=a.includedInQuery(g,w.$nc(g),h);(0,O.$3g)(C)?t.push(C.then(v=>{v&&n(c)})):C&&n(c)}}},l=this.n(i),r=await this.e.provideTextSearchResults(p(this.d.contentPattern),l,d,s);return t.length&&await Promise.all(t),r}l(i){if(u(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,M.$CK)(this.d.includePattern,i.includePattern),s=(0,M.$CK)(this.d.excludePattern,i.excludePattern),a={folder:k.URI.from(i.folder),excludes:s,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$0ic=I;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new b(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$Kg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(E(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$$ic=S;function E(o){return u(o)?{preview:{matches:(0,D.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,D.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function u(o){return!!o.preview}e.$_ic=u;class b{constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<b.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},b.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$ajc=b,b.a=4e3,b.b=50}),define(Se[97],De([1,0,3,6,5,363,20,66,13,2,156]),function(re,e,D,O,f,R,L,w,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=e.$bjc=void 0,e.$bjc=(0,f.$ei)("IExtHostSearch");let I=class{constructor(u,b,o){this.k=u,this.l=b,this.n=o,this.c=this.k.getProxy(O.$1L.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$9ic}o(u){return this.l.transformOutgoingScheme(u)}registerTextSearchProvider(u,b){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const o=this.d++;return this.e.set(o,b),this.c.$registerTextSearchProvider(o,this.o(u)),(0,D.$Rc)(()=>{this.g.delete(u),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(u,b){if(this.i.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.i.add(u);const o=this.d++;return this.h.set(o,b),this.c.$registerFileSearchProvider(o,this.o(u)),(0,D.$Rc)(()=>{this.i.delete(u),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(u,b,o,i){const n=p(o),s=this.h.get(u);if(s)return this.j.fileSearch(n,s,a=>{this.c.$handleFileMatch(u,b,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,b,o){return{messages:[]}}$clearCache(u){return this.j.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,b,o,i){const n=this.e.get(u);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const s=p(o);return this.q(s,n).search(t=>this.c.$handleTextMatch(u,b,t),i)}$enableExtensionHostSearch(){}q(u,b){return new M.$0ic(u,b,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$cjc=I,e.$cjc=I=Je([He(0,L.$fO),He(1,w.$8hc),He(2,$.$yj)],I);function p(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(S),extraFileResources:E.extraFileResources&&E.extraFileResources.map(u=>k.URI.revive(u))}}e.$djc=p;function S(E){return{...E,folder:k.URI.revive(E.folder)}}}),define(Se[371],De([1,0,22,14,4,3,16,40,2,133,180,181,82,25,32,13,65,87,268,6,313,342,91,314,319,299,320,321,322,300,288,33,323,43,324,96,149,325,302,315,326,327,72,71,316,47,328,69,329,59,27,343,344,317,303,330,331,115,116,304,362,333,274,334,345,335,154,305,336,337,338,20,339,97,117,340,306,341,118,93,95,90,46,346,347,318,348,349,70,15,7,307,66,308,92,350,351,148,38,281,114,26,94]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d,l,r,c,h,g,C,v,m,y,P,j,U,z,N,A,T,F,G,K,X,Q,Z,ie,ee,we,ue,ae,H,fe,he,se,ce,le,de,q,_,ge,me,Ae,ye,Re,Le,ze,B,V,x,Y,$e,ve,Te,Ve,Qe,tt,at,dt,ot,rt,Pe,Ie,Ge,te,oe,Ce,Ke,xe,st,Ne,bt,Ct,At,qt,Gt,Rt,Zt,xt,si,oi,et,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;function _t($t){const pt=$t.get(ae.$vO),Kt=$t.get(ue.$Rhc),zt=$t.get(ee.$dic),Wt=$t.get(Z.$Mic),ft=$t.get(xt.$$hc),Mt=$t.get(Pe.$zO),ei=$t.get(P.$bic),ti=$t.get(Ct.$8hc),Xe=$t.get($e.$fO),Vt=$t.get(dt.$wic),Yt=$t.get(ot.$eic),ni=$t.get(u.$zj),vt=$t.get(u.$yj),Ut=$t.get(xe.$yAb),Ot=$t.get(t.$Nhc),Lt=$t.get(Zt.$Rjc),ri=$t.get(Ve.$Eic),Bt=$t.get(X.$nic),Jt=$t.get(q.$Iic);Xe.set(n.$2L.ExtHostFileSystemInfo,Kt),Xe.set(n.$2L.ExtHostLogLevelServiceShape,ni),Xe.set(n.$2L.ExtHostWorkspace,ft),Xe.set(n.$2L.ExtHostConfiguration,ei),Xe.set(n.$2L.ExtHostExtensionService,Wt),Xe.set(n.$2L.ExtHostStorage,Vt),Xe.set(n.$2L.ExtHostTunnelService,Ut),Xe.set(n.$2L.ExtHostWindow,Lt),Xe.set(n.$2L.ExtHostSecretState,ri),Xe.set(n.$2L.ExtHostTelemetry,Mt),Xe.set(n.$2L.ExtHostEditorTabs,Bt),Xe.set(n.$2L.ExtHostManagedSockets,Jt);const Nt=Xe.set(n.$2L.ExtHostDecorations,$t.get(z.$Xic)),Pt=Xe.set(n.$2L.ExtHostDocumentsAndEditors,$t.get(K.$qO)),yt=Xe.set(n.$2L.ExtHostCommands,$t.get(m.$BO)),kt=Xe.set(n.$2L.ExtHostTerminalService,$t.get(Ie.$zic)),St=Xe.set(n.$2L.ExtHostDebugService,$t.get(U.$Ric)),mi=Xe.set(n.$2L.ExtHostSearch,$t.get(Te.$bjc)),Qt=Xe.set(n.$2L.ExtHostTask,$t.get(rt.$Ejc)),hi=Xe.set(n.$2L.ExtHostOutputService,$t.get(ze.$rjc)),Me=Xe.set(n.$2L.ExtHostLocalization,$t.get(de.$Hic)),je=Xe.set(n.$2L.ExtHostUrls,new At.$Ojc(Xe)),Ee=Xe.set(n.$2L.ExtHostDocuments,new G.$Uhc(Xe,Pt)),ne=Xe.set(n.$2L.ExtHostDocumentContentProviders,new T.$Zic(Xe,Pt,vt)),Oe=Xe.set(n.$2L.ExtHostDocumentSaveParticipant,new F.$1ic(vt,Ee,Xe.getProxy(n.$1L.MainThreadBulkEdits))),Ue=Xe.set(n.$2L.ExtHostNotebook,new ge.$ejc(Xe,yt,Pt,Ee,zt,mi)),_e=Xe.set(n.$2L.ExtHostNotebookDocuments,new Ae.$ljc(Ue)),Ye=Xe.set(n.$2L.ExtHostNotebookEditors,new ye.$mjc(vt,Ue)),lt=Xe.set(n.$2L.ExtHostNotebookKernels,new Re.$njc(Xe,pt,Ue,yt,vt)),Dt=Xe.set(n.$2L.ExtHostNotebookRenderers,new Le.$pjc(Xe,Ue)),Xt=Xe.set(n.$2L.ExtHostNotebookDocumentSaveParticipant,new me.$kjc(vt,Ue,Xe.getProxy(n.$1L.MainThreadBulkEdits))),It=Xe.set(n.$2L.ExtHostEditors,new te.$5hc(Xe,Pt)),Tt=Xe.set(n.$2L.ExtHostTreeViews,new Ke.$Mjc(Xe.getProxy(n.$1L.MainThreadTreeViews),yt,vt)),ii=Xe.set(n.$2L.ExtHostEditorInsets,new v.$6hc(Xe.getProxy(n.$1L.MainThreadEditorInsets),It,pt.remote)),ci=Xe.set(n.$2L.ExtHostDiagnostics,new N.$Thc(Xe,vt,Kt,Pt)),pi=Xe.set(n.$2L.ExtHostLanguages,new le.$ijc(Xe,Ee,yt.converter,ti)),gt=Xe.set(n.$2L.ExtHostLanguageFeatures,new ce.$Vhc(Xe,ti,Ee,yt,ci,vt,Ot,Mt)),Fi=Xe.set(n.$2L.ExtHostFileSystem,new ie.$3ic(Xe,gt)),li=Xe.set(n.$2L.ExtHostFileSystemEventService,new we.$4ic(Xe,vt,Pt)),$i=Xe.set(n.$2L.ExtHostQuickOpen,(0,Y.$vjc)(Xe,ft,yt)),Si=Xe.set(n.$2L.ExtHostSCM,new ve.$xjc(Xe,yt,Ee,vt)),Ni=Xe.set(n.$2L.ExtHostQuickDiff,new x.$ujc(Xe,ti)),Ti=Xe.set(n.$2L.ExtHostShare,new Qe.$yjc(Xe,ti)),ji=Xe.set(n.$2L.ExtHostComments,(0,y.$7hc)(Xe,yt,Ee)),Di=Xe.set(n.$2L.ExtHostProgress,new V.$tjc(Xe.getProxy(n.$1L.MainThreadProgress))),Ji=Xe.set(n.$2L.ExtHostLabelService,new se.$hjc(Xe)),Ci=Xe.set(n.$2L.ExtHostTheming,new oe.$Jjc(Xe)),di=Xe.set(n.$2L.ExtHostAuthentication,new d.$Xhc(Xe)),zi=Xe.set(n.$2L.ExtHostTimeline,new Ce.$Ljc(Xe,yt)),vi=Xe.set(n.$2L.ExtHostWebviews,new qt.$iic(Xe,pt.remote,ft,vt,Ot)),Ii=Xe.set(n.$2L.ExtHostWebviewPanels,new Gt.$lic(Xe,vi,ft)),fn=Xe.set(n.$2L.ExtHostCustomEditors,new j.$mic(Xe,Ee,Yt,vi,Ii)),Qi=Xe.set(n.$2L.ExtHostWebviewViews,new Rt.$Pjc(Xe,vi)),bi=Xe.set(n.$2L.ExtHostTesting,new Ge.$Fjc(Xe,vt,yt,Pt)),Ui=Xe.set(n.$2L.ExtHostUriOpeners,new bt.$Njc(Xe)),Xi=Xe.set(n.$2L.ExtHostProfileContentHandlers,new B.$sjc(Xe));Xe.set(n.$2L.ExtHostInteractive,new fe.$fjc(Xe,Ue,Pt,yt,vt));const Yi=Xe.set(n.$2L.ExtHostInlineChat,new H.$5ic(Xe,yt,Ee,vt)),yi=Xe.set(n.$2L.ExtHostChatProvider,new h.$2hc(Xe,vt,di)),Zi=Xe.set(n.$2L.ExtHostChatAgents2,new c.$1hc(Xe,vt,yt)),xi=Xe.set(n.$2L.ExtHostChatVariables,new g.$3hc(Xe)),Bi=Xe.set(n.$2L.ExtHostChat,new r.$Zhc(Xe)),_i=Xe.set(n.$2L.ExtHostAiRelatedInformation,new s.$Mhc(Xe)),Wi=Xe.set(n.$2L.ExtHostAiEmbeddingVector,new Q.$2ic(Xe)),Pi=Xe.set(n.$2L.ExtHostIssueReporter,new he.$gjc(Xe)),en=Xe.set(n.$2L.ExtHostStatusBar,new at.$Bjc(Xe,yt.converter)),gn=Xe.set(n.$2L.ExtHostSpeech,new tt.$zjc(Xe)),tn=Object.values(n.$2L);Xe.assertRegistered(tn);const mn=new l.$Yhc(Xe,Pt),Ai=new C.$4hc(Xe),Ri=new _.$jjc(Xe,vt),qi=new A.$Yic(Xe);return a.$Whc.register(yt),function(Be,fi,Li){function ct(be){return(ke,We,ut)=>{const Et=be(Ft=>{try{ke.call(We,Ft)}catch(ki){O.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event: ${ki.toString()}`,{cause:ki})),Mt.onExtensionError(Be.identifier,ki)}});return ut?.push(Et),Et}}const mt=function(){let be=!Be.isUnderDevelopment;function ke(){be||(vt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function We(ut){if(Array.isArray(ut))ut.forEach(We);else if(typeof ut=="string")ke();else{const Et=ut;typeof Et.scheme>"u"&&ke(),typeof Et.exclusive=="boolean"&&(0,et.$WF)(Be,"documentFiltersExclusive")}return ut}}(),Mi={getSession(be,ke,We){return di.getSession(Be,be,ke,We)},getSessions(be,ke){return(0,et.$WF)(Be,"authGetSessions"),di.getSessions(Be,be,ke)},async hasSession(be,ke){return(0,et.$WF)(Be,"authSession"),!!await di.getSession(Be,be,ke,{silent:!0})},get onDidChangeSessions(){return ct(di.onDidChangeSessions)},registerAuthenticationProvider(be,ke,We,ut){return di.registerAuthenticationProvider(be,ke,We,ut)}},$n={registerCommand(be,ke,We){return yt.registerCommand(!0,be,ke,We,void 0,Be)},registerTextEditorCommand(be,ke,We){return yt.registerCommand(!0,be,(...ut)=>{const Et=It.getActiveTextEditor();if(!Et){vt.warn("Cannot execute "+be+" because there is no active text editor.");return}return Et.edit(Ft=>{ke.apply(We,[Et,Ft,...ut])}).then(Ft=>{Ft||vt.warn("Edits from command "+be+" were not applied.")},Ft=>{vt.warn("An error occurred while running command "+be,Ft)})},void 0,void 0,Be)},registerDiffInformationCommand:(be,ke,We)=>((0,et.$WF)(Be,"diffCommand"),yt.registerCommand(!0,be,async(...ut)=>{const Et=Pt.activeEditor(!0);if(!Et){vt.warn("Cannot execute "+be+" because there is no active text editor.");return}const Ft=await It.getDiffInformation(Et.id);ke.apply(We,[Ft,...ut])},void 0,void 0,Be)),executeCommand(be,...ke){return yt.executeCommand(be,...ke)},getCommands(be=!1){return yt.getCommands(be)}},Vi={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Ai.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ct(kt.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$WF)(Be,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$WF)(Be,"telemetry"),ct(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Pe.$yO)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,ke){return Pe.$xO.validateSender(be),Mt.instantiateLogger(Be,be,ke)},openExternal(be,ke){return Lt.openUri(be,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===pt.environment.appUriScheme)return je.createAppUri(be);try{return await Lt.asExternalUri(be,{allowTunneling:!!pt.remote.authority})}catch(ke){if((0,L.$og)(be,L.Schemas.http)||(0,L.$og)(be,L.Schemas.https))return be;throw ke}},get remoteName(){return(0,b.$ml)(pt.remote.authority)},get remoteAuthority(){return(0,et.$WF)(Be,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return ct(vt.onDidChangeLogLevel)},registerIssueUriRequestHandler(be){return(0,et.$WF)(Be,"handleIssueUri"),Pi.registerIssueUriRequestHandler(Be,be)},registerIssueDataProvider(be){return(0,et.$WF)(Be,"handleIssueUri"),Pi.registerIssueDataProvider(Be,be)},get appQuality(){return(0,et.$WF)(Be,"resolvers"),pt.quality},get appCommit(){return(0,et.$WF)(Be,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Vi);const Oi={createTestController(be,ke,We){return bi.createTestController(Be,be,ke,We)},createTestObserver(){return(0,et.$WF)(Be,"testObserver"),bi.createTestObserver()},runTests(be){return(0,et.$WF)(Be,"testObserver"),bi.runTests(be)},get onDidChangeTestResults(){return(0,et.$WF)(Be,"testObserver"),ct(bi.onResultsChanged)},get testResults(){return(0,et.$WF)(Be,"testObserver"),bi.results}},Ei=pt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,nn={getExtension(be,ke){(0,et.$VF)(Be,"extensionsAny")||(ke=!1);const We=fi.mine.getExtensionDescription(be);if(We)return new Z.$Nic(Wt,Be.identifier,We,Ei,!1);if(ke){const ut=fi.all.getExtensionDescription(be);if(ut)return new Z.$Nic(Wt,Be.identifier,ut,Ei,!0)}},get all(){const be=[];for(const ke of fi.mine.getAllExtensionDescriptions())be.push(new Z.$Nic(Wt,Be.identifier,ke,Ei,!1));return be},get allAcrossExtensionHosts(){(0,et.$WF)(Be,"extensionsAny");const be=new S.$ym(fi.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ke=[];for(const We of fi.all.getAllExtensionDescriptions()){const ut=!be.has(We.identifier);ke.push(new Z.$Nic(Wt,Be.identifier,We,Ei,ut))}return ke},get onDidChange(){return(0,et.$VF)(Be,"extensionsAny")?ct(f.Event.any(fi.mine.onDidChange,fi.all.onDidChange)):ct(fi.mine.onDidChange)}},rn={createDiagnosticCollection(be){return ci.createDiagnosticCollection(Be.identifier,be)},get onDidChangeDiagnostics(){return ct(ci.onDidChangeDiagnostics)},getDiagnostics:be=>ci.getDiagnostics(be),getLanguages(){return pi.getLanguages()},setTextDocumentLanguage(be,ke){return pi.changeLanguage(be.uri,ke)},match(be,ke){const We=st.LanguageSelector.from(be);let ut;return(0,M.$Ot)(We)&&(ut=Ue.notebookDocuments.find(Et=>!!Et.getCell(ke.uri))?.apiNotebook),(0,M.$Nt)(We,ke.uri,ke.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(be,ke,We){return gt.registerCodeActionProvider(Be,mt(be),ke,We)},registerDocumentPasteEditProvider(be,ke,We){return(0,et.$WF)(Be,"documentPaste"),gt.registerDocumentPasteEditProvider(Be,mt(be),ke,We)},registerCodeLensProvider(be,ke){return gt.registerCodeLensProvider(Be,mt(be),ke)},registerDefinitionProvider(be,ke){return gt.registerDefinitionProvider(Be,mt(be),ke)},registerDeclarationProvider(be,ke){return gt.registerDeclarationProvider(Be,mt(be),ke)},registerImplementationProvider(be,ke){return gt.registerImplementationProvider(Be,mt(be),ke)},registerTypeDefinitionProvider(be,ke){return gt.registerTypeDefinitionProvider(Be,mt(be),ke)},registerHoverProvider(be,ke){return gt.registerHoverProvider(Be,mt(be),ke,Be.identifier)},registerEvaluatableExpressionProvider(be,ke){return gt.registerEvaluatableExpressionProvider(Be,mt(be),ke,Be.identifier)},registerInlineValuesProvider(be,ke){return gt.registerInlineValuesProvider(Be,mt(be),ke,Be.identifier)},registerDocumentHighlightProvider(be,ke){return gt.registerDocumentHighlightProvider(Be,mt(be),ke)},registerMultiDocumentHighlightProvider(be,ke){return gt.registerMultiDocumentHighlightProvider(Be,mt(be),ke)},registerLinkedEditingRangeProvider(be,ke){return gt.registerLinkedEditingRangeProvider(Be,mt(be),ke)},registerReferenceProvider(be,ke){return gt.registerReferenceProvider(Be,mt(be),ke)},registerRenameProvider(be,ke){return gt.registerRenameProvider(Be,mt(be),ke)},registerNewSymbolNamesProvider(be,ke){return(0,et.$WF)(Be,"newSymbolNamesProvider"),gt.registerNewSymbolNamesProvider(Be,mt(be),ke)},registerDocumentSymbolProvider(be,ke,We){return gt.registerDocumentSymbolProvider(Be,mt(be),ke,We)},registerWorkspaceSymbolProvider(be){return gt.registerWorkspaceSymbolProvider(Be,be)},registerDocumentFormattingEditProvider(be,ke){return gt.registerDocumentFormattingEditProvider(Be,mt(be),ke)},registerDocumentRangeFormattingEditProvider(be,ke){return gt.registerDocumentRangeFormattingEditProvider(Be,mt(be),ke)},registerOnTypeFormattingEditProvider(be,ke,We,...ut){return gt.registerOnTypeFormattingEditProvider(Be,mt(be),ke,[We].concat(ut))},registerDocumentSemanticTokensProvider(be,ke,We){return gt.registerDocumentSemanticTokensProvider(Be,mt(be),ke,We)},registerDocumentRangeSemanticTokensProvider(be,ke,We){return gt.registerDocumentRangeSemanticTokensProvider(Be,mt(be),ke,We)},registerSignatureHelpProvider(be,ke,We,...ut){return typeof We=="object"?gt.registerSignatureHelpProvider(Be,mt(be),ke,We):gt.registerSignatureHelpProvider(Be,mt(be),ke,typeof We>"u"?[]:[We,...ut])},registerCompletionItemProvider(be,ke,...We){return gt.registerCompletionItemProvider(Be,mt(be),ke,We)},registerInlineCompletionItemProvider(be,ke,We){return ke.handleDidShowCompletionItem&&(0,et.$WF)(Be,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,et.$WF)(Be,"inlineCompletionsAdditions"),We&&(0,et.$WF)(Be,"inlineCompletionsAdditions"),gt.registerInlineCompletionsProvider(Be,mt(be),ke,We)},registerInlineEditProvider(be,ke){return(0,et.$WF)(Be,"inlineEdit"),gt.registerInlineEditProvider(Be,mt(be),ke)},registerDocumentLinkProvider(be,ke){return gt.registerDocumentLinkProvider(Be,mt(be),ke)},registerColorProvider(be,ke){return gt.registerColorProvider(Be,mt(be),ke)},registerFoldingRangeProvider(be,ke){return gt.registerFoldingRangeProvider(Be,mt(be),ke)},registerSelectionRangeProvider(be,ke){return gt.registerSelectionRangeProvider(Be,be,ke)},registerCallHierarchyProvider(be,ke){return gt.registerCallHierarchyProvider(Be,be,ke)},registerTypeHierarchyProvider(be,ke){return gt.registerTypeHierarchyProvider(Be,be,ke)},setLanguageConfiguration:(be,ke)=>gt.setLanguageConfiguration(Be,be,ke),getTokenInformationAtPosition(be,ke){return(0,et.$WF)(Be,"tokenInformation"),pi.tokenAtPosition(be,ke)},registerInlayHintsProvider(be,ke){return gt.registerInlayHintsProvider(Be,be,ke)},createLanguageStatusItem(be,ke){return pi.createLanguageStatusItem(Be,be,ke)},registerDocumentDropEditProvider(be,ke,We){return gt.registerDocumentOnDropEditProvider(Be,be,ke,(0,et.$VF)(Be,"dropMetadata")?We:void 0)}},sn={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(be,ke,We){$.URI.isUri(be)&&be.scheme===L.Schemas.vscodeRemote&&!be.authority&&Ot.report("workspace.showTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri(be)?Promise.resolve(on.openTextDocument(be)):Promise.resolve(be));return It.showTextDocument(ut,ke,We)},createTextEditorDecorationType(be){return It.createTextEditorDecorationType(Be,be)},onDidChangeActiveTextEditor(be,ke,We){return ct(It.onDidChangeActiveTextEditor)(be,ke,We)},onDidChangeVisibleTextEditors(be,ke,We){return ct(It.onDidChangeVisibleTextEditors)(be,ke,We)},onDidChangeTextEditorSelection(be,ke,We){return ct(It.onDidChangeTextEditorSelection)(be,ke,We)},onDidChangeTextEditorOptions(be,ke,We){return ct(It.onDidChangeTextEditorOptions)(be,ke,We)},onDidChangeTextEditorVisibleRanges(be,ke,We){return ct(It.onDidChangeTextEditorVisibleRanges)(be,ke,We)},onDidChangeTextEditorViewColumn(be,ke,We){return ct(It.onDidChangeTextEditorViewColumn)(be,ke,We)},onDidCloseTerminal(be,ke,We){return ct(kt.onDidCloseTerminal)(be,ke,We)},onDidOpenTerminal(be,ke,We){return ct(kt.onDidOpenTerminal)(be,ke,We)},onDidChangeActiveTerminal(be,ke,We){return ct(kt.onDidChangeActiveTerminal)(be,ke,We)},onDidChangeTerminalDimensions(be,ke,We){return(0,et.$WF)(Be,"terminalDimensions"),ct(kt.onDidChangeTerminalDimensions)(be,ke,We)},onDidChangeTerminalState(be,ke,We){return ct(kt.onDidChangeTerminalState)(be,ke,We)},onDidWriteTerminalData(be,ke,We){return(0,et.$WF)(Be,"terminalDataWriteEvent"),ct(kt.onDidWriteTerminalData)(be,ke,We)},onDidExecuteTerminalCommand(be,ke,We){return(0,et.$WF)(Be,"terminalExecuteCommandEvent"),ct(kt.onDidExecuteTerminalCommand)(be,ke,We)},get state(){return Lt.getState(Be)},onDidChangeWindowState(be,ke,We){return ct(Lt.onDidChangeWindowState)(be,ke,We)},showInformationMessage(be,...ke){return Ri.showMessage(Be,w.default.Info,be,ke[0],ke.slice(1))},showWarningMessage(be,...ke){return Ri.showMessage(Be,w.default.Warning,be,ke[0],ke.slice(1))},showErrorMessage(be,...ke){return Ri.showMessage(Be,w.default.Error,be,ke[0],ke.slice(1))},showQuickPick(be,ke,We){return $i.showQuickPick(Be,be,ke,We)},showWorkspaceFolderPick(be){return $i.showWorkspaceFolderPick(be)},showInputBox(be,ke){return $i.showInput(be,ke)},showOpenDialog(be){return qi.showOpenDialog(Be,be)},showSaveDialog(be){return qi.showSaveDialog(be)},createStatusBarItem(be,ke,We){let ut,Et,Ft;return typeof be=="string"?(ut=be,Et=ke,Ft=We):(Et=be,Ft=ke),en.createStatusBarEntry(Be,ut,Et,Ft)},setStatusBarMessage(be,ke){return en.setStatusBarMessage(be,ke)},withScmProgress(be){return Ot.report("window.withScmProgress",Be,"Use 'withProgress' instead."),Di.withProgress(Be,{location:Ne.ProgressLocation.SourceControl},(ke,We)=>be({report(ut){}}))},withProgress(be,ke){return Di.withProgress(Be,be,ke)},createOutputChannel(be,ke){return hi.createOutputChannel(be,ke,Be)},createWebviewPanel(be,ke,We,ut){return Ii.createWebviewPanel(Be,be,ke,We,ut)},createWebviewTextEditorInset(be,ke,We,ut){return(0,et.$WF)(Be,"editorInsets"),ii.createWebviewEditorInset(be,ke,We,ut,Be)},createTerminal(be,ke,We){return typeof be=="object"?"pty"in be?kt.createExtensionTerminal(be):kt.createTerminalFromOptions(be):kt.createTerminal(be,ke,We)},registerTerminalLinkProvider(be){return kt.registerLinkProvider(be)},registerTerminalProfileProvider(be,ke){return kt.registerProfileProvider(Be,be,ke)},registerTerminalQuickFixProvider(be,ke){return(0,et.$WF)(Be,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(be,Be.identifier.value,ke)},registerTreeDataProvider(be,ke){return Tt.registerTreeDataProvider(be,ke,Be)},createTreeView(be,ke){return Tt.createTreeView(be,ke,Be)},registerWebviewPanelSerializer:(be,ke)=>Ii.registerWebviewPanelSerializer(Be,be,ke),registerCustomEditorProvider:(be,ke,We={})=>fn.registerCustomEditorProvider(Be,be,ke,We),registerFileDecorationProvider(be){return Nt.registerFileDecorationProvider(be,Be)},registerUriHandler(be){return je.registerUriHandler(Be,be)},createQuickPick(){return $i.createQuickPick(Be)},createInputBox(){return $i.createInputBox(Be)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(be,ke,We){return ct(Ci.onDidChangeActiveColorTheme)(be,ke,We)},registerWebviewViewProvider(be,ke,We){return Qi.registerWebviewViewProvider(Be,be,ke,We?.webviewOptions)},get activeNotebookEditor(){return Ue.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,ke,We){return ct(Ue.onDidChangeActiveNotebookEditor)(be,ke,We)},get visibleNotebookEditors(){return Ue.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Ue.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(be,ke,We){return ct(Ye.onDidChangeNotebookEditorSelection)(be,ke,We)},onDidChangeNotebookEditorVisibleRanges(be,ke,We){return ct(Ye.onDidChangeNotebookEditorVisibleRanges)(be,ke,We)},showNotebookDocument(be,ke){return Ue.showNotebookDocument(be,ke)},registerExternalUriOpener(be,ke,We){return(0,et.$WF)(Be,"externalUriOpener"),Ui.registerExternalUriOpener(Be.identifier,be,ke,We)},registerProfileContentHandler(be,ke){return(0,et.$WF)(Be,"profileContentHandlers"),Xi.registerProfileContentHandler(Be,be,ke)},registerQuickDiffProvider(be,ke,We,ut){return(0,et.$WF)(Be,"quickDiffProvider"),Ni.registerQuickDiffProvider(mt(be),ke,We,ut)},get tabGroups(){return Bt.tabGroups},registerShareProvider(be,ke){return(0,et.$WF)(Be,"shareProvider"),Ti.registerShareProvider(mt(be),ke)}},on={get rootPath(){return Ot.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(be){throw new O.$9("rootPath")},getWorkspaceFolder(be){return ft.getWorkspaceFolder(be)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(be){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(be){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(be,ke,...We)=>ft.updateWorkspaceFolders(Be,be,ke||0,...We),onDidChangeWorkspaceFolders:function(be,ke,We){return ct(ft.onDidChangeWorkspace)(be,ke,We)},asRelativePath:(be,ke)=>ft.getRelativePath(be,ke),findFiles:(be,ke,We,ut)=>ft.findFiles(be,ke,We,Be.identifier,ut),findFiles2:(be,ke,We)=>((0,et.$WF)(Be,"findFiles2"),ft.findFiles2(be,ke,Be.identifier,We)),findTextInFiles:(be,ke,We,ut)=>{(0,et.$WF)(Be,"findTextInFiles");let Et,Ft;return typeof ke=="object"?(Et=ke,Ft=We):(Et={},Ft=ke,ut=We),ft.findTextInFiles(be,Et||{},Ft,Be.identifier,ut)},save:be=>ft.save(be),saveAs:be=>ft.saveAs(be),saveAll:be=>ft.saveAll(be),applyEdit(be,ke){return mn.applyWorkspaceEdit(be,Be,ke)},createFileSystemWatcher:(be,ke,We,ut)=>{let Et;return typeof ke=="boolean"?Et={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!ut,correlate:!1}:ke&&((0,et.$WF)(Be,"createFileSystemWatcher"),Et={...ke,correlate:!0}),li.createFileSystemWatcher(ft,Be,be,Et)},get textDocuments(){return Ee.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new O.$9("textDocuments")},openTextDocument(be){let ke;const We=be;if(typeof be=="string")ke=Promise.resolve($.URI.file(be));else if($.URI.isUri(be))ke=Promise.resolve(be);else if(!We||typeof We=="object")ke=Ee.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(ut=>(ut.scheme===L.Schemas.vscodeRemote&&!ut.authority&&Ot.report("workspace.openTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority."),Ee.ensureDocumentData(ut).then(Et=>Et.document)))},onDidOpenTextDocument:(be,ke,We)=>ct(Ee.onDidAddDocument)(be,ke,We),onDidCloseTextDocument:(be,ke,We)=>ct(Ee.onDidRemoveDocument)(be,ke,We),onDidChangeTextDocument:(be,ke,We)=>ct(Ee.onDidChangeDocument)(be,ke,We),onDidSaveTextDocument:(be,ke,We)=>ct(Ee.onDidSaveDocument)(be,ke,We),onWillSaveTextDocument:(be,ke,We)=>ct(Oe.getOnWillSaveTextDocumentEvent(Be))(be,ke,We),get notebookDocuments(){return Ue.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,ke){let We;if($.URI.isUri(be))We=be,await Ue.openNotebookDocument(be);else if(typeof be=="string")We=$.URI.revive(await Ue.createNotebookDocument({viewType:be,content:ke}));else throw new Error("Invalid arguments");return Ue.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(be,ke,We){return ct(_e.onDidSaveNotebookDocument)(be,ke,We)},onDidChangeNotebookDocument(be,ke,We){return ct(_e.onDidChangeNotebookDocument)(be,ke,We)},onWillSaveNotebookDocument(be,ke,We){return ct(Xt.getOnWillSaveNotebookDocumentEvent(Be))(be,ke,We)},get onDidOpenNotebookDocument(){return ct(Ue.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Ue.onDidCloseNotebookDocument)},registerNotebookSerializer(be,ke,We,ut){return Ue.registerNotebookSerializer(Be,be,ke,We,(0,et.$VF)(Be,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(be,ke,We)=>ct(Li.onDidChangeConfiguration)(be,ke,We),getConfiguration(be,ke){return ke=arguments.length===1?void 0:ke,Li.getConfiguration(be,ke,Be)},registerTextDocumentContentProvider(be,ke){return ne.registerTextDocumentContentProvider(be,ke)},registerTaskProvider:(be,ke)=>(Ot.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Be,be,ke)),registerFileSystemProvider(be,ke,We){return(0,R.$Qc)(Fi.registerFileSystemProvider(Be,be,ke,We),zt.addFileSystemProvider(be,ke,We))},get fs(){return zt.value},registerFileSearchProvider:(be,ke)=>((0,et.$WF)(Be,"fileSearchProvider"),mi.registerFileSearchProvider(be,ke)),registerTextSearchProvider:(be,ke)=>((0,et.$WF)(Be,"textSearchProvider"),mi.registerTextSearchProvider(be,ke)),registerRemoteAuthorityResolver:(be,ke)=>((0,et.$WF)(Be,"resolvers"),Wt.registerRemoteAuthorityResolver(be,ke)),registerResourceLabelFormatter:be=>((0,et.$WF)(Be,"resolvers"),Ji.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,et.$WF)(Be,"resolvers"),Wt.getRemoteExecServer(be)),onDidCreateFiles:(be,ke,We)=>ct(li.onDidCreateFile)(be,ke,We),onDidDeleteFiles:(be,ke,We)=>ct(li.onDidDeleteFile)(be,ke,We),onDidRenameFiles:(be,ke,We)=>ct(li.onDidRenameFile)(be,ke,We),onWillCreateFiles:(be,ke,We)=>ct(li.getOnWillCreateFileEvent(Be))(be,ke,We),onWillDeleteFiles:(be,ke,We)=>ct(li.getOnWillDeleteFileEvent(Be))(be,ke,We),onWillRenameFiles:(be,ke,We)=>ct(li.getOnWillRenameFileEvent(Be))(be,ke,We),openTunnel:be=>((0,et.$WF)(Be,"tunnels"),Ut.openTunnel(Be,be).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,et.$WF)(Be,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(be,ke,We)=>((0,et.$WF)(Be,"tunnels"),ct(Ut.onDidChangeTunnels)(be,ke,We)),registerPortAttributesProvider:(be,ke)=>((0,et.$WF)(Be,"portsAttributes"),Ut.registerPortsAttributesProvider(be,ke)),registerTunnelProvider:(be,ke)=>((0,et.$WF)(Be,"tunnelFactory"),Ut.registerTunnelProvider(be,ke)),registerTimelineProvider:(be,ke)=>((0,et.$WF)(Be,"timeline"),zi.registerTimelineProvider(be,ke,Be.identifier,yt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:be=>((0,et.$WF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,ke,We)=>ct(ft.onDidGrantWorkspaceTrust)(be,ke,We),registerEditSessionIdentityProvider:(be,ke)=>((0,et.$WF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(be,ke)),onWillCreateEditSessionIdentity:(be,ke,We)=>((0,et.$WF)(Be,"editSessionIdentityProvider"),ct(ft.getOnWillCreateEditSessionIdentityEvent(Be))(be,ke,We)),registerCanonicalUriProvider:(be,ke)=>((0,et.$WF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider(be,ke)),getCanonicalUri:(be,ke,We)=>((0,et.$WF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri(be,ke,We))},an={get inputBox(){return Ot.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Be)},createSourceControl(be,ke,We){return Si.createSourceControl(Be,be,ke,We)}},cn={createCommentController(be,ke){return ji.createCommentController(Be,be,ke)}},bn={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},registerDebugVisualizationProvider(be,ke){return(0,et.$WF)(Be,"debugVisualization"),St.registerDebugVisualizationProvider(Be,be,ke)},registerDebugVisualizationTreeProvider(be,ke){return(0,et.$WF)(Be,"debugVisualization"),St.registerDebugVisualizationTree(Be,be,ke)},onDidStartDebugSession(be,ke,We){return ct(St.onDidStartDebugSession)(be,ke,We)},onDidTerminateDebugSession(be,ke,We){return ct(St.onDidTerminateDebugSession)(be,ke,We)},onDidChangeActiveDebugSession(be,ke,We){return ct(St.onDidChangeActiveDebugSession)(be,ke,We)},onDidReceiveDebugSessionCustomEvent(be,ke,We){return ct(St.onDidReceiveDebugSessionCustomEvent)(be,ke,We)},onDidChangeBreakpoints(be,ke,We){return ct(St.onDidChangeBreakpoints)(be,ke,We)},onDidChangeStackFrameFocus(be,ke,We){return(0,et.$WF)(Be,"debugFocus"),ct(St.onDidChangeStackFrameFocus)(be,ke,We)},registerDebugConfigurationProvider(be,ke,We){return St.registerDebugConfigurationProvider(be,ke,We||si.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,ke){return St.registerDebugAdapterDescriptorFactory(Be,be,ke)},registerDebugAdapterTrackerFactory(be,ke){return St.registerDebugAdapterTrackerFactory(be,ke)},startDebugging(be,ke,We){return!We||typeof We=="object"&&"configuration"in We?St.startDebugging(be,ke,{parentSession:We}):St.startDebugging(be,ke,We||{})},stopDebugging(be){return St.stopDebugging(be)},addBreakpoints(be){return St.addBreakpoints(be)},removeBreakpoints(be){return St.removeBreakpoints(be)},asDebugSourceUri(be,ke){return St.asDebugSourceUri(be,ke)}},wn={registerTaskProvider:(be,ke)=>Qt.registerTaskProvider(Be,be,ke),fetchTasks:be=>Qt.fetchTasks(be),executeTask:be=>Qt.executeTask(Be,be),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(be,ke,We)=>ct(Qt.onDidStartTask)(be,ke,We),onDidEndTask:(be,ke,We)=>ct(Qt.onDidEndTask)(be,ke,We),onDidStartTaskProcess:(be,ke,We)=>ct(Qt.onDidStartTaskProcess)(be,ke,We),onDidEndTaskProcess:(be,ke,We)=>ct(Qt.onDidEndTaskProcess)(be,ke,We)},ln={createNotebookController(be,ke,We,ut,Et){return lt.createNotebookController(Be,be,ke,We,ut,(0,et.$VF)(Be,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(be,ke)=>Ue.registerNotebookCellStatusBarItemProvider(Be,be,ke),createRendererMessaging(be){return Dt.createRendererMessaging(Be,be)},createNotebookControllerDetectionTask(be){return(0,et.$WF)(Be,"notebookKernelSource"),lt.createNotebookControllerDetectionTask(Be,be)},registerKernelSourceActionProvider(be,ke){return(0,et.$WF)(Be,"notebookKernelSource"),lt.registerKernelSourceActionProvider(Be,be,ke)},onDidChangeNotebookCellExecutionState(be,ke,We){return(0,et.$WF)(Be,"notebookCellExecutionState"),ct(lt.onDidChangeNotebookCellExecutionState)(be,ke,We)}},Hi={t(...be){if(typeof be[0]=="string"){const ke=be.shift(),We=!be||typeof be[0]!="object"?be:be[0];return Me.getMessage(Be.identifier.value,{message:ke,args:We})}return Me.getMessage(Be.identifier.value,be[0])},get bundle(){return Me.getBundle(Be.identifier.value)},get uri(){return Me.getBundleUri(Be.identifier.value)}},un={_version:1,registerInteractiveEditorSessionProvider(be,ke){return(0,et.$WF)(Be,"interactive"),Yi.registerProvider(Be,be,ke)},registerInteractiveSessionProvider(be,ke){return(0,et.$WF)(Be,"interactive"),Bi.registerChatProvider(Be,be,ke)},sendInteractiveRequestToProvider(be,ke){return(0,et.$WF)(Be,"interactive"),Bi.sendInteractiveRequestToProvider(be,ke)},transferChatSession(be,ke){return(0,et.$WF)(Be,"interactive"),Bi.transferChatSession(be,ke)}},hn={getRelatedInformation(be,ke){return(0,et.$WF)(Be,"aiRelatedInformation"),_i.getRelatedInformation(Be,be,ke)},registerRelatedInformationProvider(be,ke){return(0,et.$WF)(Be,"aiRelatedInformation"),_i.registerRelatedInformationProvider(Be,be,ke)},registerEmbeddingVectorProvider(be,ke){return(0,et.$WF)(Be,"aiRelatedInformation"),Wi.registerEmbeddingVectorProvider(Be,be,ke)}},dn={registerChatResponseProvider(be,ke,We){return(0,et.$WF)(Be,"chatProvider"),yi.registerLanguageModel(Be,be,ke,We)},registerChatVariableResolver(be,ke,We){return(0,et.$WF)(Be,"chatVariableResolver"),xi.registerVariableResolver(Be,be,ke,We)},registerMappedEditsProvider(be,ke){return(0,et.$WF)(Be,"mappedEditsProvider"),gt.registerMappedEditsProvider(Be,be,ke)},createChatParticipant(be,ke){return(0,et.$WF)(Be,"chatParticipant"),Zi.createChatAgent(Be,be,ke)}},pn={requestLanguageModelAccess(be,ke){return(0,et.$WF)(Be,"languageModels"),yi.requestLanguageModelAccess(Be,be,ke)},get languageModels(){return(0,et.$WF)(Be,"languageModels"),yi.getLanguageModelIds()},onDidChangeLanguageModels:(be,ke,We)=>((0,et.$WF)(Be,"languageModels"),yi.onDidChangeProviders(be,ke,We))},vn={registerSpeechProvider(be,ke){return(0,et.$WF)(Be,"speech"),gn.registerProvider(Be.identifier,be,ke)}};return{version:pt.version,ai:hn,authentication:Mi,commands:$n,comments:cn,chat:dn,debug:bn,env:Vi,extensions:nn,interactive:un,l10n:Hi,languages:rn,lm:pn,notebooks:ln,scm:an,speech:vn,tasks:wn,tests:Oi,window:sn,workspace:on,Breakpoint:Ne.$2M,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.$UN,CallHierarchyIncomingCall:Ne.$oM,CallHierarchyItem:Ne.$nM,CallHierarchyOutgoingCall:Ne.$pM,CancellationError:O.$5,CancellationTokenSource:D.$ce,CandidatePortSource:n.CandidatePortSource,CodeAction:Ne.$kM,CodeActionKind:Ne.$lM,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$qM,Color:Ne.$DM,ColorInformation:Ne.$EM,ColorPresentation:Ne.$FM,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$xM,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$yM,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$NM,DebugAdapterExecutable:Ne.$6M,DebugAdapterInlineImplementation:Ne.$9M,DebugAdapterNamedPipeServer:Ne.$8M,DebugAdapterServer:Ne.$7M,DebugConfigurationProviderTriggerKind:si.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$mN,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$eM,DiagnosticRelatedInformation:Ne.$dM,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$3L,DocumentHighlight:Ne.$gM,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$hM,DocumentLink:Ne.$CM,DocumentSymbol:Ne.$jM,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$_M,InlineValueText:Ne.$aN,InlineValueVariableLookup:Ne.$bN,InlineValueEvaluatableExpression:Ne.$cN,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:f.$5d,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$oN,FileDecoration2:Ne.$oN,FileSystemError:Ne.$fN,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:Ne.$gN,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$4M,InlineCompletionItem:Ne.$zM,InlineCompletionList:Ne.$AM,Hover:Ne.$fM,IndentAction:I.IndentAction,Location:Ne.$cM,MarkdownString:Ne.$rM,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Ne.$sM,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$4L,ProcessExecution:Ne.$LM,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$nN,Range:Ne.$5L,RelativePattern:Ne.$ZM,Selection:Ne.$6L,SelectionRange:Ne.$mM,SemanticTokens:Ne.$jN,SemanticTokensBuilder:Ne.$iN,SemanticTokensEdit:Ne.$kN,SemanticTokensEdits:Ne.$lN,SemanticTokensLegend:Ne.$hN,ShellExecution:Ne.$MM,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$uM,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$tM,SnippetString:Ne.$bM,SourceBreakpoint:Ne.$3M,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$iM,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$OM,TaskGroup:Ne.$KM,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$GM,TerminalQuickFixTerminalCommand:Ne.$IM,TerminalQuickFixOpener:Ne.$HM,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$JM,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$0L,SnippetTextEdit:Ne.$_L,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$YM,ThemeIcon:Ne.$XM,TreeItem:Ne.$PM,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$JN,UIKind:oi.UIKind,Uri:$.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$aM,DocumentDropEdit:Ne.$VM,DocumentPasteEdit:Ne.$WM,InlayHint:Ne.$wM,InlayHintLabelPart:Ne.$vM,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$9L,ResolvedAuthority:Ne.$7L,ManagedResolvedAuthority:Ne.$8L,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$yN,NotebookRange:Ne.$qN,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$rN,NotebookData:Ne.$sN,NotebookRendererScript:Ne.$wN,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$uN,NotebookCellOutputItem:Ne.$tN,NotebookCellStatusBarItem:Ne.$vN,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$$L,NotebookKernelSourceAction:Ne.$xN,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$AN,LinkedEditingRanges:Ne.$zN,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$BN,TestMessage:Ne.$CN,TestTag:Ne.$DN,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:Ne.$UM,DataTransferItem:Ne.$QM,CoveredCount:Ne.$EN,FileCoverage:Ne.$FN,StatementCoverage:Ne.$GN,BranchCoverage:Ne.$HN,DeclarationCoverage:Ne.$IN,FunctionCoverage:Ne.$IN,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$KN,TabInputTextDiff:Ne.$LN,TabInputTextMerge:Ne.$MN,TabInputCustom:Ne.$NN,TabInputNotebook:Ne.$PN,TabInputNotebookDiff:Ne.$QN,TabInputWebview:Ne.$ON,TabInputTerminal:Ne.$RN,TabInputInteractiveWindow:Ne.$SN,TabInputChat:Ne.$TN,TelemetryTrustedValue:o.$Xo,LogLevel:u.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$0M,ThreadFocus:Ne.$$M,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.$VN,ChatResponseFileTreePart:Ne.$WN,ChatResponseAnchorPart:Ne.$XN,ChatResponseProgressPart:Ne.$YN,ChatResponseReferencePart:Ne.$1N,ChatResponseCommandButtonPart:Ne.$ZN,ChatRequestTurn:Ne.$2N,ChatResponseTurn:Ne.$3N,LanguageModelSystemMessage:Ne.$4N,LanguageModelUserMessage:Ne.$5N,LanguageModelAssistantMessage:Ne.$6N,NewSymbolName:Ne.$eN,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.$7N,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}e.$Sjc=_t}),define(Se[372],De([1,0,84,154,38,149,43,33,72,46,95,96,97,118,70,91,148,69,59,117,90,71,147,13,60,115,116]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d,l,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$$r)(r.$Hic,r.$Gic,1),(0,D.$$r)(d.$zj,t.$Tjc,1),(0,D.$$r)(u.$Nhc,u.$Ohc,1),(0,D.$$r)(w.$BO,w.$AO,0),(0,D.$$r)(L.$bic,L.$_hc,0),(0,D.$$r)(o.$dic,o.$cic,0),(0,D.$$r)(I.$Ric,I.$Vic,0),(0,D.$$r)(R.$Xic,R.$Wic,0),(0,D.$$r)($.$qO,$.$pO,0),(0,D.$$r)(c.$Iic,c.$Jic,0),(0,D.$$r)(i.$Rhc,i.$Qhc,0),(0,D.$$r)(O.$rjc,O.$qjc,1),(0,D.$$r)(p.$bjc,p.$cjc,0),(0,D.$$r)(S.$wic,S.$vic,0),(0,D.$$r)(M.$Ejc,M.$Djc,0),(0,D.$$r)(k.$zic,k.$Cic,0),(0,D.$$r)(E.$yAb,E.$zAb,0),(0,D.$$r)(b.$Rjc,b.$Qjc,0),(0,D.$$r)(f.$$hc,f.$0hc,0),(0,D.$$r)(n.$Eic,n.$Dic,0),(0,D.$$r)(s.$zO,s.$wO,0),(0,D.$$r)(a.$nic,a.$oic,0),(0,D.$$r)(l.$Pic,l.$Qic,0)}),define(Se[120],De([1,0,19,13,36,94]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=e.$0jc=void 0;function L(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$0jc=L;function w(I,p,S,E){const u=(0,D.$2b)(S,$),b=new f.$pK(p,u,E),o=b.preview.matches;return{ranges:(0,D.$2b)(u,k),uri:I,preview:{text:b.preview.text,matches:(0,D.$2b)(o,k)}}}e.$$jc=w;function $(I){return new f.$qK(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new R.$eK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let M=class{constructor(p,S){this.a=p,this.b=S}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$_jc=M,e.$_jc=M=Je([He(1,O.$yj)],M)}),define(Se[373],De([1,0,50,17,76,34,9,12,120,374]),function(re,e,D,O,f,R,L,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=e.$akc=void 0;const M=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(n,s,a,t){const d=p(n,s,a,t),l=s.folder.fsPath;return{cmd:D.spawn(M,d.args,{cwd:l}),rgDiskPath:M,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}e.$akc=I;function p(n,s,a,t){const d=["--files","--hidden","--case-sensitive","--no-require-git"];E([s],a,!1).forEach(r=>{const c=(0,$.$0jc)(r);if(d.push("-g",c),L.$d){const h=(0,f.$Tl)(c);h!==c&&d.push("-g",h)}});const l=S([s],t,void 0,!1);return l.globArgs.forEach(r=>{const c=`!${(0,$.$0jc)(r)}`;if(d.push("-g",c),L.$d){const h=(0,f.$Tl)(c);h!==c&&d.push("-g",h)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),n.exists&&d.push("--quiet"),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function S(n,s,a,t=!0){const d=[];let l={};return n.forEach(r=>{const c=Object.assign({},r.excludePattern||{},s||{}),h=u(c,t?r.folder.fsPath:void 0,a);d.push(...h.globArgs),h.siblingClauses&&(l=Object.assign(l,h.siblingClauses))}),{globArgs:d,siblingClauses:l}}function E(n,s,a=!0){const t=[];return n.forEach(d=>{const l=Object.assign({},s||{},d.includePattern||{}),r=u(l,a?d.folder.fsPath:void 0);t.push(...r.globArgs)}),t}function u(n,s,a){const t=[],d={};return Object.keys(n).forEach(l=>{if(a&&a.has(l)||!l)return;const r=n[l];l=o(s?b(s,l):l),l.startsWith("\\\\")?l="\\\\"+l.substr(2).replace(/\\/g,"/"):l=l.replace(/\\/g,"/"),typeof r=="boolean"&&r?(l.startsWith("\\\\")&&(l+="**"),t.push(i(l))):r&&r.when&&(d[l]=r)}),{globArgs:t,siblingClauses:d}}function b(n,s){return O.$ic(s)?s:O.$jc(n,s)}e.$bkc=b;function o(n){return n=w.$4e(n,"\\"),w.$4e(n,"/")}function i(n){return R.$bg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$ckc=i}),define(Se[375],De([1,0,50,57,17,376,19,41,35,76,34,9,39,12,18,31,36,373,126]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=e.$dkc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(l=>l())});class s{constructor(r){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=r,this.b=r.filePattern||"",this.d=r.includePattern&&$.$Xj(r.includePattern),this.f=r.maxResults||null,this.g=!!r.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=r.shouldGlobMatchFilePattern?null:(0,i.$_q)(this.b).normalizedLowercase),this.u=r.excludePattern&&$.$Xj(r.excludePattern),this.t=new Map,r.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),g=c.folder.fsPath;r.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==g).forEach(C=>{(0,M.$fg)(C,g)&&(h[f.$lc(g,C)]=!0)}),this.t.set(g,new t(h,g))})}cancel(){this.l=!0,n.forEach(r=>r())}walk(r,c,h,g,C){if(this.m=p.$1d.create(!1),this.l)return C(null,this.j);c.forEach(v=>{const m=f.$nc(v.fsPath);this.u&&this.u(v.fsPath,m)||this.J(h,{relativePath:v.fsPath,searchPath:void 0})}),this.r=p.$1d.create(!1),this.w(r,(v,m)=>{this.x(this.y,this,v,h,g,y=>{if(y){const P=(0,w.$2i)(y);console.error(P),this.q.push(P),m(y,void 0)}else m(null,void 0)})},(v,m)=>{this.m.stop();const y=v?L.$Hb(v)[0]:null;C(y,this.j)})}w(r,c,h){const g=new Array(r.length),C=new Array(r.length);let v=!1,m=0;if(r.length===0)return h(null,[]);r.forEach((y,P)=>{c(y,(j,U)=>{if(j?(v=!0,g[P]=null,C[P]=j):(g[P]=U,C[P]=null),++m===r.length)return h(v?C:null,g)})})}x(r,c,...h){try{r.apply(c,h)}catch(g){h[h.length-1](g)}}y(r,c,h,g){const C=r.folder.fsPath,v=I.$d,m=()=>z&&z.kill();n.add(m);let y=F=>{n.delete(m),y=()=>{},g(F)},P="";const j=this.D(),U=(0,o.$akc)(this.a,r,this.a.includePattern,this.t.get(r.folder.fsPath).expression),z=U.cmd,N=!Object.keys(U.siblingClauses).length,A=U.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let T=`${U.rgDiskPath} ${A}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(z,"utf8",h,(F,G,K)=>{if(F){y(F);return}if(this.j){y();return}const Q=(P+(v?k.$Sl(G||""):G)).split(`
`);if(K){const Z=Q.length;Q[Z-1]=Q[Z-1].trim(),Q[Z-1]||Q.pop()}else P=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Q.length,N){for(const Z of Q)if(this.J(c,{base:C,relativePath:Z,searchPath:this.N(r,Z)}),this.j){m();break}(K||this.j)&&y();return}this.G(r,j,C,Q,c),K&&(this.H(j,C,c),y())})}spawnFindCmd(r){const c=this.t.get(r.folder.fsPath),h=c.getBasenameTerms(),g=c.getPathTerms(),C=["-L","."];if(h.length||g.length){C.push("-not","(","(");for(const v of h)C.push("-name",v),C.push("-o");for(const v of g)C.push("-path",v),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),D.spawn("find",C,{cwd:r.folder.fsPath})}readStdout(r,c,h){let g="";this.z(r,c,()=>{},(C,v,m)=>{if(C){h(C);return}g+=v,m&&h(null,g)})}z(r,c,h,g){let C=(y,P,j)=>{(y||j)&&(C=()=>{},this.r?.stop()),g(y,P,j)},v=!1;r.stdout?(this.A(r.stdout,c,C),r.stdout.once("data",()=>v=!0)):h({message:"stdout is null"});let m;r.stderr?m=this.B(r.stderr):h({message:"stderr is null"}),r.on("error",y=>{C(y)}),r.on("close",y=>{let P;!v&&(P=this.C(m,c))&&d(P)?C(new Error(`command failed with error code ${y}: ${this.C(m,c)}`)):(this.g&&y===0&&(this.j=!0),C(null,"",!0))})}A(r,c,h){const g=new R.StringDecoder(c);return r.on("data",C=>{h(null,g.write(C))}),g}B(r){const c=[];return r.on("data",h=>{c.push(h)}),c}C(r,c){const h=new R.StringDecoder(c);return r.map(g=>h.write(g)).join("")}D(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}G(r,{pathToEntries:c},h,g,C){g.indexOf(this.b)!==-1&&this.J(C,{base:h,relativePath:this.b,searchPath:this.N(r,this.b)});const v=m=>{const y=f.$nc(m),P=f.$mc(m);let j=c[P];j||(j=c[P]=[],v(P)),j.push({base:h,relativePath:m,basename:y,searchPath:this.N(r,m)})};g.forEach(v)}H({rootEntries:r,pathToEntries:c},h,g){const C=this,v=this.t.get(h),m=this.b;function y(P){C.o++;const j=(0,b.$FK)(()=>P.map(U=>U.basename));for(let U=0,z=P.length;U<z;U++){const N=P[U],{relativePath:A,basename:T}=N;if(v.test(A,T,m!==T?j:void 0))continue;const F=c[A];if(F)y(F);else{if(C.p++,A===m)continue;C.J(g,N)}if(C.j)break}}y(r)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(r,c,h,g,C){const v=r.folder,m=(0,b.$FK)(()=>h);this.w(h,(y,P)=>{if(this.l||this.j)return P(null);const j=c?[c,y].join(f.sep):y;if(this.t.get(r.folder.fsPath).test(j,y,this.a.filePattern!==y?m:void 0))return P(null);const U=[v.fsPath,j].join(f.sep);O.lstat(U,(z,N)=>{if(z||this.l||this.j)return P(null);this.L(U,N,(A,T)=>A||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(U,N,(F,G)=>F||this.l||this.j||(G=G||"",this.v[G])?P(null):(this.v[G]=!0,u.Promises.readdir(U).then(K=>{if(this.l||this.j)return P(null);this.I(r,j,K,g,X=>P(X||null))},K=>{P(null)})))):(this.p++,j===this.b||this.h&&E.$Wf(T.size)&&T.size>this.h||this.J(g,{base:v.fsPath,relativePath:j,searchPath:this.N(r,j)}),P(null,void 0)))})},y=>{const P=y&&L.$Hb(y);return C(P&&P.length>0?P[0]:void 0)})}J(r,c){this.K(c)&&(!this.d||this.d(c.relativePath,f.$nc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||r(c))}K(r){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,b.$AK)(r,this.c);if(this.b)return(0,b.$AK)(r,this.b,!1)}return!0}L(r,c,h){return c.isSymbolicLink()?O.stat(r,h):h(null,c)}M(r,c,h){return c.isSymbolicLink()?O.realpath(r,(g,C)=>g?h(g):h(null,C)):h(null,r)}N(r,c){return r.folderName?f.$jc(r.folderName,c):c}}e.$dkc=s;class a{constructor(r){this.a=r.folderQueries,this.b=r.extraFileResources||[],this.c=new s(r)}search(r,c,h){this.c.walk(this.a,this.b,r,c,(g,C)=>{h(g,{limitHit:C,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$ekc=a;class t{constructor(r,c){this.expression=r,this.c=c,this.d(r)}d(r){let c,h;Object.keys(r).filter(g=>r[g]).forEach(g=>{f.$ic(g)?(c=c||$.$Sj(),c[g]=r[g]):(h=h||$.$Sj(),h[g]=r[g])}),this.a=c&&$.$Xj(c,{trimForExclusions:!0}),this.b=h&&$.$Xj(h,{trimForExclusions:!0})}test(r,c,h){return this.b&&this.b(r,c,h)||this.a&&this.a(f.$jc(this.c,r),c,h)}getBasenameTerms(){const r=[];return this.a&&r.push(...$.$Zj(this.a)),this.b&&r.push(...$.$Zj(this.b)),r}getPathTerms(){const r=[];return this.a&&r.push(...$.$1j(this.a)),this.b&&r.push(...$.$1j(this.b)),r}}function d(l){const r=l.trim().split(`
`),c=r[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return S.$Kf(r[r.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Se[377],De([1,0,100,21,168,22]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LD=e.$KD=e.$JD=e.$ID=e.$HD=e.$GD=e.$FD=e.$ED=e.$DD=e.DecodeStreamErrorKind=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=void 0,e.$vD="utf8",e.$wD="utf8bom",e.$xD="utf16be",e.$yD="utf16le";function L(c){return[e.$vD,e.$wD,e.$xD,e.$yD].some(h=>h===c)}e.$zD=L,e.$AD=[254,255],e.$BD=[255,254],e.$CD=[239,187,191];const w=512,$=512,k=512*8,M=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(h,g){super(h),this.decodeStreamErrorKind=g}}e.$DD=p;class S{static async create(h){let g;if(h!==e.$vD)g=(await(0,f.$uD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const C=new TextDecoder;g={write(v){return C.decode(v,{stream:!0})},end(){return C.decode()}}}return new S(g)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function E(c,h){const g=h.minBytesRequiredForDetection??h.guessEncoding?k:$;return new Promise((C,v)=>{const m=(0,D.$ge)(N=>N.join("")),y=[];let P=0,j;const U=new R.$ce,z=async()=>{try{const N=await r({buffer:O.$se.concat(y),bytesRead:P},h.guessEncoding);if(N.seemsBinary&&h.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);N.encoding=await h.overwriteEncoding(N.encoding),j=await S.create(N.encoding);const A=j.write(O.$se.concat(y).buffer);m.write(A),y.length=0,P=0,C({stream:m,detected:N})}catch(N){U.cancel(),m.destroy(),v(N)}};(0,D.$ke)(c,{onData:async N=>{j?m.write(j.write(N.buffer)):(y.push(N),P+=N.byteLength,P>=g&&(c.pause(),await z(),setTimeout(()=>c.resume())))},onError:N=>m.error(N),onEnd:async()=>{j||await z(),m.end(j?.end())}},U.token)})}e.$ED=E;async function u(c,h,g){const v=(await(0,f.$uD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),g);let m=!1,y=!1;return{read(){if(y)return null;const P=c.read();if(typeof P!="string"){if(y=!0,!m&&g?.addBOM)switch(h){case e.$vD:case e.$wD:return O.$se.wrap(Uint8Array.from(e.$CD));case e.$xD:return O.$se.wrap(Uint8Array.from(e.$AD));case e.$yD:return O.$se.wrap(Uint8Array.from(e.$BD))}const j=v.end();return j&&j.length>0?(m=!0,O.$se.wrap(j)):null}return m=!0,O.$se.wrap(v.write(P))}}}e.$FD=u;async function b(c){return(await(0,f.$uD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}e.$GD=b;function o(c){return c===e.$wD||c===null?e.$vD:c}e.$HD=o;function i(c,h){if(!c||h<e.$AD.length)return null;const g=c.readUInt8(0),C=c.readUInt8(1);if(g===e.$AD[0]&&C===e.$AD[1])return e.$xD;if(g===e.$BD[0]&&C===e.$BD[1])return e.$yD;if(h<e.$CD.length)return null;const v=c.readUInt8(2);return g===e.$CD[0]&&C===e.$CD[1]&&v===e.$CD[2]?e.$wD:null}e.$ID=i;const n=["ascii","utf-16","utf-32"];async function s(c){const h=await(0,f.$uD)("jschardet","dist/jschardet.min.js"),g=c.slice(0,M),C=d(g.buffer),v=h.detect(C);if(!v||!v.encoding)return null;const m=v.encoding.toLowerCase();return 0<=n.indexOf(m)?null:t(v.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function d(c){let h="";for(let g=0;g<c.length;g++)h+=String.fromCharCode(c[g]);return h}function l(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}e.$JD=l;function r({buffer:c,bytesRead:h},g){let C=i(c,h),v=!1;if(C!==e.$xD&&C!==e.$yD&&c){let m=!0,y=!0,P=!1;for(let j=0;j<h&&j<w;j++){const U=j%2===1,z=c.readUInt8(j)===0;if(z&&(P=!0),m&&(U&&!z||!U&&z)&&(m=!1),y&&(U&&z||!U&&!z)&&(y=!1),z&&!m&&!y)break}P&&(m?C=e.$yD:y?C=e.$xD:v=!0)}return g&&!v&&!C&&c?s(c.slice(0,h)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:v,encoding:C}}e.$KD=r,e.$LD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[157],De([1,0,377,31,156]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;class R extends f.$0ic{constructor(w,$,k=O,M="searchProcess"){super(w,$,{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.$JD)(I)},M)}}e.$mkc=R}),define(Se[158],De([1,0,50,393,376,19,73,35,12,2,36,94,394,374,120]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=e.$jkc=e.$ikc=e.$hkc=e.$gkc=e.$fkc=void 0;const u=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(m){this.a=m}provideTextSearchResults(m,y,P,j){return this.a.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,z)=>{j.onCancellationRequested(()=>Q());const N=t(m,y),A=y.folder.fsPath,T=N.map(ue=>ue.match(/^-/)?ue:`'${ue}'`).join(" ");this.a.appendLine(`${u} ${T}
 - cwd: ${A}`);let F=D.spawn(u,N,{cwd:A});F.on("error",ue=>{console.error(ue),this.a.appendLine("Error: "+(ue&&ue.message)),z((0,M.$wK)(new M.$uK(ue&&ue.message,M.SearchErrorCode.rgProcessError)))});let G=!1;const K=new n(y.maxResults,y.folder,y.previewOptions);K.on("result",ue=>{G=!0,ie="",P.report(ue)});let X=!1;const Q=()=>{X=!0,F?.kill(),K?.cancel()};let Z=!1;K.on("hitLimit",()=>{Z=!0,Q()});let ie="";F.stdout.on("data",ue=>{K.handleData(ue),G||(ie+=ue)});let ee=!1;F.stdout.once("data",()=>ee=!0);let we="";F.stderr.on("data",ue=>{const ae=ue.toString();this.a.appendLine(ae),we.length+ae.length<1e6&&(we+=ae)}),F.on("close",()=>{if(this.a.appendLine(ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(G?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),X)U({limitHit:Z});else{K.flush(),F=null;let ue;we&&!ee&&(ue=o(we))?z((0,M.$wK)(new M.$uK(ue.message,ue.code))):U({limitHit:Z})}})})}}e.$fkc=b;function o(v){const m=v.split(`
`),y=m[0].trim();if(m.some(j=>j.startsWith("regex parse error")))return new M.$uK(i(m),M.SearchErrorCode.regexParseError);const P=y.match(/grep config error: unknown encoding: (.*)/);if(P)return new M.$uK(`Unknown encoding: ${P[1]}`,M.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new M.$uK(y.charAt(0).toUpperCase()+y.substr(1),M.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new M.$uK(y.charAt(0).toUpperCase()+y.substr(1),M.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new M.$uK(y,M.SearchErrorCode.regexParseError)}function i(v){const m=["Regex parse error"],y=v.filter(P=>P.startsWith("PCRE2:"));if(y.length>=1){const P=y[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const j=P.split(":")[1];m.push(":"+j)}}return m.join("")}class n extends O.EventEmitter{constructor(m,y,P){super(),this.g=m,this.h=y,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(m,y){return super.on(m,y),this}handleData(m){if(this.b)return;const y=typeof m=="string"?m:this.d.write(m);this.k(y)}k(m){let y=m.indexOf(`
`);const P=this.a+m;if(y>=0)y+=this.a.length;else{this.a=P;return}let j=0;for(;y>=0;)this.m(P.substring(j,y).trim()),j=y+1,y=P.indexOf(`
`,j);this.a=P.substring(j)}m(m){if(this.b||!m)return;let y;try{y=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(y.type==="match"){const P=s(y.data.path),j=k.URI.joinPath(this.h,P),U=this.n(y.data,j);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const P=s(y.data.path),j=k.URI.joinPath(this.h,P);this.o(y.data,j).forEach(z=>this.p(z))}}n(m,y){const P=m.line_number-1,j=s(m.lines),U=Buffer.from(j);let z=0,N=0,A=P;m.submatches.length===0&&m.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(m.submatches.map((F,G)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const K=s(F.match),X=U.slice(z,F.start).toString(),Q=a(X),Z=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+N,ie=a(K),ee=Q.numLines+A,we=ie.numLines+ee,ue=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+Z;return z=F.end,N=ue,A=we,new I.$eK(ee,Z,we,ue)}));return(0,E.$$jc)(y,j,T,this.j)}o(m,y){const P=s(m.lines),j=m.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((U,z)=>({text:U,uri:y,lineNumber:j+z}))}p(m){this.emit("result",m)}}e.$gkc=n;function s(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function a(v){const m=/\n/g;let y=0,P=-1,j;for(;j=m.exec(v);)y++,P=j.index;const U=P>=0?v.length-P-1:v.length;return{numLines:y,lastLineLength:U}}function t(v,m){const y=["--hidden","--no-require-git"];y.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:j}=(0,L.$E)(m.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const z=new Set;j.forEach(N=>{z.add(N)}),y.push("-g","!*"),z.forEach(N=>{d(N).map(E.$0jc).forEach(A=>{y.push("-g",A)})})}P&&P.length&&P.forEach(z=>{y.push("-g",z)}),m.excludes.map(E.$0jc).forEach(z=>y.push("-g",`!${z}`)),m.maxFileSize&&y.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),m.followSymlinks&&y.push("--follow"),m.encoding&&m.encoding!=="utf8"&&y.push("--encoding",m.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,$.$Xe)(v.pattern),v.isRegExp=!0),m.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),v.isRegExp&&(v.pattern=l(v.pattern),y.push("--engine","auto"));let U;if(v.isWordMatch){const N=(0,$.$7e)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",N)}else if(v.isRegExp){let z=c(v.pattern);z=h(z),y.push("--regexp",z)}else U=v.pattern,y.push("--fixed-strings");return y.push("--no-config"),m.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),v.isMultiline&&y.push("--multiline"),m.beforeContext&&y.push("--before-context",m.beforeContext+""),m.afterContext&&y.push("--after-context",m.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}e.$hkc=t;function d(v){return C(v).flatMap(y=>{const P=(0,w.$Vj)(y,"/");return P.map((j,U)=>P.slice(0,U+1).join("/"))})}function l(v){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(m);)v=v.replace(m,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(y);)v=v.replace(y,"$1\\x{$2}");return v}e.$ikc=l;const r=v=>v.type==="Assertion"&&v.kind==="lookbehind";function c(v){let m;try{m=new p.RegExpParser().parsePattern(v)}catch{return v}let y="",P=0;const j=(N,A,T)=>{y+=v.slice(P,N)+T,P=A},U=[];return new p.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const A=U[0];if(!A)j(N.start,N.end,"\\r?\\n");else if(!U.some(r))if(A.type==="CharacterClass")if(A.negate){const T=v.slice(A.start+2,N.start)+v.slice(N.end,A.end-1);A.parent?.type==="Quantifier"?j(A.start,A.end,T?`[^${T}]`:"."):j(A.start,A.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=v.slice(A.start+1,N.start)+v.slice(N.end,A.end-1);j(A.start,A.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else A.type==="Quantifier"&&j(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){U.unshift(N)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(N){U.unshift(N)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(N){U.unshift(N)},onCharacterClassLeave(){U.shift()},onAssertionEnter(N){r(N)&&U.push(N)},onAssertionLeave(N){U[0]===N&&U.shift()}}).visit(m),y+=v.slice(P),y}e.$jkc=c;function h(v){return v.replace(/\n/g,"\\r?\\n")}e.$kkc=h;function g(v){let m=!1,y=!1,P="",j="";for(let U=0;U<v.length;U++){const z=v[U];switch(z){case"\\":y?(m?j+="\\"+z:P+="\\"+z,y=!1):y=!0;break;case"{":if(y)m?j+=z:P+=z,y=!1;else{if(m)return{strInBraces:P+"{"+j+"{"+v.substring(U+1)};m=!0}break;case"}":if(y)m?j+=z:P+=z,y=!1;else{if(m)return{fixedStart:P,strInBraces:j,fixedEnd:v.substring(U+1)};P+=z}break;default:m?j+=(y?"\\":"")+z:P+=(y?"\\":"")+z,y=!1;break}}return{strInBraces:P+(m?"{"+j:"")}}function C(v){const{fixedStart:m,strInBraces:y,fixedEnd:P}=g(v);if(m===void 0||P===void 0)return[y];let j=(0,w.$Vj)(y,",");j.length||(j=[""]);const U=C(P);return j.flatMap(z=>{const N=m+z;return U.map(A=>N+A)})}e.$lkc=C}),define(Se[378],De([1,0,22,158,107,16]),function(re,e,D,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=void 0;class L{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,M,I,p){const S=new O.$fkc(this.b);if(M.folder.scheme===R.Schemas.vscodeUserData){const E={...M,folder:M.folder.with({scheme:R.Schemas.file})},u=new f.$Iv(b=>I.report({...b,uri:b.uri.with({scheme:M.folder.scheme})}));return this.c(p,b=>S.provideTextSearchResults(k,E,u,b))}else return this.c(p,E=>S.provideTextSearchResults(k,M,I,E))}async c(k,M){const I=w(k);this.a.add(I);const p=await M(I.token);return this.a.delete(I),p}d(){this.a.forEach(k=>k.cancel())}}e.$pkc=L;function w($){const k=new D.$ce;return $.onCancellationRequested(()=>k.cancel()),k}}),define(Se[379],De([1,0,31,158,157]),function(re,e,D,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0;class R{constructor($){this.a=$}search($,k,M){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(S){M({message:S})}},p=new f.$mkc(this.a,new O.$fkc(I),D);return new Promise((S,E)=>p.search(u=>{k(u.map(L))},$).then(u=>S({limitHit:u.limitHit,type:"success",stats:u.stats}),E))}}e.$nkc=R;function L(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce(($,k)=>{if(k.ranges){const M=k;return $+(Array.isArray(M.ranges)?M.ranges.length:1)}else return $+1},0)}}}),define(Se[380],De([1,0,19,8,14,4,126,17,39,2,32,36,375,379]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=void 0;class E{constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let a;const t=o(s),d=new R.$5d({onDidAddFirstListener:()=>{a=(0,O.$4g)(l=>this.doFileSearchWithEngine(p.$ekc,t,r=>d.fire(r),l)),a.then(l=>d.fire(l),l=>d.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return d.event}textSearch(s){let a;const t=o(s),d=new R.$5d({onDidAddFirstListener:()=>{a=(0,O.$4g)(l=>this.f(t,r=>d.fire(r),l)),a.then(l=>d.fire(l),l=>d.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return d.event}f(s,a,t){return s.maxFileSize=this.g().maxFileSize,new S.$nkc(s).search(t,a,a)}g(){return{maxFileSize:16*M.$0k.GB}}doFileSearch(s,a,t){return this.doFileSearchWithEngine(p.$ekc,s,a,t)}doFileSearchWithEngine(s,a,t,d,l=E.a){let r=0;const c=g=>{Array.isArray(g)?(r+=g.length,t(g.map(C=>this.h(C)))):g.relativePath?(r++,t(this.h(g))):t(g)};if(a.sortByScore){let g=this.l(a,c,d);if(!g){const C=a.maxResults?Object.assign({},a,{maxResults:null}):a,v=new s(C);g=this.j(v,a,t,c,d)}return new Promise((C,v)=>{g.then(([m,y])=>{const P=y.map(j=>this.h(j));this.o(P,t,l),C(m)},v)})}const h=new s(a);return this.r(h,c,l,d).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:r,sortingTime:void 0}}))}h(s){return{path:s.base?(0,w.$jc)(s.base,s.relativePath):s.relativePath}}j(s,a,t,d,l){const r=new R.$5d;let c=(0,O.$4g)(g=>{let C=[];const v=m=>{Array.isArray(m)?C=m:(d(m),r.fire(m))};return this.r(s,v,-1,g).then(m=>[m,C])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const g={promise:c,event:r.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=g,c.then(()=>{g.resolved=!0},C=>{delete h.resultsToSearchCache[a.filePattern||""]}),c=this.s(c)}return c.then(([g,C])=>{const v=h?h.scorerCache:Object.create(null),m=(typeof a.maxResults!="number"||a.maxResults>0)&&$.$1d.create(!1);return this.n(a,C,v,l).then(y=>{const P=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:y.length},messages:g.messages,limitHit:g.limitHit||typeof a.maxResults=="number"&&C.length>a.maxResults},y]})})}k(s){const a=this.b[s];return a||(this.b[s]=new u)}l(s,a,t){const d=s.cacheKey&&this.b[s.cacheKey];if(!d)return;const l=this.q(d,s.filePattern||"",a,t);if(l)return l.then(([r,c,h])=>{const g=$.$1d.create(!1);return this.n(s,c,d.scorerCache,t).then(C=>{const v=g.elapsed(),m={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:v};return[{type:"success",limitHit:r.limitHit||typeof s.maxResults=="number"&&c.length>s.maxResults,stats:m},C]})})}n(s,a,t,d){const l=(0,L.$_q)(s.filePattern||""),r=(h,g)=>(0,L.$$q)(h,g,l,!0,b,t),c=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return D.$Gb(a,r,c,1e4,d)}o(s,a,t){if(t&&t>0)for(let d=0;d<s.length;d+=t)a(s.slice(d,d+t));else a(s)}q(s,a,t,d){const l=$.$1d.create(!1),r=a.indexOf(w.sep)>=0;let c;for(const v in s.resultsToSearchCache)if(a.startsWith(v)){if(r&&v.indexOf(w.sep)<0&&v!=="")continue;const m=s.resultsToSearchCache[v];c={promise:this.s(m.promise),event:m.event,resolved:m.resolved};break}if(!c)return null;const h=l.elapsed(),g=$.$1d.create(!1),C=c.event(t);return d&&d.onCancellationRequested(()=>{C.dispose()}),c.promise.then(([v,m])=>{if(d&&d.isCancellationRequested)throw(0,f.$6)();const y=[],P=(0,L.$_q)(a).normalizedLowercase;for(const j of m)(0,I.$AK)(j,P)&&y.push(j);return[v,y,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:g.elapsed(),cacheEntryCount:m.length}]})}r(s,a,t,d){return new Promise((l,r)=>{let c=[];d?.onCancellationRequested(()=>s.cancel()),s.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(a(c),c=[])):a(h))},h=>{a(h)},(h,g)=>{c.length&&a(c),h?(a({message:"Search finished. Error: "+h.message}),r(h)):(a({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),l(g))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return s.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return s.finally(a)}}}}e.$okc=E,E.a=512;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(n){return(0,w.$nc)(n.relativePath)}getItemDescription(n){return(0,w.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(s=>k.URI.revive(s))}}function i(n){return{...n,folder:k.URI.revive(n.folder)}}}),define(Se[381],De([1,0,3,16,2,31,13,27,20,97,66,36,380,378,120,157]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=void 0;let b=class extends k.$cjc{constructor(i,n,s,a){super(i,s,a),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new E.$_jc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new S.$pkc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new E.$_jc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.file,new S.$pkc(i))),this.x.add(this.z(O.Schemas.file,new p.$okc("fileSearchProvider")))}z(i,n){const s=this.d++;return this.v=n,this.t=s,this.c.$registerFileSearchProvider(s,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(i,n,s,a){const t=(0,k.$djc)(s);if(i===this.t){const d=Date.now();return this.A(i,n,t,a).then(l=>{const r=Date.now()-d;return this.n.debug(`Ext host file search time: ${r}ms`),l})}return super.$provideFileSearchResults(i,n,s,a)}doInternalFileSearchWithCustomCallback(i,n,s){const a=t=>{if((0,I.$zK)(t)&&(t=[t]),Array.isArray(t)){s(t.map(d=>f.URI.file(d.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,s,a){return this.doInternalFileSearchWithCustomCallback(s,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new u.$mkc(i,n,void 0,"textSearchProvider")}};e.$qkc=b,e.$qkc=b=Je([He(0,$.$fO),He(1,w.$vO),He(2,M.$8hc),He(3,L.$yj)],b)}),define(Se[121],De([1,0,395,63,62,396,21,14,4,3,17,9,30,80,81]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=void 0;class u{traceSocketEvent(m,y){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,y)}constructor(m,y=""){this.f=!0,this.debugLabel=y,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,w.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(m){const y=P=>{this.traceSocketEvent("read",P),m(L.$se.wrap(P))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(m){const y=P=>{m({type:0,hadError:P,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(m){const y=()=>{m()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(m){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,w.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,w.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$6h=u;var b;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var o;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(o||(o={}));class i extends k.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(m,y){this.socket.traceSocketEvent(m,y)}constructor(m,y,P,j){super(),this.f=this.B(new $.$5d),this.g=this.B(new $.$5d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:P?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new n(this,y,P,j,this.f,(U,z)=>this.m(U,z))),this.B(this.a.onError(U=>{console.error(U),(0,w.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new E.$1h,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this.f.event(m)}onClose(m){return this.g.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){let y=0;for(;y<m.byteLength;)this.a.writeMessage(m.slice(y,Math.min(y+262144,m.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(m,{compressed:y,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let j=2;m.byteLength<126?j+=0:m.byteLength<2**16?j+=2:j+=8;const U=L.$se.alloc(j),z=y?64:0,N=P&15;if(U.writeUInt8(128|z|N,0),m.byteLength<126)U.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){U.writeUInt8(126,1);let A=1;U.writeUInt8(m.byteLength>>>8&255,++A),U.writeUInt8(m.byteLength>>>0&255,++A)}else{U.writeUInt8(127,1);let A=1;U.writeUInt8(0,++A),U.writeUInt8(0,++A),U.writeUInt8(0,++A),U.writeUInt8(0,++A),U.writeUInt8(m.byteLength>>>24&255,++A),U.writeUInt8(m.byteLength>>>16&255,++A),U.writeUInt8(m.byteLength>>>8&255,++A),U.writeUInt8(m.byteLength>>>0&255,++A)}this.socket.write(L.$se.concat([U,m]))}end(){this.h=!0,this.socket.end()}n(m){if(m.byteLength!==0){for(this.b.acceptChunk(m);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),P=y.readUInt8(0),j=(P&128)>>>7,U=(P&64)>>>6,z=P&15,N=y.readUInt8(1),A=(N&128)>>>7,T=N&127;this.j.state=2,this.j.readLen=2+(A?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),P=y.readUInt8(1),j=(P&128)>>>7;let U=P&127,z=1;U===126?U=y.readUInt8(++z)*2**8+y.readUInt8(++z):U===127&&(U=y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z));let N=0;j&&(N=y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z)),this.j.state=3,this.j.readLen=U,this.j.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$7h=i;class n extends k.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$se.alloc(0)}constructor(m,y,P,j,U,z){super(),this.n=m,this.r=U,this.s=z,this.a=this.B(new $.$5d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$5d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$5d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new s(this.n,j,P,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(N=>this.a.fire(N))),this.B(this.f.onError(N=>this.a.fire(N)))):(this.b=null,this.f=null)}writeMessage(m,y){this.g.push({data:m,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:m,options:y}=this.g.shift();if(this.f&&y.compressed){const P=await this.w(this.f,m);this.s(P,y)}else this.s(m,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(m,y){return new Promise((P,j)=>{m.write(y),m.flush(U=>P(U))})}acceptFrame(m,y,P){this.h.push({data:m,isCompressed:y,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const m=this.h.shift();if(this.b&&m.isCompressed){const y=await this.C(this.b,m.data,m.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(m.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(m,y,P){return new Promise((j,U)=>{m.write(y),P&&m.write(L.$se.fromByteArray([0,0,255,255])),m.flush(z=>j(z))})}}class s extends k.$Tc{get recordedInflateBytes(){return this.j?L.$se.concat(this.f):L.$se.alloc(0)}constructor(m,y,P,j){super(),this.h=m,this.j=y,this.a=this.B(new $.$5d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(j),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(L.$se.wrap(U))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(m){this.j&&this.f.push(m.clone()),this.h.traceSocketEvent("zlibInflateWrite",m),this.b.write(m.buffer)}flush(m){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=L.$se.concat(this.g);this.g.length=0,m(y)})}}class a extends k.$Tc{constructor(m,y){super(),this.g=m,this.a=this.B(new $.$5d),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(L.$se.wrap(P))})}write(m){this.g.traceSocketEvent("zlibDeflateWrite",m.buffer),this.b.write(m.buffer)}flush(m){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=L.$se.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),m(y)})}}function t(v,m){if(m===0)return;const y=v.byteLength>>>2;for(let A=0;A<y;A++){const T=v.readUInt32BE(A*4);v.writeUInt32BE(T^m,A*4)}const P=y*4,j=v.byteLength-P,U=m>>>24&255,z=m>>>16&255,N=m>>>8&255;j>=1&&v.writeUInt8(v.readUInt8(P)^U,P),j>=2&&v.writeUInt8(v.readUInt8(P+1)^z,P+1),j>=3&&v.writeUInt8(v.readUInt8(P+2)^N,P+2)}e.$8h=process.env.XDG_RUNTIME_DIR;const d={2:107,1:103};function l(){const v=(0,p.$Ag)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const m=process.platform!=="darwin"&&e.$8h?e.$8h:(0,f.tmpdir)(),y=(0,M.$jc)(m,`vscode-ipc-${v}.sock`);return c(y),y}e.$9h=l;function r(v,m,y){const j=(0,D.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${y}-${m}-sock`;const U=y.substr(0,4),z=m.substr(0,6);let N;return process.platform!=="darwin"&&e.$8h&&!process.env.VSCODE_PORTABLE?N=(0,M.$jc)(e.$8h,`vscode-${j}-${U}-${z}.sock`):N=(0,M.$jc)(v,`${U}-${z}.sock`),c(N),N}e.$0h=r;function c(v){const m=d[I.$o];typeof m=="number"&&v.length>=m&&console.warn(`WARNING: IPC handle "${v}" is longer than ${m} chars, try a shorter --user-data-dir`)}class h extends S.$Uh{static b(m){const y=$.Event.fromNodeEventEmitter(m,"connection");return $.Event.map(y,P=>({protocol:new E.$2h(new u(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(m){super(h.b(m)),this.d=m}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$$h=h;function g(v){return new Promise((m,y)=>{const P=(0,O.createServer)();P.on("error",y),P.listen(v,()=>{P.removeListener("error",y),m(new h(P))})})}e.$_h=g;function C(v,m){return new Promise((y,P)=>{const j=(0,O.createConnection)(v,()=>{j.removeListener("error",P),y(E.$3h.fromSocket(new u(j,`ipc-client${m}`),m))});j.once("error",P)})}e.$ai=C}),define(Se[382],De([1,0,63,62,170,121,8,3,9,52,13,137,258,259,109,88,21]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=e.$Dac=e.$Cac=e.$Bac=void 0;async function o(t,d,l,r,c){let h;for(let g=3;g&&(h?.dispose(),h=await new i(t,d,l,r,c).waitForReady(),!(c&&f.$Dg[c]||!f.$Dg[h.tunnelLocalPort]));g--);return h}class i extends w.$Tc{constructor(d,l,r,c,h){super(),this.m=l,this.n=h,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=d,this.b=D.createServer(),this.c=new L.$dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(l=>{l()})}async waitForReady(){const d=this.n??this.tunnelRemotePort,l=(0,u.$Uv)(this.m)?"0.0.0.0":"127.0.0.1";let r=await(0,f.$Eg)(d,2,1e3,l),c=null;return this.b.listen(r,this.m),await this.c.wait(),c=this.b.address(),c||(r=0,this.b.listen(r,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(d){d.pause();const l=(0,u.$Sv)(this.tunnelRemoteHost)||(0,u.$Uv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,p.$wl)(this.a,l,this.tunnelRemotePort),c=r.getSocket(),h=r.readEntireBuffer();r.dispose(),h.byteLength>0&&d.write(h.buffer),d.on("end",()=>{d.localAddress&&this.j.delete(d.localAddress),c.end()}),d.on("close",()=>c.end()),d.on("error",()=>{d.localAddress&&this.j.delete(d.localAddress),c instanceof R.$6h?c.socket.destroy():c.end()}),c instanceof R.$6h?this.t(d,c):this.s(d,c),d.localAddress&&this.j.set(d.localAddress,()=>{d.end(),c.end()})}s(d,l){l.onClose(()=>d.destroy()),l.onEnd(()=>d.end()),l.onData(r=>d.write(r.buffer)),d.on("data",r=>l.write(b.$se.wrap(r))),d.resume()}t(d,l){const r=l.socket;r.on("end",()=>d.end()),r.on("close",()=>d.end()),r.on("error",()=>{d.destroy()}),r.pipe(d),d.pipe(r)}}e.$Bac=i;let n=class extends u.$Xv{constructor(d,l,r,c,h){super(l,h),this.v=d,this.w=r,this.y=c}isPortPrivileged(d){return(0,u.$Vv)(d,this.m,$.OS,O.release())}t(d,l,r,c,h,g,C,v){const m=this.s(l,r);if(m)return++m.refcount,m.value;if((0,u.$Pv)(d))return this.u(d,l,r,h,g,C,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${r} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:d,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(y,c,l,r,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(l,r,P),P}}};e.$Cac=n,e.$Cac=n=Je([He(0,S.$ql),He(1,M.$yj),He(2,E.$tl),He(3,I.$Qj),He(4,k.$Ki)],n);let s=class extends n{constructor(d,l,r,c,h){super(d,l,r,c,h)}};e.$Dac=s,e.$Dac=s=Je([He(0,S.$ql),He(1,M.$yj),He(2,E.$tl),He(3,I.$Qj),He(4,k.$Ki)],s);let a=class extends w.$Tc{constructor(d,l,r,c,h){super(),this.b=d,this.c=l,this.f=r,this.g=c,this.h=h,this.a=new Map}async openTunnel(d,l,r,c,h,g,C,v,m){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${c} on local port ${g}.`),!this.a.has(d)){const y=new s(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(d,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(d))})}return this.a.get(d).openTunnel(l,r,c,h,g,C,v,m)}};e.$Eac=a,e.$Eac=a=Je([He(0,S.$ql),He(1,M.$yj),He(2,I.$Qj),He(3,E.$tl),He(4,k.$Ki)],a)}),define(Se[383],De([1,0,121,111,57,33,2,13,42]),function(re,e,D,O,f,R,L,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=void 0;class k{constructor(p,S,E){this.b=p,this.c=S,this.f=E,this.a=O.createServer((u,b)=>this.h(u,b)),this.g().catch(u=>(S.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,S){const E=(b,o)=>{S.writeHead(b,{"content-type":"application/json"}),S.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},u=[];p.setEncoding("utf8"),p.on("data",b=>u.push(b)),p.on("end",async()=>{try{const b=JSON.parse(u.join(""));let o;switch(b.type){case"open":o=await this.i(b);break;case"openExternal":o=await this.j(b);break;case"status":o=await this.l(b);break;case"extensionManagement":o=await this.k(b);break;default:E(404,`Unknown message type: ${b.type}`);break}E(200,o)}catch(b){const o=b instanceof Error?b.message:JSON.stringify(b);E(500,o),this.c.error("Error while processing pipe request",b)}})}async i(p){const{fileURIs:S,folderURIs:E,forceNewWindow:u,diffMode:b,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:s,waitMarkerFilePath:a,remoteAuthority:t}=p,d=[];if(Array.isArray(E))for(const h of E)try{d.push({folderUri:L.URI.parse(h)})}catch{}if(Array.isArray(S))for(const h of S)try{(0,$.$Ji)(h)?d.push({workspaceUri:L.URI.parse(h)}):d.push({fileUri:L.URI.parse(h)})}catch{}const l=a?L.URI.file(a):void 0,c={forceNewWindow:u,diffMode:b,mergeMode:o,addMode:i,gotoLineMode:s,forceReuseWindow:n,preferNewWindow:!n&&!l&&!i,waitMarkerFileURI:l,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",d,c)}async j(p){for(const S of p.uris){const E=L.URI.parse(S),u=E.scheme==="file"?E:S;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(p){const S=u=>u?.map(b=>/\.vsix$/i.test(b)?L.URI.parse(b):b),E={list:p.list,install:S(p.install),uninstall:S(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",E)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$GO=k;let M=class extends k{constructor(p,S){super(p,S,(0,D.$9h)())}};e.$HO=M,e.$HO=M=Je([He(0,R.$BO),He(1,w.$yj)],M)}),define(Se[384],De([1,0,111,58,371,366,277,47,353,2,16,7,383,102,309,38,352]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;class o extends R.$Wjc{k(){const s=this,a=globalThis._VSCODE_NODE_MODULES.module,t=a._load;a._load=function(c,h,g){return c=l(c),s.a.has(c)?s.a.get(c).load(c,k.URI.file((0,S.$Iq)(h.filename)),C=>t.apply(this,[C,h,g])):t.apply(this,arguments)};const d=a._resolveLookupPaths;a._resolveLookupPaths=(r,c)=>d.call(this,l(r),c);const l=r=>{for(const c of s.b){const h=c(r);if(h){r=h;break}}return r}}}class i extends w.$Lic{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async tb(){this.h.createInstance(E.$tkc);const s=this.h.invokeFunction(f.$Sjc);if(this.h.createInstance($.$skc),this.f.remote.isRemote&&this.f.remote.authority){const d=this.h.createInstance(p.$HO);process.env.VSCODE_IPC_HOOK_CLI=d.ipcHandlePath}this.h.createInstance(b.$ukc),await this.h.createInstance(o,s,{mine:this.J,all:this.L}).install(),O.mark("code/extHost/didInitAPI"),(async()=>{const d=process.env.VSCODE_IPC_HOOK_CLI,l=process.env.CODE_SERVER_SESSION_SOCKET;if(!d||!l)return;const c={workspace:this.h.invokeFunction(g=>g.get(u.$$hc).workspace),socketPath:d},h=JSON.stringify({entry:c});await new Promise((g,C)=>{const v={path:"/add-session",socketPath:l,method:"POST",headers:{"content-type":"application/json"}},m=D.request(v,y=>{y.on("error",C),y.on("end",()=>{try{y.statusCode===200?g():C(new Error("Unexpected status code: "+y.statusCode))}catch(P){C(P)}})});m.on("error",C),m.write(h),m.end()})})().catch(d=>{this.s.error(d)});const t=await this.m.getConfigProvider();await(0,L.$rkc)(this.j,t,this,this.s,this.z,this.f),O.mark("code/extHost/didInitProxyResolver")}ub(s){return s.main}async vb(s,a,t){if(a.scheme!==M.Schemas.file)throw new Error(`Cannot load URI: '${a}', must be of file-scheme`);let d=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${a.toString(!0)}`),this.s.flush();const l=s?.identifier.value;s&&await this.w.initializeLocalizedMessages(s);try{l&&O.mark(`code/extHost/willLoadExtensionCode/${l}`),d=re.__$__nodeRequire(a.fsPath)}finally{l&&O.mark(`code/extHost/didLoadExtensionCode/${l}`),t.codeLoadingStop()}return d}async $setRemoteEnvironment(s){if(this.f.remote.isRemote)for(const a in s){const t=s[a];t===null?delete process.env[a]:process.env[a]=t}}}e.$vkc=i}),define(Se[385],De([1,0,50,21,4,3,123,9,23,2,31,13,257,64,109,88,382,27,20,70,360]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=e.$Bkc=e.$Akc=e.$zkc=e.$ykc=e.$xkc=e.$wkc=void 0;function a(m){const y=m.trim().split(`
`),P=[];return y.forEach(U=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);z&&z.length>=3&&P.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),P.reduce((U,z)=>(U[z.socket]=z,U),{})}e.$wkc=a;function t(...m){const y=[].concat(...m.map(l));return[...new Map(y.filter(P=>P.st==="0A").map(P=>{const j=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:d(j[0]),port:parseInt(j[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$xkc=t;function d(m){let y="";if(m.length===8)for(let P=m.length-2;P>=0;P-=2)y+=parseInt(m.substr(P,2),16),P!==0&&(y+=".");else for(let P=0;P<m.length;P+=8){const j=m.substring(P,P+8);let U="";for(let z=8;z>=2;z-=2)U+=j.substring(z-2,z),(z===6||z===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",P+z!==m.length-6&&(y+=":"))}return y}e.$ykc=d;function l(m){const y=m.trim().split(`
`),P=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((z,N,A)=>(z[P[A]||A]=N,z),{}))}e.$zkc=l;function r(m){return!!m.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||m.indexOf("out/server-main.js")!==-1||m.indexOf("_productName=VSCode")!==-1}function c(m){const y=m.trim().split(`
`),P=[];return y.forEach(j=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(j);U&&U.length>=4&&P.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),P}e.$Akc=c;async function h(m,y,P){const j=P.reduce((z,N)=>(z[N.pid]=N,z),{}),U=[];return m.forEach(({socket:z,ip:N,port:A})=>{const T=y[z]?y[z].pid:void 0,F=T?j[T]?.cmd:void 0;T&&F&&!r(F)&&U.push({host:N,port:A,detail:F,pid:T})}),U}e.$Bkc=h;function g(m,y,P){const j=new Map,U=c(y);for(const z of m){const N=P.get(z.port);if(N){j.set(z.port,N);continue}const A=U.find(T=>T.cmd.includes(`${z.port}`));if(A){let T=A,F;do F=U.find(G=>G.ppid===T.pid),F&&(T=F);while(F);j.set(z.port,{host:z.ip,port:z.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else j.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return j}e.$Ckc=g;let C=class extends n.$zAb{constructor(y,P,j,U){super(y,P,j),this.D=P,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,w.$e&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const j=new L.$jm;let U=0;for(;this.C;){const z=new Date().getTime(),N=(await this.I()).filter(F=>(0,u.$Sv)(F.host)||(0,u.$Uv)(F.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(F=>F.port).join(", ")}`);const A=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${A} ms.`),U++>3&&j.update(A),(!P||JSON.stringify(P)!==JSON.stringify(N))&&(P=N,await this.a.$onFoundNewCandidates(P));const T=this.G(j.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(F=>setTimeout(()=>F(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",P="";try{y=await M.Promises.readFile("/proc/net/tcp","utf8"),P=await M.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const j=t(y,P),U=await new Promise(X=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,Z,ie)=>{X(Z)})}),z=a(U),N=await M.Promises.readdir("/proc"),A=[];for(const X of N)try{const Q=Number(X),Z=$.$Rg(k.URI.file("/proc"),X);if((await M.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(Q)){const ee=await M.Promises.readlink($.$Rg(Z,"cwd").fsPath),we=await M.Promises.readFile($.$Rg(Z,"cmdline").fsPath,"utf8");A.push({pid:Q,cwd:ee,cmd:we})}}catch{}const T=[],F=j.filter(X=>{const Q=z[X.socket];return Q||T.push(X),Q}),G=h(F,z,A);let K;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const X=await new Promise(Q=>{(0,D.exec)("ps -F -A -l | grep root",(Z,ie,ee)=>{Q(ie)})});this.z=g(T,X,this.z),K=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.map(Q=>Q.port).join(", ")}`)}return G.then(X=>K?X.concat(K):X)}w(y){return async P=>{const j=new b.$Bac({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,N,A,T){const F=await y.makeConnection();return v.connect(F,N,A,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$hl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await j.waitForReady();const U=new f.$5d;return{localAddress:(0,s.$oL)(j.localAddress)??j.localAddress,remoteAddress:{port:j.tunnelRemotePort,host:j.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{j.dispose(),U.fire(),U.dispose()}}}}};e.$Dkc=C,e.$Dkc=C=Je([He(0,i.$fO),He(1,o.$vO),He(2,I.$yj),He(3,E.$tl)],C);class v extends p.$ytb{static connect(y,P,j,U){const z=new R.$Sc,N={onClose:z.add(new f.$5d),onData:z.add(new f.$5d),onEnd:z.add(new f.$5d)};z.add(y.onDidReceiveMessage(T=>N.onData.fire(O.$se.wrap(T)))),z.add(y.onDidEnd(()=>N.onEnd.fire())),z.add(y.onDidClose(T=>N.onClose.fire({type:0,error:T,hadError:!!T})));const A=new v(y,U,N);return A.B(z),(0,p.$xtb)(A,P,j,U,N)}constructor(y,P,j){super(P,j),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[386],De([1,0,84,355,369,368,381,384,385,96,47,97,95,46,70,93,354,310,13,370,60,272,105,109,139]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i,n,s,a,t,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$$r)(M.$Mic,w.$vkc,0),(0,D.$$r)(i.$zj,o.$Fkc,1),(0,D.$$r)(i.$yj,new t.$bi(a.$Vjc,[!1],!0)),(0,D.$$r)(d.$tl,l.$Gac,1),(0,D.$$r)(u.$eic,b.$Ekc,0),(0,D.$$r)(k.$Ric,R.$9jc,0),(0,D.$$r)(I.$bjc,L.$qkc,0),(0,D.$$r)(p.$Ejc,f.$1jc,0),(0,D.$$r)(S.$zic,O.$Zjc,0),(0,D.$$r)(E.$yAb,$.$Dkc,0),(0,D.$$r)(s.$Pic,n.$Gkc,0)}),define(Se[397],De([1,0,111,63,398,58,14,81,121,255,114,367,21,31,102,8,133,278,292,372,386]),function(re,e,D,O,f,R,L,w,$,k,M,I,p,S,E,u,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let C=0;C<process.execArgv.length;C++)process.execArgv[C]==="--inspect-port=0"&&(process.execArgv.splice(C,1),C--)}();const n=f(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,C=g._load;g._load=function(v){if(v==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return C.apply(this,arguments)}})();const s=process.exit.bind(process),a=process.on.bind(process);function t(g){process.exit=function(C){if(g)s(C);else{const v=new Error("An extension called process.exit() and this was prevented.");console.warn(v.stack)}},process.crash=function(){const C=new Error("An extension called process.crash() and this was prevented.");console.warn(C.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(C,v){C==="uncaughtException"&&(v=function(){try{return v.call(void 0,arguments)}catch{}}),a(C,v)}}let d=function(g){s()};function l(){const g=(0,i.$7m)(process.env);if(g.type===3)return new Promise((C,v)=>{const m=y=>{const P=y[0],j=new w.$4h;P.on("message",U=>j.fire(p.$se.wrap(U.data))),P.on("close",()=>{d("renderer closed the MessagePort")}),P.start(),C({onMessage:j.event,send:U=>P.postMessage(U.buffer)})};process.parentPort.on("message",y=>m(y.ports))});if(g.type===2)return new Promise((C,v)=>{let m=null;const y=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),P=108e5,j=3e5,U=new u.$rh(()=>d("renderer disconnected for too long (1)"),P),z=new u.$rh(()=>d("renderer disconnected for too long (2)"),j);process.on("message",(A,T)=>{if(A&&A.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const F=p.$se.wrap(Buffer.from(A.initialDataChunk,"base64"));let G;if(A.skipWebSocketFrames)G=new $.$6h(T,"extHost-socket");else{const K=p.$se.wrap(Buffer.from(A.inflateBytes,"base64"));G=new $.$7h(new $.$6h(T,"extHost-socket"),A.permessageDeflate,K,!1)}m?(U.cancel(),z.cancel(),m.beginAcceptReconnection(G,F),m.endAcceptReconnection(),m.sendResume()):(clearTimeout(y),m=new w.$5h({socket:G,initialChunk:F}),m.sendResume(),m.onDidDispose(()=>d("renderer disconnected")),C(m),m.onSocketClose(()=>{U.schedule()}))}if(A&&A.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;U.isScheduled()&&z.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const C=g.pipeName;return new Promise((v,m)=>{const y=O.createConnection(C,()=>{y.removeListener("error",m);const P=new w.$5h({socket:new $.$6h(y,"extHost-renderer")});P.sendResume(),v(P)});y.once("error",m),y.on("close",()=>{d("renderer closed the socket")})})}}async function r(){const g=await l();return new class{constructor(){this.a=new w.$4h,this.onMessage=this.a.event,this.b=!1,g.onMessage(C=>{(0,M.$Gm)(C,2)?(this.b=!0,d("received terminate message from renderer")):this.a.fire(C)})}send(C){this.b||g.send(C)}async drain(){if(g.drain)return g.drain()}}}function c(g){return new Promise(C=>{const v=g.onMessage(m=>{v.dispose();const y=JSON.parse(m.toString()),P=y.commit,j=k.default.commit;if(P&&j&&P!==j&&s(55),y.parentPid){let U=0;setInterval(function(){try{process.kill(y.parentPid,0),U=0}catch(N){N&&N.code==="EPERM"?(U++,U>=3&&d(`parent process ${y.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):d(`parent process ${y.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(y.parentPid)}catch(N){(0,L.$1)(N)}}g.send((0,M.$Fm)(0)),C({protocol:g,initData:y})});g.send((0,M.$Fm)(1))})}async function h(){const g=[];process.on("unhandledRejection",(U,z)=>{g.push(z),setTimeout(()=>{const N=g.indexOf(z);N>=0&&z.catch(A=>{g.splice(N,1),(0,L.$4)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A&&A.stack&&console.warn(`stack trace: ${A.stack}`),U&&(0,L.$1)(U))})},1e3)}),process.on("rejectionHandled",U=>{const z=g.indexOf(U);z>=0&&g.splice(z,1)}),process.on("uncaughtException",function(U){(0,L.$Z)(U)||(0,L.$1)(U)}),R.mark("code/extHost/willConnectToRenderer");const C=await r();R.mark("code/extHost/didConnectToRenderer");const v=await c(C);R.mark("code/extHost/didWaitForInitData");const{initData:m}=v;t(!!m.environment.extensionTestsLocationURI),m.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,m.environment.skipWorkspaceStorageLock=(0,b.boolean)(n.skipWorkspaceStorageLock,!1);const y=new class{constructor(){this.pid=process.pid}exit(z){s(z)}fsExists(z){return S.Promises.exists(z)}fsRealpath(z){return(0,E.$Hq)(z)}};let P=null;m.remote.authority&&n.transformURIs&&(P=(0,o.$cs)(m.remote.authority));const j=new I.$Yjc(v.protocol,m,y,P);d=U=>{j.terminate(U);const z=process.env.VSCODE_IPC_HOOK_CLI,N=process.env.CODE_SERVER_SESSION_SOCKET;if(!z||!N)return;const A=JSON.stringify({socketPath:z}),T={path:"/delete-session",socketPath:N,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},F=D.request(T);F.write(A),F.end()}}h().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
