"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Me=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/glob","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/iterator","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(x){for(var e=[],D=0,P=x.length;D<P;D++)e[D]=Me[x[D]];return e};define(Me[68],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function D(M){return(g,f,k)=>{let F=null,S=null;if(typeof k.value=="function"?(F="value",S=k.value):typeof k.get=="function"&&(F="get",S=k.get),!S)throw new Error("not supported");k[F]=M(S,f)}}function P(M,g,f){let k=null,F=null;if(typeof f.value=="function"?(k="value",F=f.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(k="get",F=f.get),!F)throw new Error("not supported");const S=`$memoize$${g}`;f[k]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,l)}),this[S]}}e.$Ih=P;function C(M,g,f){return D((k,F)=>{const S=`$debounce$${F}`,l=`$debounce$result$${F}`;return function(...w){this[l]||(this[l]=f?f():void 0),clearTimeout(this[S]),g&&(this[l]=g(this[l],...w),w=[this[l]]),this[S]=setTimeout(()=>{k.apply(this,w),this[l]=f?f():void 0},M)}})}e.$Jh=C;function L(M,g,f){return D((k,F)=>{const S=`$throttle$timer$${F}`,l=`$throttle$result$${F}`,w=`$throttle$lastRun$${F}`,m=`$throttle$pending$${F}`;return function(...s){if(this[l]||(this[l]=f?f():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),g&&(this[l]=g(this[l],...s)),this[m])return;const u=this[w]+M;u<=Date.now()?(this[w]=Date.now(),k.apply(this,[this[l]]),this[l]=f?f():void 0):(this[m]=!0,this[S]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),k.apply(this,[this[l]]),this[l]=f?f():void 0},u-Date.now()))}})}e.$Kh=L}),define(Me[88],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0;class D{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$kO=D,e.$lO=new D("id#")}),define(Me[120],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function M(t,$=!1){let c=0;const o=t.length;let b="",p=0,d=16,I=0;function v(O){let R=0,B=0;for(;R<O;){const T=t.charCodeAt(c);if(T>=48&&T<=57)B=B*16+T-48;else if(T>=65&&T<=70)B=B*16+T-65+10;else if(T>=97&&T<=102)B=B*16+T-97+10;else break;c++,R++}return R<O&&(B=-1),B}function y(O){c=O,b="",p=0,d=16,I=0}function E(){const O=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&k(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&k(t.charCodeAt(c)))for(c++;c<t.length&&k(t.charCodeAt(c));)c++;else return I=3,t.substring(O,c);let R=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&k(t.charCodeAt(c))){for(c++;c<t.length&&k(t.charCodeAt(c));)c++;R=c}else I=3;return t.substring(O,R)}function A(){let O="",R=c;for(;;){if(c>=o){O+=t.substring(R,c),I=2;break}const B=t.charCodeAt(c);if(B===34){O+=t.substring(R,c),c++;break}if(B===92){if(O+=t.substring(R,c),c++,c>=o){I=2;break}switch(t.charCodeAt(c++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const te=v(4);te>=0?O+=String.fromCharCode(te):I=4;break}default:I=5}R=c;continue}if(B>=0&&B<=31)if(f(B)){O+=t.substring(R,c),I=2;break}else I=6;c++}return O}function V(){if(b="",I=0,p=c,c>=o)return p=o,d=17;let O=t.charCodeAt(c);if(g(O)){do c++,b+=String.fromCharCode(O),O=t.charCodeAt(c);while(g(O));return d=15}if(f(O))return c++,b+=String.fromCharCode(O),O===13&&t.charCodeAt(c)===10&&(c++,b+=`
`),d=14;switch(O){case 123:return c++,d=1;case 125:return c++,d=2;case 91:return c++,d=3;case 93:return c++,d=4;case 58:return c++,d=6;case 44:return c++,d=5;case 34:return c++,b=A(),d=10;case 47:{const R=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<o&&!f(t.charCodeAt(c));)c++;return b=t.substring(R,c),d=12}if(t.charCodeAt(c+1)===42){c+=2;const B=o-1;let T=!1;for(;c<B;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,T=!0;break}c++}return T||(c++,I=1),b=t.substring(R,c),d=13}return b+=String.fromCharCode(O),c++,d=16}case 45:if(b+=String.fromCharCode(O),c++,c===o||!k(t.charCodeAt(c)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=E(),d=11;default:for(;c<o&&X(O);)c++,O=t.charCodeAt(c);if(p!==c){switch(b=t.substring(p,c),b){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return b+=String.fromCharCode(O),c++,d=16}}function X(O){if(g(O)||f(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let O;do O=V();while(O>=12&&O<=15);return O}return{setPosition:y,getPosition:()=>c,scan:$?H:V,getToken:()=>d,getTokenValue:()=>b,getTokenOffset:()=>p,getTokenLength:()=>c-p,getTokenError:()=>I}}e.$nn=M;function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var F;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(F||(F={}));function S(t,$){const c=[],o=new Object;let b;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function I(v,y,E,A){p.value=v,p.offset=y,p.length=E,p.type=A,p.colonOffset=void 0,b=p}try{n(t,{onObjectBegin:(v,y)=>{if($<=v)throw o;b=void 0,d=$>v,c.push("")},onObjectProperty:(v,y,E)=>{if($<y||(I(v,y,E,"property"),c[c.length-1]=v,$<=y+E))throw o},onObjectEnd:(v,y)=>{if($<=v)throw o;b=void 0,c.pop()},onArrayBegin:(v,y)=>{if($<=v)throw o;b=void 0,c.push(0)},onArrayEnd:(v,y)=>{if($<=v)throw o;b=void 0,c.pop()},onLiteralValue:(v,y,E)=>{if($<y||(I(v,y,E,h(v)),$<=y+E))throw o},onSeparator:(v,y,E)=>{if($<=y)throw o;if(v===":"&&b&&b.type==="property")b.colonOffset=y,d=!1,b=void 0;else if(v===","){const A=c[c.length-1];typeof A=="number"?c[c.length-1]=A+1:(d=!0,c[c.length-1]=""),b=void 0}}})}catch(v){if(v!==o)throw v}return{path:c,previousNode:b,isAtPropertyKey:d,matches:v=>{let y=0;for(let E=0;y<v.length&&E<c.length;E++)if(v[y]===c[E]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.$on=S;function l(t,$=[],c=L.DEFAULT){let o=null,b=[];const p=[];function d(v){Array.isArray(b)?b.push(v):o!==null&&(b[o]=v)}return n(t,{onObjectBegin:()=>{const v={};d(v),p.push(b),b=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{b=p.pop()},onArrayBegin:()=>{const v=[];d(v),p.push(b),b=v,o=null},onArrayEnd:()=>{b=p.pop()},onLiteralValue:d,onError:(v,y,E)=>{$.push({error:v,offset:y,length:E})}},c),b[0]}e.$pn=l;function w(t,$=[],c=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(v){o.type==="property"&&(o.length=v-o.offset,o=o.parent)}function p(v){return o.children.push(v),v}n(t,{onObjectBegin:v=>{o=p({type:"object",offset:v,length:-1,parent:o,children:[]})},onObjectProperty:(v,y,E)=>{o=p({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:v,offset:y,length:E,parent:o})},onObjectEnd:(v,y)=>{o.length=v+y-o.offset,o=o.parent,b(v+y)},onArrayBegin:(v,y)=>{o=p({type:"array",offset:v,length:-1,parent:o,children:[]})},onArrayEnd:(v,y)=>{o.length=v+y-o.offset,o=o.parent,b(v+y)},onLiteralValue:(v,y,E)=>{p({type:h(v),offset:y,length:E,parent:o,value:v}),b(y+E)},onSeparator:(v,y,E)=>{o.type==="property"&&(v===":"?o.colonOffset=y:v===","&&b(y))},onError:(v,y,E)=>{$.push({error:v,offset:y,length:E})}},c);const I=o.children[0];return I&&delete I.parent,I}e.$qn=w;function m(t,$){if(!t)return;let c=t;for(const o of $)if(typeof o=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let b=!1;for(const p of c.children)if(Array.isArray(p.children)&&p.children[0].value===o){c=p.children[1],b=!0;break}if(!b)return}else{const b=o;if(c.type!=="array"||b<0||!Array.isArray(c.children)||b>=c.children.length)return;c=c.children[b]}return c}e.$rn=m;function s(t){if(!t.parent||!t.parent.children)return[];const $=s(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;$.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&$.push(c)}return $}e.$sn=s;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const $=Object.create(null);for(const c of t.children){const o=c.children[1];o&&($[c.children[0].value]=u(o))}return $}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$tn=u;function i(t,$,c=!1){return $>=t.offset&&$<t.offset+t.length||c&&$===t.offset+t.length}e.$un=i;function r(t,$,c=!1){if(i(t,$,c)){const o=t.children;if(Array.isArray(o))for(let b=0;b<o.length&&o[b].offset<=$;b++){const p=r(o[b],$,c);if(p)return p}return t}}e.$vn=r;function n(t,$,c=L.DEFAULT){const o=M(t,!1);function b(ne){return ne?()=>ne(o.getTokenOffset(),o.getTokenLength()):()=>!0}function p(ne){return ne?ke=>ne(ke,o.getTokenOffset(),o.getTokenLength()):()=>!0}const d=b($.onObjectBegin),I=p($.onObjectProperty),v=b($.onObjectEnd),y=b($.onArrayBegin),E=b($.onArrayEnd),A=p($.onLiteralValue),V=p($.onSeparator),X=b($.onComment),H=p($.onError),O=c&&c.disallowComments,R=c&&c.allowTrailingComma;function B(){for(;;){const ne=o.scan();switch(o.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:O||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(ne){case 12:case 13:O?T(10):X();break;case 16:T(1);break;case 15:case 14:break;default:return ne}}}function T(ne,ke=[],oe=[]){if(H(ne),ke.length+oe.length>0){let ve=o.getToken();for(;ve!==17;){if(ke.indexOf(ve)!==-1){B();break}else if(oe.indexOf(ve)!==-1)break;ve=B()}}}function te(ne){const ke=o.getTokenValue();return ne?A(ke):I(ke),B(),!0}function Q(){switch(o.getToken()){case 11:{let ne=0;try{ne=JSON.parse(o.getTokenValue()),typeof ne!="number"&&(T(2),ne=0)}catch{T(2)}A(ne);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return B(),!0}function ce(){return o.getToken()!==10?(T(3,[],[2,5]),!1):(te(!1),o.getToken()===6?(V(":"),B(),$e()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function le(){d(),B();let ne=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ne||T(4,[],[]),V(","),B(),o.getToken()===2&&R)break}else ne&&T(6,[],[]);ce()||T(4,[],[2,5]),ne=!0}return v(),o.getToken()!==2?T(7,[2],[]):B(),!0}function se(){y(),B();let ne=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ne||T(4,[],[]),V(","),B(),o.getToken()===4&&R)break}else ne&&T(6,[],[]);$e()||T(4,[],[4,5]),ne=!0}return E(),o.getToken()!==4?T(8,[4],[]):B(),!0}function $e(){switch(o.getToken()){case 3:return se();case 1:return le();case 10:return te(!0);default:return Q()}}return B(),o.getToken()===17?c.allowEmptyContent?!0:(T(4,[],[]),!1):$e()?(o.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.$wn=n;function a(t,$){const c=M(t),o=[];let b,p=0,d;do switch(d=c.getPosition(),b=c.scan(),b){case 12:case 13:case 17:p!==d&&o.push(t.substring(p,d)),$!==void 0&&o.push(c.getTokenValue().replace(/[^\r\n]/g,$)),p=c.getPosition();break}while(b!==17);return o.join("")}e.$xn=a;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$yn=h}),function(x,e){typeof define=="function"&&define.amd?define(Me[121],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(x=typeof globalThis<"u"?globalThis:x||self,e(x.marked={}))}(this,function(x){"use strict";function e(ye,we){for(var he=0;he<we.length;he++){var K=we[he];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ye,K.key,K)}}function D(ye,we,he){return we&&e(ye.prototype,we),he&&e(ye,he),Object.defineProperty(ye,"prototype",{writable:!1}),ye}function P(ye,we){if(ye){if(typeof ye=="string")return C(ye,we);var he=Object.prototype.toString.call(ye).slice(8,-1);if(he==="Object"&&ye.constructor&&(he=ye.constructor.name),he==="Map"||he==="Set")return Array.from(ye);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return C(ye,we)}}function C(ye,we){(we==null||we>ye.length)&&(we=ye.length);for(var he=0,K=new Array(we);he<we;he++)K[he]=ye[he];return K}function L(ye,we){var he=typeof Symbol<"u"&&ye[Symbol.iterator]||ye["@@iterator"];if(he)return(he=he.call(ye)).next.bind(he);if(Array.isArray(ye)||(he=P(ye))||we&&ye&&typeof ye.length=="number"){he&&(ye=he);var K=0;return function(){return K>=ye.length?{done:!0}:{done:!1,value:ye[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}x.defaults=M();function g(ye){x.defaults=ye}var f=/[&<>"']/,k=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(we){return l[we]};function m(ye,we){if(we){if(f.test(ye))return ye.replace(k,w)}else if(F.test(ye))return ye.replace(S,w);return ye}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ye){return ye.replace(s,function(we,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var i=/(^|[^\[])\^/g;function r(ye,we){ye=typeof ye=="string"?ye:ye.source,we=we||"";var he={replace:function(Y,me){return me=me.source||me,me=me.replace(i,"$1"),ye=ye.replace(Y,me),he},getRegex:function(){return new RegExp(ye,we)}};return he}var n=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ye,we,he){if(ye){var K;try{K=decodeURIComponent(u(he)).replace(n,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}we&&!a.test(he)&&(he=b(we,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var t={},$=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(ye,we){t[" "+ye]||($.test(ye)?t[" "+ye]=ye+"/":t[" "+ye]=v(ye,"/",!0)),ye=t[" "+ye];var he=ye.indexOf(":")===-1;return we.substring(0,2)==="//"?he?we:ye.replace(c,"$1")+we:we.charAt(0)==="/"?he?we:ye.replace(o,"$1")+we:ye+we}var p={exec:function(){}};function d(ye){for(var we=1,he,K;we<arguments.length;we++){he=arguments[we];for(K in he)Object.prototype.hasOwnProperty.call(he,K)&&(ye[K]=he[K])}return ye}function I(ye,we){var he=ye.replace(/\|/g,function(me,pe,Fe){for(var be=!1,Re=pe;--Re>=0&&Fe[Re]==="\\";)be=!be;return be?"|":" |"}),K=he.split(/ \|/),Y=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>we)K.splice(we);else for(;K.length<we;)K.push("");for(;Y<K.length;Y++)K[Y]=K[Y].trim().replace(/\\\|/g,"|");return K}function v(ye,we,he){var K=ye.length;if(K===0)return"";for(var Y=0;Y<K;){var me=ye.charAt(K-Y-1);if(me===we&&!he)Y++;else if(me!==we&&he)Y++;else break}return ye.slice(0,K-Y)}function y(ye,we){if(ye.indexOf(we[1])===-1)return-1;for(var he=ye.length,K=0,Y=0;Y<he;Y++)if(ye[Y]==="\\")Y++;else if(ye[Y]===we[0])K++;else if(ye[Y]===we[1]&&(K--,K<0))return Y;return-1}function E(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ye,we){if(we<1)return"";for(var he="";we>1;)we&1&&(he+=ye),we>>=1,ye+=ye;return he+ye}function V(ye,we,he,K){var Y=we.href,me=we.title?m(we.title):null,pe=ye[1].replace(/\\([\[\]])/g,"$1");if(ye[0].charAt(0)!=="!"){K.state.inLink=!0;var Fe={type:"link",raw:he,href:Y,title:me,text:pe,tokens:K.inlineTokens(pe)};return K.state.inLink=!1,Fe}return{type:"image",raw:he,href:Y,title:me,text:m(pe)}}function X(ye,we){var he=ye.match(/^(\s+)(?:```)/);if(he===null)return we;var K=he[1];return we.split(`
`).map(function(Y){var me=Y.match(/^\s+/);if(me===null)return Y;var pe=me[0];return pe.length>=K.length?Y.slice(K.length):Y}).join(`
`)}var H=function(){function ye(he){this.options=he||x.defaults}var we=ye.prototype;return we.space=function(K){var Y=this.rules.block.newline.exec(K);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},we.code=function(K){var Y=this.rules.block.code.exec(K);if(Y){var me=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},we.fences=function(K){var Y=this.rules.block.fences.exec(K);if(Y){var me=Y[0],pe=X(me,Y[3]||"");return{type:"code",raw:me,lang:Y[2]?Y[2].trim():Y[2],text:pe}}},we.heading=function(K){var Y=this.rules.block.heading.exec(K);if(Y){var me=Y[2].trim();if(/#$/.test(me)){var pe=v(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:me,tokens:this.lexer.inline(me)}}},we.hr=function(K){var Y=this.rules.block.hr.exec(K);if(Y)return{type:"hr",raw:Y[0]}},we.blockquote=function(K){var Y=this.rules.block.blockquote.exec(K);if(Y){var me=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},we.list=function(K){var Y=this.rules.block.list.exec(K);if(Y){var me,pe,Fe,be,Re,Pe,We,j,z,q,W,ie,ue=Y[1].trim(),Le=ue.length>1,Be={type:"list",raw:"",ordered:Le,start:Le?+ue.slice(0,-1):"",loose:!1,items:[]};ue=Le?"\\d{1,9}\\"+ue.slice(-1):"\\"+ue,this.options.pedantic&&(ue=Le?ue:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(ie=!1,!(!(Y=Ke.exec(K))||this.rules.block.hr.test(K)));){if(me=Y[0],K=K.substring(me.length),j=Y[2].split(`
`,1)[0],z=K.split(`
`,1)[0],this.options.pedantic?(be=2,W=j.trimLeft()):(be=Y[2].search(/[^ ]/),be=be>4?1:be,W=j.slice(be),be+=Y[1].length),Pe=!1,!j&&/^ *$/.test(z)&&(me+=z+`
`,K=K.substring(z.length+1),ie=!0),!ie)for(var et=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ft=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");K&&(q=K.split(`
`,1)[0],j=q,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ft.test(j)||at.test(j)||et.test(j)||rt.test(K)));){if(j.search(/[^ ]/)>=be||!j.trim())W+=`
`+j.slice(be);else if(!Pe)W+=`
`+j;else break;!Pe&&!j.trim()&&(Pe=!0),me+=q+`
`,K=K.substring(q.length+1)}Be.loose||(We?Be.loose=!0:/\n *\n *$/.test(me)&&(We=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(W),pe&&(Fe=pe[0]!=="[ ] ",W=W.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:me,task:!!pe,checked:Fe,loose:!1,text:W}),Be.raw+=me}Be.items[Be.items.length-1].raw=me.trimRight(),Be.items[Be.items.length-1].text=W.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Re=0;Re<nt;Re++){this.lexer.state.top=!1,Be.items[Re].tokens=this.lexer.blockTokens(Be.items[Re].text,[]);var ct=Be.items[Re].tokens.filter(function(it){return it.type==="space"}),Ve=ct.every(function(it){for(var _=it.raw.split(""),Z=0,Ee=L(_),qe;!(qe=Ee()).done;){var Ye=qe.value;if(Ye===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&ct.length&&Ve&&(Be.loose=!0,Be.items[Re].loose=!0)}return Be}},we.html=function(K){var Y=this.rules.block.html.exec(K);if(Y){var me={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},we.def=function(K){var Y=this.rules.block.def.exec(K);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var me=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:Y[0],href:Y[2],title:Y[3]}}},we.table=function(K){var Y=this.rules.block.table.exec(K);if(Y){var me={type:"table",header:I(Y[1]).map(function(We){return{text:We}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=Y[0];var pe=me.align.length,Fe,be,Re,Pe;for(Fe=0;Fe<pe;Fe++)/^ *-+: *$/.test(me.align[Fe])?me.align[Fe]="right":/^ *:-+: *$/.test(me.align[Fe])?me.align[Fe]="center":/^ *:-+ *$/.test(me.align[Fe])?me.align[Fe]="left":me.align[Fe]=null;for(pe=me.rows.length,Fe=0;Fe<pe;Fe++)me.rows[Fe]=I(me.rows[Fe],me.header.length).map(function(We){return{text:We}});for(pe=me.header.length,be=0;be<pe;be++)me.header[be].tokens=this.lexer.inline(me.header[be].text);for(pe=me.rows.length,be=0;be<pe;be++)for(Pe=me.rows[be],Re=0;Re<Pe.length;Re++)Pe[Re].tokens=this.lexer.inline(Pe[Re].text);return me}}},we.lheading=function(K){var Y=this.rules.block.lheading.exec(K);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},we.paragraph=function(K){var Y=this.rules.block.paragraph.exec(K);if(Y){var me=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:me,tokens:this.lexer.inline(me)}}},we.text=function(K){var Y=this.rules.block.text.exec(K);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},we.escape=function(K){var Y=this.rules.inline.escape.exec(K);if(Y)return{type:"escape",raw:Y[0],text:m(Y[1])}},we.tag=function(K){var Y=this.rules.inline.tag.exec(K);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]}},we.link=function(K){var Y=this.rules.inline.link.exec(K);if(Y){var me=Y[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=v(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Fe=y(Y[2],"()");if(Fe>-1){var be=Y[0].indexOf("!")===0?5:4,Re=be+Y[1].length+Fe;Y[2]=Y[2].substring(0,Fe),Y[0]=Y[0].substring(0,Re).trim(),Y[3]=""}}var Pe=Y[2],We="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);j&&(Pe=j[1],We=j[3])}else We=Y[3]?Y[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(me)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),V(Y,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},we.reflink=function(K,Y){var me;if((me=this.rules.inline.reflink.exec(K))||(me=this.rules.inline.nolink.exec(K))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=Y[pe.toLowerCase()],!pe||!pe.href){var Fe=me[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return V(me,pe,me[0],this.lexer)}},we.emStrong=function(K,Y,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(K);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=pe[1]||pe[2]||"";if(!Fe||Fe&&(me===""||this.rules.inline.punctuation.exec(me))){var be=pe[0].length-1,Re,Pe,We=be,j=0,z=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,Y=Y.slice(-1*K.length+be);(pe=z.exec(Y))!=null;)if(Re=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Re){if(Pe=Re.length,pe[3]||pe[4]){We+=Pe;continue}else if((pe[5]||pe[6])&&be%3&&!((be+Pe)%3)){j+=Pe;continue}if(We-=Pe,!(We>0)){if(Pe=Math.min(Pe,Pe+We+j),Math.min(be,Pe)%2){var q=K.slice(1,be+pe.index+Pe);return{type:"em",raw:K.slice(0,be+pe.index+Pe+1),text:q,tokens:this.lexer.inlineTokens(q)}}var W=K.slice(2,be+pe.index+Pe-1);return{type:"strong",raw:K.slice(0,be+pe.index+Pe+1),text:W,tokens:this.lexer.inlineTokens(W)}}}}}},we.codespan=function(K){var Y=this.rules.inline.code.exec(K);if(Y){var me=Y[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Fe=/^ /.test(me)&&/ $/.test(me);return pe&&Fe&&(me=me.substring(1,me.length-1)),me=m(me,!0),{type:"codespan",raw:Y[0],text:me}}},we.br=function(K){var Y=this.rules.inline.br.exec(K);if(Y)return{type:"br",raw:Y[0]}},we.del=function(K){var Y=this.rules.inline.del.exec(K);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},we.autolink=function(K,Y){var me=this.rules.inline.autolink.exec(K);if(me){var pe,Fe;return me[2]==="@"?(pe=m(this.options.mangle?Y(me[1]):me[1]),Fe="mailto:"+pe):(pe=m(me[1]),Fe=pe),{type:"link",raw:me[0],text:pe,href:Fe,tokens:[{type:"text",raw:pe,text:pe}]}}},we.url=function(K,Y){var me;if(me=this.rules.inline.url.exec(K)){var pe,Fe;if(me[2]==="@")pe=m(this.options.mangle?Y(me[0]):me[0]),Fe="mailto:"+pe;else{var be;do be=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(be!==me[0]);pe=m(me[0]),me[1]==="www."?Fe="http://"+pe:Fe=pe}return{type:"link",raw:me[0],text:pe,href:Fe,tokens:[{type:"text",raw:pe,text:pe}]}}},we.inlineText=function(K,Y){var me=this.rules.inline.text.exec(K);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):m(me[0]):me[0]:pe=m(this.options.smartypants?Y(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},ye}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=r(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=r(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=r(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=r(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=r(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=r(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=d({},O),O.gfm=d({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=r(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=r(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=d({},O.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:r(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=r(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=r(O._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=r(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=r(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=r(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=r(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=r(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=r(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=r(R.reflink).replace("label",R._label).replace("ref",O._label).getRegex(),R.nolink=r(R.nolink).replace("ref",O._label).getRegex(),R.reflinkSearch=r(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=d({},R),R.pedantic=d({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=d({},R.normal,{escape:r(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=r(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=d({},R.gfm,{br:r(R.br).replace("{2,}","*").getRegex(),text:r(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function T(ye){var we="",he,K,Y=ye.length;for(he=0;he<Y;he++)K=ye.charCodeAt(he),Math.random()>.5&&(K="x"+K.toString(16)),we+="&#"+K+";";return we}var te=function(){function ye(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||x.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:O.normal,inline:R.normal};this.options.pedantic?(K.block=O.pedantic,K.inline=R.pedantic):this.options.gfm&&(K.block=O.gfm,this.options.breaks?K.inline=R.breaks:K.inline=R.gfm),this.tokenizer.rules=K}ye.lex=function(K,Y){var me=new ye(Y);return me.lex(K)},ye.lexInline=function(K,Y){var me=new ye(Y);return me.inlineTokens(K)};var we=ye.prototype;return we.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},we.blockTokens=function(K,Y){var me=this;Y===void 0&&(Y=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(We,j,z){return j+"    ".repeat(z.length)});for(var pe,Fe,be,Re;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(pe=We.call({lexer:me},K,Y))?(K=K.substring(pe.raw.length),Y.push(pe),!0):!1}))){if(pe=this.tokenizer.space(K)){K=K.substring(pe.raw.length),pe.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(pe);continue}if(pe=this.tokenizer.code(K)){K=K.substring(pe.raw.length),Fe=Y[Y.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):Y.push(pe);continue}if(pe=this.tokenizer.fences(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.heading(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.hr(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.blockquote(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.list(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.html(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.def(K)){K=K.substring(pe.raw.length),Fe=Y[Y.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.lheading(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(be=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,j=K.slice(1),z=void 0;me.options.extensions.startBlock.forEach(function(q){z=q.call({lexer:this},j),typeof z=="number"&&z>=0&&(We=Math.min(We,z))}),We<1/0&&We>=0&&(be=K.substring(0,We+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(be))){Fe=Y[Y.length-1],Re&&Fe.type==="paragraph"?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):Y.push(pe),Re=be.length!==K.length,K=K.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(K)){K=K.substring(pe.raw.length),Fe=Y[Y.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+pe.raw,Fe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):Y.push(pe);continue}if(K){var Pe="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,Y},we.inline=function(K,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:K,tokens:Y}),Y},we.inlineTokens=function(K,Y){var me=this;Y===void 0&&(Y=[]);var pe,Fe,be,Re=K,Pe,We,j;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)z.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,Pe.index)+"["+A("a",Pe[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,Pe.index)+"["+A("a",Pe[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,Pe.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(We||(j=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(W){return(pe=W.call({lexer:me},K,Y))?(K=K.substring(pe.raw.length),Y.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.tag(K)){K=K.substring(pe.raw.length),Fe=Y[Y.length-1],Fe&&pe.type==="text"&&Fe.type==="text"?(Fe.raw+=pe.raw,Fe.text+=pe.text):Y.push(pe);continue}if(pe=this.tokenizer.link(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(pe.raw.length),Fe=Y[Y.length-1],Fe&&pe.type==="text"&&Fe.type==="text"?(Fe.raw+=pe.raw,Fe.text+=pe.text):Y.push(pe);continue}if(pe=this.tokenizer.emStrong(K,Re,j)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.codespan(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.br(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.del(K)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.autolink(K,T)){K=K.substring(pe.raw.length),Y.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(K,T))){K=K.substring(pe.raw.length),Y.push(pe);continue}if(be=K,this.options.extensions&&this.options.extensions.startInline&&function(){var W=1/0,ie=K.slice(1),ue=void 0;me.options.extensions.startInline.forEach(function(Le){ue=Le.call({lexer:this},ie),typeof ue=="number"&&ue>=0&&(W=Math.min(W,ue))}),W<1/0&&W>=0&&(be=K.substring(0,W+1))}(),pe=this.tokenizer.inlineText(be,B)){K=K.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(j=pe.raw.slice(-1)),We=!0,Fe=Y[Y.length-1],Fe&&Fe.type==="text"?(Fe.raw+=pe.raw,Fe.text+=pe.text):Y.push(pe);continue}if(K){var q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return Y},D(ye,null,[{key:"rules",get:function(){return{block:O,inline:R}}}]),ye}(),Q=function(){function ye(he){this.options=he||x.defaults}var we=ye.prototype;return we.code=function(K,Y,me){var pe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(K,pe);Fe!=null&&Fe!==K&&(me=!0,K=Fe)}return K=K.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+m(pe,!0)+'">'+(me?K:m(K,!0))+`</code></pre>
`:"<pre><code>"+(me?K:m(K,!0))+`</code></pre>
`},we.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},we.html=function(K){return K},we.heading=function(K,Y,me,pe){if(this.options.headerIds){var Fe=this.options.headerPrefix+pe.slug(me);return"<h"+Y+' id="'+Fe+'">'+K+"</h"+Y+`>
`}return"<h"+Y+">"+K+"</h"+Y+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(K,Y,me){var pe=Y?"ol":"ul",Fe=Y&&me!==1?' start="'+me+'"':"";return"<"+pe+Fe+`>
`+K+"</"+pe+`>
`},we.listitem=function(K){return"<li>"+K+`</li>
`},we.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(K){return"<p>"+K+`</p>
`},we.table=function(K,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+Y+`</table>
`},we.tablerow=function(K){return`<tr>
`+K+`</tr>
`},we.tablecell=function(K,Y){var me=Y.header?"th":"td",pe=Y.align?"<"+me+' align="'+Y.align+'">':"<"+me+">";return pe+K+("</"+me+`>
`)},we.strong=function(K){return"<strong>"+K+"</strong>"},we.em=function(K){return"<em>"+K+"</em>"},we.codespan=function(K){return"<code>"+K+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(K){return"<del>"+K+"</del>"},we.link=function(K,Y,me){if(K=h(this.options.sanitize,this.options.baseUrl,K),K===null)return me;var pe='<a href="'+m(K)+'"';return Y&&(pe+=' title="'+Y+'"'),pe+=">"+me+"</a>",pe},we.image=function(K,Y,me){if(K=h(this.options.sanitize,this.options.baseUrl,K),K===null)return me;var pe='<img src="'+K+'" alt="'+me+'"';return Y&&(pe+=' title="'+Y+'"'),pe+=this.options.xhtml?"/>":">",pe},we.text=function(K){return K},ye}(),ce=function(){function ye(){}var we=ye.prototype;return we.strong=function(K){return K},we.em=function(K){return K},we.codespan=function(K){return K},we.del=function(K){return K},we.html=function(K){return K},we.text=function(K){return K},we.link=function(K,Y,me){return""+me},we.image=function(K,Y,me){return""+me},we.br=function(){return""},ye}(),le=function(){function ye(){this.seen={}}var we=ye.prototype;return we.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(K,Y){var me=K,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[K];do pe++,me=K+"-"+pe;while(this.seen.hasOwnProperty(me))}return Y||(this.seen[K]=pe,this.seen[me]=0),me},we.slug=function(K,Y){Y===void 0&&(Y={});var me=this.serialize(K);return this.getNextSafeSlug(me,Y.dryrun)},ye}(),se=function(){function ye(he){this.options=he||x.defaults,this.options.renderer=this.options.renderer||new Q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ce,this.slugger=new le}ye.parse=function(K,Y){var me=new ye(Y);return me.parse(K)},ye.parseInline=function(K,Y){var me=new ye(Y);return me.parseInline(K)};var we=ye.prototype;return we.parse=function(K,Y){Y===void 0&&(Y=!0);var me="",pe,Fe,be,Re,Pe,We,j,z,q,W,ie,ue,Le,Be,Ke,et,rt,ft,at,nt=K.length;for(pe=0;pe<nt;pe++){if(W=K[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(at=this.options.extensions.renderers[W.type].call({parser:this},W),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(W.type))){me+=at||"";continue}switch(W.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(W.tokens),W.depth,u(this.parseInline(W.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(W.text,W.lang,W.escaped);continue}case"table":{for(z="",j="",Re=W.header.length,Fe=0;Fe<Re;Fe++)j+=this.renderer.tablecell(this.parseInline(W.header[Fe].tokens),{header:!0,align:W.align[Fe]});for(z+=this.renderer.tablerow(j),q="",Re=W.rows.length,Fe=0;Fe<Re;Fe++){for(We=W.rows[Fe],j="",Pe=We.length,be=0;be<Pe;be++)j+=this.renderer.tablecell(this.parseInline(We[be].tokens),{header:!1,align:W.align[be]});q+=this.renderer.tablerow(j)}me+=this.renderer.table(z,q);continue}case"blockquote":{q=this.parse(W.tokens),me+=this.renderer.blockquote(q);continue}case"list":{for(ie=W.ordered,ue=W.start,Le=W.loose,Re=W.items.length,q="",Fe=0;Fe<Re;Fe++)Ke=W.items[Fe],et=Ke.checked,rt=Ke.task,Be="",Ke.task&&(ft=this.renderer.checkbox(et),Le?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=ft+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=ft+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:ft}):Be+=ft),Be+=this.parse(Ke.tokens,Le),q+=this.renderer.listitem(Be,rt,et);me+=this.renderer.list(q,ie,ue);continue}case"html":{me+=this.renderer.html(W.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(W.tokens));continue}case"text":{for(q=W.tokens?this.parseInline(W.tokens):W.text;pe+1<nt&&K[pe+1].type==="text";)W=K[++pe],q+=`
`+(W.tokens?this.parseInline(W.tokens):W.text);me+=Y?this.renderer.paragraph(q):q;continue}default:{var ct='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return me},we.parseInline=function(K,Y){Y=Y||this.renderer;var me="",pe,Fe,be,Re=K.length;for(pe=0;pe<Re;pe++){if(Fe=K[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(be=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){me+=be||"";continue}switch(Fe.type){case"escape":{me+=Y.text(Fe.text);break}case"html":{me+=Y.html(Fe.text);break}case"link":{me+=Y.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,Y));break}case"image":{me+=Y.image(Fe.href,Fe.title,Fe.text);break}case"strong":{me+=Y.strong(this.parseInline(Fe.tokens,Y));break}case"em":{me+=Y.em(this.parseInline(Fe.tokens,Y));break}case"codespan":{me+=Y.codespan(Fe.text);break}case"br":{me+=Y.br();break}case"del":{me+=Y.del(this.parseInline(Fe.tokens,Y));break}case"text":{me+=Y.text(Fe.text);break}default:{var Pe='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return me},ye}();function $e(ye,we,he){if(typeof ye>"u"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof we=="function"&&(he=we,we=null),we=d({},$e.defaults,we||{}),E(we),he){var K=we.highlight,Y;try{Y=te.lex(ye,we)}catch(Re){return he(Re)}var me=function(Pe){var We;if(!Pe)try{we.walkTokens&&$e.walkTokens(Y,we.walkTokens),We=se.parse(Y,we)}catch(j){Pe=j}return we.highlight=K,Pe?he(Pe):he(null,We)};if(!K||K.length<3||(delete we.highlight,!Y.length))return me();var pe=0;$e.walkTokens(Y,function(Re){Re.type==="code"&&(pe++,setTimeout(function(){K(Re.text,Re.lang,function(Pe,We){if(Pe)return me(Pe);We!=null&&We!==Re.text&&(Re.text=We,Re.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Fe(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+m(Re.message+"",!0)+"</pre>";throw Re}try{var be=te.lex(ye,we);if(we.walkTokens){if(we.async)return Promise.all($e.walkTokens(be,we.walkTokens)).then(function(){return se.parse(be,we)}).catch(Fe);$e.walkTokens(be,we.walkTokens)}return se.parse(be,we)}catch(Re){Fe(Re)}}$e.options=$e.setOptions=function(ye){return d($e.defaults,ye),g($e.defaults),$e},$e.getDefaults=M,$e.defaults=x.defaults,$e.use=function(){for(var ye=arguments.length,we=new Array(ye),he=0;he<ye;he++)we[he]=arguments[he];var K=d.apply(void 0,[{}].concat(we)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},me;we.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var Re=Y.renderers?Y.renderers[be.name]:null;Re?Y.renderers[be.name]=function(){for(var Pe=arguments.length,We=new Array(Pe),j=0;j<Pe;j++)We[j]=arguments[j];var z=be.renderer.apply(this,We);return z===!1&&(z=Re.apply(this,We)),z}:Y.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[be.level]?Y[be.level].unshift(be.tokenizer):Y[be.level]=[be.tokenizer],be.start&&(be.level==="block"?Y.startBlock?Y.startBlock.push(be.start):Y.startBlock=[be.start]:be.level==="inline"&&(Y.startInline?Y.startInline.push(be.start):Y.startInline=[be.start]))}be.childTokens&&(Y.childTokens[be.name]=be.childTokens)})),pe.renderer&&function(){var be=$e.defaults.renderer||new Q,Re=function(j){var z=be[j];be[j]=function(){for(var q=arguments.length,W=new Array(q),ie=0;ie<q;ie++)W[ie]=arguments[ie];var ue=pe.renderer[j].apply(be,W);return ue===!1&&(ue=z.apply(be,W)),ue}};for(var Pe in pe.renderer)Re(Pe);K.renderer=be}(),pe.tokenizer&&function(){var be=$e.defaults.tokenizer||new H,Re=function(j){var z=be[j];be[j]=function(){for(var q=arguments.length,W=new Array(q),ie=0;ie<q;ie++)W[ie]=arguments[ie];var ue=pe.tokenizer[j].apply(be,W);return ue===!1&&(ue=z.apply(be,W)),ue}};for(var Pe in pe.tokenizer)Re(Pe);K.tokenizer=be}(),pe.walkTokens){var Fe=$e.defaults.walkTokens;K.walkTokens=function(be){var Re=[];return Re.push(pe.walkTokens.call(this,be)),Fe&&(Re=Re.concat(Fe.call(this,be))),Re}}me&&(K.extensions=Y),$e.setOptions(K)})},$e.walkTokens=function(ye,we){for(var he=[],K=function(){var Fe=me.value;switch(he=he.concat(we.call($e,Fe)),Fe.type){case"table":{for(var be=L(Fe.header),Re;!(Re=be()).done;){var Pe=Re.value;he=he.concat($e.walkTokens(Pe.tokens,we))}for(var We=L(Fe.rows),j;!(j=We()).done;)for(var z=j.value,q=L(z),W;!(W=q()).done;){var ie=W.value;he=he.concat($e.walkTokens(ie.tokens,we))}break}case"list":{he=he.concat($e.walkTokens(Fe.items,we));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Fe.type]?$e.defaults.extensions.childTokens[Fe.type].forEach(function(ue){he=he.concat($e.walkTokens(Fe[ue],we))}):Fe.tokens&&(he=he.concat($e.walkTokens(Fe.tokens,we)))}},Y=L(ye),me;!(me=Y()).done;)K();return he},$e.parseInline=function(ye,we){if(typeof ye>"u"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");we=d({},$e.defaults,we||{}),E(we);try{var he=te.lexInline(ye,we);return we.walkTokens&&$e.walkTokens(he,we.walkTokens),se.parseInline(he,we)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+m(K.message+"",!0)+"</pre>";throw K}},$e.Parser=se,$e.parser=se.parse,$e.Renderer=Q,$e.TextRenderer=ce,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=H,$e.Slugger=le,$e.parse=$e;var ne=$e.options,ke=$e.setOptions,oe=$e.use,ve=$e.walkTokens,G=$e.parseInline,ge=$e,ae=se.parse,De=te.lex;x.Lexer=te,x.Parser=se,x.Renderer=Q,x.Slugger=le,x.TextRenderer=ce,x.Tokenizer=H,x.getDefaults=M,x.lexer=De,x.marked=$e,x.options=ne,x.parse=ge,x.parseInline=G,x.parser=ae,x.setOptions=ke,x.use=oe,x.walkTokens=ve,Object.defineProperty(x,"__esModule",{value:!0})}),define(Me[122],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0;function D(s){const u=L(s);if(u&&u.length>0)return new Uint32Array(u)}e.$3j=D;let P=0;const C=new Uint32Array(10);function L(s){if(P=0,M(s,S,4352),P>0||(M(s,l,4449),P>0)||(M(s,w,4520),P>0)||(M(s,m,12593),P))return C.subarray(0,P);if(s>=44032&&s<=55203){const u=s-44032,i=u%588,r=Math.floor(u/588),n=Math.floor(i/28),a=i%28-1;if(r<S.length?M(r,S,0):4352+r-12593<m.length&&M(4352+r,m,12593),n<l.length?M(n,l,0):4449+n-12593<m.length&&M(4449+n-12593,m,12593),a>=0&&(a<w.length?M(a,w,0):4520+a-12593<m.length&&M(4520+a-12593,m,12593)),P>0)return C.subarray(0,P)}}function M(s,u,i){s>=i&&s<i+u.length&&g(u[s-i])}function g(s){s!==0&&(C[P++]=s&255,s>>8&&(C[P++]=s>>8&255),s>>16&&(C[P++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var F;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(F||(F={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Me[123],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.rot=e.$gm=void 0;function D(g,f,k){return Math.min(Math.max(g,f),k)}e.$gm=D;function P(g,f){return(f+g%f)%f}e.rot=P;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$im=C;class L{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$jm=L;class M{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const k=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$km=M}),function(){function x(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function M(f){L.push(f,Date.now())}function g(){const f=[];for(let k=0;k<L.length;k+=2)f.push({name:L[k],startTime:L[k+1]});return f}return{mark:M,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const M of performance.getEntriesByType("mark"))L.push({name:M.name,startTime:Math.round(C+M.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function D(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=D(P))}(),define(Me[124],Ae([1,0,40,19]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=void 0;const C=new D.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),L=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(I,v,y=!1){const E=I||"",A=v||"",V=C.value.collator.compare(E,A);return C.value.collatorIsNumeric&&V===0&&E!==A?E<A?-1:1:V}e.$Uq=g;function f(I,v){const y=L.value.collator;return I=I||"",v=v||"",a(y,I,v)}e.$Vq=f;function k(I,v){const y=L.value.collator;return I=I||"",v=v||"",c(I,v)||a(y,I,v)}e.$Wq=k;function F(I,v){const y=L.value.collator;return I=I||"",v=v||"",$(I,v)||a(y,I,v)}e.$Xq=F;function S(I,v){return I=I||"",v=v||"",I===v?0:I<v?-1:1}e.$Yq=S;function l(I,v){const[y,E]=r(I),[A,V]=r(v);let X=C.value.collator.compare(E,V);if(X===0){if(C.value.collatorIsNumeric&&E!==V)return E<V?-1:1;if(X=C.value.collator.compare(y,A),C.value.collatorIsNumeric&&X===0&&y!==A)return y<A?-1:1}return X}e.$Zq=l;function w(I,v){I=I||"",v=v||"";const y=n(I),E=n(v),A=L.value.collator,V=M.value.collator;return a(V,y,E)||a(A,I,v)}e.$1q=w;function m(I,v){I=I||"",v=v||"";const y=n(I),E=n(v),A=L.value.collator,V=M.value.collator;return a(V,y,E)||c(I,v)||a(A,I,v)}e.$2q=m;function s(I,v){I=I||"",v=v||"";const y=n(I),E=n(v),A=L.value.collator,V=M.value.collator;return a(V,y,E)||$(I,v)||a(A,I,v)}e.$3q=s;function u(I,v){I=I||"",v=v||"";const y=n(I).toLowerCase(),E=n(v).toLowerCase();return y!==E?y<E?-1:1:I!==v?I<v?-1:1:0}e.$4q=u;const i=/^(.*?)(\.([^.]*))?$/;function r(I,v=!1){const y=I?i.exec(I):[];let E=[y&&y[1]||"",y&&y[3]||""];return v&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function n(I){const v=I?i.exec(I):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function a(I,v,y){const E=I.compare(v,y);return E!==0?E:v.length!==y.length?v.length<y.length?-1:1:0}function h(I){const v=I.charAt(0);return v.toLocaleUpperCase()!==v}function t(I){const v=I.charAt(0);return v.toLocaleLowerCase()!==v}function $(I,v){return h(I)&&t(v)?-1:t(I)&&h(v)?1:0}function c(I,v){return t(I)&&h(v)?-1:h(I)&&t(v)?1:0}function o(I,v,y=!1){return y||(I=I&&I.toLowerCase(),v=v&&v.toLowerCase()),I===v?0:I<v?-1:1}function b(I,v,y=!1){const E=I.split(P.sep),A=v.split(P.sep),V=E.length-1,X=A.length-1;let H,O;for(let R=0;;R++){if(H=V===R,O=X===R,H&&O)return g(E[R],A[R],y);if(H)return-1;if(O)return 1;const B=o(E[R],A[R],y);if(B!==0)return B}}e.$5q=b;function p(I,v,y){const E=I.toLowerCase(),A=v.toLowerCase(),V=d(I,v,y);if(V)return V;const X=E.endsWith(y),H=A.endsWith(y);if(X!==H)return X?-1:1;const O=g(E,A);return O!==0?O:E.localeCompare(A)}e.$6q=p;function d(I,v,y){const E=I.toLowerCase(),A=v.toLowerCase(),V=E.startsWith(y),X=A.startsWith(y);if(V!==X)return V?-1:1;if(V&&X){if(E.length<A.length)return-1;if(E.length>A.length)return 1}return 0}e.$7q=d}),define(Me[69],Ae([1,0,19]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=e.$ss=e.$rs=void 0,e.$rs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(F){const S=(0,D.$oc)(F),l=P[S.toLowerCase()];return l!==void 0?l:M(F)}e.$ss=L;function M(F){const S=(0,D.$oc)(F);return C[S.toLowerCase()]}e.$ts=M;function g(F){for(const S in C)if(C[S]===F)return S}e.$us=g;const f=/^(.+)\/(.+?)(;.+)?$/;function k(F,S){const l=f.exec(F);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:F}e.$vs=k}),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var P in D)(typeof exports=="object"?exports:x)[P]=D[P]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function D(P){if(e[P])return e[P].exports;var C=e[P]={i:P,l:!1,exports:{}};return x[P].call(C.exports,C,C.exports,D),C.l=!0,C.exports}return D.m=x,D.c=e,D.d=function(P,C,L){D.o(P,C)||Object.defineProperty(P,C,{enumerable:!0,get:L})},D.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},D.t=function(P,C){if(1&C&&(P=D(P)),8&C||4&C&&typeof P=="object"&&P&&P.__esModule)return P;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:P}),2&C&&typeof P!="string")for(var M in P)D.d(L,M,function(g){return P[g]}.bind(null,M));return L},D.n=function(P){var C=P&&P.__esModule?function(){return P.default}:function(){return P};return D.d(C,"a",C),C},D.o=function(P,C){return Object.prototype.hasOwnProperty.call(P,C)},D.p="",D(D.s=0)}([function(x,e,D){(function(P){var C;e=x.exports=oe,C=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],f=e.src=[],k=0,F=k++;f[F]="0|[1-9]\\d*";var S=k++;f[S]="[0-9]+";var l=k++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=k++;f[w]="("+f[F]+")\\.("+f[F]+")\\.("+f[F]+")";var m=k++;f[m]="("+f[S]+")\\.("+f[S]+")\\.("+f[S]+")";var s=k++;f[s]="(?:"+f[F]+"|"+f[l]+")";var u=k++;f[u]="(?:"+f[S]+"|"+f[l]+")";var i=k++;f[i]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var r=k++;f[r]="(?:-?("+f[u]+"(?:\\."+f[u]+")*))";var n=k++;f[n]="[0-9A-Za-z-]+";var a=k++;f[a]="(?:\\+("+f[n]+"(?:\\."+f[n]+")*))";var h=k++,t="v?"+f[w]+f[i]+"?"+f[a]+"?";f[h]="^"+t+"$";var $="[v=\\s]*"+f[m]+f[r]+"?"+f[a]+"?",c=k++;f[c]="^"+$+"$";var o=k++;f[o]="((?:<|>)?=?)";var b=k++;f[b]=f[S]+"|x|X|\\*";var p=k++;f[p]=f[F]+"|x|X|\\*";var d=k++;f[d]="[v=\\s]*("+f[p]+")(?:\\.("+f[p]+")(?:\\.("+f[p]+")(?:"+f[i]+")?"+f[a]+"?)?)?";var I=k++;f[I]="[v=\\s]*("+f[b]+")(?:\\.("+f[b]+")(?:\\.("+f[b]+")(?:"+f[r]+")?"+f[a]+"?)?)?";var v=k++;f[v]="^"+f[o]+"\\s*"+f[d]+"$";var y=k++;f[y]="^"+f[o]+"\\s*"+f[I]+"$";var E=k++;f[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=k++;f[A]="(?:~>?)";var V=k++;f[V]="(\\s*)"+f[A]+"\\s+",g[V]=new RegExp(f[V],"g");var X=k++;f[X]="^"+f[A]+f[d]+"$";var H=k++;f[H]="^"+f[A]+f[I]+"$";var O=k++;f[O]="(?:\\^)";var R=k++;f[R]="(\\s*)"+f[O]+"\\s+",g[R]=new RegExp(f[R],"g");var B=k++;f[B]="^"+f[O]+f[d]+"$";var T=k++;f[T]="^"+f[O]+f[I]+"$";var te=k++;f[te]="^"+f[o]+"\\s*("+$+")$|^$";var Q=k++;f[Q]="^"+f[o]+"\\s*("+t+")$|^$";var ce=k++;f[ce]="(\\s*)"+f[o]+"\\s*("+$+"|"+f[d]+")",g[ce]=new RegExp(f[ce],"g");var le=k++;f[le]="^\\s*("+f[d]+")\\s+-\\s+("+f[d]+")\\s*$";var se=k++;f[se]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var $e=k++;f[$e]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)C(ne,f[ne]),g[ne]||(g[ne]=new RegExp(f[ne]));function ke(z,q){if(z instanceof oe)return z;if(typeof z!="string"||z.length>L||!(q?g[c]:g[h]).test(z))return null;try{return new oe(z,q)}catch{return null}}function oe(z,q){if(z instanceof oe){if(z.loose===q)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(z,q);C("SemVer",z,q),this.loose=q;var W=z.trim().match(q?g[c]:g[h]);if(!W)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+W[1],this.minor=+W[2],this.patch=+W[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");W[4]?this.prerelease=W[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var ue=+ie;if(ue>=0&&ue<M)return ue}return ie}):this.prerelease=[],this.build=W[5]?W[5].split("."):[],this.format()}e.parse=ke,e.valid=function(z,q){var W=ke(z,q);return W?W.version:null},e.clean=function(z,q){var W=ke(z.trim().replace(/^[=v]+/,""),q);return W?W.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(z){return C("SemVer.compare",this.version,this.loose,z),z instanceof oe||(z=new oe(z,this.loose)),this.compareMain(z)||this.comparePre(z)},oe.prototype.compareMain=function(z){return z instanceof oe||(z=new oe(z,this.loose)),G(this.major,z.major)||G(this.minor,z.minor)||G(this.patch,z.patch)},oe.prototype.comparePre=function(z){if(z instanceof oe||(z=new oe(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var q=0;do{var W=this.prerelease[q],ie=z.prerelease[q];if(C("prerelease compare",q,W,ie),W===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(W===void 0)return-1;if(W!==ie)return G(W,ie)}while(++q)},oe.prototype.inc=function(z,q){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var W=this.prerelease.length;--W>=0;)typeof this.prerelease[W]=="number"&&(this.prerelease[W]++,W=-2);W===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,q,W,ie){typeof W=="string"&&(ie=W,W=void 0);try{return new oe(z,W).inc(q,ie).version}catch{return null}},e.diff=function(z,q){if(ye(z,q))return null;var W=ke(z),ie=ke(q);if(W.prerelease.length||ie.prerelease.length){for(var ue in W)if((ue==="major"||ue==="minor"||ue==="patch")&&W[ue]!==ie[ue])return"pre"+ue;return"prerelease"}for(var ue in W)if((ue==="major"||ue==="minor"||ue==="patch")&&W[ue]!==ie[ue])return ue},e.compareIdentifiers=G;var ve=/^[0-9]+$/;function G(z,q){var W=ve.test(z),ie=ve.test(q);return W&&ie&&(z=+z,q=+q),W&&!ie?-1:ie&&!W?1:z<q?-1:z>q?1:0}function ge(z,q,W){return new oe(z,W).compare(new oe(q,W))}function ae(z,q,W){return ge(z,q,W)>0}function De(z,q,W){return ge(z,q,W)<0}function ye(z,q,W){return ge(z,q,W)===0}function we(z,q,W){return ge(z,q,W)!==0}function he(z,q,W){return ge(z,q,W)>=0}function K(z,q,W){return ge(z,q,W)<=0}function Y(z,q,W,ie){var ue;switch(q){case"===":typeof z=="object"&&(z=z.version),typeof W=="object"&&(W=W.version),ue=z===W;break;case"!==":typeof z=="object"&&(z=z.version),typeof W=="object"&&(W=W.version),ue=z!==W;break;case"":case"=":case"==":ue=ye(z,W,ie);break;case"!=":ue=we(z,W,ie);break;case">":ue=ae(z,W,ie);break;case">=":ue=he(z,W,ie);break;case"<":ue=De(z,W,ie);break;case"<=":ue=K(z,W,ie);break;default:throw new TypeError("Invalid operator: "+q)}return ue}function me(z,q){if(z instanceof me){if(z.loose===q)return z;z=z.value}if(!(this instanceof me))return new me(z,q);C("comparator",z,q),this.loose=q,this.parse(z),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(z,q){return G(q,z)},e.major=function(z,q){return new oe(z,q).major},e.minor=function(z,q){return new oe(z,q).minor},e.patch=function(z,q){return new oe(z,q).patch},e.compare=ge,e.compareLoose=function(z,q){return ge(z,q,!0)},e.rcompare=function(z,q,W){return ge(q,z,W)},e.sort=function(z,q){return z.sort(function(W,ie){return e.compare(W,ie,q)})},e.rsort=function(z,q){return z.sort(function(W,ie){return e.rcompare(W,ie,q)})},e.gt=ae,e.lt=De,e.eq=ye,e.neq=we,e.gte=he,e.lte=K,e.cmp=Y,e.Comparator=me;var pe={};function Fe(z,q){if(z instanceof Fe)return z.loose===q?z:new Fe(z.raw,q);if(z instanceof me)return new Fe(z.value,q);if(!(this instanceof Fe))return new Fe(z,q);if(this.loose=q,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(W){return this.parseRange(W.trim())},this).filter(function(W){return W.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function be(z){return!z||z.toLowerCase()==="x"||z==="*"}function Re(z,q,W,ie,ue,Le,Be,Ke,et,rt,ft,at,nt){return((q=be(W)?"":be(ie)?">="+W+".0.0":be(ue)?">="+W+"."+ie+".0":">="+q)+" "+(Ke=be(et)?"":be(rt)?"<"+(+et+1)+".0.0":be(ft)?"<"+et+"."+(+rt+1)+".0":at?"<="+et+"."+rt+"."+ft+"-"+at:"<="+Ke)).trim()}function Pe(z,q){for(var W=0;W<z.length;W++)if(!z[W].test(q))return!1;if(q.prerelease.length){for(W=0;W<z.length;W++)if(C(z[W].semver),z[W].semver!==pe&&z[W].semver.prerelease.length>0){var ie=z[W].semver;if(ie.major===q.major&&ie.minor===q.minor&&ie.patch===q.patch)return!0}return!1}return!0}function We(z,q,W){try{q=new Fe(q,W)}catch{return!1}return q.test(z)}function j(z,q,W,ie){var ue,Le,Be,Ke,et;switch(z=new oe(z,ie),q=new Fe(q,ie),W){case">":ue=ae,Le=K,Be=De,Ke=">",et=">=";break;case"<":ue=De,Le=he,Be=ae,Ke="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(z,q,ie))return!1;for(var rt=0;rt<q.set.length;++rt){var ft=q.set[rt],at=null,nt=null;if(ft.forEach(function(ct){ct.semver===pe&&(ct=new me(">=0.0.0")),at=at||ct,nt=nt||ct,ue(ct.semver,at.semver,ie)?at=ct:Be(ct.semver,nt.semver,ie)&&(nt=ct)}),at.operator===Ke||at.operator===et||(!nt.operator||nt.operator===Ke)&&Le(z,nt.semver)||nt.operator===et&&Be(z,nt.semver))return!1}return!0}me.prototype.parse=function(z){var q=this.loose?g[te]:g[Q],W=z.match(q);if(!W)throw new TypeError("Invalid comparator: "+z);this.operator=W[1],this.operator==="="&&(this.operator=""),W[2]?this.semver=new oe(W[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(z){return C("Comparator.test",z,this.loose),this.semver===pe||(typeof z=="string"&&(z=new oe(z,this.loose)),Y(z,this.operator,this.semver,this.loose))},me.prototype.intersects=function(z,q){if(!(z instanceof me))throw new TypeError("a Comparator is required");var W;if(this.operator==="")return W=new Fe(z.value,q),We(this.value,W,q);if(z.operator==="")return W=new Fe(this.value,q),We(z.semver,W,q);var ie=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Le=this.semver.version===z.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ke=Y(this.semver,"<",z.semver,q)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),et=Y(this.semver,">",z.semver,q)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ie||ue||Le&&Be||Ke||et},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(z){var q=this.loose;z=z.trim(),C("range",z,q);var W=q?g[se]:g[le];z=z.replace(W,Re),C("hyphen replace",z),z=z.replace(g[ce],"$1$2$3"),C("comparator trim",z,g[ce]),z=(z=(z=z.replace(g[V],"$1~")).replace(g[R],"$1^")).split(/\s+/).join(" ");var ie=q?g[te]:g[Q],ue=z.split(" ").map(function(Le){return function(Be,Ke){return C("comp",Be),Be=function(et,rt){return et.trim().split(/\s+/).map(function(ft){return function(at,nt){C("caret",at,nt);var ct=nt?g[T]:g[B];return at.replace(ct,function(Ve,it,_,Z,Ee){var qe;return C("caret",at,Ve,it,_,Z,Ee),be(it)?qe="":be(_)?qe=">="+it+".0.0 <"+(+it+1)+".0.0":be(Z)?qe=it==="0"?">="+it+"."+_+".0 <"+it+"."+(+_+1)+".0":">="+it+"."+_+".0 <"+(+it+1)+".0.0":Ee?(C("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),qe=it==="0"?_==="0"?">="+it+"."+_+"."+Z+Ee+" <"+it+"."+_+"."+(+Z+1):">="+it+"."+_+"."+Z+Ee+" <"+it+"."+(+_+1)+".0":">="+it+"."+_+"."+Z+Ee+" <"+(+it+1)+".0.0"):(C("no pr"),qe=it==="0"?_==="0"?">="+it+"."+_+"."+Z+" <"+it+"."+_+"."+(+Z+1):">="+it+"."+_+"."+Z+" <"+it+"."+(+_+1)+".0":">="+it+"."+_+"."+Z+" <"+(+it+1)+".0.0"),C("caret return",qe),qe})}(ft,rt)}).join(" ")}(Be,Ke),C("caret",Be),Be=function(et,rt){return et.trim().split(/\s+/).map(function(ft){return function(at,nt){var ct=nt?g[H]:g[X];return at.replace(ct,function(Ve,it,_,Z,Ee){var qe;return C("tilde",at,Ve,it,_,Z,Ee),be(it)?qe="":be(_)?qe=">="+it+".0.0 <"+(+it+1)+".0.0":be(Z)?qe=">="+it+"."+_+".0 <"+it+"."+(+_+1)+".0":Ee?(C("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),qe=">="+it+"."+_+"."+Z+Ee+" <"+it+"."+(+_+1)+".0"):qe=">="+it+"."+_+"."+Z+" <"+it+"."+(+_+1)+".0",C("tilde return",qe),qe})}(ft,rt)}).join(" ")}(Be,Ke),C("tildes",Be),Be=function(et,rt){return C("replaceXRanges",et,rt),et.split(/\s+/).map(function(ft){return function(at,nt){at=at.trim();var ct=nt?g[y]:g[v];return at.replace(ct,function(Ve,it,_,Z,Ee,qe){C("xRange",at,Ve,it,_,Z,Ee,qe);var Ye=be(_),ut=Ye||be(Z),Oe=ut||be(Ee);return it==="="&&Oe&&(it=""),Ye?Ve=it===">"||it==="<"?"<0.0.0":"*":it&&Oe?(ut&&(Z=0),Oe&&(Ee=0),it===">"?(it=">=",ut?(_=+_+1,Z=0,Ee=0):Oe&&(Z=+Z+1,Ee=0)):it==="<="&&(it="<",ut?_=+_+1:Z=+Z+1),Ve=it+_+"."+Z+"."+Ee):ut?Ve=">="+_+".0.0 <"+(+_+1)+".0.0":Oe&&(Ve=">="+_+"."+Z+".0 <"+_+"."+(+Z+1)+".0"),C("xRange return",Ve),Ve})}(ft,rt)}).join(" ")}(Be,Ke),C("xrange",Be),Be=function(et,rt){return C("replaceStars",et,rt),et.trim().replace(g[$e],"")}(Be,Ke),C("stars",Be),Be}(Le,q)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(Le){return!!Le.match(ie)})),ue=ue.map(function(Le){return new me(Le,q)})},Fe.prototype.intersects=function(z,q){if(!(z instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(W){return W.every(function(ie){return z.set.some(function(ue){return ue.every(function(Le){return ie.intersects(Le,q)})})})})},e.toComparators=function(z,q){return new Fe(z,q).set.map(function(W){return W.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new oe(z,this.loose));for(var q=0;q<this.set.length;q++)if(Pe(this.set[q],z))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(z,q,W){var ie=null,ue=null;try{var Le=new Fe(q,W)}catch{return null}return z.forEach(function(Be){Le.test(Be)&&(ie&&ue.compare(Be)!==-1||(ue=new oe(ie=Be,W)))}),ie},e.minSatisfying=function(z,q,W){var ie=null,ue=null;try{var Le=new Fe(q,W)}catch{return null}return z.forEach(function(Be){Le.test(Be)&&(ie&&ue.compare(Be)!==1||(ue=new oe(ie=Be,W)))}),ie},e.validRange=function(z,q){try{return new Fe(z,q).range||"*"}catch{return null}},e.ltr=function(z,q,W){return j(z,q,"<",W)},e.gtr=function(z,q,W){return j(z,q,">",W)},e.outside=j,e.prerelease=function(z,q){var W=ke(z,q);return W&&W.prerelease.length?W.prerelease:null},e.intersects=function(z,q,W){return z=new Fe(z,W),q=new Fe(q,W),z.intersects(q)},e.coerce=function(z){if(z instanceof oe)return z;if(typeof z!="string")return null;var q=z.match(g[E]);return q==null?null:ke((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,D(1))},function(x,e){var D,P,C=x.exports={};function L(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function g(u){if(D===setTimeout)return setTimeout(u,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(u,0);try{return D(u,0)}catch{try{return D.call(null,u,0)}catch{return D.call(this,u,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{P=typeof clearTimeout=="function"?clearTimeout:M}catch{P=M}})();var f,k=[],F=!1,S=-1;function l(){F&&f&&(F=!1,f.length?k=f.concat(k):S=-1,k.length&&w())}function w(){if(!F){var u=g(l);F=!0;for(var i=k.length;i;){for(f=k,k=[];++S<i;)f&&f[S].run();S=-1,i=k.length}f=null,F=!1,function(r){if(P===clearTimeout)return clearTimeout(r);if((P===M||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(r);try{P(r)}catch{try{return P.call(null,r)}catch{return P.call(this,r)}}}(u)}}function m(u,i){this.fun=u,this.array=i}function s(){}C.nextTick=function(u){var i=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)i[r-1]=arguments[r];k.push(new m(u,i)),k.length!==1||F||g(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=s,C.addListener=s,C.once=s,C.off=s,C.removeListener=s,C.removeAllListeners=s,C.emit=s,C.prependListener=s,C.prependOnceListener=s,C.listeners=function(u){return[]},C.binding=function(u){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(u){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Me[125],Ae([1,0,15,6]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function C(a){const h=a;return h?typeof h.read=="function":!1}e.$de=C;function L(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$ee=L;function M(a){const h=a;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$fe=M;function g(a,h){return new f(a,h)}e.$ge=g;class f{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,D.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let $;switch(h){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const c=$.indexOf(t);c>=0&&$.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach($=>$())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(a,h){const t=[];let $;for(;($=a.read())!==null;)t.push($);return h(t)}e.$he=k;function F(a,h,t){const $=[];let c;for(;(c=a.read())!==null&&$.length<t;)$.push(c);return c===null&&$.length>0?h($):{read:()=>{if($.length>0)return $.shift();if(typeof c<"u"){const o=c;return c=void 0,o}return a.read()}}}e.$ie=F;function S(a,h){return new Promise((t,$)=>{const c=[];l(a,{onData:o=>{h&&c.push(o)},onError:o=>{h?$(o):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}e.$je=S;function l(a,h,t){a.on("error",$=>{t?.isCancellationRequested||h.onError($)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",$=>{t?.isCancellationRequested||h.onData($)})}e.$ke=l;function w(a,h){return new Promise((t,$)=>{const c=new P.$Sc,o=[],b=I=>{if(o.push(I),o.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:o,ended:!1})},p=I=>(c.dispose(),$(I)),d=()=>(c.dispose(),t({stream:a,buffer:o,ended:!0}));c.add((0,P.$Rc)(()=>a.removeListener("error",p))),a.on("error",p),c.add((0,P.$Rc)(()=>a.removeListener("end",d))),a.on("end",d),c.add((0,P.$Rc)(()=>a.removeListener("data",b))),a.on("data",b)})}e.$le=w;function m(a,h){const t=g(h);return t.end(a),t}e.$me=m;function s(){const a=g(()=>{throw new Error("not supported")});return a.end(),a}e.$ne=s;function u(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}e.$oe=u;function i(a,h,t){const $=g(t);return l(a,{onData:c=>$.write(h.data(c)),onError:c=>$.error(h.error?h.error(c):c),onEnd:()=>$.end()}),$}e.$pe=i;function r(a,h,t){let $=!1;return{read:()=>{const c=h.read();return $?c:($=!0,c!==null?t([a,c]):a)}}}e.$qe=r;function n(a,h,t){let $=!1;const c=g(t);return l(h,{onData:o=>$?c.write(o):($=!0,c.write(t([a,o]))),onError:o=>c.error(o),onEnd:()=>{$||($=!0,c.write(a)),c.end()}}),c}e.$re=n}),define(Me[24],Ae([1,0,40,125]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const C=typeof Buffer<"u",L=new D.$V(()=>new Uint8Array(256));let M,g;class f{static alloc(E){return C?new f(Buffer.allocUnsafe(E)):new f(new Uint8Array(E))}static wrap(E){return C&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new f(E)}static fromString(E,A){return!(A?.dontUseNodeBuffer||!1)&&C?new f(Buffer.from(E)):(M||(M=new TextEncoder),new f(M.encode(E)))}static fromByteArray(E){const A=f.alloc(E.length);for(let V=0,X=E.length;V<X;V++)A.buffer[V]=E[V];return A}static concat(E,A){if(typeof A>"u"){A=0;for(let H=0,O=E.length;H<O;H++)A+=E[H].byteLength}const V=f.alloc(A);let X=0;for(let H=0,O=E.length;H<O;H++){const R=E[H];V.set(R,X),X+=R.byteLength}return V}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=f.alloc(this.byteLength);return E.set(this),E}toString(){return C?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(E,A){return new f(this.buffer.subarray(E,A))}set(E,A){if(E instanceof f)this.buffer.set(E.buffer,A);else if(E instanceof Uint8Array)this.buffer.set(E,A);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),A);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return l(this.buffer,E)}writeUInt32BE(E,A){w(this.buffer,E,A)}readUInt32LE(E){return m(this.buffer,E)}writeUInt32LE(E,A){s(this.buffer,E,A)}readUInt8(E){return u(this.buffer,E)}writeUInt8(E,A){i(this.buffer,E,A)}indexOf(E,A=0){return k(this.buffer,E instanceof f?E.buffer:E,A)}}e.$se=f;function k(y,E,A=0){const V=E.byteLength,X=y.byteLength;if(V===0)return 0;if(V===1)return y.indexOf(E[0]);if(V>X-A)return-1;const H=L.value;H.fill(E.length);for(let T=0;T<E.length;T++)H[E[T]]=E.length-T-1;let O=A+E.length-1,R=O,B=-1;for(;O<X;)if(y[O]===E[R]){if(R===0){B=O;break}O--,R--}else O+=Math.max(E.length-R,H[y[O]]),R=E.length-1;return B}e.$te=k;function F(y,E){return y[E+0]<<0>>>0|y[E+1]<<8>>>0}e.$ue=F;function S(y,E,A){y[A+0]=E&255,E=E>>>8,y[A+1]=E&255}e.$ve=S;function l(y,E){return y[E]*2**24+y[E+1]*2**16+y[E+2]*2**8+y[E+3]}e.$we=l;function w(y,E,A){y[A+3]=E,E=E>>>8,y[A+2]=E,E=E>>>8,y[A+1]=E,E=E>>>8,y[A]=E}e.$xe=w;function m(y,E){return y[E+0]<<0>>>0|y[E+1]<<8>>>0|y[E+2]<<16>>>0|y[E+3]<<24>>>0}e.$ye=m;function s(y,E,A){y[A+0]=E&255,E=E>>>8,y[A+1]=E&255,E=E>>>8,y[A+2]=E&255,E=E>>>8,y[A+3]=E&255}e.$ze=s;function u(y,E){return y[E]}e.$Ae=u;function i(y,E,A){y[A]=E}e.$Be=i;function r(y){return P.$he(y,E=>f.concat(E))}e.$Ce=r;function n(y){return P.$oe(y)}e.$De=n;function a(y){return P.$je(y,E=>f.concat(E))}e.$Ee=a;async function h(y){return y.ended?f.concat(y.buffer):f.concat([...y.buffer,await a(y.stream)])}e.$Fe=h;function t(y){return P.$me(y,E=>f.concat(E))}e.$Ge=t;function $(y){return P.$pe(y,{data:E=>typeof E=="string"?f.fromString(E):f.wrap(E)},E=>f.concat(E))}e.$He=$;function c(y){return P.$ge(E=>f.concat(E),y)}e.$Ie=c;function o(y,E){return P.$qe(y,E,A=>f.concat(A))}e.$Je=o;function b(y,E){return P.$re(y,E,A=>f.concat(A))}e.$Ke=b;function p(y){let E=0,A=0,V=0;const X=new Uint8Array(Math.floor(y.length/4*3)),H=R=>{switch(A){case 3:X[V++]=E|R,A=0;break;case 2:X[V++]=E|R>>>2,E=R<<6,A=3;break;case 1:X[V++]=E|R>>>4,E=R<<4,A=2;break;default:E=R<<2,A=1}};for(let R=0;R<y.length;R++){const B=y.charCodeAt(R);if(B>=65&&B<=90)H(B-65);else if(B>=97&&B<=122)H(B-97+26);else if(B>=48&&B<=57)H(B-48+52);else if(B===43||B===45)H(62);else if(B===47||B===95)H(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${y[R]}`)}}const O=V;for(;A>0;)H(0);return f.wrap(X).slice(0,O)}e.$Le=p;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:y},E=!0,A=!1){const V=A?I:d;let X="";const H=y.byteLength%3;let O=0;for(;O<y.byteLength-H;O+=3){const R=y[O+0],B=y[O+1],T=y[O+2];X+=V[R>>>2],X+=V[(R<<4|B>>>4)&63],X+=V[(B<<2|T>>>6)&63],X+=V[T&63]}if(H===1){const R=y[O+0];X+=V[R>>>2],X+=V[R<<4&63],E&&(X+="==")}else if(H===2){const R=y[O+0],B=y[O+1];X+=V[R>>>2],X+=V[(R<<4|B>>>4)&63],X+=V[B<<2&63],E&&(X+="=")}return X}e.$Me=v}),define(Me[126],Ae([1,0,28,122,13]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.FuzzyScore=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.or=void 0;function L(...be){return function(Re,Pe){for(let We=0,j=be.length;We<j;We++){const z=be[We](Re,Pe);if(z)return z}return null}}e.or=L,e.$5j=M.bind(void 0,!1),e.$6j=M.bind(void 0,!0);function M(be,Re,Pe){if(!Pe||Pe.length<Re.length)return null;let We;return be?We=C.$kf(Pe,Re):We=Pe.indexOf(Re)===0,We?Re.length>0?[{start:0,end:Re.length}]:[]:null}function g(be,Re){const Pe=Re.toLowerCase().indexOf(be.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+be.length}]}e.$7j=g;function f(be,Re){return k(be.toLowerCase(),Re.toLowerCase(),0,0)}e.$8j=f;function k(be,Re,Pe,We){if(Pe===be.length)return[];if(We===Re.length)return null;if(be[Pe]===Re[We]){let j=null;return(j=k(be,Re,Pe+1,We+1))?a({start:We,end:We+1},j):null}return k(be,Re,Pe,We+1)}function F(be){return 97<=be&&be<=122}function S(be){return 65<=be&&be<=90}e.$9j=S;function l(be){return 48<=be&&be<=57}function w(be){return be===32||be===9||be===10||be===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>m.add(be.charCodeAt(0)));function s(be){return w(be)||m.has(be)}function u(be,Re){return be===Re||s(be)&&s(Re)}const i=new Map;function r(be){if(i.has(be))return i.get(be);let Re;const Pe=(0,P.$3j)(be);return Pe&&(Re=Pe),i.set(be,Re),Re}function n(be){return F(be)||S(be)||l(be)}function a(be,Re){return Re.length===0?Re=[be]:be.end===Re[0].start?Re[0].start=be.start:Re.unshift(be),Re}function h(be,Re){for(let Pe=Re;Pe<be.length;Pe++){const We=be.charCodeAt(Pe);if(S(We)||l(We)||Pe>0&&!n(be.charCodeAt(Pe-1)))return Pe}return be.length}function t(be,Re,Pe,We){if(Pe===be.length)return[];if(We===Re.length)return null;if(be[Pe]!==Re[We].toLowerCase())return null;{let j=null,z=We+1;for(j=t(be,Re,Pe+1,We+1);!j&&(z=h(Re,z))<Re.length;)j=t(be,Re,Pe+1,z),z++;return j===null?null:a({start:We,end:We+1},j)}}function $(be){let Re=0,Pe=0,We=0,j=0,z=0;for(let Le=0;Le<be.length;Le++)z=be.charCodeAt(Le),S(z)&&Re++,F(z)&&Pe++,n(z)&&We++,l(z)&&j++;const q=Re/be.length,W=Pe/be.length,ie=We/be.length,ue=j/be.length;return{upperPercent:q,lowerPercent:W,alphaPercent:ie,numericPercent:ue}}function c(be){const{upperPercent:Re,lowerPercent:Pe}=be;return Pe===0&&Re>.6}function o(be){const{upperPercent:Re,lowerPercent:Pe,alphaPercent:We,numericPercent:j}=be;return Pe>.2&&Re<.8&&We>.6&&j<.2}function b(be){let Re=0,Pe=0,We=0,j=0;for(let z=0;z<be.length;z++)We=be.charCodeAt(z),S(We)&&Re++,F(We)&&Pe++,w(We)&&j++;return(Re===0||Pe===0)&&j===0?be.length<=30:Re<=5}function p(be,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!b(be))return null;Re.length>60&&(Re=Re.substring(0,60));const Pe=$(Re);if(!o(Pe)){if(!c(Pe))return null;Re=Re.toLowerCase()}let We=null,j=0;for(be=be.toLowerCase();j<Re.length&&(We=t(be,Re,0,j))===null;)j=h(Re,j+1);return We}e.$0j=p;function d(be,Re,Pe=!1){if(!Re||Re.length===0)return null;let We=null,j=0;for(be=be.toLowerCase(),Re=Re.toLowerCase();j<Re.length&&(We=I(be,Re,0,j,Pe),We===null);)j=v(Re,j+1);return We}e.$$j=d;function I(be,Re,Pe,We,j){let z=0;if(Pe===be.length)return[];if(We===Re.length)return null;if(!u(be.charCodeAt(Pe),Re.charCodeAt(We))){const ie=r(be.charCodeAt(Pe));if(!ie)return null;for(let ue=0;ue<ie.length;ue++)if(!u(ie[ue],Re.charCodeAt(We+ue)))return null;z+=ie.length-1}let q=null,W=We+z+1;if(q=I(be,Re,Pe+1,W,j),!j)for(;!q&&(W=v(Re,W))<Re.length;)q=I(be,Re,Pe+1,W,j),W++;if(!q)return null;if(be.charCodeAt(Pe)!==Re.charCodeAt(We)){const ie=r(be.charCodeAt(Pe));if(!ie)return q;for(let ue=0;ue<ie.length;ue++)if(ie[ue]!==Re.charCodeAt(We+ue))return q}return a({start:We,end:We+z+1},q)}function v(be,Re){for(let Pe=Re;Pe<be.length;Pe++)if(s(be.charCodeAt(Pe))||Pe>0&&s(be.charCodeAt(Pe-1)))return Pe;return be.length}const y=L(e.$6j,p,g),E=L(e.$6j,p,f),A=new D.$Dc(1e4);function V(be,Re,Pe=!1){if(typeof be!="string"||typeof Re!="string")return null;let We=A.get(be);We||(We=new RegExp(C.$5e(be),"i"),A.set(be,We));const j=We.exec(Re);return j?[{start:j.index,end:j.index+j[0].length}]:Pe?E(be,Re):y(be,Re)}e.$_j=V;function X(be,Re){const Pe=we(be,be.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Pe?O(Pe):null}e.$ak=X;function H(be,Re,Pe,We,j,z){const q=Math.min(13,be.length);for(;Pe<q;Pe++){const W=we(be,Re,Pe,We,j,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(W)return W}return[0,z]}e.$bk=H;function O(be){if(typeof be>"u")return[];const Re=[],Pe=be[1];for(let We=be.length-1;We>1;We--){const j=be[We]+Pe,z=Re[Re.length-1];z&&z.end===j?z.end=j+1:Re.push({start:j,end:j+1})}return Re}e.$ck=O;const R=128;function B(){const be=[],Re=[];for(let Pe=0;Pe<=R;Pe++)Re[Pe]=0;for(let Pe=0;Pe<=R;Pe++)be.push(Re.slice(0));return be}function T(be){const Re=[];for(let Pe=0;Pe<=be;Pe++)Re[Pe]=0;return Re}const te=T(2*R),Q=T(2*R),ce=B(),le=B(),se=B(),$e=!1;function ne(be,Re,Pe,We,j){function z(W,ie,ue=" "){for(;W.length<ie;)W=ue+W;return W}let q=` |   |${We.split("").map(W=>z(W,3)).join("|")}
`;for(let W=0;W<=Pe;W++)W===0?q+=" |":q+=`${Re[W-1]}|`,q+=be[W].slice(0,j+1).map(ie=>z(ie.toString(),3)).join("|")+`
`;return q}function ke(be,Re,Pe,We){be=be.substr(Re),Pe=Pe.substr(We),console.log(ne(le,be,be.length,Pe,Pe.length)),console.log(ne(se,be,be.length,Pe,Pe.length)),console.log(ne(ce,be,be.length,Pe,Pe.length))}function oe(be,Re){if(Re<0||Re>=be.length)return!1;const Pe=be.codePointAt(Re);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$Cf(Pe)}}function ve(be,Re){if(Re<0||Re>=be.length)return!1;switch(be.charCodeAt(Re)){case 32:case 9:return!0;default:return!1}}function G(be,Re,Pe){return Re[be]!==Pe[be]}function ge(be,Re,Pe,We,j,z,q=!1){for(;Re<Pe&&j<z;)be[Re]===We[j]&&(q&&(te[Re]=j),Re+=1),j+=1;return Re===Pe}e.$dk=ge;var ae;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var De;(function(be){be.Default=[-100,0];function Re(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}be.isDefault=Re})(De||(e.FuzzyScore=De={}));class ye{constructor(Re,Pe){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Pe}}e.$ek=ye,ye.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function we(be,Re,Pe,We,j,z,q=ye.default){const W=be.length>R?R:be.length,ie=We.length>R?R:We.length;if(Pe>=W||z>=ie||W-Pe>ie-z||!ge(Re,Pe,W,j,z,ie,!0))return;he(W,ie,Pe,z,Re,j);let ue=1,Le=1,Be=Pe,Ke=z;const et=[!1];for(ue=1,Be=Pe;Be<W;ue++,Be++){const ct=te[Be],Ve=Q[Be],it=Be+1<W?Q[Be+1]:ie;for(Le=ct-z+1,Ke=ct;Ke<it;Le++,Ke++){let _=Number.MIN_SAFE_INTEGER,Z=!1;Ke<=Ve&&(_=K(be,Re,Be,Pe,We,j,Ke,ie,z,ce[ue-1][Le-1]===0,et));let Ee=0;_!==Number.MAX_SAFE_INTEGER&&(Z=!0,Ee=_+le[ue-1][Le-1]);const qe=Ke>ct,Ye=qe?le[ue][Le-1]+(ce[ue][Le-1]>0?-5:0):0,ut=Ke>ct+1&&ce[ue][Le-1]>0,Oe=ut?le[ue][Le-2]+(ce[ue][Le-2]>0?-5:0):0;if(ut&&(!qe||Oe>=Ye)&&(!Z||Oe>=Ee))le[ue][Le]=Oe,se[ue][Le]=3,ce[ue][Le]=0;else if(qe&&(!Z||Ye>=Ee))le[ue][Le]=Ye,se[ue][Le]=2,ce[ue][Le]=0;else if(Z)le[ue][Le]=Ee,se[ue][Le]=1,ce[ue][Le]=ce[ue-1][Le-1]+1;else throw new Error("not possible")}}if($e&&ke(be,Pe,We,z),!et[0]&&!q.firstMatchCanBeWeak)return;ue--,Le--;const rt=[le[ue][Le],z];let ft=0,at=0;for(;ue>=1;){let ct=Le;do{const Ve=se[ue][ct];if(Ve===3)ct=ct-2;else if(Ve===2)ct=ct-1;else break}while(ct>=1);ft>1&&Re[Pe+ue-1]===j[z+Le-1]&&!G(ct+z-1,We,j)&&ft+1>ce[ue][ct]&&(ct=Le),ct===Le?ft++:ft=1,at||(at=ct),ue--,Le=ct-1,rt.push(Le)}ie===W&&q.boostFullMatch&&(rt[0]+=2);const nt=at-W;return rt[0]-=nt,rt}e.$fk=we;function he(be,Re,Pe,We,j,z){let q=be-1,W=Re-1;for(;q>=Pe&&W>=We;)j[q]===z[W]&&(Q[q]=W,q--),W--}function K(be,Re,Pe,We,j,z,q,W,ie,ue,Le){if(Re[Pe]!==z[q])return Number.MIN_SAFE_INTEGER;let Be=1,Ke=!1;return q===Pe-We?Be=be[Pe]===j[q]?7:5:G(q,j,z)&&(q===0||!G(q-1,j,z))?(Be=be[Pe]===j[q]?7:5,Ke=!0):oe(z,q)&&(q===0||!oe(z,q-1))?Be=5:(oe(z,q-1)||ve(z,q-1))&&(Be=5,Ke=!0),Be>1&&Pe===We&&(Le[0]=!0),Ke||(Ke=G(q,j,z)||oe(z,q-1)||ve(z,q-1)),Pe===We?q>ie&&(Be-=Ke?3:5):ue?Be+=Ke?2:0:Be+=Ke?0:1,q+1===W&&(Be-=Ke?3:5),Be}function Y(be,Re,Pe,We,j,z,q){return pe(be,Re,Pe,We,j,z,!0,q)}e.$gk=Y;function me(be,Re,Pe,We,j,z,q){return pe(be,Re,Pe,We,j,z,!1,q)}e.$hk=me;function pe(be,Re,Pe,We,j,z,q,W){let ie=we(be,Re,Pe,We,j,z,W);if(ie&&!q)return ie;if(be.length>=3){const ue=Math.min(7,be.length-1);for(let Le=Pe+1;Le<ue;Le++){const Be=Fe(be,Le);if(Be){const Ke=we(Be,Be.toLowerCase(),Pe,We,j,z,W);Ke&&(Ke[0]-=3,(!ie||Ke[0]>ie[0])&&(ie=Ke))}}}return ie}function Fe(be,Re){if(Re+1>=be.length)return;const Pe=be[Re],We=be[Re+1];if(Pe!==We)return be.slice(0,Re)+We+Pe+be.slice(Re+2)}}),define(Me[32],Ae([1,0,13]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(P||(P={})),function(C){const L="error",M="warning",g="warn",f="info",k="ignore";function F(l){return l?D.$jf(L,l)?C.Error:D.$jf(M,l)||D.$jf(g,l)?C.Warning:D.$jf(f,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=F;function S(l){switch(l){case C.Error:return L;case C.Warning:return M;case C.Info:return f;default:return k}}C.toString=S}(P||(P={})),e.default=P}),define(Me[127],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(Me[50],Ae([1,0,18,13]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class C{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const m=w.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.$gi=C;class L{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,P.$df)(w,this.b,0,w.length,this.c,this.d):(0,P.$ff)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=L;class M{constructor(w=!0,m=!0){this.f=w,this.g=m}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let m=w.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,P.$df)(w,this.b,0,w.length,this.d,this.e):(0,P.$ff)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=M;var g;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(g||(g={}));class f{constructor(w,m){this.f=w,this.g=m,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,P.$ef)(w,this.c.scheme);if(this.d[this.e]===2)return(0,P.$ef)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,P.$cf)(w,this.c.query);if(this.d[this.e]===5)return(0,P.$cf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=f;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var F;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(F||(F={}));class S{static forUris(w=()=>!1,m=()=>!1){return new S(new f(w,m))}static forPaths(w=!1){return new S(new M(void 0,!w))}static forStrings(){return new S(new C)}static forConfigKeys(){return new S(new L)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,m){if(m){const s=m.slice(0);(0,D.$Xb)(s);for(const u of s)this.set(u,w)}else{const s=w.slice(0);(0,D.$Xb)(s);for(const u of s)this.set(u[0],u[1])}}set(w,m){const s=this.b.reset(w);let u;this.c||(this.c=new k,this.c.segment=s.value());const i=[];for(u=this.c;;){const n=s.cmp(u.segment);if(n>0)u.left||(u.left=new k,u.left.segment=s.value()),i.push([-1,u]),u=u.left;else if(n<0)u.right||(u.right=new k,u.right.segment=s.value()),i.push([1,u]),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new k,u.mid.segment=s.value()),i.push([0,u]),u=u.mid;else break}const r=u.value;u.value=m,u.key=w;for(let n=i.length-1;n>=0;n--){const a=i[n][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=i[n][0],$=i[n+1][0];if(t===1&&$===1)i[n][1]=a.rotateLeft();else if(t===-1&&$===-1)i[n][1]=a.rotateRight();else if(t===1&&$===-1)a.right=i[n+1][1]=i[n+1][1].rotateRight(),i[n][1]=a.rotateLeft();else if(t===-1&&$===1)a.left=i[n+1][1]=i[n+1][1].rotateLeft(),i[n][1]=a.rotateRight();else throw new Error;if(n>0)switch(i[n-1][0]){case-1:i[n-1][1].left=i[n][1];break;case 1:i[n-1][1].right=i[n][1];break;case 0:i[n-1][1].mid=i[n][1];break}else this.c=i[0][1]}}return r}get(w){return this.d(w)?.value}d(w){const m=this.b.reset(w);let s=this.c;for(;s;){const u=m.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(w){const m=this.d(w);return!(m?.value===void 0&&m?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,m){const s=this.b.reset(w),u=[];let i=this.c;for(;i;){const r=s.cmp(i.segment);if(r>0)u.push([-1,i]),i=i.left;else if(r<0)u.push([1,i]),i=i.right;else if(s.hasNext())s.next(),u.push([0,i]),i=i.mid;else break}if(i){if(m?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const r=this.f(i.right);if(r.key){const{key:n,value:a,segment:h}=r;this.e(r.key,!1),i.key=n,i.value=a,i.segment=h}}else{const r=i.left??i.right;if(u.length>0){const[n,a]=u[u.length-1];switch(n){case-1:a.left=r;break;case 0:a.mid=r;break;case 1:a.right=r;break}}else this.c=r}for(let r=u.length-1;r>=0;r--){const n=u[r][1];n.updateHeight();const a=n.balanceFactor();if(a>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),u[r][1]=n.rotateLeft()):a<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),u[r][1]=n.rotateRight()),r>0)switch(u[r-1][0]){case-1:u[r-1][1].left=u[r][1];break;case 1:u[r-1][1].right=u[r][1];break;case 0:u[r-1][1].mid=u[r][1];break}else this.c=u[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const m=this.b.reset(w);let s=this.c,u;for(;s;){const i=m.cmp(s.segment);if(i>0)s=s.left;else if(i<0)s=s.right;else if(m.hasNext())m.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(w){return this.g(w,!1)}g(w,m){const s=this.b.reset(w);let u=this.c;for(;u;){const i=s.cmp(u.segment);if(i>0)u=u.left;else if(i<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this.h(u.mid):m?u.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[m,s]of this)w(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const m=[];return this.j(w,m),m[Symbol.iterator]()}j(w,m){w&&(w.left&&this.j(w.left,m),w.value&&m.push([w.key,w.value]),w.mid&&this.j(w.mid,m),w.right&&this.j(w.right,m))}_isBalanced(){const w=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:w(m.left)&&w(m.right)};return w(this.c)}}e.$ki=S}),define(Me[45],Ae([1,0,19,21,13,16]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function M(p){return p===47||p===92}e.$$f=M;function g(p){return p.replace(/[\\/]/g,D.$gc.sep)}e.$_f=g;function f(p){return p.indexOf("/")===-1&&(p=g(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}e.$ag=f;function k(p,d=D.$gc.sep){if(!p)return"";const I=p.length,v=p.charCodeAt(0);if(M(v)){if(M(p.charCodeAt(1))&&!M(p.charCodeAt(2))){let E=3;const A=E;for(;E<I&&!M(p.charCodeAt(E));E++);if(A!==E&&!M(p.charCodeAt(E+1))){for(E+=1;E<I;E++)if(M(p.charCodeAt(E)))return p.slice(0,E+1).replace(/[\\/]/g,d)}}return d}else if(i(v)&&p.charCodeAt(1)===58)return M(p.charCodeAt(2))?p.slice(0,2)+d:p.slice(0,2);let y=p.indexOf("://");if(y!==-1){for(y+=3;y<I;y++)if(M(p.charCodeAt(y)))return p.slice(0,y+1)}return""}e.$bg=k;function F(p){if(!P.$c||!p||p.length<5)return!1;let d=p.charCodeAt(0);if(d!==92||(d=p.charCodeAt(1),d!==92))return!1;let I=2;const v=I;for(;I<p.length&&(d=p.charCodeAt(I),d!==92);I++);return!(v===I||(d=p.charCodeAt(I+1),isNaN(d)||d===92))}e.$cg=F;const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(p,d=P.$c){const I=d?S:l;return!(!p||p.length===0||/^\s+$/.test(p)||(I.lastIndex=0,I.test(p))||d&&w.test(p)||p==="."||p===".."||d&&p[p.length-1]==="."||d&&p.length!==p.trim().length||p.length>255)}e.$dg=m;function s(p,d,I){const v=p===d;return!I||v?v:!p||!d?!1:(0,C.$jf)(p,d)}e.$eg=s;function u(p,d,I,v=D.sep){if(p===d)return!0;if(!p||!d||d.length>p.length)return!1;if(I){if(!(0,C.$kf)(p,d))return!1;if(d.length===p.length)return!0;let E=d.length;return d.charAt(d.length-1)===v&&E--,p.charAt(E)===v}return d.charAt(d.length-1)!==v&&(d+=v),p.indexOf(d)===0}e.$fg=u;function i(p){return p>=65&&p<=90||p>=97&&p<=122}e.$gg=i;function r(p,d){return P.$c&&p.endsWith(":")&&(p+=D.sep),(0,D.$ic)(p)||(p=(0,D.$jc)(d,p)),p=(0,D.$hc)(p),P.$c?(p=(0,C.$4e)(p,D.sep),p.endsWith(":")&&(p+=D.sep)):(p=(0,C.$4e)(p,D.sep),p||(p=D.sep)),p}e.$hg=r;function n(p){const d=(0,D.$hc)(p);return P.$c?p.length>3?!1:a(d)&&(p.length===2||d.charCodeAt(2)===92):d===D.$gc.sep}e.$ig=n;function a(p,d=P.$c){return d?i(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}e.$jg=a;function h(p,d=P.$c){return a(p,d)?p[0]:void 0}e.$kg=h;function t(p,d,I){return d.length>p.length?-1:p===d?0:(I&&(p=p.toLowerCase(),d=d.toLowerCase()),p.indexOf(d))}e.$lg=t;function $(p){const d=p.split(":");let I,v,y;for(const E of d){const A=Number(E);(0,L.$Wf)(A)?v===void 0?v=A:y===void 0&&(y=A):I=I?[I,E].join(":"):E}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.$mg=$;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(p,d,I=8){let v="";for(let E=0;E<I;E++){let A;E===0&&P.$c&&!d&&(I===3||I===4)?A=o:A=c,v+=A.charAt(Math.floor(Math.random()*A.length))}let y;return d?y=`${d}-${v}`:y=v,p?(0,D.$jc)(p,y):y}e.$ng=b}),define(Me[41],Ae([1,0,89]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$lk=e.ThemeColor=void 0;var P;(function(M){function g(f){return f&&typeof f=="object"&&typeof f.id=="string"}M.isThemeColor=g})(P||(e.ThemeColor=P={}));function C(M){return{id:M}}e.$lk=C;var L;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(r){const n=g.exec(r.id);if(!n)return f(D.$kk.error);const[,a,h]=n,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}M.asClassNameArray=f;function k(r){return f(r).join(" ")}M.asClassName=k;function F(r){return"."+f(r).join(".")}M.asCSSSelector=F;function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||P.isThemeColor(r.color))}M.isThemeIcon=S;const l=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function w(r){const n=l.exec(r);if(!n)return;const[,a]=n;return{id:a}}M.fromString=w;function m(r){return{id:r}}M.fromId=m;function s(r,n){let a=r.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),n&&(a=`${a}~${n}`),{id:a}}M.modify=s;function u(r){const n=r.id.lastIndexOf("~");if(n!==-1)return r.id.substring(n+1)}M.getModifier=u;function i(r,n){return r.id===n.id&&r.color?.id===n.color?.id}M.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Me[128],Ae([1,0,126,13,41]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;const L="$(",M=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${M.source}`,"g");function f(i){return i.replace(g,(r,n)=>n?r:`\\${r}`)}e.$mk=f;const k=new RegExp(`\\\\${M.source}`,"g");function F(i){return i.replace(k,r=>`\\${r}`)}e.$nk=F;const S=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function l(i){return i.indexOf(L)===-1?i:i.replace(S,(r,n,a,h)=>a?r:n||h||"")}e.$ok=l;function w(i){return i?i.replace(/\$\((.*?)\)/g,(r,n)=>` ${n} `).trim():""}e.$pk=w;const m=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(i){m.lastIndex=0;let r="";const n=[];let a=0;for(;;){const h=m.lastIndex,t=m.exec(i),$=i.substring(h,t?.index);if($.length>0){r+=$;for(let c=0;c<$.length;c++)n.push(a)}if(!t)break;a+=t[0].length}return{text:r,iconOffsets:n}}e.$qk=s;function u(i,r,n=!1){const{text:a,iconOffsets:h}=r;if(!h||h.length===0)return(0,D.$_j)(i,a,n);const t=(0,P.$3e)(a," "),$=a.length-t.length,c=(0,D.$_j)(i,t,n);if(c)for(const o of c){const b=h[o.start+$]+$;o.start+=b,o.end+=b}return c}e.$rk=u}),define(Me[51],Ae([1,0,24,2]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function C(f){return JSON.stringify(f,M)}e.$Lh=C;function L(f){let k=JSON.parse(f);return k=g(k),k}e.$Mh=L;function M(f,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function g(f,k=0){if(!f||k>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return P.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof D.$se||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let F=0;F<f.length;++F)f[F]=g(f[F],k+1);else for(const F in f)Object.hasOwnProperty.call(f,F)&&(f[F]=g(f[F],k+1))}return f}e.$Nh=g}),define(Me[12],Ae([1,0,15,21,13,2]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var M;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.codeSetting="code-setting",l.codeFeature="code-feature"})(M||(e.Schemas=M={}));function g(l,w){return L.URI.isUri(l)?(0,C.$jf)(l.scheme,w):(0,C.$kf)(l,w+":")}e.$og=g;function f(l,...w){return w.some(m=>g(l,m))}e.$pg=f,e.$qg="vscode-tkn",e.$rg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${M.vscodeRemoteResource}`}set(w,m,s){this.a[w]=m,this.b[w]=s}setConnectionToken(w,m){this.c[w]=m}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(n){return D.$1(n),w}const m=w.authority;let s=this.a[m];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const u=this.b[m],i=this.c[m];let r=`path=${encodeURIComponent(w.path)}`;return typeof i=="string"&&(r+=`&${e.$rg}=${encodeURIComponent(i)}`),L.URI.from({scheme:P.$i?this.d:M.vscodeRemoteResource,authority:`${s}:${u}`,path:P.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:r})}}e.$sg=new k,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class F{asBrowserUri(w){const m=this.b(w,x);return this.uriToBrowserUri(m)}uriToBrowserUri(w){return w.scheme===M.vscodeRemote?e.$sg.rewrite(w):w.scheme===M.file&&(P.$g||P.$k===`${M.vscodeFileResource}://${F.a}`)?w.with({scheme:M.vscodeFileResource,authority:w.authority||F.a,query:null,fragment:null}):w}asFileUri(w){const m=this.b(w,x);return this.uriToFileUri(m)}uriToFileUri(w){return w.scheme===M.vscodeFileResource?w.with({scheme:M.file,authority:w.authority!==F.a?w.authority:null,query:null,fragment:null}):w}b(w,m){return L.URI.isUri(w)?w:L.URI.parse(m.toUrl(w))}}F.a=e.$xg,e.$yg=new F;var S;(function(l){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(w.get("3"));const m="vscode-coi";function s(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:L.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const n=r?.get(m);if(n)return w.get(n)}l.getHeadersFromQuery=s;function u(i,r,n){if(!globalThis.crossOriginIsolated)return;const a=r&&n?"3":n?"2":"1";i instanceof URLSearchParams?i.set(m,a):i[m]=a}l.addSearchParam=u})(S||(e.COI=S={}))}),define(Me[25],Ae([1,0,45,12,19,21,13,2]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function f(w){return(0,g.$wc)(w,!0)}e.$Fg=f;class k{constructor(m){this.a=m}compare(m,s,u=!1){return m===s?0:(0,M.$cf)(this.getComparisonKey(m,u),this.getComparisonKey(s,u))}isEqual(m,s,u=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,u)===this.getComparisonKey(s,u)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,u=!1){if(m.scheme===s.scheme){if(m.scheme===P.Schemas.file)return D.$fg(f(m),f(s),this.a(m))&&m.query===s.query&&(u||m.fragment===s.fragment);if((0,e.$Wg)(m.authority,s.authority))return D.$fg(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(u||m.fragment===s.fragment)}return!1}joinPath(m,...s){return g.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.$Og)(m)||m.authority}basename(m){return C.$gc.basename(m.path)}extname(m){return C.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===P.Schemas.file?s=g.URI.file(C.$mc(f(m))).path:(s=C.$gc.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===P.Schemas.file?s=g.URI.file(C.$hc(f(m))).path:s=C.$gc.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.$Wg)(m.authority,s.authority))return;if(m.scheme===P.Schemas.file){const r=C.$lc(f(m),f(s));return L.$c?D.$_f(r):r}let u=m.path||"/";const i=s.path||"/";if(this.a(m)){let r=0;for(const n=Math.min(u.length,i.length);r<n&&!(u.charCodeAt(r)!==i.charCodeAt(r)&&u.charAt(r).toLowerCase()!==i.charAt(r).toLowerCase());r++);u=i.substr(0,r)+u.substr(r)}return C.$gc.relative(u,i)}resolvePath(m,s){if(m.scheme===P.Schemas.file){const u=g.URI.file(C.$kc(f(m),s));return m.with({authority:u.authority,path:u.path})}return s=D.$ag(s),m.with({path:C.$gc.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,M.$jf)(m,s)}hasTrailingPathSeparator(m,s=C.sep){if(m.scheme===P.Schemas.file){const u=f(m);return u.length>D.$bg(u).length&&u[u.length-1]===s}else{const u=m.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=C.sep){return(0,e.$Xg)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=C.sep){let u=!1;if(m.scheme===P.Schemas.file){const i=f(m);u=i!==void 0&&i.length===D.$bg(i).length&&i[i.length-1]===s}else{s="/";const i=m.path;u=i.length===1&&i.charCodeAt(i.length-1)===47}return!u&&!(0,e.$Xg)(m,s)?m.with({path:m.path+"/"}):m}}e.$Gg=k,e.$Hg=new k(()=>!1),e.$Ig=new k(w=>w.scheme===P.Schemas.file?!L.$e:!0),e.$Jg=new k(w=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function F(w,m){const s=[];for(let u=0;u<w.length;u++){const i=m(w[u]);w.some((r,n)=>n===u?!1:(0,e.$Lg)(i,m(r)))||s.push(w[u])}return s}e.$1g=F;var S;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(s){const u=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[a,h]=n.split(":");a&&h&&u.set(a,h)});const r=s.path.substring(0,s.path.indexOf(";"));return r&&u.set(w.META_DATA_MIME,r),u}w.parseMetaData=m})(S||(e.DataUri=S={}));function l(w,m,s){if(m){let u=w.path;return u&&u[0]!==C.$gc.sep&&(u=C.$gc.sep+u),w.with({scheme:s,authority:m,path:u})}return w.with({scheme:s})}e.$2g=l}),define(Me[11],Ae([1,0,22,15,5,6,25,21,127,40]),function(x,e,D,P,C,L,M,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function F(he){return!!he&&typeof he.then=="function"}e.$3g=F;function S(he){const K=new D.$ce,Y=he(K.token),me=new Promise((pe,Fe)=>{const be=K.token.onCancellationRequested(()=>{be.dispose(),Fe(new P.$5)});Promise.resolve(Y).then(Re=>{be.dispose(),K.dispose(),pe(Re)},Re=>{be.dispose(),K.dispose(),Fe(Re)})});return new class{cancel(){K.cancel(),K.dispose()}then(pe,Fe){return me.then(pe,Fe)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}e.$4g=S;function l(he,K,Y){return new Promise((me,pe)=>{const Fe=K.onCancellationRequested(()=>{Fe.dispose(),me(Y)});he.then(me,pe).finally(()=>Fe.dispose())})}e.$5g=l;function w(he,K){return new Promise((Y,me)=>{const pe=K.onCancellationRequested(()=>{pe.dispose(),me(new P.$5)});he.then(Y,me).finally(()=>pe.dispose())})}e.$6g=w;async function m(he){let K=-1;const Y=he.map((me,pe)=>me.then(Fe=>(K=pe,Fe)));try{return await Promise.race(Y)}finally{he.forEach((me,pe)=>{pe!==K&&me.cancel()})}}e.$7g=m;function s(he,K,Y){let me;const pe=setTimeout(()=>{me?.(void 0),Y?.()},K);return Promise.race([he.finally(()=>clearTimeout(pe)),new Promise(Fe=>me=Fe)])}e.$8g=s;function u(he){return new Promise((K,Y)=>{const me=he();F(me)?me.then(K,Y):K(me)})}e.$9g=u;function i(){let he,K;return{promise:new Promise((me,pe)=>{he=me,K=pe}),resolve:he,reject:K}}e.$0g=i;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const Y=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(Y,Y).then(me)})}return new Promise((Y,me)=>{this.b.then(Y,me)})}return this.a=K(),new Promise((Y,me)=>{this.a.then(pe=>{this.a=null,Y(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$$g=r;class n{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$_g=n;class a{constructor(){this.a=new Map}queue(K,Y){const pe=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(K)===pe&&this.a.delete(K)});return this.a.set(K,pe),pe}}e.$ah=a;const h=(he,K)=>{let Y=!0;const me=setTimeout(()=>{Y=!1,K()},he);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(me),Y=!1}}},t=he=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,he())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class ${constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,Y=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((pe,Fe)=>{this.d=pe,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=Y===f.$2d?t(me):h(Y,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=$;class c{constructor(K){this.a=new $(K),this.b=new r}trigger(K,Y){return this.a.trigger(()=>this.b.queue(K),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=c;class o{constructor(){this.a=!1,this.b=new Promise((K,Y)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=o;class b extends o{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$eh=b;function p(he,K){return K?new Promise((Y,me)=>{const pe=setTimeout(()=>{Fe.dispose(),Y()},he),Fe=K.onCancellationRequested(()=>{clearTimeout(pe),Fe.dispose(),me(new P.$5)})}):S(Y=>p(he,Y))}e.$fh=p;function d(he,K=0,Y){const me=setTimeout(()=>{he(),Y&&pe.dispose()},K),pe=(0,L.$Rc)(()=>{clearTimeout(me),Y?.deleteAndLeak(pe)});return Y?.add(pe),pe}e.$gh=d;function I(he){const K=[];let Y=0;const me=he.length;function pe(){return Y<me?he[Y++]():null}function Fe(be){be!=null&&K.push(be);const Re=pe();return Re?Re.then(Fe):Promise.resolve(K)}return Promise.resolve(null).then(Fe)}e.$hh=I;function v(he,K=me=>!!me,Y=null){let me=0;const pe=he.length,Fe=()=>{if(me>=pe)return Promise.resolve(Y);const be=he[me++];return Promise.resolve(be()).then(Pe=>K(Pe)?Promise.resolve(Pe):Fe())};return Fe()}e.$ih=v;function y(he,K=me=>!!me,Y=null){if(he.length===0)return Promise.resolve(Y);let me=he.length;const pe=()=>{me=-1;for(const Fe of he)Fe.cancel?.()};return new Promise((Fe,be)=>{for(const Re of he)Re.then(Pe=>{--me>=0&&K(Pe)?(pe(),Fe(Pe)):me===0&&Fe(Y)}).catch(Pe=>{--me>=0&&(pe(),be(Pe))})})}e.$jh=y;class E{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new C.$5d}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,me)=>{this.g.push({factory:K,c:Y,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const Y=K.factory();Y.then(K.c,K.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=E;class A extends E{constructor(){super(1)}}e.$lh=A;class V{constructor(){this.a=new se,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$mh=V;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ke;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,Y=M.$Hg){const me=Y.getComparisonKey(K);return this.a.get(me)?.size??0}queueFor(K,Y,me=M.$Hg){const pe=me.getComparisonKey(K);let Fe=this.a.get(pe);if(!Fe){Fe=new A;const be=this.f++,Re=C.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(be,Re),this.a.set(pe,Fe)}return Fe.queue(Y)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=X;class H{constructor(K,Y){this.a=-1,typeof K=="function"&&typeof Y=="number"&&this.setIfNotSet(K,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},Y)}setIfNotSet(K,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},Y))}}e.$oh=H;class O{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,Y,me=globalThis){this.cancel();const pe=me.setInterval(()=>{K()},Y);this.d=(0,L.$Rc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel()}}e.$ph=O;class R{constructor(K,Y){this.b=-1,this.a=K,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=R;class B{constructor(K,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=K,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=B;class T extends R{constructor(K,Y){super(K,Y),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$sh=T;class te extends L.$Tc{constructor(K,Y){super(),this.g=K,this.h=Y,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of K)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(he,K)=>{(0,g.$v)(()=>{if(Y)return;const me=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$vh=(he,K,Y)=>{const me=he.requestIdleCallback(K,typeof Y=="number"?{timeout:Y}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,he.cancelIdleCallback(me))}}},e.$uh=he=>(0,e.$vh)(globalThis,he)}();class Q{constructor(K,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$vh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=Q;class ce extends Q{constructor(K){super(globalThis,K)}}e.$xh=ce;async function le(he,K,Y){let me;for(let pe=0;pe<Y;pe++)try{return await he()}catch(Fe){me=Fe,await p(K)}throw me}e.$yh=le;class se{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,Y,me){return this.a={taskId:K,cancel:()=>me?.(),promise:Y},Y.then(()=>this.d(K),()=>this.d(K)),Y}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:Y,resolve:me,reject:pe}=i();this.b={run:K,promise:Y,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=se;class $e{constructor(K,Y=()=>Date.now()){this.d=K,this.f=Y,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Ah=$e;var ne;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(ne||(ne={}));class ke{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,Y)=>{this.a=K,this.b=Y})}complete(K){return new Promise(Y=>{this.a(K),this.d={outcome:0,value:K},Y()})}error(K){return new Promise(Y=>{this.b(K),this.d={outcome:1,value:K},Y()})}cancel(){return this.error(new P.$5)}}e.$Bh=ke;var oe;(function(he){async function K(me){let pe;const Fe=await Promise.all(me.map(be=>be.then(Re=>Re,Re=>{pe||(pe=Re)})));if(typeof pe<"u")throw pe;return Fe}he.settled=K;function Y(me){return new Promise(async(pe,Fe)=>{try{await me(pe,Fe)}catch(be){Fe(be)}})}he.withAsyncBody=Y})(oe||(e.Promises=oe={}));class ve{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new P.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=ve;class G{constructor(K){this.b=K,this.a=new k.$V(()=>new ve(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=G;var ge;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(ge||(ge={}));class ae{static fromArray(K){return new ae(Y=>{Y.emitMany(K)})}static fromPromise(K){return new ae(async Y=>{Y.emitMany(await K)})}static fromPromises(K){return new ae(async Y=>{await Promise.all(K.map(async me=>Y.emitOne(await me)))})}static merge(K){return new ae(async Y=>{await Promise.all(K.map(async me=>{for await(const pe of me)Y.emitOne(pe)}))})}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new C.$5d,queueMicrotask(async()=>{const Y={emitOne:me=>this.g(me),emitMany:me=>this.h(me),reject:me=>this.k(me)};try{await Promise.resolve(K(Y)),this.j()}catch(me){this.k(me)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(K,Y){return new ae(async me=>{for await(const pe of K)me.emitOne(Y(pe))})}map(K){return ae.map(this,K)}static filter(K,Y){return new ae(async me=>{for await(const pe of K)Y(pe)&&me.emitOne(pe)})}filter(K){return ae.filter(this,K)}static coalesce(K){return ae.filter(K,Y=>!!Y)}coalesce(){return ae.coalesce(this)}static async toPromise(K){const Y=[];for await(const me of K)Y.push(me);return Y}toPromise(){return ae.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$Eh=ae,ae.EMPTY=ae.fromArray([]);class De extends ae{constructor(K,Y){super(Y),this.l=K}cancel(){this.l.cancel()}}e.$Fh=De;function ye(he){const K=new D.$ce,Y=he(K.token);return new De(K,async me=>{const pe=K.token.onCancellationRequested(()=>{pe.dispose(),K.dispose(),me.reject(new P.$5)});try{for await(const Fe of Y){if(K.token.isCancellationRequested)return;me.emitOne(Fe)}pe.dispose(),K.dispose()}catch(Fe){pe.dispose(),K.dispose(),me.reject(Fe)}})}e.$Gh=ye;class we{constructor(){this.a=new ke,this.b=new ae(me=>{if(K){me.reject(K);return}return Y&&me.emitMany(Y),this.d=pe=>me.reject(pe),this.f=pe=>me.emitOne(pe),this.a.p});let K,Y;this.f=me=>{Y||(Y=[]),Y.push(me)},this.d=me=>{K||(K=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Hh=we}),define(Me[33],Ae([1,0,18,11,45,28,19,21,13]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;function k(){return Object.create(null)}e.$Sj=k,e.$Tj="**",e.$Uj="/";const F="[/\\\\]",S="[^/\\\\]",l=/\//g;function w(Q,ce){switch(Q){case 0:return"";case 1:return`${S}*?`;default:return`(?:${F}|${S}+${F}${ce?`|${F}${S}+`:""})*?`}}function m(Q,ce){if(!Q)return[];const le=[];let se=!1,$e=!1,ne="";for(const ke of Q){switch(ke){case ce:if(!se&&!$e){le.push(ne),ne="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}ne+=ke}return ne&&le.push(ne),le}e.$Vj=m;function s(Q){if(!Q)return"";let ce="";const le=m(Q,e.$Uj);if(le.every(se=>se===e.$Tj))ce=".*";else{let se=!1;le.forEach(($e,ne)=>{if($e===e.$Tj){if(se)return;ce+=w(2,ne===le.length-1)}else{let ke=!1,oe="",ve=!1,G="";for(const ge of $e){if(ge!=="}"&&ke){oe+=ge;continue}if(ve&&(ge!=="]"||!G)){let ae;ge==="-"?ae=ge:(ge==="^"||ge==="!")&&!G?ae="^":ge===e.$Uj?ae="":ae=(0,f.$Xe)(ge),G+=ae;continue}switch(ge){case"{":ke=!0;continue;case"[":ve=!0;continue;case"}":{const De=`(?:${m(oe,",").map(ye=>s(ye)).join("|")})`;ce+=De,ke=!1,oe="";break}case"]":{ce+="["+G+"]",ve=!1,G="";break}case"?":ce+=S;continue;case"*":ce+=w(1);continue;default:ce+=(0,f.$Xe)(ge)}}ne<le.length-1&&(le[ne+1]!==e.$Tj||ne+2<le.length)&&(ce+=F)}se=$e===e.$Tj})}return ce}const u=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),$=function(){return!1},c=function(){return null};function o(Q,ce){if(!Q)return c;let le;typeof Q!="string"?le=Q.pattern:le=Q,le=le.trim();const se=`${le}_${!!ce.trimForExclusions}`;let $e=t.get(se);if($e)return b($e,Q);let ne;return u.test(le)?$e=d(le.substr(4),le):(ne=i.exec(p(le,ce)))?$e=I(ne[1],le):(ce.trimForExclusions?n:r).test(le)?$e=v(le,ce):(ne=a.exec(p(le,ce)))?$e=y(ne[1].substr(1),le,!0):(ne=h.exec(p(le,ce)))?$e=y(ne[1],le,!1):$e=E(le),t.set(se,$e),b($e,Q)}function b(Q,ce){if(typeof ce=="string")return Q;const le=function(se,$e){return(0,C.$fg)(se,ce.base,!g.$e)?Q((0,f.$3e)(se.substr(ce.base.length),M.sep),$e):null};return le.allBasenames=Q.allBasenames,le.allPaths=Q.allPaths,le.basenames=Q.basenames,le.patterns=Q.patterns,le}function p(Q,ce){return ce.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function d(Q,ce){return function(le,se){return typeof le=="string"&&le.endsWith(Q)?ce:null}}function I(Q,ce){const le=`/${Q}`,se=`\\${Q}`,$e=function(ke,oe){return typeof ke!="string"?null:oe?oe===Q?ce:null:ke===Q||ke.endsWith(le)||ke.endsWith(se)?ce:null},ne=[Q];return $e.basenames=ne,$e.patterns=[ce],$e.allBasenames=ne,$e}function v(Q,ce){const le=T(Q.slice(1,-1).split(",").map(oe=>o(oe,ce)).filter(oe=>oe!==c),Q),se=le.length;if(!se)return c;if(se===1)return le[0];const $e=function(oe,ve){for(let G=0,ge=le.length;G<ge;G++)if(le[G](oe,ve))return Q;return null},ne=le.find(oe=>!!oe.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const ke=le.reduce((oe,ve)=>ve.allPaths?oe.concat(ve.allPaths):oe,[]);return ke.length&&($e.allPaths=ke),$e}function y(Q,ce,le){const se=M.sep===M.$gc.sep,$e=se?Q:Q.replace(l,M.sep),ne=M.sep+$e,ke=M.$gc.sep+Q;let oe;return le?oe=function(ve,G){return typeof ve=="string"&&(ve===$e||ve.endsWith(ne)||!se&&(ve===Q||ve.endsWith(ke)))?ce:null}:oe=function(ve,G){return typeof ve=="string"&&(ve===$e||!se&&ve===Q)?ce:null},oe.allPaths=[(le?"*/":"./")+Q],oe}function E(Q){try{const ce=new RegExp(`^${s(Q)}$`);return function(le){return ce.lastIndex=0,typeof le=="string"&&ce.test(le)?Q:null}}catch{return c}}function A(Q,ce,le){return!Q||typeof ce!="string"?!1:V(Q)(ce,void 0,le)}e.$Wj=A;function V(Q,ce={}){if(!Q)return $;if(typeof Q=="string"||X(Q)){const le=o(Q,ce);if(le===c)return $;const se=function($e,ne){return!!le($e,ne)};return le.allBasenames&&(se.allBasenames=le.allBasenames),le.allPaths&&(se.allPaths=le.allPaths),se}return R(Q,ce)}e.$Xj=V;function X(Q){const ce=Q;return ce?typeof ce.base=="string"&&typeof ce.pattern=="string":!1}e.$Yj=X;function H(Q){return Q.allBasenames||[]}e.$Zj=H;function O(Q){return Q.allPaths||[]}e.$1j=O;function R(Q,ce){const le=T(Object.getOwnPropertyNames(Q).map(oe=>B(oe,Q[oe],ce)).filter(oe=>oe!==c)),se=le.length;if(!se)return c;if(!le.some(oe=>!!oe.requiresSiblings)){if(se===1)return le[0];const oe=function(ge,ae){let De;for(let ye=0,we=le.length;ye<we;ye++){const he=le[ye](ge,ae);if(typeof he=="string")return he;(0,P.$3g)(he)&&(De||(De=[]),De.push(he))}return De?(async()=>{for(const ye of De){const we=await ye;if(typeof we=="string")return we}return null})():null},ve=le.find(ge=>!!ge.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const G=le.reduce((ge,ae)=>ae.allPaths?ge.concat(ae.allPaths):ge,[]);return G.length&&(oe.allPaths=G),oe}const $e=function(oe,ve,G){let ge,ae;for(let De=0,ye=le.length;De<ye;De++){const we=le[De];we.requiresSiblings&&G&&(ve||(ve=(0,M.$nc)(oe)),ge||(ge=ve.substr(0,ve.length-(0,M.$oc)(oe).length)));const he=we(oe,ve,ge,G);if(typeof he=="string")return he;(0,P.$3g)(he)&&(ae||(ae=[]),ae.push(he))}return ae?(async()=>{for(const De of ae){const ye=await De;if(typeof ye=="string")return ye}return null})():null},ne=le.find(oe=>!!oe.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const ke=le.reduce((oe,ve)=>ve.allPaths?oe.concat(ve.allPaths):oe,[]);return ke.length&&($e.allPaths=ke),$e}function B(Q,ce,le){if(ce===!1)return c;const se=o(Q,le);if(se===c)return c;if(typeof ce=="boolean")return se;if(ce){const $e=ce.when;if(typeof $e=="string"){const ne=(ke,oe,ve,G)=>{if(!G||!se(ke,oe))return null;const ge=$e.replace("$(basename)",()=>ve),ae=G(ge);return(0,P.$3g)(ae)?ae.then(De=>De?Q:null):ae?Q:null};return ne.requiresSiblings=!0,ne}}return se}function T(Q,ce){const le=Q.filter(oe=>!!oe.basenames);if(le.length<2)return Q;const se=le.reduce((oe,ve)=>{const G=ve.basenames;return G?oe.concat(G):oe},[]);let $e;if(ce){$e=[];for(let oe=0,ve=se.length;oe<ve;oe++)$e.push(ce)}else $e=le.reduce((oe,ve)=>{const G=ve.patterns;return G?oe.concat(G):oe},[]);const ne=function(oe,ve){if(typeof oe!="string")return null;if(!ve){let ge;for(ge=oe.length;ge>0;ge--){const ae=oe.charCodeAt(ge-1);if(ae===47||ae===92)break}ve=oe.substr(ge)}const G=se.indexOf(ve);return G!==-1?$e[G]:null};ne.basenames=se,ne.patterns=$e,ne.allBasenames=se;const ke=Q.filter(oe=>!oe.basenames);return ke.push(ne),ke}function te(Q,ce){return(0,D.$ub)(Q,ce,(le,se)=>typeof le=="string"&&typeof se=="string"?le===se:typeof le!="string"&&typeof se!="string"?le.base===se.base&&le.pattern===se.pattern:!1)}e.$2j=te}),define(Me[52],Ae([1,0,15,128,25,13,2]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class f{constructor(r="",n=!1){if(this.value=r,typeof this.value!="string")throw(0,D.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(r,n=0){return this.value+=l(this.supportThemeIcons?(0,P.$mk)(r):r).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,n){return this.value+=`
${w(n,r)}
`,this}appendLink(r,n,a){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(r),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(r,n){const a=new RegExp((0,L.$Xe)(n),"g");return r.replace(a,(h,t)=>r.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$sk=f;function k(i){return F(i)?!i.value:Array.isArray(i)?i.every(k):!0}e.$tk=k;function F(i){return i instanceof f?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||typeof i.isTrusted=="object"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.$uk=F;function S(i,r){return i===r?!0:!i||!r?!1:i.value===r.value&&i.isTrusted===r.isTrusted&&i.supportThemeIcons===r.supportThemeIcons&&i.supportHtml===r.supportHtml&&(i.baseUri===r.baseUri||!!i.baseUri&&!!r.baseUri&&(0,C.$Kg)(M.URI.from(i.baseUri),M.URI.from(r.baseUri)))}e.$vk=S;function l(i){return i.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$wk=l;function w(i,r){const n=i.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=n>=3?n+1:3;return[`${"`".repeat(a)}${r}`,i,`${"`".repeat(a)}`].join(`
`)}e.$xk=w;function m(i){return i.replace(/"/g,"&quot;")}e.$yk=m;function s(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$zk=s;function u(i){const r=[],n=i.split("|").map(h=>h.trim());i=n[0];const a=n[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),$=h?h[1]:"",c=t?t[1]:"",o=isFinite(parseInt(c)),b=isFinite(parseInt($));o&&r.push(`width="${c}"`),b&&r.push(`height="${$}"`)}return{href:i,dimensions:r}}e.$Ak=u}),define(Me[90],Ae([1,0,18,45,19,21,25,13]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=void 0;function f(o,b){const{os:p,tildify:d,relative:I}=b;if(I){const E=k(o,I,p);if(typeof E=="string")return E}let v=o.fsPath;if(p===1&&!L.$c?v=v.replace(/\//g,"\\"):p!==1&&L.$c&&(v=v.replace(/\\/g,"/")),p!==1&&d?.userHome){const E=d.userHome.fsPath;let A;o.scheme!==d.userHome.scheme&&o.path[0]===C.$gc.sep&&o.path[1]!==C.$gc.sep?A=d.userHome.with({path:o.path}).fsPath:A=v,v=l(A,E,p)}return(p===1?C.$fc:C.$gc).normalize(F(v,p===1))}e.$9v=f;function k(o,b,p){const d=p===1?C.$fc:C.$gc,I=p===3?M.$Hg:M.$Jg,v=b.getWorkspace(),y=(0,D.$Ob)(v.folders);if(!y)return;o.scheme!==y.uri.scheme&&o.path[0]===C.$gc.sep&&o.path[1]!==C.$gc.sep&&(o=y.uri.with({path:o.path}));const E=b.getWorkspaceFolder(o);if(!E)return;let A;if(I.isEqual(E.uri,o)?A="":A=I.relativePath(E.uri,o)??"",A&&(A=d.normalize(A)),v.folders.length>1&&!b.noPrefix){const V=E.name?E.name:I.basenameOrAuthority(E.uri);A=A?`${V} \u2022 ${A}`:V}return A}function F(o,b=L.$c){return(0,P.$jg)(o,b)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$0v=F;let S=Object.create(null);function l(o,b,p=L.OS){if(p===1||!o||!b)return o;let d=S.original===b?S.normalized:void 0;d||(d=b,L.$c&&(d=(0,P.$_f)(d)),d=`${(0,g.$4e)(d,C.$gc.sep)}${C.$gc.sep}`,S={original:b,normalized:d});let I=o;return L.$c&&(I=(0,P.$_f)(I)),(p===3?I.startsWith(d):(0,g.$kf)(I,d))?`~/${I.substr(d.length)}`:o}e.$$v=l;function w(o,b){return o.replace(/^~($|\/|\\)/,`${b}$1`)}e.$_v=w;const m="\u2026",s="\\\\",u="~";function i(o,b=C.sep){const p=new Array(o.length);let d=!1;for(let I=0;I<o.length;I++){const v=o[I];if(v===""){p[I]=`.${b}`;continue}if(!v){p[I]=v;continue}d=!0;let y="",E=v;E.indexOf(s)===0?(y=E.substr(0,E.indexOf(s)+s.length),E=E.substr(E.indexOf(s)+s.length)):E.indexOf(b)===0?(y=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length)):E.indexOf(u)===0&&(y=E.substr(0,E.indexOf(u)+u.length),E=E.substr(E.indexOf(u)+u.length));const A=E.split(b);for(let V=1;d&&V<=A.length;V++)for(let X=A.length-V;d&&X>=0;X--){d=!1;let H=A.slice(X,X+V).join(b);for(let O=0;!d&&O<o.length;O++)if(O!==I&&o[O]&&o[O].indexOf(H)>-1){const R=X+V===A.length,B=X>0&&o[O].indexOf(b)>-1?b+H:H,T=o[O].endsWith(B);d=!R||T}if(!d){let O="";(A[0].endsWith(":")||y!=="")&&(X===1&&(X=0,V++,H=A[0]+b+H),X>0&&(O=A[0]+b),O=y+O),X>0&&(O=O+m+b),O=O+H,X+V<A.length&&(O=O+b+m),p[I]=O}}d&&(p[I]=v)}return p}e.$aw=i;var r;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function n(o,b=Object.create(null)){const p=[];let d=!1,I="";for(const v of o)if(v==="$"||d&&v==="{")I&&p.push({value:I,type:r.TEXT}),I="",d=!0;else if(v==="}"&&d){const y=b[I];if(typeof y=="string")y.length&&p.push({value:y,type:r.VARIABLE});else if(y){const E=p[p.length-1];(!E||E.type!==r.SEPARATOR)&&p.push({value:y.label,type:r.SEPARATOR})}I="",d=!1}else I+=v;return I&&!d&&p.push({value:I,type:r.TEXT}),p.filter((v,y)=>{if(v.type===r.SEPARATOR){const E=p[y-1],A=p[y+1];return[E,A].every(V=>V&&(V.type===r.VARIABLE||V.type===r.TEXT)&&V.value.length>0)}return!0}).map(v=>v.value).join("")}e.$bw=n;function a(o,b){return L.$d||b?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$d?"&":"&&"):o.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.$cw=a;function h(o,b){return L.$d||b?o.replace(/\(&&\w\)|&&/g,""):L.$c?o.replace(/&&|&/g,p=>p==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$dw=h;function t(o){return o.replace(/&/g,"&&")}e.$ew=t;function $(o){if(o.endsWith("]")){const b=o.lastIndexOf(" [",o.length-2);if(b!==-1){const p=c(o.substring(0,b)),d=o.substring(b);return{name:p.name+d,parentPath:p.parentPath}}}return c(o)}e.$fw=$;function c(o){const b=o.indexOf("/")!==-1?C.$gc:C.$fc,p=b.basename(o),d=b.dirname(o);return p.length?{name:p,parentPath:d}:{name:d,parentPath:""}}}),define(Me[129],Ae([1,0,24,2]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function C(S){return S.toJSON()}class L{constructor(l){this.a=l}transformIncoming(l){const w=this.a.transformIncoming(l);return w===l?l:C(P.URI.from(w))}transformOutgoing(l){const w=this.a.transformOutgoing(l);return w===l?l:C(P.URI.from(w))}transformOutgoingURI(l){const w=this.a.transformOutgoing(l);return w===l?l:P.URI.from(w)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$en=L,e.$fn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function M(S,l,w){if(!S||w>200)return null;if(typeof S=="object"){if(S instanceof P.URI)return l.transformOutgoing(S);for(const m in S)if(Object.hasOwnProperty.call(S,m)){const s=M(S[m],l,w+1);s!==null&&(S[m]=s)}}return null}function g(S,l){const w=M(S,l,0);return w===null?S:w}e.$gn=g;function f(S,l,w,m){if(!S||m>200)return null;if(typeof S=="object"){if(S.$mid===1)return w?P.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof D.$se)return null;for(const s in S)if(Object.hasOwnProperty.call(S,s)){const u=f(S[s],l,w,m+1);u!==null&&(S[s]=u)}}return null}function k(S,l){const w=f(S,l,!1,0);return w===null?S:w}e.$hn=k;function F(S,l){const w=f(S,l,!0,0);return w===null?S:w}e.$in=F}),define(Me[34],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(C){return D.test(C)}e.$zg=P,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(g){for(let f=0;f<g.length;f++)g[f]=Math.floor(Math.random()*256);return g};const L=new Uint8Array(16),M=[];for(let g=0;g<256;g++)M.push(g.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,k="";return k+=M[L[f++]],k+=M[L[f++]],k+=M[L[f++]],k+=M[L[f++]],k+="-",k+=M[L[f++]],k+=M[L[f++]],k+="-",k+=M[L[f++]],k+=M[L[f++]],k+="-",k+=M[L[f++]],k+=M[L[f++]],k+="-",k+=M[L[f++]],k+=M[L[f++]],k+=M[L[f++]],k+=M[L[f++]],k+=M[L[f++]],k+=M[L[f++]],k}}()}),define(Me[130],Ae([1,0,18,53,34]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.$Bt=e.$At=e.$zt=void 0;function L(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$zt=L;function M(S,l,w){const m={id:(0,C.$Ag)(),name:S,uri:l,data:w};return{asString:async()=>"",asFile:()=>m,value:void 0}}e.$At=M;class g{constructor(){this.a=new Map}get size(){let l=0;for(const w of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const w=[...this.a.keys()];return P.Iterable.some(this,([m,s])=>s.asFile())&&w.push("files"),F(f(l),w)}get(l){return this.a.get(this.b(l))?.[0]}append(l,w){const m=this.a.get(l);m?m.push(w):this.a.set(this.b(l),[w])}replace(l,w){this.a.set(this.b(l),[w])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,w]of this.a)for(const m of w)yield[l,m]}b(l){return f(l)}}e.$Bt=g;function f(S){return S.toLowerCase()}function k(S,l){return F(f(S),l.map(f))}e.$Ct=k;function F(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const w=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[m,s,u]=w;return u==="*"?l.some(i=>i.startsWith(s+"/")):!1}e.$Dt=Object.freeze({create:S=>(0,D.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Dt.split(S).filter(l=>!l.startsWith("#"))})}),define(Me[131],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.StringEOL=void 0;var D;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function P(C){let L=0,M=0,g=0,f=0;for(let k=0,F=C.length;k<F;k++){const S=C.charCodeAt(k);S===13?(L===0&&(M=k),L++,k+1<F&&C.charCodeAt(k+1)===10?(f|=2,k++):f|=3,g=k+1):S===10&&(f|=1,L===0&&(M=k),L++,g=k+1)}return L===0&&(M=C.length),[L,M,C.length-g,f]}e.$Gt=P}),define(Me[132],Ae([1,0,13,21,24]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=void 0;let L;function M(){return L||(L=new TextDecoder("UTF-16LE")),L}let g;function f(){return g||(g=new TextDecoder("UTF-16BE")),g}let k;function F(){return k||(k=P.$x()?M():f()),k}e.$mt=F;function S(m,s,u){const i=new Uint16Array(m.buffer,s,u);return u>0&&(i[0]===65279||i[0]===65534)?l(m,s,u):M().decode(i)}e.$nt=S;function l(m,s,u){const i=[];let r=0;for(let n=0;n<u;n++){const a=C.$ue(m,s);s+=2,i[r++]=String.fromCharCode(a)}return i.join("")}class w{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return F().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const u=this.a-this.d;u<=1&&(u===0||D.$nf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const u=s.length;if(this.d+u>=this.a){this.f(),this.c[this.c.length]=s;return}for(let i=0;i<u;i++)this.b[this.d++]=s.charCodeAt(i)}}e.$ot=w}),define(Me[133],Ae([1,0,24,132]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=void 0;function C(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,F,S,l){this.oldPosition=k,this.oldText=F,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,F,S){const l=F.length;D.$xe(k,l,S),S+=4;for(let w=0;w<l;w++)D.$ve(k,F.charCodeAt(w),S),S+=2;return S}static d(k,F){const S=D.$we(k,F);return F+=4,(0,P.$nt)(k,F,S)}writeSize(){return 8+L.a(this.oldText)+L.a(this.newText)}write(k,F){return D.$xe(k,this.oldPosition,F),F+=4,D.$xe(k,this.newPosition,F),F+=4,F=L.c(k,this.oldText,F),F=L.c(k,this.newText,F),F}static read(k,F,S){const l=D.$we(k,F);F+=4;const w=D.$we(k,F);F+=4;const m=L.d(k,F);F+=L.a(m);const s=L.d(k,F);return F+=L.a(s),S.push(new L(l,m,w,s)),F}}e.$pt=L;function M(f,k){return f===null||f.length===0?k:new g(f,k).compress()}e.$qt=M;class g{constructor(k,F){this.a=k,this.c=F,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,F=0,S=this.n(k),l=this.l(F);for(;k<this.f||F<this.h;){if(S===null){this.k(l),l=this.l(++F);continue}if(l===null){this.m(S),S=this.n(++k);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++F);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++k);continue}if(l.oldPosition<S.newPosition){const[i,r]=g.r(l,S.newPosition-l.oldPosition);this.k(i),l=r;continue}if(S.newPosition<l.oldPosition){const[i,r]=g.q(S,l.oldPosition-S.newPosition);this.m(i),S=r;continue}let s,u;if(l.oldEnd===S.newEnd)s=S,u=l,S=this.n(++k),l=this.l(++F);else if(l.oldEnd<S.newEnd){const[i,r]=g.q(S,l.oldLength);s=i,u=l,S=r,l=this.l(++F)}else{const[i,r]=g.r(l,S.newLength);s=S,u=i,S=this.n(++k),l=r}this.d[this.e++]=new L(s.oldPosition,s.oldText,u.newPosition,u.newText),this.g+=s.newLength-s.oldLength,this.j+=u.newLength-u.oldLength}const w=g.s(this.d);return g.t(w)}k(k){this.d[this.e++]=g.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=g.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,F){return new L(F.oldPosition-k,F.oldText,F.newPosition,F.newText)}static p(k,F){return new L(F.oldPosition,F.oldText,F.newPosition+k,F.newText)}static q(k,F){const S=k.newText.substr(0,F),l=k.newText.substr(F);return[new L(k.oldPosition,k.oldText,k.newPosition,S),new L(k.oldEnd,"",k.newPosition+F,l)]}static r(k,F){const S=k.oldText.substr(0,F),l=k.oldText.substr(F);return[new L(k.oldPosition,S,k.newPosition,k.newText),new L(k.oldPosition+F,l,k.newEnd,"")]}static s(k){if(k.length===0)return k;const F=[];let S=0,l=k[0];for(let w=1;w<k.length;w++){const m=k[w];l.oldEnd===m.oldPosition?l=new L(l.oldPosition,l.oldText+m.oldText,l.newPosition,l.newText+m.newText):(F[S++]=l,l=m)}return F[S++]=l,F}static t(k){if(k.length===0)return k;const F=[];let S=0;for(let l=0;l<k.length;l++){const w=k[l];w.oldText!==w.newText&&(F[S++]=w)}return F}}}),define(Me[134],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0,e.$Es={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Me[135],Ae([1,0,33,19]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=e.$Nt=void 0;function C(M,g,f,k,F,S){if(Array.isArray(M)){let l=0;for(const w of M){const m=C(w,g,f,k,F,S);if(m===10)return m;m>l&&(l=m)}return l}else{if(typeof M=="string")return k?M==="*"?5:M===f?10:0:0;if(M){const{language:l,pattern:w,scheme:m,hasAccessToAllModels:s,notebookType:u}=M;if(!k&&!s)return 0;u&&F&&(g=F);let i=0;if(m)if(m===g.scheme)i=10;else if(m==="*")i=5;else return 0;if(l)if(l===f)i=10;else if(l==="*")i=Math.max(i,5);else return 0;if(u)if(u===S)i=10;else if(u==="*"&&S!==void 0)i=Math.max(i,5);else return 0;if(w){let r;if(typeof w=="string"?r=w:r={...w,base:(0,P.$hc)(w.base)},r===g.fsPath||(0,D.$Wj)(r,g.fsPath))i=10;else return 0}return i}else return 0}}e.$Nt=C;function L(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(L):!!M.notebookType}e.$Ot=L}),define(Me[136],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6t=e.$5t=e.IndentAction=void 0;var D;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class P{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let f=0,k=g.notIn.length;f<k;f++)switch(g.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,f){if(g.getTokenCount()===0)return!0;const k=g.findTokenIndexAtOffset(f-2),F=g.getStandardTokenType(k);return this.isOK(F)}g(g,f){for(let k=g;k<=f;k++){const F=String.fromCharCode(k);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$5t=P;class C{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of g)L(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),L(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),L(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),L(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&L(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$6t=C;function L(M,g,f){M.has(g)?M.get(g).push(f):M.set(g,[f])}}),define(Me[137],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=e.$7B=e.NodeColor=e.$6B=void 0;class D{constructor(u,i){this.piece=u,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$7B)return C(this.right);let u=this;for(;u.parent!==e.$7B&&u.parent.left!==u;)u=u.parent;return u.parent===e.$7B?e.$7B:u.parent}prev(){if(this.left!==e.$7B)return L(this.left);let u=this;for(;u.parent!==e.$7B&&u.parent.right!==u;)u=u.parent;return u.parent===e.$7B?e.$7B:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$6B=D;var P;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(P||(e.NodeColor=P={})),e.$7B=new D(null,0),e.$7B.parent=e.$7B,e.$7B.left=e.$7B,e.$7B.right=e.$7B,e.$7B.color=0;function C(s){for(;s.left!==e.$7B;)s=s.left;return s}e.$8B=C;function L(s){for(;s.right!==e.$7B;)s=s.right;return s}e.$9B=L;function M(s){return s===e.$7B?0:s.size_left+s.piece.length+M(s.right)}function g(s){return s===e.$7B?0:s.lf_left+s.piece.lineFeedCnt+g(s.right)}function f(){e.$7B.parent=e.$7B}function k(s,u){const i=u.right;i.size_left+=u.size_left+(u.piece?u.piece.length:0),i.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=i.left,i.left!==e.$7B&&(i.left.parent=u),i.parent=u.parent,u.parent===e.$7B?s.root=i:u.parent.left===u?u.parent.left=i:u.parent.right=i,i.left=u,u.parent=i}e.$0B=k;function F(s,u){const i=u.left;u.left=i.right,i.right!==e.$7B&&(i.right.parent=u),i.parent=u.parent,u.size_left-=i.size_left+(i.piece?i.piece.length:0),u.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),u.parent===e.$7B?s.root=i:u===u.parent.right?u.parent.right=i:u.parent.left=i,i.right=u,u.parent=i}e.$$B=F;function S(s,u){let i,r;if(u.left===e.$7B?(r=u,i=r.right):u.right===e.$7B?(r=u,i=r.left):(r=C(u.right),i=r.right),r===s.root){s.root=i,i.color=0,u.detach(),f(),s.root.parent=e.$7B;return}const n=r.color===1;if(r===r.parent.left?r.parent.left=i:r.parent.right=i,r===u?(i.parent=r.parent,m(s,i)):(r.parent===u?i.parent=r:i.parent=r.parent,m(s,i),r.left=u.left,r.right=u.right,r.parent=u.parent,r.color=u.color,u===s.root?s.root=r:u===u.parent.left?u.parent.left=r:u.parent.right=r,r.left!==e.$7B&&(r.left.parent=r),r.right!==e.$7B&&(r.right.parent=r),r.size_left=u.size_left,r.lf_left=u.lf_left,m(s,r)),u.detach(),i.parent.left===i){const h=M(i),t=g(i);if(h!==i.parent.size_left||t!==i.parent.lf_left){const $=h-i.parent.size_left,c=t-i.parent.lf_left;i.parent.size_left=h,i.parent.lf_left=t,w(s,i.parent,$,c)}}if(m(s,i.parent),n){f();return}let a;for(;i!==s.root&&i.color===0;)i===i.parent.left?(a=i.parent.right,a.color===1&&(a.color=0,i.parent.color=1,k(s,i.parent),a=i.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.right.color===0&&(a.left.color=0,a.color=1,F(s,a),a=i.parent.right),a.color=i.parent.color,i.parent.color=0,a.right.color=0,k(s,i.parent),i=s.root)):(a=i.parent.left,a.color===1&&(a.color=0,i.parent.color=1,F(s,i.parent),a=i.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.left.color===0&&(a.right.color=0,a.color=1,k(s,a),a=i.parent.left),a.color=i.parent.color,i.parent.color=0,a.left.color=0,F(s,i.parent),i=s.root));i.color=0,f()}e.$_B=S;function l(s,u){for(m(s,u);u!==s.root&&u.parent.color===1;)if(u.parent===u.parent.parent.left){const i=u.parent.parent.right;i.color===1?(u.parent.color=0,i.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,k(s,u)),u.parent.color=0,u.parent.parent.color=1,F(s,u.parent.parent))}else{const i=u.parent.parent.left;i.color===1?(u.parent.color=0,i.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,F(s,u)),u.parent.color=0,u.parent.parent.color=1,k(s,u.parent.parent))}s.root.color=0}e.$aC=l;function w(s,u,i,r){for(;u!==s.root&&u!==e.$7B;)u.parent.left===u&&(u.parent.size_left+=i,u.parent.lf_left+=r),u=u.parent}e.$bC=w;function m(s,u){let i=0,r=0;if(u!==s.root){for(;u!==s.root&&u===u.parent.right;)u=u.parent;if(u!==s.root)for(u=u.parent,i=M(u.left)-u.size_left,r=g(u.left)-u.lf_left,u.size_left+=i,u.lf_left+=r;u!==s.root&&(i!==0||r!==0);)u.parent.left===u&&(u.parent.size_left+=i,u.parent.lf_left+=r),u=u.parent}}e.$cC=m}),define(Me[91],Ae([1,0,92,29,93,137,94]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=void 0;const g=65535;function f(i){let r;return i[i.length-1]<65536?r=new Uint16Array(i.length):r=new Uint32Array(i.length),r.set(i,0),r}class k{constructor(r,n,a,h,t){this.lineStarts=r,this.cr=n,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function F(i,r=!0){const n=[0];let a=1;for(let h=0,t=i.length;h<t;h++){const $=i.charCodeAt(h);$===13?h+1<t&&i.charCodeAt(h+1)===10?(n[a++]=h+2,h++):n[a++]=h+1:$===10&&(n[a++]=h+1)}return r?f(n):n}e.$jC=F;function S(i,r){i.length=0,i[0]=0;let n=1,a=0,h=0,t=0,$=!0;for(let o=0,b=r.length;o<b;o++){const p=r.charCodeAt(o);p===13?o+1<b&&r.charCodeAt(o+1)===10?(t++,i[n++]=o+2,o++):(a++,i[n++]=o+1):p===10?(h++,i[n++]=o+1):$&&p!==9&&(p<32||p>126)&&($=!1)}const c=new k(f(i),a,h,t,$);return i.length=0,c}e.$kC=S;class l{constructor(r,n,a,h,t){this.bufferIndex=r,this.start=n,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$lC=l;class w{constructor(r,n){this.buffer=r,this.lineStarts=n}}e.$mC=w;class m{constructor(r,n){this.a=[],this.c=r,this.d=n,this.b=0,r.root!==L.$7B&&r.iterate(r.root,a=>(a!==L.$7B&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(r){this.a=r,this.b=[]}get(r){for(let n=this.b.length-1;n>=0;n--){const a=this.b[n];if(a.nodeStartOffset<=r&&a.nodeStartOffset+a.node.piece.length>=r)return a}return null}get2(r){for(let n=this.b.length-1;n>=0;n--){const a=this.b[n];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<r&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=r)return a}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let n=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=r){a[h]=null,n=!0;continue}}if(n){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class u{constructor(r,n,a){this.create(r,n,a)}create(r,n,a){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=L.$7B,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=a;let h=null;for(let t=0,$=r.length;t<$;t++)if(r[t].buffer.length>0){r[t].lineStarts||(r[t].lineStarts=F(r[t].buffer));const c=new l(t+1,{line:0,column:0},{line:r[t].lineStarts.length-1,column:r[t].buffer.length-r[t].lineStarts[r[t].lineStarts.length-1]},r[t].lineStarts.length-1,r[t].buffer.length);this.a.push(r[t]),h=this.S(h,c)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const n=g,a=n-Math.floor(n/3),h=a*2;let t="",$=0;const c=[];if(this.iterate(this.root,o=>{const b=this.R(o),p=b.length;if($<=a||$+p<h)return t+=b,$+=p,!0;const d=t.replace(/\r\n|\r|\n/g,r);return c.push(new w(d,F(d))),t=b,$=p,!0}),$>0){const o=t.replace(/\r\n|\r|\n/g,r);c.push(new w(o,F(o)))}this.create(c,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new m(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let n=0;return this.iterate(this.root,h=>{if(h===L.$7B)return!0;const t=this.R(h),$=t.length,c=r.G(n),o=r.G(n+$),b=r.getValueInRange2(c,o);return n+=$,t===b})}getOffsetAt(r,n){let a=0,h=this.root;for(;h!==L.$7B;)if(h.left!==L.$7B&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){a+=h.size_left;const t=this.B(h,r-h.lf_left-2);return a+=t+n-1}else r-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let n=this.root,a=0;const h=r;for(;n!==L.$7B;)if(n.size_left!==0&&n.size_left>=r)n=n.left;else if(n.size_left+n.piece.length>=r){const t=this.A(n,r-n.size_left);if(a+=n.lf_left+t.index,t.index===0){const $=this.getOffsetAt(a+1,1),c=h-$;return new D.$6s(a+1,c+1)}return new D.$6s(a+1,t.remainder+1)}else if(r-=n.size_left+n.piece.length,a+=n.lf_left+n.piece.lineFeedCnt,n.right===L.$7B){const t=this.getOffsetAt(a+1,1),$=h-r-t;return new D.$6s(a+1,$+1)}else n=n.right;return new D.$6s(1,1)}getValueInRange(r,n){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const a=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),t=this.getValueInRange2(a,h);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(r,n){if(r.node===n.node){const c=r.node,o=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);return o.substring(b+r.remainder,b+n.remainder)}let a=r.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let $=h.substring(t+r.remainder,t+a.piece.length);for(a=a.next();a!==L.$7B;){const c=this.a[a.piece.bufferIndex].buffer,o=this.u(a.piece.bufferIndex,a.piece.start);if(a===n.node){$+=c.substring(o,o+n.remainder);break}else $+=c.substr(o,a.piece.length);a=a.next()}return $}getLinesContent(){const r=[];let n=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===L.$7B)return!0;const $=t.piece;let c=$.length;if(c===0)return!0;const o=this.a[$.bufferIndex].buffer,b=this.a[$.bufferIndex].lineStarts,p=$.start.line,d=$.end.line;let I=b[p]+$.start.column;if(h&&(o.charCodeAt(I)===10&&(I++,c--),r[n++]=a,a="",h=!1,c===0))return!0;if(p===d)return!this.f&&o.charCodeAt(I+c-1)===13?(h=!0,a+=o.substr(I,c-1)):a+=o.substr(I,c),!0;a+=this.f?o.substring(I,Math.max(I,b[p+1]-this.e)):o.substring(I,b[p+1]).replace(/(\r\n|\r|\n)$/,""),r[n++]=a;for(let v=p+1;v<d;v++)a=this.f?o.substring(b[v],b[v+1]-this.e):o.substring(b[v],b[v+1]).replace(/(\r\n|\r|\n)$/,""),r[n++]=a;return!this.f&&o.charCodeAt(b[d]+$.end.column-1)===13?(h=!0,$.end.column===0?n--:a=o.substr(b[d],$.end.column-1)):a=o.substr(b[d],$.end.column),!0}),h&&(r[n++]=a,a=""),r[n++]=a,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const n=r.node.next();if(!n)return 0;const a=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start);return a.buffer.charCodeAt(h)}else{const n=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return n.buffer.charCodeAt(h)}}getLineCharCode(r,n){const a=this.H(r,n+1);return this.l(a)}getLineLength(r){if(r===this.getLineCount()){const n=this.getOffsetAt(r,1);return this.getLength()-n}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const n=this.G(r);return this.l(n)}findMatchesInNode(r,n,a,h,t,$,c,o,b,p,d){const I=this.a[r.piece.bufferIndex],v=this.u(r.piece.bufferIndex,r.piece.start),y=this.u(r.piece.bufferIndex,t),E=this.u(r.piece.bufferIndex,$);let A;const V={line:0,column:0};let X,H;n._wordSeparators?(X=I.buffer.substring(y,E),H=O=>O+y,n.reset(0)):(X=I.buffer,H=O=>O,n.reset(y));do if(A=n.next(X),A){if(H(A.index)>=E)return p;this.s(r,H(A.index)-v,V);const O=this.t(r.piece.bufferIndex,t,V),R=V.line===t.line?V.column-t.column+h:V.column+1,B=R+A[0].length;if(d[p++]=(0,M.$fC)(new P.$7s(a+O,R,a+O,B),A,o),H(A.index)+A[0].length>=E||p>=b)return p}while(A);return p}findMatchesLineByLine(r,n,a,h){const t=[];let $=0;const c=new M.$iC(n.wordSeparators,n.regex);let o=this.H(r.startLineNumber,r.startColumn);if(o===null)return[];const b=this.H(r.endLineNumber,r.endColumn);if(b===null)return[];let p=this.s(o.node,o.remainder);const d=this.s(b.node,b.remainder);if(o.node===b.node)return this.findMatchesInNode(o.node,c,r.startLineNumber,r.startColumn,p,d,n,a,h,$,t),t;let I=r.startLineNumber,v=o.node;for(;v!==b.node;){const E=this.t(v.piece.bufferIndex,p,v.piece.end);if(E>=1){const V=this.a[v.piece.bufferIndex].lineStarts,X=this.u(v.piece.bufferIndex,v.piece.start),H=V[p.line+E],O=I===r.startLineNumber?r.startColumn:1;if($=this.findMatchesInNode(v,c,I,O,p,this.s(v,H-X),n,a,h,$,t),$>=h)return t;I+=E}const A=I===r.startLineNumber?r.startColumn-1:0;if(I===r.endLineNumber){const V=this.getLineContent(I).substring(A,r.endColumn-1);return $=this.n(n,c,V,r.endLineNumber,A,$,t,a,h),t}if($=this.n(n,c,this.getLineContent(I).substr(A),I,A,$,t,a,h),$>=h)return t;I++,o=this.H(I,1),v=o.node,p=this.s(o.node,o.remainder)}if(I===r.endLineNumber){const E=I===r.startLineNumber?r.startColumn-1:0,A=this.getLineContent(I).substring(E,r.endColumn-1);return $=this.n(n,c,A,r.endLineNumber,E,$,t,a,h),t}const y=I===r.startLineNumber?r.startColumn:1;return $=this.findMatchesInNode(b.node,c,I,y,p,d,n,a,h,$,t),t}n(r,n,a,h,t,$,c,o,b){const p=r.wordSeparators;if(!o&&r.simpleSearch){const I=r.simpleSearch,v=I.length,y=a.length;let E=-v;for(;(E=a.indexOf(I,E+v))!==-1;)if((!p||(0,M.$hC)(p,a,y,E,v))&&(c[$++]=new C.$nv(new P.$7s(h,E+1+t,h,E+1+v+t),null),$>=b))return $;return $}let d;n.reset(0);do if(d=n.next(a),d&&(c[$++]=(0,M.$fC)(new P.$7s(h,d.index+1+t,h,d.index+1+d[0].length+t),d,o),$>=b))return $;while(d);return $}insert(r,n,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==L.$7B){const{node:h,remainder:t,nodeStartOffset:$}=this.G(r),c=h.piece,o=c.bufferIndex,b=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&$+c.length===r&&n.length<g){this.F(h,n),this.y();return}if($===r)this.o(n,h),this.h.validate(r);else if($+h.piece.length>r){const p=[];let d=new l(c.bufferIndex,b,c.end,this.t(c.bufferIndex,b,c.end),this.u(o,c.end)-this.u(o,b));if(this.K()&&this.M(n)&&this.I(h,t)===10){const E={line:d.start.line+1,column:0};d=new l(d.bufferIndex,E,d.end,this.t(d.bufferIndex,E,d.end),d.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(h,t-1)===13){const E=this.s(h,t-1);this.C(h,E),n="\r"+n,h.piece.length===0&&p.push(h)}else this.C(h,b);else this.C(h,b);const I=this.w(n);d.length>0&&this.S(h,d);let v=h;for(let y=0;y<I.length;y++)v=this.S(v,I[y]);this.v(p)}else this.q(n,h)}else{const h=this.w(n);let t=this.T(null,h[0]);for(let $=1;$<h.length;$++)t=this.S(t,h[$])}this.y()}delete(r,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===L.$7B)return;const a=this.G(r),h=this.G(r+n),t=a.node,$=h.node;if(t===$){const I=this.s(t,a.remainder),v=this.s(t,h.remainder);if(a.nodeStartOffset===r){if(n===t.piece.length){const y=t.next();(0,L.$_B)(this,t),this.N(y),this.y();return}this.D(t,v),this.h.validate(r),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===r+n){this.C(t,I),this.O(t),this.y();return}this.E(t,I,v),this.y();return}const c=[],o=this.s(t,a.remainder);this.C(t,o),this.h.validate(r),t.piece.length===0&&c.push(t);const b=this.s($,h.remainder);this.D($,b),$.piece.length===0&&c.push($);const p=t.next();for(let I=p;I!==L.$7B&&I!==$;I=I.next())c.push(I);const d=t.piece.length===0?t.prev():t;this.v(c),this.O(d),this.y()}o(r,n){const a=[];if(this.K()&&this.M(r)&&this.L(n)){const $=n.piece,c={line:$.start.line+1,column:0},o=new l($.bufferIndex,c,$.end,this.t($.bufferIndex,c,$.end),$.length-1);n.piece=o,r+=`
`,(0,L.$bC)(this,n,-1,-1),n.piece.length===0&&a.push(n)}const h=this.w(r);let t=this.T(n,h[h.length-1]);for(let $=h.length-2;$>=0;$--)t=this.T(t,h[$]);this.N(t),this.v(a)}q(r,n){this.Q(r,n)&&(r+=`
`);const a=this.w(r),h=this.S(n,a[0]);let t=h;for(let $=1;$<a.length;$++)t=this.S(t,a[$]);this.N(h)}s(r,n,a){const h=r.piece,t=r.piece.bufferIndex,$=this.a[t].lineStarts,o=$[h.start.line]+h.start.column+n;let b=h.start.line,p=h.end.line,d=0,I=0,v=0;for(;b<=p&&(d=b+(p-b)/2|0,v=$[d],d!==p);)if(I=$[d+1],o<v)p=d-1;else if(o>=I)b=d+1;else break;return a?(a.line=d,a.column=o-v,null):{line:d,column:o-v}}t(r,n,a){if(a.column===0)return a.line-n.line;const h=this.a[r].lineStarts;if(a.line===h.length-1)return a.line-n.line;const t=h[a.line+1],$=h[a.line]+a.column;if(t>$+1)return a.line-n.line;const c=$-1;return this.a[r].buffer.charCodeAt(c)===13?a.line-n.line+1:a.line-n.line}u(r,n){return this.a[r].lineStarts[n.line]+n.column}v(r){for(let n=0;n<r.length;n++)(0,L.$_B)(this,r[n])}w(r){if(r.length>g){const p=[];for(;r.length>g;){const I=r.charCodeAt(g-1);let v;I===13||I>=55296&&I<=56319?(v=r.substring(0,g-1),r=r.substring(g-1)):(v=r.substring(0,g),r=r.substring(g));const y=F(v);p.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:v.length-y[y.length-1]},y.length-1,v.length)),this.a.push(new w(v,y))}const d=F(r);return p.push(new l(this.a.length,{line:0,column:0},{line:d.length-1,column:r.length-d[d.length-1]},d.length-1,r.length)),this.a.push(new w(r,d)),p}let n=this.a[0].buffer.length;const a=F(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let p=0;p<a.length;p++)a[p]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+r,n+=1}else{if(n!==0)for(let p=0;p<a.length;p++)a[p]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=r}const t=this.a[0].buffer.length,$=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[$],o={line:$,column:c},b=new l(0,h,o,this.t(0,h,o),t-n);return this.g=o,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,n=0){let a=this.root,h="";const t=this.h.get2(r);if(t){a=t.node;const $=this.B(a,r-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,o=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===r)h=c.substring(o+$,o+a.piece.length);else{const b=this.B(a,r-t.nodeStartLineNumber);return c.substring(o+$,o+b-n)}}else{let $=0;const c=r;for(;a!==L.$7B;)if(a.left!==L.$7B&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const o=this.B(a,r-a.lf_left-2),b=this.B(a,r-a.lf_left-1),p=this.a[a.piece.bufferIndex].buffer,d=this.u(a.piece.bufferIndex,a.piece.start);return $+=a.size_left,this.h.set({node:a,nodeStartOffset:$,nodeStartLineNumber:c-(r-1-a.lf_left)}),p.substring(d+o,d+b-n)}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const o=this.B(a,r-a.lf_left-2),b=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);h=b.substring(p+o,p+a.piece.length);break}else r-=a.lf_left+a.piece.lineFeedCnt,$+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==L.$7B;){const $=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),o=this.u(a.piece.bufferIndex,a.piece.start);return h+=$.substring(o,o+c-n),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=$.substr(c,a.piece.length)}a=a.next()}return h}y(){let r=this.root,n=1,a=0;for(;r!==L.$7B;)n+=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;this.b=n,this.c=a,this.h.validate(this.c)}A(r,n){const a=r.piece,h=this.s(r,n),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===n){const $=this.t(r.piece.bufferIndex,a.start,h);if($!==t)return{index:$,remainder:0}}return{index:t,remainder:h.column}}B(r,n){if(n<0)return 0;const a=r.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+n+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(r,n){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),$=n,c=this.u(a.bufferIndex,$),o=this.t(a.bufferIndex,a.start,$),b=o-h,p=c-t,d=a.length+p;r.piece=new l(a.bufferIndex,a.start,$,o,d),(0,L.$bC)(this,r,p,b)}D(r,n){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),$=n,c=this.t(a.bufferIndex,$,a.end),o=this.u(a.bufferIndex,$),b=c-h,p=t-o,d=a.length+p;r.piece=new l(a.bufferIndex,$,a.end,c,d),(0,L.$bC)(this,r,p,b)}E(r,n,a){const h=r.piece,t=h.start,$=h.end,c=h.length,o=h.lineFeedCnt,b=n,p=this.t(h.bufferIndex,h.start,b),d=this.u(h.bufferIndex,n)-this.u(h.bufferIndex,t);r.piece=new l(h.bufferIndex,h.start,b,p,d),(0,L.$bC)(this,r,d-c,p-o);const I=new l(h.bufferIndex,a,$,this.t(h.bufferIndex,a,$),this.u(h.bufferIndex,$)-this.u(h.bufferIndex,a)),v=this.S(r,I);this.N(v)}F(r,n){this.Q(n,r)&&(n+=`
`);const a=this.K()&&this.L(n)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=n;const t=F(n,!1);for(let v=0;v<t.length;v++)t[v]+=h;if(a){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const $=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[$],o={line:$,column:c},b=r.piece.length+n.length,p=r.piece.lineFeedCnt,d=this.t(0,r.piece.start,o),I=d-p;r.piece=new l(r.piece.bufferIndex,r.piece.start,o,d,b),this.g=o,(0,L.$bC)(this,r,n.length,I)}G(r){let n=this.root;const a=this.h.get(r);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:r-a.nodeStartOffset};let h=0;for(;n!==L.$7B;)if(n.size_left>r)n=n.left;else if(n.size_left+n.piece.length>=r){h+=n.size_left;const t={node:n,remainder:r-n.size_left,nodeStartOffset:h};return this.h.set(t),t}else r-=n.size_left+n.piece.length,h+=n.size_left+n.piece.length,n=n.right;return null}H(r,n){let a=this.root,h=0;for(;a!==L.$7B;)if(a.left!==L.$7B&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const t=this.B(a,r-a.lf_left-2),$=this.B(a,r-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+n-1,$),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const t=this.B(a,r-a.lf_left-2);if(t+n-1<=a.piece.length)return{node:a,remainder:t+n-1,nodeStartOffset:h};n-=a.piece.length-t;break}else r-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==L.$7B;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),$=this.J(a);return{node:a,remainder:Math.min(n-1,t),nodeStartOffset:$}}else if(a.piece.length>=n-1){const t=this.J(a);return{node:a,remainder:n-1,nodeStartOffset:t}}else n-=a.piece.length;a=a.next()}return null}I(r,n){if(r.piece.lineFeedCnt<1)return-1;const a=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+n;return a.buffer.charCodeAt(h)}J(r){if(!r)return 0;let n=r.size_left;for(;r!==this.root;)r.parent.right===r&&(n+=r.parent.size_left+r.parent.piece.length),r=r.parent;return n}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===L.$7B||r.piece.lineFeedCnt===0)return!1;const n=r.piece,a=this.a[n.bufferIndex].lineStarts,h=n.start.line,t=a[h]+n.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===L.$7B||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const n=r.prev();this.M(n)&&this.P(n,r)}}O(r){if(this.K()&&this.M(r)){const n=r.next();this.L(n)&&this.P(r,n)}}P(r,n){const a=[],h=this.a[r.piece.bufferIndex].lineStarts;let t;r.piece.end.column===0?t={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:t={line:r.piece.end.line,column:r.piece.end.column-1};const $=r.piece.length-1,c=r.piece.lineFeedCnt-1;r.piece=new l(r.piece.bufferIndex,r.piece.start,t,c,$),(0,L.$bC)(this,r,-1,-1),r.piece.length===0&&a.push(r);const o={line:n.piece.start.line+1,column:0},b=n.piece.length-1,p=this.t(n.piece.bufferIndex,o,n.piece.end);n.piece=new l(n.piece.bufferIndex,o,n.piece.end,p,b),(0,L.$bC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const d=this.w(`\r
`);this.S(r,d[0]);for(let I=0;I<a.length;I++)(0,L.$_B)(this,a[I])}Q(r,n){if(this.K()&&this.M(r)){const a=n.next();if(this.L(a)){if(r+=`
`,a.piece.length===1)(0,L.$_B)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},$=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new l(h.bufferIndex,t,h.end,c,$),(0,L.$bC)(this,a,-1,-1)}return!0}}return!1}iterate(r,n){if(r===L.$7B)return n(L.$7B);const a=this.iterate(r.left,n);return a&&n(r)&&this.iterate(r.right,n)}R(r){if(r===L.$7B)return"";const n=this.a[r.piece.bufferIndex],a=r.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return n.buffer.substring(h,t)}getPieceContent(r){const n=this.a[r.bufferIndex],a=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return n.buffer.substring(a,h)}S(r,n){const a=new L.$6B(n,1);if(a.left=L.$7B,a.right=L.$7B,a.parent=L.$7B,a.size_left=0,a.lf_left=0,this.root===L.$7B)this.root=a,a.color=0;else if(r.right===L.$7B)r.right=a,a.parent=r;else{const t=(0,L.$8B)(r.right);t.left=a,a.parent=t}return(0,L.$aC)(this,a),a}T(r,n){const a=new L.$6B(n,1);if(a.left=L.$7B,a.right=L.$7B,a.parent=L.$7B,a.size_left=0,a.lf_left=0,this.root===L.$7B)this.root=a,a.color=0;else if(r.left===L.$7B)r.left=a,a.parent=r;else{const h=(0,L.$9B)(r.left);h.right=a,a.parent=h}return(0,L.$aC)(this,a),a}U(r){let n="";return this.iterate(r,a=>(n+=this.R(a),!0)),n}}e.$nC=u}),define(Me[138],Ae([1,0,5,13,29,93,91,131,133,6]),function(x,e,D,P,C,L,M,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=void 0;class F extends k.$Tc{constructor(l,w,m,s,u,i,r){super(),this.m=this.B(new D.$5d),this.onDidChangeContent=this.m.event,this.f=w,this.j=!i,this.g=s,this.h=u,this.c=new M.$nC(l,m,r)}equals(l){return!(l instanceof F)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,w){return this.c.getOffsetAt(l,w)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,w){const m=l+w,s=this.getPositionAt(l),u=this.getPositionAt(m);return new C.$7s(s.lineNumber,s.column,u.lineNumber,u.column)}getValueInRange(l,w=0){if(l.isEmpty())return"";const m=this.n(w);return this.c.getValueInRange(l,m)}getValueLengthInRange(l,w=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const m=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let u=0;const i=this.n(w),r=this.getEOL();if(i.length!==r.length){const n=i.length-r.length,a=l.endLineNumber-l.startLineNumber;u=n*a}return s-m+u}getCharacterCountInRange(l,w=0){if(this.j){let m=0;const s=l.startLineNumber,u=l.endLineNumber;for(let i=s;i<=u;i++){const r=this.getLineContent(i),n=i===s?l.startColumn-1:0,a=i===u?l.endColumn-1:r.length;for(let h=n;h<a;h++)P.$nf(r.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(w).length*(u-s),m}return this.getValueLengthInRange(l,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,w){return this.c.getLineCharCode(l,w)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const w=P.$$e(this.getLineContent(l));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(l){const w=P.$af(this.getLineContent(l));return w===-1?0:w+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,w,m){let s=this.g,u=this.h,i=this.j,r=!0,n=[];for(let b=0;b<l.length;b++){const p=l[b];r&&p._isTracked&&(r=!1);const d=p.range;if(p.text){let A=!0;i||(A=!P.$yf(p.text),i=A),!s&&A&&(s=P.$xf(p.text)),!u&&A&&(u=P.$Af(p.text))}let I="",v=0,y=0,E=0;if(p.text){let A;[v,y,E,A]=(0,g.$Gt)(p.text);const V=this.getEOL();A===0||A===(V===`\r
`?2:1)?I=p.text:I=p.text.replace(/\r\n|\r|\n/g,V)}n[b]={sortIndex:b,identifier:p.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),text:I,eolCount:v,firstLineLength:y,lastLineLength:E,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}n.sort(F.u);let a=!1;for(let b=0,p=n.length-1;b<p;b++){const d=n[b].range.getEndPosition(),I=n[b+1].range.getStartPosition();if(I.isBeforeOrEqual(d)){if(I.isBefore(d))throw new Error("Overlapping ranges are not allowed!");a=!0}}r&&(n=this.s(n));const h=m||w?F._getInverseEditRanges(n):[],t=[];if(w)for(let b=0;b<n.length;b++){const p=n[b],d=h[b];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let I=d.startLineNumber;I<=d.endLineNumber;I++){let v="";I===d.startLineNumber&&(v=this.getLineContent(p.range.startLineNumber),P.$$e(v)!==-1)||t.push({lineNumber:I,oldContent:v})}}let $=null;if(m){let b=0;$=[];for(let p=0;p<n.length;p++){const d=n[p],I=h[p],v=this.getValueInRange(d.range),y=d.rangeOffset+b;b+=d.text.length-v.length,$[p]={sortIndex:d.sortIndex,identifier:d.identifier,range:I,text:v,textChange:new f.$pt(d.rangeOffset,v,y,d.text)}}a||$.sort((p,d)=>p.sortIndex-d.sortIndex)}this.g=s,this.h=u,this.j=i;const c=this.t(n);let o=null;if(w&&t.length>0){t.sort((b,p)=>p.lineNumber-b.lineNumber),o=[];for(let b=0,p=t.length;b<p;b++){const d=t[b].lineNumber;if(b>0&&t[b-1].lineNumber===d)continue;const I=t[b].oldContent,v=this.getLineContent(d);v.length===0||v===I||P.$$e(v)!==-1||o.push(d)}}return this.m.fire(),new L.$rv($,c,o)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let w=!1;const m=l[0].range,s=l[l.length-1].range,u=new C.$7s(m.startLineNumber,m.startColumn,s.endLineNumber,s.endColumn);let i=m.startLineNumber,r=m.startColumn;const n=[];for(let c=0,o=l.length;c<o;c++){const b=l[c],p=b.range;w=w||b.forceMoveMarkers,n.push(this.getValueInRange(new C.$7s(i,r,p.startLineNumber,p.startColumn))),b.text.length>0&&n.push(b.text),i=p.endLineNumber,r=p.endColumn}const a=n.join(""),[h,t,$]=(0,g.$Gt)(a);return{sortIndex:0,identifier:l[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:$,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(l){l.sort(F.w);const w=[];for(let m=0;m<l.length;m++){const s=l[m],u=s.range.startLineNumber,i=s.range.startColumn,r=s.range.endLineNumber,n=s.range.endColumn;if(u===r&&i===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const a=new C.$7s(u,i,r,n);w.push({range:a,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return w}findMatchesLineByLine(l,w,m,s){return this.c.findMatchesLineByLine(l,w,m,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,w){const m=l.startLineNumber,s=l.startColumn,[u,i,r]=(0,g.$Gt)(w);let n;if(w.length>0){const a=u+1;a===1?n=new C.$7s(m,s,m,s+i):n=new C.$7s(m,s,m+a-1,r+1)}else n=new C.$7s(m,s,m,s);return n}static _getInverseEditRanges(l){const w=[];let m=0,s=0,u=null;for(let i=0,r=l.length;i<r;i++){const n=l[i];let a,h;u?u.range.endLineNumber===n.range.startLineNumber?(a=m,h=s+(n.range.startColumn-u.range.endColumn)):(a=m+(n.range.startLineNumber-u.range.endLineNumber),h=n.range.startColumn):(a=n.range.startLineNumber,h=n.range.startColumn);let t;if(n.text.length>0){const $=n.eolCount+1;$===1?t=new C.$7s(a,h,a,h+n.firstLineLength):t=new C.$7s(a,h,a+$-1,n.lastLineLength+1)}else t=new C.$7s(a,h,a,h);m=t.endLineNumber,s=t.endColumn,w.push(t),u=n}return w}static u(l,w){const m=C.$7s.compareRangesUsingEnds(l.range,w.range);return m===0?l.sortIndex-w.sortIndex:m}static w(l,w){const m=C.$7s.compareRangesUsingEnds(l.range,w.range);return m===0?w.sortIndex-l.sortIndex:-m}}e.$oC=F}),define(Me[139],Ae([1,0,13,91,138]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pC=void 0;class L{constructor(f,k,F,S,l,w,m,s,u){this.a=f,this.b=k,this.c=F,this.d=S,this.e=l,this.f=w,this.g=m,this.h=s,this.j=u}k(f){const k=this.c+this.d+this.e,F=this.c+this.e;return k===0?f===1?`
`:`\r
`:F>k/2?`\r
`:`
`}create(f){const k=this.k(f),F=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let l=0,w=F.length;l<w;l++){const m=F[l].buffer.replace(/\r\n|\r|\n/g,k),s=(0,P.$jC)(m);F[l]=new P.$mC(m,s)}const S=new C.$oC(F,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&D.$Gf(f)&&(this.b=D.$Ff,f=f.substr(1));const k=f.charCodeAt(f.length-1);k===13||k>=55296&&k<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=k):(this.m(f,!1),this.c=!1,this.d=k)}m(f,k){!k&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const k=(0,P.$kC)(this.e,f);this.a.push(new P.$mC(f,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=D.$xf(f)),this.k||(this.k=D.$Af(f)))}finish(f=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const k=(0,P.$jC)(f.buffer);f.lineStarts=k,this.d===13&&this.f++}}}e.$pC=M}),define(Me[95],Ae([1,0,24,21]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cab=e.$bab=void 0;var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function L(S){for(let l=0,w=S.length;l<w;l+=4){const m=S[l+0],s=S[l+1],u=S[l+2],i=S[l+3];S[l+0]=i,S[l+1]=u,S[l+2]=s,S[l+3]=m}}function M(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return P.$x()||L(l),D.$se.wrap(l)}function g(S){const l=S.buffer;if(P.$x()||L(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function f(S){const l=new Uint32Array(k(S));let w=0;if(l[w++]=S.id,S.type==="full")l[w++]=1,l[w++]=S.data.length,l.set(S.data,w),w+=S.data.length;else{l[w++]=2,l[w++]=S.deltas.length;for(const m of S.deltas)l[w++]=m.start,l[w++]=m.deleteCount,m.data?(l[w++]=m.data.length,l.set(m.data,w),w+=m.data.length):l[w++]=0}return M(l)}e.$bab=f;function k(S){let l=0;if(l+=2,S.type==="full")l+=1+S.data.length;else{l+=1,l+=3*S.deltas.length;for(const w of S.deltas)w.data&&(l+=w.data.length)}return l}function F(S){const l=g(S);let w=0;const m=l[w++];if(l[w++]===1){const r=l[w++],n=l.subarray(w,w+r);return w+=r,{id:m,type:"full",data:n}}const u=l[w++],i=[];for(let r=0;r<u;r++){const n=l[w++],a=l[w++],h=l[w++];let t;h>0&&(t=l.subarray(w,w+h),w+=h),i[r]={start:n,deleteCount:a,data:t}}return{id:m,type:"delta",deltas:i}}e.$cab=F}),define(Me[140],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9=e.$I9=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const M=this.a.get(L);return this.a.delete(L),M}}addDragOperationTransfer(L,M){this.a.set(L,M)}}e.$I9=D;class P{constructor(L){this.identifier=L}}e.$J9=P}),define(Me[141],Ae([9,10]),function(x,e){return x.create("vs/base/common/actions",e)}),define(Me[142],Ae([1,0,5,6,141]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;class L extends P.$Tc{constructor(l,w="",m="",s=!0,u){super(),this.h=this.B(new D.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=w,this.u=m,this.w=s,this.C=u}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,w){this.C&&await this.C(l)}}e.$Vi=L;class M extends P.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$5d),this.onWillRun=this.f.event,this.m=this.B(new D.$5d),this.onDidRun=this.m.event}async run(l,w){if(!l.enabled)return;this.f.fire({action:l});let m;try{await this.u(l,w)}catch(s){m=s}this.m.fire({action:l,error:m})}async u(l,w){await l.run(w)}}e.$Wi=M;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let w=[];for(const m of l)m.length&&(w.length?w=[...w,new g,...m]:w=m);return w}async run(){}}e.$Xi=g,g.ID="vs.actions.separator";class f{get actions(){return this.a}constructor(l,w,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=w,this.class=s,this.a=m}async run(){}}e.$Yi=f;class k extends L{constructor(){super(k.ID,C.localize(0,null),void 0,!1)}}e.$Zi=k,k.ID="vs.actions.empty";function F(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...l)=>S.run(...l),tooltip:S.label}}e.$1i=F}),define(Me[143],Ae([9,10]),function(x,e){return x.create("vs/base/common/date",e)}),define(Me[144],Ae([1,0,143]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0;const P=60,C=P*60,L=C*24,M=L*7,g=L*30,f=L*365;function k(l,w,m,s){typeof l!="number"&&(l=l.getTime());const u=Math.round((new Date().getTime()-l)/1e3);if(u<-30)return(0,D.localize)(0,null,k(new Date().getTime()+u*1e3,!1));if(!s&&u<30)return(0,D.localize)(1,null);let i;return u<P?(i=u,w?i===1?m?(0,D.localize)(2,null,i):(0,D.localize)(3,null,i):m?(0,D.localize)(4,null,i):(0,D.localize)(5,null,i):i===1?m?(0,D.localize)(6,null,i):(0,D.localize)(7,null,i):m?(0,D.localize)(8,null,i):(0,D.localize)(9,null,i)):u<C?(i=Math.floor(u/P),w?i===1?m?(0,D.localize)(10,null,i):(0,D.localize)(11,null,i):m?(0,D.localize)(12,null,i):(0,D.localize)(13,null,i):i===1?m?(0,D.localize)(14,null,i):(0,D.localize)(15,null,i):m?(0,D.localize)(16,null,i):(0,D.localize)(17,null,i)):u<L?(i=Math.floor(u/C),w?i===1?m?(0,D.localize)(18,null,i):(0,D.localize)(19,null,i):m?(0,D.localize)(20,null,i):(0,D.localize)(21,null,i):i===1?m?(0,D.localize)(22,null,i):(0,D.localize)(23,null,i):m?(0,D.localize)(24,null,i):(0,D.localize)(25,null,i)):u<M?(i=Math.floor(u/L),w?i===1?(0,D.localize)(26,null,i):(0,D.localize)(27,null,i):i===1?(0,D.localize)(28,null,i):(0,D.localize)(29,null,i)):u<g?(i=Math.floor(u/M),w?i===1?m?(0,D.localize)(30,null,i):(0,D.localize)(31,null,i):m?(0,D.localize)(32,null,i):(0,D.localize)(33,null,i):i===1?m?(0,D.localize)(34,null,i):(0,D.localize)(35,null,i):m?(0,D.localize)(36,null,i):(0,D.localize)(37,null,i)):u<f?(i=Math.floor(u/g),w?i===1?m?(0,D.localize)(38,null,i):(0,D.localize)(39,null,i):m?(0,D.localize)(40,null,i):(0,D.localize)(41,null,i):i===1?m?(0,D.localize)(42,null,i):(0,D.localize)(43,null,i):m?(0,D.localize)(44,null,i):(0,D.localize)(45,null,i)):(i=Math.floor(u/f),w?i===1?m?(0,D.localize)(46,null,i):(0,D.localize)(47,null,i):m?(0,D.localize)(48,null,i):(0,D.localize)(49,null,i):i===1?m?(0,D.localize)(50,null,i):(0,D.localize)(51,null,i):m?(0,D.localize)(52,null,i):(0,D.localize)(53,null,i))}e.$Hm=k;function F(l,w){const m=Math.abs(l/1e3);return m<1?w?(0,D.localize)(54,null,l):(0,D.localize)(55,null,l):m<P?w?(0,D.localize)(56,null,Math.round(l)/1e3):(0,D.localize)(57,null,Math.round(l)/1e3):m<C?w?(0,D.localize)(58,null,Math.round(l/(1e3*P))):(0,D.localize)(59,null,Math.round(l/(1e3*P))):m<L?w?(0,D.localize)(60,null,Math.round(l/(1e3*C))):(0,D.localize)(61,null,Math.round(l/(1e3*C))):(0,D.localize)(62,null,Math.round(l/(1e3*L)))}e.$Im=F;function S(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Jm=S}),define(Me[145],Ae([9,10]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Me[35],Ae([1,0,18,16,145]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function L(S,l){return l&&(S.stack||S.stacktrace)?C.localize(0,null,g(S),M(S.stack)||M(S.stacktrace)):g(S)}function M(S){return Array.isArray(S)?S.join(`
`):S}function g(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(1,null,S.message):S.message||C.localize(2,null)}function f(S=null,l=!1){if(!S)return C.localize(3,null);if(Array.isArray(S)){const w=D.$Hb(S),m=f(w[0],l);return w.length>1?C.localize(4,null,m,w.length):m}if(P.$Sf(S))return S;if(S.detail){const w=S.detail;if(w.error)return L(w.error,l);if(w.exception)return L(w.exception,l)}return S.stack?L(S,l):S.message?S.message:C.localize(5,null)}e.$2i=f;function k(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}e.$3i=k;function F(S,l){let w;return typeof S=="string"?w=new Error(S):w=S,w.actions=l,w}e.$4i=F}),define(Me[146],Ae([9,10]),function(x,e){return x.create("vs/editor/common/config/editorOptions",e)}),define(Me[147],Ae([1,0,18,26,21,134,148,146]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class S{constructor(Z,Ee,qe,Ye){this.id=Z,this.name=Ee,this.defaultValue=qe,this.schema=Ye}applyUpdate(Z,Ee){return w(Z,Ee)}compute(Z,Ee,qe){return qe}}class l{constructor(Z,Ee){this.newValue=Z,this.didChange=Ee}}e.ApplyUpdateResult=l;function w(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new l(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const qe=Array.isArray(_)&&Array.isArray(Z)&&D.$ub(_,Z);return new l(Z,!qe)}let Ee=!1;for(const qe in Z)if(Z.hasOwnProperty(qe)){const Ye=w(_[qe],Z[qe]);Ye.didChange&&(_[qe]=Ye.newValue,Ee=!0)}return new l(_,Ee)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,Ee){return w(Z,Ee)}validate(Z){return this.defaultValue}}class s{constructor(Z,Ee,qe,Ye){this.id=Z,this.name=Ee,this.defaultValue=qe,this.schema=Ye}applyUpdate(Z,Ee){return w(Z,Ee)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,Ee,qe){return qe}}function u(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=u;class i extends s{constructor(Z,Ee,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=qe),super(Z,Ee,qe,Ye)}validate(Z){return u(Z,this.defaultValue)}}function r(_,Z,Ee,qe){if(typeof _>"u")return Z;let Ye=parseInt(_,10);return isNaN(Ye)?Z:(Ye=Math.max(Ee,Ye),Ye=Math.min(qe,Ye),Ye|0)}e.clampedInt=r;class n extends s{static clampedInt(Z,Ee,qe,Ye){return r(Z,Ee,qe,Ye)}constructor(Z,Ee,qe,Ye,ut,Oe=void 0){typeof Oe<"u"&&(Oe.type="integer",Oe.default=qe,Oe.minimum=Ye,Oe.maximum=ut),super(Z,Ee,qe,Oe),this.minimum=Ye,this.maximum=ut}validate(Z){return n.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function a(_,Z,Ee,qe){if(typeof _>"u")return Z;const Ye=h.float(_,Z);return h.clamp(Ye,Ee,qe)}e.clampedFloat=a;class h extends s{static clamp(Z,Ee,qe){return Z<Ee?Ee:Z>qe?qe:Z}static float(Z,Ee){if(typeof Z=="number")return Z;if(typeof Z>"u")return Ee;const qe=parseFloat(Z);return isNaN(qe)?Ee:qe}constructor(Z,Ee,qe,Ye,ut){typeof ut<"u"&&(ut.type="number",ut.default=qe),super(Z,Ee,qe,ut),this.validationFn=Ye}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class t extends s{static string(Z,Ee){return typeof Z!="string"?Ee:Z}constructor(Z,Ee,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=qe),super(Z,Ee,qe,Ye)}validate(Z){return t.string(Z,this.defaultValue)}}function $(_,Z,Ee,qe){return typeof _!="string"?Z:qe&&_ in qe?qe[_]:Ee.indexOf(_)===-1?Z:_}e.stringSet=$;class c extends s{constructor(Z,Ee,qe,Ye,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=Ye,ut.default=qe),super(Z,Ee,qe,ut),this.c=Ye}validate(Z){return $(Z,this.defaultValue,this.c)}}class o extends S{constructor(Z,Ee,qe,Ye,ut,Oe,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ut,It.default=Ye),super(Z,Ee,qe,It),this.c=ut,this.d=Oe}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function b(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,Ee,qe){return qe===0?Z.accessibilitySupport:qe}}class d extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:g.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{insertSpace:u(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function v(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function E(_){switch(_){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function A(_){switch(_){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class V extends m{constructor(){super(141)}compute(Z,Ee,qe){const Ye=["monaco-editor"];return Ee.get(39)&&Ye.push(Ee.get(39)),Z.extraEditorClassName&&Ye.push(Z.extraEditorClassName),Ee.get(74)==="default"?Ye.push("mouse-default"):Ee.get(74)==="copy"&&Ye.push("mouse-copy"),Ee.get(111)&&Ye.push("showUnused"),Ee.get(139)&&Ye.push("showDeprecated"),Ye.join(" ")}}class X extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(Z,Ee,qe){return qe&&Z.emptySelectionClipboard}}class H extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:g.localize(16,null),included:C.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:g.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{cursorMoveOnType:u(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":$(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":$(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ee.loop,this.defaultValue.loop)}}}class O extends S{constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?O.OFF:Z==="true"?O.ON:Z:Z?O.ON:O.OFF}}e.EditorFontLigatures=O,O.OFF='"liga" off, "calt" off',O.ON='"liga" on, "calt" on';class R extends S{constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.TRANSLATE:Z:Z?R.TRANSLATE:R.OFF}compute(Z,Ee,qe){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=R,R.OFF="normal",R.TRANSLATE="translate";class B extends m{constructor(){super(50)}compute(Z,Ee,qe){return Z.fontInfo}}class T extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(Z){const Ee=h.float(Z,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ee,6,100)}compute(Z,Ee,qe){return Z.fontInfo.fontSize}}class te extends S{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:te.d,maximum:te.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:te.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(n.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,te.d,te.e))}}te.c=["normal","bold","100","200","300","400","500","600","700","800","900"],te.d=1,te.e=1e3;class Q extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:qe,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:qe,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:qe,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:qe,description:g.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{multiple:$(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??$(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??$(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??$(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??$(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??$(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:g.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:u(Ee.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ee.above,this.defaultValue.above)}}}var le;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(le||(e.RenderMinimap=le={}));class se extends m{constructor(){super(144)}compute(Z,Ee,qe){return se.computeLayout(Ee,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const Ee=Z.height/Z.lineHeight,qe=Math.floor(Z.paddingTop/Z.lineHeight);let Ye=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ye=Math.max(Ye,Ee-1));const ut=(qe+Z.viewLineCount+Ye)/(Z.pixelRatio*Z.height),Oe=Math.floor(Z.viewLineCount/ut);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ye,desiredRatio:ut,minimapLineCount:Oe}}static c(Z,Ee){const qe=Z.outerWidth,Ye=Z.outerHeight,ut=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const Oe=Ee.stableMinimapLayoutInput,It=Oe&&Z.outerHeight===Oe.outerHeight&&Z.lineHeight===Oe.lineHeight&&Z.typicalHalfwidthCharacterWidth===Oe.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Oe.pixelRatio&&Z.scrollBeyondLastLine===Oe.scrollBeyondLastLine&&Z.paddingTop===Oe.paddingTop&&Z.paddingBottom===Oe.paddingBottom&&Z.minimap.enabled===Oe.minimap.enabled&&Z.minimap.side===Oe.minimap.side&&Z.minimap.size===Oe.minimap.size&&Z.minimap.showSlider===Oe.minimap.showSlider&&Z.minimap.renderCharacters===Oe.minimap.renderCharacters&&Z.minimap.maxColumn===Oe.minimap.maxColumn&&Z.minimap.scale===Oe.minimap.scale&&Z.verticalScrollbarWidth===Oe.verticalScrollbarWidth&&Z.isViewportWrapping===Oe.isViewportWrapping,Vt=Z.lineHeight,Ut=Z.typicalHalfwidthCharacterWidth,Yt=Z.scrollBeyondLastLine,Ht=Z.minimap.renderCharacters;let Pt=ut>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Zt=Z.minimap.maxColumn,_t=Z.minimap.size,si=Z.minimap.side,oi=Z.verticalScrollbarWidth,_e=Z.viewLineCount,Tt=Z.remainingWidth,xt=Z.isViewportWrapping,$t=Ht?2:3;let vt=Math.floor(ut*Ye);const Kt=vt/ut;let Nt=!1,Bt=!1,dt=$t*Pt,Mt=Pt/ut,ei=1;if(_t==="fill"||_t==="fit"){const{typicalViewportLineCount:jt,extraLinesBeforeFirstLine:At,extraLinesBeyondLastLine:Rt,desiredRatio:ri,minimapLineCount:zt}=se.computeContainedMinimapLineCount({viewLineCount:_e,scrollBeyondLastLine:Yt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ye,lineHeight:Vt,pixelRatio:ut});if(_e/zt>1)Nt=!0,Bt=!0,Pt=1,dt=1,Mt=Pt/ut;else{let Lt=!1,Ct=Pt+1;if(_t==="fit"){const bt=Math.ceil((At+_e+Rt)*dt);xt&&It&&Tt<=Ee.stableFitRemainingWidth?(Lt=!0,Ct=Ee.stableFitMaxMinimapScale):Lt=bt>vt}if(_t==="fill"||Lt){Nt=!0;const bt=Pt;dt=Math.min(Vt*ut,Math.max(1,Math.floor(1/ri))),xt&&It&&Tt<=Ee.stableFitRemainingWidth&&(Ct=Ee.stableFitMaxMinimapScale),Pt=Math.min(Ct,Math.max(1,Math.floor(dt/$t))),Pt>bt&&(ei=Math.min(2,Pt/bt)),Mt=Pt/ut/ei,vt=Math.ceil(Math.max(jt,At+_e+Rt)*dt),xt?(Ee.stableMinimapLayoutInput=Z,Ee.stableFitRemainingWidth=Tt,Ee.stableFitMaxMinimapScale=Pt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ti=Math.floor(Zt*Mt),Ge=Math.min(ti,Math.max(0,Math.floor((Tt-oi-2)*Mt/(Ut+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Wt=Math.floor(ut*Ge);const Xt=Wt/ut;Wt=Math.floor(Wt*ei);const ni=Ht?1:2,wt=si==="left"?0:qe-Ge-oi;return{renderMinimap:ni,minimapLeft:wt,minimapWidth:Ge,minimapHeightIsEditorHeight:Nt,minimapIsSampling:Bt,minimapScale:Pt,minimapLineHeight:dt,minimapCanvasInnerWidth:Wt,minimapCanvasInnerHeight:vt,minimapCanvasOuterWidth:Xt,minimapCanvasOuterHeight:Kt}}static computeLayout(Z,Ee){const qe=Ee.outerWidth|0,Ye=Ee.outerHeight|0,ut=Ee.lineHeight|0,Oe=Ee.lineNumbersDigitCount|0,It=Ee.typicalHalfwidthCharacterWidth,Vt=Ee.maxDigitWidth,Ut=Ee.pixelRatio,Yt=Ee.viewLineCount,Ht=Z.get(136),Pt=Ht==="inherit"?Z.get(135):Ht,Zt=Pt==="inherit"?Z.get(131):Pt,_t=Z.get(134),si=Ee.isDominatedByLongLines,oi=Z.get(57),_e=Z.get(68).renderType!==0,Tt=Z.get(69),xt=Z.get(105),$t=Z.get(84),vt=Z.get(73),Kt=Z.get(103),Nt=Kt.verticalScrollbarSize,Bt=Kt.verticalHasArrows,dt=Kt.arrowSize,Mt=Kt.horizontalScrollbarSize,ei=Z.get(43),ti=Z.get(110)!=="never";let Ge=Z.get(66);ei&&ti&&(Ge+=16);let Wt=0;if(_e){const Dt=Math.max(Oe,Tt);Wt=Math.round(Dt*Vt)}let Xt=0;oi&&(Xt=ut*Ee.glyphMarginDecorationLaneCount);let ni=0,wt=ni+Xt,jt=wt+Wt,At=jt+Ge;const Rt=qe-Xt-Wt-Ge;let ri=!1,zt=!1,Gt=-1;Pt==="inherit"&&si?(ri=!0,zt=!0):Zt==="on"||Zt==="bounded"?zt=!0:Zt==="wordWrapColumn"&&(Gt=_t);const Lt=se.c({outerWidth:qe,outerHeight:Ye,lineHeight:ut,typicalHalfwidthCharacterWidth:It,pixelRatio:Ut,scrollBeyondLastLine:xt,paddingTop:$t.top,paddingBottom:$t.bottom,minimap:vt,verticalScrollbarWidth:Nt,viewLineCount:Yt,remainingWidth:Rt,isViewportWrapping:zt},Ee.memory||new F);Lt.renderMinimap!==0&&Lt.minimapLeft===0&&(ni+=Lt.minimapWidth,wt+=Lt.minimapWidth,jt+=Lt.minimapWidth,At+=Lt.minimapWidth);const Ct=Rt-Lt.minimapWidth,bt=Math.max(1,Math.floor((Ct-Nt-2)/It)),Et=Bt?dt:0;return zt&&(Gt=Math.max(1,bt),Zt==="bounded"&&(Gt=Math.min(Gt,_t))),{width:qe,height:Ye,glyphMarginLeft:ni,glyphMarginWidth:Xt,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:wt,lineNumbersWidth:Wt,decorationsLeft:jt,decorationsWidth:Ge,contentLeft:At,contentWidth:Ct,minimap:Lt,viewportColumn:bt,isWordWrapMinified:ri,isViewportWrapping:zt,wrappingColumn:Gt,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:Mt,overviewRuler:{top:Et,width:Nt,height:Ye-2*Et,right:0}}}}e.EditorLayoutInfoComputer=se;class $e extends S{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(Z){return $(Z,"simple",["simple","advanced"])}compute(Z,Ee,qe){return Ee.get(2)===2?"advanced":qe}}var ne;(function(_){_.Off="off",_.OnCode="onCode",_.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class ke extends S{constructor(){const Z={enabled:ne.OnCode};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:Z.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:$(Z.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class oe extends S{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:g.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,C.$d?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,C.$d?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:g.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:$(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:u(Ee.padding,this.defaultValue.padding)}}}class G extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):n.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,Ee,qe){return qe<0?n.clampedInt(-qe*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class ge extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:g.localize(66,null)})}compute(Z,Ee,qe){return Z.fontInfo.lineHeight}}class ae extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:Z.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:g.localize(77,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),autohide:u(Ee.autohide,this.defaultValue.autohide),size:$(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(Ee.side,this.defaultValue.side,["right","left"]),showSlider:$(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ee.scale,1,1,3),maxColumn:n.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function De(_){return _==="ctrlCmd"?C.$d?"metaKey":"ctrlKey":"altKey"}class ye extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{top:n.clampedInt(Ee.top,0,0,1e3),bottom:n.clampedInt(Ee.bottom,0,0,1e3)}}}class we extends S{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:g.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:g.localize(81,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),cycle:u(Ee.cycle,this.defaultValue.cycle)}}}class he extends m{constructor(){super(142)}compute(Z,Ee,qe){return Z.pixelRatio}}class K extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Z.strings,description:g.localize(85,null)},comments:{anyOf:Ee,default:Z.comments,description:g.localize(86,null)},other:{anyOf:Ee,default:Z.other,description:g.localize(87,null)}},default:Z,markdownDescription:g.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Ut=Z?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:Ee,comments:qe,strings:Ye}=Z,ut=["on","inline","off"];let Oe,It,Vt;return typeof Ee=="boolean"?Oe=Ee?"on":"off":Oe=$(Ee,this.defaultValue.other,ut),typeof qe=="boolean"?It=qe?"on":"off":It=$(qe,this.defaultValue.comments,ut),typeof Ye=="boolean"?Vt=Ye?"on":"off":Vt=$(Ye,this.defaultValue.strings,ut),{other:Oe,comments:It,strings:Vt}}}var Y;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class me extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(89,null),g.localize(90,null),g.localize(91,null),g.localize(92,null)],default:"on",description:g.localize(93,null)})}validate(Z){let Ee=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(Ee=4,qe=Z):Z==="interval"?Ee=3:Z==="relative"?Ee=2:Z==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:qe}}}function pe(_){const Z=_.get(98);return Z==="editable"?_.get(91):Z!=="on"}e.filterValidationDecorations=pe;class Fe extends S{constructor(){const Z=[],Ee={type:"number",description:g.localize(94,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(95,null),format:"color-hex"}}}]},default:Z,description:g.localize(96,null)})}validate(Z){if(Array.isArray(Z)){const Ee=[];for(const qe of Z)if(typeof qe=="number")Ee.push({column:n.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ye=qe;Ee.push({column:n.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Ee.sort((qe,Ye)=>qe.column-Ye.column),Ee}return this.defaultValue}}class be extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Re(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class Pe extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(101,null),g.localize(102,null),g.localize(103,null)],default:"auto",description:g.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:g.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:g.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:g.localize(108,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z,qe=n.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=n.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Re(Ee.vertical,this.defaultValue.vertical),horizontal:Re(Ee.horizontal,this.defaultValue.horizontal),useShadows:u(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:n.clampedInt(Ee.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:n.clampedInt(Ee.verticalSliderSize,Ye,0,1e3),scrollByPage:u(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:u(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class We extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:g.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:g.localize(115,null)}})}applyUpdate(Z,Ee){let qe=!1;Ee.allowedCharacters&&Z&&(P.$Mn(Z.allowedCharacters,Ee.allowedCharacters)||(Z={...Z,allowedCharacters:Ee.allowedCharacters},qe=!0)),Ee.allowedLocales&&Z&&(P.$Mn(Z.allowedLocales,Ee.allowedLocales)||(Z={...Z,allowedLocales:Ee.allowedLocales},qe=!0));const Ye=super.applyUpdate(Z,Ee);return qe?new l(Ye.newValue,!0):Ye}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{nonBasicASCII:ie(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ie(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ie(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,Ee){if(typeof Z!="object"||!Z)return Ee;const qe={};for(const[Ye,ut]of Object.entries(Z))ut===!0&&(qe[Ye]=!0);return qe}}class j extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:g.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],description:g.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:g.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:g.localize(122,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),mode:$(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:u(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ee.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class z extends S{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:g.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(124,null),g.localize(125,null),g.localize(126,null)],description:g.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:g.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:g.localize(129,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),showToolbar:$(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ee.fontFamily,this.defaultValue.fontFamily),keepOnBlur:u(Ee.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:u(Ee.backgroundColoring,this.defaultValue.backgroundColoring)}}}class q extends S{constructor(){const Z={enabled:L.$Es.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Es.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:g.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:g.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class W extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(132,null),g.localize(133,null),g.localize(134,null)],default:Z.bracketPairs,description:g.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(136,null),g.localize(137,null),g.localize(138,null)],default:Z.bracketPairsHorizontal,description:g.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:g.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:g.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(142,null),g.localize(143,null),g.localize(144,null)],default:Z.highlightActiveIndentation,description:g.localize(145,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{bracketPairs:ie(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ie(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:ie(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ie(_,Z,Ee){const qe=Ee.indexOf(_);return qe===-1?Z:Ee[qe]}class ue extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(146,null),g.localize(147,null)],default:Z.insertMode,description:g.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:g.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:g.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:g.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null)],default:Z.selectionMode,markdownDescription:g.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:g.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:g.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:g.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:g.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:g.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(193,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{insertMode:$(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ee.preview,this.defaultValue.preview),previewMode:$(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ee.showMethods,this.defaultValue.showMethods),showFunctions:u(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ee.showFields,this.defaultValue.showFields),showVariables:u(Ee.showVariables,this.defaultValue.showVariables),showClasses:u(Ee.showClasses,this.defaultValue.showClasses),showStructs:u(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ee.showModules,this.defaultValue.showModules),showProperties:u(Ee.showProperties,this.defaultValue.showProperties),showEvents:u(Ee.showEvents,this.defaultValue.showEvents),showOperators:u(Ee.showOperators,this.defaultValue.showOperators),showUnits:u(Ee.showUnits,this.defaultValue.showUnits),showValues:u(Ee.showValues,this.defaultValue.showValues),showConstants:u(Ee.showConstants,this.defaultValue.showConstants),showEnums:u(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ee.showKeywords,this.defaultValue.showKeywords),showWords:u(Ee.showWords,this.defaultValue.showWords),showColors:u(Ee.showColors,this.defaultValue.showColors),showFiles:u(Ee.showFiles,this.defaultValue.showFiles),showReferences:u(Ee.showReferences,this.defaultValue.showReferences),showFolders:u(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ee.showUsers,this.defaultValue.showUsers),showIssues:u(Ee.showIssues,this.defaultValue.showIssues)}}}class Le extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(195,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Ke extends S{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(196,null),g.localize(197,null),g.localize(198,null),g.localize(199,null)],description:g.localize(200,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,Ee,qe){return Ee.get(2)===2?0:qe}}class et extends m{constructor(){super(145)}compute(Z,Ee,qe){const Ye=Ee.get(144);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class rt extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:g.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(203,null),g.localize(204,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),showDropSelector:$(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ft extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:g.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(207,null),g.localize(208,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:u(Ee.enabled,this.defaultValue.enabled),showPasteSelector:$(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const at="Consolas, 'Courier New', monospace",nt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$d?nt:C.$e?ct:at,fontWeight:"normal",fontSize:C.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ve(_){return e.editorOptionsRegistry[_.id]=_,_}var it;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.inlineEdit=63]="inlineEdit",_[_.letterSpacing=64]="letterSpacing",_[_.lightbulb=65]="lightbulb",_[_.lineDecorationsWidth=66]="lineDecorationsWidth",_[_.lineHeight=67]="lineHeight",_[_.lineNumbers=68]="lineNumbers",_[_.lineNumbersMinChars=69]="lineNumbersMinChars",_[_.linkedEditing=70]="linkedEditing",_[_.links=71]="links",_[_.matchBrackets=72]="matchBrackets",_[_.minimap=73]="minimap",_[_.mouseStyle=74]="mouseStyle",_[_.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=76]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",_[_.multiCursorModifier=78]="multiCursorModifier",_[_.multiCursorPaste=79]="multiCursorPaste",_[_.multiCursorLimit=80]="multiCursorLimit",_[_.occurrencesHighlight=81]="occurrencesHighlight",_[_.overviewRulerBorder=82]="overviewRulerBorder",_[_.overviewRulerLanes=83]="overviewRulerLanes",_[_.padding=84]="padding",_[_.pasteAs=85]="pasteAs",_[_.parameterHints=86]="parameterHints",_[_.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",_[_.quickSuggestions=89]="quickSuggestions",_[_.quickSuggestionsDelay=90]="quickSuggestionsDelay",_[_.readOnly=91]="readOnly",_[_.readOnlyMessage=92]="readOnlyMessage",_[_.renameOnType=93]="renameOnType",_[_.renderControlCharacters=94]="renderControlCharacters",_[_.renderFinalNewline=95]="renderFinalNewline",_[_.renderLineHighlight=96]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=98]="renderValidationDecorations",_[_.renderWhitespace=99]="renderWhitespace",_[_.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",_[_.roundedSelection=101]="roundedSelection",_[_.rulers=102]="rulers",_[_.scrollbar=103]="scrollbar",_[_.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=105]="scrollBeyondLastLine",_[_.scrollPredominantAxis=106]="scrollPredominantAxis",_[_.selectionClipboard=107]="selectionClipboard",_[_.selectionHighlight=108]="selectionHighlight",_[_.selectOnLineNumbers=109]="selectOnLineNumbers",_[_.showFoldingControls=110]="showFoldingControls",_[_.showUnused=111]="showUnused",_[_.snippetSuggestions=112]="snippetSuggestions",_[_.smartSelect=113]="smartSelect",_[_.smoothScrolling=114]="smoothScrolling",_[_.stickyScroll=115]="stickyScroll",_[_.stickyTabStops=116]="stickyTabStops",_[_.stopRenderingLineAfter=117]="stopRenderingLineAfter",_[_.suggest=118]="suggest",_[_.suggestFontSize=119]="suggestFontSize",_[_.suggestLineHeight=120]="suggestLineHeight",_[_.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",_[_.suggestSelection=122]="suggestSelection",_[_.tabCompletion=123]="tabCompletion",_[_.tabIndex=124]="tabIndex",_[_.unicodeHighlighting=125]="unicodeHighlighting",_[_.unusualLineTerminators=126]="unusualLineTerminators",_[_.useShadowDOM=127]="useShadowDOM",_[_.useTabStops=128]="useTabStops",_[_.wordBreak=129]="wordBreak",_[_.wordSeparators=130]="wordSeparators",_[_.wordWrap=131]="wordWrap",_[_.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=134]="wordWrapColumn",_[_.wordWrapOverride1=135]="wordWrapOverride1",_[_.wordWrapOverride2=136]="wordWrapOverride2",_[_.wrappingIndent=137]="wrappingIndent",_[_.wrappingStrategy=138]="wrappingStrategy",_[_.showDeprecated=139]="showDeprecated",_[_.inlayHints=140]="inlayHints",_[_.editorClassName=141]="editorClassName",_[_.pixelRatio=142]="pixelRatio",_[_.tabFocusMode=143]="tabFocusMode",_[_.layoutInfo=144]="layoutInfo",_[_.wrappingInfo=145]="wrappingInfo",_[_.defaultColorDecorators=146]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(it||(e.EditorOption=it={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ve(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(209,null)})),acceptSuggestionOnEnter:Ve(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(210,null),""],markdownDescription:g.localize(211,null)})),accessibilitySupport:Ve(new p),accessibilityPageSize:Ve(new n(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(212,null),tags:["accessibility"]})),ariaLabel:Ve(new t(4,"ariaLabel",g.localize(213,null))),ariaRequired:Ve(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ve(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Ve(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(215,null),g.localize(216,null),""],description:g.localize(217,null)})),autoClosingComments:Ve(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoClosingDelete:Ve(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(221,null),""],description:g.localize(222,null)})),autoClosingOvertype:Ve(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(223,null),""],description:g.localize(224,null)})),autoClosingQuotes:Ve(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(225,null),g.localize(226,null),""],description:g.localize(227,null)})),autoIndent:Ve(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[g.localize(228,null),g.localize(229,null),g.localize(230,null),g.localize(231,null),g.localize(232,null)],description:g.localize(233,null)})),automaticLayout:Ve(new i(13,"automaticLayout",!1)),autoSurround:Ve(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),""],description:g.localize(237,null)})),bracketPairColorization:Ve(new q),bracketPairGuides:Ve(new W),stickyTabStops:Ve(new i(116,"stickyTabStops",!1,{description:g.localize(238,null)})),codeLens:Ve(new i(17,"codeLens",!0,{description:g.localize(239,null)})),codeLensFontFamily:Ve(new t(18,"codeLensFontFamily","",{description:g.localize(240,null)})),codeLensFontSize:Ve(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(241,null)})),colorDecorators:Ve(new i(20,"colorDecorators",!0,{description:g.localize(242,null)})),colorDecoratorActivatedOn:Ve(new c(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),colorDecoratorsLimit:Ve(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(247,null)})),columnSelection:Ve(new i(22,"columnSelection",!1,{description:g.localize(248,null)})),comments:Ve(new d),contextmenu:Ve(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ve(new i(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(249,null)})),cursorBlinking:Ve(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:g.localize(250,null)})),cursorSmoothCaretAnimation:Ve(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),cursorStyle:Ve(new o(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:g.localize(255,null)})),cursorSurroundingLines:Ve(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(256,null)})),cursorSurroundingLinesStyle:Ve(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(257,null),g.localize(258,null)],markdownDescription:g.localize(259,null)})),cursorWidth:Ve(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(260,null)})),disableLayerHinting:Ve(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ve(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ve(new i(34,"domReadOnly",!1)),dragAndDrop:Ve(new i(35,"dragAndDrop",!0,{description:g.localize(261,null)})),emptySelectionClipboard:Ve(new X),dropIntoEditor:Ve(new rt),stickyScroll:Ve(new oe),experimentalWhitespaceRendering:Ve(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(262,null),g.localize(263,null),g.localize(264,null)],description:g.localize(265,null)})),extraEditorClassName:Ve(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ve(new h(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:g.localize(266,null)})),find:Ve(new H),fixedOverflowWidgets:Ve(new i(42,"fixedOverflowWidgets",!1)),folding:Ve(new i(43,"folding",!0,{description:g.localize(267,null)})),foldingStrategy:Ve(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),foldingHighlight:Ve(new i(45,"foldingHighlight",!0,{description:g.localize(271,null)})),foldingImportsByDefault:Ve(new i(46,"foldingImportsByDefault",!1,{description:g.localize(272,null)})),foldingMaximumRegions:Ve(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(273,null)})),unfoldOnClickAfterEndOfLine:Ve(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(274,null)})),fontFamily:Ve(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(275,null)})),fontInfo:Ve(new B),fontLigatures2:Ve(new O),fontSize:Ve(new T),fontWeight:Ve(new te),fontVariations:Ve(new R),formatOnPaste:Ve(new i(55,"formatOnPaste",!1,{description:g.localize(276,null)})),formatOnType:Ve(new i(56,"formatOnType",!1,{description:g.localize(277,null)})),glyphMargin:Ve(new i(57,"glyphMargin",!0,{description:g.localize(278,null)})),gotoLocation:Ve(new Q),hideCursorInOverviewRuler:Ve(new i(59,"hideCursorInOverviewRuler",!1,{description:g.localize(279,null)})),hover:Ve(new ce),inDiffEditor:Ve(new i(61,"inDiffEditor",!1)),letterSpacing:Ve(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>h.clamp(_,-5,20),{description:g.localize(280,null)})),lightbulb:Ve(new ke),lineDecorationsWidth:Ve(new G),lineHeight:Ve(new ge),lineNumbers:Ve(new me),lineNumbersMinChars:Ve(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ve(new i(70,"linkedEditing",!1,{description:g.localize(281,null)})),links:Ve(new i(71,"links",!0,{description:g.localize(282,null)})),matchBrackets:Ve(new c(72,"matchBrackets","always",["always","near","never"],{description:g.localize(283,null)})),minimap:Ve(new ae),mouseStyle:Ve(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ve(new h(75,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:g.localize(284,null)})),mouseWheelZoom:Ve(new i(76,"mouseWheelZoom",!1,{markdownDescription:C.$d?g.localize(285,null):g.localize(286,null)})),multiCursorMergeOverlapping:Ve(new i(77,"multiCursorMergeOverlapping",!0,{description:g.localize(287,null)})),multiCursorModifier:Ve(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],De,{markdownEnumDescriptions:[g.localize(288,null),g.localize(289,null)],markdownDescription:g.localize(290,null)})),multiCursorPaste:Ve(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(291,null),g.localize(292,null)],markdownDescription:g.localize(293,null)})),multiCursorLimit:Ve(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(294,null)})),occurrencesHighlight:Ve(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(295,null),g.localize(296,null),g.localize(297,null)],markdownDescription:g.localize(298,null)})),overviewRulerBorder:Ve(new i(82,"overviewRulerBorder",!0,{description:g.localize(299,null)})),overviewRulerLanes:Ve(new n(83,"overviewRulerLanes",3,0,3)),padding:Ve(new ye),pasteAs:Ve(new ft),parameterHints:Ve(new we),peekWidgetDefaultFocus:Ve(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(300,null),g.localize(301,null)],description:g.localize(302,null)})),definitionLinkOpensInPeek:Ve(new i(88,"definitionLinkOpensInPeek",!1,{description:g.localize(303,null)})),quickSuggestions:Ve(new K),quickSuggestionsDelay:Ve(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(304,null)})),readOnly:Ve(new i(91,"readOnly",!1)),readOnlyMessage:Ve(new be),renameOnType:Ve(new i(93,"renameOnType",!1,{description:g.localize(305,null),markdownDeprecationMessage:g.localize(306,null)})),renderControlCharacters:Ve(new i(94,"renderControlCharacters",!0,{description:g.localize(307,null),restricted:!0})),renderFinalNewline:Ve(new c(95,"renderFinalNewline",C.$e?"dimmed":"on",["off","on","dimmed"],{description:g.localize(308,null)})),renderLineHighlight:Ve(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(309,null)],description:g.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Ve(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(311,null)})),renderValidationDecorations:Ve(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ve(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(312,null),g.localize(313,null),g.localize(314,null),""],description:g.localize(315,null)})),revealHorizontalRightPadding:Ve(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ve(new i(101,"roundedSelection",!0,{description:g.localize(316,null)})),rulers:Ve(new Fe),scrollbar:Ve(new Pe),scrollBeyondLastColumn:Ve(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(317,null)})),scrollBeyondLastLine:Ve(new i(105,"scrollBeyondLastLine",!0,{description:g.localize(318,null)})),scrollPredominantAxis:Ve(new i(106,"scrollPredominantAxis",!0,{description:g.localize(319,null)})),selectionClipboard:Ve(new i(107,"selectionClipboard",!0,{description:g.localize(320,null),included:C.$e})),selectionHighlight:Ve(new i(108,"selectionHighlight",!0,{description:g.localize(321,null)})),selectOnLineNumbers:Ve(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:Ve(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(322,null),g.localize(323,null),g.localize(324,null)],description:g.localize(325,null)})),showUnused:Ve(new i(111,"showUnused",!0,{description:g.localize(326,null)})),showDeprecated:Ve(new i(139,"showDeprecated",!0,{description:g.localize(327,null)})),inlayHints:Ve(new ve),snippetSuggestions:Ve(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(328,null),g.localize(329,null),g.localize(330,null),g.localize(331,null)],description:g.localize(332,null)})),smartSelect:Ve(new Le),smoothScrolling:Ve(new i(114,"smoothScrolling",!1,{description:g.localize(333,null)})),stopRenderingLineAfter:Ve(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ve(new ue),inlineSuggest:Ve(new j),inlineEdit:Ve(new z),inlineCompletionsAccessibilityVerbose:Ve(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(334,null)})),suggestFontSize:Ve(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ve(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ve(new i(121,"suggestOnTriggerCharacters",!0,{description:g.localize(337,null)})),suggestSelection:Ve(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(338,null),g.localize(339,null),g.localize(340,null)],description:g.localize(341,null)})),tabCompletion:Ve(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(342,null),g.localize(343,null),g.localize(344,null)],description:g.localize(345,null)})),tabIndex:Ve(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ve(new We),unusualLineTerminators:Ve(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(346,null),g.localize(347,null),g.localize(348,null)],description:g.localize(349,null)})),useShadowDOM:Ve(new i(127,"useShadowDOM",!0)),useTabStops:Ve(new i(128,"useTabStops",!0,{description:g.localize(350,null)})),wordBreak:Ve(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(351,null),g.localize(352,null)],description:g.localize(353,null)})),wordSeparators:Ve(new t(130,"wordSeparators",M.$Fs,{description:g.localize(354,null)})),wordWrap:Ve(new c(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(355,null),g.localize(356,null),g.localize(357,null),g.localize(358,null)],description:g.localize(359,null)})),wordWrapBreakAfterCharacters:Ve(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ve(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ve(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(360,null)})),wordWrapOverride1:Ve(new c(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ve(new c(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ve(new V),defaultColorDecorators:Ve(new i(146,"defaultColorDecorators",!1,{markdownDescription:g.localize(361,null)})),pixelRatio:Ve(new he),tabFocusMode:Ve(new i(143,"tabFocusMode",!1,{markdownDescription:g.localize(362,null)})),layoutInfo:Ve(new se),wrappingInfo:Ve(new et),wrappingIndent:Ve(new Ke),wrappingStrategy:Ve(new $e)}}),define(Me[149],Ae([9,10]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Me[150],Ae([9,10]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(Me[151],Ae([9,10]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(Me[152],Ae([9,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Me[153],Ae([9,10]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Me[154],Ae([9,10]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(Me[155],Ae([9,10]),function(x,e){return x.create("vs/platform/markers/common/markers",e)}),define(Me[156],Ae([9,10]),function(x,e){return x.create("vs/platform/theme/common/iconRegistry",e)}),define(Me[157],Ae([9,10]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Me[158],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Me[159],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Me[160],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Me[161],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Me[162],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Me[163],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostLogService",e)}),define(Me[164],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostNotebook",e)}),define(Me[165],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Me[166],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Me[167],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Me[168],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Me[169],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Me[170],Ae([9,10]),function(x,e){return x.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Me[171],Ae([9,10]),function(x,e){return x.create("vs/workbench/common/configuration",e)}),define(Me[172],Ae([9,10]),function(x,e){return x.create("vs/workbench/common/editor",e)}),define(Me[173],Ae([9,10]),function(x,e){return x.create("vs/workbench/common/views",e)}),define(Me[174],Ae([9,10]),function(x,e){return x.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Me[175],Ae([9,10]),function(x,e){return x.create("vs/workbench/contrib/debug/common/debug",e)}),define(Me[176],Ae([9,10]),function(x,e){return x.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Me[177],Ae([9,10]),function(x,e){return x.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Me[178],Ae([9,10]),function(x,e){return x.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Me[179],Ae([9,10]),function(x,e){return x.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Me[180],Ae([9,10]),function(x,e){return x.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Me[181],Ae([9,10]),function(x,e){return x.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Me[182],Ae([1,0,15,151]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var C;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...k){switch(k.length){case 1:return(0,P.localize)(0,null,k[0]);case 2:return(0,P.localize)(1,null,k[0],k[1]);case 3:return(0,P.localize)(2,null,k[0],k[1],k[2]);default:return}}const M=(0,P.localize)(3,null),g=(0,P.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(F){switch(F.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return F.isTripleEq?"===":"==";case 4:return F.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return F.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return F.lexeme;case 18:return F.lexeme;case 19:return F.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(F)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(F){return this.c=F,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(F){return this.r()||this.c.charCodeAt(this.e)!==F?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(F){this.f.push({type:F,offset:this.d})}l(F){const S=this.d,l=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:F}),this.f.push(w)}n(){this.m.lastIndex=this.d;const F=this.m.exec(this.c);if(F){this.e=this.d+F[0].length;const S=this.c.substring(this.d,this.e),l=f.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let F=this.e,S=!1,l=!1;for(;;){if(F>=this.c.length){this.e=F,this.l(g);return}const m=this.c.charCodeAt(F);if(S)S=!1;else if(m===47&&!l){F++;break}else m===91?l=!0:m===92?S=!0:m===93&&(l=!1);F++}for(;F<this.c.length&&f.a.has(this.c.charCodeAt(F));)F++;this.e=F;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=f,f.a=new Set(["i","g","s","m","y","u"].map(k=>k.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Me[183],Ae([1,0,25,32,153,297]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function f(i){return i=i.trim(),i==="*"||M.test(i)}e.$mp=f;function k(i){if(!f(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=i.match(M);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$np=k;function F(i){if(!i)return null;const r=i.majorBase,n=i.majorMustEqual,a=i.minorBase;let h=i.minorMustEqual;const t=i.patchBase;let $=i.patchMustEqual;i.hasCaret&&(r===0||(h=!1),$=!1);let c=0;if(i.preRelease){const o=g.exec(i.preRelease);if(o){const[,b,p,d]=o;c=Date.UTC(Number(b),Number(p)-1,Number(d))}}return{majorBase:r,majorMustEqual:n,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:$,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$op=F;function S(i,r,n){let a;typeof i=="string"?a=F(k(i)):a=i;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof n=="string"?t=F(k(n)):t=n,!a||!t)return!1;const $=a.majorBase,c=a.minorBase,o=a.patchBase;let b=t.majorBase,p=t.minorBase,d=t.patchBase;const I=t.notBefore;let v=t.majorMustEqual,y=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?$>b?!0:$<b?!1:c>p?!0:c<p||h&&h<I?!1:o>=d:($===1&&b===0&&(!v||!y||!E)&&(b=1,p=0,d=0,v=!0,y=!1,E=!1),$<b?!1:$>b?!v:c<p?!1:c>p?!y:o<d?!1:o>d?!E:!(h&&h<I))}e.$pp=S;function l(i,r,n,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([P.default.Error,C.localize(0,null)]),t;if(typeof a.name!="string")return t.push([P.default.Error,C.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([P.default.Error,C.localize(2,null,"version")]),t;if(!a.engines)return t.push([P.default.Error,C.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([P.default.Error,C.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!u(a.extensionDependencies))return t.push([P.default.Error,C.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!u(a.activationEvents))return t.push([P.default.Error,C.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([P.default.Error,C.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([P.default.Warning,C.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([P.default.Error,C.localize(9,null,"main")]),t;{const o=(0,D.$Rg)(n,a.main);(0,D.$Lg)(o,n)||t.push([P.default.Warning,C.localize(10,null,o.path,n.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([P.default.Error,C.localize(11,null,"browser")]),t;{const o=(0,D.$Rg)(n,a.browser);(0,D.$Lg)(o,n)||t.push([P.default.Warning,C.localize(12,null,o.path,n.path)])}}if(!L.valid(a.version))return t.push([P.default.Error,C.localize(13,null)]),t;const $=[];if(!w(i,r,a,h,$))for(const o of $)t.push([P.default.Error,o]);return t}e.$qp=l;function w(i,r,n,a,h){return a||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(i,r,n.engines.vscode,h)}e.$rp=w;function m(i,r,n){return i==="*"||s(r,n,i)}e.$sp=m;function s(i,r,n,a=[]){const h=F(k(n));if(!h)return a.push(C.localize(14,null,n)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(C.localize(15,null,n)),!1}else if(!h.majorMustEqual)return a.push(C.localize(16,null,n)),!1;return S(i,r,h)?!0:(a.push(C.localize(17,null,i,n)),!1)}function u(i){if(!Array.isArray(i))return!1;for(let r=0,n=i.length;r<n;r++)if(typeof i[r]!="string")return!1;return!0}}),define(Me[70],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class D{constructor(C,L=[],M=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=M}}e.$bi=D}),define(Me[54],Ae([1,0,70]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.InstantiationType=void 0;const P=[];var C;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(g,f,k){f instanceof D.$bi||(f=new D.$bi(f,[],!!k)),P.push([g,f])}e.$$r=L;function M(){return P}e.$_r=M}),define(Me[184],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class D{constructor(L,M){this.key=L,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$Oq=D;class P{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const M of this.a.values())M.outgoing.size===0&&L.push(M);return L}insertEdge(L,M){const g=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(M);g.outgoing.set(f.key,f),f.incoming.set(g.key,g)}removeNode(L){const M=this.b(L);this.a.delete(M);for(const g of this.a.values())g.outgoing.delete(M),g.incoming.delete(M)}lookupOrInsertNode(L){const M=this.b(L);let g=this.a.get(M);return g||(g=new D(M,L),this.a.set(M,g)),g}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[M,g]of this.a)L.push(`${M}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,M]of this.a){const g=new Set([L]),f=this.c(M,g);if(f)return f}}c(L,M){for(const[g,f]of L.outgoing){if(M.has(g))return[...M,g].join(" -> ");M.add(g);const k=this.c(f,M);if(k)return k;M.delete(g)}}}e.$Pq=P}),define(Me[4],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var D;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function g(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=g})(D||(e._util=D={})),e.$di=C("instantiationService");function P(M,g,f){g[D.DI_TARGET]===g?g[D.DI_DEPENDENCIES].push({id:M,index:f}):(g[D.DI_DEPENDENCIES]=[{id:M,index:f}],g[D.DI_TARGET]=g)}function C(M){if(D.serviceIds.has(M))return D.serviceIds.get(M);const g=function(f,k,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(g,f,F)};return g.toString=()=>M,D.serviceIds.set(M,g),g}e.$ei=C;function L(M){return M}e.$fi=L}),define(Me[46],Ae([1,0,16,2,4]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,C.$ei)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof P.URI)}e.$Li=L;function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof P.URI)}e.$Mi=M;var g;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function f(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=f;function k(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$Oi=k;function F(i,r){const n=Object.create(null);for(const a in i)S(n,a,i[a],r);return n}e.$Pi=F;function S(i,r,n,a){const h=r.split("."),t=h.pop();let $=i;for(let c=0;c<h.length;c++){const o=h[c];let b=$[o];switch(typeof b){case"undefined":b=$[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(b)}`);return}$=b}if(typeof $=="object"&&$!==null)try{$[t]=n}catch{a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify($)}`)}else a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify($)}`)}e.$Qi=S;function l(i,r){const n=r.split(".");w(i,n)}e.$Ri=l;function w(i,r){const n=r.shift();if(r.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const a=i[n];typeof a=="object"&&!Array.isArray(a)&&(w(a,r),Object.keys(a).length===0&&delete i[n])}}function m(i,r,n){function a($,c){let o=$;for(const b of c){if(typeof o!="object"||o===null)return;o=o[b]}return o}const h=r.split("."),t=a(i,h);return typeof t>"u"?n:t}e.$Si=m;function s(i,r,n){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in i?D.$Uf(i[a])&&D.$Uf(r[a])?s(i[a],r[a],n):n&&(i[a]=r[a]):i[a]=r[a])})}e.$Ti=s;function u(i){return i.replace(/[\[\]]/g,"")}e.$Ui=u}),define(Me[36],Ae([1,0,21,13,182,4,150,15]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",D.$d),f.set("isLinux",D.$e),f.set("isWindows",D.$c),f.set("isWeb",D.$i),f.set("isMacNative",D.$d&&!D.$i),f.set("isEdge",D.$B),f.set("isFirefox",D.$z),f.set("isChrome",D.$y),f.set("isSafari",D.$A);function k(ve,G){if(f.get(ve)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(ve,G)}e.$aj=k;const F=Object.prototype.hasOwnProperty;var S;(function(ve){ve[ve.False=0]="False",ve[ve.True=1]="True",ve[ve.Defined=2]="Defined",ve[ve.Not=3]="Not",ve[ve.Equals=4]="Equals",ve[ve.NotEquals=5]="NotEquals",ve[ve.And=6]="And",ve[ve.Regex=7]="Regex",ve[ve.NotRegex=8]="NotRegex",ve[ve.Or=9]="Or",ve[ve.In=10]="In",ve[ve.NotIn=11]="NotIn",ve[ve.Greater=12]="Greater",ve[ve.GreaterEquals=13]="GreaterEquals",ve[ve.Smaller=14]="Smaller",ve[ve.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},w=(0,M.localize)(0,null),m=(0,M.localize)(1,null),s=(0,M.localize)(2,null),u=(0,M.localize)(3,null),i=(0,M.localize)(4,null),r=(0,M.localize)(5,null),n=(0,M.localize)(6,null),a=(0,M.localize)(7,null);class h{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(G=l){this.k=G,this.d=new C.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(G){if(G===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(G).scan(),this.g=0,this.h=[];try{const ge=this.l();if(!this.E()){const ae=this.D(),De=ae.type===17?r:void 0;throw this.h.push({message:i,offset:ae.offset,lexeme:C.$_i.getLexeme(ae),additionalInfo:De}),h.c}return ge}catch(ge){if(ge!==h.c)throw ge;return}}l(){return this.m()}m(){const G=[this.o()];for(;this.y(16);){const ge=this.o();G.push(ge)}return G.length===1?G[0]:t.or(...G)}o(){const G=[this.s()];for(;this.y(15);){const ge=this.s();G.push(ge)}return G.length===1?G[0]:t.and(...G)}s(){if(this.y(2)){const G=this.D();switch(G.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const ge=this.l();return this.A(1,u),ge?.negate()}case 17:return this.z(),A.create(G.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",G)}}return this.t()}t(){const G=this.D();switch(G.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ge=this.l();return this.A(1,u),ge}case 17:{const ge=G.lexeme;if(this.z(),this.y(9)){const De=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),De.type!==10)throw this.B("REGEX",De);const ye=De.lexeme,we=ye.lastIndexOf("/"),he=we===ye.length-1?void 0:this.w(ye.substring(we+1));let K;try{K=new RegExp(ye.substring(1,we),he)}catch{throw this.B("REGEX",De)}return B.create(ge,K)}switch(De.type){case 10:case 19:{const ye=[De.lexeme];this.z();let we=this.D(),he=0;for(let Fe=0;Fe<De.lexeme.length;Fe++)De.lexeme.charCodeAt(Fe)===40?he++:De.lexeme.charCodeAt(Fe)===41&&he--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:he++;break;case 1:he--;break;case 10:case 18:for(let Fe=0;Fe<we.lexeme.length;Fe++)we.lexeme.charCodeAt(Fe)===40?he++:De.lexeme.charCodeAt(Fe)===41&&he--}if(he<0)break;ye.push(C.$_i.getLexeme(we)),this.z(),we=this.D()}const K=ye.join(""),Y=K.lastIndexOf("/"),me=Y===K.length-1?void 0:this.w(K.substring(Y+1));let pe;try{pe=new RegExp(K.substring(1,Y),me)}catch{throw this.B("REGEX",De)}return t.regex(ge,pe)}case 18:{const ye=De.lexeme;this.z();let we=null;if(!(0,P.$Se)(ye)){const he=ye.indexOf("/"),K=ye.lastIndexOf("/");if(he!==K&&he>=0){const Y=ye.slice(he+1,K),me=ye[K+1]==="i"?"i":"";try{we=new RegExp(Y,me)}catch{throw this.B("REGEX",De)}}}if(we===null)throw this.B("REGEX",De);return B.create(ge,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const De=this.u();return t.notIn(ge,De)}switch(this.D().type){case 3:{this.z();const De=this.u();if(this.x().type===18)return t.equals(ge,De);switch(De){case"true":return t.has(ge);case"false":return t.not(ge);default:return t.equals(ge,De)}}case 4:{this.z();const De=this.u();if(this.x().type===18)return t.notEquals(ge,De);switch(De){case"true":return t.not(ge);case"false":return t.has(ge);default:return t.notEquals(ge,De)}}case 5:return this.z(),O.create(ge,this.u());case 6:return this.z(),R.create(ge,this.u());case 7:return this.z(),X.create(ge,this.u());case 8:return this.z(),H.create(ge,this.u());case 13:return this.z(),t.in(ge,this.u());default:return t.has(ge)}}case 20:throw this.h.push({message:n,offset:G.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const G=this.D();switch(G.type){case 17:case 18:return this.z(),G.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(G){return G.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(G){return this.C(G)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(G,ge){if(this.C(G))return this.z();throw this.B(ge,this.D())}B(G,ge,ae){const De=(0,M.localize)(8,null,G,C.$_i.getLexeme(ge)),ye=ge.offset,we=C.$_i.getLexeme(ge);return this.h.push({message:De,offset:ye,lexeme:we,additionalInfo:ae}),h.c}C(G){return this.D().type===G}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=h,h.c=new Error;class t{static false(){return b.INSTANCE}static true(){return p.INSTANCE}static has(G){return d.create(G)}static equals(G,ge){return I.create(G,ge)}static notEquals(G,ge){return E.create(G,ge)}static regex(G,ge){return B.create(G,ge)}static in(G,ge){return v.create(G,ge)}static notIn(G,ge){return y.create(G,ge)}static not(G){return A.create(G)}static and(...G){return Q.create(G,null,!0)}static or(...G){return ce.create(G,null,!0)}static greater(G,ge){return X.create(G,ge)}static greaterEquals(G,ge){return H.create(G,ge)}static smaller(G,ge){return O.create(G,ge)}static smallerEquals(G,ge){return R.create(G,ge)}static deserialize(G){return G==null?void 0:this.c.parse(G)}}e.$cj=t,t.c=new h({regexParsingWithErrorRecovery:!1});function $(ve){const G=new h({regexParsingWithErrorRecovery:!1});return ve.map(ge=>(G.parse(ge),G.lexingErrors.length>0?G.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,M.localize)(9,null,ae.additionalInfo):(0,M.localize)(10,null),offset:ae.offset,length:ae.lexeme.length})):G.parsingErrors.length>0?G.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}e.$dj=$;function c(ve,G){const ge=ve?ve.substituteConstants():void 0,ae=G?G.substituteConstants():void 0;return!ge&&!ae?!0:!ge||!ae?!1:ge.equals(ae)}e.$ej=c;function o(ve,G){return ve.cmp(G)}class b{constructor(){this.type=0}cmp(G){return this.type-G.type}equals(G){return G.type===this.type}substituteConstants(){return this}evaluate(G){return!1}serialize(){return"false"}keys(){return[]}map(G){return this}negate(){return p.INSTANCE}}e.$fj=b,b.INSTANCE=new b;class p{constructor(){this.type=1}cmp(G){return this.type-G.type}equals(G){return G.type===this.type}substituteConstants(){return this}evaluate(G){return!0}serialize(){return"true"}keys(){return[]}map(G){return this}negate(){return b.INSTANCE}}e.$gj=p,p.INSTANCE=new p;class d{static create(G,ge=null){const ae=f.get(G);return typeof ae=="boolean"?ae?p.INSTANCE:b.INSTANCE:new d(G,ge)}constructor(G,ge){this.key=G,this.c=ge,this.type=2}cmp(G){return G.type!==this.type?this.type-G.type:se(this.key,G.key)}equals(G){return G.type===this.type?this.key===G.key:!1}substituteConstants(){const G=f.get(this.key);return typeof G=="boolean"?G?p.INSTANCE:b.INSTANCE:this}evaluate(G){return!!G.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(G){return G.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$hj=d;class I{static create(G,ge,ae=null){if(typeof ge=="boolean")return ge?d.create(G,ae):A.create(G,ae);const De=f.get(G);return typeof De=="boolean"?ge===(De?"true":"false")?p.INSTANCE:b.INSTANCE:new I(G,ge,ae)}constructor(G,ge,ae){this.c=G,this.d=ge,this.f=ae,this.type=4}cmp(G){return G.type!==this.type?this.type-G.type:$e(this.c,this.d,G.c,G.d)}equals(G){return G.type===this.type?this.c===G.c&&this.d===G.d:!1}substituteConstants(){const G=f.get(this.c);if(typeof G=="boolean"){const ge=G?"true":"false";return this.d===ge?p.INSTANCE:b.INSTANCE}return this}evaluate(G){return G.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(G){return G.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$ij=I;class v{static create(G,ge){return new v(G,ge)}constructor(G,ge){this.d=G,this.f=ge,this.type=10,this.c=null}cmp(G){return G.type!==this.type?this.type-G.type:$e(this.d,this.f,G.d,G.f)}equals(G){return G.type===this.type?this.d===G.d&&this.f===G.f:!1}substituteConstants(){return this}evaluate(G){const ge=G.getValue(this.f),ae=G.getValue(this.d);return Array.isArray(ge)?ge.includes(ae):typeof ae=="string"&&typeof ge=="object"&&ge!==null?F.call(ge,ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(G){return G.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$jj=v;class y{static create(G,ge){return new y(G,ge)}constructor(G,ge){this.d=G,this.f=ge,this.type=11,this.c=v.create(G,ge)}cmp(G){return G.type!==this.type?this.type-G.type:this.c.cmp(G.c)}equals(G){return G.type===this.type?this.c.equals(G.c):!1}substituteConstants(){return this}evaluate(G){return!this.c.evaluate(G)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(G){return G.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=y;class E{static create(G,ge,ae=null){if(typeof ge=="boolean")return ge?A.create(G,ae):d.create(G,ae);const De=f.get(G);return typeof De=="boolean"?ge===(De?"true":"false")?b.INSTANCE:p.INSTANCE:new E(G,ge,ae)}constructor(G,ge,ae){this.c=G,this.d=ge,this.f=ae,this.type=5}cmp(G){return G.type!==this.type?this.type-G.type:$e(this.c,this.d,G.c,G.d)}equals(G){return G.type===this.type?this.c===G.c&&this.d===G.d:!1}substituteConstants(){const G=f.get(this.c);if(typeof G=="boolean"){const ge=G?"true":"false";return this.d===ge?b.INSTANCE:p.INSTANCE}return this}evaluate(G){return G.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(G){return G.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$lj=E;class A{static create(G,ge=null){const ae=f.get(G);return typeof ae=="boolean"?ae?b.INSTANCE:p.INSTANCE:new A(G,ge)}constructor(G,ge){this.c=G,this.d=ge,this.type=3}cmp(G){return G.type!==this.type?this.type-G.type:se(this.c,G.c)}equals(G){return G.type===this.type?this.c===G.c:!1}substituteConstants(){const G=f.get(this.c);return typeof G=="boolean"?G?b.INSTANCE:p.INSTANCE:this}evaluate(G){return!G.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(G){return G.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.$mj=A;function V(ve,G){if(typeof ve=="string"){const ge=parseFloat(ve);isNaN(ge)||(ve=ge)}return typeof ve=="string"||typeof ve=="number"?G(ve):b.INSTANCE}class X{static create(G,ge,ae=null){return V(ge,De=>new X(G,De,ae))}constructor(G,ge,ae){this.c=G,this.d=ge,this.f=ae,this.type=12}cmp(G){return G.type!==this.type?this.type-G.type:$e(this.c,this.d,G.c,G.d)}equals(G){return G.type===this.type?this.c===G.c&&this.d===G.d:!1}substituteConstants(){return this}evaluate(G){return typeof this.d=="string"?!1:parseFloat(G.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(G){return G.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$nj=X;class H{static create(G,ge,ae=null){return V(ge,De=>new H(G,De,ae))}constructor(G,ge,ae){this.c=G,this.d=ge,this.f=ae,this.type=13}cmp(G){return G.type!==this.type?this.type-G.type:$e(this.c,this.d,G.c,G.d)}equals(G){return G.type===this.type?this.c===G.c&&this.d===G.d:!1}substituteConstants(){return this}evaluate(G){return typeof this.d=="string"?!1:parseFloat(G.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(G){return G.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$oj=H;class O{static create(G,ge,ae=null){return V(ge,De=>new O(G,De,ae))}constructor(G,ge,ae){this.c=G,this.d=ge,this.f=ae,this.type=14}cmp(G){return G.type!==this.type?this.type-G.type:$e(this.c,this.d,G.c,G.d)}equals(G){return G.type===this.type?this.c===G.c&&this.d===G.d:!1}substituteConstants(){return this}evaluate(G){return typeof this.d=="string"?!1:parseFloat(G.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(G){return G.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$pj=O;class R{static create(G,ge,ae=null){return V(ge,De=>new R(G,De,ae))}constructor(G,ge,ae){this.c=G,this.d=ge,this.f=ae,this.type=15}cmp(G){return G.type!==this.type?this.type-G.type:$e(this.c,this.d,G.c,G.d)}equals(G){return G.type===this.type?this.c===G.c&&this.d===G.d:!1}substituteConstants(){return this}evaluate(G){return typeof this.d=="string"?!1:parseFloat(G.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(G){return G.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$qj=R;class B{static create(G,ge){return new B(G,ge)}constructor(G,ge){this.d=G,this.f=ge,this.type=7,this.c=null}cmp(G){if(G.type!==this.type)return this.type-G.type;if(this.d<G.d)return-1;if(this.d>G.d)return 1;const ge=this.f?this.f.source:"",ae=G.f?G.f.source:"";return ge<ae?-1:ge>ae?1:0}equals(G){if(G.type===this.type){const ge=this.f?this.f.source:"",ae=G.f?G.f.source:"";return this.d===G.d&&ge===ae}return!1}substituteConstants(){return this}evaluate(G){const ge=G.getValue(this.d);return this.f?this.f.test(ge):!1}serialize(){const G=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${G}`}keys(){return[this.d]}map(G){return G.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=T.create(this)),this.c}}e.$rj=B;class T{static create(G){return new T(G)}constructor(G){this.c=G,this.type=8}cmp(G){return G.type!==this.type?this.type-G.type:this.c.cmp(G.c)}equals(G){return G.type===this.type?this.c.equals(G.c):!1}substituteConstants(){return this}evaluate(G){return!this.c.evaluate(G)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(G){return new T(this.c.map(G))}negate(){return this.c}}e.$sj=T;function te(ve){let G=null;for(let ge=0,ae=ve.length;ge<ae;ge++){const De=ve[ge].substituteConstants();if(ve[ge]!==De&&G===null){G=[];for(let ye=0;ye<ge;ye++)G[ye]=ve[ye]}G!==null&&(G[ge]=De)}return G===null?ve:G}class Q{static create(G,ge,ae){return Q.d(G,ge,ae)}constructor(G,ge){this.expr=G,this.c=ge,this.type=6}cmp(G){if(G.type!==this.type)return this.type-G.type;if(this.expr.length<G.expr.length)return-1;if(this.expr.length>G.expr.length)return 1;for(let ge=0,ae=this.expr.length;ge<ae;ge++){const De=o(this.expr[ge],G.expr[ge]);if(De!==0)return De}return 0}equals(G){if(G.type===this.type){if(this.expr.length!==G.expr.length)return!1;for(let ge=0,ae=this.expr.length;ge<ae;ge++)if(!this.expr[ge].equals(G.expr[ge]))return!1;return!0}return!1}substituteConstants(){const G=te(this.expr);return G===this.expr?this:Q.create(G,this.c,!1)}evaluate(G){for(let ge=0,ae=this.expr.length;ge<ae;ge++)if(!this.expr[ge].evaluate(G))return!1;return!0}static d(G,ge,ae){const De=[];let ye=!1;for(const we of G)if(we){if(we.type===1){ye=!0;continue}if(we.type===0)return b.INSTANCE;if(we.type===6){De.push(...we.expr);continue}De.push(we)}if(De.length===0&&ye)return p.INSTANCE;if(De.length!==0){if(De.length===1)return De[0];De.sort(o);for(let we=1;we<De.length;we++)De[we-1].equals(De[we])&&(De.splice(we,1),we--);if(De.length===1)return De[0];for(;De.length>1;){const we=De[De.length-1];if(we.type!==9)break;De.pop();const he=De.pop(),K=De.length===0,Y=ce.create(we.expr.map(me=>Q.create([me,he],null,ae)),null,K);Y&&(De.push(Y),De.sort(o))}if(De.length===1)return De[0];if(ae){for(let we=0;we<De.length;we++)for(let he=we+1;he<De.length;he++)if(De[we].negate().equals(De[he]))return b.INSTANCE;if(De.length===1)return De[0]}return new Q(De,ge)}}serialize(){return this.expr.map(G=>G.serialize()).join(" && ")}keys(){const G=[];for(const ge of this.expr)G.push(...ge.keys());return G}map(G){return new Q(this.expr.map(ge=>ge.map(G)),null)}negate(){if(!this.c){const G=[];for(const ge of this.expr)G.push(ge.negate());this.c=ce.create(G,this,!0)}return this.c}}e.$tj=Q;class ce{static create(G,ge,ae){return ce.d(G,ge,ae)}constructor(G,ge){this.expr=G,this.c=ge,this.type=9}cmp(G){if(G.type!==this.type)return this.type-G.type;if(this.expr.length<G.expr.length)return-1;if(this.expr.length>G.expr.length)return 1;for(let ge=0,ae=this.expr.length;ge<ae;ge++){const De=o(this.expr[ge],G.expr[ge]);if(De!==0)return De}return 0}equals(G){if(G.type===this.type){if(this.expr.length!==G.expr.length)return!1;for(let ge=0,ae=this.expr.length;ge<ae;ge++)if(!this.expr[ge].equals(G.expr[ge]))return!1;return!0}return!1}substituteConstants(){const G=te(this.expr);return G===this.expr?this:ce.create(G,this.c,!1)}evaluate(G){for(let ge=0,ae=this.expr.length;ge<ae;ge++)if(this.expr[ge].evaluate(G))return!0;return!1}static d(G,ge,ae){let De=[],ye=!1;if(G){for(let we=0,he=G.length;we<he;we++){const K=G[we];if(K){if(K.type===0){ye=!0;continue}if(K.type===1)return p.INSTANCE;if(K.type===9){De=De.concat(K.expr);continue}De.push(K)}}if(De.length===0&&ye)return b.INSTANCE;De.sort(o)}if(De.length!==0){if(De.length===1)return De[0];for(let we=1;we<De.length;we++)De[we-1].equals(De[we])&&(De.splice(we,1),we--);if(De.length===1)return De[0];if(ae){for(let we=0;we<De.length;we++)for(let he=we+1;he<De.length;he++)if(De[we].negate().equals(De[he]))return p.INSTANCE;if(De.length===1)return De[0]}return new ce(De,ge)}}serialize(){return this.expr.map(G=>G.serialize()).join(" || ")}keys(){const G=[];for(const ge of this.expr)G.push(...ge.keys());return G}map(G){return new ce(this.expr.map(ge=>ge.map(G)),null)}negate(){if(!this.c){const G=[];for(const ge of this.expr)G.push(ge.negate());for(;G.length>1;){const ge=G.shift(),ae=G.shift(),De=[];for(const ye of oe(ge))for(const we of oe(ae))De.push(Q.create([ye,we],null,!1));G.unshift(ce.create(De,null,!1))}this.c=ce.create(G,this,!0)}return this.c}}e.$uj=ce;class le extends d{static all(){return le.d.values()}constructor(G,ge,ae){super(G,null),this.f=ge,typeof ae=="object"?le.d.push({...ae,key:G}):ae!==!0&&le.d.push({key:G,description:ae,type:ge!=null?typeof ge:void 0})}bindTo(G){return G.createKey(this.key,this.f)}getValue(G){return G.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(G){return I.create(this.key,G)}notEqualsTo(G){return E.create(this.key,G)}}e.$vj=le,le.d=[],e.$wj=(0,L.$ei)("contextKeyService");function se(ve,G){return ve<G?-1:ve>G?1:0}function $e(ve,G,ge,ae){return ve<ge?-1:ve>ge?1:G<ae?-1:G>ae?1:0}function ne(ve,G){if(ve.type===0||G.type===1)return!0;if(ve.type===9)return G.type===9?ke(ve.expr,G.expr):!1;if(G.type===9){for(const ge of G.expr)if(ne(ve,ge))return!0;return!1}if(ve.type===6){if(G.type===6)return ke(G.expr,ve.expr);for(const ge of ve.expr)if(ne(ge,G))return!0;return!1}return ve.equals(G)}e.$xj=ne;function ke(ve,G){let ge=0,ae=0;for(;ge<ve.length&&ae<G.length;){const De=ve[ge].cmp(G[ae]);if(De<0)return!1;De===0&&ge++,ae++}return ge===ve.length}function oe(ve){return ve.type===9?ve.expr:[ve]}}),define(Me[185],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,D.$ei)("environmentService"),e.$mi=(0,D.$fi)(e.$li)}),define(Me[96],Ae([1,0,152,4]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.ExtensionGalleryErrorCode=e.$Mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0,e.$zo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ao=new RegExp(e.$zo),e.$Bo="__web_extension",e.$Co="skipWalkthrough",e.$Do="extensionsSync",e.$Eo="dependecyOrPackExtensionInstall";function C(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Fo=C;function L(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Go=L;function M(n,a){switch(n){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ho=M;function g(n,a){return a==="web"&&!n.includes("web")}e.$Io=g;function f(n,a,h){return g(a,h)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===h}e.$Jo=f;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Ko=k;var F;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(F||(e.SortBy=F={}));var S;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(n){n.Install="install",n.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var w;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Lo=(0,P.$ei)("extensionGalleryService");var m;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var s;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class u extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Mo=u;var i;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(i||(e.ExtensionGalleryErrorCode=i={}));class r extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$No=r,e.$Oo=(0,P.$ei)("extensionManagementService"),e.$Po="extensionsIdentifiers/disabled",e.$Qo="extensionsIdentifiers/enabled",e.$Ro=(0,P.$ei)("IGlobalExtensionEnablementService"),e.$So=(0,P.$ei)("IExtensionTipsService"),e.$To=(0,D.localize2)(0,"Extensions"),e.$Uo=(0,D.localize2)(1,"Preferences")}),define(Me[42],Ae([1,0,50,19,13,16,2,154,4,21,12,40]),function(x,e,D,P,C,L,M,g,f,k,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,f.$ei)("fileService");function l(ne){return ne.create===!0}e.$Ck=l;var w;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var m;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function s(ne){const ke=ne;return!!ke&&typeof ke.onDidChange=="function"}e.$Dk=s;var u;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function i(ne){return!!(ne.capabilities&2)}e.$Ek=i;function r(ne){return!!(ne.capabilities&8)}e.$Fk=r;function n(ne){return!!(ne.capabilities&131072)}e.$Gk=n;function a(ne){return!!(ne.capabilities&4)}e.$Hk=a;function h(ne){return!!(ne.capabilities&16)}e.$Ik=h;function t(ne){return i(ne)?!!(ne.capabilities&16384):!1}e.$Jk=t;function $(ne){return i(ne)?!!(ne.capabilities&32768):!1}e.$Kk=$;function c(ne){return!!(ne.capabilities&65536)}e.$Lk=c;function o(ne){return!!(ne.capabilities&2048)}e.$Mk=o;var b;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class p extends Error{static create(ke,oe){const ve=new p(ke.toString(),oe);return v(ve,oe),ve}constructor(ke,oe){super(ke),this.code=oe}}e.$Nk=p;function d(ne,ke){return p.create(ne,ke)}e.$Ok=d;function I(ne){return ne||d((0,g.localize)(0,null),b.Unknown)}e.$Pk=I;function v(ne,ke){return ne.name=ke?`${ke} (FileSystemError)`:"FileSystemError",ne}e.$Qk=v;function y(ne){if(!ne)return b.Unknown;if(ne instanceof p)return ne.code;const ke=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!ke)return b.Unknown;switch(ke[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.$Rk=y;function E(ne){if(ne instanceof R)return ne.fileOperationResult;switch(y(ne)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.$Sk=E;var A;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class V{constructor(ke,oe,ve){this.resource=ke,this.operation=oe,this.target=ve}isOperation(ke){return this.operation===ke}}e.$Tk=V;var X;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(X||(e.FileChangeType=X={}));class H{constructor(ke,oe){this.c=oe,this.b=void 0,this.d=new S.$V(()=>{const ve=D.$ki.forUris(()=>this.c);return ve.fill(this.rawAdded.map(G=>[G,!0])),ve}),this.f=new S.$V(()=>{const ve=D.$ki.forUris(()=>this.c);return ve.fill(this.rawUpdated.map(G=>[G,!0])),ve}),this.g=new S.$V(()=>{const ve=D.$ki.forUris(()=>this.c);return ve.fill(this.rawDeleted.map(G=>[G,!0])),ve}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ve of ke){switch(ve.type){case 1:this.rawAdded.push(ve.resource);break;case 0:this.rawUpdated.push(ve.resource);break;case 2:this.rawDeleted.push(ve.resource);break}this.b!==H.a&&(typeof ve.cId=="number"?this.b===void 0?this.b=ve.cId:this.b!==ve.cId&&(this.b=H.a):this.b!==void 0&&(this.b=H.a))}}contains(ke,...oe){return this.h(ke,{includeChildren:!1},...oe)}affects(ke,...oe){return this.h(ke,{includeChildren:!0},...oe)}h(ke,oe,...ve){if(!ke)return!1;const G=ve.length>0;return!!((!G||ve.includes(1))&&(this.d.value.get(ke)||oe.includeChildren&&this.d.value.findSuperstr(ke))||(!G||ve.includes(0))&&(this.f.value.get(ke)||oe.includeChildren&&this.f.value.findSuperstr(ke))||(!G||ve.includes(2))&&(this.g.value.findSubstr(ke)||oe.includeChildren&&this.g.value.findSuperstr(ke)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ke){return this.b===ke}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=H,H.a=null;function O(ne,ke,oe){return!ne||!ke||ne===ke||ke.length>ne.length?!1:(ke.charAt(ke.length-1)!==P.sep&&(ke+=P.sep),oe?(0,C.$kf)(ne,ke):ne.indexOf(ke)===0)}e.$Vk=O;class R extends Error{constructor(ke,oe,ve){super(ke),this.fileOperationResult=oe,this.options=ve}}e.$Wk=R;class B extends R{constructor(ke,oe,ve,G){super(ke,oe,G),this.fileOperationResult=oe,this.size=ve}}e.$Xk=B;class T extends R{constructor(ke,oe,ve){super(ke,2,ve),this.stat=oe}}e.$Yk=T;var te;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var Q;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$7k="";function ce(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.$8k=ce;async function le(ne,ke){if(!ke.hasProvider(M.URI.from({scheme:ne.scheme})))return new Promise(oe=>{const ve=ke.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===ne.scheme&&G.added&&(ve.dispose(),oe())})})}e.$9k=le;class se{static formatSize(ke){return(0,L.$Wf)(ke)||(ke=0),ke<se.KB?(0,g.localize)(1,null,ke.toFixed(0)):ke<se.MB?(0,g.localize)(2,null,(ke/se.KB).toFixed(2)):ke<se.GB?(0,g.localize)(3,null,(ke/se.MB).toFixed(2)):ke<se.TB?(0,g.localize)(4,null,(ke/se.GB).toFixed(2)):(0,g.localize)(5,null,(ke/se.TB).toFixed(2))}}e.$0k=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;function $e(ne){const ke=typeof ne=="string"||ne?.scheme===F.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===F.Schemas.file?1024*se.MB:ke?10*se.MB:k.$i?50*se.MB:1024*se.MB}e.$$k=$e}),define(Me[71],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class D{constructor(...C){this.a=new Map;for(const[L,M]of C)this.set(L,M)}set(C,L){const M=this.a.get(C);return this.a.set(C,L),M}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$ci=D}),define(Me[186],Ae([1,0,11,15,6,70,184,4,71,187]),function(x,e,D,P,C,L,M,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;const F=!1;class S extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class l{constructor(u=new f.$ci,i=!1,r,n=F){this.f=u,this.g=i,this.h=r,this.i=n,this.o=new Set,this.f.set(g.$di,this),this._globalGraph=n?r?._globalGraph??new M.$Pq(a=>a):void 0}createChild(u){return new l(u,this.g,this,this.i)}invokeFunction(u,...i){const r=m.traceInvocation(this.i,u);let n=!1;try{return u({get:h=>{if(n)throw(0,P.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...i)}finally{n=!0,r.stop()}}createInstance(u,...i){let r,n;return u instanceof L.$bi?(r=m.traceCreation(this.i,u.ctor),n=this.j(u.ctor,u.staticArguments.concat(i),r)):(r=m.traceCreation(this.i,u),n=this.j(u,i,r)),r.stop(),n}j(u,i=[],r){const n=g._util.getServiceDependencies(u).sort((t,$)=>t.index-$.index),a=[];for(const t of n){const $=this.m(t.id,r);$||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),a.push($)}const h=n.length>0?n[0].index:i.length;if(i.length!==h){console.trace(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${i.length} static arguments`);const t=h-i.length;t>0?i=i.concat(new Array(t)):i=i.slice(0,h)}return Reflect.construct(u,i.concat(a))}k(u,i){if(this.f.get(u)instanceof L.$bi)this.f.set(u,i);else if(this.h)this.h.k(u,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const i=this.f.get(u);return!i&&this.h?this.h.l(u):i}m(u,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const r=this.l(u);return r instanceof L.$bi?this.q(u,r,i.branch(u,!0)):(i.branch(u,!1),r)}q(u,i,r){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,i,r)}finally{this.o.delete(u)}}r(u,i,r){const n=new M.$Pq(t=>t.id.toString());let a=0;const h=[{id:u,desc:i,_trace:r}];for(;h.length;){const t=h.pop();if(n.lookupOrInsertNode(t),a++>1e3)throw new S(n);for(const $ of g._util.getServiceDependencies(t.desc.ctor)){const c=this.l($.id);if(c||this.u(`[createInstance] ${u} depends on ${$.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String($.id)),c instanceof L.$bi){const o={id:$.id,desc:c,_trace:t._trace.branch($.id,!0)};n.insertEdge(t,o),h.push(o)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new S(n);break}for(const{data:$}of t){if(this.l($.id)instanceof L.$bi){const o=this.s($.id,$.desc.ctor,$.desc.staticArguments,$.desc.supportsDelayedInstantiation,$._trace);this.k($.id,o)}n.removeNode($)}}return this.l(u)}s(u,i,r=[],n,a){if(this.f.get(u)instanceof L.$bi)return this.t(u,i,r,n,a);if(this.h)return this.h.s(u,i,r,n,a);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(u,i,r=[],n,a){if(n){const h=new l(void 0,this.g,this,this.i);h.c=String(u);const t=new Map,$=new D.$xh(()=>{const c=h.j(i,r,a);for(const[o,b]of t){const p=c[o];if(typeof p=="function")for(const d of b)d.disposable=p.apply(c,d.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,o){if(!$.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let d=t.get(o);return d||(d=new k.$4c,t.set(o,d)),(v,y,E)=>{if($.isInitialized)return $.value[o](v,y,E);{const A={listener:[v,y,E],disposable:void 0},V=d.push(A);return(0,C.$Rc)(()=>{V(),A.disposable?.dispose()})}}}if(o in c)return c[o];const b=$.value;let p=b[o];return typeof p!="function"||(p=p.bind(b),c[o]=p),p},set(c,o,b){return $.value[o]=b,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,r,a)}u(u,i){if(i&&console.warn(u),this.g)throw new Error(u)}}e.$Qq=l;var w;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(w||(w={}));class m{static traceInvocation(u,i){return u?new m(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(u,i){return u?new m(1,i.name):m.c}constructor(u,i){this.type=u,this.name=i,this.g=Date.now(),this.h=[]}branch(u,i){const r=new m(3,u.toString());return this.h.push([u,i,r]),r}stop(){const u=Date.now()-this.g;m.f+=u;let i=!1;function r(a,h){const t=[],$=new Array(a+1).join("	");for(const[c,o,b]of h.h)if(o&&b){i=!0,t.push(`${$}CREATES -> ${c}`);const p=r(a+1,b);p&&t.push(p)}else t.push(`${$}uses -> ${c}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(u>2||i)&&m.all.add(n.join(`
`))}}e.$Rq=m,m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0}),define(Me[14],Ae([1,0,35,5,97,6,28,21,25,16,2,36,4]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,l.$ei)("logService"),e.$zj=(0,l.$ei)("loggerService");function w(){return new Date().toISOString()}function m(v){return(0,k.$Wf)(v)}e.$Aj=m;var s;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$Bj=s.Info;function u(v,y,E){switch(y){case s.Trace:v.trace(E);break;case s.Debug:v.debug(E);break;case s.Info:v.info(E);break;case s.Warning:v.warn(E);break;case s.Error:v.error(E);break;case s.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=u;function i(v,y=!1){let E="";for(let A=0;A<v.length;A++){let V=v[A];if(V instanceof Error&&(V=(0,D.$2i)(V,y)),typeof V=="object")try{V=JSON.stringify(V)}catch{}E+=(A>0?" ":"")+V}return E}class r extends L.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new P.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==s.Off&&this.b<=y}}e.$Dj=r;class n extends r{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...E){this.f(s.Trace)&&this.g(s.Trace,i([y,...E],!0))}debug(y,...E){this.f(s.Debug)&&this.g(s.Debug,i([y,...E]))}info(y,...E){this.f(s.Info)&&this.g(s.Info,i([y,...E]))}warn(y,...E){this.f(s.Warning)&&this.g(s.Warning,i([y,...E]))}error(y,...E){if(this.f(s.Error))if(y instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=y.stack,this.g(s.Error,i(A))}else this.g(s.Error,i([y,...E]))}flush(){}}e.$Ej=n;class a extends r{constructor(y=e.$Bj){super(),this.setLevel(y),this.g=!g.$c}trace(y,...E){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,y,...E):console.log(`[main ${w()}]`,y,...E))}debug(y,...E){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,y,...E):console.log(`[main ${w()}]`,y,...E))}info(y,...E){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,y,...E):console.log(`[main ${w()}]`,y,...E))}warn(y,...E){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,y,...E):console.warn(`[main ${w()}]`,y,...E))}error(y,...E){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,y,...E):console.error(`[main ${w()}]`,y,...E))}flush(){}}e.$Fj=a;class h extends r{constructor(y=e.$Bj,E=!0){super(),this.g=E,this.setLevel(y)}trace(y,...E){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...E):console.log(y,...E))}debug(y,...E){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...E):console.log(y,...E))}info(y,...E){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...E):console.log(y,...E))}warn(y,...E){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...E):console.log(y,...E))}error(y,...E){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...E):console.error(y,...E))}flush(){}}e.$Gj=h;class t extends r{constructor(y,E=e.$Bj){super(),this.g=y,this.setLevel(E)}trace(y,...E){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(y),...E])}debug(y,...E){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(y),...E])}info(y,...E){this.f(s.Info)&&this.g.log(s.Info,[this.h(y),...E])}warn(y,...E){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(y),...E])}error(y,...E){this.f(s.Error)&&this.g.log(s.Error,[this.h(y),...E])}h(y){return typeof y=="string"?y:(0,D.$2i)(y,this.f(s.Trace))}flush(){}}e.$Hj=t;class $ extends r{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const E of this.g)E.setLevel(y);super.setLevel(y)}trace(y,...E){for(const A of this.g)A.trace(y,...E)}debug(y,...E){for(const A of this.g)A.debug(y,...E)}info(y,...E){for(const A of this.g)A.info(y,...E)}warn(y,...E){for(const A of this.g)A.warn(y,...E)}error(y,...E){for(const A of this.g)A.error(y,...E)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$Ij=$;class c extends L.$Tc{constructor(y,E,A){if(super(),this.h=y,this.j=E,this.b=new M.$Ac,this.c=this.B(new P.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$5d),this.onDidChangeVisibility=this.g.event,A)for(const V of A)this.b.set(V.resource,{logger:void 0,info:V})}m(y){return(0,k.$Sf)(y)?[...this.b.values()].find(E=>E.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,E){const A=this.n(y),V=(0,k.$Sf)(y)?y:E?.id??(0,C.$5i)(A.toString()).toString(16);let X=this.b.get(A)?.logger;const H=E?.logLevel==="always"?s.Trace:E?.logLevel;X||(X=this.s(A,H??this.getLogLevel(A)??this.h,{...E,id:V}));const O={logger:X,info:{resource:A,id:V,logLevel:H,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(O.info),this.b.set(A,O),X}n(y){return(0,k.$Sf)(y)?(0,f.$Rg)(this.j,`${y}.log`):y}setLogLevel(y,E){if(F.URI.isUri(y)){const A=y,V=E,X=this.b.get(A);X&&V!==X.info.logLevel&&(X.info.logLevel=V===this.h?void 0:V,X.logger?.setLevel(V),this.b.set(X.info.resource,X),this.f.fire([A,V]))}else{this.h=y;for(const[A,V]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,E){const A=this.m(y);A&&E!==!A.info.hidden&&(A.info.hidden=!E,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,E]))}getLogLevel(y){let E;return y&&(E=this.b.get(y)?.info.logLevel),E??this.h}registerLogger(y){const E=this.b.get(y.resource);E?E.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const E=this.b.get(y);E&&(E.logger&&E.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=c;class o{constructor(){this.onDidChangeLogLevel=new P.$5d().event}setLevel(y){}getLevel(){return s.Info}trace(y,...E){}debug(y,...E){}info(y,...E){}warn(y,...E){}error(y,...E){}critical(y,...E){}dispose(){}flush(){}}e.$Kj=o;class b extends o{}e.$Lj=b;function p(v){if(v.verbose)return s.Trace;if(typeof v.logLevel=="string"){const y=I(v.logLevel.toLowerCase());if(y!==void 0)return y}return e.$Bj}e.$Mj=p;function d(v){switch(v){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Nj=d;function I(v){switch(v){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Oj=I,e.$Pj=new S.$vj("logLevel",d(s.Info))}),define(Me[188],Ae([1,0,6,14]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=void 0;class C extends D.$Tc{constructor(M,g=[]){super(),this.a=new P.$Ij([M,...g]),this.B(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...g){this.a.trace(M,...g)}debug(M,...g){this.a.debug(M,...g)}info(M,...g){this.a.info(M,...g)}warn(M,...g){this.a.warn(M,...g)}error(M,...g){this.a.error(M,...g)}flush(){this.a.flush()}}e.$DP=C}),define(Me[98],Ae([1,0,32,155,4]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var M;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(f){function k(m,s){return s-m}f.compare=k;const F=Object.create(null);F[f.Error]=(0,P.localize)(0,null),F[f.Warning]=(0,P.localize)(1,null),F[f.Info]=(0,P.localize)(2,null);function S(m){return F[m]||""}f.toString=S;function l(m){switch(m){case D.default.Error:return f.Error;case D.default.Warning:return f.Warning;case D.default.Info:return f.Info;case D.default.Ignore:return f.Hint}}f.fromSeverity=l;function w(m){switch(m){case f.Error:return D.default.Error;case f.Warning:return D.default.Warning;case f.Info:return D.default.Info;case f.Hint:return D.default.Ignore}}f.toSeverity=w}(M||(e.MarkerSeverity=M={}));var g;(function(f){const k="";function F(l){return S(l,!0)}f.makeKey=F;function S(l,w){const m=[k];return l.source?m.push(l.source.replace("\xA6","\\\xA6")):m.push(k),l.code?typeof l.code=="string"?m.push(l.code.replace("\xA6","\\\xA6")):m.push(l.code.value.replace("\xA6","\\\xA6")):m.push(k),l.severity!==void 0&&l.severity!==null?m.push(M.toString(l.severity)):m.push(k),l.message&&w?m.push(l.message.replace("\xA6","\\\xA6")):m.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?m.push(l.startLineNumber.toString()):m.push(k),l.startColumn!==void 0&&l.startColumn!==null?m.push(l.startColumn.toString()):m.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?m.push(l.endLineNumber.toString()):m.push(k),l.endColumn!==void 0&&l.endColumn!==null?m.push(l.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}f.makeKeyOptionalMessage=S})(g||(e.IMarkerData=g={})),e.$Mt=(0,C.$ei)("markerService")}),define(Me[189],Ae([1,0,5,32,4]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.NotificationsFilter=e.$Dv=e.NeverShowAgainScope=e.NotificationPriority=e.$Cv=e.Severity=void 0,e.Severity=P.default,e.$Cv=(0,C.$ei)("notificationService");var L;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var M;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function g(S){if(S){const l=S;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$Dv=g;var f;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class k{constructor(){this.progress=new F,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Ev=k;class F{infinite(){}done(){}total(l){}worked(l){}}e.$Fv=F}),define(Me[190],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,D.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"});var Xe=this&&this.__decorate||function(x,e,D,P){var C=arguments.length,L=C<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,D):P,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(x,e,D,P);else for(var g=x.length-1;g>=0;g--)(M=x[g])&&(L=(C<3?M(L):C>3?M(e,D,L):M(e,D))||L);return C>3&&L&&Object.defineProperty(e,D,L),L},He=this&&this.__param||function(x,e){return function(D,P){e(D,P,x)}};define(Me[99],Ae([1,0,11,22,6,4]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.ProgressLocation=e.$Gv=void 0,e.$Gv=(0,L.$ei)("progressService");var M;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Hv=Object.freeze({total(){},worked(){},done(){}});class g{get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Iv=g,g.None=Object.freeze({report(){}});class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const w=this.d;this.d=()=>{w?.(),l()}}):Promise.resolve()}}e.$Jv=f;let k=class extends C.$Tc{constructor(l,w){super(),this.a=new D.$Bh,w.withProgress(l,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Kv=k,e.$Kv=k=Xe([He(1,e.$Gv)],k);class F extends C.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Sc)}start(l){this.stop();const w=++this.a,m=new P.$ce;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>m.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:w,token:m.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Lv=F,e.$Mv=(0,L.$ei)("editorProgressService")}),define(Me[30],Ae([1,0,55,16]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0;class C{constructor(){this.a=new Map}add(M,g){D.ok(P.$Sf(M)),D.ok(P.$Uf(g)),D.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,g)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$Un=new C}),define(Me[72],Ae([1,0,5,30]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=void 0,e.$Vn={JSONContribution:"base.contributions.json"};function C(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class L{constructor(){this.b=new D.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,k){this.a[C(f)]=k,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const M=new L;P.$Un.add(e.$Vn.JSONContribution,M)}),define(Me[56],Ae([1,0,18,5,16,149,46,72,30]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ConfigurationScope=e.$Zn=e.EditPresentationTypes=void 0;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$Zn={Configuration:"base.contributions.configuration"};var F;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F||(e.ConfigurationScope=F={})),e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n="vscode://schemas/settings/resourceLanguage",e.$8n="vscode://schemas/settings/configurationDefaults";const S=f.$Un.as(g.$Vn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new P.$5d,this.onDidSchemaChange=this.i.event,this.j=new P.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$7n,this.g),this.v()}registerConfiguration(t,$=!0){this.registerConfigurations([t],$)}registerConfigurations(t,$=!0){const c=new Set;this.n(t,$,c),S.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const $=new Set;this.o(t,$),S.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:$})}updateConfigurations({add:t,remove:$}){const c=new Set;this.o($,c),this.n(t,!1,c),S.registerSchema(e.$7n,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const $=new Set;this.k(t,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}k(t,$){const c=[];for(const{overrides:o,source:b}of t)for(const p in o)if($.add(p),e.$0n.test(p)){const d=this.a.get(p),I=d?.valuesSources??new Map;if(b)for(const A of Object.keys(o[p]))I.set(A,b);const v={...d?.value||{},...o[p]};this.a.set(p,{source:b,value:v,valuesSources:I});const y=(0,M.$Ui)(p),E={type:"object",default:v,description:L.localize(1,null,y),$ref:e.$7n,defaultDefaultValue:v,source:C.$Sf(b)?void 0:b,defaultValueSource:b};c.push(...s(p)),this.d[p]=E,this.b.properties[p]=E}else{this.a.set(p,{value:o[p],source:b});const d=this.d[p];d&&(this.w(p,d),this.r(p,d))}this.m(c)}deregisterDefaultConfigurations(t){const $=new Set;this.l(t,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}l(t,$){for(const{overrides:c,source:o}of t)for(const b in c){const p=this.a.get(b),d=C.$Sf(o)?o:o?.id,I=C.$Sf(p?.source)?p?.source:p?.source?.id;if(d===I)if($.add(b),this.a.delete(b),e.$0n.test(b))delete this.d[b],delete this.b.properties[b];else{const v=this.d[b];v&&(this.w(b,v),this.r(b,v))}}this.u()}deltaConfiguration(t){let $=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),$=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),$=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:$})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const $ of t)this.h.add($);this.u()}n(t,$,c){t.forEach(o=>{this.p(o,$,o.extensionInfo,o.restrictedProperties,void 0,c),this.c.push(o),this.q(o)})}o(t,$){const c=o=>{if(o.properties)for(const b in o.properties){$.add(b);const p=this.d[b];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[b],this.s(b,o.properties[b])}o.allOf?.forEach(b=>c(b))};for(const o of t){c(o);const b=this.c.indexOf(o);b!==-1&&this.c.splice(b,1)}}p(t,$=!0,c,o,b=3,p){b=C.$2f(t.scope)?b:t.scope;const d=t.properties;if(d)for(const v in d){const y=d[v];if($&&n(v,y)){delete d[v];continue}if(y.source=c,y.defaultDefaultValue=d[v].default,this.w(v,y),e.$0n.test(v)?y.scope=void 0:(y.scope=C.$2f(y.scope)?b:y.scope,y.restricted=C.$2f(y.restricted)?!!o?.includes(v):y.restricted),d[v].hasOwnProperty("included")&&!d[v].included){this.f[v]=d[v],delete d[v];continue}else this.d[v]=d[v],d[v].policy?.name&&this.e.set(d[v].policy.name,v);!d[v].deprecationMessage&&d[v].markdownDeprecationMessage&&(d[v].deprecationMessage=d[v].markdownDeprecationMessage),p.add(v)}const I=t.allOf;if(I)for(const v of I)this.p(v,$,c,o,b,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const $=c=>{const o=c.properties;if(o)for(const p in o)this.r(p,o[p]);c.allOf?.forEach($)};$(t)}r(t,$){switch(e.$1n.properties[t]=$,$.scope){case 1:e.$2n.properties[t]=$;break;case 2:e.$3n.properties[t]=$;break;case 6:e.$4n.properties[t]=$;break;case 3:e.$5n.properties[t]=$;break;case 4:e.$6n.properties[t]=$;break;case 5:e.$6n.properties[t]=$,this.g.properties[t]=$;break}}s(t,$){switch(delete e.$1n.properties[t],$.scope){case 1:delete e.$2n.properties[t];break;case 2:delete e.$3n.properties[t];break;case 6:delete e.$4n.properties[t];break;case 3:delete e.$5n.properties[t];break;case 4:case 5:delete e.$6n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const $=`[${t}]`,c={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$7n};this.w($,c),e.$1n.properties[$]=c,e.$2n.properties[$]=c,e.$3n.properties[$]=c,e.$4n.properties[$]=c,e.$5n.properties[$]=c,e.$6n.properties[$]=c}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$7n};e.$1n.patternProperties[e.$9n]=t,e.$2n.patternProperties[e.$9n]=t,e.$3n.patternProperties[e.$9n]=t,e.$4n.patternProperties[e.$9n]=t,e.$5n.patternProperties[e.$9n]=t,e.$6n.patternProperties[e.$9n]=t,this.i.fire()}w(t,$){const c=this.a.get(t);let o=c?.value,b=c?.source;C.$Zf(o)&&(o=$.defaultDefaultValue,b=void 0),C.$Zf(o)&&(o=i($.type)),$.default=o,$.defaultValueSource=b}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.$9n=`^(${w})+$`,e.$0n=new RegExp(e.$9n);function s(h){const t=[];if(e.$0n.test(h)){let $=m.exec(h);for(;$?.length;){const c=$[1].trim();c&&t.push(c),$=m.exec(h)}}return(0,D.$Mb)(t)}e.$$n=s;function u(h){return h.reduce((t,$)=>`${t}[${$}]`,"")}e.$_n=u;function i(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ao=i;const r=new l;f.$Un.add(e.$Zn.Configuration,r);function n(h,t){return h.trim()?e.$0n.test(h)?L.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$bo=n;function a(){const h=[],t=r.getConfigurationProperties();for(const $ of Object.keys(t))h.push([$,t[$].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$co=a}),define(Me[191],Ae([1,0,18,5,120,6,28,26,16,2,46,56,30]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function w($){return Object.isFrozen($)?$:g.$Jn($)}class m{constructor(c={},o=[],b=[],p){this.b=c,this.c=o,this.d=b,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(o=>{if(o instanceof m)return o;const b=new s("");return b.parseRaw(o),b.configurationModel});this.f=c.reduce((o,b)=>b===o?b:o.merge(b),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,F.$Si)(this.contents,c):this.contents}inspect(c,o){const b=this;return{get value(){return w(b.rawConfiguration.getValue(c))},get override(){return o?w(b.rawConfiguration.getOverrideValue(c,o)):void 0},get merged(){return w(o?b.rawConfiguration.override(o).getValue(c):b.rawConfiguration.getValue(c))},get overrides(){const p=[];for(const{contents:d,identifiers:I,keys:v}of b.rawConfiguration.overrides){const y=new m(d,v).getValue(c);y!==void 0&&p.push({identifiers:I,value:y})}return p.length?w(p):void 0}}}getOverrideValue(c,o){const b=this.i(o);return b?c?(0,F.$Si)(b,c):b:void 0}getKeysForOverrideIdentifier(c){const o=[];for(const b of this.overrides)b.identifiers.includes(c)&&o.push(...b.keys);return D.$Mb(o)}getAllOverrideIdentifiers(){const c=[];for(const o of this.overrides)c.push(...o.identifiers);return D.$Mb(c)}override(c){let o=this.a.get(c);return o||(o=this.g(c),this.a.set(c,o)),o}merge(...c){const o=g.$In(this.contents),b=g.$In(this.overrides),p=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const I of c)if(d.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const v of I.overrides){const[y]=b.filter(E=>D.$ub(E.identifiers,v.identifiers));y?(this.h(y.contents,v.contents),y.keys.push(...v.keys),y.keys=D.$Mb(y.keys)):b.push(g.$In(v))}for(const v of I.keys)p.indexOf(v)===-1&&p.push(v)}return new m(o,p,b,d.every(I=>I instanceof m)?void 0:d)}g(c){const o=this.i(c);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const b={};for(const p of D.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let d=this.contents[p];const I=o[p];I&&(typeof d=="object"&&typeof I=="object"?(d=g.$In(d),this.h(d,I)):d=I),b[p]=d}return new m(b,this.keys,this.overrides)}h(c,o){for(const b of Object.keys(o)){if(b in c&&f.$Uf(c[b])&&f.$Uf(o[b])){this.h(c[b],o[b]);continue}c[b]=g.$In(o[b])}}i(c){let o=null,b=null;const p=d=>{d&&(b?this.h(b,d):b=g.$In(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===c?o=d.contents:d.identifiers.includes(c)&&p(d.contents);return p(o),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,o){this.j(c,o,!0)}setValue(c,o){this.j(c,o,!1)}removeValue(c){const o=this.keys.indexOf(c);o!==-1&&(this.keys.splice(o,1),(0,F.$Ri)(this.contents,c),S.$0n.test(c)&&this.overrides.splice(this.overrides.findIndex(b=>D.$ub(b.identifiers,(0,S.$$n)(c))),1))}j(c,o,b){(0,F.$Qi)(this.contents,c,o,p=>console.error(p)),b=b||this.keys.indexOf(c)===-1,b&&this.keys.push(c),S.$0n.test(c)&&this.overrides.push({identifiers:(0,S.$$n)(c),keys:Object.keys(this.contents[c]),contents:(0,F.$Pi)(this.contents[c],p=>console.error(p))})}}e.$do=m;class s{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,o){if(!f.$2f(c)){const b=this.g(c);this.parseRaw(b,o)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,o){this.a=c;const{contents:b,keys:p,overrides:d,restricted:I,hasExcludedProperties:v}=this.h(c,o);this.b=new m(b,p,d,v?[c]:void 0),this.c=I||[]}g(c){let o={},b=null,p=[];const d=[],I=[];function v(E){Array.isArray(p)?p.push(E):b!==null&&(p[b]=E)}const y={onObjectBegin:()=>{const E={};v(E),d.push(p),p=E,b=null},onObjectProperty:E=>{b=E},onObjectEnd:()=>{p=d.pop()},onArrayBegin:()=>{const E=[];v(E),d.push(p),p=E,b=null},onArrayEnd:()=>{p=d.pop()},onLiteralValue:v,onError:(E,A,V)=>{I.push({error:E,offset:A,length:V})}};if(c)try{C.$wn(c,y),o=p[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return o}h(c,o){const b=l.$Un.as(S.$Zn.Configuration).getConfigurationProperties(),p=this.i(c,b,!0,o);c=p.raw;const d=(0,F.$Pi)(c,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),I=Object.keys(c),v=this.j(c,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:d,keys:I,overrides:v,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(c,o,b,p){let d=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:d};const I={},v=[];for(const y in c)if(S.$0n.test(y)&&b){const E=this.i(c[y],o,!1,p);I[y]=E.raw,d=d||E.hasExcludedProperties,v.push(...E.restricted)}else{const E=o[y],A=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&v.push(y),!p.exclude?.includes(y)&&(p.include?.includes(y)||(A===void 0||p.scopes===void 0||p.scopes.includes(A))&&!(p.skipRestricted&&E?.restricted))?I[y]=c[y]:d=!0}return{raw:I,restricted:v,hasExcludedProperties:d}}j(c,o){const b=[];for(const p of Object.keys(c))if(S.$0n.test(p)){const d={};for(const I in c[p])d[I]=c[p][I];b.push({identifiers:(0,S.$$n)(p),keys:Object.keys(d),contents:(0,F.$Pi)(d,o)})}return b}}e.$eo=s;class u extends L.$Tc{constructor(c,o,b,p){super(),this.c=c,this.f=o,this.g=p,this.b=this.B(new P.$5d),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,d=>d.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&b.isEqual(d.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fo=u;class i{constructor(c,o,b,p,d,I,v,y,E,A,V,X,H){this.a=c,this.b=o,this.c=b,this.overrideIdentifiers=p,this.d=d,this.f=I,this.g=v,this.h=y,this.i=E,this.j=A,this.k=V,this.l=X,this.m=H}get value(){return w(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class r{constructor(c,o,b,p,d=new m,I=new m,v=new M.$Ac,y=new m,E=new M.$Ac){this.c=c,this.d=o,this.f=b,this.g=p,this.h=d,this.i=I,this.j=v,this.l=y,this.m=E,this.a=null,this.b=new M.$Ac,this.n=null}getValue(c,o,b){return this.p(c,o,b).getValue(c)}updateValue(c,o,b={}){let p;b.resource?(p=this.m.get(b.resource),p||(p=new m,this.m.set(b.resource,p))):p=this.l,o===void 0?p.removeValue(c):p.setValue(c,o),b.resource||(this.a=null)}inspect(c,o,b){const p=this.p(c,o,b),d=this.t(o.resource,b),I=o.resource?this.m.get(o.resource)||this.l:this.l,v=new Set;for(const y of p.overrides)for(const E of y.identifiers)p.getOverrideValue(c,E)!==void 0&&v.add(E);return new i(c,o,p.getValue(c),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,d||void 0,I)}keys(c){const o=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,o){this.j.set(c,o),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,o){const b=[];if(!o){const{added:p,updated:d,removed:I}=h(this.c,c);o=[...p,...d,...I]}for(const p of o)for(const d of(0,S.$$n)(p)){const I=this.c.getKeysForOverrideIdentifier(d),v=c.getKeysForOverrideIdentifier(d),y=[...v.filter(E=>I.indexOf(E)===-1),...I.filter(E=>v.indexOf(E)===-1),...I.filter(E=>!g.$Mn(this.c.override(d).getValue(E),c.override(d).getValue(E)))];b.push([d,y])}return this.updateDefaultConfiguration(c),{keys:o,overrides:b}}compareAndUpdatePolicyConfiguration(c){const{added:o,updated:b,removed:p}=h(this.d,c),d=[...o,...b,...p];return d.length&&this.updatePolicyConfiguration(c),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:o,updated:b,removed:p,overrides:d}=h(this.applicationConfiguration,c),I=[...o,...b,...p];return I.length&&this.updateApplicationConfiguration(c),{keys:I,overrides:d}}compareAndUpdateLocalUserConfiguration(c){const{added:o,updated:b,removed:p,overrides:d}=h(this.localUserConfiguration,c),I=[...o,...b,...p];return I.length&&this.updateLocalUserConfiguration(c),{keys:I,overrides:d}}compareAndUpdateRemoteUserConfiguration(c){const{added:o,updated:b,removed:p,overrides:d}=h(this.remoteUserConfiguration,c),I=[...o,...b,...p];return I.length&&this.updateRemoteUserConfiguration(c),{keys:I,overrides:d}}compareAndUpdateWorkspaceConfiguration(c){const{added:o,updated:b,removed:p,overrides:d}=h(this.workspaceConfiguration,c),I=[...o,...b,...p];return I.length&&this.updateWorkspaceConfiguration(c),{keys:I,overrides:d}}compareAndUpdateFolderConfiguration(c,o){const b=this.folderConfigurations.get(c),{added:p,updated:d,removed:I,overrides:v}=h(b,o),y=[...p,...d,...I];return(y.length||!b)&&this.updateFolderConfiguration(c,o),{keys:y,overrides:v}}compareAndDeleteFolderConfiguration(c){const o=this.folderConfigurations.get(c);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:b,updated:p,removed:d,overrides:I}=h(o,void 0);return{keys:[...b,...p,...d],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,o,b){let p=this.q(o,b);return o.overrideIdentifier&&(p=p.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(p=p.merge(this.d)),p}q({resource:c},o){let b=this.r();if(o&&c){const p=o.getFolder(c);p&&(b=this.s(p.uri)||b);const d=this.m.get(c);d&&(b=b.merge(d))}return b}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let o=this.b.get(c);if(!o){const b=this.r(),p=this.j.get(c);p?(o=b.merge(p),this.b.set(c,o)):o=b}return o}t(c,o){if(o&&c){const b=o.getFolder(c);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,o)=>{const{contents:b,overrides:p,keys:d}=this.j.get(o);return c.push([o,{contents:b,overrides:p,keys:d}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(o=>c.add(o)),this.userConfiguration.keys.forEach(o=>c.add(o)),this.i.keys.forEach(o=>c.add(o)),this.j.forEach(o=>o.keys.forEach(b=>c.add(b))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>c.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>c.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>c.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(b=>c.add(b))),[...c.values()]}v(c){const o=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(b=>o.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>o.add(b)),this.i.getKeysForOverrideIdentifier(c).forEach(b=>o.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(c).forEach(p=>o.add(p))),[...o.values()]}static parse(c){const o=this.w(c.defaults),b=this.w(c.policy),p=this.w(c.application),d=this.w(c.user),I=this.w(c.workspace),v=c.folders.reduce((y,E)=>(y.set(k.URI.revive(E[0]),this.w(E[1])),y),new M.$Ac);return new r(o,b,p,d,new m,I,v,new m,new M.$Ac)}static w(c){return new m(c.contents,c.keys,c.overrides)}}e.$go=r;function n(...$){if($.length===0)return{keys:[],overrides:[]};if($.length===1)return $[0];const c=new Set,o=new Map;for(const p of $)p.keys.forEach(d=>c.add(d)),p.overrides.forEach(([d,I])=>{const v=(0,M.$xc)(o,d,new Set);I.forEach(y=>v.add(y))});const b=[];return o.forEach((p,d)=>b.push([d,[...p.values()]])),{keys:[...c.values()],overrides:b}}e.$ho=n;class a{constructor(c,o,b,p){this.change=c,this.f=o,this.g=b,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const d of c.keys)this.affectedKeys.add(d);for(const[,d]of c.overrides)for(const I of d)this.affectedKeys.add(I);this.d=this.a;for(const d of this.affectedKeys)this.d+=d+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(c,o){const b=this.a+c,p=this.d.indexOf(b);if(p<0)return!1;const d=p+b.length;if(d>=this.d.length)return!1;const I=this.d.charCodeAt(d);if(I!==this.b&&I!==this.c)return!1;if(o){const v=this.previousConfiguration?this.previousConfiguration.getValue(c,o,this.f?.workspace):void 0,y=this.g.getValue(c,o,this.h);return!g.$Mn(v,y)}return!0}}e.$io=a;function h($,c){const{added:o,removed:b,updated:p}=t(c?.rawConfiguration,$?.rawConfiguration),d=[],I=$?.getAllOverrideIdentifiers()||[],v=c?.getAllOverrideIdentifiers()||[];if(c){const y=v.filter(E=>!I.includes(E));for(const E of y)d.push([E,c.getKeysForOverrideIdentifier(E)])}if($){const y=I.filter(E=>!v.includes(E));for(const E of y)d.push([E,$.getKeysForOverrideIdentifier(E)])}if(c&&$){for(const y of I)if(v.includes(y)){const E=t({contents:$.getOverrideValue(void 0,y)||{},keys:$.getKeysForOverrideIdentifier(y)},{contents:c.getOverrideValue(void 0,y)||{},keys:c.getKeysForOverrideIdentifier(y)});d.push([y,[...E.added,...E.removed,...E.updated]])}}return{added:o,removed:b,updated:p,overrides:d}}function t($,c){const o=$?c?$.keys.filter(d=>c.keys.indexOf(d)===-1):[...$.keys]:[],b=c?$?c.keys.filter(d=>$.keys.indexOf(d)===-1):[...c.keys]:[],p=[];if($&&c){for(const d of c.keys)if($.keys.indexOf(d)!==-1){const I=(0,F.$Si)(c.contents,d),v=(0,F.$Si)($.contents,d);g.$Mn(I,v)||p.push(d)}}return{added:o,removed:b,updated:p}}}),define(Me[100],Ae([1,0,15,4]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.RemoteAuthorityResolverErrorCode=e.$il=e.$hl=e.RemoteConnectionType=e.$gl=void 0,e.$gl=(0,P.$ei)("remoteAuthorityResolverService");var C;(function(F){F[F.WebSocket=0]="WebSocket",F[F.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$hl=L;class M{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$il=M;var g;(function(F){F.Unknown="Unknown",F.NotAvailable="NotAvailable",F.TemporarilyNotAvailable="TemporarilyNotAvailable",F.NoResolverFound="NoResolverFound",F.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class f extends D.$bb{static isNotAvailable(S){return S instanceof f&&S._code===g.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof f&&S._code===g.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof f&&S._code===g.NoResolverFound}static isInvalidAuthority(S){return S instanceof f&&S._code===g.InvalidAuthority}static isHandled(S){return S instanceof f&&S.isHandled}constructor(S,l=g.Unknown,w){super(S),this._message=S,this._code=l,this._detail=w,this.isHandled=l===g.NotAvailable&&w===!0,Object.setPrototypeOf(this,f.prototype)}}e.$jl=f;function k(F){const S=F.indexOf("+");return S===-1?F:F.substring(0,S)}e.$kl=k}),define(Me[57],Ae([1,0,12]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function P(k){return k.scheme===D.Schemas.vscodeRemote?k.authority:void 0}e.$ll=P;function C(k){if(!k)return;const F=k.indexOf("+");return F<0?k:k.substr(0,F)}e.$ml=C;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.$nl=L;function M(k){const{host:F,port:S}=f(k);if(typeof S>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:F,port:S}}e.$ol=M;function g(k,F){let{host:S,port:l}=f(k);return typeof l>"u"&&(l=F),{host:S,port:l}}e.$pl=g;function f(k){const F=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(F)return{host:F[1],port:parseInt(F[2],10)};const S=k.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const l=k.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:k,port:void 0}}}),define(Me[20],Ae([1,0,13,4,57]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.TargetPlatform=e.ExtensionType=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=void 0,e.$rm="extensions.user.cache",e.$sm="extensions.builtin.cache",e.$tm="undefined_publisher",e.$um=["ui","workspace","web"];function L(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$vm=L,e.$wm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var g;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class f{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,i){if(typeof u>"u"||u===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof u=="string"||typeof i=="string"){const r=typeof u=="string"?u:u.value,n=typeof i=="string"?i:i.value;return D.$jf(r,n)}return u._lower===i._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$xm=f;class k{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const i of u)this.add(i)}add(u){this.c.add(f.toKey(u))}delete(u){return this.c.delete(f.toKey(u))}has(u){return this.c.has(f.toKey(u))}}e.$ym=k;class F{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(f.toKey(u))}get(u){return this.c.get(f.toKey(u))}has(u){return this.c.has(f.toKey(u))}set(u,i){this.c.set(f.toKey(u),i)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zm=F;function S(s){return l(s)}e.$Am=S;function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$Bm=l;function w(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$Cm=w;function m(s,u){if(u){const i=`onResolveRemoteAuthority:${(0,C.$ml)(u)}`;return!!s.activationEvents?.includes(i)}return!1}e.$Dm=m,e.$Em=(0,P.$ei)("IBuiltinExtensionsScannerService")}),define(Me[101],Ae([1,0,15,20]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(M,g){this.a.set(M,g)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const g=Object.create(null);for(const f of M){const k=this.readActivationEvents(f);k.length>0&&(g[P.$xm.toKey(f.identifier)]=k)}return g}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const g=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let f=0;f<g.length;f++)g[f]==="onUri"&&(g[f]=`onUri:${P.$xm.toKey(M.identifier)}`);if(!M.contributes)return g;for(const f in M.contributes){const k=this.a.get(f);if(!k)continue;const F=M.contributes[f],S=Array.isArray(F)?F:[F];try{k(S,g)}catch(l){(0,D.$1)(l)}}return g}}e.$AF=C,e.$BF=new C}),define(Me[192],Ae([1,0,21,73,34]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=void 0;function L(f){if(D.$o===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function M(f,k,F,S,l,w,m,s,u){const i=Object.create(null);i["common.machineId"]=w,i["common.sqmId"]=m,i.sessionID=(0,C.$Ag)()+Date.now(),i.commitHash=S,i.version=l,i["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,D.$b)(D.$o),i["common.nodePlatform"]=P.$dc,i["common.nodeArch"]=F,i["common.product"]=u||"desktop",s&&(i["common.msftInternal"]=s);let r=0;const n=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),D.$f&&(i["common.snap"]="true");const a=L(k);return a&&(i["common.platformDetail"]=a),i}e.$Vo=M;function g(f){const k=P.env.USERDNSDOMAIN;if(!k)return!1;const F=k.toLowerCase();return f.some(S=>F===S)}e.$Wo=g}),define(Me[193],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,D.$ei)("telemetryService"),e.$Gl=(0,D.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var P;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Me[58],Ae([1,0,26,16,57,192,193]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0;class g{constructor($){this.value=$,this.isTrustedTelemetryValue=!0}}e.$Xo=g;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Yo=f,e.$Zo=new f;class k{async publicLog($,c,o){}async publicLogError($,c,o){}}e.$1o=k,e.$2o="telemetry",e.$3o="extensionTelemetryLog",e.$4o={log:()=>null,flush:()=>Promise.resolve(null)};function F(t,$){return!$.isBuilt&&!$.disableTelemetry?!0:!($.disableTelemetry||!t.enableTelemetry)}e.$5o=F;function S(t,$){return $.extensionTestsLocationURI?!0:!($.isBuilt||$.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$6o=S;function l(t){const $=t.getValue(M.$Nl),c=t.getValue(M.$Ol);if(t.getValue(M.$Pl)===!1||c===!1)return 0;switch($??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$7o=l;function w(t){const $={},c={},o={};u(t,o);for(let b in o){b=b.length>150?b.substr(b.length-149):b;const p=o[b];typeof p=="number"?c[b]=p:typeof p=="boolean"?c[b]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${p.length}`),$[b]=p.substring(0,8191)):typeof p<"u"&&p!==null&&($[b]=p)}return{properties:$,measurements:c}}e.$8o=w;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const $=(0,C.$ml)(t);return m.has($)?$:"other"}e.$9o=s;function u(t,$,c=0,o){if(t)for(const b of Object.getOwnPropertyNames(t)){const p=t[b],d=o?o+b:b;Array.isArray(p)?$[d]=(0,D.$Nn)(p):p instanceof Date?$[d]=p.toISOString():(0,P.$Uf)(p)?c<2?u(p,$,c+1,d+"."):$[d]=(0,D.$Nn)(p):$[d]=p}}function i(t,$){const c=t.msftInternalDomains||[],o=$.getValue("telemetry.internalTesting");return(0,L.$Wo)(c)||o}e.$0o=i;function r(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$$o=r;function n(t,$){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const o=[];for(const I of $)for(;;){const v=I.exec(t);if(!v)break;o.push([v.index,I.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(c="";;){const I=p.exec(t);if(!I)break;const v=o.some(([y,E])=>I.index<E&&y<p.lastIndex);!b.test(I[0])&&!v&&(c+=t.substring(d,I.index)+"<REDACTED: user-file-path>",d=p.lastIndex)}return d<t.length&&(c+=t.substr(d)),c}function a(t){if(!t)return t;const $=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of $)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,$){return(0,D.$Kn)(t,c=>{if(c instanceof g||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let o=c.replaceAll("%20"," ");o=n(o,$);for(const b of $)o=o.replace(b,"");return o=a(o),o}})}e.$_o=h}),define(Me[194],Ae([1,0,13,96,20,21,2,15,73,58]),function(x,e,D,P,C,L,M,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;function F(c,o){return c.uuid&&o.uuid?c.uuid===o.uuid:c.id===o.id?!0:(0,D.$ef)(c.id,o.id)===0}e.$ap=F;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(o){const b=o.manifest?o.manifest.version:o.version,p=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new l(o.identifier,b,p)}static parse(o){const b=S.exec(o);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(o,b,p="undefined"){this.version=b,this.targetPlatform=p,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof l?F(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$bp=l;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(c){const o=w.exec(c);return o&&o[1]?[u(o[1]),o[2]]:[u(c),void 0]}e.$cp=m;function s(c,o){return`${c}.${o}`}e.$dp=s;function u(c){return c.toLowerCase()}e.$ep=u;function i(c,o){return u(s(c??C.$tm,o))}e.$fp=i;function r(c,o){const b=[],p=d=>{for(const I of b)if(I.some(v=>F(o(v),o(d))))return I;return null};for(const d of c){const I=p(d);I?I.push(d):b.push([d])}return b}e.$gp=r;function n(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$hp=n;function a(c){return{id:new k.$Xo(c.identifier.id),name:new k.$Xo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$ip=a,e.$jp=new C.$xm("pprice.better-merge");function h(c,o){const b=[],p=o.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const d=p.shift();if(d&&b.every(I=>!F(I.identifier,{id:d}))){const I=c.filter(v=>F(v.identifier,{id:d}));I.length===1&&(b.push(I[0]),p.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.$kp=h;async function t(c,o){if(!L.$e)return!1;let b;try{b=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){o.debug("Error while getting the os-release file.",(0,g.$0)(d))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function $(c,o){const b=await t(c,o),p=(0,P.$Ho)(b?"alpine":L.$o,f.$ec);return o.debug("ComputeTargetPlatform:",p),p}e.$lp=$}),define(Me[195],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=e.$Yr=void 0;function D(f){return[...f.entries()]}e.$Yr=D;function P(f){return f?[...f.entries()]:[]}e.$Zr=P;function C(f){return new Map(f)}e.$1r=C;function L(f){return new Map(f??[])}e.$2r=L;function M(f){return Array.from(f.entries()).map(k=>[k[0],D(k[1].map),P(k[1].descriptionMap)])}e.$3r=M;function g(f){return new Map(f.map(k=>[k[0],{map:C(k[1]),descriptionMap:L(k[2])}]))}e.$4r=g}),define(Me[196],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ptb=void 0;class D{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,M=5){const g=L(f=>{const k=typeof f=="string"?f:f.data;let F=this.a.get(C);if(F){F.data.push(k);return}const S=setTimeout(()=>this.flushBuffer(C),M);F={data:[k],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),g.dispose()}},this.a.set(C,F)});return g}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$Ptb=D}),define(Me[197],Ae([1,0,11,89,41,5,16,2,156,72,30]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.IconFontDefinition=e.IconContribution=e.$Jw=void 0,e.$Jw={IconContribution:"base.contributions.icons"};var S;(function(a){function h(t,$){let c=t.defaults;for(;C.ThemeIcon.isThemeIcon(c);){const o=m.getIcon(c.id);if(!o)return;c=o.defaults}return c}a.getDefinition=h})(S||(e.IconContribution=S={}));var l;(function(a){function h($){return{weight:$.weight,style:$.style,src:$.src.map(c=>({format:c.format,location:c.location.toString()}))}}a.toJSONObject=h;function t($){const c=o=>(0,M.$Sf)(o)?o:void 0;if($&&Array.isArray($.src)&&$.src.every(o=>(0,M.$Sf)(o.format)&&(0,M.$Sf)(o.location)))return{weight:c($.weight),style:c($.style),src:$.src.map(o=>({format:o.format,location:g.URI.parse(o.location)}))}}a.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class w{constructor(){this.a=new L.$5d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,$,c){const o=this.b[h];if(o){if($&&!o.description){o.description=$,this.d.properties[h].markdownDescription=`${$} $(${h})`;const d=this.e.enum.indexOf(h);d!==-1&&(this.e.enumDescriptions[d]=$),this.a.fire()}return o}const b={id:h,description:$,defaults:t,deprecationMessage:c};this.b[h]=b;const p={$ref:"#/definitions/icons"};return c&&(p.deprecationMessage=c),$&&(p.markdownDescription=`${$}: $(${h})`),this.d.properties[h]=p,this.e.enum.push(h),this.e.enumDescriptions.push($||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const $=this.f[h];return $||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(o,b)=>o.id.localeCompare(b.id),t=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},$=[];$.push("| preview     | identifier                        | default codicon ID                | description"),$.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(o=>this.b[o]);for(const o of c.filter(b=>!!b.description).sort(h))$.push(`|<i class="${t(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);$.push("| preview     | identifier                        "),$.push("| ----------- | --------------------------------- |");for(const o of c.filter(b=>!C.ThemeIcon.isThemeIcon(b.defaults)).sort(h))$.push(`|<i class="${t(o)}"></i>|${o.id}|`);return $.join(`
`)}}const m=new w;F.$Un.add(e.$Jw.IconContribution,m);function s(a,h,t,$){return m.registerIcon(a,h,t,$)}e.$Kw=s;function u(){return m}e.$Lw=u;function i(){const a=(0,P.$ik)();for(const h in a){const t="\\"+a[h].toString(16);m.registerIcon(h,{fontCharacter:t})}}i(),e.$Mw="vscode://schemas/icons";const r=F.$Un.as(k.$Vn.JSONContribution);r.registerSchema(e.$Mw,m.getIconSchema());const n=new D.$qh(()=>r.notifySchemaChanged(e.$Mw),200);m.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Nw=s("widget-close",P.$kk.close,(0,f.localize)(2,null)),e.$Ow=s("goto-previous-location",P.$kk.arrowUp,(0,f.localize)(3,null)),e.$Pw=s("goto-next-location",P.$kk.arrowDown,(0,f.localize)(4,null)),e.$Qw=C.ThemeIcon.modify(P.$kk.sync,"spin"),e.$Rw=C.ThemeIcon.modify(P.$kk.loading,"spin")}),define(Me[198],Ae([1,0,5,46,4,14]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.ProvidedOnAutoForward=e.$Pv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ov=e.$Nv=void 0,e.$Nv=(0,C.$ei)("tunnelService"),e.$Ov=(0,C.$ei)("sharedTunnelsService");var M;(function(u){u.Http="http",u.Https="https"})(M||(e.TunnelProtocol=M={}));var g;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(g||(e.TunnelPrivacyId=g={}));function f(u){return!!u.forwardPort}e.$Pv=f;var k;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function F(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(i)return{address:i[1],port:+i[2]}}e.$Qv=F,e.$Rv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(u){return e.$Rv.indexOf(u)>=0}e.$Sv=S,e.$Tv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(u){return e.$Tv.indexOf(u)>=0}e.$Uv=l;function w(u,i,r,n){if(r===1)return!1;if(r===2&&l(i)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(a?.length===4&&parseInt(a[1])>=18)return!1}return u<1024}e.$Vv=w;class m{constructor(i,r,n){this.remoteAddress=i,this.localAddress=r,this.b=n,this.a=new D.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Wv=m;let s=class{constructor(i,r){this.k=i,this.l=r,this.a=new D.$5d,this.onTunnelOpened=this.a.event,this.b=new D.$5d,this.onTunnelClosed=this.b.event,this.c=new D.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const n of r){const a=Array.from(n.values());for(const h of a){const t=await h.value;t&&typeof t!="string"&&i.push(t)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(n=>typeof n!="string"?n?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,n,a,h){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:n,privacy:a,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(l(i)||S(i))&&(i=e.$Rv[0]);const n=this.s(i,r);if(n)return++n.refcount,n.value}openTunnel(i,r,n,a,h,t=!1,$,c){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${n} on local port ${h}.`);const o=this.f??i;if(!o)return;if(r||(r="localhost"),a||(a=this.m),this.f&&this.j.has(n)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(o,r,n,a,h,t,$,c);return b?b.then(p=>{if(p){if(typeof p=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,n),p}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,n);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.o(p);return(p.tunnelRemoteHost!==r||p.tunnelRemotePort!==n)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&p.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(d),d}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const n=r.get(i.tunnelRemotePort);n&&(n.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,n))}}}}async p(i,r,n){if(n.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const a=n.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),a}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const n=this.e.get(i);if(n&&n.has(r)){const a=n.get(r);a.refcount=0,await this.p(i,r,a)}}q(i,r,n){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:n})}async r(i,r){const n=this.e.get(i);if(n){const a=n.get(r),h=a?await a.value:void 0;(!h||typeof h=="string")&&n.delete(r),n.size===0&&this.e.delete(i)}}s(i,r){const n=[i];S(i)?(n.push(...e.$Rv),n.push(...e.$Tv)):l(i)&&n.push(...e.$Tv);const a=n.map(h=>this.e.get(h));for(const h of a){const t=h?.get(r);if(t)return t}}canTunnel(i){return!!F(i)}u(i,r,n,a,h,t,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${n} on local port ${a}.`);const c=n;this.j.add(c);const o=a===void 0?n:a,b={elevationRequired:h?this.isPortPrivileged(o):!1},p={remoteAddress:{host:r,port:n},localAddressPort:a,privacy:t,public:t?t!==g.Private:void 0,protocol:$},d=i.forwardPort(p,b);return d?(this.q(r,n,d),d.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(c)})):this.j.delete(c),d}};e.$Xv=s,e.$Xv=s=Xe([He(0,L.$yj),He(1,P.$Ki)],s)}),define(Me[199],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Yv=void 0,e.$Yv=(0,D.$ei)("editSessionIdentityService");var P;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(P||(e.EditSessionIdentityMatch=P={}))}),define(Me[200],Ae([1,0,12]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=void 0;function P(f){return f.scheme!==D.Schemas.file&&f.scheme!==D.Schemas.vscodeRemote}e.$xL=P;function C(f){if(f.folders.length)return f.folders.every(k=>P(k.uri))?f.folders[0].uri:void 0;if(f.configuration&&P(f.configuration))return f.configuration}e.$yL=C;function L(f){return C(f)?.scheme}e.$zL=L;function M(f){return C(f)?.authority}e.$AL=M;function g(f){return C(f)!==void 0}e.$BL=g}),define(Me[47],Ae([1,0,157,19,50,25,2,4,12]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,g.$ei)("contextService");function k(o){const b=o;return typeof b?.id=="string"&&M.URI.isUri(b.uri)}e.$oi=k;function F(o){return typeof o?.id=="string"&&!k(o)&&!l(o)}e.$pi=F,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function S(o,b){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,P.$nc)(o)}:b?e.$qi:e.$ri;const p=o;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}e.$si=S;function l(o){const b=o;return typeof b?.id=="string"&&M.URI.isUri(b.configPath)}e.$ti=l;function w(o){const b=o;if(b?.uri)return{id:b.id,uri:M.URI.revive(b.uri)};const p=o;if(p?.configPath)return{id:p.id,configPath:M.URI.revive(p.configPath)};if(o?.id)return{id:o.id}}e.$ui=w;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function s(o){const b=o;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.$vi=s;function u(o){const b=o;return!!(b&&typeof b=="object"&&M.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.$wi=u;class i{constructor(b,p,d,I,v){this.h=b,this.j=d,this.k=I,this.l=v,this.c=C.$ki.forUris(this.l,()=>!0),this.folders=p}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=C.$ki.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=i;class r{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,L.$Rg)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=r;function n(o){return new r({uri:o,index:0,name:(0,L.$Ng)(o)},{uri:o.toString()})}e.$zi=n,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,D.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function a(o,b){return L.$Ig.isEqualOrParent(o,b.untitledWorkspacesHome)}e.$Ei=a;function h(o){let b;return M.URI.isUri(o)?b=o:b=o.configuration,b?.scheme===f.Schemas.tmp}e.$Fi=h,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$Gi}e.$Hi=t;function $(o,b){return!a(o,b)&&!h(o)}e.$Ii=$;function c(o){return(typeof o=="string"?(0,P.$oc)(o):(0,L.$Pg)(o))===e.$Bi}e.$Ji=c}),define(Me[74],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class D{constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Lhc=D,D.a=!1}),define(Me[43],Ae([1,0,12,25,4]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=void 0;class L{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new P.$Gg(g=>{const f=this.b.get(g.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(g,f){f===null?this.b.delete(g.scheme):this.b.set(g.scheme,f)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$Qhc=L,e.$Rhc=(0,C.$ei)("IExtHostFileSystemInfo")}),define(Me[27],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=void 0,e.$vO=(0,D.$ei)("IExtHostInitDataService")}),define(Me[201],Ae([1,0,163,14,188,27]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=void 0;let M=class extends C.$DP{constructor(f,k,F){const S=F.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=F.remote.isRemote?(0,D.localize)(0,null):f?(0,D.localize)(1,null):(0,D.localize)(2,null);super(k.createLogger(S,{name:l}))}};e.$Vjc=M,e.$Vjc=M=Xe([He(1,P.$zj),He(2,L.$vO)],M)}),define(Me[202],Ae([1,0,11]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=void 0;class P{constructor(M,g,f){this.h=new Map,this.a=M,this.b=g,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new D.$qh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const F of k.values())F.complete()}catch(F){for(const S of k.values())S.error(F)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,g){let f=this.f[M];return typeof f>"u"&&(f=g),f}update(M,g){this.f[M]=g;const f=this.h.get(M);if(f!==void 0)return f.p;const k=new D.$Bh;return this.h.set(M,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$xic=P;class C extends P{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,g){super(M.identifier.value,!0,g),this.j=M}}e.$yic=C}),define(Me[203],Ae([1,0,5,2]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class C{constructor(M){this.c=M,this.a=new D.$5d,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$5d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,g,f,k){const S=this.c.getNotebookDocument(P.URI.revive(M)).acceptModelChanged(g.value,f,k);this.b.fire(S)}$acceptDirtyStateChanged(M,g){this.c.getNotebookDocument(P.URI.revive(M)).acceptDirty(g)}$acceptModelSaved(M){const g=this.c.getNotebookDocument(P.URI.revive(M));this.a.fire(g.apiNotebook)}}e.$ljc=C}),define(Me[17],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=e.$fO=void 0,e.$fO=(0,D.$ei)("IExtHostRpcService");class P{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$gO=P});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[204],Ae([1,0,20,5]),function(x,e,D,P){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class L{constructor(g,f){C.set(this,void 0),this.b=new P.$5d,this.onDidChange=this.b.event,this.a=D.$xm.toKey(g.identifier),xe(this,C,f,"f"),Ue(this,C,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(g){return Ue(this,C,"f").get(this.a,g)}store(g,f){return Ue(this,C,"f").store(this.a,g,f)}delete(g){return Ue(this,C,"f").delete(this.a,g)}}e.$Fic=L,C=new WeakMap}),define(Me[59],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0,e.$8hc=(0,D.$ei)("IURITransformerService");class P{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$9hc=P}),define(Me[205],Ae([1,0,24]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnb=e.$inb=void 0;class P{constructor(){this.buffers=[]}add(f){let k=this.buffers.indexOf(f);return k<0&&(k=this.buffers.length,this.buffers.push(f)),k}}function C(g,f){if(f.serializeBuffersForPostMessage){const k=new P,S=JSON.stringify(g,(w,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m)};if(ArrayBuffer.isView(m)){const s=L(m);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m.buffer),view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),l=k.buffers.map(w=>{const m=new Uint8Array(w);return D.$se.wrap(m)});return{message:S,buffers:l}}else return{message:JSON.stringify(g),buffers:[]}}e.$inb=C;function L(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(g,f){const k=f.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),F=f.length?(l,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const m=w,{index:s}=m,u=k[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(u,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return w}:void 0;return{message:JSON.parse(g,F),arrayBuffers:k}}e.$jnb=M}),define(Me[102],Ae([1,0,172,16,2,6,4,30,42,12,35,142,32]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.$fF=e.EditorsOrder=e.$eF=e.CloseDirection=e.$dF=e.$cF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.EditorInputCapabilities=e.$6E=e.SaveReason=e.Verbosity=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$SE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$UE="workbench.editor.sidebysideEditor",e.$VE="workbench.editors.textDiffEditor",e.$WE="workbench.editors.binaryResourceDiffEditor";var w;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var m;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function s(oe){const ve=oe;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$XE=s;function u(oe,ve,G){for(const ge of G.visibleEditorPanes)if(ge.group.id===ve&&oe.matches(ge.input))return ge.getViewState()}e.$YE=u;function i(oe){if(d(oe))return!1;const ve=oe;return C.URI.isUri(ve?.resource)}e.$ZE=i;function r(oe){if(d(oe))return!1;const ve=oe;return ve?.original!==void 0&&ve.modified!==void 0}e.$1E=r;function n(oe){if(d(oe))return!1;const ve=oe;return!ve||ve.resources&&!Array.isArray(ve.resources)?!1:!!ve.resources||!!ve.multiDiffSource}e.$2E=n;function a(oe){if(d(oe)||r(oe))return!1;const ve=oe;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$3E=a;function h(oe){if(d(oe))return!1;const ve=oe;return ve?ve.resource===void 0||ve.resource.scheme===k.Schemas.untitled||ve.forceUntitled===!0:!1}e.$4E=h;function t(oe){if(d(oe))return!1;const ve=oe;return C.URI.isUri(ve?.base?.resource)&&C.URI.isUri(ve?.input1?.resource)&&C.URI.isUri(ve?.input2?.resource)&&C.URI.isUri(ve?.result?.resource)}e.$5E=t;var $;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})($||(e.Verbosity=$={}));var c;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class o{constructor(){this.a=new Map}registerSource(ve,G){let ge=this.a.get(ve);return ge||(ge={source:ve,label:G},this.a.set(ve,ge)),ge.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$6E=new o;var b;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(b||(e.EditorInputCapabilities=b={}));class p extends L.$Tc{}e.$7E=p;function d(oe){return oe instanceof p}e.$8E=d;function I(oe){const ve=oe;return C.URI.isUri(ve?.preferredResource)}function v(oe){const ve=oe;return d(ve?.primary)&&d(ve?.secondary)}e.$9E=v;function y(oe){const ve=oe;return d(ve?.modified)&&d(ve?.original)}e.$0E=y;function E(oe,ve,G,ge,ae){return ke(ge,[(0,S.$1i)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const De={...G,limits:{size:Number.MAX_VALUE}};oe.openEditor(ve,De)}}),(0,S.$1i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$$E=E;function A(oe){return d(oe?.editor)}e.$_E=A;function V(oe){const ve=oe;return A(oe)&&ve?.group!==void 0}e.$aF=V;function X(oe){const ve=oe;return typeof ve?.groupId=="number"&&d(ve.editor)}e.$bF=X;var H;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var O;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var R;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(R||(e.SideBySideEditor=R={}));class B{getOriginalUri(ve,G){if(!ve)return;if(t(ve))return e.$dF.getOriginalUri(ve.result,G);if(G?.supportSideBySide){const{primary:ae,secondary:De}=this.a(ve);if(ae&&De){if(G?.supportSideBySide===R.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===R.ANY)return this.getOriginalUri(ae,{filterByScheme:G.filterByScheme})??this.getOriginalUri(De,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===R.PRIMARY?ae:De}}if(r(ve)||n(ve)||a(ve)||t(ve))return;const ge=I(ve)?ve.preferredResource:ve.resource;return!ge||!G||!G.filterByScheme?ge:this.b(ge,G.filterByScheme)}a(ve){return v(ve)||a(ve)?{primary:ve.primary,secondary:ve.secondary}:y(ve)||r(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,G){if(!ve)return;if(t(ve))return e.$dF.getCanonicalUri(ve.result,G);if(G?.supportSideBySide){const{primary:ae,secondary:De}=this.a(ve);if(ae&&De){if(G?.supportSideBySide===R.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===R.ANY)return this.getCanonicalUri(ae,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===R.PRIMARY?ae:De}}if(r(ve)||n(ve)||a(ve)||t(ve))return;const ge=ve.resource;return!ge||!G||!G.filterByScheme?ge:this.b(ge,G.filterByScheme)}b(ve,G){if(Array.isArray(G)){if(G.some(ge=>ve.scheme===ge))return ve}else if(G===ve.scheme)return ve}}var T;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function te(oe,ve,G,ge){if(!oe.isSticky(ve))return!1;switch(ge.preventPinnedEditorClose){case"keyboardAndMouse":return G===T.MOUSE||G===T.KEYBOARD;case"mouse":return G===T.MOUSE;case"keyboard":return G===T.KEYBOARD}return!1}e.$cF=te,e.$dF=new B;var Q;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class ce{constructor(){this.c=new Map,this.d=new Map}start(ve){const G=this.a=ve.get(M.$di);for(const[ge,ae]of this.c)this.e(ge,ae,G);this.c.clear()}e(ve,G,ge){const ae=ge.createInstance(G);this.d.set(ve,ae)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,P.$4f)(this.b)}registerEditorSerializer(ve,G){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,G,this.a):this.c.set(ve,G),(0,L.$Rc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}g.$Un.add(e.$SE.EditorFactory,new ce);async function le(oe,ve,G){return!oe||!oe.length?[]:await Promise.all(oe.map(async ge=>{const ae=C.URI.revive(ge.fileUri);if(!ae){G.info("Cannot resolve the path because it is not valid.",ge);return}if(!await ve.canHandleResource(ae)){G.info("Cannot resolve the path because it cannot be handled",ge);return}let ye=ge.exists,we=ge.type;if(typeof ye!="boolean"||typeof we!="number")try{we=(await ve.stat(ae)).isDirectory?f.FileType.Directory:f.FileType.Unknown,ye=!0}catch(K){G.error(K),ye=!1}if(!ye&&ge.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",ge);return}if(we===f.FileType.Directory){G.info("Cannot resolve the path because it is a directory",ge);return}const he={...ge.options,pinned:!0};return ye?{resource:ae,options:he}:{resource:ae,options:he,forceUntitled:!0}}))}e.$eF=le;var se;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(se||(e.EditorsOrder=se={}));function $e(oe){const ve=oe;if(!ve)return!1;const G=ve;if(G.modified)return $e(G.modified);const ge=ve;return!!(ge.contributionsState&&ge.viewState&&Array.isArray(ge.cursorState))}e.$fF=$e;function ne(oe){return(0,F.$3i)(oe)}e.$gF=ne;function ke(oe,ve,G){const ge=(0,F.$4i)(oe,ve);return ge.forceMessage=G?.forceMessage,ge.forceSeverity=G?.forceSeverity,ge.allowDialog=G?.allowDialog,ge}e.$hF=ke}),define(Me[206],Ae([1,0,5,173,4,6,28,30,18,26,89,197]),function(x,e,D,P,C,L,M,g,f,k,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$nF=e.ViewContentGroups=e.$mF=e.$lF=e.ViewContainerLocation=e.Extensions=e.$kF=e.$jF=e.$iF=void 0,e.$iF="views",e.$jF=(0,P.localize)(0,null),e.$kF=(0,S.$Kw)("default-view-icon",F.$kk.window,(0,P.localize)(1,null));var l;(function($){$.ViewContainersRegistry="workbench.registry.view.containers",$.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var w;(function($){$[$.Sidebar=0]="Sidebar",$[$.Panel=1]="Panel",$[$.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$lF=[0,1,2];function m($){switch($){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$mF=m;class s extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$5d),this.onDidRegister=this.c.event,this.f=this.B(new D.$5d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(c,o,b){const p=this.get(c.id);if(p)return p;const d=c;return d.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,M.$xc)(this.g,o,[]).push(d),b?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:o}),d}deregisterViewContainer(c){for(const o of this.g.keys()){const b=this.g.get(o),p=b?.indexOf(c);if(p!==-1){b?.splice(p,1),b.length===0&&this.g.delete(o),this.f.fire({viewContainer:c,viewContainerLocation:o});return}}}get(c){return this.all.filter(o=>o.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(o=>this.getViewContainerLocation(o)===c)}}g.$Un.add(l.ViewContainersRegistry,new s);var u;(function($){$.Open="2_open",$.Debug="4_debug",$.SCM="5_scm",$.More="9_more"})(u||(e.ViewContentGroups=u={}));function i($,c){const o=$.group??u.More,b=c.group??u.More;return o!==b?o.localeCompare(b):($.order??5)-(c.order??5)}class r extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$5d),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$5d),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$5d),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$5d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Gc}registerViews(c,o){this.registerViews2([{views:c,viewContainer:o}])}registerViews2(c){c.forEach(({views:o,viewContainer:b})=>this.r(o,b)),this.c.fire(c)}deregisterViews(c,o){const b=this.s(c,o);b.length&&this.f.fire({views:b,viewContainer:o})}moveViews(c,o){for(const b of this.m.keys())if(b!==o){const p=this.s(c,b);p.length&&(this.r(p,o),this.g.fire({views:p,from:b,to:o}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const o of this.j){const b=(this.m.get(o)||[]).filter(p=>p.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const o of this.j)if((this.m.get(o)||[]).filter(p=>p.id===c)[0])return o;return null}registerViewWelcomeContent(c,o){return this.n.add(c,o),this.h.fire(c),(0,L.$Rc)(()=>{this.n.delete(c,o),this.h.fire(c)})}registerViewWelcomeContent2(c,o){const b=new Map;for(const[p,d]of o)this.n.add(c,d),b.set(p,(0,L.$Rc)(()=>{this.n.delete(c,d),this.h.fire(c)}));return this.h.fire(c),b}getViewWelcomeContent(c){const o=[];return this.n.forEach(c,b=>o.push(b)),o.sort(i)}r(c,o){let b=this.m.get(o);b||(b=[],this.m.set(o,b),this.j.push(o));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,P.localize)(2,null,p.id));b.push(p)}}s(c,o){const b=this.m.get(o);if(!b)return[];const p=[],d=[];for(const I of b)c.includes(I)?p.push(I):d.push(I);return p.length&&(d.length?this.m.set(o,d):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),p}}g.$Un.add(l.ViewsRegistry,new r),e.$nF=(0,C.$ei)("viewDescriptorService");var n;(function($){$[$.Default=0]="Default",$[$.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var a;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,o){this.c=!1,this.d=!1,(0,k.$Ln)(this,c),this.d=!!o,this.resolve=async b=>{if(o&&!this.c){const p=await o(b);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$oF=h;class t extends Error{constructor(c){super((0,P.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$pF=t}),define(Me[207],Ae([1,0,2,29,4]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$xF=e.$wF=void 0;function L(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof D.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(P.$7s.isIRange)}e.$wF=L;function M(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(L)}e.$xF=M;var g;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var f;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.$yF=(0,C.$ei)("IChatService"),e.$zF="accessibility.voice.keywordActivation"}),define(Me[208],Ae([1,0,5,11,174]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onb=void 0;class L{constructor(){this.f=new Map,this.m=[],this.n=new D.$5d,this.o=new D.$5d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(g){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=g}onEvent(g){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=g}onRequest(g){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.u("response",g)}sendRequest(g,f,k,F){const S={command:g};if(f&&Object.keys(f).length>0&&(S.arguments=f),this.u("request",S),typeof F=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.f.get(S.seq);if(w){this.f.delete(S.seq);const m={type:"response",seq:0,request_seq:S.seq,success:!1,command:g,message:(0,C.localize)(0,null,F,g)};w(m)}},F)}return k&&this.f.set(S.seq,k),S.seq}acceptMessage(g){this.k?this.k(g):(this.m.push(g),this.m.length===1&&this.s())}q(g,f){return g.type!=="event"||f.type!=="event"}async s(){let g;for(;this.m.length;){if((!g||this.q(this.m[0],g))&&await(0,P.$fh)(0),g=this.m.shift(),!g)return;switch(g.type){case"event":this.j?.(g);break;case"request":this.g?.(g);break;case"response":{const f=g,k=this.f.get(f.request_seq);k&&(this.f.delete(f.request_seq),k(f));break}}}}u(g,f){f.type=g,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((f,k)=>g.set(k,f)),await(0,P.$fh)(500),g.forEach((f,k)=>{f({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Onb=L}),define(Me[209],Ae([1,0,2,175,36,4]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$zI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$yI=e.MemoryRangeType=e.$xI=e.State=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=void 0,e.$oH="workbench.view.debug",e.$pH="workbench.debug.variablesView",e.$qH="workbench.debug.watchExpressionsView",e.$rH="workbench.debug.callStackView",e.$sH="workbench.debug.loadedScriptsView",e.$tH="workbench.debug.breakPointsView",e.$uH="workbench.debug.disassemblyView",e.$vH="workbench.panel.repl",e.$wH="workbench.panel.repl.view",e.$xH=new C.$vj("debugType",void 0,{type:"string",description:P.localize(0,null)}),e.$yH=new C.$vj("debugConfigurationType",void 0,{type:"string",description:P.localize(1,null)}),e.$zH=new C.$vj("debugState","inactive",{type:"string",description:P.localize(2,null)}),e.$AH="debugUx",e.$BH=new C.$vj(e.$AH,"default",{type:"string",description:P.localize(3,null)}),e.$CH=new C.$vj("hasDebugged",!1,{type:"boolean",description:P.localize(4,null)}),e.$DH=new C.$vj("inDebugMode",!1,{type:"boolean",description:P.localize(5,null)}),e.$EH=new C.$vj("inDebugRepl",!1,{type:"boolean",description:P.localize(6,null)}),e.$FH=new C.$vj("breakpointWidgetVisible",!1,{type:"boolean",description:P.localize(7,null)}),e.$GH=new C.$vj("inBreakpointWidget",!1,{type:"boolean",description:P.localize(8,null)}),e.$HH=new C.$vj("breakpointsFocused",!0,{type:"boolean",description:P.localize(9,null)}),e.$IH=new C.$vj("watchExpressionsFocused",!0,{type:"boolean",description:P.localize(10,null)}),e.$JH=new C.$vj("watchExpressionsExist",!1,{type:"boolean",description:P.localize(11,null)}),e.$KH=new C.$vj("variablesFocused",!0,{type:"boolean",description:P.localize(12,null)}),e.$LH=new C.$vj("expressionSelected",!1,{type:"boolean",description:P.localize(13,null)}),e.$MH=new C.$vj("breakpointInputFocused",!1,{type:"boolean",description:P.localize(14,null)}),e.$NH=new C.$vj("callStackItemType",void 0,{type:"string",description:P.localize(15,null)}),e.$OH=new C.$vj("callStackSessionIsAttach",!1,{type:"boolean",description:P.localize(16,null)}),e.$PH=new C.$vj("callStackItemStopped",!1,{type:"boolean",description:P.localize(17,null)}),e.$QH=new C.$vj("callStackSessionHasOneThread",!1,{type:"boolean",description:P.localize(18,null)}),e.$RH=new C.$vj("watchItemType",void 0,{type:"string",description:P.localize(19,null)}),e.$SH=new C.$vj("canViewMemory",void 0,{type:"boolean",description:P.localize(20,null)}),e.$TH=new C.$vj("breakpointItemType",void 0,{type:"string",description:P.localize(21,null)}),e.$UH=new C.$vj("breakpointHasModes",!1,{type:"boolean",description:P.localize(22,null)}),e.$VH=new C.$vj("breakpointSupportsCondition",!1,{type:"boolean",description:P.localize(23,null)}),e.$WH=new C.$vj("loadedScriptsSupported",!1,{type:"boolean",description:P.localize(24,null)}),e.$XH=new C.$vj("loadedScriptsItemType",void 0,{type:"string",description:P.localize(25,null)}),e.$YH=new C.$vj("focusedSessionIsAttach",!1,{type:"boolean",description:P.localize(26,null)}),e.$ZH=new C.$vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:P.localize(27,null)}),e.$1H=new C.$vj("stepBackSupported",!1,{type:"boolean",description:P.localize(28,null)}),e.$2H=new C.$vj("restartFrameSupported",!1,{type:"boolean",description:P.localize(29,null)}),e.$3H=new C.$vj("stackFrameSupportsRestart",!1,{type:"boolean",description:P.localize(30,null)}),e.$4H=new C.$vj("jumpToCursorSupported",!1,{type:"boolean",description:P.localize(31,null)}),e.$5H=new C.$vj("stepIntoTargetsSupported",!1,{type:"boolean",description:P.localize(32,null)}),e.$6H=new C.$vj("breakpointsExist",!1,{type:"boolean",description:P.localize(33,null)}),e.$7H=new C.$vj("debuggersAvailable",!1,{type:"boolean",description:P.localize(34,null)}),e.$8H=new C.$vj("debugExtensionAvailable",!0,{type:"boolean",description:P.localize(35,null)}),e.$9H=new C.$vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:P.localize(36,null)}),e.$0H=new C.$vj("debugSetVariableSupported",!1,{type:"boolean",description:P.localize(37,null)}),e.$$H=new C.$vj("debugSetExpressionSupported",!1,{type:"boolean",description:P.localize(38,null)}),e.$_H=new C.$vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:P.localize(39,null)}),e.$aI=new C.$vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:P.localize(40,null)}),e.$bI=new C.$vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:P.localize(41,null)}),e.$cI=new C.$vj("terminateDebuggeeSupported",!1,{type:"boolean",description:P.localize(42,null)}),e.$dI=new C.$vj("suspendDebuggeeSupported",!1,{type:"boolean",description:P.localize(43,null)}),e.$eI=new C.$vj("variableEvaluateNamePresent",!1,{type:"boolean",description:P.localize(44,null)}),e.$fI=new C.$vj("variableIsReadonly",!1,{type:"boolean",description:P.localize(45,null)}),e.$gI=new C.$vj("variableValue",!1,{type:"string",description:P.localize(46,null)}),e.$hI=new C.$vj("variableType",!1,{type:"string",description:P.localize(47,null)}),e.$iI=new C.$vj("variableName",!1,{type:"string",description:P.localize(48,null)}),e.$jI=new C.$vj("variableLanguage",!1,{type:"string",description:P.localize(49,null)}),e.$kI=new C.$vj("variableExtensionId",!1,{type:"string",description:P.localize(50,null)}),e.$lI=new C.$vj("exceptionWidgetVisible",!1,{type:"boolean",description:P.localize(51,null)}),e.$mI=new C.$vj("multiSessionRepl",!1,{type:"boolean",description:P.localize(52,null)}),e.$nI=new C.$vj("multiSessionDebug",!1,{type:"boolean",description:P.localize(53,null)}),e.$oI=new C.$vj("disassembleRequestSupported",!1,{type:"boolean",description:P.localize(54,null)}),e.$pI=new C.$vj("disassemblyViewFocus",!1,{type:"boolean",description:P.localize(55,null)}),e.$qI=new C.$vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:P.localize(56,null)}),e.$rI=new C.$vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:P.localize(57,null)});const M=i=>P.localize(58,null,i);e.$sI=M,e.$tI="editor.contrib.debug",e.$uI="editor.contrib.breakpoint",e.$vI="debug",e.$wI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:P.localize(59,null)};var g;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(g||(e.State=g={}));function f(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$xI=f;var k;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$yI="vscode-debug-memory";var F;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(F||(e.DebugConfigurationProviderTriggerKind=F={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$zI=(0,L.$ei)("debugService");var l;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var w;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(w||(e.DebugVisualizationType=w={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var s;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(s||(e.IDebugVisualizationTreeItem=s={}));var u;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:D.URI.revive(r.iconPath.light),dark:D.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(u||(e.IDebugVisualization=u={}))}),define(Me[210],Ae([1,0,13,2,19,26,12,29,22,18]),function(x,e,D,P,C,L,M,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0;const F=/{([^}]+)}/g;function S(I,v,y){return I.replace(F,function(E,A){return v&&A.length>0&&A[0]!=="_"?E:y&&y.hasOwnProperty(A)?y[A]:E})}e.$qG=S;function l(I){const v={};for(const y of Object.keys(I))y.startsWith("!")||(v[y]=I[y]);return v}e.$rG=l;function w(I){return I.configuration.request==="attach"&&!m(I)&&(!I.parentSession||w(I.parentSession))}e.$sG=w;function m(I){let v=I.configuration.type;if(v)return v==="vslsShare"&&(v=I.configuration.adapterProxy.configuration.type),(0,D.$jf)(v,"extensionhost")||(0,D.$jf)(v,"pwa-extensionhost")?I:I.parentSession?m(I.parentSession):void 0}e.$tG=m;function s(I){return I.type&&(I.label||I.program||I.runtime)}e.$uG=s;function u(I,v,y){let E,A=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let X=null;for(;X=V.exec(I);){const H=X.index+1,O=H+X[0].length;if(H<=v&&O>=y){E=X[0],A=H;break}}if(E){const H=/\w+/g;let O=null;for(;(O=H.exec(E))&&!(O.index+1+A+O[0].length>=y););O&&(E=E.substring(0,H.lastIndex))}return E?{start:A,end:A+E.length-1}:{start:0,end:0}}e.$vG=u;async function i(I,v,y,E){if(I.evaluatableExpressionProvider.has(v)){const A=I.evaluatableExpressionProvider.ordered(v),V=(0,k.$Hb)(await Promise.all(A.map(async X=>{try{return await X.provideEvaluatableExpression(v,y,E??f.CancellationToken.None)}catch{return}})));if(V.length>0){let X=V[0].expression;const H=V[0].range;return X||(X=v.getLineContent(y.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:X}}}else{const A=v.getLineContent(y.lineNumber),{start:V,end:X}=u(A,y.column,y.column),H=A.substring(V-1,X);return{matchingExpression:H,range:new g.$7s(y.lineNumber,V,y.lineNumber,V+H.length)}}return null}e.$wG=i;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(I){return!!(I&&I.match(r))}e.$xG=n;function a(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(n(I.path))return P.URI.parse(I.path);if((0,C.$ic)(I.path))return P.URI.file(I.path)}return I.path}function h(I){if(typeof I.path=="object"){const v=P.URI.revive(I.path);if(v)return v.scheme===M.Schemas.file?v.fsPath:v.toString()}return I.path}function t(I,v){const y=v?a:h,E=(0,L.$In)(I);return c(E,(A,V)=>{A&&V&&(V.path=y(V))}),E}e.$yG=t;function $(I,v){const y=v?a:h,E=(0,L.$In)(I);return c(E,(A,V)=>{!A&&V&&(V.path=y(V))}),E}e.$zG=$;function c(I,v){switch(I.type){case"event":{const y=I;switch(y.event){case"output":v(!1,y.body.source);break;case"loadedSource":v(!1,y.body.source);break;case"breakpoint":v(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=I;switch(y.command){case"setBreakpoints":v(!0,y.arguments.source);break;case"breakpointLocations":v(!0,y.arguments.source);break;case"source":v(!0,y.arguments.source);break;case"gotoTargets":v(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(E=>v(!1,E));break;default:break}break}case"response":{const y=I;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(E=>v(!1,E.source));break;case"loadedSources":y.body.sources.forEach(E=>v(!1,E));break;case"scopes":y.body.scopes.forEach(E=>v(!1,E.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(E=>v(!1,E.source));break;case"setBreakpoints":y.body.breakpoints.forEach(E=>v(!1,E.source));break;case"disassemble":y.body?.instructions.forEach(A=>v(!1,A.location));break;default:break}break}}}function o(I){return I.filter(v=>!v.presentation?.hidden).sort((v,y)=>v.presentation?y.presentation?v.presentation.group?y.presentation.group?v.presentation.group!==y.presentation.group?v.presentation.group.localeCompare(y.presentation.group):b(v.presentation.order,y.presentation.order):-1:y.presentation.group?1:b(v.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$AG=o;function b(I,v){return typeof I!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:I-v}async function p(I,v){const y=I.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(y!=="none"&&(await v.saveAll(),y==="allEditorsInActiveGroup")){const E=v.activeEditorPane;E&&E.input.resource?.scheme===M.Schemas.untitled&&await v.save({editor:E.input,groupId:E.group.id})}await I.reloadConfiguration()}e.$BG=p;const d=(I,v)=>!I||!v?I===v:I.name===v.name&&I.path===v.path&&I.sourceReference===v.sourceReference;e.$CG=d}),define(Me[211],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.CellExecutionUpdateType=void 0;var P;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(P||(e.CellExecutionUpdateType=P={})),e.$8J=(0,D.$ei)("INotebookExecutionService")}),define(Me[212],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gb=e.$0gb=e.ProxyKernelState=e.$9gb=void 0,e.$9gb=100;var P;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(P||(e.ProxyKernelState=P={})),e.$0gb=(0,D.$ei)("INotebookKernelService"),e.$$gb=(0,D.$ei)("INotebookKernelHistoryService")}),define(Me[213],Ae([1,0,6,29,139,94]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vTb=void 0;class M extends D.$Tc{constructor(f,k,F){super(),this._source=f,this.b=k,this.c=F,this.a=void 0}f(f){const k=f.getLineCount();return new P.$7s(1,1,k,this.g(f,k))}g(f,k){if(k<1||k>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const f=new C.$pC;f.acceptChunk(this._source);const k=f.finish(!0),{textBuffer:F,disposable:S}=k.create(1);this.b=F,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const k=new C.$pC;k.acceptChunk(f);const F=k.finish(!0),{textBuffer:S,disposable:l}=F.create(1);return this.B(l),S})),this.a}findInInputs(f){const F=new L.$dC(f,!1,!1,null).parseSearchRequest();if(!F)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,F,!0,5e3)}findInOutputs(f){const F=new L.$dC(f,!1,!1,null).parseSearchRequest();return F?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),F,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$vTb=M}),define(Me[48],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(L){L.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var P;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(P||(e.TestPosition=P={}));class C{static fromExtHostTestItem(M,g,f=M.parent){if(M._isRoot)return new C([g]);const k=[M.id];for(let F=f;F&&F.id!==g;F=F.parent)k.push(F.id);return k.push(g),new C(k.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const g=M.indexOf("\0");return g===-1?M:M.slice(0,g)}static fromString(M){return new C(M.split("\0"))}static join(M,g){return new C([...M.path,g])}static joinToString(M,g){return M.toString()+"\0"+g}static parentId(M){const g=M.lastIndexOf("\0");return g===-1?void 0:M.slice(0,g)}static localId(M){const g=M.lastIndexOf("\0");return g===-1?M:M.slice(g+1)}static isChild(M,g){return g.startsWith(M)&&g[M.length]==="\0"}static compare(M,g){return M===g?0:C.isChild(M,g)?2:C.isChild(g,M)?3:1}constructor(M,g=M.length){if(this.path=M,this.d=g,M.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new C(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new C(this.path,M)}compare(M){if(typeof M=="string")return C.compare(this.toString(),M);for(let g=0;g<M.d&&g<this.d;g++)if(M.path[g]!==this.path[g])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$RK=C}),define(Me[60],Ae([1,0,2,92,29,48]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$YK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$XK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$WK=e.$VK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$UK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$TK=e.$SK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var g;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var f;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$SK=[2,4,8,16,32,64];const k=R=>"runId"in R;e.$TK=k;var F;(function(R){R.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),R.deserialize=(B,T)=>({range:C.$7s.lift(T.range),uri:B.asCanonicalUri(D.URI.revive(T.uri))})})(F||(e.IRichLocation=F={}));var S;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(R){R.serialize=B=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&F.serialize(B.location)}),R.deserialize=(B,T)=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&F.deserialize(B,T.location)})})(l||(e.ITestErrorMessage=l={}));const w=(R,B)=>`${B?"s":"e"}${R}`;e.$UK=w;var m;(function(R){R.serialize=B=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&F.serialize(B.location)}),R.deserialize=(B,T)=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&F.deserialize(B,T.location)})})(m||(e.ITestOutputMessage=m={}));var s;(function(R){R.serialize=B=>B.type===0?l.serialize(B):m.serialize(B),R.deserialize=(B,T)=>T.type===0?l.deserialize(B,T):m.deserialize(B,T)})(s||(e.ITestMessage=s={}));var u;(function(R){R.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),R.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map(s.serialize)}),R.deserialize=(B,T)=>({state:T.state,duration:T.duration,messages:T.messages.map(te=>s.deserialize(B,te))})})(u||(e.ITestTaskState=u={}));const i="\0",r=(R,B)=>R+i+B;e.$VK=r;const n=R=>{const B=R.indexOf(i);return{ctrlId:R.slice(0,B),tagId:R.slice(B+1)}};e.$WK=n;var a;(function(R){R.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),R.deserialize=(B,T)=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?B.asCanonicalUri(D.URI.revive(T.uri)):void 0,range:T.range?C.$7s.lift(T.range):null,description:T.description,error:T.error,sortText:T.sortText})})(a||(e.ITestItem=a={}));var h;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(R){R.serialize=B=>({expand:B.expand,item:a.serialize(B.item)}),R.deserialize=(B,T)=>({controllerId:L.$RK.root(T.item.extId),expand:T.expand,item:a.deserialize(B,T.item)})})(t||(e.InternalTestItem=t={}));var $;(function(R){R.serialize=B=>{let T;return B.item&&(T={},B.item.label!==void 0&&(T.label=B.item.label),B.item.tags!==void 0&&(T.tags=B.item.tags),B.item.busy!==void 0&&(T.busy=B.item.busy),B.item.uri!==void 0&&(T.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(T.range=B.item.range?.toJSON()),B.item.description!==void 0&&(T.description=B.item.description),B.item.error!==void 0&&(T.error=B.item.error),B.item.sortText!==void 0&&(T.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:T}},R.deserialize=B=>{let T;return B.item&&(T={},B.item.label!==void 0&&(T.label=B.item.label),B.item.tags!==void 0&&(T.tags=B.item.tags),B.item.busy!==void 0&&(T.busy=B.item.busy),B.item.range!==void 0&&(T.range=B.item.range?C.$7s.lift(B.item.range):null),B.item.description!==void 0&&(T.description=B.item.description),B.item.error!==void 0&&(T.error=B.item.error),B.item.sortText!==void 0&&(T.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:T}}})($||(e.ITestItemUpdate=$={}));const c=(R,B)=>{B.expand!==void 0&&(R.expand=B.expand),B.item!==void 0&&(R.item=R.item?Object.assign(R.item,B.item):B.item)};e.$XK=c;var o;(function(R){R.serializeWithoutMessages=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(u.serializeWithoutMessages)}),R.serialize=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(u.serialize)}),R.deserialize=(B,T)=>({...t.deserialize(B,T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(te=>u.deserialize(B,te)),retired:!0})})(o||(e.TestResultItem=o={}));var b;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(B,T)=>{B.covered+=T.covered,B.total+=T.total}})(b||(e.ICoveredCount=b={}));var p;(function(R){R.serialize=B=>({statement:B.statement,branch:B.branch,declaration:B.declaration,details:B.details?.map(y.serialize),uri:B.uri.toJSON()}),R.deserialize=(B,T)=>({statement:T.statement,branch:T.branch,declaration:T.declaration,details:T.details?.map(y.deserialize),uri:B.asCanonicalUri(D.URI.revive(T.uri))})})(p||(e.IFileCoverage=p={}));function d(R){return{...R,location:R.location?.toJSON()}}function I(R){return R.location=R.location?P.$6s.isIPosition(R.location)?P.$6s.lift(R.location):C.$7s.lift(R.location):void 0,R}e.$YK=3;var v;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(v||(e.DetailType=v={}));var y;(function(R){R.serialize=B=>B.type===0?A.serialize(B):V.serialize(B),R.deserialize=B=>B.type===0?A.deserialize(B):V.deserialize(B)})(y||(e.CoverageDetails=y={}));var E;(function(R){R.serialize=d,R.deserialize=I})(E||(e.IBranchCoverage=E={}));var A;(function(R){R.serialize=d,R.deserialize=I})(A||(e.IDeclarationCoverage=A={}));var V;(function(R){R.serialize=B=>({...d(B),branches:B.branches?.map(E.serialize)}),R.deserialize=B=>({...I(B),branches:B.branches?.map(E.deserialize)})})(V||(e.IStatementCoverage=V={}));var X;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(X||(e.TestDiffOpType=X={}));var H;(function(R){R.deserialize=(B,T)=>T.op===0?{op:T.op,item:t.deserialize(B,T.item)}:T.op===1?{op:T.op,item:$.deserialize(T.item)}:T.op===2?{op:T.op,uri:B.asCanonicalUri(D.URI.revive(T.uri)),docv:T.docv}:T,R.serialize=B=>B.op===0?{op:B.op,item:t.serialize(B.item)}:B.op===1?{op:B.op,item:$.serialize(B.item)}:B})(H||(e.TestsDiffOp=H={}));class O{constructor(B){this.k=B,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(B){const T=this.v();for(const te of B)switch(te.op){case 0:this.l(t.deserialize(this.k,te.item),T);break;case 1:this.o($.deserialize(te.item),T);break;case 3:this.p(te.itemId,T);break;case 5:this.q(te.itemId);break;case 4:this.updatePendingRoots(te.amount);break;case 6:this.c.set(te.tag.id,te.tag);break;case 7:this.c.delete(te.id);break}T.complete?.()}l(B,T){const te=L.$RK.parentId(B.item.extId)?.toString();let Q;if(!te)Q=this.w(B),this.g.add(Q),this.f.set(B.item.extId,Q);else if(this.f.has(te)){const ce=this.f.get(te);ce.children.add(B.item.extId),Q=this.w(B,ce),this.f.set(B.item.extId,Q)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return T.add?.(Q),B.expand===2&&this.h++,Q}o(B,T){const te=this.f.get(B.extId);if(te)return B.expand!==void 0&&(te.expand===2&&this.h--,B.expand===2&&this.h++),(0,e.$XK)(te,B),T.update?.(te),te}p(B,T){const te=this.f.get(B);if(!te)return;const Q=L.$RK.parentId(te.item.extId)?.toString();Q?this.f.get(Q).children.delete(te.item.extId):this.g.delete(te);const ce=[[B]];for(;ce.length;)for(const le of ce.pop()){const se=this.f.get(le);se&&(ce.push(se.children),this.f.delete(le),T.remove?.(se,se!==te),se.expand===2&&this.h--)}}q(B){}updatePendingRoots(B){this.j+=B}v(){return{}}}e.$ZK=O}),define(Me[75],Ae([1,0,11,5,6,55,60,48]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.TestItemEventOp=void 0;var f;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const k=(r,n)=>r===n,S=Object.entries({range:(r,n)=>r===n?!0:!r||!n?!1:r.equalsRange(n),busy:k,label:k,description:k,error:k,sortText:k,tags:(r,n)=>!(r.length!==n.length||r.some(a=>!n.includes(a)))}),l=(r,n)=>{let a;for(const[h,t]of S)t(r[h],n[h])||(a?a[h]=n[h]:a={[h]:n[h]});return a};class w extends C.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$qh(()=>this.flushDiff(),200)),this.g=this.B(new P.$5d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===n.uri){a.docv=n.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===n.item.extId){(0,M.$XK)(a.item,n.item);return}if(a.op===0&&a.item.item.extId===n.item.extId){(0,M.$XK)(a.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,a){const h=this.tree.get(n);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,a){switch(a.op){case 3:this.O(g.$RK.joinToString(n.fullId,a.id));break;case 0:this.z(a.item,n);break;case 5:for(const h of a.ops)this.w(n,h);break;case 1:this.C(a.new,a.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:a.update}});break;case 6:this.y(n.actual.uri);break;default:(0,L.$9c)(a)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,a){const h=g.$RK.fromExtHostTestItem(n,this.root.id,a?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(n.id);let $=this.tree.get(h.toString());if(!$){$={fullId:h,actual:n,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set($.fullId.toString(),$),this.G(n,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:$.expand,item:this.s.toITestItem(n)}}),this.I(n,$,a);return}if($.actual===n){this.H(n,$,a);return}if($.actual.uri?.toString()!==n.uri?.toString())return this.O(h.toString()),this.z(n,a);const c=this.s.getChildren($.actual),o=$.actual,b=l(this.s.toITestItem(o),this.s.toITestItem(n));this.s.getApiFor(o).listener=void 0,$.actual=n,$.expand=0,b&&(b.hasOwnProperty("tags")&&(this.C(n.tags,o.tags,h.toString()),delete b.tags),this.w($,{op:4,update:b})),this.I(n,$,a);for(const[p,d]of c)this.s.getChildren(n).get(d.id)||this.O(g.$RK.joinToString(h,d.id));this.y($.actual.uri)}C(n,a,h){const t=new Set(a.map($=>$.id));for(const $ of n)t.delete($.id)||this.D($);this.pushDiff({op:1,item:{extId:h,item:{tags:n.map($=>(0,M.$VK)(this.s.controllerId,$.id))}}}),t.forEach(this.F,this)}D(n){const a=this.j.get(n.id);a?a.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$VK)(this.s.controllerId,n.id)}}))}F(n){const a=this.j.get(n);a&&!--a.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,M.$VK)(this.s.controllerId,n)}))}G(n,a){this.s.getApiFor(n).parent=a&&a.actual!==this.root?a.actual:void 0}H(n,a,h){this.G(n,h);const t=this.s.getApiFor(n);t.parent=h?.actual,t.listener=$=>this.w(a,$),this.J(a)}I(n,a,h){this.H(n,a,h);for(const[t,$]of this.s.getChildren(n))this.z($,a)}J(n){let a;this.h?n.resolveBarrier?a=n.resolveBarrier.isOpen()?3:2:a=n.actual.canResolveChildren?1:0:a=0,a!==n.expand&&(n.expand=a,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:a}}),a===1&&n.expandLevels!==void 0&&this.M(n))}L(n,a){if(a<0)return;const h=[];for(const[t,$]of this.s.getChildren(n.actual)){const c=this.expand(g.$RK.joinToString(n.fullId,$.id),a);(0,D.$3g)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const $=new D.$dh;return $.open(),$}n.expand=2,this.N(n);const a=n.resolveBarrier=new D.$dh,h=$=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,$)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch($){h($)}return(0,D.$3g)(t)?t.catch(h).then(()=>{a.open(),this.J(n)}):(a.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const a=this.tree.get(n);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const $ of t.actual.tags)this.F($.id);this.tree.delete(t.fullId.toString());for(const[$,c]of this.s.getChildren(t.actual))h.push(this.tree.get(g.$RK.joinToString(t.fullId,c.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$8N=w;class m extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$9N=m;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$0N=s;class u extends Error{constructor(n,a,h){super(`TestItem with ID "${n}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$$N=u;const i=(r,n,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,$){for(const c of h.values())t.call($,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const $=new Map,c=new Set(h.keys()),o={op:5,ops:[]};for(const b of t){if(!(b instanceof a))throw new s(b.id);const p=n(b).controllerId;if(p!==r.controllerId)throw new u(b.id,p,r.controllerId);if($.has(b.id))throw new m(b.id);$.set(b.id,b),c.delete(b.id),o.ops.push({op:0,item:b})}for(const b of c.keys())o.ops.push({op:3,id:b});r.listener?.(o),h=$},add(t){if(!(t instanceof a))throw new s(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$_N=i}),define(Me[103],Ae([1,0,75]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=void 0;const P=new WeakMap,C=(M,g)=>{const f={controllerId:g};return P.set(M,f),f};e.$aO=C;const L=M=>{const g=P.get(M);if(!g)throw new D.$0N(M?.id||"<unknown>");return g};e.$bO=L}),define(Me[76],Ae([1,0,12,2]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kxb=e.$Jxb=e.$Ixb=e.$Hxb=e.$Gxb=void 0,e.$Gxb="vscode-cdn.net",e.$Hxb=`vscode-resource.${e.$Gxb}`,e.$Ixb=`'self' https://*.${e.$Gxb}`;function C(g,f){return g.scheme===D.Schemas.http||g.scheme===D.Schemas.https?g:(f&&f.authority&&f.isRemote&&g.scheme===D.Schemas.file&&(g=P.URI.from({scheme:D.Schemas.vscodeRemote,authority:f.authority,path:g.path})),P.URI.from({scheme:D.Schemas.https,authority:`${g.scheme}+${L(g.authority)}.${e.$Hxb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$Jxb=C;function L(g){return g.replace(/./g,f=>{const k=f.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?f:"-"+k.toString(16).padStart(4,"0")})}function M(g){return g.replace(/-([0-9a-f]{4})/g,(f,k)=>String.fromCharCode(parseInt(k,16)))}e.$Kxb=M}),define(Me[214],Ae([1,0,5,6,76]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class L{constructor(g,f,k){this.d=g,this.e=f,this.f=k,this.a=0,this.b=new P.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const F=f.getVisibleTextEditors();for(const S of this.c.values())F.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,f,k,F,S){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===g){l=n;break}if(!l)throw new Error("not a visible editor");const w=this,m=this.a++,s=new D.$5d,u=new D.$5d,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,C.$Jxb)(n,w.f)}get cspSource(){return C.$Ixb}set options(n){this.b=n,w.d.$setOptions(m,n)}get options(){return this.b}set html(n){this.a=n,w.d.$setHtml(m,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return w.d.$postMessage(m,n)}},r=new class{constructor(){this.editor=g,this.line=f,this.height=k,this.webview=i,this.onDidDispose=u.event}dispose(){w.c.has(m)&&(w.c.delete(m),w.d.$disposeEditorInset(m),u.fire(),u.dispose(),s.dispose())}};return this.d.$createEditorInset(m,l.id,l.value.document.uri,f+1,k,F||{},S.identifier,S.extensionLocation),this.c.set(m,{editor:g,inset:r,onDidReceiveMessage:s}),r}$onDidDispose(g){const f=this.c.get(g);f&&f.inset.dispose()}$onDidReceiveMessage(g,f){this.c.get(g)?.onDidReceiveMessage.fire(f)}}e.$6hc=L}),define(Me[104],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.$7K=void 0,e.$7K="__",e.$8K=(0,D.$ei)("IAuthenticationService")}),define(Me[215],Ae([1,0,4]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.VariableKind=e.$4O=void 0,e.$4O=(0,D.$ei)("configurationResolverService");var P;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class C extends Error{constructor(M,g){super(g),this.variable=M}}e.$5O=C}),define(Me[216],Ae([1,0,19,73,16,26,21,90,178,215,13]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=void 0;class S{constructor(w,m,s,u){this.h=new Map,this.a=w,this.b=m,this.g=s,u&&(this.c=u.then(i=>this.i(i)))}i(w){if(M.$c){const m=Object.create(null);return Object.keys(w).forEach(s=>{m[s.toLowerCase()]=w[s]}),m}return w}resolveWithEnvironment(w,m,s){return this.l({env:this.i(w),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(w,m){const s={env:await this.c,userHome:await this.g};return this.l(s,w?w.uri:void 0,m)}async j(w,m,s,u){const i=L.$In(m);M.$c&&i.windows?Object.keys(i.windows).forEach(n=>i[n]=i.windows[n]):M.$d&&i.osx?Object.keys(i.osx).forEach(n=>i[n]=i.osx[n]):M.$e&&i.linux&&Object.keys(i.linux).forEach(n=>i[n]=i.linux[n]),delete i.windows,delete i.osx,delete i.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,i,s,u)}async resolveAnyAsync(w,m,s){return this.j(w,m,s)}async resolveAnyMap(w,m,s){const u=new Map;return{newConfig:await this.j(w,m,s,u),resolvedVariables:u}}resolveWithInteractionReplace(w,m,s,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,m,s,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,m){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,m)}async l(w,m,s,u,i){if(C.$Sf(s))return this.m(w,m,s,u,i);if(Array.isArray(s))return Promise.all(s.map(r=>this.l(w,m,r,u,i)));if(C.$Uf(s)){const r=Object.create(null),n=await Promise.all(Object.keys(s).map(async a=>[await this.m(w,m,a,u,i),await this.l(w,m,s[a],u,i)]));for(const[a,h]of n)r[a]=h;return r}return s}m(w,m,s,u,i){return(0,F.$bf)(s,S.VARIABLE_REGEXP,async(r,n)=>{if(n.includes(S.VARIABLE_LHS))return r;let a=await this.o(w,r,n,m,u);return i?.set(n,a),a!==r&&C.$Sf(a)&&a.match(S.VARIABLE_REGEXP)&&(a=await this.m(w,m,a,u,i)),a})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,m,s,u,i){let r;const n=s.split(":");n.length>1&&(s=n[0],r=n[1]);const a=$=>{const c=this.a.getFilePath();if(c)return(0,g.$0v)(c);throw new k.$5O($,(0,f.localize)(0,null,m))},h=$=>{const c=a($);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,g.$0v)(o)}throw new k.$5O($,(0,f.localize)(1,null,m,D.$nc(c)))},t=$=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new k.$5O($,(0,f.localize)(2,null,m,r))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new k.$5O($,(0,f.localize)(3,null,m)):new k.$5O($,(0,f.localize)(4,null,m))};switch(s){case"env":if(r){if(w.env){const $=w.env[M.$c?r.toLowerCase():r];if(C.$Sf($))return $}return""}throw new k.$5O(k.VariableKind.Env,(0,f.localize)(5,null,m));case"config":if(r){const $=this.a.getConfigurationValue(u,r);if(C.$2f($))throw new k.$5O(k.VariableKind.Config,(0,f.localize)(6,null,m,r));if(C.$Uf($))throw new k.$5O(k.VariableKind.Config,(0,f.localize)(7,null,m,r));return $}throw new k.$5O(k.VariableKind.Config,(0,f.localize)(8,null,m));case"command":return this.p(k.VariableKind.Command,m,r,i,"command");case"input":return this.p(k.VariableKind.Input,m,r,i,"input");case"extensionInstallFolder":if(r){const $=await this.a.getExtension(r);if(!$)throw new k.$5O(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,m,r));return this.n($.extensionLocation)}throw new k.$5O(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,g.$0v)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return u||r?(0,g.$0v)(this.n(t(k.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$0v)(D.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new k.$5O(k.VariableKind.UserHome,(0,f.localize)(11,null,m))}case"lineNumber":{const $=this.a.getLineNumber();if($)return $;throw new k.$5O(k.VariableKind.LineNumber,(0,f.localize)(12,null,m))}case"selectedText":{const $=this.a.getSelectedText();if($)return $;throw new k.$5O(k.VariableKind.SelectedText,(0,f.localize)(13,null,m))}case"file":return a(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||r?D.$lc(this.n(t(k.VariableKind.RelativeFile)),a(k.VariableKind.RelativeFile)):a(k.VariableKind.RelativeFile);case"relativeFileDirname":{const $=D.$mc(a(k.VariableKind.RelativeFileDirname));if(u||r){const c=D.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),$);return c.length===0?".":c}return $}case"fileDirname":return D.$mc(a(k.VariableKind.FileDirname));case"fileExtname":return D.$oc(a(k.VariableKind.FileExtname));case"fileBasename":return D.$nc(a(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const $=D.$nc(a(k.VariableKind.FileBasenameNoExtension));return $.slice(0,$.length-D.$oc($).length)}case"fileDirnameBasename":return D.$nc(D.$mc(a(k.VariableKind.FileDirnameBasename)));case"execPath":{const $=this.a.getExecPath();return $||m}case"execInstallFolder":{const $=this.a.getAppRoot();return $||m}case"pathSeparator":case"/":return D.sep;default:try{const $=r?`${s}:${r}`:s;return this.p(k.VariableKind.Unknown,m,$,i,void 0)}catch{return m}}}}p(w,m,s,u,i){if(s&&u){const r=i===void 0?u[s]:u[i+":"+s];if(typeof r=="string")return r;throw new k.$5O(w,(0,f.localize)(14,null,m))}return m}}e.$gP=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Me[105],Ae([1,0,4,102]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oD=e.$nD=e.OpenEditorContext=e.GroupsOrder=e.$mD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$lD=void 0,e.$lD=(0,D.$ei)("editorGroupsService");var C;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var g;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var f;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function k(m){const s=m;return(0,P.$8E)(s?.editor)&&(0,P.$8E)(s?.replacement)}e.$mD=k;var F;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F||(e.GroupsOrder=F={}));var S;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$nD=l;function w(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$oD=w}),define(Me[217],Ae([1,0,4,105]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=void 0,e.$pD=(0,D.$ei)("editorService"),e.$qD=-1,e.$rD=-2,e.$sD=-3;function C(L){const M=L;return typeof L=="number"||(0,P.$nD)(M)}e.$tD=C}),define(Me[218],Ae([1,0,4,185]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=void 0,e.$lL=(0,D.$fi)(P.$li)}),define(Me[106],Ae([1,0,20,5,19,6,11]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=e.$O9b=e.$N9b=e.$M9b=void 0;class g{constructor(r,n){this.versionId=r,this.removedDueToLooping=n}}e.$M9b=g;class f{static isHostExtension(r,n,a){if(n.getExtensionDescription(r))return!1;const h=a.getExtensionDescription(r);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(r,n){this.j=r,this.c=new P.$5d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new D.$zm,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const n=this.j.readActivationEvents(r);for(const a of n)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,n){this.e=u(this.e,n),this.e=this.e.concat(r);const a=f.l(this.e);return this.e=u(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new g(this.d,a)}static l(r){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,o){this.addNode(c),this.addNode(o),this.c.has(c)?this.c.get(c).push(o):this.c.set(c,[o])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,o){const b=n.getArcs(c);for(let p=0;p<b.length;p++)if(!o.has(b[p]))return!1;return!0}getNodes(){return this.e}},a=new D.$zm;for(const c of r)if(a.set(c.identifier,c),c.extensionDependencies)for(const o of c.extensionDependencies)n.addArc(D.$xm.toKey(c.identifier),D.$xm.toKey(o));const h=new Set;n.getNodes().filter(c=>n.getArcs(c).length===0).forEach(c=>h.add(c));const t=n.getNodes().filter(c=>!h.has(c));let $;do{$=!1;for(let c=0;c<t.length;c++){const o=t[c];n.hasOnlyGoodArcs(o,h)&&(t.splice(c,1),c--,h.add(o),$=!0)}}while($);return t.map(c=>a.get(c))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const n=this.h.get(r);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const n=this.f.get(r);return n||void 0}getExtensionDescriptionByUUID(r){for(const n of this.g)if(n.uuid===r)return n}getExtensionDescriptionByIdOrUUID(r,n){return this.getExtensionDescription(r)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$N9b=f;class k{constructor(r,n){this.versionId=r,this.extensions=n}}e.$O9b=k;class F{constructor(r){this.d=new w,this.c=new f(r,[])}async acquireLock(r){const n=await this.d.acquire(r);return new S(this,n)}deltaExtensions(r,n,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,n){return this.c.getExtensionDescriptionByIdOrUUID(r,n)}}e.$P9b=F;class S extends L.$Tc{constructor(r,n){super(),this.f=r,this.c=!1,this.B(n)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$Q9b=S;class l{constructor(r){this.name=r;const n=(0,M.$0g)();this.promise=n.promise,this.c=n.resolve}resolve(r){this.c(r)}}class w{constructor(){this.c=[],this.d=!1}async acquire(r){const n=new l(r);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let n=!0;const a=setTimeout(()=>{n&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{n&&(clearTimeout(a),n=!1,this.d=!1,this.e())};r.resolve((0,L.$Rc)(h))}}var m;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(m||(m={}));function s(i,r){const n=i.isBuiltin?0:i.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(n!==a)return n-a;const h=C.$gc.basename(i.extensionLocation.path),t=C.$gc.basename(r.extensionLocation.path);return h<t?-1:h>t?1:0}function u(i,r){const n=new D.$ym(r);return i.filter(a=>!n.has(a.identifier))}}),define(Me[77],Ae([1,0,24]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Gm=e.$Fm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(P||(e.UIKind=P={}));var C;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function M(k){const F=D.$se.alloc(1);switch(k){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}e.$Fm=M;function g(k,F){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}e.$Gm=g;var f;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Me[61],Ae([1,0,4,5,14,27,77,57,58,26,2,6,166]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=e.$yO=e.$xO=e.$wO=void 0;let w=class extends S.$Tc{constructor(i,r){super(),this.s=i,this.t=r,this.a=this.B(new P.$5d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.$5d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=F.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:f.$3o,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(r.onDidChangeLogLevel(n=>{(0,C.$Aj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,r,n){const a=this.getTelemetryDetails(),h=new m(r,n,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(i,r,n){this.f=i,this.g=r,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const r=Object.create(null);switch(r["common.extname"]=`${i.publisher}.${i.name}`,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:r["common.uikind"]="web";break;case M.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,g.$ml)((0,f.$9o)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const r=this.getTelemetryDetails();this.r.forEach((n,a)=>{const h=n.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(n=>{for(const a of n)a.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,r){const a=this.r.get(i.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(i.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$wO=w,e.$wO=w=Xe([He(0,L.$vO),He(1,C.$zj)],w);class m{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,r,n,a,h,t,$){this.g=n,this.h=a,this.i=h,this.j=t,this.a=new P.$5d,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let r="properties"in i?i.properties??{}:i;return r=(0,f.$_o)(r,[]),this.c&&(r=(0,k.$Ln)(r,this.c)),this.b||(r=(0,k.$Ln)(r,this.j)),"properties"in i?i.properties=r:i=r,i}k(i,r){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(i,r),this.h.trace(i,r))}logUsage(i,r){this.d.isUsageEnabled&&this.k(i,r)}logError(i,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,r);else{const n={name:i.name,message:i.message,stack:i.stack,cause:i.cause},a=(0,f.$_o)(n,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$xO=m;function s(u){const i=Date.now()-new Date(u).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$yO=s,e.$zO=(0,D.$ei)("IExtHostTelemetry")}),define(Me[23],Ae([1,0,5,2,194,101,20,4]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.ActivationKind=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.ExtensionHostStartup=e.$TF=e.$SF=e.$RF=e.$QF=void 0,e.$QF=Object.freeze({identifier:new M.$xm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$RF="extensions.webWorker",e.$SF=(0,g.$ei)("extensionService");class f{constructor(h){this.dependency=h}}e.$TF=f;var k;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class F{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,$){this.c=h,this.d=t.slice(0),this.e=$.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$BF.createActivationEventsMap(this.d)}}set(h,t,$){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],o=[],b=[],p=[],d=S(this.d),I=S(t),v=(X,H)=>X.extensionLocation.toString()===H.extensionLocation.toString()||X.isBuiltin===H.isBuiltin||X.isUserBuiltin===H.isUserBuiltin||X.isUnderDevelopment===H.isUnderDevelopment;for(const X of this.d){const H=I.get(X.identifier);if(!H){c.push(X.identifier),d.delete(X.identifier);continue}if(!v(X,H)){c.push(X.identifier),d.delete(X.identifier);continue}}for(const X of t){const H=d.get(X.identifier);if(!H){o.push(X);continue}if(!v(H,X)){c.push(H.identifier),d.delete(H.identifier);continue}}const y=new M.$ym(this.e),E=new M.$ym($);for(const X of this.e)E.has(X)||b.push(X);for(const X of $)y.has(X)||p.push(X);const A=L.$BF.createActivationEventsMap(o),V={versionId:h,toRemove:c,toAdd:o,addActivationEvents:A,myToRemove:b,myToAdd:p};return this.delta(V),V}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:$,myToRemove:c,myToAdd:o}=h,b=new M.$ym(t),p=new M.$ym(c);for(let d=0;d<this.d.length;d++)b.has(this.d[d].identifier)&&(this.d.splice(d,1),d--);for(let d=0;d<this.e.length;d++)p.has(this.e[d])&&(this.e.splice(d,1),d--);for(const d of $)this.d.push(d);for(const d of o)this.e.push(d);return this.f=null,h}containsExtension(h){for(const t of this.e)if(M.$xm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const $=L.$BF.readActivationEvents(t);for(const c of $)h.add(c)}return h}}e.$UF=F;function S(a){const h=new M.$zm;for(const t of a)h.set(t.identifier,t);return h}function l(a,h){return!0}e.$VF=l;function w(a,h){if(!l(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$WF=w;class m{constructor(h,t,$,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=$,this.activationReason=c}}e.$XF=m;class s{constructor(h,t){this.description=h,this.value=t}}e.$YF=s;var u;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function i(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,C.$fp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$ZF=i;function r(a,h){return{identifier:new M.$xm((0,C.$dp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$1F=r;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$2F=n}),define(Me[219],Ae([1,0,15,106,20,23,14,11]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=e.$ric=e.$qic=e.$pic=void 0;class f{constructor(i,r,n,a){this.startup=i,this.codeLoadingTime=r,this.activateCallTime=n,this.activateResolvedTime=a}}e.$pic=f,f.NONE=new f(!1,-1,-1,-1);class k{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,r){return i===-1||r===-1?-1:r-i}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$qic=k;class F{constructor(i,r,n,a,h,t){this.activationFailed=i,this.activationFailedError=r,this.activationTimes=n,this.module=a,this.exports=h,this.subscriptions=t}}e.$ric=F;class S extends F{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$sic=S;class l extends F{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$tic=l;class w extends F{constructor(i){super(!0,i,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(i,r,n,a){this.g=a,this.a=i,this.b=r,this.c=n,this.d=new C.$zm,this.f=Object.create(null)}dispose(){for(const[i,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const i=[];for(const[r,n]of this.d)i.push(n.wait());await Promise.all(i)}isActivated(i){const r=this.d.get(i);return!!(r&&r.value)}getActivatedExtension(i){const r=this.d.get(i);if(!r||!r.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return r.value}async activateByEvent(i,r){if(this.f[i])return;const n=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(n.map(a=>({id:a.identifier,reason:{startup:r,extensionId:a.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,r){const n=this.a.getExtensionDescription(i);if(!n)throw new Error(`Extension '${i}' is not known`);return this.h([{id:n.identifier,reason:r}])}async h(i){const r=i.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(r.map(n=>n.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const r=this.a.getExtensionDescription(i.id);if(!r){const h=new Error(`Cannot activate unknown extension '${i.id.value}'`),t=this.k(i,null,[],new w(h));return this.c.onExtensionActivationError(i.id,h,new L.$TF(i.id.value)),t}const n=[],a=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){n.push(t);continue}if(this.l(h)){n.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:i.reason}));continue}const $=this.a.getExtensionDescription(h);if($){if(!$.main&&!$.browser)continue;n.push(this.j({id:$.identifier,reason:i.reason}));continue}const c=r.displayName||r.identifier.value,o=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),b=this.k(i,r.displayName,[],new w(o));return this.c.onExtensionActivationError(r.identifier,o,new L.$TF(h)),b}return this.k(i,r.displayName,n,null)}k(i,r,n,a){const h=new s(i.id,r,i.reason,n,a,this.c,this.g);return this.d.set(i.id,h),h}l(i){return P.$N9b.isHostExtension(i,this.a,this.b)}m(i){const r=this.b.getExtensionDescription(i);return r?!r.main&&!r.browser:!1}};e.$uic=m,e.$uic=m=Xe([He(3,M.$yj)],m);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,r,n,a,h,t,$){this.c=i,this.d=r,this.f=n,this.g=a,this.h=h,this.j=t,this.k=$,this.a=new g.$dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const r=this.g[i];if(r.value&&!r.value.activationFailed){this.g.splice(i,1),i--;continue}if(r.value&&r.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);n.detail=r.value.activationFailedError,this.h=new w(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const r=new Error;if(i&&i.name&&(r.name=i.name),i&&i.message?r.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(r.stack=i.stack),this.h=new w(r),this.b&&D.$4(i))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};s=Xe([He(6,M.$yj)],s)}),define(Me[220],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Me[221],Ae([1,0,180,15,32,96,72,30,20,220,190,101]),function(x,e,D,P,C,L,M,g,f,k,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=void 0;const l=g.$Un.as(M.$Vn.JSONContribution);class w{constructor(h,t,$){this.a=h,this.b=t,this.c=$}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$KF=w;class m{static a(h){const t=new f.$ym;for(let $=0,c=h.length;$<c;$++)t.add(h[$].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new m(t,[]);if(!t||!t.length)return new m([],h);const $=this.a(h),c=this.a(t),o=t.filter(p=>!$.has(p.description.identifier)),b=h.filter(p=>!c.has(p.description.identifier));return new m(o,b)}constructor(h,t){this.added=h,this.removed=t}}e.$LF=m;class s{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,P.$1)(h)}}}e.$MF=s;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$NF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$wm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$zo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$zo}},extensionKind:{description:D.localize(52,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&S.$BF.register(h.extensionPoint,h.activationEventsGenerator),e.$NF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(i,e.$NF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$OF=r;const n={ExtensionsRegistry:"ExtensionsRegistry"};g.$Un.add(n.ExtensionsRegistry,new r),e.$PF=g.$Un.as(n.ExtensionsRegistry),l.registerSchema(i,e.$NF),l.registerSchema(F.$Rj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Me[222],Ae([1,0,176,16,26,221,36,5]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var k;(function(l){function w(m,s,u){if(!m)return;const i=P.$Sf(m.type)?m.type:void 0;if(!i||i.length===0){u.error(D.localize(3,null));return}const r=[];if(Array.isArray(m.required))for(const n of m.required)P.$Sf(n)&&r.push(n);return{extensionId:s.value,taskType:i,required:r,properties:m.properties?C.$In(m.properties):{},when:m.when?M.$cj.deserialize(m.when):void 0}}l.from=w})(k||(k={}));const F=L.$PF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,w)=>{for(const m of l)m.type&&w.push(`onTaskType:${m.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:f}});class S{constructor(){this.d=new g.$5d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,m)=>{F.setHandler((s,u)=>{this.c=void 0;try{for(const i of u.removed){const r=i.value;for(const n of r)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const i of u.added){const r=i.value;for(const n of r){const a=k.from(n,i.description.identifier,i.collector);a&&(this.a[a.taskType]=a)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=C.$In(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},w.push(s)}this.c={oneOf:w}}return this.c}}e.$dH=new S}),define(Me[223],Ae([1,0,177,16,25,26,36,222]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$nH=e.JsonSchemaVersion=e.ExecutionEngine=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$hH=e.ShellQuoting=e.$gH=e.$fH=e.$eH=void 0,e.$eH="settings",e.$fH=new M.$vj("taskRunning",!1,D.localize(0,null)),e.$gH=D.localize2(2,"Tasks");var f;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$hH="$customized",function(R){function B(T){if(!T)return R.Strong;switch(T.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=B}(f||(e.ShellQuoting=f={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var F;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(F||(e.RevealKind=F={})),function(R){function B(T){switch(T.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=B}(F||(e.RevealKind=F={}));var S;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(R){function B(T){switch(T.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=B}(S||(e.RevealProblemKind=S={}));var l;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(l||(e.PanelKind=l={})),function(R){function B(T){switch(T.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=B}(l||(e.PanelKind=l={}));var w;(function(R){R.defaults={echo:!0,reveal:F.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(R){function B(te){switch(te.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=B;function T(te){switch(te){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=T}(m||(e.RuntimeType=m={}));var s;(function(R){function B(T){return P.$Sf(T)?T:T.value}R.value=B})(s||(e.CommandString=s={}));var u;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function B(te){return te===R.Clean._id||te===R.Build._id||te===R.Rebuild._id||te===R.Test._id}R.is=B;function T(te){if(te!==void 0)return P.$Sf(te)?B(te)?{_id:te,isDefault:!1}:void 0:te}R.from=T})(u||(e.TaskGroup=u={}));var i;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var r;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function B(T){switch(T){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=B})(r||(e.TaskSourceKind=r={}));var n;(function(R){R.parallel="parallel",R.sequence="sequence"})(n||(e.DependsOrder=n={}));var a;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(B,T,te,Q,ce,le){this._label="",this._id=B,T&&(this._label=T),te&&(this.type=te),this.runOptions=Q,this.configurationProperties=ce,this._source=le}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,T=!1){if(B===void 0)return!1;if(P.$Sf(B))return B===this._label||B===this.configurationProperties.identifier||T&&B===this._id;const te=this.getDefinition(!0);return te!==void 0&&te._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$iH=t;class $ extends t{constructor(B,T,te,Q,ce,le,se,$e){super(B,te,void 0,se,$e,T),this.command={},this._source=T,this.hasDefinedMatchers=le,ce&&(this.command=ce)}clone(){return new $(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let T;switch(this.command?this.command.runtime:void 0){case m.Shell:T="shell";break;case m.Process:T="process";break;case m.CustomExecution:T="customExecution";break;case void 0:T="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:T,_key:this._id,id:this._id}}}static is(B){return B instanceof $}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$eH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let T=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(T+=this._source.kind);const te={type:e.$hH,folder:B,id:T};return JSON.stringify(te)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Og(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new $(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$jH=$;class c extends t{constructor(B,T,te,Q,ce,le,se){super(B,te,Q,le,se,T),this._source=T,this.configures=ce}static is(B){return B instanceof c}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Og(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$eH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let T=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(T+=this._source.kind);const te={type:e.$hH,folder:B,id:T};return JSON.stringify(te)}}e.$kH=c;class o extends t{constructor(B,T,te,Q,ce,le,se,$e,ne){super(B,te,Q,$e,ne,T),this.defines=ce,this.hasDefinedMatchers=se,this.command=le,this.icon=ne.icon,this.hide=ne.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof o}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new o(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$lH=o;class b extends t{constructor(B,T,te,Q,ce,le){super(B,te,Q,ce,le,T),this._source=T}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new b(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$mH=b;var p;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(R){R._default=R.Terminal}(p||(e.ExecutionEngine=p={}));var d;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class I{constructor(B){this.c=new Map;for(let T=0;T<B.length;T++)this.c.set(B[T].uri.toString(),T)}compare(B,T){const te=B.getWorkspaceFolder(),Q=T.getWorkspaceFolder();if(te&&Q){let ce=this.c.get(te.uri.toString());ce=ce===void 0?0:ce+1;let le=this.c.get(Q.uri.toString());return le=le===void 0?0:le+1,ce===le?B._label.localeCompare(T._label):ce-le}else return!te&&Q?-1:te&&!Q?1:0}}e.$nH=I;var v;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(v||(e.TaskEventKind=v={}));var y;(function(R){R.SingleRun="singleRun",R.Background="background"})(y||(e.TaskRunType=y={}));var E;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var A;(function(R){function B($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function T($e,ne,ke){return{...B($e),kind:"start",terminalId:ne,resolvedVariables:ke}}R.start=T;function te($e,ne,ke){return{...B($e),kind:"processStarted",terminalId:ne,processId:ke}}R.processStarted=te;function Q($e,ne,ke){return{...B($e),kind:"processEnded",terminalId:ne,exitCode:ke}}R.processEnded=Q;function ce($e,ne,ke){return{...B($e),kind:"terminated",exitReason:ke,terminalId:ne}}R.terminated=ce;function le($e,ne,ke){return{...B(ne),kind:$e,terminalId:ke}}R.general=le;function se(){return{kind:"changed"}}R.changed=se})(A||(e.TaskEvent=A={}));var V;(function(R){function B(te){const Q=Object.keys(te).sort();let ce="";for(const le of Q){let se=te[le];se instanceof Object?se=B(se):typeof se=="string"&&(se=se.replace(/,/g,",,")),ce+=le+","+se+","}return ce}function T(te){const ce={_key:B(te),type:te.taskType};return Object.assign(ce,te),ce}R.create=T})(V||(e.KeyedTaskIdentifier=V={}));var X;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(X||(e.TaskSettingId=X={}));var H;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(H||(e.TasksSchemaProperties=H={}));var O;(function(R){function B(T,te){const Q=g.$dH.get(T.type);if(Q===void 0){const $e=L.$In(T);return delete $e._key,V.create($e)}const ce=Object.create(null);ce.type=Q.taskType;const le=new Set;Q.required.forEach($e=>le.add($e));const se=Q.properties;for(const $e of Object.keys(se)){const ne=T[$e];if(ne!=null)ce[$e]=ne;else if(le.has($e)){const ke=se[$e];if(ke.default!==void 0)ce[$e]=L.$In(ke.default);else switch(ke.type){case"boolean":ce[$e]=!1;break;case"number":case"integer":ce[$e]=0;break;case"string":ce[$e]="";break;default:te.error(D.localize(1,null,JSON.stringify(T,void 0,0),$e));return}}}return V.create(ce)}R.createTaskIdentifier=B})(O||(e.TaskDefinition=O={}))}),define(Me[224],Ae([1,0,15]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9b=e.$R9b=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,g)=>{this.b=M,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,D.$1)(M))}then(M,g){return this.j().then(M,g)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$R9b=P;class C extends P{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$S9b=C}),define(Me[49],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=void 0;class D{constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++D.count}}e.$4v=D,D.count=0;const P=[];function C(g){const f=new D(g);return P[f.nid]=f,f}e.$5v=C;function L(g){return P[g].sid}e.$6v=L;class M{constructor(f){this.value=f}}e.$7v=M}),define(Me[3],Ae([1,0,49]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(P||(e.TextEditorRevealType=P={}));var C;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var g;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var F;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(F||(e.CandidatePortSource=F={}));class S{static mixin(u){return u._id=S.a++,u}}e.$ZL=S,S.a=0;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$1L={MainThreadAuthentication:(0,D.$5v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$5v)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$5v)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$5v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$5v)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$5v)("MainThreadClipboard"),MainThreadCommands:(0,D.$5v)("MainThreadCommands"),MainThreadComments:(0,D.$5v)("MainThreadComments"),MainThreadConfiguration:(0,D.$5v)("MainThreadConfiguration"),MainThreadConsole:(0,D.$5v)("MainThreadConsole"),MainThreadDebugService:(0,D.$5v)("MainThreadDebugService"),MainThreadDecorations:(0,D.$5v)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$5v)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$5v)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$5v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$5v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$5v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$5v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$5v)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$5v)("MainThreadErrors"),MainThreadTreeViews:(0,D.$5v)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$5v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$5v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$5v)("MainThreadLanguages"),MainThreadLogger:(0,D.$5v)("MainThreadLogger"),MainThreadMessageService:(0,D.$5v)("MainThreadMessageService"),MainThreadOutputService:(0,D.$5v)("MainThreadOutputService"),MainThreadProgress:(0,D.$5v)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$5v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$5v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$5v)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$5v)("MainThreadSecretState"),MainThreadStorage:(0,D.$5v)("MainThreadStorage"),MainThreadSpeech:(0,D.$5v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$5v)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$5v)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$5v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$5v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$5v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$5v)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$5v)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$5v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$5v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$5v)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$5v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$5v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$5v)("MainThreadExtensionService"),MainThreadSCM:(0,D.$5v)("MainThreadSCM"),MainThreadSearch:(0,D.$5v)("MainThreadSearch"),MainThreadShare:(0,D.$5v)("MainThreadShare"),MainThreadTask:(0,D.$5v)("MainThreadTask"),MainThreadWindow:(0,D.$5v)("MainThreadWindow"),MainThreadLabelService:(0,D.$5v)("MainThreadLabelService"),MainThreadNotebook:(0,D.$5v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$5v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$5v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$5v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$5v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$5v)("MainThreadInteractive"),MainThreadChat:(0,D.$5v)("MainThreadChat"),MainThreadInlineChat:(0,D.$5v)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$5v)("MainThreadTheming"),MainThreadTunnelService:(0,D.$5v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$5v)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$5v)("MainThreadTimeline"),MainThreadTesting:(0,D.$5v)("MainThreadTesting"),MainThreadLocalization:(0,D.$5v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$5v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$5v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$5v)("MainThreadIssueReporter")},e.$2L={ExtHostCommands:(0,D.$5v)("ExtHostCommands"),ExtHostConfiguration:(0,D.$5v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$5v)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$5v)("ExtHostDebugService"),ExtHostDecorations:(0,D.$5v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$5v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$5v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$5v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$5v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$5v)("ExtHostEditors"),ExtHostTreeViews:(0,D.$5v)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$5v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$5v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$5v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$5v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$5v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$5v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$5v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$5v)("ExtHostStatusBar"),ExtHostShare:(0,D.$5v)("ExtHostShare"),ExtHostExtensionService:(0,D.$5v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$5v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$5v)("ExtHostTerminalService"),ExtHostSCM:(0,D.$5v)("ExtHostSCM"),ExtHostSearch:(0,D.$5v)("ExtHostSearch"),ExtHostTask:(0,D.$5v)("ExtHostTask"),ExtHostWorkspace:(0,D.$5v)("ExtHostWorkspace"),ExtHostWindow:(0,D.$5v)("ExtHostWindow"),ExtHostWebviews:(0,D.$5v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$5v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$5v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$5v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$5v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$5v)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$5v)("ExtHostProgress"),ExtHostComments:(0,D.$5v)("ExtHostComments"),ExtHostSecretState:(0,D.$5v)("ExtHostSecretState"),ExtHostStorage:(0,D.$5v)("ExtHostStorage"),ExtHostUrls:(0,D.$5v)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$5v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$5v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$5v)("ExtHostOutputService"),ExtHostLabelService:(0,D.$5v)("ExtHostLabelService"),ExtHostNotebook:(0,D.$5v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$5v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$5v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$5v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$5v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$5v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$5v)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$5v)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$5v)("ExtHostChat"),ExtHostChatAgents2:(0,D.$5v)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$5v)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$5v)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$5v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$5v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$5v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$5v)("ExtHostTheming"),ExtHostTunnelService:(0,D.$5v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$5v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$5v)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$5v)("ExtHostTimeline"),ExtHostTesting:(0,D.$5v)("ExtHostTesting"),ExtHostTelemetry:(0,D.$5v)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$5v)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$5v)("ExtHostIssueReporter")}}),define(Me[78],Ae([1,0,4,14,3,17]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=e.$Nhc=void 0,e.$Nhc=(0,D.$ei)("IExtHostApiDeprecationService");let M=class{constructor(f,k){this.c=k,this.a=new Set,this.b=f.getProxy(C.$1L.MainThreadTelemetry)}report(f,k,F){const S=this.d(f,k);this.a.has(S)||(this.a.add(S),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${F}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:f}))}d(f,k){return`${f}-${k.identifier.value}`}};e.$Ohc=M,e.$Ohc=M=Xe([He(0,L.$fO),He(1,P.$yj)],M),e.$Phc=Object.freeze(new class{report(g,f,k){}})}),define(Me[225],Ae([1,0,53,6,3]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class L{constructor(f,k){this.extension=f,this.provider=k,this.handle=L.a++}}L.a=0;class M{constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(C.$1L.MainThreadChat)}registerChatProvider(f,k,F){const S=new L(f,F);return this.b.set(S.handle,S),this.d.$registerChatProvider(S.handle,k),(0,P.$Rc)(()=>{this.d.$unregisterChatProvider(S.handle),this.b.delete(S.handle)})}transferChatSession(f,k){const F=D.Iterable.find(this.c.keys(),S=>this.c.get(S)===f)??0;typeof F=="number"&&this.d.$transferChatSession(F,k)}sendInteractiveRequestToProvider(f,k){this.d.$sendRequestToProvider(f,k)}async $prepareChat(f,k){const F=this.b.get(f);if(!F)return;const S=await F.provider.prepareSession(k);if(!S)return;const l=M.a++;return this.c.set(l,S),{id:l,requesterUsername:S.requester?.name,requesterAvatarIconUri:S.requester?.icon,responderUsername:S.responder?.name,responderAvatarIconUri:S.responder?.icon,inputPlaceholder:S.inputPlaceholder}}$releaseSession(f){this.c.delete(f)}}e.$Zhc=M,M.a=0}),define(Me[226],Ae([1,0,3]),function(x,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class P{constructor(L){const M=L.getProxy(D.$1L.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(g){return M.$writeText(g)}})}}e.$4hc=P}),define(Me[227],Ae([1,0,26,3,27,17]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=void 0;let M=class{constructor(F,S){this.a=F.getProxy(P.$1L.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(F,S){const l=this,w=console[F];Object.defineProperty(console,F,{set:()=>{},get:()=>function(){l.e(F,S,w,arguments)}})}e(F,S,l,w){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:f(w,this.b)}),this.c&&this.f(F,l,w)}};e.$Ujc=M,e.$Ujc=M=Xe([He(0,L.$fO),He(1,C.$vO)],M);const g=1e5;function f(k,F){const S=[];if(k.length)for(let l=0;l<k.length;l++){let w=k[l];if(typeof w>"u")w="undefined";else if(w instanceof Error){const m=w;m.stack?w=m.stack:w=m.toString()}S.push(w)}if(F){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,D.$Nn)(S);return l.length>g?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Me[228],Ae([1,0,2,3,23]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class L{constructor(g){this.a=g.getProxy(P.$1L.MainThreadDialogs)}showOpenDialog(g,f){return f?.allowUIResources&&(0,C.$WF)(g,"showLocal"),this.a.$showOpenDialog(f).then(k=>k?k.map(F=>D.URI.revive(F)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(f=>f?D.URI.revive(f):void 0)}}e.$Yic=L}),define(Me[229],Ae([1,0,6,3]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class C{constructor(M){this.b=0,this.a=M.getProxy(P.$1L.MainThreadLabelService)}$registerResourceLabelFormatter(M){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,M),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$hjc=C}),define(Me[79],Ae([1,0,21,13,2,4,14,3,27,17]),function(x,e,D,P,C,L,M,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=e.$Gic=void 0;let F=class{constructor(l,w,m){this.f=m,this.d=new Map,this.a=w.getProxy(g.$1L.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===D.$a}getMessage(l,w){const{message:m,args:s,comment:u}=w;if(this.c)return(0,P.$Ue)(m,s??{});let i=m;u&&u.length>0&&(i+=`/${Array.isArray(u)?u.join(""):u}`);const r=this.d.get(l)?.contents[i];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,P.$Ue)(r??m,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let w;const m=await this.g(l);if(!m){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),u=JSON.parse(s);w=l.isBuiltin?u.contents?.bundle:u}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${m}: ${s.message}`);return}w&&this.d.set(l.identifier.value,{contents:w,uri:m})}async g(l){if(l.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive(w)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Gic=F,e.$Gic=F=Xe([He(0,f.$vO),He(1,k.$fO),He(2,M.$yj)],F),e.$Hic=(0,L.$ei)("IExtHostLocalizationService")}),define(Me[230],Ae([1,0,14,3,27,17,2,51]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;let f=class extends D.$Jj{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(w=>(0,g.$Nh)(w))),this.r=S.getProxy(P.$1L.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(M.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,w){return new k(this.r,S,l,w)}};e.$Tjc=f,e.$Tjc=f=Xe([He(0,L.$fO),He(1,C.$vO)],f);class k extends D.$Ej{constructor(S,l,w,m){super(m?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(l,m).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const w=[[S,l]];this.m?this.u(w):this.n.push(...w)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Me[80],Ae([1,0,3,4,6,17,24]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=e.$Iic=void 0,e.$Iic=(0,P.$ei)("IExtHostManagedSockets");let g=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(D.$1L.MainThreadManagedSockets)}setFactory(S,l){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,w=await this.c.makeConnection(),m=new C.$Sc;return this.d.set(l,new k(l,w,m)),m.add((0,C.$Rc)(()=>this.d.delete(l))),m.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),m.dispose()})),m.add(w.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),m.dispose()})),m.add(w.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,M.$se.wrap(s)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Jic=g,e.$Jic=g=Xe([He(0,L.$fO)],g);class f{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class k extends C.$Tc{constructor(S,l,w){super(),this.socketId=S,this.actual=l,this.B(w)}}}),define(Me[231],Ae([1,0,3,14,23]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;function L(g){return g&&g.title}let M=class{constructor(f,k){this.b=k,this.a=f.getProxy(D.$1L.MainThreadMessageService)}showMessage(f,k,F,S,l){const w={source:{identifier:f.identifier,label:f.displayName||f.name}};let m;typeof S=="string"||L(S)?m=[S,...l]:(w.modal=S?.modal,w.useCustom=S?.useCustom,w.detail=S?.detail,m=l),w.useCustom&&(0,C.$WF)(f,"resolvers");const s=[];let u=!1;for(let i=0;i<m.length;i++){const r=m[i];if(typeof r=="string")s.push({title:r,handle:i,isCloseAffordance:!1});else if(typeof r=="object"){const{title:n,isCloseAffordance:a}=r;s.push({title:n,isCloseAffordance:!!a,handle:i}),a&&(u?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,r):u=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,r)}return this.a.$showMessage(k,F,w,s).then(i=>{if(typeof i=="number")return m[i]})}};e.$jjc=M,e.$jjc=M=Xe([He(1,P.$yj)],M)}),define(Me[232],Ae([1,0,6,16,2,23,3]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;class g{constructor(k){this.b=new Map,this.a=k.getProxy(M.$1L.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,F,S){if((0,L.$WF)(k,"profileContentHandlers"),this.b.has(F))throw new Error(`Handler with id '${F}' already registered`);return this.b.set(F,S),this.a.$registerProfileContentHandler(F,S.name,S.description,k.identifier.value),(0,D.$Rc)(()=>{this.b.delete(F),this.a.$unregisterProfileContentHandler(F)})}async $saveProfile(k,F,S,l){const w=this.b.get(k);if(!w)throw new Error(`Unknown handler with id: ${k}`);return w.saveProfile(F,S,l)}async $readProfile(k,F,S){const l=this.b.get(k);if(!l)throw new Error(`Unknown handler with id: ${k}`);return l.readProfile((0,P.$Sf)(F)?F:C.URI.revive(F),S)}}e.$sjc=g}),define(Me[81],Ae([1,0,3,5,4]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=void 0;class L{constructor(g){this.b=new P.$5d,this.onDidChangePassword=this.b.event,this.a=g.getProxy(D.$1L.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,f){return this.a.$getPassword(g,f)}store(g,f,k){return this.a.$setPassword(g,f,k)}delete(g,f){return this.a.$deletePassword(g,f)}}e.$Dic=L,e.$Eic=(0,C.$ei)("IExtHostSecretState")}),define(Me[233],Ae([1,0,22,6,3]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;class L{constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(C.$1L.MainThreadSpeech)}async $createSpeechToTextSession(g,f,k){const F=this.c.get(g);if(!F)return;const S=new P.$Sc,l=new D.$ce;this.d.set(f,l);const w=S.add(F.provideSpeechToTextSession(l.token,k?{language:k}:void 0));S.add(w.onDidChange(m=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,m)})),S.add(l.token.onCancellationRequested(()=>S.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}async $createKeywordRecognitionSession(g,f){const k=this.c.get(g);if(!k)return;const F=new P.$Sc,S=new D.$ce;this.d.set(f,S);const l=F.add(k.provideKeywordRecognitionSession(S.token));F.add(l.onDidChange(w=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,w)})),F.add(S.token.onCancellationRequested(()=>F.dispose()))}async $cancelKeywordRecognitionSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,f,k){const F=L.a++;return this.c.set(F,k),this.b.$registerProvider(F,f,{extension:g,displayName:g.value}),(0,P.$Rc)(()=>{this.b.$unregisterProvider(F),this.c.delete(F)})}}e.$zjc=L,L.a=1}),define(Me[82],Ae([1,0,3,5,4]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;class L{constructor(g,f){this.c=f,this.b=new P.$5d,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(D.$1L.MainThreadStorage)}registerExtensionStorageKeysToSync(g,f){this.a.$registerExtensionStorageKeysToSync(g,f)}async initializeExtensionStorage(g,f,k){const F=await this.a.$initializeExtensionStorage(g,f);let S;return F&&(S=this.d(g,f,F)),S||k}setValue(g,f,k){return this.a.$setValue(g,f,k)}$acceptValue(g,f,k){const F=this.d(g,f,k);F&&this.b.fire({shared:g,key:f,value:F})}d(g,f,k){try{return JSON.parse(k)}catch(F){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${g}): ${F}`)}}}e.$vic=L,e.$wic=(0,C.$ei)("IExtHostStorage")}),define(Me[234],Ae([1,0,6,12,2,3]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class M{constructor(f){this.c=new Map,this.b=f.getProxy(L.$1L.MainThreadUriOpeners)}registerExternalUriOpener(f,k,F,S){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=S.schemes.find(w=>!M.a.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(k,F),this.b.$registerUriOpener(k,S.schemes,f,S.label),(0,D.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(f,k,F){const S=this.c.get(f);if(!S)throw new Error(`Unknown opener with id: ${f}`);const l=C.URI.revive(k);return S.canOpenExternalUri(l,F)}async $openUri(f,k,F){const S=this.c.get(f);if(!S)throw new Error(`Unknown opener id: '${f}'`);return S.openExternalUri(C.URI.revive(k.resolvedUri),{sourceUri:C.URI.revive(k.sourceUri)},F)}}e.$Njc=M,M.a=new Set([P.Schemas.http,P.Schemas.https])}),define(Me[235],Ae([1,0,3,2,6,15,20]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=void 0;class g{constructor(k){this.c=new M.$ym,this.d=new Map,this.b=k.getProxy(D.$1L.MainThreadUrls)}registerUriHandler(k,F){const S=k.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=g.a++;return this.c.add(S),this.d.set(l,F),this.b.$registerUriHandler(l,S,k.displayName||k.name),(0,C.$Rc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(k,F){const S=this.d.get(k);if(!S)return Promise.resolve(void 0);try{S.handleUri(P.URI.revive(F))}catch(l){(0,L.$1)(l)}return Promise.resolve(void 0)}async createAppUri(k){return P.URI.revive(await this.b.$createAppUri(k))}}e.$Ojc=g,g.a=0});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[62],Ae([1,0,5,6,12,26,2,183,205,76,3]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";var S,l,w,m,s,u,i,r,n,a,h,t,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=e.$iic=e.$hic=e.$gic=void 0;class c{constructor(A,V,X,H,O,R,B){S.set(this,void 0),l.set(this,void 0),w.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),i.set(this,""),r.set(this,void 0),n.set(this,!1),a.set(this,!1),h.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new D.$5d,this.onDidReceiveMessage=this._onMessageEmitter.event,$.set(this,new D.$5d),this._onDidDispose=Ue(this,$,"f").event,xe(this,S,A,"f"),xe(this,l,V,"f"),xe(this,r,X,"f"),xe(this,m,H,"f"),xe(this,s,O,"f"),xe(this,u,R,"f"),xe(this,h,o(R),"f"),xe(this,t,b(R),"f"),xe(this,w,B,"f")}dispose(){xe(this,n,!0,"f"),Ue(this,$,"f").fire(),Ue(this,$,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(A){return xe(this,a,!0,"f"),(0,k.$Jxb)(A,Ue(this,m,"f"))}get cspSource(){const A=Ue(this,u,"f").extensionLocation;if(A.scheme===C.Schemas.https||A.scheme===C.Schemas.http){let V=A.toString();return V.endsWith("/")||(V+="/"),V+" "+k.$Ixb}return k.$Ixb}get html(){return this.a(),Ue(this,i,"f")}set html(A){this.a(),Ue(this,i,"f")!==A&&(xe(this,i,A,"f"),Ue(this,t,"f")&&!Ue(this,a,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(A)&&(xe(this,a,!0,"f"),Ue(this,w,"f").report("Webview vscode-resource: uris",Ue(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,l,"f").$setHtml(Ue(this,S,"f"),this.b(A)))}get options(){return this.a(),Ue(this,r,"f")}set options(A){this.a(),L.$Mn(Ue(this,r,"f"),A)||Ue(this,l,"f").$setOptions(Ue(this,S,"f"),I(Ue(this,u,"f"),Ue(this,s,"f"),A)),xe(this,r,A,"f")}async postMessage(A){if(Ue(this,n,"f"))return!1;const V=(0,f.$inb)(A,{serializeBuffersForPostMessage:Ue(this,h,"f")});return Ue(this,l,"f").$postMessage(Ue(this,S,"f"),V.message,...V.buffers)}a(){if(Ue(this,n,"f"))throw new Error("Webview is disposed")}b(A){if(!Ue(this,t,"f"))return A;const V=Ue(this,u,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,X=Ue(this,u,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Ue(this,u,"f").extensionLocation.authority:void 0;return A.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,O,R,B,T,te)=>{const Q=M.URI.from({scheme:B||"file",path:decodeURIComponent(T)}),ce=(0,k.$Jxb)(Q,{isRemote:V,authority:X}).toString();return`${O}${ce}${te}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,O,R,B,T,te)=>{const Q=M.URI.from({scheme:B||"file",path:decodeURIComponent(T)}),ce=(0,k.$Jxb)(Q,{isRemote:V,authority:X}).toString();return`${O}${ce}${te}`})}}e.$gic=c,S=new WeakMap,l=new WeakMap,w=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,i=new WeakMap,r=new WeakMap,n=new WeakMap,a=new WeakMap,h=new WeakMap,t=new WeakMap,$=new WeakMap;function o(E){try{const A=(0,g.$op)((0,g.$np)(E.engines.vscode));return!!A&&A.majorBase>=1&&A.minorBase>=57}catch{return!1}}e.$hic=o;function b(E){try{const A=(0,g.$op)((0,g.$np)(E.engines.vscode));return A?A.majorBase<1||A.majorBase===1&&A.minorBase<60:!1}catch{return!1}}class p extends P.$Tc{constructor(A,V,X,H,O){super(),this.c=V,this.f=X,this.g=H,this.h=O,this.b=new Map,this.a=A.getProxy(F.$1L.MainThreadWebviews)}dispose(){super.dispose();for(const A of this.b.values())A.dispose();this.b.clear()}$onMessage(A,V,X){const H=this.j(A);if(H){const{message:O}=(0,f.$jnb)(V,X.value);H._onMessageEmitter.fire(O)}}$onMissingCsp(A,V){this.g.warn(`${V} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(A,V,X){const H=new c(A,this.a,v(V),this.c,this.f,X,this.h);this.b.set(A,H);const O=H._onDidDispose(()=>{O.dispose(),this.deleteWebview(A)});return H}deleteWebview(A){this.b.delete(A)}j(A){return this.b.get(A)}}e.$iic=p;function d(E){return{id:E.identifier,location:E.extensionLocation}}e.$jic=d;function I(E,A,V){return{enableCommandUris:V.enableCommandUris,enableScripts:V.enableScripts,enableForms:V.enableForms,portMapping:V.portMapping,localResourceRoots:V.localResourceRoots||y(E,A)}}e.$kic=I;function v(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(A=>M.URI.from(A))}}function y(E,A){return[...(A?.getWorkspaceFolders()||[]).map(V=>V.uri),E.extensionLocation]}}),define(Me[107],Ae([1,0,5,3,2,12,13,4,17,23]),function(x,e,D,P,C,L,M,g,f,k){"use strict";var F;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=e.$Qjc=void 0;let S=F=class{getState(w){const m=this.d;return{get focused(){return m.focused},get active(){return(0,k.$WF)(w,"windowActivity"),m.active}}}constructor(w){this.c=new D.$5d,this.onDidChangeWindowState=this.c.event,this.d=F.a,this.b=w.getProxy(P.$1L.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:s})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,m){m!==this.d[w]&&(this.d={...this.d,[w]:m},this.c.fire(this.d))}openUri(w,m){let s;if(typeof w=="string"){s=w;try{w=C.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,M.$Se)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,s,m)}async asExternalUri(w,m){if((0,M.$Se)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(w,m);return C.URI.from(s)}};e.$Qjc=S,S.a={focused:!0,active:!0},e.$Qjc=S=F=Xe([He(0,f.$fO)],S),e.$Rjc=(0,g.$ei)("IExtHostWindow")}),define(Me[236],Ae([1,0,227,27,17]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;let L=class extends D.$Ujc{constructor(g,f){super(g,f)}f(g,f,k){f.apply(console,k)}};e.$3lc=L,e.$3lc=L=Xe([He(0,C.$fO),He(1,P.$vO)],L)}),define(Me[237],Ae([1,0,11,24,22,15,5,6,129,224,49]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$V9b=e.ResponsiveState=e.RequestInitiator=e.$U9b=e.$T9b=void 0;function l(E,A){try{return JSON.stringify(E,A)}catch{return"null"}}const w="$$ref$$",m={[w]:-1};class s{constructor(A,V){this.jsonString=A,this.referencedBuffers=V}}function u(E,A=null,V=!1){const X=[];return{jsonString:(V?l:JSON.stringify)(E,(O,R)=>{if(typeof R>"u")return m;if(typeof R=="object"){if(R instanceof P.$se){const B=X.push(R)-1;return{[w]:B}}if(A)return A(O,R)}return R}),referencedBuffers:X}}e.$T9b=u;function i(E,A,V){return JSON.parse(E,(X,H)=>{if(H){const O=H[w];if(typeof O=="number")return A[O];if(V&&H.$mid===1)return V.transformIncoming(H)}return H})}e.$U9b=i;function r(E,A){return JSON.stringify(E,A)}function n(E){return E?(A,V)=>V&&V.$mid===1?E.transformOutgoing(V):V:null}var a;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},$=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class o extends g.$Tc{constructor(A,V=null,X=null){super(),this[S]=!0,this.b=this.B(new M.$5d),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=V,this.g=X,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let H=0,O=F.$4v.count;H<O;H++)this.m[H]=null,this.s[H]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$qh(()=>this.H(),1e3)),this.c.onMessage(H=>this.L(H))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const V=this.w[A];delete this.w[A],V.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,f.$hn)(A,this.g):A}getProxy(A){const{nid:V,sid:X}=A;return this.s[V]||(this.s[V]=this.J(V,X)),this.s[V]}J(A,V){const X={get:(H,O)=>(typeof O=="string"&&!H[O]&&O.charCodeAt(0)===36&&(H[O]=(...R)=>this.U(A,O,R)),O===c?V:H[O])};return new Proxy(Object.create(null),X)}set(A,V){return this.m[A.nid]=V,V}assertRegistered(A){for(let V=0,X=A.length;V<X;V++){const H=A[V];if(!this.m[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}L(A){if(this.j)return;const V=A.byteLength,X=p.read(A,0),H=X.readUInt8(),O=X.readUInt32();switch(H){case 1:case 2:{let{rpcId:R,method:B,args:T}=I.deserializeRequestJSONArgs(X);this.g&&(T=(0,f.$hn)(T,this.g)),this.M(V,O,R,B,T,H===2);break}case 3:case 4:{let{rpcId:R,method:B,args:T}=I.deserializeRequestMixedArgs(X);this.g&&(T=(0,f.$hn)(T,this.g)),this.M(V,O,R,B,T,H===4);break}case 5:{this.f?.logIncoming(V,O,0,"ack"),this.G(O);break}case 6:{this.N(V,O);break}case 7:{this.O(V,O,void 0);break}case 9:{let R=I.deserializeReplyOKJSON(X);this.g&&(R=(0,f.$hn)(R,this.g)),this.O(V,O,R);break}case 10:{const R=I.deserializeReplyOKJSONWithBuffers(X,this.g);this.O(V,O,R);break}case 8:{const R=I.deserializeReplyOKVSBuffer(X);this.O(V,O,R);break}case 11:{let R=I.deserializeReplyErrError(X);this.g&&(R=(0,f.$hn)(R,this.g)),this.P(V,O,R);break}case 12:{this.P(V,O,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,V,X,H,O,R){this.f?.logIncoming(A,V,1,`receiveRequest ${(0,F.$6v)(X)}.${H}(`,O);const B=String(V);let T,te;if(R){const ce=new C.$ce;O.push(ce.token),T=this.Q(X,H,O),te=()=>ce.cancel()}else T=this.Q(X,H,O),te=t;this.u[B]=te;const Q=I.serializeAcknowledged(V);this.f?.logOutgoing(Q.byteLength,V,1,"ack"),this.c.send(Q),T.then(ce=>{delete this.u[B];const le=I.serializeReplyOK(V,ce,this.h);this.f?.logOutgoing(le.byteLength,V,1,"reply:",ce),this.c.send(le)},ce=>{delete this.u[B];const le=I.serializeReplyErr(V,ce);this.f?.logOutgoing(le.byteLength,V,1,"replyErr:",ce),this.c.send(le)})}N(A,V){this.f?.logIncoming(A,V,1,"receiveCancel");const X=String(V);this.u[X]?.()}O(A,V,X){this.f?.logIncoming(A,V,0,"receiveReply:",X);const H=String(V);if(!this.w.hasOwnProperty(H))return;const O=this.w[H];delete this.w[H],O.resolveOk(X)}P(A,V,X){this.f?.logIncoming(A,V,0,"receiveReplyErr:",X);const H=String(V);if(!this.w.hasOwnProperty(H))return;const O=this.w[H];delete this.w[H];let R;X&&(X.$isError?(R=new Error,R.name=X.name,R.message=X.message,R.stack=X.stack):R=X),O.resolveErr(R)}Q(A,V,X){try{return Promise.resolve(this.S(A,V,X))}catch(H){return Promise.reject(H)}}S(A,V,X){const H=this.m[A];if(!H)throw new Error("Unknown actor "+(0,F.$6v)(A));const O=H[V];if(typeof O!="function")throw new Error("Unknown method "+V+" on actor "+(0,F.$6v)(A));return O.apply(H,X)}U(A,V,X){if(this.j)return new k.$S9b;let H=null;if(X.length>0&&C.CancellationToken.isCancellationToken(X[X.length-1])&&(H=X.pop()),H&&H.isCancellationRequested)return Promise.reject(L.$6());const O=I.serializeRequestArguments(X,this.h),R=++this.t,B=String(R),T=new k.$R9b,te=new g.$Sc;H&&te.add(H.onCancellationRequested(()=>{const ce=I.serializeCancel(R);this.f?.logOutgoing(ce.byteLength,R,0,"cancel"),this.c.send(I.serializeCancel(R))})),this.w[B]=new b(T,te),this.F(R);const Q=I.serializeRequest(R,A,V,O,!!H);return this.f?.logOutgoing(Q.byteLength,R,0,`request: ${(0,F.$6v)(A)}.${V}(`,X),this.c.send(Q),T}}e.$V9b=o,S=$,o.a=3*1e3;class b{constructor(A,V){this.a=A,this.b=V}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class p{static alloc(A,V,X){const H=new p(P.$se.alloc(X+1+4),0);return H.writeUInt8(A),H.writeUInt32(V),H}static read(A,V){return new p(A,V)}get buffer(){return this.a}constructor(A,V){this.a=A,this.b=V}static sizeUInt8(){return 1}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const X=this.a.slice(this.b,this.b+A).toString();return this.b+=A,X}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+A).toString();return this.b+=A,X}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+A);return this.b+=A,V}static sizeMixedArray(A){let V=0;V+=1;for(let X=0,H=A.length;X<H;X++){const O=A[X];switch(V+=1,O.type){case 1:V+=this.sizeLongString(O.value);break;case 2:V+=this.sizeVSBuffer(O.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(O.value);for(let R=0;R<O.buffers.length;++R)V+=this.sizeVSBuffer(O.buffers[R]);break;case 4:break}}return V}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let V=0,X=A.length;V<X;V++){const H=A[V];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let O=0;O<H.buffers.length;++O)this.writeBuffer(H.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const V=new Array(A);for(let X=0;X<A;X++)switch(this.readUInt8()){case 1:V[X]=this.readLongString();break;case 2:V[X]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),R=this.readLongString(),B=[];for(let T=0;T<O;++T)B.push(this.readVSBuffer());V[X]=new F.$7v(i(R,B,null));break}case 4:V[X]=void 0;break}return V}}p.sizeUInt32=4;var d;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(d||(d={}));class I{static a(A){for(let V=0,X=A.length;V<X;V++)if(A[V]instanceof P.$se||A[V]instanceof F.$7v||typeof A[V]>"u")return!0;return!1}static serializeRequestArguments(A,V){if(this.a(A)){const X=[];for(let H=0,O=A.length;H<O;H++){const R=A[H];if(R instanceof P.$se)X[H]={type:2,value:R};else if(typeof R>"u")X[H]={type:4};else if(R instanceof F.$7v){const{jsonString:B,referencedBuffers:T}=u(R.value,V);X[H]={type:3,value:P.$se.fromString(B),buffers:T}}else X[H]={type:1,value:P.$se.fromString(r(R,V))}}return{type:1,args:X}}return{type:0,args:r(A,V)}}static serializeRequest(A,V,X,H,O){switch(H.type){case 0:return this.b(A,V,X,H.args,O);case 1:return this.c(A,V,X,H.args,O)}}static b(A,V,X,H,O){const R=P.$se.fromString(X),B=P.$se.fromString(H);let T=0;T+=p.sizeUInt8(),T+=p.sizeShortString(R),T+=p.sizeLongString(B);const te=p.alloc(O?2:1,A,T);return te.writeUInt8(V),te.writeShortString(R),te.writeLongString(B),te.buffer}static deserializeRequestJSONArgs(A){const V=A.readUInt8(),X=A.readShortString(),H=A.readLongString();return{rpcId:V,method:X,args:JSON.parse(H)}}static c(A,V,X,H,O){const R=P.$se.fromString(X);let B=0;B+=p.sizeUInt8(),B+=p.sizeShortString(R),B+=p.sizeMixedArray(H);const T=p.alloc(O?4:3,A,B);return T.writeUInt8(V),T.writeShortString(R),T.writeMixedArray(H),T.buffer}static deserializeRequestMixedArgs(A){const V=A.readUInt8(),X=A.readShortString(),H=A.readMixedArray(),O=new Array(H.length);for(let R=0,B=H.length;R<B;R++){const T=H[R];typeof T=="string"?O[R]=JSON.parse(T):O[R]=T}return{rpcId:V,method:X,args:O}}static serializeAcknowledged(A){return p.alloc(5,A,0).buffer}static serializeCancel(A){return p.alloc(6,A,0).buffer}static serializeReplyOK(A,V,X){if(typeof V>"u")return this.d(A);if(V instanceof P.$se)return this.e(A,V);if(V instanceof F.$7v){const{jsonString:H,referencedBuffers:O}=u(V.value,X,!0);return this.g(A,H,O)}else return this.f(A,l(V,X))}static d(A){return p.alloc(7,A,0).buffer}static e(A,V){let X=0;X+=p.sizeVSBuffer(V);const H=p.alloc(8,A,X);return H.writeVSBuffer(V),H.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,V){const X=P.$se.fromString(V);let H=0;H+=p.sizeLongString(X);const O=p.alloc(9,A,H);return O.writeLongString(X),O.buffer}static g(A,V,X){const H=P.$se.fromString(V);let O=0;O+=p.sizeUInt32,O+=p.sizeLongString(H);for(const B of X)O+=p.sizeVSBuffer(B);const R=p.alloc(10,A,O);R.writeUInt32(X.length),R.writeLongString(H);for(const B of X)R.writeBuffer(B);return R.buffer}static deserializeReplyOKJSON(A){const V=A.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(A,V){const X=A.readUInt32(),H=A.readLongString(),O=[];for(let R=0;R<X;++R)O.push(A.readVSBuffer());return new F.$7v(i(H,O,V))}static serializeReplyErr(A,V){const X=V?l(L.$3(V),null):void 0;if(typeof X!="string")return this.h(A);const H=P.$se.fromString(X);let O=0;O+=p.sizeLongString(H);const R=p.alloc(11,A,O);return R.writeLongString(H),R.buffer}static deserializeReplyErrError(A){const V=A.readLongString();return JSON.parse(V)}static h(A){return p.alloc(12,A,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var y;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(y||(y={}))}),define(Me[238],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;const D=function(L){const M=g=>{globalThis.removeEventListener("message",M);const f=g.data;Object.defineProperties(globalThis,{postMessage:{value(k,F){f.postMessage(k,F)}},onmessage:{get(){return f.onmessage},set(k){f.onmessage=k}}}),f.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",M)}.toString();class P extends EventTarget{constructor(L,M,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${D})('${M}'))`,k=new Blob([f],{type:"application/javascript"}),F=URL.createObjectURL(k),S=new MessageChannel,l=F,w={type:"_newWorker",id:l,port:S.port2,url:F,options:g};L(w,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{L({type:"_terminateWorker",id:l}),URL.revokeObjectURL(F),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(m){S.port1.onmessage=m}},onmessageerror:{get(){return S.port1.onmessageerror},set(m){S.port1.onmessageerror=m}}}),S.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),S.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),S.port1.start()}}e.$5lc=P}),define(Me[239],Ae([1,0,24,28,12,54,4]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=(0,M.$ei)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${g.join("")}]+`),k=7;function F(w){if(w.scheme!==C.Schemas.vscodeNotebookCell)return;const m=w.fragment.indexOf("s");if(m<0)return;const s=parseInt(w.fragment.substring(0,m).replace(f,""),k),u=(0,D.$Le)(w.fragment.substring(m+1)).toString();if(!isNaN(s))return{handle:s,notebook:w.with({scheme:u,fragment:null})}}e.$LJ=F;function S(w,m){const s=m.toString(k),i=`${s.length<g.length?g[s.length-1]:"z"}${s}s${(0,D.$Me)(D.$se.fromString(w.scheme),!0,!0)}`;return w.with({scheme:C.Schemas.vscodeNotebookCell,fragment:i})}e.$MJ=S;class l{constructor(){this.a=new P.$Ac}getNotebook(m){if(m.scheme===C.Schemas.vscodeNotebookCell){const s=F(m);if(s){const u=this.a.get(s.notebook);if(u)return u}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$NJ=l,(0,L.$$r)(e.$KJ,l,1)}),define(Me[83],Ae([1,0,24,33,53,69,12,19,21,36,239]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.$3J=e.CellStatusbarAlignment=e.$2J=e.$1J=e.$ZJ=e.NotebookEditorPriority=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.CellKind=e.$QJ=e.$PJ=e.$OJ=void 0,e.$OJ="workbench.editor.notebook",e.$PJ="workbench.editor.notebookTextDiffEditor",e.$QJ="workbench.editor.interactive";var S;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(S||(e.CellKind=S={})),e.$RJ=["application/json","application/javascript","text/html","image/svg+xml",L.$rs.latex,L.$rs.markdown,"image/png","image/jpeg",L.$rs.text],e.$SJ=[L.$rs.latex,L.$rs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$rs.text],e.$TJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$UJ="_notAvailable";var l;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var w;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var m;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var s;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var u;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var i;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(i||(e.NotebookCellsChangeType=i={}));var r;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var n;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var a;(function(T){T.scheme=M.Schemas.vscodeNotebookCell;function te(ne,ke){return(0,F.$MJ)(ne,ke)}T.generate=te;function Q(ne){return(0,F.$LJ)(ne)}T.parse=Q;function ce(ne,ke){return ne.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${ke??""},${ne.scheme!==M.Schemas.file?ne.scheme:""}`})}T.generateCellOutputUri=ce;function le(ne){if(ne.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const ke=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!ke)return;const oe=ke[1]&&ke[1]!==""?ke[1]:void 0,ve=ke[2];return{outputId:oe,notebook:ne.with({scheme:ve||M.Schemas.file,fragment:null})}}T.parseCellOutputUri=le;function se(ne,ke,oe){return T.generate(ne,ke).with({scheme:oe})}T.generateCellPropertyUri=se;function $e(ne,ke){if(ne.scheme===ke)return T.parse(ne.with({scheme:T.scheme}))}T.parseCellPropertyUri=$e})(a||(e.CellUri=a={}));const h=T=>f.$c?T.replace(/\//g,"\\"):T;class t{constructor(te=[],Q=e.$RJ){this.e=Q,this.d=[...new Set(te)].map(ce=>({pattern:ce,matches:P.$Xj(h(ce))}))}sort(te){const Q=new Map(C.Iterable.map(te,le=>[le,h(le)]));let ce=[];for(const{matches:le}of this.d)for(const[se,$e]of Q)if(le($e)){ce.push(se),Q.delete(se);break}return Q.size&&(ce=ce.concat([...Q.keys()].sort((le,se)=>this.e.indexOf(le)-this.e.indexOf(se)))),ce}prioritize(te,Q){const ce=this.f(te);if(ce===-1){this.d.unshift({pattern:te,matches:P.$Xj(h(te))});return}const le=new Set(Q.map($e=>this.f($e,ce)));le.delete(-1);const se=Array.from(le).sort();this.d.splice(ce+1,0,...se.map($e=>this.d[$e]));for(let $e=se.length-1;$e>=0;$e--)this.d.splice(se[$e],1)}toArray(){return this.d.map(te=>te.pattern)}f(te,Q=this.d.length){const ce=h(te);for(let le=0;le<Q;le++)if(this.d[le].matches(ce))return le;return-1}}e.$VJ=t;function $(T,te,Q,ce=(le,se)=>le===se){const le=[];function se(ke,oe,ve){if(oe===0&&ve.length===0)return;const G=le[le.length-1];G&&G.start+G.deleteCount===ke?(G.deleteCount+=oe,G.toInsert.push(...ve)):le.push({start:ke,deleteCount:oe,toInsert:ve})}let $e=0,ne=0;for(;;){if($e===T.length){se($e,0,te.slice(ne));break}if(ne===te.length){se($e,T.length-$e,[]);break}const ke=T[$e],oe=te[ne];if(ce(ke,oe)){$e+=1,ne+=1;continue}Q(oe)?(se($e,1,[]),$e+=1):(se($e,0,[oe]),ne+=1)}return le}e.$WJ=$,e.$XJ=new k.$vj("notebookEditorCursorAtBoundary","none"),e.$YJ=new k.$vj("notebookEditorCursorAtLineBoundary","none");var c;(function(T){T.default="default",T.option="option"})(c||(e.NotebookEditorPriority=c={}));function o(T){const te=T;return!!((typeof te.include=="string"||P.$Yj(te.include))&&(typeof te.exclude=="string"||P.$Yj(te.exclude)))}e.$ZJ=o;function b(T,te,Q){if(Array.isArray(T.viewType)&&T.viewType.indexOf(te)>=0||T.viewType===te)return!0;if(T.filenamePattern){const ce=o(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,le=o(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(P.$Wj(ce,(0,g.$nc)(Q.fsPath).toLowerCase()))return!(le&&P.$Wj(le,(0,g.$nc)(Q.fsPath).toLowerCase()))}return!1}e.$1J=b,e.$2J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var p;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class d{static create(te){return`${d.d}${te}`}static parse(te){if(te.startsWith(d.d))return te.substring(d.d.length)}}e.$3J=d,d.d="notebook/";function I(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$4J=I;const v=new TextDecoder;function y(T){const te=[];let Q=!1;for(const $e of T)(te.length===0||Q)&&(te.push($e),Q=!0);let ce=V(te);const le=D.$se.concat(te.map($e=>D.$se.wrap($e))),se=B(le);return ce=ce||se.byteLength!==le.byteLength,{data:se,didCompression:ce}}e.$5J=y,e.$6J="\x1B[A";const E=e.$6J.split("").map(T=>T.charCodeAt(0)),A=10;function V(T){let te=!1;return T.forEach((Q,ce)=>{if(ce===0||Q.length<e.$6J.length)return;const le=T[ce-1],se=Q.subarray(0,e.$6J.length);if(se[0]===E[0]&&se[1]===E[1]&&se[2]===E[2]){const $e=le.lastIndexOf(A);if($e===-1)return;te=!0,T[ce-1]=le.subarray(0,$e),T[ce]=Q.subarray(e.$6J.length)}}),te}function X(T){let te=T;do T=te,te=T.replace(/[^\n]\x08/gm,"");while(te.length<T.length);return T}function H(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const te=T.match(/^(.*)\r+/m)[1];let Q=T.match(/\r+(.*)$/m)[1];Q=Q+te.slice(Q.length,te.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return T}const O=8,R=13;function B(T){return!T.buffer.includes(O)&&!T.buffer.includes(R)?T:D.$se.fromString(H(X(v.decode(T.buffer))))}});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[7],Ae([1,0,18,15,52,28,69,13,16,2,34,20,42,100,83]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m){"use strict";var s,u,i,r,n,a,h,t,$,c,o,b,p,d,I,v,y,E,A,V,X,H,O,R,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$7N=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$UN=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.TestRunProfileKind=e.TestResultState=e.$AN=e.$zN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$yN=e.NotebookVariablesRequestKind=e.$xN=e.$wN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$vN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.ColorThemeKind=e.$pN=e.$oN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$nN=e.$mN=e.DebugConsoleMode=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$gN=e.$fN=e.FileChangeType=e.$eN=e.NewSymbolNameTag=e.$dN=e.$cN=e.$bN=e.$aN=e.InlineCompletionTriggerKind=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.ConfigurationTarget=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$PM=e.ViewBadge=e.ProgressLocation=e.$OM=e.$NM=e.TaskScope=e.ShellQuoting=e.$MM=e.$LM=e.$KM=e.TaskPanelKind=e.TaskRevealKind=e.$JM=e.TerminalLocation=e.$IM=e.$HM=e.$GM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$FM=e.$EM=e.$DM=e.$CM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$BM=e.StatusBarAlignment=e.ViewColumn=e.$AM=e.$zM=e.$yM=e.$xM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$wM=e.$vM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.LanguageStatusSeverity=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.CodeActionTriggerKind=e.$jM=e.$iM=e.SymbolTag=e.SymbolKind=e.$hM=e.$gM=e.DocumentHighlightKind=e.$fM=e.$eM=e.$dM=e.$cM=e.DiagnosticSeverity=e.DiagnosticTag=e.$bM=e.$aM=e.FileEditType=e.$_L=e.$$L=e.$0L=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(U){return Object.assign(U,{apply:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const Ce=re.length===1?[]:re[1];return Reflect.construct(U,Ce,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const[Ce,...Qe]=re;return Reflect.construct(U,Qe,Ce.constructor)}}})}var te;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(te||(e.TerminalOutputAnchor=te={}));var Q;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(Q||(e.TerminalQuickFixType=Q={}));let ce=$=class{static from(...N){let re=N;return new $(function(){if(re){for(const Ce of re)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();re=void 0}})}constructor(N){s.set(this,void 0),xe(this,s,N,"f")}dispose(){typeof Ue(this,s,"f")=="function"&&(Ue(this,s,"f").call(this),xe(this,s,void 0,"f"))}};e.$3L=ce,s=new WeakMap,e.$3L=ce=$=Xe([T],ce);let le=c=class{static Min(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let Ce=1;Ce<N.length;Ce++){const Qe=N[Ce];Qe.isBefore(re)&&(re=Qe)}return re}static Max(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let Ce=1;Ce<N.length;Ce++){const Qe=N[Ce];Qe.isAfter(re)&&(re=Qe)}return re}static isPosition(N){if(!N)return!1;if(N instanceof c)return!0;const{line:re,character:Ce}=N;return typeof re=="number"&&typeof Ce=="number"}static of(N){if(N instanceof c)return N;if(this.isPosition(N))return new c(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,re){if(N<0)throw(0,P.$7)("line must be non-negative");if(re<0)throw(0,P.$7)("character must be non-negative");this.c=N,this.e=re}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,re=0){if(N===null||re===null)throw(0,P.$7)();let Ce;return typeof N>"u"?Ce=0:typeof N=="number"?Ce=N:(Ce=typeof N.lineDelta=="number"?N.lineDelta:0,re=typeof N.characterDelta=="number"?N.characterDelta:0),Ce===0&&re===0?this:new c(this.line+Ce,this.character+re)}with(N,re=this.character){if(N===null||re===null)throw(0,P.$7)();let Ce;return typeof N>"u"?Ce=this.line:typeof N=="number"?Ce=N:(Ce=typeof N.line=="number"?N.line:this.line,re=typeof N.character=="number"?N.character:this.character),Ce===this.line&&re===this.character?this:new c(Ce,re)}toJSON(){return{line:this.line,character:this.character}}};e.$4L=le,e.$4L=le=c=Xe([T],le);let se=o=class{static isRange(N){return N instanceof o?!0:N?le.isPosition(N.start)&&le.isPosition(N.end):!1}static of(N){if(N instanceof o)return N;if(this.isRange(N))return new o(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,re,Ce,Qe){let tt,ht;if(typeof N=="number"&&typeof re=="number"&&typeof Ce=="number"&&typeof Qe=="number"?(tt=new le(N,re),ht=new le(Ce,Qe)):le.isPosition(N)&&le.isPosition(re)&&(tt=le.of(N),ht=le.of(re)),!tt||!ht)throw new Error("Invalid arguments");tt.isBefore(ht)?(this.c=tt,this.e=ht):(this.c=ht,this.e=tt)}contains(N){return o.isRange(N)?this.contains(N.start)&&this.contains(N.end):le.isPosition(N)?!(le.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const re=le.Max(N.start,this.c),Ce=le.Min(N.end,this.e);if(!re.isAfter(Ce))return new o(re,Ce)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const re=le.Min(N.start,this.c),Ce=le.Max(N.end,this.end);return new o(re,Ce)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,re=this.end){if(N===null||re===null)throw(0,P.$7)();let Ce;return N?le.isPosition(N)?Ce=N:(Ce=N.start||this.start,re=N.end||this.end):Ce=this.start,Ce.isEqual(this.c)&&re.isEqual(this.end)?this:new o(Ce,re)}toJSON(){return[this.start,this.end]}};e.$5L=se,e.$5L=se=o=Xe([T],se);let $e=b=class extends se{static isSelection(N){return N instanceof b?!0:N?se.isRange(N)&&le.isPosition(N.anchor)&&le.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,re,Ce,Qe){let tt,ht;if(typeof N=="number"&&typeof re=="number"&&typeof Ce=="number"&&typeof Qe=="number"?(tt=new le(N,re),ht=new le(Ce,Qe)):le.isPosition(N)&&le.isPosition(re)&&(tt=le.of(N),ht=le.of(re)),!tt||!ht)throw new Error("Invalid arguments");super(tt,ht),this.f=tt,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6L=$e,e.$6L=$e=b=Xe([T],$e);const ne=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,P.$7)("connectionToken")};class ke{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,re,Ce){if(typeof N!="string"||N.length===0)throw(0,P.$7)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,P.$7)("port");typeof Ce<"u"&&ne(Ce),this.host=N,this.port=Math.round(re),this.connectionToken=Ce}}e.$7L=ke;class oe{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,re){this.makeConnection=N,this.connectionToken=re,typeof re<"u"&&ne(re)}}e.$8L=oe;class ve extends Error{static NotAvailable(N,re){return new ve(N,w.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(N){return new ve(N,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,re=w.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(N),this._message=N,this._code=re,this._detail=Ce,Object.setPrototypeOf(this,ve.prototype)}}e.$9L=ve;var G;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var ge;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ge||(e.EnvironmentVariableMutatorType=ge={}));let ae=p=class{static isTextEdit(N){return N instanceof p?!0:N?se.isRange(N)&&typeof N.newText=="string":!1}static replace(N,re){return new p(N,re)}static insert(N,re){return p.replace(new se(N,N),re)}static delete(N){return p.replace(N,"")}static setEndOfLine(N){const re=new p(new se(new le(0,0),new le(0,0)),"");return re.newEol=N,re}get range(){return this.c}set range(N){if(N&&!se.isRange(N))throw(0,P.$7)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,P.$7)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,P.$7)("newEol");this.f=N}constructor(N,re){this.c=N,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0L=ae,e.$0L=ae=p=Xe([T],ae);let De=d=class{static isNotebookCellEdit(N){return N instanceof d?!0:N?mt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,re){return new d(N,re)}static insertCells(N,re){return new d(new mt(N,N),re)}static deleteCells(N){return new d(N,[])}static updateCellMetadata(N,re){const Ce=new d(new mt(N,N),[]);return Ce.newCellMetadata=re,Ce}static updateNotebookMetadata(N){const re=new d(new mt(0,0),[]);return re.newNotebookMetadata=N,re}constructor(N,re){this.range=N,this.newCells=re}};e.$$L=De,e.$$L=De=d=Xe([T],De);class ye{static isSnippetTextEdit(N){return N instanceof ye?!0:N?se.isRange(N.range)&&K.isSnippetString(N.snippet):!1}static replace(N,re){return new ye(N,re)}static insert(N,re){return ye.replace(new se(N,N),re)}constructor(N,re){this.range=N,this.snippet=re}}e.$_L=ye;var we;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let he=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,re,Ce,Qe){this.c.push({_type:1,from:N,to:re,options:Ce,metadata:Qe})}createFile(N,re,Ce){this.c.push({_type:1,from:void 0,to:N,options:re,metadata:Ce})}deleteFile(N,re,Ce){this.c.push({_type:1,from:N,to:void 0,options:re,metadata:Ce})}e(N,re,Ce){this.c.push({_type:3,metadata:Ce,uri:N,edit:{editType:5,metadata:re},notebookMetadata:re})}f(N,re,Ce,Qe){const tt=re.start,ht=re.end;(tt!==ht||Ce.length>0)&&this.c.push({_type:5,uri:N,index:tt,count:ht-tt,cells:Ce,metadata:Qe})}g(N,re,Ce,Qe){this.c.push({_type:3,metadata:Qe,uri:N,edit:{editType:3,index:re,metadata:Ce}})}replace(N,re,Ce,Qe){this.c.push({_type:2,uri:N,edit:new ae(re,Ce),metadata:Qe})}insert(N,re,Ce,Qe){this.replace(N,new se(re,re),Ce,Qe)}delete(N,re,Ce){this.replace(N,re,"",Ce)}has(N){return this.c.some(re=>re._type===2&&re.uri.toString()===N.toString())}set(N,re){if(re)for(const Ce of re){if(!Ce)continue;let Qe,tt;Array.isArray(Ce)?(Qe=Ce[0],tt=Ce[1]):Qe=Ce,De.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(N,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(N,Qe.newNotebookMetadata,tt):this.f(N,Qe.range,Qe.newCells,tt):ye.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:N,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:N,edit:Qe,metadata:tt})}else{for(let Ce=0;Ce<this.c.length;Ce++){const Qe=this.c[Ce];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===N.toString()&&(this.c[Ce]=void 0);break}}(0,D.$Ib)(this.c)}}get(N){const re=[];for(const Ce of this.c)Ce._type===2&&Ce.uri.toString()===N.toString()&&re.push(Ce.edit);return re}entries(){const N=new L.$Ac;for(const re of this.c)if(re._type===2){let Ce=N.get(re.uri);Ce||(Ce=[re.uri,[]],N.set(re.uri,Ce)),Ce[1].push(re.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aM=he,e.$aM=he=Xe([T],he);let K=I=class{static isSnippetString(N){return N instanceof I?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=I.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,re=this.e++){if(typeof N=="function"){const Ce=new I;Ce.e=this.e,N(Ce),this.e=Ce.e,N=Ce.value}else N=I.c(N);return this.value+="${",this.value+=re,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,re=this.e++){const Ce=N.map(Qe=>Qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(N,re){if(typeof re=="function"){const Ce=new I;Ce.e=this.e,re(Ce),this.e=Ce.e,re=Ce.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$bM=K,e.$bM=K=I=Xe([T],K);var Y;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var me;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let pe=v=class{static isLocation(N){return N instanceof v?!0:N?se.isRange(N.range)&&k.URI.isUri(N.uri):!1}constructor(N,re){if(this.uri=N,re)if(se.isRange(re))this.range=se.of(re);else if(le.isPosition(re))this.range=new se(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cM=pe,e.$cM=pe=v=Xe([T],pe);let Fe=class{static is(N){return N?typeof N.message=="string"&&N.location&&se.isRange(N.location.range)&&k.URI.isUri(N.location.uri):!1}constructor(N,re){this.location=N,this.message=re}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.location.range.isEqual(re.location.range)&&N.location.uri.toString()===re.location.uri.toString()}};e.$dM=Fe,e.$dM=Fe=Xe([T],Fe);let be=class{constructor(N,re,Ce=me.Error){if(!se.isRange(N))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=N,this.message=re,this.severity=Ce}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.severity===re.severity&&N.code===re.code&&N.severity===re.severity&&N.source===re.source&&N.range.isEqual(re.range)&&(0,D.$ub)(N.tags,re.tags)&&(0,D.$ub)(N.relatedInformation,re.relatedInformation,Fe.isEqual)}};e.$eM=be,e.$eM=be=Xe([T],be);let Re=class{constructor(N,re){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=re}};e.$fM=Re,e.$fM=Re=Xe([T],Re);var Pe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Pe||(e.DocumentHighlightKind=Pe={}));let We=class{constructor(N,re=Pe.Text){this.range=N,this.kind=re}toJSON(){return{range:this.range,kind:Pe[this.kind]}}};e.$gM=We,e.$gM=We=Xe([T],We);let j=class{constructor(N,re){this.uri=N,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$hM=j,e.$hM=j=Xe([T],j);var z;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(z||(e.SymbolKind=z={}));var q;(function(U){U[U.Deprecated=1]="Deprecated"})(q||(e.SymbolTag=q={}));let W=y=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,re,Ce,Qe,tt){this.name=N,this.kind=re,this.containerName=tt,typeof Ce=="string"&&(this.containerName=Ce),Qe instanceof pe?this.location=Qe:Ce instanceof se&&(this.location=new pe(Qe,Ce)),y.validate(this)}toJSON(){return{name:this.name,kind:z[this.kind],location:this.location,containerName:this.containerName}}};e.$iM=W,e.$iM=W=y=Xe([T],W);let ie=E=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(E.validate)}constructor(N,re,Ce,Qe,tt){this.name=N,this.detail=re,this.kind=Ce,this.range=Qe,this.selectionRange=tt,this.children=[],E.validate(this)}};e.$jM=ie,e.$jM=ie=E=Xe([T],ie);var ue;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(ue||(e.CodeActionTriggerKind=ue={}));let Le=class{constructor(N,re){this.title=N,this.kind=re}};e.$kM=Le,e.$kM=Le=Xe([T],Le);let Be=A=class{constructor(N){this.value=N}append(N){return new A(this.value?this.value+A.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+A.c)}};e.$lM=Be,Be.c=".",e.$lM=Be=A=Xe([T],Be),Be.Empty=new Be(""),Be.QuickFix=Be.Empty.append("quickfix"),Be.Refactor=Be.Empty.append("refactor"),Be.RefactorExtract=Be.Refactor.append("extract"),Be.RefactorInline=Be.Refactor.append("inline"),Be.RefactorMove=Be.Refactor.append("move"),Be.RefactorRewrite=Be.Refactor.append("rewrite"),Be.Source=Be.Empty.append("source"),Be.SourceOrganizeImports=Be.Source.append("organizeImports"),Be.SourceFixAll=Be.Source.append("fixAll"),Be.Notebook=Be.Empty.append("notebook");let Ke=class{constructor(N,re){if(this.range=N,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$mM=Ke,e.$mM=Ke=Xe([T],Ke);class et{constructor(N,re,Ce,Qe,tt,ht){this.kind=N,this.name=re,this.detail=Ce,this.uri=Qe,this.range=tt,this.selectionRange=ht}}e.$nM=et;class rt{constructor(N,re){this.fromRanges=re,this.from=N}}e.$oM=rt;class ft{constructor(N,re){this.fromRanges=re,this.to=N}}e.$pM=ft;var at;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(at||(e.LanguageStatusSeverity=at={}));let nt=class{constructor(N,re){this.range=N,this.command=re}get isResolved(){return!!this.command}};e.$qM=nt,e.$qM=nt=Xe([T],nt);let ct=V=class{static isMarkdownString(N){return N instanceof V?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,re=!1){u.set(this,void 0),xe(this,u,new C.$sk(N,{supportThemeIcons:re}),"f")}get value(){return Ue(this,u,"f").value}set value(N){Ue(this,u,"f").value=N}get isTrusted(){return Ue(this,u,"f").isTrusted}set isTrusted(N){Ue(this,u,"f").isTrusted=N}get supportThemeIcons(){return Ue(this,u,"f").supportThemeIcons}set supportThemeIcons(N){Ue(this,u,"f").supportThemeIcons=N}get supportHtml(){return Ue(this,u,"f").supportHtml}set supportHtml(N){Ue(this,u,"f").supportHtml=N}get baseUri(){return Ue(this,u,"f").baseUri}set baseUri(N){Ue(this,u,"f").baseUri=N}appendText(N){return Ue(this,u,"f").appendText(N),this}appendMarkdown(N){return Ue(this,u,"f").appendMarkdown(N),this}appendCodeblock(N,re){return Ue(this,u,"f").appendCodeblock(re??"",N),this}};e.$rM=ct,u=new WeakMap,e.$rM=ct=V=Xe([T],ct);let Ve=class{constructor(N,re){this.label=N,this.documentation=re}};e.$sM=Ve,e.$sM=Ve=Xe([T],Ve);let it=class{constructor(N,re){this.label=N,this.documentation=re,this.parameters=[]}};e.$tM=it,e.$tM=it=Xe([T],it);let _=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$uM=_,e.$uM=_=Xe([T],_);var Z;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Z||(e.SignatureHelpTriggerKind=Z={}));var Ee;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ee||(e.InlayHintKind=Ee={}));let qe=class{constructor(N){this.value=N}};e.$vM=qe,e.$vM=qe=Xe([T],qe);let Ye=class{constructor(N,re,Ce){this.position=N,this.label=re,this.kind=Ce}};e.$wM=Ye,e.$wM=Ye=Xe([T],Ye);var ut;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut||(e.CompletionTriggerKind=ut={}));var Oe;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Oe||(e.CompletionItemKind=Oe={}));var It;(function(U){U[U.Deprecated=1]="Deprecated"})(It||(e.CompletionItemTag=It={}));let Vt=class{constructor(N,re){this.label=N,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$xM=Vt,e.$xM=Vt=Xe([T],Vt);let Ut=class{constructor(N=[],re=!1){this.items=N,this.isIncomplete=re}};e.$yM=Ut,e.$yM=Ut=Xe([T],Ut);let Yt=class{constructor(N,re,Ce){this.insertText=N,this.range=re,this.command=Ce}};e.$zM=Yt,e.$zM=Yt=Xe([T],Yt);let Ht=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$AM=Ht,e.$AM=Ht=Xe([T],Ht);var Pt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Pt||(e.ViewColumn=Pt={}));var Zt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Zt||(e.StatusBarAlignment=Zt={}));function _t(U,N){return`${S.$xm.toKey(U)}.${N}`}e.$BM=_t;var si;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(si||(e.TextEditorLineNumbersStyle=si={}));var oi;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(oi||(e.TextDocumentSaveReason=oi={}));var _e;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(_e||(e.TextEditorRevealType=_e={}));var Tt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var xt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var $t;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})($t||(e.DecorationRangeBehavior=$t={})),function(U){function N(re){switch(re){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=N}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var vt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(vt||(e.SyntaxTokenType=vt={})),function(U){function N(re){switch(re){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=N}(vt||(e.SyntaxTokenType=vt={}));let Kt=class{constructor(N,re){if(re&&!k.URI.isUri(re))throw(0,P.$7)("target");if(!se.isRange(N)||N.isEmpty)throw(0,P.$7)("range");this.range=N,this.target=re}};e.$CM=Kt,e.$CM=Kt=Xe([T],Kt);let Nt=class{constructor(N,re,Ce,Qe){this.red=N,this.green=re,this.blue=Ce,this.alpha=Qe}};e.$DM=Nt,e.$DM=Nt=Xe([T],Nt);let Bt=class{constructor(N,re){if(re&&!(re instanceof Nt))throw(0,P.$7)("color");if(!se.isRange(N)||N.isEmpty)throw(0,P.$7)("range");this.range=N,this.color=re}};e.$EM=Bt,e.$EM=Bt=Xe([T],Bt);let dt=class{constructor(N){if(!N||typeof N!="string")throw(0,P.$7)("label");this.label=N}};e.$FM=dt,e.$FM=dt=Xe([T],dt);var Mt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Mt||(e.ColorFormat=Mt={}));var ei;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var ti;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));class Ge{constructor(N,re,Ce){if(this.startIndex=N,this.length=re,this.tooltip=Ce,typeof N!="number"||N<0)throw(0,P.$7)("startIndex");if(typeof re!="number"||re<1)throw(0,P.$7)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,P.$7)("tooltip")}}e.$GM=Ge;class Wt{constructor(N){this.uri=N}}e.$HM=Wt;class Xt{constructor(N){this.terminalCommand=N}}e.$IM=Xt;var ni;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ni||(e.TerminalLocation=ni={}));class wt{constructor(N){if(this.options=N,typeof N!="object")throw(0,P.$7)("options")}}e.$JM=wt;var jt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(jt||(e.TaskRevealKind=jt={}));var At;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(At||(e.TaskPanelKind=At={}));let Rt=X=class{static from(N){switch(N){case"clean":return X.Clean;case"build":return X.Build;case"rebuild":return X.Rebuild;case"test":return X.Test;default:return}}constructor(N,re){if(this.label=re,typeof N!="string"||typeof re!="string")throw(0,P.$7)("name");this.c=N}get id(){return this.c}};e.$KM=Rt,Rt.Clean=new X("clean","Clean"),Rt.Build=new X("build","Build"),Rt.Rebuild=new X("rebuild","Rebuild"),Rt.Test=new X("test","Test"),e.$KM=Rt=X=Xe([T],Rt);function ri(U){let N="";for(let re=0;re<U.length;re++)N+=U[re].replace(/,/g,",,")+",";return N}let zt=class{constructor(N,re,Ce){if(typeof N!="string")throw(0,P.$7)("process");this.e=[],this.c=N,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Ce):this.f=re)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,P.$7)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const re of this.e)N.push(re);return ri(N)}};e.$LM=zt,e.$LM=zt=Xe([T],zt);let Gt=class{constructor(N,re,Ce){if(this.f=[],Array.isArray(re)){if(!N)throw(0,P.$7)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,P.$7)("command");this.e=N,this.f=re,this.g=Ce}else{if(typeof N!="string")throw(0,P.$7)("commandLine");this.c=N,this.g=re}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,P.$7)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,P.$7)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)N.push(typeof re=="string"?re:re.value);return ri(N)}};e.$MM=Gt,e.$MM=Gt=Xe([T],Gt);var Lt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Lt||(e.ShellQuoting=Lt={}));var Ct;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Ct||(e.TaskScope=Ct={}));class bt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,F.$Ag)()}set callback(N){this.c=N}get callback(){return this.c}}e.$NM=bt;let Et=H=class{constructor(N,re,Ce,Qe,tt,ht){this.k=!1,this.l=this.definition=N;let pt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=Ce,this.execution=Qe,pt=tt,this.k=!0):re===Ct.Global||re===Ct.Workspace?(this.target=re,this.o=this.name=Ce,this.w=this.source=Qe,this.execution=tt,pt=ht):(this.target=re,this.o=this.name=Ce,this.w=this.source=Qe,this.execution=tt,pt=ht),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof zt?this.l={type:H.e,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:H.f,id:this.q.computeId()}:this.q instanceof bt?this.l={type:H.c,id:this.q.computeId()}:this.l={type:H.g,id:(0,F.$Ag)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,P.$7)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,P.$7)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const re=this.l.type;(H.g===re||H.e===re||H.f===re||H.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,P.$7)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$OM=Et,Et.c="customExecution",Et.e="process",Et.f="shell",Et.g="$empty",e.$OM=Et=H=Xe([T],Et);var Dt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Dt||(e.ProgressLocation=Dt={}));var mi;(function(U){function N(re){const Ce=re;return(0,f.$Wf)(Ce.value)?Ce.tooltip&&!(0,f.$Sf)(Ce.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ce.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ce.value),!1)}U.isViewBadge=N})(mi||(e.ViewBadge=mi={}));let Jt=O=class{static isTreeItem(N,re){const Ce=N;if(Ce.checkboxState!==void 0){const Qe=(0,f.$Wf)(Ce.checkboxState)?Ce.checkboxState:(0,f.$Uf)(Ce.checkboxState)&&(0,f.$Wf)(Ce.checkboxState.state)?Ce.checkboxState.state:void 0,tt=!(0,f.$Wf)(Ce.checkboxState)&&(0,f.$Uf)(Ce.checkboxState)?Ce.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Se.Checked&&Qe!==Se.Unchecked||tt!==void 0&&!(0,f.$Sf)(tt))return console.log("INVALID tree item, invalid checkboxState",Ce.checkboxState),!1}if(N instanceof O)return!0;if(Ce.label!==void 0&&!(0,f.$Sf)(Ce.label)&&!Ce.label?.label)return console.log("INVALID tree item, invalid label",Ce.label),!1;if(Ce.id!==void 0&&!(0,f.$Sf)(Ce.id))return console.log("INVALID tree item, invalid id",Ce.id),!1;if(Ce.iconPath!==void 0&&!(0,f.$Sf)(Ce.iconPath)&&!k.URI.isUri(Ce.iconPath)&&(!Ce.iconPath||!(0,f.$Sf)(Ce.iconPath.id))){const Qe=Ce.iconPath;if(!Qe||!(0,f.$Sf)(Qe.light)&&!k.URI.isUri(Qe.light)&&!(0,f.$Sf)(Qe.dark)&&!k.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Ce.iconPath),!1}return Ce.description!==void 0&&!(0,f.$Sf)(Ce.description)&&typeof Ce.description!="boolean"?(console.log("INVALID tree item, invalid description",Ce.description),!1):Ce.resourceUri!==void 0&&!k.URI.isUri(Ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ce.resourceUri),!1):Ce.tooltip!==void 0&&!(0,f.$Sf)(Ce.tooltip)&&!(Ce.tooltip instanceof ct)?(console.log("INVALID tree item, invalid tooltip",Ce.tooltip),!1):Ce.command!==void 0&&!Ce.command.command?(console.log("INVALID tree item, invalid command",Ce.command),!1):Ce.collapsibleState!==void 0&&Ce.collapsibleState<hi.None&&Ce.collapsibleState>hi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ce.collapsibleState),!1):Ce.contextValue!==void 0&&!(0,f.$Sf)(Ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ce.contextValue),!1):Ce.accessibilityInformation!==void 0&&!Ce.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ce.accessibilityInformation),!1):!0}constructor(N,re=hi.None){this.collapsibleState=re,k.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$PM=Jt,e.$PM=Jt=O=Xe([T],Jt);var hi;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(hi||(e.TreeItemCollapsibleState=hi={}));var Se;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Se||(e.TreeItemCheckboxState=Se={}));let Te=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$QM=Te,e.$QM=Te=Xe([T],Te);class de extends Te{}e.$RM=de;class J extends de{constructor(N){super(""),i.set(this,void 0),xe(this,i,N,"f")}asFile(){return Ue(this,i,"f")}}e.$SM=J,i=new WeakMap;class Ie{constructor(N,re,Ce,Qe){this.name=N,this.uri=re,this._itemId=Ce,this.c=Qe}data(){return this.c()}}e.$TM=Ie;let Ne=class{constructor(N){r.add(this),n.set(this,new Map);for(const[re,Ce]of N??[]){const Qe=Ue(this,n,"f").get(Ue(this,r,"m",a).call(this,re));Qe?Qe.push(Ce):Ue(this,n,"f").set(Ue(this,r,"m",a).call(this,re),[Ce])}}get(N){return Ue(this,n,"f").get(Ue(this,r,"m",a).call(this,N))?.[0]}set(N,re){Ue(this,n,"f").set(Ue(this,r,"m",a).call(this,N),[re])}forEach(N,re){for(const[Ce,Qe]of Ue(this,n,"f"))for(const tt of Qe)N.call(re,tt,Ce,this)}*[(n=new WeakMap,r=new WeakSet,Symbol.iterator)](){for(const[N,re]of Ue(this,n,"f"))for(const Ce of re)yield[N,Ce]}};e.$UM=Ne,a=function(N){return N.toLowerCase()},e.$UM=Ne=Xe([T],Ne);let Ze=class{constructor(N){this.insertText=N}};e.$VM=Ze,e.$VM=Ze=Xe([T],Ze);let Je=class{constructor(N,re){this.label=re,this.insertText=N}};e.$WM=Je,e.$WM=Je=Xe([T],Je);let ot=class{constructor(N,re){this.id=N,this.color=re}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$XM=ot,e.$XM=ot=Xe([T],ot),ot.File=new ot("file"),ot.Folder=new ot("folder");let kt=class{constructor(N){this.id=N}};e.$YM=kt,e.$YM=kt=Xe([T],kt);var Qt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Qt||(e.ConfigurationTarget=Qt={}));let St=class{get base(){return this.c}set base(N){this.c=N,this.e=k.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,re){if(typeof N!="string"&&(!N||!k.URI.isUri(N)&&!k.URI.isUri(N.uri)))throw(0,P.$7)("base");if(typeof re!="string")throw(0,P.$7)("pattern");typeof N=="string"?this.baseUri=k.URI.file(N):k.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ZM=St,e.$ZM=St=Xe([T],St);const Ot=new WeakMap;function ii(U,N){Ot.set(U,N)}e.$1M=ii;let ci=class{constructor(N,re,Ce,Qe,tt){this.enabled=typeof N=="boolean"?N:!0,typeof re=="string"&&(this.condition=re),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Qe=="string"&&(this.logMessage=Qe),typeof tt=="string"&&(this.mode=tt)}get id(){return this.c||(this.c=Ot.get(this)??(0,F.$Ag)()),this.c}};e.$2M=ci,e.$2M=ci=Xe([T],ci);let wi=class extends ci{constructor(N,re,Ce,Qe,tt,ht){if(super(re,Ce,Qe,tt,ht),N===null)throw(0,P.$7)("location");this.location=N}};e.$3M=wi,e.$3M=wi=Xe([T],wi);let gt=class extends ci{constructor(N,re,Ce,Qe,tt,ht){super(re,Ce,Qe,tt,ht),this.functionName=N}};e.$4M=gt,e.$4M=gt=Xe([T],gt);let Oi=class extends ci{constructor(N,re,Ce,Qe,tt,ht,pt,qt){if(super(Qe,tt,ht,pt,qt),!re)throw(0,P.$7)("dataId");this.label=N,this.dataId=re,this.canPersist=Ce}};e.$5M=Oi,e.$5M=Oi=Xe([T],Oi);let ui=class{constructor(N,re,Ce){this.command=N,this.args=re||[],this.options=Ce}};e.$6M=ui,e.$6M=ui=Xe([T],ui);let $i=class{constructor(N,re){this.port=N,this.host=re}};e.$7M=$i,e.$7M=$i=Xe([T],$i);let ki=class{constructor(N){this.path=N}};e.$8M=ki,e.$8M=ki=Xe([T],ki);let Ti=class{constructor(N){this.implementation=N}};e.$9M=Ti,e.$9M=Ti=Xe([T],Ti);let Ni=class{constructor(N,re,Ce){this.session=N,this.threadId=re,this.frameId=Ce}};e.$0M=Ni,e.$0M=Ni=Xe([T],Ni);let ji=class{constructor(N,re){this.session=N,this.threadId=re}};e.$$M=ji,e.$$M=ji=Xe([T],ji);let Si=class{constructor(N,re){this.range=N,this.expression=re}};e.$_M=Si,e.$_M=Si=Xe([T],Si);var Ji;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Ii=class{constructor(N,re){this.range=N,this.text=re}};e.$aN=Ii,e.$aN=Ii=Xe([T],Ii);let di=class{constructor(N,re,Ce=!0){this.range=N,this.variableName=re,this.caseSensitiveLookup=Ce}};e.$bN=di,e.$bN=di=Xe([T],di);let zi=class{constructor(N,re){this.range=N,this.expression=re}};e.$cN=zi,e.$cN=zi=Xe([T],zi);let bi=class{constructor(N,re){this.frameId=N,this.stoppedLocation=re}};e.$dN=bi,e.$dN=bi=Xe([T],bi);var Ci;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Ci||(e.NewSymbolNameTag=Ci={}));class fn{constructor(N,re){this.newSymbolName=N,this.tags=re}}e.$eN=fn;var Qi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let pi=R=class extends Error{static FileExists(N){return new R(N,l.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(N){return new R(N,l.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(N){return new R(N,l.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(N){return new R(N,l.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(N){return new R(N,l.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(N){return new R(N,l.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(N,re=l.FileSystemProviderErrorCode.Unknown,Ce){super(k.URI.isUri(N)?N.toString(!0):N),this.code=Ce?.name??"Unknown",(0,l.$Qk)(this,re),Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}};e.$fN=pi,e.$fN=pi=R=Xe([T],pi);let Ui=class{constructor(N,re,Ce){this.start=N,this.end=re,this.kind=Ce}};e.$gN=Ui,e.$gN=Ui=Xe([T],Ui);var Xi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Yi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Yi||(e.CommentThreadCollapsibleState=Yi={}));var yi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(yi||(e.CommentMode=yi={}));var Zi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var _i;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Bi{constructor(N,re=[]){this.tokenTypes=N,this.tokenModifiers=re}}e.$hN=Bi;function xi(U){return typeof U>"u"||(0,f.$Tf)(U)}class Wi{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let re=0,Ce=N.tokenTypes.length;re<Ce;re++)this.k.set(N.tokenTypes[re],re);for(let re=0,Ce=N.tokenModifiers.length;re<Ce;re++)this.l.set(N.tokenModifiers[re],re)}}push(N,re,Ce,Qe,tt){if(typeof N=="number"&&typeof re=="number"&&typeof Ce=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(N,re,Ce,Qe,tt);if(se.isRange(N)&&typeof re=="string"&&xi(Ce))return this.o(N,re,Ce);throw(0,P.$7)()}o(N,re,Ce){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const Qe=N.start.line,tt=N.start.character,ht=N.end.character-N.start.character,pt=this.k.get(re);let qt=0;if(Ce)for(const ai of Ce){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const li=this.l.get(ai);qt|=1<<li>>>0}this.q(Qe,tt,ht,pt,qt)}q(N,re,Ce,Qe,tt){if(this.f&&(N<this.c||N===this.c&&re<this.e)){this.f=!1;const qt=this.g.length/5|0;let ai=0,li=0;for(let gi=0;gi<qt;gi++){let vi=this.g[5*gi],Ki=this.g[5*gi+1];vi===0?(vi=ai,Ki+=li):vi+=ai,this.g[5*gi]=vi,this.g[5*gi+1]=Ki,ai=vi,li=Ki}}let ht=N,pt=re;this.f&&this.j>0&&(ht-=this.c,ht===0&&(pt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=pt,this.g[this.j++]=Ce,this.g[this.j++]=Qe,this.g[this.j++]=tt,this.c=N,this.e=re}static r(N){const re=[],Ce=N.length/5|0;for(let pt=0;pt<Ce;pt++)re[pt]=pt;re.sort((pt,qt)=>{const ai=N[5*pt],li=N[5*qt];if(ai===li){const gi=N[5*pt+1],vi=N[5*qt+1];return gi-vi}return ai-li});const Qe=new Uint32Array(N.length);let tt=0,ht=0;for(let pt=0;pt<Ce;pt++){const qt=5*re[pt],ai=N[qt+0],li=N[qt+1],gi=N[qt+2],vi=N[qt+3],Ki=N[qt+4],On=ai-tt,cr=On===0?li-ht:li,Gi=5*pt;Qe[Gi+0]=On,Qe[Gi+1]=cr,Qe[Gi+2]=gi,Qe[Gi+3]=vi,Qe[Gi+4]=Ki,tt=ai,ht=li}return Qe}build(N){return this.f?new Pi(new Uint32Array(this.g),N):new Pi(Wi.r(this.g),N)}}e.$iN=Wi;class Pi{constructor(N,re){this.resultId=re,this.data=N}}e.$jN=Pi;class en{constructor(N,re,Ce){this.start=N,this.deleteCount=re,this.data=Ce}}e.$kN=en;class gn{constructor(N,re){this.resultId=re,this.edits=N}}e.$lN=gn;var tn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(tn||(e.DebugConsoleMode=tn={}));class mn{constructor(N){this.name=N}}e.$mN=mn;let Ri=class{constructor(){}};e.$nN=Ri,Ri.Back={iconPath:new ot("arrow-left")},e.$nN=Ri=Xe([T],Ri);var Mi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Mi||(e.QuickPickItemKind=Mi={}));var Vi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Vi||(e.InputBoxValidationSeverity=Vi={}));var je;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(je||(e.ExtensionKind=je={}));class fi{static validate(N){if(typeof N.badge=="string"){let re=(0,g.$tf)(N.badge,0);if(re<N.badge.length&&(re+=(0,g.$tf)(N.badge,re)),N.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!ot.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,re,Ce){this.badge=N,this.tooltip=re,this.color=Ce}}e.$oN=fi;let Ai=class{constructor(N){this.kind=N}};e.$pN=Ai,e.$pN=Ai=Xe([T],Ai);var st;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(st||(e.ColorThemeKind=st={}));class mt{static isNotebookRange(N){return N instanceof mt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,re){if(N<0)throw(0,P.$7)("start must be positive");if(re<0)throw(0,P.$7)("end must be positive");N<=re?(this.c=N,this.e=re):(this.c=re,this.e=N)}with(N){let re=this.c,Ce=this.e;return N.start!==void 0&&(re=N.start),N.end!==void 0&&(Ce=N.end),re===this.c&&Ce===this.e?this:new mt(re,Ce)}}e.$qN=mt;class Fi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(re=>Fi.isNotebookCellData(re))}static isNotebookCellData(N){return!0}constructor(N,re,Ce,Qe,tt,ht,pt){this.kind=N,this.value=re,this.languageId=Ce,this.mime=Qe,this.outputs=tt??[],this.metadata=ht,this.executionSummary=pt,Fi.validate(this)}}e.$rN=Fi;class $n{constructor(N){this.cells=N}}e.$sN=$n;class qi{static isNotebookCellOutputItem(N){return N instanceof h?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const re={name:N.name,message:N.message,stack:N.stack};return h.json(re,"application/vnd.code.notebook.error")}static stdout(N){return h.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return h.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,re="application/octet-stream"){return new h(N,re)}static text(N,re=M.$rs.text){const Ce=Ue(h,h,"f",t).encode(String(N));return new h(Ce,re)}static json(N,re="text/x-json"){const Ce=JSON.stringify(N,void 0,"	");return h.text(Ce,re)}constructor(N,re){this.data=N,this.mime=re;const Ce=(0,M.$vs)(re,!0);if(!Ce)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}}e.$tN=qi,h=qi,t={value:new TextEncoder};class Li{static isNotebookCellOutput(N){return N instanceof Li?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,re=!1){const Ce=new Set,Qe=new Set;for(let tt=0;tt<N.length;tt++){const ht=N[tt],pt=(0,M.$vs)(ht.mime);if(!Ce.has(pt)||(0,m.$4J)(pt)){Ce.add(pt);continue}Qe.add(tt),re&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Qe.size===0?N:N.filter((tt,ht)=>!Qe.has(ht))}constructor(N,re,Ce){this.items=Li.ensureUniqueMimeTypes(N,!0),typeof re=="string"?(this.id=re,this.metadata=Ce):(this.id=(0,F.$Ag)(),this.metadata=re??Ce)}}e.$uN=Li;var Ei;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var nn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class on{constructor(N,re){this.text=N,this.alignment=re}}e.$vN=on;var an;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(an||(e.NotebookControllerAffinity=an={}));var cn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(cn||(e.NotebookControllerAffinity2=cn={}));class pn{constructor(N,re=[]){this.uri=N,this.provides=(0,D.$3b)(re)}}e.$wN=pn;class vn{constructor(N){this.label=N}}e.$xN=vn;var un;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(un||(e.NotebookVariablesRequestKind=un={}));let Hi=class{constructor(N,re){this.label=N,this.timestamp=re}};e.$yN=Hi,e.$yN=Hi=Xe([T],Hi);var ln;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(ln||(e.ExtensionMode=ln={}));var hn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(hn||(e.ExtensionRuntime=hn={}));var dn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(dn||(e.StandardTokenType=dn={}));class wn{constructor(N,re){this.ranges=N,this.wordPattern=re}}e.$zN=wn;class bn{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$AN=bn;var ee;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(ee||(e.TestResultState=ee={}));var fe;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(fe||(e.TestRunProfileKind=fe={}));let ze=class{constructor(N=void 0,re=void 0,Ce=void 0,Qe=!1){this.include=N,this.exclude=re,this.profile=Ce,this.continuous=Qe}};e.$BN=ze,e.$BN=ze=Xe([T],ze);let lt=B=class{static diff(N,re,Ce){const Qe=new B(N);return Qe.expectedOutput=re,Qe.actualOutput=Ce,Qe}constructor(N){this.message=N}};e.$CN=lt,e.$CN=lt=B=Xe([T],lt);let yt=class{constructor(N){this.id=N}};e.$DN=yt,e.$DN=yt=Xe([T],yt);class Ft{constructor(N,re){this.covered=N,this.total=re}}e.$EN=Ft;const Di=U=>{if(U&&U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`)};class yn{static fromDetails(N,re){const Ce=new Ft(0,0),Qe=new Ft(0,0),tt=new Ft(0,0);for(const pt of re)if("branches"in pt){Ce.total+=1,Ce.covered+=pt.executed?1:0;for(const qt of pt.branches)Qe.total+=1,Qe.covered+=qt.executed?1:0}else tt.total+=1,tt.covered+=pt.executed?1:0;const ht=new yn(N,Ce,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return ht.detailedCoverage=re,ht}constructor(N,re,Ce,Qe){this.uri=N,this.statementCoverage=re,this.branchCoverage=Ce,this.declarationCoverage=Qe,Di(re),Di(Ce),Di(Qe)}}e.$FN=yn;class Tn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,re,Ce=[]){this.executed=N,this.location=re,this.branches=Ce}}e.$GN=Tn;class Nn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,re,Ce){this.executed=N,this.location=re,this.label=Ce}}e.$HN=Nn;class jn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,re,Ce){this.name=N,this.executed=re,this.location=Ce}}e.$IN=jn;var En;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(En||(e.ExternalUriOpenerPriority=En={}));var Dn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Dn||(e.WorkspaceTrustState=Dn={}));var kn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class zn{constructor(N,re,Ce,Qe,tt,ht){this.kind=N,this.name=re,this.detail=Ce,this.uri=Qe,this.range=tt,this.selectionRange=ht}}e.$JN=zn;class Un{constructor(N){this.uri=N}}e.$KN=Un;class Bn{constructor(N,re){this.original=N,this.modified=re}}e.$LN=Bn;class Wn{constructor(N,re,Ce,Qe){this.base=N,this.input1=re,this.input2=Ce,this.result=Qe}}e.$MN=Wn;class Vn{constructor(N,re){this.uri=N,this.viewType=re}}e.$NN=Vn;class qn{constructor(N){this.viewType=N}}e.$ON=qn;class Hn{constructor(N,re){this.uri=N,this.notebookType=re}}e.$PN=Hn;class Kn{constructor(N,re,Ce){this.original=N,this.modified=re,this.notebookType=Ce}}e.$QN=Kn;class Gn{constructor(){}}e.$RN=Gn;class Jn{constructor(N,re){this.uri=N,this.inputBoxUri=re}}e.$SN=Jn;class Qn{constructor(N){this.providerId=N}}e.$TN=Qn;var Sn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Sn||(e.InteractiveSessionVoteDirection=Sn={}));var In;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(In||(e.ChatCopyKind=In={}));var Cn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Cn||(e.ChatVariableLevel=Cn={}));class Xn{constructor(N,re){this.label=N,this.values=re}}e.$UN=Xn;var Pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}));var Rn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Rn||(e.ChatResultFeedbackKind=Rn={}));class Yn{constructor(N){this.value=typeof N=="string"?new ct(N):N}}e.$VN=Yn;class Zn{constructor(N,re){this.value=N,this.baseUri=re}}e.$WN=Zn;class _n{constructor(N,re){this.value=N,this.title=re}}e.$XN=_n;class xn{constructor(N){this.value=N}}e.$YN=xn;class er{constructor(N){this.value=N}}e.$ZN=er;class tr{constructor(N){this.value=N}}e.$1N=tr;class ir{constructor(N,re,Ce,Qe){this.prompt=N,this.command=re,this.variables=Ce,this.participant=Qe}}e.$2N=ir;class nr{constructor(N,re,Ce,Qe){this.response=N,this.result=re,this.participant=Ce,this.command=Qe}}e.$3N=nr;class rr{constructor(N){this.content=N}}e.$4N=rr;class sr{constructor(N,re){this.content=N,this.name=re}}e.$5N=sr;class or{constructor(N){this.content=N}}e.$6N=or;var Mn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Mn||(e.RelatedInformationType=Mn={}));var An;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(An||(e.SpeechToTextStatus=An={}));var Fn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Fn||(e.KeywordRecognitionStatus=Fn={}));class ar{constructor(N,re){this.text=N,this.range=re}}e.$7N=ar;var Ln;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Ln||(e.InlineEditTriggerKind=Ln={}))}),define(Me[240],Ae([1,0,3,7]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class C{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(D.$1L.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,g,f){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(M);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(g,f)??[]}getRelatedInformation(M,g,f){return this.c.$getAiRelatedInformation(g,f)}registerRelatedInformationProvider(M,g,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiRelatedInformationProvider(k,g),new P.$3L(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Mhc=C}),define(Me[241],Ae([1,0,5,3,7,20,104]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class g{constructor(F){this.b=new Map,this.c=new D.$5d,this.onDidChangeSessions=this.c.event,this.d=new f,this.f=new f,this.a=F.getProxy(P.$1L.MainThreadAuthentication)}async getSession(F,S,l,w={}){const m=L.$xm.toKey(F.identifier),s=[...l].sort().join(" ");return await this.d.getOrCreate(`${m} ${S} ${s}`,async()=>{await this.a.$ensureProvider(S);const u=F.displayName||F.name;return this.a.$getSession(S,l,m,u,w)})}async getSessions(F,S,l){const w=L.$xm.toKey(F.identifier),m=[...l].sort().join(" ");return await this.f.getOrCreate(`${w} ${m}`,async()=>{await this.a.$ensureProvider(S);const s=F.displayName||F.name;return this.a.$getSessions(S,l,w,s)})}async removeSession(F,S){const l=this.b.get(F);return l?l.provider.removeSession(S):this.a.$removeSession(F,S)}registerAuthenticationProvider(F,S,l,w){if(this.b.get(F))throw new Error(`An authentication provider with id '${F}' is already registered.`);this.b.set(F,{label:S,provider:l,options:w??{supportsMultipleAccounts:!1}});const m=l.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(F,s));return this.a.$registerAuthenticationProvider(F,S,w?.supportsMultipleAccounts??!1),new C.$3L(()=>{m.dispose(),this.b.delete(F),this.a.$unregisterAuthenticationProvider(F)})}$createSession(F,S,l){const w=this.b.get(F);if(w)return Promise.resolve(w.provider.createSession(S,l));throw new Error(`Unable to find authentication provider with handle: ${F}`)}$removeSession(F,S){const l=this.b.get(F);if(l)return Promise.resolve(l.provider.removeSession(S));throw new Error(`Unable to find authentication provider with handle: ${F}`)}$getSessions(F,S){const l=this.b.get(F);if(l)return Promise.resolve(l.provider.getSessions(S));throw new Error(`Unable to find authentication provider with handle: ${F}`)}$onDidChangeAuthenticationSessions(F,S){return F.startsWith(M.$7K)||this.c.fire({provider:{id:F,label:S}}),Promise.resolve()}}e.$Xhc=g;class f{constructor(){this.a=new Map}getOrCreate(F,S){const l=this.a.get(F);if(l)return l;const w=S().finally(()=>this.a.delete(F));return this.a.set(F,w),w}}}),define(Me[108],Ae([1,0,2,3,7,4,17,14,18,13,19,23]),function(x,e,D,P,C,L,M,g,f,k,F,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=e.$Wic=void 0;let w=l=class{constructor(s,u){this.h=u,this.f=new Map,this.g=s.getProxy(P.$1L.MainThreadDecorations)}registerFileDecorationProvider(s,u){const i=l.c++;this.f.set(i,{provider:s,extensionDescription:u}),this.g.$registerDecorationProvider(i,u.identifier.value);const r=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(i,null);return}const a=(0,f.$3b)(n);if(a.length<=l.d){this.g.$onDidChange(i,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,k.$Ye)(c.path,"/")})),t=(0,f.$zb)(h,(c,o)=>c.rank-o.rank||(0,k.$cf)(c.uri.path,o.uri.path)),$=[];e:for(const c of t){let o;for(const b of c){const p=(0,F.$mc)(b.uri.path);if(o!==p&&(o=p,$.push(b.uri)>=l.d))break e}}this.g.$onDidChange(i,$)});return new C.$3L(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(s,u,i){if(!this.f.has(s))return Object.create(null);const r=Object.create(null),{provider:n,extensionDescription:a}=this.f.get(s);return await Promise.all(u.map(async h=>{try{const{uri:t,id:$}=h,c=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),i));if(!c)return;try{C.$oN.validate(c),c.badge&&typeof c.badge!="string"&&(0,S.$WF)(a,"codiconDecoration"),r[$]=[c.propagate,c.tooltip,c.badge,c.color]}catch(o){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),r}};e.$Wic=w,w.c=0,w.d=250,e.$Wic=w=l=Xe([He(0,M.$fO),He(1,g.$yj)],w),e.$Xic=(0,L.$ei)("IExtHostDecorations")}),define(Me[242],Ae([1,0,15,2,7,3,12,22,13]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class k{constructor(S,l,w){this.d=l,this.e=w,this.b=new Map,this.c=S.getProxy(L.$1L.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(M.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const w=k.a++;this.b.set(w,l),this.c.$registerTextContentProvider(w,S);let m;if(typeof l.onDidChange=="function"){let s;m=l.onDidChange(async u=>{if(u.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(u))return;s&&await s;const i=this.$provideTextDocumentContent(w,u).then(async r=>{if(!r&&typeof r!="string")return;const n=this.d.getDocument(u);if(!n)return;const a=(0,f.$9e)(r);if(!n.equalLines(a))return this.c.$onVirtualDocumentChange(u,r)}).catch(D.$1).finally(()=>{s===i&&(s=void 0)});s=i})}return new C.$3L(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(S,l){const w=this.b.get(S);return w?Promise.resolve(w.provideTextDocumentContent(P.URI.revive(l),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Zic=k,k.a=0}),define(Me[109],Ae([1,0,55,12,13,298,148,7,18]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=e.$hO=void 0;const k=new Map;function F(m,s){s?k.set(m,s):k.delete(m)}e.$hO=F;function S(m){return k.get(m)}class l extends L.$yv{constructor(s,u,i,r,n,a,h){super(u,i,r,n),this.c=s,this.m=a,this.q=h,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===P.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(u){return u?s.s(u):s.getText()},get eol(){return s.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(u){return s.t(u)},offsetAt(u){return s.u(u)},positionAt(u){return s.v(u)},validateRange(u){return s.w(u)},validatePosition(u){return s.x(u)},getWordRangeAtPosition(u,i){return s.y(u,i)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,D.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,D.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const u=this.w(s);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const i=this.g,r=u.start.line,n=u.end.line,a=[];a.push(this.f[r].substring(u.start.character));for(let h=r+1;h<n;h++)a.push(this.f[h]);return a.push(this.f[n].substring(0,u.end.character)),a.join(i)}t(s){let u;if(s instanceof g.$4L?u=s.line:typeof s=="number"&&(u=s),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new w(u,this.f[u],u===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const u=this.j.getIndexOf(s),i=this.f[u.index].length;return new g.$4L(u.index,Math.min(u.remainder,i))}w(s){if(!(s instanceof g.$5L))throw new Error("Invalid argument");const u=this.x(s.start),i=this.x(s.end);return u===s.start&&i===s.end?s:new g.$5L(u.line,u.character,i.line,i.character)}x(s){if(!(s instanceof g.$4L))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:u,character:i}=s,r=!1;if(u<0)u=0,i=0,r=!0;else if(u>=this.f.length)u=this.f.length-1,i=this.f[u].length,r=!0;else{const n=this.f[u].length;i<0?(i=0,r=!0):i>n&&(i=n,r=!0)}return r?new g.$4L(u,i):s}y(s,u){const i=this.x(s);if(!u)u=S(this.m);else if((0,C.$8e)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const r=(0,M.$Js)(i.character+1,(0,M.$Hs)(u),this.f[i.line],0);if(r)return new g.$5L(i.line,r.startColumn-1,i.line,r.endColumn-1)}}e.$iO=l;class w{constructor(s,u,i){this.a=s,this.b=u,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$5L(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$5L(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$jO=w}),define(Me[243],Ae([1,0,3,7]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;class C{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(D.$1L.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,g,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(M);if(!k)throw new Error("Embedding vector provider not found");const F=await k.provideEmbeddingVector(g,f);if(!F)throw new Error("Embedding vector provider returned undefined");return F}registerEmbeddingVectorProvider(M,g,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiEmbeddingVectorProvider(g,k),new P.$3L(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$2ic=C}),define(Me[63],Ae([1,0,3,42,7,24,4,17,43,6,11,25,12]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;let m=w=class{constructor(u,i){this.b=new Map,this.c=new F.$nh,this.a=u.getProxy(D.$1L.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(n){try{let a;const h=r.b.get(n.scheme);return h?(await r.a.$ensureActivation(n.scheme),a=await h.impl.stat(n)):a=await r.a.$stat(n),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===P.FilePermission.Readonly?1:void 0}}catch(a){w.e(a)}},async readDirectory(n){try{const a=r.b.get(n.scheme);return a?(await r.a.$ensureActivation(n.scheme),(await a.impl.readDirectory(n)).slice()):await r.a.$readdir(n)}catch(a){return w.e(a)}},async createDirectory(n){try{const a=r.b.get(n.scheme);return a&&!a.isReadonly?(await r.a.$ensureActivation(n.scheme),await r.d(a.impl,a.extUri,n)):await r.a.$mkdir(n)}catch(a){return w.e(a)}},async readFile(n){try{const a=r.b.get(n.scheme);return a?(await r.a.$ensureActivation(n.scheme),(await a.impl.readFile(n)).slice()):(await r.a.$readFile(n)).buffer}catch(a){return w.e(a)}},async writeFile(n,a){try{const h=r.b.get(n.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(n.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(n)),await r.c.queueFor(n,()=>Promise.resolve(h.impl.writeFile(n,a,{create:!0,overwrite:!0})))):await r.a.$writeFile(n,L.$se.wrap(a))}catch(h){return w.e(h)}},async delete(n,a){try{const h=r.b.get(n.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await r.a.$ensureActivation(n.scheme),await h.impl.delete(n,{recursive:!1,...a})):await r.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return w.e(h)}},async rename(n,a,h){try{return await r.a.$rename(n,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},async copy(n,a,h){try{return await r.a.$copy(n,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},isWritableFileSystem(n){const a=i.getCapabilities(n);if(typeof a=="number")return!(a&2048)}})}async d(u,i,r){const n=[];for(;!i.isEqual(r,i.dirname(r));)try{if(!((await u.stat(r)).type&P.FileType.Directory))throw C.$fN.FileExists(`Unable to create folder '${r.scheme===l.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(P.$Rk(a)!==P.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(i.basename(r)),r=i.dirname(r)}for(let a=n.length-1;a>=0;a--){r=i.joinPath(r,n[a]);try{await u.createDirectory(r)}catch(h){if(P.$Rk(h)!==P.FileSystemProviderErrorCode.FileExists)throw h}}}static e(u){if(u instanceof C.$fN)throw u;if(u instanceof P.$Nk)switch(u.code){case P.FileSystemProviderErrorCode.FileExists:throw C.$fN.FileExists(u.message);case P.FileSystemProviderErrorCode.FileNotFound:throw C.$fN.FileNotFound(u.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw C.$fN.FileNotADirectory(u.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw C.$fN.FileIsADirectory(u.message);case P.FileSystemProviderErrorCode.NoPermissions:throw C.$fN.NoPermissions(u.message);case P.FileSystemProviderErrorCode.Unavailable:throw C.$fN.Unavailable(u.message);default:throw new C.$fN(u.message,u.name)}if(!(u instanceof Error))throw new C.$fN(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw C.$fN.Unavailable(u.message);switch(u.name){case P.FileSystemProviderErrorCode.FileExists:throw C.$fN.FileExists(u.message);case P.FileSystemProviderErrorCode.FileNotFound:throw C.$fN.FileNotFound(u.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw C.$fN.FileNotADirectory(u.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw C.$fN.FileIsADirectory(u.message);case P.FileSystemProviderErrorCode.NoPermissions:throw C.$fN.NoPermissions(u.message);case P.FileSystemProviderErrorCode.Unavailable:throw C.$fN.Unavailable(u.message);default:throw new C.$fN(u.message,u.name)}}addFileSystemProvider(u,i,r){return this.b.set(u,{impl:i,extUri:r?.isCaseSensitive?S.$Hg:S.$Jg,isReadonly:!!r?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??S.$Hg}};e.$cic=m,e.$cic=m=w=Xe([He(0,g.$fO),He(1,f.$Rhc)],m),e.$dic=(0,M.$ei)("IExtHostConsumerFileSystem")}),define(Me[244],Ae([1,0,3,7]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;class C{constructor(M){this.a=new Map,this.b=new Map,this.c=M.getProxy(D.$1L.MainThreadIssueReporter)}async $getIssueReporterUri(M,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(M);if(!f)throw new Error("Issue request handler not found");const k=await f.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(M,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(M);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueData(g);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(M,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(M);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueTemplate(g);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(M,g){const f=M.identifier.value;return this.a.set(f,g),this.c.$registerIssueUriRequestHandler(f),new P.$3L(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(M,g){const f=M.identifier.value;return this.b.set(f,g),this.c.$registerIssueDataProvider(f),new P.$3L(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$gjc=C}),define(Me[84],Ae([1,0,4,27,14,63,2]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=e.$eic=void 0,e.$eic=(0,D.$ei)("IExtensionStoragePaths");let g=class{constructor(k,F,S){this.d=F,this.f=S,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(k){return M.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,F=await this.g(k);try{return await this.f.value.stat(F),this.d.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",F),await this.f.value.createDirectory(F),await this.f.value.writeFile(M.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),F}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(k){if(this.c)return M.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return M.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fic=g,e.$fic=g=Xe([He(0,P.$vO),He(1,C.$yj),He(2,L.$dic)],g)}),define(Me[245],Ae([1,0,7,17,5]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;let L=class{constructor(g){this.a=new D.$pN(D.ColorThemeKind.Dark),this.b=new C.$5d}get activeColorTheme(){return this.a}$onColorThemeChange(g){let f;switch(g){case"light":f=D.ColorThemeKind.Light;break;case"hcDark":f=D.ColorThemeKind.HighContrast;break;case"hcLight":f=D.ColorThemeKind.HighContrastLight;break;default:f=D.ColorThemeKind.Dark}this.a=new D.$pN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jjc=L,e.$Jjc=L=Xe([He(0,P.$fO)],L)}),define(Me[85],Ae([1,0,22,5,6,169,4,14,198,3,27,17,7]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zAb=e.$yAb=e.TunnelDtoConverter=void 0;class w extends f.$Wv{}var m;(function(u){function i(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:n.protocol}}u.fromApiTunnel=i;function r(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==f.TunnelPrivacyId.ConstantPrivate&&n.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}u.fromServiceTunnel=r})(m||(e.TunnelDtoConverter=m={})),e.$yAb=(0,M.$ei)("IExtHostTunnelService");let s=class extends C.$Tc{constructor(i,r,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new P.$5d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(k.$1L.MainThreadTunnelService)}async openTunnel(i,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const n=await this.a.$openTunnel(r,i.displayName);if(n){const a=new w(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,r){const n=this.u();return this.r.set(n,{selector:i,provider:r}),this.a.$registerPortsAttributesProvider(i,n),new l.$3L(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(i,r,n,a,h){const t=[];for(const c of i){const o=this.r.get(c);if(!o)return[];t.push(...await Promise.all(r.map(async b=>{let p;try{p=await o.provider.providePortAttributes({port:b,pid:n,commandLine:a},h)}catch{p=await o.provider.providePortAttributes(b,n,a,h)}return{providedAttributes:p,port:b}})))}const $=t.filter(c=>!!c.providedAttributes);return $.length>0?$.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await i.provideTunnel(a,h,new D.$ce().token)??void 0;const n=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions,protocol:r.tunnelFeatures.protocol===void 0?!0:r.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,r){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const n=i.tunnelFactory??(r?this.w(r):void 0);if(n){this.b=n;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,r){if(this.g.has(i.host)){const n=this.g.get(i.host);n.has(i.port)&&(r&&n.get(i.port).disposeListener.dispose(),await n.get(i.port).tunnel.dispose(),n.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(i,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const a=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:a,disposeListener:h}),m.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(i){const r=await Promise.all(i.map(a=>this.f(a.host,a.port,a.detail??""))),n=i.filter((a,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(a=>a.port).join(", ")} to ${n.map(a=>a.port).join(", ")}`),n}};e.$zAb=s,e.$zAb=s=Xe([He(0,S.$fO),He(1,F.$vO),He(2,g.$yj)],s)}),define(Me[8],Ae([1,0,18,24,130,246,52,28,121,51,69,26,25,16,2,29,86,98,103,102,83,48,60,217,23,7]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$eO=e.$dO=e.MarkdownString=e.$cO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var b;(function(Se){function Te(J){const{selectionStartLineNumber:Ie,selectionStartColumn:Ne,positionLineNumber:Ze,positionColumn:Je}=J,ot=new o.$4L(Ie-1,Ne-1),kt=new o.$4L(Ze-1,Je-1);return new o.$6L(ot,kt)}Se.to=Te;function de(J){const{anchor:Ie,active:Ne}=J;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}Se.from=de})(b||(e.Selection=b={}));var p;(function(Se){function Te(J){if(!J)return;const{start:Ie,end:Ne}=J;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}Se.from=Te;function de(J){if(!J)return;const{startLineNumber:Ie,startColumn:Ne,endLineNumber:Ze,endColumn:Je}=J;return new o.$5L(Ie-1,Ne-1,Ze-1,Je-1)}Se.to=de})(p||(e.Range=p={}));var d;(function(Se){function Te(J){return{uri:J.uri,range:p.from(J.range)}}Se.from=Te;function de(J){return new o.$cM(m.URI.revive(J.uri),p.to(J.range))}Se.to=de})(d||(e.Location=d={}));var I;(function(Se){function Te(de){switch(de){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Se.to=Te})(I||(e.TokenType=I={}));var v;(function(Se){function Te(J){return new o.$4L(J.lineNumber-1,J.column-1)}Se.to=Te;function de(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=de})(v||(e.Position=v={}));var y;(function(Se){function Te(Ie,Ne,Ze){return(0,D.$Hb)((0,D.$3b)(Ie).map(Je=>de(Je,Ne,Ze)))}Se.from=Te;function de(Ie,Ne,Ze){if(typeof Ie=="string")return{$serialized:!0,language:Ie,isBuiltin:Ze?.isBuiltin};if(Ie)return{$serialized:!0,language:Ie.language,scheme:J(Ie.scheme,Ne),pattern:Z.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType,isBuiltin:Ze?.isBuiltin}}function J(Ie,Ne){return Ne&&typeof Ie=="string"?Ne.transformOutgoingScheme(Ie):Ie}})(y||(e.DocumentSelector=y={}));var E;(function(Se){function Te(J){switch(J){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Se.from=Te;function de(J){switch(J){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Se.to=de})(E||(e.DiagnosticTag=E={}));var A;(function(Se){function Te(J){let Ie;return J.code&&((0,w.$Sf)(J.code)||(0,w.$Wf)(J.code)?Ie=String(J.code):Ie={value:String(J.code.value),target:J.code.target}),{...p.from(J.range),message:J.message,source:J.source,code:Ie,severity:X.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,D.$Hb)(J.tags.map(E.from)):void 0}}Se.from=Te;function de(J){const Ie=new o.$eM(p.to(J),J.message,X.to(J.severity));return Ie.source=J.source,Ie.code=(0,w.$Sf)(J.code)?J.code:J.code?.value,Ie.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),Ie.tags=J.tags&&(0,D.$Hb)(J.tags.map(E.to)),Ie}Se.to=de})(A||(e.Diagnostic=A={}));var V;(function(Se){function Te(J){return{...p.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=Te;function de(J){return new o.$dM(new o.$cM(J.resource,p.to(J)),J.message)}Se.to=de})(V||(e.DiagnosticRelatedInformation=V={}));var X;(function(Se){function Te(J){switch(J){case o.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Se.from=Te;function de(J){switch(J){case i.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Se.to=de})(X||(e.DiagnosticSeverity=X={}));var H;(function(Se){function Te(J){return typeof J=="number"&&J>=o.ViewColumn.One?J-1:J===o.ViewColumn.Beside?$.$rD:$.$qD}Se.from=Te;function de(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(H||(e.ViewColumn=H={}));function O(Se){return typeof Se.range<"u"}function R(Se){return Se.length===0?!0:!!O(Se[0])}e.$cO=R;var B;(function(Se){function Te(Je){return Je.map(Se.from)}Se.fromMany=Te;function de(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function J(Je){let ot;if(de(Je)){const{language:Ot,value:ii}=Je;ot={value:"```"+Ot+`
`+ii+"\n```\n"}}else o.$rM.isMarkdownString(Je)?ot={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ot={value:Je}:ot={value:""};const kt=Object.create(null);ot.uris=kt;const Qt=Ot=>{try{let ii=m.URI.parse(Ot,!0);ii=ii.with({query:Ie(ii.query,kt)}),kt[Ot]=ii}catch{}return""},St=new f.marked.Renderer;return St.link=Qt,St.image=Ot=>typeof Ot=="string"?Qt(M.$Ak(Ot).href):"",(0,f.marked)(ot.value,{renderer:St}),ot}Se.from=J;function Ie(Je,ot){if(!Je)return Je;let kt;try{kt=(0,k.$Mh)(Je)}catch{}if(!kt)return Je;let Qt=!1;return kt=(0,S.$Kn)(kt,St=>{if(m.URI.isUri(St)){const Ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[Ot]=St,Qt=!0,Ot}else return}),Qt?JSON.stringify(kt):Je}function Ne(Je){const ot=new o.$rM(Je.value,Je.supportThemeIcons);return ot.isTrusted=Je.isTrusted,ot.supportHtml=Je.supportHtml,ot.baseUri=Je.baseUri?m.URI.from(Je.baseUri):void 0,ot}Se.to=Ne;function Ze(Je){if(Je)return typeof Je=="string"?Je:Se.from(Je)}Se.fromStrict=Ze})(B||(e.MarkdownString=B={}));function T(Se){return R(Se)?Se.map(Te=>({range:p.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?B.fromMany(Te.hoverMessage):Te.hoverMessage?B.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Se.map(Te=>({range:p.from(Te)}))}e.$dO=T;function te(Se){return typeof Se>"u"?Se:typeof Se=="string"?m.URI.file(Se):Se}e.$eO=te;var Q;(function(Se){function Te(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?te(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Te})(Q||(e.ThemableDecorationAttachmentRenderOptions=Q={}));var ce;(function(Se){function Te(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?te(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Q.from(de.before):void 0,after:de.after?Q.from(de.after):void 0}}Se.from=Te})(ce||(e.ThemableDecorationRenderOptions=ce={}));var le;(function(Se){function Te(de){if(typeof de>"u")return de;switch(de){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Te})(le||(e.DecorationRangeBehavior=le={}));var se;(function(Se){function Te(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?le.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?ce.from(de.light):void 0,dark:de.dark?ce.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?te(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Q.from(de.before):void 0,after:de.after?Q.from(de.after):void 0}}Se.from=Te})(se||(e.DecorationRenderOptions=se={}));var $e;(function(Se){function Te(J){return{text:J.newText,eol:J.newEol&&nt.from(J.newEol),range:p.from(J.range)}}Se.from=Te;function de(J){const Ie=new o.$0L(p.to(J.range),J.text);return Ie.newEol=typeof J.eol>"u"?void 0:nt.to(J.eol),Ie}Se.to=de})($e||(e.TextEdit=$e={}));var ne;(function(Se){function Te(J,Ie){const Ne={edits:[]};if(J instanceof o.$aM){const Ze=new g.$Bc;for(const Je of J._allEntries())Je._type===1&&m.URI.isUri(Je.to)&&Je.from===void 0&&Ze.add(Je.to);for(const Je of J._allEntries())if(Je._type===1){let ot;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ot={type:"base64",value:(0,P.$Me)(P.$se.wrap(Je.options.contents))}:ot={type:"dataTransferItem",id:Je.options.contents._itemId}),Ne.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ot},metadata:Je.metadata})}else Je._type===2?Ne.edits.push({resource:Je.uri,textEdit:$e.from(Je.edit),versionId:Ze.has(Je.uri)?void 0:Ie?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ne.edits.push({resource:Je.uri,textEdit:{range:p.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ze.has(Je.uri)?void 0:Ie?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ne.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ne.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Ut.from)}})}return Ne}Se.from=Te;function de(J){const Ie=new o.$aM,Ne=new g.$Ac;for(const Ze of J.edits)if(Ze.textEdit){const Je=Ze,ot=m.URI.revive(Je.resource),kt=p.to(Je.textEdit.range),Qt=Je.textEdit.text,St=Je.textEdit.insertAsSnippet;let Ot;St?Ot=o.$_L.replace(kt,new o.$bM(Qt)):Ot=o.$0L.replace(kt,Qt);const ii=Ne.get(ot);ii?ii.push(Ot):Ne.set(ot,[Ot])}else Ie.renameFile(m.URI.revive(Ze.oldResource),m.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Je]of Ne)Ie.set(Ze,Je);return Ie}Se.to=de})(ne||(e.WorkspaceEdit=ne={}));var ke;(function(Se){const Te=Object.create(null);Te[o.SymbolKind.File]=0,Te[o.SymbolKind.Module]=1,Te[o.SymbolKind.Namespace]=2,Te[o.SymbolKind.Package]=3,Te[o.SymbolKind.Class]=4,Te[o.SymbolKind.Method]=5,Te[o.SymbolKind.Property]=6,Te[o.SymbolKind.Field]=7,Te[o.SymbolKind.Constructor]=8,Te[o.SymbolKind.Enum]=9,Te[o.SymbolKind.Interface]=10,Te[o.SymbolKind.Function]=11,Te[o.SymbolKind.Variable]=12,Te[o.SymbolKind.Constant]=13,Te[o.SymbolKind.String]=14,Te[o.SymbolKind.Number]=15,Te[o.SymbolKind.Boolean]=16,Te[o.SymbolKind.Array]=17,Te[o.SymbolKind.Object]=18,Te[o.SymbolKind.Key]=19,Te[o.SymbolKind.Null]=20,Te[o.SymbolKind.EnumMember]=21,Te[o.SymbolKind.Struct]=22,Te[o.SymbolKind.Event]=23,Te[o.SymbolKind.Operator]=24,Te[o.SymbolKind.TypeParameter]=25;function de(Ie){return typeof Te[Ie]=="number"?Te[Ie]:6}Se.from=de;function J(Ie){for(const Ne in Te)if(Te[Ne]===Ie)return Number(Ne);return o.SymbolKind.Property}Se.to=J})(ke||(e.SymbolKind=ke={}));var oe;(function(Se){function Te(J){switch(J){case o.SymbolTag.Deprecated:return 1}}Se.from=Te;function de(J){switch(J){case 1:return o.SymbolTag.Deprecated}}Se.to=de})(oe||(e.SymbolTag=oe={}));var ve;(function(Se){function Te(J){return{name:J.name,kind:ke.from(J.kind),tags:J.tags&&J.tags.map(oe.from),containerName:J.containerName,location:ye.from(J.location)}}Se.from=Te;function de(J){const Ie=new o.$iM(J.name,ke.to(J.kind),J.containerName,ye.to(J.location));return Ie.tags=J.tags&&J.tags.map(oe.to),Ie}Se.to=de})(ve||(e.WorkspaceSymbol=ve={}));var G;(function(Se){function Te(J){const Ie={name:J.name||"!!MISSING: name!!",detail:J.detail,range:p.from(J.range),selectionRange:p.from(J.selectionRange),kind:ke.from(J.kind),tags:J.tags?.map(oe.from)??[]};return J.children&&(Ie.children=J.children.map(Te)),Ie}Se.from=Te;function de(J){const Ie=new o.$jM(J.name,J.detail,ke.to(J.kind),p.to(J.range),p.to(J.selectionRange));return(0,D.$Lb)(J.tags)&&(Ie.tags=J.tags.map(oe.to)),J.children&&(Ie.children=J.children.map(de)),Ie}Se.to=de})(G||(e.DocumentSymbol=G={}));var ge;(function(Se){function Te(J){const Ie=new o.$nM(ke.to(J.kind),J.name,J.detail||"",m.URI.revive(J.uri),p.to(J.range),p.to(J.selectionRange));return Ie._sessionId=J._sessionId,Ie._itemId=J._itemId,Ie}Se.to=Te;function de(J,Ie,Ne){if(Ie=Ie??J._sessionId,Ne=Ne??J._itemId,Ie===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ne,name:J.name,detail:J.detail,kind:ke.from(J.kind),uri:J.uri,range:p.from(J.range),selectionRange:p.from(J.selectionRange),tags:J.tags?.map(oe.from)}}Se.from=de})(ge||(e.CallHierarchyItem=ge={}));var ae;(function(Se){function Te(de){return new o.$oM(ge.to(de.from),de.fromRanges.map(J=>p.to(J)))}Se.to=Te})(ae||(e.CallHierarchyIncomingCall=ae={}));var De;(function(Se){function Te(de){return new o.$pM(ge.to(de.to),de.fromRanges.map(J=>p.to(J)))}Se.to=Te})(De||(e.CallHierarchyOutgoingCall=De={}));var ye;(function(Se){function Te(J){return{range:J.range&&p.from(J.range),uri:J.uri}}Se.from=Te;function de(J){return new o.$cM(m.URI.revive(J.uri),p.to(J.range))}Se.to=de})(ye||(e.location=ye={}));var we;(function(Se){function Te(J){const Ie=J,Ne=J;return{originSelectionRange:Ie.originSelectionRange?p.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Ne.uri,range:p.from(Ie.targetRange?Ie.targetRange:Ne.range),targetSelectionRange:Ie.targetSelectionRange?p.from(Ie.targetSelectionRange):void 0}}Se.from=Te;function de(J){return{targetUri:m.URI.revive(J.uri),targetRange:p.to(J.range),targetSelectionRange:J.targetSelectionRange?p.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?p.to(J.originSelectionRange):void 0}}Se.to=de})(we||(e.DefinitionLink=we={}));var he;(function(Se){function Te(J){return{range:p.from(J.range),contents:B.fromMany(J.contents)}}Se.from=Te;function de(J){return new o.$fM(J.contents.map(B.to),p.to(J.range))}Se.to=de})(he||(e.Hover=he={}));var K;(function(Se){function Te(J){return{range:p.from(J.range),expression:J.expression}}Se.from=Te;function de(J){return new o.$_M(p.to(J.range),J.expression)}Se.to=de})(K||(e.EvaluatableExpression=K={}));var Y;(function(Se){function Te(J){if(J instanceof o.$aN)return{type:"text",range:p.from(J.range),text:J.text};if(J instanceof o.$bN)return{type:"variable",range:p.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof o.$cN)return{type:"expression",range:p.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Te;function de(J){switch(J.type){case"text":return{range:p.to(J.range),text:J.text};case"variable":return{range:p.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:p.to(J.range),expression:J.expression}}}Se.to=de})(Y||(e.InlineValue=Y={}));var me;(function(Se){function Te(J){return{frameId:J.frameId,stoppedLocation:p.from(J.stoppedLocation)}}Se.from=Te;function de(J){return new o.$dN(J.frameId,p.to(J.stoppedLocation))}Se.to=de})(me||(e.InlineValueContext=me={}));var pe;(function(Se){function Te(J){return{range:p.from(J.range),kind:J.kind}}Se.from=Te;function de(J){return new o.$gM(p.to(J.range),J.kind)}Se.to=de})(pe||(e.DocumentHighlight=pe={}));var Fe;(function(Se){function Te(J){return{uri:J.uri,highlights:J.highlights.map(pe.from)}}Se.from=Te;function de(J){return new o.$hM(m.URI.revive(J.uri),J.highlights.map(pe.to))}Se.to=de})(Fe||(e.MultiDocumentHighlight=Fe={}));var be;(function(Se){function Te(de){switch(de){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Se.to=Te})(be||(e.CompletionTriggerKind=be={}));var Re;(function(Se){function Te(de){return{triggerKind:be.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Te})(Re||(e.CompletionContext=Re={}));var Pe;(function(Se){function Te(J){switch(J){case o.CompletionItemTag.Deprecated:return 1}}Se.from=Te;function de(J){switch(J){case 1:return o.CompletionItemTag.Deprecated}}Se.to=de})(Pe||(e.CompletionItemTag=Pe={}));var We;(function(Se){const Te=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function de(Ne){return Te.get(Ne)??9}Se.from=de;const J=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Ie(Ne){return J.get(Ne)??o.CompletionItemKind.Property}Se.to=Ie})(We||(e.CompletionItemKind=We={}));var j;(function(Se){function Te(de,J){const Ie=new o.$xM(de.label);return Ie.insertText=de.insertText,Ie.kind=We.to(de.kind),Ie.tags=de.tags?.map(Pe.to),Ie.detail=de.detail,Ie.documentation=M.$uk(de.documentation)?B.to(de.documentation):de.documentation,Ie.sortText=de.sortText,Ie.filterText=de.filterText,Ie.preselect=de.preselect,Ie.commitCharacters=de.commitCharacters,s.$7s.isIRange(de.range)?Ie.range=p.to(de.range):typeof de.range=="object"&&(Ie.range={inserting:p.to(de.range.insert),replacing:p.to(de.range.replace)}),Ie.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Ie.insertText=new o.$bM(de.insertText):(Ie.insertText=de.insertText,Ie.textEdit=Ie.range instanceof o.$5L?new o.$0L(Ie.range,Ie.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Ie.additionalTextEdits=de.additionalTextEdits.map(Ne=>$e.to(Ne))),Ie.command=J&&de.command?J.fromInternal(de.command):void 0,Ie}Se.to=Te})(j||(e.CompletionItem=j={}));var z;(function(Se){function Te(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:B.fromStrict(J.documentation)}}Se.from=Te;function de(J){return{label:J.label,documentation:M.$uk(J.documentation)?B.to(J.documentation):J.documentation}}Se.to=de})(z||(e.ParameterInformation=z={}));var q;(function(Se){function Te(J){return{label:J.label,documentation:B.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(z.from):[],activeParameter:J.activeParameter}}Se.from=Te;function de(J){return{label:J.label,documentation:M.$uk(J.documentation)?B.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(z.to):[],activeParameter:J.activeParameter}}Se.to=de})(q||(e.SignatureInformation=q={}));var W;(function(Se){function Te(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(q.from):[]}}Se.from=Te;function de(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(q.to):[]}}Se.to=de})(W||(e.SignatureHelp=W={}));var ie;(function(Se){function Te(de,J){const Ie=new o.$wM(v.to(J.position),typeof J.label=="string"?J.label:J.label.map(ue.to.bind(void 0,de)),J.kind&&Le.to(J.kind));return Ie.textEdits=J.textEdits&&J.textEdits.map($e.to),Ie.tooltip=M.$uk(J.tooltip)?B.to(J.tooltip):J.tooltip,Ie.paddingLeft=J.paddingLeft,Ie.paddingRight=J.paddingRight,Ie}Se.to=Te})(ie||(e.InlayHint=ie={}));var ue;(function(Se){function Te(de,J){const Ie=new o.$vM(J.label);return Ie.tooltip=M.$uk(J.tooltip)?B.to(J.tooltip):J.tooltip,u.Command.is(J.command)&&(Ie.command=de.fromInternal(J.command)),J.location&&(Ie.location=ye.to(J.location)),Ie}Se.to=Te})(ue||(e.InlayHintLabelPart=ue={}));var Le;(function(Se){function Te(J){return J}Se.from=Te;function de(J){return J}Se.to=de})(Le||(e.InlayHintKind=Le={}));var Be;(function(Se){function Te(J){return{range:p.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=Te;function de(J){let Ie;if(J.url)try{Ie=typeof J.url=="string"?m.URI.parse(J.url,!0):m.URI.revive(J.url)}catch{}return new o.$CM(p.to(J.range),Ie)}Se.to=de})(Be||(e.DocumentLink=Be={}));var Ke;(function(Se){function Te(J){const Ie=new o.$FM(J.label);return J.textEdit&&(Ie.textEdit=$e.to(J.textEdit)),J.additionalTextEdits&&(Ie.additionalTextEdits=J.additionalTextEdits.map(Ne=>$e.to(Ne))),Ie}Se.to=Te;function de(J){return{label:J.label,textEdit:J.textEdit?$e.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ie=>$e.from(Ie)):void 0}}Se.from=de})(Ke||(e.ColorPresentation=Ke={}));var et;(function(Se){function Te(J){return new o.$DM(J[0],J[1],J[2],J[3])}Se.to=Te;function de(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=de})(et||(e.Color=et={}));var rt;(function(Se){function Te(J){return{range:p.from(J.range)}}Se.from=Te;function de(J){return new o.$mM(p.to(J.range))}Se.to=de})(rt||(e.SelectionRange=rt={}));var ft;(function(Se){function Te(de){switch(de){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Se.to=Te})(ft||(e.TextDocumentSaveReason=ft={}));var at;(function(Se){function Te(J){switch(J){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Te;function de(J){switch(J){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}Se.to=de})(at||(e.TextEditorLineNumbersStyle=at={}));var nt;(function(Se){function Te(J){if(J===o.EndOfLine.CRLF)return 1;if(J===o.EndOfLine.LF)return 0}Se.from=Te;function de(J){if(J===1)return o.EndOfLine.CRLF;if(J===0)return o.EndOfLine.LF}Se.to=de})(nt||(e.EndOfLine=nt={}));var ct;(function(Se){function Te(de){if(typeof de=="object")return de.viewId;switch(de){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Te})(ct||(e.ProgressLocation=ct={}));var Ve;(function(Se){function Te(J){const Ie={start:J.start+1,end:J.end+1};return J.kind&&(Ie.kind=it.from(J.kind)),Ie}Se.from=Te;function de(J){const Ie={start:J.start-1,end:J.end-1};return J.kind&&(Ie.kind=it.to(J.kind)),Ie}Se.to=de})(Ve||(e.FoldingRange=Ve={}));var it;(function(Se){function Te(J){if(J)switch(J){case o.FoldingRangeKind.Comment:return u.$Xt.Comment;case o.FoldingRangeKind.Imports:return u.$Xt.Imports;case o.FoldingRangeKind.Region:return u.$Xt.Region}}Se.from=Te;function de(J){if(J)switch(J.value){case u.$Xt.Comment.value:return o.FoldingRangeKind.Comment;case u.$Xt.Imports.value:return o.FoldingRangeKind.Imports;case u.$Xt.Region.value:return o.FoldingRangeKind.Region}}Se.to=de})(it||(e.FoldingRangeKind=it={}));var _;(function(Se){function Te(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?p.from(de.selection):void 0,override:typeof de.override=="boolean"?n.$TE.id:void 0}}Se.from=Te})(_||(e.TextEditorOpenOptions=_={}));var Z;(function(Se){function Te(Ne){return Ne instanceof o.$ZM?Ne.toJSON():typeof Ne=="string"?Ne:de(Ne)||J(Ne)?new o.$ZM(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}Se.from=Te;function de(Ne){const Ze=Ne;return Ze?m.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Ne){const Ze=Ne;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ie(Ne){return typeof Ne=="string"?Ne:new o.$ZM(m.URI.revive(Ne.baseUri),Ne.pattern)}Se.to=Ie})(Z||(e.GlobPattern=Z={}));var Ee;(function(Se){function Te(de){if(de){if(Array.isArray(de))return de.map(Te);if(typeof de=="string")return de;{const J=de;return{language:J.language,scheme:J.scheme,pattern:Z.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=Te})(Ee||(e.LanguageSelector=Ee={}));var qe;(function(Se){function Te(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Ie=>Array.isArray(Ie)&&Ie.every(Ne=>Ne&&typeof Ne=="object"&&"uri"in Ne&&m.URI.isUri(Ne.uri)&&"version"in Ne&&typeof Ne.version=="number"&&"ranges"in Ne&&Array.isArray(Ne.ranges)&&Ne.ranges.every(Ze=>Ze instanceof o.$5L)))}Se.is=Te;function de(J){return{documents:J.documents.map(Ie=>Ie.map(Ne=>({uri:m.URI.from(Ne.uri),version:Ne.version,ranges:Ne.ranges.map(Ze=>p.from(Ze))})))}}Se.from=de})(qe||(e.MappedEditsContext=qe={}));var Ye;(function(Se){function Te(J){return{start:J.start,end:J.end}}Se.from=Te;function de(J){return new o.$qN(J.start,J.end)}Se.to=de})(Ye||(e.NotebookRange=Ye={}));var ut;(function(Se){function Te(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=Te;function de(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=de})(ut||(e.NotebookCellExecutionSummary=ut={}));var Oe;(function(Se){function Te(de){if(de===a.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(de===a.NotebookCellExecutionState.Pending)return;if(de===a.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Te})(Oe||(e.NotebookCellExecutionState=Oe={}));var It;(function(Se){function Te(J){switch(J){case o.NotebookCellKind.Markup:return a.CellKind.Markup;case o.NotebookCellKind.Code:default:return a.CellKind.Code}}Se.from=Te;function de(J){switch(J){case a.CellKind.Markup:return o.NotebookCellKind.Markup;case a.CellKind.Code:default:return o.NotebookCellKind.Code}}Se.to=de})(It||(e.NotebookCellKind=It={}));var Vt;(function(Se){function Te(J){const Ie={metadata:J.metadata??Object.create(null),cells:[]};for(const Ne of J.cells)o.$rN.validate(Ne),Ie.cells.push(Ut.from(Ne));return Ie}Se.from=Te;function de(J){const Ie=new o.$sN(J.cells.map(Ut.to));return(0,w.$6f)(J.metadata)||(Ie.metadata=J.metadata),Ie}Se.to=de})(Vt||(e.NotebookData=Vt={}));var Ut;(function(Se){function Te(J){return{cellKind:It.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:ut.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ht.from):[]}}Se.from=Te;function de(J){return new o.$rN(It.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ht.to):void 0,J.metadata,J.internalMetadata?ut.to(J.internalMetadata):void 0)}Se.to=de})(Ut||(e.NotebookCellData=Ut={}));var Yt;(function(Se){function Te(J){return{mime:J.mime,valueBytes:P.$se.wrap(J.data)}}Se.from=Te;function de(J){return new o.$tN(J.valueBytes.buffer,J.mime)}Se.to=de})(Yt||(e.NotebookCellOutputItem=Yt={}));var Ht;(function(Se){function Te(J){return{outputId:J.id,items:J.items.map(Yt.from),metadata:J.metadata}}Se.from=Te;function de(J){const Ie=J.items.map(Yt.to);return new o.$uN(Ie,J.outputId,J.metadata)}Se.to=de})(Ht||(e.NotebookCellOutput=Ht={}));var Pt;(function(Se){function Te(Ie){return J(Ie)?{include:Z.from(Ie.include)??void 0,exclude:Z.from(Ie.exclude)??void 0}:Z.from(Ie)??void 0}Se.from=Te;function de(Ie){return J(Ie)?{include:Z.to(Ie.include),exclude:Z.to(Ie.exclude)}:Z.to(Ie)}Se.to=de;function J(Ie){const Ne=Ie;return Ne?!(0,w.$2f)(Ne.include)&&!(0,w.$2f)(Ne.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Zt;(function(Se){function Te(de,J,Ie){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ne,Ie),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Te})(Zt||(e.NotebookStatusBarItem=Zt={}));var _t;(function(Se){function Te(de,J,Ie){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:J.toInternal(Ne,Ie),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Se.from=Te})(_t||(e.NotebookKernelSourceAction=_t={}));var si;(function(Se){function Te(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=Te})(si||(e.NotebookDocumentContentOptions=si={}));var oi;(function(Se){function Te(J){return{uri:J.uri,provides:J.provides}}Se.from=Te;function de(J){return new o.$wN(m.URI.revive(J.uri),J.provides)}Se.to=de})(oi||(e.NotebookRendererScript=oi={}));var _e;(function(Se){function Te(J){return{message:B.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:p.from(J.location.range),uri:J.location.uri}}}Se.from=Te;function de(J){const Ie=new o.$CN(typeof J.message=="string"?J.message:B.to(J.message));return Ie.actualOutput=J.actual,Ie.expectedOutput=J.expected,Ie.contextValue=J.contextValue,Ie.location=J.location?ye.to(J.location):void 0,Ie}Se.to=de})(_e||(e.TestMessage=_e={}));var Tt;(function(Se){Se.namespace=t.$VK,Se.denamespace=t.$WK})(Tt||(e.TestTag=Tt={}));var xt;(function(Se){function Te(J){const Ie=(0,r.$bO)(J).controllerId;return{extId:h.$RK.fromExtHostTestItem(J,Ie).toString(),label:J.label,uri:m.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ne=>Tt.namespace(Ie,Ne.id)),range:s.$7s.lift(p.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&B.fromStrict(J.error)||null}}Se.from=Te;function de(J){return{parent:void 0,error:void 0,id:h.$RK.fromString(J.extId).localId,label:J.label,uri:m.URI.revive(J.uri),tags:(J.tags||[]).map(Ie=>{const{tagId:Ne}=Tt.denamespace(Ie);return new o.$DN(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:p.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=de})(xt||(e.TestItem=xt={})),function(Se){function Te(J){return{id:J.id}}Se.from=Te;function de(J){return new o.$DN(J.id)}Se.to=de}(Tt||(e.TestTag=Tt={}));var $t;(function(Se){const Te=(J,Ie)=>{const Ne=[];for(const[Je,ot]of Ie)h.$RK.compare(ot.item.extId,Je)===2&&(Ie.delete(Je),Ne.push(ot));const Ze={...xt.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ot=>ot.type===0).map(_e.to)})),children:Ne.map(Je=>Te(Je,Ie))};for(const Je of Ze.children)Je.parent=Ze;return Ze};function de(J){const Ie=[],Ne=new Map;for(const Ze of J.items){Ne.set(Ze.item.extId,Ze);const Je=h.$RK.root(Ze.item.extId);J.request.targets.some(ot=>ot.controllerId===Je&&ot.testIds.includes(Ze.item.extId))&&Ie.push(Ze)}return{completedAt:J.completedAt,results:Ie.map(Ze=>Te(Ze,Ne))}}Se.to=de})($t||(e.TestResults=$t={}));var vt;(function(Se){function Te(Ne){return{covered:Ne.covered,total:Ne.total}}function de(Ne){return"line"in Ne?v.from(Ne):p.from(Ne)}function J(Ne){return"branches"in Ne?{count:Ne.executed,location:de(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&de(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ne.name,count:Ne.executed,location:de(Ne.location)}}Se.fromDetailed=J;function Ie(Ne){return{uri:Ne.uri,statement:Te(Ne.statementCoverage),branch:Ne.branchCoverage&&Te(Ne.branchCoverage),declaration:Ne.declarationCoverage&&Te(Ne.declarationCoverage),details:Ne.detailedCoverage?.map(J)}}Se.fromFile=Ie})(vt||(e.TestCoverage=vt={}));var Kt;(function(Se){function Te(de){switch(de){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Se.to=Te})(Kt||(e.CodeActionTriggerKind=Kt={}));var Nt;(function(Se){function Te(J){const Ie=new o.$JN(ke.to(J.kind),J.name,J.detail||"",m.URI.revive(J.uri),p.to(J.range),p.to(J.selectionRange));return Ie._sessionId=J._sessionId,Ie._itemId=J._itemId,Ie}Se.to=Te;function de(J,Ie,Ne){if(Ie=Ie??J._sessionId,Ne=Ne??J._itemId,Ie===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ne,kind:ke.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:p.from(J.range),selectionRange:p.from(J.selectionRange),tags:J.tags?.map(oe.from)}}Se.from=de})(Nt||(e.TypeHierarchyItem=Nt={}));var Bt;(function(Se){function Te(de){if(de)return{value:de.value,tooltip:de.tooltip}}Se.from=Te})(Bt||(e.ViewBadge=Bt={}));var dt;(function(Se){function Te(Ne,Ze,Je){const ot=Ze.fileData;return ot?new o.$SM(new o.$TM(ot.name,m.URI.revive(ot.uri),ot.id,(0,L.$db)(()=>Je(ot.id)))):Ne===F.$rs.uriList&&Ze.uriListData?new o.$RM(Ie(Ze.uriListData)):new o.$RM(Ze.asString)}Se.to=Te;async function de(Ne,Ze){const Je=await Ze.asString();if(Ne===F.$rs.uriList)return{asString:Je,fileData:void 0,uriListData:J(Je)};const ot=Ze.asFile();return{asString:Je,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Se.from=de;function J(Ne){return C.$Dt.split(Ne).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return m.URI.parse(Ze)}catch{}return Ze})}function Ie(Ne){return C.$Dt.create(Ne.map(Ze=>typeof Ze=="string"?Ze:m.URI.revive(Ze)))}})(dt||(e.DataTransferItem=dt={}));var Mt;(function(Se){function Te(J,Ie){const Ne=J.items.map(([Ze,Je])=>[Ze,dt.to(Ze,Je,Ie)]);return new o.$UM(Ne)}Se.toDataTransfer=Te;async function de(J){const Ie={items:[]},Ne=[];for(const[Ze,Je]of J)Ne.push((async()=>{Ie.items.push([Ze,await dt.from(Ze,Je)])})());return await Promise.all(Ne),Ie}Se.from=de})(Mt||(e.DataTransfer=Mt={}));var ei;(function(Se){function Te(J,Ie){return{kind:"reply",agentId:J.participant??Ie?.agentId??"",subCommand:J.command??Ie?.command,message:J.prompt,title:J.label}}Se.from=Te;function de(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}Se.to=de})(ei||(e.ChatFollowup=ei={}));var ti;(function(Se){function Te(de){return"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:{kind:"reply",message:de.message,title:de.title,tooltip:de.tooltip}}Se.from=Te})(ti||(e.ChatInlineFollowup=ti={}));var Ge;(function(Se){function Te(J){switch(J.role){case 0:return new o.$4N(J.content);case 1:return new o.$5N(J.content);case 2:return new o.$6N(J.content)}}Se.to=Te;function de(J){if(J instanceof o.$4N)return{role:0,content:J.content};if(J instanceof o.$5N)return{role:1,content:J.content};if(J instanceof o.$6N)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}Se.from=de})(Ge||(e.LanguageModelMessage=Ge={}));var Wt;(function(Se){function Te(Ie){const Ne={};for(const Ze of Object.keys(Ie))Ne[Ze]=Ie[Ze].map(Se.to);return Ne}Se.objectTo=Te;function de(Ie){return{level:Xt.to(Ie.level),kind:Ie.kind,value:(0,m.$vc)(Ie.value)?m.URI.revive(Ie.value):Ie.value,description:Ie.description}}Se.to=de;function J(Ie){return{level:Xt.from(Ie.level),kind:Ie.kind,value:Ie.value,description:Ie.description}}Se.from=J})(Wt||(e.ChatVariable=Wt={}));var Xt;(function(Se){function Te(J){switch(J){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}Se.to=Te;function de(J){switch(J){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}Se.from=de})(Xt||(e.ChatVariableLevel=Xt={}));var ni;(function(Se){function Te(de){switch(de){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Te})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var wt;(function(Se){function Te(J){return{kind:"markdownContent",content:B.from(J.value)}}Se.to=Te;function de(J){return new o.$VN(B.to(J.content))}Se.from=de})(wt||(e.ChatResponseMarkdownPart=wt={}));var jt;(function(Se){function Te(J){const{value:Ie,baseUri:Ne}=J;function Ze(Je,ot){return Je.map(kt=>{const Qt=m.URI.joinPath(ot,kt.name);return{label:kt.name,uri:Qt,children:kt.children&&Ze(kt.children,Qt)}})}return{kind:"treeData",treeData:{label:(0,l.$Og)(Ne),uri:Ne,children:Ze(Ie,Ne)}}}Se.to=Te;function de(J){const Ie=(0,k.$Nh)(J.treeData);function Ne(ot){return ot.map(kt=>({name:kt.label,children:kt.children&&Ne(kt.children)}))}const Ze=Ie.uri,Je=Ie.children?Ne(Ie.children):[];return new o.$WN(Je,Ze)}Se.from=de})(jt||(e.ChatResponseFilesPart=jt={}));var At;(function(Se){function Te(J){return{kind:"inlineReference",name:J.title,inlineReference:m.URI.isUri(J.value)?J.value:d.from(J.value)}}Se.to=Te;function de(J){const Ie=(0,k.$Nh)(J);return new o.$XN(m.URI.isUri(Ie.inlineReference)?Ie.inlineReference:d.to(Ie.inlineReference),J.name)}Se.from=de})(At||(e.ChatResponseAnchorPart=At={}));var Rt;(function(Se){function Te(J){return{kind:"progressMessage",content:B.from(J.value)}}Se.to=Te;function de(J){return new o.$YN(J.content.value)}Se.from=de})(Rt||(e.ChatResponseProgressPart=Rt={}));var ri;(function(Se){function Te(J,Ie,Ne){return{kind:"command",command:Ie.toInternal(J.value,Ne)??{command:J.value.command,title:J.value.title}}}Se.to=Te;function de(J,Ie){return new o.$ZN(Ie.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}Se.from=de})(ri||(e.ChatResponseCommandButtonPart=ri={}));var zt;(function(Se){function Te(J){return{kind:"reference",reference:m.URI.isUri(J.value)?J.value:d.from(J.value)}}Se.to=Te;function de(J){const Ie=(0,k.$Nh)(J);return new o.$1N(m.URI.isUri(Ie.reference)?Ie.reference:d.to(Ie.reference))}Se.from=de})(zt||(e.ChatResponseReferencePart=zt={}));var Gt;(function(Se){function Te(Ie){return Ie instanceof o.$VN?wt.to(Ie):Ie instanceof o.$XN?At.to(Ie):Ie instanceof o.$1N?zt.to(Ie):Ie instanceof o.$YN?Rt.to(Ie):Ie instanceof o.$WN?jt.to(Ie):{kind:"content",content:""}}Se.to=Te;function de(Ie,Ne){switch(Ie.kind){case"reference":return zt.from(Ie);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Ie,Ne)}}Se.from=de;function J(Ie,Ne){switch(Ie.kind){case"markdownContent":return wt.from(Ie);case"inlineReference":return At.from(Ie);case"progressMessage":return;case"treeData":return jt.from(Ie);case"command":return ri.from(Ie,Ne)}}Se.fromContent=J})(Gt||(e.ChatResponsePart=Gt={}));var Lt;(function(Se){function Te(Ie,Ne){return"markdownContent"in Ne?((0,c.$WF)(Ie,"chatParticipantAdditions"),{content:B.from(Ne.markdownContent),kind:"markdownContent"}):"content"in Ne?"vulnerabilities"in Ne&&Ne.vulnerabilities?((0,c.$WF)(Ie,"chatParticipantAdditions"),{content:Ne.content,vulnerabilities:Ne.vulnerabilities,kind:"vulnerability"}):typeof Ne.content=="string"?{content:Ne.content,kind:"content"}:((0,c.$WF)(Ie,"chatParticipantAdditions"),{content:B.from(Ne.content),kind:"markdownContent"}):"documents"in Ne?{documents:Ne.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(Je=>p.from(Je))})),kind:"usedContext"}:"reference"in Ne?{reference:"uri"in Ne.reference?{uri:Ne.reference.uri,range:p.from(Ne.reference.range)}:Ne.reference,kind:"reference"}:"inlineReference"in Ne?{inlineReference:"uri"in Ne.inlineReference?{uri:Ne.inlineReference.uri,range:p.from(Ne.inlineReference.range)}:Ne.inlineReference,name:Ne.title,kind:"inlineReference"}:"participant"in Ne?((0,c.$WF)(Ie,"chatParticipantAdditions"),{agentName:Ne.participant,command:Ne.command,kind:"agentDetection"}):"message"in Ne?{content:B.from(Ne.message),kind:"progressMessage"}:void 0}Se.from=Te;function de(Ie){switch(Ie.kind){case"markdownContent":case"inlineReference":case"treeData":return Se.to(Ie);case"content":return{content:Ie.content};case"usedContext":return{documents:Ie.documents.map(Ne=>({uri:m.URI.revive(Ne.uri),version:Ne.version,ranges:Ne.ranges.map(Ze=>p.to(Ze))}))};case"reference":return{reference:(0,m.$vc)(Ie.reference)?m.URI.revive(Ie.reference):d.to(Ie.reference)};case"agentDetection":return;case"progressMessage":return{message:Ie.content.value};case"vulnerability":return{content:Ie.content,vulnerabilities:Ie.vulnerabilities};default:return}}Se.to=de;function J(Ie,Ne){switch(Ie.kind){case"markdownContent":return{content:Ie.content.value};case"inlineReference":return{inlineReference:(0,m.$vc)(Ie.inlineReference)?m.URI.revive(Ie.inlineReference):d.to(Ie.inlineReference),title:Ie.name};case"command":return{command:Ne.fromInternal(Ie.command)??{command:Ie.command.id,title:Ie.command.title}};default:return}}Se.toProgressContent=J})(Lt||(e.ChatResponseProgress=Lt={}));var Ct;(function(Se){function Te(de){return{prompt:de.message,command:de.command,variables:de.variables.variables.map(bt.to)}}Se.to=Te})(Ct||(e.ChatAgentRequest=Ct={}));var bt;(function(Se){function Te(de){return{name:de.name,range:[de.range.start,de.range.endExclusive],values:de.values.map(Wt.to)}}Se.to=Te})(bt||(e.ChatAgentResolvedVariable=bt={}));var Et;(function(Se){function Te(de){return{label:de.label,values:de.values.map(Wt.from),insertText:de.insertText,detail:de.detail,documentation:de.documentation}}Se.from=Te})(Et||(e.ChatAgentCompletionItem=Et={}));var Dt;(function(Se){function Te(de){return{errorDetails:de.errorDetails,metadata:de.metadata}}Se.to=Te})(Dt||(e.ChatAgentResult=Dt={}));var mi;(function(Se){function Te(de,J,Ie){if(J.action.kind==="vote")return;const Ne=Dt.to(de);return J.action.kind==="command"?{action:{kind:"command",commandButton:Lt.toProgressContent(J.action.commandButton,Ie)},result:Ne}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:ei.to(J.action.followup)},result:Ne}:{action:J.action,result:Ne}}Se.to=Te})(mi||(e.ChatAgentUserActionEvent=mi={}));var Jt;(function(Se){function Te(de,J,Ie){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:J.toInternal(de,Ie)}Se.from=Te})(Jt||(e.TerminalQuickFix=Jt={}));var hi;(function(Se){function Te(de,J){return{id:J,label:de.label,description:de.description,canEdit:de.canEdit,collapsibleState:de.collapsibleState||0,contextValue:de.contextValue}}Se.from=Te})(hi||(e.DebugTreeItem=hi={}))}),define(Me[247],Ae([1,0,3,17,8]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;let L=class{constructor(g,f){this.a=g.getProxy(D.$1L.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>f.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,f,k){const F=C.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(F,void 0,k?.isRefactoring??!1)}};e.$Yhc=L,e.$Yhc=L=Xe([He(0,P.$fO)],L)}),define(Me[248],Ae([1,0,18,11,35,5,53,6,64,16,2,158,20,3,8,7,207,23]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class r{constructor(t,$,c,o,b,p){this.j=t,this.k=$,this.l=c,this.m=o,this.n=b,this.o=p,this.b=f.$1d.create(!1),this.d=!1}close(){this.d=!0}get timings(){return{firstProgress:this.g,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.i){let $=function(o){if(t.d){const b=new Error("Response stream has been closed");throw Error.captureStackTrace(b,o),b}};const t=this;this.b.reset();const c=o=>{typeof this.g>"u"&&"content"in o&&(this.g=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,o)};this.i={markdown(o){$(this.markdown);const b=new s.$VN(o),p=m.ChatResponseMarkdownPart.to(b);return c(p),this},filetree(o,b){$(this.filetree);const p=new s.$WN(o,b),d=m.ChatResponseFilesPart.to(p);return c(d),this},anchor(o,b){$(this.anchor);const p=new s.$XN(o,b),d=m.ChatResponseAnchorPart.to(p);return c(d),this},button(o){$(this.anchor);const b=new s.$ZN(o),p=m.ChatResponseCommandButtonPart.to(b,t.n,t.o);return c(p),this},progress(o){$(this.progress);const b=new s.$YN(o),p=m.ChatResponseProgressPart.to(b);return c(p),this},reference(o){$(this.reference);const b=new s.$1N(o),p=m.ChatResponseReferencePart.to(b);return c(p),this},push(o){$(this.push);const b=m.ChatResponsePart.to(o);return c(b),this},report(o){if($(this.report),"placeholder"in o&&"resolvedContent"in o)return;const b=m.ChatResponseProgress.from(t.j,o);if(!b){t.m.error("Unknown progress type: "+JSON.stringify(o));return}return c(b),this}}}return this.i}}class n{constructor(t,$,c){this.j=$,this.k=c,this.d=new Map,this.i=new g.$3c,this.g=t.getProxy(w.$1L.MainThreadChatAgents2)}createChatAgent(t,$,c){const o=n.b++,b=new a(t,$,this.g,o,c);return this.d.set(o,b),this.g.$registerAgent(o,t.identifier,$,{}),b.apiAgent}async $invokeAgent(t,$,c,o){const b=this.d.get(t);if(!b)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this.i.get($.sessionId);p||(p=new g.$Sc,this.i.set($.sessionId,p));const d=new r(b.extension,$,this.g,this.j,this.k.converter,p);try{const I=await this.l($.agentId,c),v=b.invoke(m.ChatAgentRequest.to($),{history:I},d.apiObject,o);return await(0,P.$5g)(Promise.resolve(v).then(y=>{if(y?.metadata)try{JSON.stringify(y.metadata)}catch(E){const A=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.j.error(`[${b.extension.identifier.value}] [@${b.id}] ${A}`,b.extension),{errorDetails:{message:A},timings:d.timings}}return{errorDetails:y?.errorDetails,timings:d.timings,metadata:y?.metadata}}),o)}catch(I){return this.j.error(I,b.extension),{errorDetails:{message:(0,S.localize)(0,null,(0,C.$2i)(I)),responseIsIncomplete:!0}}}finally{d.close()}}async l(t,$){const c=[];for(const o of $.history){const b=m.ChatAgentResult.to(o.result),p=t===o.request.agentId?b:{...b,metadata:void 0};c.push(new s.$2N(o.request.message,o.request.command,o.request.variables.variables.map(m.ChatAgentResolvedVariable.to),{extensionId:"",name:o.request.agentId}));const d=(0,D.$Hb)(o.response.map(I=>m.ChatResponsePart.fromContent(I,this.k.converter)));c.push(new s.$3N(d,p,{extensionId:"",name:o.request.agentId},o.request.command))}return c}$releaseSession(t){this.i.deleteAndDispose(t)}async $provideSlashCommands(t,$,c){const o=this.d.get(t);if(!o)return[];const b=await this.l(o.id,$);try{return await o.provideSlashCommands({history:b},c)}catch(p){const d=(0,C.$2i)(p);return this.j.error(`[${o.extension.identifier.value}] [@${o.id}] Error while providing slash commands: ${d}`),[]}}async $provideFollowups(t,$,c,o){const b=this.d.get($);if(!b)return Promise.resolve([]);const p=m.ChatAgentResult.to(c);return(await b.provideFollowups(p,o)).filter(d=>{const I=!d.participant||M.Iterable.some(this.d.values(),v=>v.id===d.participant&&l.$xm.equals(v.extension.identifier,b.extension.identifier));return I||this.j.warn(`[@${b.id}] ChatFollowup refers to an invalid participant: ${d.participant}`),I}).map(d=>m.ChatFollowup.from(d,t))}$acceptFeedback(t,$,c,o){const b=this.d.get(t);if(!b)return;const p=m.ChatAgentResult.to($);let d;switch(c){case u.InteractiveSessionVoteDirection.Down:d=s.ChatResultFeedbackKind.Unhelpful;break;case u.InteractiveSessionVoteDirection.Up:d=s.ChatResultFeedbackKind.Helpful;break}b.acceptFeedback(Object.freeze(o?{result:p,kind:d,reportIssue:o}:{result:p,kind:d}))}$acceptAction(t,$,c){const o=this.d.get(t);if(!o||c.action.kind==="vote")return;const b=m.ChatAgentUserActionEvent.to($,c,this.k.converter);b&&o.acceptAction(Object.freeze(b))}async $invokeCompletionProvider(t,$,c){const o=this.d.get(t);return o?(await o.invokeCompletionProvider($,c)).map(m.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,$){const c=this.d.get(t);if(c)return await c.provideWelcomeMessage($)}async $provideSampleQuestions(t,$){const c=this.d.get(t);if(c)return(await c.provideSampleQuestions($)).map(o=>m.ChatFollowup.from(o,void 0))}}e.$1hc=n,n.b=0;class a{constructor(t,$,c,o,b){this.extension=t,this.id=$,this.y=c,this.z=o,this.A=b,this.q=new L.$5d,this.s=new L.$5d}acceptFeedback(t){this.q.fire(t)}acceptAction(t){this.s.fire(t)}async invokeCompletionProvider(t,$){return this.u?await this.u.provider.provideCompletionItems(t,$)??[]:[]}async provideSlashCommands(t,$){if(!this.b)return[];const c=await this.b.provideCommands(t,$);return c?c.map(o=>("isSticky2"in o&&(0,i.$WF)(this.extension,"chatParticipantAdditions"),{name:o.name,description:o.description??"",followupPlaceholder:o.isSticky2?.placeholder,isSticky:o.isSticky2?.isSticky??o.isSticky,sampleRequest:o.sampleRequest})):[]}async provideFollowups(t,$){if(!this.d)return[];const c=await this.d.provideFollowups(t,$);return c?c.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(t){if(!this.w)return[];const $=await this.w.provideWelcomeMessage(t);return $?$.map(c=>typeof c=="string"?c:m.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.w||!this.w.provideSampleQuestions)return[];const $=await this.w.provideSampleQuestions(t);return $||[]}get apiAgent(){let t=!1,$=!1;const c=()=>{t||$||($=!0,queueMicrotask(()=>{this.y.$updateAgent(this.z,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof F.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof s.$XM?this.j:void 0,hasSlashCommands:this.b!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.p,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),helpTextVariablesPrefix:!this.m||typeof this.m=="string"?this.m:m.MarkdownString.from(this.m),helpTextPostfix:!this.n||typeof this.n=="string"?this.n:m.MarkdownString.from(this.n),sampleRequest:this.o,supportIssueReporting:this.t,isSticky:this.x}),$=!1}))},o=this;return{get name(){return o.id},get description(){return o.g??""},set description(b){o.g=b,c()},get fullName(){return(0,i.$WF)(o.extension,"defaultChatParticipant"),o.i??o.extension.displayName??o.extension.name},set fullName(b){(0,i.$WF)(o.extension,"defaultChatParticipant"),o.i=b,c()},get iconPath(){return o.j},set iconPath(b){o.j=b,c()},get requestHandler(){return o.A},set requestHandler(b){(0,k.$3f)(typeof b=="function","Invalid request handler"),o.A=b},get commandProvider(){return o.b},set commandProvider(b){o.b=b,c()},get followupProvider(){return o.d},set followupProvider(b){o.d=b,c()},get isDefault(){return(0,i.$WF)(o.extension,"defaultChatParticipant"),o.k},set isDefault(b){(0,i.$WF)(o.extension,"defaultChatParticipant"),o.k=b,c()},get helpTextPrefix(){return(0,i.$WF)(o.extension,"defaultChatParticipant"),o.l},set helpTextPrefix(b){if((0,i.$WF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextPrefix is only available on the default chat agent");o.l=b,c()},get helpTextVariablesPrefix(){return(0,i.$WF)(o.extension,"defaultChatParticipant"),o.m},set helpTextVariablesPrefix(b){if((0,i.$WF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextVariablesPrefix is only available on the default chat agent");o.m=b,c()},get helpTextPostfix(){return(0,i.$WF)(o.extension,"defaultChatParticipant"),o.n},set helpTextPostfix(b){if((0,i.$WF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextPostfix is only available on the default chat agent");o.n=b,c()},get isSecondary(){return(0,i.$WF)(o.extension,"defaultChatParticipant"),o.p},set isSecondary(b){(0,i.$WF)(o.extension,"defaultChatParticipant"),o.p=b,c()},get sampleRequest(){return o.o},set sampleRequest(b){o.o=b,c()},get supportIssueReporting(){return(0,i.$WF)(o.extension,"chatParticipantAdditions"),o.t},set supportIssueReporting(b){(0,i.$WF)(o.extension,"chatParticipantAdditions"),o.t=b,c()},get onDidReceiveFeedback(){return o.q.event},set participantVariableProvider(b){if((0,i.$WF)(o.extension,"chatParticipantAdditions"),o.u=b,b){if(!b.triggerCharacters.length)throw new Error("triggerCharacters are required");o.y.$registerAgentCompletionsProvider(o.z,b.triggerCharacters)}else o.y.$unregisterAgentCompletionsProvider(o.z)},get participantVariableProvider(){return(0,i.$WF)(o.extension,"chatParticipantAdditions"),o.u},set welcomeMessageProvider(b){(0,i.$WF)(o.extension,"defaultChatParticipant"),o.w=b,c()},get welcomeMessageProvider(){return(0,i.$WF)(o.extension,"defaultChatParticipant"),o.w},onDidPerformAction:(0,i.$VF)(this.extension,"chatParticipantAdditions")?this.s.event:void 0,get isSticky(){return o.x},set isSticky(b){o.x=b,c()},dispose(){t=!0,o.b=void 0,o.d=void 0,o.q.dispose(),o.y.$unregisterAgent(o.z)}}}invoke(t,$,c,o){return this.A(t,$,c,o)}}}),define(Me[249],Ae([1,0,22,6,3,8,99,20,11,5,159,104,35]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;class w{constructor(i,r){this.option=i,this.stream=new f.$Hh,this.stream=r??new f.$Hh}}class m{constructor(i,r){this.cts=r,this.a=new Map,this.b=new f.$Hh,this.c=!1;const n=this;this.apiObject={result:i,stream:n.b.asyncIterable},i.then(()=>{for(const a of this.d())a.resolve()}).catch(a=>{a instanceof Error||(a=new Error((0,l.$2i)(a),{cause:a}));for(const h of this.d())h.reject(a)}).finally(()=>{this.c=!0})}*d(){if(this.a.size>0)for(const[,i]of this.a)yield i.stream;else yield this.b}handleFragment(i){if(this.c)return;let r=this.a.get(i.index);r||(this.a.size===0?r=new w(i.index,this.b):r=new w(i.index),this.a.set(i.index,r)),r.stream.emitOne(i.part)}}class s{constructor(i,r,n){this.j=r,this.k=n,this.c=new k.$5d,this.d=new k.$5d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new g.$zm,this.i=new Map,this.b=i.getProxy(C.$1L.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(i,r,n,a){const h=s.a++;this.f.set(h,{extension:i.identifier,provider:n});let t;return a.auth&&(t={providerLabel:i.displayName||i.name,accountLabel:typeof a.auth=="object"?a.auth.label:void 0}),this.b.$registerProvider(h,r,{extension:i.identifier,model:a.name??"",auth:t}),(0,P.$Rc)(()=>{this.f.delete(h),this.b.$unregisterProvider(h)})}async $provideLanguageModelResponse(i,r,n,a,h,t){const $=this.f.get(i);if(!$)return;const c=new M.$Iv(async o=>{if(t.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:o.index,part:o.part})});return $.provider.provideLanguageModelResponse2(a.map(L.LanguageModelMessage.to),h,g.$xm.toKey(n),c,t)}$updateLanguageModels(i){const r=[],n=[];if(i.added)for(const a of i.added)this.g.add(a),r.push(a);if(i.removed)for(const a of i.removed){this.g.delete(a),n.push(a);for(const[h,t]of this.i)t.languageModelId===a&&(t.res.cts.cancel(),this.i.delete(h))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(n)}))}getLanguageModelIds(){return Array.from(this.g)}$updateModelAccesslist(i){const r=new Array;for(const{from:n,to:a,enabled:h}of i){const t=this.h.get(n)??new g.$ym;if(t.has(a)!==h){h?t.add(a):t.delete(a),this.h.set(n,t);const c={from:n,to:a};r.push(c),this.c.fire(c)}}}async requestLanguageModelAccess(i,r,n){const a=i.identifier,h=n?.justification,t=await this.b.$prepareChatAccess(a,r,h);if(!t)throw new Error(`Language model '${r}' NOT found`);this.m(a,t)&&await this.l(i,{identifier:t.extension,displayName:t.auth.providerLabel},h);const $=this;return{get model(){return t.model},get isRevoked(){return $.m(a,t)&&!$.h.get(a)?.has(t.extension)||!$.g.has(r)},get onDidChangeAccess(){const c=k.Event.filter($.d.event,b=>b.removed.includes(r)),o=k.Event.filter($.c.event,b=>g.$xm.equals(b.from,a)&&g.$xm.equals(b.to,t.extension));return k.Event.signal(k.Event.any(c,o))},makeChatRequest(c,o,b){if($.m(a,t)&&!$.h.get(a)?.has(t.extension))throw new Error("Access to chat has been revoked");if(!$.g.has(r))throw new Error("Language Model has been removed");const p=new D.$ce(b),d=Math.random()*1e6|0,I=$.b.$fetchResponse(a,r,d,c.map(L.LanguageModelMessage.from),o??{},p.token),v=new m(I,p);return $.i.set(d,{languageModelId:r,res:v}),I.finally(()=>{$.i.delete(d),p.dispose()}),v.apiObject}}}async $handleResponseFragment(i,r){const n=this.i.get(i);n&&n.res.handleFragment(r)}async l(i,r,n){const a=S.$7K+r.identifier.value;if(!await this.k.getSession(i,a,[],{silent:!0}))try{const t=n?(0,F.localize)(0,null,r.displayName,n):(0,F.localize)(1,null,r.displayName);await this.k.getSession(i,a,[],{forceNewSession:{detail:t}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:i.identifier,to:r.identifier,enabled:!0}])}m(i,r){return!!r.auth&&!g.$xm.equals(r.extension,i)}}e.$2hc=s,s.a=1}),define(Me[250],Ae([1,0,15,6,3,8,7,23]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;class f{constructor(S){this.b=new Map,this.c=S.getProxy(C.$1L.MainThreadChatVariables)}async $resolveVariable(S,l,w,m){const s=this.b.get(S);if(s)try{if(s.resolver.resolve2){(0,g.$WF)(s.extension,"chatParticipantAdditions");const u=new k(l,this.c),i=await s.resolver.resolve2(s.data.name,{prompt:w},u.apiObject,m);if(i)return i.map(L.ChatVariable.from)}else{const u=await s.resolver.resolve(s.data.name,{prompt:w},m);if(u)return u.map(L.ChatVariable.from)}}catch(u){(0,D.$2)(u)}}registerVariableResolver(S,l,w,m){const s=f.a++;return this.b.set(s,{extension:S,data:{name:l,description:w},resolver:m}),this.c.$registerVariable(s,{name:l,description:w}),(0,P.$Rc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$3hc=f,f.a=0;class k{constructor(S,l){this.c=S,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(m){if(S.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,m),s}};const S=this,w=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){l(this.progress);const s=new M.$YN(m),u=L.ChatResponseProgressPart.to(s);return w(u),this},reference(m){l(this.reference);const s=new M.$1N(m),u=L.ChatResponseReferencePart.to(s);return w(u),this},push(m){l(this.push);const s=L.ChatResponsePart.to(m);return w(s),this}}}return this.b}}}),define(Me[251],Ae([1,0,11,68,5,6,2,86,20,8,7,3,23]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;function w(m,s,u){const i=m.getProxy(S.$1L.MainThreadComments);class r{constructor(){this.b=new Map,this.c=new f.$zm,s.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===6){const d=this.b.get(p.handle);return d?d.value:p}else if(p&&p.$mid===7){const d=this.b.get(p.commentControlHandle);if(!d)return p;const I=d.getCommentThread(p.commentThreadHandle);return I?I.value:p}else if(p&&(p.$mid===9||p.$mid===8)){const d=this.b.get(p.thread.commentControlHandle);if(!d)return p;const I=d.getCommentThread(p.thread.commentThreadHandle);return I?p.$mid===8?I.value:{thread:I.value,text:p.text}:p}else if(p&&p.$mid===10){const d=this.b.get(p.thread.commentControlHandle);if(!d)return p;const I=d.getCommentThread(p.thread.commentThreadHandle);if(!I)return p;const v=p.commentUniqueId,y=I.getCommentByUniqueId(v);return y||p}else if(p&&p.$mid===11){const d=this.b.get(p.thread.commentControlHandle);if(!d)return p;const I=d.getCommentThread(p.thread.commentThreadHandle);if(!I)return p;const v=p.text,y=p.commentUniqueId,E=I.getCommentByUniqueId(y);return E?(typeof E.body=="string"?E.body=v:E.body=new F.$rM(v),E):p}return p}})}createCommentController(p,d,I){const v=r.a++,y=new a(p,v,d,I);this.b.set(y.handle,y);const E=this.c.get(p.identifier)||[];return E.push(y),this.c.set(p.identifier,E),y.value}async $createCommentThreadTemplate(p,d,I){const v=this.b.get(p);v&&v.$createCommentThreadTemplate(d,I)}async $setActiveComment(p,d){const I=this.b.get(p);I&&I.$setActiveComment(d??void 0)}async $updateCommentThreadTemplate(p,d,I){const v=this.b.get(p);v&&v.$updateCommentThreadTemplate(d,I)}$deleteCommentThread(p,d){this.b.get(p)?.$deleteCommentThread(d)}$provideCommentingRanges(p,d,I){const v=this.b.get(p);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const y=u.getDocument(M.URI.revive(d));return(0,D.$9g)(async()=>{const E=await v.commentingRangeProvider.provideCommentingRanges(y,I);let A;return Array.isArray(E)?A={ranges:E,fileComments:!1}:E?A={ranges:E.ranges||[],fileComments:E.fileComments||!1}:A=E??void 0,A}).then(E=>{let A;return E&&(A={ranges:E.ranges.map(V=>k.Range.from(V)),fileComments:E.fileComments}),A})}$toggleReaction(p,d,I,v,y){const E=this.b.get(p);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$9g)(()=>{const A=E.getCommentThread(d);if(A){const V=A.getCommentByUniqueId(v.uniqueIdInThread);if(E!==void 0&&V&&E.reactionHandler)return E.reactionHandler(V,$(y))}return Promise.resolve(void 0)})}}r.a=0;class n{set threadId(p){this.n=p}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(p){(p===void 0!=(this.p===void 0)||!p||!this.p||!p.isEqual(this.p))&&(this.p=p,this.b.range=p,this.c.fire())}get range(){return this.p}set canReply(p){this.d!==p&&(this.d=p,this.b.canReply=p,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(p){this.e=p,this.b.label=p,this.c.fire()}get contextValue(){return this.f}set contextValue(p){this.f=p,this.b.contextValue=p,this.c.fire()}get comments(){return this.q}set comments(p){this.q=p,this.b.comments=p,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(p){this.g=p,this.b.collapsibleState=p,this.c.fire()}get state(){return this.h}set state(p){this.h=p,this.b.state=p,this.c.fire()}get isDisposed(){return this.j}constructor(p,d,I,v,y,E,A,V){this.m=d,this.n=I,this.o=v,this.p=y,this.q=E,this.extensionDescription=A,this.r=V,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$5d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Uc,this.l.value=new L.$Sc,this.n===void 0&&(this.n=`${p}.${this.handle}`),i.$createCommentThread(d,this.handle,this.n,this.o,k.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{i.$deleteCommentThread(d,this.handle)}});const X=this;this.value={get uri(){return X.uri},get range(){return X.range},set range(H){X.range=H},get comments(){return X.comments},set comments(H){X.comments=H},get collapsibleState(){return X.collapsibleState},set collapsibleState(H){X.collapsibleState=H},get canReply(){return X.canReply},set canReply(H){X.canReply=H},get contextValue(){return X.contextValue},set contextValue(H){X.contextValue=H},get label(){return X.label},set label(H){X.label=H},get state(){return X.state},set state(H){X.state=H},dispose:()=>{X.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Sc);const p=I=>Object.prototype.hasOwnProperty.call(this.b,I),d={};p("range")&&(d.range=k.Range.from(this.p)),p("label")&&(d.label=this.label),p("contextValue")&&(d.contextValue=this.contextValue??null),p("comments")&&(d.comments=this.q.map(I=>h(this,I,this.k,this.extensionDescription))),p("collapsibleState")&&(d.collapseState=c(this.g)),p("canReply")&&(d.canReply=this.canReply),p("state")&&(d.state=o(this.h)),p("isTemplate")&&(d.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,d)}getCommentByUniqueId(p){for(const d of this.k){const I=d[0],v=d[1];if(p===v)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(p=>p.dispose())}}n.a=0,Xe([(0,P.$Jh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(p){this.b=p,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(p){this.c=p,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!p})}get options(){return this.d}set options(p){this.d=p,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$WF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$WF)(this.h,"activeComment"),this.f}constructor(p,d,I,v){this.h=p,this.i=d,this.j=I,this.k=v,this.a=new Map,i.$registerCommentController(this.handle,I,v,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(E){y.options=E},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(E){y.commentingRangeProvider=E},get reactionHandler(){return y.reactionHandler},set reactionHandler(E){y.reactionHandler=E},get activeCommentThread(){return y.activeCommentThread},createCommentThread(E,A,V){return y.createCommentThread(E,A,V).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(p,d,I){d===void 0&&(0,l.$WF)(this.h,"fileComments");const v=new n(this.id,this.handle,void 0,p,d,I,this.h,!1);return this.a.set(v.handle,v),v}$setActiveComment(p){if(!p){this.e=void 0,this.f=void 0;return}const d=this.a.get(p.commentThreadHandle);d&&(this.e=p.uniqueIdInThread?d.getCommentByUniqueId(p.uniqueIdInThread):void 0,this.f=d)}$createCommentThreadTemplate(p,d){const I=new n(this.id,this.handle,void 0,M.URI.revive(p),k.Range.to(d),[],this.h,!0);return I.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(p,d){const I=this.a.get(p);I&&(I.range=k.Range.to(d))}$deleteCommentThread(p){this.a.get(p)?.dispose(),this.a.delete(p)}getCommentThread(p){return this.a.get(p)}dispose(){this.a.forEach(p=>{p.dispose()}),this.g.forEach(p=>p.dispose())}}function h(b,p,d,I){let v=d.get(p);return v||(v=++b.commentHandle,d.set(p,v)),p.state!==void 0&&(0,l.$WF)(I,"commentsDraftState"),p.reactions?.some(y=>y.reactors!==void 0)&&(0,l.$WF)(I,"commentReactor"),{mode:p.mode,contextValue:p.contextValue,uniqueIdInThread:v,body:typeof p.body=="string"?p.body:k.MarkdownString.from(p.body),userName:p.author.name,userIconPath:p.author.iconPath,label:p.label,commentReactions:p.reactions?p.reactions.map(y=>t(y)):void 0,state:p.state,timestamp:p.timestamp?.toJSON()}}function t(b){return{label:b.label,iconPath:b.iconPath?k.$eO(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted,reactors:b.reactors&&b.reactors.length>0&&typeof b.reactors[0]!="string"?b.reactors.map(p=>p.name):b.reactors}}function $(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?M.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1,reactors:b.reactors?.map(p=>({name:p}))}}function c(b){if(b!==void 0)switch(b){case F.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function o(b){if(b!==void 0)switch(b){case F.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case F.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new r}e.$7hc=w}),define(Me[252],Ae([1,0,22,97,6,12,25,2,8,62,74,3,7]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class w{constructor($,c){this.document=$,this.b=c,this.a=1,this.c=new F.$Lhc("custom documents")}addEdit($){return this.c.add([$])}async undo($,c){await this.f($).undo(),c||this.disposeBackup()}async redo($,c){await this.f($).redo(),c||this.disposeBackup()}disposeEdits($){for(const c of $)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const $=h(this.document.uri)+this.a++;return(0,M.$Rg)(this.b,$)}updateBackup($){this.d?.delete(),this.d=$}disposeBackup(){this.d?.delete(),this.d=void 0}f($){const c=this.c.get($,0);if(!c)throw new Error("No edit found");return c}}class m{constructor(){this.a=new Map}get($,c){return this.a.get(this.b($,c))}add($,c,o){const b=this.b($,c.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${$} resource:${c.uri}`);const p=new w(c,o);return this.a.set(b,p),p}delete($,c){const o=this.b($,c.uri);this.a.delete(o)}b($,c){return`${$}@@@${c}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class u{constructor(){this.a=new Map}addTextProvider($,c,o){return this.b(0,$,c,o)}addCustomProvider($,c,o){return this.b(1,$,c,o)}get($){return this.a.get($)}b($,c,o,b){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:$,extension:o,provider:b}),new l.$3L(()=>this.a.delete(c))}}class i{constructor($,c,o,b,p){this.d=c,this.f=o,this.g=b,this.h=p,this.b=new u,this.c=new m,this.a=$.getProxy(S.$1L.MainThreadCustomEditors)}registerCustomEditorProvider($,c,o,b){const p=new C.$Sc;return n(o)?(p.add(this.b.addTextProvider(c,$,o)),this.a.$registerTextEditorProvider((0,k.$jic)($),c,b.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.$hic)($))):(p.add(this.b.addCustomProvider(c,$,o)),r(o)&&p.add(o.onDidChangeCustomDocument(d=>{const I=this.i(c,d.document.uri);if(a(d)){const v=I.addEdit(d);this.a.$onDidEdit(d.document.uri,c,v,d.label)}else this.a.$onContentChange(d.document.uri,c)})),this.a.$registerCustomEditorProvider((0,k.$jic)($),c,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,k.$hic)($))),l.$3L.from(p,new l.$3L(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument($,c,o,b,p){const d=this.b.get(c);if(!d)throw new Error(`No provider found for '${c}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${c}'`);const I=g.URI.revive($),v=await d.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:b?.buffer},p);let y;return r(d.provider)&&this.f&&(y=this.f.workspaceValue(d.extension)??this.f.globalValue(d.extension)),this.c.add(c,v,y),{editable:r(d.provider)}}async $disposeCustomDocument($,c){const o=this.b.get(c);if(!o)throw new Error(`No provider found for '${c}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${c}'`);const b=g.URI.revive($),{document:p}=this.i(c,b);this.c.delete(c,p),p.dispose()}async $resolveCustomEditor($,c,o,b,p,d){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const v=f.ViewColumn.to(p),y=this.g.createNewWebview(c,b.contentOptions,I.extension),E=this.h.createNewWebviewPanel(c,o,b.title,v,b.options,y,b.active),A=g.URI.revive($);switch(I.type){case 1:{const{document:V}=this.i(o,A);return I.provider.resolveCustomEditor(V,E,d)}case 0:{const V=this.d.getDocument(A);return I.provider.resolveCustomTextEditor(V,E,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits($,c,o){this.i(c,$).disposeEdits(o)}async $onMoveCustomEditor($,c,o){const b=this.b.get(o);if(!b)throw new Error(`No provider found for '${o}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const p=this.h.getWebviewPanel($);if(!p)throw new Error("No webview found");const d=g.URI.revive(c),I=this.d.getDocument(d);await b.provider.moveCustomTextEditor(I,p,D.CancellationToken.None)}async $undo($,c,o,b){return this.i(c,$).undo(o,b)}async $redo($,c,o,b){return this.i(c,$).redo(o,b)}async $revert($,c,o){const b=this.i(c,$);await this.j(c).revertCustomDocument(b.document,o),b.disposeBackup()}async $onSave($,c,o){const b=this.i(c,$);await this.j(c).saveCustomDocument(b.document,o),b.disposeBackup()}async $onSaveAs($,c,o,b){const p=this.i(c,$);return this.j(c).saveCustomDocumentAs(p.document,g.URI.revive(o),b)}async $backup($,c,o){const b=this.i(c,$),d=await this.j(c).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},o);return b.updateBackup(d),d.id}i($,c){const o=this.c.get($,g.URI.revive(c));if(!o)throw new Error("No custom document found");return o}j($){const o=this.b.get($)?.provider;if(!o||!r(o))throw new Error("Custom document is not editable");return o}}e.$mic=i;function r(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const $=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,P.$5i)($)+""}});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[253],Ae([1,0,160,98,2,3,7,8,5,14,28,43]),function(x,e,D,P,C,L,M,g,f,k,F,S){"use strict";var l,w,m,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=void 0;class u{constructor(n,a,h,t,$,c,o,b){this.d=n,this.e=a,this.f=h,this.g=t,this.h=$,l.set(this,void 0),w.set(this,void 0),m.set(this,void 0),this.c=!1,this.f=Math.max(t,h),xe(this,m,new F.$Ac(p=>c.getComparisonKey(p)),"f"),xe(this,l,o,"f"),xe(this,w,b,"f")}dispose(){this.c||(Ue(this,w,"f").fire([...Ue(this,m,"f").keys()]),Ue(this,l,"f")?.$clear(this.e),Ue(this,m,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(n,a){if(!n){this.clear();return}this.j();let h=[];if(C.URI.isUri(n)){if(!a){this.delete(n);return}Ue(this,m,"f").set(n,a.slice()),h=[n]}else if(Array.isArray(n)){h=[];let c;n=[...n].sort(u.k);for(const o of n){const[b,p]=o;if((!c||b.toString()!==c.toString())&&(c&&Ue(this,m,"f").get(c).length===0&&Ue(this,m,"f").delete(c),c=b,h.push(b),Ue(this,m,"f").set(b,[])),p)Ue(this,m,"f").get(b)?.push(...p);else{const d=Ue(this,m,"f").get(b);d&&(d.length=0)}}}if(Ue(this,w,"f").fire(h),!Ue(this,l,"f"))return;const t=[];let $=0;for(const c of h){let o=[];const b=Ue(this,m,"f").get(c);if(b)if(b.length>this.g){o=[];const p=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const I of b)if(I.severity===p[d]&&o.push({...g.Diagnostic.from(I),modelVersionId:this.h(c)})===this.g)break e;o.push({severity:P.MarkerSeverity.Info,message:(0,D.localize)(0,null,b.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=b.map(p=>({...g.Diagnostic.from(p),modelVersionId:this.h(c)}));if(t.push([c,o]),$+=o.length,$>this.f)break}Ue(this,l,"f").$changeMany(this.e,t)}delete(n){this.j(),Ue(this,w,"f").fire([n]),Ue(this,m,"f").delete(n),Ue(this,l,"f")?.$changeMany(this.e,[[n,void 0]])}clear(){this.j(),Ue(this,w,"f").fire([...Ue(this,m,"f").keys()]),Ue(this,m,"f").clear(),Ue(this,l,"f")?.$clear(this.e)}forEach(n,a){this.j();for(const[h,t]of this)n.call(a,h,t,this)}*[(l=new WeakMap,w=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.j();for(const n of Ue(this,m,"f").keys())yield[n,this.get(n)]}get(n){this.j();const a=Ue(this,m,"f").get(n);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(n){return this.j(),Array.isArray(Ue(this,m,"f").get(n))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(n,a){return n[0].toString()<a[0].toString()?-1:n[0].toString()>a[0].toString()?1:0}}e.$Shc=u;let i=s=class{static _mapper(n){const a=new F.$Ac;for(const h of n)a.set(h,h);return{uris:Object.freeze(Array.from(a.values()))}}constructor(n,a,h,t){this.j=a,this.k=h,this.l=t,this.g=new Map,this.h=new f.$9d({merge:$=>$.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,s._mapper),this.f=n.getProxy(L.$1L.MainThreadDiagnostics)}createDiagnosticCollection(n,a){const{g:h,f:t,h:$,j:c,k:o,l:b}=this,p=new class{$changeMany(v,y){t.$changeMany(v,y),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",n.value,v,y.length===0?"CLEARING":y)}$clear(v){t.$clear(v),c.trace("[DiagnosticCollection] remove all (extension, owner)",n.value,v)}dispose(){t.dispose()}};let d;if(!a)a="_generated_diagnostic_collection_name_#"+s.c++,d=a;else if(!h.has(a))d=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do d=a+s.c++;while(h.has(d))}return new class extends u{constructor(){super(a,d,s.e,s.d,v=>b.getDocument(v)?.version,o.extUri,p,$),h.set(d,this)}dispose(){super.dispose(),h.delete(d)}}}getDiagnostics(n){if(n)return this.m(n);{const a=new Map,h=[];for(const t of this.g.values())t.forEach(($,c)=>{let o=a.get($.toString());typeof o>"u"&&(o=h.length,a.set($.toString(),o),h.push([$,[]])),h[o][1]=h[o][1].concat(...c)});return h}}m(n){let a=[];for(const h of this.g.values())h.has(n)&&(a=a.concat(h.get(n)));return a}$acceptMarkersChange(n){if(!this.n){const a="_generated_mirror",h=new u(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(a,h),this.n=h}for(const[a,h]of n)this.n.set(C.URI.revive(a),h.map(g.Diagnostic.to))}};e.$Thc=i,i.c=0,i.d=1e3,i.e=1.1*s.d,e.$Thc=i=s=Xe([He(1,k.$yj),He(2,S.$Rhc)],i)}),define(Me[254],Ae([1,0,2,15,7,8,187]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;class g{constructor(k,F,S,l={timeout:1500,errors:3}){this.c=k,this.d=F,this.f=S,this.g=l,this.a=new M.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(F,S,l)=>{const m={dispose:this.a.push([F,S,k])};return Array.isArray(l)&&l.push(m),m}}async $participateInSave(k,F){const S=D.URI.revive(k);let l=!1;const w=setTimeout(()=>l=!0,this.g.timeout),m=[];try{for(const s of[...this.a]){if(l)break;const u=this.d.getDocument(S),i=await this.h(s,{document:u,reason:L.TextDocumentSaveReason.to(F)});m.push(i)}}finally{clearTimeout(w)}return m}h([k,F,S],l){const w=this.b.get(k);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(S,k,F,l).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const s=this.b.get(k);this.b.set(k,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,F,S,l){const w=[],m=Date.now(),{document:s,reason:u}=l,{version:i}=s,r=Object.freeze({document:s,reason:u,waitUntil(n){if(Object.isFrozen(w))throw(0,P.$8)("waitUntil can not be called async");w.push(Promise.resolve(n))}});try{F.apply(S,[r])}catch(n){return Promise.reject(n)}return Object.freeze(w),new Promise((n,a)=>{const h=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(w).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(h),n(t)}).catch(t=>{clearTimeout(h),a(t)})}).then(n=>{const a={edits:[]};for(const h of n)if(Array.isArray(h)&&h.every(t=>t instanceof C.$0L))for(const{newText:t,newEol:$,range:c}of h)a.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:c&&L.Range.from(c),text:t,eol:$&&L.EndOfLine.from($)}});if(a.edits.length!==0)return i===s.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$1ic=g}),define(Me[255],Ae([1,0,5,6,2,3,109,8,16,26,7]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class S{constructor(w,m){this.a=new D.$5d,this.b=new D.$5d,this.c=new D.$5d,this.d=new D.$5d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.$Sc,this.h=new Map,this.f=w.getProxy(L.$1L.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const u of s)this.b.fire(u.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const u of s)this.a.fire(u.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const m=this.g.getDocument(w);if(m)return m}getDocument(w){const m=this.getDocumentData(w);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return m.document}ensureDocumentData(w){const m=this.g.getDocument(w);if(m)return Promise.resolve(m);let s=this.h.get(w.toString());return s||(s=this.f.$tryOpenDocument(w).then(u=>{this.h.delete(w.toString());const i=C.URI.revive(u);return(0,f.$4f)(this.g.getDocument(i))},u=>(this.h.delete(w.toString()),Promise.reject(u))),this.h.set(w.toString(),s)),s}createDocumentData(w){return this.f.$tryCreateDocument(w).then(m=>C.URI.revive(m))}$acceptModelLanguageChanged(w,m){const s=C.URI.revive(w),u=this.g.getDocument(s);if(!u)throw new Error("unknown document");this.b.fire(u.document),u._acceptLanguageId(m),this.a.fire(u.document)}$acceptModelSaved(w){const m=C.URI.revive(w),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(w,m){const s=C.URI.revive(w),u=this.g.getDocument(s);if(!u)throw new Error("unknown document");u._acceptIsDirty(m),this.c.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,m,s){const u=C.URI.revive(w),i=this.g.getDocument(u);if(!i)throw new Error("unknown document");i._acceptIsDirty(s),i.onEvents(m);let r;m.isUndoing?r=F.TextDocumentChangeReason.Undo:m.isRedoing&&(r=F.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Jn)({document:i.document,contentChanges:m.changes.map(n=>({range:g.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:r}))}setWordDefinitionFor(w,m){(0,M.$hO)(w,m)}}e.$Uhc=S}),define(Me[65],Ae([1,0,256,5,16,2,4,3,17,8,7]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=e.$nic=void 0,e.$nic=(0,M.$ei)("IExtHostEditorTabs");class S{constructor(u,i,r){this.e=r,this.d=i,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,i={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new F.$KN(L.URI.revive(this.b.input.uri));case 2:return new F.$LN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new F.$MN(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new F.$NN(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new F.$ON(this.b.input.viewType);case 4:return new F.$PN(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new F.$QN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new F.$RN;case 9:return new F.$SN(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new F.$TN(this.b.input.providerId);default:return}}}class l{constructor(u,i){this.c=[],this.d="",this.b=u,this.e=i;for(const r of u.tabs)r.isActive&&(this.d=r.id),this.c.push(new S(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,i={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return k.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(r=>r.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(r=>r.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const r=new S(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,r),u.tabDto.isActive&&(this.d=r.tabId),r}else if(u.kind===1){const r=this.c.splice(u.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(u.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,r),r}const i=this.c.find(r=>r.tabId===u.tabDto.id);if(!i)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(u.tabDto),i}activeTabId(){return this.d}}let w=class{constructor(u){this.b=new P.$5d,this.c=new P.$5d,this.e=[],this.a=u.getProxy(g.$1L.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,i={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(r=>r.apiObject))},get activeTabGroup(){const r=u.d;return(0,C.$4f)(u.e.find(a=>a.groupId===r)?.apiObject)},close:async(r,n)=>{const a=Array.isArray(r)?r:[r];return a.length?m(a[0])?this.j(a,n):this.i(a,n):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(u){const i=new Set(this.e.map(c=>c.groupId)),r=new Set(u.map(c=>c.groupId)),n=(0,D.$F)(i,r),a=this.e.filter(c=>n.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=u.map(c=>{const o=new l(c,()=>this.d);return n.added.includes(o.groupId)?h.push(o.apiObject):t.push(o.apiObject),o});const $=(0,C.$4f)(u.find(c=>c.isActive===!0)?.groupId);$!==void 0&&this.d!==$&&(this.d=$),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(u){const i=this.e.find(r=>r.groupId===u.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const i=this.e.find(n=>n.groupId===u.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const r=i.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(u){for(const i of this.e)for(const r of i.tabs)if(r.apiObject===u)return r}h(u){return this.e.find(i=>i.apiObject===u)}async i(u,i){const r=[];for(const n of u){const a=this.g(n);if(!a)throw new Error("Tab close: Invalid tab not found!");r.push(a.tabId)}return this.a.$closeTab(r,i)}async j(u,i){const r=[];for(const n of u){const a=this.h(n);if(!a)throw new Error("Group close: Invalid group not found!");r.push(a.groupId)}return this.a.$closeGroup(r,i)}};e.$oic=w,e.$oic=w=Xe([He(0,f.$fO)],w);function m(s){return s.tabs!==void 0}}),define(Me[257],Ae([1,0,2,3,6,7,8,299,13,24,23,52]),function(x,e,D,P,C,L,M,g,f,k,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const u=this.a.indexOf(s);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),u=[];let i,r,n=14,a=14;for(const h of s){let t=i?(0,f.$lf)(i,h):0;for(t===0?r=1:r=a;t<h.length;t++)t+1===h.length?(n=a,a=9):a+=1,u.push([r,h.toUpperCase().charCodeAt(t),a]),u.push([r,h.toLowerCase().charCodeAt(t),a]),r=a;i=h,a=n}u.push([9,58,10]),u.push([10,47,12]),this.b=new g.$01(u)}}provideDocumentLinks(s){this.c();const u=[],i=g.$$1.computeLinks({getLineContent(r){return s.lineAt(r-1).text},getLineCount(){return s.lineCount}},this.b);for(const r of i){const n=M.DocumentLink.to(r);n.target&&u.push(n)}return u}}class w{constructor(s,u){this.i=u,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(P.$1L.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,u,i,r={}){if(w.j(i),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(u),this.d.add(u),this.c.set(n,i);let a=2;r.isCaseSensitive&&(a+=1024),r.isReadonly&&(a+=2048),typeof i.copy=="function"&&(a+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,F.$WF)(s,"fsChunks"),a+=4);let h;r.isReadonly&&(0,S.$uk)(r.isReadonly)&&r.isReadonly.value!==""&&(h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(n,u,a,h).catch($=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${u}`),console.error($)});const t=i.onDidChangeFile($=>{const c=[];for(const o of $){const{uri:b,type:p}=o;if(b.scheme!==u)continue;let d;switch(p){case L.FileChangeType.Changed:d=0;break;case L.FileChangeType.Created:d=1;break;case L.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:b,type:d})}this.a.$onFileSystemChange(n,c)});return(0,C.$Rc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:u,ctime:i,mtime:r,size:n,permissions:a}=s;return{type:u,ctime:i,mtime:r,size:n,permissions:a}}$stat(s,u){return Promise.resolve(this.l(s).stat(D.URI.revive(u))).then(i=>w.k(i))}$readdir(s,u){return Promise.resolve(this.l(s).readDirectory(D.URI.revive(u)))}$readFile(s,u){return Promise.resolve(this.l(s).readFile(D.URI.revive(u))).then(i=>k.$se.wrap(i))}$writeFile(s,u,i,r){return Promise.resolve(this.l(s).writeFile(D.URI.revive(u),i.buffer,r))}$delete(s,u,i){return Promise.resolve(this.l(s).delete(D.URI.revive(u),i))}$rename(s,u,i,r){return Promise.resolve(this.l(s).rename(D.URI.revive(u),D.URI.revive(i),r))}$copy(s,u,i,r){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(u),D.URI.revive(i),r))}$mkdir(s,u){return Promise.resolve(this.l(s).createDirectory(D.URI.revive(u)))}$watch(s,u,i,r){const n=this.l(s).watch(D.URI.revive(i),r);this.f.set(u,n)}$unwatch(s,u){const i=this.f.get(u);i&&(i.dispose(),this.f.delete(u))}$open(s,u,i){const r=this.l(s);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(D.URI.revive(u),i))}$close(s,u){const i=this.l(s);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(u))}$read(s,u,i,r){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const a=k.$se.alloc(r);return Promise.resolve(n.read(u,i,a.buffer,0,r)).then(h=>a.slice(0,h))}$write(s,u,i,r){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(u,i,r.buffer,0,r.byteLength))}l(s){const u=this.c.get(s);if(!u){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return u}}e.$3ic=w}),define(Me[258],Ae([1,0,5,33,2,3,8,7,40]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,m,s,u,i,r){this.a=Math.random(),this.b=new D.$5d,this.c=new D.$5d,this.d=new D.$5d,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const n=(0,P.$Xj)(i),a=typeof i=="string",h=r?.correlate,t=u($=>{if(!(typeof $.session=="number"&&$.session!==this.a)&&!(h&&typeof $.session>"u")){if(!r?.ignoreCreateEvents)for(const c of $.created){const o=C.URI.revive(c);n(o.fsPath)&&(!a||m.getWorkspaceFolder(o))&&this.b.fire(o)}if(!r?.ignoreChangeEvents)for(const c of $.changed){const o=C.URI.revive(c);n(o.fsPath)&&(!a||m.getWorkspaceFolder(o))&&this.c.fire(o)}if(!r?.ignoreDeleteEvents)for(const c of $.deleted){const o=C.URI.revive(c);n(o.fsPath)&&(!a||m.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=g.$3L.from(this.i(w,s,i,r,r?.correlate),this.b,this.c,this.d,t)}i(w,m,s,u,i){const r=g.$3L.from();if(typeof s=="string")return r;const n=w.getProxy(L.$1L.MainThreadFileSystemEventService);let a=!1;return(s.pattern.includes(P.$Tj)||s.pattern.includes(P.$Uj))&&(a=!0),n.$watch(m.identifier.value,this.a,s.baseUri,{recursive:a,excludes:u?.excludes??[]},!!i),g.$3L.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class F{constructor(w){this.a=w,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(C.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(w,m,s){this.j=w,this.k=m,this.l=s,this.a=new D.$5d,this.b=new D.$5d,this.c=new D.$5d,this.d=new D.$5d,this.g=new D.$7d,this.h=new D.$7d,this.i=new D.$7d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,m,s,u){return new k(this.j,w,m,this.a.event,M.GlobPattern.from(s),u)}$onFileEvent(w){this.a.fire(new F(w))}$onDidRunFileOperation(w,m){switch(w){case 2:this.b.fire(Object.freeze({files:m.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(s=>C.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(s=>C.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,m){return(s,u,i)=>{const r=function(a){s.call(u,a)};return r.extension=w,m.event(r,void 0,i)}}async $onWillRunFileOperation(w,m,s,u){switch(w){case 2:return await this.n(this.g,{files:m.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))},s,u);case 1:return await this.n(this.i,{files:m.map(i=>C.URI.revive(i.target))},s,u);case 0:case 3:return await this.n(this.h,{files:m.map(i=>C.URI.revive(i.target))},s,u)}}async n(w,m,s,u){const i=new Set,r=[];if(await w.fireAsync(m,u,async(a,h)=>{const t=Date.now(),$=await Promise.resolve(a);$ instanceof g.$aM&&(r.push([h.extension,$]),i.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),u.isCancellationRequested||r.length===0)return;const n={edits:[]};for(const[,a]of r){const{edits:h}=M.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(h)}return{edit:n,extensionNames:Array.from(i)}}}e.$4ic=S}),define(Me[259],Ae([1,0,18,11,22,15,88,6,26,64,13,16,2,29,300,86,95,162,20,8,7,23,74,3]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class c{constructor(j,z){this.d=j,this.e=z}async provideDocumentSymbols(j,z){const q=this.d.getDocument(j),W=await this.e.provideDocumentSymbols(q,z);if(!(0,D.$Kb)(W))return W[0]instanceof a.$jM?W.map(n.DocumentSymbol.from):c.f(W)}static f(j){j=j.slice(0).sort((W,ie)=>{let ue=W.location.range.start.compareTo(ie.location.range.start);return ue===0&&(ue=ie.location.range.end.compareTo(W.location.range.end)),ue});const z=[],q=[];for(const W of j){const ie={name:W.name||"!!MISSING: name!!",kind:n.SymbolKind.from(W.kind),tags:W.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:n.Range.from(W.location.range),selectionRange:n.Range.from(W.location.range),children:[]};for(;;){if(q.length===0){q.push(ie),z.push(ie);break}const ue=q[q.length-1];if(w.$7s.containsRange(ue.range,ie.range)&&!w.$7s.equalsRange(ue.range,ie.range)){ue.children?.push(ie),q.push(ie);break}q.pop()}}return z}}class o{constructor(j,z,q,W,ie,ue){this.f=j,this.g=z,this.h=q,this.j=W,this.k=ie,this.l=ue,this.d=new t.$Lhc("CodeLens"),this.e=new Map}async provideCodeLenses(j,z){const q=this.f.getDocument(j),W=await this.h.provideCodeLenses(q,z);if(!W||z.isCancellationRequested)return;const ie=this.d.add(W),ue=new g.$Sc;this.e.set(ie,ue);const Le={cacheId:ie,lenses:[]};for(let Be=0;Be<W.length;Be++)Le.lenses.push({cacheId:[ie,Be],range:n.Range.from(W[Be].range),command:this.g.toInternal(W[Be].command,ue)});return Le}async resolveCodeLens(j,z){const q=j.cacheId&&this.d.get(...j.cacheId);if(!q)return;let W;if(typeof this.h.resolveCodeLens!="function"||q.isResolved?W=q:W=await this.h.resolveCodeLens(q,z),W||(W=q),z.isCancellationRequested)return;const ie=j.cacheId&&this.e.get(j.cacheId[0]);if(ie){if(!W.command){const ue=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ue),this.l.error(ue);return}return j.command=this.g.toInternal(W.command,ie),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function b(We){return Array.isArray(We)?We.map(n.DefinitionLink.from):We?[n.DefinitionLink.from(We)]:[]}class p{constructor(j,z){this.d=j,this.e=z}async provideDefinition(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideDefinition(W,ie,q);return b(ue)}}class d{constructor(j,z){this.d=j,this.e=z}async provideDeclaration(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideDeclaration(W,ie,q);return b(ue)}}class I{constructor(j,z){this.d=j,this.e=z}async provideImplementation(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideImplementation(W,ie,q);return b(ue)}}class v{constructor(j,z){this.d=j,this.e=z}async provideTypeDefinition(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideTypeDefinition(W,ie,q);return b(ue)}}class y{constructor(j,z){this.d=j,this.e=z}async provideHover(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideHover(W,ie,q);if(!(!ue||(0,D.$Kb)(ue.contents)))return ue.range||(ue.range=W.getWordRangeAtPosition(ie)),ue.range||(ue.range=new a.$5L(ie,ie)),n.Hover.from(ue)}}class E{constructor(j,z){this.d=j,this.e=z}async provideEvaluatableExpression(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideEvaluatableExpression(W,ie,q);if(ue)return n.EvaluatableExpression.from(ue)}}class A{constructor(j,z){this.d=j,this.e=z}async provideInlineValues(j,z,q,W){const ie=this.d.getDocument(j),ue=await this.e.provideInlineValues(ie,n.Range.to(z),n.InlineValueContext.to(q),W);if(Array.isArray(ue))return ue.map(Le=>n.InlineValue.from(Le))}}class V{constructor(j,z){this.d=j,this.e=z}async provideDocumentHighlights(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideDocumentHighlights(W,ie,q);if(Array.isArray(ue))return ue.map(n.DocumentHighlight.from)}}class X{constructor(j,z){this.d=j,this.e=z}async provideMultiDocumentHighlights(j,z,q,W){const ie=this.d.getDocument(j),ue=q.map(Ke=>this.d.getDocument(Ke)),Le=n.Position.to(z),Be=await this.e.provideMultiDocumentHighlights(ie,Le,ue,W);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class H{constructor(j,z){this.d=j,this.e=z}async provideLinkedEditingRanges(j,z,q){const W=this.d.getDocument(j),ie=n.Position.to(z),ue=await this.e.provideLinkedEditingRanges(W,ie,q);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,D.$Hb)(ue.ranges.map(n.Range.from)),wordPattern:ue.wordPattern}}}class O{constructor(j,z){this.d=j,this.e=z}async provideReferences(j,z,q,W){const ie=this.d.getDocument(j),ue=n.Position.to(z),Le=await this.e.provideReferences(ie,ue,q,W);if(Array.isArray(Le))return Le.map(n.location.from)}}class R{constructor(j,z,q,W,ie,ue,Le){this.g=j,this.h=z,this.j=q,this.k=W,this.l=ie,this.m=ue,this.n=Le,this.e=new t.$Lhc("CodeAction"),this.f=new Map}async provideCodeActions(j,z,q,W){const ie=this.g.getDocument(j),ue=m.$9s.isISelection(z)?n.Selection.to(z):n.Range.to(z),Le=[];for(const at of this.j.getDiagnostics(j))if(ue.intersection(at.range)&&Le.push(at)>R.d)break;const Be={diagnostics:Le,only:q.only?new a.$lM(q.only):void 0,triggerKind:n.CodeActionTriggerKind.to(q.trigger)},Ke=await this.k.provideCodeActions(ie,ue,Be,W);if(!(0,D.$Lb)(Ke)||W.isCancellationRequested)return;const et=this.e.add(Ke),rt=new g.$Sc;this.f.set(et,rt);const ft=[];for(let at=0;at<Ke.length;at++){const nt=Ke[at];if(nt)if(R.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ft.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,rt)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];ft.push({cacheId:[et,at],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,rt),diagnostics:nt.diagnostics&&nt.diagnostics.map(n.Diagnostic.from),edit:nt.edit&&n.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$VF)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$VF)(this.m,"codeActionRanges")?(0,D.$Hb)(ct.map(n.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:et,actions:ft}}async resolveCodeAction(j,z){const[q,W]=j,ie=this.e.get(q,W);if(!ie||R.o(ie))return{};if(!this.k.resolveCodeAction)return{};const ue=await this.k.resolveCodeAction(ie,z)??ie;let Le;ue.edit&&(Le=n.WorkspaceEdit.from(ue.edit,void 0));let Be;if(ue.command){const Ke=this.f.get(q);Ke&&(Be=this.h.toInternal(ue.command,Ke))}return{edit:Le,command:Be}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}R.d=1e3;class B{static toInternalProviderId(j,z){return j+"."+z}constructor(j,z,q,W,ie){this.d=j,this.e=z,this.f=q,this.g=W,this.h=ie}async prepareDocumentPaste(j,z,q,W){if(!this.f.prepareDocumentPaste)return;const ie=this.e.getDocument(j),ue=z.map(Ke=>n.Range.to(Ke)),Le=n.DataTransfer.toDataTransfer(q,()=>{throw new L.$$});if(await this.f.prepareDocumentPaste(ie,ue,Le,W),W.isCancellationRequested)return;const Be=Array.from(Le).filter(([,Ke])=>!(Ke instanceof a.$RM));return n.DataTransfer.from(Be)}async providePasteEdits(j,z,q,W,ie){if(!this.f.provideDocumentPasteEdits)return;const ue=this.e.getDocument(z),Le=q.map(et=>n.Range.to(et)),Be=n.DataTransfer.toDataTransfer(W,async et=>(await this.d.$resolvePasteFileData(this.g,j,et)).buffer),Ke=await this.f.provideDocumentPasteEdits(ue,Le,Be,ie);if(Ke)return{label:Ke.label??(0,i.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ke.yieldTo?.map(et=>"mimeType"in et?et:{providerId:B.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?n.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class T{constructor(j,z){this.d=j,this.e=z}async provideDocumentFormattingEdits(j,z,q){const W=this.d.getDocument(j),ie=await this.e.provideDocumentFormattingEdits(W,z,q);if(Array.isArray(ie))return ie.map(n.TextEdit.from)}}class te{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeFormattingEdits(j,z,q,W){const ie=this.d.getDocument(j),ue=n.Range.to(z),Le=await this.e.provideDocumentRangeFormattingEdits(ie,ue,q,W);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,z,q,W){(0,S.$3f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ie=this.d.getDocument(j),ue=z.map(n.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(ie,ue,q,W);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}}class Q{constructor(j,z){this.d=j,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,z,q,W,ie){const ue=this.d.getDocument(j),Le=n.Position.to(z),Be=await this.e.provideOnTypeFormattingEdits(ue,Le,q,W,ie);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ce{constructor(j,z){this.e=j,this.f=z,this.d=new t.$Lhc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,z){const q=await this.e.provideWorkspaceSymbols(j,z);if(!(0,D.$Lb)(q))return{symbols:[]};const W=this.d.add(q),ie={cacheId:W,symbols:[]};for(let ue=0;ue<q.length;ue++){const Le=q[ue];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}ie.symbols.push({...n.WorkspaceSymbol.from(Le),cacheId:[W,ue]})}return ie}async resolveWorkspaceSymbol(j,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const q=this.d.get(...j.cacheId);if(q){const W=await this.e.resolveWorkspaceSymbol(q,z);return W&&(0,f.$Ln)(j,n.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class le{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,z,q){this.d=j,this.e=z,this.f=q}async provideRenameEdits(j,z,q,W){const ie=this.d.getDocument(j),ue=n.Position.to(z);try{const Le=await this.e.provideRenameEdits(ie,ue,q,W);return Le?n.WorkspaceEdit.from(Le):void 0}catch(Le){const Be=le.g(Le);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(j,z,q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const W=this.d.getDocument(j),ie=n.Position.to(z);try{const ue=await this.e.prepareRename(W,ie,q);let Le,Be;if(a.$5L.isRange(ue)?(Le=ue,Be=W.getText(ue)):(0,S.$Uf)(ue)&&(Le=ue.range,Be=ue.placeholder),!Le||!Be)return;if(Le.start.line>ie.line||Le.end.line<ie.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Le),text:Be}}catch(ue){const Le=le.g(ue);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(ue)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class se{constructor(j,z,q){this.d=j,this.e=z,this.f=q}async provideNewSymbolNames(j,z,q){const W=this.d.getDocument(j),ie=n.Range.to(z);try{const ue=await this.e.provideNewSymbolNames(W,ie,q);return ue?ue.map(Le=>typeof Le=="string"?{newSymbolName:Le}:{newSymbolName:Le.newSymbolName,tags:Le.tags}):void 0}catch(ue){this.f.error(se.g(ue)??JSON.stringify(ue,null,"	"));return}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class $e{constructor(j,z){this.resultId=j,this.tokens=z}}class ne{constructor(j,z){this.f=j,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,z,q){const W=this.f.getDocument(j),ie=z!==0?this.d.get(z):null;let ue=typeof ie?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(W,ie.resultId,q):await this.g.provideDocumentSemanticTokens(W,q);return ie&&this.d.delete(z),ue?(ue=ne.h(ue),this.o(ne.n(ie,ue),ue)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return ne.j(j)?ne.k(j)?j:new a.$jN(new Uint32Array(j.data),j.resultId):ne.l(j)?ne.m(j)?j:new a.$lN(j.edits.map(z=>new a.$kN(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const z of j.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(j,z){if(!ne.j(z)||!j||!j.tokens)return z;const q=j.tokens,W=q.length,ie=z.data,ue=ie.length;let Le=0;const Be=Math.min(W,ue);for(;Le<Be&&q[Le]===ie[Le];)Le++;if(Le===W&&Le===ue)return new a.$lN([],z.resultId);let Ke=0;const et=Be-Le;for(;Ke<et&&q[W-Ke-1]===ie[ue-Ke-1];)Ke++;return new a.$lN([{start:Le,deleteCount:W-Le-Ke,data:ie.subarray(Le,ue-Ke)}],z.resultId)}o(j,z){if(ne.j(j)){const q=this.e++;return this.d.set(q,new $e(j.resultId,j.data)),(0,u.$bab)({id:q,type:"full",data:j.data})}if(ne.l(j)){const q=this.e++;return ne.j(z)?this.d.set(q,new $e(z.resultId,z.data)):this.d.set(q,new $e(j.resultId)),(0,u.$bab)({id:q,type:"delta",deltas:(j.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}class ke{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeSemanticTokens(j,z,q){const W=this.d.getDocument(j),ie=await this.e.provideDocumentRangeSemanticTokens(W,n.Range.to(z),q);return ie?this.f(ie):null}f(j){return(0,u.$bab)({id:0,type:"full",data:j.data})}}class oe{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,z,q,W,ie){this.f=j,this.g=z,this.h=q,this.j=W,this.k=ie,this.d=new t.$Lhc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,z,q,W){const ie=this.f.getDocument(j),ue=n.Position.to(z),Le=ie.getWordRangeAtPosition(ue)||new a.$5L(ue,ue),Be=Le.with({end:ue}),Ke=new k.$1d,et=await this.h.provideCompletionItems(ie,ue,W,n.CompletionContext.to(q));if(!et||W.isCancellationRequested)return;const rt=Array.isArray(et)?new a.$yM(et):et,ft=oe.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),at=new g.$Sc;this.e.set(ft,at);const nt=[],ct={x:ft,b:nt,a:{replace:n.Range.from(Le),insert:n.Range.from(Be)},c:rt.isIncomplete||void 0,d:Ke.elapsed()};for(let Ve=0;Ve<rt.items.length;Ve++){const it=rt.items[Ve],_=this.l(it,[ft,Ve],Be,Le);nt.push(_)}return ct}async resolveCompletionItem(j,z){if(typeof this.h.resolveCompletionItem!="function")return;const q=this.d.get(...j);if(!q)return;const W=this.l(q,j),ie=await this.h.resolveCompletionItem(q,z);if(!ie)return;const ue=this.l(ie,j);return(W.h!==ue.h||W.i!==ue.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(W.n!==ue.n||W.o!==ue.o||!(0,f.$Mn)(W.p,ue.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...W,d:ue.d,c:ue.c,l:ue.l,h:ue.h,i:ue.i,n:ue.n,o:ue.o,p:ue.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z,q,W){const ie=this.e.get(z[0]);if(!ie)throw Error("DisposableStore is missing...");const ue=this.g.toInternal(j.command,ie),Le={x:z,a:j.label,b:j.kind!==void 0?n.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(n.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:n.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(n.TextEdit.from),n:ue?.$ident,o:ue?.id,p:ue?.$ident?void 0:ue?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=j.textEdit.newText):typeof j.insertText=="string"?Le.h=j.insertText:j.insertText instanceof a.$bM&&(Le.h=j.insertText.value,Le.i|=4);let Be;return j.textEdit?Be=j.textEdit.range:j.range&&(Be=j.range),a.$5L.isRange(Be)?Le.j=n.Range.from(Be):Be&&(!q?.isEqual(Be.inserting)||!W?.isEqual(Be.replacing))&&(Le.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Le}}class ve{async provideInlineCompletions(j,z,q,W){}disposeCompletions(j){}handleDidShowCompletionItem(j,z,q){}handlePartialAccept(j,z,q){}}class G extends ve{constructor(j,z,q,W){super(),this.f=j,this.g=z,this.h=q,this.j=W,this.d=new ae,this.e=(0,h.$VF)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$VF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,z,q,W){const ie=this.g.getDocument(j),ue=n.Position.to(z),Le=await this.h.provideInlineCompletionItems(ie,ue,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:n.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[q.triggerKind]},W);if(!Le||W.isCancellationRequested)return;const Be=Array.isArray(Le)?Le:Le.items,Ke=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],et=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Be}),items:Be.map((at,nt)=>{let ct;at.command&&(rt||(rt=new g.$Sc),ct=this.j.toInternal(at.command,rt));const Ve=at.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:at.filterText,range:at.range?n.Range.from(at.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ke.map(at=>(rt||(rt=new g.$Sc),this.j.toInternal(at,rt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,z,q){const W=this.d.get(j)?.items[z];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W,q)}handlePartialAccept(j,z,q){const W=this.d.get(j)?.items[z];W&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(W,q)}}class ge{async provideInlineEdits(j,z,q){const W=this.f.getDocument(j),ie=await this.g.provideInlineEdit(W,{triggerKind:this.e[z.triggerKind]},q);if(!ie||q.isCancellationRequested)return;let ue;const Le=this.d.createReferenceId({dispose(){ue?.dispose()},item:ie});let Be;ie.accepted&&(ue||(ue=new g.$Sc),Be=this.h.toInternal(ie.accepted,ue));let Ke;return ie.rejected&&(ue||(ue=new g.$Sc),Ke=this.h.toInternal(ie.rejected,ue)),{pid:Le,text:ie.text,range:n.Range.from(ie.range),accepted:Be,rejected:Ke}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,z,q,W){this.f=z,this.g=q,this.h=W,this.d=new ae,this.e={[s.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class ae{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const z=this.e++;return this.d.set(z,j),z}disposeReferenceId(j){const z=this.d.get(j);return this.d.delete(j),z}get(j){return this.d.get(j)}}class De{constructor(j,z){this.e=j,this.f=z,this.d=new t.$Lhc("SignatureHelp")}async provideSignatureHelp(j,z,q,W){const ie=this.e.getDocument(j),ue=n.Position.to(z),Le=this.g(q),Be=await this.f.provideSignatureHelp(ie,ue,W,Le);if(Be){const Ke=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:Ke}}}g(j){let z;if(j.activeSignatureHelp){const q=n.SignatureHelp.to(j.activeSignatureHelp),W=this.d.get(j.activeSignatureHelp.id,0);W?(z=W,z.activeSignature=q.activeSignature,z.activeParameter=q.activeParameter):z=q}return{...j,activeSignatureHelp:z}}releaseSignatureHelp(j){this.d.delete(j)}}class ye{constructor(j,z,q,W,ie){this.f=j,this.g=z,this.h=q,this.j=W,this.k=ie,this.d=new t.$Lhc("InlayHints"),this.e=new Map}async provideInlayHints(j,z,q){const W=this.f.getDocument(j),ie=n.Range.to(z),ue=await this.h.provideInlayHints(W,ie,q);if(!Array.isArray(ue)||ue.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(q.isCancellationRequested)return;const Le=this.d.add(ue);this.e.set(Le,new g.$Sc);const Be={hints:[],cacheId:Le};for(let Ke=0;Ke<ue.length;Ke++)this.l(ue[Ke],ie)&&Be.hints.push(this.m(ue[Ke],[Le,Ke]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Be}async resolveInlayHint(j,z){if(typeof this.h.resolveInlayHint!="function")return;const q=this.d.get(...j);if(!q)return;const W=await this.h.resolveInlayHint(q,z);if(W&&this.l(W))return this.m(W,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z){return j.label.length===0||Array.isArray(j.label)&&j.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(z&&!z.contains(j.position))}m(j,z){const q=this.e.get(z[0]);if(!q)throw Error("DisposableStore is missing...");const W={label:"",cacheId:z,tooltip:n.MarkdownString.fromStrict(j.tooltip),position:n.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(n.TextEdit.from),kind:j.kind&&n.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")W.label=j.label;else{const ie=[];W.label=ie;for(const ue of j.label){if(!ue.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:ue.value,tooltip:n.MarkdownString.fromStrict(ue.tooltip)};a.$cM.isLocation(ue.location)&&(Le.location=n.location.from(ue.location)),ue.command&&(Le.command=this.g.toInternal(ue.command,q)),ie.push(Le)}}return W}}class we{constructor(j,z){this.e=j,this.f=z,this.d=new t.$Lhc("DocumentLink")}async provideLinks(j,z){const q=this.e.getDocument(j),W=await this.f.provideDocumentLinks(q,z);if(!(!Array.isArray(W)||W.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:W.filter(we.g).map(n.DocumentLink.from)};{const ie=this.d.add(W),ue={links:[],cacheId:ie};for(let Le=0;Le<W.length;Le++){if(!we.g(W[Le]))continue;const Be=n.DocumentLink.from(W[Le]);Be.cacheId=[ie,Le],ue.links.push(Be)}return ue}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,z){if(typeof this.f.resolveDocumentLink!="function")return;const q=this.d.get(...j);if(!q)return;const W=await this.f.resolveDocumentLink(q,z);if(!(!W||!we.g(W)))return n.DocumentLink.from(W)}releaseLinks(j){this.d.delete(j)}}class he{constructor(j,z){this.d=j,this.e=z}async provideColors(j,z){const q=this.d.getDocument(j),W=await this.e.provideDocumentColors(q,z);return Array.isArray(W)?W.map(ue=>({color:n.Color.from(ue.color),range:n.Range.from(ue.range)})):[]}async provideColorPresentations(j,z,q){const W=this.d.getDocument(j),ie=n.Range.to(z.range),ue=n.Color.to(z.color),Le=await this.e.provideColorPresentations(ue,{document:W,range:ie},q);if(Array.isArray(Le))return Le.map(n.ColorPresentation.from)}}class K{constructor(j,z){this.d=j,this.e=z}async provideFoldingRanges(j,z,q){const W=this.d.getDocument(j),ie=await this.e.provideFoldingRanges(W,z,q);if(Array.isArray(ie))return ie.map(n.FoldingRange.from)}}class Y{constructor(j,z,q){this.d=j,this.e=z,this.f=q}async provideSelectionRanges(j,z,q){const W=this.d.getDocument(j),ie=z.map(n.Position.to),ue=await this.e.provideSelectionRanges(W,ie,q);if(!(0,D.$Lb)(ue))return[];if(ue.length!==ie.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let Be=0;Be<ie.length;Be++){const Ke=[];Le.push(Ke);let et=ie[Be],rt=ue[Be];for(;;){if(!rt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(rt)),!rt.parent)break;et=rt.range,rt=rt.parent}}return Le}}class me{constructor(j,z){this.f=j,this.g=z,this.d=new M.$kO(""),this.e=new Map}async prepareSession(j,z,q){const W=this.f.getDocument(j),ie=n.Position.to(z),ue=await this.g.prepareCallHierarchy(W,ie,q);if(!ue)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ue)?ue.map(Be=>this.h(Le,Be)):[this.h(Le,ue)]}async provideCallsTo(j,z,q){const W=this.j(j,z);if(!W)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyIncomingCalls(W,q);if(ie)return ie.map(ue=>({from:this.h(j,ue.from),fromRanges:ue.fromRanges.map(Le=>n.Range.from(Le))}))}async provideCallsFrom(j,z,q){const W=this.j(j,z);if(!W)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyOutgoingCalls(W,q);if(ie)return ie.map(ue=>({to:this.h(j,ue.to),fromRanges:ue.fromRanges.map(Le=>n.Range.from(Le))}))}releaseSession(j){this.e.delete(j)}h(j,z){const q=this.e.get(j),W=n.CallHierarchyItem.from(z,j,q.size.toString(36));return q.set(W._itemId,z),W}j(j,z){return this.e.get(j)?.get(z)}}class pe{constructor(j,z){this.f=j,this.g=z,this.d=new M.$kO(""),this.e=new Map}async prepareSession(j,z,q){const W=this.f.getDocument(j),ie=n.Position.to(z),ue=await this.g.prepareTypeHierarchy(W,ie,q);if(!ue)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ue)?ue.map(Be=>this.h(Le,Be)):[this.h(Le,ue)]}async provideSupertypes(j,z,q){const W=this.j(j,z);if(!W)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySupertypes(W,q);if(ie)return ie.map(ue=>this.h(j,ue))}async provideSubtypes(j,z,q){const W=this.j(j,z);if(!W)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySubtypes(W,q);if(ie)return ie.map(ue=>this.h(j,ue))}releaseSession(j){this.e.delete(j)}h(j,z){const q=this.e.get(j),W=n.TypeHierarchyItem.from(z,j,q.size.toString(36));return q.set(W._itemId,z),W}j(j,z){return this.e.get(j)?.get(z)}}class Fe{static toInternalProviderId(j,z){return j+"."+z}constructor(j,z,q,W,ie){this.d=j,this.e=z,this.f=q,this.g=W,this.h=ie}async provideDocumentOnDropEdits(j,z,q,W,ie){const ue=this.e.getDocument(z),Le=n.Position.to(q),Be=n.DataTransfer.toDataTransfer(W,async et=>(await this.d.$resolveDocumentOnDropFileData(this.g,j,et)).buffer),Ke=await this.f.provideDocumentDropEdits(ue,Le,Be,ie);if(Ke)return{label:Ke.label??(0,i.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ke.yieldTo?.map(et=>"mimeType"in et?et:{providerId:Fe.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?n.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class be{constructor(j,z){this.d=j,this.e=z}async provideMappedEdits(j,z,q,W){const ie=l.URI.revive(j),ue=this.d.getDocument(ie),Le=q.documents.map(et=>et.map(rt=>({uri:l.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ft=>n.Range.to(ft))}))),Be={documents:Le,selections:Le[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(ue,z,Be,W);return Ke?n.WorkspaceEdit.from(Ke):null}}class Re{constructor(j,z){this.adapter=j,this.extension=z}}class Pe{constructor(j,z,q,W,ie,ue,Le,Be){this.g=z,this.h=q,this.j=W,this.k=ie,this.l=ue,this.m=Le,this.n=Be,this.f=new Map,this.e=j.getProxy($.$1L.MainThreadLanguageFeatures)}o(j,z){return n.DocumentSelector.from(j,this.g,z)}p(j){return new a.$3L(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Pe.d++}async s(j,z,q,W,ie,ue=!1){const Le=this.f.get(j);if(!Le||!(Le.adapter instanceof z))return W;const Be=Date.now();ue||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const Ke=q(Le.adapter,Le.extension);return Promise.resolve(Ke).catch(et=>{(0,L.$4)(et)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Le.extension.identifier,et))}).finally(()=>{ue||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),C.CancellationToken.isCancellationToken(ie)?(0,P.$6g)(Ke,ie):Ke}t(j,z){const q=this.q();return this.f.set(q,new Re(j,z)),q}static u(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,z,q,W){const ie=this.t(new c(this.h,q),j),ue=W&&W.label||Pe.u(j);return this.e.$registerDocumentSymbolProvider(ie,this.o(z,j),ue),this.p(ie)}$provideDocumentSymbols(j,z,q){return this.s(j,c,W=>W.provideDocumentSymbols(l.URI.revive(z),q),void 0,q)}registerCodeLensProvider(j,z,q){const W=this.q(),ie=typeof q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(W,new Re(new o(this.h,this.j.converter,q,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(W,this.o(z,j),ie);let ue=this.p(W);if(ie!==void 0){const Le=q.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ie));ue=a.$3L.from(ue,Le)}return ue}$provideCodeLenses(j,z,q){return this.s(j,o,W=>W.provideCodeLenses(l.URI.revive(z),q),void 0,q)}$resolveCodeLens(j,z,q){return this.s(j,o,W=>W.resolveCodeLens(z,q),void 0,void 0)}$releaseCodeLenses(j,z){this.s(j,o,q=>Promise.resolve(q.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(j,z,q){const W=this.t(new p(this.h,q),j);return this.e.$registerDefinitionSupport(W,this.o(z,j)),this.p(W)}$provideDefinition(j,z,q,W){return this.s(j,p,ie=>ie.provideDefinition(l.URI.revive(z),q,W),[],W)}registerDeclarationProvider(j,z,q){const W=this.t(new d(this.h,q),j);return this.e.$registerDeclarationSupport(W,this.o(z,j)),this.p(W)}$provideDeclaration(j,z,q,W){return this.s(j,d,ie=>ie.provideDeclaration(l.URI.revive(z),q,W),[],W)}registerImplementationProvider(j,z,q){const W=this.t(new I(this.h,q),j);return this.e.$registerImplementationSupport(W,this.o(z,j)),this.p(W)}$provideImplementation(j,z,q,W){return this.s(j,I,ie=>ie.provideImplementation(l.URI.revive(z),q,W),[],W)}registerTypeDefinitionProvider(j,z,q){const W=this.t(new v(this.h,q),j);return this.e.$registerTypeDefinitionSupport(W,this.o(z,j)),this.p(W)}$provideTypeDefinition(j,z,q,W){return this.s(j,v,ie=>ie.provideTypeDefinition(l.URI.revive(z),q,W),[],W)}registerHoverProvider(j,z,q,W){const ie=this.t(new y(this.h,q),j);return this.e.$registerHoverProvider(ie,this.o(z,j)),this.p(ie)}$provideHover(j,z,q,W){return this.s(j,y,ie=>ie.provideHover(l.URI.revive(z),q,W),void 0,W)}registerEvaluatableExpressionProvider(j,z,q,W){const ie=this.t(new E(this.h,q),j);return this.e.$registerEvaluatableExpressionProvider(ie,this.o(z,j)),this.p(ie)}$provideEvaluatableExpression(j,z,q,W){return this.s(j,E,ie=>ie.provideEvaluatableExpression(l.URI.revive(z),q,W),void 0,W)}registerInlineValuesProvider(j,z,q,W){const ie=typeof q.onDidChangeInlineValues=="function"?this.q():void 0,ue=this.t(new A(this.h,q),j);this.e.$registerInlineValuesProvider(ue,this.o(z,j),ie);let Le=this.p(ue);if(ie!==void 0){const Be=q.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ie));Le=a.$3L.from(Le,Be)}return Le}$provideInlineValues(j,z,q,W,ie){return this.s(j,A,ue=>ue.provideInlineValues(l.URI.revive(z),q,W,ie),void 0,ie)}registerDocumentHighlightProvider(j,z,q){const W=this.t(new V(this.h,q),j);return this.e.$registerDocumentHighlightProvider(W,this.o(z,j)),this.p(W)}registerMultiDocumentHighlightProvider(j,z,q){const W=this.t(new X(this.h,q),j);return this.e.$registerMultiDocumentHighlightProvider(W,this.o(z,j)),this.p(W)}$provideDocumentHighlights(j,z,q,W){return this.s(j,V,ie=>ie.provideDocumentHighlights(l.URI.revive(z),q,W),void 0,W)}$provideMultiDocumentHighlights(j,z,q,W,ie){return this.s(j,X,ue=>ue.provideMultiDocumentHighlights(l.URI.revive(z),q,W.map(Le=>l.URI.revive(Le)),ie),void 0,ie)}registerLinkedEditingRangeProvider(j,z,q){const W=this.t(new H(this.h,q),j);return this.e.$registerLinkedEditingRangeProvider(W,this.o(z,j)),this.p(W)}$provideLinkedEditingRanges(j,z,q,W){return this.s(j,H,async ie=>{const ue=await ie.provideLinkedEditingRanges(l.URI.revive(z),q,W);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?Pe.w(ue.wordPattern):void 0}},void 0,W)}registerReferenceProvider(j,z,q){const W=this.t(new O(this.h,q),j);return this.e.$registerReferenceSupport(W,this.o(z,j)),this.p(W)}$provideReferences(j,z,q,W,ie){return this.s(j,O,ue=>ue.provideReferences(l.URI.revive(z),q,W,ie),void 0,ie)}registerCodeActionProvider(j,z,q,W){const ie=new g.$Sc,ue=this.t(new R(this.h,this.j.converter,this.k,q,this.l,j,this.m),j);return this.e.$registerQuickFixSupport(ue,this.o(z,j),{providedKinds:W?.providedCodeActionKinds?.map(Le=>Le.value),documentation:W?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,ie)}))},Pe.u(j),!!q.resolveCodeAction),ie.add(this.p(ue)),ie}$provideCodeActions(j,z,q,W,ie){return this.s(j,R,ue=>ue.provideCodeActions(l.URI.revive(z),q,W,ie),void 0,ie)}$resolveCodeAction(j,z,q){return this.s(j,R,W=>W.resolveCodeAction(z,q),{},void 0)}$releaseCodeActions(j,z){this.s(j,R,q=>Promise.resolve(q.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(j,z,q){const W=this.t(new T(this.h,q),j);return this.e.$registerDocumentFormattingSupport(W,this.o(z,j),j.identifier,j.displayName||j.name),this.p(W)}$provideDocumentFormattingEdits(j,z,q,W){return this.s(j,T,ie=>ie.provideDocumentFormattingEdits(l.URI.revive(z),q,W),void 0,W)}registerDocumentRangeFormattingEditProvider(j,z,q){const W=typeof q.provideDocumentRangesFormattingEdits=="function",ie=this.t(new te(this.h,q),j);return this.e.$registerRangeFormattingSupport(ie,this.o(z,j),j.identifier,j.displayName||j.name,W),this.p(ie)}$provideDocumentRangeFormattingEdits(j,z,q,W,ie){return this.s(j,te,ue=>ue.provideDocumentRangeFormattingEdits(l.URI.revive(z),q,W,ie),void 0,ie)}$provideDocumentRangesFormattingEdits(j,z,q,W,ie){return this.s(j,te,ue=>ue.provideDocumentRangesFormattingEdits(l.URI.revive(z),q,W,ie),void 0,ie)}registerOnTypeFormattingEditProvider(j,z,q,W){const ie=this.t(new Q(this.h,q),j);return this.e.$registerOnTypeFormattingSupport(ie,this.o(z,j),W,j.identifier),this.p(ie)}$provideOnTypeFormattingEdits(j,z,q,W,ie,ue){return this.s(j,Q,Le=>Le.provideOnTypeFormattingEdits(l.URI.revive(z),q,W,ie,ue),void 0,ue)}registerWorkspaceSymbolProvider(j,z){const q=this.t(new ce(z,this.l),j);return this.e.$registerNavigateTypeSupport(q,typeof z.resolveWorkspaceSymbol=="function"),this.p(q)}$provideWorkspaceSymbols(j,z,q){return this.s(j,ce,W=>W.provideWorkspaceSymbols(z,q),{symbols:[]},q)}$resolveWorkspaceSymbol(j,z,q){return this.s(j,ce,W=>W.resolveWorkspaceSymbol(z,q),void 0,void 0)}$releaseWorkspaceSymbols(j,z){this.s(j,ce,q=>q.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(j,z,q){const W=this.t(new le(this.h,q,this.l),j);return this.e.$registerRenameSupport(W,this.o(z,j),le.supportsResolving(q)),this.p(W)}$provideRenameEdits(j,z,q,W,ie){return this.s(j,le,ue=>ue.provideRenameEdits(l.URI.revive(z),q,W,ie),void 0,ie)}$resolveRenameLocation(j,z,q,W){return this.s(j,le,ie=>ie.resolveRenameLocation(l.URI.revive(z),q,W),void 0,W)}registerNewSymbolNamesProvider(j,z,q){const W=this.t(new se(this.h,q,this.l),j);return this.e.$registerNewSymbolNamesProvider(W,this.o(z,j)),this.p(W)}$provideNewSymbolNames(j,z,q,W){return this.s(j,se,ie=>ie.provideNewSymbolNames(l.URI.revive(z),q,W),void 0,W)}registerDocumentSemanticTokensProvider(j,z,q,W){const ie=this.t(new ne(this.h,q),j),ue=typeof q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ie,this.o(z,j),W,ue);let Le=this.p(ie);if(ue){const Be=q.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(ue));Le=a.$3L.from(Le,Be)}return Le}$provideDocumentSemanticTokens(j,z,q,W){return this.s(j,ne,ie=>ie.provideDocumentSemanticTokens(l.URI.revive(z),q,W),null,W)}$releaseDocumentSemanticTokens(j,z){this.s(j,ne,q=>q.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,z,q,W){const ie=this.t(new ke(this.h,q),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ie,this.o(z,j),W),this.p(ie)}$provideDocumentRangeSemanticTokens(j,z,q,W){return this.s(j,ke,ie=>ie.provideDocumentRangeSemanticTokens(l.URI.revive(z),q,W),null,W)}registerCompletionItemProvider(j,z,q,W){const ie=this.t(new oe(this.h,this.j.converter,q,this.m,j),j);return this.e.$registerCompletionsProvider(ie,this.o(z,j),W,oe.supportsResolving(q),j.identifier),this.p(ie)}$provideCompletionItems(j,z,q,W,ie){return this.s(j,oe,ue=>ue.provideCompletionItems(l.URI.revive(z),q,W,ie),void 0,ie)}$resolveCompletionItem(j,z,q){return this.s(j,oe,W=>W.resolveCompletionItem(z,q),void 0,q)}$releaseCompletionItems(j,z){this.s(j,oe,q=>q.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(j,z,q,W){const ie=new G(j,this.h,q,this.j.converter),ue=this.t(ie,j);return this.e.$registerInlineCompletionsSupport(ue,this.o(z,j),ie.supportsHandleEvents,r.$xm.toKey(j.identifier.value),W?.yieldTo?.map(Le=>r.$xm.toKey(Le))||[]),this.p(ue)}$provideInlineCompletions(j,z,q,W,ie){return this.s(j,ve,ue=>ue.provideInlineCompletions(l.URI.revive(z),q,W,ie),void 0,ie)}$handleInlineCompletionDidShow(j,z,q,W){this.s(j,ve,async ie=>{ie.handleDidShowCompletionItem(z,q,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,z,q,W){this.s(j,ve,async ie=>{ie.handlePartialAccept(z,q,W)},void 0,void 0)}$freeInlineCompletionsList(j,z){this.s(j,ve,async q=>{q.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(j,z,q){const W=new ge(j,this.h,q,this.j.converter),ie=this.t(W,j);return this.e.$registerInlineEditProvider(ie,this.o(z,j),j.identifier),this.p(ie)}$provideInlineEdit(j,z,q,W){return this.s(j,ge,ie=>ie.provideInlineEdits(l.URI.revive(z),q,W),void 0,W)}$freeInlineEdit(j,z){this.s(j,ge,async q=>{q.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(j,z,q,W){const ie=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,ue=this.t(new De(this.h,q),j);return this.e.$registerSignatureHelpProvider(ue,this.o(z,j),ie),this.p(ue)}$provideSignatureHelp(j,z,q,W,ie){return this.s(j,De,ue=>ue.provideSignatureHelp(l.URI.revive(z),q,W,ie),void 0,ie)}$releaseSignatureHelp(j,z){this.s(j,De,q=>q.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(j,z,q){const W=typeof q.onDidChangeInlayHints=="function"?this.q():void 0,ie=this.t(new ye(this.h,this.j.converter,q,this.l,j),j);this.e.$registerInlayHintsProvider(ie,this.o(z,j),typeof q.resolveInlayHint=="function",W,Pe.u(j));let ue=this.p(ie);if(W!==void 0){const Le=q.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(W));ue=a.$3L.from(ue,Le)}return ue}$provideInlayHints(j,z,q,W){return this.s(j,ye,ie=>ie.provideInlayHints(l.URI.revive(z),q,W),void 0,W)}$resolveInlayHint(j,z,q){return this.s(j,ye,W=>W.resolveInlayHint(z,q),void 0,q)}$releaseInlayHints(j,z){this.s(j,ye,q=>q.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(j,z,q){const W=this.t(new we(this.h,q),j);return this.e.$registerDocumentLinkProvider(W,this.o(z,j),typeof q.resolveDocumentLink=="function"),this.p(W)}$provideDocumentLinks(j,z,q){return this.s(j,we,W=>W.provideLinks(l.URI.revive(z),q),void 0,q,z.scheme==="output")}$resolveDocumentLink(j,z,q){return this.s(j,we,W=>W.resolveLink(z,q),void 0,void 0,!0)}$releaseDocumentLinks(j,z){this.s(j,we,q=>q.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(j,z,q){const W=this.t(new he(this.h,q),j);return this.e.$registerDocumentColorProvider(W,this.o(z,j)),this.p(W)}$provideDocumentColors(j,z,q){return this.s(j,he,W=>W.provideColors(l.URI.revive(z),q),[],q)}$provideColorPresentations(j,z,q,W){return this.s(j,he,ie=>ie.provideColorPresentations(l.URI.revive(z),q,W),void 0,W)}registerFoldingRangeProvider(j,z,q){const W=this.q(),ie=typeof q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(W,new Re(new K(this.h,q),j)),this.e.$registerFoldingRangeProvider(W,this.o(z,j),j.identifier,ie);let ue=this.p(W);if(ie!==void 0){const Le=q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ie));ue=a.$3L.from(ue,Le)}return ue}$provideFoldingRanges(j,z,q,W){return this.s(j,K,ie=>ie.provideFoldingRanges(l.URI.revive(z),q,W),void 0,W)}registerSelectionRangeProvider(j,z,q){const W=this.t(new Y(this.h,q,this.l),j);return this.e.$registerSelectionRangeProvider(W,this.o(z,j)),this.p(W)}$provideSelectionRanges(j,z,q,W){return this.s(j,Y,ie=>ie.provideSelectionRanges(l.URI.revive(z),q,W),[],W)}registerCallHierarchyProvider(j,z,q){const W=this.t(new me(this.h,q),j);return this.e.$registerCallHierarchyProvider(W,this.o(z,j)),this.p(W)}$prepareCallHierarchy(j,z,q,W){return this.s(j,me,ie=>Promise.resolve(ie.prepareSession(l.URI.revive(z),q,W)),void 0,W)}$provideCallHierarchyIncomingCalls(j,z,q,W){return this.s(j,me,ie=>ie.provideCallsTo(z,q,W),void 0,W)}$provideCallHierarchyOutgoingCalls(j,z,q,W){return this.s(j,me,ie=>ie.provideCallsFrom(z,q,W),void 0,W)}$releaseCallHierarchy(j,z){this.s(j,me,q=>Promise.resolve(q.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(j,z,q){const W=this.t(new pe(this.h,q),j);return this.e.$registerTypeHierarchyProvider(W,this.o(z,j)),this.p(W)}$prepareTypeHierarchy(j,z,q,W){return this.s(j,pe,ie=>Promise.resolve(ie.prepareSession(l.URI.revive(z),q,W)),void 0,W)}$provideTypeHierarchySupertypes(j,z,q,W){return this.s(j,pe,ie=>ie.provideSupertypes(z,q,W),void 0,W)}$provideTypeHierarchySubtypes(j,z,q,W){return this.s(j,pe,ie=>ie.provideSubtypes(z,q,W),void 0,W)}$releaseTypeHierarchy(j,z){this.s(j,pe,q=>Promise.resolve(q.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(j,z,q,W){const ie=this.q();this.f.set(ie,new Re(new Fe(this.e,this.h,q,ie,j),j));const ue=(0,h.$VF)(j,"dropMetadata")&&W?Fe.toInternalProviderId(j.identifier.value,W.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ie,this.o(z,j),ue,(0,h.$VF)(j,"dropMetadata")?W:void 0),this.p(ie)}$provideDocumentOnDropEdits(j,z,q,W,ie,ue){return this.s(j,Fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(z,l.URI.revive(q),W,ie,ue)),void 0,void 0)}registerMappedEditsProvider(j,z,q){const W=this.t(new be(this.h,q),j);return this.e.$registerMappedEditsProvider(W,this.o(z,j)),this.p(W)}$provideMappedEdits(j,z,q,W,ie){return this.s(j,be,ue=>Promise.resolve(ue.provideMappedEdits(z,q,W,ie)),null,ie)}registerDocumentPasteEditProvider(j,z,q,W){const ie=this.q();this.f.set(ie,new Re(new B(this.e,this.h,q,ie,j),j));const ue=B.toInternalProviderId(j.identifier.value,W.id);return this.e.$registerPasteEditProvider(ie,this.o(z,j),ue,{supportsCopy:!!q.prepareDocumentPaste,supportsPaste:!!q.provideDocumentPasteEdits,copyMimeTypes:W.copyMimeTypes,pasteMimeTypes:W.pasteMimeTypes}),this.p(ie)}$prepareDocumentPaste(j,z,q,W,ie){return this.s(j,B,ue=>ue.prepareDocumentPaste(l.URI.revive(z),q,W,ie),void 0,ie)}$providePasteEdits(j,z,q,W,ie,ue){return this.s(j,B,Le=>Le.providePasteEdits(z,l.URI.revive(q),W,ie,ue),void 0,ue)}static w(j){return{pattern:j.source,flags:j.flags}}static y(j){return{decreaseIndentPattern:Pe.w(j.decreaseIndentPattern),increaseIndentPattern:Pe.w(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Pe.w(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Pe.w(j.unIndentedLinePattern):void 0}}static z(j){return{beforeText:Pe.w(j.beforeText),afterText:j.afterText?Pe.w(j.afterText):void 0,previousLineText:j.previousLineText?Pe.w(j.previousLineText):void 0,action:j.action}}static B(j){return j.map(Pe.z)}static C(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(z=>a.SyntaxTokenType.toString(z)):void 0}}static D(j){return j.map(Pe.C)}setLanguageConfiguration(j,z,q){const{wordPattern:W}=q;if(W&&(0,F.$8e)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this.h.setWordDefinitionFor(z,W):this.h.setWordDefinitionFor(z,void 0),q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ie=this.q(),ue={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?Pe.w(q.wordPattern):void 0,indentationRules:q.indentationRules?Pe.y(q.indentationRules):void 0,onEnterRules:q.onEnterRules?Pe.B(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport,autoClosingPairs:q.autoClosingPairs?Pe.D(q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ie,z,ue),this.p(ie)}$setWordDefinitions(j){for(const z of j)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Vhc=Pe,Pe.d=0}),define(Me[260],Ae([1,0,3,8,7,32,11,6,23]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class k{constructor(S,l,w,m){this.c=l,this.d=w,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(D.$1L.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const w=this.c.getDocumentData(S);if(!w)throw new Error(`document '${S.toString()}' NOT found`);return w.document}async tokenAtPosition(S,l){const w=S.version,m=P.Position.from(l),s=await this.a.$tokensAtPosition(S.uri,m),u={type:C.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new C.$5L(l.line,l.character,l.line,l.character)};if(!s)return u;const i={range:P.Range.to(s.range),type:P.TokenType.to(s.type)};return!i.range.contains(l)||w!==S.version?u:i}createLanguageStatusItem(S,l,w){const m=this.f++,s=this.a,u=this.g,i=`${S.identifier.value}/${l}`;if(u.has(i))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);u.add(i);const r={selector:w,id:l,name:S.displayName??S.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const a=new g.$Sc,h=()=>{if(n?.dispose(),!u.has(i)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,M.$gh)(()=>{a.clear(),this.a.$setLanguageStatus(m,{id:i,name:r.name??S.displayName??S.name,source:S.displayName??S.name,selector:P.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===C.LanguageStatusSeverity.Error?L.default.Error:r.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){a.dispose(),n?.dispose(),s.$removeLanguageStatus(m),u.delete(i)},get id(){return r.id},get name(){return r.name},set name($){r.name=$,h()},get selector(){return r.selector},set selector($){r.selector=$,h()},get text(){return r.text},set text($){r.text=$,h()},set text2($){(0,f.$WF)(S,"languageStatusText"),r.text=$,h()},get text2(){return(0,f.$WF)(S,"languageStatusText"),r.text},get detail(){return r.detail},set detail($){r.detail=$,h()},get severity(){return r.severity},set severity($){r.severity=$,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation($){r.accessibilityInformation=$,h()},get command(){return r.command},set command($){r.command=$,h()},get busy(){return r.busy},set busy($){r.busy=$,h()}};return h(),t}}e.$ijc=k}),define(Me[261],Ae([1,0,12,2,8,7,83]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=void 0;class g{constructor(S,l,w,m){this.start=S,this.deletedCount=l,this.deletedItems=w,this.items=m}asApiEvent(){return{range:new L.$qN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,l,w){this.notebook=S,this.h=l,this.j=w,this.handle=w.handle,this.uri=P.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(C.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(m){S.g=m},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(w)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,l,w){const m=w.map(C.NotebookCellOutputItem.to),s=this.a.find(u=>u.id===S);if(s&&(l||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(u=>M.$4J(u.mime)))){const u=new Map,i=[];s.items.forEach(r=>{let n;u.has(r.mime)?n=u.get(r.mime):(n=[],u.set(r.mime,n),i.push(r.mime)),n.push(r.data)}),s.items.length=0,i.forEach(r=>{const n=M.$5J(u.get(r));s.items.push({mime:r,data:n.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$6ic=f;class k{constructor(S,l,w,m,s){this.k=S,this.l=l,this.m=w,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===D.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(w){return w=S.n(w),S.b[w].apiCell},getCells(w){return(w?S.p(w):S.b).map(s=>s.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,w){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:w});const m={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},s=[];for(const i of S.rawEvents)i.kind===M.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,m.contentChanges):i.kind===M.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,m.contentChanges):i.kind===M.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),s.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===M.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),s.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),s.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),s.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),s.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const u=new Map;for(let i=0;i<s.length;i++){const r=s[i],n=u.get(r.cell);if(n===void 0){const a=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});u.set(r.cell,a-1)}else m.cellChanges[n]={...m.cellChanges[n],...r}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,w=S.end|0;return l<0&&(l=0),w>this.b.length&&(w=this.b.length),S.with({start:l,end:w})}p(S){S=this.o(S);const l=[];for(let w=S.start;w<S.end;w++)l.push(this.b[w]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,w){if(this.j)return;const m=[],s=[],u=[];if(S.reverse().forEach(i=>{const n=i[2].map(t=>{const $=new f(this,this.l,t);return l||s.push(f.asModelAddData(t)),$}),a=new g(i[0],i[1],[],n),h=this.b.splice(i[0],i[1],...n);for(const t of h)u.push(t.uri),a.deletedItems.push(t.apiCell);m.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:u}),w)for(const i of m)w.push(i.asApiEvent())}s(S,l,w,m){const s=this.b.splice(S,l);this.b.splice(w,0,...s);const u=[new g(S,l,s.map(i=>i.apiCell),[]),new g(w,0,[],s)];for(const i of u)m.push(i.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,w,m){this.b[S].setOutputItems(l,w,m)}v(S,l){const w=this.b[S];w.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(w.uri,l)}w(S,l){const w=this.b[S];w.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){if(P.URI.isUri(S)){const l=M.CellUri.parse(S);if(!l||l.notebook.toString()!==this.uri.toString())return;S=l.handle}return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$7ic=k,k.a=0}),define(Me[262],Ae([1,0,5,2,8,7]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class M{constructor(f,k,F,S={timeout:1500,errors:3}){this.b=f,this.c=k,this.d=F,this.f=S,this.a=new D.$7d}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(k,F,S)=>{const l=function(m){k.call(F,m)};return l.extension=f,this.a.event(l,void 0,S)}}async $participateInSave(f,k,F){const S=P.URI.revive(f),l=this.c.getNotebookDocument(S);if(!l)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(k)},F,async(s,u)=>{const i=Date.now(),r=await await Promise.resolve(s);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!F.isCancellationRequested&&r&&(r instanceof L.$aM?w.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),F.isCancellationRequested)return!1;if(w.length===0)return!0;const m={edits:[]};for(const s of w){const{edits:u}=C.WorkspaceEdit.from(s);m.edits=m.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(m)}}e.$kjc=M}),define(Me[110],Ae([1,0,15,8,7]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class L{constructor(g,f,k,F,S,l){this.id=g,this.f=f,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=F,this.c=l}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(f){this.selections=[f]},get selections(){return g.a},set selections(f){if(!Array.isArray(f)||!f.every(C.$qN.isNotebookRange))throw(0,D.$7)("selections");g.a=f,g.g(f)},get visibleRanges(){return g.b},revealRange(f,k){g.f.$tryRevealRange(g.id,P.NotebookRange.from(f),k??C.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(P.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$8ic=L,L.apiEditorsToExtHost=new WeakMap}),define(Me[263],Ae([1,0,5,14,8]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;let L=class{constructor(g,f){this.c=g,this.d=f,this.a=new D.$5d,this.b=new D.$5d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,f);const k=this.d.getEditorById(g);f.visibleRanges&&k._acceptVisibleRanges(f.visibleRanges.ranges.map(C.NotebookRange.to)),f.selections&&k._acceptSelections(f.selections.selections.map(C.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const f in g)this.d.getEditorById(f)._acceptViewColumn(C.ViewColumn.to(g[f]))}};e.$mjc=L,e.$mjc=L=Xe([He(0,P.$yj)],L)}),define(Me[264],Ae([1,0,5,3,110]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;class L{constructor(g,f){this.c=f,this.a=new Map,this.b=g.getProxy(P.$1L.MainThreadNotebookRenderers)}$postRendererMessage(g,f,k){const F=this.c.getEditorById(g);this.a.get(f)?.fire({editor:F.apiEditor,message:k})}createRendererMessaging(g,f){if(!g.contributes?.notebookRenderer?.some(F=>F.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(F,S,l)=>this.d(f).event(F,S,l),postMessage:(F,S)=>{C.$8ic.apiEditorsToExtHost.has(F)&&([F,S]=[S,F]);const l=S&&C.$8ic.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,f,F)}}}d(g){let f=this.a.get(g);return f||(f=new D.$5d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(g)}}),this.a.set(g,f),f)}}e.$pjc=L}),define(Me[265],Ae([1,0,8,99,22,68,15]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;class g{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,l,w){const m=this.b++,{title:s,location:u,cancellable:i}=l,r={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(m,{location:D.ProgressLocation.from(u),title:s,source:r,cancellable:i},S.isUnderDevelopment?void 0:S.identifier.value).catch(M.$2),this.d(m,w,!!i)}d(S,l,w){let m;w&&(m=new C.$ce,this.c.set(S,m));const s=i=>{this.a.$progressEnd(i),this.c.delete(i),m?.dispose()};let u;try{u=l(new k(this.a,S),w&&m?m.token:C.CancellationToken.None)}catch(i){throw s(S),i}return u.then(i=>s(S),i=>s(S)),u}$acceptProgressCanceled(S){const l=this.c.get(S);l&&(l.cancel(),this.c.delete(S))}}e.$tjc=g;function f(F,S){return F.message=S.message,typeof S.increment=="number"&&(typeof F.increment=="number"?F.increment+=S.increment:F.increment=S.increment),F}class k extends P.$Iv{constructor(S,l){super(w=>this.throttledReport(w)),this.c=S,this.d=l}throttledReport(S){this.c.$progressReport(this.d,S)}}Xe([(0,L.$Kh)(100,(F,S)=>f(F,S),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Me[266],Ae([1,0,2,3,11,8]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=void 0;class M{constructor(f,k){this.d=k,this.c=new Map,this.b=f.getProxy(P.$1L.MainThreadQuickDiff)}$provideOriginalResource(f,k,F){const S=D.URI.revive(k),l=this.c.get(f);return l?(0,C.$9g)(()=>l.provideOriginalResource(S,F)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(f,k,F,S){const l=M.a++;return this.c.set(l,k),this.b.$registerQuickDiffProvider(l,L.DocumentSelector.from(f,this.d),F,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$ujc=M,M.a=0}),define(Me[267],Ae([1,0,22,5,6,3,2,7,15,18,32,41,23,8]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;function m(s,u,i){const r=s.getProxy(L.$1L.MainThreadQuickOpen);class n{constructor(d,I){this.e=new Map,this.f=0,this.a=d,this.b=I}showQuickPick(d,I,v,y=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(I),A=++this.f,V=r.$show(A,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),X={},H=V.then(()=>X);return Promise.race([H,E]).then(O=>{if(O===X)return;const R=(0,l.$VF)(d,"quickPickItemTooltip");return E.then(B=>{const T=[];for(let te=0;te<B.length;te++){const Q=B[te];if(typeof Q=="string")T.push({label:Q,handle:te});else if(Q.kind===g.QuickPickItemKind.Separator)T.push({type:"separator",label:Q.label});else{Q.tooltip&&!R&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const ce=Q.iconPath?c(Q.iconPath):void 0;T.push({label:Q.label,iconPath:ce?.iconPath,iconClass:ce?.iconClass,description:Q.description,detail:Q.detail,picked:Q.picked,alwaysShow:Q.alwaysShow,tooltip:R?w.MarkdownString.fromStrict(Q.tooltip):void 0,handle:te})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=te=>{v.onDidSelectItem(B[te])}),r.$setItems(A,T),V.then(te=>{if(typeof te=="number")return B[te];if(Array.isArray(te))return te.map(Q=>B[Q])})})}).then(void 0,O=>{if(!(0,f.$4)(O))return r.$setError(A,O),Promise.reject(O)})}$onItemSelected(d){this.c?.(d)}showInput(d,I=D.CancellationToken.None){return this.d=d?.validateInput,r.$input(d,typeof this.d=="function",I).then(void 0,v=>{if(!(0,f.$4)(v))return Promise.reject(v)})}async $validateInput(d){if(!this.d)return;const I=await this.d(d);if(!I||typeof I=="string")return I;let v;switch(I.severity){case g.InputBoxValidationSeverity.Info:v=F.default.Info;break;case g.InputBoxValidationSeverity.Warning:v=F.default.Warning;break;case g.InputBoxValidationSeverity.Error:v=F.default.Error;break;default:v=I.message?F.default.Error:F.default.Ignore;break}return{content:I.message,severity:v}}async showWorkspaceFolderPick(d,I=D.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!v)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(E=>E.uri.toString()===v.uri.toString())}createQuickPick(d){const I=new o(d,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(d){const I=new b(d,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(d,I){this.e.get(d)?._fireDidChangeValue(I)}$onDidAccept(d){this.e.get(d)?._fireDidAccept()}$onDidChangeActive(d,I){const v=this.e.get(d);v instanceof o&&v._fireDidChangeActive(I)}$onDidChangeSelection(d,I){const v=this.e.get(d);v instanceof o&&v._fireDidChangeSelection(I)}$onDidTriggerButton(d,I){this.e.get(d)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(d,I,v){const y=this.e.get(d);y instanceof o&&y._fireDidTriggerItemButton(I,v)}$onDidHide(d){this.e.get(d)?._fireDidHide()}}class a{constructor(d,I){this.x=d,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.$5d,this.q=new P.$5d,this.r=new P.$5d,this.s=new P.$5d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(d){this.b=d,this.z({title:d})}get step(){return this.c}set step(d){this.c=d,this.z({step:d})}get totalSteps(){return this.d}set totalSteps(d){this.d=d,this.z({totalSteps:d})}get enabled(){return this.g}set enabled(d){this.g=d,this.z({enabled:d})}get busy(){return this.j}set busy(d){this.j=d,this.z({busy:d})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(d){this.k=d,this.z({ignoreFocusOut:d})}get value(){return this.l}set value(d){this.l=d,this.z({value:d})}get placeholder(){return this.m}set placeholder(d){this.m=d,this.z({placeholder:d})}get buttons(){return this.n}set buttons(d){this.n=d.slice(),this.o.clear(),d.forEach((I,v)=>{const y=I===g.$nN.Back?-1:v;this.o.set(y,I)}),this.z({buttons:d.map((I,v)=>({...c(I.iconPath),tooltip:I.tooltip,handle:I===g.$nN.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(d){this.l=d,this.q.fire(d)}_fireDidTriggerButton(d){const I=this.o.get(d);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(d){if(!this.v){for(const I of Object.keys(d)){const v=d[I];this.u[I]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}a.a=1;function h(p){if(p instanceof g.$XM)return{id:p.id};const d=$(p),I=t(p);return{dark:typeof d=="string"?M.URI.file(d):d,light:typeof I=="string"?M.URI.file(I):I}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function $(p){return typeof p=="object"&&"dark"in p?p.dark:p}function c(p){const d=h(p);let I,v;return"id"in d?v=S.ThemeIcon.asClassName(d):I=d,{iconPath:I,iconClass:v}}class o extends a{constructor(d,I){super(d.identifier,I),this.O=d,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.$5d,this.L=[],this.M=new P.$5d,this.N=new P.$5d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(d){this.B=d.slice(),this.C.clear(),this.D.clear(),d.forEach((y,E)=>{this.C.set(E,y),this.D.set(y,E)});const I=(0,l.$VF)(this.O,"quickPickItemTooltip"),v=[];for(let y=0;y<d.length;y++){const E=d[y];if(E.kind===g.QuickPickItemKind.Separator)v.push({type:"separator",label:E.label});else{E.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=E.iconPath?c(E.iconPath):void 0;v.push({handle:y,label:E.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:I?w.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((V,X)=>({...c(V.iconPath),tooltip:V.tooltip,handle:X}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(d){this.E=d,this.z({canSelectMany:d})}get matchOnDescription(){return this.F}set matchOnDescription(d){this.F=d,this.z({matchOnDescription:d})}get matchOnDetail(){return this.G}set matchOnDetail(d){this.G=d,this.z({matchOnDetail:d})}get sortByLabel(){return this.H}set sortByLabel(d){this.H=d,this.z({sortByLabel:d})}get keepScrollPosition(){return this.I}set keepScrollPosition(d){this.I=d,this.z({keepScrollPosition:d})}get activeItems(){return this.J}set activeItems(d){this.J=d.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(d){this.L=d.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(d){const I=(0,k.$Hb)(d.map(v=>this.C.get(v)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(d){const I=(0,k.$Hb)(d.map(v=>this.C.get(v)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(d,I){const v=this.C.get(d);if(!v||!v.buttons||!v.buttons.length)return;const y=v.buttons[I];y&&this.N.fire({button:y,item:v})}}class b extends a{constructor(d,I){super(d.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(d){this.B=d,this.z({password:d})}get prompt(){return this.C}set prompt(d){this.C=d,this.z({prompt:d})}get valueSelection(){return this.D}set valueSelection(d){this.D=d,this.z({valueSelection:d})}get validationMessage(){return this.E}set validationMessage(d){this.E=d,d?typeof d=="string"?this.z({validationMessage:d,severity:F.default.Error}):this.z({validationMessage:d.message,severity:d.severity??F.default.Error}):this.z({validationMessage:void 0,severity:F.default.Ignore})}}return new n(u,i)}e.$vjc=m});var Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)},xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D};define(Me[268],Ae([1,0,2,5,68,6,11,3,18,124,14,20,41,8,23,12,21]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u){"use strict";var i,r,n,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=e.$wjc=void 0;function h(H){return H instanceof D.URI}function t(H,O){return H.scheme===s.Schemas.file&&O.scheme===s.Schemas.file&&u.$e?H.toString()===O.toString():H.toString().toLowerCase()===O.toString().toLowerCase()}function $(H){if(H)return typeof H.iconPath=="string"?D.URI.file(H.iconPath):D.URI.isUri(H.iconPath)||l.ThemeIcon.isThemeIcon(H.iconPath)?H.iconPath:void 0}function c(H){if(H.icon){if(D.URI.isUri(H.icon))return H.icon;if(l.ThemeIcon.isThemeIcon(H.icon))return H.icon;{const O=H.icon;return{light:O.light,dark:O.dark}}}else return}function o(H,O){if(!H.iconPath&&!O.iconPath)return 0;if(H.iconPath){if(!O.iconPath)return 1}else return-1;const R=typeof H.iconPath=="string"?H.iconPath:D.URI.isUri(H.iconPath)?H.iconPath.fsPath:H.iconPath.id,B=typeof O.iconPath=="string"?O.iconPath:D.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,k.$5q)(R,B)}function b(H,O){let R=0;if(H.strikeThrough!==O.strikeThrough)return H.strikeThrough?1:-1;if(H.faded!==O.faded)return H.faded?1:-1;if(H.tooltip!==O.tooltip)return(H.tooltip||"").localeCompare(O.tooltip||"");if(R=o(H,O),R!==0)return R;if(H.light&&O.light)R=o(H.light,O.light);else{if(H.light)return 1;if(O.light)return-1}if(R!==0)return R;if(H.dark&&O.dark)R=o(H.dark,O.dark);else{if(H.dark)return 1;if(O.dark)return-1}return R}function p(H,O){if(H.command!==O.command)return H.command<O.command?-1:1;if(H.title!==O.title)return H.title<O.title?-1:1;if(H.tooltip!==O.tooltip){if(H.tooltip!==void 0&&O.tooltip!==void 0)return H.tooltip<O.tooltip?-1:1;if(H.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(H.arguments===O.arguments)return 0;if(H.arguments)if(O.arguments){if(H.arguments.length!==O.arguments.length)return H.arguments.length-O.arguments.length}else return 1;else return-1;for(let R=0;R<H.arguments.length;R++){const B=H.arguments[R],T=O.arguments[R];if(B!==T&&!(h(B)&&h(T)&&t(B,T)))return B<T?-1:1}return 0}function d(H,O){let R=(0,k.$5q)(H.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(R!==0)return R;if(H.command&&O.command)R=p(H.command,O.command);else{if(H.command)return 1;if(O.command)return-1}if(R!==0)return R;if(H.decorations&&O.decorations)R=b(H.decorations,O.decorations);else{if(H.decorations)return 1;if(O.decorations)return-1}if(H.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)R=(0,k.$5q)(H.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(H.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(H.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)R=(0,k.$5q)(H.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(H.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return R}function I(H,O){for(let R=0;R<H.length;R++)if(H[R]!==O[R])return!1;return!0}function v(H,O){return H.command===O.command&&H.title===O.title&&H.tooltip===O.tooltip&&(H.arguments&&O.arguments?I(H.arguments,O.arguments):H.arguments===O.arguments)}function y(H,O){return(0,f.$ub)(H,O,v)}class E{get value(){return this.d}set value(O){O=O??"",Ue(this,i,"f").$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){Ue(this,i,"f").$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,m.$WF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,m.$WF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,Ue(this,i,"f").$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,Ue(this,i,"f").$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,Ue(this,i,"f").$setInputBoxVisibility(this.l,O))}get document(){return(0,m.$WF)(this.k,"scmTextDocument"),Ue(this,r,"f").getDocument(this.m)}constructor(O,R,B,T,te){this.k=O,this.l=T,this.m=te,i.set(this,void 0),r.set(this,void 0),this.d="",this.e=new P.$5d,this.f="",this.h=!0,this.j=!0,xe(this,r,R,"f"),xe(this,i,B,"f")}showValidationMessage(O,R){(0,m.$WF)(this.k,"scmValidation"),Ue(this,i,"f").$showValidationMessage(this.l,O,R)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$wjc=E,i=new WeakMap,r=new WeakMap;class A{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,R,B,T,te,Q,ce){this.q=O,this.s=R,this.t=B,this.u=T,this.v=te,this.multiDiffEditorEnableViewChanges=Q,this.w=ce,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.$5d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new P.$5d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=A.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,R){const B=this.h.get(O);return B?(0,M.$9g)(()=>this.s.executeCommand(B.command,...B.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(d),B=(0,f.$Db)(this.o,O,d).map(Q=>{const ce=Q.toInsert.map(le=>{const se=this.e++;this.g.set(se,le);const $e=le.resourceUri;let ne;if(le.command)if(le.command.command==="vscode.open"||le.command.command==="vscode.diff"||le.command.command==="vscode.changes"){const me=new L.$Sc;ne=this.s.converter.toInternal(le.command,me),this.j.set(se,me)}else this.h.set(se,le.command);const ke=(0,m.$VF)(this.w,"scmMultiDiffEditor"),oe=ke?le.multiDiffEditorOriginalUri:void 0,ve=ke?le.multiFileDiffEditorModifiedUri:void 0,G=$(le.decorations),ge=le.decorations&&$(le.decorations.light)||G,ae=le.decorations&&$(le.decorations.dark)||G,De=[ge,ae],ye=le.decorations&&le.decorations.tooltip||"",we=le.decorations&&!!le.decorations.strikeThrough,he=le.decorations&&!!le.decorations.faded,K=le.contextValue||"";return{rawResource:[se,$e,De,ye,we,he,K,ne,oe,ve],handle:se}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:ce}}),T=B.map(({start:Q,deleteCount:ce,toInsert:le})=>[Q,ce,le.map(se=>se.rawResource)]),te=B.reverse();for(const{start:Q,deleteCount:ce,toInsert:le}of te){const se=le.map(ne=>ne.handle),$e=this.n.splice(Q,ce,...se);for(const ne of $e)this.g.delete(ne),this.h.delete(ne),this.j.get(ne)?.dispose(),this.j.delete(ne)}return this.o=O,T}dispose(){this.l=!0,this.m.fire()}}A.d=0;class V{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,Ue(this,n,"f").$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let R;(0,m.$VF)(this.x,"quickDiffProvider")&&(R=O?.label),Ue(this,n,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:R})}get historyProvider(){return(0,m.$WF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,m.$WF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new L.$Sc,Ue(this,n,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,Ue(this,n,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,Ue(this,n,"f").$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new L.$Sc,this.o=O;const R=this.y.converter.toInternal(O,this.n.value);Ue(this,n,"f").$updateSourceControl(this.w,{acceptInputCommand:R})}get actionButton(){return(0,m.$WF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,m.$WF)(this.x,"scmActionButton"),this.p.value=new L.$Sc,this.q=O;const R=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(B=>B.map(T=>this.y.converter.toInternal(T,this.p.value))),description:O.description,enabled:O.enabled}:void 0;Ue(this,n,"f").$updateSourceControl(this.w,{actionButton:R??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&y(this.t,O))return;this.s.value=new L.$Sc,this.t=O;const R=(O||[]).map(B=>this.y.converter.toInternal(B,this.s.value));Ue(this,n,"f").$updateSourceControl(this.w,{statusBarCommands:R})}get selected(){return this.u}constructor(O,R,B,T,te,Q,ce){this.x=O,this.y=T,this.z=te,this.A=Q,this.B=ce,n.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Uc,this.m=void 0,this.n=new L.$Uc,this.o=void 0,this.p=new L.$Uc,this.s=new L.$Uc,this.t=void 0,this.u=!1,this.v=new P.$5d,this.onDidChangeSelection=this.v.event,this.w=V.d++,this.C=new Map,this.D=new Set,xe(this,n,B,"f");const le=D.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${te}/scm${this.w}/input`,query:ce?`rootUri=${encodeURIComponent(ce.toString())}`:void 0});this.f=new E(O,R,Ue(this,n,"f"),this.w,le),Ue(this,n,"f").$registerSourceControl(this.w,te,Q,ce,le)}createResourceGroup(O,R,B){const T=(0,m.$VF)(this.x,"scmMultiDiffEditor")&&B?.multiDiffEditorEnableViewChanges===!0,te=new A(Ue(this,n,"f"),this.y,this.w,O,R,T,this.x),Q=P.Event.once(te.onDidDispose)(()=>this.C.delete(te));return this.C.set(te,Q),this.eventuallyAddResourceGroups(),te}eventuallyAddResourceGroups(){const O=[],R=[];for(const[B,T]of this.C){T.dispose();const te=B.onDidUpdateResourceStates(()=>{this.D.add(B),this.eventuallyUpdateResourceStates()});P.Event.once(B.onDidDispose)(()=>{this.D.delete(B),te.dispose(),this.e.delete(B.handle),Ue(this,n,"f").$unregisterGroup(this.w,B.handle)}),O.push([B.handle,B.id,B.label,B.features,B.multiDiffEditorEnableViewChanges]);const Q=B._takeResourceStateSnapshot();Q.length>0&&R.push([B.handle,Q]),this.e.set(B.handle,B)}Ue(this,n,"f").$registerGroups(this.w,O,R),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(R=>{const B=R._takeResourceStateSnapshot();B.length!==0&&O.push([R.handle,B])}),O.length>0&&Ue(this,n,"f").$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),Ue(this,n,"f").$unregisterSourceControl(this.w)}}n=new WeakMap,V.d=0,Xe([(0,C.$Jh)(100)],V.prototype,"eventuallyAddResourceGroups",null),Xe([(0,C.$Jh)(100)],V.prototype,"eventuallyUpdateResourceStates",null);let X=a=class{get onDidChangeActiveProvider(){return this.j.event}constructor(O,R,B,T){this.l=R,this.m=B,this.n=T,this.g=new Map,this.h=new S.$zm,this.j=new P.$5d,this.e=O.getProxy(g.$1L.MainThreadSCM),this.f=O.getProxy(g.$1L.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:te=>{if(te&&te.$mid===3){const Q=this.g.get(te.sourceControlHandle);if(!Q)return te;const ce=Q.getResourceGroup(te.groupHandle);return ce?ce.getResourceState(te.handle):te}else if(te&&te.$mid===4){const Q=this.g.get(te.sourceControlHandle);return Q?Q.getResourceGroup(te.groupHandle):te}else if(te&&te.$mid===5){const Q=this.g.get(te.handle);return Q||te}return te}})}createSourceControl(O,R,B,T){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,R,B,T),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const te=a.d++,Q=new V(O,this.m,this.e,this.l,R,B,T);this.g.set(te,Q);const ce=this.h.get(O.identifier)||[];return ce.push(Q),this.h.set(O.identifier,ce),Q}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const R=this.h.get(O.identifier),B=R&&R[R.length-1];return B&&B.inputBox}$provideOriginalResource(O,R,B){const T=D.URI.revive(R);this.n.trace("ExtHostSCM#$provideOriginalResource",O,T.toString());const te=this.g.get(O);return!te||!te.quickDiffProvider||!te.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$9g)(()=>te.quickDiffProvider.provideOriginalResource(T,B)).then(Q=>Q||null)}$onInputBoxValueChange(O,R){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const B=this.g.get(O);return B&&B.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(O,R,B,T){this.n.trace("ExtHostSCM#$executeResourceCommand",O,R,B);const te=this.g.get(O);if(!te)return Promise.resolve(void 0);const Q=te.getResourceGroup(R);return Q?Q.$executeResourceCommand(B,T):Promise.resolve(void 0)}$validateInput(O,R,B){this.n.trace("ExtHostSCM#$validateInput",O);const T=this.g.get(O);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,M.$9g)(()=>T.inputBox.validateInput(R,B)).then(te=>{if(!te)return Promise.resolve(void 0);const Q=w.MarkdownString.fromStrict(te.message);return Q?Promise.resolve([Q,te.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,R,B,T){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(R,B,T)??void 0}async $provideHistoryItems(O,R,B,T){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(R,B,T))?.map(ce=>({...ce,icon:c(ce)}))??void 0}async $provideHistoryItemSummary(O,R,B,T){const te=this.g.get(O)?.historyProvider;if(typeof te?.provideHistoryItemSummary!="function")return;const Q=await te.provideHistoryItemSummary(R,B,T);return Q?{...Q,icon:c(Q)}:void 0}async $provideHistoryItemChanges(O,R,B,T){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(R,B,T)??void 0}};e.$xjc=X,X.d=0,e.$xjc=X=a=Xe([He(3,F.$yj)],X)}),define(Me[269],Ae([1,0,3,8,2]),function(x,e,D,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class L{constructor(g,f){this.d=f,this.c=new Map,this.b=g.getProxy(D.$1L.MainThreadShare)}async $provideShare(g,f,k){return await this.c.get(g)?.provideShare({selection:P.Range.to(f.selection),resourceUri:C.URI.revive(f.resourceUri)},k)??void 0}registerShareProvider(g,f){const k=L.a++;return this.c.set(k,f),this.b.$registerShareProvider(k,P.DocumentSelector.from(g,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$yjc=L,L.a=0});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[270],Ae([1,0,7,3,165,6,8,16]),function(x,e,D,P,C,L,M,g){"use strict";var f,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=void 0;class F{constructor(m,s,u,i,r,n=D.StatusBarAlignment.Left,a){if(f.set(this,void 0),k.set(this,void 0),this.i=!1,this.k="",this.q=new L.$Sc,xe(this,f,m,"f"),xe(this,k,s,"f"),r&&i){this.c=(0,D.$BM)(i.identifier,r);const h=u.get(this.c);h&&(n=h.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,a=h.priority,this.j=!0,this.name=h.name,this.text=h.text,this.tooltip=h.tooltip,this.command=h.command,this.accessibilityInformation=h.accessibilityInformation)}else this.c=String(F.a++);this.e=i,this.f=r,this.g=n,this.h=this.u(a)}u(m){if((0,g.$Wf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!F.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new L.$Sc,typeof m=="string"?this.r={fromApi:m,internal:Ue(this,k,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Ue(this,k,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,f,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let s;this.m?s=this.m:s=(0,C.localize)(0,null,this.e.displayName||this.e.name);let u=this.n;this.o&&(u=F.b.get(this.o.id));const i=M.MarkdownString.fromStrict(this.l);Ue(this,f,"f").$setEntry(this.c,m,this.e?.identifier.value,s,this.k,i,this.r?.internal,u,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ajc=F,f=new WeakMap,k=new WeakMap,F.a=0,F.b=new Map([["statusBarItem.errorBackground",new D.$YM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$YM("statusBarItem.warningForeground")]]);class S{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const s={message:m};return this.b.unshift(s),this.c(),new D.$3L(()=>{const u=this.b.indexOf(s);u>=0&&(this.b.splice(u,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class l{constructor(m,s){this.e=new Map,this.a=m.getProxy(P.$1L.MainThreadStatusBar),this.b=s,this.c=new S(this)}$acceptStaticEntries(m){for(const s of m)this.e.set(s.entryId,s)}createStatusBarEntry(m,s,u,i){return new F(this.a,this.b,this.e,m,s,u,i)}setStatusBarMessage(m,s){const u=this.c.setMessage(m);let i;return typeof s=="number"?i=setTimeout(()=>u.dispose(),s):typeof s<"u"&&s.then(()=>u.dispose(),()=>u.dispose()),new D.$3L(()=>{u.dispose(),clearTimeout(i)})}}e.$Bjc=l}),define(Me[111],Ae([1,0,29,103,48,75,60,8,2]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=void 0;const k=(n,a,h,t)=>{let $=a;return{enumerable:!0,configurable:!1,get(){return $},set(c){if(!h($,c)){const o=$;$=c,n.listener?.(t(c,o))}}}},F=(n,a)=>n===a,S={range:(n,a)=>n===a?!0:!n||!a?!1:n.isEqual(a),label:F,description:F,sortText:F,busy:F,error:F,canResolveChildren:F,tags:(n,a)=>!(n.length!==a.length||n.some(h=>!a.find(t=>h.id===t.id)))},l=n=>a=>({op:4,update:n(a)}),w=(n,a)=>({range:(()=>{let h;const t=l($=>({range:D.$7s.lift(g.Range.from($))}));return{enumerable:!0,configurable:!1,get(){return h},set($){n.listener?.({op:6}),S.range(h,$)||(h=$,n.listener?.(t($)))}}})(),label:k(n,a,S.label,l(h=>({label:h}))),description:k(n,void 0,S.description,l(h=>({description:h}))),sortText:k(n,void 0,S.sortText,l(h=>({sortText:h}))),canResolveChildren:k(n,!1,S.canResolveChildren,h=>({op:2,state:h})),busy:k(n,!1,S.busy,l(h=>({busy:h}))),error:k(n,void 0,S.error,l(h=>({error:g.MarkdownString.fromStrict(h)||null}))),tags:k(n,[],S.tags,(h,t)=>({op:1,new:h.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),m=n=>{const a=C.$RK.fromString(n.extId),h=new u(a.controllerId,a.localId,n.label,f.URI.revive(n.uri)||void 0);return h.range=g.Range.to(n.range||void 0),h.description=n.description||void 0,h.sortText=n.sortText||void 0,h.tags=n.tags.map(t=>g.TestTag.to({id:(0,M.$WK)(t).tagId})),h},s=n=>{let a;for(const h of n.tests){const t=m(h.item);(0,P.$bO)(t).parent=a,a=t}return a};e.$rO=s;class u{constructor(a,h,t,$){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,P.$aO)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:$,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,L.$_N)(c,P.$bO,u),enumerable:!0,writable:!1},...w(c,t)})}}e.$sO=u;class i extends u{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$tO=i;class r extends L.$8N{constructor(a,h,t){super({controllerId:a,getDocumentVersion:$=>$&&t.getDocument($)?.version,getApiFor:P.$bO,getChildren:$=>$.children,root:new i(a,h),toITestItem:g.TestItem.from})}}e.$uO=r});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[31],Ae([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,111,24,49,35,64,58,61,34]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$){"use strict";var c,o,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=void 0;let p=class{constructor(A,V,X){c.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),b.set(this,void 0),xe(this,c,A.getProxy(M.$1L.MainThreadCommands),"f"),this.d=V,xe(this,b,X,"f"),xe(this,o,A.getProxy(M.$1L.MainThreadTelemetry),"f"),this.converter=new d(this,H=>{const O=this.c.get(H);return O?.result===v.Void?O:void 0},V),this.f=[{processArgument(H){return(0,k.$Nh)(H)}},{processArgument(H){return(0,L.$Kn)(H,function(O){if(F.$7s.isIRange(O))return C.Range.to(O);if(S.$6s.isIPosition(O))return C.Position.to(O);if(F.$7s.isIRange(O.range)&&l.URI.isUri(O.uri))return C.location.to(O);if(O instanceof i.$se)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(A){this.f.push(A)}registerApiCommand(A){const V=this.registerCommand(!1,A.id,async(...X)=>{const H=A.args.map((R,B)=>{if(!R.validate(X[B]))throw new Error(`Invalid argument '${R.name}' when running '${A.id}', received: ${typeof X[B]=="object"?JSON.stringify(X[B],null,"	"):X[B]} `);return R.convert(X[B])}),O=await this.executeCommand(A.internalId,...H);return A.result.convert(O,X,this.converter)},void 0,{description:A.description,args:A.args,returns:A.result.description});return this.c.set(A.id,A),new P.$3L(()=>{V.dispose(),this.c.delete(A.id)})}registerCommand(A,V,X,H,O,R){if(this.d.trace("ExtHostCommands#registerCommand",V),!V.trim().length)throw new Error("invalid id");if(this.b.has(V))throw new Error(`command '${V}' already exists`);return this.b.set(V,{callback:X,thisArg:H,metadata:O,extension:R}),A&&Ue(this,c,"f").$registerCommand(V),new P.$3L(()=>{this.b.delete(V)&&A&&Ue(this,c,"f").$unregisterCommand(V)})}executeCommand(A,...V){return this.d.trace("ExtHostCommands#executeCommand",A),this.g(A,V,!0)}async g(A,V,X){if(this.b.has(A))return Ue(this,c,"f").$fireCommandActivationEvent(A),this.h(A,V,!1);{let H=!1;const O=(0,L.$Kn)(V,function(R){if(R instanceof P.$4L)return C.Position.from(R);if(R instanceof P.$5L)return C.Range.from(R);if(R instanceof P.$cM)return C.location.from(R);if(P.$qN.isNotebookRange(R))return C.NotebookRange.from(R);if(R instanceof ArrayBuffer)return H=!0,i.$se.wrap(new Uint8Array(R));if(R instanceof Uint8Array)return H=!0,i.$se.wrap(R);if(R instanceof i.$se)return H=!0,R;if(!Array.isArray(R))return R});try{const R=await Ue(this,c,"f").$executeCommand(A,H?new r.$7v(O):O,X);return(0,k.$Nh)(R)}catch(R){if(R instanceof Error&&R.message==="$executeCommand:retry")return this.g(A,V,!1);throw R}}}async h(A,V,X){const H=this.b.get(A);if(!H)throw new Error("Unknown command");const{callback:O,thisArg:R,metadata:B}=H;if(B?.args)for(let te=0;te<B.args.length;te++)try{(0,D.$0f)(V[te],B.args[te].constraint)}catch{throw new Error(`Running the contributed command: '${A}' failed. Illegal argument '${B.args[te].name}' - ${B.args[te].description}`)}const T=a.$1d.create();try{return await O.apply(R,V)}catch(te){if(A===this.converter.delegatingCommandId){const Q=this.converter.getActualCommand(...V);Q&&(A=Q.command)}if(this.d.error(te,A,H.extension?.identifier),!X)throw te;if(H.extension?.identifier){const Q=Ue(this,b,"f").onExtensionError(H.extension.identifier,te);this.d.trace("forwarded error to extension?",Q,H.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$2i)(te)),this.id=A,this.source=H.extension?.displayName??H.extension?.name}}}finally{this.j(H,A,T.elapsed())}}j(A,V,X){A.extension&&Ue(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:A.extension.identifier.value,id:new h.$Xo(V),duration:X})}$executeContributedCommand(A,...V){this.d.trace("ExtHostCommands#$executeContributedCommand",A);const X=this.b.get(A);return X?(V=V.map(H=>this.f.reduce((O,R)=>R.processArgument(O,X.extension?.identifier),H)),this.h(A,V,!0)):Promise.reject(new Error(`Contributed command '${A}' does not exist.`))}getCommands(A=!1){return this.d.trace("ExtHostCommands#getCommands",A),Ue(this,c,"f").$getCommands().then(V=>(A&&(V=V.filter(X=>X[0]!=="_")),V))}$getContributedCommandMetadata(){const A=Object.create(null);for(const[V,X]of this.b){const{metadata:H}=X;H&&(A[V]=H)}return Promise.resolve(A)}};e.$AO=p,c=new WeakMap,o=new WeakMap,b=new WeakMap,e.$AO=p=Xe([He(0,s.$fO),He(1,f.$yj),He(2,t.$zO)],p),e.$BO=(0,m.$ei)("IExtHostCommands");class d{constructor(A,V,X){this.d=A,this.f=V,this.g=X,this.delegatingCommandId=`__vsc${(0,$.$Ag)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(A,V){if(!A)return;const X={$ident:void 0,id:A.command,title:A.title,tooltip:A.tooltip};if(!A.command)return X;const H=this.f(A.command);if(H)X.id=H.internalId,X.arguments=H.args.map((O,R)=>O.convert(A.arguments&&A.arguments[R]));else if((0,g.$Lb)(A.arguments)){const O=`${A.command} /${++this.c}`;this.b.set(O,A),V.add((0,w.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),X.$ident=O,X.id=this.delegatingCommandId,X.arguments=[O],this.g.trace("CommandsConverter#CREATE",A.command,O)}return X}fromInternal(A){return typeof A.$ident=="string"?this.b.get(A.$ident):{command:A.id,title:A.title,arguments:A.arguments}}getActualCommand(...A){return this.b.get(A[0])}h(...A){const V=this.getActualCommand(...A);return this.g.trace("CommandsConverter#EXECUTE",A[0],V?V.command:"MISSING"),V?this.d.executeCommand(V.command,...V.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${A[0]}`)}}e.$CO=d;class I{static Arr(A){return new I(`${A.name}_array`,`Array of ${A.name}, ${A.description}`,V=>Array.isArray(V)&&V.every(X=>A.validate(X)),V=>V.map(X=>A.convert(X)))}constructor(A,V,X,H){this.name=A,this.description=V,this.validate=X,this.convert=H}optional(){return new I(this.name,`(optional) ${this.description}`,A=>A==null||this.validate(A),A=>A===void 0?void 0:A===null?null:this.convert(A))}with(A,V){return new I(A??this.name,V??this.description,this.validate,this.convert)}}e.$DO=I,I.Uri=new I("uri","Uri of a text document",E=>l.URI.isUri(E),E=>E),I.Position=new I("position","A position in a text document",E=>P.$4L.isPosition(E),C.Position.from),I.Range=new I("range","A range in a text document",E=>P.$5L.isRange(E),C.Range.from),I.Selection=new I("selection","A selection in a text document",E=>P.$6L.isSelection(E),C.Selection.from),I.Number=new I("number","",E=>typeof E=="number",E=>E),I.String=new I("string","",E=>typeof E=="string",E=>E),I.StringArray=I.Arr(I.String),I.CallHierarchyItem=new I("item","A call hierarchy item",E=>E instanceof P.$nM,C.CallHierarchyItem.from),I.TypeHierarchyItem=new I("item","A type hierarchy item",E=>E instanceof P.$JN,C.TypeHierarchyItem.from),I.TestItem=new I("testItem","A VS Code TestItem",E=>E instanceof u.$sO,C.TestItem.from);class v{constructor(A,V){this.description=A,this.convert=V}}e.$EO=v,v.Void=new v("no result",E=>E);class y{constructor(A,V,X,H,O){this.id=A,this.internalId=V,this.description=X,this.args=H,this.result=O}}e.$FO=y}),define(Me[271],Ae([1,0,18,12,2,86,95,36,31,8,7]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;const S=[new f.$FO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of DocumentHighlight-instances.",w(k.DocumentHighlight.to))),new f.$FO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$DO.Uri],new f.$EO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,u)=>{if((0,D.$Kb)(s))return;class i extends F.$iM{static to(n){const a=new i(n.name,k.SymbolKind.to(n.kind),n.containerName||"",new F.$cM(u[0],k.Range.to(n.range)));return a.detail=n.detail,a.range=a.location.range,a.selectionRange=k.Range.to(n.selectionRange),a.children=n.children?n.children.map(i.to):[],a}}return s.map(i.to)})),new f.$FO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$DO.Uri,new f.$DO("options","Formatting options",s=>!0,s=>s)],new f.$EO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new f.$FO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$DO.Uri,f.$DO.Range,new f.$DO("options","Formatting options",s=>!0,s=>s)],new f.$EO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new f.$FO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$DO.Uri,f.$DO.Position,new f.$DO("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$DO("options","Formatting options",s=>!0,s=>s)],new f.$EO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new f.$FO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of Location-instances.",w(k.location.to))),new f.$FO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of Hover-instances.",w(k.Hover.to))),new f.$FO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$DO.Uri,new f.$DO("position","A position in a text document",s=>Array.isArray(s)&&s.every(u=>F.$4L.isPosition(u)),s=>s.map(k.Position.from))],new f.$EO("A promise that resolves to an array of ranges.",s=>s.map(u=>{let i;for(const r of u.reverse())i=new F.$mM(k.Range.to(r),i);return i}))),new f.$FO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$DO.String.with("query","Search string")],new f.$EO("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new f.$FO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new f.$FO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$DO.CallHierarchyItem],new f.$EO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new f.$FO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$DO.CallHierarchyItem],new f.$EO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new f.$FO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new f.$FO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$DO.Uri,f.$DO.Position,f.$DO.String.with("newName","The new symbol name")],new f.$EO("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new f.$FO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$DO.Uri,f.$DO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$EO("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new f.$FO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$DO.Uri],new f.$EO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new F.$hN(s.tokenTypes,s.tokenModifiers)})),new f.$FO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$DO.Uri],new f.$EO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const u=(0,M.$cab)(s);if(u.type==="full")return new F.$jN(u.data,void 0)})),new f.$FO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$DO.Uri,f.$DO.Range.optional()],new f.$EO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new F.$hN(s.tokenTypes,s.tokenModifiers)})),new f.$FO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$DO.Uri,f.$DO.Range],new f.$EO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const u=(0,M.$cab)(s);if(u.type==="full")return new F.$jN(u.data,void 0)})),new f.$FO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$DO.Uri,f.$DO.Position,f.$DO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$DO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$EO("A promise that resolves to a CompletionList-instance.",(s,u,i)=>{if(!s)return new F.$yM([]);const r=s.suggestions.map(n=>k.CompletionItem.to(n,i));return new F.$yM(r,s.incomplete)})),new f.$FO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$DO.Uri,f.$DO.Position,f.$DO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$EO("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new f.$FO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$DO.Uri,f.$DO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$EO("A promise that resolves to an array of CodeLens-instances.",(s,u,i)=>w(r=>new F.$qM(k.Range.to(r.range),r.command&&i.fromInternal(r.command)))(s))),new f.$FO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$DO.Uri,new f.$DO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>F.$5L.isRange(s),s=>F.$6L.isSelection(s)?k.Selection.from(s):k.Range.from(s)),f.$DO.String.with("kind","Code action kind to return code actions for").optional(),f.$DO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$EO("A promise that resolves to an array of Command-instances.",(s,u,i)=>w(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(r.command)}else{const n=new F.$kM(r.title,r.kind?new F.$lM(r.kind):void 0);return r.edit&&(n.edit=k.WorkspaceEdit.to(r.edit)),r.command&&(n.command=i.fromInternal(r.command)),n.isPreferred=r.isPreferred,n}})(s))),new f.$FO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$DO.Uri],new f.$EO("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(u=>new F.$EM(k.Range.to(u.range),k.Color.to(u.color))):[])),new f.$FO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$DO("color","The color to show and insert",s=>s instanceof F.$DM,k.Color.from),new f.$DO("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new f.$EO("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new f.$FO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$DO.Uri,f.$DO.Range],new f.$EO("A promise that resolves to an array of Inlay objects",(s,u,i)=>s.map(k.InlayHint.to.bind(void 0,i)))),new f.$FO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$DO.Uri],new f.$EO("A promise that resolves to an array of FoldingRange objects",(s,u)=>{if(s)return s.map(k.FoldingRange.to)})),new f.$FO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$EO("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(u=>k.NotebookExclusiveDocumentPattern.to(u))})))),new f.$FO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$DO.Uri,f.$DO.Range,new f.$DO("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof F.$5L,s=>k.InlineValueContext.from(s))],new f.$EO("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new f.$FO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$DO("uriOrString","Uri-instance or string (only http/https)",s=>C.URI.isUri(s)||typeof s=="string"&&(0,P.$pg)(s,P.Schemas.http,P.Schemas.https),s=>s),new f.$DO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),f.$DO.String.with("label","").optional()],f.$EO.Void),new f.$FO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$DO.Uri.with("resource","Resource to open"),f.$DO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$DO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],f.$EO.Void),new f.$FO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$DO.Uri.with("left","Left-hand side resource of the diff editor"),f.$DO.Uri.with("right","Right-hand side resource of the diff editor"),f.$DO.String.with("title","Human readable title for the diff editor").optional(),new f.$DO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],f.$EO.Void),new f.$FO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$DO.String.with("title","Human readable title for the changes editor"),new f.$DO("resourceList","List of resources to compare",s=>{for(const u of s){if(u.length!==3)return!1;const[i,r,n]=u;if(!C.URI.isUri(i)||!C.URI.isUri(r)&&r!==void 0&&r!==null||!C.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],f.$EO.Void),new f.$FO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$DO.Uri,f.$DO.Position],new f.$EO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$FO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$DO.TypeHierarchyItem],new f.$EO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$FO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$DO.TypeHierarchyItem],new f.$EO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$FO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$DO.TestItem],f.$EO.Void),new f.$FO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$DO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$EO.Void),new f.$FO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$DO.String.with("name","The context key name"),new f.$DO("value","The context key value",()=>!0,s=>s)],f.$EO.Void),new f.$FO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$DO.Uri,f.$DO.StringArray,new f.$DO("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new f.$EO("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class l{static register(u){S.forEach(u.registerApiCommand,u),this.a(u)}static a(u){u.registerCommand(!1,"_validateWhenClauses",g.$dj)}}e.$Whc=l;function w(s){return u=>{if(Array.isArray(u))return u.map(s)}}function m(s){if(!Array.isArray(s))return;const u=[];for(const i of s)L.$Tt(i)?u.push(k.DefinitionLink.to(i)):u.push(k.location.to(i));return u}}),define(Me[272],Ae([1,0,11,6,2,3,31,8,7]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;class k{constructor(w,m){this.extension=w,this.provider=m,this.handle=k.a++}}k.a=0;class F{constructor(w){this.session=w,this.responses=[]}}class S{constructor(w,m,s,u){this.f=s,this.g=u,this.b=new Map,this.d=new Map,this.e=w.getProxy(L.$1L.MainThreadInlineChat),m.registerApiCommand(new M.$FO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$DO("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?g.Range.from(i.initialRange):void 0,initialSelection:f.$6L.isSelection(i.initialSelection)?g.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?g.Position.from(i.position):void 0}})],M.$EO.Void))}registerProvider(w,m,s){const u=new k(w,m);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,s?.label??w.displayName??w.name,w.identifier.value,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",s?.supportReportIssue??!1),(0,P.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(w,m,s,u){const i=this.b.get(w);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(C.URI.revive(m)),n=g.Selection.to(s),a=await i.provider.prepareInteractiveEditorSession({document:r,selection:n},u);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=S.a++;return this.d.set(h,new F(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:g.Range.from(a.wholeRange),message:a.message}}async $provideResponse(w,m,s,u){const i=this.b.get(w);if(!i)return;const r=this.d.get(m.id);if(!r)return;const n={prompt:s.prompt,selection:g.Selection.to(s.selection),wholeRange:g.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(C.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let a=!1;const h={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||u.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(g.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:f.$rM.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(i.provider.provideInteractiveEditorResponse(r.session,n,h,u));let $;try{$=await(0,D.$5g)(t,u)}finally{a=!0}if(!$)return;const c=r.responses.push($)-1,o={wholeRange:g.Range.from($.wholeRange),placeholder:$.placeholder};if(!S.h($))return{...o,id:c,type:"editorEdit",message:g.MarkdownString.from($.contents),edits:[]};const{edits:b,contents:p}=$,d=p!==void 0?g.MarkdownString.from(p):void 0;return b instanceof f.$aM?{...o,id:c,type:"bulkEdit",edits:g.WorkspaceEdit.from(b),message:d}:{...o,id:c,type:"editorEdit",edits:b.map(g.TextEdit.from),message:d}}async $provideFollowups(w,m,s,u){const i=this.b.get(w),r=this.d.get(m),n=r?.responses[s];if(i&&n&&i.provider.provideFollowups){const a=Promise.resolve(i.provider.provideFollowups(r.session,n,u));return(await(0,D.$5g)(a,u))?.map(g.ChatInlineFollowup.from)}}$handleFeedback(w,m,s,u){const i=this.b.get(w),r=this.d.get(m),n=r?.responses[s];if(i&&n){const a=g.InteractiveEditorResponseFeedbackKind.to(u);i.provider.handleInteractiveEditorResponseFeedback?.(r.session,n,a)}}$releaseSession(w,m){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$5ic=S,S.a=0}),define(Me[273],Ae([1,0,2,31]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;class C{constructor(M,g,f,k,F){this.a=g,this.b=f,this.c=k;const S=new P.$FO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.$DO("showOptions","Show Options",l=>!0,l=>l),new P.$DO("resource","Interactive resource Uri",l=>!0,l=>l),new P.$DO("controllerId","Notebook controller Id",l=>!0,l=>l),new P.$DO("title","Interactive editor title",l=>!0,l=>l)],new P.$EO("Notebook and input URI",l=>{if(F.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const w=this.a.getEditorById(l.notebookEditorId);return F.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:D.URI.revive(l.notebookUri),inputUri:D.URI.revive(l.inputUri),notebookEditor:w.apiEditor}}return F.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:D.URI.revive(l.notebookUri),inputUri:D.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(M,g,f,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:f,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$fjc=C}),define(Me[274],Ae([1,0,18,11,22,5,6,28,2,20,14,3,31,8,7,76,211,23,49,212]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=void 0;let a=class{constructor(d,I,v,y,E){this.m=I,this.n=v,this.o=y,this.q=E,this.b=new g.$Ac,this.c=new g.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$5d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(S.$1L.MainThreadNotebookKernels);const A=new l.$FO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$DO("options","Select kernel options",X=>!0,X=>{if(X&&"notebookEditor"in X&&"id"in X){const H=this.n.getIdByEditor(X.notebookEditor);return{id:X.id,extension:X.extension,notebookEditorId:H}}else if(X&&"notebookEditor"in X){const H=this.n.getIdByEditor(X.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${X.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return X})],l.$EO.Void),V=new l.$FO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$DO.Uri],new l.$EO("A promise that resolves to an array of variables",(X,H)=>X.map(O=>({name:O.name,value:O.value,type:O.type,editable:!1}))));this.o.registerApiCommand(A),this.o.registerApiCommand(V)}createNotebookController(d,I,v,y,E,A){for(const ke of this.j.values())if(ke.controller.id===I&&k.$xm.equals(d.identifier,ke.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const V=this.k++,X=this;this.q.trace(`NotebookController[${V}], CREATED by ${d.identifier.value}, ${I}`);const H=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${d.identifier}'`);let O=!1;const R=new L.$5d,B=new L.$5d,T={id:b(d.identifier,I),notebookType:v,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:y||d.identifier.value,preloads:A?A.map(w.NotebookRendererScript.from):[]};let te=E??H,Q,ce;this.a.$addKernel(V,T).catch(ke=>{console.log(ke),O=!0});let le=0;const se=()=>{if(O)return;const ke=++le;Promise.resolve().then(()=>{ke===le&&this.a.$updateKernel(V,T)})},$e=new g.$Ac,ne={get id(){return I},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return T.label},set label(ke){T.label=ke??d.displayName??d.name,se()},get detail(){return T.detail??""},set detail(ke){T.detail=ke,se()},get description(){return T.description??""},set description(ke){T.description=ke,se()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ke){T.supportedLanguages=ke,se()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ke){T.supportsExecutionOrder=ke,se()},get rendererScripts(){return T.preloads?T.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(ke){te=ke??H},get interruptHandler(){return Q},set interruptHandler(ke){Q=ke,T.supportsInterrupt=!!ke,se()},set variableProvider(ke){(0,i.$WF)(d,"notebookVariableProvider"),ce=ke,T.hasVariableProvider=!!ke,ke?.onDidChangeVariables(oe=>X.a.$variablesUpdated(oe.uri)),se()},get variableProvider(){return ce},createNotebookCellExecution(ke){if(O)throw new Error("notebook controller is DISPOSED");if(!$e.has(ke.notebook.uri))throw X.q.trace(`NotebookController[${V}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ke.notebook.uri.toString()}`);return X._createNotebookCellExecution(ke,b(d.identifier,this.id))},createNotebookExecution(ke){if((0,i.$WF)(d,"notebookExecution"),O)throw new Error("notebook controller is DISPOSED");if(!$e.has(ke.uri))throw X.q.trace(`NotebookController[${V}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ke.uri.toString()}`);return X._createNotebookExecution(ke,b(d.identifier,this.id))},dispose:()=>{O||(this.q.trace(`NotebookController[${V}], DISPOSED`),O=!0,this.j.delete(V),R.dispose(),B.dispose(),this.a.$removeKernel(V))},updateNotebookAffinity(ke,oe){oe===m.NotebookControllerAffinity2.Hidden&&(0,i.$WF)(d,"notebookControllerAffinityHidden"),X.a.$updateNotebookPriority(V,ke.uri,oe)},onDidReceiveMessage:B.event,postMessage(ke,oe){return(0,i.$WF)(d,"notebookMessaging"),X.a.$postMessage(V,oe&&X.n.getIdByEditor(oe),ke)},asWebviewUri(ke){return(0,i.$WF)(d,"notebookMessaging"),(0,s.$Jxb)(ke,X.m.remote)}};return this.j.set(V,{extensionId:d.identifier,controller:ne,onDidReceiveMessage:B,onDidChangeSelection:R,associatedNotebooks:$e}),ne}getIdByController(d){for(const[I,v]of this.j)if(v.controller===d)return b(v.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,I){const v=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(v,I);const E={dispose:()=>{this.f.delete(v),y.a.$removeKernelDetectionTask(v)}};return this.f.set(v,E),E}registerKernelSourceActionProvider(d,I,v){const y=this.i++,E=typeof v.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,A=this;this.h.set(y,v),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,I);let V;return E!==void 0&&(V=v.onDidChangeNotebookKernelSourceActions(X=>this.a.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this.h.delete(y),A.a.$removeKernelSourceActionProvider(y,y),V?.dispose()}}}async $provideKernelSourceActions(d,I){const v=this.h.get(d);if(v){const y=new M.$Sc;return(await v.provideNotebookKernelSourceActions(I)??[]).map(A=>w.NotebookKernelSourceAction.from(A,this.o.converter,y))}return[]}$acceptNotebookAssociation(d,I,v){const y=this.j.get(d);if(y){const E=this.n.getNotebookDocument(f.URI.revive(I));v?y.associatedNotebooks.set(E.uri,!0):y.associatedNotebooks.delete(E.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,E.uri.toString(),v),y.onDidChangeSelection.fire({selected:v,notebook:E.apiNotebook})}}async $executeCells(d,I,v){const y=this.j.get(d);if(!y)return;const E=this.n.getNotebookDocument(f.URI.revive(I)),A=[];for(const V of v){const X=E.getCell(V);X&&A.push(X.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,E.uri.toString(),A.length),await y.controller.executeHandler.call(y.controller,A,E.apiNotebook,y.controller)}catch(V){this.q.error(`NotebookController[${d}] execute cells FAILED`,V),console.error(V)}}async $cancelCells(d,I,v){const y=this.j.get(d);if(!y)return;const E=this.n.getNotebookDocument(f.URI.revive(I));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,E.apiNotebook);else for(const A of v){const V=E.getCell(A);V&&this.b.get(V.uri)?.cancel()}if(y.controller.interruptHandler){const A=this.c.get(E.uri);v.length&&Array.isArray(A)&&A.length&&A.forEach(V=>V.dispose())}}async $provideVariables(d,I,v,y,E,A,V){const X=this.j.get(d);if(!X)return;const H=this.n.getNotebookDocument(f.URI.revive(v)),O=X.controller.variableProvider;if(!O)return;let R;if(y!==void 0){if(R=this.s[y],!R)return}else this.s={};const B=E==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,T=O.provideVariables(H.apiNotebook,R,B,A,V);let te=0;for await(const Q of T){if(V.isCancellationRequested)return;const ce={id:this.r++,name:Q.variable.name,value:Q.variable.value,type:Q.variable.type,hasNamedChildren:Q.hasNamedChildren,indexedChildrenCount:Q.indexedChildrenCount,extensionId:X.extensionId.value};if(this.s[ce.id]=Q.variable,this.a.$receiveVariable(I,ce),te++>=n.$9gb)return}}$acceptKernelMessageFromRenderer(d,I,v){const y=this.j.get(d);if(!y)return;const E=this.n.getEditorById(I);y.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:v}))}$cellExecutionChanged(d,I,v){const E=this.n.getNotebookDocument(f.URI.revive(d)).getCell(I);if(E){const A=v?w.NotebookCellExecutionState.to(v):m.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:E.apiCell,state:A})}}_createNotebookCellExecution(d,I){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const E=new t(I,y,this.a);this.b.set(y.uri,E);const A=E.onDidChangeState(()=>{E.state===h.Resolved&&(E.dispose(),A.dispose(),this.b.delete(y.uri))});return E.asApiObject()}_createNotebookExecution(d,I){const v=this.n.getNotebookDocument(d.uri),y=d.getCells().find(V=>{const X=v.getCellFromApiCell(V);return X&&this.b.has(X.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const E=new c(I,v,this.a),A=E.onDidChangeState(()=>{E.state===$.Resolved&&(E.dispose(),A.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[E,A]),E.asApiObject()}};e.$njc=a,e.$njc=a=Xe([He(4,F.$yj)],a);var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class t extends M.$Tc{get state(){return this.f}constructor(d,I,v){super(),this.m=I,this.n=v,this.b=t.a++,this.c=new L.$5d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new C.$ce),this.h=new o(10,y=>this.s(y)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const I=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new r.$7v(I))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let I=this.m;if(d&&(I=this.m.notebook.getCellFromApiCell(d)),!I)throw new Error("INVALID cell");return I.handle}y(d){return d.map(I=>{const v=m.$uN.ensureUniqueMimeTypes(I.items,!0);return v===I.items?w.NotebookCellOutput.from(I):w.NotebookCellOutput.from({items:v,id:I.id,metadata:I.metadata})})}async z(d,I,v){const y=this.w(I),E=this.y((0,D.$3b)(d));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:y,append:v,outputs:E})}async C(d,I,v){return d=m.$uN.ensureUniqueMimeTypes((0,D.$3b)(d),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:d.map(w.NotebookCellOutputItem.from),outputId:I.id,append:v})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(v){d.j=v,d.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(v){if(d.f===h.Resolved||d.f===h.Started)throw new Error("Cannot call start again");d.f=h.Started,d.c.fire(),d.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,y){if(d.f===h.Resolved)throw new Error("Cannot call resolve twice");d.f=h.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new r.$7v({runEndTime:y,lastRunSuccess:v}))},clearOutput(v){return d.t(),d.z([],v,!1)},appendOutput(v,y){return d.t(),d.z(v,y,!0)},replaceOutput(v,y){return d.t(),d.z(v,y,!1)},appendOutputItems(v,y){return d.t(),d.C(v,y,!0)},replaceOutputItems(v,y){return d.t(),d.C(v,y,!1)}})}}t.a=0;var $;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})($||($={}));class c extends M.$Tc{get state(){return this.f}constructor(d,I,v){super(),this.h=I,this.j=v,this.b=c.a++,this.c=new L.$5d,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new C.$ce),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===$.Resolved||this.f===$.Started)throw new Error("Cannot call start again");this.f=$.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===$.Resolved)throw new Error("Cannot call resolve twice");this.f=$.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}c.a=0;class o{constructor(d,I){this.f=d,this.g=I,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new P.$Bh,this.b=Date.now(),(0,P.$fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>d.complete())}}function b(p,d){return`${p.value}/${d}`}e.$ojc=b}),define(Me[66],Ae([1,0,5,3,4,2,17,6,7,167,15,195,22,34,196,41,11,8,31]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=e.$Bic=e.$Aic=e.$zic=void 0,e.$zic=(0,C.$ei)("IExtHostTerminalService");class n{constructor(v,y,E,A){this.l=v,this._id=y,this.m=E,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(X=>this.f=X);const V=this;this.value={get name(){return V.n||""},get processId(){return V.b},get creationOptions(){return V.m},get exitStatus(){return V.h},get state(){return V.j},get selection(){return V.k},sendText(X,H=!0){V.q(),V.l.$sendText(V._id,X,H)},show(X){V.q(),V.l.$show(V._id,X)},hide(){V.q(),V.l.$hide(V._id)},dispose(){V.a||(V.a=!0,V.l.$dispose(V._id))},get dimensions(){if(!(V.d===void 0||V.g===void 0))return{columns:V.d,rows:V.g}}}}async create(v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??y?.cwd??void 0,env:v.env??void 0,icon:b(v.iconPath)??void 0,color:s.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(v.location,y?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,y,E,A,V){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:A,color:s.ThemeColor.isThemeColor(V)?V.id:void 0,location:y?.location||this.o(v,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,y){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in v?{viewColumn:i.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,y){this.h=Object.freeze({code:v,reason:y})}setDimensions(v,y){return v===this.d&&y===this.g||v===0||y===0?!1:(this.d=v,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(y=>{y!==v&&(this.b=Promise.resolve(v))})}}e.$Aic=n;class a{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new D.$5d,this.onProcessData=this.a.event,this.b=new D.$5d,this.d=new D.$5d,this.onDidChangeProperty=this.d.event,this.f=new D.$5d,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,y){this.g.setDimensions?.({columns:v,rows:y})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends g.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,y,E){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$5d,this.onDidCloseTerminal=this.H.event,this.I=new D.$5d,this.onDidOpenTerminal=this.I.event,this.J=new D.$5d,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$5d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$5d,this.onDidChangeTerminalState=this.M.event,this.N=new D.$5d,this.onDidChangeShell=this.N.event,this.O=new D.$5d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$5d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(P.$1L.MainThreadTerminalService),this.y=new m.$Ptb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:A=>{const V=X=>{const H=X;return this.W(H.instanceId)?.value};switch(A?.$mid){case 15:return V(A);default:{if(Array.isArray(A))for(let X=0;X<A.length&&A[X].$mid===15;X++)A[X]=V(A[X]);return A}}}}),this.B({dispose:()=>{for(const[A,V]of this.g)V.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,y){const E=new n(this.a,(0,w.$Ag)(),v,v.name),A=new a(v.pty);return E.createExtensionTerminal(v.location,y,this.R(v,y).resolvedExtHostIdentifier,b(v.iconPath),p(v.color)).then(V=>{const X=this.S(V,A);this.h[V]=X}),this.f.push(E),E.value}R(v,y){if(y=y||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const E=v.location.parentTerminal;if(E){const A=this.f.find(V=>V.value===E);A&&(y.resolvedExtHostIdentifier=A._id)}}else v.location&&typeof v.location!="object"?y.location=v.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(v,y){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const A=new a(y),V=this.S(v,A);this.h[v]=V}async $acceptActiveTerminalChanged(v){const y=this.b;if(v===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const E=this.W(v);E&&(this.b=E,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,y){const E=this.W(v);E&&this.O.fire({terminal:E.value,data:y})}async $acceptTerminalDimensions(v,y,E){const A=this.W(v);A&&A.setDimensions(y,E)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(v,y){const E=this.W(v);E&&this.P.fire({terminal:E.value,...y})}async $acceptTerminalMaximumDimensions(v,y,E){this.g.get(v)?.resize(y,E)}async $acceptTerminalTitleChange(v,y){const E=this.W(v);E&&(E.name=y)}async $acceptTerminalClosed(v,y,E){const A=this.Y(this.f,v);if(A!==null){const V=this.f.splice(A,1)[0];V.setExitStatus(y,E),this.H.fire(V.value)}}$acceptTerminalOpened(v,y,E,A){if(y){const H=this.Y(this.f,y);if(H!==null){this.f[H]._id=v,this.I.fire(this.terminals[H]),this.f[H].isOpen=!0;return}}const V={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},X=new n(this.a,v,V,E);this.f.push(X),this.I.fire(X.value),X.isOpen=!0}async $acceptTerminalProcessId(v,y){this.W(v)?._setProcessId(y)}async $startExtensionTerminal(v,y){const E=this.W(v);if(!E)return{message:(0,k.localize)(0,null,v)};E.isOpen||await new Promise(V=>{const X=this.onDidOpenTerminal(async H=>{H===E.value&&(X.dispose(),V())})});const A=this.g.get(v);A?A.startSendingEvents(y):this.j[v]={initialDimensions:y}}S(v,y){const E=new g.$Sc;E.add(y.onProcessReady(V=>this.a.$sendProcessReady(v,V.pid,V.cwd,V.windowsPty))),E.add(y.onDidChangeProperty(V=>this.a.$sendProcessProperty(v,V))),this.y.startBuffering(v,y.onProcessData),E.add(y.onProcessExit(V=>this.U(v,V))),this.g.set(v,y);const A=this.j[v];return A&&y instanceof a&&(y.startSendingEvents(A.initialDimensions),delete this.j[v]),E}$acceptProcessAckDataEvent(v,y){this.g.get(v)?.acknowledgeDataEvent(y)}$acceptProcessInput(v,y){this.g.get(v)?.input(y)}$acceptTerminalInteraction(v){const y=this.W(v);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(v,y){this.W(v)?.setSelection(y)}$acceptProcessResize(v,y,E){try{this.g.get(v)?.resize(y,E)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(v,y){this.g.get(v)?.shutdown(y)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(y=>this.a.$sendProcessProperty(v,{type:"cwd",value:y}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new f.$3L(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,y,E){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,E),this.a.$registerProfileProvider(y,v.identifier.value),new f.$3L(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(v,y,E){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,E),this.a.$registerQuickFixProvider(v,y),new f.$3L(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,y){const E=new l.$ce().token;if(E.isCancellationRequested)return;const A=this.D.get(v);if(!A)return;const V=await A.provideTerminalQuickFixes(y,E);if(V===null||Array.isArray(V)&&V.length===0)return;const X=new g.$Sc;if(this.w.value=X,!Array.isArray(V))return V?i.TerminalQuickFix.from(V,this.Q.converter,X):void 0;const H=[];for(const O of V){const R=i.TerminalQuickFix.from(O,this.Q.converter,X);R&&H.push(R)}return H}async $createContributedProfileTerminal(v,y){const E=new l.$ce().token;let A=await this.C.get(v)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,y);return}this.createTerminalFromOptions(A.options,y)}}async $provideLinks(v,y){const E=this.W(v);if(!E)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const V=new l.$ce;this.G.set(v,V);const X=[],H={terminal:E.value,line:y},O=[];for(const T of this.z)O.push(u.Promises.withAsyncBody(async te=>{V.token.onCancellationRequested(()=>te({provider:T,links:[]}));const Q=await T.provideTerminalLinks(H,V.token)||[];V.token.isCancellationRequested||te({provider:T,links:Q})}));const R=await Promise.all(O);if(V.token.isCancellationRequested)return[];const B=new Map;for(const T of R)T&&T.links.length>0&&X.push(...T.links.map(te=>{const Q={id:h++,startIndex:te.startIndex,length:te.length,label:te.tooltip};return B.set(Q.id,{provider:T.provider,link:te}),Q}));return this.F.set(v,B),X}$activateLink(v,y){const E=this.F.get(v)?.get(y);E&&E.provider.handleTerminalLink(E.link)}U(v,y){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const E=this.h[v];E&&(E.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,y)}W(v){return this.X(this.f,v)}X(v,y){const E=this.Y(v,y);return E!==null?v[E]:null}Y(v,y){const E=v.findIndex(A=>A._id===y);return E===-1?null:E}getEnvironmentVariableCollection(v){let y=this.n.get(v.identifier.value);return y||(y=new $,this.$(v.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(v,y){const E=(0,S.$Yr)(y.map),A=(0,S.$Zr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(v,y.persistent,E.length===0?void 0:E,A)}$initEnvironmentVariableCollections(v){v.forEach(y=>{const E=y[0],A=new $(y[1]);this.$(E,A)})}$acceptDefaultProfile(v,y){const E=this.s;this.s=v,this.u=y,E?.path!==v.path&&this.N.fire(v.path)}$(v,y){this.n.set(v,y),y.onDidChangeCollection(()=>{this.Z(v,y)})}};e.$Bic=t,e.$Bic=t=Xe([He(1,r.$BO),He(2,M.$fO)],t);class ${get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$5d,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const y=this.h(v);let E=this.a.get(y);return E||(E=new c(this,v),this.a.set(y,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(v,y,E,A){this.f(v,{value:y,type:f.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:A})}append(v,y,E,A){this.f(v,{value:y,type:f.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:A})}prepend(v,y,E,A){this.f(v,{value:y,type:f.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:A})}f(v,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(v,y.scope),A=this.map.get(E),V=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==y.value||A.type!==y.type||A.options?.applyAtProcessCreation!==V.applyAtProcessCreation||A.options?.applyAtShellIntegration!==V.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const X=this.g(v,y.scope),H={variable:v,...y,options:V};this.map.set(X,H),this.d.fire()}}get(v,y){const E=this.g(v,y),A=this.map.get(E);return A?d(A):void 0}g(v,y){const E=this.h(y);return E.length?`${v}:::${E}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const y=new Map;for(const[E,A]of this.map)this.h(A.scope)===this.h(v)&&y.set(A.variable,d(A));return y}delete(v,y){const E=this.g(v,y);this.map.delete(E),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[y,E]of this.map)E.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(y);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,y){const E=this.h(y),A=this.descriptionMap.get(E);if(!A||A.description!==v){let V;typeof v=="string"?V=v:V=v?.value.split(`

`)[0];const X={description:V,scope:y};this.descriptionMap.set(E,X),this.d.fire()}}getDescription(v){const y=this.h(v);return this.descriptionMap.get(y)?.description}k(v){const y=this.h(v);this.descriptionMap.delete(y)}}class c{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,y){this.b=v,this.d=y,this.a=new D.$5d}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,y,E){this.b.replace(v,y,E,this.d)}append(v,y,E){this.b.append(v,y,E,this.d)}prepend(v,y,E){this.b.prepend(v,y,E,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,y){this.b.getVariableMap(this.d).forEach((E,A)=>v.call(y,A,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends t{constructor(v,y){super(!1,v,y)}createTerminal(v,y,E){throw new F.$_}createTerminalFromOptions(v,y){throw new F.$_}};e.$Cic=o,e.$Cic=o=Xe([He(0,r.$BO),He(1,M.$fO)],o);function b(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function p(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function d(I){const v={...I};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}});var Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)},xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D};define(Me[275],Ae([1,0,11,24,22,5,246,97,6,26,16,34,14,3,17,111,8,7,48,75,60,23]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h){"use strict";var t,$,c,o,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=e.$Gjc=e.$Fjc=void 0;let p=class extends f.$Tc{constructor(Q,ce,le,se){super(),this.w=se,this.f=this.B(new L.$5d),this.g=new Map,this.s=this.B(new L.$5d),this.onResultsChanged=this.f.event,this.results=[],this.h=Q.getProxy(w.$1L.MainThreadTesting),this.m=new O(this.h),this.j=new y(this.h,ce),le.registerArgumentProcessor({processArgument:$e=>{switch($e?.$mid){case 16:{const ne=$e,ke=ne.tests[ne.tests.length-1].item.extId;return this.g.get(r.$RK.root(ke))?.collection.tree.get(ke)?.actual??(0,s.$rO)($e)}case 18:{const{extId:ne,message:ke}=$e;return{test:this.g.get(r.$RK.root(ne))?.collection.tree.get(ne)?.actual,message:u.TestMessage.to(ke)}}default:return $e}}}),le.registerCommand(!1,"testing.getExplorerSelection",async()=>{const $e=await le.executeCommand("_testing.getExplorerSelection"),ne=ke=>{const oe=this.g.get(r.$RK.root(ke));if(oe)return r.$RK.isRoot(ke)?oe.controller:oe.collection.tree.get(ke)?.actual};return{include:$e?.include.map(ne).filter(F.$1f)||[],exclude:$e?.exclude.map(ne).filter(F.$1f)||[]}})}createTestController(Q,ce,le,se){if(this.g.has(ce))throw new Error(`Attempt to insert a duplicate controller with ID "${ce}"`);const $e=new f.$Sc,ne=$e.add(new s.$uO(ce,le,this.w));ne.root.label=le;const ke=new Map,oe=new Set,ve=this.h,G={items:ne.root.children,get label(){return le},set label(ae){le=ae,ne.root.label=ae,ve.$updateController(ce,{label:le})},get refreshHandler(){return se},set refreshHandler(ae){se=ae,ve.$updateController(ce,{canRefresh:!!ae})},get id(){return ce},createRunProfile:(ae,De,ye,we,he,K)=>{let Y=(0,g.$5i)(ae);for(;ke.has(Y);)Y++;return new B(this.h,ke,oe,this.s.event,ce,Y,ae,De,ye,we,he,K)},createTestItem(ae,De,ye){return new s.$sO(ce,ae,De,ye)},createTestRun:(ae,De,ye=!0)=>this.j.createTestRun(Q,ce,ne,ae,De,ye),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const De=ae instanceof Array?ae:[ae];this.h.$markTestRetired(De.map(ye=>r.$RK.fromExtHostTestItem(ye,ce).toString()))}},set resolveHandler(ae){ne.resolveHandler=ae},get resolveHandler(){return ne.resolveHandler},dispose:()=>{$e.dispose()}};ve.$registerTestController(ce,le,!!se),$e.add((0,f.$Rc)(()=>ve.$unregisterTestController(ce)));const ge={controller:G,collection:ne,profiles:ke,extension:Q,activeProfiles:oe};return this.g.set(ce,ge),$e.add((0,f.$Rc)(()=>this.g.delete(ce))),$e.add(ne.onDidGenerateDiff(ae=>ve.$publishDiff(ce,ae.map(a.TestsDiffOp.serialize)))),G}createTestObserver(){return this.m.checkout()}async runTests(Q,ce=C.CancellationToken.None){const le=E(Q);if(!le)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const se=this.g.get(le.controllerId);if(!se)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:Q.include?.map($e=>r.$RK.fromExtHostTestItem($e,se.collection.root.id).toString())??[se.collection.root.id],profileGroup:T[le.kind],profileId:le.profileId,controllerId:le.controllerId}],exclude:Q.exclude?.map($e=>$e.id)},ce)}$syncTests(){for(const{collection:Q}of this.g.values())Q.flushDiff();return Promise.resolve()}async $provideFileCoverage(Q,ce,le){return await this.j.getCoverageReport(Q,ce)?.provideFileCoverage(le)??[]}async $resolveFileCoverage(Q,ce,le,se){return await this.j.getCoverageReport(Q,ce)?.resolveFileCoverage(le,se)??[]}$configureRunProfile(Q,ce){this.g.get(Q)?.profiles.get(ce)?.configureHandler?.()}$setDefaultRunProfiles(Q){const ce=new Map;for(const[le,se]of Object.entries(Q)){const $e=this.g.get(le);if(!$e)continue;const ne=new Map,ke=se.filter(ve=>!$e.activeProfiles.has(ve)),oe=[...$e.activeProfiles].filter(ve=>!se.includes(ve));for(const ve of ke)ne.set(ve,!0),$e.activeProfiles.add(ve);for(const ve of oe)ne.set(ve,!1),$e.activeProfiles.delete(ve);ne.size&&ce.set(le,ne)}this.s.fire(ce)}async $refreshTests(Q,ce){await this.g.get(Q)?.controller.refreshHandler?.(ce)}$publishTestResults(Q){this.results=Object.freeze(Q.map(ce=>(0,k.$Jn)(u.TestResults.to(ce))).concat(this.results).sort((ce,le)=>le.completedAt-ce.completedAt).slice(0,32)),this.f.fire()}async $expandTest(Q,ce){const le=this.g.get(r.$RK.fromString(Q).controllerId)?.collection;le&&(await le.expand(Q,ce<0?1/0:ce),le.flushDiff())}$acceptDiff(Q){this.m.applyDiff(Q.map(ce=>a.TestsDiffOp.deserialize({asCanonicalUri:le=>le},ce)))}async $runControllerTests(Q,ce){return Promise.all(Q.map(le=>this.y(le,!1,ce)))}async $startContinuousRun(Q,ce){const le=new C.$ce(ce),se=await Promise.all(Q.map($e=>this.y($e,!0,le.token)));return!ce.isCancellationRequested&&!se.some($e=>$e.error)&&await new Promise($e=>ce.onCancellationRequested($e)),le.dispose(!0),se}async y(Q,ce,le){const se=this.g.get(Q.controllerId);if(!se)return{};const{collection:$e,profiles:ne,extension:ke}=se,oe=ne.get(Q.profileId);if(!oe)return{};const ve=Q.testIds.map(De=>$e.tree.get(De)).filter(F.$1f),G=Q.excludeExtIds.map(De=>se.collection.tree.get(De)).filter(F.$1f).filter(De=>ve.some(ye=>ye.fullId.compare(De.fullId)===2));if(!ve.length)return{};const ge=new i.$BN(ve.some(De=>De.actual instanceof s.$tO)?void 0:ve.map(De=>De.actual),G.map(De=>De.actual),oe,ce),ae=(0,a.$TK)(Q)&&this.j.prepareForMainThreadTestRun(ge,A.fromInternal(Q,se.collection),ke,le);try{return await oe.runHandler(ge,le),{}}catch(De){return{error:String(De)}}finally{ae&&(ae.hasRunningTasks&&!le.isCancellationRequested&&await L.Event.toPromise(ae.onEnd),ae.dispose())}}$cancelExtensionTestRun(Q){Q===void 0?this.j.cancelAllRuns():this.j.cancelRunById(Q)}};e.$Fjc=p,e.$Fjc=p=Xe([He(0,m.$fO),He(1,l.$yj)],p);const d=1e4;var I;(function(te){te[te.Running=0]="Running",te[te.Cancelling=1]="Cancelling",te[te.Ended=2]="Ended"})(I||(I={}));class v extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(Q,ce,le,se,$e){super(),this.s=Q,this.w=ce,this.y=le,this.z=se,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$5d),this.m=this.B(new L.$5d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new C.$ce($e));const ne=this.B(new D.$qh(()=>this.C(),d));this.B(this.h.token.onCancellationRequested(()=>ne.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(Q){const ce=this.s.id,le=this.s.controllerId,se=(0,S.$Ag)(),$e=this.y,ne=this.m;let ke;const oe=ae=>(De,...ye)=>{if(G){this.z.warn(`Setting the state of test "${De.id}" is a no-op after the run ends.`);return}this.s.isIncluded(De)&&(this.F(De),ae(De,...ye))},ve=(ae,De)=>{const ye=De instanceof Array?De.map(u.TestMessage.from):[u.TestMessage.from(De)];if(ae.uri&&ae.range){const we={range:u.Range.from(ae.range),uri:ae.uri};for(const he of ye)he.location=he.location||we}this.w.$appendTestMessagesInRun(ce,se,r.$RK.fromExtHostTestItem(ae,le).toString(),ye)};let G=!1;const ge={isPersisted:this.s.isPersisted,token:this.h.token,name:Q,get coverageProvider(){return ke?.provider},set coverageProvider(ae){(0,h.$WF)($e,"testCoverage"),ke=ae&&new V(ae),ne.fire({taskId:se,runId:ce,coverage:ke})},enqueued:oe(ae=>{this.w.$updateTestStateInRun(ce,se,r.$RK.fromExtHostTestItem(ae,le).toString(),1)}),skipped:oe(ae=>{this.w.$updateTestStateInRun(ce,se,r.$RK.fromExtHostTestItem(ae,le).toString(),5)}),started:oe(ae=>{this.w.$updateTestStateInRun(ce,se,r.$RK.fromExtHostTestItem(ae,le).toString(),2)}),errored:oe((ae,De,ye)=>{ve(ae,De),this.w.$updateTestStateInRun(ce,se,r.$RK.fromExtHostTestItem(ae,le).toString(),6,ye)}),failed:oe((ae,De,ye)=>{ve(ae,De),this.w.$updateTestStateInRun(ce,se,r.$RK.fromExtHostTestItem(ae,le).toString(),4,ye)}),passed:oe((ae,De)=>{this.w.$updateTestStateInRun(ce,se,r.$RK.fromExtHostTestItem(ae,this.s.controllerId).toString(),3,De)}),appendOutput:(ae,De,ye)=>{G||(ye&&(this.s.isIncluded(ye)?this.F(ye):ye=void 0),this.w.$appendOutputToRun(ce,se,P.$se.fromString(ae),De&&u.location.from(De),ye&&r.$RK.fromExtHostTestItem(ye,le).toString()))},end:()=>{G||(G=!0,this.w.$finishedTestRunTask(ce,se),this.f.delete(se),this.f.size||this.D())}};return this.f.set(se,{run:ge}),this.w.$startedTestRunTask(ce,{id:se,name:Q,running:!0}),ge}C(){for(const{run:Q}of this.f.values())Q.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(Q){if(!(Q instanceof s.$sO))throw new n.$0N(Q.id);if(this.g.has(r.$RK.fromExtHostTestItem(Q,this.s.controllerId).toString()))return;const ce=[],le=this.s.colllection.root;for(;;){const se=u.TestItem.from(Q);if(ce.unshift(se),this.g.has(se.extId)||(this.g.add(se.extId),Q===le))break;Q=Q.parent||le}this.w.$addTestsToRun(this.s.controllerId,this.s.id,ce)}dispose(){this.D(),super.dispose()}}class y{get trackers(){return this.c.values()}constructor(Q,ce){this.g=Q,this.h=ce,this.c=new Map,this.f=[]}getCoverageReport(Q,ce){return this.f.find(le=>le.runId===Q)?.coverage.get(ce)}prepareForMainThreadTestRun(Q,ce,le,se){return this.j(Q,ce,le,se)}cancelRunById(Q){for(const ce of this.c.values())if(ce.id===Q){ce.cancel();return}}cancelAllRuns(){for(const Q of this.c.values())Q.cancel()}createTestRun(Q,ce,le,se,$e,ne){const ke=this.c.get(se);if(ke)return ke.createRun($e);const oe=A.fromPublic(ce,le,se,ne),ve=E(se);this.g.$startedExtensionTestRun({controllerId:ce,continuous:!!se.continuous,profile:ve&&{group:T[ve.kind],id:ve.profileId},exclude:se.exclude?.map(ge=>r.$RK.fromExtHostTestItem(ge,le.root.id).toString())??[],id:oe.id,include:se.include?.map(ge=>r.$RK.fromExtHostTestItem(ge,le.root.id).toString())??[le.root.id],persist:ne});const G=this.j(se,oe,Q);return L.Event.once(G.onEnd)(()=>{this.g.$finishedExtensionTestRun(oe.id),G.dispose()}),G.createRun($e)}j(Q,ce,le,se){const $e=new v(ce,this.g,le,this.h,se);this.c.set(Q,$e);let ne;const ke=$e.onDidCoverage(({runId:oe,taskId:ve,coverage:G})=>{ne||(ne={runId:oe,coverage:new Map},this.f.unshift(ne),this.f.length>a.$YK&&this.f.pop()),ne.coverage.set(ve,G),this.g.$signalCoverageAvailable(oe,ve,!!G)});return L.Event.once($e.onEnd)(()=>{this.c.delete(Q),ke.dispose()}),$e}}e.$Gjc=y;const E=te=>{if(te.profile){if(!(te.profile instanceof B))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return te.profile}};class A{static fromPublic(Q,ce,le,se){return new A(Q,(0,S.$Ag)(),le.include?.map($e=>r.$RK.fromExtHostTestItem($e,Q).toString())??[Q],le.exclude?.map($e=>r.$RK.fromExtHostTestItem($e,Q).toString())??[],se,ce)}static fromInternal(Q,ce){return new A(Q.controllerId,Q.runId,Q.testIds,Q.excludeExtIds,!0,ce)}constructor(Q,ce,le,se,$e,ne){this.controllerId=Q,this.id=ce,this.isPersisted=$e,this.colllection=ne,this.c=le.map(ke=>ke+"\0"),this.f=se.map(ke=>ke+"\0")}isIncluded(Q){const ce=r.$RK.fromExtHostTestItem(Q,this.controllerId).toString()+"\0";for(const le of this.f)if(ce===le||ce.startsWith(le))return!1;for(const le of this.c)if(ce===le||ce.startsWith(le))return!0;return!1}}e.$Hjc=A;class V{constructor(Q){this.provider=Q}async provideFileCoverage(Q){this.c||(this.c=(async()=>this.provider.provideFileCoverage(Q))());try{return(await this.c)?.map(u.TestCoverage.fromFile)??[]}catch(ce){throw this.c=void 0,ce}}async resolveFileCoverage(Q,ce){const le=await this.c;let se=le?.[Q];return!this.provider||!le||!se?[]:(se.detailedCoverage||(se=le[Q]=await this.provider.resolveFileCoverage?.(se,ce)??se),se.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class X{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(Q){this.j=Q,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(Q){this.c.add(Q)}update(Q){Object.assign(Q.revived,u.TestItem.toPlain(Q.item)),this.c.has(Q)||this.f.add(Q)}remove(Q){if(this.c.has(Q)){this.c.delete(Q);return}this.f.delete(Q);const ce=r.$RK.parentId(Q.item.extId);if(ce&&this.h.has(ce.toString())){this.h.add(Q.item.extId);return}this.g.add(Q)}getChangeEvent(){const{c:Q,f:ce,g:le}=this;return{get added(){return[...Q].map(se=>se.revived)},get updated(){return[...ce].map(se=>se.revived)},get removed(){return[...le].map(se=>se.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class H extends a.$ZK{constructor(){super(...arguments),this.s=new L.$5d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(Q){return this.f.get(Q)}getMirroredTestDataByReference(Q){return this.f.get(Q.id)}w(Q,ce){return{...Q,revived:u.TestItem.toPlain(Q.item),depth:ce?ce.depth+1:0,children:new Set}}v(){return new X(this.s)}}class O{constructor(Q){this.f=Q}checkout(){this.c||(this.c=this.g());const Q=this.c;return Q.observers++,{onDidChangeTest:Q.tests.onDidChangeTests,get tests(){return[...Q.tests.rootTests].map(ce=>ce.revived)},dispose:(0,M.$db)(()=>{--Q.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(Q){return this.c?.tests.getMirroredTestDataByReference(Q)}applyDiff(Q){this.c?.tests.apply(Q)}g(){const Q=new H({asCanonicalUri:ce=>ce});return this.f.$subscribeToDiffs(),{observers:0,tests:Q}}}const R=(te,Q,ce,le)=>{ce?Object.assign(ce,le):Q.$updateTestRunConfig(te.controllerId,te.profileId,le)};class B{get label(){return this.f}set label(Q){Q!==this.f&&(this.f=Q,R(this,Ue(this,t,"f"),Ue(this,o,"f"),{label:Q}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(Q){Q!==this.g&&(this.g=Q,R(this,Ue(this,t,"f"),Ue(this,o,"f"),{supportsContinuousRun:Q}))}get isDefault(){return Ue(this,$,"f").has(this.profileId)}set isDefault(Q){Q!==this.isDefault&&(Q?Ue(this,$,"f").add(this.profileId):Ue(this,$,"f").delete(this.profileId),R(this,Ue(this,t,"f"),Ue(this,o,"f"),{isDefault:Q}))}get tag(){return this._tag}set tag(Q){Q?.id!==this._tag?.id&&(this._tag=Q,R(this,Ue(this,t,"f"),Ue(this,o,"f"),{tag:Q?u.TestTag.namespace(this.controllerId,Q.id):null}))}get configureHandler(){return this.c}set configureHandler(Q){Q!==this.c&&(this.c=Q,R(this,Ue(this,t,"f"),Ue(this,o,"f"),{hasConfigurationHandler:!!Q}))}get onDidChangeDefault(){return L.Event.chain(Ue(this,c,"f"),Q=>Q.map(ce=>ce.get(this.controllerId)?.get(this.profileId)).filter(F.$1f))}constructor(Q,ce,le,se,$e,ne,ke,oe,ve,G=!1,ge=void 0,ae=!1){this.controllerId=$e,this.profileId=ne,this.f=ke,this.kind=oe,this.runHandler=ve,this._tag=ge,this.g=ae,t.set(this,void 0),$.set(this,void 0),c.set(this,void 0),o.set(this,void 0),b.set(this,void 0),xe(this,t,Q,"f"),xe(this,b,ce,"f"),xe(this,$,le,"f"),xe(this,c,se,"f"),ce.set(ne,this);const De=T[oe];if(typeof De!="number")throw new Error(`Unknown TestRunProfile.group ${oe}`);G&&le.add(ne),xe(this,o,{profileId:ne,controllerId:$e,tag:ge?u.TestTag.namespace(this.controllerId,ge.id):null,label:ke,group:De,isDefault:G,hasConfigurationHandler:!1,supportsContinuousRun:ae},"f"),queueMicrotask(()=>{Ue(this,o,"f")&&(Ue(this,t,"f").$publishTestRunProfile(Ue(this,o,"f")),xe(this,o,void 0,"f"))})}dispose(){Ue(this,b,"f")?.delete(this.profileId)&&(xe(this,b,void 0,"f"),Ue(this,t,"f").$removeTestProfile(this.controllerId,this.profileId)),xe(this,o,void 0,"f")}}e.$Ijc=B,t=new WeakMap,$=new WeakMap,c=new WeakMap,o=new WeakMap,b=new WeakMap;const T={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Me[112],Ae([1,0,55,15,88,8,7]),function(x,e,D,P,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oO=e.$nO=e.$mO=void 0;class g{constructor(l,w,m){const s=g.c.nextId();l.$registerTextEditorDecorationType(w.identifier,s,L.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$mO=g,g.c=new C.$kO("TextEditorDecorationType");class f{constructor(l,w){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,w){this.k();let m=null;if(l instanceof M.$4L)m=new M.$5L(l,l);else if(l instanceof M.$5L)m=l;else throw new Error("Unrecognized location");this.l(m,w,!1)}insert(l,w){this.k(),this.l(new M.$5L(l,l),w,!0)}delete(l){this.k();let w=null;if(l instanceof M.$5L)w=l;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(l,w,m){const s=this.c.validateRange(l);this.g.push({range:s,text:w,forceMoveMarkers:m})}setEndOfLine(l){if(this.k(),l!==M.EndOfLine.LF&&l!==M.EndOfLine.CRLF)throw(0,P.$7)("endOfLine");this.h=l}}class k{constructor(l,w,m,s){this.c=l,this.d=w,this._accept(m),this.e=s;const u=this;this.value={get tabSize(){return u.f},set tabSize(i){u.n(i)},get indentSize(){return u.g},set indentSize(i){u.p(i)},get insertSpaces(){return u.j},set insertSpaces(i){u.s(i)},get cursorStyle(){return u.k},set cursorStyle(i){u.t(i)},get lineNumbers(){return u.l},set lineNumbers(i){u.u(i)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}n(l){const w=this.m(l);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}p(l){const w=this.o(l);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const w=this.q(l);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let m=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(m=!0,w.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,w.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(m=!0,w.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,m=!0,w.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(m=!0,w.insertSpaces=s):this.j!==s&&(this.j=s,m=!0,w.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,m=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,m=!0,w.lineNumbers=L.TextEditorLineNumbersStyle.from(l.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(l,w){w.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(m)})}}e.$nO=k;class F{constructor(l,w,m,s,u,i,r,n){this.id=l,this.j=w,this.k=m,this.g=!1,this.h=new Set,this.c=u,this.d=new k(this.j,this.id,i,m),this.e=r,this.f=n;const a=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new P.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof M.$6L))throw(0,P.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof M.$6L)))throw(0,P.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new P.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new P.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const $=new f(s.value,t);return h($),a.m($)},insertSnippet(h,t,$={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map(o=>L.Range.from(o));else if(t instanceof M.$4L){const{lineNumber:o,column:b}=L.Position.from(t);c=[{startLineNumber:o,startColumn:b,endLineNumber:o,endColumn:b}]}else if(t instanceof M.$5L)c=[L.Range.from(t)];else{c=[];for(const o of t)if(o instanceof M.$5L)c.push(L.Range.from(o));else{const{lineNumber:b,column:p}=L.Position.from(o);c.push({startLineNumber:b,startColumn:p,endLineNumber:b,endColumn:p})}}return w.$tryInsertSnippet(l,s.value.version,h.value,c,$)},setDecorations(h,t){const $=t.length===0;$&&!a.h.has(h.key)||($?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(L.$cO(t))return w.$trySetDecorations(l,h.key,L.$dO(t));{const c=new Array(4*t.length);for(let o=0,b=t.length;o<b;o++){const p=t[o];c[4*o]=p.start.line+1,c[4*o+1]=p.start.character+1,c[4*o+2]=p.end.line+1,c[4*o+3]=p.end.character+1}return w.$trySetDecorationsFast(l,h.key,c)}}))},revealRange(h,t){a.n(()=>w.$tryRevealRange(l,L.Range.from(h),t||M.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(l,L.ViewColumn.from(h))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,D.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,D.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,D.ok)(!this.g),this.f=l}_acceptSelections(l){(0,D.ok)(!this.g),this.c=l}async l(){const l=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const m=w.edits.map(u=>u.range);m.sort((u,i)=>u.end.line===i.end.line?u.end.character===i.end.character?u.start.line===i.start.line?u.start.character-i.start.character:u.start.line-i.start.line:u.end.character-i.end.character:u.end.line-i.end.line);for(let u=0,i=m.length-1;u<i;u++){const r=m[u].end;if(m[u+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=w.edits.map(u=>({range:L.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,s,{setEndOfLine:typeof w.setEndOfLine=="number"?L.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$oO=F}),define(Me[67],Ae([1,0,55,5,6,2,4,3,109,17,112,8,14,28,12,53,40]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=e.$pO=void 0;class i{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new P.$5d,this.e=new P.$5d,this.f=new P.$5d,this.g=new P.$5d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],$=[];if(a.removedDocuments)for(const c of a.removedDocuments){const o=L.URI.revive(c),b=this.c.get(o);b?.unref()&&(this.c.delete(o),h.push(b.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const o=L.URI.revive(c.uri);let b=this.c.get(o);if(b&&o.scheme!==m.Schemas.vscodeNotebookCell&&o.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);b||(b=new i(new f.$iO(this.h.getProxy(g.$1L.MainThreadDocuments),o,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set(o,b),t.push(b.value)),b.ref()}if(a.removedEditors)for(const c of a.removedEditors){const o=this.b.get(c);this.b.delete(c),o&&$.push(o)}if(a.addedEditors)for(const c of a.addedEditors){const o=L.URI.revive(c.documentUri);D.ok(this.c.has(o),`document '${o}' does not exist`),D.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const b=this.c.get(o).value,p=new F.$oO(c.id,this.h.getProxy(g.$1L.MainThreadTextEditors),this.i,new u.$V(()=>b.document),c.selections.map(S.Selection.to),c.options,c.visibleRanges.map(d=>S.Range.to(d)),typeof c.editorPosition=="number"?S.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,p)}a.newActiveEditor!==void 0&&(D.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,C.$Oc)(h),(0,C.$Oc)($),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return s.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$pO=r,e.$pO=r=Xe([He(0,k.$fO),He(1,l.$yj)],r),e.$qO=(0,M.$ei)("IExtHostDocumentsAndEditors")}),define(Me[276],Ae([1,0,18,5,3,112,8,7]),function(x,e,D,P,C,L,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class f{constructor(F,S){this.i=S,this.a=new P.$5d,this.b=new P.$5d,this.c=new P.$5d,this.d=new P.$5d,this.f=new P.$5d,this.g=new P.$5d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=F.getProxy(C.$1L.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(F){const S=this.i.allEditors();return F?S:S.map(l=>l.value)}async showTextDocument(F,S,l){let w;typeof S=="number"?w={position:M.ViewColumn.from(S),preserveFocus:l}:typeof S=="object"?w={position:M.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?M.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:w={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(F.uri,w),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,S){return new L.$mO(this.h,F,S).value}$acceptEditorPropertiesChanged(F,S){const l=this.i.getEditor(F);if(!l)throw new Error("unknown text editor");if(S.options&&l._acceptOptions(S.options),S.selections){const w=S.selections.selections.map(M.Selection.to);l._acceptSelections(w)}if(S.visibleRanges){const w=D.$Hb(S.visibleRanges.map(M.Range.to));l._acceptVisibleRanges(w)}if(S.options&&this.b.fire({textEditor:l.value,options:{...S.options,lineNumbers:M.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const w=g.TextEditorSelectionChangeKind.fromValue(S.selections.source),m=S.selections.selections.map(M.Selection.to);this.a.fire({textEditor:l.value,selections:m,kind:w})}if(S.visibleRanges){const w=D.$Hb(S.visibleRanges.map(M.Range.to));this.c.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(F){for(const S in F){const l=this.i.getEditor(S);if(!l)throw new Error("Unknown text editor");const w=M.ViewColumn.to(F[S]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this.d.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(F){return Promise.resolve(this.h.$getDiffInformation(F))}}e.$5hc=f}),define(Me[277],Ae([1,0,2,4,3,6,7,8,20,16]),function(x,e,D,P,C,L,M,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,P.$ei)("IExtHostTimeline");class F{constructor(w,m){this.b=new Map,this.c=new Map,this.a=w.getProxy(C.$1L.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,u)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$xm.equals(u,this.b.get(s.source)?.extension)){const i=s.uri===void 0?void 0:D.URI.revive(s.uri);return this.c.get(s.source)?.get(S(i))?.get(s.handle)}else return;return s}})}async $getTimeline(w,m,s,u){return this.b.get(w)?.provider.provideTimeline(D.URI.revive(m),s,u)}registerTimelineProvider(w,m,s,u){const i=new L.$Sc,r=this.d(m.id,u,i).bind(this);let n;m.onDidChange&&(n=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const a=this.c;return this.f({...m,scheme:w,onDidChange:void 0,async provideTimeline(h,t,$){t?.resetCache&&(i.clear(),a.get(m.id)?.clear());const c=await m.provideTimeline(h,t,$);if(c==null)return;const o=r(h,t);return{...c,source:m.id,items:c.items.map(o)}},dispose(){for(const h of a.values())h.get(m.id)?.clear();n?.dispose(),i.dispose()}},s)}d(w,m,s){return(u,i)=>{let r;if(i?.cacheResults){let n=this.c.get(w);n===void 0&&(n=new Map,this.c.set(w,n));const a=S(u);r=n.get(a),r===void 0&&(r=new Map,n.set(a,r))}return n=>{const{iconPath:a,...h}=n,t=`${w}|${n.id??n.timestamp}`;r?.set(t,n);let $,c,o;n.iconPath&&(a instanceof M.$XM?o={id:a.id,color:a.color}:D.URI.isUri(a)?($=a,c=a):{light:$,dark:c}=a);let b;return M.$rM.isMarkdownString(h.tooltip)?b=g.MarkdownString.from(h.tooltip):(0,k.$Sf)(h.tooltip)?b=h.tooltip:M.$rM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=g.MarkdownString.from(h.detail)):(0,k.$Sf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=h.detail),{...h,id:h.id??void 0,handle:t,source:w,command:n.command?m.toInternal(n.command,s):void 0,icon:$,iconDark:c,themeIcon:o,tooltip:b,accessibilityInformation:n.accessibilityInformation}}}}f(w,m){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:m}),(0,L.$Rc)(()=>{for(const u of this.c.values())u.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Ljc=F;function S(l){return l?.toString()}}),define(Me[278],Ae([1,0,168,25,2,5,6,206,11,7,16,18,8,52,22,140,23]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;function i(a,h){if((0,F.$Sf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter($=>$.length===2&&typeof $[0]=="number"&&typeof $[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class r extends M.$Tc{constructor(h,t,$){super(),this.f=h,this.g=t,this.h=$,this.a=new Map,this.b=new s.$I9;function c(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>c(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(b=>c(b)?this.r(b):b):o})}registerTreeDataProvider(h,t,$){const c=this.createTreeView(h,{treeDataProvider:t},$);return{dispose:()=>c.dispose()}}createTreeView(h,t,$){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,d=this.m(h,t,$),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:o,hasHandleDrag:b,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,I),y={get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,u.$WF)($,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,u.$WF)($,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(E){(0,w.$uk)(E)&&(0,u.$WF)($,"treeViewMarkdownMessage"),d.message=E},get title(){return d.title},set title(E){d.title=E},get description(){return d.description},set description(E){d.description=E},get badge(){return d.badge},set badge(E){E!==void 0&&k.ViewBadge.isViewBadge(E)?d.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(d.badge=void 0)},reveal:(E,A)=>d.reveal(E,A),dispose:async()=>{await v,this.a.delete(h),d.dispose()}};return this.B(y),y}$getChildren(h,t){const $=this.a.get(h);return $?$.getChildren(t):Promise.reject(new g.$pF(h))}async $handleDrop(h,t,$,c,o,b,p,d){const I=this.a.get(h);if(!I)return Promise.reject(new g.$pF(h));const v=l.DataTransfer.toDataTransfer($,async y=>(await this.f.$resolveDropFileData(h,t,y)).buffer);return p===h&&d&&await this.j(v,I,d,o,b),I.onDrop(v,c,o)}async j(h,t,$,c,o){const b=this.b.removeDragOperationTransfer(o);if(b)(await b)?.forEach((p,d)=>{p&&h.set(d,p)});else if(o&&t.handleDrag){const p=t.handleDrag($,h,c);this.b.addDragOperationTransfer(o,p),await p}return h}async $handleDrag(h,t,$,c){const o=this.a.get(h);if(!o)return Promise.reject(new g.$pF(h));const b=await this.j(new k.$UM,o,t,c,$);if(!(!b||c.isCancellationRequested))return l.DataTransfer.from(b)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new g.$pF(h);return t.hasResolve}$resolve(h,t,$){const c=this.a.get(h);if(!c)throw new g.$pF(h);return c.resolveTreeItem(t,$)}$setExpanded(h,t,$){const c=this.a.get(h);if(!c)throw new g.$pF(h);c.setExpanded(t,$)}$setSelectionAndFocus(h,t,$){const c=this.a.get(h);if(!c)throw new g.$pF(h);c.setSelectionAndFocus(t,$)}$setVisible(h,t){const $=this.a.get(h);if(!$){if(!t)return;throw new g.$pF(h)}$.setVisible(t)}$changeCheckboxState(h,t){const $=this.a.get(h);if(!$)throw new g.$pF(h);$.setCheckboxState(t)}m(h,t,$){const c=this.B(new n(h,t,this.f,this.g.converter,this.h,$));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Mjc=r;class n extends M.$Tc{get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,F.$2f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,$,c,o,b){if(super(),this.I=h,this.J=$,this.L=c,this.M=o,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$5d),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$5d),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$5d),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$5d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$5d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$5d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$5d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$ce,b.contributes&&b.contributes.views)for(const v in b.contributes.views)for(const y of b.contributes.views[v])y.id===h&&(this.P=y.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let p,d;const I=L.Event.debounce(this.F.event,(v,y)=>(v||(v={message:!1,elements:[]}),y.element!==!1&&(p||(p=new Promise(E=>d=E),this.G=this.G.then(()=>p)),Array.isArray(y.element)?v.elements.push(...y.element):v.elements.push(y.element)),y.message&&(v.message=!0),v),200,!0);this.B(I(({message:v,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const E=d;return p=null,this.$(y).then(()=>E())})),v&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let $=this.X(h);return $||($=await this.Y(t)),$?$.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const $=(0,F.$2f)(t.select)?!0:t.select,c=(0,F.$2f)(t.focus)?!1:t.focus,o=(0,F.$2f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(b=>this.W(h,b[b.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:b.map(d=>d.item)},{select:$,focus:c,expand:o})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:$,focus:c,expand:o})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const $=this.getExtensionElement(h);$&&(t?this.u.fire(Object.freeze({element:$})):this.w.fire(Object.freeze({element:$})))}setSelectionAndFocus(h,t){const $=!(0,S.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,$&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async $=>{const c=this.getExtensionElement($.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:$.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter($=>$!==void 0);t.forEach($=>{$.treeItem.checkboxState=$.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map($=>[$.extensionItem,$.newState])})}async handleDrag(h,t,$){const c=[];for(const o of h){const b=this.getExtensionElement(o);b&&c.push(b)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,$),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,$){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,f.$9g)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,$):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const $=this.j.get(h);if($){const c=this.m.get($);if(c){const o=await this.f.resolveTreeItem(c.extensionItem,$,t)??c.extensionItem;return this.hb(o),c.item.tooltip=this.eb(o.tooltip),c.item.command=this.fb(c.disposableStore,o.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then($=>this.W(t,$[$.length-1]).then(c=>($.push(c),$))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$9g)(()=>this.f.getParent(h))}W(h,t){const $=this.m.get(h);return $?Promise.resolve($):(0,f.$9g)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(c);if(o){const b=this.m.get(o);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const $=this.getExtensionElement(h);t=$?this.m.get($):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new m.$ce(this.Z.token);try{const $=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const o=(0,S.$Hb)(c||[]),b=await Promise.all((0,S.$Hb)(o).map(d=>this.f.getTreeItem(d)));if(t.token.isCancellationRequested)return;const p=b.map((d,I)=>d?this.db(o[I],d,$):null);return(0,S.$Hb)(p)}finally{t.dispose()}}$(h){if(h.some($=>!$))return this.Z.dispose(!0),this.Z=new m.$ce,this.tb(),this.J.$refresh(this.I);{const $=this.ab(h);if($.length)return this.bb($)}return Promise.resolve(void 0)}ab(h){const t=new Set,$=h.map(o=>this.m.get(o));for(const o of $)if(o&&!t.has(o.item.handle)){let b=o;for(;b&&b.parent&&$.findIndex(p=>b&&b.parent&&p&&p.item.handle===b.parent.item.handle)===-1;){const p=this.j.get(b.parent.item.handle);b=p?this.m.get(p):void 0}b&&!b.parent&&t.add(o.item.handle)}const c=[];return t.forEach(o=>{const b=this.j.get(o);if(b){const p=this.m.get(b);p&&(!p.parent||!t.has(p.parent.item.handle))&&c.push(o)}}),c}bb(h){const t={};return Promise.all(h.map($=>this.cb($).then(c=>{c&&(t[$]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const $=this.m.get(t);if($)return this.rb(t),(0,f.$9g)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const o=this.ib(t,c,$.parent);return this.pb(t,o,$,$.parent),$.dispose(),o}return null})}return Promise.resolve(null)}db(h,t,$){const c=this.ib(h,t,$);if(t.id&&this.j.has(c.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,$),c}eb(h){return k.$rM.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,$,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,$=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:$,accessibilityInformation:c}}hb(h){if(!k.$PM.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,$){this.hb(t);const c=this.B(new M.$Sc),o=this.kb(h,t,$),b=this.lb(t);return{item:{handle:o,parentHandle:$?$.item.handle:void 0,label:i(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:b,iconDark:this.mb(t)||b,themeIcon:this.jb(t),collapsibleState:(0,F.$2f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:$,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof k.$XM?h.iconPath:void 0}kb(h,{id:t,label:$,resourceUri:c},o,b){if(t)return`${n.b}/${t}`;const p=i($,this.N),d=o?o.item.handle:n.a;let I=p?p.label:c?(0,P.$Og)(c):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(o)||[];let E,A=0;do{if(E=`${d}/${A}:${I}`,b||!this.j.has(E)||v===E)break;A++}while(A<=y.length);return E}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$XM))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$XM)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,$,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==$.item.handle&&this.j.delete($.item.handle),this.ob(h,t);const o=this.X(c)||[],b=o.filter(p=>p.item.handle===$.item.handle)[0];b&&o.splice(o.indexOf(b),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const $ of t.children){const c=this.j.get($.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const $ of t.children){const c=this.j.get($.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}n.a="0",n.b="1"});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[279],Ae([1,0,5,6,2,34,8,62,3,7]),function(x,e,D,P,C,L,M,g,f,k){"use strict";var F,S,l,w,m,s,u,i,r,n,a,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class $ extends P.$Tc{constructor(p,d,I,v){super(),F.set(this,void 0),S.set(this,void 0),l.set(this,void 0),w.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),i.set(this,void 0),r.set(this,!0),n.set(this,void 0),a.set(this,!1),h.set(this,this.B(new D.$5d)),this.onDidDispose=Ue(this,h,"f").event,t.set(this,this.B(new D.$5d)),this.onDidChangeViewState=Ue(this,t,"f").event,xe(this,F,p,"f"),xe(this,S,d,"f"),xe(this,w,I,"f"),xe(this,l,v.viewType,"f"),xe(this,m,v.panelOptions,"f"),xe(this,i,v.viewColumn,"f"),xe(this,s,v.title,"f"),xe(this,n,v.active,"f")}dispose(){Ue(this,a,"f")||(xe(this,a,!0,"f"),Ue(this,h,"f").fire(),Ue(this,S,"f").$disposeWebview(Ue(this,F,"f")),Ue(this,w,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,w,"f")}get viewType(){return this.c(),Ue(this,l,"f")}get title(){return this.c(),Ue(this,s,"f")}set title(p){this.c(),Ue(this,s,"f")!==p&&(xe(this,s,p,"f"),Ue(this,S,"f").$setTitle(Ue(this,F,"f"),p))}get iconPath(){return this.c(),Ue(this,u,"f")}set iconPath(p){this.c(),Ue(this,u,"f")!==p&&(xe(this,u,p,"f"),Ue(this,S,"f").$setIconPath(Ue(this,F,"f"),C.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Ue(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,i,"f")=="number"&&Ue(this,i,"f")<0))return Ue(this,i,"f")}get active(){return this.c(),Ue(this,n,"f")}get visible(){return this.c(),Ue(this,r,"f")}_updateViewState(p){Ue(this,a,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(xe(this,n,p.active,"f"),xe(this,r,p.visible,"f"),xe(this,i,p.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(p,d){this.c(),Ue(this,S,"f").$reveal(Ue(this,F,"f"),{viewColumn:typeof p>"u"?void 0:M.ViewColumn.from(p),preserveFocus:!!d})}c(){if(Ue(this,a,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,S=new WeakMap,l=new WeakMap,w=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,i=new WeakMap,r=new WeakMap,n=new WeakMap,a=new WeakMap,h=new WeakMap,t=new WeakMap;class c extends P.$Tc{static c(){return(0,L.$Ag)()}constructor(p,d,I){super(),this.j=d,this.m=I,this.g=new Map,this.h=new Map,this.f=p.getProxy(f.$1L.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,d,I,v,y={}){const E=typeof v=="object"?v.viewColumn:v,A={viewColumn:M.ViewColumn.from(E),preserveFocus:typeof v=="object"&&!!v.preserveFocus},V=(0,g.$hic)(p),X=c.c();this.f.$createWebviewPanel((0,g.$jic)(p),X,d,{title:I,panelOptions:o(y),webviewOptions:(0,g.$kic)(p,this.m,y),serializeBuffersForPostMessage:V},A);const H=this.j.createNewWebview(X,y,p);return this.createNewWebviewPanel(X,d,I,E,y,H,!0)}$onDidChangeWebviewPanelViewStates(p){const d=Object.keys(p);d.sort((I,v)=>{const y=p[I],E=p[v];return y.active?1:E.active?-1:+y.visible-+E.visible});for(const I of d){const v=this.getWebviewPanel(I);if(!v)continue;const y=p[I];v._updateViewState({active:y.active,visible:y.visible,viewColumn:M.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,d,I){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:I,extension:p}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,g.$hic)(p)}),new k.$3L(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel(p,d,I,v){const y=this.h.get(d);if(!y)throw new Error(`No serializer found for '${d}'`);const{serializer:E,extension:A}=y,V=this.j.createNewWebview(p,I.webviewOptions,A),X=this.createNewWebviewPanel(p,d,I.title,v,I.panelOptions,V,I.active);await E.deserializeWebviewPanel(X,I.state)}createNewWebviewPanel(p,d,I,v,y,E,A){const V=new $(p,this.f,E,{viewType:d,title:I,viewColumn:v,panelOptions:y,active:A});return this.g.set(p,V),V}getWebviewPanel(p){return this.g.get(p)}}e.$lic=c;function o(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[280],Ae([1,0,5,6,62,8,3,7]),function(x,e,D,P,C,L,M,g){"use strict";var f,k,F,S,l,w,m,s,u,i,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;class n extends P.$Tc{constructor(t,$,c,o,b,p){super(),f.set(this,void 0),k.set(this,void 0),F.set(this,void 0),S.set(this,void 0),l.set(this,!1),w.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),i.set(this,this.B(new D.$5d)),this.onDidChangeVisibility=Ue(this,i,"f").event,r.set(this,this.B(new D.$5d)),this.onDidDispose=Ue(this,r,"f").event,xe(this,F,c,"f"),xe(this,m,o,"f"),xe(this,f,t,"f"),xe(this,k,$,"f"),xe(this,S,b,"f"),xe(this,w,p,"f")}dispose(){Ue(this,l,"f")||(xe(this,l,!0,"f"),Ue(this,r,"f").fire(),Ue(this,S,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,m,"f")}set title(t){this.a(),Ue(this,m,"f")!==t&&(xe(this,m,t,"f"),Ue(this,k,"f").$setWebviewViewTitle(Ue(this,f,"f"),t))}get description(){return this.a(),Ue(this,s,"f")}set description(t){this.a(),Ue(this,s,"f")!==t&&(xe(this,s,t,"f"),Ue(this,k,"f").$setWebviewViewDescription(Ue(this,f,"f"),t))}get visible(){return Ue(this,w,"f")}get webview(){return Ue(this,S,"f")}get viewType(){return Ue(this,F,"f")}_setVisible(t){t===Ue(this,w,"f")||Ue(this,l,"f")||(xe(this,w,t,"f"),Ue(this,i,"f").fire())}get badge(){return this.a(),Ue(this,u,"f")}set badge(t){this.a(),!(t?.value===Ue(this,u,"f")?.value&&t?.tooltip===Ue(this,u,"f")?.tooltip)&&(xe(this,u,L.ViewBadge.from(t),"f"),Ue(this,k,"f").$setWebviewViewBadge(Ue(this,f,"f"),t))}show(t){this.a(),Ue(this,k,"f").$show(Ue(this,f,"f"),!!t)}a(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}f=new WeakMap,k=new WeakMap,F=new WeakMap,S=new WeakMap,l=new WeakMap,w=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,i=new WeakMap,r=new WeakMap;class a{constructor(t,$){this.d=$,this.b=new Map,this.c=new Map,this.a=t.getProxy(M.$1L.MainThreadWebviewViews)}registerWebviewViewProvider(t,$,c,o){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:c,extension:t}),this.a.$registerWebviewViewProvider((0,C.$jic)(t),$,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$hic)(t)}),new g.$3L(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(t,$,c,o,b){const p=this.b.get($);if(!p)throw new Error(`No view provider found for '${$}'`);const{provider:d,extension:I}=p,v=this.d.createNewWebview(t,{},I),y=new n(t,this.a,$,c,v,!0);this.c.set(t,y),await d.resolveWebviewView(y,{state:o},b)}async $onDidChangeWebviewViewVisibility(t,$){this.e(t)._setVisible($)}async $disposeWebviewView(t){const $=this.e(t);this.c.delete(t),$.dispose(),this.d.deleteWebview(t)}e(t){const $=this.c.get(t);if(!$)throw new Error("No webview found");return $}}e.$Pjc=a}),define(Me[281],Ae([1,0,5,30,36,4]),function(x,e,D,P,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.OutputChannelUpdateMode=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=void 0,e.$_K="text/x-code-output",e.$aL="output",e.$bL="Log",e.$cL="text/x-code-log-output",e.$dL="log",e.$eL="workbench.panel.output",e.$fL=new C.$vj("inOutput",!1),e.$gL=new C.$vj("activeLogOutput",!1),e.$hL=new C.$vj("outputView.scrollLock",!1),e.$iL=(0,L.$ei)("outputService");var M;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$jL={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new D.$5d,this.onDidRegisterChannel=this.b.event,this.c=new D.$5d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(F=>k.push(F)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}P.$Un.add(e.$jL.OutputChannels,new g),e.$kL=new C.$vj("activeOutputChannel","")}),define(Me[113],Ae([1,0,3,4,17,20,14,281,63,27,43,144,24,16,42,5,6]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=e.$qjc=void 0;class i extends M.$Ej{get disposed(){return this.n}constructor(h,t,$,c,o){super(),this.id=h,this.name=t,this.r=$,this.s=c,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel($.getLevel()),this.B($.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$se.fromString(t).byteLength,(0,M.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends i{appendLine(h){this.append(h)}}let n=class{constructor(h,t,$,c,o,b){this.i=t,this.j=$,this.k=c,this.l=o,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(D.$1L.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$Jm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,$]of this.g)$.visible=t===this.h}createOutputChannel(h,t,$){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,o=(0,w.$Sf)(t)?t:void 0;if((0,w.$Sf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const p=this.i.environment.extensionLogLevel?.find(([I])=>L.$xm.equals($.identifier,I))?.[1];p&&(b=(0,M.$Oj)(p));const d=c?this.o(h,b,$):this.n(h,o,$);return d.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),c?this.r(h,b??this.m.getLevel(),d):this.q(h,d)}async n(h,t,$){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,o=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(h,o,t,$.identifier.value);return new i(p,h,b,this.a,$)}async o(h,t,$){const c=await this.p($),o=h.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(c,`${o}.log`),p=`${$.identifier.value}.${o}`,d=this.l.createLogger(b,{id:p,name:h,logLevel:t,extensionId:$.identifier.value});return new r(p,h,d,this.a,$)}p(h){let t=this.d.get(h.identifier.value);if(!t){const $=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory($)}catch(c){if((0,m.$Rk)(c)!==m.FileSystemProviderErrorCode.FileExists)throw c}return $})())}return t}q(h,t){let $=!1;const c=()=>{if($)throw new Error("Channel has been closed")};return{get name(){return h},append(o){c(),t.then(b=>b.append(o))},appendLine(o){c(),t.then(b=>b.appendLine(o))},clear(){c(),t.then(o=>o.clear())},replace(o){c(),t.then(b=>b.replace(o))},show(o,b){c(),t.then(p=>p.show(o,b))},hide(){c(),t.then(o=>o.hide())},dispose(){$=!0,t.then(o=>o.dispose())}}}r(h,t,$){const c=new u.$Sc,o=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},b=c.add(new s.$5d);function p(d){t=d,b.fire(d)}return $.then(d=>{c.add(d),d.logLevel!==t&&p(d.logLevel),c.add(d.onDidChangeLogLevel(I=>p(I)))}),{...this.q(h,$),get logLevel(){return t},onDidChangeLogLevel:b.event,trace(d,...I){o(),$.then(v=>v.trace(d,...I))},debug(d,...I){o(),$.then(v=>v.debug(d,...I))},info(d,...I){o(),$.then(v=>v.info(d,...I))},warn(d,...I){o(),$.then(v=>v.warn(d,...I))},error(d,...I){o(),$.then(v=>v.error(d,...I))},dispose(){c.dispose()}}}};e.$qjc=n,e.$qjc=n=Xe([He(0,C.$fO),He(1,k.$vO),He(2,f.$dic),He(3,F.$Rhc),He(4,M.$zj),He(5,M.$yj)],n),e.$rjc=(0,P.$ei)("IExtHostOutputService")}),define(Me[114],Ae([1,0,4,11]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$Ym=(0,D.$ei)("remoteAgentService"),e.$Zm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let g=0;g<this.maxSampleCount;g++){const f=await C.getRoundTripTime();if(f===void 0)return;L=Math.min(L,f/2),await(0,P.$fh)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(L):M=this.initial.reduce((g,f)=>g+f,0)/this.initial.length,this.lastMeasurement={initial:M,current:L,average:this.average.reduce((g,f)=>g+f,0)/this.average.length,high:typeof M>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Me[282],Ae([1,0,171,56,30,47,46,6,5,114,21,26,11]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=void 0,e.$HI=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$II=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$JI=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$KI=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$LI={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new f.$5d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const m=new w;C.$Un.add(e.$LI.ConfigurationMigration,m);let s=class extends g.$Tc{constructor(r,n){super(),this.a=r,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(r){await this.f(void 0,r);for(const n of this.b.getWorkspace().folders)await this.f(n,r)}async f(r,n){await Promise.all([n.map(a=>this.g(a,r?.uri))])}async g(r,n){const a=this.a.inspect(r.key,{resource:n}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,$]of h){const c=a[t];if(!c)continue;const o=[];if(c.value!==void 0){const b=await this.h(r,t,c.value,n,void 0);for(const p of b??[])o.push([p,[]])}for(const{identifiers:b,value:p}of c.overrides??[])if(p!==void 0){const d=await this.h(r,t,p,n,b);for(const I of d??[])o.push([I,b])}o.length&&await Promise.allSettled(o.map(async([[b,p],d])=>this.a.updateValue(b,p.value,{resource:n,overrideIdentifiers:d},$)))}}async h(r,n,a,h,t){const $=o=>{const p=this.a.inspect(o,{resource:h})[n];if(p)return t?p.overrides?.find(({identifiers:d})=>(0,S.$Mn)(d,t))?.value:p.value},c=await r.migrateFn(a,$);return Array.isArray(c)?c:[[r.key,c]]}};e.$MI=s,s.ID="workbench.contrib.configurationMigration",e.$MI=s=Xe([He(0,M.$Ki),He(1,L.$ni)],s);let u=class extends g.$Tc{constructor(r){super(),this.b=r,this.a=new l.$Bh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!F.$c&&(await this.b.getEnvironment())?.os!==1)return;C.$Un.as(P.$Zn.Configuration).registerConfiguration({...e.$JI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})}};e.$NI=u,u.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$NI=u=Xe([He(0,k.$Ym)],u)}),define(Me[283],Ae([1,0,33,12,19,25,179,282,56,4,30]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7eb=e.$6eb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$5eb=e.$4eb=void 0,e.$4eb=(0,k.$ei)("editorResolverService"),e.$5eb="workbench.editorAssociations";const S=F.$Un.as(f.$Zn.Configuration),l={...g.$II,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var w;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(w||(e.RegisteredEditorPriority=w={}));var m;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function s(i){switch(i){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}e.$6eb=s;function u(i,r){if(new Set([P.Schemas.extension,P.Schemas.webviewPanel,P.Schemas.vscodeWorkspaceTrust,P.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof i=="string"&&i.indexOf(C.$gc.sep)>=0?`${r.scheme}:${r.path}`:(0,L.$Og)(r);return D.$Wj(typeof i=="string"?i.toLowerCase():i,h.toLowerCase())}e.$7eb=u}),define(Me[284],Ae([1,0,45,12,19,21,25,2,4,200,47,218,114]),function(x,e,D,P,C,L,M,g,f,k,F,S,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=void 0,e.$CL=(0,f.$ei)("pathService");let m=w=class{constructor(u,i,r,n){this.d=u,this.e=i,this.f=r,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??u})()}hasValidBasename(u,i,r){return typeof i=="string"||typeof i>"u"?this.a.then(n=>this.h(u,n,i)):this.h(u,i,r)}h(u,i,r){return u.scheme===P.Schemas.file||u.scheme===P.Schemas.vscodeRemote?(0,D.$dg)(r??(0,M.$Og)(u),i===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,i){if(u.remoteAuthority)return P.Schemas.vscodeRemote;const r=(0,k.$zL)(i.getWorkspace());if(r)return r;const n=i.getWorkspace().folders[0];if(n)return n.uri.scheme;const a=i.getWorkspace().configuration;return a?a.scheme:P.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?C.$fc:C.$gc)}async fileURI(u){let i="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const n=u.indexOf("/",2);n===-1?(i=u.substring(2),u="/"):(i=u.substring(2,n),u=u.substring(n)||"/")}return g.URI.from({scheme:P.Schemas.file,authority:i,path:u,query:"",fragment:""})}};e.$DL=m,e.$DL=m=w=Xe([He(1,l.$Ym),He(2,S.$lL),He(3,F.$ni)],m)}),define(Me[115],Ae([1,0]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$eK=e.$dK=void 0;class D{constructor(M,g){this.line=M,this.character=g}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,g){return new D(0,0)}with(M){return new D(0,0)}}e.$dK=D;class P{constructor(M,g,f,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(M,g),this.end=new D(f,k)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new P(0,0,0,0)}with(M){return new P(0,0,0,0)}}e.$eK=P;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Me[44],Ae([1,0,18,33,26,45,13,4,19,15,115,11]),function(x,e,D,P,C,L,M,g,f,k,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.SearchErrorCode=e.$tK=e.$sK=e.SearchSortOrder=e.ViewMode=e.$rK=e.$qK=e.$pK=e.$oK=e.SearchCompletionExitCode=e.$nK=e.$mK=e.$lK=e.QueryType=e.SearchProviderType=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.$fK="workbench.view.search",e.$gK="workbench.panel.search",e.$hK="workbench.view.search",e.$iK="search-result",e.$jK="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",m=(l.length+w.length+5)*2;e.$kK=(0,g.$ei)("searchService");var s;(function(se){se[se.file=0]="file",se[se.text=1]="text"})(s||(e.SearchProviderType=s={}));var u;(function(se){se[se.File=1]="File",se[se.Text=2]="Text"})(u||(e.QueryType=u={}));function i(se){return!!se.preview}e.$lK=i;function r(se){return!!se.resource}e.$mK=r;function n(se){return!!se.message}e.$nK=n;var a;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor($e){this.resource=$e,this.results=[]}}e.$oK=h;class t{constructor($e,ne,ke,oe){this.ranges=ne,this.webviewIndex=oe;const ve=Array.isArray(ne)?ne:[ne];if(ke&&ke.matchLines===1&&$(ve)){$e=(0,M.$Lf)($e,ke.matchLines);let G="",ge=0,ae=0;const De=Math.floor(ke.charsPerLine/5),ye=[];for(const we of ve){const he=Math.max(we.startColumn-De,0),K=we.startColumn+ke.charsPerLine;if(he>ae+De+m){const Y=l+(he-ae)+w;G+=Y+$e.slice(he,K),ge+=he-(ae+Y.length)}else G+=$e.slice(ae,K);ye.push(new o(0,we.startColumn-ge,we.endColumn-ge)),ae=K}this.preview={text:G,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const G=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:$e,matches:(0,D.$2b)(ne,ge=>new c(ge.startLineNumber-G,ge.startColumn,ge.endLineNumber-G,ge.endColumn))}}}}e.$pK=t;function $(se){const $e=se[0].startLineNumber;for(const ne of se)if(ne.startLineNumber!==$e||ne.endLineNumber!==$e)return!1;return!0}class c{constructor($e,ne,ke,oe){this.startLineNumber=$e,this.startColumn=ne,this.endLineNumber=ke,this.endColumn=oe}}e.$qK=c;class o extends c{constructor($e,ne,ke){super($e,ne,$e,ke)}}e.$rK=o;var b;(function(se){se.List="list",se.Tree="tree"})(b||(e.ViewMode=b={}));var p;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function d(se,$e=!0){const ne=se&&se.files&&se.files.exclude,ke=$e&&se&&se.search&&se.search.exclude;if(!ne&&!ke)return;if(!ne||!ke)return ne||ke;let oe=Object.create(null);return oe=C.$Ln(oe,C.$In(ne)),oe=C.$Ln(oe,C.$In(ke),!0),oe}e.$sK=d;function I(se,$e){return se.excludePattern&&P.$Wj(se.excludePattern,$e)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&P.$Wj(se.includePattern,$e)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(ne=>{const ke=ne.folder.fsPath;if(L.$fg($e,ke)){const oe=f.$lc(ke,$e);return!ne.includePattern||!!P.$Wj(ne.includePattern,oe)}else return!1}):!1:!0}e.$tK=I;var v;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class y extends Error{constructor($e,ne){super($e),this.code=ne}}e.$uK=y;function E(se){const $e=se.message;if((0,k.$4)(se))return new y($e,v.canceled);try{const ne=JSON.parse($e);return new y(ne.message,ne.code)}catch{return new y($e,v.other)}}e.$vK=E;function A(se){const $e={message:se.message,code:se.code};return new Error(JSON.stringify($e))}e.$wK=A;function V(se){return se.type==="error"?!0:se.type==="success"}e.$xK=V;function X(se){return se.type==="success"}e.$yK=X;function H(se){return!!se.path}e.$zK=H;function O(se,$e,ne=!0){const ke=se.searchPath?se.searchPath:se.relativePath;return ne?(0,M.$If)(ke,$e):P.$Wj($e,ke)}e.$AK=O;class R{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$BK=R;function B(se,$e){const ne={...se||{},...$e||{}};return Object.keys(ne).filter(ke=>{const oe=ne[ke];return typeof oe=="boolean"&&oe})}e.$CK=B;class T{constructor($e,ne){this.c=null,this.a={...$e.excludePattern||{},...ne.excludePattern||{}},this.b=P.$Xj(this.a);let ke=$e.includePattern;ne.includePattern&&(ke?ke={...ke,...ne.includePattern}:ke=ne.includePattern),ke&&(this.c=P.$Xj(ke))}matchesExcludesSync($e,ne,ke){return!!(this.b&&this.b($e,ne,ke))}includedInQuerySync($e,ne,ke){return!(this.b&&this.b($e,ne,ke)||this.c&&!this.c($e,ne,ke))}includedInQuery($e,ne,ke){const oe=this.b($e,ne,ke),ve=()=>this.c?!!this.c($e,ne,ke):!0;return(0,S.$3g)(oe)?oe.then(G=>G?!1:ve()):ve()}hasSiblingExcludeClauses(){return te(this.a)}}e.$DK=T;function te(se){for(const $e in se)if(typeof se[$e]!="boolean")return!0;return!1}function Q(se){if(!se)return;let $e;return ne=>($e||($e=(se()||Promise.resolve([])).then(ke=>ke?le(ke):{})),$e.then(ke=>!!ke[ne]))}e.$EK=Q;function ce(se){if(!se)return;let $e;return ne=>{if(!$e){const ke=se();$e=ke?le(ke):{}}return!!$e[ne]}}e.$FK=ce;function le(se){const $e={};for(const ne of se)$e[ne]=!0;return $e}}),define(Me[37],Ae([1,0,18,11,22,5,6,50,12,123,25,13,2,170,4,14,189,47,43,27,17,8,7,59,44,3,51]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$,c,o,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=e.$0hc=void 0;function p(X,H,O){return new F.$Gg(R=>y(R,O)).isEqual(X,H)}function d(X,H,O){return p(X.uri,H.uri,O)?0:(0,S.$cf)(X.uri.toString(),H.uri.toString())}function I(X,H,O){return X.index!==H.index?X.index<H.index?-1:1:p(X.uri,H.uri,O)?(0,S.$cf)(X.name,H.name):(0,S.$cf)(X.uri.toString(),H.uri.toString())}function v(X,H,O,R){const B=X.slice(0).sort((te,Q)=>O(te,Q,R)),T=H.slice(0).sort((te,Q)=>O(te,Q,R));return(0,D.$Eb)(B,T,(te,Q)=>O(te,Q,R))}function y(X,H){const O=H.getCapabilities(X.scheme);return!(O&&O&1024)}class E extends i.$xi{static toExtHostWorkspace(H,O,R,B){if(!H)return{workspace:null,added:[],removed:[]};const{id:T,name:te,folders:Q,configuration:ce,transient:le,isUntitled:se}=H,$e=[],ne=O;O?Q.forEach((G,ge)=>{const ae=l.URI.revive(G.uri),De=E.o(R||O,ae,B);De?(De.name=G.name,De.index=G.index,$e.push(De)):$e.push({uri:ae,name:G.name,index:ge})}):$e.push(...Q.map(({uri:G,name:ge,index:ae})=>({uri:l.URI.revive(G),name:ge,index:ae}))),$e.sort((G,ge)=>G.index<ge.index?-1:1);const ke=new E(T,te,$e,!!le,ce?l.URI.revive(ce):null,!!se,G=>y(G,B)),{added:oe,removed:ve}=v(ne?ne.workspaceFolders:[],ke.workspaceFolders,d,B);return{workspace:ke,added:oe,removed:ve}}static o(H,O,R){for(let B=0;B<H.folders.length;B++){const T=H.workspaceFolders[B];if(p(T.uri,O,R))return T}}constructor(H,O,R,B,T,te,Q){super(H,R.map(ce=>new i.$yi(ce)),B,T,Q),this.t=O,this.u=te,this.q=[],this.s=g.$ki.forUris(Q),R.forEach(ce=>{this.q.push(ce),this.s.set(ce.uri,ce)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(H,O){return O&&this.s.get(H)&&(H=(0,F.$Qg)(H)),this.s.findSubstr(H)}resolveWorkspaceFolder(H){return this.s.get(H)}}let A=class{constructor(H,O,R,B,T){this.c=new L.$5d,this.onDidChangeWorkspace=this.c.event,this.g=new L.$5d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new L.$7d,this.C=new Map,this.h=B,this.s=R,this.t=T,this.j=new k.$im,this.k=new P.$dh,this.o=H.getProxy(o.$1L.MainThreadWorkspace),this.q=H.getProxy(o.$1L.MainThreadMessageService);const te=O.workspace;this.l=te?new E(te.id,te.name,[],!!te.transient,te.configuration?l.URI.revive(te.configuration):null,!!te.isUntitled,Q=>y(Q,R)):void 0}$initializeWorkspace(H,O){this.v=O,this.$acceptWorkspaceData(H),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,F.$Og)((0,F.$Qg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(H,O,R,...B){const T=[];if(Array.isArray(B)&&B.forEach(se=>{l.URI.isUri(se.uri)&&!T.some($e=>p($e.uri,se.uri,this.s))&&T.push({uri:se.uri,name:se.name||(0,F.$Ng)(se.uri)})}),this.n||[O,R].some(se=>typeof se!="number"||se<0)||R===0&&T.length===0)return!1;const te=this.x?this.x.workspaceFolders:[];if(O+R>te.length)return!1;const Q=te.slice(0);Q.splice(O,R,...T.map(se=>({uri:se.uri,name:se.name||(0,F.$Ng)(se.uri),index:void 0})));for(let se=0;se<Q.length;se++){const $e=Q[se];if(Q.some((ne,ke)=>ke!==se&&p($e.uri,ne.uri,this.s)))return!1}Q.forEach((se,$e)=>se.index=$e);const{added:ce,removed:le}=v(te,Q,I,this.s);if(ce.length===0&&le.length===0)return!1;if(this.o){const se=H.displayName||H.name;this.o.$updateWorkspaceFolders(se,O,R,T).then(void 0,$e=>{this.n=void 0;const ne={source:{identifier:H.identifier,label:H.displayName||H.name}};this.q.$showMessage(u.Severity.Error,(0,w.localize)(0,null,se,$e.toString()),ne,[])})}return this.y(Q),!0}getWorkspaceFolder(H,O){if(this.x)return this.x.getWorkspaceFolder(H,O)}async getWorkspaceFolder2(H,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(H,O)}async resolveWorkspaceFolder(H){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(H)}getPath(){if(!this.x)return;const{folders:H}=this.x;if(H.length!==0)return H[0].uri.fsPath}getRelativePath(H,O){let R,B="";if(typeof H=="string"?(R=l.URI.file(H),B=H):typeof H<"u"&&(R=H,B=H.fsPath),!R)return B;const T=this.getWorkspaceFolder(R,!0);if(!T)return B;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let te=(0,F.$Tg)(T.uri,R);return O&&T.name&&(te=`${T.name}/${te}`),te}y(H){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:H,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(H){const{workspace:O,added:R,removed:B}=E.toExtHostWorkspace(H,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:B}))}findFiles(H,O,R,B,T=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let te="",Q=!0;return O===null?Q=!1:O!==void 0&&(typeof O=="string"?te=O:te=O.pattern),this.z(H,void 0,{exclude:te,maxResults:R,useDefaultExcludes:Q,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},T)}findFiles2(H,O={},R,B=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,H,O,B)}async z(H,O,R,B=C.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const T=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,te={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:T,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let Q;if(H){const{includePattern:ce,folder:le}=V(h.GlobPattern.from(H));Q=le,te.includePattern=ce}else{const{includePattern:ce,folder:le}=V(h.GlobPattern.from(O));Q=le,te.filePattern=ce}return this.o.$startFileSearch(Q??null,te,B).then(ce=>Array.isArray(ce)?ce.map(le=>l.URI.revive(le)):[])}async findTextInFiles(H,O,R,B,T=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const te=this.j.getNext(),Q=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:ce,folder:le}=V(h.GlobPattern.from(O.include)),se=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,$e={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:Q,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:ce,excludePattern:se},ne=!1;if(this.u[te]=ke=>{if(ne)return;const oe=l.URI.revive(ke.resource);ke.results.forEach(ve=>{const G=(0,b.$Nh)(ve);(0,c.$lK)(G)?R({uri:oe,preview:{text:G.preview.text,matches:(0,D.$2b)(G.preview.matches,ge=>new t.$5L(ge.startLineNumber,ge.startColumn,ge.endLineNumber,ge.endColumn))},ranges:(0,D.$2b)(G.ranges,ge=>new t.$5L(ge.startLineNumber,ge.startColumn,ge.endLineNumber,ge.endColumn))}):R({uri:oe,text:G.text,lineNumber:G.lineNumber})})},T.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(H,le??null,$e,te,T);return delete this.u[te],ke||{}}catch(ke){throw delete this.u[te],ke}}$handleTextSearchResult(H,O){this.u[O]?.(H)}async save(H){const O=await this.o.$save(H,{saveAs:!1});return l.URI.revive(O)}async saveAs(H){const O=await this.o.$save(H,{saveAs:!0});return l.URI.revive(O)}saveAll(H){return this.o.$saveAll(H)}resolveProxy(H){return this.o.$resolveProxy(H)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(H){return this.o.$requestWorkspaceTrust(H)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(H,O){if(this.w.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this.w.set(H,O);const R=this.t.transformOutgoingScheme(H),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,R),(0,M.$Rc)(()=>{this.w.delete(H),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(H,O){this.h.info("Getting edit session identifier for workspaceFolder",H);const R=await this.resolveWorkspaceFolder(l.URI.revive(H));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const B=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!B),!B)return;const T=await B.provideEditSessionIdentity(R,O);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(H,O,R,B){this.h.info("Getting edit session identifier for workspaceFolder",H);const T=await this.resolveWorkspaceFolder(l.URI.revive(H));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const te=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!te),!te)return;const Q=await te.provideEditSessionIdentityMatch?.(O,R,B);if(this.h.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(H){return(O,R,B)=>{const T=function(Q){O.call(R,Q)};return T.extension=H,this.B.event(T,void 0,B)}}async $onWillCreateEditSessionIdentity(H,O,R){const B=await this.resolveWorkspaceFolder(l.URI.revive(H));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},O,async(T,te)=>{const Q=Date.now();await Promise.resolve(T),Date.now()-Q>R&&this.h.warn("SLOW edit session create-participant",te.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(H,O){if(this.C.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this.C.set(H,O);const R=this.t.transformOutgoingScheme(H),B=this.A++;return this.o.$registerCanonicalUriProvider(B,R),(0,M.$Rc)(()=>{this.C.delete(H),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(H,O,R){const B=this.C.get(H.scheme);if(!B)return;const T=await B.provideCanonicalUri?.(l.URI.revive(H),O,R);if(T)return T}async $provideCanonicalUri(H,O,R){return this.provideCanonicalUri(l.URI.revive(H),{targetScheme:O},R)}};e.$0hc=A,e.$0hc=A=Xe([He(0,a.$fO),He(1,n.$vO),He(2,r.$Rhc),He(3,s.$yj),He(4,$.$8hc)],A),e.$$hc=(0,m.$ei)("IExtHostWorkspace");function V(X){let H,O;return X&&(typeof X=="string"?H=X:(H=X.pattern,O=l.URI.revive(X.baseUri))),{includePattern:H,folder:O}}}),define(Me[38],Ae([1,0,26,5,37,3,7,191,56,16,11,4,17,14,2]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=e.$_hc=void 0;function s($,c){if(c){const o=c.split(".");let b=$;for(let p=0;b&&p<o.length;p++)b=b[o[p]];return b}}function u($){return $ instanceof m.URI}function i($){return $&&$.uri instanceof m.URI&&$.languageId&&typeof $.languageId=="string"}function r($){return $&&!$.uri&&$.languageId&&typeof $.languageId=="string"}function n($){return $&&$.uri instanceof m.URI&&(!$.name||typeof $.name=="string")&&(!$.index||typeof $.index=="number")}function a($){if(u($))return{resource:$};if(i($))return{resource:$.uri,overrideIdentifier:$.languageId};if(r($))return{overrideIdentifier:$.languageId};if(n($))return{resource:$.uri};if($===null)return{resource:null}}let h=class{constructor(c,o,b){this.a=c.getProxy(L.$1L.MainThreadConfiguration),this.c=o,this.b=b,this.d=new F.$dh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,o){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(c,o))}};e.$_hc=h,e.$_hc=h=Xe([He(0,l.$fO),He(1,C.$$hc),He(2,w.$yj)],h);class t{constructor(c,o,b,p){this.a=new P.$5d,this.b=c,this.f=p,this.c=o,this.e=g.$go.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,o){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$go.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(o,b))}getConfiguration(c,o,b){const p=a(o)||{},d=this.g(c?s(this.e.getValue(void 0,p,this.c.workspace),c):this.e.getValue(void 0,p,this.c.workspace));c&&this.h(c,p,b?.identifier);function I(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(y){return typeof s(d,y)<"u"},get:(y,E)=>{this.h(c?`${c}.${y}`:y,p,b?.identifier);let A=s(d,y);if(typeof A>"u")A=E;else{let V;const X=(H,O)=>{if((0,k.$Uf)(H)){let R;const B=()=>{V=V||(0,D.$In)(d),R=R||s(V,O)};return new Proxy(H,{get:(T,te)=>{if(typeof te=="string"&&te.toLowerCase()==="tojson")return B(),()=>R;if(V)return R=R||s(V,O),R[te];const Q=T[te];return typeof te=="string"?X(Q,`${O}.${te}`):Q},set:(T,te,Q)=>(B(),R&&(R[te]=Q),!0),deleteProperty:(T,te)=>(B(),R&&delete R[te],!0),defineProperty:(T,te,Q)=>(B(),R&&Object.defineProperty(R,te,Q),!0)})}return Array.isArray(H)?(0,D.$In)(H):H};A=X(A,y)}return A},update:(y,E,A,V)=>{y=c?`${c}.${y}`:y;const X=I(A);return E!==void 0?this.b.$updateConfigurationOption(X,y,E,p,V):this.b.$removeConfigurationOption(X,y,p,V)},inspect:y=>{y=c?`${c}.${y}`:y;const E=this.e.inspect(y,p,this.c.workspace);if(E)return{key:y,defaultValue:(0,D.$In)(E.policy?.value??E.default?.value),globalValue:(0,D.$In)(E.user?.value??E.application?.value),workspaceValue:(0,D.$In)(E.workspace?.value),workspaceFolderValue:(0,D.$In)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$In)(E.default?.override),globalLanguageValue:(0,D.$In)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$In)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$In)(E.workspaceFolder?.override),languageIds:(0,D.$In)(E.overrideIdentifiers)}}};return typeof d=="object"&&(0,D.$Ln)(v,d,!1),Object.freeze(v)}g(c){const o=b=>(0,k.$Uf)(b)?new Proxy(b,{get:(p,d)=>o(p[d]),set:(p,d,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(p,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(p,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return o(c)}h(c,o,b){const p=f.$0n.test(c)?4:this.d.get(c),d=b?`[${b.value}] `:"";if(p===4){typeof o?.resource>"u"&&this.f.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){o?.resource&&this.f.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,o){const b=new g.$io(c,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,d)=>b.affectsConfiguration(p,a(d))})}k(c){return c.reduce((o,b)=>(o.set(b[0],b[1]),o),new Map)}}e.$aic=t,e.$bic=(0,S.$ei)("IExtHostConfiguration")});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[116],Ae([1,0,2,11,5,3,7,37,67,38,22,66,17,27,4,12,21,14,78,223,15]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=e.$Cjc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(H){function O(B){if(B!=null)return B}H.from=O;function R(B){if(B!=null)return B}H.to=R})(t||(t={}));var $;(function(H){function O(B){if(B!=null)return B}H.from=O;function R(B){if(B!=null)return B}H.to=R})($||($={}));var c;(function(H){function O(B){if(B!=null)return B}H.from=O;function R(B){if(B!=null)return B}H.to=R})(c||(c={}));var o;(function(H){function O(T){if(T){const te=T;return te&&!!te.process}else return!1}H.is=O;function R(T){if(T==null)return;const te={process:T.process,args:T.args};return T.options&&(te.options=c.from(T.options)),te}H.from=R;function B(T){if(T!=null)return new M.$LM(T.process,T.args,T.options)}H.to=B})(o||(o={}));var b;(function(H){function O(B){if(B!=null)return B}H.from=O;function R(B){if(B!=null)return B}H.to=R})(b||(b={}));var p;(function(H){function O(T){if(T){const te=T;return te&&(!!te.commandLine||!!te.command)}else return!1}H.is=O;function R(T){if(T==null)return;const te={};return T.commandLine!==void 0?te.commandLine=T.commandLine:(te.command=T.command,te.args=T.args),T.options&&(te.options=b.from(T.options)),te}H.from=R;function B(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$MM(T.commandLine,T.options):new M.$MM(T.command,T.args?T.args:[],T.options)}H.to=B})(p||(p={}));var d;(function(H){function O(T){if(T){const te=T;return te&&te.customExecution==="customExecution"}else return!1}H.is=O;function R(T){return{customExecution:"customExecution"}}H.from=R;function B(T,te){return te.get(T)}H.to=B})(d||(e.CustomExecutionDTO=d={}));var I;(function(H){function O(R,B){let T;return R.scope!==void 0&&typeof R.scope!="number"?T=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===M.TaskScope.Workspace&&B&&B.workspaceFile?T=B.workspaceFile:T=n.$eH),{id:R._id,workspaceFolder:T}}H.from=O})(I||(e.TaskHandleDTO=I={}));var v;(function(H){function O(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}H.from=O})(v||(v={}));var y;(function(H){function O(T,te){if(T==null)return[];const Q=[];for(const ce of T){const le=R(ce,te);le&&Q.push(le)}return Q}H.fromMany=O;function R(T,te){if(T==null)return;let Q;T.execution instanceof M.$LM?Q=o.from(T.execution):T.execution instanceof M.$MM?Q=p.from(T.execution):T.execution&&T.execution instanceof M.$NM&&(Q=d.from(T.execution));const ce=t.from(T.definition);let le;return T.scope?typeof T.scope=="number"?le=T.scope:le=T.scope.uri:le=M.TaskScope.Workspace,!ce||!le?void 0:{_id:T._id,definition:ce,name:T.name,source:{extensionId:te.identifier.value,label:T.source,scope:le},execution:Q,isBackground:T.isBackground,group:v.from(T.group),presentationOptions:$.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}H.from=R;async function B(T,te,Q){if(T==null)return;let ce;o.is(T.execution)?ce=o.to(T.execution):p.is(T.execution)?ce=p.to(T.execution):d.is(T.execution)&&(ce=d.to(T._id,Q));const le=t.to(T.definition);let se;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?se=T.source.scope:se=await te.resolveWorkspaceFolder(D.URI.revive(T.source.scope)):se=M.TaskScope.Workspace),!le||!se)return;const $e=new M.$OM(le,se,T.name,T.source.label,ce,T.problemMatchers);return T.isBackground!==void 0&&($e.isBackground=T.isBackground),T.group!==void 0&&($e.group=M.$KM.from(T.group._id),$e.group&&T.group.isDefault&&($e.group=new M.$KM($e.group.id,$e.group.label),T.group.isDefault===!0&&($e.group.isDefault=T.group.isDefault))),T.presentationOptions&&($e.presentationOptions=$.to(T.presentationOptions)),T._id&&($e._id=T._id),T.detail&&($e.detail=T.detail),$e}H.to=B})(y||(e.TaskDTO=y={}));var E;(function(H){function O(B){return B}H.from=O;function R(B){if(B)return Object.assign(Object.create(null),B)}H.to=R})(E||(E={}));class A{constructor(O,R,B){this._id=R,this.a=B,h.set(this,void 0),xe(this,h,O,"f")}get task(){return this.a}terminate(){Ue(this,h,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}h=new WeakMap;let V=class{constructor(O,R,B,T,te,Q,ce,le){this.q=new C.$5d,this.r=new C.$5d,this.s=new C.$5d,this.u=new C.$5d,this.a=O.getProxy(L.$1L.MainThreadTask),this.b=B,this.c=T,this.d=te,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=le,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(O,R,B){if(!B)return new M.$3L(()=>{});const T=this.x();return this.j.set(T,{type:R,provider:B,extension:O}),this.a.$registerTaskProvider(T,R),new M.$3L(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(O,R){this.a.$registerTaskSystem(O,R)}fetchTasks(O){return this.a.$fetchTasks(E.from(O)).then(async R=>{const B=[];for(const T of R){const te=await y.to(T,this.b,this.m);te&&B.push(te)}return B})}get taskExecutions(){const O=[];return this.k.forEach(R=>O.push(R)),O}terminateTask(O){if(!(O instanceof A))throw new Error("No valid task execution provided");return this.a.$terminateTask(O._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(O,R,B){const T=this.m.get(O.id);T&&(this.o.set(O.id,T),this.e.attachPtyToTerminal(R,await T.callback(B))),this.p=O.id,this.q.fire({execution:await this.z(O)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(O){if(!this.l.has(O.id))return;const R=await this.z(O);this.l.delete(O.id),this.k.delete(O.id),this.B(O),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(O){const R=await this.z(O.id);this.s.fire({execution:R,processId:O.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(O){const R=await this.z(O.id);this.u.fire({execution:R,exitCode:O.exitCode})}$provideTasks(O,R){const B=this.j.get(O);if(!B)return Promise.reject(new Error("no handler found"));const T=[],te=(0,P.$9g)(()=>B.provider.provideTasks(F.CancellationToken.None)).then(Q=>this.v(R,T,B,Q));return new Promise(Q=>{te.then(ce=>{Promise.all(T).then(()=>{Q(ce)})})})}async $resolveTask(O,R){const B=this.j.get(O);if(!B)return Promise.reject(new Error("no handler found"));if(R.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${B.type}].`);const T=await y.to(R,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const te=await B.provider.resolveTask(T,F.CancellationToken.None);if(!te)return;this.A(te,B);const Q=y.from(te,B.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(te.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(Q.execution)&&await this.y(Q,te,!0),await this.w(Q)}x(){return this.h++}async y(O,R,B){const T=await this.a.$createTaskId(O);!B&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,R.execution)),this.m.set(T,R.execution)}async z(O,R){if(typeof O=="string"){const te=this.l.get(O);if(!te)throw new a.$bb("Unexpected: The specified task is missing an execution");return te}const B=this.l.get(O.id);if(B)return B;let T;return R?T=Promise.resolve(new A(this,O.id,R)):T=y.to(O.task,this.b,this.m).then(te=>{if(!te)throw new a.$bb("Unexpected: Task does not exist.");return new A(this,O.id,te)}),this.l.set(O.id,T),T.then(te=>(this.k.set(O.id,te),te))}A(O,R){O._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}B(O){this.o.get(O.id)&&this.o.delete(O.id),this.n.has(O.id)&&this.p!==O.id&&(this.m.delete(O.id),this.n.delete(O.id));const B=this.n.values();let T=B.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=B.next()}};e.$Cjc=V,e.$Cjc=V=Xe([He(0,l.$fO),He(1,w.$vO),He(2,g.$$hc),He(3,f.$qO),He(4,k.$bic),He(5,S.$zic),He(6,i.$yj),He(7,r.$Nhc)],V);let X=class extends V{constructor(O,R,B,T,te,Q,ce,le){super(O,R,B,T,te,Q,ce,le),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:u.$b(0)})}async executeTask(O,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const B=y.from(R,O);if(B===void 0)throw new Error("Task is not valid");if(d.is(B.execution))await this.y(B,R,!1);else throw new a.$_;const T=await this.z(await this.a.$getTaskExecution(B),R);return this.a.$executeTask(B).catch(te=>{throw new Error(te)}),T}v(O,R,B,T){const te=[];if(T)for(const Q of T){if(this.A(Q,B),!Q.definition||!O[Q.definition.type]){const le=Q.source?Q.source:"No task source";this.f.warn(`The task [${le}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=y.from(Q,B.extension);ce&&d.is(ce.execution)?(te.push(ce),R.push(this.y(ce,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:te,extension:B.extension}}async w(O){if(d.is(O.execution))return O;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(O,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,R,B){}};e.$Djc=X,e.$Djc=X=Xe([He(0,l.$fO),He(1,w.$vO),He(2,g.$$hc),He(3,f.$qO),He(4,k.$bic),He(5,S.$zic),He(6,i.$yj),He(7,r.$Nhc)],X),e.$Ejc=(0,m.$ei)("IExtHostTask")}),define(Me[285],Ae([1,0,44,29]),function(x,e,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.$LK=void 0;function C(M){return"cellResults"in M}e.$LK=C,e.$MK="rawCell#";function L(M,g){let f=-1;const k=[];let F=[];return M.forEach(l=>{l.range.startLineNumber!==f&&F.length>0&&(k.push([...F]),F=[]),F.push(l),f=l.range.endLineNumber}),F.length>0&&k.push([...F]),k.map(l=>{const w=[],m=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let u=m;u<=s;u++)w.push(g.getLineContent(u));return new D.$pK(w.join(`
`)+`
`,l.map(u=>new P.$7s(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}e.$NK=L}),define(Me[286],Ae([1,0,164,24,5,6,28,13,16,2,42,74,3,31,8,7,49,261,110,26,12,213,285,283]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class c{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,p,d,I,v,y){this.q=d,this.r=I,this.s=v,this.t=y,this.f=new Map,this.g=new M.$Ac,this.h=new Map,this.j=new C.$5d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$5d,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$5d,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$5d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Lhc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=b.getProxy(l.$1L.MainThreadNotebook),this.c=b.getProxy(l.$1L.MainThreadNotebookDocuments),this.d=b.getProxy(l.$1L.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const A=E.notebookEditor?.notebookUri,V=E.cell.handle,H=this.g.get(A)?.getCell(V);if(H)return H.apiCell}if(E&&E.$mid===14){const A=E.uri,V=this.g.get(A);if(V)return V.apiNotebook}return E}}),c.B(p)}getEditorById(b){const p=this.h.get(b);if(!p)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(b){for(const[p,d]of this.h)if(d.apiEditor===b)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,p){const d=this.g.get(b);if(!d&&!p)throw new Error(`NO notebook document for '${b}'`);return d}static u(b,p){if(!p)return;const d=p.filenamePattern.map(I=>m.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(p.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:p.displayName,filenamePattern:d,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,p,d){const I=c.a++,v=typeof d.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(I,d),this.b.$registerNotebookCellStatusBarItemProvider(I,v,p);let y;return v!==void 0&&(y=d.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(v))),new s.$3L(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,v),y?.dispose()})}async createNotebookDocument(b){const p=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&m.NotebookData.from(b.content)});return k.URI.revive(p)}async openNotebookDocument(b){const p=this.g.get(b);if(p)return p.apiNotebook;const d=await this.c.$tryOpenNotebook(b),I=this.g.get(k.URI.revive(d));return(0,f.$4f)(I?.apiNotebook)}async showNotebookDocument(b,p){k.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let d;typeof p=="object"?d={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(m.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:d={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,d),v=I&&this.h.get(I)?.apiEditor;if(v)return v;throw I?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,p,d,I){const v=this.f.get(b),y=k.URI.revive(p),E=this.g.get(y);if(!E||!v)return;const A=E.getCellFromIndex(d);if(!A)return;const V=await v.provideCellStatusBarItems(A.apiCell,I);if(!V)return;const X=new L.$Sc,H=this.p.add([X]),R=(Array.isArray(V)?V:[V]).map(B=>m.NotebookStatusBarItem.from(B,this.i,X));return{cacheId:H,items:R}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,p,d,I,v){if((0,g.$Se)(p))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:p,serializer:d,options:I}),this.b.$registerNotebookSerializer(y,{id:b.identifier,location:b.extensionLocation},p,m.NotebookDocumentContentOptions.from(I),c.u(b,v)),(0,L.$Rc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(b,p,d){const I=this.x.get(b);if(!I)throw new Error("NO serializer found");const v=await I.serializer.deserializeNotebook(p.buffer,d);return new u.$7v(m.NotebookData.from(v))}async $notebookToData(b,p,d){const I=this.x.get(b);if(!I)throw new Error("NO serializer found");const v=await I.serializer.serializeNotebook(m.NotebookData.to(p.value),d);return P.$se.wrap(v)}async $saveNotebook(b,p,d,I,v){const y=k.URI.revive(p),E=this.x.get(b);if(!E)throw new Error("NO serializer found");const A=this.g.get(y);if(!A)throw new Error("Document NOT found");if(A.versionId!==d)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new F.$Wk((0,D.localize)(0,null,this.z(y)),6);await this.y(y,I);const V={metadata:(0,n.$Qn)(A.apiNotebook.metadata,B=>!(E.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of A.apiNotebook.getCells()){const T=new s.$rN(B.kind,B.document.getText(),B.document.languageId,B.mime,E.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);T.metadata=(0,n.$Qn)(B.metadata,te=>!(E.options?.transientCellMetadata??{})[te]),V.cells.push(T)}const X=await E.serializer.serializeNotebook(V,v);await this.s.value.writeFile(y,X);const H=this.s.getFileSystemProviderExtUri(y.scheme),O=await this.s.value.stat(y);return{name:H.basename(y),isFile:(O.type&F.FileType.File)!==0,isDirectory:(O.type&F.FileType.Directory)!==0,isSymbolicLink:(O.type&F.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&F.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((O.permissions??0)&F.FilePermission.Locked),etag:F.$8k({mtime:O.mtime,size:O.size}),children:void 0}}async $searchInNotebooks(b,p,d,I,v){const y=this.x.get(b)?.serializer;if(!y)return{limitHit:!1,results:[]};const E=new M.$Bc;await(async(O,R,B)=>{await Promise.all(O.map(async T=>await Promise.all(T.filenamePatterns.map(te=>{const Q={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:1,filePattern:te};return this.t.doInternalFileSearchWithCustomCallback(Q,R,ce=>{ce.forEach(le=>{E.has(le)||I.some($e=>T.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(ne=>(0,$.$7eb)(ne,le)))||E.add(le)})}).catch(ce=>{if(ce.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ce})}))))})(d,v,p);const V=new M.$Ac;let X=!1;const H=Array.from(E).map(async O=>{const R=[];try{if(v.isCancellationRequested)return;if(p.maxResults&&[...V.values()].reduce((Q,ce)=>Q+ce.cellResults.length,0)>p.maxResults){X=!0;return}const B=[],T=this.g.get(O);if(T)T.apiNotebook.getCells().forEach(ce=>B.push({input:ce.document.getText(),outputs:ce.outputs.flatMap(le=>le.items.map(se=>se.data.toString()))}));else{const Q=await this.s.value.readFile(O),ce=P.$se.fromString(Q.toString()),le=await y.deserializeNotebook(ce.buffer,v);if(v.isCancellationRequested)return;m.NotebookData.from(le).cells.forEach($e=>B.push({input:$e.source,outputs:$e.outputs.flatMap(ne=>ne.items.map(ke=>ke.valueBytes.toString()))}))}if(v.isCancellationRequested)return;B.forEach((Q,ce)=>{const le=p.contentPattern.pattern,se=new h.$vTb(Q.input,void 0,Q.outputs),$e=se.findInInputs(le),ne=se.findInOutputs(le),ke=ne.flatMap(oe=>(0,t.$NK)(oe.matches,oe.textBuffer)).map((oe,ve)=>(oe.webviewIndex=ve,oe));if($e.length>0||ne.length>0){const oe={index:ce,contentResults:(0,t.$NK)($e,se.inputTextBuffer),webviewResults:ke};R.push(oe)}});const te={resource:O,cellResults:R};V.set(O,te);return}catch{return}});return await Promise.all(H),{limitHit:X,results:[...V.values()]}}async y(b,p){const d=await this.s.value.stat(b);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==F.$7k&&typeof d.mtime=="number"&&typeof d.size=="number"&&p.mtime<d.mtime&&p.etag!==F.$8k({mtime:p.mtime,size:d.size}))throw new F.$Wk((0,D.localize)(1,null),3,p)}z(b){return b.scheme===a.Schemas.file?b.fsPath:b.toString()}A(b,p,d){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const I=new r.$8ic(p,this.d,b,d.visibleRanges.map(m.NotebookRange.to),d.selections.map(m.NotebookRange.to),typeof d.viewColumn=="number"?m.ViewColumn.to(d.viewColumn):void 0);this.h.set(p,I)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const d of b.value.removedDocuments){const I=k.URI.revive(d),v=this.g.get(I);v&&(v.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(v.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===I.toString()&&this.h.delete(y.id)}if(b.value.addedDocuments){const d=[];for(const I of b.value.addedDocuments){const v=k.URI.revive(I.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const y=new i.$7ic(this.c,this.q,this.r,v,I);d.push(...I.cells.map(E=>i.$6ic.asModelAddData(E))),this.g.get(v)?.dispose(),this.g.set(v,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this.m.fire(y.apiNotebook)}}if(b.value.addedEditors)for(const d of b.value.addedEditors){if(this.h.has(d.id))return;const I=k.URI.revive(d.documentUri),v=this.g.get(I);v&&this.A(v,d.id,d)}const p=[];if(b.value.removedEditors)for(const d of b.value.removedEditors){const I=this.h.get(d);I&&(this.h.delete(d),this.k?.id===I.id&&(this.k=void 0),p.push(I))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const d=new Set;this.l.forEach(I=>d.add(I.id));for(const I of this.h.values()){const v=d.has(I.id);I._acceptVisibility(v)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(b){const p=w.$DO.String.with("notebookType","A notebook type"),d=new w.$FO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new w.$DO("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>P.$se.wrap(v))],new w.$EO("Notebook Data",v=>m.NotebookData.to(v.value))),I=new w.$FO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new w.$DO("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new u.$7v(m.NotebookData.from(v)))],new w.$EO("Bytes",v=>v.buffer));b.registerApiCommand(d),b.registerApiCommand(I)}}e.$ejc=c,c.a=0}),define(Me[287],Ae([1,0,19,22,35,33,25,64,44]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;class k{constructor(l,w,m){this.k=l,this.l=w,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&L.$Xj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&L.$Xj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const w=this.k.folderQueries||[];return new Promise((m,s)=>{const u=i=>{this.f++,l(i)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const r=i.toString(),n=D.$nc(r);this.j&&this.j(r,n)||this.v(u,{base:i,basename:n})}),Promise.all(w.map(i=>this.p(i,u))).then(i=>{m({limitHit:this.e,stats:i[0]||void 0})},i=>{s(new Error((0,C.$2i)(i)))})})}async p(l,w){const m=new P.$ce,s=this.q(l),u=this.r(),i=new f.$DK(this.k,l),r=!i.hasSiblingExcludeClauses();let n;try{this.h.add(m),n=g.$1d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),h=n.elapsed(),t=g.$1d.create();return this.g&&!this.e||(a&&a.forEach($=>{const c=D.$gc.relative(l.folder.path,$.path);if(r){const o=D.$nc($.path);this.v(w,{base:l.folder,relativePath:c,basename:o});return}this.s(u,l.folder,c,w)}),this.g&&!this.e)?null:(this.u(u,i,w),{providerTime:h,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(l){const w=(0,f.$CK)(this.k.includePattern,l.includePattern),m=(0,f.$CK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:m,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},w,m,s){if(m===this.a){const i=D.$nc(this.a);this.v(s,{base:w,relativePath:this.a,basename:i})}function u(i){const r=D.$nc(i),n=D.$mc(i);let a=l[n];a||(a=l[n]=[],u(n)),a.push({base:w,relativePath:i,basename:r})}u(m)}u({rootEntries:l,pathToEntries:w},m,s){const u=this,i=this.a;function r(n){const a=(0,f.$FK)(()=>n.map(h=>h.basename));for(let h=0,t=n.length;h<t;h++){const $=n[h],{relativePath:c,basename:o}=$;if(m.matchesExcludesSync(c,o,i!==o?a:void 0))continue;const b=w[c];if(b)r(b);else{if(c===i)continue;u.v(s,$)}if(u.e)break}}r(l)}v(l,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(w))}}class F{constructor(){this.b=new Map}fileSearch(l,w,m,s){const u=this.c(l.cacheKey),i=new k(l,w,u&&u.token);let r=0;const n=a=>{r+=a.length,m(a.map(h=>this.d(h)))};return this.e(i,F.a,n,s).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:a.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new P.$ce),this.b.get(l)}d(l){return l.relativePath?{resource:M.$Rg(l.base,l.relativePath)}:{resource:l.base}}e(l,w,m,s){const u=s.onCancellationRequested(()=>{l.cancel()}),i=n=>{n&&(r.push(n),w>0&&r.length>=w&&(m(r),r=[]))};let r=[];return l.search(i).then(n=>(r.length&&m(r),u.dispose(),n),n=>(r.length&&m(r),u.dispose(),Promise.reject(n)))}}e.$9ic=F,F.a=512}),define(Me[288],Ae([1,0,18,256,33,90,28,12,19,25,13,16,2,94,181,46,14,47,105,284,44]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=void 0;let h=class{constructor(y,E,A,V,X){this.a=y,this.b=E,this.c=A,this.d=V,this.e=X}text(y,E,A={}){y=this.f(y,A);const V=this.a.getValue(),X=E&&E.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(E?.map(i.$zi),A),type:2,contentPattern:y,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:V.search.usePCRE2||X||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(y,E){const A=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const V={...y,wordSeparators:A.editor.wordSeparators};return this.j(y,E)&&(V.isCaseSensitive=!0),this.k(y)&&(V.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),V}file(y,E={}){return{...this.h(y,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey,shouldGlobMatchFilePattern:E.shouldGlobSearch}}g(y,E){return y?(y=Array.isArray(y)?y.map(b):b(y),E?this.parseSearchPaths(y):{pattern:$(...Array.isArray(y)?y:[y])}):{}}h(y=[],E={}){const A=this.g(E.includePattern,E.expandPatterns),V=this.g(E.excludePattern,E.expandPatterns),X=y.length>1,H=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(B=>this.q(B,E,V)):y.map(B=>this.r(B,E,V,X))).filter(B=>!!B),O={_reason:E._reason,folderQueries:H,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:V.pattern,includePattern:A.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const B=D.$Hb(D.$Rb(this.c.groups.map(Q=>Q.editors.map(ce=>ce.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const T=B.filter(Q=>(0,a.$tK)(O,Q.fsPath)),te=this.i(T);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(te)),{...O,...te}}const R=E.extraFileResources&&E.extraFileResources.filter(B=>(0,a.$tK)(O,B.fsPath));return O.extraFileResources=R&&R.length?R:void 0,O}i(y){const E=[],A=new M.$Ac,V={};let X=!1;return y.forEach(H=>{if(H.scheme===g.Schemas.walkThrough)return;if((0,k.$Vg)(H)){const R=this.b.getWorkspaceFolder(H)?.uri??H.with({path:f.$mc(H.fsPath)});let B=A.get(R);B||(X=!0,B={folder:R,includePattern:{}},E.push(B),A.set(R,B));const T=f.$lc(R.fsPath,H.fsPath);(0,S.$4f)(B.includePattern)[T.replace(/\\/g,"/")]=!0}else H.fsPath&&(X=!0,V[H.fsPath]=!0)}),{folderQueries:E,includePattern:V,usingSearchPaths:!0,excludePattern:X?void 0:{"**/*":!0}}}j(y,E){if(E.isSmartCase){if(y.isRegExp){if(F.$Jf(y.pattern,!0))return!0}else if(F.$Jf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,w.$eC)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const E=te=>f.$ic(te)||/^\.\.?([\/\\]|$)/.test(te),V=(Array.isArray(y)?y:c(y)).map(te=>{const Q=this.e.resolvedUserHome;return Q?(0,L.$_v)(te,Q.scheme===g.Schemas.file?Q.fsPath:Q.path):te}),X=P.$E(V,te=>E(te)?"searchPaths":"exprSegments"),H=(X.exprSegments||[]).map(te=>F.$4e(te,"/")).map(te=>F.$4e(te,"\\")).map(te=>(te[0]==="."&&(te="*"+te),o(te))),O={},R=this.m(X.searchPaths||[]);R&&R.length&&(O.searchPaths=R);const B=D.$Rb(H),T=$(...B);return T&&(O.pattern=T),O}l(y,E){return E.disregardExcludeSettings?void 0:(0,a.$sK)(y,!E.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const E=y.flatMap(V=>{let{pathPortion:X,globPortion:H}=t(V);return H&&(H=p(H)),this.n(X).flatMap(R=>this.o(R,H))}),A=new Map;return E.forEach(V=>{const X=V.searchPath.toString(),H=A.get(X);H?V.pattern&&(H.pattern=H.pattern||{},H.pattern[V.pattern]=!0):A.set(X,{searchPath:V.searchPath,pattern:V.pattern?$(V.pattern):void 0})}),Array.from(A.values())}n(y){if(f.$ic(y)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==g.Schemas.file?[{searchPath:E[0].uri.with({path:y})}]:[{searchPath:l.URI.file(f.$hc(y))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(y=b(y),y.startsWith("../")||y===".."){const V=f.$gc.resolve(E.path,y);return[{searchPath:E.with({path:V})}]}const A=p(y);return[{searchPath:E,pattern:A}]}else{if(y==="./"||y===".\\")return[];{const E=y.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(X=>{const H=E.match(new RegExp(`^${F.$Xe(X.name)}(?:/(.*)|$)`));return H?{match:H,folder:X}:null}).filter(S.$1f);if(V.length)return V.map(X=>{const H=X.match[1];return{searchPath:X.folder.uri,pattern:H&&p(H)}});{const X=y.match(/\.[\/\\](.+)[\/\\]?/),H=X?X[1]:y,O=m.localize(0,null,H);throw new Error(O)}}}}o(y,E){const A=y.pattern&&E?`${y.pattern}/${E}`:y.pattern||E,V=[{searchPath:y.searchPath,pattern:A}];return A&&!A.endsWith("**")&&V.push({searchPath:y.searchPath,pattern:A+"/**"}),V}q(y,E,A){const V=this.r((0,i.$zi)(y.searchPath),E,A,!1);return V?{...V,includePattern:y.pattern}:null}r(y,E,A,V){let X;const H=l.URI.isUri(y)?y:y.uri;if(A.searchPaths){const te=A.searchPaths.filter(Q=>(0,k.$Kg)(Q.searchPath,H))[0];if(te&&!te.pattern)return null;te&&(X=te.pattern)}const O=this.a.getValue({resource:H}),B={...this.l(O,E)||{},...X||{}},T=l.URI.isUri(y)?(0,k.$Og)(y):y.name;return{folder:H,folderName:V?T:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!O.search.followSymlinks}}};e.$EL=h,e.$EL=h=Xe([He(0,s.$Ki),He(1,i.$ni),He(2,r.$lD),He(3,u.$yj),He(4,n.$CL)],h);function t(v){const y=v.match(/[\*\{\}\(\)\[\]\?]/);if(y){const E=y.index,A=v.substr(0,E).match(/[/|\\][^/\\]*$/);if(A){let V=v.substr(0,A.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:v.substr((A.index||0)+1)}}}return{pathPortion:v}}function $(...v){return v.length?v.reduce((y,E)=>(y[E]=!0,y),Object.create(null)):void 0}function c(v){return C.$Vj(v,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(v){return[`**/${v}/**`,`**/${v}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function b(v){return v.replace(/\\/g,"/")}function p(v){return b(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(v){return v.replace(/([?*[\]])/g,"[$1]")}function I(v,y){v=D.$Mb(v,V=>V.toString());const E=[],A=y.getWorkspace();return v&&v.forEach(V=>{let X;if(y.getWorkbenchState()===2)X=(0,k.$Tg)(A.folders[0].uri,V),X&&X!=="."&&(X="./"+X);else{const H=y.getWorkspaceFolder(V);if(H){const O=H.name;if(A.folders.filter(B=>B.name===O).length===1){const B=(0,k.$Tg)(H.uri,V);B===""?X=`./${H.name}`:X=`./${H.name}/${B}`}else X=V.fsPath}}X&&E.push(d(X))}),E}e.$FL=I}),define(Me[289],Ae([1,0,25,2,22,15,4,288,44,47,11]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wub=e.$vub=void 0;const S=7e3;function l(u,i){const r=i.activationEvents;if(!r)return Promise.resolve(void 0);const n=[],a=[];for(const b of r)if(/^workspaceContains:/.test(b)){const p=b.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||u.forceUsingSearch?a.push(p):n.push(p)}if(n.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,F.$0g)(),$=b=>t({activationEvent:b}),c=Promise.all(n.map(b=>w(u,b,$))).then(()=>{}),o=m(u,i.identifier,a,$);return Promise.all([c,o]).then(()=>{t(void 0)}),h}e.$vub=l;async function w(u,i,r){for(const n of u.folders)if(await u.exists(D.$Rg(P.URI.revive(n),i))){r(`workspaceContains:${i}`);return}}async function m(u,i,r,n){if(r.length===0)return Promise.resolve(void 0);const a=new C.$ce,h=u.checkExists(u.folders,r,a.token),t=setTimeout(async()=>{a.cancel(),u.logService.info(`Not activating extension '${i.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},S);let $=!1;try{$=await h}catch(c){L.$4(c)||L.$1(c)}a.dispose(),clearTimeout(t),$&&n(`workspaceContains:${r.join(",")}`)}function s(u,i,r,n){const a=u.get(M.$di),h=u.get(f.$kK),$=a.createInstance(g.$EL).file(i.map(c=>(0,k.$zi)(P.URI.revive(c))),{_reason:"checkExists",includePattern:r,exists:!0});return h.fileSearch($,n).then(c=>!!c.limitHit,c=>L.$4(c)?!1:Promise.reject(c))}e.$wub=s});var xe=this&&this.__classPrivateFieldSet||function(x,e,D,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!C:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(x,D):C?C.value=D:e.set(x,D),D},Ue=this&&this.__classPrivateFieldGet||function(x,e,D,P){if(D==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?P:D==="a"?P.call(x):P?P.value:e.get(x)};define(Me[39],Ae([1,0,161,19,87,25,11,6,50,2,14,3,38,219,82,37,23,106,15,20,24,202,7,100,4,27,84,17,71,85,66,5,289,81,204,12,79,64,21,80]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$,c,o,b,p,d,I,v,y,E,A,V,X,H,O,R,B){"use strict";var T,te,Q,ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=e.$Nic=e.$Mic=e.$Lic=e.$Kic=void 0,e.$Kic=(0,c.$ei)("IHostUtils");let le=ce=class extends g.$Tc{constructor(ae,De,ye,we,he,K,Y,me,pe,Fe,be,Re){super(),this.X=Re,this.a=this.B(new y.$5d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=De,this.g=ye,this.f=Y,this.j=we,this.m=he,this.s=K,this.t=pe,this.u=Fe,this.w=be,this.y=this.g.getProxy(S.$1L.MainThreadWorkspace),this.z=this.g.getProxy(S.$1L.MainThreadTelemetry),this.C=this.g.getProxy(S.$1L.MainThreadExtensionService),this.D=new M.$dh,this.F=new M.$dh,this.G=new M.$dh,this.H=new M.$dh,this.I=new G(this.f.extensions.activationEvents),this.L=new i.$N9b(this.I,this.f.extensions.allExtensions);const Pe=new n.$ym(this.f.extensions.myExtensions);this.J=new i.$N9b(this.I,oe(this.L,Pe)),R.$n&&(this.s.info(`Creating extension host with the following global extensions: ${ne(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ne(this.J)}`)),this.M=new m.$vic(this.g,this.s),this.N=new A.$Dic(this.g),this.O=me,this.h=ae.createChild(new d.$ci([m.$wic,this.M],[A.$Eic,this.N])),this.P=this.B(new w.$uic(this.J,this.L,{onExtensionActivationError:(We,j,z)=>{this.C.$onExtensionActivationError(We,r.$3(j),z)},actualActivateExtension:async(We,j)=>{if(i.$N9b.isHostExtension(We,this.J,this.L))return await this.C.$activateExtension(We,j),new w.$tic;const z=this.J.getExtensionDescription(We);return this.db(z,j)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ae){r.$1(ae)}}async Y(){this.O.onWillDeactivateAll();let ae=[];try{ae=this.J.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.cb(he))}catch{}await Promise.all(ae)}terminate(ae,De=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ae}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(we=>{this.s.error(we)}),this.g.dispose();const ye=this.Y();Promise.race([(0,M.$fh)(5e3),ye]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${De}`):this.s.info(`Extension host exiting with code ${De}`),this.s.flush(),this.s.dispose(),this.c.exit(De)})}isActivated(ae){return this.G.isOpen()?this.P.isActivated(ae):!1}async getExtension(ae){const De=await this.C.$getExtension(ae);return De&&{...De,identifier:new n.$xm(De.identifier.value),extensionLocation:k.URI.revive(De.extensionLocation)}}Z(ae,De){return this.P.activateByEvent(ae,De)}$(ae,De){return this.P.activateById(ae,De)}activateByIdWithErrors(ae,De){return this.$(ae,De).then(()=>{const ye=this.P.getActivatedExtension(ae);if(ye.activationFailed)return Promise.reject(ye.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ae=>this.J)}getExtensionExports(ae){if(this.G.isOpen())return this.P.getActivatedExtension(ae).exports;try{return this.P.getActivatedExtension(ae).exports}catch{return null}}async ab(ae){if(ae.scheme===X.Schemas.file&&this.c.fsRealpath){const De=await this.c.fsRealpath(ae.fsPath);return k.URI.file(De)}return ae}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ae=>new ve(ae))),this.Q}async bb(ae){const De=f.$ki.forUris(ye=>L.$Ig.ignorePathCasing(ye));return await Promise.all(ae.map(async ye=>{if(this.ub(ye)){const we=await this.ab(ye.extensionLocation);De.set(we,ye)}})),De}cb(ae){let De=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ae))return De;const ye=this.P.getActivatedExtension(ae);if(!ye)return De;try{typeof ye.module.deactivate=="function"&&(De=Promise.resolve(ye.module.deactivate()).then(void 0,we=>(this.s.error(we),Promise.resolve(void 0))))}catch(we){this.s.error(`An error occurred when deactivating the extension '${ae.value}':`),this.s.error(we)}try{(0,g.$Oc)(ye.subscriptions)}catch(we){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ae.value}':`),this.s.error(we)}return De}async db(ae,De){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ae.identifier):await this.C.$onWillActivateExtension(ae.identifier),this.fb(ae,De).then(ye=>{const we=ye.activationTimes;return this.C.$onDidActivateExtension(ae.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,De),this.eb(ae,De,"success",we),ye},ye=>{throw this.eb(ae,De,"failure"),ye})}eb(ae,De,ye,we){const he=$e(ae,De);this.z.$publicLog2("extensionActivationTimes",{...he,...we||{},outcome:ye})}fb(ae,De){const ye=$e(ae,De);this.z.$publicLog2("activatePlugin",ye);const we=this.ub(ae);if(!we)return Promise.resolve(new w.$sic(w.$pic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ae.identifier.value}, startup: ${De.startup}, activationEvent: '${De.activationEvent}'${ae.identifier.value!==De.extensionId.value?`, root cause: ${De.extensionId.value}`:""}`),this.s.flush();const he=new w.$qic(De.startup);return Promise.all([this.vb(ae,(0,L.$Rg)(ae.extensionLocation,we),he),this.gb(ae)]).then(K=>(C.mark(`code/extHost/willActivateExtension/${ae.identifier.value}`),ce.hb(this.s,ae.identifier,K[0],K[1],he))).then(K=>(C.mark(`code/extHost/didActivateExtension/${ae.identifier.value}`),K))}gb(ae){const De=new h.$yic(ae,this.M),ye=new h.$xic(ae.identifier.value,!1,this.M),we=new V.$Fic(ae,this.N),he=ae.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,K=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ae.identifier.value}`),Promise.all([De.whenReady,ye.whenReady,this.O.whenReady]).then(()=>{const Y=this;let me,pe;const Fe=(0,u.$VF)(ae,"ipc")?this.f.messagePorts?.get(n.$xm.toKey(ae.identifier)):void 0;return Object.freeze({globalState:De,workspaceState:ye,secrets:we,subscriptions:[],get extensionUri(){return ae.extensionLocation},get extensionPath(){return ae.extensionLocation.fsPath},asAbsolutePath(be){return P.$jc(ae.extensionLocation.fsPath,be)},get storagePath(){return Y.O.workspaceValue(ae)?.fsPath},get globalStoragePath(){return Y.O.globalValue(ae).fsPath},get logPath(){return P.$jc(Y.f.logsLocation.fsPath,ae.identifier.value)},get logUri(){return k.URI.joinPath(Y.f.logsLocation,ae.identifier.value)},get storageUri(){return Y.O.workspaceValue(ae)},get globalStorageUri(){return Y.O.globalValue(ae)},get extensionMode(){return he},get extension(){return me===void 0&&(me=new ke(Y,ae.identifier,ae,K,!1)),me},get extensionRuntime(){return(0,u.$WF)(ae,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y.u.getEnvironmentVariableCollection(ae)},get messagePassingProtocol(){if(!pe){if(!Fe)return;const be=y.Event.buffer(y.Event.fromDOMEventEmitter(Fe,"message",Re=>Re.data));Fe.start(),pe={onDidReceiveMessage:be,postMessage:Fe.postMessage.bind(Fe)}}return pe}})})}static hb(ae,De,ye,we,he){return ye=ye||{activate:void 0,deactivate:void 0},this.ib(ae,De,ye,we,he).then(K=>new w.$ric(!1,null,he.build(),ye,K,we.subscriptions))}static ib(ae,De,ye,we,he){if(typeof ye.activate=="function")try{he.activateCallStart(),ae.trace(`ExtensionService#_callActivateOptional ${De.value}`);const K=typeof global=="object"?global:self,Y=ye.activate.apply(K,[we]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Y).then(me=>(he.activateResolveStop(),me))}catch(K){return Promise.reject(K)}else return Promise.resolve(ye)}jb(ae,De){this.$(ae.identifier,{startup:!1,extensionId:ae.identifier,activationEvent:De}).then(void 0,ye=>{this.s.error(ye)})}kb(ae,De=0){const we=Date.now();(0,R.$v)(()=>{for(let he=De;he<ae.length;he+=1){const K=ae[he];for(const Y of K.activationEvents??[])if(Y==="onStartupFinished")if(Date.now()-we>50){this.kb(ae,he);break}else this.jb(K,Y)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ae=>{const De=ae.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ye=this.J.getAllExtensionDescriptions();if(De)this.kb(ye);else for(const we of ye)if(we.activationEvents)for(const he of we.activationEvents)he==="onStartupFinished"&&this.jb(we,he)})}mb(){const ae=this.Z("*",!0).then(void 0,K=>{this.s.error(K)});this.B(this.j.onDidChangeWorkspace(K=>this.nb(K.added)));const De=this.j.workspace?this.j.workspace.folders:[],ye=this.nb(De),we=this.pb(),he=Promise.all([we,ae,ye]).then(()=>{});return Promise.race([he,(0,M.$fh)(1e4)]).then(()=>{this.lb()}),he}nb(ae){return ae.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(De=>this.ob(ae,De))).then(()=>{})}async ob(ae,De){if(this.isActivated(De.identifier))return;const ye=!this.f.remote.isRemote&&!!this.f.remote.authority,we={logService:this.s,folders:ae.map(K=>K.uri),forceUsingSearch:ye||!this.c.fsExists,exists:K=>this.c.fsExists(K.fsPath),checkExists:(K,Y,me)=>this.y.$checkExists(K,Y,me)},he=await(0,E.$vub)(we,De);if(he)return this.$(De.identifier,{startup:!0,extensionId:De.identifier,activationEvent:he.activationEvent}).then(void 0,K=>this.s.error(K))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ae){throw console.error(ae),ae}}async qb(){const{extensionDevelopmentLocationURI:ae,extensionTestsLocationURI:De}=this.f.environment;if(!ae||!De)throw new Error(D.localize(0,null));const ye=await this.vb(null,De,new w.$qic(!1));if(!ye||typeof ye.run!="function")throw new Error(D.localize(1,null,De.toString()));return new Promise((we,he)=>{const K=(pe,Fe)=>{pe?(R.$n&&this.s.error("Test runner called back with error",pe),he(pe)):(R.$n&&(Fe?this.s.info(`Test runner called back with ${Fe} failures.`):this.s.info("Test runner called back with successful outcome.")),we(typeof Fe=="number"&&Fe>0?1:0))},Y=(0,L.$Fg)(De),me=ye.run(Y,K);me&&me.then&&me.then(()=>{R.$n&&this.s.info("Test runner finished successfully."),we(0)}).catch(pe=>{R.$n&&this.s.error("Test runner finished with error",pe),he(pe instanceof Error&&pe.stack?pe.stack:String(pe))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$fh)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ae,De){return this.R[ae]=De,(0,g.$Rc)(()=>{delete this.R[ae]})}async getRemoteExecServer(ae){const{resolver:De}=await this.sb(ae);return De?.resolveExecServer?.(ae,{resolveAttempt:0})}async sb(ae){const De=ae.indexOf("+");if(De===-1)throw new t.$9L("Not an authority that can be resolved!",$.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ye=ae.substr(0,De);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ye}`,!1),{authorityPrefix:ye,resolver:this.R[ye]}}async $resolveAuthority(ae,De){const ye=O.$1d.create(!1),we=()=>`[resolveAuthority(${(0,$.$kl)(ae)},${De})][${ye.elapsed()}ms] `,he=W=>this.s.info(`${we()}${W}`),K=W=>this.s.warn(`${we()}${W}`),Y=(W,ie=void 0)=>this.s.error(`${we()}${W}`,ie),me=W=>{if(W instanceof t.$9L)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},pe=async W=>{he(`activating resolver for ${W}...`);const{resolver:ie,authorityPrefix:ue}=await this.sb(W);if(!ie)throw Y(`no resolver for ${ue}`),new t.$9L(`No remote extension installed to resolve ${ue}.`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ie,authorityPrefix:ue,remoteAuthority:W}},Fe=ae.split(/@|%40/g).reverse();he(`activating remote resolvers ${Fe.join(" -> ")}`);let be;try{be=await Promise.all(Fe.map(pe)).catch(async W=>{if(!(W instanceof t.$9L)||W._code!==$.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return K(`resolving nested authorities failed: ${W.message}`),[await pe(ae)]})}catch(W){return me(W)}const Re=new M.$ph;Re.cancelAndSet(()=>he("waiting..."),1e3);let Pe,We;for(const[W,{authorityPrefix:ie,resolver:ue,remoteAuthority:Le}]of be.entries())try{if(W===be.length-1)he("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${ie}`),Pe=await ue.resolve(Le,{resolveAttempt:De,execServer:We}),C.mark(`code/extHost/didResolveAuthorityOK/${ie}`),he("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ue,t.$8L.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(he(`invoking resolveExecServer() for ${Le}`),C.mark(`code/extHost/willResolveExecServer/${ie}`),We=await ue.resolveExecServer?.(Le,{resolveAttempt:De,execServer:We}),!We)throw new t.$9L(`Exec server was not available for ${Le}`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${ie}`)}}catch(Be){return C.mark(`code/extHost/didResolveAuthorityError/${ie}`),Y("returned an error",Be),Re.dispose(),me(Be)}Re.dispose();const j={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},z={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${t.$8L.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let q;if(t.$8L.isManagedResolvedAuthority(Pe)){const W=De;this.X.setFactory(W,Pe.makeConnection),q={authority:ae,connectTo:new $.$hl(W),connectionToken:Pe.connectionToken}}else q={authority:ae,connectTo:new $.$il(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:q,options:z,tunnelInformation:j}}}async $getCanonicalURI(ae,De){this.s.info(`$getCanonicalURI invoked for authority (${(0,$.$kl)(ae)})`);const{resolver:ye}=await this.sb(ae);if(!ye)return null;const we=k.URI.revive(De);if(typeof ye.getCanonicalURI>"u")return we;const he=await(0,M.$9g)(()=>ye.getCanonicalURI(we));return he||we}$startExtensionHost(ae){ae.toAdd.forEach(we=>we.extensionLocation=k.URI.revive(we.extensionLocation));const{globalRegistry:De,myExtensions:ye}=se(this.I,this.L,this.J,ae);return this.L.set(De.getAllExtensionDescriptions()),this.J.set(ye),R.$n&&(this.s.info(`$startExtensionHost: global extensions: ${ne(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ne(this.J)}`)),this.rb()}$activateByEvent(ae,De){return De===1?this.D.wait().then(ye=>this.Z(ae,!1)):this.G.wait().then(ye=>this.Z(ae,!1))}async $activate(ae,De){return await this.G.wait(),this.J.getExtensionDescription(ae)?(await this.$(ae,De),!0):!1}async $deltaExtensions(ae){ae.toAdd.forEach(K=>K.extensionLocation=k.URI.revive(K.extensionLocation));const{globalRegistry:De,myExtensions:ye}=se(this.I,this.L,this.J,ae),we=await this.bb(ye);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(De.getAllExtensionDescriptions()),this.J.set(ye),R.$n&&(this.s.info(`$deltaExtensions: global extensions: ${ne(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ne(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ae){return ae}async $test_up(ae){return ae.byteLength}async $test_down(ae){const De=a.$se.alloc(ae),ye=Math.random()%256;for(let we=0;we<ae;we++)De.writeUInt8(ye,we);return De}async $updateRemoteConnectionData(ae){this.W=ae,this.a.fire()}};e.$Lic=le,e.$Lic=le=ce=Xe([He(0,c.$di),He(1,e.$Kic),He(2,p.$fO),He(3,s.$$hc),He(4,l.$bic),He(5,F.$yj),He(6,o.$vO),He(7,b.$eic),He(8,I.$yAb),He(9,v.$zic),He(10,H.$Hic),He(11,B.$Iic)],le);function se(ge,ae,De,ye){ge.addActivationEvents(ye.addActivationEvents);const we=new i.$N9b(ge,ae.getAllExtensionDescriptions());we.deltaExtensions(ye.toAdd,ye.toRemove);const he=new n.$ym(De.getAllExtensionDescriptions().map(Y=>Y.identifier));for(const Y of ye.myToRemove)he.delete(Y);for(const Y of ye.myToAdd)he.add(Y);const K=oe(we,he);return{globalRegistry:we,myExtensions:K}}function $e(ge,ae){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:ae.activationEvent,reasonId:ae.extensionId.value}}function ne(ge){return ge.getAllExtensionDescriptions().map(ae=>ae.identifier.value).join(",")}e.$Mic=(0,c.$ei)("IExtHostExtensionService");class ke{constructor(ae,De,ye,we,he){T.set(this,void 0),te.set(this,void 0),Q.set(this,void 0),xe(this,T,ae,"f"),xe(this,te,De,"f"),xe(this,Q,ye.identifier,"f"),this.id=ye.identifier.value,this.extensionUri=ye.extensionLocation,this.extensionPath=P.$hc((0,L.$Fg)(ye.extensionLocation)),this.packageJSON=ye,this.extensionKind=we,this.isFromDifferentExtensionHost=he}get isActive(){return Ue(this,T,"f").isActivated(Ue(this,Q,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,T,"f").getExtensionExports(Ue(this,Q,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,T,"f").activateByIdWithErrors(Ue(this,Q,"f"),{startup:!1,extensionId:Ue(this,te,"f"),activationEvent:"api"}),this.exports}}e.$Nic=ke,T=new WeakMap,te=new WeakMap,Q=new WeakMap;function oe(ge,ae){return ge.getAllExtensionDescriptions().filter(De=>ae.has(De.identifier))}class ve{constructor(ae){this.a=ae}setSearchTree(ae){this.a=ae}findSubstr(ae){return this.a.findSubstr(ae)}forEach(ae){return this.a.forEach(ae)}}e.$Oic=ve;class G{constructor(ae){this.a=new n.$zm,this.addActivationEvents(ae)}readActivationEvents(ae){return this.a.get(ae.identifier)??[]}addActivationEvents(ae){for(const De of Object.keys(ae))this.a.set(De,ae[De])}}}),define(Me[290],Ae([1,0,87,2,3,38,23,20,17,27,4,39,14,13]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;let s=class{constructor(a,h,t,$,c,o,b){this.c=a,this.d=h,this.f=t,this.g=$,this.h=c,this.i=o,this.j=b,this.a=new Map,this.b=[]}async install(){this.k(),D.mark("code/extHost/willWaitForConfig");const a=await this.g.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const h=await this.h.getExtensionPathIndex();this.register(new i(this.c,h,this.d,a,this.j)),this.register(this.f.createInstance(u)),this.i.remote.isRemote&&this.register(this.f.createInstance(r,h,this.i.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$Wjc=s,e.$Wjc=s=Xe([He(2,F.$di),He(3,L.$bic),He(4,S.$Mic),He(5,k.$vO),He(6,l.$yj)],s);let u=m=class{constructor(a){if(a.environment.appRoot&&m.a.size){const h=(0,w.$Xe)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",$=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${$})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,$,c]=h,o=m.a.get($);if(o!==void 0)return console.warn(`${$} as been renamed to ${o}, please update your imports`),t+o+c}c(a){return a.replace(/\\/g,"/")}};u.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),u=m=Xe([He(0,k.$vO)],u);class i{constructor(a,h,t,$,c){this.c=a,this.d=h,this.e=t,this.f=$,this.g=c,this.nodeModuleName="vscode",this.a=new g.$zm}load(a,h){const t=this.d.findSubstr(h);if(t){let $=this.a.get(t.identifier);return $||($=this.c(t,this.e,this.f),this.a.set(t.identifier,$)),$}if(!this.b){let $="";this.d.forEach((c,o)=>$+=`	${o} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${$}`),this.b=this.c(M.$QF,this.e,this.f)}return this.b}}let r=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(C.$1L.MainThreadTelemetry);const $=t.getProxy(C.$1L.MainThreadWindow);this.c=(c,o)=>{const b=P.URI.parse(c);return o?this.g(c,o):b.scheme==="http"||b.scheme==="https"?$.$openUri(b,c,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?$.$openUri(b,c,{}):this.g(c,o)}}load(a,h,t){const $=this.e.findSubstr(h);return $&&(this.a=$.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Xe([He(2,f.$fO)],r)}),define(Me[117],Ae([1,0,40,6,19,73,4,67,65,39,7,37,216,38]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=e.$Pic=void 0,e.$Pic=(0,M.$ei)("IExtHostVariableResolverProvider");class m extends l.$gP{constructor(i,r,n,a,h,t,$){function c(){if(n){const o=n.activeEditor();if(o)return o.document.uri;const b=a.tabGroups.all.find(p=>p.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof F.$LN||b.input instanceof F.$QN)return b.input.modified;if(b.input instanceof F.$KN||b.input instanceof F.$PN||b.input instanceof F.$NN)return b.input.uri}}}super({getFolderUri:o=>{const b=t.folders.filter(p=>p.name===o);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,b)=>h.getConfiguration(void 0,o).get(b),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=c();if(o)return C.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const o=c();if(o){const b=r.getWorkspaceFolder(o);if(b)return C.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(n){const o=n.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(n){const o=n.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,$?Promise.resolve($):void 0,Promise.resolve(L.env))}}let s=class extends P.$Tc{constructor(i,r,n,a,h){super(),this.b=i,this.c=r,this.g=n,this.h=a,this.j=h,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$Qic=s,e.$Qic=s=Xe([He(0,k.$Mic),He(1,S.$$hc),He(2,g.$qO),He(3,w.$bic),He(4,f.$nic)],s)}),define(Me[118],Ae([1,0,11,5,2,20,4,3,65,39,17,7,37,208,210,38,117,6,41,31,8]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=e.$Uic=e.$Tic=e.$Sic=e.$Ric=void 0,e.$Ric=(0,M.$ei)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(d,I,v,y,E,A,V){this.N=I,this.O=v,this.P=y,this.Q=E,this.R=A,this.S=V,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new P.$5d,this.o=new P.$5d,this.q=new P.$5d,this.w=new P.$5d,this.l=d.getProxy(g.$1L.MainThreadDebugService),this.A=new P.$5d,this.C=new P.$5d,this.y=new $(this.l),this.z=new Map,this.O.getExtensionRegistry().then(X=>{X.onDidChange(H=>{this.V(X)}),this.V(X)})}async $getVisualizerTreeItem(d,I){const v=this.W(I);if(!v)return;const y=await this.H.get(d)?.getTreeItem?.(v);return y?this.U(d,y):void 0}registerDebugVisualizationTree(d,I,v){const y=L.$xm.toKey(d.identifier),E=this.jb(y,I);if(this.G.has(E))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(E,v),this.l.$registerDebugVisualizerTree(E,!!v.editItem),(0,i.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(E),this.H.delete(I)})}async $getVisualizerTreeItemChildren(d,I){const v=this.J.get(I)?.item;return v?(await this.H.get(d)?.getChildren?.(v))?.map(E=>this.U(d,E))||[]:[]}async $editVisualizerTreeItem(d,I){const v=this.J.get(d);if(!v)return;const y=await this.H.get(v.provider)?.editItem?.(v.item,I);return this.U(v.provider,y||v.item)}$disposeVisualizedTree(d){const I=this.J.get(d);if(!I)return;const v=[I.children];for(const y of v)if(y)for(const E of y)v.push(this.J.get(E)?.children),this.J.delete(E)}U(d,I){let v=this.I.get(I);return v||(v=this.F++,this.I.set(I,v),this.J.set(v,{provider:d,item:I})),a.DebugTreeItem.from(I,v)}asDebugSourceUri(d,I){const v=d;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let y=`debug:${encodeURIComponent(v.path||"")}`,E="?";return I&&(y+=`${E}session=${encodeURIComponent(I.id)}`,E="&"),y+=`${E}ref=${v.sourceReference}`,C.URI.parse(y)}else{if(v.path)return C.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(d){const I=[];for(const v of d.getAllExtensionDescriptions())if(v.contributes){const y=v.contributes.debuggers;if(y&&y.length>0)for(const E of y)(0,m.$uG)(E)&&I.push(E.type)}this.l.$registerDebugTypes(I)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const d=[];return this.z.forEach(I=>d.push(I)),d}async $resolveDebugVisualizer(d,I){const v=this.L.get(d);if(!v)throw new Error(`No debug visualizer found with id '${d}'`);let{v:y,provider:E,extensionId:A}=v;if(y.visualization||(y=await E.resolveDebugVisualization?.(y,I)||y,v.v=y),!y.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${E}'`);return this.kb(A,y.visualization)}async $executeDebugVisualizerCommand(d){const I=this.L.get(d);if(!I)throw new Error(`No debug visualizer found with id '${d}'`);const v=I.v.visualization;v&&"command"in v&&this.S.executeCommand(v.command,...v.arguments||[])}W(d){const I=this.m.get(d.sessionId);return I&&{session:I.api,variable:d.variable,containerId:d.containerId,frameId:d.frameId,threadId:d.threadId}}async $provideDebugVisualizers(d,I,v,y){const E=this.W(v),A=this.jb(d,I),V=this.G.get(A);if(!E||!V)return[];const X=await V.provideDebugVisualization(E,y);return X?X.map(H=>{const O=++this.M;this.L.set(O,{v:H,provider:V,extensionId:d});const R=H.iconPath?this.lb(H.iconPath):void 0;return{id:O,name:H.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.kb(d,H.visualization)}}):[]}$disposeDebugVisualizers(d){for(const I of d)this.L.delete(I)}registerDebugVisualizationProvider(d,I,v){if(!d.contributes?.debugVisualizers?.some(A=>A.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const y=L.$xm.toKey(d.identifier),E=this.jb(y,I);if(this.G.has(E))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(E,v),this.l.$registerDebugVisualizer(y,I),(0,i.$Rc)(()=>{this.l.$unregisterDebugVisualizer(y,I),this.G.delete(I)})}addBreakpoints(d){const I=d.filter(E=>{const A=E.id;return this.z.has(A)?!1:(this.z.set(A,E),!0)});this.gb(I,[],[]);const v=[],y=new Map;for(const E of I)if(E instanceof S.$3M){let A=y.get(E.location.uri.toString());A||(A={type:"sourceMulti",uri:E.location.uri,lines:[]},y.set(E.location.uri.toString(),A),v.push(A)),A.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character,mode:E.mode})}else E instanceof S.$4M&&v.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName,mode:E.mode});return this.l.$registerBreakpoints(v)}removeBreakpoints(d){const I=d.filter(A=>this.z.delete(A.id));this.gb([],I,[]);const v=I.filter(A=>A instanceof S.$3M).map(A=>A.id),y=I.filter(A=>A instanceof S.$4M).map(A=>A.id),E=I.filter(A=>A instanceof S.$5M).map(A=>A.id);return this.l.$unregisterBreakpoints(v,y,E)}startDebugging(d,I,v){return this.l.$startDebugging(d?d.uri:void 0,I,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(d){return this.l.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,I,v){if(!I)return new S.$3L(()=>{});const y=this.d++;return this.f.push({type:d,handle:y,provider:I}),this.l.$registerDebugConfigurationProvider(d,v,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,y),new S.$3L(()=>{this.f=this.f.filter(E=>E.provider!==I),this.l.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(d,I,v){if(!v)return new S.$3L(()=>{});if(!this.cb(d,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:I,handle:y,factory:v}),this.l.$registerDebugAdapterDescriptorFactory(I,y),new S.$3L(()=>{this.h=this.h.filter(E=>E.factory!==v),this.l.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(d,I){if(!I)return new S.$3L(()=>{});const v=this.j++;return this.k.push({type:d,handle:v,factory:I}),new S.$3L(()=>{this.k=this.k.filter(y=>y.factory!==I)})}async $runInTerminal(d,I){return Promise.resolve(void 0)}async $substituteVariables(d,I){let v;const y=await this.ib(d);return y&&(v={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(v,I)}X(d,I){if(d.type==="implementation")return new o(d.implementation)}Y(){}async $startDASession(d,I){const v=this,y=await this.hb(I);return this.eb(this.$(y.type),y).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const A=this.Z(E),V=this.X(A,y);if(!V)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const X=V;return this.D.set(d,X),this.db(y).then(H=>(H&&this.E.set(d,H),X.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const R=O,B={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const T=await this.K.sign(R.arguments.value);B.body={signature:T},X.sendResponse(B)}else throw new Error("no signer")}catch(T){B.success=!1,B.message=T.message,X.sendResponse(B)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(O),O=(0,m.$zG)(O,!0),v.l.$acceptDAMessage(d,O)}),X.onError(O=>{H&&H.onError&&H.onError(O),this.l.$acceptDAError(d,O.name,O.message,O.stack)}),X.onExit(O=>{H&&H.onExit&&H.onExit(O??void 0,void 0),this.l.$acceptDAExit(d,O??void 0,void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),X.startSession()))})}$sendDAMessage(d,I){I=(0,m.$yG)(I,!1);const v=this.E.get(d);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(I),this.D.get(d)?.sendMessage(I)}$stopDASession(d){const I=this.E.get(d);this.E.delete(d),I&&I.onWillStopSession&&I.onWillStopSession();const v=this.D.get(d);return this.D.delete(d),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const I=[],v=[],y=[];if(d.added)for(const E of d.added){const A=E.id;if(A&&!this.z.has(A)){let V;if(E.type==="function")V=new S.$4M(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage,E.mode);else if(E.type==="data")V=new S.$5M(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage,E.mode);else{const X=C.URI.revive(E.uri);V=new S.$3M(new S.$cM(X,new S.$4L(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage,E.mode)}(0,S.$1M)(V,A),this.z.set(A,V),I.push(V)}}if(d.removed)for(const E of d.removed){const A=this.z.get(E);A&&(this.z.delete(E),v.push(A))}if(d.changed){for(const E of d.changed)if(E.id){const A=this.z.get(E.id);if(A){if(A instanceof S.$4M&&E.type==="function"){const V=A;V.enabled=E.enabled,V.condition=E.condition,V.hitCondition=E.hitCondition,V.logMessage=E.logMessage,V.functionName=E.functionName}else if(A instanceof S.$3M&&E.type==="source"){const V=A;V.enabled=E.enabled,V.condition=E.condition,V.hitCondition=E.hitCondition,V.logMessage=E.logMessage,V.location=new S.$cM(C.URI.revive(E.uri),new S.$4L(E.line,E.character))}y.push(A)}}}this.gb(I,v,y)}async $acceptStackFrameFocus(d){let I;const v=d.sessionId?await this.hb(d.sessionId):void 0;if(!v)throw new Error("no DebugSession found for debug focus context");d.kind==="thread"?I=new S.$$M(v.api,d.threadId):I=new S.$0M(v.api,d.threadId,d.frameId),this.B=I,this.C.fire(this.B)}$provideDebugConfigurations(d,I,v){return(0,D.$9g)(async()=>{const y=this.bb(d);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.ib(I);return y.provideDebugConfigurations(E,v)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(d,I,v,y){return(0,D.$9g)(async()=>{const E=this.bb(d);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.ib(I);return E.resolveDebugConfiguration(A,v,y)})}$resolveDebugConfigurationWithSubstitutedVariables(d,I,v,y){return(0,D.$9g)(async()=>{const E=this.bb(d);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.ib(I);return E.resolveDebugConfigurationWithSubstitutedVariables(A,v,y)})}async $provideDebugAdapter(d,I){const v=this.ab(d);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.hb(I);return this.eb(v,y).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.Z(E)})}async $acceptDebugSessionStarted(d){const I=await this.hb(d);this.n.fire(I.api)}async $acceptDebugSessionTerminated(d){const I=await this.hb(d);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged(d){this.u=d?await this.hb(d):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(d,I){(await this.hb(d))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(d,I){const y={session:(await this.hb(d)).api,event:I.event,body:I.body};this.w.fire(y)}Z(d){if(d instanceof S.$6M)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof S.$7M)return{type:"server",port:d.port,host:d.host};if(d instanceof S.$8M)return{type:"pipeServer",path:d.path};if(d instanceof S.$9M)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}$(d){const I=this.h.filter(v=>v.type===d);if(I.length>0)return I[0].factory}ab(d){const I=this.h.filter(v=>v.handle===d);if(I.length>0)return I[0].factory}bb(d){const I=this.f.filter(v=>v.handle===d);if(I.length>0)return I[0].provider}cb(d,I){if(d.contributes){const v=d.contributes.debuggers;if(v&&v.length>0){for(const y of v)if(y.label&&y.type&&y.type===I)return!0}}return!1}db(d){const v=d.configuration.type,y=this.k.filter(E=>E.type===v||E.type==="*").map(E=>(0,D.$9g)(()=>E.factory.createDebugAdapterTracker(d.api)).then(A=>A,A=>null));return Promise.race([Promise.all(y).then(E=>{const A=E.filter(V=>!!V);if(A.length>0)return new c(A)}),new Promise(E=>setTimeout(()=>E(void 0),1e3))]).catch(E=>{})}async eb(d,I){const v=I.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new S.$7M(v));if(d){const E=await this.O.getExtensionRegistry();return(0,D.$9g)(()=>d.createDebugAdapterDescriptor(I.api,this.fb(I,E))).then(A=>{if(A)return A})}const y=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,y))}fb(d,I){}gb(d,I,v){(d.length>0||I.length>0||v.length>0)&&this.A.fire(Object.freeze({added:d,removed:I,changed:v}))}async hb(d){if(d)if(typeof d=="string"){const I=this.m.get(d);if(I)return I}else{let I=this.m.get(d.id);if(!I){const v=await this.ib(d.folderUri),y=d.parent?this.m.get(d.parent):void 0;I=new t(this.l,d.id,d.type,d.name,v,d.configuration,y?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib(d){if(d){const I=C.URI.revive(d);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb(d,I){return`${d}\0${I}`}kb(d,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${d}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(d){const I=this.mb(d);let v,y;return"id"in I?y=r.ThemeIcon.asClassName(I):v=I,{iconPath:v,iconClass:y}}mb(d){if(d instanceof S.$XM)return{id:d.id};const I=typeof d=="object"&&"dark"in d?d.dark:d,v=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof I=="string"?C.URI.file(I):I,light:typeof v=="string"?C.URI.file(v):v}}};e.$Sic=h,e.$Sic=h=Xe([He(0,F.$fO),He(1,l.$$hc),He(2,k.$Mic),He(3,s.$bic),He(4,f.$nic),He(5,u.$Pic),He(6,n.$BO)],h);class t{constructor(d,I,v,y,E,A,V){this.f=d,this.g=I,this.h=v,this.j=y,this.k=E,this.l=A,this.m=V}get api(){const d=this;return this.d??(this.d=Object.freeze({id:d.g,type:d.h,get name(){return d.j},set name(I){d.j=I,d.f.$setDebugSessionName(d.g,I)},parentSession:d.m,workspaceFolder:d.k,configuration:d.l,customRequest(I,v){return d.f.$customDebugAdapterRequest(d.g,I,v)},getDebugProtocolBreakpoint(I){return d.f.$getDebugProtocolBreakpoint(d.g,I.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.j=d}get configuration(){return this.l}}e.$Tic=t;class ${constructor(d){this.value=Object.freeze({append(I){d.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$Uic=$;class c{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(I=>I.onError?I.onError(d):void 0)}onExit(d,I){this.d.forEach(v=>v.onExit?v.onExit(d,I):void 0)}}class o extends w.$Onb{constructor(d){super(),this.h=d,d.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends h{constructor(d,I,v,y,E,A,V){super(d,I,v,y,E,A,V)}};e.$Vic=b,e.$Vic=b=Xe([He(0,F.$fO),He(1,l.$$hc),He(2,k.$Mic),He(3,s.$bic),He(4,f.$nic),He(5,u.$Pic),He(6,n.$BO)],b)}),define(Me[291],Ae([1,0,15,87,2,3,237,14,54,71,27,186,17,59,39,61]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=e.$Xjc=void 0;class u{static async installEarlyHandler(n){Error.stackTraceLimit=100;const a=n.get(g.$yj),t=n.get(l.$fO).getProxy(L.$1L.MainThreadErrors);D.setUnexpectedErrorHandler($=>{a.error($);const c=D.$3($);t.$onUnexpectedError(c)})}static async installFullHandler(n){const a=n.get(g.$yj),h=n.get(l.$fO),t=n.get(m.$Mic),$=n.get(s.$zO),c=h.getProxy(L.$1L.MainThreadExtensionService),o=h.getProxy(L.$1L.MainThreadErrors),b=await t.getExtensionPathIndex(),p=new WeakMap;function d(y,E){if(p.has(y))return p.get(y).stack;let A="",V,X;for(const O of E)A+=`
	at ${O.toString()}`,X=O.getFileName(),!V&&X&&(V=b.findSubstr(C.URI.file(X)));const H=`${y.name||"Error"}: ${y.message||""}${A}`;return p.set(y,{extensionIdentifier:V?.identifier,stack:H}),H}const I=Symbol("prepareStackTrace wrapped");let v=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(y){if(y===d||!y||y[I]){v=y||d;return}v=function(E,A){return d(E,A),y.call(Error,E,A)},Object.assign(v,{[I]:!0})}}),D.setUnexpectedErrorHandler(y=>{a.error(y);const E=D.$3(y),A=p.get(y);if(!A?.extensionIdentifier){o.$onUnexpectedError(E);return}c.$onExtensionRuntimeError(A.extensionIdentifier,E);const V=$.onExtensionError(A.extensionIdentifier,y);a.trace("forwarded error to extension?",V,A)})}}e.$Xjc=u;class i{constructor(n,a,h,t,$){this.a=h,this.b=new M.$V9b(n,null,t),a=i.e(a,this.b);const c=new k.$ci(...(0,f.$_r)());c.set(F.$vO,{_serviceBrand:void 0,...a,messagePorts:$}),c.set(l.$fO,new l.$gO(this.b)),c.set(w.$8hc,new w.$9hc(t)),c.set(m.$Kic,h);const o=new S.$Qq(c,!0);o.invokeFunction(u.installEarlyHandler),this.d=o.invokeFunction(b=>b.get(g.$yj)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=o.invokeFunction(b=>b.get(m.$Mic)),this.c.initialize(),o.invokeFunction(u.installFullHandler)}async asBrowserUri(n){const a=this.b.getProxy(L.$1L.MainThreadExtensionService);return C.URI.revive(await a.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,a){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=C.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=C.URI.revive(a.transformIncomingURIs(n.environment.appRoot));const h=n.environment.extensionDevelopmentLocationURI;return h&&(n.environment.extensionDevelopmentLocationURI=h.map(t=>C.URI.revive(a.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=C.URI.revive(a.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=C.URI.revive(a.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=C.URI.revive(a.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=C.URI.revive(a.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=C.URI.revive(a.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=C.URI.revive(a.transformIncomingURIs(n.logsLocation)),n.workspace=a.transformIncomingURIs(n.workspace),n}}e.$Yjc=i}),define(Me[292],Ae([1,0,18,11,22,35,12,19,25,2,44]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=e.$$ic=e.$0ic=void 0;class S{constructor(r,n,a,h){this.d=r,this.e=n,this.f=a,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,n){const a=this.d.folderQueries||[],h=new C.$ce(n);return new Promise((t,$)=>{this.a=new w(r);let c=!1;const o=(b,p)=>{if(!c&&!this.b){const d=this.h(b);s(b)&&typeof this.d.maxResults=="number"&&this.c+d>this.d.maxResults&&(this.b=!0,c=!0,h.cancel(),b=this.j(b,this.d.maxResults-this.c));const I=this.h(b);this.c+=I,(I>0||!s(b))&&this.a.add(b,p)}};Promise.all(a.map((b,p)=>this.k(b,d=>o(d,p),h.token))).then(b=>{h.dispose(),this.a.flush();const p=b.some(d=>!!d&&!!d.limitHit);t({limitHit:this.b||p,messages:(0,D.$Rb)(b.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.g}})},b=>{h.dispose();const p=(0,L.$2i)(b);$(new Error(p))})})}h(r){return s(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,n){const a=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:a.slice(0,n),preview:{matches:h.slice(0,n),text:r.preview.text},uri:r.uri}}async k(r,n,a){const h=new F.$DK(this.d,r),t=[],$={report:b=>{if(!this.l(b))return;const p=r.folder.scheme===M.Schemas.file?(0,F.$EK)(()=>this.f.readdir(f.$Qg(b.uri))):void 0,d=f.$Tg(r.folder,b.uri);if(d){const I=h.includedInQuery(d,g.$nc(d),p);(0,P.$3g)(I)?t.push(I.then(v=>{v&&n(b)})):I&&n(b)}}},c=this.n(r),o=await this.e.provideTextSearchResults(l(this.d.contentPattern),c,$,a);return t.length&&await Promise.all(t),o}l(r){if(s(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const n=(0,F.$CK)(this.d.includePattern,r.includePattern),a=(0,F.$CK)(this.d.excludePattern,r.excludePattern),h={folder:k.URI.from(r.folder),excludes:a,includes:n,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$0ic=S;function l(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class w{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new u(512,n=>this.g(n))}add(r,n){this.d&&(this.b!==n||!f.$Kg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:r.uri,results:[]}),this.d.results.push(m(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$$ic=w;function m(i){return s(i)?{preview:{matches:(0,D.$2b)(i.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:i.preview.text},ranges:(0,D.$2b)(i.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function s(i){return!!i.preview}e.$_ic=s;class u{constructor(r,n){this.g=r,this.h=n,this.c=0,this.d=[],this.e=0}addItem(r,n){r&&this.j(r,n)}addItems(r,n){r&&this.k(r,n)}j(r,n){this.d.push(r),this.e+=n,this.l()}k(r,n){this.d=this.d.concat(r),this.e+=n,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$ajc=u,u.a=4e3,u.b=50}),define(Me[119],Ae([1,0,6,3,4,287,17,59,14,2,292]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=e.$bjc=void 0,e.$bjc=(0,C.$ei)("IExtHostSearch");let S=class{constructor(s,u,i){this.k=s,this.l=u,this.n=i,this.c=this.k.getProxy(P.$1L.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$9ic}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,u){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const i=this.d++;return this.e.set(i,u),this.c.$registerTextSearchProvider(i,this.o(s)),(0,D.$Rc)(()=>{this.g.delete(s),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(s,u){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const i=this.d++;return this.h.set(i,u),this.c.$registerFileSearchProvider(i,this.o(s)),(0,D.$Rc)(()=>{this.i.delete(s),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(s,u,i,r){const n=l(i),a=this.h.get(s);if(a)return this.j.fileSearch(n,a,h=>{this.c.$handleFileMatch(s,u,h.map(t=>t.resource))},r);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,u,i){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,u,i,r){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const a=l(i);return this.q(a,n).search(t=>this.c.$handleTextMatch(s,u,t),r)}$enableExtensionHostSearch(){}q(s,u){return new F.$0ic(s,u,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$cjc=S,e.$cjc=S=Xe([He(0,M.$fO),He(1,g.$8hc),He(2,f.$yj)],S);function l(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(w),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>k.URI.revive(s))}}e.$djc=l;function w(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(Me[293],Ae([1,0,22,15,5,6,12,32,2,147,135,136,93,20,42,14,57,58,199,3,240,271,78,241,247,225,248,249,250,226,214,31,251,38,252,118,108,253,228,242,254,255,67,65,243,39,257,63,258,43,27,272,273,244,229,259,260,79,80,231,286,262,203,263,274,264,113,232,265,266,267,17,268,119,81,269,233,270,82,84,116,61,66,275,276,245,277,278,85,8,7,234,59,235,62,279,280,107,37,209,77,23,115]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$,c,o,b,p,d,I,v,y,E,A,V,X,H,O,R,B,T,te,Q,ce,le,se,$e,ne,ke,oe,ve,G,ge,ae,De,ye,we,he,K,Y,me,pe,Fe,be,Re,Pe,We,j,z,q,W,ie,ue,Le,Be,Ke,et,rt,ft,at,nt,ct,Ve,it,_,Z,Ee,qe,Ye,ut,Oe,It,Vt,Ut,Yt,Ht,Pt,Zt,_t,si,oi,_e,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;function xt($t){const vt=$t.get(ve.$vO),Kt=$t.get(oe.$Rhc),Nt=$t.get(ne.$dic),Bt=$t.get(se.$Mic),dt=$t.get(_t.$$hc),Mt=$t.get(ct.$zO),ei=$t.get(A.$bic),ti=$t.get(Vt.$8hc),Ge=$t.get(ie.$fO),Wt=$t.get(ft.$wic),Xt=$t.get(at.$eic),ni=$t.get(s.$zj),wt=$t.get(s.$yj),jt=$t.get(Ye.$yAb),At=$t.get(t.$Nhc),Rt=$t.get(Zt.$Rjc),ri=$t.get(Be.$Eic),zt=$t.get(ce.$nic),Gt=$t.get(K.$Iic);Ge.set(n.$2L.ExtHostFileSystemInfo,Kt),Ge.set(n.$2L.ExtHostLogLevelServiceShape,ni),Ge.set(n.$2L.ExtHostWorkspace,dt),Ge.set(n.$2L.ExtHostConfiguration,ei),Ge.set(n.$2L.ExtHostExtensionService,Bt),Ge.set(n.$2L.ExtHostStorage,Wt),Ge.set(n.$2L.ExtHostTunnelService,jt),Ge.set(n.$2L.ExtHostWindow,Rt),Ge.set(n.$2L.ExtHostSecretState,ri),Ge.set(n.$2L.ExtHostTelemetry,Mt),Ge.set(n.$2L.ExtHostEditorTabs,zt),Ge.set(n.$2L.ExtHostManagedSockets,Gt);const Lt=Ge.set(n.$2L.ExtHostDecorations,$t.get(H.$Xic)),Ct=Ge.set(n.$2L.ExtHostDocumentsAndEditors,$t.get(Q.$qO)),bt=Ge.set(n.$2L.ExtHostCommands,$t.get(y.$BO)),Et=Ge.set(n.$2L.ExtHostTerminalService,$t.get(Ve.$zic)),Dt=Ge.set(n.$2L.ExtHostDebugService,$t.get(X.$Ric)),mi=Ge.set(n.$2L.ExtHostSearch,$t.get(Le.$bjc)),Jt=Ge.set(n.$2L.ExtHostTask,$t.get(nt.$Ejc)),hi=Ge.set(n.$2L.ExtHostOutputService,$t.get(We.$rjc)),Se=Ge.set(n.$2L.ExtHostLocalization,$t.get(he.$Hic)),Te=Ge.set(n.$2L.ExtHostUrls,new Ut.$Ojc(Ge)),de=Ge.set(n.$2L.ExtHostDocuments,new te.$Uhc(Ge,Ct)),J=Ge.set(n.$2L.ExtHostDocumentContentProviders,new B.$Zic(Ge,Ct,wt)),Ie=Ge.set(n.$2L.ExtHostDocumentSaveParticipant,new T.$1ic(wt,de,Ge.getProxy(n.$1L.MainThreadBulkEdits))),Ne=Ge.set(n.$2L.ExtHostNotebook,new me.$ejc(Ge,bt,Ct,de,Nt,mi)),Ze=Ge.set(n.$2L.ExtHostNotebookDocuments,new Fe.$ljc(Ne)),Je=Ge.set(n.$2L.ExtHostNotebookEditors,new be.$mjc(wt,Ne)),ot=Ge.set(n.$2L.ExtHostNotebookKernels,new Re.$njc(Ge,vt,Ne,bt,wt)),kt=Ge.set(n.$2L.ExtHostNotebookRenderers,new Pe.$pjc(Ge,Ne)),Qt=Ge.set(n.$2L.ExtHostNotebookDocumentSaveParticipant,new pe.$kjc(wt,Ne,Ge.getProxy(n.$1L.MainThreadBulkEdits))),St=Ge.set(n.$2L.ExtHostEditors,new _.$5hc(Ge,Ct)),Ot=Ge.set(n.$2L.ExtHostTreeViews,new qe.$Mjc(Ge.getProxy(n.$1L.MainThreadTreeViews),bt,wt)),ii=Ge.set(n.$2L.ExtHostEditorInsets,new v.$6hc(Ge.getProxy(n.$1L.MainThreadEditorInsets),St,vt.remote)),ci=Ge.set(n.$2L.ExtHostDiagnostics,new O.$Thc(Ge,wt,Kt,Ct)),wi=Ge.set(n.$2L.ExtHostLanguages,new we.$ijc(Ge,de,bt.converter,ti)),gt=Ge.set(n.$2L.ExtHostLanguageFeatures,new ye.$Vhc(Ge,ti,de,bt,ci,wt,At,Mt)),Oi=Ge.set(n.$2L.ExtHostFileSystem,new $e.$3ic(Ge,gt)),ui=Ge.set(n.$2L.ExtHostFileSystemEventService,new ke.$4ic(Ge,wt,Ct)),$i=Ge.set(n.$2L.ExtHostQuickOpen,(0,W.$vjc)(Ge,dt,bt)),ki=Ge.set(n.$2L.ExtHostSCM,new ue.$xjc(Ge,bt,de,wt)),Ti=Ge.set(n.$2L.ExtHostQuickDiff,new q.$ujc(Ge,ti)),Ni=Ge.set(n.$2L.ExtHostShare,new Ke.$yjc(Ge,ti)),ji=Ge.set(n.$2L.ExtHostComments,(0,E.$7hc)(Ge,bt,de)),Si=Ge.set(n.$2L.ExtHostProgress,new z.$tjc(Ge.getProxy(n.$1L.MainThreadProgress))),Ji=Ge.set(n.$2L.ExtHostLabelService,new De.$hjc(Ge)),Ii=Ge.set(n.$2L.ExtHostTheming,new Z.$Jjc(Ge)),di=Ge.set(n.$2L.ExtHostAuthentication,new $.$Xhc(Ge)),zi=Ge.set(n.$2L.ExtHostTimeline,new Ee.$Ljc(Ge,bt)),bi=Ge.set(n.$2L.ExtHostWebviews,new Yt.$iic(Ge,vt.remote,dt,wt,At)),Ci=Ge.set(n.$2L.ExtHostWebviewPanels,new Ht.$lic(Ge,bi,dt)),fn=Ge.set(n.$2L.ExtHostCustomEditors,new V.$mic(Ge,de,Xt,bi,Ci)),Qi=Ge.set(n.$2L.ExtHostWebviewViews,new Pt.$Pjc(Ge,bi)),pi=Ge.set(n.$2L.ExtHostTesting,new it.$Fjc(Ge,wt,bt,Ct)),Ui=Ge.set(n.$2L.ExtHostUriOpeners,new It.$Njc(Ge)),Xi=Ge.set(n.$2L.ExtHostProfileContentHandlers,new j.$sjc(Ge));Ge.set(n.$2L.ExtHostInteractive,new ge.$fjc(Ge,Ne,Ct,bt,wt));const Yi=Ge.set(n.$2L.ExtHostInlineChat,new G.$5ic(Ge,bt,de,wt)),yi=Ge.set(n.$2L.ExtHostChatProvider,new p.$2hc(Ge,wt,di)),Zi=Ge.set(n.$2L.ExtHostChatAgents2,new b.$1hc(Ge,wt,bt)),_i=Ge.set(n.$2L.ExtHostChatVariables,new d.$3hc(Ge)),Bi=Ge.set(n.$2L.ExtHostChat,new o.$Zhc(Ge)),xi=Ge.set(n.$2L.ExtHostAiRelatedInformation,new a.$Mhc(Ge)),Wi=Ge.set(n.$2L.ExtHostAiEmbeddingVector,new le.$2ic(Ge)),Pi=Ge.set(n.$2L.ExtHostIssueReporter,new ae.$gjc(Ge)),en=Ge.set(n.$2L.ExtHostStatusBar,new rt.$Bjc(Ge,bt.converter)),gn=Ge.set(n.$2L.ExtHostSpeech,new et.$zjc(Ge)),tn=Object.values(n.$2L);Ge.assertRegistered(tn);const mn=new c.$Yhc(Ge,Ct),Ri=new I.$4hc(Ge),Mi=new Y.$jjc(Ge,wt),Vi=new R.$Yic(Ge);return h.$Whc.register(bt),function(je,fi,Ai){function st(ee){return(fe,ze,lt)=>{const yt=ee(Ft=>{try{fe.call(ze,Ft)}catch(Di){P.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),Mt.onExtensionError(je.identifier,Di)}});return lt?.push(yt),yt}}const mt=function(){let ee=!je.isUnderDevelopment;function fe(){ee||(wt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function ze(lt){if(Array.isArray(lt))lt.forEach(ze);else if(typeof lt=="string")fe();else{const yt=lt;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,_e.$WF)(je,"documentFiltersExclusive")}return lt}}(),Fi={getSession(ee,fe,ze){return di.getSession(je,ee,fe,ze)},getSessions(ee,fe){return(0,_e.$WF)(je,"authGetSessions"),di.getSessions(je,ee,fe)},async hasSession(ee,fe){return(0,_e.$WF)(je,"authSession"),!!await di.getSession(je,ee,fe,{silent:!0})},get onDidChangeSessions(){return st(di.onDidChangeSessions)},registerAuthenticationProvider(ee,fe,ze,lt){return di.registerAuthenticationProvider(ee,fe,ze,lt)}},$n={registerCommand(ee,fe,ze){return bt.registerCommand(!0,ee,fe,ze,void 0,je)},registerTextEditorCommand(ee,fe,ze){return bt.registerCommand(!0,ee,(...lt)=>{const yt=St.getActiveTextEditor();if(!yt){wt.warn("Cannot execute "+ee+" because there is no active text editor.");return}return yt.edit(Ft=>{fe.apply(ze,[yt,Ft,...lt])}).then(Ft=>{Ft||wt.warn("Edits from command "+ee+" were not applied.")},Ft=>{wt.warn("An error occurred while running command "+ee,Ft)})},void 0,void 0,je)},registerDiffInformationCommand:(ee,fe,ze)=>((0,_e.$WF)(je,"diffCommand"),bt.registerCommand(!0,ee,async(...lt)=>{const yt=Ct.activeEditor(!0);if(!yt){wt.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Ft=await St.getDiffInformation(yt.id);fe.apply(ze,[Ft,...lt])},void 0,void 0,je)),executeCommand(ee,...fe){return bt.executeCommand(ee,...fe)},getCommands(ee=!1){return bt.getCommands(ee)}},qi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Ri.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return st(Et.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$WF)(je,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$WF)(je,"telemetry"),st(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ct.$yO)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,fe){return ct.$xO.validateSender(ee),Mt.instantiateLogger(je,ee,fe)},openExternal(ee,fe){return Rt.openUri(ee,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===vt.environment.appUriScheme)return Te.createAppUri(ee);try{return await Rt.asExternalUri(ee,{allowTunneling:!!vt.remote.authority})}catch(fe){if((0,M.$og)(ee,M.Schemas.http)||(0,M.$og)(ee,M.Schemas.https))return ee;throw fe}},get remoteName(){return(0,u.$ml)(vt.remote.authority)},get remoteAuthority(){return(0,_e.$WF)(je,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return st(wt.onDidChangeLogLevel)},registerIssueUriRequestHandler(ee){return(0,_e.$WF)(je,"handleIssueUri"),Pi.registerIssueUriRequestHandler(je,ee)},registerIssueDataProvider(ee){return(0,_e.$WF)(je,"handleIssueUri"),Pi.registerIssueDataProvider(je,ee)},get appQuality(){return(0,_e.$WF)(je,"resolvers"),vt.quality},get appCommit(){return(0,_e.$WF)(je,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(qi);const Li={createTestController(ee,fe,ze){return pi.createTestController(je,ee,fe,ze)},createTestObserver(){return(0,_e.$WF)(je,"testObserver"),pi.createTestObserver()},runTests(ee){return(0,_e.$WF)(je,"testObserver"),pi.runTests(ee)},get onDidChangeTestResults(){return(0,_e.$WF)(je,"testObserver"),st(pi.onResultsChanged)},get testResults(){return(0,_e.$WF)(je,"testObserver"),pi.results}},Ei=vt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension(ee,fe){(0,_e.$VF)(je,"extensionsAny")||(fe=!1);const ze=fi.mine.getExtensionDescription(ee);if(ze)return new se.$Nic(Bt,je.identifier,ze,Ei,!1);if(fe){const lt=fi.all.getExtensionDescription(ee);if(lt)return new se.$Nic(Bt,je.identifier,lt,Ei,!0)}},get all(){const ee=[];for(const fe of fi.mine.getAllExtensionDescriptions())ee.push(new se.$Nic(Bt,je.identifier,fe,Ei,!1));return ee},get allAcrossExtensionHosts(){(0,_e.$WF)(je,"extensionsAny");const ee=new w.$ym(fi.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),fe=[];for(const ze of fi.all.getAllExtensionDescriptions()){const lt=!ee.has(ze.identifier);fe.push(new se.$Nic(Bt,je.identifier,ze,Ei,lt))}return fe},get onDidChange(){return(0,_e.$VF)(je,"extensionsAny")?st(C.Event.any(fi.mine.onDidChange,fi.all.onDidChange)):st(fi.mine.onDidChange)}},rn={createDiagnosticCollection(ee){return ci.createDiagnosticCollection(je.identifier,ee)},get onDidChangeDiagnostics(){return st(ci.onDidChangeDiagnostics)},getDiagnostics:ee=>ci.getDiagnostics(ee),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(ee,fe){return wi.changeLanguage(ee.uri,fe)},match(ee,fe){const ze=ut.LanguageSelector.from(ee);let lt;return(0,F.$Ot)(ze)&&(lt=Ne.notebookDocuments.find(yt=>!!yt.getCell(fe.uri))?.apiNotebook),(0,F.$Nt)(ze,fe.uri,fe.languageId,!0,lt?.uri,lt?.notebookType)},registerCodeActionsProvider(ee,fe,ze){return gt.registerCodeActionProvider(je,mt(ee),fe,ze)},registerDocumentPasteEditProvider(ee,fe,ze){return(0,_e.$WF)(je,"documentPaste"),gt.registerDocumentPasteEditProvider(je,mt(ee),fe,ze)},registerCodeLensProvider(ee,fe){return gt.registerCodeLensProvider(je,mt(ee),fe)},registerDefinitionProvider(ee,fe){return gt.registerDefinitionProvider(je,mt(ee),fe)},registerDeclarationProvider(ee,fe){return gt.registerDeclarationProvider(je,mt(ee),fe)},registerImplementationProvider(ee,fe){return gt.registerImplementationProvider(je,mt(ee),fe)},registerTypeDefinitionProvider(ee,fe){return gt.registerTypeDefinitionProvider(je,mt(ee),fe)},registerHoverProvider(ee,fe){return gt.registerHoverProvider(je,mt(ee),fe,je.identifier)},registerEvaluatableExpressionProvider(ee,fe){return gt.registerEvaluatableExpressionProvider(je,mt(ee),fe,je.identifier)},registerInlineValuesProvider(ee,fe){return gt.registerInlineValuesProvider(je,mt(ee),fe,je.identifier)},registerDocumentHighlightProvider(ee,fe){return gt.registerDocumentHighlightProvider(je,mt(ee),fe)},registerMultiDocumentHighlightProvider(ee,fe){return gt.registerMultiDocumentHighlightProvider(je,mt(ee),fe)},registerLinkedEditingRangeProvider(ee,fe){return gt.registerLinkedEditingRangeProvider(je,mt(ee),fe)},registerReferenceProvider(ee,fe){return gt.registerReferenceProvider(je,mt(ee),fe)},registerRenameProvider(ee,fe){return gt.registerRenameProvider(je,mt(ee),fe)},registerNewSymbolNamesProvider(ee,fe){return(0,_e.$WF)(je,"newSymbolNamesProvider"),gt.registerNewSymbolNamesProvider(je,mt(ee),fe)},registerDocumentSymbolProvider(ee,fe,ze){return gt.registerDocumentSymbolProvider(je,mt(ee),fe,ze)},registerWorkspaceSymbolProvider(ee){return gt.registerWorkspaceSymbolProvider(je,ee)},registerDocumentFormattingEditProvider(ee,fe){return gt.registerDocumentFormattingEditProvider(je,mt(ee),fe)},registerDocumentRangeFormattingEditProvider(ee,fe){return gt.registerDocumentRangeFormattingEditProvider(je,mt(ee),fe)},registerOnTypeFormattingEditProvider(ee,fe,ze,...lt){return gt.registerOnTypeFormattingEditProvider(je,mt(ee),fe,[ze].concat(lt))},registerDocumentSemanticTokensProvider(ee,fe,ze){return gt.registerDocumentSemanticTokensProvider(je,mt(ee),fe,ze)},registerDocumentRangeSemanticTokensProvider(ee,fe,ze){return gt.registerDocumentRangeSemanticTokensProvider(je,mt(ee),fe,ze)},registerSignatureHelpProvider(ee,fe,ze,...lt){return typeof ze=="object"?gt.registerSignatureHelpProvider(je,mt(ee),fe,ze):gt.registerSignatureHelpProvider(je,mt(ee),fe,typeof ze>"u"?[]:[ze,...lt])},registerCompletionItemProvider(ee,fe,...ze){return gt.registerCompletionItemProvider(je,mt(ee),fe,ze)},registerInlineCompletionItemProvider(ee,fe,ze){return fe.handleDidShowCompletionItem&&(0,_e.$WF)(je,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,_e.$WF)(je,"inlineCompletionsAdditions"),ze&&(0,_e.$WF)(je,"inlineCompletionsAdditions"),gt.registerInlineCompletionsProvider(je,mt(ee),fe,ze)},registerInlineEditProvider(ee,fe){return(0,_e.$WF)(je,"inlineEdit"),gt.registerInlineEditProvider(je,mt(ee),fe)},registerDocumentLinkProvider(ee,fe){return gt.registerDocumentLinkProvider(je,mt(ee),fe)},registerColorProvider(ee,fe){return gt.registerColorProvider(je,mt(ee),fe)},registerFoldingRangeProvider(ee,fe){return gt.registerFoldingRangeProvider(je,mt(ee),fe)},registerSelectionRangeProvider(ee,fe){return gt.registerSelectionRangeProvider(je,ee,fe)},registerCallHierarchyProvider(ee,fe){return gt.registerCallHierarchyProvider(je,ee,fe)},registerTypeHierarchyProvider(ee,fe){return gt.registerTypeHierarchyProvider(je,ee,fe)},setLanguageConfiguration:(ee,fe)=>gt.setLanguageConfiguration(je,ee,fe),getTokenInformationAtPosition(ee,fe){return(0,_e.$WF)(je,"tokenInformation"),wi.tokenAtPosition(ee,fe)},registerInlayHintsProvider(ee,fe){return gt.registerInlayHintsProvider(je,ee,fe)},createLanguageStatusItem(ee,fe){return wi.createLanguageStatusItem(je,ee,fe)},registerDocumentDropEditProvider(ee,fe,ze){return gt.registerDocumentOnDropEditProvider(je,ee,fe,(0,_e.$VF)(je,"dropMetadata")?ze:void 0)}},sn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ee,fe,ze){f.URI.isUri(ee)&&ee.scheme===M.Schemas.vscodeRemote&&!ee.authority&&At.report("workspace.showTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority.");const lt=await(f.URI.isUri(ee)?Promise.resolve(on.openTextDocument(ee)):Promise.resolve(ee));return St.showTextDocument(lt,fe,ze)},createTextEditorDecorationType(ee){return St.createTextEditorDecorationType(je,ee)},onDidChangeActiveTextEditor(ee,fe,ze){return st(St.onDidChangeActiveTextEditor)(ee,fe,ze)},onDidChangeVisibleTextEditors(ee,fe,ze){return st(St.onDidChangeVisibleTextEditors)(ee,fe,ze)},onDidChangeTextEditorSelection(ee,fe,ze){return st(St.onDidChangeTextEditorSelection)(ee,fe,ze)},onDidChangeTextEditorOptions(ee,fe,ze){return st(St.onDidChangeTextEditorOptions)(ee,fe,ze)},onDidChangeTextEditorVisibleRanges(ee,fe,ze){return st(St.onDidChangeTextEditorVisibleRanges)(ee,fe,ze)},onDidChangeTextEditorViewColumn(ee,fe,ze){return st(St.onDidChangeTextEditorViewColumn)(ee,fe,ze)},onDidCloseTerminal(ee,fe,ze){return st(Et.onDidCloseTerminal)(ee,fe,ze)},onDidOpenTerminal(ee,fe,ze){return st(Et.onDidOpenTerminal)(ee,fe,ze)},onDidChangeActiveTerminal(ee,fe,ze){return st(Et.onDidChangeActiveTerminal)(ee,fe,ze)},onDidChangeTerminalDimensions(ee,fe,ze){return(0,_e.$WF)(je,"terminalDimensions"),st(Et.onDidChangeTerminalDimensions)(ee,fe,ze)},onDidChangeTerminalState(ee,fe,ze){return st(Et.onDidChangeTerminalState)(ee,fe,ze)},onDidWriteTerminalData(ee,fe,ze){return(0,_e.$WF)(je,"terminalDataWriteEvent"),st(Et.onDidWriteTerminalData)(ee,fe,ze)},onDidExecuteTerminalCommand(ee,fe,ze){return(0,_e.$WF)(je,"terminalExecuteCommandEvent"),st(Et.onDidExecuteTerminalCommand)(ee,fe,ze)},get state(){return Rt.getState(je)},onDidChangeWindowState(ee,fe,ze){return st(Rt.onDidChangeWindowState)(ee,fe,ze)},showInformationMessage(ee,...fe){return Mi.showMessage(je,g.default.Info,ee,fe[0],fe.slice(1))},showWarningMessage(ee,...fe){return Mi.showMessage(je,g.default.Warning,ee,fe[0],fe.slice(1))},showErrorMessage(ee,...fe){return Mi.showMessage(je,g.default.Error,ee,fe[0],fe.slice(1))},showQuickPick(ee,fe,ze){return $i.showQuickPick(je,ee,fe,ze)},showWorkspaceFolderPick(ee){return $i.showWorkspaceFolderPick(ee)},showInputBox(ee,fe){return $i.showInput(ee,fe)},showOpenDialog(ee){return Vi.showOpenDialog(je,ee)},showSaveDialog(ee){return Vi.showSaveDialog(ee)},createStatusBarItem(ee,fe,ze){let lt,yt,Ft;return typeof ee=="string"?(lt=ee,yt=fe,Ft=ze):(yt=ee,Ft=fe),en.createStatusBarEntry(je,lt,yt,Ft)},setStatusBarMessage(ee,fe){return en.setStatusBarMessage(ee,fe)},withScmProgress(ee){return At.report("window.withScmProgress",je,"Use 'withProgress' instead."),Si.withProgress(je,{location:Oe.ProgressLocation.SourceControl},(fe,ze)=>ee({report(lt){}}))},withProgress(ee,fe){return Si.withProgress(je,ee,fe)},createOutputChannel(ee,fe){return hi.createOutputChannel(ee,fe,je)},createWebviewPanel(ee,fe,ze,lt){return Ci.createWebviewPanel(je,ee,fe,ze,lt)},createWebviewTextEditorInset(ee,fe,ze,lt){return(0,_e.$WF)(je,"editorInsets"),ii.createWebviewEditorInset(ee,fe,ze,lt,je)},createTerminal(ee,fe,ze){return typeof ee=="object"?"pty"in ee?Et.createExtensionTerminal(ee):Et.createTerminalFromOptions(ee):Et.createTerminal(ee,fe,ze)},registerTerminalLinkProvider(ee){return Et.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,fe){return Et.registerProfileProvider(je,ee,fe)},registerTerminalQuickFixProvider(ee,fe){return(0,_e.$WF)(je,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(ee,je.identifier.value,fe)},registerTreeDataProvider(ee,fe){return Ot.registerTreeDataProvider(ee,fe,je)},createTreeView(ee,fe){return Ot.createTreeView(ee,fe,je)},registerWebviewPanelSerializer:(ee,fe)=>Ci.registerWebviewPanelSerializer(je,ee,fe),registerCustomEditorProvider:(ee,fe,ze={})=>fn.registerCustomEditorProvider(je,ee,fe,ze),registerFileDecorationProvider(ee){return Lt.registerFileDecorationProvider(ee,je)},registerUriHandler(ee){return Te.registerUriHandler(je,ee)},createQuickPick(){return $i.createQuickPick(je)},createInputBox(){return $i.createInputBox(je)},get activeColorTheme(){return Ii.activeColorTheme},onDidChangeActiveColorTheme(ee,fe,ze){return st(Ii.onDidChangeActiveColorTheme)(ee,fe,ze)},registerWebviewViewProvider(ee,fe,ze){return Qi.registerWebviewViewProvider(je,ee,fe,ze?.webviewOptions)},get activeNotebookEditor(){return Ne.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,fe,ze){return st(Ne.onDidChangeActiveNotebookEditor)(ee,fe,ze)},get visibleNotebookEditors(){return Ne.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(Ne.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,fe,ze){return st(Je.onDidChangeNotebookEditorSelection)(ee,fe,ze)},onDidChangeNotebookEditorVisibleRanges(ee,fe,ze){return st(Je.onDidChangeNotebookEditorVisibleRanges)(ee,fe,ze)},showNotebookDocument(ee,fe){return Ne.showNotebookDocument(ee,fe)},registerExternalUriOpener(ee,fe,ze){return(0,_e.$WF)(je,"externalUriOpener"),Ui.registerExternalUriOpener(je.identifier,ee,fe,ze)},registerProfileContentHandler(ee,fe){return(0,_e.$WF)(je,"profileContentHandlers"),Xi.registerProfileContentHandler(je,ee,fe)},registerQuickDiffProvider(ee,fe,ze,lt){return(0,_e.$WF)(je,"quickDiffProvider"),Ti.registerQuickDiffProvider(mt(ee),fe,ze,lt)},get tabGroups(){return zt.tabGroups},registerShareProvider(ee,fe){return(0,_e.$WF)(je,"shareProvider"),Ni.registerShareProvider(mt(ee),fe)}},on={get rootPath(){return At.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new P.$9("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new P.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new P.$9("workspaceFile")},updateWorkspaceFolders:(ee,fe,...ze)=>dt.updateWorkspaceFolders(je,ee,fe||0,...ze),onDidChangeWorkspaceFolders:function(ee,fe,ze){return st(dt.onDidChangeWorkspace)(ee,fe,ze)},asRelativePath:(ee,fe)=>dt.getRelativePath(ee,fe),findFiles:(ee,fe,ze,lt)=>dt.findFiles(ee,fe,ze,je.identifier,lt),findFiles2:(ee,fe,ze)=>((0,_e.$WF)(je,"findFiles2"),dt.findFiles2(ee,fe,je.identifier,ze)),findTextInFiles:(ee,fe,ze,lt)=>{(0,_e.$WF)(je,"findTextInFiles");let yt,Ft;return typeof fe=="object"?(yt=fe,Ft=ze):(yt={},Ft=fe,lt=ze),dt.findTextInFiles(ee,yt||{},Ft,je.identifier,lt)},save:ee=>dt.save(ee),saveAs:ee=>dt.saveAs(ee),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,fe){return mn.applyWorkspaceEdit(ee,je,fe)},createFileSystemWatcher:(ee,fe,ze,lt)=>{let yt;return typeof fe=="boolean"?yt={ignoreCreateEvents:!!fe,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!lt,correlate:!1}:fe&&((0,_e.$WF)(je,"createFileSystemWatcher"),yt={...fe,correlate:!0}),ui.createFileSystemWatcher(dt,je,ee,yt)},get textDocuments(){return de.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new P.$9("textDocuments")},openTextDocument(ee){let fe;const ze=ee;if(typeof ee=="string")fe=Promise.resolve(f.URI.file(ee));else if(f.URI.isUri(ee))fe=Promise.resolve(ee);else if(!ze||typeof ze=="object")fe=de.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(lt=>(lt.scheme===M.Schemas.vscodeRemote&&!lt.authority&&At.report("workspace.openTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority."),de.ensureDocumentData(lt).then(yt=>yt.document)))},onDidOpenTextDocument:(ee,fe,ze)=>st(de.onDidAddDocument)(ee,fe,ze),onDidCloseTextDocument:(ee,fe,ze)=>st(de.onDidRemoveDocument)(ee,fe,ze),onDidChangeTextDocument:(ee,fe,ze)=>st(de.onDidChangeDocument)(ee,fe,ze),onDidSaveTextDocument:(ee,fe,ze)=>st(de.onDidSaveDocument)(ee,fe,ze),onWillSaveTextDocument:(ee,fe,ze)=>st(Ie.getOnWillSaveTextDocumentEvent(je))(ee,fe,ze),get notebookDocuments(){return Ne.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,fe){let ze;if(f.URI.isUri(ee))ze=ee,await Ne.openNotebookDocument(ee);else if(typeof ee=="string")ze=f.URI.revive(await Ne.createNotebookDocument({viewType:ee,content:fe}));else throw new Error("Invalid arguments");return Ne.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(ee,fe,ze){return st(Ze.onDidSaveNotebookDocument)(ee,fe,ze)},onDidChangeNotebookDocument(ee,fe,ze){return st(Ze.onDidChangeNotebookDocument)(ee,fe,ze)},onWillSaveNotebookDocument(ee,fe,ze){return st(Qt.getOnWillSaveNotebookDocumentEvent(je))(ee,fe,ze)},get onDidOpenNotebookDocument(){return st(Ne.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(Ne.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,fe,ze,lt){return Ne.registerNotebookSerializer(je,ee,fe,ze,(0,_e.$VF)(je,"notebookLiveShare")?lt:void 0)},onDidChangeConfiguration:(ee,fe,ze)=>st(Ai.onDidChangeConfiguration)(ee,fe,ze),getConfiguration(ee,fe){return fe=arguments.length===1?void 0:fe,Ai.getConfiguration(ee,fe,je)},registerTextDocumentContentProvider(ee,fe){return J.registerTextDocumentContentProvider(ee,fe)},registerTaskProvider:(ee,fe)=>(At.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(je,ee,fe)),registerFileSystemProvider(ee,fe,ze){return(0,L.$Qc)(Oi.registerFileSystemProvider(je,ee,fe,ze),Nt.addFileSystemProvider(ee,fe,ze))},get fs(){return Nt.value},registerFileSearchProvider:(ee,fe)=>((0,_e.$WF)(je,"fileSearchProvider"),mi.registerFileSearchProvider(ee,fe)),registerTextSearchProvider:(ee,fe)=>((0,_e.$WF)(je,"textSearchProvider"),mi.registerTextSearchProvider(ee,fe)),registerRemoteAuthorityResolver:(ee,fe)=>((0,_e.$WF)(je,"resolvers"),Bt.registerRemoteAuthorityResolver(ee,fe)),registerResourceLabelFormatter:ee=>((0,_e.$WF)(je,"resolvers"),Ji.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,_e.$WF)(je,"resolvers"),Bt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,fe,ze)=>st(ui.onDidCreateFile)(ee,fe,ze),onDidDeleteFiles:(ee,fe,ze)=>st(ui.onDidDeleteFile)(ee,fe,ze),onDidRenameFiles:(ee,fe,ze)=>st(ui.onDidRenameFile)(ee,fe,ze),onWillCreateFiles:(ee,fe,ze)=>st(ui.getOnWillCreateFileEvent(je))(ee,fe,ze),onWillDeleteFiles:(ee,fe,ze)=>st(ui.getOnWillDeleteFileEvent(je))(ee,fe,ze),onWillRenameFiles:(ee,fe,ze)=>st(ui.getOnWillRenameFileEvent(je))(ee,fe,ze),openTunnel:ee=>((0,_e.$WF)(je,"tunnels"),jt.openTunnel(je,ee).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,_e.$WF)(je,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(ee,fe,ze)=>((0,_e.$WF)(je,"tunnels"),st(jt.onDidChangeTunnels)(ee,fe,ze)),registerPortAttributesProvider:(ee,fe)=>((0,_e.$WF)(je,"portsAttributes"),jt.registerPortsAttributesProvider(ee,fe)),registerTunnelProvider:(ee,fe)=>((0,_e.$WF)(je,"tunnelFactory"),jt.registerTunnelProvider(ee,fe)),registerTimelineProvider:(ee,fe)=>((0,_e.$WF)(je,"timeline"),zi.registerTimelineProvider(ee,fe,je.identifier,bt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,_e.$WF)(je,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,fe,ze)=>st(dt.onDidGrantWorkspaceTrust)(ee,fe,ze),registerEditSessionIdentityProvider:(ee,fe)=>((0,_e.$WF)(je,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,fe)),onWillCreateEditSessionIdentity:(ee,fe,ze)=>((0,_e.$WF)(je,"editSessionIdentityProvider"),st(dt.getOnWillCreateEditSessionIdentityEvent(je))(ee,fe,ze)),registerCanonicalUriProvider:(ee,fe)=>((0,_e.$WF)(je,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,fe)),getCanonicalUri:(ee,fe,ze)=>((0,_e.$WF)(je,"canonicalUriProvider"),dt.provideCanonicalUri(ee,fe,ze))},an={get inputBox(){return At.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(je)},createSourceControl(ee,fe,ze){return ki.createSourceControl(je,ee,fe,ze)}},cn={createCommentController(ee,fe){return ji.createCommentController(je,ee,fe)}},pn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get stackFrameFocus(){return Dt.stackFrameFocus},registerDebugVisualizationProvider(ee,fe){return(0,_e.$WF)(je,"debugVisualization"),Dt.registerDebugVisualizationProvider(je,ee,fe)},registerDebugVisualizationTreeProvider(ee,fe){return(0,_e.$WF)(je,"debugVisualization"),Dt.registerDebugVisualizationTree(je,ee,fe)},onDidStartDebugSession(ee,fe,ze){return st(Dt.onDidStartDebugSession)(ee,fe,ze)},onDidTerminateDebugSession(ee,fe,ze){return st(Dt.onDidTerminateDebugSession)(ee,fe,ze)},onDidChangeActiveDebugSession(ee,fe,ze){return st(Dt.onDidChangeActiveDebugSession)(ee,fe,ze)},onDidReceiveDebugSessionCustomEvent(ee,fe,ze){return st(Dt.onDidReceiveDebugSessionCustomEvent)(ee,fe,ze)},onDidChangeBreakpoints(ee,fe,ze){return st(Dt.onDidChangeBreakpoints)(ee,fe,ze)},onDidChangeStackFrameFocus(ee,fe,ze){return(0,_e.$WF)(je,"debugFocus"),st(Dt.onDidChangeStackFrameFocus)(ee,fe,ze)},registerDebugConfigurationProvider(ee,fe,ze){return Dt.registerDebugConfigurationProvider(ee,fe,ze||si.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,fe){return Dt.registerDebugAdapterDescriptorFactory(je,ee,fe)},registerDebugAdapterTrackerFactory(ee,fe){return Dt.registerDebugAdapterTrackerFactory(ee,fe)},startDebugging(ee,fe,ze){return!ze||typeof ze=="object"&&"configuration"in ze?Dt.startDebugging(ee,fe,{parentSession:ze}):Dt.startDebugging(ee,fe,ze||{})},stopDebugging(ee){return Dt.stopDebugging(ee)},addBreakpoints(ee){return Dt.addBreakpoints(ee)},removeBreakpoints(ee){return Dt.removeBreakpoints(ee)},asDebugSourceUri(ee,fe){return Dt.asDebugSourceUri(ee,fe)}},vn={registerTaskProvider:(ee,fe)=>Jt.registerTaskProvider(je,ee,fe),fetchTasks:ee=>Jt.fetchTasks(ee),executeTask:ee=>Jt.executeTask(je,ee),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(ee,fe,ze)=>st(Jt.onDidStartTask)(ee,fe,ze),onDidEndTask:(ee,fe,ze)=>st(Jt.onDidEndTask)(ee,fe,ze),onDidStartTaskProcess:(ee,fe,ze)=>st(Jt.onDidStartTaskProcess)(ee,fe,ze),onDidEndTaskProcess:(ee,fe,ze)=>st(Jt.onDidEndTaskProcess)(ee,fe,ze)},un={createNotebookController(ee,fe,ze,lt,yt){return ot.createNotebookController(je,ee,fe,ze,lt,(0,_e.$VF)(je,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,fe)=>Ne.registerNotebookCellStatusBarItemProvider(je,ee,fe),createRendererMessaging(ee){return kt.createRendererMessaging(je,ee)},createNotebookControllerDetectionTask(ee){return(0,_e.$WF)(je,"notebookKernelSource"),ot.createNotebookControllerDetectionTask(je,ee)},registerKernelSourceActionProvider(ee,fe){return(0,_e.$WF)(je,"notebookKernelSource"),ot.registerKernelSourceActionProvider(je,ee,fe)},onDidChangeNotebookCellExecutionState(ee,fe,ze){return(0,_e.$WF)(je,"notebookCellExecutionState"),st(ot.onDidChangeNotebookCellExecutionState)(ee,fe,ze)}},Hi={t(...ee){if(typeof ee[0]=="string"){const fe=ee.shift(),ze=!ee||typeof ee[0]!="object"?ee:ee[0];return Se.getMessage(je.identifier.value,{message:fe,args:ze})}return Se.getMessage(je.identifier.value,ee[0])},get bundle(){return Se.getBundle(je.identifier.value)},get uri(){return Se.getBundleUri(je.identifier.value)}},ln={_version:1,registerInteractiveEditorSessionProvider(ee,fe){return(0,_e.$WF)(je,"interactive"),Yi.registerProvider(je,ee,fe)},registerInteractiveSessionProvider(ee,fe){return(0,_e.$WF)(je,"interactive"),Bi.registerChatProvider(je,ee,fe)},sendInteractiveRequestToProvider(ee,fe){return(0,_e.$WF)(je,"interactive"),Bi.sendInteractiveRequestToProvider(ee,fe)},transferChatSession(ee,fe){return(0,_e.$WF)(je,"interactive"),Bi.transferChatSession(ee,fe)}},hn={getRelatedInformation(ee,fe){return(0,_e.$WF)(je,"aiRelatedInformation"),xi.getRelatedInformation(je,ee,fe)},registerRelatedInformationProvider(ee,fe){return(0,_e.$WF)(je,"aiRelatedInformation"),xi.registerRelatedInformationProvider(je,ee,fe)},registerEmbeddingVectorProvider(ee,fe){return(0,_e.$WF)(je,"aiRelatedInformation"),Wi.registerEmbeddingVectorProvider(je,ee,fe)}},dn={registerChatResponseProvider(ee,fe,ze){return(0,_e.$WF)(je,"chatProvider"),yi.registerLanguageModel(je,ee,fe,ze)},registerChatVariableResolver(ee,fe,ze){return(0,_e.$WF)(je,"chatVariableResolver"),_i.registerVariableResolver(je,ee,fe,ze)},registerMappedEditsProvider(ee,fe){return(0,_e.$WF)(je,"mappedEditsProvider"),gt.registerMappedEditsProvider(je,ee,fe)},createChatParticipant(ee,fe){return(0,_e.$WF)(je,"chatParticipant"),Zi.createChatAgent(je,ee,fe)}},wn={requestLanguageModelAccess(ee,fe){return(0,_e.$WF)(je,"languageModels"),yi.requestLanguageModelAccess(je,ee,fe)},get languageModels(){return(0,_e.$WF)(je,"languageModels"),yi.getLanguageModelIds()},onDidChangeLanguageModels:(ee,fe,ze)=>((0,_e.$WF)(je,"languageModels"),yi.onDidChangeProviders(ee,fe,ze))},bn={registerSpeechProvider(ee,fe){return(0,_e.$WF)(je,"speech"),gn.registerProvider(je.identifier,ee,fe)}};return{version:vt.version,ai:hn,authentication:Fi,commands:$n,comments:cn,chat:dn,debug:pn,env:qi,extensions:nn,interactive:ln,l10n:Hi,languages:rn,lm:wn,notebooks:un,scm:an,speech:bn,tasks:vn,tests:Li,window:sn,workspace:on,Breakpoint:Oe.$2M,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatResultFeedbackKind:Oe.ChatResultFeedbackKind,ChatVariableLevel:Oe.ChatVariableLevel,ChatCompletionItem:Oe.$UN,CallHierarchyIncomingCall:Oe.$oM,CallHierarchyItem:Oe.$nM,CallHierarchyOutgoingCall:Oe.$pM,CancellationError:P.$5,CancellationTokenSource:D.$ce,CandidatePortSource:n.CandidatePortSource,CodeAction:Oe.$kM,CodeActionKind:Oe.$lM,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$qM,Color:Oe.$DM,ColorInformation:Oe.$EM,ColorPresentation:Oe.$FM,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$xM,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$yM,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$NM,DebugAdapterExecutable:Oe.$6M,DebugAdapterInlineImplementation:Oe.$9M,DebugAdapterNamedPipeServer:Oe.$8M,DebugAdapterServer:Oe.$7M,DebugConfigurationProviderTriggerKind:si.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$mN,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$eM,DiagnosticRelatedInformation:Oe.$dM,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$3L,DocumentHighlight:Oe.$gM,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$hM,DocumentLink:Oe.$CM,DocumentSymbol:Oe.$jM,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$_M,InlineValueText:Oe.$aN,InlineValueVariableLookup:Oe.$bN,InlineValueEvaluatableExpression:Oe.$cN,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:C.$5d,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$oN,FileDecoration2:Oe.$oN,FileSystemError:Oe.$fN,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:Oe.$gN,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$4M,InlineCompletionItem:Oe.$zM,InlineCompletionList:Oe.$AM,Hover:Oe.$fM,IndentAction:S.IndentAction,Location:Oe.$cM,MarkdownString:Oe.$rM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Oe.$sM,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$4L,ProcessExecution:Oe.$LM,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$nN,Range:Oe.$5L,RelativePattern:Oe.$ZM,Selection:Oe.$6L,SelectionRange:Oe.$mM,SemanticTokens:Oe.$jN,SemanticTokensBuilder:Oe.$iN,SemanticTokensEdit:Oe.$kN,SemanticTokensEdits:Oe.$lN,SemanticTokensLegend:Oe.$hN,ShellExecution:Oe.$MM,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$uM,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$tM,SnippetString:Oe.$bM,SourceBreakpoint:Oe.$3M,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$iM,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$OM,TaskGroup:Oe.$KM,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$GM,TerminalQuickFixTerminalCommand:Oe.$IM,TerminalQuickFixOpener:Oe.$HM,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$JM,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$0L,SnippetTextEdit:Oe.$_L,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$YM,ThemeIcon:Oe.$XM,TreeItem:Oe.$PM,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$JN,UIKind:oi.UIKind,Uri:f.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$aM,DocumentDropEdit:Oe.$VM,DocumentPasteEdit:Oe.$WM,InlayHint:Oe.$wM,InlayHintLabelPart:Oe.$vM,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$9L,ResolvedAuthority:Oe.$7L,ManagedResolvedAuthority:Oe.$8L,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$yN,NotebookRange:Oe.$qN,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$rN,NotebookData:Oe.$sN,NotebookRendererScript:Oe.$wN,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$uN,NotebookCellOutputItem:Oe.$tN,NotebookCellStatusBarItem:Oe.$vN,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$$L,NotebookKernelSourceAction:Oe.$xN,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$AN,LinkedEditingRanges:Oe.$zN,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$BN,TestMessage:Oe.$CN,TestTag:Oe.$DN,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Tt.TextSearchCompleteMessageType,DataTransfer:Oe.$UM,DataTransferItem:Oe.$QM,CoveredCount:Oe.$EN,FileCoverage:Oe.$FN,StatementCoverage:Oe.$GN,BranchCoverage:Oe.$HN,DeclarationCoverage:Oe.$IN,FunctionCoverage:Oe.$IN,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$KN,TabInputTextDiff:Oe.$LN,TabInputTextMerge:Oe.$MN,TabInputCustom:Oe.$NN,TabInputNotebook:Oe.$PN,TabInputNotebookDiff:Oe.$QN,TabInputWebview:Oe.$ON,TabInputTerminal:Oe.$RN,TabInputInteractiveWindow:Oe.$SN,TabInputChat:Oe.$TN,TelemetryTrustedValue:i.$Xo,LogLevel:s.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatCopyKind:Oe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$0M,ThreadFocus:Oe.$$M,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Oe.$VN,ChatResponseFileTreePart:Oe.$WN,ChatResponseAnchorPart:Oe.$XN,ChatResponseProgressPart:Oe.$YN,ChatResponseReferencePart:Oe.$1N,ChatResponseCommandButtonPart:Oe.$ZN,ChatRequestTurn:Oe.$2N,ChatResponseTurn:Oe.$3N,LanguageModelSystemMessage:Oe.$4N,LanguageModelUserMessage:Oe.$5N,LanguageModelAssistantMessage:Oe.$6N,NewSymbolName:Oe.$eN,NewSymbolNameTag:Oe.NewSymbolNameTag,InlineEdit:Oe.$7N,InlineEditTriggerKind:Oe.InlineEditTriggerKind}}}e.$Sjc=xt}),define(Me[294],Ae([1,0,54,113,37,108,38,31,67,66,116,118,119,82,85,78,107,63,43,81,61,65,230,14,117,79,80]),function(x,e,D,P,C,L,M,g,f,k,F,S,l,w,m,s,u,i,r,n,a,h,t,$,c,o,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$$r)(o.$Hic,o.$Gic,1),(0,D.$$r)($.$zj,t.$Tjc,1),(0,D.$$r)(s.$Nhc,s.$Ohc,1),(0,D.$$r)(g.$BO,g.$AO,0),(0,D.$$r)(M.$bic,M.$_hc,0),(0,D.$$r)(i.$dic,i.$cic,0),(0,D.$$r)(S.$Ric,S.$Vic,0),(0,D.$$r)(L.$Xic,L.$Wic,0),(0,D.$$r)(f.$qO,f.$pO,0),(0,D.$$r)(b.$Iic,b.$Jic,0),(0,D.$$r)(r.$Rhc,r.$Qhc,0),(0,D.$$r)(P.$rjc,P.$qjc,1),(0,D.$$r)(l.$bjc,l.$cjc,0),(0,D.$$r)(w.$wic,w.$vic,0),(0,D.$$r)(F.$Ejc,F.$Djc,0),(0,D.$$r)(k.$zic,k.$Cic,0),(0,D.$$r)(m.$yAb,m.$zAb,0),(0,D.$$r)(u.$Rjc,u.$Qjc,0),(0,D.$$r)(C.$$hc,C.$0hc,0),(0,D.$$r)(n.$Eic,n.$Dic,0),(0,D.$$r)(a.$zO,a.$wO,0),(0,D.$$r)(h.$nic,h.$oic,0),(0,D.$$r)(c.$Pic,c.$Qic,0)}),define(Me[295],Ae([1,0,293,39,2,290,7,11,236]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class k extends L.$Wjc{k(){}getModule(w,m){for(const s of this.b){const u=s(w);if(u){w=u;break}}if(this.a.has(w))return this.a.get(w).load(w,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends P.$Lic{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$3lc);const w=this.h.invokeFunction(D.$Sjc);this.r=this.h.createInstance(k,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(w){return w.browser}async vb(w,m,s){m=m.with({path:S(m.path,".js")});const u=w?.identifier.value;u&&performance.mark(`code/extHost/willFetchExtensionCode/${u}`);const i=C.URI.revive(await this.C.$asBrowserUri(m)),r=await fetch(i.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u}`),r.status!==200)throw new Error(r.statusText);const n=await r.text(),a=`${m.toString(!0)}#vscode-extension`,h=`${n}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(b){throw console.error(u?`Loading code for extension ${u} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${m.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}w&&await this.w.initializeLocalizedMessages(w);const $={},c={exports:$},o=b=>{const p=this.r.getModule(b,m);if(p===void 0)throw new Error(`Cannot load module '${b}'`);return p};try{return s.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u}`),t(c,$,o),c.exports!==$?c.exports:$}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u}`),s.codeLoadingStop()}}async $setRemoteEnvironment(w){}async zb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+w;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,g.$fh)(10)}}e.$4lc=F;function S(l,w){return l.endsWith(w)?l:l+w}}),define(Me[296],Ae([1,0,70,54,14,39,201,84,295]),function(x,e,D,P,C,L,M,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.$$r)(C.$yj,new D.$bi(M.$Vjc,[!0],!0)),(0,P.$$r)(L.$Mic,f.$4lc,0),(0,P.$$r)(g.$eic,g.$fic,0)}),define(Me[301],Ae([1,0,24,5,77,291,238,19,87,12,2,294,296]),function(x,e,D,P,C,L,M,g,f,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function s(t){self.fetch=async function($,c){return $ instanceof Request||w(String($))&&($=(await t(F.URI.parse(String($)))).toString(!0)),m($,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open($,c,o,b,p){(async()=>(w(c.toString())&&(c=(await t(F.URI.parse(c.toString()))).toString(!0)),super.open($,c,o??!0,b,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function($,c){if(/^file:/i.test($.toString()))$=k.$yg.uriToBrowserUri(F.URI.parse($.toString())).toString(!0);else if(/^vscode-remote:/i.test($.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(v){function y(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const E=fetch.bind(self);self.fetch=function(V,X){return V instanceof Request?E(V,X):E(y(V),X)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,X,H,O,R){return super.open(V,y(X),H??!0,O,R)}};const A=importScripts.bind(self);self.importScripts=(...V)=>{A(...V.map(y))},A(v)}.toString()}('${$}'))`;c=c||{},c.name=`${name} -> ${c.name||g.$nc($.toString())}`;const p=new Blob([b],{type:"application/javascript"}),d=URL.createObjectURL(p);return new t(d,c)}}else self.Worker=class extends M.$5lc{constructor(t,$){super(l,t,{name:g.$nc(t.toString()),...$})}};const u=new class{constructor(){this.pid=void 0}exit(t){S()}};class i{constructor(){const $=new MessageChannel,c=new P.$5d;let o=!1;l($.port2,[$.port2]),$.port1.onmessage=b=>{const{data:p}=b;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const d=D.$se.wrap(new Uint8Array(p,0,p.byteLength));if((0,C.$Gm)(d,2)){o=!0,n("received terminate message from renderer");return}c.fire(d)},this.protocol={onMessage:c.event,send:b=>{if(!o){const p=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);$.port1.postMessage(p,[p])}}}}}function r(t){return new Promise($=>{const c=t.onMessage(o=>{c.dispose();const b=JSON.parse(o.toString());t.send((0,C.$Fm)(0)),$({protocol:t,initData:b})});t.send((0,C.$Fm)(1))})}let n=t=>S();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){f.mark("code/extHost/willConnectToRenderer");const t=new i;return{onmessage($){a($)&&r(t.protocol).then(c=>{f.mark("code/extHost/didWaitForInitData");const o=new L.$Yjc(c.protocol,c.initData,u,null,$.data);s(b=>o.asBrowserUri(b)),n=b=>o.terminate(b)})}}}e.create=h})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
