"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var H=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/base/common/uri","vs/editor/common/tokens/lineTokens","vs/base/common/observable","vs/base/common/buffer","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/types","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(q){for(var e=[],A=0,E=q.length;A<E;A++)e[A]=H[q[A]];return e};define(H[23],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class A{static get(){const k=new Map,O=new Map,r=new Map,g=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function d(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let $=[];typeof q=="function"&&typeof q.getStats=="function"&&($=q.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of $)switch(a.type){case 10:t(k,a);break;case 11:case 12:d(k,a);break;case 21:t(O,a);break;case 22:d(O,a);break;case 33:t(r,a);break;case 34:d(r,a);break;case 31:t(g,a);break;case 32:d(g,a);break}let f=0;r.forEach(a=>f+=a);function h(a){const i=[];return a.forEach((n,s)=>i.push([s,n])),i}return{amdLoad:h(k),amdInvoke:h(O),nodeRequire:h(r),nodeEval:h(g),nodeRequireTotal:f}}static toMarkdownTable(k,O){let r="";const g=[];return k.forEach((t,d)=>{g[d]=t.length}),O.forEach(t=>{t.forEach((d,$)=>{typeof d>"u"&&(d=t[$]="-");const f=d.toString().length;g[$]=Math.max(f,g[$])})}),k.forEach((t,d)=>{r+=`| ${t+" ".repeat(g[d]-t.toString().length)} `}),r+=`|
`,k.forEach((t,d)=>{r+=`| ${"-".repeat(g[d])} `}),r+=`|
`,O.forEach(t=>{t.forEach((d,$)=>{typeof d<"u"&&(r+=`| ${d+" ".repeat(g[$]-d.toString().length)} `)}),r+=`|
`}),r}}e.$U=A}),define(H[4],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=void 0;class A{constructor(i,n,s){this.owner=i,this.debugNameSource=n,this.referenceFn=s}getDebugName(i){return O(i,this)}}e.$5c=A;const E=new Map,k=new WeakMap;function O(a,i){const n=k.get(a);if(n)return n;const s=r(a,i);if(s){let l=E.get(s)??0;l++,E.set(s,l);const y=l===1?s:`${s}#${l}`;return k.set(a,y),y}}e.$6c=O;function r(a,i){const n=k.get(a);if(n)return n;const s=i.owner?$(i.owner)+".":"";let l;const y=i.debugNameSource;if(y!==void 0)if(typeof y=="function"){if(l=y(),l!==void 0)return s+l}else return s+y;const L=i.referenceFn;if(L!==void 0&&(l=h(L),l!==void 0))return s+l;if(i.owner!==void 0){const P=g(i.owner,a);if(P!==void 0)return s+P}}function g(a,i){for(const n in a)if(a[n]===i)return n}const t=new Map,d=new WeakMap;function $(a){const i=d.get(a);if(i)return i;const n=f(a);let s=t.get(n)??0;s++,t.set(n,s);const l=s===1?n:`${n}#${s}`;return d.set(a,l),l}function f(a){const i=a.constructor;return i?i.name:"Object"}function h(a){const i=a.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(i);return(s?s[1]:void 0)?.trim()}e.$7c=h}),define(H[5],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yd=e.$xd=e.$wd=void 0;let A;function E(n){A=n}e.$wd=E;function k(){return A}e.$xd=k;class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([g(a("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[g(" "),d($(s.oldValue,70),{color:"red",strikeThrough:!0}),g(" "),d($(s.newValue,60),{color:"green"})]:[g(" (unchanged)")]:[g(" "),d($(s.newValue,60),{color:"green"}),g(" (initial)")]}handleObservableChanged(s,l){console.log(...this.b([t("observable value changed"),d(s.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(s){if(s.size!==0)return d(" (changed deps: "+[...s].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(y,L)=>(this.d.get(s).add(y),l.apply(s,[y,L]))}handleDerivedRecomputed(s,l){const y=this.d.get(s);console.log(...this.b([t("derived recomputed"),d(s.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(y),{data:[{fn:s._computeFn}]}])),y.clear()}handleFromEventObservableTriggered(s,l){console.log(...this.b([t("observable from event triggered"),d(s.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(y,L)=>(this.d.get(s).add(y),l.apply(s,[y,L]))}handleAutorunTriggered(s){const l=this.d.get(s);console.log(...this.b([t("autorun"),d(s.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:s._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let l=s.getDebugName();l===void 0&&(l=""),console.log(...this.b([t("transaction"),d(l,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$yd=O;function r(n){const s=new Array,l=[];let y="";function L(T){if("length"in T)for(const u of T)u&&L(u);else"text"in T?(y+=`%c${T.text}`,s.push(T.style),T.data&&l.push(...T.data)):"data"in T&&l.push(...T.data)}L(n);const P=[y,...s];return P.push(...l),P}function g(n){return d(n,{color:"black"})}function t(n){return d(i(`${n}: `,10),{color:"black",bold:!0})}function d(n,s={color:"black"}){function l(L){return Object.entries(L).reduce((P,[T,u])=>`${P}${T}:${u};`,"")}const y={color:s.color};return s.strikeThrough&&(y["text-decoration"]="line-through"),s.bold&&(y["font-weight"]="bold"),{text:n,style:l(y)}}function $(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?f(n,s):h(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function f(n,s){let l="[ ",y=!0;for(const L of n){if(y||(l+=", "),l.length-5>s){l+="...";break}y=!1,l+=`${$(L,s-l.length)}`}return l+=" ]",l}function h(n,s){let l="{ ",y=!0;for(const[L,P]of Object.entries(n)){if(y||(l+=", "),l.length-5>s){l+="...";break}y=!1,l+=`${L}: ${$(P,s-l.length)}`}return l+=" }",l}function a(n,s){let l="";for(let y=1;y<=s;y++)l+=n;return l}function i(n,s){for(;n.length<s;)n+=" ";return n}}),define(H[7],W([0,1,24,2,4,5]),function(q,e,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function r(i){return new a(new k.$5c(void 0,void 0,i),i,void 0,void 0)}e.$bd=r;function g(i,n){return new a(new k.$5c(i.owner,i.debugName,i.debugReferenceFn??n),n,void 0,void 0)}e.$cd=g;function t(i,n){return new a(new k.$5c(i.owner,i.debugName,i.debugReferenceFn??n),n,i.createEmptyChangeSummary,i.handleChange)}e.$dd=t;function d(i,n){const s=new E.$Sc,l=t({owner:i.owner,debugName:i.debugName,debugReferenceFn:i.debugReferenceFn,createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(y,L)=>{s.clear(),n(y,L,s)});return(0,E.$Rc)(()=>{l.dispose(),s.dispose()})}e.$ed=d;function $(i){const n=new E.$Sc,s=g({owner:void 0,debugName:void 0,debugReferenceFn:i},l=>{n.clear(),i(l,n)});return(0,E.$Rc)(()=>{s.dispose(),n.dispose()})}e.$fd=$;function f(i,n){let s;return g({debugReferenceFn:n},l=>{const y=i.read(l),L=s;s=y,n({lastValue:L,newValue:y})})}e.$gd=f;var h;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class a{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,s,l,y){this.h=n,this._runFn=s,this.i=l,this.j=y,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$xd)()?.handleAutorunCreated(this),this.k(),(0,E.$Kc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,E.$Lc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const s=this.c;try{if(!s){(0,O.$xd)()?.handleAutorunTriggered(this);const l=this.g;this.g=this.i?.(),this._runFn(this,l)}}finally{s||(0,O.$xd)()?.handleAutorunFinished(this);for(const l of this.f)l.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,A.$_c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,s){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:s,didChange:y=>y===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const s=n.get();return this.e.add(n),this.f.delete(n),s}}e.$hd=a,function(i){i.Observer=a}(r||(e.$bd=r={}))}),define(H[6],W([0,1,4,5]),function(q,e,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=void 0;let k;function O(u){k=u}e.$Gd=O;let r;function g(u){r=u}e.$Hd=g;let t;function d(u){t=u}e.$Id=d;class ${get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,w){const U=w===void 0?void 0:b,D=w===void 0?b:w;return t({owner:U,debugName:()=>{const c=(0,A.$7c)(D);if(c!==void 0)return c;const j=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(D.toString());if(j)return`${this.debugName}.${j[2]}`;if(!U)return`${this.debugName} (mapped)`}},c=>D(this.read(c),c))}recomputeInitiallyAndOnChange(b,w){return b.add(k(this,w)),this}keepObserved(b){return b.add(r(this)),this}}e.$Jd=$;class f extends ${constructor(){super(...arguments),this.c=new Set}addObserver(b){const w=this.c.size;this.c.add(b),w===0&&this.f()}removeObserver(b){this.c.delete(b)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Kd=f;function h(u,b){const w=new l(u,b);try{u(w)}finally{w.finish()}}e.$Ld=h;let a;function i(u){if(a)u(a);else{const b=new l(u,void 0);a=b;try{u(b)}finally{b.finish(),a=void 0}}}e.$Md=i;async function n(u,b){const w=new l(u,b);try{await u(w)}finally{w.finish()}}e.$Nd=n;function s(u,b,w){u?b(u):h(b,w)}e.$Od=s;class l{constructor(b,w){this._fn=b,this.b=w,this.a=[],(0,E.$xd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,A.$7c)(this._fn)}updateObserver(b,w){this.a.push({observer:b,observable:w}),b.beginUpdate(w)}finish(){const b=this.a;for(let w=0;w<b.length;w++){const{observer:U,observable:D}=b[w];U.endUpdate(D)}this.a=null,(0,E.$xd)()?.handleEndTransaction()}}e.$Pd=l;function y(u,b){return typeof u=="string"?new L(void 0,u,b):new L(u,void 0,b)}e.$Qd=y;class L extends f{get debugName(){return new A.$5c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor(b,w,U){super(),this.b=b,this.d=w,this.a=U}get(){return this.a}set(b,w,U){if(this.a===b)return;let D;w||(w=D=new l(()=>{},()=>`Setting ${this.debugName}`));try{const c=this.a;this.e(b),(0,E.$xd)()?.handleObservableChanged(this,{oldValue:c,newValue:b,change:U,didChange:!0,hadValue:!0});for(const S of this.c)w.updateObserver(S,this),S.handleChange(this,U)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(b){this.a=b}}e.$Rd=L;function P(u,b){return typeof u=="string"?new T(void 0,u,b):new T(u,void 0,b)}e.$Sd=P;class T extends L{e(b){this.a!==b&&(this.a&&this.a.dispose(),this.a=b)}dispose(){this.a?.dispose()}}e.$Td=T}),define(H[8],W([0,1,24,2,6,4,5]),function(q,e,A,E,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=void 0;const g=(n,s)=>n===s;e.$zd=g;function t(n,s){return s!==void 0?new i(new O.$5c(n,void 0,s),s,void 0,void 0,void 0,e.$zd):new i(new O.$5c(void 0,void 0,n),n,void 0,void 0,void 0,e.$zd)}e.$Ad=t;function d(n,s){return new i(new O.$5c(n.owner,n.debugName,n.debugReferenceFn),s,void 0,void 0,n.onLastObserverRemoved,n.equalityComparer??e.$zd)}e.$Bd=d,(0,k.$Id)(d);function $(n,s){return new i(new O.$5c(n.owner,n.debugName,void 0),s,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??e.$zd)}e.$Cd=$;function f(n,s){let l,y;s===void 0?(l=n,y=void 0):(y=n,l=s);const L=new E.$Sc;return new i(new O.$5c(y,void 0,l),P=>(L.clear(),l(P,L)),void 0,void 0,()=>L.dispose(),e.$zd)}e.$Dd=f;function h(n,s){let l,y;s===void 0?(l=n,y=void 0):(y=n,l=s);const L=new E.$Sc;return new i(new O.$5c(y,void 0,l),P=>{L.clear();const T=l(P);return T&&L.add(T),T},void 0,void 0,()=>L.dispose(),e.$zd)}e.$Ed=h;var a;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(a||(a={}));class i extends k.$Kd{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(s,l,y,L,P=void 0,T){super(),this.n=s,this._computeFn=l,this.p=y,this.q=L,this.s=P,this.t=T,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,r.$xd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const s of this.k)s.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const s=this._computeFn(this,this.p?.());return this.g(),s}else{do{if(this.e===1){for(const s of this.k)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const s=this.l;this.l=this.k,this.k=s;const l=this.e!==0,y=this.h;this.e=3;const L=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,L)}finally{for(const T of this.l)T.removeObserver(this);this.l.clear()}const P=l&&!this.t(y,this.h);if((0,r.$xd)()?.handleDerivedRecomputed(this,{oldValue:y,newValue:this.h,change:void 0,didChange:P,hadValue:l}),P)for(const T of this.c)T.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.j++;const l=this.j===1;if(this.e===3&&(this.e=1,!l))for(const y of this.c)y.handlePossibleChange(this);if(l)for(const y of this.c)y.beginUpdate(this)}endUpdate(s){if(this.j--,this.j===0){const l=[...this.c];for(const y of l)y.endUpdate(this)}(0,A.$_c)(()=>this.j>=0)}handlePossibleChange(s){if(this.e===3&&this.k.has(s)&&!this.l.has(s)){this.e=1;for(const l of this.c)l.handlePossibleChange(this)}}handleChange(s,l){if(this.k.has(s)&&!this.l.has(s)){const y=this.q?this.q({changedObservable:s,change:l,didChange:P=>P===s},this.m):!0,L=this.e===3;if(y&&(this.e===1||L)&&(this.e=2,L))for(const P of this.c)P.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const l=s.get();return this.k.add(s),this.l.delete(s),l}addObserver(s){const l=!this.c.has(s)&&this.j>0;super.addObserver(s),l&&s.beginUpdate(this)}removeObserver(s){const l=this.c.has(s)&&this.j>0;super.removeObserver(s),l&&s.endUpdate(this)}}e.$Fd=i}),define(H[25],W([0,1,2,7,6,4,8,5]),function(q,e,A,E,k,O,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=void 0;function t(D){return new d(D)}e.$id=t;class d extends k.$Jd{constructor(c){super(),this.a=c}get debugName(){return this.toString()}get(){return this.a}addObserver(c){}removeObserver(c){}toString(){return`Const: ${this.a}`}}function $(D){const c=(0,k.$Qd)("promiseValue",{});return D.then(S=>{c.set({value:S},void 0)}),c}e.$jd=$;function f(D,c){return new h(D,c)}e.$kd=f;class h extends k.$Kd{constructor(c,S){super(),this.e=c,this._getValue=S,this.b=!1,this.k=j=>{const F=this._getValue(j),C=this.a,m=!this.b||C!==F;let M=!1;m&&(this.a=F,this.b&&(M=!0,(0,k.$Od)(h.globalTransaction,B=>{(0,g.$xd)()?.handleFromEventObservableTriggered(this,{oldValue:C,newValue:F,change:void 0,didChange:m,hadValue:this.b});for(const G of this.c)B.updateObserver(G,this),G.handleChange(this,void 0)},()=>{const B=this.h();return"Event fired"+(B?`: ${B}`:"")})),this.b=!0),M||(0,g.$xd)()?.handleFromEventObservableTriggered(this,{oldValue:C,newValue:F,change:void 0,didChange:m,hadValue:this.b})}}h(){return(0,O.$7c)(this._getValue)}get debugName(){const c=this.h();return"From Event"+(c?`: ${c}`:"")}f(){this.d=this.e(this.k)}g(){this.d.dispose(),this.d=void 0,this.b=!1,this.a=void 0}get(){return this.d?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$ld=h,function(D){D.Observer=h;function c(S,j){let F=!1;h.globalTransaction===void 0&&(h.globalTransaction=S,F=!0);try{j()}finally{F&&(h.globalTransaction=void 0)}}D.batchEventsGlobally=c}(f||(e.$kd=f={}));function a(D,c){return new i(D,c)}e.$md=a;class i extends k.$Kd{constructor(c,S){super(),this.debugName=c,this.b=S,this.e=()=>{(0,k.$Ld)(j=>{for(const F of this.c)j.updateObserver(F,this),F.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.e)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(D){return typeof D=="string"?new s(D):new s(void 0,D)}e.$nd=n;class s extends k.$Kd{get debugName(){return new O.$5c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor(c,S){super(),this.a=c,this.b=S}trigger(c,S){if(!c){(0,k.$Ld)(j=>{this.trigger(j,S)},()=>`Trigger signal ${this.debugName}`);return}for(const j of this.c)c.updateObserver(j,this),j.handleChange(this,S)}get(){}}function l(D,c,S){const j=(0,k.$Qd)("debounced",void 0);let F;return S.add((0,E.$bd)(C=>{const m=D.read(C);F&&clearTimeout(F),F=setTimeout(()=>{(0,k.$Ld)(M=>{j.set(m,M)})},c)})),j}e.$od=l;function y(D,c,S){const j=(0,k.$Qd)("triggeredRecently",!1);let F;return S.add(D(()=>{j.set(!0,void 0),F&&clearTimeout(F),F=setTimeout(()=>{j.set(!1,void 0)},c)})),j}e.$pd=y;function L(D){const c=new T(!1,void 0);return D.addObserver(c),(0,A.$Rc)(()=>{D.removeObserver(c)})}e.$qd=L,(0,k.$Hd)(L);function P(D,c){const S=new T(!0,c);return D.addObserver(S),c?c(D.get()):D.reportChanges(),(0,A.$Rc)(()=>{D.removeObserver(S)})}e.$rd=P,(0,k.$Gd)(P);class T{constructor(c,S){this.b=c,this.c=S,this.a=0}beginUpdate(c){this.a++}endUpdate(c){this.a--,this.a===0&&this.b&&(this.c?this.c(c.get()):c.reportChanges())}handlePossibleChange(c){}handleChange(c,S){}}e.$sd=T;function u(D){let c;return(0,r.$Ad)(j=>(c=D(j,c),c))}e.$td=u;function b(D,c){let S;const j=(0,k.$Qd)("derivedObservableWithWritableCache.counter",0),F=(0,r.$Ad)(D,C=>(j.read(C),S=c(C,S),S));return Object.assign(F,{clearCache:C=>{S=void 0,j.set(j.get()+1,C)}})}e.$ud=b;function w(D,c,S,j){let F=new U(S,j);return(0,r.$Bd)({debugReferenceFn:S,owner:D,onLastObserverRemoved:()=>{F.dispose(),F=new U(S)}},m=>(F.setItems(c.read(m)),F.getItems()))}e.$vd=w;class U{constructor(c,S){this.c=c,this.d=S,this.a=new Map,this.b=[]}dispose(){this.a.forEach(c=>c.store.dispose()),this.a.clear()}setItems(c){const S=[],j=new Set(this.a.keys());for(const F of c){const C=this.d?this.d(F):F;let m=this.a.get(C);if(m)j.delete(C);else{const M=new A.$Sc;m={out:this.c(F,M),store:M},this.a.set(C,m)}S.push(m.out)}for(const F of j)this.a.get(F).store.dispose(),this.a.delete(F);this.b=S}getItems(){return this.b}}}),define(H[26],W([0,1,7,6,8,27,4]),function(q,e,A,E,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=void 0;class g{get cachedValue(){return this.a}constructor(i){this.b=i,this.a=(0,E.$Qd)(this,void 0)}getValue(){let i=this.a.get();return i||(i=this.b(),this.a.set(i,void 0)),i}}e.$Ud=g;class t{constructor(i){this.a=(0,E.$Qd)(this,void 0),this.promiseResult=this.a,this.promise=i.then(n=>((0,E.$Ld)(s=>{this.a.set(new d(n,void 0),s)}),n),n=>{throw(0,E.$Ld)(s=>{this.a.set(new d(void 0,n),s)}),n})}}e.$Vd=t;class d{constructor(i,n){this.data=i,this.error=n}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$Wd=d;class ${constructor(i){this.b=i,this.a=new g(()=>new t(this.b())),this.cachedPromiseResult=(0,k.$Ad)(this,n=>this.a.cachedValue.read(n)?.promiseResult.read(n))}getPromise(){return this.a.getValue().promise}}e.$Xd=$;function f(a,i,n){return new Promise((s,l)=>{let y=!0,L=!1;const P=a.map(u=>({isFinished:i(u),error:n?n(u):!1,state:u})),T=(0,A.$bd)(u=>{const{isFinished:b,error:w,state:U}=P.read(u);(b||w)&&(y?L=!0:T.dispose(),w?l(w===!0?U:w):s(U))});y=!1,L&&T.dispose()})}e.$Yd=f;function h(a,i){let n,s;i===void 0?(n=a,s=void 0):(s=a,n=i);let l;return new k.$Fd(new r.$5c(s,void 0,n),y=>(l&&l.dispose(!0),l=new O.$ce,n(y,l.token)),void 0,void 0,()=>l?.dispose(),k.$zd)}e.$Zd=h}),define(H[12],W([0,1,6,8,7,25,26,5]),function(q,e,A,E,k,O,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return A.$Qd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return A.$Sd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return A.$Ld}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return A.$Od}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.$Ad}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return E.$Bd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return E.$Cd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return E.$Dd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.$bd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.$gd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.$dd}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.$fd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.$cd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.$ed}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$id}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$od}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$td}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$ud}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.$qd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$rd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$kd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$jd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$nd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$md}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$pd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$Ud}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return r.$Xd}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$Vd}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$Wd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$Yd}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return r.$Zd}}),!1&&(0,g.$wd)(new g.$yd)}),define(H[28],W([0,1,9,2]),function(q,e,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function k(P){const T=P;return T?typeof T.read=="function":!1}e.$de=k;function O(P){const T=P;return T?[T.on,T.pause,T.resume,T.destroy].every(u=>typeof u=="function"):!1}e.$ee=O;function r(P){const T=P;return T?O(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.$fe=r;function g(P,T){return new t(P,T)}e.$ge=g;class t{constructor(T,u){this.e=T,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(T){if(!this.a.destroyed){if(this.a.flowing)this.g(T);else if(this.b.data.push(T),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(T){this.a.destroyed||(this.a.flowing?this.h(T):this.b.error.push(T))}end(T){this.a.destroyed||(typeof T<"u"&&this.write(T),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(T){this.c.data.slice(0).forEach(u=>u(T))}h(T){this.c.error.length===0?(0,A.$1)(T):this.c.error.slice(0).forEach(u=>u(T))}i(){this.c.end.slice(0).forEach(T=>T())}on(T,u){if(!this.a.destroyed)switch(T){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(T,u){if(this.a.destroyed)return;let b;switch(T){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const w=b.indexOf(u);w>=0&&b.splice(w,1)}}j(){if(this.b.data.length>0){const T=this.e(this.b.data);this.g(T),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const T of this.b.error)this.h(T);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(P,T){const u=[];let b;for(;(b=P.read())!==null;)u.push(b);return T(u)}e.$he=d;function $(P,T,u){const b=[];let w;for(;(w=P.read())!==null&&b.length<u;)b.push(w);return w===null&&b.length>0?T(b):{read:()=>{if(b.length>0)return b.shift();if(typeof w<"u"){const U=w;return w=void 0,U}return P.read()}}}e.$ie=$;function f(P,T){return new Promise((u,b)=>{const w=[];h(P,{onData:U=>{T&&w.push(U)},onError:U=>{T?b(U):u(void 0)},onEnd:()=>{u(T?T(w):void 0)}})})}e.$je=f;function h(P,T,u){P.on("error",b=>{u?.isCancellationRequested||T.onError(b)}),P.on("end",()=>{u?.isCancellationRequested||T.onEnd()}),P.on("data",b=>{u?.isCancellationRequested||T.onData(b)})}e.$ke=h;function a(P,T){return new Promise((u,b)=>{const w=new E.$Sc,U=[],D=j=>{if(U.push(j),U.length>T)return w.dispose(),P.pause(),u({stream:P,buffer:U,ended:!1})},c=j=>(w.dispose(),b(j)),S=()=>(w.dispose(),u({stream:P,buffer:U,ended:!0}));w.add((0,E.$Rc)(()=>P.removeListener("error",c))),P.on("error",c),w.add((0,E.$Rc)(()=>P.removeListener("end",S))),P.on("end",S),w.add((0,E.$Rc)(()=>P.removeListener("data",D))),P.on("data",D)})}e.$le=a;function i(P,T){const u=g(T);return u.end(P),u}e.$me=i;function n(){const P=g(()=>{throw new Error("not supported")});return P.end(),P}e.$ne=n;function s(P){let T=!1;return{read:()=>T?null:(T=!0,P)}}e.$oe=s;function l(P,T,u){const b=g(u);return h(P,{onData:w=>b.write(T.data(w)),onError:w=>b.error(T.error?T.error(w):w),onEnd:()=>b.end()}),b}e.$pe=l;function y(P,T,u){let b=!1;return{read:()=>{const w=T.read();return b?w:(b=!0,w!==null?u([P,w]):P)}}}e.$qe=y;function L(P,T,u){let b=!1;const w=g(u);return h(T,{onData:U=>b?w.write(U):(b=!0,w.write(u([P,U]))),onError:U=>w.error(U),onEnd:()=>{b||(b=!0,w.write(P)),w.end()}}),w}e.$re=L}),define(H[13],W([0,1,29,28]),function(q,e,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const k=typeof Buffer<"u",O=new A.$V(()=>new Uint8Array(256));let r,g;class t{static alloc(m){return k?new t(Buffer.allocUnsafe(m)):new t(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new t(m)}static fromString(m,M){return!(M?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(m)):(r||(r=new TextEncoder),new t(r.encode(m)))}static fromByteArray(m){const M=t.alloc(m.length);for(let B=0,G=m.length;B<G;B++)M.buffer[B]=m[B];return M}static concat(m,M){if(typeof M>"u"){M=0;for(let _=0,J=m.length;_<J;_++)M+=m[_].byteLength}const B=t.alloc(M);let G=0;for(let _=0,J=m.length;_<J;_++){const K=m[_];B.set(K,G),G+=K.byteLength}return B}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=t.alloc(this.byteLength);return m.set(this),m}toString(){return k?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(m,M){return new t(this.buffer.subarray(m,M))}set(m,M){if(m instanceof t)this.buffer.set(m.buffer,M);else if(m instanceof Uint8Array)this.buffer.set(m,M);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),M);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return h(this.buffer,m)}writeUInt32BE(m,M){a(this.buffer,m,M)}readUInt32LE(m){return i(this.buffer,m)}writeUInt32LE(m,M){n(this.buffer,m,M)}readUInt8(m){return s(this.buffer,m)}writeUInt8(m,M){l(this.buffer,m,M)}indexOf(m,M=0){return d(this.buffer,m instanceof t?m.buffer:m,M)}}e.$se=t;function d(C,m,M=0){const B=m.byteLength,G=C.byteLength;if(B===0)return 0;if(B===1)return C.indexOf(m[0]);if(B>G-M)return-1;const _=O.value;_.fill(m.length);for(let Z=0;Z<m.length;Z++)_[m[Z]]=m.length-Z-1;let J=M+m.length-1,K=J,V=-1;for(;J<G;)if(C[J]===m[K]){if(K===0){V=J;break}J--,K--}else J+=Math.max(m.length-K,_[C[J]]),K=m.length-1;return V}e.$te=d;function $(C,m){return C[m+0]<<0>>>0|C[m+1]<<8>>>0}e.$ue=$;function f(C,m,M){C[M+0]=m&255,m=m>>>8,C[M+1]=m&255}e.$ve=f;function h(C,m){return C[m]*2**24+C[m+1]*2**16+C[m+2]*2**8+C[m+3]}e.$we=h;function a(C,m,M){C[M+3]=m,m=m>>>8,C[M+2]=m,m=m>>>8,C[M+1]=m,m=m>>>8,C[M]=m}e.$xe=a;function i(C,m){return C[m+0]<<0>>>0|C[m+1]<<8>>>0|C[m+2]<<16>>>0|C[m+3]<<24>>>0}e.$ye=i;function n(C,m,M){C[M+0]=m&255,m=m>>>8,C[M+1]=m&255,m=m>>>8,C[M+2]=m&255,m=m>>>8,C[M+3]=m&255}e.$ze=n;function s(C,m){return C[m]}e.$Ae=s;function l(C,m,M){C[M]=m}e.$Be=l;function y(C){return E.$he(C,m=>t.concat(m))}e.$Ce=y;function L(C){return E.$oe(C)}e.$De=L;function P(C){return E.$je(C,m=>t.concat(m))}e.$Ee=P;async function T(C){return C.ended?t.concat(C.buffer):t.concat([...C.buffer,await P(C.stream)])}e.$Fe=T;function u(C){return E.$me(C,m=>t.concat(m))}e.$Ge=u;function b(C){return E.$pe(C,{data:m=>typeof m=="string"?t.fromString(m):t.wrap(m)},m=>t.concat(m))}e.$He=b;function w(C){return E.$ge(m=>t.concat(m),C)}e.$Ie=w;function U(C,m){return E.$qe(C,m,M=>t.concat(M))}e.$Je=U;function D(C,m){return E.$re(C,m,M=>t.concat(M))}e.$Ke=D;function c(C){let m=0,M=0,B=0;const G=new Uint8Array(Math.floor(C.length/4*3)),_=K=>{switch(M){case 3:G[B++]=m|K,M=0;break;case 2:G[B++]=m|K>>>2,m=K<<6,M=3;break;case 1:G[B++]=m|K>>>4,m=K<<4,M=2;break;default:m=K<<2,M=1}};for(let K=0;K<C.length;K++){const V=C.charCodeAt(K);if(V>=65&&V<=90)_(V-65);else if(V>=97&&V<=122)_(V-97+26);else if(V>=48&&V<=57)_(V-48+52);else if(V===43||V===45)_(62);else if(V===47||V===95)_(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${C[K]}`)}}const J=B;for(;M>0;)_(0);return t.wrap(G).slice(0,J)}e.$Le=c;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function F({buffer:C},m=!0,M=!1){const B=M?j:S;let G="";const _=C.byteLength%3;let J=0;for(;J<C.byteLength-_;J+=3){const K=C[J+0],V=C[J+1],Z=C[J+2];G+=B[K>>>2],G+=B[(K<<4|V>>>4)&63],G+=B[(V<<2|Z>>>6)&63],G+=B[Z&63]}if(_===1){const K=C[J+0];G+=B[K>>>2],G+=B[K<<4&63],m&&(G+="==")}else if(_===2){const K=C[J+0],V=C[J+1];G+=B[K>>>2],G+=B[(K<<4|V>>>4)&63],G+=B[V<<2&63],m&&(G+="=")}return G}e.$Me=F}),define(H[30],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(H[31],W([0,1,32,3,14,47]),function(q,e,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function r(c){return c===47||c===92}e.$$f=r;function g(c){return c.replace(/[\\/]/g,A.$gc.sep)}e.$_f=g;function t(c){return c.indexOf("/")===-1&&(c=g(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$ag=t;function d(c,S=A.$gc.sep){if(!c)return"";const j=c.length,F=c.charCodeAt(0);if(r(F)){if(r(c.charCodeAt(1))&&!r(c.charCodeAt(2))){let m=3;const M=m;for(;m<j&&!r(c.charCodeAt(m));m++);if(M!==m&&!r(c.charCodeAt(m+1))){for(m+=1;m<j;m++)if(r(c.charCodeAt(m)))return c.slice(0,m+1).replace(/[\\/]/g,S)}}return S}else if(l(F)&&c.charCodeAt(1)===58)return r(c.charCodeAt(2))?c.slice(0,2)+S:c.slice(0,2);let C=c.indexOf("://");if(C!==-1){for(C+=3;C<j;C++)if(r(c.charCodeAt(C)))return c.slice(0,C+1)}return""}e.$bg=d;function $(c){if(!E.$c||!c||c.length<5)return!1;let S=c.charCodeAt(0);if(S!==92||(S=c.charCodeAt(1),S!==92))return!1;let j=2;const F=j;for(;j<c.length&&(S=c.charCodeAt(j),S!==92);j++);return!(F===j||(S=c.charCodeAt(j+1),isNaN(S)||S===92))}e.$cg=$;const f=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(c,S=E.$c){const j=S?f:h;return!(!c||c.length===0||/^\s+$/.test(c)||(j.lastIndex=0,j.test(c))||S&&a.test(c)||c==="."||c===".."||S&&c[c.length-1]==="."||S&&c.length!==c.trim().length||c.length>255)}e.$dg=i;function n(c,S,j){const F=c===S;return!j||F?F:!c||!S?!1:(0,k.$jf)(c,S)}e.$eg=n;function s(c,S,j,F=A.sep){if(c===S)return!0;if(!c||!S||S.length>c.length)return!1;if(j){if(!(0,k.$kf)(c,S))return!1;if(S.length===c.length)return!0;let m=S.length;return S.charAt(S.length-1)===F&&m--,c.charAt(m)===F}return S.charAt(S.length-1)!==F&&(S+=F),c.indexOf(S)===0}e.$fg=s;function l(c){return c>=65&&c<=90||c>=97&&c<=122}e.$gg=l;function y(c,S){return E.$c&&c.endsWith(":")&&(c+=A.sep),(0,A.$ic)(c)||(c=(0,A.$jc)(S,c)),c=(0,A.$hc)(c),E.$c?(c=(0,k.$4e)(c,A.sep),c.endsWith(":")&&(c+=A.sep)):(c=(0,k.$4e)(c,A.sep),c||(c=A.sep)),c}e.$hg=y;function L(c){const S=(0,A.$hc)(c);return E.$c?c.length>3?!1:P(S)&&(c.length===2||S.charCodeAt(2)===92):S===A.$gc.sep}e.$ig=L;function P(c,S=E.$c){return S?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$jg=P;function T(c,S=E.$c){return P(c,S)?c[0]:void 0}e.$kg=T;function u(c,S,j){return S.length>c.length?-1:c===S?0:(j&&(c=c.toLowerCase(),S=S.toLowerCase()),c.indexOf(S))}e.$lg=u;function b(c){const S=c.split(":");let j,F,C;for(const m of S){const M=Number(m);(0,O.$Wf)(M)?F===void 0?F=M:C===void 0&&(C=M):j=j?[j,m].join(":"):m}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:F!==void 0?F:void 0,column:C!==void 0?C:F!==void 0?1:void 0}}e.$mg=b;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",U="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(c,S,j=8){let F="";for(let m=0;m<j;m++){let M;m===0&&E.$c&&!S&&(j===3||j===4)?M=U:M=w,F+=M.charAt(Math.floor(Math.random()*M.length))}let C;return S?C=`${S}-${F}`:C=F,c?(0,A.$jc)(c,C):C}e.$ng=D}),define(H[15],W([0,1,9,3,14,10]),function(q,e,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var r;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.codeSetting="code-setting",h.codeFeature="code-feature"})(r||(e.Schemas=r={}));function g(h,a){return O.URI.isUri(h)?(0,k.$jf)(h.scheme,a):(0,k.$kf)(h,a+":")}e.$og=g;function t(h,...a){return a.some(i=>g(h,i))}e.$pg=t,e.$qg="vscode-tkn",e.$rg="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${r.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${r.vscodeRemoteResource}`}set(a,i,n){this.a[a]=i,this.b[a]=n}setConnectionToken(a,i){this.c[a]=i}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(L){return A.$1(L),a}const i=a.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this.b[i],l=this.c[i];let y=`path=${encodeURIComponent(a.path)}`;return typeof l=="string"&&(y+=`&${e.$rg}=${encodeURIComponent(l)}`),O.URI.from({scheme:E.$i?this.d:r.vscodeRemoteResource,authority:`${n}:${s}`,path:E.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:y})}}e.$sg=new d,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class ${asBrowserUri(a){const i=this.b(a,q);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===r.vscodeRemote?e.$sg.rewrite(a):a.scheme===r.file&&(E.$g||E.$k===`${r.vscodeFileResource}://${$.a}`)?a.with({scheme:r.vscodeFileResource,authority:a.authority||$.a,query:null,fragment:null}):a}asFileUri(a){const i=this.b(a,q);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===r.vscodeFileResource?a.with({scheme:r.file,authority:a.authority!==$.a?a.authority:null,query:null,fragment:null}):a}b(a,i){return O.URI.isUri(a)?a:O.URI.parse(i.toUrl(a))}}$.a=e.$xg,e.$yg=new $;var f;(function(h){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(l){let y;typeof l=="string"?y=new URL(l).searchParams:l instanceof URL?y=l.searchParams:O.URI.isUri(l)&&(y=new URL(l.toString(!0)).searchParams);const L=y?.get(i);if(L)return a.get(L)}h.getHeadersFromQuery=n;function s(l,y,L){if(!globalThis.crossOriginIsolated)return;const P=y&&L?"3":L?"2":"1";l instanceof URLSearchParams?l.set(i,P):l[i]=P}h.addSearchParam=s})(f||(e.COI=f={}))}),define(H[33],W([0,1,23,15,3,10]),function(q,e,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=void 0;class r{constructor(h,a,i){this.id=h,this.dependencies=a,this.callback=i}}class g{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,a,i)=>{typeof h!="string"&&(i=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this.c.push(new r(h,a,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const a=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!a)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(h){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const s=()=>{n.removeEventListener("load",l),n.removeEventListener("error",y)},l=L=>{s(),a(this.c.pop())},y=L=>{s(),i(L)};n.addEventListener("load",l),n.addEventListener("error",y),this.f&&(h=this.f.createScriptURL(h)),n.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(h){return new Promise((a,i)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),a(this.c.pop())}catch(n){i(n)}})}async j(h){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,s=O.URI.parse(h).fsPath,l=a.readFileSync(s).toString(),y=n.wrap(l.replace(/^#!.*/,""));return new i.Script(y).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}g.INSTANCE=new g;const t=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function $(f,h,a){if(A.$T){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[f]&&(f=d[f]);const i=`${f}/${h}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const L=`${a&&!k.$i?E.$vg:E.$ug}/${i}`;n=E.$yg.asBrowserUri(L).toString(!0)}const s=g.INSTANCE.load(n);return t.set(i,s),s}else return await new Promise((i,n)=>{q([f],i,n)})}e.$uD=$}),define(H[16],W([0,1,31,15,32,3,14,10]),function(q,e,A,E,k,O,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function t(a){return(0,g.$wc)(a,!0)}e.$Fg=t;class d{constructor(i){this.a=i}compare(i,n,s=!1){return i===n?0:(0,r.$cf)(this.getComparisonKey(i,s),this.getComparisonKey(n,s))}isEqual(i,n,s=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,s)===this.getComparisonKey(n,s)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,s=!1){if(i.scheme===n.scheme){if(i.scheme===E.Schemas.file)return A.$fg(t(i),t(n),this.a(i))&&i.query===n.query&&(s||i.fragment===n.fragment);if((0,e.$Wg)(i.authority,n.authority))return A.$fg(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(s||i.fragment===n.fragment)}return!1}joinPath(i,...n){return g.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$Og)(i)||i.authority}basename(i){return k.$gc.basename(i.path)}extname(i){return k.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===E.Schemas.file?n=g.URI.file(k.$mc(t(i))).path:(n=k.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===E.Schemas.file?n=g.URI.file(k.$hc(t(i))).path:n=k.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Wg)(i.authority,n.authority))return;if(i.scheme===E.Schemas.file){const y=k.$lc(t(i),t(n));return O.$c?A.$_f(y):y}let s=i.path||"/";const l=n.path||"/";if(this.a(i)){let y=0;for(const L=Math.min(s.length,l.length);y<L&&!(s.charCodeAt(y)!==l.charCodeAt(y)&&s.charAt(y).toLowerCase()!==l.charAt(y).toLowerCase());y++);s=l.substr(0,y)+s.substr(y)}return k.$gc.relative(s,l)}resolvePath(i,n){if(i.scheme===E.Schemas.file){const s=g.URI.file(k.$kc(t(i),n));return i.with({authority:s.authority,path:s.path})}return n=A.$ag(n),i.with({path:k.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,r.$jf)(i,n)}hasTrailingPathSeparator(i,n=k.sep){if(i.scheme===E.Schemas.file){const s=t(i);return s.length>A.$bg(s).length&&s[s.length-1]===n}else{const s=i.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=k.sep){return(0,e.$Xg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=k.sep){let s=!1;if(i.scheme===E.Schemas.file){const l=t(i);s=l!==void 0&&l.length===A.$bg(l).length&&l[l.length-1]===n}else{n="/";const l=i.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.$Xg)(i,n)?i.with({path:i.path+"/"}):i}}e.$Gg=d,e.$Hg=new d(()=>!1),e.$Ig=new d(a=>a.scheme===E.Schemas.file?!O.$e:!0),e.$Jg=new d(a=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function $(a,i){const n=[];for(let s=0;s<a.length;s++){const l=i(a[s]);a.some((y,L)=>L===s?!1:(0,e.$Lg)(l,i(y)))||n.push(a[s])}return n}e.$1g=$;var f;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const s=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(L=>{const[P,T]=L.split(":");P&&T&&s.set(P,T)});const y=n.path.substring(0,n.path.indexOf(";"));return y&&s.set(a.META_DATA_MIME,y),s}a.parseMetaData=i})(f||(e.DataUri=f={}));function h(a,i,n){if(i){let s=a.path;return s&&s[0]!==k.$gc.sep&&(s=k.$gc.sep+s),a.with({scheme:n,authority:i,path:s})}return a.with({scheme:n})}e.$2g=h}),define(H[17],W([0,1,27,9,34,2,16,3,30,29]),function(q,e,A,E,k,O,r,g,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function $(N){return!!N&&typeof N.then=="function"}e.$3g=$;function f(N){const o=new A.$ce,v=N(o.token),I=new Promise((R,z)=>{const p=o.token.onCancellationRequested(()=>{p.dispose(),z(new E.$5)});Promise.resolve(v).then(Y=>{p.dispose(),o.dispose(),R(Y)},Y=>{p.dispose(),o.dispose(),z(Y)})});return new class{cancel(){o.cancel(),o.dispose()}then(R,z){return I.then(R,z)}catch(R){return this.then(void 0,R)}finally(R){return I.finally(R)}}}e.$4g=f;function h(N,o,v){return new Promise((I,R)=>{const z=o.onCancellationRequested(()=>{z.dispose(),I(v)});N.then(I,R).finally(()=>z.dispose())})}e.$5g=h;function a(N,o){return new Promise((v,I)=>{const R=o.onCancellationRequested(()=>{R.dispose(),I(new E.$5)});N.then(v,I).finally(()=>R.dispose())})}e.$6g=a;async function i(N){let o=-1;const v=N.map((I,R)=>I.then(z=>(o=R,z)));try{return await Promise.race(v)}finally{N.forEach((I,R)=>{R!==o&&I.cancel()})}}e.$7g=i;function n(N,o,v){let I;const R=setTimeout(()=>{I?.(void 0),v?.()},o);return Promise.race([N.finally(()=>clearTimeout(R)),new Promise(z=>I=z)])}e.$8g=n;function s(N){return new Promise((o,v)=>{const I=N();$(I)?I.then(o,v):o(I)})}e.$9g=s;function l(){let N,o;return{promise:new Promise((I,R)=>{N=I,o=R}),resolve:N,reject:o}}e.$0g=l;class y{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const v=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(v,v).then(I)})}return new Promise((v,I)=>{this.b.then(v,I)})}return this.a=o(),new Promise((v,I)=>{this.a.then(R=>{this.a=null,v(R)},R=>{this.a=null,I(R)})})}dispose(){this.f=!0}}e.$$g=y;class L{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$_g=L;class P{constructor(){this.a=new Map}queue(o,v){const R=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(o)===R&&this.a.delete(o)});return this.a.set(o,R),R}}e.$ah=P;const T=(N,o)=>{let v=!0;const I=setTimeout(()=>{v=!1,o()},N);return{isTriggered:()=>v,dispose:()=>{clearTimeout(I),v=!1}}},u=N=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,N())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class b{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,v=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((R,z)=>{this.d=R,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=v===t.$2d?u(I):T(v,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new E.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=b;class w{constructor(o){this.a=new b(o),this.b=new y}trigger(o,v){return this.a.trigger(()=>this.b.queue(o),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=w;class U{constructor(){this.a=!1,this.b=new Promise((o,v)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=U;class D extends U{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$eh=D;function c(N,o){return o?new Promise((v,I)=>{const R=setTimeout(()=>{z.dispose(),v()},N),z=o.onCancellationRequested(()=>{clearTimeout(R),z.dispose(),I(new E.$5)})}):f(v=>c(N,v))}e.$fh=c;function S(N,o=0,v){const I=setTimeout(()=>{N(),v&&R.dispose()},o),R=(0,O.$Rc)(()=>{clearTimeout(I),v?.deleteAndLeak(R)});return v?.add(R),R}e.$gh=S;function j(N){const o=[];let v=0;const I=N.length;function R(){return v<I?N[v++]():null}function z(p){p!=null&&o.push(p);const Y=R();return Y?Y.then(z):Promise.resolve(o)}return Promise.resolve(null).then(z)}e.$hh=j;function F(N,o=I=>!!I,v=null){let I=0;const R=N.length,z=()=>{if(I>=R)return Promise.resolve(v);const p=N[I++];return Promise.resolve(p()).then(X=>o(X)?Promise.resolve(X):z())};return z()}e.$ih=F;function C(N,o=I=>!!I,v=null){if(N.length===0)return Promise.resolve(v);let I=N.length;const R=()=>{I=-1;for(const z of N)z.cancel?.()};return new Promise((z,p)=>{for(const Y of N)Y.then(X=>{--I>=0&&o(X)?(R(),z(X)):I===0&&z(v)}).catch(X=>{--I>=0&&(R(),p(X))})})}e.$jh=C;class m{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new k.$5d}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,I)=>{this.g.push({factory:o,c:v,e:I}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const v=o.factory();v.then(o.c,o.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=m;class M extends m{constructor(){super(1)}}e.$lh=M;class B{constructor(){this.a=new te,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$mh=B;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new x;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,v=r.$Hg){const I=v.getComparisonKey(o);return this.a.get(I)?.size??0}queueFor(o,v,I=r.$Hg){const R=I.getComparisonKey(o);let z=this.a.get(R);if(!z){z=new M;const p=this.f++,Y=k.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(R),this.h(),this.d?.deleteAndDispose(p),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(p,Y),this.a.set(R,z)}return z.queue(v)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=G;class _{constructor(o,v){this.a=-1,typeof o=="function"&&typeof v=="number"&&this.setIfNotSet(o,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},v)}setIfNotSet(o,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},v))}}e.$oh=_;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,v,I=globalThis){this.cancel();const R=I.setInterval(()=>{o()},v);this.d=(0,O.$Rc)(()=>{I.clearInterval(R),this.d=void 0})}dispose(){this.cancel()}}e.$ph=J;class K{constructor(o,v){this.b=-1,this.a=o,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=K;class V{constructor(o,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=o,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=V;class Z extends K{constructor(o,v){super(o,v),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$sh=Z;class he extends O.$Tc{constructor(o,v){super(),this.g=o,this.h=v,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of o)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(N,o)=>{(0,g.$v)(()=>{if(v)return;const I=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$vh=(N,o,v)=>{const I=N.requestIdleCallback(o,typeof v=="number"?{timeout:v}:void 0);let R=!1;return{dispose(){R||(R=!0,N.cancelIdleCallback(I))}}},e.$uh=N=>(0,e.$vh)(globalThis,N)}();class ee{constructor(o,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(I){this.l=I}finally{this.g=!0}},this.f=(0,e.$vh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=ee;class ue extends ee{constructor(o){super(globalThis,o)}}e.$xh=ue;async function oe(N,o,v){let I;for(let R=0;R<v;R++)try{return await N()}catch(z){I=z,await c(o)}throw I}e.$yh=oe;class te{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,v,I){return this.a={taskId:o,cancel:()=>I?.(),promise:v},v.then(()=>this.d(o),()=>this.d(o)),v}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:v,resolve:I,reject:R}=l();this.b={run:o,promise:v,promiseResolve:I,promiseReject:R}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=te;class ce{constructor(o,v=()=>Date.now()){this.d=o,this.f=v,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$Ah=ce;var ne;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,v)=>{this.a=o,this.b=v})}complete(o){return new Promise(v=>{this.a(o),this.d={outcome:0,value:o},v()})}error(o){return new Promise(v=>{this.b(o),this.d={outcome:1,value:o},v()})}cancel(){return this.error(new E.$5)}}e.$Bh=x;var ie;(function(N){async function o(I){let R;const z=await Promise.all(I.map(p=>p.then(Y=>Y,Y=>{R||(R=Y)})));if(typeof R<"u")throw R;return z}N.settled=o;function v(I){return new Promise(async(R,z)=>{try{await I(R,z)}catch(p){z(p)}})}N.withAsyncBody=v})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new E.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=se;class de{constructor(o){this.b=o,this.a=new d.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=de;var re;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(re||(re={}));class Q{static fromArray(o){return new Q(v=>{v.emitMany(o)})}static fromPromise(o){return new Q(async v=>{v.emitMany(await o)})}static fromPromises(o){return new Q(async v=>{await Promise.all(o.map(async I=>v.emitOne(await I)))})}static merge(o){return new Q(async v=>{await Promise.all(o.map(async I=>{for await(const R of I)v.emitOne(R)}))})}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new k.$5d,queueMicrotask(async()=>{const v={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(o(v)),this.j()}catch(I){this.k(I)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(o,v){return new Q(async I=>{for await(const R of o)I.emitOne(v(R))})}map(o){return Q.map(this,o)}static filter(o,v){return new Q(async I=>{for await(const R of o)v(R)&&I.emitOne(R)})}filter(o){return Q.filter(this,o)}static coalesce(o){return Q.filter(o,v=>!!v)}coalesce(){return Q.coalesce(this)}static async toPromise(o){const v=[];for await(const I of o)v.push(I);return v}toPromise(){return Q.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$Eh=Q,Q.EMPTY=Q.fromArray([]);class ae extends Q{constructor(o,v){super(v),this.l=o}cancel(){this.l.cancel()}}e.$Fh=ae;function le(N){const o=new A.$ce,v=N(o.token);return new ae(o,async I=>{const R=o.token.onCancellationRequested(()=>{R.dispose(),o.dispose(),I.reject(new E.$5)});try{for await(const z of v){if(o.token.isCancellationRequested)return;I.emitOne(z)}R.dispose(),o.dispose()}catch(z){R.dispose(),o.dispose(),I.reject(z)}})}e.$Gh=le;class fe{constructor(){this.a=new x,this.b=new Q(I=>{if(o){I.reject(o);return}return v&&I.emitMany(v),this.d=R=>I.reject(R),this.f=R=>I.emitOne(R),this.a.p});let o,v;this.f=I=>{v||(v=[]),v.push(I)},this.d=I=>{o||(o=I)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}e.$Hh=fe}),define(H[18],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.StringEOL=void 0;var A;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(A||(e.StringEOL=A={}));function E(k){let O=0,r=0,g=0,t=0;for(let d=0,$=k.length;d<$;d++){const f=k.charCodeAt(d);f===13?(O===0&&(r=d),O++,d+1<$&&k.charCodeAt(d+1)===10?(t|=2,d++):t|=3,g=d+1):f===10&&(t|=1,O===0&&(r=d),O++,g=d+1)}return O===0&&(r=k.length),[O,r,k.length-g,t]}e.$Gt=E}),define(H[19],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(A||(e.LanguageId=A={}));var E;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class g{static getLanguageId(d){return(d&255)>>>0}static getTokenType(d){return(d&768)>>>8}static containsBalancedBrackets(d){return(d&1024)!==0}static getFontStyle(d){return(d&30720)>>>11}static getForeground(d){return(d&16744448)>>>15}static getBackground(d){return(d&4278190080)>>>24}static getClassNameFromMetadata(d){let f="mtk"+this.getForeground(d);const h=this.getFontStyle(d);return h&1&&(f+=" mtki"),h&2&&(f+=" mtkb"),h&4&&(f+=" mtku"),h&8&&(f+=" mtks"),f}static getInlineStyleFromMetadata(d,$){const f=this.getForeground(d),h=this.getFontStyle(d);let a=`color: ${$[f]};`;h&1&&(a+="font-style: italic;"),h&2&&(a+="font-weight: bold;");let i="";return h&4&&(i+=" underline"),h&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(d){const $=this.getForeground(d),f=this.getFontStyle(d);return{foreground:$,italic:!!(f&1),bold:!!(f&2),underline:!!(f&4),strikethrough:!!(f&8)}}}e.$Et=g}),define(H[35],W([0,1,36]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=void 0;class E{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,g){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=g}replace(r,g,t){if(r>=this.a.length)return;if(g===0){this.insert(r,t);return}else if(t===0){this.delete(r,g);return}const d=this.a.slice(0,r),$=this.a.slice(r+g),f=k(t,this.b);this.a=d.concat(f,$)}delete(r,g){g===0||r>=this.a.length||this.a.splice(r,g)}insert(r,g){if(g===0||r>=this.a.length)return;const t=[];for(let d=0;d<g;d++)t[d]=this.b;this.a=(0,A.$Wb)(this.a,r,t)}}e.$tC=E;function k(O,r){const g=[];for(let t=0;t<O;t++)g[t]=r;return g}}),define(H[11],W([0,1,19]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=void 0;class E{static createEmpty(r,g){const t=E.defaultTokenMetadata,d=new Uint32Array(2);return d[0]=r.length,d[1]=t,new E(d,r,g)}constructor(r,g,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=g,this.d=t}equals(r){return r instanceof E?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,g,t){if(this.c!==r.c||this.b!==r.b)return!1;const d=g<<1,$=d+(t<<1);for(let f=d;f<$;f++)if(this.a[f]!==r.a[f])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const g=this.a[(r<<1)+1],t=A.$Et.getLanguageId(g);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const g=this.a[(r<<1)+1];return A.$Et.getTokenType(g)}getForeground(r){const g=this.a[(r<<1)+1];return A.$Et.getForeground(g)}getClassName(r){const g=this.a[(r<<1)+1];return A.$Et.getClassNameFromMetadata(g)}getInlineStyle(r,g){const t=this.a[(r<<1)+1];return A.$Et.getInlineStyleFromMetadata(t,g)}getPresentation(r){const g=this.a[(r<<1)+1];return A.$Et.getPresentationFromMetadata(g)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return E.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,g,t){return new k(this,r,g,t)}static convertToEndOffset(r,g){const d=(r.length>>>1)-1;for(let $=0;$<d;$++)r[$<<1]=r[$+1<<1];r[d<<1]=g}static findIndexInTokensArray(r,g){if(r.length<=2)return 0;let t=0,d=(r.length>>>1)-1;for(;t<d;){const $=t+Math.floor((d-t)/2),f=r[$<<1];if(f===g)return $+1;f<g?t=$+1:f>g&&(d=$)}return t}withInserted(r){if(r.length===0)return this;let g=0,t=0,d="";const $=new Array;let f=0;for(;;){const h=g<this.b?this.a[g<<1]:-1,a=t<r.length?r[t]:null;if(h!==-1&&(a===null||h<=a.offset)){d+=this.c.substring(f,h);const i=this.a[(g<<1)+1];$.push(d.length,i),g++,f=h}else if(a){if(a.offset>f){d+=this.c.substring(f,a.offset);const i=this.a[(g<<1)+1];$.push(d.length,i),f=a.offset}d+=a.text,$.push(d.length,a.tokenMetadata),t++}else break}return new E(new Uint32Array($),d,this.d)}}e.$Ht=E,E.defaultTokenMetadata=(32768|2<<24)>>>0;class k{constructor(r,g,t,d){this.a=r,this.b=g,this.c=t,this.d=d,this.e=r.findTokenIndexAtOffset(g),this.f=0;for(let $=this.e,f=r.getCount();$<f&&!(r.getStartOffset($)>=t);$++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof k?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const g=this.a.getEndOffset(this.e+r);return Math.min(this.c,g)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,g){return this.a.getInlineStyle(this.e+r,g)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(H[37],W([0,1,11]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$Jt=e.$It=void 0,e.$It=new Uint32Array(0).buffer;class E{static deleteBeginning(r,g){return r===null||r===e.$It?r:E.delete(r,0,g)}static deleteEnding(r,g){if(r===null||r===e.$It)return r;const t=k(r),d=t[t.length-2];return E.delete(r,g,d)}static delete(r,g,t){if(r===null||r===e.$It||g===t)return r;const d=k(r),$=d.length>>>1;if(g===0&&d[d.length-2]===t)return e.$It;const f=A.$Ht.findIndexInTokensArray(d,g),h=f>0?d[f-1<<1]:0,a=d[f<<1];if(t<a){const y=t-g;for(let L=f;L<$;L++)d[L<<1]-=y;return r}let i,n;h!==g?(d[f<<1]=g,i=f+1<<1,n=g):(i=f<<1,n=h);const s=t-g;for(let y=f+1;y<$;y++){const L=d[y<<1]-s;L>n&&(d[i++]=L,d[i++]=d[(y<<1)+1],n=L)}if(i===d.length)return r;const l=new Uint32Array(i);return l.set(d.subarray(0,i),0),l.buffer}static append(r,g){if(g===e.$It)return r;if(r===e.$It)return g;if(r===null)return r;if(g===null)return null;const t=k(r),d=k(g),$=d.length>>>1,f=new Uint32Array(t.length+d.length);f.set(t,0);let h=t.length;const a=t[t.length-2];for(let i=0;i<$;i++)f[h++]=d[i<<1]+a,f[h++]=d[(i<<1)+1];return f.buffer}static insert(r,g,t){if(r===null||r===e.$It)return r;const d=k(r),$=d.length>>>1;let f=A.$Ht.findIndexInTokensArray(d,g);f>0&&d[f-1<<1]===g&&f--;for(let h=f;h<$;h++)d[h<<1]+=t;return r}}e.$Jt=E;function k(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$Kt=k}),define(H[38],W([0,1,36,13,48,18,37,20]),function(q,e,A,E,k,O,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class t{static deserialize($,f,h){const a=new Uint32Array($.buffer),i=(0,E.$we)($,f);f+=4;const n=(0,E.$we)($,f);f+=4;const s=[];for(let l=0;l<n;l++){const y=(0,E.$we)($,f);f+=4,s.push(a.subarray(f/4,f/4+y/4)),f+=y}return h.push(new t(i,s)),f}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor($,f){this.a=$,this.b=f}getLineRange(){return new g.$dt(this.a,this.a+this.b.length)}getLineTokens($){return this.b[$-this.a]}appendLineTokens($){this.b.push($)}serializeSize(){let $=0;$+=4,$+=4;for(let f=0;f<this.b.length;f++){const h=this.b[f];if(!(h instanceof Uint32Array))throw new Error("Not supported!");$+=4,$+=h.byteLength}return $}serialize($,f){(0,E.$xe)($,this.a,f),f+=4,(0,E.$xe)($,this.b.length,f),f+=4;for(let h=0;h<this.b.length;h++){const a=this.b[h];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,E.$xe)($,a.byteLength,f),f+=4,$.set(new Uint8Array(a.buffer),f),f+=a.byteLength}return f}applyEdit($,f){const[h,a]=(0,O.$Gt)(f);this.c($),this.d(new k.$6s($.startLineNumber,$.startColumn),h,a)}c($){if($.startLineNumber===$.endLineNumber&&$.startColumn===$.endColumn)return;const f=$.startLineNumber-this.a,h=$.endLineNumber-this.a;if(h<0){const a=h-f;this.a-=a;return}if(!(f>=this.b.length)){if(f<0&&h>=this.b.length){this.a=0,this.b=[];return}if(f===h){this.b[f]=r.$Jt.delete(this.b[f],$.startColumn-1,$.endColumn-1);return}if(f>=0)if(this.b[f]=r.$Jt.deleteEnding(this.b[f],$.startColumn-1),h<this.b.length){const a=r.$Jt.deleteBeginning(this.b[h],$.endColumn-1);this.b[f]=r.$Jt.append(this.b[f],a),this.b.splice(f+1,h-f)}else this.b[f]=r.$Jt.append(this.b[f],null),this.b=this.b.slice(0,f+1);else{const a=-f;this.a-=a,this.b[h]=r.$Jt.deleteBeginning(this.b[h],$.endColumn-1),this.b=this.b.slice(h)}}}d($,f,h){if(f===0&&h===0)return;const a=$.lineNumber-this.a;if(a<0){this.a+=f;return}if(!(a>=this.b.length)){if(f===0){this.b[a]=r.$Jt.insert(this.b[a],$.column-1,h);return}this.b[a]=r.$Jt.deleteEnding(this.b[a],$.column-1),this.b[a]=r.$Jt.insert(this.b[a],$.column-1,h),this.e($.lineNumber,f)}}e($,f){if(f===0)return;const h=[];for(let a=0;a<f;a++)h[a]=null;this.b=A.$Wb(this.b,$,h)}}e.$Lt=t}),define(H[21],W([0,1,13,38]),function(q,e,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=void 0;class k{static deserialize(r){let g=0;const t=(0,A.$we)(r,g);g+=4;const d=[];for(let $=0;$<t;$++)g=E.$Lt.deserialize(r,g,d);return d}constructor(){this.a=[]}add(r,g){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(g);return}}this.a.push(new E.$Lt(r,[g]))}finalize(){return this.a}serialize(){const r=this.b(),g=new Uint8Array(r);return this.c(g),g}b(){let r=0;r+=4;for(let g=0;g<this.a.length;g++)r+=this.a[g].serializeSize();return r}c(r){let g=0;(0,A.$xe)(r,this.a.length,g),g+=4;for(let t=0;t<this.a.length;t++)g=this.a[t].serialize(r,g)}}e.$uC=k}),define(H[22],W([0,1,39]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sC=e.$rC=e.$qC=void 0,e.$qC=new class{clone(){return this}equals(O){return this===O}};function E(O,r){return new A.$Qt([new A.$Pt(0,"",O)],r)}e.$rC=E;function k(O,r){const g=new Uint32Array(2);return g[0]=0,g[1]=(O<<0|0|0|32768|2<<24)>>>0,new A.$Rt(g,r===null?e.$qC:r)}e.$sC=k}),define(H[40],W([0,1,17,9,3,41,18,20,49,22,35,21,11]),function(q,e,A,E,k,O,r,g,t,d,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=e.$zC=e.$yC=e.$xC=e.$wC=e.$vC=void 0;var a;(function(T){T[T.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(u,b){this.tokenizationSupport=b,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(u)}getStartState(u){return this.store.getStartState(u,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$vC=i;class n extends i{constructor(u,b,w,U){super(u,b),this._textModel=w,this._languageIdCodec=U}updateTokensUntilLine(u,b){const w=this._textModel.getLanguageId();for(;;){const U=this.getFirstInvalidLine();if(!U||U.lineNumber>b)break;const D=this._textModel.getLineContent(U.lineNumber),c=L(this._languageIdCodec,w,this.tokenizationSupport,D,!0,U.startState);u.add(U.lineNumber,c.tokens),this.store.setEndState(U.lineNumber,c.endState)}}getTokenTypeIfInsertingCharacter(u,b){const w=this.getStartState(u.lineNumber);if(!w)return 0;const U=this._textModel.getLanguageId(),D=this._textModel.getLineContent(u.lineNumber),c=D.substring(0,u.column-1)+b+D.substring(u.column-1),S=L(this._languageIdCodec,U,this.tokenizationSupport,c,!0,w),j=new h.$Ht(S.tokens,c,this._languageIdCodec);if(j.getCount()===0)return 0;const F=j.findTokenIndexAtOffset(u.column-1);return j.getStandardTokenType(F)}tokenizeLineWithEdit(u,b,w){const U=u.lineNumber,D=u.column,c=this.getStartState(U);if(!c)return null;const S=this._textModel.getLineContent(U),j=S.substring(0,D-1)+w+S.substring(D-1+b),F=this._textModel.getLanguageIdAtPosition(U,0),C=L(this._languageIdCodec,F,this.tokenizationSupport,j,!0,c);return new h.$Ht(C.tokens,j,this._languageIdCodec)}isCheapToTokenize(u){const b=this.store.getFirstInvalidEndStateLineNumberOrMax();return u<b||u===b&&this._textModel.getLineLength(u)<2048}tokenizeHeuristically(u,b,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(u,w),{heuristicTokens:!1};let U=this.b(b);const D=this._textModel.getLanguageId();for(let c=b;c<=w;c++){const S=this._textModel.getLineContent(c),j=L(this._languageIdCodec,D,this.tokenizationSupport,S,!0,U);u.add(c,j.tokens),U=j.endState}return{heuristicTokens:!0}}b(u){let b=this._textModel.getLineFirstNonWhitespaceColumn(u);const w=[];let U=null;for(let S=u-1;b>1&&S>=1;S--){const j=this._textModel.getLineFirstNonWhitespaceColumn(S);if(j!==0&&j<b&&(w.push(this._textModel.getLineContent(S)),b=j,U=this.getStartState(S),U))break}U||(U=this.tokenizationSupport.getInitialState()),w.reverse();const D=this._textModel.getLanguageId();let c=U;for(const S of w)c=L(this._languageIdCodec,D,this.tokenizationSupport,S,!1,c).endState;return c}}e.$wC=n;class s{constructor(u){this.d=u,this.a=new l,this.b=new y,this.b.addRange(new t.$bt(1,u+1))}getEndState(u){return this.a.getEndState(u)}setEndState(u,b){if(!b)throw new E.$cb("Cannot set null/undefined state");this.b.delete(u);const w=this.a.setEndState(u,b);return w&&u<this.d&&this.b.addRange(new t.$bt(u+1,u+2)),w}acceptChange(u,b){this.d+=b-u.length,this.a.acceptChange(u,b),this.b.addRangeAndResize(new t.$bt(u.startLineNumber,u.endLineNumberExclusive),b)}acceptChanges(u){for(const b of u){const[w]=(0,r.$Gt)(b.text);this.acceptChange(new g.$dt(b.range.startLineNumber,b.range.endLineNumber+1),w+1)}}invalidateEndStateRange(u){this.b.addRange(new t.$bt(u.startLineNumber,u.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(u,b){return u===1?b:this.getEndState(u-1)}getFirstInvalidLine(u){const b=this.getFirstInvalidEndStateLineNumber();if(b===null)return null;const w=this.getStartState(b,u);if(!w)throw new E.$cb("Start state must be defined");return{lineNumber:b,startState:w}}}e.$xC=s;class l{constructor(){this.a=new $.$tC(null)}getEndState(u){return this.a.get(u)}setEndState(u,b){const w=this.a.get(u);return w&&w.equals(b)?!1:(this.a.set(u,b),!0)}acceptChange(u,b){let w=u.length;b>0&&w>0&&(w--,b--),this.a.replace(u.startLineNumber,w,b)}acceptChanges(u){for(const b of u){const[w]=(0,r.$Gt)(b.text);this.acceptChange(new g.$dt(b.range.startLineNumber,b.range.endLineNumber+1),w+1)}}}e.$yC=l;class y{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const u=this.a[0];return u.start+1===u.endExclusive?this.a.shift():this.a[0]=new t.$bt(u.start+1,u.endExclusive),u.start}delete(u){const b=this.a.findIndex(w=>w.contains(u));if(b!==-1){const w=this.a[b];w.start===u?w.endExclusive===u+1?this.a.splice(b,1):this.a[b]=new t.$bt(u+1,w.endExclusive):w.endExclusive===u+1?this.a[b]=new t.$bt(w.start,u):this.a.splice(b,1,new t.$bt(w.start,u),new t.$bt(u+1,w.endExclusive))}}addRange(u){t.$bt.addRange(u,this.a)}addRangeAndResize(u,b){let w=0;for(;!(w>=this.a.length||u.start<=this.a[w].endExclusive);)w++;let U=w;for(;!(U>=this.a.length||u.endExclusive<this.a[U].start);)U++;const D=b-u.length;for(let c=U;c<this.a.length;c++)this.a[c]=this.a[c].delta(D);if(w===U){const c=new t.$bt(u.start,u.start+b);c.isEmpty||this.a.splice(w,0,c)}else{const c=Math.min(u.start,this.a[w].start),S=Math.max(u.endExclusive,this.a[U-1].endExclusive),j=new t.$bt(c,S+D);j.isEmpty?this.a.splice(w,U-w):this.a.splice(w,U-w,j)}}toString(){return this.a.map(u=>u.toString()).join(" + ")}}e.$zC=y;function L(T,u,b,w,U,D){let c=null;if(b)try{c=b.tokenizeEncoded(w,U,D.clone())}catch(S){(0,E.$1)(S)}return c||(c=(0,d.$sC)(T.encodeLanguageId(u),D)),h.$Ht.convertToEndOffset(c.tokens,w.length),c}class P{constructor(u,b){this.b=u,this.d=b,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,A.$uh)(u=>{this.f=!1,this.h(u)}))}h(u){const b=Date.now()+u.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<b?(0,k.$v)(w):this.g())};w()}j(){const u=this.b._textModel.getLineCount(),b=new f.$uC,w=O.$1d.create(!1);do if(w.elapsed()>1||this.l(b)>=u)break;while(this.k());this.d.setTokens(b.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(u){const b=this.b?.getFirstInvalidLine();return b?(this.b.updateTokensUntilLine(u,b.lineNumber),b.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(u,b){this.b.store.invalidateEndStateRange(new g.$dt(u,b))}}e.$AC=P}),define(H[42],W([0,1,34,2,41,19,39]),function(q,e,A,E,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Ib=void 0;class g extends E.$Tc{constructor(d,$,f,h,a,i,n){super(),this.c=d,this.f=$,this.g=f,this.h=h,this.j=a,this.m=i,this.n=n,this.a=[],this.b=this.B(new A.$5d),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(d,$,f){throw new Error("Not supported!")}createBackgroundTokenizer(d,$){if(this.h)return this.h(d,$)}tokenizeEncoded(d,$,f){const h=Math.random()*1e4<1,a=this.n||h,i=a?new k.$1d(!0):void 0,n=this.c.tokenizeLine2(d,f,500);if(a){const l=i.elapsed();(h||l>32)&&this.m(l,d.length,h)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${d.substring(0,100)}`),new r.$Rt(n.tokens,f);if(this.g){const l=this.a,y=n.tokens;for(let L=0,P=y.length>>>1;L<P;L++){const T=y[(L<<1)+1],u=O.$Et.getLanguageId(T);l[u]||(l[u]=!0,this.b.fire(u))}}let s;return f.equals(n.ruleStack)?s=f:s=n.ruleStack,new r.$Rt(n.tokens,s)}}e.$4Ib=g}),define(H[43],W([0,1,22,2,12]),function(q,e,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Ib=void 0;class O extends E.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(g,t,d){super(),this.a=g,this.b=t,this.c=d,this.B((0,k.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(g,t,d){throw new Error("Not supported!")}tokenizeEncoded(g,t,d){return g.length>=this.c.get()?(0,A.$sC)(this.a,d):this.b.tokenizeEncoded(g,t,d)}createBackgroundTokenizer(g,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(g,t)}}e.$5Ib=O}),define(H[44],W([0,1,33,17,12,3,20,50,40,21,11,42,43]),function(q,e,A,E,k,O,r,g,t,d,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ib=void 0;class a extends g.$yv{constructor(s,l,y,L,P,T,u,b){super(s,l,y,L),this.s=P,this.t=T,this.u=u,this.a=null,this.b=!1,this.c=(0,k.observableValue)(this,-1),this.q=new E.$qh(()=>this.w(),10),this.c.set(b,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,l){this.t=s,this.u=l,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,l){this.a&&(this.a.store.invalidateEndStateRange(new r.$dt(s,l)),this.q.schedule())}async v(){this.a=null;const s=this.t,l=this.u,y=await this.s.getOrCreateGrammar(s,l);if(!(this.b||s!==this.t||l!==this.u||!y)){if(y.grammar){const L=new h.$5Ib(this.u,new f.$4Ib(y.grammar,y.initialState,!1,void 0,()=>!1,(P,T,u)=>{this.s.reportTokenizationTime(P,s,y.sourceExtensionId,T,u)},!1),this.c);this.a=new t.$vC(this.f.length,L)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:l}=await(0,A.$uD)("vscode-textmate","release/main.js");this.m=l}const s=new Date().getTime();for(;;){let l=0;const y=new d.$uC,L=new i;for(;;){const u=this.a.getFirstInvalidLine();if(u===null||l>200)break;l++;const b=this.f[u.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(b,!0,u.startState);if(this.a.store.setEndState(u.lineNumber,w.endState)){const D=this.m(u.startState,w.endState);L.setState(u.lineNumber,D)}else L.setState(u.lineNumber,null);if($.$Ht.convertToEndOffset(w.tokens,b.length),y.add(u.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(l===0)break;const P=L.getStateDeltas();if(this.s.setTokensAndStates(this.h,y.serialize(),P),new Date().getTime()-s>20){(0,O.$v)(()=>this.w());return}}}}e.$0Ib=a;class i{constructor(){this.a=-1,this.b=[]}setState(s,l){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(l):this.b.push({startLineNumber:s,stateDeltas:[l]}),this.a=s}getStateDeltas(){return this.b}}}),define(H[45],W([0,1,16]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Ib=void 0;class E{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const r=this.a[O.scopeName];A.$Kg(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$7Ib=E}),define(H[46],W([0,1,2,45]),function(q,e,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Ib=e.$8Ib=void 0,e.$8Ib="No TM Grammar registered for this language.";class k extends A.$Tc{constructor(r,g,t,d){super(),this.a=r,this.b=t.INITIAL,this.c=new E.$7Ib,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:d,loadGrammar:async $=>{const f=this.c.getGrammarDefinition($);if(!f)return this.a.logTrace(`No grammar found for scope ${$}`),null;const h=f.location;try{const a=await this.a.readFile(h);return t.parseRawGrammar(a,h.path)}catch(a){return this.a.logError(`Unable to load and parse grammar for scope ${$} from ${h}`,a),null}},getInjections:$=>{const f=$.split(".");let h=[];for(let a=1;a<=f.length;a++){const i=f.slice(0,a).join(".");h=[...h,...this.f[i]||[]]}return h}}));for(const $ of g){if(this.c.register($),$.injectTo){for(const f of $.injectTo){let h=this.f[f];h||(this.f[f]=h=[]),h.push($.scopeName)}if($.embeddedLanguages)for(const f of $.injectTo){let h=this.g[f];h||(this.g[f]=h=[]),h.push($.embeddedLanguages)}}$.language&&this.h.set($.language,$.scopeName)}}has(r){return this.h.has(r)}setTheme(r,g){this.j.setTheme(r,g)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,g){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$8Ib);const d=this.c.getGrammarDefinition(t);if(!d)throw new Error(e.$8Ib);const $=d.embeddedLanguages;if(this.g[t]){const a=this.g[t];for(const i of a)for(const n of Object.keys(i))$[n]=i[n]}const f=Object.keys($).length>0;let h;try{h=await this.j.loadGrammarWithConfiguration(t,g,{embeddedLanguages:$,tokenTypes:d.tokenTypes,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.$8Ib):a}return{languageId:r,grammar:h,initialState:this.b,containsEmbeddedLanguages:f,sourceExtensionId:d.sourceExtensionId}}}e.$9Ib=k}),define(H[51],W([0,1,10,46,44]),function(q,e,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(g,t){return new r(g,t)}e.create=O;class r{constructor(t,d){this.f=d,this.b=new Map,this.c=[],this.a=t.host;const $=d.grammarDefinitions.map(f=>({location:A.URI.revive(f.location),language:f.language,scopeName:f.scopeName,embeddedLanguages:f.embeddedLanguages,tokenTypes:f.tokenTypes,injectTo:f.injectTo,balancedBracketSelectors:f.balancedBracketSelectors,unbalancedBracketSelectors:f.unbalancedBracketSelectors,sourceExtensionId:f.sourceExtensionId}));this.d=this.g($)}async g(t){const d=this.f.textmateMainUri,$=await new Promise((n,s)=>{q([d],n,s)}),f=await new Promise((n,s)=>{q([this.f.onigurumaMainUri],n,s)}),a=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await f.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>f.createOnigScanner(n),createOnigString:n=>f.createOnigString(n)});return new E.$9Ib({logTrace:n=>{},logError:(n,s)=>console.error(n,s),readFile:n=>this.a.readFile(n)},t,$,i)}acceptNewModel(t){const d=A.URI.revive(t.uri),$=this;this.b.set(t.controllerId,new k.$0Ib(d,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(f,h){const a=await $.d;return a?($.c[h]||($.c[h]=a.createGrammar(f,h)),$.c[h]):Promise.resolve(null)},setTokensAndStates(f,h,a){$.a.setTokensAndStates(t.controllerId,f,h,a)},reportTokenizationTime(f,h,a,i,n){$.a.reportTokenizationTime(f,h,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,d){this.b.get(t).onEvents(d)}retokenize(t,d,$){this.b.get(t).retokenize(d,$)}acceptModelLanguageChanged(t,d,$){this.b.get(t).onLanguageId(d,$)}acceptRemovedModel(t){const d=this.b.get(t);d&&(d.dispose(),this.b.delete(t))}async acceptTheme(t,d){(await this.d)?.setTheme(t,d)}acceptMaxTokenizationLineLength(t,d){this.b.get(t).acceptMaxTokenizationLineLength(d)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=textMateTokenizationWorker.worker.js.map
